class
	PD_EYESREC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	SD_WIDGETREC
		redefine
			make,
			copy,
			is_equal,
			structure_info
		end
	S_X11_XLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create eyes.make
			Precursor
		end

feature {ANY} -- fields

	eyes: PD_EYESPART assign set_eyes

feature {ANY} -- field setters

	set_eyes (a_eyes: PD_EYESPART)
		do
			eyes := a_eyes
			update_memory_field ("eyes")
		end

feature {ANY} -- public routines

	eyeLiner (a_d: NATURAL_32; a_outgc, a_centergc: CE_POINTER [ANY]; a_num: INTEGER_32)
		local
			l_dpy: CE_POINTER [ANY]
		do
			l_dpy := (core.screen).item.display
			TFillArc (l_dpy, a_d, a_outgc, create {CE_CLASS_POINTER [PD_TRANSFORM]}.make_shared (c_pointer + (create {PD_EYESREC}.make).offset_of ("eyes") + (create {PD_EYESPART}.make).offset_of ("t")), (a_num.to_double * 2.0 - (2.0 - (0.175 + 0.1) * (2).to_double) / 2.0) - 0.175, (0.0 - (2.0 - (0.175 + 0.1) * (2).to_double) / 2.0) - 0.175, (2.0 - (0.175 + 0.1) * (2).to_double) + 0.175 * 2.0, (2.0 - (0.175 + 0.1) * (2).to_double) + 0.175 * 2.0, 5_760, 23_040)
			update_class_fields -- Current might have been changed; synchronize
			if (not a_centergc.is_void) then
				TFillArc (l_dpy, a_d, a_centergc, create {CE_CLASS_POINTER [PD_TRANSFORM]}.make_shared (c_pointer + (create {PD_EYESREC}.make).offset_of ("eyes") + (create {PD_EYESPART}.make).offset_of ("t")), a_num.to_double * 2.0 - (2.0 - (0.175 + 0.1) * (2).to_double) / 2.0, 0.0 - (2.0 - (0.175 + 0.1) * (2).to_double) / 2.0, 2.0 - (0.175 + 0.1) * (2).to_double, 2.0 - (0.175 + 0.1) * (2).to_double, 5_760, 23_040)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	eyeBall (a_gc: CE_POINTER [ANY]; a_num: INTEGER_32)
		local
			l_dpy: CE_POINTER [ANY]
			l_win: NATURAL_32
		do
			l_dpy := (core.screen).item.display
			l_win := core.window
			TFillArc (l_dpy, l_win, a_gc, create {CE_CLASS_POINTER [PD_TRANSFORM]}.make_shared (c_pointer + (create {PD_EYESREC}.make).offset_of ("eyes") + (create {PD_EYESPART}.make).offset_of ("t")), eyes.pupil[a_num].x - 0.3 / 2.0, eyes.pupil[a_num].y - 0.3 / 2.0, 0.3, 0.3, 5_760, 23_040)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_EYESREC} -- private routines

	TFillArc (a_dpy: CE_POINTER [ANY]; a_d: NATURAL_32; a_gc: CE_POINTER [ANY]; a_t: CE_POINTER [PD_TRANSFORM]; a_x, a_y, a_width, a_height: REAL_64; a_angle1, a_angle2: INTEGER_32)
		require
			not a_t.is_void
		local
			l_xx: INTEGER_32
			l_xy: INTEGER_32
			l_xw: INTEGER_32
			l_xh: INTEGER_32
		do
			l_xx := ((a_t.item.mx * a_x + a_t.item.bx) + 0.5).truncated_to_integer
			l_xy := ((a_t.item.my * a_y + a_t.item.by) + 0.5).truncated_to_integer
			l_xw := (a_t.item.mx * a_width + 0.5).truncated_to_integer
			l_xh := (a_t.item.my * a_height + 0.5).truncated_to_integer
			if l_xw < 0 then
				l_xx := l_xx + l_xw
				l_xw := -l_xw
			end
			if l_xh < 0 then
				l_xy := l_xy + l_xh
				l_xh := -l_xh
			end
			XFillArc (a_dpy, a_d, a_gc, l_xx, l_xy, l_xw.to_natural_32, l_xh.to_natural_32, a_angle1, a_angle2).do_nothing
		end

feature {ANY}

	copy (a_other: like Current)
		do
			Precursor {SD_WIDGETREC} (a_other)
			eyes := a_other.eyes.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				Precursor {SD_WIDGETREC} (a_other) and
				eyes.is_equal (a_other.eyes)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("eyes")
				>>)
			Result.set_superclasses (<<{SD_WIDGETREC}>>)
			init_structure_info
		end

end
