class
	SD_CORECLASSPART

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_WIDGETCLASSREC]} superclass.make
			create {CE_INTEGER_8_POINTER} class_name.make
			create class_initialize.make
			create class_part_initialize.make
			create initialize.make
			create initialize_hook.make
			create realize.make
			create {CE_CLASS_POINTER [SD_XTACTIONSREC]} actions.make
			create {CE_CLASS_POINTER [SD_XTRESOURCE]} resources.make
			create destroy.make
			create resize.make
			create expose.make
			create set_values.make
			create set_values_hook.make
			create set_values_almost.make
			create get_values_hook.make
			create accept_focus.make
			create {CE_VOID_POINTER} callback_private.make
			create {CE_INTEGER_8_POINTER} tm_table.make
			create query_geometry.make
			create display_accelerator.make
			create {CE_VOID_POINTER} extension.make
		end

feature {ANY} -- fields

	superclass: CE_POINTER [SD_WIDGETCLASSREC] assign set_superclass

	class_name: CE_POINTER [INTEGER_8] assign set_class_name

	widget_size: NATURAL_32 assign set_widget_size

	class_initialize: CE_ROUTINE assign set_class_initialize

	class_part_initialize: CE_ROUTINE assign set_class_part_initialize

	class_inited: NATURAL_8 assign set_class_inited

	initialize: CE_ROUTINE assign set_initialize

	initialize_hook: CE_ROUTINE assign set_initialize_hook

	realize: CE_ROUTINE assign set_realize

	actions: CE_POINTER [SD_XTACTIONSREC] assign set_actions

	num_actions: NATURAL_32 assign set_num_actions

	resources: CE_POINTER [SD_XTRESOURCE] assign set_resources

	num_resources: NATURAL_32 assign set_num_resources

	xrm_class: INTEGER_32 assign set_xrm_class

	compress_motion: INTEGER_8 assign set_compress_motion

	compress_exposure: NATURAL_8 assign set_compress_exposure

	compress_enterleave: INTEGER_8 assign set_compress_enterleave

	visible_interest: INTEGER_8 assign set_visible_interest

	destroy: CE_ROUTINE assign set_destroy

	resize: CE_ROUTINE assign set_resize

	expose: CE_ROUTINE assign set_expose

	set_values: CE_ROUTINE assign set_set_values

	set_values_hook: CE_ROUTINE assign set_set_values_hook

	set_values_almost: CE_ROUTINE assign set_set_values_almost

	get_values_hook: CE_ROUTINE assign set_get_values_hook

	accept_focus: CE_ROUTINE assign set_accept_focus

	version: NATURAL_32 assign set_version

	callback_private: CE_POINTER [ANY] assign set_callback_private

	tm_table: CE_POINTER [INTEGER_8] assign set_tm_table

	query_geometry: CE_ROUTINE assign set_query_geometry

	display_accelerator: CE_ROUTINE assign set_display_accelerator

	extension: CE_POINTER [ANY] assign set_extension

feature {ANY} -- field setters

	set_superclass (a_superclass: CE_POINTER [SD_WIDGETCLASSREC])
		do
			superclass := a_superclass
			update_memory_field ("superclass")
		end

	set_class_name (a_class_name: CE_POINTER [INTEGER_8])
		do
			class_name := a_class_name
			update_memory_field ("class_name")
		end

	set_widget_size (a_widget_size: NATURAL_32)
		do
			widget_size := a_widget_size
			update_memory_field ("widget_size")
		end

	set_class_initialize (a_class_initialize: CE_ROUTINE)
		do
			class_initialize := a_class_initialize
			update_memory_field ("class_initialize")
		end

	set_class_part_initialize (a_class_part_initialize: CE_ROUTINE)
		do
			class_part_initialize := a_class_part_initialize
			update_memory_field ("class_part_initialize")
		end

	set_class_inited (a_class_inited: NATURAL_8)
		do
			class_inited := a_class_inited
			update_memory_field ("class_inited")
		end

	set_initialize (a_initialize: CE_ROUTINE)
		do
			initialize := a_initialize
			update_memory_field ("initialize")
		end

	set_initialize_hook (a_initialize_hook: CE_ROUTINE)
		do
			initialize_hook := a_initialize_hook
			update_memory_field ("initialize_hook")
		end

	set_realize (a_realize: CE_ROUTINE)
		do
			realize := a_realize
			update_memory_field ("realize")
		end

	set_actions (a_actions: CE_POINTER [SD_XTACTIONSREC])
		do
			actions := a_actions
			update_memory_field ("actions")
		end

	set_num_actions (a_num_actions: NATURAL_32)
		do
			num_actions := a_num_actions
			update_memory_field ("num_actions")
		end

	set_resources (a_resources: CE_POINTER [SD_XTRESOURCE])
		do
			resources := a_resources
			update_memory_field ("resources")
		end

	set_num_resources (a_num_resources: NATURAL_32)
		do
			num_resources := a_num_resources
			update_memory_field ("num_resources")
		end

	set_xrm_class (a_xrm_class: INTEGER_32)
		do
			xrm_class := a_xrm_class
			update_memory_field ("xrm_class")
		end

	set_compress_motion (a_compress_motion: INTEGER_8)
		do
			compress_motion := a_compress_motion
			update_memory_field ("compress_motion")
		end

	set_compress_exposure (a_compress_exposure: NATURAL_8)
		do
			compress_exposure := a_compress_exposure
			update_memory_field ("compress_exposure")
		end

	set_compress_enterleave (a_compress_enterleave: INTEGER_8)
		do
			compress_enterleave := a_compress_enterleave
			update_memory_field ("compress_enterleave")
		end

	set_visible_interest (a_visible_interest: INTEGER_8)
		do
			visible_interest := a_visible_interest
			update_memory_field ("visible_interest")
		end

	set_destroy (a_destroy: CE_ROUTINE)
		do
			destroy := a_destroy
			update_memory_field ("destroy")
		end

	set_resize (a_resize: CE_ROUTINE)
		do
			resize := a_resize
			update_memory_field ("resize")
		end

	set_expose (a_expose: CE_ROUTINE)
		do
			expose := a_expose
			update_memory_field ("expose")
		end

	set_set_values (a_set_values: CE_ROUTINE)
		do
			set_values := a_set_values
			update_memory_field ("set_values")
		end

	set_set_values_hook (a_set_values_hook: CE_ROUTINE)
		do
			set_values_hook := a_set_values_hook
			update_memory_field ("set_values_hook")
		end

	set_set_values_almost (a_set_values_almost: CE_ROUTINE)
		do
			set_values_almost := a_set_values_almost
			update_memory_field ("set_values_almost")
		end

	set_get_values_hook (a_get_values_hook: CE_ROUTINE)
		do
			get_values_hook := a_get_values_hook
			update_memory_field ("get_values_hook")
		end

	set_accept_focus (a_accept_focus: CE_ROUTINE)
		do
			accept_focus := a_accept_focus
			update_memory_field ("accept_focus")
		end

	set_version (a_version: NATURAL_32)
		do
			version := a_version
			update_memory_field ("version")
		end

	set_callback_private (a_callback_private: CE_POINTER [ANY])
		do
			callback_private := a_callback_private
			update_memory_field ("callback_private")
		end

	set_tm_table (a_tm_table: CE_POINTER [INTEGER_8])
		do
			tm_table := a_tm_table
			update_memory_field ("tm_table")
		end

	set_query_geometry (a_query_geometry: CE_ROUTINE)
		do
			query_geometry := a_query_geometry
			update_memory_field ("query_geometry")
		end

	set_display_accelerator (a_display_accelerator: CE_ROUTINE)
		do
			display_accelerator := a_display_accelerator
			update_memory_field ("display_accelerator")
		end

	set_extension (a_extension: CE_POINTER [ANY])
		do
			extension := a_extension
			update_memory_field ("extension")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			superclass := a_other.superclass
			class_name := a_other.class_name
			widget_size := a_other.widget_size
			class_initialize := a_other.class_initialize
			class_part_initialize := a_other.class_part_initialize
			class_inited := a_other.class_inited
			initialize := a_other.initialize
			initialize_hook := a_other.initialize_hook
			realize := a_other.realize
			actions := a_other.actions
			num_actions := a_other.num_actions
			resources := a_other.resources
			num_resources := a_other.num_resources
			xrm_class := a_other.xrm_class
			compress_motion := a_other.compress_motion
			compress_exposure := a_other.compress_exposure
			compress_enterleave := a_other.compress_enterleave
			visible_interest := a_other.visible_interest
			destroy := a_other.destroy
			resize := a_other.resize
			expose := a_other.expose
			set_values := a_other.set_values
			set_values_hook := a_other.set_values_hook
			set_values_almost := a_other.set_values_almost
			get_values_hook := a_other.get_values_hook
			accept_focus := a_other.accept_focus
			version := a_other.version
			callback_private := a_other.callback_private
			tm_table := a_other.tm_table
			query_geometry := a_other.query_geometry
			display_accelerator := a_other.display_accelerator
			extension := a_other.extension
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				superclass.is_equal (a_other.superclass) and
				class_name.is_equal (a_other.class_name) and
				widget_size = a_other.widget_size and
				class_initialize.is_equal (a_other.class_initialize) and
				class_part_initialize.is_equal (a_other.class_part_initialize) and
				class_inited = a_other.class_inited and
				initialize.is_equal (a_other.initialize) and
				initialize_hook.is_equal (a_other.initialize_hook) and
				realize.is_equal (a_other.realize) and
				actions.is_equal (a_other.actions) and
				num_actions = a_other.num_actions and
				resources.is_equal (a_other.resources) and
				num_resources = a_other.num_resources and
				xrm_class = a_other.xrm_class and
				compress_motion = a_other.compress_motion and
				compress_exposure = a_other.compress_exposure and
				compress_enterleave = a_other.compress_enterleave and
				visible_interest = a_other.visible_interest and
				destroy.is_equal (a_other.destroy) and
				resize.is_equal (a_other.resize) and
				expose.is_equal (a_other.expose) and
				set_values.is_equal (a_other.set_values) and
				set_values_hook.is_equal (a_other.set_values_hook) and
				set_values_almost.is_equal (a_other.set_values_almost) and
				get_values_hook.is_equal (a_other.get_values_hook) and
				accept_focus.is_equal (a_other.accept_focus) and
				version = a_other.version and
				callback_private.is_equal (a_other.callback_private) and
				tm_table.is_equal (a_other.tm_table) and
				query_geometry.is_equal (a_other.query_geometry) and
				display_accelerator.is_equal (a_other.display_accelerator) and
				extension.is_equal (a_other.extension)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("superclass"),
					create {CE_STRUCTURE_FIELD}.make ("class_name"),
					create {CE_STRUCTURE_FIELD}.make ("widget_size"),
					create {CE_STRUCTURE_FIELD}.make ("class_initialize"),
					create {CE_STRUCTURE_FIELD}.make ("class_part_initialize"),
					create {CE_STRUCTURE_FIELD}.make ("class_inited"),
					create {CE_STRUCTURE_FIELD}.make ("initialize"),
					create {CE_STRUCTURE_FIELD}.make ("initialize_hook"),
					create {CE_STRUCTURE_FIELD}.make ("realize"),
					create {CE_STRUCTURE_FIELD}.make ("actions"),
					create {CE_STRUCTURE_FIELD}.make ("num_actions"),
					create {CE_STRUCTURE_FIELD}.make ("resources"),
					create {CE_STRUCTURE_FIELD}.make ("num_resources"),
					create {CE_STRUCTURE_FIELD}.make ("xrm_class"),
					create {CE_STRUCTURE_FIELD}.make ("compress_motion"),
					create {CE_STRUCTURE_FIELD}.make ("compress_exposure"),
					create {CE_STRUCTURE_FIELD}.make ("compress_enterleave"),
					create {CE_STRUCTURE_FIELD}.make ("visible_interest"),
					create {CE_STRUCTURE_FIELD}.make ("destroy"),
					create {CE_STRUCTURE_FIELD}.make ("resize"),
					create {CE_STRUCTURE_FIELD}.make ("expose"),
					create {CE_STRUCTURE_FIELD}.make ("set_values"),
					create {CE_STRUCTURE_FIELD}.make ("set_values_hook"),
					create {CE_STRUCTURE_FIELD}.make ("set_values_almost"),
					create {CE_STRUCTURE_FIELD}.make ("get_values_hook"),
					create {CE_STRUCTURE_FIELD}.make ("accept_focus"),
					create {CE_STRUCTURE_FIELD}.make ("version"),
					create {CE_STRUCTURE_FIELD}.make ("callback_private"),
					create {CE_STRUCTURE_FIELD}.make ("tm_table"),
					create {CE_STRUCTURE_FIELD}.make ("query_geometry"),
					create {CE_STRUCTURE_FIELD}.make ("display_accelerator"),
					create {CE_STRUCTURE_FIELD}.make ("extension")
				>>)
			init_structure_info
		end

end
