class
	SD_VISUAL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_XEXTDATA]} ext_data.make
		end

feature {ANY} -- fields

	ext_data: CE_POINTER [SD_XEXTDATA] assign set_ext_data

	visualid: NATURAL_32 assign set_visualid

	class2: INTEGER_32 assign set_class2

	red_mask: NATURAL_32 assign set_red_mask

	green_mask: NATURAL_32 assign set_green_mask

	blue_mask: NATURAL_32 assign set_blue_mask

	bits_per_rgb: INTEGER_32 assign set_bits_per_rgb

	map_entries: INTEGER_32 assign set_map_entries

feature {ANY} -- field setters

	set_ext_data (a_ext_data: CE_POINTER [SD_XEXTDATA])
		do
			ext_data := a_ext_data
			update_memory_field ("ext_data")
		end

	set_visualid (a_visualid: NATURAL_32)
		do
			visualid := a_visualid
			update_memory_field ("visualid")
		end

	set_class2 (a_class2: INTEGER_32)
		do
			class2 := a_class2
			update_memory_field ("class2")
		end

	set_red_mask (a_red_mask: NATURAL_32)
		do
			red_mask := a_red_mask
			update_memory_field ("red_mask")
		end

	set_green_mask (a_green_mask: NATURAL_32)
		do
			green_mask := a_green_mask
			update_memory_field ("green_mask")
		end

	set_blue_mask (a_blue_mask: NATURAL_32)
		do
			blue_mask := a_blue_mask
			update_memory_field ("blue_mask")
		end

	set_bits_per_rgb (a_bits_per_rgb: INTEGER_32)
		do
			bits_per_rgb := a_bits_per_rgb
			update_memory_field ("bits_per_rgb")
		end

	set_map_entries (a_map_entries: INTEGER_32)
		do
			map_entries := a_map_entries
			update_memory_field ("map_entries")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ext_data := a_other.ext_data
			visualid := a_other.visualid
			class2 := a_other.class2
			red_mask := a_other.red_mask
			green_mask := a_other.green_mask
			blue_mask := a_other.blue_mask
			bits_per_rgb := a_other.bits_per_rgb
			map_entries := a_other.map_entries
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ext_data.is_equal (a_other.ext_data) and
				visualid = a_other.visualid and
				class2 = a_other.class2 and
				red_mask = a_other.red_mask and
				green_mask = a_other.green_mask and
				blue_mask = a_other.blue_mask and
				bits_per_rgb = a_other.bits_per_rgb and
				map_entries = a_other.map_entries
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ext_data"),
					create {CE_STRUCTURE_FIELD}.make ("visualid"),
					create {CE_STRUCTURE_FIELD}.make ("class2"),
					create {CE_STRUCTURE_FIELD}.make ("red_mask"),
					create {CE_STRUCTURE_FIELD}.make ("green_mask"),
					create {CE_STRUCTURE_FIELD}.make ("blue_mask"),
					create {CE_STRUCTURE_FIELD}.make ("bits_per_rgb"),
					create {CE_STRUCTURE_FIELD}.make ("map_entries")
				>>)
			init_structure_info
		end

end
