class
	SD_XERROREVENT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} display.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	display: CE_POINTER [ANY] assign set_display

	resourceid: NATURAL_32 assign set_resourceid

	serial: NATURAL_32 assign set_serial

	error_code: NATURAL_8 assign set_error_code

	request_code: NATURAL_8 assign set_request_code

	minor_code: NATURAL_8 assign set_minor_code

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_resourceid (a_resourceid: NATURAL_32)
		do
			resourceid := a_resourceid
			update_memory_field ("resourceid")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_error_code (a_error_code: NATURAL_8)
		do
			error_code := a_error_code
			update_memory_field ("error_code")
		end

	set_request_code (a_request_code: NATURAL_8)
		do
			request_code := a_request_code
			update_memory_field ("request_code")
		end

	set_minor_code (a_minor_code: NATURAL_8)
		do
			minor_code := a_minor_code
			update_memory_field ("minor_code")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			display := a_other.display
			resourceid := a_other.resourceid
			serial := a_other.serial
			error_code := a_other.error_code
			request_code := a_other.request_code
			minor_code := a_other.minor_code
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				display.is_equal (a_other.display) and
				resourceid = a_other.resourceid and
				serial = a_other.serial and
				error_code = a_other.error_code and
				request_code = a_other.request_code and
				minor_code = a_other.minor_code
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("resourceid"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("error_code"),
					create {CE_STRUCTURE_FIELD}.make ("request_code"),
					create {CE_STRUCTURE_FIELD}.make ("minor_code")
				>>)
			init_structure_info
		end

end
