class
	SD_XRMOPTIONDESCREC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} option.make
			create {CE_INTEGER_8_POINTER} specifier.make
			create {CE_INTEGER_8_POINTER} value.make
		end

feature {ANY} -- fields

	option: CE_POINTER [INTEGER_8] assign set_option

	specifier: CE_POINTER [INTEGER_8] assign set_specifier

	argKind: NATURAL_32 assign set_argKind

	value: CE_POINTER [INTEGER_8] assign set_value

feature {ANY} -- field setters

	set_option (a_option: CE_POINTER [INTEGER_8])
		do
			option := a_option
			update_memory_field ("option")
		end

	set_specifier (a_specifier: CE_POINTER [INTEGER_8])
		do
			specifier := a_specifier
			update_memory_field ("specifier")
		end

	set_argKind (a_argKind: NATURAL_32)
		do
			argKind := a_argKind
			update_memory_field ("argKind")
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			value := a_value
			update_memory_field ("value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			option := a_other.option
			specifier := a_other.specifier
			argKind := a_other.argKind
			value := a_other.value
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				option.is_equal (a_other.option) and
				specifier.is_equal (a_other.specifier) and
				argKind = a_other.argKind and
				value.is_equal (a_other.value)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("option"),
					create {CE_STRUCTURE_FIELD}.make ("specifier"),
					create {CE_STRUCTURE_FIELD}.make ("argKind"),
					create {CE_STRUCTURE_FIELD}.make ("value")
				>>)
			init_structure_info
		end

end
