class
	SD_XTTMREC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} translations.make
			create {CE_ROUTINE_POINTER} proc_table.make
			create {CE_VOID_POINTER} current_state.make
		end

feature {ANY} -- fields

	translations: CE_POINTER [ANY] assign set_translations

	proc_table: CE_POINTER [CE_ROUTINE] assign set_proc_table

	current_state: CE_POINTER [ANY] assign set_current_state

	lastEventTime: NATURAL_32 assign set_lastEventTime

feature {ANY} -- field setters

	set_translations (a_translations: CE_POINTER [ANY])
		do
			translations := a_translations
			update_memory_field ("translations")
		end

	set_proc_table (a_proc_table: CE_POINTER [CE_ROUTINE])
		do
			proc_table := a_proc_table
			update_memory_field ("proc_table")
		end

	set_current_state (a_current_state: CE_POINTER [ANY])
		do
			current_state := a_current_state
			update_memory_field ("current_state")
		end

	set_lastEventTime (a_lastEventTime: NATURAL_32)
		do
			lastEventTime := a_lastEventTime
			update_memory_field ("lastEventTime")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			translations := a_other.translations
			proc_table := a_other.proc_table
			current_state := a_other.current_state
			lastEventTime := a_other.lastEventTime
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				translations.is_equal (a_other.translations) and
				proc_table.is_equal (a_other.proc_table) and
				current_state.is_equal (a_other.current_state) and
				lastEventTime = a_other.lastEventTime
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("translations"),
					create {CE_STRUCTURE_FIELD}.make ("proc_table"),
					create {CE_STRUCTURE_FIELD}.make ("current_state"),
					create {CE_STRUCTURE_FIELD}.make ("lastEventTime")
				>>)
			init_structure_info
		end

end
