class
	P_EDIT_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_FCNTL_STATIC
	S_UNISTD_STATIC

feature {ANY} -- public attributes

	fd0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	errmsgs: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	force_open: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	curr_altfilename: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	curr_altpipe: CE_STATIC [CE_POINTER [ANY]]
		once ("PROCESS")
			Result.item := create {CE_VOID_POINTER}.make
		end

feature {ANY} -- public routines

	close_file
		local
			l_scrpos: CE_ARRAY [PD_SCRPOS]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_SCRPOS]} l_scrpos.make (<<1>>)

			if ((create {P_MAIN_STATIC}).curr_ifile.item).is_void then
				l_return := True
			end
			if not l_return then
				l_scrpos.item.get_scrpos
				if l_scrpos.item.pos /= -1 then
					l_scrpos.item.store_pos ((create {P_MAIN_STATIC}).curr_ifile.item);
					(create {P_MARK_STATIC}).lastmark
				end
				(create {P_CH_STATIC}).ch_close
				if not curr_altfilename.item.is_void then
					(create {P_FILENAME_STATIC}).close_altfile (curr_altfilename.item, ((create {P_IFILE_STATIC}).get_filename ((create {P_MAIN_STATIC}).curr_ifile.item)), curr_altpipe.item)
					free (create {CE_VOID_POINTER}.make_cast (curr_altfilename.item))
					curr_altfilename.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				end
				(create {P_MAIN_STATIC}).curr_ifile.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
			end
		end

	edit (a_filename: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_filename.is_void then
				Result := (edit_ifile (create {CE_VOID_POINTER}.make_shared (default_pointer)))
				l_return := True
			end
			if not l_return then
				Result := (edit_ifile (((create {P_IFILE_STATIC}).get_ifile (a_filename, (create {P_MAIN_STATIC}).curr_ifile.item))))
			end
		end

	edit_ifile (a_ifile: CE_POINTER [ANY]): INTEGER_32
		local
			l_f: CE_ARRAY [INTEGER_32]
			l_answer: INTEGER_32
			l_no_display: INTEGER_32
			l_chflags: INTEGER_32
			l_filename: CE_POINTER [INTEGER_8]
			l_open_filename: CE_POINTER [INTEGER_8]
			l_qopen_filename: CE_POINTER [INTEGER_8]
			l_alt_filename: CE_POINTER [INTEGER_8]
			l_alt_pipe: CE_ARRAY [CE_POINTER [ANY]]
			l_was_curr_ifile: CE_POINTER [ANY]
			l_parg: CE_ARRAY [PD_PARG]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_f.make (<<1>>)
			create {CE_INTEGER_8_POINTER} l_filename.make
			create {CE_INTEGER_8_POINTER} l_qopen_filename.make
			create {CE_INTEGER_8_POINTER} l_alt_filename.make
			create {CE_POINTER_ARRAY [ANY]} l_alt_pipe.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_ifile.is_equal ((create {P_MAIN_STATIC}).curr_ifile.item) then
						Result := 0
						l_return := True
					end
					if not l_return then
						(create {P_CH_STATIC}).end_logfile
						l_was_curr_ifile := save_curr_ifile
						if not ((create {P_MAIN_STATIC}).curr_ifile.item).is_void then
							l_chflags := (create {P_CH_STATIC}).ch_getflags
							close_file
							if ((l_chflags).bit_and (8)).to_boolean then
								if ((create {P_IFILE_STATIC}).held_ifile (l_was_curr_ifile)) <= 1 then
									(create {P_IFILE_STATIC}).del_ifile (l_was_curr_ifile)
									l_was_curr_ifile := (create {P_MAIN_STATIC}).old_ifile.item
								end
							end
						end
						if a_ifile.is_void then
							unsave_ifile (l_was_curr_ifile)
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_filename := (create {P_MAIN_STATIC}).save (((create {P_IFILE_STATIC}).get_filename (a_ifile)))
						l_alt_pipe.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
						l_alt_filename := (create {P_FILENAME_STATIC}).open_altfile (l_filename, l_f, l_alt_pipe)
						if not l_alt_filename.is_void then
							l_open_filename := l_alt_filename
						else
							l_open_filename := l_filename
						end
						l_qopen_filename := (create {P_FILENAME_STATIC}).shell_unquote (l_open_filename)
						l_chflags := 0
						if (l_alt_pipe.item).is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_chflags := (l_chflags).bit_or ((4))
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 4 then -- else:
						if (strcmp (l_open_filename, ce_string ("-"))) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_f.item := fd0.item
						l_chflags := (l_chflags).bit_or ((2))
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if (strcmp (l_open_filename, ce_string ("@/\less/\help/\file/\@"))) /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_f.item := -1
						l_chflags := (l_chflags).bit_or ((8))
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 10 then -- else:
						l_parg.item.p_string := (create {P_FILENAME_STATIC}).bad_file (l_open_filename)
						if (l_parg.item.p_string).is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 11 then -- if:;
						(create {P_OUTPUT_STATIC}).error (ce_string ("%%s"), l_parg)
						free (create {CE_VOID_POINTER}.make_cast (l_parg.item.p_string))
				when 12 then -- err1:
						if not l_alt_filename.is_void then
							(create {P_FILENAME_STATIC}).close_altfile (l_alt_filename, l_filename, l_alt_pipe.item)
							free (create {CE_VOID_POINTER}.make_cast (l_alt_filename))
						end
						(create {P_IFILE_STATIC}).del_ifile (a_ifile)
						free (create {CE_VOID_POINTER}.make_cast (l_qopen_filename))
						free (create {CE_VOID_POINTER}.make_cast (l_filename))
						reedit_ifile (l_was_curr_ifile)
						Result := 1
						l_return := True
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_f.item := open ([l_qopen_filename, 0])
						if l_f.item < 0 then
							l_parg.item.p_string := (create {P_OS_STATIC}).errno_message (l_filename);
							(create {P_OUTPUT_STATIC}).error (ce_string ("%%s"), l_parg)
							free (create {CE_VOID_POINTER}.make_cast (l_parg.item.p_string))
							l_pos := -1 + 12 -- goto err1
						else
							l_chflags := (l_chflags).bit_or ((1))
							if not (force_open.item.item).to_boolean then
								if not ((create {P_IFILE_STATIC}).opened (a_ifile)).to_boolean then
									if ((create {P_FILENAME_STATIC}).bin_file (l_f.item)).to_boolean then
										l_parg.item.p_string := l_filename
										l_answer := (create {P_OUTPUT_STATIC}).query (ce_string ("%"%%s%" may be a binary file.  See it anyway? "), l_parg)
										if l_answer /= 121 then
											if l_answer /= 89 then
												close (l_f.item).do_nothing
												l_pos := -1 + 12 -- goto err1
											end
										end
									end
								end
							end
						end
				when 15 then -- if done | if done | if done | if done
					if not l_return then
						free (create {CE_VOID_POINTER}.make_cast (l_qopen_filename))
						if not l_was_curr_ifile.is_void then
							(create {P_MAIN_STATIC}).old_ifile.item := l_was_curr_ifile
							unsave_ifile (l_was_curr_ifile)
						end
						(create {P_MAIN_STATIC}).curr_ifile.item := a_ifile
						curr_altfilename.item := l_alt_filename
						curr_altpipe.item := l_alt_pipe.item;
						(create {P_IFILE_STATIC}).set_open ((create {P_MAIN_STATIC}).curr_ifile.item);
						(create {P_IFILE_STATIC}).get_pos ((create {P_MAIN_STATIC}).curr_ifile.item, (create {P_MAIN_STATIC}).initial_scrpos.item);
						(create {P_MAIN_STATIC}).new_file.item := 1;
						(create {P_CH_STATIC}).ch_init (l_f.item, l_chflags)
						if not ((l_chflags).bit_and (8)).to_boolean then
							if not ((create {P_MAIN_STATIC}).namelogfile.item).is_void then
								if ((create {P_MAIN_STATIC}).is_tty.item).to_boolean then
									use_logfile ((create {P_MAIN_STATIC}).namelogfile.item)
								end
							end
							if not ((create {P_MAIN_STATIC}).every_first_cmd.item).is_void then
								(create {P_COMMAND_STATIC}).ungetsc ((create {P_MAIN_STATIC}).every_first_cmd.item)
							end
						end
						l_no_display := (not ((create {P_MAIN_STATIC}).any_display.item).to_boolean).to_integer;
						(create {P_OUTPUT_STATIC}).flush;
						(create {P_MAIN_STATIC}).any_display.item := 1
						if ((create {P_MAIN_STATIC}).is_tty.item).to_boolean then
							(create {P_POSITION_STATIC}).pos_clear;
							(create {P_LINENUM_STATIC}).clr_linenum;
							(create {P_SEARCH_STATIC}).clr_hilite;
							(create {P_CMDBUF_STATIC}).cmd_addhist (create {CE_CLASS_POINTER [PD_MLIST]}.make_cast ((create {P_CMDBUF_STATIC}).ml_examine.item), l_filename)
							if l_no_display.to_boolean then
								if errmsgs.item > 0 then
									l_parg.item.p_string := l_filename;
									(create {P_OUTPUT_STATIC}).error (ce_string ("%%s"), l_parg)
								end
							end
						end
						free (create {CE_VOID_POINTER}.make_cast (l_filename))
						Result := 0
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	edit_list (a_filelist: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_filelist.is_void
		local
			l_save_ifile: CE_POINTER [ANY]
			l_good_filename: CE_POINTER [INTEGER_8]
			l_filename: CE_POINTER [INTEGER_8]
			l_gfilelist: CE_POINTER [INTEGER_8]
			l_gfilename: CE_POINTER [INTEGER_8]
			l_tl_files: CE_ARRAY [PD_TEXTLIST]
			l_tl_gfiles: CE_ARRAY [PD_TEXTLIST]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_TEXTLIST]} l_tl_files.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_TEXTLIST]} l_tl_gfiles.make (<<1>>)

			l_save_ifile := save_curr_ifile
			l_good_filename := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_tl_files.item.init_textlist (a_filelist)
			l_filename := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_filename := l_tl_files.item.forw_textlist (l_filename)
				if l_filename.is_void then
					l_break := True
				end
				if not (l_return or l_break) then
					l_gfilelist := (create {P_FILENAME_STATIC}).lglob (l_filename)
					l_tl_gfiles.item.init_textlist (l_gfilelist)
					l_gfilename := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					from
					until
						(l_break)
					loop
						l_break := False
						l_gfilename := l_tl_gfiles.item.forw_textlist (l_gfilename)
						if l_gfilename.is_void then
							l_break := True
						end
						if not (l_break) then
							if (edit (l_gfilename)) = 0 then
								if l_good_filename.is_void then
									l_good_filename := (create {P_IFILE_STATIC}).get_filename ((create {P_MAIN_STATIC}).curr_ifile.item)
								end
							end
						end
					end
					l_break := False
					free (create {CE_VOID_POINTER}.make_cast (l_gfilelist))
				end
			end
			l_break := False
			if l_good_filename.is_void then
				unsave_ifile (l_save_ifile)
				Result := 1
				l_return := True
			end
			if not l_return then
				if ((create {P_IFILE_STATIC}).get_ifile (l_good_filename, (create {P_MAIN_STATIC}).curr_ifile.item)).is_equal ((create {P_MAIN_STATIC}).curr_ifile.item) then
					unsave_ifile (l_save_ifile)
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				reedit_ifile (l_save_ifile)
				Result := (edit (l_good_filename))
			end
		end

	edit_first: INTEGER_32
		do
			(create {P_MAIN_STATIC}).curr_ifile.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
			Result := (edit_next (1))
		end

	edit_last: INTEGER_32
		do
			(create {P_MAIN_STATIC}).curr_ifile.item := create {CE_VOID_POINTER}.make_shared (default_pointer)
			Result := (edit_prev (1))
		end

	edit_istep (a_h: CE_POINTER [ANY]; a_n, a_dir: INTEGER_32): INTEGER_32
		local
			l_h: CE_POINTER [ANY]
			l_n: INTEGER_32
			l_next: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_h := a_h
			l_n := a_n
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if a_dir > 0 then
					l_next := ((create {P_IFILE_STATIC}).next_ifile (l_h))
				else
					l_next := ((create {P_IFILE_STATIC}).prev_ifile (l_h))
				end
				l_n := l_n - 1
				if l_n < 0 then
					if (edit_ifile (l_h)) = 0 then
						l_break := True
					end
				end
				if not (l_return or l_break) then
					if l_next.is_void then
						Result := 1
						l_return := True
					end
					if not l_return and then ((((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean) then
						Result := 1
						l_return := True
					end
					if not l_return then
						l_h := l_next
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	edit_inext (a_h: CE_POINTER [ANY]; a_n: INTEGER_32): INTEGER_32
		do
			Result := (edit_istep (a_h, a_n, 1))
		end

	edit_next (a_n: INTEGER_32): INTEGER_32
		do
			Result := (edit_istep ((create {P_MAIN_STATIC}).curr_ifile.item, a_n, 1))
		end

	edit_iprev (a_h: CE_POINTER [ANY]; a_n: INTEGER_32): INTEGER_32
		do
			Result := (edit_istep (a_h, a_n, -1))
		end

	edit_prev (a_n: INTEGER_32): INTEGER_32
		do
			Result := (edit_istep ((create {P_MAIN_STATIC}).curr_ifile.item, a_n, -1))
		end

	edit_index (a_n: INTEGER_32): INTEGER_32
		local
			l_h: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_h := create {CE_VOID_POINTER}.make_shared (default_pointer)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_h := (create {P_IFILE_STATIC}).next_ifile (l_h)
				if l_h.is_void then
					Result := 1
					l_return := True
				end
				if not l_return then
					if ((create {P_IFILE_STATIC}).get_index (l_h)) = a_n then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := (edit_ifile (l_h))
			end
		end

	save_curr_ifile: CE_POINTER [ANY]
		do
			if not ((create {P_MAIN_STATIC}).curr_ifile.item).is_void then
				(create {P_IFILE_STATIC}).hold_ifile ((create {P_MAIN_STATIC}).curr_ifile.item, 1)
			end
			Result := ((create {P_MAIN_STATIC}).curr_ifile.item)
		end

	unsave_ifile (a_save_ifile: CE_POINTER [ANY])
		do
			if not a_save_ifile.is_void then
				(create {P_IFILE_STATIC}).hold_ifile (a_save_ifile, -1)
			end
		end

	reedit_ifile (a_save_ifile: CE_POINTER [ANY])
		local
			l_next: CE_POINTER [ANY]
			l_prev: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			unsave_ifile (a_save_ifile)
			l_next := (create {P_IFILE_STATIC}).next_ifile (a_save_ifile)
			l_prev := (create {P_IFILE_STATIC}).prev_ifile (a_save_ifile)
			if (edit_ifile (a_save_ifile)) = 0 then
				l_return := True
			end
			if not l_return and then (not l_next.is_void) then
				if (edit_inext (l_next, 0)) = 0 then
					l_return := True
				end
			end
			if not l_return and then (not l_prev.is_void) then
				if (edit_iprev (l_prev, 0)) = 0 then
					l_return := True
				end
			end
			if not l_return then
				(create {P_MAIN_STATIC}).quit (1)
			end
		end

	edit_stdin: INTEGER_32
		do
			if (isatty (fd0.item)).to_boolean then
				(create {P_OUTPUT_STATIC}).error (ce_string ("Missing filename (%"less --help%" for help)"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer));
				(create {P_MAIN_STATIC}).quit (0)
			end
			Result := (edit (ce_string ("-")))
		end

	cat_file
		local
			l_c: INTEGER_32
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				l_c := (create {P_CH_STATIC}).ch_forw_get
				if l_c = -1 then
					l_break := True
				end
				if not (l_break) then
					(create {P_OUTPUT_STATIC}).putchr (l_c).do_nothing
				end
			end
			l_break := False;
			(create {P_OUTPUT_STATIC}).flush
		end

	use_logfile (a_filename: CE_POINTER [INTEGER_8])
		local
			l_filename: CE_POINTER [INTEGER_8]
			l_exists: INTEGER_32
			l_answer: INTEGER_32
			l_parg: CE_ARRAY [PD_PARG]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PARG]} l_parg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_filename := a_filename
					if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (1)).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						l_filename := (create {P_FILENAME_STATIC}).shell_unquote (l_filename)
						l_exists := open ([l_filename, 0])
						close (l_exists).do_nothing
						l_exists := (l_exists >= 0).to_integer
						if not l_exists.to_boolean then
							l_answer := ('O').code
						elseif ((create {P_MAIN_STATIC}).force_logfile.item).to_boolean then
							l_answer := ('O').code
						else
							l_parg.item.p_string := l_filename
							l_answer := (create {P_OUTPUT_STATIC}).query (ce_string ("Warning: %"%%s%" exists; Overwrite, Append or Don%'t log? "), l_parg)
						end
				when 2 then -- loop:
						inspect l_answer -- switch 1 head
						when 79 then l_pos := -1 + 3
						when 111 then l_pos := -1 + 3
						when 65 then l_pos := -1 + 4
						when 97 then l_pos := -1 + 4
						when 68 then l_pos := -1 + 5
						when 100 then l_pos := -1 + 5
						when 113 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 79 | switch 1, case 111;
						(create {P_MAIN_STATIC}).logfile.item := creat (l_filename, (420).to_natural_32)
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 65 | switch 1, case 97;
						(create {P_MAIN_STATIC}).logfile.item := open ([l_filename, 1_025])
						if (lseek ((create {P_MAIN_STATIC}).logfile.item, (0).to_integer_32, 2)) = -1 then
							close ((create {P_MAIN_STATIC}).logfile.item).do_nothing;
							(create {P_MAIN_STATIC}).logfile.item := -1
						end
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 68 | switch 1, case 100
						free (create {CE_VOID_POINTER}.make_cast (l_filename))
						l_return := True
				when 6 then -- switch 1, case 113
						if not l_return then
							(create {P_MAIN_STATIC}).quit (0)
						end
				when 7 then -- switch 1, default:
						if not l_return then
							l_answer := (create {P_OUTPUT_STATIC}).query (ce_string ("Overwrite, Append, or Don%'t log? (Type %"O%", %"A%", %"D%" or %"q%") "), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
							l_pos := -1 + 2 -- goto loop
						end
				when 8 then -- switch 1, done: | if done
					if not l_return and then ((create {P_MAIN_STATIC}).logfile.item < 0) then
						l_parg.item.p_string := l_filename;
						(create {P_OUTPUT_STATIC}).error (ce_string ("Cannot write to %"%%s%""), l_parg)
						free (create {CE_VOID_POINTER}.make_cast (l_filename))
						l_return := True
					end
					if not l_return then
						free (create {CE_VOID_POINTER}.make_cast (l_filename))
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
