class
	P_LINENUM_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	lnloop: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	anchor___0: CE_STATIC [CE_ARRAY [PD_LINENUM_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LINENUM_INFO]}.make (<<1>>)
		end

	freelist: CE_STATIC [CE_POINTER [PD_LINENUM_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_LINENUM_INFO]}.make
		end

	pool: CE_STATIC [CE_ARRAY [PD_LINENUM_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LINENUM_INFO]}.make (<<50>>)
		end

	spare: CE_STATIC [CE_POINTER [PD_LINENUM_INFO]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_LINENUM_INFO]}.make
		end

	loopcount: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	startime: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	clr_linenum
		local
			l_p: CE_POINTER [PD_LINENUM_INFO]
		do
			l_p := pool.item
			from
			until
				not ((l_p.c_pointer.to_integer_32).to_natural_32 < ((pool.item + 48).c_pointer.to_integer_32).to_natural_32)
			loop
				l_p.item.next := l_p + 1
				l_p := l_p + 1
			end
			pool.item[48].next := create {CE_CLASS_POINTER [PD_LINENUM_INFO]}.make_shared (default_pointer)
			freelist.item := pool.item
			spare.item := pool.item + 49
			anchor___0.item.item.prev := anchor___0.item
			anchor___0.item.item.next := anchor___0.item.item.prev
			anchor___0.item.item.gap := (0).to_integer_32
			anchor___0.item.item.pos := (0).to_integer_32
			anchor___0.item.item.line := (1).to_integer_32
		end

	calcgap (a_p: CE_POINTER [PD_LINENUM_INFO])
		local
			l_return: BOOLEAN
		do
			if a_p.is_equal (anchor___0.item) then
				l_return := True
			elseif (a_p.item.next).is_equal (anchor___0.item) then
				l_return := True
			end
			if not l_return then
				a_p.item.gap := (a_p.item.next).item.pos - (a_p.item.prev).item.pos
			end
		end

	add_lnum (a_linenum, a_pos: INTEGER_32)
		local
			l_p: CE_POINTER [PD_LINENUM_INFO]
			l_new: CE_POINTER [PD_LINENUM_INFO]
			l_nextp: CE_POINTER [PD_LINENUM_INFO]
			l_prevp: CE_POINTER [PD_LINENUM_INFO]
			l_mingap: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_p := anchor___0.item.item.next
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if not l_p.is_equal (anchor___0.item) then
					if not (l_p.item.pos < a_pos) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					if l_p.item.line = a_linenum then
						l_return := True
					end
					if not l_return then
						l_p := l_p.item.next
					end
				end
			end
			if not l_return then
				l_break := False
				l_nextp := l_p
				l_prevp := l_p.item.prev
				if not freelist.item.is_void then
					l_new := freelist.item
					freelist.item := freelist.item.item.next
				else
					l_new := spare.item
					spare.item := create {CE_CLASS_POINTER [PD_LINENUM_INFO]}.make_shared (default_pointer)
				end
				l_new.item.next := l_nextp
				l_new.item.prev := l_prevp
				l_new.item.pos := a_pos
				l_new.item.line := a_linenum
				l_nextp.item.prev := l_new
				l_prevp.item.next := l_new
				calcgap (l_new)
				calcgap (l_nextp)
				calcgap (l_prevp)
				if spare.item.is_void then
					l_mingap := (anchor___0.item.item.next).item.gap
					l_p := anchor___0.item.item.next
					from
					until
						(l_p.item.next).is_equal (anchor___0.item)
					loop
						if l_p.item.gap <= l_mingap then
							spare.item := l_p
							l_mingap := l_p.item.gap
						end
						l_p := l_p.item.next
					end
					(spare.item.item.next).item.prev := spare.item.item.prev;
					(spare.item.item.prev).item.next := spare.item.item.next
				end
			end
		end

	longloopmessage
		do
			(create {P_OUTPUT_STATIC}).ierror (ce_string ("Calculating line numbers"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
			lnloop.item := 1
		end

	longish
		do
			if loopcount.item >= 0 then
				loopcount.item := loopcount.item + 1
				if loopcount.item > 100 then
					loopcount.item := 0
					if ((create {P_OS_STATIC}).get_time) >= startime.item + 2 then
						longloopmessage
						loopcount.item := -1
					end
				end
			end
		end

	find_linenum (a_pos: INTEGER_32): INTEGER_32
		local
			l_p: CE_POINTER [PD_LINENUM_INFO]
			l_linenum: INTEGER_32
			l_cpos: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_LINE_STATIC}).linenums.item.item).to_boolean then
						Result := (0).to_integer_32
						l_return := True
					end
					if not l_return and then (a_pos = -1) then
						Result := (0).to_integer_32
						l_return := True
					end
					if not l_return and then (a_pos <= 0) then
						Result := (1).to_integer_32
						l_return := True
					end
					if not l_return then
						l_p := anchor___0.item.item.next
						from
						until
							(l_break)
						loop
							l_break := False
							l_continue := False
							if not l_p.is_equal (anchor___0.item) then
								if not (l_p.item.pos < a_pos) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break or l_continue) then
								l_continue := True
							end
							if (not l_break) then
								l_p := l_p.item.next
							end
						end
						l_break := False
						l_continue := False
						if l_p.item.pos = a_pos then
							Result := (l_p.item.line)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						startime.item := (create {P_OS_STATIC}).get_time
						if not (l_p.is_equal (anchor___0.item)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (a_pos - (l_p.item.prev).item.pos < l_p.item.pos - a_pos) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_p := l_p.item.prev
						if ((create {P_CH_STATIC}).ch_seek (l_p.item.pos)).to_boolean then
							Result := (0).to_integer_32
							l_return := True
						end
						if not l_return then
							loopcount.item := 0
							l_linenum := l_p.item.line
							l_cpos := l_p.item.pos
							from
							until
								not (not (l_return) and then (l_cpos < a_pos))
							loop
								l_cpos := (create {P_LINE_STATIC}).forw_raw_line (l_cpos, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer))
								if (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
									Result := (0).to_integer_32
									l_return := True
								elseif l_cpos = -1 then
									Result := (0).to_integer_32
									l_return := True
								end
								if not l_return then
									longish
									l_linenum := l_linenum + 1
								end
							end
						end
						if not l_return then
							lnloop.item := 0
							add_lnum (l_linenum, l_cpos)
							if l_cpos > a_pos then
								l_linenum := l_linenum - 1
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if ((create {P_CH_STATIC}).ch_seek (l_p.item.pos)).to_boolean then
							Result := (0).to_integer_32
							l_return := True
						end
						if not l_return then
							loopcount.item := 0
							l_linenum := l_p.item.line
							l_cpos := l_p.item.pos
							from
							until
								not (not (l_return) and then (l_cpos > a_pos))
							loop
								l_cpos := (create {P_LINE_STATIC}).back_raw_line (l_cpos, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer))
								if (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
									Result := (0).to_integer_32
									l_return := True
								elseif l_cpos = -1 then
									Result := (0).to_integer_32
									l_return := True
								end
								if not l_return then
									longish
									l_linenum := l_linenum - 1
								end
							end
						end
						if not l_return then
							lnloop.item := 0
							add_lnum (l_linenum, l_cpos)
						end
				when 8 then -- if done | if done
					if not l_return then
						Result := l_linenum
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_pos (a_linenum: INTEGER_32): INTEGER_32
		local
			l_p: CE_POINTER [PD_LINENUM_INFO]
			l_cpos: INTEGER_32
			l_clinenum: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_linenum <= 1 then
						Result := (0).to_integer_32
						l_return := True
					end
					if not l_return then
						l_p := anchor___0.item.item.next
						from
						until
							(l_break)
						loop
							l_break := False
							l_continue := False
							if not l_p.is_equal (anchor___0.item) then
								if not (l_p.item.line < a_linenum) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break or l_continue) then
								l_continue := True
							end
							if (not l_break) then
								l_p := l_p.item.next
							end
						end
						l_break := False
						l_continue := False
						if l_p.item.line = a_linenum then
							Result := (l_p.item.pos)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if not (l_p.is_equal (anchor___0.item)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (a_linenum - (l_p.item.prev).item.line < l_p.item.line - a_linenum) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_p := l_p.item.prev
						if ((create {P_CH_STATIC}).ch_seek (l_p.item.pos)).to_boolean then
							Result := (-1).to_integer_32
							l_return := True
						end
						if not l_return then
							l_clinenum := l_p.item.line
							l_cpos := l_p.item.pos
							from
							until
								not (not (l_return) and then (l_clinenum < a_linenum))
							loop
								l_cpos := (create {P_LINE_STATIC}).forw_raw_line (l_cpos, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer))
								if (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
									Result := (-1).to_integer_32
									l_return := True
								elseif l_cpos = -1 then
									Result := (-1).to_integer_32
									l_return := True
								end
								if not l_return then
									l_clinenum := l_clinenum + 1
								end
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if ((create {P_CH_STATIC}).ch_seek (l_p.item.pos)).to_boolean then
							Result := (-1).to_integer_32
							l_return := True
						end
						if not l_return then
							l_clinenum := l_p.item.line
							l_cpos := l_p.item.pos
							from
							until
								not (not (l_return) and then (l_clinenum > a_linenum))
							loop
								l_cpos := (create {P_LINE_STATIC}).back_raw_line (l_cpos, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer))
								if (((create {P_CH_STATIC}).sigs.item).bit_and (3)).to_boolean then
									Result := (-1).to_integer_32
									l_return := True
								elseif l_cpos = -1 then
									Result := (-1).to_integer_32
									l_return := True
								end
								if not l_return then
									l_clinenum := l_clinenum - 1
								end
							end
						end
				when 8 then -- if done | if done
					if not l_return then
						add_lnum (l_clinenum, l_cpos)
						Result := l_cpos
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	currline (a_where: INTEGER_32): INTEGER_32
		local
			l_where: INTEGER_32
			l_pos2: INTEGER_32
			l_len: INTEGER_32
			l_linenum: INTEGER_32
			l_break: BOOLEAN
		do
			l_where := a_where
			l_pos2 := (create {P_POSITION_STATIC}).position (l_where)
			l_len := (create {P_CH_STATIC}).ch_length
			from
			until
				(l_break)
			loop
				l_break := False
				if l_pos2 = -1 then
					if l_where >= 0 then
						if not (l_where < (create {P_SCREEN_STATIC}).sc_height.item) then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_where := l_where + 1
					l_pos2 := (create {P_POSITION_STATIC}).position (l_where)
				end
			end
			l_break := False
			if l_pos2 = -1 then
				l_pos2 := l_len
			end
			l_linenum := find_linenum (l_pos2)
			if l_pos2 = l_len then
				l_linenum := l_linenum - 1
			end
			Result := l_linenum
		end

end
