class
	P_POSITION_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	table: CE_STATIC [CE_POINTER [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
		end

	table_size: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	position (a_where: INTEGER_32): INTEGER_32
		local
			l_where: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_where := a_where
					inspect l_where -- switch 1 head
					when -1 then l_pos := -1 + 1 -- -1
					when -2 then l_pos := -1 + 2 -- -2
					when -3 then l_pos := -1 + 3 -- -3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case -1
					l_where := (create {P_SCREEN_STATIC}).sc_height.item - 2
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case -2
					l_where := (create {P_SCREEN_STATIC}).sc_height.item - 1
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case -3
					l_where := ((create {P_SCREEN_STATIC}).sc_height.item - 1) // 2
				when 4 then -- switch 1, done:
					Result := (table.item[l_where])
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_forw_pos (a_pos: INTEGER_32)
		local
			l_i: INTEGER_32
		do
			l_i := 1
			from
			until
				not (l_i < (create {P_SCREEN_STATIC}).sc_height.item)
			loop
				table.item[(l_i - 1)] := table.item[l_i]
				l_i := l_i + 1
			end
			table.item[((create {P_SCREEN_STATIC}).sc_height.item - 1)] := a_pos
		end

	add_back_pos (a_pos: INTEGER_32)
		local
			l_i: INTEGER_32
		do
			l_i := (create {P_SCREEN_STATIC}).sc_height.item - 1
			from
			until
				not (l_i > 0)
			loop
				table.item[l_i] := table.item[(l_i - 1)]
				l_i := l_i - 1
			end
			table.item[0] := a_pos
		end

	pos_clear
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < (create {P_SCREEN_STATIC}).sc_height.item)
			loop
				table.item[l_i] := (-1).to_integer_32
				l_i := l_i + 1
			end
		end

	pos_init
		local
			l_scrpos: CE_ARRAY [PD_SCRPOS]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_SCRPOS]} l_scrpos.make (<<1>>)

			if (create {P_SCREEN_STATIC}).sc_height.item <= table_size.item then
				l_return := True
			end
			if not l_return then
				if not table.item.is_void then
					l_scrpos.item.get_scrpos
					free (create {CE_VOID_POINTER}.make_cast (table.item))
				else
					l_scrpos.item.pos := (-1).to_integer_32
				end
				table.item := create {CE_INTEGER_32_POINTER}.make_cast (((create {P_MAIN_STATIC}).ecalloc ((create {P_SCREEN_STATIC}).sc_height.item, {PLATFORM}.Integer_32_bytes.to_natural_32)))
				table_size.item := (create {P_SCREEN_STATIC}).sc_height.item
				pos_clear
				if l_scrpos.item.pos /= -1 then
					table.item[(l_scrpos.item.ln - 1)] := l_scrpos.item.pos
				end
			end
		end

	onscreen (a_pos: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			if a_pos < table.item[0] then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_i := 1
				from
				until
					not (not (l_return) and then (l_i < (create {P_SCREEN_STATIC}).sc_height.item))
				loop
					if a_pos < table.item[l_i] then
						Result := (l_i - 1)
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	empty_screen: INTEGER_32
		do
			Result := (empty_lines (0, (create {P_SCREEN_STATIC}).sc_height.item - 1))
		end

	empty_lines (a_s, a_e: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := a_s
			from
			until
				not (not (l_return) and then (l_i <= a_e))
			loop
				if table.item[l_i] /= -1 then
					Result := 0
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	adjsline (a_sline: INTEGER_32): INTEGER_32
		local
			l_sline: INTEGER_32
		do
			l_sline := a_sline
			if l_sline < 0 then
				l_sline := l_sline + ((create {P_SCREEN_STATIC}).sc_height.item)
			end
			if l_sline <= 0 then
				l_sline := 1
			end
			if l_sline >= (create {P_SCREEN_STATIC}).sc_height.item then
				l_sline := (create {P_SCREEN_STATIC}).sc_height.item - 1
			end
			Result := (l_sline - 1)
		end

end
