class
	PD_BUF

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	PD_BUFLIST
		rename
			buf_next as next,
			buf_prev as prev,
			buf_hnext as hnext,
			buf_hprev as hprev
		redefine
			make,
			copy,
			is_equal,
			structure_info
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} data.make (<<8_192>>)
			Precursor
		end

feature {ANY} -- fields

	block: INTEGER_32 assign set_block

	datasize: NATURAL_32 assign set_datasize

	data: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_block (a_block: INTEGER_32)
		do
			block := a_block
			update_memory_field ("block")
		end

	set_datasize (a_datasize: NATURAL_32)
		do
			datasize := a_datasize
			update_memory_field ("datasize")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			Precursor {PD_BUFLIST} (a_other)
			block := a_other.block
			datasize := a_other.datasize
			data := a_other.data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				Precursor {PD_BUFLIST} (a_other) and
				block = a_other.block and
				datasize = a_other.datasize and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("datasize"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("data", <<8_192>>)
				>>)
			Result.set_superclasses (<<{PD_BUFLIST}>>)
			Result.add_rename ("buf_next", "next")
			Result.add_rename ("buf_prev", "prev")
			Result.add_rename ("buf_hnext", "hnext")
			Result.add_rename ("buf_hprev", "hprev")
			init_structure_info
		end

end
