class
	PD_HILITE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_HILITE]} hl_next.make
		end

feature {ANY} -- fields

	hl_next: CE_POINTER [PD_HILITE] assign set_hl_next

	hl_startpos: INTEGER_32 assign set_hl_startpos

	hl_endpos: INTEGER_32 assign set_hl_endpos

feature {ANY} -- field setters

	set_hl_next (a_hl_next: CE_POINTER [PD_HILITE])
		do
			hl_next := a_hl_next
			update_memory_field ("hl_next")
		end

	set_hl_startpos (a_hl_startpos: INTEGER_32)
		do
			hl_startpos := a_hl_startpos
			update_memory_field ("hl_startpos")
		end

	set_hl_endpos (a_hl_endpos: INTEGER_32)
		do
			hl_endpos := a_hl_endpos
			update_memory_field ("hl_endpos")
		end

feature {ANY} -- public routines

	adj_hilite (a_linepos: INTEGER_32; a_cvt_ops: INTEGER_32)
		local
			l_line: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_hl: CE_POINTER [PD_HILITE]
			l_checkstart: INTEGER_32
			l_opos: INTEGER_32
			l_npos: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_line.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_LINE_STATIC}).forw_raw_line (a_linepos, l_line).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_npos := a_linepos
					l_opos := l_npos
					l_hl := hl_next
					l_checkstart := 1
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (not l_hl.is_void)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if not (l_checkstart.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_hl.item.hl_startpos = l_opos then
							l_hl.item.hl_startpos := l_npos
							update_class_fields -- Current might have been changed; synchronize
							l_checkstart := 0
							l_continue := True
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if not l_checkstart.to_boolean then
							if l_hl.item.hl_endpos = l_opos then
								l_hl.item.hl_endpos := l_npos
								update_class_fields -- Current might have been changed; synchronize
								l_checkstart := 1
								l_hl := l_hl.item.hl_next
								l_continue := True
							end
						end
				when 6 then
						if not (l_return or l_break or l_continue) and then ((l_line.item[0]).to_integer_32 = 0) then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							if ((a_cvt_ops).bit_and (8)).to_boolean then
								from
								until
									not (not (l_return) and then ((l_line.item[0]).to_integer_32 = 27))
								loop
									l_line.item := l_line.item + 1
									update_class_fields -- Current might have been changed; synchronize
									l_npos := l_npos + 1
									from
									until
										not (not (l_break) and then ((l_line.item[0]).to_integer_32 /= 0))
									loop
										l_break := False
										l_npos := l_npos + 1
										l_tmp := l_line.item
										l_line.item := l_line.item + 1
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___0 := (create {P_LINE_STATIC}).is_ansi_end (((l_tmp[0]).to_integer_32).to_integer_8)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___0.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
							end
							l_opos := l_opos + 1
							l_npos := l_npos + 1
							l_line.item := l_line.item + 1
							update_class_fields -- Current might have been changed; synchronize
							if ((a_cvt_ops).bit_and (2)).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_line.item[0]).to_integer_32 = 8 then
										if (l_line.item[1]).to_integer_32 = 0 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break) then
										l_npos := l_npos + (2)
										l_line.item := l_line.item + (2)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								l_break := False
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_break := False
					l_continue := False
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hl_next := a_other.hl_next
			hl_startpos := a_other.hl_startpos
			hl_endpos := a_other.hl_endpos
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hl_next.is_equal (a_other.hl_next) and
				hl_startpos = a_other.hl_startpos and
				hl_endpos = a_other.hl_endpos
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hl_next"),
					create {CE_STRUCTURE_FIELD}.make ("hl_startpos"),
					create {CE_STRUCTURE_FIELD}.make ("hl_endpos")
				>>)
			init_structure_info
		end

end
