class
	SD_STAT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create st_atim.make
			create st_mtim.make
			create st_ctim.make
		end

feature {ANY} -- fields

	st_dev: NATURAL_64 assign set_st_dev

	pad1: NATURAL_16 assign set_pad1

	st_ino: NATURAL_32 assign set_st_ino

	st_mode: NATURAL_32 assign set_st_mode

	st_nlink: NATURAL_32 assign set_st_nlink

	st_uid: NATURAL_32 assign set_st_uid

	st_gid: NATURAL_32 assign set_st_gid

	st_rdev: NATURAL_64 assign set_st_rdev

	pad2: NATURAL_16 assign set_pad2

	st_size: INTEGER_32 assign set_st_size

	st_blksize: INTEGER_32 assign set_st_blksize

	st_blocks: INTEGER_32 assign set_st_blocks

	st_atim: SD_TIMESPEC assign set_st_atim

	st_mtim: SD_TIMESPEC assign set_st_mtim

	st_ctim: SD_TIMESPEC assign set_st_ctim

	unused4: NATURAL_32 assign set_unused4

	unused5: NATURAL_32 assign set_unused5

feature {ANY} -- field setters

	set_st_dev (a_st_dev: NATURAL_64)
		do
			st_dev := a_st_dev
			update_memory_field ("st_dev")
		end

	set_pad1 (a_pad1: NATURAL_16)
		do
			pad1 := a_pad1
			update_memory_field ("pad1")
		end

	set_st_ino (a_st_ino: NATURAL_32)
		do
			st_ino := a_st_ino
			update_memory_field ("st_ino")
		end

	set_st_mode (a_st_mode: NATURAL_32)
		do
			st_mode := a_st_mode
			update_memory_field ("st_mode")
		end

	set_st_nlink (a_st_nlink: NATURAL_32)
		do
			st_nlink := a_st_nlink
			update_memory_field ("st_nlink")
		end

	set_st_uid (a_st_uid: NATURAL_32)
		do
			st_uid := a_st_uid
			update_memory_field ("st_uid")
		end

	set_st_gid (a_st_gid: NATURAL_32)
		do
			st_gid := a_st_gid
			update_memory_field ("st_gid")
		end

	set_st_rdev (a_st_rdev: NATURAL_64)
		do
			st_rdev := a_st_rdev
			update_memory_field ("st_rdev")
		end

	set_pad2 (a_pad2: NATURAL_16)
		do
			pad2 := a_pad2
			update_memory_field ("pad2")
		end

	set_st_size (a_st_size: INTEGER_32)
		do
			st_size := a_st_size
			update_memory_field ("st_size")
		end

	set_st_blksize (a_st_blksize: INTEGER_32)
		do
			st_blksize := a_st_blksize
			update_memory_field ("st_blksize")
		end

	set_st_blocks (a_st_blocks: INTEGER_32)
		do
			st_blocks := a_st_blocks
			update_memory_field ("st_blocks")
		end

	set_st_atim (a_st_atim: SD_TIMESPEC)
		do
			st_atim := a_st_atim
			update_memory_field ("st_atim")
		end

	set_st_mtim (a_st_mtim: SD_TIMESPEC)
		do
			st_mtim := a_st_mtim
			update_memory_field ("st_mtim")
		end

	set_st_ctim (a_st_ctim: SD_TIMESPEC)
		do
			st_ctim := a_st_ctim
			update_memory_field ("st_ctim")
		end

	set_unused4 (a_unused4: NATURAL_32)
		do
			unused4 := a_unused4
			update_memory_field ("unused4")
		end

	set_unused5 (a_unused5: NATURAL_32)
		do
			unused5 := a_unused5
			update_memory_field ("unused5")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			st_dev := a_other.st_dev
			pad1 := a_other.pad1
			st_ino := a_other.st_ino
			st_mode := a_other.st_mode
			st_nlink := a_other.st_nlink
			st_uid := a_other.st_uid
			st_gid := a_other.st_gid
			st_rdev := a_other.st_rdev
			pad2 := a_other.pad2
			st_size := a_other.st_size
			st_blksize := a_other.st_blksize
			st_blocks := a_other.st_blocks
			st_atim := a_other.st_atim.twin
			st_mtim := a_other.st_mtim.twin
			st_ctim := a_other.st_ctim.twin
			unused4 := a_other.unused4
			unused5 := a_other.unused5
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				st_dev = a_other.st_dev and
				pad1 = a_other.pad1 and
				st_ino = a_other.st_ino and
				st_mode = a_other.st_mode and
				st_nlink = a_other.st_nlink and
				st_uid = a_other.st_uid and
				st_gid = a_other.st_gid and
				st_rdev = a_other.st_rdev and
				pad2 = a_other.pad2 and
				st_size = a_other.st_size and
				st_blksize = a_other.st_blksize and
				st_blocks = a_other.st_blocks and
				st_atim.is_equal (a_other.st_atim) and
				st_mtim.is_equal (a_other.st_mtim) and
				st_ctim.is_equal (a_other.st_ctim) and
				unused4 = a_other.unused4 and
				unused5 = a_other.unused5
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("st_dev"),
					create {CE_STRUCTURE_FIELD}.make ("pad1"),
					create {CE_STRUCTURE_FIELD}.make ("st_ino"),
					create {CE_STRUCTURE_FIELD}.make ("st_mode"),
					create {CE_STRUCTURE_FIELD}.make ("st_nlink"),
					create {CE_STRUCTURE_FIELD}.make ("st_uid"),
					create {CE_STRUCTURE_FIELD}.make ("st_gid"),
					create {CE_STRUCTURE_FIELD}.make ("st_rdev"),
					create {CE_STRUCTURE_FIELD}.make ("pad2"),
					create {CE_STRUCTURE_FIELD}.make ("st_size"),
					create {CE_STRUCTURE_FIELD}.make ("st_blksize"),
					create {CE_STRUCTURE_FIELD}.make ("st_blocks"),
					create {CE_STRUCTURE_FIELD}.make ("st_atim"),
					create {CE_STRUCTURE_FIELD}.make ("st_mtim"),
					create {CE_STRUCTURE_FIELD}.make ("st_ctim"),
					create {CE_STRUCTURE_FIELD}.make ("unused4"),
					create {CE_STRUCTURE_FIELD}.make ("unused5")
				>>)
			init_structure_info
		end

end
