class
	P_CONVERT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	S_LIBINTL_STATIC
	S_BITS_ERRNO_STATIC
	S_STRING_STATIC
	S_UNISTD_STATIC
	S_STDIO_STATIC
	S_STDLIB_STATIC
	S_LIBIO_STATIC
	S_ASSERT_STATIC

feature {ANY} -- public attributes

	dl_url_file_map: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	downloaded_html_set: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	downloaded_css_set: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	dl_file_url_map: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	converted_files: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	downloaded_files_hash: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

	v1: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					{PC_DOWNLOADED_FILE_T}.FILE_NOT_ALREADY_DOWNLOADED
				>>)
		end

	v2: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					{PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_NORMALLY
				>>)
		end

	v3: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					{PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_AND_HTML_EXTENSION_ADDED
				>>)
		end

	v4: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					{PC_DOWNLOADED_FILE_T}.CHECK_FOR_FILE
				>>)
		end

feature {ANY} -- public routines

	convert_links_in_hashtable (a_downloaded_set: CE_POINTER [PD_HASH_TABLE]; a_is_css: INTEGER_32; a_file_count: CE_POINTER [INTEGER_32])
		local
			l_i: INTEGER_32
			l_cnt: INTEGER_32
			l_file_array: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_urls: CE_POINTER [PD_URLPOS]
			l_cur_url: CE_POINTER [PD_URLPOS]
			l_url: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [INTEGER_8]
			l_local_name: CE_POINTER [INTEGER_8]
			l_u: CE_POINTER [PD_URL]
			l_return, l_break, l_continue: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			l_cnt := 0
			if (not a_downloaded_set.is_void) then
				l_cnt := a_downloaded_set.item.hash_table_count
			end
			if l_cnt = 0 then
				l_return := True
			end
			if not l_return then
				l_file_array := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (l_cnt.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
				a_downloaded_set.item.string_set_to_array (l_file_array)
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < l_cnt))
				loop
					l_continue := False
					l_file := l_file_array[l_i]
					l_url := create {CE_INTEGER_8_POINTER}.make_cast ((dl_file_url_map.item.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (l_file))))
					if l_url.is_void then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Apparently %%s has been removed.%N"), l_file])
							end
							l_break := True
						end
						l_break := False
						l_continue := True
					end
					if not (l_return or l_break or l_continue) then
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Scanning %%s (from %%s)%N"), l_file, l_url])
							end
							l_break := True
						end
						l_break := False
						if a_is_css.to_boolean then
							l_urls := ((create {P_CSS_URL_STATIC}).get_urls_css_file (l_file, l_url))
						else
							l_urls := ((create {P_HTML_URL_STATIC}).get_urls_html (l_file, l_url, create {CE_BOOLEAN_POINTER}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_IRI]}.make_shared (default_pointer)))
						end
						l_cur_url := l_urls
						from
						until
							not (not (l_return) and then (not l_cur_url.is_void))
						loop
							l_continue := False
							l_u := l_cur_url.item.url
							if (l_cur_url.item.link_base_p).to_boolean then
								l_cur_url.item.convert2 := {PC_CONVERT_OPTIONS}.CO_NULLIFY_BASE
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								l_local_name := create {CE_INTEGER_8_POINTER}.make_cast ((dl_url_file_map.item.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (l_u.item.url))))
								if (not l_local_name.is_void) then
									l_cur_url.item.convert2 := {PC_CONVERT_OPTIONS}.CO_CONVERT_TO_RELATIVE
									l_cur_url.item.local_name := (create {P_XMALLOC_STATIC}).xstrdup (l_local_name)
									from
									until
										(l_break)
									loop
										l_break := False
										if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
											(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("will convert url %%s to local %%s%N"), l_u.item.url, l_local_name])
										end
										l_break := True
									end
									l_break := False
								else
									if not (l_cur_url.item.link_complete_p).to_boolean then
										l_cur_url.item.convert2 := {PC_CONVERT_OPTIONS}.CO_CONVERT_TO_COMPLETE
									end
									l_cur_url.item.local_name := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									from
									until
										(l_break)
									loop
										l_break := False
										if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
											(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("will convert url %%s to complete%N"), l_u.item.url])
										end
										l_break := True
									end
									l_break := False
								end
							end
							if (not l_return) then
								l_cur_url := l_cur_url.item.next
							end
						end
						l_continue := False
						convert_links (l_file, l_urls)
						a_file_count.item := (a_file_count.item) + 1;
						(create {P_RETR_STATIC}).free_urlpos (l_urls)
					end
					if (not l_return) then
						l_i := l_i + 1
					end
				end
				l_continue := False
			end
		end

	convert_all_links
		local
			l_secs: REAL_64
			l_file_count: CE_ARRAY [INTEGER_32]
			l_timer: CE_POINTER [PD_PTIMER]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_32_ARRAY} l_file_count.make (<<1>>)

			l_file_count.item := 0
			l_timer := ((create {P_PTIMER_STATIC}).ptimer_new)
			convert_links_in_hashtable (downloaded_html_set.item, 0, l_file_count)
			convert_links_in_hashtable (downloaded_css_set.item, 1, l_file_count)
			l_secs := l_timer.item.ptimer_measure
			l_tmp___0 := (create {P_UTILS_STATIC}).print_decimal (l_secs);
			(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Converted %%d files in %%s seconds.%N"))), l_file_count.item, l_tmp___0]);
			(create {P_PTIMER_STATIC}).ptimer_destroy (l_timer)
		end

	convert_links (a_file: CE_POINTER [INTEGER_8]; a_links: CE_POINTER [PD_URLPOS])
		local
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_p___0: CE_POINTER [INTEGER_8]
			l_downloaded_file_return: NATURAL_32
			l_link___0: CE_POINTER [PD_URLPOS]
			l_to_url_count: INTEGER_32
			l_to_file_count: INTEGER_32
			l_dry_count: INTEGER_32
			l_dry: CE_POINTER [PD_URLPOS]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_url_start: CE_POINTER [INTEGER_8]
			l_newname: CE_POINTER [INTEGER_8]
			l_quoted_newname: CE_POINTER [INTEGER_8]
			l_newlink: CE_POINTER [INTEGER_8]
			l_quoted_newlink: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_to_url_count := 0
					l_to_file_count := 0;
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Converting %%s... "))), a_file])
					l_dry_count := 0
					l_dry := a_links
					from
					until
						l_dry.is_void
					loop
						if l_dry.item.convert2 /= {NATURAL_32} 0 then
							l_dry_count := l_dry_count + 1
						end
						l_dry := l_dry.item.next
					end
					if not l_dry_count.to_boolean then
						(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("nothing to do.%N"))))
						l_return := True
					end
					if not l_return then
						l_fm := (create {P_UTILS_STATIC}).read_file (a_file)
						if l_fm.is_void then
							l_tmp___2 := strerror ((errno_location).item);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot convert links in %%s: %%s%N"))), a_file, l_tmp___2])
							l_return := True
						end
					end
					if not l_return then
						l_downloaded_file_return := downloaded_file ({PC_DOWNLOADED_FILE_T}.CHECK_FOR_FILE, a_file)
						if (create {P_OPTIONS_STATIC}).opt.item.item.backup_converted then
							if l_downloaded_file_return.to_boolean then
								write_backup_file (a_file, l_downloaded_file_return)
							end
						end
						if (unlink (a_file)) < 0 then
							if (errno_location).item /= 2 then
								l_tmp___5 := strerror ((errno_location).item)
								l_tmp___6 := (create {P_QUOTE_STATIC}).quote (a_file);
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Unable to delete %%s: %%s%N"))), l_tmp___6, l_tmp___5])
								l_fm.item.read_file_free
								l_return := True
							end
						end
					end
					if not l_return then
						l_fp := fopen (a_file, ce_string ("wb"))
						if l_fp.is_void then
							l_tmp___11 := strerror ((errno_location).item);
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot convert links in %%s: %%s%N"))), a_file, l_tmp___11])
							l_fm.item.read_file_free
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := l_fm.item.content
						l_link___0 := a_links
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then (not l_link___0.is_void)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						l_url_start := l_fm.item.content + l_link___0.item.pos
						if (l_link___0.item.pos).to_integer_32 >= l_fm.item.length then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Something strange is going on.  Please investigate.")])
								end
								l_break := True
							end
							l_break := False
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then (l_link___0.item.convert2 = {NATURAL_32} 0) then
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
									(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Skipping %%s at position %%d.%N"), (l_link___0.item.url).item.url, l_link___0.item.pos])
								end
								l_break := True
							end
							l_break := False
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						fwrite (create {CE_VOID_POINTER}.make_cast (l_p___0), (1).to_natural_32, (l_url_start.distance (l_p___0)).to_natural_32, l_fp).do_nothing
						l_p___0 := l_url_start
						inspect (l_link___0.item.convert2).to_integer_32 -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when 0 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 5 then -- switch 1, case 1
						l_newname := (construct_relative (a_file, l_link___0.item.local_name))
						l_quoted_newname := (local_quote_string (l_newname))
						if (l_link___0.item.link_css_p).to_boolean then
							l_p___0 := replace_plain (l_p___0, l_link___0.item.size, l_fp, l_quoted_newname)
						elseif not (l_link___0.item.link_refresh_p).to_boolean then
							l_p___0 := replace_attr (l_p___0, l_link___0.item.size, l_fp, l_quoted_newname)
						else
							l_p___0 := replace_attr_refresh_hack (l_p___0, l_link___0.item.size, l_fp, l_quoted_newname, l_link___0.item.refresh_timeout)
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("TO_RELATIVE: %%s to %%s at position %%d in %%s.%N"), (l_link___0.item.url).item.url, l_newname, l_link___0.item.pos, a_file])
							end
							l_break := True
						end
						l_break := False
						free (create {CE_VOID_POINTER}.make_cast (l_newname))
						free (create {CE_VOID_POINTER}.make_cast (l_quoted_newname))
						l_to_file_count := l_to_file_count + 1
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 2
						l_newlink := (l_link___0.item.url).item.url
						l_quoted_newlink := (html_quote_string (l_newlink))
						if (l_link___0.item.link_css_p).to_boolean then
							l_p___0 := replace_plain (l_p___0, l_link___0.item.size, l_fp, l_quoted_newlink)
						elseif not (l_link___0.item.link_refresh_p).to_boolean then
							l_p___0 := replace_attr (l_p___0, l_link___0.item.size, l_fp, l_quoted_newlink)
						else
							l_p___0 := replace_attr_refresh_hack (l_p___0, l_link___0.item.size, l_fp, l_quoted_newlink, l_link___0.item.refresh_timeout)
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("TO_COMPLETE: <something> to %%s at position %%d in %%s.%N"), l_newlink, l_link___0.item.pos, a_file])
							end
							l_break := True
						end
						l_break := False
						free (create {CE_VOID_POINTER}.make_cast (l_quoted_newlink))
						l_to_url_count := l_to_url_count + 1
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 3
						l_p___0 := replace_attr (l_p___0, l_link___0.item.size, l_fp, ce_string (""))
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, case 0
						abort
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						if (not l_return and not l_break) then
							l_link___0 := l_link___0.item.next
						end
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						l_continue := False
						if (l_p___0.distance ((l_fm.item.content))).to_integer_32 < l_fm.item.length then
							fwrite (create {CE_VOID_POINTER}.make_cast (l_p___0), (1).to_natural_32, (l_fm.item.length - (l_p___0.distance ((l_fm.item.content))).to_integer_32).to_natural_32, l_fp).do_nothing
						end
						fclose (l_fp).do_nothing
						l_fm.item.read_file_free;
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%%d-%%d%N"), l_to_file_count, l_to_url_count])
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	construct_relative (a_basefile, a_linkfile: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_basefile.is_void
			not a_linkfile.is_void
		local
			l_basefile: CE_POINTER [INTEGER_8]
			l_linkfile: CE_POINTER [INTEGER_8]
			l_link___0: CE_POINTER [INTEGER_8]
			l_basedirs: INTEGER_32
			l_b: CE_POINTER [INTEGER_8]
			l_l: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_start: INTEGER_32
			l_break: BOOLEAN
		do
			l_basefile := a_basefile
			l_linkfile := a_linkfile
			l_start := 0
			l_b := l_basefile
			l_l := l_linkfile
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_b[0]).to_integer_32 = (l_l[0]).to_integer_32 then
					if (l_b[0]).to_integer_32 = 0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if (l_b[0]).to_integer_32 = 47 then
						l_start := (l_b.distance (l_basefile)) + 1
					end
					l_b := l_b + 1
					l_l := l_l + 1
				end
			end
			l_break := False
			l_basefile := l_basefile + l_start
			l_linkfile := l_linkfile + l_start
			l_basedirs := 0
			l_b := l_basefile
			from
			until
				not ((l_b[0]).to_boolean)
			loop
				if (l_b[0]).to_integer_32 = 47 then
					l_basedirs := l_basedirs + 1
				end
				l_b := l_b + 1
			end
			l_link___0 := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (((3 * l_basedirs).to_natural_32 + (strlen (l_linkfile))) + {NATURAL_32} 1)))
			l_i := 0
			from
			until
				not (l_i < l_basedirs)
			loop
				memcpy (create {CE_VOID_POINTER}.make_cast ((l_link___0 + 3 * l_i)), create {CE_VOID_POINTER}.make_cast (ce_string ("../")), (3).to_natural_32).do_nothing
				l_i := l_i + 1
			end
			strcpy ((l_link___0 + 3 * l_i), l_linkfile).do_nothing
			Result := l_link___0
		end

	write_backup_file (a_file: CE_POINTER [INTEGER_8]; a_downloaded_file_return: NATURAL_32)
		require
			not a_file.is_void
		local
			l_filename_len: NATURAL_32
			l_filename_plus_orig_suffix: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_aaf: CE_ALLOCA_FACTORY
		do
			l_filename_len := (strlen (a_file))
			if a_downloaded_file_return = {NATURAL_32} 2 then
				l_filename_plus_orig_suffix := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (l_filename_len + {NATURAL_32} 1)))
				strcpy (l_filename_plus_orig_suffix, a_file).do_nothing
				strcpy (((l_filename_plus_orig_suffix + l_filename_len.to_integer_32) - 4), ce_string ("orig")).do_nothing
			else
				l_filename_plus_orig_suffix := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (l_filename_len + ((".orig").count + 1).to_natural_32)))
				strcpy (l_filename_plus_orig_suffix, a_file).do_nothing
				strcpy ((l_filename_plus_orig_suffix + l_filename_len.to_integer_32), ce_string (".orig")).do_nothing
			end
			if converted_files.item.is_void then
				converted_files.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
			end
			if not (converted_files.item.item.string_set_contains (a_file)).to_boolean then
				if (rename2 (a_file, l_filename_plus_orig_suffix)) /= 0 then
					l_tmp___3 := strerror ((errno_location).item);
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Cannot back up %%s as %%s: %%s%N"))), a_file, l_filename_plus_orig_suffix, l_tmp___3])
				end
				converted_files.item.item.string_set_add (a_file)
			end
		end

	replace_plain (a_p___0: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]; a_new_text: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [INTEGER_8]
		do
			l_p___0 := a_p___0
			fputs (a_new_text, a_fp).do_nothing
			l_p___0 := l_p___0 + a_size
			Result := l_p___0
		end

	replace_attr (a_p___0: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]; a_new_text: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_size: INTEGER_32
			l_quote_flag: BOOLEAN
			l_quote_char: INTEGER_8
			l_frag_beg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_frag_end: CE_ARRAY [CE_POINTER [INTEGER_8]]
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_frag_beg.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_frag_end.make (<<1>>)

			l_p___0 := a_p___0
			l_size := a_size
			l_quote_flag := (0).to_boolean
			l_quote_char := (('%"').code).to_integer_8
			if (l_p___0[0]).to_integer_32 = 34 then
				l_quote_char := l_p___0[0]
				l_quote_flag := (1).to_boolean
				l_p___0 := l_p___0 + 1
				l_size := l_size - (2)
			elseif (l_p___0[0]).to_integer_32 = 39 then
				l_quote_char := l_p___0[0]
				l_quote_flag := (1).to_boolean
				l_p___0 := l_p___0 + 1
				l_size := l_size - (2)
			end
			IO_putc (l_quote_char.to_integer_32, a_fp).do_nothing
			fputs (a_new_text, a_fp).do_nothing
			if (find_fragment (l_p___0, l_size, l_frag_beg, l_frag_end)) then
				fwrite (create {CE_VOID_POINTER}.make_cast (l_frag_beg.item), (1).to_natural_32, ((l_frag_end.item).distance ((l_frag_beg.item))).to_natural_32, a_fp).do_nothing
			end
			l_p___0 := l_p___0 + l_size
			if l_quote_flag then
				l_p___0 := l_p___0 + 1
			end
			IO_putc (l_quote_char.to_integer_32, a_fp).do_nothing
			Result := l_p___0
		end

	replace_attr_refresh_hack (a_p___0: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_fp: CE_POINTER [SD_IO_FILE]; a_new_text: CE_POINTER [INTEGER_8]; a_timeout: INTEGER_32): CE_POINTER [INTEGER_8]
		require
			not a_p___0.is_void
			not a_new_text.is_void
		local
			l_new_with_timeout: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			l_tmp := (create {P_UTILS_STATIC}).numdigit (a_timeout.to_integer_64)
			l_new_with_timeout := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new (((l_tmp + 6).to_natural_32 + (strlen (a_new_text))) + {NATURAL_32} 1)))
			sprintf ([l_new_with_timeout, ce_string ("%%d; URL=%%s"), a_timeout, a_new_text]).do_nothing
			Result := (replace_attr (a_p___0, a_size, a_fp, l_new_with_timeout))
		end

	find_fragment (a_beg: CE_POINTER [INTEGER_8]; a_size: INTEGER_32; a_bp, a_ep: CE_POINTER [CE_POINTER [INTEGER_8]]): BOOLEAN
		local
			l_beg: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_saw_amp: BOOLEAN
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_beg := a_beg
					l_end := l_beg + a_size
					l_saw_amp := (0).to_boolean
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_beg.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_beg[0]).to_integer_32 -- switch 1 head
						when 38 then l_pos := -1 + 3
						when 35 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 38
						l_saw_amp := (1).to_boolean
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 35
						if not l_saw_amp then
							a_bp.item := l_beg
							a_ep.item := l_end
							Result := (1).to_boolean
							l_return := True
						end
				when 5 then -- switch 1, default:
						if not l_return then
							l_saw_amp := (0).to_boolean
						end
				when 6 then -- switch 1, done:
						if not l_return then
							l_beg := l_beg + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not l_return then
						Result := (0).to_boolean
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	local_quote_string (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_file.is_void
		local
			l_from: CE_POINTER [INTEGER_8]
			l_newname: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			l_any: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_any := (strpbrk (a_file, ce_string ("?#%%;")))
					if l_any.is_void then
						Result := (html_quote_string (a_file))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_newname := create {CE_INTEGER_8_POINTER}.make_cast ((l_aaf.new ({NATURAL_32} 3 * (strlen (a_file)) + {NATURAL_32} 1)))
						l_to := l_newname
						l_from := a_file
				when 2 then -- loop condition:
						if not ((l_from[0]).to_boolean) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						inspect (l_from[0]).to_integer_32 -- switch 1 head
						when 37 then l_pos := -1 + 4
						when 35 then l_pos := -1 + 5
						when 59 then l_pos := -1 + 6
						when 63 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 37
						l_tmp___3 := l_to
						l_to := l_to + 1
						l_tmp___3[0] := (('%%').code).to_integer_8
						l_tmp___4 := l_to
						l_to := l_to + 1
						l_tmp___4[0] := (('2').code).to_integer_8
						l_tmp___5 := l_to
						l_to := l_to + 1
						l_tmp___5[0] := (('5').code).to_integer_8
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 35
						l_tmp___6 := l_to
						l_to := l_to + 1
						l_tmp___6[0] := (('%%').code).to_integer_8
						l_tmp___7 := l_to
						l_to := l_to + 1
						l_tmp___7[0] := (('2').code).to_integer_8
						l_tmp___8 := l_to
						l_to := l_to + 1
						l_tmp___8[0] := (('3').code).to_integer_8
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 59
						l_tmp___9 := l_to
						l_to := l_to + 1
						l_tmp___9[0] := (('%%').code).to_integer_8
						l_tmp___10 := l_to
						l_to := l_to + 1
						l_tmp___10[0] := (('3').code).to_integer_8
						l_tmp___11 := l_to
						l_to := l_to + 1
						l_tmp___11[0] := (('B').code).to_integer_8
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 63
						if (create {P_OPTIONS_STATIC}).opt.item.item.adjust_extension then
							l_tmp___12 := l_to
							l_to := l_to + 1
							l_tmp___12[0] := (('%%').code).to_integer_8
							l_tmp___13 := l_to
							l_to := l_to + 1
							l_tmp___13[0] := (('3').code).to_integer_8
							l_tmp___14 := l_to
							l_to := l_to + 1
							l_tmp___14[0] := (('F').code).to_integer_8
							l_pos := -1 + 9 -- switch 1; break
						end
				when 8 then -- switch 1, default:
						l_tmp___15 := l_to
						l_to := l_to + 1
						l_tmp___15[0] := l_from[0]
				when 9 then -- switch 1, done:
						l_from := l_from + 1
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_to[0] := (('%/0/').code).to_integer_8
						Result := (html_quote_string (l_newname))
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	match_except_index (a_s1, a_s2: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_s1.is_void
		local
			l_s1: CE_POINTER [INTEGER_8]
			l_s2: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_lng: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_POINTER} l_lng.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s1 := a_s1
					l_s2 := a_s2
					l_i := 0
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_s1[0]).to_boolean then
							if (l_s2[0]).to_boolean then
								if (l_s1[0]).to_integer_32 /= (l_s2[0]).to_integer_32 then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_s1 := l_s1 + 1
							l_s2 := l_s2 + 1
							l_i := l_i + 1
						end
					end
					l_break := False
					if l_i = 0 then
						Result := (0).to_boolean
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if (l_s1[0]).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not (l_s2[0]).to_boolean then
							Result := (1).to_boolean
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if not ((l_s1[0]).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_s2[0]).to_boolean then
							Result := (0).to_boolean
							l_return := True
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (l_s1[0]).to_boolean then
							l_lng := l_s1
						else
							l_lng := l_s2
						end
				when 8 then -- if done | if done
					if not l_return then
						if (l_lng[0]).to_integer_32 /= 47 then
							l_lng := l_lng - 1
						end
						if (l_lng[0]).to_integer_32 = 47 then
							if (l_lng[1]).to_integer_32 = 0 then
								Result := (1).to_boolean
								l_return := True
							end
						end
					end
					if not l_return then
						Result := (0 = (strcmp (l_lng, ce_string ("/index.html"))))
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dissociate_urls_from_file_mapper (a_key, a_value, a_arg: CE_POINTER [ANY]): INTEGER_32
		local
			l_mapping_url: CE_POINTER [INTEGER_8]
			l_mapping_file: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [INTEGER_8]
		do
			l_mapping_url := create {CE_INTEGER_8_POINTER}.make_cast (a_key)
			l_mapping_file := create {CE_INTEGER_8_POINTER}.make_cast (a_value)
			l_file := create {CE_INTEGER_8_POINTER}.make_cast (a_arg)
			if 0 = (strcmp (l_mapping_file, l_file)) then
				dl_url_file_map.item.item.hash_table_remove (create {CE_VOID_POINTER}.make_cast (l_mapping_url)).do_nothing
				free (create {CE_VOID_POINTER}.make_cast (l_mapping_url))
				free (create {CE_VOID_POINTER}.make_cast (l_mapping_file))
			end
			Result := 0
		end

	dissociate_urls_from_file (a_file: CE_POINTER [INTEGER_8])
		do
			dl_url_file_map.item.item.hash_table_for_each (dissociate_urls_from_file_mapper_address, create {CE_VOID_POINTER}.make_cast (a_file))
		end

	register_download (a_url, a_file: CE_POINTER [INTEGER_8])
		local
			l_old_file: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_old_url: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_old_file.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_old_url.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					from
					until
						(l_break)
					loop
						l_break := False
						if dl_file_url_map.item.is_void then
							dl_file_url_map.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
						end
						if dl_url_file_map.item.is_void then
							dl_url_file_map.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
						end
						l_break := True
					end
					l_break := False
					if not ((dl_file_url_map.item.item.hash_table_get_pair (create {CE_VOID_POINTER}.make_cast (a_file), create {CE_VOID_POINTER}.make_cast (l_old_file), create {CE_VOID_POINTER}.make_cast (l_old_url))).to_boolean) then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if 0 = (strcmp (a_url, l_old_url.item)) then
							l_return := True
						end
						if l_return then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (match_except_index (a_url, l_old_url.item)) then
							if not (dl_url_file_map.item.item.hash_table_contains (create {CE_VOID_POINTER}.make_cast (a_url))).to_boolean then
								l_pos := -1 + 6 -- goto url_only
							end
						end
				when 3 then
						dl_file_url_map.item.item.hash_table_remove (create {CE_VOID_POINTER}.make_cast (a_file)).do_nothing
						free (create {CE_VOID_POINTER}.make_cast (l_old_file.item))
						free (create {CE_VOID_POINTER}.make_cast (l_old_url.item))
						dissociate_urls_from_file (a_file)
				when 4 then -- if done | if done
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 5 then -- if:
						l_tmp___3 := (create {P_XMALLOC_STATIC}).xstrdup (a_url)
						dl_file_url_map.item.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xstrdup (a_file))), create {CE_VOID_POINTER}.make_cast (l_tmp___3))
				when 6 then -- url_only:
						if (dl_url_file_map.item.item.hash_table_get_pair (create {CE_VOID_POINTER}.make_cast (a_url), create {CE_VOID_POINTER}.make_cast (l_old_url), create {CE_VOID_POINTER}.make_cast (l_old_file))).to_boolean then
							dl_url_file_map.item.item.hash_table_remove (create {CE_VOID_POINTER}.make_cast (a_url)).do_nothing
							free (create {CE_VOID_POINTER}.make_cast (l_old_url.item))
							free (create {CE_VOID_POINTER}.make_cast (l_old_file.item))
						end
						l_tmp___6 := (create {P_XMALLOC_STATIC}).xstrdup (a_file)
						dl_url_file_map.item.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xstrdup (a_url))), create {CE_VOID_POINTER}.make_cast (l_tmp___6))
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	register_redirection (a_from, a_to: CE_POINTER [INTEGER_8])
		local
			l_file: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				if dl_file_url_map.item.is_void then
					dl_file_url_map.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
				end
				if dl_url_file_map.item.is_void then
					dl_url_file_map.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
				end
				l_break := True
			end
			l_break := False
			l_file := create {CE_INTEGER_8_POINTER}.make_cast ((dl_url_file_map.item.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (a_to))))
			if l_file.is_void then
				assert_fail (ce_string ("file != ((void *)0)"), ce_string ("convert.c"), {NATURAL_32} 838, ce_string ("register_redirection"))
			end
			if not (dl_url_file_map.item.item.hash_table_contains (create {CE_VOID_POINTER}.make_cast (a_from))).to_boolean then
				l_tmp___0 := (create {P_XMALLOC_STATIC}).xstrdup (l_file)
				dl_url_file_map.item.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xstrdup (a_from))), create {CE_VOID_POINTER}.make_cast (l_tmp___0))
			end
		end

	register_html (a_url, a_file: CE_POINTER [INTEGER_8])
		do
			if downloaded_html_set.item.is_void then
				downloaded_html_set.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
			end
			downloaded_html_set.item.item.string_set_add (a_file)
		end

	register_css (a_url, a_file: CE_POINTER [INTEGER_8])
		do
			if downloaded_css_set.item.is_void then
				downloaded_css_set.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
			end
			downloaded_css_set.item.item.string_set_add (a_file)
		end

	convert_cleanup
		do
			if (not dl_file_url_map.item.is_void) then
				dl_file_url_map.item.item.free_keys_and_values
				dl_file_url_map.item.item.hash_table_destroy
				dl_file_url_map.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer)
			end
			if (not dl_url_file_map.item.is_void) then
				dl_url_file_map.item.item.free_keys_and_values
				dl_url_file_map.item.item.hash_table_destroy
				dl_url_file_map.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer)
			end
			if (not downloaded_html_set.item.is_void) then
				downloaded_html_set.item.item.string_set_free
			end
			downloaded_files_free
			if (not converted_files.item.is_void) then
				converted_files.item.item.string_set_free
			end
		end

	downloaded_mode_to_ptr (a_mode: NATURAL_32): CE_POINTER [NATURAL_32]
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_mode.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					Result := v1.item
					l_return := True
				when 2 then -- switch 1, case 1
					if not l_return then
						Result := v2.item
						l_return := True
					end
				when 3 then -- switch 1, case 2
					if not l_return then
						Result := v3.item
						l_return := True
					end
				when 4 then -- switch 1, case 3
					if not l_return then
						Result := v4.item
						l_return := True
					end
				when 5 then -- switch 1, done:
					if not l_return then
						Result := (create {CE_NATURAL_32_POINTER}.make_shared (default_pointer))
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	downloaded_file (a_mode: NATURAL_32; a_file: CE_POINTER [INTEGER_8]): NATURAL_32
		local
			l_ptr: CE_POINTER [NATURAL_32]
			l_return: BOOLEAN
		do
			if a_mode = {NATURAL_32} 3 then
				if downloaded_files_hash.item.is_void then
					Result := ({PC_DOWNLOADED_FILE_T}.FILE_NOT_ALREADY_DOWNLOADED)
					l_return := True
				end
				if not l_return then
					l_ptr := create {CE_NATURAL_32_POINTER}.make_cast ((downloaded_files_hash.item.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (a_file))))
					if l_ptr.is_void then
						Result := ({PC_DOWNLOADED_FILE_T}.FILE_NOT_ALREADY_DOWNLOADED)
						l_return := True
					end
				end
				if not l_return then
					Result := (l_ptr.item)
					l_return := True
				end
			end
			if not l_return then
				if downloaded_files_hash.item.is_void then
					downloaded_files_hash.item := (create {P_HASH_STATIC}).make_string_hash_table (0)
				end
				l_ptr := create {CE_NATURAL_32_POINTER}.make_cast ((downloaded_files_hash.item.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (a_file))))
				if (not l_ptr.is_void) then
					Result := (l_ptr.item)
					l_return := True
				end
			end
			if not l_return then
				l_ptr := downloaded_mode_to_ptr (a_mode)
				downloaded_files_hash.item.item.hash_table_put (create {CE_VOID_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xstrdup (a_file))), create {CE_VOID_POINTER}.make_cast (l_ptr))
				Result := ({PC_DOWNLOADED_FILE_T}.FILE_NOT_ALREADY_DOWNLOADED)
			end
		end

	downloaded_files_free
		local
			l_iter: CE_ARRAY [PD_HASH_TABLE_ITERATOR]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HASH_TABLE_ITERATOR]} l_iter.make (<<1>>)

			if (not downloaded_files_hash.item.is_void) then
				downloaded_files_hash.item.item.hash_table_iterate (l_iter)
				from
				until
					(l_break)
				loop
					l_break := False
					if not (l_iter.item.hash_table_iter_next).to_boolean then
						l_break := True
					end
					if not (l_break) then
						free (l_iter.item.key)
					end
				end
				l_break := False
				downloaded_files_hash.item.item.hash_table_destroy
				downloaded_files_hash.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer)
			end
		end

	html_quote_string (a_s: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_b: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_res___0: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_tmp___15: CE_POINTER [INTEGER_8]
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_b := l_s
					l_i := 0
					from
					until
						not ((l_s[0]).to_boolean)
					loop
						if (l_s[0]).to_integer_32 = 38 then
							l_i := l_i + (4)
						elseif (l_s[0]).to_integer_32 = 60 then
							l_i := l_i + (3)
						elseif (l_s[0]).to_integer_32 = 62 then
							l_i := l_i + (3)
						elseif (l_s[0]).to_integer_32 = 34 then
							l_i := l_i + (5)
						elseif (l_s[0]).to_integer_32 = 32 then
							l_i := l_i + (4)
						end
						l_s := l_s + 1
						l_i := l_i + 1
					end
					l_res___0 := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc ((l_i + 1).to_natural_32)))
					l_s := l_b
					l_p___0 := l_res___0
				when 1 then -- loop condition:
					if not ((l_s[0]).to_boolean) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						inspect (l_s[0]).to_integer_32 -- switch 1 head
						when 38 then l_pos := -1 + 3
						when 60 then l_pos := -1 + 4
						when 62 then l_pos := -1 + 4
						when 34 then l_pos := -1 + 5
						when 32 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 38
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___0[0] := (('&').code).to_integer_8
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___1[0] := (('a').code).to_integer_8
						l_tmp___2 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___2[0] := (('m').code).to_integer_8
						l_tmp___3 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___3[0] := (('p').code).to_integer_8
						l_tmp___4 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___4[0] := ((';').code).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 60 | switch 1, case 62
						l_tmp___5 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___5[0] := (('&').code).to_integer_8
						l_tmp___6 := l_p___0
						l_p___0 := l_p___0 + 1
						if (l_s[0]).to_integer_32 = 60 then
							l_tmp___6[0] := (('l').code).to_integer_8
						else
							l_tmp___6[0] := (('g').code).to_integer_8
						end
						l_tmp___7 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___7[0] := (('t').code).to_integer_8
						l_tmp___8 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___8[0] := ((';').code).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 34
						l_tmp___9 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___9[0] := (('&').code).to_integer_8
						l_tmp___10 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___10[0] := (('q').code).to_integer_8
						l_tmp___11 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___11[0] := (('u').code).to_integer_8
						l_tmp___12 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___12[0] := (('o').code).to_integer_8
						l_tmp___13 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___13[0] := (('t').code).to_integer_8
						l_tmp___14 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___14[0] := ((';').code).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 32
						l_tmp___15 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___15[0] := (('&').code).to_integer_8
						l_tmp___16 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___16[0] := (('#').code).to_integer_8
						l_tmp___17 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___17[0] := (('3').code).to_integer_8
						l_tmp___18 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___18[0] := (('2').code).to_integer_8
						l_tmp___19 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___19[0] := ((';').code).to_integer_8
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						l_tmp___20 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___20[0] := l_s[0]
				when 8 then -- switch 1, done:
						l_s := l_s + 1
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_p___0[0] := (('%/0/').code).to_integer_8
					Result := l_res___0
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	dissociate_urls_from_file_mapper_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent dissociate_urls_from_file_mapper)
		end

end
