class
	P_HOST_STATIC

inherit
	CE_UTILITIES
	S_ASSERT_STATIC
	S_NETDB_STATIC
	S_BITS_ERRNO_STATIC
	S_GCC_BUILTIN_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_STDLIB_STATIC
	S_LIBINTL_STATIC

feature {ANY} -- public attributes

	host_name_addresses_map: CE_STATIC [CE_POINTER [PD_HASH_TABLE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make
		end

feature {ANY} -- public routines

	address_list_from_addrinfo (a_ai: CE_POINTER [SD_ADDRINFO]): CE_POINTER [PD_ADDRESS_LIST]
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_ptr: CE_POINTER [SD_ADDRINFO]
			l_cnt: INTEGER_32
			l_ip___0: CE_POINTER [PD_IP_ADDRESS]
			l_sin6: CE_POINTER [SD_SOCKADDR_IN6]
			l_sin: CE_POINTER [SD_SOCKADDR_IN]
			l_return: BOOLEAN
		do
			l_cnt := 0
			l_ptr := a_ai
			from
			until
				l_ptr.is_void
			loop
				if l_ptr.item.ai_family = 2 then
					l_cnt := l_cnt + 1
				elseif l_ptr.item.ai_family = 10 then
					l_cnt := l_cnt + 1
				end
				l_ptr := l_ptr.item.ai_next
			end
			if l_cnt = 0 then
				Result := (create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_al := create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_cast (((create {P_XMALLOC_STATIC}).xcalloc ((1).to_natural_32, (create {PD_ADDRESS_LIST}.make).structure_size.to_natural_32)))
				l_al.item.addresses := create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (l_cnt.to_natural_32 * (create {PD_IP_ADDRESS}.make).structure_size.to_natural_32)))
				l_al.item.count := l_cnt
				l_al.item.refcount := 1
				l_ip___0 := l_al.item.addresses
				l_ptr := a_ai
				from
				until
					l_ptr.is_void
				loop
					if l_ptr.item.ai_family = 10 then
						l_sin6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (l_ptr.item.ai_addr)
						l_ip___0.item.family := 10
						l_ip___0.item.data.d6 := (l_sin6.item.sin6_addr).twin
						l_ip___0.item.ipv6_scope := (l_sin6.item.sin6_scope_id).to_integer_32
						l_ip___0 := l_ip___0 + 1
					elseif l_ptr.item.ai_family = 2 then
						l_sin := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (l_ptr.item.ai_addr)
						l_ip___0.item.family := 2
						l_ip___0.item.data.d4 := (l_sin.item.sin_addr).twin
						l_ip___0 := l_ip___0 + 1
					end
					l_ptr := l_ptr.item.ai_next
				end
				if l_ip___0.distance ((l_al.item.addresses)) /= l_cnt then
					assert_fail (ce_string ("ip - al->addresses == cnt"), ce_string ("host.c"), {NATURAL_32} 224, ce_string ("address_list_from_addrinfo"))
				end
				Result := l_al
			end
		end

	cmp_prefer_ipv4 (a_addr1, a_addr2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := (((create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_cast (a_addr1)).item.family /= 2).to_integer - ((create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_cast (a_addr2)).item.family /= 2).to_integer)
		end

	cmp_prefer_ipv6 (a_addr1, a_addr2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := (((create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_cast (a_addr1)).item.family /= 10).to_integer - ((create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_cast (a_addr2)).item.family /= 10).to_integer)
		end

	getaddrinfo_with_timeout_callback (a_arg: CE_POINTER [ANY])
		local
			l_ctx: CE_POINTER [PD_GAIWT_CONTEXT]
		do
			l_ctx := create {CE_CLASS_POINTER [PD_GAIWT_CONTEXT]}.make_cast (a_arg)
			l_ctx.item.exit_code := getaddrinfo (l_ctx.item.node, l_ctx.item.service, l_ctx.item.hints, l_ctx.item.res)
		end

	getaddrinfo_with_timeout (a_node, a_service: CE_POINTER [INTEGER_8]; a_hints: CE_POINTER [SD_ADDRINFO]; a_res___0: CE_POINTER [CE_POINTER [SD_ADDRINFO]]; a_timeout: REAL_64): INTEGER_32
		local
			l_ctx: CE_ARRAY [PD_GAIWT_CONTEXT]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GAIWT_CONTEXT]} l_ctx.make (<<1>>)

			l_ctx.item.node := a_node
			l_ctx.item.service := a_service
			l_ctx.item.hints := a_hints
			l_ctx.item.res := a_res___0
			if ((create {P_UTILS_STATIC}).run_with_timeout (a_timeout, getaddrinfo_with_timeout_callback_address, create {CE_VOID_POINTER}.make_cast (l_ctx))) then
				(errno_location).item := 110
				Result := (-11)
				l_return := True
			end
			if not l_return then
				Result := (l_ctx.item.exit_code)
			end
		end

	is_valid_ipv4_address (a_str, a_end: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_str: CE_POINTER [INTEGER_8]
			l_saw_digit: BOOLEAN
			l_octets: INTEGER_32
			l_val: INTEGER_32
			l_ch: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str := a_str
					l_saw_digit := (0).to_boolean
					l_octets := 0
					l_val := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_str.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp := l_str
						l_str := l_str + 1
						l_ch := (l_tmp[0]).to_integer_32
						if not (l_ch >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_ch <= 57 then
							l_val := l_val * 10 + (l_ch - 48)
							if l_val > 255 then
								Result := (0).to_boolean
								l_return := True
							end
							if not l_return and then (not l_saw_digit) then
								l_octets := l_octets + 1
								if l_octets > 4 then
									Result := (0).to_boolean
									l_return := True
								end
								if not l_return then
									l_saw_digit := (1).to_boolean
								end
							end
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if l_ch = 46 then
							if l_saw_digit then
								if l_octets = 4 then
									Result := (0).to_boolean
									l_return := True
								end
								if not l_return then
									l_val := 0
									l_saw_digit := (0).to_boolean
								end
							else
								Result := (0).to_boolean
								l_return := True
							end
						else
							Result := (0).to_boolean
							l_return := True
						end
				when 6 then
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not l_return and then (l_octets < 4) then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						Result := (1).to_boolean
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_valid_ipv6_address (a_str, a_end: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_str: CE_POINTER [INTEGER_8]
			l_curtok: CE_POINTER [INTEGER_8]
			l_tp: INTEGER_32
			l_colonp: CE_POINTER [INTEGER_8]
			l_saw_xdigit: BOOLEAN
			l_val: NATURAL_32
			l_ch: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_str := a_str
			l_tp := 0
			l_colonp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			if l_str.is_equal (a_end) then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return and then ((l_str[0]).to_integer_32 = 58) then
				l_str := l_str + 1
				if l_str.is_equal (a_end) then
					Result := (0).to_boolean
					l_return := True
				elseif (l_str[0]).to_integer_32 /= 58 then
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				l_curtok := l_str
				l_saw_xdigit := (0).to_boolean
				l_val := {NATURAL_32} 0
				from
				until
					not (not (l_return or l_break) and then ((l_str.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32))
				loop
					l_break := False
					l_continue := False
					l_tmp := l_str
					l_str := l_str + 1
					l_ch := (l_tmp[0]).to_integer_32
					if ((create {P_C_CTYPE_STATIC}).c2_isxdigit (l_ch)) then
						l_val := (l_val).bit_shift_left ((4))
						if l_ch < 65 then
							l_tmp___1 := l_ch - 48
						else
							l_tmp___1 := (((create {P_C_CTYPE_STATIC}).c2_toupper (l_ch)) - 65) + 10
						end
						l_val := (l_val).bit_or (l_tmp___1.to_natural_32)
						if l_val > {NATURAL_32} 65_535 then
							Result := (0).to_boolean
							l_return := True
						end
						if not l_return then
							l_saw_xdigit := (1).to_boolean
							l_continue := True
						end
					end
					if not (l_return or l_break or l_continue) and then (l_ch = 58) then
						l_curtok := l_str
						if not l_saw_xdigit then
							if not l_colonp.is_void then
								Result := (0).to_boolean
								l_return := True
							end
							if not l_return then
								l_colonp := l_str + l_tp
								l_continue := True
							end
						elseif l_str.is_equal (a_end) then
							Result := (0).to_boolean
							l_return := True
						end
						if not (l_return or l_break or l_continue) then
							if l_tp > 14 then
								Result := (0).to_boolean
								l_return := True
							end
							if not l_return then
								l_tp := l_tp + (2)
								l_saw_xdigit := (0).to_boolean
								l_val := {NATURAL_32} 0
								l_continue := True
							end
						end
					end
					if not (l_return or l_break or l_continue) and then (l_ch = 46) then
						if l_tp <= 12 then
							if (is_valid_ipv4_address (l_curtok, a_end)).to_integer = 1 then
								l_tp := l_tp + (4)
								l_saw_xdigit := (0).to_boolean
								l_break := True
							end
						end
					end
					if not (l_return or l_break or l_continue) then
						Result := (0).to_boolean
						l_return := True
					end
				end
			end
			if not l_return then
				l_break := False
				l_continue := False
				if l_saw_xdigit then
					if l_tp > 14 then
						Result := (0).to_boolean
						l_return := True
					end
					if not l_return then
						l_tp := l_tp + (2)
					end
				end
			end
			if not l_return and then (not l_colonp.is_void) then
				if l_tp = 16 then
					Result := (0).to_boolean
					l_return := True
				end
				if not l_return then
					l_tp := 16
				end
			end
			if not l_return and then (l_tp /= 16) then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				Result := (1).to_boolean
			end
		end

	cache_query (a_host: CE_POINTER [INTEGER_8]): CE_POINTER [PD_ADDRESS_LIST]
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_return, l_break: BOOLEAN
		do
			if host_name_addresses_map.item.is_void then
				Result := (create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_al := create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_cast ((host_name_addresses_map.item.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (a_host))))
				if (not l_al.is_void) then
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)).to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Found %%s in host_name_addresses_map (%%p)%N"), a_host, l_al])
						end
						l_break := True
					end
					l_break := False
					l_al.item.refcount := (l_al.item.refcount) + 1
					Result := l_al
					l_return := True
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
			end
		end

	cache_remove (a_host: CE_POINTER [INTEGER_8])
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_return: BOOLEAN
		do
			if host_name_addresses_map.item.is_void then
				l_return := True
			end
			if not l_return then
				l_al := create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_cast ((host_name_addresses_map.item.item.hash_table_get (create {CE_VOID_POINTER}.make_cast (a_host))))
				if (not l_al.is_void) then
					l_al.item.address_list_release
					host_name_addresses_map.item.item.hash_table_remove (create {CE_VOID_POINTER}.make_cast (a_host)).do_nothing
				end
			end
		end

	lookup_host (a_host: CE_POINTER [INTEGER_8]; a_flags: INTEGER_32): CE_POINTER [PD_ADDRESS_LIST]
		require
			not a_host.is_void
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_silent: BOOLEAN
			l_use_cache: BOOLEAN
			l_numeric_address: BOOLEAN
			l_timeout: REAL_64
			l_end: CE_POINTER [INTEGER_8]
			l_str: CE_POINTER [INTEGER_8]
			l_name: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_tmp___2: NATURAL_32
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_err: INTEGER_32
			l_hints: CE_ARRAY [SD_ADDRINFO]
			l_res___0: CE_ARRAY [CE_POINTER [SD_ADDRINFO]]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___14: CE_ROUTINE
			l_i: INTEGER_32
			l_printmax: INTEGER_32
			l_tmp___15: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_ADDRINFO]} l_hints.make (<<1>>)
			create {CE_POINTER_ARRAY [SD_ADDRINFO]} l_res___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_silent := (((a_flags).bit_and (1)).to_boolean)
					l_numeric_address := (0).to_boolean
					l_timeout := (create {P_OPTIONS_STATIC}).opt.item.item.dns_timeout
					l_end := a_host + (strlen (a_host)).to_integer_32
					if (is_valid_ipv4_address (a_host, l_end)) then
						l_numeric_address := (1).to_boolean
					elseif (is_valid_ipv6_address (a_host, l_end)) then
						l_numeric_address := (1).to_boolean
					end
					l_use_cache := (create {P_OPTIONS_STATIC}).opt.item.item.dns_cache
					if ((a_flags).bit_and (2)).to_boolean then
						l_use_cache := (0).to_boolean
					elseif l_numeric_address then
						l_use_cache := (0).to_boolean
					end
					if l_use_cache then
						if not ((a_flags).bit_and (4)).to_boolean then
							l_al := cache_query (a_host)
							if (not l_al.is_void) then
								Result := l_al
								l_return := True
							end
						else
							cache_remove (a_host)
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not l_silent then
							if not l_numeric_address then
								l_str := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								if (create {P_OPTIONS_STATIC}).opt.item.item.enable_iri then
									l_name := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
									if not l_name.is_void then
										l_tmp___2 := strlen (a_host)
										l_len := ((l_tmp___2 + (strlen (l_name))) + {NATURAL_32} 4).to_integer_32
										l_str := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (l_len.to_natural_32)))
										snprintf ([l_str, l_len.to_natural_32, ce_string ("%%s (%%s)"), l_name, a_host]).do_nothing
										l_str[(l_len - 1)] := (('%/0/').code).to_integer_8
										free (create {CE_VOID_POINTER}.make_cast (l_name))
									end
								end
								if (not l_str.is_void) then
									l_tmp___5 := l_str
								else
									l_tmp___5 := a_host
								end
								l_tmp___6 := (create {P_QUOTEARG_STATIC}).quotearg_style ({PC_QUOTING_STYLE}.escape_quoting_style, l_tmp___5);
								(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("Resolving %%s... "))), l_tmp___6])
								if (not l_str.is_void) then
									free (create {CE_VOID_POINTER}.make_cast (l_str))
								end
							end
						end
						memset (create {CE_VOID_POINTER}.make_cast (l_hints), ('%/0/').code, (create {SD_ADDRINFO}.make).structure_size.to_natural_32).do_nothing
						l_hints.item.ai_socktype := 1
						if (create {P_OPTIONS_STATIC}).opt.item.item.ipv4_only then
							l_hints.item.ai_family := 2
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.ipv6_only then
							l_hints.item.ai_family := 10
						else
							l_hints.item.ai_family := 0
						end
						if ((a_flags).bit_and (2)).to_boolean then
							l_hints.item.ai_flags := (l_hints.item.ai_flags).bit_or ((1))
						end
						if l_numeric_address then
							l_hints.item.ai_flags := (l_hints.item.ai_flags).bit_or ((4))
							l_timeout := (0).to_double
						end
						l_err := getaddrinfo_with_timeout (a_host, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), l_hints, l_res___0, l_timeout)
						if l_err = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((l_res___0.item).is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not l_silent then
							if l_err /= -11 then
								l_tmp___11 := (gai_strerror (l_err))
							else
								l_tmp___11 := (strerror ((errno_location).item))
							end
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("failed: %%s.%N"))), l_tmp___11])
						end
						Result := (create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
						l_return := True
				when 6 then -- if done | if done
					if not l_return then
						l_al := address_list_from_addrinfo (l_res___0.item)
						freeaddrinfo (l_res___0.item)
						if l_al.is_void then
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, (gettext (ce_string ("failed: No IPv4/IPv6 addresses for host.%N")))])
							Result := (create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						if l_al.item.count > 1 then
							if (create {P_OPTIONS_STATIC}).opt.item.item.prefer_family /= {NATURAL_32} 2 then
								if (create {P_OPTIONS_STATIC}).opt.item.item.prefer_family = {NATURAL_32} 0 then
									l_tmp___14 := cmp_prefer_ipv4_address
								else
									l_tmp___14 := cmp_prefer_ipv6_address
								end
								(create {P_UTILS_STATIC}).stable_sort (create {CE_VOID_POINTER}.make_cast (l_al.item.addresses), (l_al.item.count).to_natural_32, (create {PD_IP_ADDRESS}.make).structure_size.to_natural_32, l_tmp___14)
							end
						end
						if not l_silent then
							if not l_numeric_address then
								if l_al.item.count <= 3 then
									l_tmp___15 := l_al.item.count
								else
									l_tmp___15 := 3
								end
								l_printmax := l_tmp___15
								l_i := 0
								from
								until
									not (l_i < l_printmax)
								loop
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ((l_al.item.addresses + l_i).item.print_address))
									if l_i < l_printmax - 1 then
										(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (", "))
									end
									l_i := l_i + 1
								end
								if l_printmax /= l_al.item.count then
									(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string (", ..."))
								end
								(create {P_LOG_STATIC}).logputs ({PC_LOG_OPTIONS}.LOG_VERBOSE, ce_string ("%N"))
							end
						end
						if l_use_cache then
							l_al.item.cache_store (a_host)
						end
						Result := l_al
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sufmatch (a_list: CE_POINTER [CE_POINTER [INTEGER_8]]; a_what: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_list.is_void
			not a_what.is_void
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_lw: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_lw := (strlen (a_what)).to_integer_32
			l_i := 0
			from
			until
				not (not (l_return) and then (not (a_list[l_i]).is_void))
			loop
				l_j := (strlen (a_list[l_i])).to_integer_32
				l_k := l_lw
				from
				until
					(l_break)
				loop
					l_break := False
					if l_j >= 0 then
						if not (l_k >= 0) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_tmp___1 := (create {P_C_CTYPE_STATIC}).c2_tolower (((a_list[l_i])[l_j]).to_integer_32)
						if l_tmp___1 /= ((create {P_C_CTYPE_STATIC}).c2_tolower ((a_what[l_k]).to_integer_32)) then
							l_break := True
						end
					end
					if not (l_break) then
						l_j := l_j - 1
						l_k := l_k - 1
					end
				end
				l_break := False
				if l_j = -1 then
					Result := (1).to_boolean
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	host_cleanup
		local
			l_iter: CE_ARRAY [PD_HASH_TABLE_ITERATOR]
			l_host: CE_POINTER [INTEGER_8]
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_HASH_TABLE_ITERATOR]} l_iter.make (<<1>>)

			if (not host_name_addresses_map.item.is_void) then
				host_name_addresses_map.item.item.hash_table_iterate (l_iter)
				from
				until
					(l_break)
				loop
					l_break := False
					if not (l_iter.item.hash_table_iter_next).to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_host := create {CE_INTEGER_8_POINTER}.make_cast (l_iter.item.key)
						l_al := create {CE_CLASS_POINTER [PD_ADDRESS_LIST]}.make_cast (l_iter.item.value)
						free (create {CE_VOID_POINTER}.make_cast (l_host))
						if l_al.item.refcount /= 1 then
							assert_fail (ce_string ("al->refcount == 1"), ce_string ("host.c"), {NATURAL_32} 900, ce_string ("host_cleanup"))
						end
						l_al.item.address_list_delete
					end
				end
				l_break := False
				host_name_addresses_map.item.item.hash_table_destroy
				host_name_addresses_map.item := create {CE_CLASS_POINTER [PD_HASH_TABLE]}.make_shared (default_pointer)
			end
		end

feature {ANY} -- routine addresses

	cmp_prefer_ipv4_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent cmp_prefer_ipv4)
		end

	cmp_prefer_ipv6_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent cmp_prefer_ipv6)
		end

	getaddrinfo_with_timeout_callback_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent getaddrinfo_with_timeout_callback)
		end

end
