class
	P_LOG_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_BITS_ERRNO_STATIC
	S_UNISTD_STATIC
	S_ASSERT_STATIC
	S_LIBINTL_STATIC

feature {ANY} -- public attributes

	logfp: CE_STATIC [CE_POINTER [SD_IO_FILE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make
		end

	inhibit_logging: CE_STATIC [BOOLEAN]
		once ("PROCESS")
		end

	save_context_p: CE_STATIC [BOOLEAN]
		once ("PROCESS")
		end

	flush_log_p: CE_STATIC [BOOLEAN]
		once ("PROCESS")
			Result.item := (1).to_boolean
		end

	needs_flushing: CE_STATIC [BOOLEAN]
		once ("PROCESS")
		end

	log_lines: CE_STATIC [CE_ARRAY [PD_LOG_LN]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LOG_LN]}.make (<<24>>)
		end

	log_line_current: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	trailing_line: CE_STATIC [BOOLEAN]
		once ("PROCESS")
		end

	ring: CE_STATIC [CE_ARRAY [PD_RINGEL]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_RINGEL]}.make (<<3>>)
		end

	ringpos: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	redirect_request: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := {PC_REDIRECT_REQUEST}.RR_NONE
		end

	redirect_request_signal_name: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

feature {ANY} -- public routines

	free_log_line (a_num: INTEGER_32)
		local
			l_ln: CE_POINTER [PD_LOG_LN]
		do
			l_ln := log_lines.item + a_num
			if (not (l_ln.item.malloced_line).is_void) then
				free (create {CE_VOID_POINTER}.make_cast (l_ln.item.malloced_line))
				l_ln.item.malloced_line := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			end
			l_ln.item.content := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	saved_append_1 (a_start, a_end: CE_POINTER [INTEGER_8])
		local
			l_len: INTEGER_32
			l_ln: CE_POINTER [PD_LOG_LN]
			l_ln___0: CE_POINTER [PD_LOG_LN]
			l_old_len: INTEGER_32
			l_old_len___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_len := a_end.distance (a_start)
			if not l_len.to_boolean then
				l_return := True
			end
			if not l_return then
				if not trailing_line.item then
					if log_line_current.item = -1 then
						log_line_current.item := 0
					else
						free_log_line (log_line_current.item)
					end
					l_ln := log_lines.item + log_line_current.item
					if l_len > 128 then
						l_ln.item.malloced_line := (create {P_UTILS_STATIC}).strdupdelim (a_start, a_end)
						l_ln.item.content := l_ln.item.malloced_line
					else
						memcpy (create {CE_VOID_POINTER}.make_cast ((l_ln.item.static_line)), create {CE_VOID_POINTER}.make_cast (a_start), l_len.to_natural_32).do_nothing
						l_ln.item.static_line[l_len] := (('%/0/').code).to_integer_8
						l_ln.item.content := l_ln.item.static_line
					end
				else
					l_ln___0 := log_lines.item + log_line_current.item
					if (not (l_ln___0.item.malloced_line).is_void) then
						l_old_len := (strlen (l_ln___0.item.malloced_line)).to_integer_32
						l_ln___0.item.malloced_line := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_ln___0.item.malloced_line), ((l_old_len + l_len) + 1).to_natural_32)))
						memcpy (create {CE_VOID_POINTER}.make_cast ((l_ln___0.item.malloced_line + l_old_len)), create {CE_VOID_POINTER}.make_cast (a_start), l_len.to_natural_32).do_nothing
						l_ln___0.item.malloced_line[(l_old_len + l_len)] := (('%/0/').code).to_integer_8
						l_ln___0.item.content := l_ln___0.item.malloced_line
					else
						l_old_len___0 := (strlen ((l_ln___0.item.static_line))).to_integer_32
						if l_old_len___0 + l_len > 128 then
							l_ln___0.item.malloced_line := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xmalloc (((l_old_len___0 + l_len) + 1).to_natural_32)))
							memcpy (create {CE_VOID_POINTER}.make_cast (l_ln___0.item.malloced_line), create {CE_VOID_POINTER}.make_cast ((l_ln___0.item.static_line)), l_old_len___0.to_natural_32).do_nothing
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_ln___0.item.malloced_line + l_old_len___0)), create {CE_VOID_POINTER}.make_cast (a_start), l_len.to_natural_32).do_nothing
							l_ln___0.item.malloced_line[(l_old_len___0 + l_len)] := (('%/0/').code).to_integer_8
							l_ln___0.item.content := l_ln___0.item.malloced_line
						else
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_ln___0.item.static_line + l_old_len___0)), create {CE_VOID_POINTER}.make_cast (a_start), l_len.to_natural_32).do_nothing
							l_ln___0.item.static_line[l_old_len___0 + l_len] := (('%/0/').code).to_integer_8
							l_ln___0.item.content := l_ln___0.item.static_line
						end
					end
				end
				trailing_line.item := ((a_end[-1]).to_integer_32 /= 10)
				if not trailing_line.item then
					from
					until
						(l_break)
					loop
						l_break := False
						log_line_current.item := log_line_current.item + 1
						if log_line_current.item >= 24 then
							log_line_current.item := 0
						end
						l_break := True
					end
					l_break := False
				end
			end
		end

	saved_append (a_s: CE_POINTER [INTEGER_8])
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
		do
			l_s := a_s
			from
			until
				not ((l_s[0]).to_boolean)
			loop
				l_end := (strchr (l_s, ('%N').code))
				if l_end.is_void then
					l_end := l_s + (strlen (l_s)).to_integer_32
				else
					l_end := l_end + 1
				end
				saved_append_1 (l_s, l_end)
				l_s := l_end
			end
		end

	get_log_fp: CE_POINTER [SD_IO_FILE]
		local
			l_return: BOOLEAN
		do
			if inhibit_logging.item then
				Result := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return and then (not logfp.item.is_void) then
				Result := logfp.item
				l_return := True
			end
			if not l_return then
				Result := ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)))
			end
		end

	logputs (a_o: NATURAL_32; a_s: CE_POINTER [INTEGER_8])
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					check_redirect_output
					l_fp := get_log_fp
					if l_fp.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						inspect a_o.to_integer_32 -- switch 1 head
						when 3 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 3
						l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 1
						if (create {P_OPTIONS_STATIC}).opt.item.item.quiet then
							l_return := True
						end
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 2
						if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							l_return := True
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.quiet then
							l_return := True
						end
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 0
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							l_return := True
						end
				when 6 then -- switch 1, done: | if done
					if not l_return then
						fputs (a_s, l_fp).do_nothing
						if save_context_p.item then
							saved_append (a_s)
						end
						if flush_log_p.item then
							logflush
						else
							needs_flushing.item := (1).to_boolean
						end
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	log_vprintf_internal (a_state: CE_POINTER [PD_LOGVPRINTF_STATE]; a_fmt: CE_POINTER [INTEGER_8]; a_args: CE_VA_LIST): BOOLEAN
		local
			l_args: CE_VA_LIST
			l_smallmsg: CE_ARRAY [INTEGER_8]
			l_write_ptr: CE_POINTER [INTEGER_8]
			l_available_size: INTEGER_32
			l_numwritten: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_newsize: INTEGER_32
			l_newsize___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_8_ARRAY} l_smallmsg.make (<<128>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args := a_args.twin
					l_write_ptr := l_smallmsg
					l_available_size := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (128).to_natural_32).to_integer_32
					l_fp := (get_log_fp)
					if not save_context_p.item then
						vfprintf (l_fp, a_fmt, l_args.twin).do_nothing
						l_pos := -1 + 3 -- goto flush
					end
				when 1 then
					if a_state.item.allocated /= 0 then
						l_write_ptr := a_state.item.bigmsg
						l_available_size := a_state.item.allocated
					end
					l_numwritten := vsnprintf (l_write_ptr, l_available_size.to_natural_32, a_fmt, l_args.twin)
					if l_numwritten = -1 then
						l_newsize := (l_available_size).bit_shift_left (1)
						a_state.item.bigmsg := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (a_state.item.bigmsg), l_newsize.to_natural_32)))
						a_state.item.allocated := l_newsize
						Result := (0).to_boolean
						l_return := True
					elseif l_numwritten >= l_available_size then
						l_newsize___0 := l_numwritten + 1
						a_state.item.bigmsg := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (a_state.item.bigmsg), l_newsize___0.to_natural_32)))
						a_state.item.allocated := l_newsize___0
						Result := (0).to_boolean
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						saved_append (l_write_ptr)
						fputs (l_write_ptr, l_fp).do_nothing
						if (not (a_state.item.bigmsg).is_void) then
							free (create {CE_VOID_POINTER}.make_cast (a_state.item.bigmsg))
						end
				when 3 then -- flush:
						if flush_log_p.item then
							logflush
						else
							needs_flushing.item := (1).to_boolean
						end
						Result := (1).to_boolean
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	logflush
		local
			l_fp: CE_POINTER [SD_IO_FILE]
		do
			l_fp := (get_log_fp)
			if (not l_fp.is_void) then
				fflush (l_fp).do_nothing
			end
			needs_flushing.item := (0).to_boolean
		end

	log_set_flush (a_flush: BOOLEAN)
		local
			l_return: BOOLEAN
		do
			if a_flush.to_integer = flush_log_p.item.to_integer then
				l_return := True
			end
			if not l_return then
				if a_flush.to_integer = 0 then
					flush_log_p.item := (0).to_boolean
				else
					if needs_flushing.item then
						logflush
					end
					flush_log_p.item := (1).to_boolean
				end
			end
		end

	log_set_save_context (a_savep: BOOLEAN): BOOLEAN
		local
			l_old: BOOLEAN
		do
			l_old := save_context_p.item
			save_context_p.item := a_savep
			Result := l_old
		end

	logprintf (a_args: TUPLE [a_o: NATURAL_32; a_fmt: CE_POINTER [INTEGER_8]])
		local
			l_args: CE_VA_LIST
			l_lpstate: CE_ARRAY [PD_LOGVPRINTF_STATE]
			l_done: BOOLEAN
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_args.make_shared (default_pointer)
			create {CE_CLASS_ARRAY [PD_LOGVPRINTF_STATE]} l_lpstate.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					check_redirect_output
					if inhibit_logging.item then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						inspect a_args.a_o.to_integer_32 -- switch 1 head
						when 3 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 0 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 3
						l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 1
						if (create {P_OPTIONS_STATIC}).opt.item.item.quiet then
							l_return := True
						end
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 2
						if ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							l_return := True
						elseif (create {P_OPTIONS_STATIC}).opt.item.item.quiet then
							l_return := True
						end
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 0
						if not ((create {P_OPTIONS_STATIC}).opt.item.item.verbose).to_boolean then
							l_return := True
						end
				when 6 then -- switch 1, done: | if done
					if not l_return then
						memset (create {CE_VOID_POINTER}.make_cast (l_lpstate), ('%/0/').code, (create {PD_LOGVPRINTF_STATE}.make).structure_size.to_natural_32).do_nothing
						from
						until
							(l_break)
						loop
							l_break := False
							l_args := create {CE_VA_LIST}.make (a_args, agent logprintf)
							l_done := log_vprintf_internal (l_lpstate, a_args.a_fmt, l_args.twin)
							if l_done then
								l_break := True
							end
						end
						l_break := False
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	debug_logprintf (a_args: TUPLE [a_fmt: CE_POINTER [INTEGER_8]])
		local
			l_args: CE_VA_LIST
			l_lpstate: CE_ARRAY [PD_LOGVPRINTF_STATE]
			l_done: BOOLEAN
			l_return, l_break: BOOLEAN
		do
			create l_args.make_shared (default_pointer)
			create {CE_CLASS_ARRAY [PD_LOGVPRINTF_STATE]} l_lpstate.make (<<1>>)

			if (create {P_OPTIONS_STATIC}).opt.item.item.debug2 then
				check_redirect_output
				if inhibit_logging.item then
					l_return := True
				end
				if not l_return then
					memset (create {CE_VOID_POINTER}.make_cast (l_lpstate), ('%/0/').code, (create {PD_LOGVPRINTF_STATE}.make).structure_size.to_natural_32).do_nothing
					from
					until
						(l_break)
					loop
						l_break := False
						l_args := create {CE_VA_LIST}.make (a_args, agent debug_logprintf)
						l_done := log_vprintf_internal (l_lpstate, a_args.a_fmt, l_args.twin)
						if l_done then
							l_break := True
						end
					end
					l_break := False
				end
			end
			if not l_return then
			end
		end

	log_init (a_file: CE_POINTER [INTEGER_8]; a_appendp: BOOLEAN)
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			if (not a_file.is_void) then
				if a_appendp then
					l_tmp := ce_string ("a")
				else
					l_tmp := ce_string ("w")
				end
				logfp.item := fopen (a_file, l_tmp)
				if logfp.item.is_void then
					Io.error.put_string (eif_string ((create {P_WGET_STATIC}).exec_name.item) + ": " + eif_string (a_file) + ": " + eif_string ((strerror ((errno_location).item))) + "%N")
					exit (1)
				end
			else
				logfp.item := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))
				if (isatty ((fileno (logfp.item)))).to_boolean then
					save_context_p.item := (1).to_boolean
				end
			end
		end

	log_close
		local
			l_i: INTEGER_32
		do
			if (not logfp.item.is_void) then
				fclose (logfp.item).do_nothing
			end
			logfp.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			inhibit_logging.item := (1).to_boolean
			save_context_p.item := (0).to_boolean
			l_i := 0
			from
			until
				not (l_i < 24)
			loop
				free_log_line (l_i)
				l_i := l_i + 1
			end
			log_line_current.item := -1
			trailing_line.item := (0).to_boolean
		end

	log_dump_context
		local
			l_num: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_ln: CE_POINTER [PD_LOG_LN]
			l_return, l_break: BOOLEAN
		do
			l_num := log_line_current.item
			l_fp := (get_log_fp)
			if l_fp.is_void then
				l_return := True
			end
			if not l_return and then (l_num = -1) then
				l_return := True
			end
			if not l_return then
				if trailing_line.item then
					from
					until
						(l_break)
					loop
						l_break := False
						l_num := l_num + 1
						if l_num >= 24 then
							l_num := 0
						end
						l_break := True
					end
					l_break := False
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_ln := log_lines.item + l_num
					if (not (l_ln.item.content).is_void) then
						fputs (l_ln.item.content, l_fp).do_nothing
					end
					from
					until
						(l_break)
					loop
						l_break := False
						l_num := l_num + 1
						if l_num >= 24 then
							l_num := 0
						end
						l_break := True
					end
					l_break := False
					if l_num = log_line_current.item then
						l_break := True
					end
				end
				l_break := False
				if trailing_line.item then
					if (not (log_lines.item[log_line_current.item].content).is_void) then
						fputs (log_lines.item[log_line_current.item].content, l_fp).do_nothing
					end
				end
				fflush (l_fp).do_nothing
			end
		end

	count_nonprint (a_source: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_source.is_void
		local
			l_p___0: CE_POINTER [INTEGER_8]
			l_cnt: INTEGER_32
		do
			l_p___0 := a_source
			l_cnt := 0
			from
			until
				not ((l_p___0[0]).to_boolean)
			loop
				if not ((create {P_C_CTYPE_STATIC}).c2_isprint ((l_p___0[0]).to_integer_32)) then
					l_cnt := l_cnt + 1
				end
				l_p___0 := l_p___0 + 1
			end
			Result := l_cnt
		end

	copy_and_escape (a_source, a_dest: CE_POINTER [INTEGER_8]; a_escape: INTEGER_8; a_base: INTEGER_32)
		require
			not a_dest.is_void
		local
			l_from: CE_POINTER [INTEGER_8]
			l_to: CE_POINTER [INTEGER_8]
			l_c: NATURAL_8
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_from := a_source
					l_to := a_dest
					inspect a_base -- switch 1 head
					when 8 then l_pos := -1 + 1
					when 16 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 8
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___5 := l_from
						l_from := l_from + 1
						l_c := (l_tmp___5[0]).to_natural_8
						if l_c.to_integer_32 = 0 then
							l_break := True
						end
						if not (l_break) then
							if ((create {P_C_CTYPE_STATIC}).c2_isprint (l_c.to_integer_32)) then
								l_tmp := l_to
								l_to := l_to + 1
								l_tmp[0] := l_c.to_integer_8
							else
								l_tmp___0 := l_to
								l_to := l_to + 1
								l_tmp___0[0] := a_escape
								l_tmp___1 := l_to
								l_to := l_to + 1
								l_tmp___1[0] := (48 + ((l_c.to_integer_32).bit_shift_right (6))).to_integer_8
								l_tmp___2 := l_to
								l_to := l_to + 1
								l_tmp___2[0] := (48 + ((((l_c.to_integer_32).bit_shift_right (3))).bit_and (7))).to_integer_8
								l_tmp___3 := l_to
								l_to := l_to + 1
								l_tmp___3[0] := (48 + ((l_c.to_integer_32).bit_and (7))).to_integer_8
							end
						end
					end
					l_break := False
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 16
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___11 := l_from
						l_from := l_from + 1
						l_c := (l_tmp___11[0]).to_natural_8
						if l_c.to_integer_32 = 0 then
							l_break := True
						end
						if not (l_break) then
							if ((create {P_C_CTYPE_STATIC}).c2_isprint (l_c.to_integer_32)) then
								l_tmp___6 := l_to
								l_to := l_to + 1
								l_tmp___6[0] := l_c.to_integer_8
							else
								l_tmp___7 := l_to
								l_to := l_to + 1
								l_tmp___7[0] := a_escape
								l_tmp___8 := l_to
								l_to := l_to + 1
								l_tmp___8[0] := (((ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_shift_right (4))).item).to_integer_32).to_integer_8
								l_tmp___9 := l_to
								l_to := l_to + 1
								l_tmp___9[0] := (((ce_string ("0123456789ABCDEF") + ((l_c.to_integer_32).bit_and (15))).item).to_integer_32).to_integer_8
							end
						end
					end
					l_break := False
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					l_to[0] := (('%/0/').code).to_integer_8
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	escnonprint_internal (a_str: CE_POINTER [INTEGER_8]; a_escape: INTEGER_8; a_base: INTEGER_32): CE_POINTER [INTEGER_8]
		require
			not a_str.is_void
		local
			l_nprcnt: INTEGER_32
			l_r: CE_POINTER [PD_RINGEL]
			l_needed_size: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			if a_base /= 8 then
				if a_base /= 16 then
					assert_fail (ce_string ("base == 8 || base == 16"), ce_string ("log.c"), {NATURAL_32} 712, ce_string ("escnonprint_internal"))
				end
			end
			l_nprcnt := count_nonprint (a_str)
			if l_nprcnt = 0 then
				Result := a_str
				l_return := True
			end
			if not l_return then
				l_r := ring.item + ringpos.item
				l_tmp := strlen (a_str)
				if a_base = 8 then
					l_tmp___0 := 3 * l_nprcnt
				else
					l_tmp___0 := 2 * l_nprcnt
				end
				l_needed_size := ((l_tmp + {NATURAL_32} 1) + l_tmp___0.to_natural_32).to_integer_32
				if (l_r.item.buffer).is_void then
					l_tmp___1 := (create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_r.item.buffer), l_needed_size.to_natural_32)
					l_r.item.buffer := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
					l_r.item.size := l_needed_size
				elseif l_r.item.size < l_needed_size then
					l_tmp___1 := (create {P_XMALLOC_STATIC}).xrealloc (create {CE_VOID_POINTER}.make_cast (l_r.item.buffer), l_needed_size.to_natural_32)
					l_r.item.buffer := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
					l_r.item.size := l_needed_size
				end
				copy_and_escape (a_str, l_r.item.buffer, a_escape, a_base)
				ringpos.item := (ringpos.item + 1) \\ 3
				Result := (l_r.item.buffer)
			end
		end

	escnonprint (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_str.is_void
		do
			Result := (escnonprint_internal (a_str, (('\').code).to_integer_8, 8))
		end

	escnonprint_uri (a_str: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_str.is_void
		do
			Result := (escnonprint_internal (a_str, (('%%').code).to_integer_8, 16))
		end

	log_cleanup
		local
			l_i: NATURAL_32
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < ((create {PD_RINGEL}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_RINGEL}.make).structure_size.to_natural_32)
			loop
				if (not (ring.item[l_i.to_integer_32].buffer).is_void) then
					free (create {CE_VOID_POINTER}.make_cast (ring.item[l_i.to_integer_32].buffer))
				end
				l_i := l_i + 1
			end
		end

	redirect_output
		local
			l_logfile: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_logfile.make (<<1>>)

			logfp.item := (create {P_UTILS_STATIC}).unique_create (ce_string ("wget-log"), (0).to_boolean, l_logfile)
			if (not logfp.item.is_void) then
				l_tmp := (create {P_QUOTE_STATIC}).quote (l_logfile.item)
				fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%N%%s received, redirecting output to %%s.%N"))), redirect_request_signal_name.item, l_tmp]).do_nothing
				free (create {CE_VOID_POINTER}.make_cast (l_logfile.item))
				log_dump_context
			else
				fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%N%%s received.%N"))), redirect_request_signal_name.item]).do_nothing
				l_tmp___3 := strerror ((errno_location).item)
				fprintf ([(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s; disabling logging.%N"))), l_logfile.item, l_tmp___3]).do_nothing
				inhibit_logging.item := (1).to_boolean
			end
			save_context_p.item := (0).to_boolean
		end

	check_redirect_output
		do
			if redirect_request.item = {NATURAL_32} 1 then
				redirect_request.item := {PC_REDIRECT_REQUEST}.RR_DONE
				redirect_output
			end
		end

	log_request_redirect_output (a_signal_name: CE_POINTER [INTEGER_8])
		do
			if redirect_request.item = {NATURAL_32} 0 then
				if save_context_p.item then
					redirect_request.item := {PC_REDIRECT_REQUEST}.RR_REQUESTED
				end
			end
			redirect_request_signal_name.item := a_signal_name
		end

end
