class
	PD_CCON

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} id.make
			create {CE_INTEGER_8_POINTER} target.make
			create {CE_CLASS_POINTER [PD_URL]} proxy.make
		end

feature {ANY} -- fields

	st: INTEGER_32 assign set_st

	cmd: INTEGER_32 assign set_cmd

	csock: INTEGER_32 assign set_csock

	dltime: REAL_64 assign set_dltime

	rs: NATURAL_32 assign set_rs

	id: CE_POINTER [INTEGER_8] assign set_id

	target: CE_POINTER [INTEGER_8] assign set_target

	proxy: CE_POINTER [PD_URL] assign set_proxy

feature {ANY} -- field setters

	set_st (a_st: INTEGER_32)
		do
			st := a_st
			update_memory_field ("st")
		end

	set_cmd (a_cmd: INTEGER_32)
		do
			cmd := a_cmd
			update_memory_field ("cmd")
		end

	set_csock (a_csock: INTEGER_32)
		do
			csock := a_csock
			update_memory_field ("csock")
		end

	set_dltime (a_dltime: REAL_64)
		do
			dltime := a_dltime
			update_memory_field ("dltime")
		end

	set_rs (a_rs: NATURAL_32)
		do
			rs := a_rs
			update_memory_field ("rs")
		end

	set_id (a_id: CE_POINTER [INTEGER_8])
		do
			id := a_id
			update_memory_field ("id")
		end

	set_target (a_target: CE_POINTER [INTEGER_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_proxy (a_proxy: CE_POINTER [PD_URL])
		do
			proxy := a_proxy
			update_memory_field ("proxy")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			st := a_other.st
			cmd := a_other.cmd
			csock := a_other.csock
			dltime := a_other.dltime
			rs := a_other.rs
			id := a_other.id
			target := a_other.target
			proxy := a_other.proxy
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				st = a_other.st and
				cmd = a_other.cmd and
				csock = a_other.csock and
				dltime = a_other.dltime and
				rs = a_other.rs and
				id.is_equal (a_other.id) and
				target.is_equal (a_other.target) and
				proxy.is_equal (a_other.proxy)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("st"),
					create {CE_STRUCTURE_FIELD}.make ("cmd"),
					create {CE_STRUCTURE_FIELD}.make ("csock"),
					create {CE_STRUCTURE_FIELD}.make ("dltime"),
					create {CE_STRUCTURE_FIELD}.make ("rs"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("proxy")
				>>)
			init_structure_info
		end

end
