class
	PD_CELL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} key.make
			create {CE_VOID_POINTER} value.make
		end

feature {ANY} -- fields

	key: CE_POINTER [ANY] assign set_key

	value: CE_POINTER [ANY] assign set_value

feature {ANY} -- field setters

	set_key (a_key: CE_POINTER [ANY])
		do
			key := a_key
			update_memory_field ("key")
		end

	set_value (a_value: CE_POINTER [ANY])
		do
			value := a_value
			update_memory_field ("value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			key := a_other.key
			value := a_other.value
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				key.is_equal (a_other.key) and
				value.is_equal (a_other.value)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("value")
				>>)
			init_structure_info
		end

end
