class
	PD_CLOCKS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	id: INTEGER_32 assign set_id

	sysconf_name: INTEGER_32 assign set_sysconf_name

feature {ANY} -- field setters

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_sysconf_name (a_sysconf_name: INTEGER_32)
		do
			sysconf_name := a_sysconf_name
			update_memory_field ("sysconf_name")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			id := a_other.id
			sysconf_name := a_other.sysconf_name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				id = a_other.id and
				sysconf_name = a_other.sysconf_name
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("sysconf_name")
				>>)
			init_structure_info
		end

end
