class
	PD_HASH_TABLE_ITERATOR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} key.make
			create {CE_VOID_POINTER} value.make
			create {CE_VOID_POINTER} pos.make
			create {CE_VOID_POINTER} end2.make
		end

feature {ANY} -- fields

	key: CE_POINTER [ANY] assign set_key

	value: CE_POINTER [ANY] assign set_value

	pos: CE_POINTER [ANY] assign set_pos

	end2: CE_POINTER [ANY] assign set_end2

feature {ANY} -- field setters

	set_key (a_key: CE_POINTER [ANY])
		do
			key := a_key
			update_memory_field ("key")
		end

	set_value (a_value: CE_POINTER [ANY])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_pos (a_pos: CE_POINTER [ANY])
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_end2 (a_end2: CE_POINTER [ANY])
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

feature {ANY} -- public routines

	hash_table_iter_next: INTEGER_32
		local
			l_c: CE_POINTER [PD_CELL]
			l_end: CE_POINTER [PD_CELL]
			l_return: BOOLEAN
		do
			l_c := create {CE_CLASS_POINTER [PD_CELL]}.make_cast (pos)
			l_end := create {CE_CLASS_POINTER [PD_CELL]}.make_cast (end2)
			from
			until
				not (not (l_return) and then ((l_c.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32))
			loop
				if ((l_c.item.key).c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + ({NATURAL_32} 4_294_967_295).to_integer_32)).c_pointer.to_integer_32).to_natural_32 then
					Current.key := l_c.item.key
					update_class_fields -- Current might have been changed; synchronize
					Current.value := l_c.item.value
					update_class_fields -- Current might have been changed; synchronize
					Current.pos := create {CE_VOID_POINTER}.make_cast ((l_c + 1))
					update_class_fields -- Current might have been changed; synchronize
					Result := 1
					l_return := True
				end
				if not l_return then
					l_c := l_c + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			key := a_other.key
			value := a_other.value
			pos := a_other.pos
			end2 := a_other.end2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				key.is_equal (a_other.key) and
				value.is_equal (a_other.value) and
				pos.is_equal (a_other.pos) and
				end2.is_equal (a_other.end2)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("end2")
				>>)
			init_structure_info
		end

end
