class
	PD_IP_ADDRESS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_NETINET_IN_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_SYS_SOCKET_STATIC
		redefine
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_ASSERT_STATIC
		redefine
			copy,
			is_equal
		end
	S_ARPA_INET_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create data.make
			Precursor
		end

feature {ANY} -- fields

	family: INTEGER_32 assign set_family

	data: PD_DATA assign set_data

	ipv6_scope: INTEGER_32 assign set_ipv6_scope

feature {ANY} -- field setters

	set_family (a_family: INTEGER_32)
		do
			family := a_family
			update_memory_field ("family")
		end

	set_data (a_data: PD_DATA)
		do
			data := a_data
			update_memory_field ("data")
		end

	set_ipv6_scope (a_ipv6_scope: INTEGER_32)
		do
			ipv6_scope := a_ipv6_scope
			update_memory_field ("ipv6_scope")
		end

feature {PD_IP_ADDRESS} -- private attributes

	buf: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<64>>)
		end

	called: CE_STATIC [BOOLEAN]
		once ("PROCESS")
		end

	should_bind: CE_STATIC [BOOLEAN]
		once ("PROCESS")
		end

	ip: CE_STATIC [CE_ARRAY [PD_IP_ADDRESS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_IP_ADDRESS]}.make (<<1>>)
		end

feature {ANY} -- public routines

	sockaddr_set_data (a_sa: CE_POINTER [SD_SOCKADDR]; a_port: INTEGER_32)
		local
			l_sin: CE_POINTER [SD_SOCKADDR_IN]
			l_sin6: CE_POINTER [SD_SOCKADDR_IN6]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect family -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_sin := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (a_sa)
					memset (create {CE_VOID_POINTER}.make_cast (l_sin), ('%/0/').code, (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_sin.item.sin_family := (2).to_natural_16
					update_class_fields -- Current might have been changed; synchronize
					l_sin.item.sin_port := htons (a_port.to_natural_16)
					update_class_fields -- Current might have been changed; synchronize
					l_sin.item.sin_addr := (data.d4).twin
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					l_sin6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (a_sa)
					memset (create {CE_VOID_POINTER}.make_cast (l_sin6), ('%/0/').code, (create {SD_SOCKADDR_IN6}.make).structure_size.to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_sin6.item.sin6_family := (10).to_natural_16
					update_class_fields -- Current might have been changed; synchronize
					l_sin6.item.sin6_port := htons (a_port.to_natural_16)
					update_class_fields -- Current might have been changed; synchronize
					l_sin6.item.sin6_addr := (data.d6).twin
					update_class_fields -- Current might have been changed; synchronize
					l_sin6.item.sin6_scope_id := ipv6_scope.to_natural_32
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
					update_class_fields -- Current might have been changed; synchronize
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	connect_to_ip (a_port: INTEGER_32; a_print: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_ss: CE_ARRAY [SD_SOCKADDR_STORAGE]
			l_sa: CE_POINTER [SD_SOCKADDR]
			l_sock: INTEGER_32
			l_txt_addr: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_str: CE_POINTER [INTEGER_8]
			l_name: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: INTEGER_32
			l_on: CE_ARRAY [INTEGER_32]
			l_err: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [INTEGER_32]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_bufsize___0: CE_ARRAY [INTEGER_32]
			l_bind_ss: CE_ARRAY [SD_SOCKADDR_STORAGE]
			l_bind_sa: CE_POINTER [SD_SOCKADDR]
			l_tmp___13: NATURAL_32
			l_tmp___14: INTEGER_32
			l_tmp___15: BOOLEAN
			l_tmp___16: NATURAL_32
			l_tmp___17: INTEGER_32
			l_tmp___18: CE_POINTER [INTEGER_8]
			l_tmp___19: INTEGER_32
			l_save_errno: INTEGER_32
			l_tmp___20: CE_POINTER [INTEGER_32]
			l_tmp___21: CE_POINTER [INTEGER_32]
			l_tmp___22: CE_POINTER [INTEGER_8]
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: CE_POINTER [INTEGER_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_SOCKADDR_STORAGE]} l_ss.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_on.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_bufsize___0.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_SOCKADDR_STORAGE]} l_bind_ss.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sa := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_ss)
					if (not a_print.is_void) then
						l_tmp := ((create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_shared (c_pointer))).item.print_address
						update_class_fields -- Current might have been changed; synchronize
						l_txt_addr := l_tmp
						l_tmp___7 := strcmp (a_print, l_txt_addr)
						update_class_fields -- Current might have been changed; synchronize
						if 0 /= l_tmp___7 then
							l_str := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							if (create {P_OPTIONS_STATIC}).opt.item.item.enable_iri then
								l_name := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								if not l_name.is_void then
									l_tmp___0 := strlen (a_print)
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___1 := strlen (l_name)
									update_class_fields -- Current might have been changed; synchronize
									l_len := ((l_tmp___0 + l_tmp___1) + {NATURAL_32} 4).to_integer_32
									l_tmp___2 := (create {P_XMALLOC_STATIC}).xmalloc (l_len.to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									l_str := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___2)
									snprintf ([l_str, l_len.to_natural_32, ce_string ("%%s (%%s)"), l_name, a_print]).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_str[(l_len - 1)] := (('%/0/').code).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
									free (create {CE_VOID_POINTER}.make_cast (l_name))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if (not l_str.is_void) then
								l_tmp___4 := l_str
							else
								l_tmp___3 := (create {P_LOG_STATIC}).escnonprint_uri (a_print)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___4 := l_tmp___3
							end
							l_tmp___5 := gettext (ce_string ("Connecting to %%s|%%s|:%%d... "))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___5, l_tmp___4, l_txt_addr, a_port])
							update_class_fields -- Current might have been changed; synchronize
							if (not l_str.is_void) then
								free (create {CE_VOID_POINTER}.make_cast (l_str))
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_tmp___6 := gettext (ce_string ("Connecting to %%s:%%d... "))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___6, l_txt_addr, a_port])
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					((create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_shared (c_pointer))).item.sockaddr_set_data (l_sa, a_port)
					update_class_fields -- Current might have been changed; synchronize
					l_sock := socket ((l_sa.item.sa_family).to_integer_32, 1, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_sock < 0 then
						l_pos := -1 + 4 -- goto err
					end
				when 1 then
					if (create {P_OPTIONS_STATIC}).opt.item.item.ipv6_only then
						l_on.item := 1
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___8 := setsockopt (l_sock, 41, 26, create {CE_VOID_POINTER}.make_cast (l_on), {PLATFORM}.Integer_32_bytes.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_err := l_tmp___8
						l_tmp___12 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___12.to_boolean then
							if l_err < 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___11 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___11.to_boolean then
										l_tmp___9 := errno_location
										update_class_fields -- Current might have been changed; synchronize
										l_tmp___10 := strerror (l_tmp___9.item)
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Failed setting IPV6_V6ONLY: %%s"), l_tmp___10])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_break := True
								end
								l_break := False
							end
						end
					end
					if ((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_boolean then
						if (create {P_OPTIONS_STATIC}).opt.item.item.limit_rate < {INTEGER_64} 8_192 then
							l_bufsize___0.item := ((create {P_OPTIONS_STATIC}).opt.item.item.limit_rate).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							if l_bufsize___0.item < 512 then
								l_bufsize___0.item := 512
								update_class_fields -- Current might have been changed; synchronize
							end
							setsockopt (l_sock, 1, 8, create {CE_VOID_POINTER}.make_cast (l_bufsize___0), {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if (not ((create {P_OPTIONS_STATIC}).opt.item.item.bind_address).is_void) then
						l_bind_sa := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_bind_ss)
						l_tmp___15 := resolve_bind_address (l_bind_sa)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___15 then
							l_tmp___13 := sockaddr_size (l_bind_sa)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___14 := bind (l_sock, l_bind_sa, l_tmp___13)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___14 < 0 then
								l_pos := -1 + 4 -- goto err
							end
						end
					end
				when 2 then
					l_tmp___16 := sockaddr_size (l_sa)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___17 := connect_with_timeout (l_sock, l_sa, l_tmp___16, (create {P_OPTIONS_STATIC}).opt.item.item.connect_timeout)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___17 < 0 then
						l_pos := -1 + 4 -- goto err
					end
				when 3 then
					if not (l_sock >= 0) then
						assert_fail (ce_string ("sock >= 0"), ce_string ("connect.c"), {NATURAL_32} 356, ce_string ("connect_to_ip"))
						update_class_fields -- Current might have been changed; synchronize
					end
					if (not a_print.is_void) then
						l_tmp___18 := gettext (ce_string ("connected.%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___18])
						update_class_fields -- Current might have been changed; synchronize
					end
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp___19 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___19.to_boolean then
							(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Created socket %%d.%N"), l_sock])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_break := True
					end
					l_break := False
					Result := l_sock
					l_return := True
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 4 then -- if: | err:
						l_tmp___20 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_save_errno := l_tmp___20.item
						if l_sock >= 0 then
							(create {P_CONNECT_STATIC}).fd_close (l_sock)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (not a_print.is_void) then
							l_tmp___21 := errno_location
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___22 := strerror (l_tmp___21.item)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___23 := gettext (ce_string ("failed: %%s.%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_VERBOSE, l_tmp___23, l_tmp___22])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___24 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___24.item := l_save_errno
						update_class_fields -- Current might have been changed; synchronize
						Result := (-1)
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	bind_local (a_port: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_sock: INTEGER_32
			l_ss: CE_ARRAY [SD_SOCKADDR_STORAGE]
			l_sa: CE_POINTER [SD_SOCKADDR]
			l_setopt_val: CE_ARRAY [INTEGER_32]
			l_setopt_ptr: CE_POINTER [ANY]
			l_setopt_size: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_addrlen: CE_ARRAY [NATURAL_32]
			l_tmp___2: NATURAL_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_SOCKADDR_STORAGE]} l_ss.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_setopt_val.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_addrlen.make (<<1>>)

			l_sa := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_ss)
			l_setopt_val.item := 1
			update_class_fields -- Current might have been changed; synchronize
			l_setopt_ptr := create {CE_VOID_POINTER}.make_cast (l_setopt_val)
			l_setopt_size := {PLATFORM}.Integer_32_bytes.to_natural_32
			l_sock := socket (family, 1, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_sock < 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				setsockopt (l_sock, 1, 2, l_setopt_ptr, l_setopt_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				memset (create {CE_VOID_POINTER}.make_cast (l_ss), ('%/0/').code, (create {SD_SOCKADDR_STORAGE}.make).structure_size.to_natural_32).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_shared (c_pointer))).item.sockaddr_set_data (l_sa, a_port.item)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := sockaddr_size (l_sa)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := bind (l_sock, l_sa, l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0 < 0 then
					(create {P_CONNECT_STATIC}).fd_close (l_sock)
					update_class_fields -- Current might have been changed; synchronize
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___1 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1.to_boolean then
						(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("Local socket fd %%d bound.%N"), l_sock])
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				if a_port.item = 0 then
					l_tmp___2 := sockaddr_size (l_sa)
					update_class_fields -- Current might have been changed; synchronize
					l_addrlen.item := l_tmp___2
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := getsockname (l_sock, l_sa, l_addrlen)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___3 < 0 then
						(create {P_CONNECT_STATIC}).fd_close (l_sock)
						update_class_fields -- Current might have been changed; synchronize
						Result := (-1)
						l_return := True
					end
					if not l_return then
						sockaddr_get_data (l_sa, create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_shared (default_pointer), a_port)
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___5 := builtin_expect (((create {P_OPTIONS_STATIC}).opt.item.item.debug2).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___5.to_boolean then
								l_tmp___4 := ((create {CE_CLASS_POINTER [PD_IP_ADDRESS]}.make_shared (c_pointer))).item.print_address
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_LOG_STATIC}).debug_logprintf ([ce_string ("binding to address %%s using port %%i.%N"), l_tmp___4, a_port.item])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_break := True
						end
						l_break := False
					end
				end
			end
			if not l_return then
				l_tmp___6 := listen (l_sock, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___6 < 0 then
					(create {P_CONNECT_STATIC}).fd_close (l_sock)
					update_class_fields -- Current might have been changed; synchronize
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Result := l_sock
			end
		end

	print_address: CE_POINTER [INTEGER_8]
		local
			l_tmp: CE_POINTER [INTEGER_32]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
		do
			l_tmp___1 := inet_ntop (family, create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_DATA]}.make_shared (c_pointer + (create {PD_IP_ADDRESS}.make).offset_of ("data")))), buf.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32))
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp___1.is_void then
				l_tmp := errno_location
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := strerror (l_tmp.item)
				update_class_fields -- Current might have been changed; synchronize
				snprintf ([buf.item, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (64).to_natural_32), ce_string ("<error: %%s>"), l_tmp___0]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := buf.item
		end

feature {PD_IP_ADDRESS} -- private routines

	sockaddr_size (a_sa: CE_POINTER [SD_SOCKADDR]): NATURAL_32
		require
			not a_sa.is_void
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_sa.item.sa_family).to_integer_32 -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					Result := ((create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)
					l_return := True
				when 2 then -- switch 1, case 10
					if not l_return then
						Result := ((create {SD_SOCKADDR_IN6}.make).structure_size.to_natural_32)
						l_return := True
					end
				when 3 then -- switch 1, default:
					if not l_return then
						abort
					end
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sockaddr_get_data (a_sa: CE_POINTER [SD_SOCKADDR]; a_ip___0: CE_POINTER [PD_IP_ADDRESS]; a_port: CE_POINTER [INTEGER_32])
		require
			not a_sa.is_void
		local
			l_sin: CE_POINTER [SD_SOCKADDR_IN]
			l_sin6: CE_POINTER [SD_SOCKADDR_IN6]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_sa.item.sa_family).to_integer_32 -- switch 1 head
					when 2 then l_pos := -1 + 1
					when 10 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 2
					l_sin := create {CE_CLASS_POINTER [SD_SOCKADDR_IN]}.make_cast (a_sa)
					if (not a_ip___0.is_void) then
						a_ip___0.item.family := 2
						a_ip___0.item.data.d4 := (l_sin.item.sin_addr).twin
					end
					if (not a_port.is_void) then
						a_port.item := (ntohs (l_sin.item.sin_port)).to_integer_32
					end
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 10
					l_sin6 := create {CE_CLASS_POINTER [SD_SOCKADDR_IN6]}.make_cast (a_sa)
					if (not a_ip___0.is_void) then
						a_ip___0.item.family := 10
						a_ip___0.item.data.d6 := (l_sin6.item.sin6_addr).twin
						a_ip___0.item.ipv6_scope := (l_sin6.item.sin6_scope_id).to_integer_32
					end
					if (not a_port.is_void) then
						a_port.item := (ntohs (l_sin6.item.sin6_port)).to_integer_32
					end
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					abort
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	resolve_bind_address (a_sa: CE_POINTER [SD_SOCKADDR]): BOOLEAN
		local
			l_al: CE_POINTER [PD_ADDRESS_LIST]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if called.item then
				if should_bind.item then
					ip.item.item.sockaddr_set_data (a_sa, 0)
				end
				Result := should_bind.item
				l_return := True
			end
			if not l_return then
				called.item := (1).to_boolean
				l_al := (create {P_HOST_STATIC}).lookup_host ((create {P_OPTIONS_STATIC}).opt.item.item.bind_address, 3)
				if l_al.is_void then
					l_tmp := (create {P_QUOTE_STATIC}).quote ((create {P_OPTIONS_STATIC}).opt.item.item.bind_address);
					(create {P_LOG_STATIC}).logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("%%s: unable to resolve bind address %%s; disabling bind.%N"))), (create {P_WGET_STATIC}).exec_name.item, l_tmp])
					should_bind.item := (0).to_boolean
					Result := (0).to_boolean
					l_return := True
				end
			end
			if not l_return then
				ip.item.item := ((l_al.item.address_list_address_at (0)).item).twin
				l_al.item.address_list_release
				ip.item.item.sockaddr_set_data (a_sa, 0)
				should_bind.item := (1).to_boolean
				Result := (1).to_boolean
			end
		end

	connect_with_timeout (a_fd: INTEGER_32; a_addr: CE_POINTER [SD_SOCKADDR]; a_addrlen: NATURAL_32; a_timeout: REAL_64): INTEGER_32
		local
			l_ctx: CE_ARRAY [PD_CWT_CONTEXT]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_CWT_CONTEXT]} l_ctx.make (<<1>>)

			l_ctx.item.fd := a_fd
			l_ctx.item.addr := a_addr
			l_ctx.item.addrlen := a_addrlen
			if ((create {P_UTILS_STATIC}).run_with_timeout (a_timeout, (create {P_CONNECT_STATIC}).connect_with_timeout_callback_address, create {CE_VOID_POINTER}.make_cast (l_ctx))) then
				(errno_location).item := 110
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if l_ctx.item.result2 = -1 then
					if (errno_location).item = 4 then
						(errno_location).item := 110
					end
				end
				Result := (l_ctx.item.result2)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			family := a_other.family
			data := a_other.data.twin
			ipv6_scope := a_other.ipv6_scope
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				family = a_other.family and
				data.is_equal (a_other.data) and
				ipv6_scope = a_other.ipv6_scope
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("family"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("ipv6_scope")
				>>)
			init_structure_info
		end

end
