class
	PD_LOGVPRINTF_STATE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} bigmsg.make
		end

feature {ANY} -- fields

	bigmsg: CE_POINTER [INTEGER_8] assign set_bigmsg

	expected_size: INTEGER_32 assign set_expected_size

	allocated: INTEGER_32 assign set_allocated

feature {ANY} -- field setters

	set_bigmsg (a_bigmsg: CE_POINTER [INTEGER_8])
		do
			bigmsg := a_bigmsg
			update_memory_field ("bigmsg")
		end

	set_expected_size (a_expected_size: INTEGER_32)
		do
			expected_size := a_expected_size
			update_memory_field ("expected_size")
		end

	set_allocated (a_allocated: INTEGER_32)
		do
			allocated := a_allocated
			update_memory_field ("allocated")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bigmsg := a_other.bigmsg
			expected_size := a_other.expected_size
			allocated := a_other.allocated
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bigmsg.is_equal (a_other.bigmsg) and
				expected_size = a_other.expected_size and
				allocated = a_other.allocated
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bigmsg"),
					create {CE_STRUCTURE_FIELD}.make ("expected_size"),
					create {CE_STRUCTURE_FIELD}.make ("allocated")
				>>)
			init_structure_info
		end

end
