class
	PD_QUEUE_ELEMENT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} url.make
			create {CE_INTEGER_8_POINTER} referer.make
			create {CE_CLASS_POINTER [PD_IRI]} iri.make
			create {CE_CLASS_POINTER [PD_QUEUE_ELEMENT]} next.make
		end

feature {ANY} -- fields

	url: CE_POINTER [INTEGER_8] assign set_url

	referer: CE_POINTER [INTEGER_8] assign set_referer

	depth: INTEGER_32 assign set_depth

	html_allowed: BOOLEAN assign set_html_allowed

	iri: CE_POINTER [PD_IRI] assign set_iri

	css_allowed: BOOLEAN assign set_css_allowed

	next: CE_POINTER [PD_QUEUE_ELEMENT] assign set_next

feature {ANY} -- field setters

	set_url (a_url: CE_POINTER [INTEGER_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_referer (a_referer: CE_POINTER [INTEGER_8])
		do
			referer := a_referer
			update_memory_field ("referer")
		end

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

	set_html_allowed (a_html_allowed: BOOLEAN)
		do
			html_allowed := a_html_allowed
			update_memory_field ("html_allowed")
		end

	set_iri (a_iri: CE_POINTER [PD_IRI])
		do
			iri := a_iri
			update_memory_field ("iri")
		end

	set_css_allowed (a_css_allowed: BOOLEAN)
		do
			css_allowed := a_css_allowed
			update_memory_field ("css_allowed")
		end

	set_next (a_next: CE_POINTER [PD_QUEUE_ELEMENT])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			url := a_other.url
			referer := a_other.referer
			depth := a_other.depth
			html_allowed := a_other.html_allowed
			iri := a_other.iri
			css_allowed := a_other.css_allowed
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				url.is_equal (a_other.url) and
				referer.is_equal (a_other.referer) and
				depth = a_other.depth and
				html_allowed = a_other.html_allowed and
				iri.is_equal (a_other.iri) and
				css_allowed = a_other.css_allowed and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("referer"),
					create {CE_STRUCTURE_FIELD}.make ("depth"),
					create {CE_STRUCTURE_FIELD}.make ("html_allowed"),
					create {CE_STRUCTURE_FIELD}.make ("iri"),
					create {CE_STRUCTURE_FIELD}.make ("css_allowed"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
