class
	PD_TAGINFO

inherit
	PD_TAGINFO_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_ASSERT_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_CLASS_POINTER [PD_ATTR_PAIR]} attrs.make
			create {CE_INTEGER_8_POINTER} start_position.make
			create {CE_INTEGER_8_POINTER} end_position.make
			create {CE_INTEGER_8_POINTER} contents_begin.make
			create {CE_INTEGER_8_POINTER} contents_end.make
			Precursor
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	end_tag_p: INTEGER_32 assign set_end_tag_p

	nattrs: INTEGER_32 assign set_nattrs

	attrs: CE_POINTER [PD_ATTR_PAIR] assign set_attrs

	start_position: CE_POINTER [INTEGER_8] assign set_start_position

	end_position: CE_POINTER [INTEGER_8] assign set_end_position

	contents_begin: CE_POINTER [INTEGER_8] assign set_contents_begin

	contents_end: CE_POINTER [INTEGER_8] assign set_contents_end

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_end_tag_p (a_end_tag_p: INTEGER_32)
		do
			end_tag_p := a_end_tag_p
			update_memory_field ("end_tag_p")
		end

	set_nattrs (a_nattrs: INTEGER_32)
		do
			nattrs := a_nattrs
			update_memory_field ("nattrs")
		end

	set_attrs (a_attrs: CE_POINTER [PD_ATTR_PAIR])
		do
			attrs := a_attrs
			update_memory_field ("attrs")
		end

	set_start_position (a_start_position: CE_POINTER [INTEGER_8])
		do
			start_position := a_start_position
			update_memory_field ("start_position")
		end

	set_end_position (a_end_position: CE_POINTER [INTEGER_8])
		do
			end_position := a_end_position
			update_memory_field ("end_position")
		end

	set_contents_begin (a_contents_begin: CE_POINTER [INTEGER_8])
		do
			contents_begin := a_contents_begin
			update_memory_field ("contents_begin")
		end

	set_contents_end (a_contents_end: CE_POINTER [INTEGER_8])
		do
			contents_end := a_contents_end
			update_memory_field ("contents_end")
		end

feature {ANY} -- public routines

	find_attr (a_name: CE_POINTER [INTEGER_8]; a_attrind: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < nattrs))
			loop
				l_tmp := strcasecmp ((attrs + l_i).item.name, a_name)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					if (not a_attrind.is_void) then
						a_attrind.item := l_i
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := ((attrs + l_i).item.value)
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
			end
		end

	check_style_attr (a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_attrind: CE_ARRAY [INTEGER_32]
			l_style: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_attrind.make (<<1>>)

			l_tmp := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("style"), l_attrind)
			update_class_fields -- Current might have been changed; synchronize
			l_style := l_tmp
			if l_style.is_void then
				l_return := True
			end
			if not l_return then
				a_ctx.item.get_urls_css ((((attrs + l_attrind.item).item.value_raw_beginning).distance ((a_ctx.item.text))) + 1, (attrs + l_attrind.item).item.value_raw_size - 2)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	tag_find_urls (a_tagid: INTEGER_32; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_i: NATURAL_32
			l_attrind: INTEGER_32
			l_first: INTEGER_32
			l_link: CE_POINTER [INTEGER_8]
			l_size: NATURAL_32
			l_up: CE_POINTER [PD_URLPOS]
			l_tmp: CE_POINTER [PD_URLPOS]
			l_flags: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_first := -1
			l_i := (0).to_natural_32
			from
			until
				not (not (l_break) and then (l_i < ((create {PD_TAG_URL_ATTRIBUTES}.make).structure_size.to_natural_32 * (21).to_natural_32) // (create {PD_TAG_URL_ATTRIBUTES}.make).structure_size.to_natural_32))
			loop
				l_break := False
				if (create {P_HTML_URL_STATIC}).tag_url_attributes.item[l_i.to_integer_32].tagid = a_tagid then
					l_first := l_i.to_integer_32
					l_break := True
				end
				if not (l_break) then
					l_i := l_i + 1
				end
			end
			l_break := False
			if l_first = -1 then
				assert_fail (ce_string ("first != -1"), ce_string ("html-url.c"), {NATURAL_32} 382, ce_string ("tag_find_urls"))
				update_class_fields -- Current might have been changed; synchronize
			end
			l_attrind := 0
			from
			until
				not (not (l_return) and then (l_attrind < nattrs))
			loop
				l_link := (attrs + l_attrind).item.value
				l_size := ((create {PD_TAG_URL_ATTRIBUTES}.make).structure_size.to_natural_32 * (21).to_natural_32) // (create {PD_TAG_URL_ATTRIBUTES}.make).structure_size.to_natural_32
				l_i := l_first.to_natural_32
				from
				until
					(l_break)
				loop
					l_break := False
					if l_i < l_size then
						if (create {P_HTML_URL_STATIC}).tag_url_attributes.item[l_i.to_integer_32].tagid /= a_tagid then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_tmp___0 := strcasecmp ((attrs + l_attrind).item.name, (create {P_HTML_URL_STATIC}).tag_url_attributes.item[l_i.to_integer_32].attr_name)
						update_class_fields -- Current might have been changed; synchronize
						if 0 = l_tmp___0 then
							l_tmp := a_ctx.item.append_url (l_link, ((attrs + l_attrind).item.value_raw_beginning).distance ((a_ctx.item.text)), (attrs + l_attrind).item.value_raw_size)
							update_class_fields -- Current might have been changed; synchronize
							l_up := l_tmp
							if (not l_up.is_void) then
								l_flags := (create {P_HTML_URL_STATIC}).tag_url_attributes.item[l_i.to_integer_32].flags
								if ((l_flags).bit_and (1)).to_boolean then
									l_up.item.link_inline_p := {NATURAL_32} 1
									update_class_fields -- Current might have been changed; synchronize
								end
								if ((l_flags).bit_and (2)).to_boolean then
									l_up.item.link_expect_html := {NATURAL_32} 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_i := l_i + 1
					end
				end
				l_break := False
				l_attrind := l_attrind + 1
			end
		end

	tag_handle_base (a_tagid: INTEGER_32; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_base_urlpos: CE_POINTER [PD_URLPOS]
			l_attrind: CE_ARRAY [INTEGER_32]
			l_newbase: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_attrind.make (<<1>>)

			l_tmp := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("href"), l_attrind)
			update_class_fields -- Current might have been changed; synchronize
			l_newbase := l_tmp
			if l_newbase.is_void then
				l_return := True
			end
			if not l_return then
				l_base_urlpos := a_ctx.item.append_url (l_newbase, ((attrs + l_attrind.item).item.value_raw_beginning).distance ((a_ctx.item.text)), (attrs + l_attrind.item).item.value_raw_size)
				update_class_fields -- Current might have been changed; synchronize
				if l_base_urlpos.is_void then
					l_return := True
				end
			end
			if not l_return then
				l_base_urlpos.item.ignore_when_downloading := {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				l_base_urlpos.item.link_base_p := {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				if (not (a_ctx.item.base).is_void) then
					free (create {CE_VOID_POINTER}.make_cast (a_ctx.item.base))
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not (a_ctx.item.parent_base).is_void) then
					a_ctx.item.base := (create {P_URL_STATIC}).uri_merge (a_ctx.item.parent_base, l_newbase)
					update_class_fields -- Current might have been changed; synchronize
				else
					a_ctx.item.base := (create {P_XMALLOC_STATIC}).xstrdup (l_newbase)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	tag_handle_form (a_tagid: INTEGER_32; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_attrind: CE_ARRAY [INTEGER_32]
			l_action: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_up: CE_POINTER [PD_URLPOS]
			l_tmp___0: CE_POINTER [PD_URLPOS]
		do
			create {CE_INTEGER_32_ARRAY} l_attrind.make (<<1>>)

			l_tmp := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("action"), l_attrind)
			update_class_fields -- Current might have been changed; synchronize
			l_action := l_tmp
			if (not l_action.is_void) then
				l_tmp___0 := a_ctx.item.append_url (l_action, ((attrs + l_attrind.item).item.value_raw_beginning).distance ((a_ctx.item.text)), (attrs + l_attrind.item).item.value_raw_size)
				update_class_fields -- Current might have been changed; synchronize
				l_up := l_tmp___0
				if (not l_up.is_void) then
					l_up.item.ignore_when_downloading := {NATURAL_32} 1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	tag_handle_link (a_tagid: INTEGER_32; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_attrind: CE_ARRAY [INTEGER_32]
			l_href: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_up: CE_POINTER [PD_URLPOS]
			l_tmp___0: CE_POINTER [PD_URLPOS]
			l_rel: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_attrind.make (<<1>>)

			l_tmp := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("href"), l_attrind)
			update_class_fields -- Current might have been changed; synchronize
			l_href := l_tmp
			if (not l_href.is_void) then
				l_tmp___0 := a_ctx.item.append_url (l_href, ((attrs + l_attrind.item).item.value_raw_beginning).distance ((a_ctx.item.text)), (attrs + l_attrind.item).item.value_raw_size)
				update_class_fields -- Current might have been changed; synchronize
				l_up := l_tmp___0
				if (not l_up.is_void) then
					l_tmp___1 := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("rel"), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_rel := l_tmp___1
					if (not l_rel.is_void) then
						l_tmp___3 := strcasecmp (l_rel, ce_string ("stylesheet"))
						update_class_fields -- Current might have been changed; synchronize
						if 0 = l_tmp___3 then
							l_up.item.link_inline_p := {NATURAL_32} 1
							update_class_fields -- Current might have been changed; synchronize
							l_up.item.link_expect_css := {NATURAL_32} 1
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___2 := strcasecmp (l_rel, ce_string ("shortcut icon"))
							update_class_fields -- Current might have been changed; synchronize
							if 0 = l_tmp___2 then
								l_up.item.link_inline_p := {NATURAL_32} 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					else
						l_up.item.link_expect_html := {NATURAL_32} 1
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	tag_handle_meta (a_tagid: INTEGER_32; a_ctx: CE_POINTER [PD_MAP_CONTEXT])
		local
			l_name: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_http_equiv: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_entry: CE_POINTER [PD_URLPOS]
			l_attrind: CE_ARRAY [INTEGER_32]
			l_timeout: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_refresh: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: BOOLEAN
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: BOOLEAN
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: BOOLEAN
			l_mcharset: CE_POINTER [INTEGER_8]
			l_content: CE_POINTER [INTEGER_8]
			l_tmp___9: CE_POINTER [INTEGER_8]
			l_content___0: CE_POINTER [INTEGER_8]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_tmp___11: NATURAL_32
			l_tmp___12: NATURAL_32
			l_tmp___13: INTEGER_32
			l_tmp___14: NATURAL_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_attrind.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("name"), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_name := l_tmp
					l_tmp___0 := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("http-equiv"), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_http_equiv := l_tmp___0
					if l_http_equiv.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp___18 := strcasecmp (l_http_equiv, ce_string ("refresh"))
						update_class_fields -- Current might have been changed; synchronize
						if 0 = l_tmp___18 then
							l_timeout := 0
							l_tmp___1 := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("content"), l_attrind)
							update_class_fields -- Current might have been changed; synchronize
							l_refresh := l_tmp___1
							if l_refresh.is_void then
								l_return := True
							end
							if not l_return then
								l_p___0 := l_refresh
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___2 := (create {P_C_CTYPE_STATIC}).c2_isdigit ((l_p___0[0]).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___2 then
										l_break := True
									end
									if not (l_break) then
										l_timeout := (10 * l_timeout + (l_p___0[0]).to_integer_32) - 48
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
								l_tmp___3 := l_p___0
								l_p___0 := l_p___0 + 1
								if (l_tmp___3[0]).to_integer_32 /= 59 then
									l_return := True
								end
							end
							if not l_return then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___4 := (create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___4 then
										l_break := True
									end
									if not (l_break) then
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
								l_tmp___5 := (create {P_C_CTYPE_STATIC}).c2_toupper ((l_p___0[0]).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___5 = 85 then
									l_tmp___6 := (create {P_C_CTYPE_STATIC}).c2_toupper ((l_p___0[1]).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___6 = 82 then
										l_tmp___7 := (create {P_C_CTYPE_STATIC}).c2_toupper ((l_p___0[2]).to_integer_32)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___7 = 76 then
											if (l_p___0[3]).to_integer_32 /= 61 then
												l_return := True
											end
										else
											l_return := True
										end
									else
										l_return := True
									end
								else
									l_return := True
								end
							end
							if not l_return then
								l_p___0 := l_p___0 + (4)
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___8 := (create {P_C_CTYPE_STATIC}).c2_isspace ((l_p___0[0]).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___8 then
										l_break := True
									end
									if not (l_break) then
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
								l_entry := a_ctx.item.append_url (l_p___0, ((attrs + l_attrind.item).item.value_raw_beginning).distance ((a_ctx.item.text)), (attrs + l_attrind.item).item.value_raw_size)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_entry.is_void) then
									l_entry.item.link_refresh_p := {NATURAL_32} 1
									update_class_fields -- Current might have been changed; synchronize
									l_entry.item.refresh_timeout := l_timeout
									update_class_fields -- Current might have been changed; synchronize
									l_entry.item.link_expect_html := {NATURAL_32} 1
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if l_http_equiv.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp___17 := strcasecmp (l_http_equiv, ce_string ("content-type"))
						update_class_fields -- Current might have been changed; synchronize
						if 0 = l_tmp___17 then
							l_tmp___9 := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("content"), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							l_content := l_tmp___9
							if l_content.is_void then
								l_return := True
							end
							if not l_return then
								l_mcharset := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
								if l_mcharset.is_void then
									l_return := True
								end
							end
							if not l_return then
								if (not ((create {P_HTML_URL_STATIC}).meta_charset.item).is_void) then
									free (create {CE_VOID_POINTER}.make_cast ((create {P_HTML_URL_STATIC}).meta_charset.item))
									update_class_fields -- Current might have been changed; synchronize
								end
								(create {P_HTML_URL_STATIC}).meta_charset.item := l_mcharset
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if (not l_name.is_void) then
							l_tmp___16 := strcasecmp (l_name, ce_string ("robots"))
							update_class_fields -- Current might have been changed; synchronize
							if 0 = l_tmp___16 then
								l_tmp___10 := ((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.find_attr (ce_string ("content"), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
								l_content___0 := l_tmp___10
								if l_content___0.is_void then
									l_return := True
								end
								if not l_return then
									l_tmp___15 := strcasecmp (l_content___0, ce_string ("none"))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___15.to_boolean then
										from
										until
											not ((l_content___0[0]).to_boolean)
										loop
											l_tmp___11 := strspn (l_content___0, ce_string (" %F%N%R%T%/11/"))
											update_class_fields -- Current might have been changed; synchronize
											l_content___0 := l_content___0 + l_tmp___11.to_integer_32
											l_tmp___12 := strcspn (l_content___0, ce_string (", %F%N%R%T%/11/"))
											update_class_fields -- Current might have been changed; synchronize
											l_end := l_content___0 + l_tmp___12.to_integer_32
											l_tmp___13 := strncasecmp (l_content___0, ce_string ("nofollow"), (l_end.distance (l_content___0)).to_natural_32)
											update_class_fields -- Current might have been changed; synchronize
											if not l_tmp___13.to_boolean then
												a_ctx.item.nofollow := (1).to_boolean
												update_class_fields -- Current might have been changed; synchronize
											end
											if (l_end[0]).to_integer_32 = 44 then
												l_end := l_end + 1
											else
												l_end := strchr (l_end, (',').code)
												update_class_fields -- Current might have been changed; synchronize
												if (not l_end.is_void) then
													l_end := l_end + 1
												else
													l_tmp___14 := strlen (l_content___0)
													update_class_fields -- Current might have been changed; synchronize
													l_end := l_content___0 + l_tmp___14.to_integer_32
												end
											end
											l_content___0 := l_end
										end
									else
										a_ctx.item.nofollow := (1).to_boolean
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
				when 7 then -- if done
					if not l_return then
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	collect_tags_mapper (a_arg: CE_POINTER [ANY])
		local
			l_ctx: CE_POINTER [PD_MAP_CONTEXT]
			l_t: CE_POINTER [PD_KNOWN_TAG]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
		do
			l_ctx := create {CE_CLASS_POINTER [PD_MAP_CONTEXT]}.make_cast (a_arg)
			l_tmp := ((create {P_HTML_URL_STATIC}).interesting_tags.item).item.hash_table_get (create {CE_VOID_POINTER}.make_cast (name))
			update_class_fields -- Current might have been changed; synchronize
			l_t := create {CE_CLASS_POINTER [PD_KNOWN_TAG]}.make_cast (l_tmp)
			if not l_t.is_void then
				(l_t.item.handler).call ([l_t.item.tagid, (create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer)), l_ctx])
				update_class_fields -- Current might have been changed; synchronize
			end
			((create {CE_CLASS_POINTER [PD_TAGINFO]}.make_shared (c_pointer))).item.check_style_attr (l_ctx)
			update_class_fields -- Current might have been changed; synchronize
			if end_tag_p.to_boolean then
				l_tmp___0 := strcasecmp (name, ce_string ("style"))
				update_class_fields -- Current might have been changed; synchronize
				if 0 = l_tmp___0 then
					if (not contents_begin.is_void) then
						if (not contents_end.is_void) then
							l_ctx.item.get_urls_css (contents_begin.distance ((l_ctx.item.text)), contents_end.distance (contents_begin))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			end_tag_p := a_other.end_tag_p
			nattrs := a_other.nattrs
			attrs := a_other.attrs
			start_position := a_other.start_position
			end_position := a_other.end_position
			contents_begin := a_other.contents_begin
			contents_end := a_other.contents_end
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				end_tag_p = a_other.end_tag_p and
				nattrs = a_other.nattrs and
				attrs.is_equal (a_other.attrs) and
				start_position.is_equal (a_other.start_position) and
				end_position.is_equal (a_other.end_position) and
				contents_begin.is_equal (a_other.contents_begin) and
				contents_end.is_equal (a_other.contents_end)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("end_tag_p"),
					create {CE_STRUCTURE_FIELD}.make ("nattrs"),
					create {CE_STRUCTURE_FIELD}.make ("attrs"),
					create {CE_STRUCTURE_FIELD}.make ("start_position"),
					create {CE_STRUCTURE_FIELD}.make ("end_position"),
					create {CE_STRUCTURE_FIELD}.make ("contents_begin"),
					create {CE_STRUCTURE_FIELD}.make ("contents_end")
				>>)
			init_structure_info
		end

end
