class
	PD_URL_QUEUE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_QUEUE_ELEMENT]} head.make
			create {CE_CLASS_POINTER [PD_QUEUE_ELEMENT]} tail.make
		end

feature {ANY} -- fields

	head: CE_POINTER [PD_QUEUE_ELEMENT] assign set_head

	tail: CE_POINTER [PD_QUEUE_ELEMENT] assign set_tail

	count: INTEGER_32 assign set_count

	maxcount: INTEGER_32 assign set_maxcount

feature {ANY} -- field setters

	set_head (a_head: CE_POINTER [PD_QUEUE_ELEMENT])
		do
			head := a_head
			update_memory_field ("head")
		end

	set_tail (a_tail: CE_POINTER [PD_QUEUE_ELEMENT])
		do
			tail := a_tail
			update_memory_field ("tail")
		end

	set_count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_maxcount (a_maxcount: INTEGER_32)
		do
			maxcount := a_maxcount
			update_memory_field ("maxcount")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			head := a_other.head
			tail := a_other.tail
			count := a_other.count
			maxcount := a_other.maxcount
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				head.is_equal (a_other.head) and
				tail.is_equal (a_other.tail) and
				count = a_other.count and
				maxcount = a_other.maxcount
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("head"),
					create {CE_STRUCTURE_FIELD}.make ("tail"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("maxcount")
				>>)
			init_structure_info
		end

end
