class
	SD_IO_MARKER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_IO_MARKER]} next.make
			create {CE_CLASS_POINTER [SD_IO_FILE]} sbuf.make
		end

feature {ANY} -- fields

	next: CE_POINTER [SD_IO_MARKER] assign set_next

	sbuf: CE_POINTER [SD_IO_FILE] assign set_sbuf

	pos: INTEGER_32 assign set_pos

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [SD_IO_MARKER])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_sbuf (a_sbuf: CE_POINTER [SD_IO_FILE])
		do
			sbuf := a_sbuf
			update_memory_field ("sbuf")
		end

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			sbuf := a_other.sbuf
			pos := a_other.pos
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				sbuf.is_equal (a_other.sbuf) and
				pos = a_other.pos
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("sbuf"),
					create {CE_STRUCTURE_FIELD}.make ("pos")
				>>)
			init_structure_info
		end

end
