class
	SD_VALUE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	wch: NATURAL_32 assign set_wch

	wchb: CE_ARRAY [INTEGER_8]

feature {ANY} -- field setters

	set_wch (a_wch: NATURAL_32)
		do
			wch := a_wch
			update_memory_field ("wch")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wch := a_other.wch
			wchb := a_other.wchb.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wch = a_other.wch and
				wchb.is_equal (a_other.wchb)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("wch"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("wchb", <<4>>)
				>>)
			init_structure_info
		end

end
