class
	P_AF_UNIX_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_UNISTD_STATIC
	S_SYS_SOCKET_STATIC
	S_SYS_SELECT_STATIC
	S_BITS_ERRNO_STATIC
	LINKS_ASSEMBLER

feature {ANY} -- public attributes

	s_unix_acc: CE_STATIC [CE_POINTER [SD_SOCKADDR]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
		end

	s_unix: CE_STATIC [CE_POINTER [SD_SOCKADDR]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
		end

	s_unix_l: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	s_unix_fd: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

feature {ANY} -- public routines

	get_address: INTEGER_32
		local
			l_su: CE_POINTER [SD_SOCKADDR_UN]
			l_path: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_path.make (<<1>>)

			if ((create {P_DEFAULT_STATIC}).links_home.item).is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_path.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 34, (create {P_DEFAULT_STATIC}).links_home.item)
				l_su := create {CE_CLASS_POINTER [SD_SOCKADDR_UN]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 35, ((create {SD_SOCKADDR_UN}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path.item)))) + {NATURAL_32} 1)))
				s_unix_acc.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 36, ((create {SD_SOCKADDR_UN}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path.item)))) + {NATURAL_32} 1)))
				memset (create {CE_VOID_POINTER}.make_cast (l_su), 0, ((create {SD_SOCKADDR_UN}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path.item)))) + {NATURAL_32} 1).do_nothing
				l_su.item.sun_family := (1).to_natural_16;
				(create {P_LINKS_STATIC}).add_to_strn (l_path, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("socket")))
				strcpy ((l_su.item.sun_path), create {CE_INTEGER_8_POINTER}.make_cast (l_path.item)).do_nothing;
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 41, create {CE_VOID_POINTER}.make_cast (l_path.item))
				s_unix.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_cast (l_su)
				s_unix_l.item := (((create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_ARRAY_POINTER [INTEGER_8]}.make_shared (l_su.c_pointer + (create {SD_SOCKADDR_UN}.make).offset_of ("sun_path"))))).distance ((create {CE_INTEGER_8_POINTER}.make_cast (l_su)))).to_natural_32 + (strlen ((l_su.item.sun_path)))) + {NATURAL_32} 1
				Result := 1
			end
		end

	unlink_unix
		do
			unlink (((create {CE_CLASS_POINTER [SD_SOCKADDR_UN]}.make_cast (s_unix.item)).item.sun_path)).do_nothing
		end

	bind_to_af_unix: INTEGER_32
		local
			l_u: INTEGER_32
			l_a1: CE_ARRAY [INTEGER_32]
			l_cnt: INTEGER_32
			l_af: INTEGER_32
			l_tv: CE_ARRAY [SD_TIMEVAL]
			l_dummy: CE_ARRAY [SD_FD_SET]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_a1.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tv.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_dummy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u := 0
					l_a1.item := 1
					l_cnt := 0
					l_af := get_address
					if l_af = -1 then
						Result := (-1)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | again:
						s_unix_fd.item := socket (l_af, 1, 0)
						if s_unix_fd.item = -1 then
							Result := (-1)
							l_return := True
						end
				when 2 then -- if done
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 3 then -- if:
						setsockopt (s_unix_fd.item, 1, 2, create {CE_VOID_POINTER}.make_cast (l_a1), {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
						if not ((bind (s_unix_fd.item, s_unix.item, s_unix_l.item)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						close (s_unix_fd.item).do_nothing
						s_unix_fd.item := socket (l_af, 1, 0)
						if s_unix_fd.item = -1 then
							Result := (-1)
							l_return := True
						end
						if l_return then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						setsockopt (s_unix_fd.item, 1, 2, create {CE_VOID_POINTER}.make_cast (l_a1), {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
						if not ((connect (s_unix_fd.item, s_unix.item, s_unix_l.item)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						l_cnt := l_cnt + 1
						if l_cnt < 3 then
							l_tv.item.tv_sec := (0).to_integer_32
							l_tv.item.tv_usec := (100_000).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								asm1 (l___d0, l___d1, l_dummy)
								l_break := True
							end
							l_break := False
							select2 (0, l_dummy, l_dummy, l_dummy, l_tv).do_nothing
							close (s_unix_fd.item).do_nothing
							l_pos := -1 + 1 -- goto again
						end
				when 7 then
						close (s_unix_fd.item).do_nothing
						s_unix_fd.item := -1
						if not l_u.to_boolean then
							unlink_unix
							l_u := 1
							l_pos := -1 + 1 -- goto again
						end
				when 8 then;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 114, create {CE_VOID_POINTER}.make_cast (s_unix.item))
						s_unix.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
						Result := (-1)
						l_return := True
				when 9 then -- if done | if done
						if not l_return then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 117, create {CE_VOID_POINTER}.make_cast (s_unix.item))
							s_unix.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
							Result := s_unix_fd.item
							l_return := True
						end
				when 10 then -- if done | if done
					if not l_return then
						if (listen (s_unix_fd.item, 100)).to_boolean then
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: listen failed: %%d")), (errno_location).item]);
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 122, create {CE_VOID_POINTER}.make_cast (s_unix.item))
							s_unix.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
							close (s_unix_fd.item).do_nothing
							s_unix_fd.item := -1
							Result := (-1)
							l_return := True
						end
					end
					if not l_return then
						(create {P_SELECT_STATIC}).set_handlers (s_unix_fd.item, af_unix_connection_address, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
						Result := (-1)
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	af_unix_connection (a_xxx: CE_POINTER [ANY])
		local
			l_l: CE_ARRAY [NATURAL_32]
			l_ns: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_l.make (<<1>>)

			l_l.item := s_unix_l.item
			memset (create {CE_VOID_POINTER}.make_cast (s_unix_acc.item), 0, l_l.item).do_nothing
			l_ns := accept (s_unix_fd.item, s_unix_acc.item, l_l)
			if l_ns = -1 then
				l_return := True
			end
			if not l_return then
				(create {P_TERMINAL_STATIC}).init_term (l_ns, l_ns, (create {PD_WINDOW_STATIC}).win_func_address).do_nothing;
				(create {P_OS_DEP_STATIC}).set_highpri
			end
		end

	af_unix_close
		do
			if s_unix_fd.item /= -1 then
				close (s_unix_fd.item).do_nothing
			end
			if (not s_unix.item.is_void) then
				unlink_unix;
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 144, create {CE_VOID_POINTER}.make_cast (s_unix.item))
				s_unix.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
			end
			if (not s_unix_acc.item.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("af_unix.c")), 145, create {CE_VOID_POINTER}.make_cast (s_unix_acc.item))
				s_unix_acc.item := create {CE_CLASS_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
			end
		end

feature {ANY} -- routine addresses

	af_unix_connection_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent af_unix_connection)
		end

end
