class
	P_BOOKMARK_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC
	S_STRING_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	bookmarks: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (bookmarks.item), create {CE_VOID_POINTER}.make_cast (bookmarks.item)])
		end

	next_bookmark_id: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	bookmark_add_msg: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					(create {P_LINKS_STATIC}).dummyarray.item + 268,
					(create {P_LINKS_STATIC}).dummyarray.item + 241
				>>)
		end

feature {ANY} -- public routines

	free_bookmarks
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			l_bm := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.item.item.next)
			from
			until
				l_bm.is_equal (bookmarks.item)
			loop
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 18, create {CE_VOID_POINTER}.make_cast (l_bm.item.title));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 19, create {CE_VOID_POINTER}.make_cast (l_bm.item.url))
				l_bm := l_bm.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (bookmarks.item))
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (bookmarks.item.item.next)
			from
			until
				l_a__.is_equal (bookmarks.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (bookmarks.item.item.prev)
			from
			until
				l_a__.is_equal (bookmarks.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(bookmarks.item.item.next).is_equal (bookmarks.item)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (bookmarks.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 22, create {CE_VOID_POINTER}.make_cast (l_a__))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (bookmarks.item))
		end

	finalize_bookmarks
		do
			write_bookmarks
			free_bookmarks
		end

	read_bookmarks
		local
			l_in_buffer: CE_ARRAY [NATURAL_8]
			l_file_name: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_title: CE_POINTER [NATURAL_8]
			l_url: CE_POINTER [NATURAL_8]
			l_f: CE_POINTER [SD_IO_FILE]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_in_buffer.make (<<1_024>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_file_name.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_url.make

			l_file_name.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 39, (create {P_DEFAULT_STATIC}).links_home.item)
			if (l_file_name.item).is_void then
				l_return := True
			end
			if not l_return then
				(create {P_LINKS_STATIC}).add_to_strn (l_file_name, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmarks")))
				l_f := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_file_name.item), ce_string ("r"));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 44, create {CE_VOID_POINTER}.make_cast (l_file_name.item))
				if l_f.is_void then
					l_return := True
				end
			end
			if not l_return then
				l_title := l_in_buffer
				from
				until
					(l_break)
				loop
					l_break := False
					l_continue := False
					if (fgets (create {CE_INTEGER_8_POINTER}.make_cast (l_in_buffer), 1_024, l_f)).is_void then
						l_break := True
					end
					if not (l_break or l_continue) then
						l_url := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_in_buffer), ('|').code)))
						if l_url.is_void then
							l_continue := True
						end
					end
					if not (l_break or l_continue) then
						l_url.item := (('%/0/').code).to_natural_8
						l_url := l_url + 1
						if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_url), ('%N').code)).is_void) then
							(strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_url), ('%N').code))[0] := (('%/0/').code).to_integer_8
						end
						add_bookmark (l_title, l_url)
					end
				end
				l_break := False
				l_continue := False
				fclose (l_f).do_nothing
			end
		end

	write_bookmarks
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_out: CE_POINTER [SD_IO_FILE]
			l_tmp_file_name: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_file_name: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_tmp_file_name.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_file_name.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp_file_name.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 69, (create {P_DEFAULT_STATIC}).links_home.item)
					if (l_tmp_file_name.item).is_void then
						l_return := True
					end
					if not l_return then
						(create {P_LINKS_STATIC}).add_to_strn (l_tmp_file_name, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmarks.tmp")))
						l_out := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_file_name.item), ce_string ("w"))
						if l_out.is_void then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 75, create {CE_VOID_POINTER}.make_cast (l_tmp_file_name.item))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_bm := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.item.item.prev)
						from
						until
							not (not (l_return) and then (not l_bm.is_equal (bookmarks.item)))
						loop
							l_p := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 80, l_bm.item.title))
							l_i := ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p))) - {NATURAL_32} 1).to_integer_32
							from
							until
								not (l_i >= 0)
							loop
								if (l_p[l_i]).to_integer_32 < 32 then
									l_p[l_i] := ((' ').code).to_natural_8
								elseif (l_p[l_i]).to_integer_32 = 124 then
									l_p[l_i] := ((' ').code).to_natural_8
								end
								l_i := l_i - 1
							end
							fputs (create {CE_INTEGER_8_POINTER}.make_cast (l_p), l_out).do_nothing
							fputc (('|').code, l_out).do_nothing
							fputs (create {CE_INTEGER_8_POINTER}.make_cast (l_bm.item.url), l_out).do_nothing
							fputc (('%N').code, l_out).do_nothing;
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 87, create {CE_VOID_POINTER}.make_cast (l_p))
							l_bm := l_bm.item.prev
						end
						if (ferror (l_out)).to_boolean then
							fclose (l_out).do_nothing
							l_pos := -1 + 3 -- goto err
						end
				when 2 then
						if (fclose (l_out)) /= -1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 3 then -- if: | err:
						remove (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_file_name.item)).do_nothing;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 97, create {CE_VOID_POINTER}.make_cast (l_tmp_file_name.item))
						l_return := True
				when 4 then -- if done | if done
					if not l_return then
						l_file_name.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 101, (create {P_DEFAULT_STATIC}).links_home.item)
						if (l_file_name.item).is_void then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 103, create {CE_VOID_POINTER}.make_cast (l_tmp_file_name.item))
							l_return := True
						end
					end
					if not l_return then
						(create {P_LINKS_STATIC}).add_to_strn (l_file_name, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmarks")))
						rename2 (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp_file_name.item), create {CE_INTEGER_8_POINTER}.make_cast (l_file_name.item)).do_nothing;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 112, create {CE_VOID_POINTER}.make_cast (l_tmp_file_name.item));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 113, create {CE_VOID_POINTER}.make_cast (l_file_name.item))
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_bookmark_by_id (a_id: INTEGER_32): CE_POINTER [PD_BOOKMARK]
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_return: BOOLEAN
		do
			if a_id = -1 then
				Result := (create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_bm := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.item.item.next)
				from
				until
					not (not (l_return) and then (not l_bm.is_equal (bookmarks.item)))
				loop
					if a_id = l_bm.item.id then
						Result := l_bm
						l_return := True
					end
					if not l_return then
						l_bm := l_bm.item.next
					end
				end
			end
			if not l_return then
				Result := (create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_shared (default_pointer))
			end
		end

	add_bookmark (a_title, a_url: CE_POINTER [NATURAL_8])
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_title_size: INTEGER_32
			l_url_size: INTEGER_32
			l_tmp___4: INTEGER_32
			l_break: BOOLEAN
		do
			l_title_size := ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_title))) + {NATURAL_32} 1).to_integer_32
			l_url_size := ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_url))) + {NATURAL_32} 1).to_integer_32
			l_bm := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 143, (create {PD_BOOKMARK}.make).structure_size.to_natural_32)))
			l_bm.item.title := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 145, l_title_size.to_natural_32)))
			l_bm.item.url := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 146, l_url_size.to_natural_32)))
			strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_bm.item.title), create {CE_INTEGER_8_POINTER}.make_cast (a_title)).do_nothing
			strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_bm.item.url), create {CE_INTEGER_8_POINTER}.make_cast (a_url)).do_nothing
			l_tmp___4 := next_bookmark_id.item
			next_bookmark_id.item := next_bookmark_id.item + 1
			l_bm.item.id := l_tmp___4
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (bookmarks.item))
				l_bm.item.next := (create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.item)).item.next
				l_bm.item.prev := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.item);
				(create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.item)).item.next := l_bm;
				(l_bm.item.next).item.prev := l_bm;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (bookmarks.item))
				l_break := True
			end
			l_break := False
		end

	create_bookmark (a_title, a_url: CE_POINTER [NATURAL_8]): CE_POINTER [PD_BOOKMARK]
		local
			l_new_bm: CE_POINTER [PD_BOOKMARK]
			l_title_size: NATURAL_32
			l_url_size: NATURAL_32
		do
			l_new_bm := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_shared (default_pointer)
			l_title_size := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_title))) + {NATURAL_32} 1
			l_url_size := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_url))) + {NATURAL_32} 1
			if l_title_size > {NATURAL_32} 2_147_483_647 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bookmark.c"), 193]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			if l_url_size > {NATURAL_32} 2_147_483_647 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bookmark.c"), 194]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			l_new_bm := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 196, (create {PD_BOOKMARK}.make).structure_size.to_natural_32)))
			l_new_bm.item.title := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 198, l_title_size)))
			l_new_bm.item.url := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 199, l_url_size)))
			strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_new_bm.item.title), create {CE_INTEGER_8_POINTER}.make_cast (a_title), l_title_size).do_nothing
			strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_new_bm.item.url), create {CE_INTEGER_8_POINTER}.make_cast (a_url), l_url_size).do_nothing
			Result := l_new_bm
		end

	delete_bookmark_by_id (a_id: INTEGER_32): INTEGER_32
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_return: BOOLEAN
		do
			l_bm := get_bookmark_by_id (a_id)
			if l_bm.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_bm));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_bm.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_bm.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_bm.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_bm.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_bm));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 221, create {CE_VOID_POINTER}.make_cast (l_bm.item.title));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 222, create {CE_VOID_POINTER}.make_cast (l_bm.item.url));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 224, create {CE_VOID_POINTER}.make_cast (l_bm))
				Result := 1
			end
		end

	bookmark_dialog_event_handler (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_ev: CE_POINTER [PD_EVENT]): INTEGER_32
		require
			not a_ev.is_void
		local
			l_di: CE_POINTER [PD_DIALOG_ITEM_DATA]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (a_ev.item.ev).to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 0 then l_pos := -1 + 15
					when 4 then l_pos := -1 + 15
					when 3 then l_pos := -1 + 15
					when 2 then l_pos := -1 + 15
					when 5 then l_pos := -1 + 15
					else l_pos := -1 + 16
					end
				when 1 then -- switch 1, case 1
					l_di := create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (a_dlg.item.selected))
					if a_ev.item.x /= 261 then
						l_pos := -1 + 4 -- skip if block
					end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 4 then -- else:
						if a_ev.item.x /= 258 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (a_ev.item.y).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						a_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (a_dlg.item.selected)), 0)
						a_dlg.item.selected := (a_dlg.item.selected) + 1
						if a_dlg.item.selected >= 5 then
							a_dlg.item.selected := 0
						end
						a_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (a_dlg.item.selected)), 1)
						Result := 0
						l_return := True
				when 7 then -- if done | if done
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 8 then -- if:
						if a_ev.item.x /= 260 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 13 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 11 then -- else:
						if a_ev.item.x /= 258 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if not ((a_ev.item.y).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L___0:
						a_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (a_dlg.item.selected)), 0)
						a_dlg.item.selected := (a_dlg.item.selected) - 1
						if a_dlg.item.selected < 0 then
							a_dlg.item.selected := 4
						end
						a_dlg.item.display_dlg_item (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (a_dlg.item.selected)), 1)
						Result := 0
						l_return := True
				when 14 then -- if done | if done | if done
					if not l_return and then (a_ev.item.x = 263) then
						(create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5))).item.box_sel_move (1)
						a_dlg.item.show_dlg_item_box (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5)))
						Result := 0
						l_return := True
					end
					if not l_return and then (a_ev.item.x = 262) then
						(create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5))).item.box_sel_move (-1)
						a_dlg.item.show_dlg_item_box (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5)))
						Result := 0
						l_return := True
					end
					if not l_return and then (a_ev.item.x = 269) then
						(create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5))).item.box_sel_move ((a_dlg.item.items[5].item).item.gid // 2)
						a_dlg.item.show_dlg_item_box (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5)))
						Result := 0
						l_return := True
					end
					if not l_return and then (a_ev.item.x = 268) then
						(create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5))).item.box_sel_move ((-1 * (a_dlg.item.items[5].item).item.gid) // 2)
						a_dlg.item.show_dlg_item_box (create {CE_CLASS_POINTER [PD_DIALOG_ITEM_DATA]}.make_shared (a_dlg.c_pointer + (create {PD_DIALOG_DATA}.make).offset_of ("items") + (create {PD_DIALOG_ITEM_DATA}.make).structure_size * (5)))
						Result := 0
						l_return := True
					end
					l_pos := -1 + 17 -- switch 1; break
				when 15 then -- switch 1, case 0 | switch 1, case 4 | switch 1, case 3 | switch 1, case 2 | switch 1, case 5
					l_pos := -1 + 17 -- switch 1; break
				when 16 then -- switch 1, default:
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c"));
						(create {P_LINKS_STATIC}).errline.item := 406;
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Unknown event received: %%d")), a_ev.item.ev])
					end
				when 17 then -- switch 1, done:
					if not l_return then
						Result := 1
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_goto_bookmark (a_term: CE_POINTER [PD_TERMINAL]; a_url: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			(create {P_SESSION_STATIC}).goto_url (a_ses, create {CE_NATURAL_8_POINTER}.make_cast (a_url))
		end

	bookmark_menu (a_term: CE_POINTER [PD_TERMINAL]; a_ddd: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_MENU_ITEM]} l_mi.make (<<1>>)

			l_mi.item := (create {P_BFU_STATIC}).new_menu (3)
			if (l_mi.item).is_void then
				l_return := True
			end
			if not l_return then
				l_bm := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast (bookmarks.item.item.next)
				from
				until
					l_bm.is_equal (bookmarks.item)
				loop
					(create {P_BFU_STATIC}).add_to_menu (l_mi, ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 485, l_bm.item.title)), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (menu_goto_bookmark_address), create {CE_VOID_POINTER}.make_cast (l_bm.item.url), 0)
					l_bm := l_bm.item.next
				end
				a_term.item.do_menu (l_mi.item, create {CE_VOID_POINTER}.make_cast (a_ses))
			end
		end

	really_del_bookmark (a_vhop: CE_POINTER [ANY])
		local
			l_hop: CE_POINTER [PD_PUSH_DEL_BUTTON_HOP_STRUCT]
			l_last: INTEGER_32
			l_return: BOOLEAN
		do
			l_hop := create {CE_CLASS_POINTER [PD_PUSH_DEL_BUTTON_HOP_STRUCT]}.make_cast (a_vhop)
			if not (delete_bookmark_by_id (l_hop.item.id)).to_boolean then
				l_return := True
			end
			if not l_return then
				l_last := (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((l_hop.item.box).c_pointer + (create {PD_DLG_DATA_ITEM_DATA_BOX}.make).offset_of ("items"))).item.bookmark_dlg_list_update
				if (l_hop.item.box).item.sel >= l_last - 1 then
					(l_hop.item.box).item.sel := l_last - 1
				end
			end
		end

feature {ANY} -- routine addresses

	bookmark_dialog_event_handler_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bookmark_dialog_event_handler)
		end

	menu_goto_bookmark_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_goto_bookmark)
		end

	really_del_bookmark_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent really_del_bookmark)
		end

end
