class
	P_LINKS_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDLIB_STATIC
	S_SYS_SELECT_STATIC
	LINKS_ASSEMBLER

feature {ANY} -- public attributes

	system_name: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<1_024>>)
		end

	errline: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	errfile: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	line_breax: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	startf: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	eofff: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	ff: CE_STATIC [CE_POINTER [ANY]]
		once ("PROCESS")
			Result.item := create {CE_VOID_POINTER}.make
		end

	put_chars_f: CE_STATIC [CE_ROUTINE]
		once ("PROCESS")
			Result.item := create {CE_ROUTINE}.make
		end

	line_break_f: CE_STATIC [CE_ROUTINE]
		once ("PROCESS")
			Result.item := create {CE_ROUTINE}.make
		end

	special_f: CE_STATIC [CE_ROUTINE]
		once ("PROCESS")
			Result.item := create {CE_ROUTINE}.make
		end

	table_level: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	empty_format: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	last_form_tag: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	last_form_attr: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	last_input_tag: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	d_opt: CE_STATIC [CE_POINTER [PD_DOCUMENT_OPTIONS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_DOCUMENT_OPTIONS]}.make
		end

	last_link_to_move: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	margin: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	dummyarray: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<378>>)
		end

	current_language: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	path_to_exe: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	g_argv: CE_STATIC [CE_POINTER [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_POINTER [NATURAL_8]}.make
		end

	g_argc: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	debug_memacpy (a_f: CE_POINTER [NATURAL_8]; a_l: INTEGER_32; a_src: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_m: CE_POINTER [NATURAL_8]
		do
			l_m := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (a_f, a_l, (a_len + 1).to_natural_32)))
			memcpy (create {CE_VOID_POINTER}.make_cast (l_m), create {CE_VOID_POINTER}.make_cast (a_src), a_len.to_natural_32).do_nothing
			l_m[a_len] := (0).to_natural_8
			Result := l_m
		end

	debug_stracpy (a_f: CE_POINTER [NATURAL_8]; a_l: INTEGER_32; a_src: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_tmp___0: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_8]
		do
			if (not a_src.is_void) then
				if (a_src.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
					l_tmp___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_src)))
				else
					l_tmp___0 := (0).to_natural_32
				end
				l_tmp___2 := (debug_memacpy (a_f, a_l, a_src, l_tmp___0.to_integer_32))
			else
				l_tmp___2 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			end
			Result := l_tmp___2
		end

	add_to_strn (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_a: CE_POINTER [NATURAL_8])
		require
			not a_s.is_void
		local
			l_p: CE_POINTER [NATURAL_8]
			l_l1: NATURAL_32
			l_l2: NATURAL_32
		do
			l_l1 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_s.item)))
			l_l2 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_a)))
			if ((((l_l1).bit_or (l_l2))).bit_or (((l_l1 + l_l2) + {NATURAL_32} 1))) > {NATURAL_32} 2_147_483_647 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("links.h"), 386]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			l_p := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("links.h")), 387, create {CE_VOID_POINTER}.make_cast (a_s.item), (l_l1 + l_l2) + {NATURAL_32} 1)))
			strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p), create {CE_INTEGER_8_POINTER}.make_cast (a_a)).do_nothing
			a_s.item := l_p
		end

	upcase (a_a: NATURAL_8): NATURAL_8
		local
			l_a: NATURAL_8
		do
			l_a := a_a
			if l_a.to_integer_32 >= 97 then
				if l_a.to_integer_32 <= 122 then
					l_a := (l_a.to_integer_32 - 32).to_natural_8
				end
			end
			Result := l_a
		end

	init_str_x (a_file: CE_POINTER [NATURAL_8]; a_line: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
		do
			l_s := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (a_file, a_line, (64).to_natural_32)))
			l_s.item := (0).to_natural_8
			Result := l_s
		end

	add_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_a: CE_POINTER [NATURAL_8])
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_p: CE_POINTER [NATURAL_8]
			l_ll: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ll := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_a)))
					if not (l_ll > {NATURAL_32} 2_147_483_647) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((a_l.item).to_natural_32 + l_ll > {NATURAL_32} 2_147_483_647) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("links.h"), 407]);
							(create {P_KBD_STATIC}).fatal_tty_exit
							exit (4)
						end
				when 5 then -- if done
					l_p := a_s.item
					if (((a_l.item).to_natural_32).bit_and ({NATURAL_32} 4_294_967_232)) /= ((((a_l.item).to_natural_32 + l_ll)).bit_and ({NATURAL_32} 4_294_967_232)) then
						l_tmp___0 := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("links.h")), 410, create {CE_VOID_POINTER}.make_cast (a_s.item), ((((a_l.item).to_natural_32 + l_ll) + {NATURAL_32} 64)).bit_and ({NATURAL_32} 4_294_967_232))))
						a_s.item := l_tmp___0
						l_p := l_tmp___0
					end
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_p + a_l.item)), create {CE_INTEGER_8_POINTER}.make_cast (a_a)).do_nothing
					a_l.item := ((a_l.item).to_natural_32 + l_ll).to_integer_32
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	safe_strncpy (a_dst, a_src: CE_POINTER [NATURAL_8]; a_dst_size: NATURAL_32): CE_POINTER [NATURAL_8]
		do
			strncpy (create {CE_INTEGER_8_POINTER}.make_cast (a_dst), create {CE_INTEGER_8_POINTER}.make_cast (a_src), a_dst_size).do_nothing
			if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_src))) >= a_dst_size then
				a_dst[(a_dst_size - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
			end
			Result := a_dst
		end

	casecmp (a_c1, a_c2: CE_POINTER [NATURAL_8]; a_len: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_tmp: NATURAL_8
			l_return: BOOLEAN
		do
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_len))
			loop
				l_tmp := upcase (a_c1[l_i.to_integer_32])
				if l_tmp.to_integer_32 /= (upcase (a_c2[l_i.to_integer_32])).to_integer_32 then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	snprint (a_s: CE_POINTER [NATURAL_8]; a_n: INTEGER_32; a_num: INTEGER_32): INTEGER_32
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_num: INTEGER_32
			l_q: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_s := a_s
			l_n := a_n
			l_num := a_num
			l_q := (1).to_integer_32
			from
			until
				not (l_q <= l_num // 10)
			loop
				l_q := l_q * (10)
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___0 := l_n
				l_n := l_n - 1
				if l_tmp___0 > 1 then
					if not l_q.to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_tmp := l_s
					l_s := l_s + 1
					l_tmp.item := (l_num // l_q + 48).to_natural_8
					l_num := l_num \\ l_q
					l_q := l_q // (10)
				end
			end
			l_break := False
			l_s.item := (0).to_natural_8
			Result := (l_q.to_boolean).to_integer
		end

	snzprint (a_s: CE_POINTER [NATURAL_8]; a_n: INTEGER_32; a_num: INTEGER_32): INTEGER_32
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_num: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_s := a_s
			l_n := a_n
			l_num := a_num
			if l_n > 1 then
				if l_num < 0 then
					l_tmp := l_s
					l_s := l_s + 1
					l_tmp.item := (('-').code).to_natural_8
					l_num := -l_num
					l_n := l_n - 1
				end
			end
			Result := (snprint (l_s, l_n, l_num))
		end

	add_bytes_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_a: CE_POINTER [NATURAL_8]; a_ll: INTEGER_32)
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_p: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			if a_l.item + a_ll < 0 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("links.h"), 418]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			l_p := a_s.item
			if ((a_l.item).bit_and (-64)) /= (((a_l.item + a_ll)).bit_and (-64)) then
				l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("links.h")), 421, create {CE_VOID_POINTER}.make_cast (a_s.item), ((((a_l.item + a_ll) + 64)).bit_and (-64)).to_natural_32)))
				a_s.item := l_tmp
				l_p := l_tmp
			end
			memcpy (create {CE_VOID_POINTER}.make_cast ((l_p + a_l.item)), create {CE_VOID_POINTER}.make_cast (a_a), a_ll.to_natural_32).do_nothing
			l_tmp___1 := a_l.item + a_ll
			a_l.item := l_tmp___1
			l_p[l_tmp___1] := (0).to_natural_8
		end

	add_chr_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_a: NATURAL_8)
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_p: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			if a_l.item + 1 < 0 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("links.h"), 429]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			l_p := a_s.item
			if ((a_l.item).bit_and (63)) = 63 then
				l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("links.h")), 432, create {CE_VOID_POINTER}.make_cast (a_s.item), ((((a_l.item + 1) + 64)).bit_and (-64)).to_natural_32)))
				a_s.item := l_tmp
				l_p := l_tmp
			end
			l_p[a_l.item] := a_a
			a_l.item := (a_l.item) + 1
			l_p[a_l.item] := (0).to_natural_8
		end

	add_num_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_n: INTEGER_32)
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_a: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_a.make (<<64>>)

			snzprint (l_a, 64, a_n).do_nothing
			add_to_str (a_s, a_l, l_a)
		end

	strtolx (a_c: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_c.is_void
			not a_end.is_void
		local
			l_l: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_c[0]).to_integer_32 = 48 then
				if (upcase (a_c[1])).to_integer_32 = 88 then
					if (a_c[2]).to_boolean then
						l_l := strtol ((create {CE_INTEGER_8_POINTER}.make_cast (a_c) + 2), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_end), 16)
					else
						l_l := strtol (create {CE_INTEGER_8_POINTER}.make_cast (a_c), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_end), 10)
					end
				else
					l_l := strtol (create {CE_INTEGER_8_POINTER}.make_cast (a_c), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_end), 10)
				end
			else
				l_l := strtol (create {CE_INTEGER_8_POINTER}.make_cast (a_c), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_end), 10)
			end
			if (a_end.item).is_void then
				Result := l_l
				l_return := True
			end
			if not l_return then
				if (upcase ((a_end.item).item)).to_integer_32 = 75 then
					a_end.item := (a_end.item) + 1
					if l_l < -2_097_151 then
						Result := (-2_147_483_647)
						l_return := True
					end
					if not l_return and then (l_l > 2_097_151) then
						Result := 2_147_483_647
						l_return := True
					end
					if not l_return then
						Result := (l_l * 1_024)
						l_return := True
					end
				end
			end
			if not l_return then
				if (upcase ((a_end.item).item)).to_integer_32 = 77 then
					a_end.item := (a_end.item) + 1
					if l_l < -2_047 then
						Result := (-2_147_483_647)
						l_return := True
					end
					if not l_return and then (l_l > 2_047) then
						Result := 2_147_483_647
						l_return := True
					end
					if not l_return then
						Result := (l_l * 1_048_576)
						l_return := True
					end
				end
			end
			if not l_return then
				Result := l_l
			end
		end

	isA (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c.to_integer_32 >= 65) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_c.to_integer_32 <= 90 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___1:
						if not (a_c.to_integer_32 >= 97) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_c.to_integer_32 <= 122 then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___0:
						if not (a_c.to_integer_32 >= 48) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_c.to_integer_32 <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if a_c.to_integer_32 = 95 then
							l_tmp := 1
						elseif a_c.to_integer_32 = 45 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 10 then -- if done | if done
					Result := l_tmp
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	xstrcmp (a_s1, a_s2: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_s1.is_void then
				if a_s2.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return and then (a_s1.is_void) then
				Result := (-1)
				l_return := True
			end
			if not l_return and then (a_s2.is_void) then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_s1), create {CE_INTEGER_8_POINTER}.make_cast (a_s2)))
			end
		end

	can_write (a_fd: INTEGER_32): INTEGER_32
		local
			l_fd: CE_ARRAY [INTEGER_32]
			l_fds: CE_ARRAY [SD_FD_SET]
			l_tv: CE_ARRAY [SD_TIMEVAL]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_fd.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_fds.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tv.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1.make (<<1>>)

			l_fd.item := a_fd
			l_tv.item.tv_sec := (0).to_integer_32
			l_tv.item.tv_usec := (0).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm2 (l___d0, l___d1, l_fds)
				l_break := True
			end
			l_break := False
			asm3 (l_fds, l_fd)
			Result := (select2 (l_fd.item + 1, create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_fds, create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_tv))
		end

	can_read (a_fd: INTEGER_32): INTEGER_32
		local
			l_fd: CE_ARRAY [INTEGER_32]
			l_fds: CE_ARRAY [SD_FD_SET]
			l_tv: CE_ARRAY [SD_TIMEVAL]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_fd.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_fds.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tv.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1.make (<<1>>)

			l_fd.item := a_fd
			l_tv.item.tv_sec := (0).to_integer_32
			l_tv.item.tv_usec := (0).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm4 (l___d0, l___d1, l_fds)
				l_break := True
			end
			l_break := False
			asm5 (l_fds, l_fd)
			Result := (select2 (l_fd.item + 1, l_fds, create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_tv))
		end

	getpri (a_c: CE_POINTER [PD_CONNECTION]): INTEGER_32
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < 6))
			loop
				if (a_c.item.pri[l_i]).to_boolean then
					Result := l_i
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				from
				until
					False
				loop
					errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("links.h"))
					errline.item := 785;
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connection has no owner"))])
				end
				Result := 6
			end
		end

	prealloc_truncate (a_x: INTEGER_32; a_y: INTEGER_32)
		do
		end

	end_of_dir (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c.to_integer_32 = 1 then
				l_tmp := 1
			elseif a_c.to_integer_32 = 35 then
				l_tmp := 1
			elseif a_c.to_integer_32 = 59 then
				l_tmp := 1
			elseif a_c.to_integer_32 = 63 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	cmpbeg (a_str, a_b: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_str.is_void
			not a_b.is_void
		local
			l_str: CE_POINTER [NATURAL_8]
			l_b: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_8
			l_break: BOOLEAN
		do
			l_str := a_str
			l_b := a_b
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_str.item).to_boolean then
					l_tmp := upcase (l_str.item)
					if l_tmp.to_integer_32 /= (upcase (l_b.item)).to_integer_32 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_str := l_str + 1
					l_b := l_b + 1
				end
			end
			l_break := False
			Result := ((l_b.item).to_boolean).to_integer
		end

end
