class
	P_SESSION_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_TIME_STATIC

feature {ANY} -- public attributes

	downloads: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (downloads.item), create {CE_VOID_POINTER}.make_cast (downloads.item)])
		end

	sessions: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (sessions.item), create {CE_VOID_POINTER}.make_cast (sessions.item)])
		end

	strerror_buf: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (strerror_buf.item), create {CE_VOID_POINTER}.make_cast (strerror_buf.item)])
		end

	depth: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	stop_recursion: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	are_there_downloads: INTEGER_32
		local
			l_d: INTEGER_32
			l_down___0: CE_POINTER [PD_DOWNLOAD]
		do
			l_d := 0
			l_down___0 := create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (downloads.item.item.next)
			from
			until
				l_down___0.is_equal (downloads.item)
			loop
				if (l_down___0.item.prog).is_void then
					l_d := 1
				end
				l_down___0 := l_down___0.item.next
			end
			Result := l_d
		end

	free_strerror_buf
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (strerror_buf.item))
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (strerror_buf.item.item.next)
			from
			until
				l_a__.is_equal (strerror_buf.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (strerror_buf.item.item.prev)
			from
			until
				l_a__.is_equal (strerror_buf.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(strerror_buf.item.item.next).is_equal (strerror_buf.item)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (strerror_buf.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 27, create {CE_VOID_POINTER}.make_cast (l_a__))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (strerror_buf.item))
		end

	get_err_msg (a_state: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_e: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [PD_STRERROR_VAL]
			l_i: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_e.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_state <= -1_000) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if not (a_state >= 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_i := 0
						from
						until
							not (not (l_return) and then (not ((create {P_SCHED_STATIC}).msg_dsc.item[l_i].msg).is_void))
						loop
							if (create {P_SCHED_STATIC}).msg_dsc.item[l_i].n = a_state then
								Result := ((create {P_SCHED_STATIC}).msg_dsc.item[l_i].msg)
								l_return := True
							end
							if not l_return then
								l_i := l_i + 1
							end
						end
						if l_return then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | unk:
						Result := ((create {P_LINKS_STATIC}).dummyarray.item + 154)
						l_return := True
				when 6 then -- if done | if done
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						l_e := create {CE_NATURAL_8_POINTER}.make_cast ((strerror (-a_state)))
						if (not l_e.is_void) then
							if not (l_e.item).to_boolean then
								l_pos := -1 + 5 -- goto unk
							end
						else
							l_pos := -1 + 5 -- goto unk
						end
				when 8 then
						l_s := create {CE_CLASS_POINTER [PD_STRERROR_VAL]}.make_cast (strerror_buf.item.item.next)
						from
						until
							not (not (l_return) and then (not l_s.is_equal (strerror_buf.item)))
						loop
							if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_s.item.msg)), create {CE_INTEGER_8_POINTER}.make_cast (l_e))).to_boolean then
								Result := (l_s.item.msg)
								l_return := True
							end
							if not l_return then
								l_s := l_s.item.next
							end
						end
				when 9 then -- if done
					if not l_return then
						l_s := create {CE_CLASS_POINTER [PD_STRERROR_VAL]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 43, ((create {PD_STRERROR_VAL}.make).structure_size.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_e)))) + {NATURAL_32} 1)))
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_s.item.msg)), create {CE_INTEGER_8_POINTER}.make_cast (l_e)).do_nothing
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (strerror_buf.item))
							l_s.item.next := (create {CE_CLASS_POINTER [PD_STRERROR_VAL]}.make_cast (strerror_buf.item)).item.next
							l_s.item.prev := create {CE_CLASS_POINTER [PD_STRERROR_VAL]}.make_cast (strerror_buf.item);
							(create {CE_CLASS_POINTER [PD_STRERROR_VAL]}.make_cast (strerror_buf.item)).item.next := l_s;
							(l_s.item.next).item.prev := l_s;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (strerror_buf.item))
							l_break := True
						end
						l_break := False
						Result := (l_s.item.msg)
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_xnum_to_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_n: INTEGER_32)
		require
			not a_s.is_void
			not a_l.is_void
		local
			l_n: INTEGER_32
			l_suff: NATURAL_8
			l_d: INTEGER_32
		do
			l_n := a_n
			l_suff := (0).to_natural_8
			l_d := -1
			if l_n >= 1_000_000_000 then
				l_suff := (('G').code).to_natural_8
				l_d := ((l_n // 100_000_000) \\ 10).to_integer_32
				l_n := l_n // (1_000_000_000)
			elseif l_n >= 1_000_000 then
				l_suff := (('M').code).to_natural_8
				l_d := ((l_n // 100_000) \\ 10).to_integer_32
				l_n := l_n // (1_000_000)
			elseif l_n >= 1_000 then
				l_suff := (('k').code).to_natural_8
				l_d := ((l_n // 100) \\ 10).to_integer_32
				l_n := l_n // (1_000)
			end
			(create {P_LINKS_STATIC}).add_num_to_str (a_s, a_l, l_n)
			if l_n < 10 then
				if l_d /= -1 then
					(create {P_LINKS_STATIC}).add_chr_to_str (a_s, a_l, (('.').code).to_natural_8);
					(create {P_LINKS_STATIC}).add_num_to_str (a_s, a_l, l_d.to_integer_32)
				end
			end
			(create {P_LINKS_STATIC}).add_chr_to_str (a_s, a_l, ((' ').code).to_natural_8)
			if l_suff.to_boolean then
				(create {P_LINKS_STATIC}).add_chr_to_str (a_s, a_l, l_suff)
			end
			(create {P_LINKS_STATIC}).add_chr_to_str (a_s, a_l, (('B').code).to_natural_8)
		end

	print_error_dialog (a_ses: CE_POINTER [PD_SESSION]; a_stat___0: CE_POINTER [PD_STATUS]; a_title: CE_POINTER [NATURAL_8])
		require
			not a_stat___0.is_void
		local
			l_t: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_t := (get_err_msg (a_stat___0.item.state))
			if l_t.is_void then
				l_return := True
			end
			if not l_return then
				(a_ses.item.term).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), a_title, 1, l_t, a_ses, 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
			end
		end

	map_selected (a_term: CE_POINTER [PD_TERMINAL]; a_ld: CE_POINTER [PD_LINK_DEF]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ld.is_void
		do
			goto_url_f (a_ses, a_ld.item.link, a_ld.item.target)
		end

	parse_http_date (a_date: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_date: CE_POINTER [INTEGER_8]
			l_months: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_t: INTEGER_32
			l_tm: CE_ARRAY [SD_TM]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_months.make (<<12>>)
			create {CE_CLASS_ARRAY [SD_TM]} l_tm.make (<<1>>)

			l_date := a_date
			l_months[0] := ce_string ("Jan")
			l_months[1] := ce_string ("Feb")
			l_months[2] := ce_string ("Mar")
			l_months[3] := ce_string ("Apr")
			l_months[4] := ce_string ("May")
			l_months[5] := ce_string ("Jun")
			l_months[6] := ce_string ("Jul")
			l_months[7] := ce_string ("Aug")
			l_months[8] := ce_string ("Sep")
			l_months[9] := ce_string ("Oct")
			l_months[10] := ce_string ("Nov")
			l_months[11] := ce_string ("Dec")
			l_t := (0).to_integer_32
			if l_date.is_void then
				Result := (0).to_integer_32
				l_return := True
			elseif (strlen (l_date)) < {NATURAL_32} 28 then
				Result := (0).to_integer_32
				l_return := True
			end
			if not l_return then
				l_date := l_date + (5)
				l_tm.item.tm_mday := ((((l_date[0]).to_integer_32 - 48) * 10 + (l_date[1]).to_integer_32) - 48)
				l_date := l_date + (3)
				l_tm.item.tm_mon := 0
				from
				until
					not (not (l_break) and then (l_tm.item.tm_mon < 12))
				loop
					l_break := False
					if not (strncmp (l_date, l_months[l_tm.item.tm_mon], (3).to_natural_32)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_tm.item.tm_mon := (l_tm.item.tm_mon) + 1
					end
				end
				l_break := False
				l_date := l_date + (4)
				l_tm.item.tm_year := (((((((l_date[0]).to_integer_32 - 48) * 1_000 + ((l_date[1]).to_integer_32 - 48) * 100) + ((l_date[2]).to_integer_32 - 48) * 10) + (l_date[3]).to_integer_32) - 48) - 1_900)
				l_date := l_date + (5)
				l_tm.item.tm_hour := ((((l_date[0]).to_integer_32 - 48) * 10 + (l_date[1]).to_integer_32) - 48)
				l_date := l_date + (3)
				l_tm.item.tm_min := ((((l_date[0]).to_integer_32 - 48) * 10 + (l_date[1]).to_integer_32) - 48)
				l_date := l_date + (3)
				l_tm.item.tm_sec := ((((l_date[0]).to_integer_32 - 48) * 10 + (l_date[1]).to_integer_32) - 48)
				l_t := mktime (l_tm)
				if l_t = -1 then
					Result := (0).to_integer_32
				else
					Result := l_t
				end
			end
		end

	subst_file (a_prog, a_file: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_prog.is_void
		local
			l_prog: CE_POINTER [NATURAL_8]
			l_n: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_p: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_n.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			l_prog := a_prog
			l_n.item := ((create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 678))
			l_l.item := 0
			from
			until
				not (not (l_return) and then ((l_prog.item).to_boolean))
			loop
				l_p := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_prog[l_p]).to_boolean then
						if (l_prog[l_p]).to_integer_32 = 37 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_p := l_p + 1
					end
				end
				l_break := False;
				(create {P_LINKS_STATIC}).add_bytes_to_str (l_n, l_l, l_prog, l_p)
				l_prog := l_prog + l_p
				if (l_prog.item).to_integer_32 = 37 then
					(create {P_LINKS_STATIC}).add_to_str (l_n, l_l, a_file)
					l_prog := l_prog + 1
				end
			end
			Result := (l_n.item)
		end

	request_frameset (a_ses: CE_POINTER [PD_SESSION]; a_fd: CE_POINTER [PD_FRAMESET_DESC])
		local
			l_i: INTEGER_32
		do
			depth.item := depth.item + 1
			if depth.item <= 5 then
				l_i := 0
				from
				until
					not (l_i < a_fd.item.n)
				loop
					if (not (a_fd.item.f[l_i].subframe).is_void) then
						request_frameset (a_ses, a_fd.item.f[l_i].subframe)
					elseif (not (a_fd.item.f[l_i].name).is_void) then
						a_ses.item.request_frame (a_fd.item.f[l_i].name, a_fd.item.f[l_i].url)
					end
					l_i := l_i + 1
				end
			end
			depth.item := depth.item - 1
		end

	load_frames (a_ses: CE_POINTER [PD_SESSION]; a_fd: CE_POINTER [PD_F_DATA_C])
		require
			not a_fd.is_void
		local
			l_ff___0: CE_POINTER [PD_F_DATA]
			l_return: BOOLEAN
		do
			l_ff___0 := a_fd.item.f_data
			if l_ff___0.is_void then
				l_return := True
			elseif not (l_ff___0.item.frame).to_boolean then
				l_return := True
			end
			if not l_return then
				request_frameset (a_ses, l_ff___0.item.frame_desc)
			end
		end

	end_load (a_stat___0: CE_POINTER [PD_STATUS]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_stat___0: CE_ARRAY [CE_POINTER [PD_STATUS]]
			l_d: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_STATUS]} l_stat___0.make (<<1>>)

			l_stat___0.item := a_stat___0
			if not (a_ses.item.wtd).to_boolean then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c"));
					(create {P_LINKS_STATIC}).errline.item := 1_086;
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("end_load: !ses->wtd"))])
				end
				l_return := True
			end
			if not l_return then
				l_d := a_ses.item.do_move (l_stat___0)
				if (l_stat___0.item).is_void then
					l_return := True
				end
			end
			if not l_return then
				if l_d = 1 then
					l_stat___0.item.item.end2 := ((create {PD_STATUS_STATIC}).doc_end_load_address)
					a_ses.item.display_timer2
				end
				if l_stat___0.item.item.state < 0 then
					if l_d /= 2 then
						if (a_ses.item.wtd).to_boolean then
							a_ses.item.free_wtd
						end
					end
					if l_d = 1 then
						(l_stat___0.item).item.doc_end_load (a_ses)
					end
				end
				if l_stat___0.item.item.state < 0 then
					if l_stat___0.item.item.state /= -1_000 then
						if l_d /= 2 then
							if l_d /= 1 then
								print_error_dialog (a_ses, l_stat___0.item, (create {P_LINKS_STATIC}).dummyarray.item + 186)
								if not l_d.to_boolean then
									a_ses.item.reload (1)
								end
							end
						end
					end
				end
				a_ses.item.print_screen_status
			end
		end

	process_file_requests (a_ses: CE_POINTER [PD_SESSION])
		local
			l_ftl: CE_POINTER [PD_FILE_TO_LOAD]
			l_more: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if stop_recursion.item.to_boolean then
				l_return := True
			end
			if not l_return then
				stop_recursion.item := 1
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_more := 0
					l_ftl := create {CE_CLASS_POINTER [PD_FILE_TO_LOAD]}.make_cast (a_ses.item.more_files.next)
					from
					until
						l_ftl.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("more_files")))
					loop
						if not (l_ftl.item.req_sent).to_boolean then
							l_ftl.item.req_sent := 1;
							(create {P_SCHED_STATIC}).load_url (l_ftl.item.url, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (l_ftl.c_pointer + (create {PD_FILE_TO_LOAD}.make).offset_of ("stat")), l_ftl.item.pri, 1).do_nothing
							l_more := 1
						end
						l_ftl := l_ftl.item.next
					end
					if not l_more.to_boolean then
						l_break := True
					end
				end
				l_break := False
				stop_recursion.item := 0
			end
		end

	create_session_info (a_cp: INTEGER_32; a_url: CE_POINTER [NATURAL_8]; a_ll: CE_POINTER [INTEGER_32]): CE_POINTER [ANY]
		require
			not a_ll.is_void
		local
			l_l: INTEGER_32
			l_i: CE_POINTER [INTEGER_32]
		do
			l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_url))).to_integer_32
			a_ll.item := ({NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32 + l_l.to_natural_32).to_integer_32
			l_i := create {CE_INTEGER_32_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_238, {NATURAL_32} 2 * {PLATFORM}.Integer_32_bytes.to_natural_32 + l_l.to_natural_32)))
			l_i[0] := a_cp
			l_i[1] := l_l
			memcpy (create {CE_VOID_POINTER}.make_cast ((l_i + 2)), create {CE_VOID_POINTER}.make_cast (a_url), l_l.to_natural_32).do_nothing
			Result := (create {CE_VOID_POINTER}.make_cast (l_i))
		end

	hx (a_a: INTEGER_32): NATURAL_8
		local
			l_tmp: INTEGER_32
		do
			if a_a >= 10 then
				l_tmp := (a_a + 65) - 10
			else
				l_tmp := a_a + 48
			end
			Result := l_tmp.to_natural_8
		end

	encode_url (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_url.is_void
		local
			l_url: CE_POINTER [NATURAL_8]
			l_u: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_tmp___0: NATURAL_8
			l_tmp___1: NATURAL_8
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_u.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			l_url := a_url
			l_u.item := ((create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_260))
			l_l.item := 0
			from
			until
				not ((l_url.item).to_boolean)
			loop
				if ((create {P_OS_DEP_STATIC}).is_safe_in_shell (l_url.item)).to_boolean then
					if (l_url.item).to_integer_32 /= 43 then
						(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, l_url.item)
					else
						(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, (('+').code).to_natural_8)
						l_tmp___0 := hx (((l_url.item).to_integer_32).bit_shift_right (4));
						(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, l_tmp___0)
						l_tmp___1 := hx (((l_url.item).to_integer_32).bit_and (15));
						(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, l_tmp___1)
					end
				else
					(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, (('+').code).to_natural_8)
					l_tmp___0 := hx (((l_url.item).to_integer_32).bit_shift_right (4));
					(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, l_tmp___0)
					l_tmp___1 := hx (((l_url.item).to_integer_32).bit_and (15));
					(create {P_LINKS_STATIC}).add_chr_to_str (l_u, l_l, l_tmp___1)
				end
				l_url := l_url + 1
			end
			Result := (l_u.item)
		end

	destroy_all_sessions
		do
		end

	abort_all_downloads
		do
			from
			until
				((downloads.item.item.next).is_equal (downloads.item))
			loop
				(create {CE_CLASS_POINTER [PD_DOWNLOAD]}.make_cast (downloads.item.item.next)).item.abort_download
			end
		end

	goto_url_w (a_ses: CE_POINTER [PD_SESSION]; a_url, a_target: CE_POINTER [NATURAL_8]; a_wtd: INTEGER_32)
		local
			l_u: CE_POINTER [NATURAL_8]
			l_pos___0: CE_POINTER [NATURAL_8]
			l_fn: CE_ROUTINE
			l_stat___0: CE_ARRAY [PD_STATUS]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_STATUS]} l_stat___0.make (<<1>>)

			l_fn := (create {P_URL_STATIC}).get_external_protocol_function (a_url)
			if (not l_fn.is_void) then
				l_fn.call ([a_ses, a_url])
				l_return := True
			end
			if not l_return then
				a_ses.item.reloadlevel := 1
				l_u := (create {P_URL_STATIC}).translate_url (a_url, (a_ses.item.term).item.cwd)
				if l_u.is_void then
					l_stat___0.item.next := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer)
					l_stat___0.item.prev := create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer)
					l_stat___0.item.c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (default_pointer)
					l_stat___0.item.ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
					l_stat___0.item.state := -1_009
					l_stat___0.item.prev_error := 5
					l_stat___0.item.pri := 0
					l_stat___0.item.end2 := create {CE_ROUTINE}.make_shared (default_pointer)
					l_stat___0.item.data := create {CE_VOID_POINTER}.make_shared (default_pointer)
					l_stat___0.item.prg := create {CE_CLASS_POINTER [PD_REMAINING_INFO]}.make_shared (default_pointer)
					print_error_dialog (a_ses, l_stat___0, (create {P_LINKS_STATIC}).dummyarray.item + 186)
					l_return := True
				end
			end
			if not l_return then
				l_pos___0 := (create {P_URL_STATIC}).extract_position (l_u)
				if a_ses.item.wtd = a_wtd then
					if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_ses.item.loading_url), create {CE_INTEGER_8_POINTER}.make_cast (l_u))).to_boolean then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_441, create {CE_VOID_POINTER}.make_cast (l_u))
						if (not (a_ses.item.goto_position).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 1_442, create {CE_VOID_POINTER}.make_cast (a_ses.item.goto_position))
						end
						a_ses.item.goto_position := l_pos___0
						l_return := True
					end
				end
			end
			if not l_return then
				a_ses.item.abort_loading
				a_ses.item.redirect_cnt := 0
				a_ses.item.ses_goto (l_u, a_target, 0, 1, a_wtd, l_pos___0, end_load_address, 0)
			end
		end

	goto_url_f (a_ses: CE_POINTER [PD_SESSION]; a_url, a_target: CE_POINTER [NATURAL_8])
		do
			goto_url_w (a_ses, a_url, a_target, 1)
		end

	goto_url (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8])
		do
			goto_url_w (a_ses, a_url, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 1)
		end

feature {ANY} -- routine addresses

	map_selected_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent map_selected)
		end

	end_load_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent end_load)
		end

	goto_url_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent goto_url)
		end

end
