class
	P_TERMINAL_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_BITS_ERRNO_STATIC
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	terminals: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (terminals.item), create {CE_VOID_POINTER}.make_cast (terminals.item)])
		end

	term_specs: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (term_specs.item), create {CE_VOID_POINTER}.make_cast (term_specs.item)])
		end

	dumb_term: CE_STATIC [CE_ARRAY [PD_TERM_SPEC]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_TERM_SPEC]}.make_initialized (<<
					create {PD_TERM_SPEC}.make_initialized ([create {CE_CLASS_POINTER [PD_TERM_SPEC]}.make_shared (default_pointer), create {CE_CLASS_POINTER [PD_TERM_SPEC]}.make_shared (default_pointer), create {CE_NATURAL_8_ARRAY}.make_initialized (<<
							(('%/0/').code).to_natural_8
						>>), 0, 1, 0, 0, 0, 0])
				>>)
		end

	frame_dumb: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, (('|').code).to_natural_8,
					(('|').code).to_natural_8, (('|').code).to_natural_8, (('|').code).to_natural_8, (('+').code).to_natural_8,
					(('+').code).to_natural_8, (('|').code).to_natural_8, (('|').code).to_natural_8, (('+').code).to_natural_8,
					(('+').code).to_natural_8, (('+').code).to_natural_8, (('+').code).to_natural_8, (('+').code).to_natural_8,
					(('+').code).to_natural_8, (('-').code).to_natural_8, (('-').code).to_natural_8, (('|').code).to_natural_8,
					(('-').code).to_natural_8, (('+').code).to_natural_8, (('|').code).to_natural_8, (('|').code).to_natural_8,
					(('+').code).to_natural_8, (('+').code).to_natural_8, (('-').code).to_natural_8, (('-').code).to_natural_8,
					(('|').code).to_natural_8, (('-').code).to_natural_8, (('+').code).to_natural_8, (('-').code).to_natural_8,
					(('-').code).to_natural_8, (('-').code).to_natural_8, (('-').code).to_natural_8, (('+').code).to_natural_8,
					(('+').code).to_natural_8, (('+').code).to_natural_8, (('+').code).to_natural_8, (('+').code).to_natural_8,
					(('+').code).to_natural_8, (('+').code).to_natural_8, (('+').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8
				>>)
		end

feature {ANY} -- public routines

	hard_write (a_fd: INTEGER_32; a_p: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_p: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_w: INTEGER_32
			l_t: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_p := a_p
			l_l := a_l
			l_w := 1
			l_t := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_continue := False
				if l_l > 0 then
					if not l_w.to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break or l_continue) then
					l_w := write (a_fd, create {CE_VOID_POINTER}.make_cast (l_p), l_l.to_natural_32)
					if l_w < 0 then
						if (errno_location).item = 4 then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							Result := (-1)
							l_return := True
						end
					end
				end
				if not (l_return or l_break or l_continue) then
					l_t := l_t + l_w
					l_p := l_p + l_w
					l_l := l_l - l_w
				end
			end
			if not l_return then
				l_break := False
				l_continue := False
				Result := l_t
			end
		end

	get_cwd: CE_POINTER [NATURAL_8]
		local
			l_bufsize: INTEGER_32
			l_buf___0: CE_POINTER [NATURAL_8]
			l_return, l_continue: BOOLEAN
		do
			l_bufsize := 128
			from
			until
				(l_return)
			loop
				l_continue := False
				l_buf___0 := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 41, l_bufsize.to_natural_32)))
				if (not (getcwd (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___0), l_bufsize.to_natural_32)).is_void) then
					Result := l_buf___0
					l_return := True
				end
				if not l_return then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 43, create {CE_VOID_POINTER}.make_cast (l_buf___0))
					if (errno_location).item = 4 then
						l_continue := True
					end
					if not (l_return or l_continue) then
						if (errno_location).item /= 34 then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							if l_bufsize.to_natural_32 > {NATURAL_32} 2_147_483_519 then
								from
								until
									False
								loop
									(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("terminal.c"), 46]);
									(create {P_KBD_STATIC}).fatal_tty_exit
									exit (4)
								end
							end
							l_bufsize := l_bufsize + (128)
						end
					end
				end
			end
			if not l_return then
				l_continue := False
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	cls_redraw_all_terminals
		local
			l_term: CE_POINTER [PD_TERMINAL]
		do
			l_term := create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast (terminals.item.item.next)
			from
			until
				l_term.is_equal (terminals.item)
			loop
				l_term.item.redraw_terminal_cls
				l_term := l_term.item.next
			end
		end

	redraw_from_window (a_win: CE_POINTER [PD_WINDOW])
		require
			not a_win.is_void
		local
			l_win: CE_POINTER [PD_WINDOW]
			l_term: CE_POINTER [PD_TERMINAL]
			l_end: CE_POINTER [PD_WINDOW]
			l_ev: CE_ARRAY [PD_EVENT]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_win := a_win
			l_term := l_win.item.term
			l_end := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))
			l_ev.item.ev := 3
			l_ev.item.x := 0
			l_ev.item.y := 0
			l_ev.item.b := 0
			l_ev.item.x := (l_term.item.x).to_integer_32
			l_ev.item.y := (l_term.item.y).to_integer_32
			if (l_term.item.redrawing).to_boolean then
				l_return := True
			end
			if not l_return then
				l_term.item.redrawing := 1
				l_win := l_win.item.prev
				from
				until
					l_win.is_equal (l_end)
				loop
					(l_win.item.handler).call ([l_win, l_ev, 0])
					l_win := l_win.item.prev
				end
				l_term.item.redrawing := 0
			end
		end

	free_term_specs
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (term_specs.item))
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (term_specs.item.item.next)
			from
			until
				l_a__.is_equal (term_specs.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (term_specs.item.item.prev)
			from
			until
				l_a__.is_equal (term_specs.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(term_specs.item.item.next).is_equal (term_specs.item)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (term_specs.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 269, create {CE_VOID_POINTER}.make_cast (l_a__))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (term_specs.item))
		end

	get_term_spec (a_term: CE_POINTER [NATURAL_8]): CE_POINTER [PD_TERM_SPEC]
		local
			l_t: CE_POINTER [PD_TERM_SPEC]
			l_return: BOOLEAN
		do
			l_t := create {CE_CLASS_POINTER [PD_TERM_SPEC]}.make_cast (term_specs.item.item.next)
			from
			until
				not (not (l_return) and then (not l_t.is_equal (term_specs.item)))
			loop
				if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_t.item.term)), create {CE_INTEGER_8_POINTER}.make_cast (a_term))).to_boolean then
					Result := l_t
					l_return := True
				end
				if not l_return then
					l_t := l_t.item.next
				end
			end
			if not l_return then
				Result := dumb_term.item
			end
		end

	new_term_spec (a_term: CE_POINTER [NATURAL_8]): CE_POINTER [PD_TERM_SPEC]
		local
			l_t: CE_POINTER [PD_TERM_SPEC]
			l_return, l_break: BOOLEAN
		do
			l_t := create {CE_CLASS_POINTER [PD_TERM_SPEC]}.make_cast (term_specs.item.item.next)
			from
			until
				not (not (l_return) and then (not l_t.is_equal (term_specs.item)))
			loop
				if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_t.item.term)), create {CE_INTEGER_8_POINTER}.make_cast (a_term))).to_boolean then
					Result := l_t
					l_return := True
				end
				if not l_return then
					l_t := l_t.item.next
				end
			end
			if not l_return then
				l_t := create {CE_CLASS_POINTER [PD_TERM_SPEC]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 287, (create {PD_TERM_SPEC}.make).structure_size.to_natural_32)))
				memcpy (create {CE_VOID_POINTER}.make_cast (l_t), create {CE_VOID_POINTER}.make_cast (dumb_term.item), (create {PD_TERM_SPEC}.make).structure_size.to_natural_32).do_nothing
				if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_term))) < {NATURAL_32} 32 then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_t.item.term)), create {CE_INTEGER_8_POINTER}.make_cast (a_term)).do_nothing
				else
					memcpy (create {CE_VOID_POINTER}.make_cast ((l_t.item.term)), create {CE_VOID_POINTER}.make_cast (a_term), (31).to_natural_32).do_nothing
					l_t.item.term[31] := (0).to_natural_8
				end
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (term_specs.item))
					l_t.item.next := (create {CE_CLASS_POINTER [PD_TERM_SPEC]}.make_cast (term_specs.item)).item.next
					l_t.item.prev := create {CE_CLASS_POINTER [PD_TERM_SPEC]}.make_cast (term_specs.item);
					(create {CE_CLASS_POINTER [PD_TERM_SPEC]}.make_cast (term_specs.item)).item.next := l_t;
					(l_t.item.next).item.prev := l_t;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (term_specs.item))
					l_break := True
				end
				l_break := False
				sync_term_specs
				Result := l_t
			end
		end

	sync_term_specs
		local
			l_term: CE_POINTER [PD_TERMINAL]
		do
			l_term := create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast (terminals.item.item.next)
			from
			until
				l_term.is_equal (terminals.item)
			loop
				l_term.item.spec := get_term_spec (l_term.item.term)
				l_term := l_term.item.next
			end
		end

	init_term (a_fdin, a_fdout: INTEGER_32; a_root_window: CE_ROUTINE): CE_POINTER [PD_TERMINAL]
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_win: CE_POINTER [PD_WINDOW]
			l_break: BOOLEAN
		do
			l_term := create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 306, (create {PD_TERMINAL}.make).structure_size.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (l_term), 0, (create {PD_TERMINAL}.make).structure_size.to_natural_32).do_nothing
			l_term.item.fdin := a_fdin
			l_term.item.fdout := a_fdout
			l_term.item.master := (l_term.item.fdout = ((create {P_OS_DEP_STATIC}).get_output_handle)).to_integer
			l_term.item.lcx := -1
			l_term.item.lcy := -1
			l_term.item.dirty := 1
			l_term.item.redrawing := 0
			l_term.item.blocked := -1
			l_term.item.screen := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer + -1)
			l_term.item.last_screen := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer + -1)
			l_term.item.spec := dumb_term.item
			l_term.item.term[0] := (0).to_natural_8
			l_term.item.cwd[0] := (0).to_natural_8
			l_term.item.input_queue := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer + -1)
			l_term.item.qlen := 0;
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
			l_term.item.windows.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))
			l_term.item.windows.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))));
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
			l_win := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 328, (create {PD_WINDOW}.make).structure_size.to_natural_32)))
			l_win.item.handler := a_root_window
			l_win.item.data := create {CE_VOID_POINTER}.make_shared (default_pointer)
			l_win.item.term := l_term
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
				l_win.item.next := (create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.next
				l_win.item.prev := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))));
				(create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows"))))).item.next := l_win;
				(l_win.item.next).item.prev := l_win;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_term.c_pointer + (create {PD_TERMINAL}.make).offset_of ("windows")))))
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (terminals.item))
				l_term.item.next := (create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast (terminals.item)).item.next
				l_term.item.prev := create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast (terminals.item);
				(create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast (terminals.item)).item.next := l_term;
				(l_term.item.next).item.prev := l_term;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (terminals.item))
				l_break := True
			end
			l_break := False;
			(create {P_SELECT_STATIC}).set_handlers (a_fdin, ((create {PD_TERMINAL_STATIC}).in_term_address), create {CE_ROUTINE}.make_shared (default_pointer), ((create {PD_TERMINAL_STATIC}).destroy_terminal_address), create {CE_VOID_POINTER}.make_cast (l_term))
			Result := l_term
		end

	redraw_all_terminals
		local
			l_term: CE_POINTER [PD_TERMINAL]
		do
			l_term := create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast (terminals.item.item.next)
			from
			until
				l_term.is_equal (terminals.item)
			loop
				l_term.item.redraw_screen
				l_term := l_term.item.next
			end
		end

	destroy_all_terminals
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				l_term := create {CE_CLASS_POINTER [PD_TERMINAL]}.make_cast (terminals.item.item.next)
				if l_term.is_equal (terminals.item) then
					l_break := True
				end
				if not (l_break) then
					l_term.item.destroy_terminal
				end
			end
			l_break := False
		end

	print_text (a_t: CE_POINTER [PD_TERMINAL]; a_x, a_y, a_l: INTEGER_32; a_text: CE_POINTER [NATURAL_8]; a_c: NATURAL_32)
		local
			l_x: INTEGER_32
			l_l: INTEGER_32
			l_text: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_break: BOOLEAN
		do
			l_x := a_x
			l_l := a_l
			l_text := a_text
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := l_l
				l_l := l_l - 1
				if l_tmp.to_boolean then
					if not (l_text.item).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					a_t.item.set_char (l_x, a_y, (l_text.item).to_natural_32 + a_c)
					l_text := l_text + 1
					l_x := l_x + 1
				end
			end
			l_break := False
		end

	exec_thread (a_path: CE_POINTER [NATURAL_8]; a_p: INTEGER_32)
		require
			not a_path.is_void
		do
			if (a_path[0]).to_integer_32 = 2 then
				setpgid (0, 0).do_nothing
			end
			(create {P_OS_DEP_STATIC}).exe (create {CE_INTEGER_8_POINTER}.make_cast ((a_path + 1))).do_nothing
			if (a_path[(({NATURAL_32} 1 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((a_path + 1))))) + {NATURAL_32} 1).to_integer_32]).to_boolean then
				unlink (create {CE_INTEGER_8_POINTER}.make_cast ((((a_path + 1) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((a_path + 1)))).to_integer_32) + 1))).do_nothing
			end
		end

	close_handle (a_p: CE_POINTER [ANY])
		local
			l_h: INTEGER_32
		do
			l_h := (a_p.c_pointer.to_integer_32).to_integer_32
			close (l_h).do_nothing;
			(create {P_SELECT_STATIC}).set_handlers (l_h, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
		end

	exec_on_terminal (a_term: CE_POINTER [PD_TERMINAL]; a_path, a_delete: CE_POINTER [NATURAL_8]; a_fg: INTEGER_32)
		local
			l_path: CE_POINTER [NATURAL_8]
			l_blockh: INTEGER_32
			l_param: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___4: NATURAL_32
			l_data: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_tmp___10: NATURAL_32
			l_return: BOOLEAN
		do
			l_path := a_path
			if (not l_path.is_void) then
				if not (l_path.item).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if l_path.is_void then
					l_path := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				end
				if (a_term.item.master).to_boolean then
					if not (l_path.item).to_boolean then
						(create {P_KBD_STATIC}).dispatch_special (a_delete)
					else
						if ((create {P_KBD_STATIC}).is_blocked).to_boolean then
							if a_fg.to_boolean then
								unlink (create {CE_INTEGER_8_POINTER}.make_cast (a_delete)).do_nothing
								l_return := True
							end
						end
						if not l_return then
							l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path))
							l_param := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 722, (l_tmp___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_delete)))) + {NATURAL_32} 3)))
							l_param[0] := a_fg.to_natural_8
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_param + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_path)).do_nothing
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((((l_param + 1) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path))).to_integer_32) + 1)), create {CE_INTEGER_8_POINTER}.make_cast (a_delete)).do_nothing
							if a_fg = 1 then
								(create {P_KBD_STATIC}).block_itrm (a_term.item.fdin)
							end
							l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path))
							l_blockh := (create {P_OS_DEP_STATIC}).start_thread ((exec_thread_address), create {CE_VOID_POINTER}.make_cast (l_param), ((l_tmp___4 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_delete)))) + {NATURAL_32} 3).to_integer_32)
							if l_blockh = -1 then
								if a_fg = 1 then
									(create {P_KBD_STATIC}).unblock_itrm (a_term.item.fdin).do_nothing
								end
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 729, create {CE_VOID_POINTER}.make_cast (l_param))
								l_return := True
							end
						end
						if not l_return then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 732, create {CE_VOID_POINTER}.make_cast (l_param))
							if a_fg = 1 then
								a_term.item.blocked := l_blockh;
								(create {P_SELECT_STATIC}).set_handlers (l_blockh, ((create {PD_TERMINAL_STATIC}).unblock_terminal_address), create {CE_ROUTINE}.make_shared (default_pointer), ((create {PD_TERMINAL_STATIC}).unblock_terminal_address), create {CE_VOID_POINTER}.make_cast (a_term));
								(create {P_SELECT_STATIC}).set_handlers (a_term.item.fdin, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), ((create {PD_TERMINAL_STATIC}).destroy_terminal_address), create {CE_VOID_POINTER}.make_cast (a_term))
							else
								(create {P_SELECT_STATIC}).set_handlers (l_blockh, close_handle_address, create {CE_ROUTINE}.make_shared (default_pointer), close_handle_address, create {CE_VOID_POINTER}.make_shared (default_pointer + l_blockh))
							end
						end
					end
				else
					l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path))
					l_data := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 744, (l_tmp___6 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_delete)))) + {NATURAL_32} 4)))
					l_data[0] := (0).to_natural_8
					l_data[1] := a_fg.to_natural_8
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_data + 2)), create {CE_INTEGER_8_POINTER}.make_cast (l_path)).do_nothing
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((l_data + 3) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path))).to_integer_32)), create {CE_INTEGER_8_POINTER}.make_cast (a_delete)).do_nothing
					l_tmp___10 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_path))
					hard_write (a_term.item.fdout, l_data, ((l_tmp___10 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_delete)))) + {NATURAL_32} 4).to_integer_32).do_nothing;
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 750, create {CE_VOID_POINTER}.make_cast (l_data))
				end
			end
			if not l_return then
			end
		end

	do_terminal_function (a_term: CE_POINTER [PD_TERMINAL]; a_code: NATURAL_8; a_data: CE_POINTER [NATURAL_8])
		local
			l_x_data: CE_POINTER [NATURAL_8]
		do
			l_x_data := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 763, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_data))) + {NATURAL_32} 2)))
			l_x_data[0] := a_code
			strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_x_data + 1)), create {CE_INTEGER_8_POINTER}.make_cast (a_data)).do_nothing
			exec_on_terminal (a_term, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_x_data, 0);
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("terminal.c")), 767, create {CE_VOID_POINTER}.make_cast (l_x_data))
		end

feature {ANY} -- routine addresses

	exec_thread_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent exec_thread)
		end

	close_handle_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent close_handle)
		end

end
