class
	P_URL_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	protocols: CE_STATIC [CE_ARRAY [PD_PROTOCOLS]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_PROTOCOLS]}.make_initialized (<<
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file")), 0, (create {PD_CONNECTION_STATIC}).file_func_address, create {CE_ROUTINE}.make_shared (default_pointer), 1, 1, 0, 0]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("https")), 443, (create {PD_CONNECTION_STATIC}).https_func_address, create {CE_ROUTINE}.make_shared (default_pointer), 0, 1, 1, 1]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http")), 80, (create {PD_CONNECTION_STATIC}).http_func_address, create {CE_ROUTINE}.make_shared (default_pointer), 0, 1, 1, 1]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("proxy")), 3_128, (create {PD_CONNECTION_STATIC}).proxy_func_address, create {CE_ROUTINE}.make_shared (default_pointer), 0, 1, 1, 1]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp")), 21, (create {PD_CONNECTION_STATIC}).ftp_func_address, create {CE_ROUTINE}.make_shared (default_pointer), 0, 1, 1, 0]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("finger")), 79, (create {PD_CONNECTION_STATIC}).finger_func_address, create {CE_ROUTINE}.make_shared (default_pointer), 0, 1, 1, 0]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smb")), 139, (create {PD_CONNECTION_STATIC}).smb_func_address, create {CE_ROUTINE}.make_shared (default_pointer), 0, 1, 1, 0]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mailto")), 0, create {CE_ROUTINE}.make_shared (default_pointer), (create {P_MAILTO_STATIC}).mailto_func_address, 0, 0, 0, 0]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("telnet")), 0, create {CE_ROUTINE}.make_shared (default_pointer), (create {P_MAILTO_STATIC}).telnet_func_address, 0, 0, 0, 0]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tn3270")), 0, create {CE_ROUTINE}.make_shared (default_pointer), (create {P_MAILTO_STATIC}).tn3270_func_address, 0, 0, 0, 0]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mms")), 0, create {CE_ROUTINE}.make_shared (default_pointer), (create {PD_SESSION_STATIC}).mms_func_address, 1, 0, 1, 0]),
					create {PD_PROTOCOLS}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0, 0, 0])
				>>)
		end

feature {ANY} -- public routines

	check_protocol (a_p: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (not (protocols.item[l_i].prot).is_void))
			loop
				if not ((create {P_LINKS_STATIC}).casecmp (protocols.item[l_i].prot, a_p, a_l.to_natural_32)).to_boolean then
					if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (protocols.item[l_i].prot))).to_integer_32 = a_l then
						Result := l_i
						l_return := True
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	get_prot_info (a_prot: CE_POINTER [NATURAL_8]; a_port: CE_POINTER [INTEGER_32]; a_func, a_nc_func: CE_POINTER [CE_ROUTINE]; a_allow_post: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (not (protocols.item[l_i].prot).is_void))
			loop
				if not (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (protocols.item[l_i].prot), create {CE_INTEGER_8_POINTER}.make_cast (a_prot))).to_boolean then
					if (not a_port.is_void) then
						a_port.item := protocols.item[l_i].port
					end
					if (not a_func.is_void) then
						a_func.item := protocols.item[l_i].func
					end
					if (not a_nc_func.is_void) then
						a_nc_func.item := protocols.item[l_i].nc_func
					end
					if (not a_allow_post.is_void) then
						a_allow_post.item := protocols.item[l_i].allow_post
					end
					Result := 0
					l_return := True
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	parse_url (a_url: CE_POINTER [NATURAL_8]; a_prlen: CE_POINTER [INTEGER_32]; a_user: CE_POINTER [CE_POINTER [NATURAL_8]]; a_uslen: CE_POINTER [INTEGER_32]; a_pass: CE_POINTER [CE_POINTER [NATURAL_8]]; a_palen: CE_POINTER [INTEGER_32]; a_host: CE_POINTER [CE_POINTER [NATURAL_8]]; a_holen: CE_POINTER [INTEGER_32]; a_port: CE_POINTER [CE_POINTER [NATURAL_8]]; a_polen: CE_POINTER [INTEGER_32]; a_data: CE_POINTER [CE_POINTER [NATURAL_8]]; a_dalen: CE_POINTER [INTEGER_32]; a_post: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_p: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_p_c: CE_ARRAY [NATURAL_8]
			l_a: INTEGER_32
			l_pp: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
			l_pp___0: CE_POINTER [NATURAL_8]
			l_cc: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_p_c.make (<<2>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not a_prlen.is_void) then
						a_prlen.item := 0
					end
					if (not a_user.is_void) then
						a_user.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if (not a_uslen.is_void) then
						a_uslen.item := 0
					end
					if (not a_pass.is_void) then
						a_pass.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if (not a_palen.is_void) then
						a_palen.item := 0
					end
					if (not a_host.is_void) then
						a_host.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if (not a_holen.is_void) then
						a_holen.item := 0
					end
					if (not a_port.is_void) then
						a_port.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if (not a_polen.is_void) then
						a_polen.item := 0
					end
					if (not a_data.is_void) then
						a_data.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if (not a_dalen.is_void) then
						a_dalen.item := 0
					end
					if (not a_post.is_void) then
						a_post.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if a_url.is_void then
						Result := (-1)
						l_return := True
					else
						l_p := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_url), (':').code)))
						if l_p.is_void then
							Result := (-1)
							l_return := True
						end
					end
					if not l_return then
						if (not a_prlen.is_void) then
							a_prlen.item := l_p.distance (a_url)
						end
						l_a := check_protocol (a_url, l_p.distance (a_url))
						if l_a = -1 then
							Result := (-1)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (l_p[1]).to_integer_32 = 47 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_p[2]).to_integer_32 = 47 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (protocols.item[l_a].need_slashes).to_boolean then
							Result := (-1)
							l_return := True
						end
						if not l_return then
							l_p := l_p - (2)
						end
				when 6 then -- if done | if done
					if not l_return and then ((protocols.item[l_a].free_syntax).to_boolean) then
						if (not a_data.is_void) then
							a_data.item := l_p + 3
						end
						if (not a_dalen.is_void) then
							a_dalen.item := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p + 3)))).to_integer_32
						end
						Result := 0
						l_return := True
					end
					if not l_return then
						l_p := l_p + (3)
						l_q := l_p + (strcspn (create {CE_INTEGER_8_POINTER}.make_cast (l_p), ce_string ("@/?"))).to_integer_32
						if not (l_q.item).to_boolean then
							if (protocols.item[l_a].need_slash_after_host).to_boolean then
								Result := (-1)
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 7 then -- if:
						if (l_q.item).to_integer_32 /= 64 then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___3 := strcspn (create {CE_INTEGER_8_POINTER}.make_cast ((l_q + 1)), ce_string ("@"))
							if not (l_tmp___3 < (strcspn (create {CE_INTEGER_8_POINTER}.make_cast ((l_q + 1)), ce_string ("/?")))) then
								l_break := True
							end
							if not (l_break) then
								l_q := (l_q + 1) + (strcspn (create {CE_INTEGER_8_POINTER}.make_cast ((l_q + 1)), ce_string ("@"))).to_integer_32
							end
						end
						l_break := False
						l_pp := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_p), (':').code)))
						if (not l_pp.is_void) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 11 then -- else:
						if not ((l_pp.c_pointer.to_integer_32).to_natural_32 > (l_q.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if (not a_user.is_void) then
							a_user.item := l_p
						end
						if (not a_uslen.is_void) then
							a_uslen.item := l_q.distance (l_p)
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						if (not a_user.is_void) then
							a_user.item := l_p
						end
						if (not a_uslen.is_void) then
							a_uslen.item := l_pp.distance (l_p)
						end
						if (not a_pass.is_void) then
							a_pass.item := l_pp + 1
						end
						if (not a_palen.is_void) then
							a_palen.item := (l_q.distance (l_pp)) - 1
						end
				when 15 then -- if done
						l_p := l_q + 1
				when 16 then -- if done
						l_q := l_p + (strcspn (create {CE_INTEGER_8_POINTER}.make_cast (l_p), ce_string (":/?"))).to_integer_32
						if not (l_q.item).to_boolean then
							if (protocols.item[l_a].need_slash_after_host).to_boolean then
								Result := (-1)
								l_return := True
							end
						end
				when 17 then -- if done
					if not l_return then
						if (not a_host.is_void) then
							a_host.item := l_p
						end
						if (not a_holen.is_void) then
							a_holen.item := l_q.distance (l_p)
						end
						if (l_q.item).to_integer_32 = 58 then
							l_pp___0 := l_q + (strcspn (create {CE_INTEGER_8_POINTER}.make_cast (l_q), ce_string ("/"))).to_integer_32
							if (l_pp___0.item).to_integer_32 /= 47 then
								if (protocols.item[l_a].need_slash_after_host).to_boolean then
									Result := (-1)
									l_return := True
								end
							end
							if not l_return then
								if (not a_port.is_void) then
									a_port.item := l_q + 1
								end
								if (not a_polen.is_void) then
									a_polen.item := (l_pp___0.distance (l_q)) - 1
								end
								l_cc := 0
								from
								until
									not (not (l_return) and then (l_cc < (l_pp___0.distance (l_q)) - 1))
								loop
									if (l_q[(l_cc + 1)]).to_integer_32 < 48 then
										Result := (-1)
										l_return := True
									elseif (l_q[(l_cc + 1)]).to_integer_32 > 57 then
										Result := (-1)
										l_return := True
									end
									if not l_return then
										l_cc := l_cc + 1
									end
								end
							end
							if not l_return then
								l_q := l_pp___0
							end
						end
					end
					if not l_return then
						if (l_q.item).to_boolean then
							if (l_q.item).to_integer_32 /= 63 then
								l_q := l_q + 1
							end
						end
						l_p := l_q
						l_p_c[0] := (1).to_natural_8
						l_p_c[1] := (0).to_natural_8
						l_q := l_p + (strcspn (create {CE_INTEGER_8_POINTER}.make_cast (l_p), create {CE_INTEGER_8_POINTER}.make_cast (l_p_c))).to_integer_32
						if (not a_data.is_void) then
							a_data.item := l_p
						end
						if (not a_dalen.is_void) then
							a_dalen.item := l_q.distance (l_p)
						end
						if (not a_post.is_void) then
							if (l_q.item).to_boolean then
								a_post.item := l_q + 1
							else
								a_post.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
						Result := 0
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_protocol_name (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_l: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			if (parse_url (a_url, l_l, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 129, a_url, l_l.item))
			end
		end

	get_host_name (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_h.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)

			if (parse_url (a_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				Result := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 146, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 147, l_h.item, l_hl.item))
			end
		end

	get_user_name (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_h.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hl.make (<<1>>)

			if (parse_url (a_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 155, l_h.item, l_hl.item))
			end
		end

	get_external_protocol_function (a_url: CE_POINTER [NATURAL_8]): CE_ROUTINE
		local
			l_p: CE_POINTER [NATURAL_8]
			l_f: CE_ARRAY [CE_ROUTINE]
			l_post: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
		do
			create {CE_ROUTINE_ARRAY} l_f.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_post.make (<<1>>)

			l_f.item := create {CE_ROUTINE}.make_shared (default_pointer)
			l_post.item := 0
			l_p := get_protocol_name (a_url)
			if l_p.is_void then
				Result := (create {CE_ROUTINE}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				get_prot_info (l_p, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_ROUTINE_POINTER}.make_shared (default_pointer), l_f, l_post).do_nothing;
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 212, create {CE_VOID_POINTER}.make_cast (l_p))
				if not (l_post.item).to_boolean then
					if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_url), 1)).is_void) then
						Result := (create {CE_ROUTINE}.make_shared (default_pointer))
						l_return := True
					end
				end
			end
			if not l_return then
				Result := (l_f.item)
			end
		end

	get_url_data (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_d: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_d.make (<<1>>)

			if (parse_url (a_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_d, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (l_d.item)
			end
		end

	translate_directories (a_url: CE_POINTER [NATURAL_8])
		local
			l_dd: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_lo: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___14: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: NATURAL_8
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_s.make
			create {CE_NATURAL_8_POINTER} l_d.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dd := (get_url_data (a_url))
					if ((create {P_LINKS_STATIC}).casecmp (a_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file://")), (7).to_natural_32)).to_boolean then
						l_tmp___1 := 0
					else
						l_tmp___1 := 1
					end
					l_lo := l_tmp___1
					if l_dd.is_void then
						l_return := True
					elseif l_dd.is_equal (a_url) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_lo.to_boolean then
							l_tmp___3 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_dd.item).to_integer_8))
						else
							l_tmp___3 := ((l_dd.item).to_integer_32 = 47).to_integer
						end
						if not l_tmp___3.to_boolean then
							l_dd := l_dd - 1
						end
						l_s := l_dd
						l_d := l_dd
				when 2 then -- r:
						if ((create {P_LINKS_STATIC}).end_of_dir (l_s[0])).to_boolean then
							memmove (create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_cast (l_s), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))) + {NATURAL_32} 1).do_nothing
							l_return := True
						end
				when 3 then -- if done
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 4 then -- if:
						if l_lo.to_boolean then
							l_tmp___7 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_s[0]).to_integer_8))
						else
							l_tmp___7 := ((l_s[0]).to_integer_32 = 47).to_integer
						end
						if not (l_tmp___7.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if (l_s[1]).to_integer_32 /= 46 then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if l_lo.to_boolean then
							l_tmp___9 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_s[2]).to_integer_8))
						else
							l_tmp___9 := ((l_s[2]).to_integer_32 = 47).to_integer
						end
						if not (l_tmp___9.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_s.is_equal (l_dd) then
							if not (l_s[3]).to_boolean then
								l_pos := -1 + 20 -- goto p
							end
						end
				when 8 then
						l_s := l_s + (2)
						l_pos := -1 + 2 -- goto r
				when 9 then -- if done | if done
						if l_lo.to_boolean then
							l_tmp___14 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_s[0]).to_integer_8))
						else
							l_tmp___14 := ((l_s[0]).to_integer_32 = 47).to_integer
						end
						if not (l_tmp___14.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 10 then -- if:
						if (l_s[1]).to_integer_32 /= 46 then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if:
						if (l_s[2]).to_integer_32 /= 46 then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						if l_lo.to_boolean then
							l_tmp___16 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_s[3]).to_integer_8))
						else
							l_tmp___16 := ((l_s[3]).to_integer_32 = 47).to_integer
						end
						if not (l_tmp___16.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 15 then -- else:
						if (l_s[3]).to_boolean then
							l_pos := -1 + 20 -- skip if block
						end
				when 16 then -- if: | _L:
						if not ((l_d.c_pointer.to_integer_32).to_natural_32 > (l_dd.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						l_d := l_d - 1
						if l_lo.to_boolean then
							l_tmp___11 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_d.item).to_integer_8))
						else
							l_tmp___11 := ((l_d.item).to_integer_32 = 47).to_integer
						end
						if l_tmp___11.to_boolean then
							l_pos := -1 + 19 -- goto b
						end
				when 18 then
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- b:
						if not (l_s[3]).to_boolean then
							l_tmp___12 := l_d
							l_d := l_d + 1
							l_tmp___12.item := l_s.item
						end
						l_s := l_s + (3)
						l_pos := -1 + 2 -- goto r
				when 20 then -- if done | if done | if done | if done | p:
						l_tmp___17 := l_d
						l_d := l_d + 1
						l_tmp___19 := l_s
						l_s := l_s + 1
						l_tmp___18 := l_tmp___19.item
						l_tmp___17.item := l_tmp___18
						if l_tmp___18.to_boolean then
							l_pos := -1 + 2 -- goto r
						end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	insert_wd (a_up___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_cwd: CE_POINTER [NATURAL_8])
		require
			not a_up___0.is_void
		local
			l_url: CE_POINTER [NATURAL_8]
			l_tmp___1: NATURAL_32
			l_return: BOOLEAN
		do
			l_url := a_up___0.item
			if l_url.is_void then
				l_return := True
			elseif a_cwd.is_void then
				l_return := True
			elseif not (a_cwd.item).to_boolean then
				l_return := True
			end
			if not l_return then
				if ((create {P_LINKS_STATIC}).casecmp (l_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file://")), (7).to_natural_32)).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_OS_DEP_STATIC}).dir_sep ((l_url[7]).to_integer_8)).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_up___0.item))
				l_url := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 272, (l_tmp___1 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_cwd)))) + {NATURAL_32} 2)))
				memcpy (create {CE_VOID_POINTER}.make_cast (l_url), create {CE_VOID_POINTER}.make_cast (a_up___0.item), (7).to_natural_32).do_nothing
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_url + 7)), create {CE_INTEGER_8_POINTER}.make_cast (a_cwd)).do_nothing
				if not ((create {P_OS_DEP_STATIC}).dir_sep ((a_cwd[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_cwd))) - {NATURAL_32} 1).to_integer_32]).to_integer_8)).to_boolean then
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_url), ce_string ("/")).do_nothing
				end
				strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_url), create {CE_INTEGER_8_POINTER}.make_cast ((a_up___0.item + 7))).do_nothing;
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 277, create {CE_VOID_POINTER}.make_cast (a_up___0.item))
				a_up___0.item := l_url
			end
		end

	join_urls (a_base, a_rel: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_rel.is_void
		local
			l_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_n: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pp: CE_POINTER [NATURAL_8]
			l_l: CE_ARRAY [INTEGER_32]
			l_lo: INTEGER_32
			l_tmp___0: INTEGER_32
			l_rj: CE_ARRAY [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_n___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___13: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___19: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_n.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_rj.make (<<3>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_n___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_LINKS_STATIC}).casecmp (a_base, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file://")), (7).to_natural_32)).to_boolean then
						l_tmp___0 := 0
					else
						l_tmp___0 := 1
					end
					l_lo := l_tmp___0
					if (a_rel[0]).to_integer_32 /= 35 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (a_rel[0]).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_n.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 287, a_base)
						l_p.item := l_n.item
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p.item.item).to_boolean then
								if (l_p.item.item).to_integer_32 /= 1 then
									if (l_p.item.item).to_integer_32 = 35 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p.item := l_p.item + 1
							end
						end
						l_break := False
						l_p.item.item := (0).to_natural_8;
						(create {P_LINKS_STATIC}).add_to_strn (l_n, a_rel)
						translate_directories (l_n.item)
						Result := (l_n.item)
						l_return := True
				when 5 then -- if done
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 6 then -- if:
						if (a_rel[0]).to_integer_32 /= 63 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 9 then -- else:
						if (a_rel[0]).to_integer_32 /= 38 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						l_d := (get_url_data (a_base))
						if l_d.is_void then
							l_pos := -1 + 16 -- goto bad_base
						end
				when 11 then
						l_rj[0] := a_rel[0]
						l_rj[1] := (1).to_natural_8
						l_rj[2] := (0).to_natural_8
						l_d := l_d + (strcspn (create {CE_INTEGER_8_POINTER}.make_cast (l_d), create {CE_INTEGER_8_POINTER}.make_cast (l_rj))).to_integer_32
						l_n.item := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 302, a_base, l_d.distance (a_base));
						(create {P_LINKS_STATIC}).add_to_strn (l_n, a_rel)
						translate_directories (l_n.item)
						Result := (l_n.item)
						l_return := True
				when 12 then -- if done | if done
					if not (not l_return and then ((a_rel[0]).to_integer_32 = 47)) then
						l_pos := -1 + 19 -- skip if block
					end
				when 13 then -- if:
						if (a_rel[1]).to_integer_32 /= 47 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						l_s := create {CE_NATURAL_8_POINTER}.make_cast ((strstr (create {CE_INTEGER_8_POINTER}.make_cast (a_base), ce_string ("//"))))
						if (not l_s.is_void) then
							l_pos := -1 + 18 -- skip if block
						end
				when 15 then -- if:
						l_s := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (a_base), (':').code)))
						if (not l_s.is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | bad_base:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c"));
							(create {P_LINKS_STATIC}).errline.item := 312;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bad base url: %%s")), a_base])
						end
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
				when 17 then -- if done
						if not l_return then
							l_s := l_s + 1
						end
				when 18 then -- if done
						if not l_return then
							l_n___0.item := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 317, a_base, l_s.distance (a_base));
							(create {P_LINKS_STATIC}).add_to_strn (l_n___0, a_rel)
							if not (parse_url (l_n___0.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
								translate_directories (l_n___0.item)
								Result := (l_n___0.item)
								l_return := True
							end
						end
						if not l_return then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 323, create {CE_VOID_POINTER}.make_cast (l_n___0.item))
						end
				when 19 then -- if done | if done
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 20 then -- if:
						if not ((create {P_LINKS_STATIC}).casecmp (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("proxy://")), a_rel, (8).to_natural_32)).to_boolean then
							l_pos := -1 + 24 -- goto prx
						end
				when 21 then
						if not (parse_url (a_rel, l_l, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
							l_n.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 327, a_rel)
							translate_directories (l_n.item)
							Result := (l_n.item)
							l_return := True
						end
				when 22 then -- if done
					if not l_return then
						l_n.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 331, a_rel)
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_n.item[0]).to_boolean then
								if not ((l_n.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_n.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 <= 32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_n.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_n.item))) - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
							end
						end
						l_break := False;
						(create {P_LINKS_STATIC}).add_to_strn (l_n, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
						if not (parse_url (l_n.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
							translate_directories (l_n.item)
							Result := (l_n.item)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 26 -- skip if block
					end
				when 23 then -- if:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 338, create {CE_VOID_POINTER}.make_cast (l_n.item))
				when 24 then -- prx:
						if (parse_url (a_base, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_p, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
							l_pos := -1 + 16 -- goto bad_base
						elseif (l_p.item).is_void then
							l_pos := -1 + 16 -- goto bad_base
						end
				when 25 then
						if l_lo.to_boolean then
							l_tmp___13 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_p.item.item).to_integer_8))
						else
							l_tmp___13 := ((l_p.item.item).to_integer_32 = 47).to_integer
						end
						if not l_tmp___13.to_boolean then
							l_p.item := l_p.item - 1
						end
						if ((create {P_LINKS_STATIC}).end_of_dir (a_rel[0])).to_boolean then
							from
							until
								not (not (l_break) and then ((l_p.item.item).to_boolean))
							loop
								l_break := False
								if ((create {P_LINKS_STATIC}).end_of_dir (l_p.item.item)).to_boolean then
									l_break := True
								end
								if not (l_break) then
									l_p.item := l_p.item + 1
								end
							end
							l_break := False
						else
							if l_lo.to_boolean then
								l_tmp___19 := ((create {P_OS_DEP_STATIC}).dir_sep ((a_rel[0]).to_integer_8))
							else
								l_tmp___19 := ((a_rel[0]).to_integer_32 = 47).to_integer
							end
							if not l_tmp___19.to_boolean then
								l_pp := l_p.item
								from
								until
									not (not (l_break) and then ((l_pp.item).to_boolean))
								loop
									l_break := False
									if ((create {P_LINKS_STATIC}).end_of_dir (l_pp.item)).to_boolean then
										l_break := True
									end
									if not (l_break) then
										if l_lo.to_boolean then
											l_tmp___17 := ((create {P_OS_DEP_STATIC}).dir_sep ((l_pp.item).to_integer_8))
										else
											l_tmp___17 := ((l_pp.item).to_integer_32 = 47).to_integer
										end
										if l_tmp___17.to_boolean then
											l_p.item := l_pp + 1
										end
										l_pp := l_pp + 1
									end
								end
								l_break := False
							end
						end
						l_n.item := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 350, (((l_p.item).distance (a_base)).to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_rel)))) + {NATURAL_32} 1)))
						memcpy (create {CE_VOID_POINTER}.make_cast (l_n.item), create {CE_VOID_POINTER}.make_cast (a_base), ((l_p.item).distance (a_base)).to_natural_32).do_nothing
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_n.item + ((l_p.item).distance (a_base)))), create {CE_INTEGER_8_POINTER}.make_cast (a_rel)).do_nothing
						translate_directories (l_n.item)
						Result := (l_n.item)
				when 26 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	translate_url (a_url, a_cwd: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_url.is_void
		local
			l_url: CE_POINTER [NATURAL_8]
			l_ch: CE_POINTER [NATURAL_8]
			l_nu: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_da: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prefix: CE_POINTER [NATURAL_8]
			l_sl: INTEGER_32
			l_f: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_tld: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_ch.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_nu.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_da.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_tld.make (<<21>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_url := a_url
					from
					until
						(l_url.item).to_integer_32 /= 32
					loop
						l_url := l_url + 1
					end
					if not ((create {P_LINKS_STATIC}).casecmp (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("proxy://")), l_url, (8).to_natural_32)).to_boolean then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						if not (parse_url (l_url, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_da, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
							l_nu.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 366, l_url)
							insert_wd (l_nu, a_cwd)
							translate_directories (l_nu.item)
							Result := (l_nu.item)
							l_return := True
						end
					end
					if not l_return then
						if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_url), 1)).is_void) then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return then
						if (not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_url), ce_string ("://"))).is_void) then
							l_nu.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 373, l_url);
							(create {P_LINKS_STATIC}).add_to_strn (l_nu, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
							if not (parse_url (l_nu.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
								insert_wd (l_nu, a_cwd)
								translate_directories (l_nu.item)
								Result := (l_nu.item)
								l_return := True
							end
							if not l_return then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 380, create {CE_VOID_POINTER}.make_cast (l_nu.item))
							end
						end
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_ch := l_url + (strcspn (create {CE_INTEGER_8_POINTER}.make_cast (l_url), ce_string (".:/@"))).to_integer_32
						l_prefix := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file://"))
						l_sl := 0
						if (l_ch.item).to_integer_32 = 58 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else:
						if (l_url[(strcspn (create {CE_INTEGER_8_POINTER}.make_cast (l_url), ce_string ("/@"))).to_integer_32]).to_integer_32 /= 64 then
							l_pos := -1 + 20 -- skip if block
						end
				when 5 then -- if: | _L:
						if (l_url.item).to_integer_32 = 46 then
							l_pos := -1 + 18 -- skip if block
						end
				when 6 then -- if:
						if (l_ch.item).to_integer_32 /= 46 then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
						l_e := l_ch + 1
						from
						until
							(l_break)
						loop
							l_break := False
							l_f := l_e + (strcspn (create {CE_INTEGER_8_POINTER}.make_cast (l_e), ce_string (".:/"))).to_integer_32
							if (l_f.item).to_integer_32 /= 46 then
								l_break := True
							end
							if not (l_break) then
								l_e := l_f + 1
							end
						end
						l_break := False
						l_i := 0
				when 8 then -- loop condition:
						if not (l_i < l_f.distance (l_e)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						if (l_e[l_i]).to_integer_32 >= 48 then
							if (l_e[l_i]).to_integer_32 <= 57 then
								l_pos := -1 + 12 -- goto http
							end
						end
				when 10 then
						l_i := l_i + 1
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						if l_f.distance (l_e) /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | http:
						l_prefix := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http://"))
						l_sl := 1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						l_tld[0] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("com"))
						l_tld[1] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("edu"))
						l_tld[2] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("net"))
						l_tld[3] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("org"))
						l_tld[4] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("gov"))
						l_tld[5] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mil"))
						l_tld[6] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("int"))
						l_tld[7] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("arpa"))
						l_tld[8] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("aero"))
						l_tld[9] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("biz"))
						l_tld[10] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("coop"))
						l_tld[11] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("info"))
						l_tld[12] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("museum"))
						l_tld[13] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("name"))
						l_tld[14] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("pro"))
						l_tld[15] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cat"))
						l_tld[16] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("jobs"))
						l_tld[17] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mobi"))
						l_tld[18] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("travel"))
						l_tld[19] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tel"))
						l_tld[20] := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_i := 0
				when 15 then -- loop condition:
						if (l_tld[l_i]).is_void then
							l_pos := -1 + 18 -- skip loop
						end
				when 16 then -- loop body:
						if (l_f.distance (l_e)).to_natural_32 = (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tld[l_i]))) then
							if not ((create {P_LINKS_STATIC}).casecmp (l_tld[l_i], l_e, (l_f.distance (l_e)).to_natural_32)).to_boolean then
								l_pos := -1 + 12 -- goto http
							end
						end
				when 17 then
						l_i := l_i + 1
						l_pos := -1 + 15 -- back to loop condition
				when 18 then -- loop done | if done | if done | if done
						if (l_ch.item).to_integer_32 = 64 then
							l_prefix := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp://"))
							l_sl := 1
						elseif (l_ch.item).to_integer_32 = 58 then
							l_prefix := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp://"))
							l_sl := 1
						elseif not ((create {P_LINKS_STATIC}).cmpbeg (l_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp.")))).to_boolean then
							l_prefix := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp://"))
							l_sl := 1
						end
						l_pos := -1 + 19 -- goto set_prefix
				when 19 then -- set_prefix:
						l_nu.item := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 402, l_prefix);
						(create {P_LINKS_STATIC}).add_to_strn (l_nu, l_url)
						if l_sl.to_boolean then
							if (strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_url), ('/').code)).is_void then
								(create {P_LINKS_STATIC}).add_to_strn (l_nu, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
							end
						end
						if (parse_url (l_nu.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 405, create {CE_VOID_POINTER}.make_cast (l_nu.item))
							l_nu.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							insert_wd (l_nu, a_cwd)
							translate_directories (l_nu.item)
						end
						Result := (l_nu.item)
						l_return := True
				when 20 then -- if done | if done
					if not l_return then
						l_nu.item := (create {P_LINKS_STATIC}).debug_memacpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 418, l_url, (l_ch.distance (l_url)) + 1);
						(create {P_LINKS_STATIC}).add_to_strn (l_nu, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("//")));
						(create {P_LINKS_STATIC}).add_to_strn (l_nu, l_ch + 1)
						if not (parse_url (l_nu.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
							insert_wd (l_nu, a_cwd)
							translate_directories (l_nu.item)
							Result := (l_nu.item)
							l_return := True
						end
					end
					if not l_return then
						(create {P_LINKS_STATIC}).add_to_strn (l_nu, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/")))
						if not (parse_url (l_nu.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))).to_boolean then
							insert_wd (l_nu, a_cwd)
							translate_directories (l_nu.item)
							Result := (l_nu.item)
							l_return := True
						end
					end
					if not l_return then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 432, create {CE_VOID_POINTER}.make_cast (l_nu.item))
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	extract_position (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_url: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_uu: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_url := a_url
			l_u := get_url_data (l_url)
			if (not l_u.is_void) then
				l_url := l_u
			end
			l_u := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_url), 1)))
			if l_u.is_void then
				l_u := l_url + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_url))).to_integer_32
			end
			l_uu := create {CE_NATURAL_8_POINTER}.make_cast ((memchr (create {CE_VOID_POINTER}.make_cast (l_url), ('#').code, (l_u.distance (l_url)).to_natural_32)))
			if l_uu.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_r := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("url.c")), 442, (l_u.distance (l_uu)).to_natural_32)))
				memcpy (create {CE_VOID_POINTER}.make_cast (l_r), create {CE_VOID_POINTER}.make_cast ((l_uu + 1)), ((l_u.distance (l_uu)) - 1).to_natural_32).do_nothing
				l_r[((l_u.distance (l_uu)) - 1)] := (0).to_natural_8
				memmove (create {CE_VOID_POINTER}.make_cast (l_uu), create {CE_VOID_POINTER}.make_cast (l_u), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_u))) + {NATURAL_32} 1).do_nothing
				Result := l_r
			end
		end

	add_conv_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_b: CE_POINTER [NATURAL_8]; a_ll, a_encode_special: INTEGER_32)
		local
			l_b: CE_POINTER [NATURAL_8]
			l_ll: INTEGER_32
			l_h: CE_ARRAY [NATURAL_8]
			l_h___0: NATURAL_8
			l_i: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_h.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := a_b
					l_ll := a_ll
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_ll.to_boolean)) then
						l_pos := -1 + 35 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						if (l_b.item).to_integer_32 < 32 then
							l_continue := True
						end
						if (l_return or l_continue) then
							l_pos := -1 + 34 -- skip if block
						end
				when 3 then -- if:
						if (l_b.item).to_integer_32 /= 37 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___10
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 6 then -- else:
						if (l_b.item).to_integer_32 /= 35 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___10:
						if a_encode_special = 1 then
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_h), ce_string ("%%%%%%02X"), ((l_b.item).to_natural_32).bit_and ({NATURAL_32} 255)]).do_nothing;
							(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, l_h)
						else
							l_pos := -1 + 9 -- goto _L___9
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 9 then -- else: | _L___9:
						if (l_b.item).to_integer_32 /= 37 then
							l_pos := -1 + 30 -- skip if block
						end
				when 10 then -- if:
						if not (a_encode_special <= -1) then
							l_pos := -1 + 28 -- skip if block
						end
				when 11 then -- if:
						if not (l_ll > 2) then
							l_pos := -1 + 26 -- skip if block
						end
				when 12 then -- if:
						if not ((l_b[1]).to_integer_32 >= 48) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (l_b[1]).to_integer_32 <= 57 then
							l_pos := -1 + 20 -- goto _L___4
						else
							l_pos := -1 + 15 -- goto _L___6
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else: | _L___6:
						if not ((l_b[1]).to_integer_32 >= 65) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (l_b[1]).to_integer_32 <= 70 then
							l_pos := -1 + 20 -- goto _L___4
						else
							l_pos := -1 + 18 -- goto _L___5
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else: | _L___5:
						if not ((l_b[1]).to_integer_32 >= 97) then
							l_pos := -1 + 24 -- skip if block
						end
				when 19 then -- if:
						if not ((l_b[1]).to_integer_32 <= 102) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L___4:
						l_h___0 := (0).to_natural_8
						l_i := 1
						from
						until
							not (l_i < 3)
						loop
							if (l_b[l_i]).to_integer_32 >= 48 then
								if (l_b[l_i]).to_integer_32 <= 57 then
									l_h___0 := ((l_h___0.to_integer_32 * 16 + (l_b[l_i]).to_integer_32) - 48).to_natural_8
								end
							end
							if (l_b[l_i]).to_integer_32 >= 65 then
								if (l_b[l_i]).to_integer_32 <= 70 then
									l_h___0 := (((l_h___0.to_integer_32 * 16 + (l_b[l_i]).to_integer_32) - 65) + 10).to_natural_8
								end
							end
							if (l_b[l_i]).to_integer_32 >= 97 then
								if (l_b[l_i]).to_integer_32 <= 102 then
									l_h___0 := (((l_h___0.to_integer_32 * 16 + (l_b[l_i]).to_integer_32) - 97) + 10).to_natural_8
								end
							end
							l_i := l_i + 1
						end
						if l_h___0.to_integer_32 >= 32 then
							(create {P_LINKS_STATIC}).add_chr_to_str (a_s, a_l, l_h___0)
						end
						l_ll := l_ll - (2)
						l_b := l_b + (2)
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 30 -- goto _L___8
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_pos := -1 + 30 -- goto _L___8
				when 25 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_pos := -1 + 30 -- goto _L___8
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 30 -- goto _L___8
				when 29 then -- if done | if block done, skip else block:
						l_pos := -1 + 34
				when 30 then -- else: | _L___8:
						if (l_b.item).to_integer_32 = 34 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if (l_b.item).to_integer_32 /= 39 then
							if (l_b.item).to_integer_32 /= 38 then
								if (l_b.item).to_integer_32 /= 60 then
									if (l_b.item).to_integer_32 /= 62 then
										(create {P_LINKS_STATIC}).add_chr_to_str (a_s, a_l, l_b.item)
									else
										l_pos := -1 + 33 -- goto _L___2
									end
								else
									l_pos := -1 + 33 -- goto _L___2
								end
							else
								l_pos := -1 + 33 -- goto _L___2
							end
						else
							l_pos := -1 + 33 -- goto _L___2
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else: | _L___2:
						if a_encode_special = -2 then
							(create {P_LINKS_STATIC}).add_chr_to_str (a_s, a_l, l_b.item)
						else
							(create {P_LINKS_STATIC}).add_to_str (a_s, a_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("&#")));
							(create {P_LINKS_STATIC}).add_num_to_str (a_s, a_l, ((l_b.item).to_integer_32).to_integer_32);
							(create {P_LINKS_STATIC}).add_chr_to_str (a_s, a_l, ((';').code).to_natural_8)
						end
				when 34 then -- if done | if done | if done | if done
						if (not l_return) then
							l_ll := l_ll - 1
							l_b := l_b + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 35 then -- loop done
					l_continue := False
				when 36 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
