class
	PD_BLACKLIST_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]} next.make
			create {CE_CLASS_POINTER [PD_BLACKLIST_ENTRY]} prev.make
			create {CE_NATURAL_8_ARRAY} host.make (<<1>>)
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_BLACKLIST_ENTRY] assign set_next

	prev: CE_POINTER [PD_BLACKLIST_ENTRY] assign set_prev

	flags: INTEGER_32 assign set_flags

	host: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_BLACKLIST_ENTRY])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_BLACKLIST_ENTRY])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			flags := a_other.flags
			host := a_other.host.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				flags = a_other.flags and
				host.is_equal (a_other.host)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("host", <<1>>)
				>>)
			init_structure_info
		end

end
