class
	PD_CACHE_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_CACHE_ENTRY]} next.make
			create {CE_CLASS_POINTER [PD_CACHE_ENTRY]} prev.make
			create {CE_NATURAL_8_POINTER} url.make
			create {CE_NATURAL_8_POINTER} head.make
			create {CE_NATURAL_8_POINTER} redirect.make
			create {CE_NATURAL_8_POINTER} last_modified.make
			create frag.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_CACHE_ENTRY] assign set_next

	prev: CE_POINTER [PD_CACHE_ENTRY] assign set_prev

	url: CE_POINTER [NATURAL_8] assign set_url

	head: CE_POINTER [NATURAL_8] assign set_head

	redirect: CE_POINTER [NATURAL_8] assign set_redirect

	redirect_get: INTEGER_32 assign set_redirect_get

	length: INTEGER_32 assign set_length

	incomplete: INTEGER_32 assign set_incomplete

	tgc: INTEGER_32 assign set_tgc

	last_modified: CE_POINTER [NATURAL_8] assign set_last_modified

	data_size: INTEGER_32 assign set_data_size

	frag: PD_LIST_HEAD assign set_frag

	count: NATURAL_32 assign set_count

	refcount: INTEGER_32 assign set_refcount

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_CACHE_ENTRY])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_CACHE_ENTRY])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_head (a_head: CE_POINTER [NATURAL_8])
		do
			head := a_head
			update_memory_field ("head")
		end

	set_redirect (a_redirect: CE_POINTER [NATURAL_8])
		do
			redirect := a_redirect
			update_memory_field ("redirect")
		end

	set_redirect_get (a_redirect_get: INTEGER_32)
		do
			redirect_get := a_redirect_get
			update_memory_field ("redirect_get")
		end

	set_length (a_length: INTEGER_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_incomplete (a_incomplete: INTEGER_32)
		do
			incomplete := a_incomplete
			update_memory_field ("incomplete")
		end

	set_tgc (a_tgc: INTEGER_32)
		do
			tgc := a_tgc
			update_memory_field ("tgc")
		end

	set_last_modified (a_last_modified: CE_POINTER [NATURAL_8])
		do
			last_modified := a_last_modified
			update_memory_field ("last_modified")
		end

	set_data_size (a_data_size: INTEGER_32)
		do
			data_size := a_data_size
			update_memory_field ("data_size")
		end

	set_frag (a_frag: PD_LIST_HEAD)
		do
			frag := a_frag
			update_memory_field ("frag")
		end

	set_count (a_count: NATURAL_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set_refcount (a_refcount: INTEGER_32)
		do
			refcount := a_refcount
			update_memory_field ("refcount")
		end

feature {ANY} -- public routines

	defrag_entry
		local
			l_f: CE_POINTER [PD_FRAGMENT]
			l_g: CE_POINTER [PD_FRAGMENT]
			l_h: CE_POINTER [PD_FRAGMENT]
			l_n: CE_POINTER [PD_FRAGMENT]
			l_x: CE_POINTER [PD_FRAGMENT]
			l_l: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (frag.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
						l_return := True
					end
					if not l_return then
						l_f := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (frag.next)
						if (l_f.item.offset).to_boolean then
							l_return := True
						end
					end
					if not l_return then
						l_g := l_f.item.next
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if not l_g.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
								if not (l_g.item.offset <= (l_g.item.prev).item.offset + (l_g.item.prev).item.length) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if l_g.item.offset < (l_g.item.prev).item.offset + (l_g.item.prev).item.length then
									from
									until
										False
									loop
										(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_LINKS_STATIC}).errline.item := 164
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fragments overlay"))])
										update_class_fields -- Current might have been changed; synchronize
									end
									l_return := True
								end
								if not l_return then
									l_g := l_g.item.next
								end
							end
						end
					end
					if not l_return then
						l_break := False
						if l_g.is_equal (l_f.item.next) then
							if l_f.item.length = l_f.item.real_length then
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_l := (0).to_integer_32
						l_h := l_f
						from
						until
							l_h.is_equal (l_g)
						loop
							l_l := l_l + (l_h.item.length)
							l_h := l_h.item.next
						end
						if not (l_l.to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (l_l < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("cache.c"), 169])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_KBD_STATIC}).fatal_tty_exit
							update_class_fields -- Current might have been changed; synchronize
							exit (4)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if done
						l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 170, (((create {PD_FRAGMENT}.make).structure_size.to_natural_32).to_natural_32 + l_l.to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_n := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (l_tmp)
						l_n.item.offset := (0).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_n.item.length := l_l
						update_class_fields -- Current might have been changed; synchronize
						l_n.item.real_length := l_l
						update_class_fields -- Current might have been changed; synchronize
						l_l := (0).to_integer_32
						l_h := l_f
						from
						until
							l_h.is_equal (l_g)
						loop
							memcpy (create {CE_VOID_POINTER}.make_cast ((l_n.item.data + l_l)), create {CE_VOID_POINTER}.make_cast ((l_h.item.data)), (l_h.item.length).to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_l := l_l + (l_h.item.length)
							l_x := l_h
							l_h := l_h.item.prev;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_x))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_x.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_x.item.prev)
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_x.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_x.item.next)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_x))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 185, create {CE_VOID_POINTER}.make_cast (l_x))
							update_class_fields -- Current might have been changed; synchronize
							l_h := l_h.item.next
						end
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
							update_class_fields -- Current might have been changed; synchronize
							l_n.item.next := (create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))).item.next
							update_class_fields -- Current might have been changed; synchronize
							l_n.item.prev := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))))).item.next := l_n
							update_class_fields; -- Current might have been changed; synchronize
							(l_n.item.next).item.prev := l_n
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	delete_entry_content
		local
			l_tmp: INTEGER_32
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			l_tmp := (create {P_CACHE_STATIC}).cache_count.item;
			(create {P_CACHE_STATIC}).cache_count.item := (create {P_CACHE_STATIC}).cache_count.item + 1
			update_class_fields -- Current might have been changed; synchronize
			Current.count := l_tmp.to_natural_32
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
			update_class_fields -- Current might have been changed; synchronize
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (frag.next)
			from
			until
				l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (frag.prev)
			from
			until
				l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.prev
			end
			from
			until
				(frag.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (frag.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 254, create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag")))))
			update_class_fields -- Current might have been changed; synchronize
			Current.length := (0).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.incomplete := 1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_CACHE_STATIC}).cache_size.item := (create {P_CACHE_STATIC}).cache_size.item - data_size
			update_class_fields -- Current might have been changed; synchronize
			if (create {P_CACHE_STATIC}).cache_size.item < 0 then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 258
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache_size underflow: %%ld")), (create {P_CACHE_STATIC}).cache_size.item])
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_CACHE_STATIC}).cache_size.item := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.data_size := (0).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if (not last_modified.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 263, create {CE_VOID_POINTER}.make_cast (last_modified))
				update_class_fields -- Current might have been changed; synchronize
				Current.last_modified := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	delete_cache_entry
		local
			l_tmp: INTEGER_32
		do
			if refcount.to_boolean then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 270
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("deleteing locked cache entry"))])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_tmp := (create {P_SCHED_STATIC}).is_entry_used ((create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer)))
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 272
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("deleting loading cache entry"))])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			((create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer))).item.delete_entry_content
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 276, create {CE_VOID_POINTER}.make_cast (url))
			update_class_fields -- Current might have been changed; synchronize
			if (not head.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 277, create {CE_VOID_POINTER}.make_cast (head))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not last_modified.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 278, create {CE_VOID_POINTER}.make_cast (last_modified))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not redirect.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 279, create {CE_VOID_POINTER}.make_cast (redirect))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cache.c")), 283, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	format_html (a_screen: CE_POINTER [PD_F_DATA])
		require
			not a_screen.is_void
		local
			l_url: CE_POINTER [NATURAL_8]
			l_fr: CE_POINTER [PD_FRAGMENT]
			l_rp: CE_POINTER [PD_PART]
			l_start: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_head___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_t: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hdl: CE_ARRAY [INTEGER_32]
			l_i: INTEGER_32
			l_tmp: NATURAL_32
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_head___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_t.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_hdl.make (<<1>>)

			l_url := url
			memset (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_R_STATIC}).table_cache_hash.item)), 0, ({PLATFORM}.Pointer_bytes.to_natural_32 * (4_096).to_natural_32)).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).d_opt.item := create {CE_CLASS_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared (a_screen.c_pointer + (create {PD_F_DATA}.make).offset_of ("opt"))
			update_class_fields -- Current might have been changed; synchronize
			a_screen.item.use_tag := count
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (c_pointer))).item.defrag_entry
			update_class_fields -- Current might have been changed; synchronize
			l_fr := create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (frag.next)
			if l_fr.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
				l_start := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			elseif (l_fr.item.offset).to_boolean then
				l_start := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			elseif not (l_fr.item.length).to_boolean then
				l_start := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			else
				l_start := l_fr.item.data
				l_end := l_fr.item.data + l_fr.item.length
			end
			(create {P_LINKS_STATIC}).startf.item := l_start
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).eofff.item := l_end
			update_class_fields -- Current might have been changed; synchronize
			l_head___0.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 998)
			update_class_fields -- Current might have been changed; synchronize
			l_hdl.item := 0
			update_class_fields -- Current might have been changed; synchronize
			if (not head.is_void) then
				(create {P_LINKS_STATIC}).add_to_str (l_head___0, l_hdl, head)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_HTML_STATIC}).scan_http_equiv (l_start, l_end, l_head___0, l_hdl, l_t)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_HTML_R_STATIC}).convert_table.item := (create {P_HTML_R_STATIC}).get_convert_table (l_head___0.item, a_screen.item.opt.cp, a_screen.item.opt.assume_cp, create {CE_INTEGER_32_POINTER}.make_shared (a_screen.c_pointer + (create {PD_F_DATA}.make).offset_of ("cp")), create {CE_INTEGER_32_POINTER}.make_shared (a_screen.c_pointer + (create {PD_F_DATA}.make).offset_of ("ass")), a_screen.item.opt.hard_assume)
			update_class_fields -- Current might have been changed; synchronize
			a_screen.item.opt.real_cp := a_screen.item.cp
			update_class_fields -- Current might have been changed; synchronize
			l_i := (create {P_LINKS_STATIC}).d_opt.item.item.plain;
			(create {P_LINKS_STATIC}).d_opt.item.item.plain := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_t.item))
			update_class_fields -- Current might have been changed; synchronize
			a_screen.item.title := (create {P_CHARSETS_STATIC}).convert_string ((create {P_HTML_R_STATIC}).convert_table.item, l_t.item, l_tmp.to_integer_32)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).d_opt.item.item.plain := l_i
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_006, create {CE_VOID_POINTER}.make_cast (l_t.item))
			update_class_fields -- Current might have been changed; synchronize
			push_base_format (l_url, create {CE_CLASS_POINTER [PD_DOCUMENT_OPTIONS]}.make_shared (a_screen.c_pointer + (create {PD_F_DATA}.make).offset_of ("opt")))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).table_level.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_HTML_R_STATIC}).g_ctrl_num.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).last_form_tag.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).last_form_attr.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_LINKS_STATIC}).last_input_tag.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_rp := (create {P_HTML_R_STATIC}).format_html_part (l_start, l_end, (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align, (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin, a_screen.item.opt.xw, a_screen, 0, 0, l_head___0.item, 1)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_rp.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_013, create {CE_VOID_POINTER}.make_cast (l_rp))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_014, create {CE_VOID_POINTER}.make_cast (l_head___0.item))
			update_class_fields -- Current might have been changed; synchronize
			a_screen.item.x := 0
			update_class_fields -- Current might have been changed; synchronize
			l_i := a_screen.item.y - 1
			from
			until
				not (not (l_break) and then (l_i >= 0))
			loop
				l_break := False
				if not ((a_screen.item.data + l_i).item.l).to_boolean then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_017, create {CE_VOID_POINTER}.make_cast ((a_screen.item.data + l_i).item.d))
					update_class_fields -- Current might have been changed; synchronize
					a_screen.item.y := (a_screen.item.y) - 1
					update_class_fields -- Current might have been changed; synchronize
				else
					l_break := True
				end
				if not (l_break) then
					l_i := l_i - 1
				end
			end
			l_break := False
			l_i := 0
			from
			until
				not (l_i < a_screen.item.y)
			loop
				if (a_screen.item.data + l_i).item.l > a_screen.item.x then
					a_screen.item.x := (a_screen.item.data + l_i).item.l
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i := l_i + 1
			end
			if (not ((create {P_HTML_STATIC}).form.item.item.action).is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_021, create {CE_VOID_POINTER}.make_cast ((create {P_HTML_STATIC}).form.item.item.action))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_HTML_STATIC}).form.item.item.action := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not ((create {P_HTML_STATIC}).form.item.item.target).is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 1_022, create {CE_VOID_POINTER}.make_cast ((create {P_HTML_STATIC}).form.item.item.target))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_HTML_STATIC}).form.item.item.target := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.kill_html_stack_item
			update_class_fields -- Current might have been changed; synchronize
			if not ((create {P_HTML_STATIC}).html_stack.item.item.next).is_equal ((create {P_HTML_STATIC}).html_stack.item) then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_LINKS_STATIC}).errline.item := 1_025
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html stack not empty after operation"))])
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item)))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_HTML_STATIC}).html_stack.item.item.next := create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_HTML_STATIC}).html_stack.item.item.prev := create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item)))
				update_class_fields -- Current might have been changed; synchronize
			end
			a_screen.item.bg := (7).bit_shift_left (8)
			update_class_fields -- Current might have been changed; synchronize
			sort_links (a_screen)
			update_class_fields -- Current might have been changed; synchronize
			if (not (a_screen.item.frame_desc).is_void) then
				a_screen.item.frame := 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {PD_CACHE_ENTRY} -- private routines

	sort_links (a_f: CE_POINTER [PD_F_DATA])
		require
			not a_f.is_void
		local
			l_i: INTEGER_32
			l_p: INTEGER_32
			l_q: INTEGER_32
			l_j: INTEGER_32
			l_link___0: CE_POINTER [PD_LINK]
			l_return, l_continue: BOOLEAN
		do
			if (a_f.item.nlinks).to_boolean then
				qsort (create {CE_VOID_POINTER}.make_cast (a_f.item.links), (a_f.item.nlinks).to_natural_32, (create {PD_LINK}.make).structure_size.to_natural_32, ((create {PD_LINK_STATIC}).comp_links_address))
			end
			if (a_f.item.y).to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Pointer_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 208]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			a_f.item.lines1 := create {CE_POINTER_POINTER [PD_LINK]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 209, (a_f.item.y).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
			a_f.item.lines2 := create {CE_POINTER_POINTER [PD_LINK]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 210, (a_f.item.y).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (a_f.item.lines1), 0, (a_f.item.y).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (a_f.item.lines2), 0, (a_f.item.y).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < a_f.item.nlinks))
			loop
				l_continue := False
				l_link___0 := a_f.item.links + l_i
				if not (l_link___0.item.n).to_boolean then
					if ((create {P_LINKS_STATIC}).d_opt.item.item.num_links).to_boolean then
						l_continue := True
					end
					if not (l_return or l_continue) then
						if (not (l_link___0.item.where).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 218, create {CE_VOID_POINTER}.make_cast (l_link___0.item.where))
						end
						if (not (l_link___0.item.target).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 219, create {CE_VOID_POINTER}.make_cast (l_link___0.item.target))
						end
						if (not (l_link___0.item.where_img).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 220, create {CE_VOID_POINTER}.make_cast (l_link___0.item.where_img))
						end
						if (not (l_link___0.item.pos).is_void) then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 221, create {CE_VOID_POINTER}.make_cast (l_link___0.item.pos))
						end
						memmove (create {CE_VOID_POINTER}.make_cast (l_link___0), create {CE_VOID_POINTER}.make_cast ((l_link___0 + 1)), ((a_f.item.nlinks - l_i) - 1).to_natural_32 * (create {PD_LINK}.make).structure_size.to_natural_32).do_nothing
						a_f.item.nlinks := (a_f.item.nlinks) - 1
						l_i := l_i - 1
						l_continue := True
					end
				end
				if not (l_return or l_continue) then
					l_p := a_f.item.y - 1
					l_q := 0
					l_j := 0
					from
					until
						not (l_j < l_link___0.item.n)
					loop
						if (l_link___0.item.pos + l_j).item.y < l_p then
							l_p := (l_link___0.item.pos + l_j).item.y
						end
						if (l_link___0.item.pos + l_j).item.y > l_q then
							l_q := (l_link___0.item.pos + l_j).item.y
						end
						l_j := l_j + 1
					end
					if l_p > l_q then
						l_j := l_p
						l_p := l_q
						l_q := l_j
					end
					l_j := l_p
					from
					until
						not (not (l_return) and then (l_j <= l_q))
					loop
						l_continue := False
						if l_j >= a_f.item.y then
							from
							until
								False
							loop
								(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
								(create {P_LINKS_STATIC}).errline.item := 240;
								(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("link out of screen"))])
							end
							l_continue := True
						end
						if not (l_return or l_continue) then
							a_f.item.lines2[l_j] := a_f.item.links + l_i
							if (a_f.item.lines1[l_j]).is_void then
								a_f.item.lines1[l_j] := a_f.item.links + l_i
							end
						end
						if (not l_return) then
							l_j := l_j + 1
						end
					end
					l_continue := False
				end
				if (not l_return) then
					l_i := l_i + 1
				end
			end
			l_continue := False
		end

	push_base_format (a_url: CE_POINTER [NATURAL_8]; a_opt: CE_POINTER [PD_DOCUMENT_OPTIONS])
		require
			not a_opt.is_void
		local
			l_e: CE_POINTER [PD_HTML_ELEMENT]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
			l_break: BOOLEAN
		do
			if not ((create {P_HTML_STATIC}).html_stack.item.item.next).is_equal ((create {P_HTML_STATIC}).html_stack.item) then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c"));
					(create {P_LINKS_STATIC}).errline.item := 919;
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("something on html stack"))])
				end
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item)));
				(create {P_HTML_STATIC}).html_stack.item.item.next := create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item));
				(create {P_HTML_STATIC}).html_stack.item.item.prev := create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item));
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item)))
			end
			l_e := create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 922, (create {PD_HTML_ELEMENT}.make).structure_size.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (l_e), 0, (create {PD_HTML_ELEMENT}.make).structure_size.to_natural_32).do_nothing
			from
			until
				(l_break)
			loop
				l_break := False;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item)))
				l_e.item.next := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast (((create {P_HTML_STATIC}).html_stack.item))).item.next
				l_e.item.prev := create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast (((create {P_HTML_STATIC}).html_stack.item));
				(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast (((create {P_HTML_STATIC}).html_stack.item))).item.next := l_e;
				(l_e.item.next).item.prev := l_e;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (((create {P_HTML_STATIC}).html_stack.item)))
				l_break := True
			end
			l_break := False;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.attr := 0;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.fontsize := 3
			l_tmp___2 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.select2 := l_tmp___2
			l_tmp___1 := l_tmp___2;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.image := l_tmp___1
			l_tmp___0 := l_tmp___1;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.target := l_tmp___0;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.link := l_tmp___0;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.form := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_shared (default_pointer)
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("fg")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_opt.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_fg")))), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("bg")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_opt.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_bg")))), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("clink")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_opt.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_link")))), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("attr") + (create {PD_TEXT_ATTRIB}.make).offset_of ("vlink")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_opt.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_vlink")))), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.href_base := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 933, a_url);
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.target_base := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_r.c")), 934, a_opt.item.framename)
			if (a_opt.item.plain).to_boolean then
				(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align := 4
			else
				(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align := 0
			end
			if (a_opt.item.plain).to_boolean then
				(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin := 0
			else
				(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin := a_opt.item.margin
			end
			if (a_opt.item.plain).to_boolean then
				(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin := 0
			else
				(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin := a_opt.item.margin
			end
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width := a_opt.item.xw
			l_tmp___3 := {NATURAL_32} 0;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.list_number := l_tmp___3;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.list_level := l_tmp___3.to_integer_32;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.dd_margin := a_opt.item.margin;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.flags := 0
			memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("parattr") + (create {PD_PAR_ATTRIB}.make).offset_of ("bgcolor")))), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (a_opt.c_pointer + (create {PD_DOCUMENT_OPTIONS}.make).offset_of ("default_bg")))), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.invisible := 0;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.namelen := 0;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.options := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.linebreak := 1;
			(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.dontkill := 1
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			url := a_other.url
			head := a_other.head
			redirect := a_other.redirect
			redirect_get := a_other.redirect_get
			length := a_other.length
			incomplete := a_other.incomplete
			tgc := a_other.tgc
			last_modified := a_other.last_modified
			data_size := a_other.data_size
			frag := a_other.frag.twin
			count := a_other.count
			refcount := a_other.refcount
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				url.is_equal (a_other.url) and
				head.is_equal (a_other.head) and
				redirect.is_equal (a_other.redirect) and
				redirect_get = a_other.redirect_get and
				length = a_other.length and
				incomplete = a_other.incomplete and
				tgc = a_other.tgc and
				last_modified.is_equal (a_other.last_modified) and
				data_size = a_other.data_size and
				frag.is_equal (a_other.frag) and
				count = a_other.count and
				refcount = a_other.refcount
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("head"),
					create {CE_STRUCTURE_FIELD}.make ("redirect"),
					create {CE_STRUCTURE_FIELD}.make ("redirect_get"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("incomplete"),
					create {CE_STRUCTURE_FIELD}.make ("tgc"),
					create {CE_STRUCTURE_FIELD}.make ("last_modified"),
					create {CE_STRUCTURE_FIELD}.make ("data_size"),
					create {CE_STRUCTURE_FIELD}.make ("frag"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("refcount")
				>>)
			init_structure_info
		end

end
