class
	PD_COOKIE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_COOKIE]} next.make
			create {CE_CLASS_POINTER [PD_COOKIE]} prev.make
			create {CE_NATURAL_8_POINTER} name.make
			create {CE_NATURAL_8_POINTER} value.make
			create {CE_NATURAL_8_POINTER} server.make
			create {CE_NATURAL_8_POINTER} path.make
			create {CE_NATURAL_8_POINTER} domain.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_COOKIE] assign set_next

	prev: CE_POINTER [PD_COOKIE] assign set_prev

	name: CE_POINTER [NATURAL_8] assign set_name

	value: CE_POINTER [NATURAL_8] assign set_value

	server: CE_POINTER [NATURAL_8] assign set_server

	path: CE_POINTER [NATURAL_8] assign set_path

	domain: CE_POINTER [NATURAL_8] assign set_domain

	expires: INTEGER_32 assign set_expires

	secure: INTEGER_32 assign set_secure

	id: INTEGER_32 assign set_id

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_COOKIE])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_COOKIE])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_server (a_server: CE_POINTER [NATURAL_8])
		do
			server := a_server
			update_memory_field ("server")
		end

	set_path (a_path: CE_POINTER [NATURAL_8])
		do
			path := a_path
			update_memory_field ("path")
		end

	set_domain (a_domain: CE_POINTER [NATURAL_8])
		do
			domain := a_domain
			update_memory_field ("domain")
		end

	set_expires (a_expires: INTEGER_32)
		do
			expires := a_expires
			update_memory_field ("expires")
		end

	set_secure (a_secure: INTEGER_32)
		do
			secure := a_secure
			update_memory_field ("secure")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

feature {ANY} -- public routines

	free_cookie
		do
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 46, create {CE_VOID_POINTER}.make_cast (name))
			update_class_fields -- Current might have been changed; synchronize
			if (not value.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 47, create {CE_VOID_POINTER}.make_cast (value))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not server.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 48, create {CE_VOID_POINTER}.make_cast (server))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not path.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 49, create {CE_VOID_POINTER}.make_cast (path))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not domain.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 50, create {CE_VOID_POINTER}.make_cast (domain))
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	delete_cookie
		local
			l_cd: CE_POINTER [PD_C2_DOMAIN]
			l_d: CE_POINTER [PD_COOKIE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := create {CE_CLASS_POINTER [PD_COOKIE]}.make_cast ((create {P_COOKIES_STATIC}).cookies.item.item.next)
				when 1 then -- loop condition:
					if l_d.is_equal ((create {P_COOKIES_STATIC}).cookies.item) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_d.item.domain), create {CE_INTEGER_8_POINTER}.make_cast (domain))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							l_pos := -1 + 5 -- goto x
						end
				when 3 then
						l_d := l_d.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_cd := create {CE_CLASS_POINTER [PD_C2_DOMAIN]}.make_cast ((create {P_COOKIES_STATIC}).c2_domains.item.item.next)
					from
					until
						not (not (l_break) and then (not l_cd.is_equal ((create {P_COOKIES_STATIC}).c2_domains.item)))
					loop
						l_break := False
						l_tmp___0 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_cd.item.domain)), create {CE_INTEGER_8_POINTER}.make_cast (domain))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.to_boolean then
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_cd))
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_cd.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_cd.item.prev)
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_cd.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_cd.item.next)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_cd))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 186, create {CE_VOID_POINTER}.make_cast (l_cd))
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						if not (l_break) then
							l_cd := l_cd.item.next
						end
					end
					l_break := False
				when 5 then -- x:;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_COOKIE]}.make_shared (c_pointer))).item.free_cookie
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cookies.c")), 192, create {CE_VOID_POINTER}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			name := a_other.name
			value := a_other.value
			server := a_other.server
			path := a_other.path
			domain := a_other.domain
			expires := a_other.expires
			secure := a_other.secure
			id := a_other.id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				name.is_equal (a_other.name) and
				value.is_equal (a_other.value) and
				server.is_equal (a_other.server) and
				path.is_equal (a_other.path) and
				domain.is_equal (a_other.domain) and
				expires = a_other.expires and
				secure = a_other.secure and
				id = a_other.id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("server"),
					create {CE_STRUCTURE_FIELD}.make ("path"),
					create {CE_STRUCTURE_FIELD}.make ("domain"),
					create {CE_STRUCTURE_FIELD}.make ("expires"),
					create {CE_STRUCTURE_FIELD}.make ("secure"),
					create {CE_STRUCTURE_FIELD}.make ("id")
				>>)
			init_structure_info
		end

end
