class
	PD_DOWNLOAD

inherit
	PD_DOWNLOAD_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_DOWNLOAD]} next.make
			create {CE_CLASS_POINTER [PD_DOWNLOAD]} prev.make
			create {CE_NATURAL_8_POINTER} url.make
			create stat.make
			create {CE_NATURAL_8_POINTER} file.make
			create {CE_NATURAL_8_POINTER} prog.make
			create {CE_CLASS_POINTER [PD_SESSION]} ses.make
			create {CE_CLASS_POINTER [PD_WINDOW]} win.make
			create {CE_CLASS_POINTER [PD_WINDOW]} ask.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_DOWNLOAD] assign set_next

	prev: CE_POINTER [PD_DOWNLOAD] assign set_prev

	url: CE_POINTER [NATURAL_8] assign set_url

	stat: PD_STATUS assign set_stat

	file: CE_POINTER [NATURAL_8] assign set_file

	last_pos: INTEGER_32 assign set_last_pos

	handle: INTEGER_32 assign set_handle

	redirect_cnt: INTEGER_32 assign set_redirect_cnt

	prog: CE_POINTER [NATURAL_8] assign set_prog

	prog_flags: INTEGER_32 assign set_prog_flags

	remotetime: INTEGER_32 assign set_remotetime

	ses: CE_POINTER [PD_SESSION] assign set_ses

	win: CE_POINTER [PD_WINDOW] assign set_win

	ask: CE_POINTER [PD_WINDOW] assign set_ask

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_DOWNLOAD])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_DOWNLOAD])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_stat (a_stat: PD_STATUS)
		do
			stat := a_stat
			update_memory_field ("stat")
		end

	set_file (a_file: CE_POINTER [NATURAL_8])
		do
			file := a_file
			update_memory_field ("file")
		end

	set_last_pos (a_last_pos: INTEGER_32)
		do
			last_pos := a_last_pos
			update_memory_field ("last_pos")
		end

	set_handle (a_handle: INTEGER_32)
		do
			handle := a_handle
			update_memory_field ("handle")
		end

	set_redirect_cnt (a_redirect_cnt: INTEGER_32)
		do
			redirect_cnt := a_redirect_cnt
			update_memory_field ("redirect_cnt")
		end

	set_prog (a_prog: CE_POINTER [NATURAL_8])
		do
			prog := a_prog
			update_memory_field ("prog")
		end

	set_prog_flags (a_prog_flags: INTEGER_32)
		do
			prog_flags := a_prog_flags
			update_memory_field ("prog_flags")
		end

	set_remotetime (a_remotetime: INTEGER_32)
		do
			remotetime := a_remotetime
			update_memory_field ("remotetime")
		end

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			ses := a_ses
			update_memory_field ("ses")
		end

	set_win (a_win: CE_POINTER [PD_WINDOW])
		do
			win := a_win
			update_memory_field ("win")
		end

	set_ask (a_ask: CE_POINTER [PD_WINDOW])
		do
			ask := a_ask
			update_memory_field ("ask")
		end

feature {ANY} -- public routines

	abort_download
		do
			if (not win.is_void) then
				win.item.delete_window
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not ask.is_void) then
				ask.item.delete_window
				update_class_fields -- Current might have been changed; synchronize
			end
			if stat.state >= 0 then
				(create {P_SCHED_STATIC}).change_connection (create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (c_pointer + (create {PD_DOWNLOAD}.make).offset_of ("stat")), create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (default_pointer), 5)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 307, create {CE_VOID_POINTER}.make_cast (url))
			update_class_fields -- Current might have been changed; synchronize
			if handle /= -1 then
				(create {P_LINKS_STATIC}).prealloc_truncate (handle, last_pos)
				update_class_fields -- Current might have been changed; synchronize
				close (handle).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not prog.is_void) then
				unlink (create {CE_INTEGER_8_POINTER}.make_cast (file)).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 311, create {CE_VOID_POINTER}.make_cast (prog))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 313, create {CE_VOID_POINTER}.make_cast (file))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 315, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			url := a_other.url
			stat := a_other.stat.twin
			file := a_other.file
			last_pos := a_other.last_pos
			handle := a_other.handle
			redirect_cnt := a_other.redirect_cnt
			prog := a_other.prog
			prog_flags := a_other.prog_flags
			remotetime := a_other.remotetime
			ses := a_other.ses
			win := a_other.win
			ask := a_other.ask
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				url.is_equal (a_other.url) and
				stat.is_equal (a_other.stat) and
				file.is_equal (a_other.file) and
				last_pos = a_other.last_pos and
				handle = a_other.handle and
				redirect_cnt = a_other.redirect_cnt and
				prog.is_equal (a_other.prog) and
				prog_flags = a_other.prog_flags and
				remotetime = a_other.remotetime and
				ses.is_equal (a_other.ses) and
				win.is_equal (a_other.win) and
				ask.is_equal (a_other.ask)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("stat"),
					create {CE_STRUCTURE_FIELD}.make ("file"),
					create {CE_STRUCTURE_FIELD}.make ("last_pos"),
					create {CE_STRUCTURE_FIELD}.make ("handle"),
					create {CE_STRUCTURE_FIELD}.make ("redirect_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("prog"),
					create {CE_STRUCTURE_FIELD}.make ("prog_flags"),
					create {CE_STRUCTURE_FIELD}.make ("remotetime"),
					create {CE_STRUCTURE_FIELD}.make ("ses"),
					create {CE_STRUCTURE_FIELD}.make ("win"),
					create {CE_STRUCTURE_FIELD}.make ("ask")
				>>)
			init_structure_info
		end

end
