class
	PD_F_DATA_C

inherit
	PD_F_DATA_C_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_F_DATA_C]} next.make
			create {CE_CLASS_POINTER [PD_F_DATA_C]} prev.make
			create {CE_NATURAL_8_POINTER} name.make
			create {CE_CLASS_POINTER [PD_F_DATA]} f_data.make
			create {CE_CLASS_POINTER [PD_LINK_BG]} link_bg.make
			create {CE_POINTER_POINTER [NATURAL_8]} search_word.make
			create {CE_CLASS_POINTER [PD_VIEW_STATE]} vs.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_F_DATA_C] assign set_next

	prev: CE_POINTER [PD_F_DATA_C] assign set_prev

	used: INTEGER_32 assign set_used

	name: CE_POINTER [NATURAL_8] assign set_name

	f_data: CE_POINTER [PD_F_DATA] assign set_f_data

	xw: INTEGER_32 assign set_xw

	yw: INTEGER_32 assign set_yw

	xp: INTEGER_32 assign set_xp

	yp: INTEGER_32 assign set_yp

	xl: INTEGER_32 assign set_xl

	yl: INTEGER_32 assign set_yl

	link_bg: CE_POINTER [PD_LINK_BG] assign set_link_bg

	link_bg_n: INTEGER_32 assign set_link_bg_n

	search_word: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_search_word

	vs: CE_POINTER [PD_VIEW_STATE] assign set_vs

	depth: INTEGER_32 assign set_depth

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_F_DATA_C])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_F_DATA_C])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_used (a_used: INTEGER_32)
		do
			used := a_used
			update_memory_field ("used")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_f_data (a_f_data: CE_POINTER [PD_F_DATA])
		do
			f_data := a_f_data
			update_memory_field ("f_data")
		end

	set_xw (a_xw: INTEGER_32)
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: INTEGER_32)
		do
			yw := a_yw
			update_memory_field ("yw")
		end

	set_xp (a_xp: INTEGER_32)
		do
			xp := a_xp
			update_memory_field ("xp")
		end

	set_yp (a_yp: INTEGER_32)
		do
			yp := a_yp
			update_memory_field ("yp")
		end

	set_xl (a_xl: INTEGER_32)
		do
			xl := a_xl
			update_memory_field ("xl")
		end

	set_yl (a_yl: INTEGER_32)
		do
			yl := a_yl
			update_memory_field ("yl")
		end

	set_link_bg (a_link_bg: CE_POINTER [PD_LINK_BG])
		do
			link_bg := a_link_bg
			update_memory_field ("link_bg")
		end

	set_link_bg_n (a_link_bg_n: INTEGER_32)
		do
			link_bg_n := a_link_bg_n
			update_memory_field ("link_bg_n")
		end

	set_search_word (a_search_word: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			search_word := a_search_word
			update_memory_field ("search_word")
		end

	set_vs (a_vs: CE_POINTER [PD_VIEW_STATE])
		do
			vs := a_vs
			update_memory_field ("vs")
		end

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

feature {PD_F_DATA_C} -- private attributes

	hash: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<4_096>>)
		end

	init___0: CE_STATIC [INTEGER_8]
		once ("PROCESS")
			Result.item := (0).to_integer_8
		end

feature {ANY} -- public routines

	detach_formatted
		do
			if (not f_data.is_void) then
				f_data.item.format_cache_reactivate
				update_class_fields -- Current might have been changed; synchronize
				f_data.item.refcount := (f_data.item.refcount) - 1
				update_class_fields -- Current might have been changed; synchronize
				if not (f_data.item.refcount).to_boolean then
					(create {P_HTML_R_STATIC}).format_cache_entries.item := (create {P_HTML_R_STATIC}).format_cache_entries.item + 1
					update_class_fields -- Current might have been changed; synchronize
				end
				if f_data.item.refcount < 0 then
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_LINKS_STATIC}).errline.item := 121
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("format_cache refcount underflow"))])
						update_class_fields -- Current might have been changed; synchronize
					end
					f_data.item.refcount := 0
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.f_data := create {CE_CLASS_POINTER [PD_F_DATA]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.vs := create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if (not link_bg.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 127, create {CE_VOID_POINTER}.make_cast (link_bg))
				update_class_fields -- Current might have been changed; synchronize
				Current.link_bg := create {CE_CLASS_POINTER [PD_LINK_BG]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Current.link_bg_n := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not name.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 128, create {CE_VOID_POINTER}.make_cast (name))
				update_class_fields -- Current might have been changed; synchronize
				Current.name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	check_vs
		local
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_ovx: INTEGER_32
			l_ovy: INTEGER_32
			l_ol: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_vs := vs
			l_ovx := l_vs.item.orig_view_posx
			l_ovy := l_vs.item.orig_view_pos
			l_ol := l_vs.item.orig_link
			if l_vs.item.current_link >= f_data.item.nlinks then
				l_vs.item.current_link := f_data.item.nlinks - 1
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_vs.item.current_link /= -1 then
				l_tmp := ((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.c2_in_view
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp.to_boolean then
					set_pos_x ((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer)), f_data.item.links + vs.item.current_link)
					update_class_fields; -- Current might have been changed; synchronize
					((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.set_pos_y (f_data.item.links + vs.item.current_link)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if l_vs.item.current_link = -1 then
				((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.find_link (1, 0)
				update_class_fields -- Current might have been changed; synchronize
			end
			l_vs.item.orig_view_posx := l_ovx
			update_class_fields -- Current might have been changed; synchronize
			l_vs.item.orig_view_pos := l_ovy
			update_class_fields -- Current might have been changed; synchronize
			l_vs.item.orig_link := l_ol
			update_class_fields -- Current might have been changed; synchronize
		end

	free_link
		do
			if (not link_bg.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 395, create {CE_VOID_POINTER}.make_cast (link_bg))
				update_class_fields -- Current might have been changed; synchronize
				Current.link_bg := create {CE_CLASS_POINTER [PD_LINK_BG]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.link_bg_n := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	get_searched (a_pt: CE_POINTER [CE_POINTER [PD_POINT]]; a_pl: CE_POINTER [INTEGER_32])
		local
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_s1: CE_ARRAY [CE_POINTER [PD_SEARCH]]
			l_s2: CE_ARRAY [CE_POINTER [PD_SEARCH]]
			l_l: INTEGER_32
			l_c: NATURAL_8
			l_points: CE_POINTER [PD_POINT]
			l_len: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: INTEGER_32
			l_return, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_SEARCH]} l_s1.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_SEARCH]} l_s2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xp := xp
					l_yp := yp
					l_xw := xw
					l_yw := yw
					l_vx := vs.item.view_posx
					l_vy := vs.item.view_pos
					l_points := create {CE_CLASS_POINTER [PD_POINT]}.make_shared (default_pointer + -1)
					l_len := 0
					if search_word.is_void then
						l_return := True
					elseif (search_word.item).is_void then
						l_return := True
					elseif not (search_word.item[0]).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						f_data.item.get_search_data
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (search_word.item))
						update_class_fields -- Current might have been changed; synchronize
						l_l := l_tmp.to_integer_32
						l_c := search_word.item[0]
						l_tmp___0 := (create {P_VIEW_STATIC}).get_range (f_data, vs.item.view_pos, yw, l_l, l_s1, l_s2)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_pos := -1 + 13 -- goto ret
						end
				when 2 then
						if not (not (l_return) and then (((l_s1.item).c_pointer.to_integer_32).to_natural_32 <= ((l_s2.item).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						l_continue := False
						if (l_s1.item.item.c).to_integer_32 = l_c.to_integer_32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | c:
						l_continue := True
				when 5 then -- if done
						if (l_return or l_continue) then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						l_i := 1
				when 7 then -- loop condition:
						if not (l_i < l_l) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						if ((l_s1.item + l_i).item.c).to_integer_32 /= (search_word.item[l_i]).to_integer_32 then
							l_pos := -1 + 4 -- goto c
						end
				when 9 then
						l_i := l_i + 1
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_l))
						loop
							l_j := 0
							from
							until
								not (not (l_return) and then (l_j < (l_s1.item + l_i).item.n))
							loop
								l_x := (((l_s1.item + l_i).item.x + l_j) + l_xp) - l_vx
								l_y := ((l_s1.item + l_i).item.y + l_yp) - l_vy
								if l_x >= l_xp then
									if l_y >= l_yp then
										if l_x < l_xp + l_xw then
											if l_y < l_yp + l_yw then
												if not ((l_len).bit_and (63)).to_boolean then
													if l_len.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_POINT}.make).structure_size.to_natural_32 - {NATURAL_32} 64 then
														from
														until
															False
														loop
															(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 488])
															update_class_fields; -- Current might have been changed; synchronize
															(create {P_KBD_STATIC}).fatal_tty_exit
															update_class_fields -- Current might have been changed; synchronize
															exit (4)
															update_class_fields -- Current might have been changed; synchronize
														end
													end
													l_tmp___1 := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 489, create {CE_VOID_POINTER}.make_cast (l_points), (create {PD_POINT}.make).structure_size.to_natural_32 * (l_len + 64).to_natural_32)
													update_class_fields -- Current might have been changed; synchronize
													l_points := create {CE_CLASS_POINTER [PD_POINT]}.make_cast (l_tmp___1)
												end
												(l_points + l_len).item.x := (l_s1.item + l_i).item.x + l_j
												update_class_fields -- Current might have been changed; synchronize
												l_tmp___2 := l_len
												l_len := l_len + 1;
												(l_points + l_tmp___2).item.y := (l_s1.item + l_i).item.y
												update_class_fields -- Current might have been changed; synchronize
											end
										end
									end
								end
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 11 then -- if done
						if (not l_return) then
							l_s1.item := l_s1.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						l_continue := False
				when 13 then -- ret:
						a_pt.item := l_points
						update_class_fields -- Current might have been changed; synchronize
						a_pl.item := l_len
						update_class_fields -- Current might have been changed; synchronize
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_first_link: CE_POINTER [PD_LINK]
		local
			l_i: INTEGER_32
			l_l: CE_POINTER [PD_LINK]
		do
			l_l := f_data.item.links + f_data.item.nlinks
			l_i := vs.item.view_pos
			from
			until
				not (l_i < vs.item.view_pos + yw)
			loop
				if l_i >= 0 then
					if l_i < f_data.item.y then
						if (not (f_data.item.lines1[l_i]).is_void) then
							if ((f_data.item.lines1[l_i]).c_pointer.to_integer_32).to_natural_32 < (l_l.c_pointer.to_integer_32).to_natural_32 then
								l_l := f_data.item.lines1[l_i]
							end
						end
					end
				end
				l_i := l_i + 1
			end
			if l_l.is_equal (f_data.item.links + f_data.item.nlinks) then
				l_l := create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer)
			end
			Result := l_l
		end

	get_last_link: CE_POINTER [PD_LINK]
		local
			l_i: INTEGER_32
			l_l: CE_POINTER [PD_LINK]
		do
			l_l := create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer)
			l_i := vs.item.view_pos
			from
			until
				not (l_i < vs.item.view_pos + yw)
			loop
				if l_i >= 0 then
					if l_i < f_data.item.y then
						if ((f_data.item.lines2[l_i]).c_pointer.to_integer_32).to_natural_32 > (l_l.c_pointer.to_integer_32).to_natural_32 then
							l_l := f_data.item.lines2[l_i]
						end
					end
				end
				l_i := l_i + 1
			end
			Result := l_l
		end

	find_form_state (a_form___0: CE_POINTER [PD_FORM_CONTROL]): CE_POINTER [PD_FORM_STATE]
		require
			not a_form___0.is_void
		local
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_vs := vs
			l_n := a_form___0.item.g_ctrl_num
			if l_n < l_vs.item.form_info_len then
				l_fs := l_vs.item.form_info + l_n
			else
				if l_n.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_FORM_STATE}.make).structure_size.to_natural_32 - {NATURAL_32} 1 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 599])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_KBD_STATIC}).fatal_tty_exit
						update_class_fields -- Current might have been changed; synchronize
						exit (4)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_tmp := (create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 600, create {CE_VOID_POINTER}.make_cast (l_vs.item.form_info), (l_n + 1).to_natural_32 * (create {PD_FORM_STATE}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_fs := create {CE_CLASS_POINTER [PD_FORM_STATE]}.make_cast (l_tmp)
				l_vs.item.form_info := l_fs
				update_class_fields -- Current might have been changed; synchronize
				memset (create {CE_VOID_POINTER}.make_cast ((l_fs + l_vs.item.form_info_len)), 0, ((l_n + 1) - l_vs.item.form_info_len).to_natural_32 * (create {PD_FORM_STATE}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_vs.item.form_info_len := l_n + 1
				update_class_fields -- Current might have been changed; synchronize
				l_fs := l_vs.item.form_info + l_n
			end
			if l_fs.item.form_num = a_form___0.item.form_num then
				if l_fs.item.ctrl_num = a_form___0.item.ctrl_num then
					if l_fs.item.g_ctrl_num = a_form___0.item.g_ctrl_num then
						if l_fs.item.position = a_form___0.item.position then
							if l_fs.item.type = a_form___0.item.type then
								Result := l_fs
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				if (not (l_fs.item.value).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 607, create {CE_VOID_POINTER}.make_cast (l_fs.item.value))
					update_class_fields -- Current might have been changed; synchronize
				end
				memset (create {CE_VOID_POINTER}.make_cast (l_fs), 0, (create {PD_FORM_STATE}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_fs.item.form_num := a_form___0.item.form_num
				update_class_fields -- Current might have been changed; synchronize
				l_fs.item.ctrl_num := a_form___0.item.ctrl_num
				update_class_fields -- Current might have been changed; synchronize
				l_fs.item.g_ctrl_num := a_form___0.item.g_ctrl_num
				update_class_fields -- Current might have been changed; synchronize
				l_fs.item.position := a_form___0.item.position
				update_class_fields -- Current might have been changed; synchronize
				l_fs.item.type := a_form___0.item.type
				update_class_fields -- Current might have been changed; synchronize
				init_ctrl (a_form___0, l_fs)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_fs
			end
		end

	c2_in_view: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if vs.item.current_link /= -1 then
				l_tmp := in_view ((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer)), f_data.item.links + vs.item.current_link)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	next_in_view (a_p, a_d: INTEGER_32; a_fn, a_cntr: CE_ROUTINE): INTEGER_32
		local
			l_p: INTEGER_32
			l_p1___0: INTEGER_32
			l_p2___0: INTEGER_32
			l_y: INTEGER_32
			l_yl: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_p := a_p
			l_p1___0 := f_data.item.nlinks - 1
			l_p2___0 := 0
			l_yl := vs.item.view_pos + yw
			if l_yl > f_data.item.y then
				l_yl := f_data.item.y
			end
			if vs.item.view_pos < 0 then
				l_y := 0
			else
				l_y := vs.item.view_pos
			end
			from
			until
				not (l_y < l_yl)
			loop
				if (not (f_data.item.lines1[l_y]).is_void) then
					if (f_data.item.lines1[l_y]).distance ((f_data.item.links)) < l_p1___0 then
						l_p1___0 := (f_data.item.lines1[l_y]).distance ((f_data.item.links))
					end
				end
				if (not (f_data.item.lines2[l_y]).is_void) then
					if (f_data.item.lines2[l_y]).distance ((f_data.item.links)) > l_p2___0 then
						l_p2___0 := (f_data.item.lines2[l_y]).distance ((f_data.item.links))
					end
				end
				l_y := l_y + 1
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if l_p >= l_p1___0 then
					if not (l_p <= l_p2___0) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					l_tmp := a_fn.integer_32_item ([(create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer)), f_data.item.links + l_p])
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						vs.item.current_link := l_p
						update_class_fields -- Current might have been changed; synchronize
						vs.item.orig_link := vs.item.current_link
						update_class_fields -- Current might have been changed; synchronize
						if (not a_cntr.is_void) then
							a_cntr.call ([(create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer)), f_data.item.links + l_p])
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := 1
						l_return := True
					end
					if not l_return then
						l_p := l_p + a_d
					end
				end
			end
			if not l_return then
				l_break := False
				vs.item.current_link := -1
				update_class_fields -- Current might have been changed; synchronize
				vs.item.orig_link := vs.item.current_link
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	set_pos_y (a_l: CE_POINTER [PD_LINK])
		require
			not a_l.is_void
		local
			l_i: INTEGER_32
			l_ym: INTEGER_32
			l_yl: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_ym := 0
			l_yl := f_data.item.y
			l_i := 0
			from
			until
				not (l_i < a_l.item.n)
			loop
				if (a_l.item.pos + l_i).item.y >= l_ym then
					l_ym := (a_l.item.pos + l_i).item.y + 1
				end
				if (a_l.item.pos + l_i).item.y < l_yl then
					l_yl := (a_l.item.pos + l_i).item.y
				end
				l_i := l_i + 1
			end
			l_tmp := (l_ym + l_yl) // 2 - f_data.item.opt.yw // 2
			vs.item.view_pos := l_tmp
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp > f_data.item.y - f_data.item.opt.yw then
				vs.item.view_pos := f_data.item.y - f_data.item.opt.yw
				update_class_fields -- Current might have been changed; synchronize
			end
			if vs.item.view_pos < 0 then
				vs.item.view_pos := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			vs.item.orig_view_pos := vs.item.view_pos
			update_class_fields -- Current might have been changed; synchronize
		end

	find_link (a_p, a_s: INTEGER_32)
		local
			l_y: INTEGER_32
			l_l: INTEGER_32
			l_link___0: CE_POINTER [PD_LINK]
			l_line: CE_POINTER [CE_POINTER [PD_LINK]]
			l_tmp: CE_POINTER [CE_POINTER [PD_LINK]]
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_p = -1 then
						l_tmp := f_data.item.lines2
					else
						l_tmp := f_data.item.lines1
					end
					l_line := l_tmp
					if a_p = -1 then
						l_y := (vs.item.view_pos + yw) - 1
						if l_y >= f_data.item.y then
							l_y := f_data.item.y - 1
						end
					else
						l_y := vs.item.view_pos
						if l_y < 0 then
							l_y := 0
						end
					end
					if l_y < 0 then
						l_pos := -1 + 3 -- goto nolink
					elseif l_y >= f_data.item.y then
						l_pos := -1 + 3 -- goto nolink
					end
				when 1 then
					l_link___0 := create {CE_CLASS_POINTER [PD_LINK]}.make_shared (default_pointer)
					from
					until
						(l_break)
					loop
						l_break := False
						if (not (l_line[l_y]).is_void) then
							if l_link___0.is_void then
								l_link___0 := l_line[l_y]
							else
								if a_p > 0 then
									l_tmp___0 := (((l_line[l_y]).c_pointer.to_integer_32).to_natural_32 < (l_link___0.c_pointer.to_integer_32).to_natural_32).to_integer
								else
									l_tmp___0 := (((l_line[l_y]).c_pointer.to_integer_32).to_natural_32 > (l_link___0.c_pointer.to_integer_32).to_natural_32).to_integer
								end
								if l_tmp___0.to_boolean then
									l_link___0 := l_line[l_y]
								end
							end
						end
						l_y := l_y + a_p
						if l_y < 0 then
							l_break := True
						elseif l_y < vs.item.view_pos then
							l_break := True
						elseif l_y >= vs.item.view_pos + f_data.item.opt.yw then
							l_break := True
						elseif l_y >= f_data.item.y then
							l_break := True
						end
					end
					l_break := False
					if l_link___0.is_void then
						l_pos := -1 + 3 -- goto nolink
					end
				when 2 then
					l_l := l_link___0.distance ((f_data.item.links))
					if a_s = 0 then
						((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.next_in_view (l_l, a_p, in_view_address, create {CE_ROUTINE}.make_shared (default_pointer)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						vs.item.current_link := l_l
						update_class_fields -- Current might have been changed; synchronize
						vs.item.orig_link := vs.item.current_link
						update_class_fields -- Current might have been changed; synchronize
						set_pos_x ((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer)), l_link___0)
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 3 then -- if: | nolink:
						vs.item.current_link := -1
						update_class_fields -- Current might have been changed; synchronize
						vs.item.orig_link := vs.item.current_link
						update_class_fields -- Current might have been changed; synchronize
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_succesful_controls (a_fc: CE_POINTER [PD_FORM_CONTROL]; a_subm: CE_POINTER [PD_LIST_HEAD])
		require
			not a_subm.is_void
		local
			l_ch: INTEGER_32
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_sub: CE_POINTER [PD_SUBMITTED_VALUE]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_fi: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_sub___0: CE_POINTER [PD_SUBMITTED_VALUE]
			l_nx: CE_POINTER [PD_SUBMITTED_VALUE]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]} l_sub.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_subm))
					update_class_fields -- Current might have been changed; synchronize
					a_subm.item.next := create {CE_VOID_POINTER}.make_cast (a_subm)
					update_class_fields -- Current might have been changed; synchronize
					a_subm.item.prev := create {CE_VOID_POINTER}.make_cast (a_subm)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_subm))
					update_class_fields -- Current might have been changed; synchronize
					l_form___0 := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast (f_data.item.forms.next)
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_form___0.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (f_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms"))))) then
						l_pos := -1 + 26 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						if l_form___0.item.form_num /= a_fc.item.form_num then
							l_pos := -1 + 25 -- skip if block
						end
				when 3 then -- if:
						if l_form___0.item.type = 8 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_form___0.item.type /= 9 then
							if l_form___0.item.type /= 10 then
								l_pos := -1 + 7 -- goto _L___0
							else
								l_pos := -1 + 6 -- goto _L___2
							end
						else
							l_pos := -1 + 6 -- goto _L___2
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else: | _L___2:
						if not (l_form___0.is_equal (a_fc)) then
							l_pos := -1 + 25 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if (l_form___0.item.name).is_void then
							l_pos := -1 + 25 -- skip if block
						end
				when 8 then -- if:
						if not ((l_form___0.item.name[0]).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 9 then -- if:
						if l_form___0.item.type = 9 then
							if (not (l_form___0.item.default_value).is_void) then
								if ((l_form___0.item.default_value).item).to_boolean then
									l_tmp := -1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_fi := l_tmp
						l_fs := ((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.find_form_state (l_form___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_fs.is_void then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if l_form___0.item.type /= 5 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if l_form___0.item.type /= 6 then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if not (l_fs.item.state).to_boolean then
							l_continue := True
						end
				when 15 then -- if done | if done
						if not (l_return or l_break or l_continue) and then (l_form___0.item.type = 7) then
							if not (l_form___0.item.nvalues).to_boolean then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if: | fi_rep:
						l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_242, (create {PD_SUBMITTED_VALUE}.make).structure_size.to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_sub := create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (l_tmp___0)
						memset (create {CE_VOID_POINTER}.make_cast (l_sub), 0, (create {PD_SUBMITTED_VALUE}.make).structure_size.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_sub.item.type := l_form___0.item.type
						update_class_fields -- Current might have been changed; synchronize
						l_sub.item.name := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_245, l_form___0.item.name)
						update_class_fields -- Current might have been changed; synchronize
						inspect l_form___0.item.type -- switch 1 head
						when 1 then l_pos := -1 + 17
						when 2 then l_pos := -1 + 17
						when 3 then l_pos := -1 + 17
						when 4 then l_pos := -1 + 18
						when 5 then l_pos := -1 + 19
						when 6 then l_pos := -1 + 19
						when 8 then l_pos := -1 + 19
						when 11 then l_pos := -1 + 19
						when 7 then l_pos := -1 + 20
						when 9 then l_pos := -1 + 21
						else l_pos := -1 + 23
						end
				when 17 then -- switch 1, case 1 | switch 1, case 2 | switch 1, case 3
						l_sub.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_250, l_fs.item.value)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
				when 18 then -- switch 1, case 4
						l_sub.item.value := encode_textarea (l_fs.item.value)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
				when 19 then -- switch 1, case 5 | switch 1, case 6 | switch 1, case 8 | switch 1, case 11
						l_sub.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_259, l_form___0.item.default_value)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
				when 20 then -- switch 1, case 7
						l_form___0.item.fixup_select_state (l_fs)
						update_class_fields -- Current might have been changed; synchronize
						l_sub.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_263, l_fs.item.value)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
				when 21 then -- switch 1, case 9
						if l_fi = -1 then
							l_sub.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_267, l_form___0.item.default_value)
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 24 -- switch 1; break
						end
				when 22 then
						if l_fi.to_boolean then
							l_tmp___1 := ce_string (".x")
						else
							l_tmp___1 := ce_string (".y")
						end
						(create {P_LINKS_STATIC}).add_to_strn (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (l_sub.c_pointer + (create {PD_SUBMITTED_VALUE}.make).offset_of ("name")), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1))
						update_class_fields -- Current might have been changed; synchronize
						l_sub.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_271, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("1")))
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 24 -- switch 1; break
				when 23 then -- switch 1, default:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_LINKS_STATIC}).errline.item := 1_274
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bad form control type"))])
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_275, create {CE_VOID_POINTER}.make_cast (l_sub))
						update_class_fields -- Current might have been changed; synchronize
						l_continue := True
				when 24 then -- switch 1, done: | if done
						if not (l_return or l_break or l_continue) then
							l_sub.item.position := l_form___0.item.form_num + l_form___0.item.ctrl_num
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_subm))
								update_class_fields -- Current might have been changed; synchronize
								l_sub.item.next := (create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm)).item.next
								update_class_fields -- Current might have been changed; synchronize
								l_sub.item.prev := create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm)
								update_class_fields; -- Current might have been changed; synchronize
								(create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm)).item.next := l_sub
								update_class_fields; -- Current might have been changed; synchronize
								(l_sub.item.next).item.prev := l_sub
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_subm))
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							if l_form___0.item.type = 9 then
								if l_fi < 1 then
									l_fi := l_fi + 1
									l_pos := -1 + 16 -- goto fi_rep
								end
							end
						end
				when 25 then -- if done | if done | if done | if done
						if (not l_return) then
							l_form___0 := l_form___0.item.next
						end
						l_pos := -1 + 1 -- back to loop condition
				when 26 then -- loop done
					l_continue := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_ch := 0
						l_sub___0 := create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm.item.next)
						from
						until
							not (not (l_return) and then (not l_sub___0.is_equal (a_subm)))
						loop
							if not (l_sub___0.item.next).is_equal (a_subm) then
								if (l_sub___0.item.next).item.position < l_sub___0.item.position then
									l_nx := l_sub___0.item.next;
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_sub___0))
									update_class_fields; -- Current might have been changed; synchronize
									(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_sub___0.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_sub___0.item.prev)
									update_class_fields; -- Current might have been changed; synchronize
									(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_sub___0.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_sub___0.item.next)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_sub___0))
									update_class_fields -- Current might have been changed; synchronize
									from
									until
										(l_break)
									loop
										l_break := False;
										(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_nx))
										update_class_fields -- Current might have been changed; synchronize
										l_sub___0.item.next := l_nx.item.next
										update_class_fields -- Current might have been changed; synchronize
										l_sub___0.item.prev := l_nx
										update_class_fields -- Current might have been changed; synchronize
										l_nx.item.next := l_sub___0
										update_class_fields; -- Current might have been changed; synchronize
										(l_sub___0.item.next).item.prev := l_sub___0
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_nx))
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									l_break := False
									l_sub___0 := l_nx
									l_ch := 1
								end
							end
							l_sub___0 := l_sub___0.item.next
						end
						l_sub___0 := create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_subm.item.prev)
						from
						until
							not (not (l_return) and then (not l_sub___0.is_equal (a_subm)))
						loop
							if not (l_sub___0.item.next).is_equal (a_subm) then
								if (l_sub___0.item.next).item.position < l_sub___0.item.position then
									l_nx := l_sub___0.item.next;
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_sub___0))
									update_class_fields; -- Current might have been changed; synchronize
									(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_sub___0.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_sub___0.item.prev)
									update_class_fields; -- Current might have been changed; synchronize
									(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_sub___0.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_sub___0.item.next)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_sub___0))
									update_class_fields -- Current might have been changed; synchronize
									from
									until
										(l_break)
									loop
										l_break := False;
										(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_nx))
										update_class_fields -- Current might have been changed; synchronize
										l_sub___0.item.next := l_nx.item.next
										update_class_fields -- Current might have been changed; synchronize
										l_sub___0.item.prev := l_nx
										update_class_fields -- Current might have been changed; synchronize
										l_nx.item.next := l_sub___0
										update_class_fields; -- Current might have been changed; synchronize
										(l_sub___0.item.next).item.prev := l_sub___0
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_nx))
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
									l_break := False
									l_sub___0 := l_nx
									l_ch := 1
								end
							end
							l_sub___0 := l_sub___0.item.prev
						end
						if not l_ch.to_boolean then
							l_break := True
						end
					end
					l_break := False
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	reset_form (a_form_num: INTEGER_32)
		local
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_fs: CE_POINTER [PD_FORM_STATE]
		do
			l_form___0 := create {CE_CLASS_POINTER [PD_FORM_CONTROL]}.make_cast (f_data.item.forms.next)
			from
			until
				l_form___0.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (f_data.c_pointer + (create {PD_F_DATA}.make).offset_of ("forms")))
			loop
				if l_form___0.item.form_num = a_form_num then
					l_fs := ((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.find_form_state (l_form___0)
					update_class_fields -- Current might have been changed; synchronize
					if (not l_fs.is_void) then
						init_ctrl (l_form___0, l_fs)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_form___0 := l_form___0.item.next
			end
		end

	textarea_adjust_viewport (a_l: CE_POINTER [PD_LINK]): INTEGER_32
		require
			not a_l.is_void
		local
			l_fc: CE_POINTER [PD_FORM_CONTROL]
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_r: INTEGER_32
		do
			l_fc := a_l.item.form
			l_vs := vs
			l_r := 0
			if (a_l.item.pos + 0).item.x + l_fc.item.cols > xw + l_vs.item.view_posx then
				l_vs.item.view_posx := ((a_l.item.pos + 0).item.x + l_fc.item.cols) - xw
				update_class_fields -- Current might have been changed; synchronize
				l_r := 1
			end
			if (a_l.item.pos + 0).item.x < l_vs.item.view_posx then
				l_vs.item.view_posx := (a_l.item.pos + 0).item.x
				update_class_fields -- Current might have been changed; synchronize
				l_r := 1
			end
			if (a_l.item.pos + 0).item.y + l_fc.item.rows > yw + l_vs.item.view_pos then
				l_vs.item.view_pos := ((a_l.item.pos + 0).item.y + l_fc.item.rows) - yw
				update_class_fields -- Current might have been changed; synchronize
				l_r := 1
			end
			if (a_l.item.pos + 0).item.y < l_vs.item.view_pos then
				l_vs.item.view_pos := (a_l.item.pos + 0).item.y
				update_class_fields -- Current might have been changed; synchronize
				l_r := 1
			end
			l_vs.item.orig_view_pos := l_vs.item.view_pos
			update_class_fields -- Current might have been changed; synchronize
			l_vs.item.orig_view_posx := l_vs.item.view_posx
			update_class_fields -- Current might have been changed; synchronize
			Result := l_r
		end

	find_next_link_in_search (a_d: INTEGER_32): INTEGER_32
		local
			l_d: INTEGER_32
			l_pt: CE_ARRAY [CE_POINTER [PD_POINT]]
			l_len: CE_ARRAY [INTEGER_32]
			l_link___0: CE_POINTER [PD_LINK]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_POINT]} l_pt.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
					if l_d /= -2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if l_d /= 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_d := l_d // (2);
						((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.find_link (l_d, 0)
						update_class_fields -- Current might have been changed; synchronize
						if vs.item.current_link = -1 then
							Result := 1
							l_return := True
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | nx:
						if vs.item.current_link = -1 then
							((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.find_link (l_d, 0)
							update_class_fields -- Current might have been changed; synchronize
							Result := 1
							l_return := True
						else
							l_tmp := ((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.next_in_view (vs.item.current_link + l_d, l_d, in_view_address, create {CE_ROUTINE}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp.to_boolean then
								((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.find_link (l_d, 0)
								update_class_fields -- Current might have been changed; synchronize
								Result := 1
								l_return := True
							end
						end
				when 7 then -- if done
					if not l_return then
						l_link___0 := f_data.item.links + vs.item.current_link;
						((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.get_searched (l_pt, l_len)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := point_intersect (l_pt.item, l_len.item, l_link___0.item.pos, l_link___0.item.n)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_907, create {CE_VOID_POINTER}.make_cast (l_pt.item))
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_910, create {CE_VOID_POINTER}.make_cast (l_pt.item))
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 6 -- goto nx
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_link
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.c2_in_view
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				l_return := True
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (c_pointer))).item.find_link (1, 0)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {PD_F_DATA_C_STATIC} -- private routines

	init_ctrl (a_form___0: CE_POINTER [PD_FORM_CONTROL]; a_fs: CE_POINTER [PD_FORM_STATE])
		require
			not a_form___0.is_void
			not a_fs.is_void
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not (a_fs.item.value).is_void) then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 566, create {CE_VOID_POINTER}.make_cast (a_fs.item.value))
						a_fs.item.value := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					inspect a_form___0.item.type -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 5 then l_pos := -1 + 3
					when 6 then l_pos := -1 + 3
					when 7 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 1 | switch 1, case 2 | switch 1, case 4
					a_fs.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 571, a_form___0.item.default_value)
					a_fs.item.state := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_form___0.item.default_value))).to_integer_32
					a_fs.item.vpos := 0
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 3
					a_fs.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 576, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
					a_fs.item.state := 0
					a_fs.item.vpos := 0
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 5 | switch 1, case 6
					a_fs.item.state := a_form___0.item.default_state
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 7
					a_fs.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 585, a_form___0.item.default_value)
					a_fs.item.state := a_form___0.item.default_state
					a_form___0.item.fixup_select_state (a_fs)
					l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_pos_x (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK])
		require
			not a_l.is_void
		local
			l_i: INTEGER_32
			l_xm: INTEGER_32
			l_xl: INTEGER_32
			l_return: BOOLEAN
		do
			l_xm := 0
			l_xl := 2_147_483_647
			l_i := 0
			from
			until
				not (l_i < a_l.item.n)
			loop
				if (a_l.item.pos + l_i).item.y >= (a_f.item.vs).item.view_pos then
					if (a_l.item.pos + l_i).item.y < (a_f.item.vs).item.view_pos + a_f.item.yw then
						if (a_l.item.pos + l_i).item.x >= l_xm then
							l_xm := (a_l.item.pos + l_i).item.x + 1
						end
						if (a_l.item.pos + l_i).item.x < l_xl then
							l_xl := (a_l.item.pos + l_i).item.x
						end
					end
				end
				l_i := l_i + 1
			end
			if l_xl = 2_147_483_647 then
				l_return := True
			end
			if not l_return then
				if (a_f.item.vs).item.view_posx + a_f.item.xw < l_xm then
					(a_f.item.vs).item.view_posx := l_xm - a_f.item.xw
				end
				if (a_f.item.vs).item.view_posx > l_xl then
					(a_f.item.vs).item.view_posx := l_xl
				end
				(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx
			end
		end

	in_view (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): INTEGER_32
		require
			not a_l.is_void
		local
			l_tmp___1: INTEGER_32
		do
			if (in_viewy (a_f, a_l)).to_boolean then
				if (in_viewx (a_f, a_l)).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	in_viewx (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): INTEGER_32
		require
			not a_l.is_void
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < a_l.item.n))
			loop
				if (a_l.item.pos + l_i).item.x >= (a_f.item.vs).item.view_posx then
					if (a_l.item.pos + l_i).item.x < (a_f.item.vs).item.view_posx + a_f.item.xw then
						Result := 1
						l_return := True
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	in_viewy (a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): INTEGER_32
		require
			not a_l.is_void
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			l_i := 0
			from
			until
				not (not (l_return) and then (l_i < a_l.item.n))
			loop
				if (a_l.item.pos + l_i).item.y >= (a_f.item.vs).item.view_pos then
					if (a_l.item.pos + l_i).item.y < (a_f.item.vs).item.view_pos + a_f.item.yw then
						Result := 1
						l_return := True
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	encode_textarea (a_t: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_t.is_void
		local
			l_t: CE_POINTER [NATURAL_8]
			l_len: CE_ARRAY [INTEGER_32]
			l_o: CE_ARRAY [CE_POINTER [NATURAL_8]]
		do
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_o.make (<<1>>)

			l_t := a_t
			l_len.item := 0
			l_o.item := ((create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_212))
			from
			until
				not ((l_t.item).to_boolean)
			loop
				if (l_t.item).to_integer_32 /= 10 then
					(create {P_LINKS_STATIC}).add_chr_to_str (l_o, l_len, l_t.item)
				else
					(create {P_LINKS_STATIC}).add_to_str (l_o, l_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
				end
				l_t := l_t + 1
			end
			Result := (l_o.item)
		end

	point_intersect (a_p1___0: CE_POINTER [PD_POINT]; a_l1: INTEGER_32; a_p2___0: CE_POINTER [PD_POINT]; a_l2: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_return: BOOLEAN
		do
			if not init___0.item.to_boolean then
				memset (create {CE_VOID_POINTER}.make_cast (hash.item), 0, (4_096).to_natural_32).do_nothing
				init___0.item := (1).to_integer_8
			end
			l_i := 0
			from
			until
				not (l_i < a_l1)
			loop
				hash.item[(((((a_p1___0 + l_i).item.y).bit_shift_left (6)) + (a_p1___0 + l_i).item.x)).bit_and (4_095)] := (1).to_integer_8
				l_i := l_i + 1
			end
			l_j := 0
			from
			until
				not (not (l_return) and then (l_j < a_l2))
			loop
				if (hash.item[(((((a_p2___0 + l_j).item.y).bit_shift_left (6)) + (a_p2___0 + l_j).item.x)).bit_and (4_095)]).to_boolean then
					l_i := 0
					from
					until
						not (not (l_return) and then (l_i < a_l1))
					loop
						if (a_p1___0 + l_i).item.x = (a_p2___0 + l_j).item.x then
							if (a_p1___0 + l_i).item.y = (a_p2___0 + l_j).item.y then
								l_i := 0
								from
								until
									not (l_i < a_l1)
								loop
									hash.item[(((((a_p1___0 + l_i).item.y).bit_shift_left (6)) + (a_p1___0 + l_i).item.x)).bit_and (4_095)] := (0).to_integer_8
									l_i := l_i + 1
								end
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							l_i := l_i + 1
						end
					end
				end
				if not l_return then
					l_j := l_j + 1
				end
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < a_l1)
				loop
					hash.item[(((((a_p1___0 + l_i).item.y).bit_shift_left (6)) + (a_p1___0 + l_i).item.x)).bit_and (4_095)] := (0).to_integer_8
					l_i := l_i + 1
				end
				Result := 0
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			used := a_other.used
			name := a_other.name
			f_data := a_other.f_data
			xw := a_other.xw
			yw := a_other.yw
			xp := a_other.xp
			yp := a_other.yp
			xl := a_other.xl
			yl := a_other.yl
			link_bg := a_other.link_bg
			link_bg_n := a_other.link_bg_n
			search_word := a_other.search_word
			vs := a_other.vs
			depth := a_other.depth
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				used = a_other.used and
				name.is_equal (a_other.name) and
				f_data.is_equal (a_other.f_data) and
				xw = a_other.xw and
				yw = a_other.yw and
				xp = a_other.xp and
				yp = a_other.yp and
				xl = a_other.xl and
				yl = a_other.yl and
				link_bg.is_equal (a_other.link_bg) and
				link_bg_n = a_other.link_bg_n and
				search_word.is_equal (a_other.search_word) and
				vs.is_equal (a_other.vs) and
				depth = a_other.depth
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("used"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("f_data"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw"),
					create {CE_STRUCTURE_FIELD}.make ("xp"),
					create {CE_STRUCTURE_FIELD}.make ("yp"),
					create {CE_STRUCTURE_FIELD}.make ("xl"),
					create {CE_STRUCTURE_FIELD}.make ("yl"),
					create {CE_STRUCTURE_FIELD}.make ("link_bg"),
					create {CE_STRUCTURE_FIELD}.make ("link_bg_n"),
					create {CE_STRUCTURE_FIELD}.make ("search_word"),
					create {CE_STRUCTURE_FIELD}.make ("vs"),
					create {CE_STRUCTURE_FIELD}.make ("depth")
				>>)
			init_structure_info
		end

end
