class
	PD_FORM_CONTROL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FORM_CONTROL]} next.make
			create {CE_CLASS_POINTER [PD_FORM_CONTROL]} prev.make
			create {CE_NATURAL_8_POINTER} action.make
			create {CE_NATURAL_8_POINTER} target.make
			create {CE_NATURAL_8_POINTER} name.make
			create {CE_NATURAL_8_POINTER} alt.make
			create {CE_NATURAL_8_POINTER} default_value.make
			create {CE_POINTER_POINTER [NATURAL_8]} values.make
			create {CE_POINTER_POINTER [NATURAL_8]} labels.make
			create {CE_CLASS_POINTER [PD_MENU_ITEM]} menu.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_FORM_CONTROL] assign set_next

	prev: CE_POINTER [PD_FORM_CONTROL] assign set_prev

	form_num: INTEGER_32 assign set_form_num

	ctrl_num: INTEGER_32 assign set_ctrl_num

	g_ctrl_num: INTEGER_32 assign set_g_ctrl_num

	position: INTEGER_32 assign set_position

	method: INTEGER_32 assign set_method

	action: CE_POINTER [NATURAL_8] assign set_action

	target: CE_POINTER [NATURAL_8] assign set_target

	type: INTEGER_32 assign set_type

	name: CE_POINTER [NATURAL_8] assign set_name

	alt: CE_POINTER [NATURAL_8] assign set_alt

	ro: INTEGER_32 assign set_ro

	default_value: CE_POINTER [NATURAL_8] assign set_default_value

	default_state: INTEGER_32 assign set_default_state

	size: INTEGER_32 assign set_size

	cols: INTEGER_32 assign set_cols

	rows: INTEGER_32 assign set_rows

	wrap: INTEGER_32 assign set_wrap

	maxlength: INTEGER_32 assign set_maxlength

	nvalues: INTEGER_32 assign set_nvalues

	values: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_values

	labels: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_labels

	menu: CE_POINTER [PD_MENU_ITEM] assign set_menu

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_FORM_CONTROL])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_FORM_CONTROL])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_form_num (a_form_num: INTEGER_32)
		do
			form_num := a_form_num
			update_memory_field ("form_num")
		end

	set_ctrl_num (a_ctrl_num: INTEGER_32)
		do
			ctrl_num := a_ctrl_num
			update_memory_field ("ctrl_num")
		end

	set_g_ctrl_num (a_g_ctrl_num: INTEGER_32)
		do
			g_ctrl_num := a_g_ctrl_num
			update_memory_field ("g_ctrl_num")
		end

	set_position (a_position: INTEGER_32)
		do
			position := a_position
			update_memory_field ("position")
		end

	set_method (a_method: INTEGER_32)
		do
			method := a_method
			update_memory_field ("method")
		end

	set_action (a_action: CE_POINTER [NATURAL_8])
		do
			action := a_action
			update_memory_field ("action")
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_alt (a_alt: CE_POINTER [NATURAL_8])
		do
			alt := a_alt
			update_memory_field ("alt")
		end

	set_ro (a_ro: INTEGER_32)
		do
			ro := a_ro
			update_memory_field ("ro")
		end

	set_default_value (a_default_value: CE_POINTER [NATURAL_8])
		do
			default_value := a_default_value
			update_memory_field ("default_value")
		end

	set_default_state (a_default_state: INTEGER_32)
		do
			default_state := a_default_state
			update_memory_field ("default_state")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_cols (a_cols: INTEGER_32)
		do
			cols := a_cols
			update_memory_field ("cols")
		end

	set_rows (a_rows: INTEGER_32)
		do
			rows := a_rows
			update_memory_field ("rows")
		end

	set_wrap (a_wrap: INTEGER_32)
		do
			wrap := a_wrap
			update_memory_field ("wrap")
		end

	set_maxlength (a_maxlength: INTEGER_32)
		do
			maxlength := a_maxlength
			update_memory_field ("maxlength")
		end

	set_nvalues (a_nvalues: INTEGER_32)
		do
			nvalues := a_nvalues
			update_memory_field ("nvalues")
		end

	set_values (a_values: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			values := a_values
			update_memory_field ("values")
		end

	set_labels (a_labels: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			labels := a_labels
			update_memory_field ("labels")
		end

	set_menu (a_menu: CE_POINTER [PD_MENU_ITEM])
		do
			menu := a_menu
			update_memory_field ("menu")
		end

feature {ANY} -- public routines

	destroy_fc
		local
			l_i: INTEGER_32
		do
			if (not action.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 37, create {CE_VOID_POINTER}.make_cast (action))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not target.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 38, create {CE_VOID_POINTER}.make_cast (target))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not name.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 39, create {CE_VOID_POINTER}.make_cast (name))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not alt.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 40, create {CE_VOID_POINTER}.make_cast (alt))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not default_value.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 41, create {CE_VOID_POINTER}.make_cast (default_value))
				update_class_fields -- Current might have been changed; synchronize
			end
			l_i := 0
			from
			until
				not (l_i < nvalues)
			loop
				if (not (values[l_i]).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 43, create {CE_VOID_POINTER}.make_cast (values[l_i]))
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not (labels[l_i]).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 44, create {CE_VOID_POINTER}.make_cast (labels[l_i]))
					update_class_fields -- Current might have been changed; synchronize
				end
				l_i := l_i + 1
			end
			if (not values.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 46, create {CE_VOID_POINTER}.make_cast (values))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not labels.is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 47, create {CE_VOID_POINTER}.make_cast (labels))
				update_class_fields -- Current might have been changed; synchronize
			end
			if (not menu.is_void) then
				(create {P_HTML_STATIC}).free_menu (menu)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	area_cursor (a_fs: CE_POINTER [PD_FORM_STATE]): INTEGER_32
		require
			not a_fs.is_void
		local
			l_ln: CE_POINTER [PD_LINE_INFO]
			l_q: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_break: BOOLEAN
		do
			l_q := 0
			l_ln := (create {P_VIEW_STATIC}).format_text (a_fs.item.value, cols, wrap)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_ln.is_void) then
				l_y := 0
				from
				until
					not (not (l_break) and then (not ((l_ln + l_y).item.st).is_void))
				loop
					l_break := False
					if ((a_fs.item.value + a_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln + l_y).item.st).c_pointer.to_integer_32).to_natural_32 then
						if ((a_fs.item.value + a_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln + l_y).item.en + (not ((l_ln + (l_y + 1)).item.st).is_equal ((l_ln + l_y).item.en)).to_integer).c_pointer.to_integer_32).to_natural_32 then
							l_x := (a_fs.item.value + a_fs.item.state).distance (((l_ln + l_y).item.st))
							if wrap.to_boolean then
								if l_x = cols then
									l_x := l_x - 1
								end
							end
							if l_x >= cols + a_fs.item.vpos then
								a_fs.item.vpos := (l_x - cols) + 1
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_x < a_fs.item.vpos then
								a_fs.item.vpos := l_x
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_y >= rows + a_fs.item.vypos then
								a_fs.item.vypos := (l_y - rows) + 1
								update_class_fields -- Current might have been changed; synchronize
							end
							if l_y < a_fs.item.vypos then
								a_fs.item.vypos := l_y
								update_class_fields -- Current might have been changed; synchronize
							end
							l_x := l_x - (a_fs.item.vpos)
							l_y := l_y - (a_fs.item.vypos)
							l_q := l_y * cols + l_x
							l_break := True
						end
					end
					if not (l_break) then
						l_y := l_y + 1
					end
				end
				l_break := False;
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 322, create {CE_VOID_POINTER}.make_cast (l_ln))
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_q
		end

	fixup_select_state (a_fs: CE_POINTER [PD_FORM_STATE])
		require
			not a_fs.is_void
		local
			l_i: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if a_fs.item.state >= 0 then
				if a_fs.item.state < nvalues then
					l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (values[a_fs.item.state]), create {CE_INTEGER_8_POINTER}.make_cast (a_fs.item.value))
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp.to_boolean then
						l_return := True
					end
				end
			end
			if not l_return then
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < nvalues))
				loop
					l_tmp___0 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (values[l_i]), create {CE_INTEGER_8_POINTER}.make_cast (a_fs.item.value))
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___0.to_boolean then
						a_fs.item.state := l_i
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				a_fs.item.state := 0
				update_class_fields -- Current might have been changed; synchronize
				if (not (a_fs.item.value).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 559, create {CE_VOID_POINTER}.make_cast (a_fs.item.value))
					update_class_fields -- Current might have been changed; synchronize
				end
				if nvalues.to_boolean then
					a_fs.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 560, values[0])
					update_class_fields -- Current might have been changed; synchronize
				else
					a_fs.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 561, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			form_num := a_other.form_num
			ctrl_num := a_other.ctrl_num
			g_ctrl_num := a_other.g_ctrl_num
			position := a_other.position
			method := a_other.method
			action := a_other.action
			target := a_other.target
			type := a_other.type
			name := a_other.name
			alt := a_other.alt
			ro := a_other.ro
			default_value := a_other.default_value
			default_state := a_other.default_state
			size := a_other.size
			cols := a_other.cols
			rows := a_other.rows
			wrap := a_other.wrap
			maxlength := a_other.maxlength
			nvalues := a_other.nvalues
			values := a_other.values
			labels := a_other.labels
			menu := a_other.menu
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				form_num = a_other.form_num and
				ctrl_num = a_other.ctrl_num and
				g_ctrl_num = a_other.g_ctrl_num and
				position = a_other.position and
				method = a_other.method and
				action.is_equal (a_other.action) and
				target.is_equal (a_other.target) and
				type = a_other.type and
				name.is_equal (a_other.name) and
				alt.is_equal (a_other.alt) and
				ro = a_other.ro and
				default_value.is_equal (a_other.default_value) and
				default_state = a_other.default_state and
				size = a_other.size and
				cols = a_other.cols and
				rows = a_other.rows and
				wrap = a_other.wrap and
				maxlength = a_other.maxlength and
				nvalues = a_other.nvalues and
				values.is_equal (a_other.values) and
				labels.is_equal (a_other.labels) and
				menu.is_equal (a_other.menu)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("form_num"),
					create {CE_STRUCTURE_FIELD}.make ("ctrl_num"),
					create {CE_STRUCTURE_FIELD}.make ("g_ctrl_num"),
					create {CE_STRUCTURE_FIELD}.make ("position"),
					create {CE_STRUCTURE_FIELD}.make ("method"),
					create {CE_STRUCTURE_FIELD}.make ("action"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("alt"),
					create {CE_STRUCTURE_FIELD}.make ("ro"),
					create {CE_STRUCTURE_FIELD}.make ("default_value"),
					create {CE_STRUCTURE_FIELD}.make ("default_state"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("cols"),
					create {CE_STRUCTURE_FIELD}.make ("rows"),
					create {CE_STRUCTURE_FIELD}.make ("wrap"),
					create {CE_STRUCTURE_FIELD}.make ("maxlength"),
					create {CE_STRUCTURE_FIELD}.make ("nvalues"),
					create {CE_STRUCTURE_FIELD}.make ("values"),
					create {CE_STRUCTURE_FIELD}.make ("labels"),
					create {CE_STRUCTURE_FIELD}.make ("menu")
				>>)
			init_structure_info
		end

end
