class
	PD_FRAMESET_PARAM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FRAMESET_DESC]} parent.make
			create {CE_INTEGER_32_POINTER} xw.make
			create {CE_INTEGER_32_POINTER} yw.make
		end

feature {ANY} -- fields

	parent: CE_POINTER [PD_FRAMESET_DESC] assign set_parent

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	xw: CE_POINTER [INTEGER_32] assign set_xw

	yw: CE_POINTER [INTEGER_32] assign set_yw

feature {ANY} -- field setters

	set_parent (a_parent: CE_POINTER [PD_FRAMESET_DESC])
		do
			parent := a_parent
			update_memory_field ("parent")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_xw (a_xw: CE_POINTER [INTEGER_32])
		do
			xw := a_xw
			update_memory_field ("xw")
		end

	set_yw (a_yw: CE_POINTER [INTEGER_32])
		do
			yw := a_yw
			update_memory_field ("yw")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent := a_other.parent
			x := a_other.x
			y := a_other.y
			xw := a_other.xw
			yw := a_other.yw
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent.is_equal (a_other.parent) and
				x = a_other.x and
				y = a_other.y and
				xw.is_equal (a_other.xw) and
				yw.is_equal (a_other.yw)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("xw"),
					create {CE_STRUCTURE_FIELD}.make ("yw")
				>>)
			init_structure_info
		end

end
