class
	PD_FTP_OPTIONS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} anon_pass.make (<<1_024>>)
		end

feature {ANY} -- fields

	anon_pass: CE_ARRAY [NATURAL_8]

	fast_ftp: INTEGER_32 assign set_fast_ftp

	passive_ftp: INTEGER_32 assign set_passive_ftp

	set_tos: INTEGER_32 assign set_set_tos

feature {ANY} -- field setters

	set_fast_ftp (a_fast_ftp: INTEGER_32)
		do
			fast_ftp := a_fast_ftp
			update_memory_field ("fast_ftp")
		end

	set_passive_ftp (a_passive_ftp: INTEGER_32)
		do
			passive_ftp := a_passive_ftp
			update_memory_field ("passive_ftp")
		end

	set_set_tos (a_set_tos: INTEGER_32)
		do
			set_tos := a_set_tos
			update_memory_field ("set_tos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			anon_pass := a_other.anon_pass.twin
			fast_ftp := a_other.fast_ftp
			passive_ftp := a_other.passive_ftp
			set_tos := a_other.set_tos
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				anon_pass.is_equal (a_other.anon_pass) and
				fast_ftp = a_other.fast_ftp and
				passive_ftp = a_other.passive_ftp and
				set_tos = a_other.set_tos
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("anon_pass", <<1_024>>),
					create {CE_STRUCTURE_FIELD}.make ("fast_ftp"),
					create {CE_STRUCTURE_FIELD}.make ("passive_ftp"),
					create {CE_STRUCTURE_FIELD}.make ("set_tos")
				>>)
			init_structure_info
		end

end
