class
	PD_HTTP_BUGS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	http10: INTEGER_32 assign set_http10

	allow_blacklist: INTEGER_32 assign set_allow_blacklist

	bug_302_redirect: INTEGER_32 assign set_bug_302_redirect

	bug_post_no_keepalive: INTEGER_32 assign set_bug_post_no_keepalive

	no_accept_charset: INTEGER_32 assign set_no_accept_charset

feature {ANY} -- field setters

	set_http10 (a_http10: INTEGER_32)
		do
			http10 := a_http10
			update_memory_field ("http10")
		end

	set_allow_blacklist (a_allow_blacklist: INTEGER_32)
		do
			allow_blacklist := a_allow_blacklist
			update_memory_field ("allow_blacklist")
		end

	set_bug_302_redirect (a_bug_302_redirect: INTEGER_32)
		do
			bug_302_redirect := a_bug_302_redirect
			update_memory_field ("bug_302_redirect")
		end

	set_bug_post_no_keepalive (a_bug_post_no_keepalive: INTEGER_32)
		do
			bug_post_no_keepalive := a_bug_post_no_keepalive
			update_memory_field ("bug_post_no_keepalive")
		end

	set_no_accept_charset (a_no_accept_charset: INTEGER_32)
		do
			no_accept_charset := a_no_accept_charset
			update_memory_field ("no_accept_charset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			http10 := a_other.http10
			allow_blacklist := a_other.allow_blacklist
			bug_302_redirect := a_other.bug_302_redirect
			bug_post_no_keepalive := a_other.bug_post_no_keepalive
			no_accept_charset := a_other.no_accept_charset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				http10 = a_other.http10 and
				allow_blacklist = a_other.allow_blacklist and
				bug_302_redirect = a_other.bug_302_redirect and
				bug_post_no_keepalive = a_other.bug_post_no_keepalive and
				no_accept_charset = a_other.no_accept_charset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("http10"),
					create {CE_STRUCTURE_FIELD}.make ("allow_blacklist"),
					create {CE_STRUCTURE_FIELD}.make ("bug_302_redirect"),
					create {CE_STRUCTURE_FIELD}.make ("bug_post_no_keepalive"),
					create {CE_STRUCTURE_FIELD}.make ("no_accept_charset")
				>>)
			init_structure_info
		end

end
