class
	PD_LINE_INFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} st.make
			create {CE_NATURAL_8_POINTER} en.make
		end

feature {ANY} -- fields

	st: CE_POINTER [NATURAL_8] assign set_st

	en: CE_POINTER [NATURAL_8] assign set_en

feature {ANY} -- field setters

	set_st (a_st: CE_POINTER [NATURAL_8])
		do
			st := a_st
			update_memory_field ("st")
		end

	set_en (a_en: CE_POINTER [NATURAL_8])
		do
			en := a_en
			update_memory_field ("en")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			st := a_other.st
			en := a_other.en
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				st.is_equal (a_other.st) and
				en.is_equal (a_other.en)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("st"),
					create {CE_STRUCTURE_FIELD}.make ("en")
				>>)
			init_structure_info
		end

end
