class
	PD_LINK

inherit
	PD_LINK_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} where.make
			create {CE_NATURAL_8_POINTER} target.make
			create {CE_NATURAL_8_POINTER} where_img.make
			create {CE_CLASS_POINTER [PD_FORM_CONTROL]} form.make
			create {CE_CLASS_POINTER [PD_POINT]} pos.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	num: INTEGER_32 assign set_num

	where: CE_POINTER [NATURAL_8] assign set_where

	target: CE_POINTER [NATURAL_8] assign set_target

	where_img: CE_POINTER [NATURAL_8] assign set_where_img

	form: CE_POINTER [PD_FORM_CONTROL] assign set_form

	sel_color: NATURAL_32 assign set_sel_color

	n: INTEGER_32 assign set_n

	pos: CE_POINTER [PD_POINT] assign set_pos

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_num (a_num: INTEGER_32)
		do
			num := a_num
			update_memory_field ("num")
		end

	set_where (a_where: CE_POINTER [NATURAL_8])
		do
			where := a_where
			update_memory_field ("where")
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_where_img (a_where_img: CE_POINTER [NATURAL_8])
		do
			where_img := a_where_img
			update_memory_field ("where_img")
		end

	set_form (a_form: CE_POINTER [PD_FORM_CONTROL])
		do
			form := a_form
			update_memory_field ("form")
		end

	set_sel_color (a_sel_color: NATURAL_32)
		do
			sel_color := a_sel_color
			update_memory_field ("sel_color")
		end

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_pos (a_pos: CE_POINTER [PD_POINT])
		do
			pos := a_pos
			update_memory_field ("pos")
		end

feature {ANY} -- public routines

	comp_links (a_l2: CE_POINTER [PD_LINK]): INTEGER_32
		require
			not a_l2.is_void
		do
			Result := (num - a_l2.item.num)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			num := a_other.num
			where := a_other.where
			target := a_other.target
			where_img := a_other.where_img
			form := a_other.form
			sel_color := a_other.sel_color
			n := a_other.n
			pos := a_other.pos
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				num = a_other.num and
				where.is_equal (a_other.where) and
				target.is_equal (a_other.target) and
				where_img.is_equal (a_other.where_img) and
				form.is_equal (a_other.form) and
				sel_color = a_other.sel_color and
				n = a_other.n and
				pos.is_equal (a_other.pos)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("num"),
					create {CE_STRUCTURE_FIELD}.make ("where"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("where_img"),
					create {CE_STRUCTURE_FIELD}.make ("form"),
					create {CE_STRUCTURE_FIELD}.make ("sel_color"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("pos")
				>>)
			init_structure_info
		end

end
