class
	PD_LIST_HEAD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} next.make
			create {CE_VOID_POINTER} prev.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [ANY] assign set_next

	prev: CE_POINTER [ANY] assign set_prev

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [ANY])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [ANY])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

feature {ANY} -- public routines

	bookmark_dlg_list_clear
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (next)
			from
			until
				(l_a__.c_pointer = c_pointer)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (prev)
			from
			until
				(l_a__.c_pointer = c_pointer)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.prev
			end
			from
			until
				(next.c_pointer = c_pointer)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 256, create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	bookmark_dlg_list_update: INTEGER_32
		local
			l_bm: CE_POINTER [PD_BOOKMARK]
			l_item: CE_POINTER [PD_BOX_ITEM]
			l_text: CE_POINTER [NATURAL_8]
			l_count: INTEGER_32
			l_id: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_count := 0;
			((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer))).item.bookmark_dlg_list_clear
			update_class_fields -- Current might have been changed; synchronize
			l_bm := create {CE_CLASS_POINTER [PD_BOOKMARK]}.make_cast ((create {P_BOOKMARK_STATIC}).bookmarks.item.item.next)
			from
			until
				not (not (l_return) and then (not l_bm.is_equal ((create {P_BOOKMARK_STATIC}).bookmarks.item)))
			loop
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_bm.item.title))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bookmark.c")), 275, ((create {PD_BOX_ITEM}.make).structure_size.to_natural_32 + l_tmp) + {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_item := create {CE_CLASS_POINTER [PD_BOX_ITEM]}.make_cast (l_tmp___0)
				l_text := create {CE_NATURAL_8_POINTER}.make_cast (l_item) + ((create {PD_BOX_ITEM}.make).structure_size.to_natural_32).to_integer_32
				l_item.item.text := l_text
				update_class_fields -- Current might have been changed; synchronize
				l_id := l_bm.item.id
				l_item.item.data := create {CE_VOID_POINTER}.make_shared (default_pointer + l_id)
				update_class_fields -- Current might have been changed; synchronize
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_text), create {CE_INTEGER_8_POINTER}.make_cast (l_bm.item.title)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_item.item.next := (create {CE_CLASS_POINTER [PD_BOX_ITEM]}.make_shared (c_pointer)).item.next
					update_class_fields -- Current might have been changed; synchronize
					l_item.item.prev := create {CE_CLASS_POINTER [PD_BOX_ITEM]}.make_shared (c_pointer)
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_BOX_ITEM]}.make_shared (c_pointer)).item.next := l_item
					update_class_fields; -- Current might have been changed; synchronize
					(l_item.item.next).item.prev := l_item
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_count := l_count + 1
				l_bm := l_bm.item.next
			end
			Result := l_count
		end

	update_prog (a_p: CE_POINTER [NATURAL_8]; a_s: INTEGER_32)
		local
			l_repl: CE_POINTER [PD_PROTOCOL_PROGRAM]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_repl := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (next)
				when 1 then -- loop condition:
					if (l_repl.c_pointer = c_pointer) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_repl.item.system = a_s then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 507, create {CE_VOID_POINTER}.make_cast (l_repl.item.prog))
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 5 -- goto ss
						end
				when 3 then
						l_repl := l_repl.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_tmp := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 510, (create {PD_PROTOCOL_PROGRAM}.make).structure_size.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_repl := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (l_tmp)
					from
					until
						(l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.next := (create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_shared (c_pointer)).item.next
						update_class_fields -- Current might have been changed; synchronize
						l_repl.item.prev := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_shared (c_pointer)
						update_class_fields; -- Current might have been changed; synchronize
						(create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_shared (c_pointer)).item.next := l_repl
						update_class_fields; -- Current might have been changed; synchronize
						(l_repl.item.next).item.prev := l_repl
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_repl.item.system := a_s
					update_class_fields -- Current might have been changed; synchronize
				when 5 then -- ss:
					l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 514, (1_024).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_repl.item.prog := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)
					update_class_fields -- Current might have been changed; synchronize
					strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_repl.item.prog), create {CE_INTEGER_8_POINTER}.make_cast (a_p), (1_024).to_natural_32).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_repl.item.prog[1_023] := (0).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_prog: CE_POINTER [NATURAL_8]
		local
			l_repl: CE_POINTER [PD_PROTOCOL_PROGRAM]
			l_return: BOOLEAN
		do
			l_repl := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (next)
			from
			until
				not (not (l_return) and then (not (l_repl.c_pointer = c_pointer)))
			loop
				if l_repl.item.system = 1 then
					Result := (l_repl.item.prog)
					l_return := True
				end
				if not l_return then
					l_repl := l_repl.item.next
				end
			end
			if not l_return then
				((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer))).item.update_prog (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 1)
				update_class_fields -- Current might have been changed; synchronize
				l_repl := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (next)
				from
				until
					not (not (l_return) and then (not (l_repl.c_pointer = c_pointer)))
				loop
					if l_repl.item.system = 1 then
						Result := (l_repl.item.prog)
						l_return := True
					end
					if not l_return then
						l_repl := l_repl.item.next
					end
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	free_succesful_controls
		local
			l_v: CE_POINTER [PD_SUBMITTED_VALUE]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			l_v := create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (next)
			from
			until
				(l_v.c_pointer = c_pointer)
			loop
				if (not (l_v.item.name).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_202, create {CE_VOID_POINTER}.make_cast (l_v.item.name))
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not (l_v.item.value).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_203, create {CE_VOID_POINTER}.make_cast (l_v.item.value))
					update_class_fields -- Current might have been changed; synchronize
				end
				if (not (l_v.item.file_content).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_204, l_v.item.file_content)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v := l_v.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (next)
			from
			until
				(l_a__.c_pointer = c_pointer)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (prev)
			from
			until
				(l_a__.c_pointer = c_pointer)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.prev
			end
			from
			until
				(next.c_pointer = c_pointer)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_206, create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	encode_controls (a_data: CE_POINTER [CE_POINTER [NATURAL_8]]; a_len: CE_POINTER [INTEGER_32]; a_cp_from, a_cp_to: INTEGER_32)
		require
			not a_data.is_void
			not a_len.is_void
		local
			l_sv: CE_POINTER [PD_SUBMITTED_VALUE]
			l_lst: INTEGER_32
			l_p2___0: CE_POINTER [INTEGER_8]
			l_convert_table___0: CE_POINTER [PD_CONV_TABLE]
			l_tmp: CE_POINTER [PD_CONV_TABLE]
			l_p: CE_POINTER [NATURAL_8]
			l_o: CE_ARRAY [PD_DOCUMENT_OPTIONS]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
		do
			create {CE_CLASS_ARRAY [PD_DOCUMENT_OPTIONS]} l_o.make (<<1>>)

			l_lst := 0
			l_tmp := (create {P_CHARSETS_STATIC}).get_translation_table (a_cp_from, a_cp_to)
			update_class_fields -- Current might have been changed; synchronize
			l_convert_table___0 := l_tmp
			a_len.item := 0
			update_class_fields -- Current might have been changed; synchronize
			a_data.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_343)
			update_class_fields -- Current might have been changed; synchronize
			l_sv := create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (next)
			from
			until
				(l_sv.c_pointer = c_pointer)
			loop
				l_p := l_sv.item.value
				memset (create {CE_VOID_POINTER}.make_cast (l_o), 0, (create {PD_DOCUMENT_OPTIONS}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_o.item.plain := 1
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_LINKS_STATIC}).d_opt.item := l_o
				update_class_fields -- Current might have been changed; synchronize
				if l_lst.to_boolean then
					(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("&")))
					update_class_fields -- Current might have been changed; synchronize
				else
					l_lst := 1
				end
				encode_string (l_sv.item.name, a_data, a_len)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("=")))
				update_class_fields -- Current might have been changed; synchronize
				if l_sv.item.type = 1 then
					l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := (create {P_CHARSETS_STATIC}).convert_string (l_convert_table___0, l_p, l_tmp___0.to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_p2___0 := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
				elseif l_sv.item.type = 2 then
					l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := (create {P_CHARSETS_STATIC}).convert_string (l_convert_table___0, l_p, l_tmp___0.to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_p2___0 := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
				elseif l_sv.item.type = 4 then
					l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := (create {P_CHARSETS_STATIC}).convert_string (l_convert_table___0, l_p, l_tmp___0.to_integer_32)
					update_class_fields -- Current might have been changed; synchronize
					l_p2___0 := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___1)
				else
					l_tmp___2 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_356, l_p)
					update_class_fields -- Current might have been changed; synchronize
					l_p2___0 := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___2)
				end
				encode_string (create {CE_NATURAL_8_POINTER}.make_cast (l_p2___0), a_data, a_len)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_358, create {CE_VOID_POINTER}.make_cast (l_p2___0))
				update_class_fields -- Current might have been changed; synchronize
				l_sv := l_sv.item.next
			end
		end

feature {PD_LIST_HEAD} -- private routines

	encode_string (a_name: CE_POINTER [NATURAL_8]; a_data: CE_POINTER [CE_POINTER [NATURAL_8]]; a_len: CE_POINTER [INTEGER_32])
		require
			not a_name.is_void
		local
			l_name: CE_POINTER [NATURAL_8]
			l_n: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_n.make (<<4>>)

			l_name := a_name
			from
			until
				not ((l_name.item).to_boolean)
			loop
				if (l_name.item).to_integer_32 = 32 then
					(create {P_LINKS_STATIC}).add_chr_to_str (a_data, a_len, (('+').code).to_natural_8)
				elseif (safe_char (l_name.item)).to_boolean then
					(create {P_LINKS_STATIC}).add_chr_to_str (a_data, a_len, l_name.item)
				else
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_n), ce_string ("%%%%%%02X"), (l_name.item).to_integer_32]).do_nothing;
					(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, l_n)
				end
				l_name := l_name + 1
			end
		end

	safe_char (a_c: NATURAL_8): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c.to_integer_32 >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_c.to_integer_32 <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___1:
						if not (a_c.to_integer_32 >= 65) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_c.to_integer_32 <= 90 then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___0:
						if not (a_c.to_integer_32 >= 97) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_c.to_integer_32 <= 122 then
							l_tmp := 1
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if a_c.to_integer_32 = 46 then
							l_tmp := 1
						elseif a_c.to_integer_32 = 45 then
							l_tmp := 1
						elseif a_c.to_integer_32 = 95 then
							l_tmp := 1
						else
							l_tmp := 0
						end
				when 10 then -- if done | if done
					Result := l_tmp
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev")
				>>)
			init_structure_info
		end

end
