class
	PD_LOCATION

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_LOCATION]} next.make
			create {CE_CLASS_POINTER [PD_LOCATION]} prev.make
			create frames.make
			create stat.make
			create vs.make
			Precursor
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_LOCATION] assign set_next

	prev: CE_POINTER [PD_LOCATION] assign set_prev

	frames: PD_LIST_HEAD assign set_frames

	stat: PD_STATUS assign set_stat

	vs: PD_VIEW_STATE assign set_vs

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_LOCATION])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_LOCATION])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_frames (a_frames: PD_LIST_HEAD)
		do
			frames := a_frames
			update_memory_field ("frames")
		end

	set_stat (a_stat: PD_STATUS)
		do
			stat := a_stat
			update_memory_field ("stat")
		end

	set_vs (a_vs: PD_VIEW_STATE)
		do
			vs := a_vs
			update_memory_field ("vs")
		end

feature {ANY} -- public routines

	destroy_location
		local
			l_frame: CE_POINTER [PD_FRAME]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (next)).item.prev := create {CE_VOID_POINTER}.make_cast (prev)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (prev)).item.next := create {CE_VOID_POINTER}.make_cast (next)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_frame := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (frames.next)
			from
			until
				l_frame.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))
			loop
				(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_frame.c_pointer + (create {PD_FRAME}.make).offset_of ("vs"))).item.destroy_vs
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 190, create {CE_VOID_POINTER}.make_cast (l_frame.item.name))
				update_class_fields -- Current might have been changed; synchronize
				l_frame := l_frame.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
			update_class_fields -- Current might have been changed; synchronize
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (frames.next)
			from
			until
				l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (frames.prev)
			from
			until
				l_a__.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
				l_a__ := l_a__.item.prev
			end
			from
			until
				(frames.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (frames.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 192, create {CE_VOID_POINTER}.make_cast (l_a__))
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("vs"))).item.destroy_vs
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 194, create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	copy_location (a_src: CE_POINTER [PD_LOCATION])
		require
			not a_src.is_void
		local
			l_f: CE_POINTER [PD_FRAME]
			l_nf: CE_POINTER [PD_FRAME]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
			update_class_fields -- Current might have been changed; synchronize
			frames.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))
			update_class_fields -- Current might have been changed; synchronize
			frames.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
			update_class_fields -- Current might have been changed; synchronize
			l_f := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (a_src.item.frames.prev)
			from
			until
				not (not (l_return) and then (not l_f.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_src.c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
			loop
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_f.item.vs.url)))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := (create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 149, ((create {PD_FRAME}.make).structure_size.to_natural_32 + l_tmp) + {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_nf := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast (l_tmp___0)
				l_nf.item.name := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 150, l_f.item.name)
				update_class_fields -- Current might have been changed; synchronize
				l_nf.item.redirect_cnt := 0
				update_class_fields -- Current might have been changed; synchronize
				copy_vs (create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_nf.c_pointer + (create {PD_FRAME}.make).offset_of ("vs")), create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (l_f.c_pointer + (create {PD_FRAME}.make).offset_of ("vs")))
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
					update_class_fields -- Current might have been changed; synchronize
					l_nf.item.next := (create {CE_CLASS_POINTER [PD_FRAME]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))).item.next
					update_class_fields -- Current might have been changed; synchronize
					l_nf.item.prev := create {CE_CLASS_POINTER [PD_FRAME]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [PD_FRAME]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames"))))).item.next := l_nf
					update_class_fields; -- Current might have been changed; synchronize
					(l_nf.item.next).item.prev := l_nf
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("frames")))))
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_f := l_f.item.prev
			end
			copy_vs (create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (c_pointer + (create {PD_LOCATION}.make).offset_of ("vs")), create {CE_CLASS_POINTER [PD_VIEW_STATE]}.make_shared (a_src.c_pointer + (create {PD_LOCATION}.make).offset_of ("vs")))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_LOCATION} -- private routines

	copy_vs (a_dst, a_src: CE_POINTER [PD_VIEW_STATE])
		require
			not a_dst.is_void
			not a_src.is_void
		local
			l_i: INTEGER_32
		do
			memcpy (create {CE_VOID_POINTER}.make_cast (a_dst), create {CE_VOID_POINTER}.make_cast (a_src), (create {PD_VIEW_STATE}.make).structure_size.to_natural_32).do_nothing
			strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((a_dst.item.url)), create {CE_INTEGER_8_POINTER}.make_cast ((a_src.item.url))).do_nothing
			a_dst.item.goto_position := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 136, a_src.item.goto_position)
			a_dst.item.goto_position_end := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 137, a_src.item.goto_position_end)
			if (a_src.item.form_info_len).to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_FORM_STATE}.make).structure_size.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 138]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			a_dst.item.form_info := create {CE_CLASS_POINTER [PD_FORM_STATE]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 139, (a_src.item.form_info_len).to_natural_32 * (create {PD_FORM_STATE}.make).structure_size.to_natural_32)))
			memcpy (create {CE_VOID_POINTER}.make_cast (a_dst.item.form_info), create {CE_VOID_POINTER}.make_cast (a_src.item.form_info), (a_src.item.form_info_len).to_natural_32 * (create {PD_FORM_STATE}.make).structure_size.to_natural_32).do_nothing
			l_i := 0
			from
			until
				not (l_i < a_src.item.form_info_len)
			loop
				if (not ((a_src.item.form_info + l_i).item.value).is_void) then
					(a_dst.item.form_info + l_i).item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 141, (a_src.item.form_info + l_i).item.value)
				end
				l_i := l_i + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			frames := a_other.frames.twin
			stat := a_other.stat.twin
			vs := a_other.vs.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				frames.is_equal (a_other.frames) and
				stat.is_equal (a_other.stat) and
				vs.is_equal (a_other.vs)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("frames"),
					create {CE_STRUCTURE_FIELD}.make ("stat"),
					create {CE_STRUCTURE_FIELD}.make ("vs")
				>>)
			init_structure_info
		end

end
