class
	PD_OPEN_IN_NEW

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} text.make
			create {CE_NATURAL_8_POINTER} hk.make
			create fn.make
		end

feature {ANY} -- fields

	text: CE_POINTER [NATURAL_8] assign set_text

	hk: CE_POINTER [NATURAL_8] assign set_hk

	fn: CE_ROUTINE assign set_fn

feature {ANY} -- field setters

	set_text (a_text: CE_POINTER [NATURAL_8])
		do
			text := a_text
			update_memory_field ("text")
		end

	set_hk (a_hk: CE_POINTER [NATURAL_8])
		do
			hk := a_hk
			update_memory_field ("hk")
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			text := a_other.text
			hk := a_other.hk
			fn := a_other.fn
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				text.is_equal (a_other.text) and
				hk.is_equal (a_other.hk) and
				fn.is_equal (a_other.fn)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("text"),
					create {CE_STRUCTURE_FIELD}.make ("hk"),
					create {CE_STRUCTURE_FIELD}.make ("fn")
				>>)
			init_structure_info
		end

end
