class
	PD_SUBMITTED_VALUE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]} next.make
			create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]} prev.make
			create {CE_NATURAL_8_POINTER} name.make
			create {CE_NATURAL_8_POINTER} value.make
			create {CE_VOID_POINTER} file_content.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_SUBMITTED_VALUE] assign set_next

	prev: CE_POINTER [PD_SUBMITTED_VALUE] assign set_prev

	type: INTEGER_32 assign set_type

	name: CE_POINTER [NATURAL_8] assign set_name

	value: CE_POINTER [NATURAL_8] assign set_value

	file_content: CE_POINTER [ANY] assign set_file_content

	fc_len: INTEGER_32 assign set_fc_len

	position: INTEGER_32 assign set_position

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_SUBMITTED_VALUE])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_SUBMITTED_VALUE])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_value (a_value: CE_POINTER [NATURAL_8])
		do
			value := a_value
			update_memory_field ("value")
		end

	set_file_content (a_file_content: CE_POINTER [ANY])
		do
			file_content := a_file_content
			update_memory_field ("file_content")
		end

	set_fc_len (a_fc_len: INTEGER_32)
		do
			fc_len := a_fc_len
			update_memory_field ("fc_len")
		end

	set_position (a_position: INTEGER_32)
		do
			position := a_position
			update_memory_field ("position")
		end

feature {ANY} -- public routines

	compare_submitted (a_sub2: CE_POINTER [PD_SUBMITTED_VALUE]): INTEGER_32
		require
			not a_sub2.is_void
		do
			Result := (position - a_sub2.item.position)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			type := a_other.type
			name := a_other.name
			value := a_other.value
			file_content := a_other.file_content
			fc_len := a_other.fc_len
			position := a_other.position
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				type = a_other.type and
				name.is_equal (a_other.name) and
				value.is_equal (a_other.value) and
				file_content.is_equal (a_other.file_content) and
				fc_len = a_other.fc_len and
				position = a_other.position
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("file_content"),
					create {CE_STRUCTURE_FIELD}.make ("fc_len"),
					create {CE_STRUCTURE_FIELD}.make ("position")
				>>)
			init_structure_info
		end

end
