class
	PD_TIMER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_TIMER]} next.make
			create {CE_CLASS_POINTER [PD_TIMER]} prev.make
			create func.make
			create {CE_VOID_POINTER} data.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TIMER] assign set_next

	prev: CE_POINTER [PD_TIMER] assign set_prev

	interval: INTEGER_32 assign set_interval

	func: CE_ROUTINE assign set_func

	data: CE_POINTER [ANY] assign set_data

	id: INTEGER_32 assign set_id

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_TIMER])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_prev (a_prev: CE_POINTER [PD_TIMER])
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_interval (a_interval: INTEGER_32)
		do
			interval := a_interval
			update_memory_field ("interval")
		end

	set_func (a_func: CE_ROUTINE)
		do
			func := a_func
			update_memory_field ("func")
		end

	set_data (a_data: CE_POINTER [ANY])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			prev := a_other.prev
			interval := a_other.interval
			func := a_other.func
			data := a_other.data
			id := a_other.id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				prev.is_equal (a_other.prev) and
				interval = a_other.interval and
				func.is_equal (a_other.func) and
				data.is_equal (a_other.data) and
				id = a_other.id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("interval"),
					create {CE_STRUCTURE_FIELD}.make ("func"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("id")
				>>)
			init_structure_info
		end

end
