class
	PD_TRANSLATION

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} name.make
		end

feature {ANY} -- fields

	code: INTEGER_32 assign set_code

	name: CE_POINTER [NATURAL_8] assign set_name

feature {ANY} -- field setters

	set_code (a_code: INTEGER_32)
		do
			code := a_code
			update_memory_field ("code")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			code := a_other.code
			name := a_other.name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				code = a_other.code and
				name.is_equal (a_other.name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("code"),
					create {CE_STRUCTURE_FIELD}.make ("name")
				>>)
			init_structure_info
		end

end
