class
	PD_WTD_DATA

inherit
	PD_WTD_DATA_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SESSION]} ses.make
			create {CE_NATURAL_8_POINTER} url.make
			create {CE_NATURAL_8_POINTER} target.make
			create {CE_NATURAL_8_POINTER} pos.make
			create fn.make
			Precursor
		end

feature {ANY} -- fields

	ses: CE_POINTER [PD_SESSION] assign set_ses

	url: CE_POINTER [NATURAL_8] assign set_url

	pri: INTEGER_32 assign set_pri

	cache: INTEGER_32 assign set_cache

	wtd: INTEGER_32 assign set_wtd

	target: CE_POINTER [NATURAL_8] assign set_target

	pos: CE_POINTER [NATURAL_8] assign set_pos

	fn: CE_ROUTINE assign set_fn

feature {ANY} -- field setters

	set_ses (a_ses: CE_POINTER [PD_SESSION])
		do
			ses := a_ses
			update_memory_field ("ses")
		end

	set_url (a_url: CE_POINTER [NATURAL_8])
		do
			url := a_url
			update_memory_field ("url")
		end

	set_pri (a_pri: INTEGER_32)
		do
			pri := a_pri
			update_memory_field ("pri")
		end

	set_cache (a_cache: INTEGER_32)
		do
			cache := a_cache
			update_memory_field ("cache")
		end

	set_wtd (a_wtd: INTEGER_32)
		do
			wtd := a_wtd
			update_memory_field ("wtd")
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_pos (a_pos: CE_POINTER [NATURAL_8])
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_fn (a_fn: CE_ROUTINE)
		do
			fn := a_fn
			update_memory_field ("fn")
		end

feature {ANY} -- public routines

	post_yes
		do
			ses.item.abort_preloading
			update_class_fields -- Current might have been changed; synchronize
			if (not (ses.item.goto_position).is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 894, create {CE_VOID_POINTER}.make_cast (ses.item.goto_position))
				update_class_fields -- Current might have been changed; synchronize
			end
			ses.item.goto_position := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 895, pos)
			update_class_fields -- Current might have been changed; synchronize
			ses.item.loading.end2 := fn
			update_class_fields -- Current might have been changed; synchronize
			ses.item.loading.data := create {CE_VOID_POINTER}.make_cast (ses)
			update_class_fields -- Current might have been changed; synchronize
			ses.item.loading_url := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("session.c")), 898, url)
			update_class_fields -- Current might have been changed; synchronize
			ses.item.wtd := wtd
			update_class_fields -- Current might have been changed; synchronize
			ses.item.wtd_target := target
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SCHED_STATIC}).load_url (ses.item.loading_url, create {CE_CLASS_POINTER [PD_STATUS]}.make_shared (ses.c_pointer + (create {PD_SESSION}.make).offset_of ("loading")), pri, cache).do_nothing
			update_class_fields -- Current might have been changed; synchronize
		end

	post_no
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			l_tmp := strchr (create {CE_INTEGER_8_POINTER}.make_cast (url), 1)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp[0] := (0).to_integer_8
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_WTD_DATA]}.make_shared (c_pointer))).item.post_yes
			update_class_fields -- Current might have been changed; synchronize
		end

	post_cancel
		do
			ses.item.reload (1)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ses := a_other.ses
			url := a_other.url
			pri := a_other.pri
			cache := a_other.cache
			wtd := a_other.wtd
			target := a_other.target
			pos := a_other.pos
			fn := a_other.fn
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ses.is_equal (a_other.ses) and
				url.is_equal (a_other.url) and
				pri = a_other.pri and
				cache = a_other.cache and
				wtd = a_other.wtd and
				target.is_equal (a_other.target) and
				pos.is_equal (a_other.pos) and
				fn.is_equal (a_other.fn)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ses"),
					create {CE_STRUCTURE_FIELD}.make ("url"),
					create {CE_STRUCTURE_FIELD}.make ("pri"),
					create {CE_STRUCTURE_FIELD}.make ("cache"),
					create {CE_STRUCTURE_FIELD}.make ("wtd"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("fn")
				>>)
			init_structure_info
		end

end
