class
	SD_GROUP

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} gr_name.make
			create {CE_INTEGER_8_POINTER} gr_passwd.make
			create {CE_POINTER_POINTER [INTEGER_8]} gr_mem.make
		end

feature {ANY} -- fields

	gr_name: CE_POINTER [INTEGER_8] assign set_gr_name

	gr_passwd: CE_POINTER [INTEGER_8] assign set_gr_passwd

	gr_gid: NATURAL_32 assign set_gr_gid

	gr_mem: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_gr_mem

feature {ANY} -- field setters

	set_gr_name (a_gr_name: CE_POINTER [INTEGER_8])
		do
			gr_name := a_gr_name
			update_memory_field ("gr_name")
		end

	set_gr_passwd (a_gr_passwd: CE_POINTER [INTEGER_8])
		do
			gr_passwd := a_gr_passwd
			update_memory_field ("gr_passwd")
		end

	set_gr_gid (a_gr_gid: NATURAL_32)
		do
			gr_gid := a_gr_gid
			update_memory_field ("gr_gid")
		end

	set_gr_mem (a_gr_mem: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			gr_mem := a_gr_mem
			update_memory_field ("gr_mem")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			gr_name := a_other.gr_name
			gr_passwd := a_other.gr_passwd
			gr_gid := a_other.gr_gid
			gr_mem := a_other.gr_mem
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				gr_name.is_equal (a_other.gr_name) and
				gr_passwd.is_equal (a_other.gr_passwd) and
				gr_gid = a_other.gr_gid and
				gr_mem.is_equal (a_other.gr_mem)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("gr_name"),
					create {CE_STRUCTURE_FIELD}.make ("gr_passwd"),
					create {CE_STRUCTURE_FIELD}.make ("gr_gid"),
					create {CE_STRUCTURE_FIELD}.make ("gr_mem")
				>>)
			init_structure_info
		end

end
