class
	P_EX_CMDS2_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_CTYPE_STATIC
	S_SYS_TIME_STATIC
	S_STDIO_STATIC
	S_STRING_STATIC
	S_FCNTL_STATIC
	S_SYS_STAT_STATIC
	S_LOCALE_STATIC

feature {ANY} -- public attributes

	script_items: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, ((create {PD_SCRIPTITEM_S}.make).structure_size.to_natural_32).to_integer_32, 4, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

	debug_greedy: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	last_cmd: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	debug_breakpoint_name: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	debug_breakpoint_lnum: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	debug_skipped: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	debug_skipped_name: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	dbg_breakp: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, ((create {PD_DEBUGGY}.make).structure_size.to_natural_32).to_integer_32, 4, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

	buf: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<50>>)
		end

	last_current_SID: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	do_debug (a_cmd: CE_POINTER [NATURAL_8])
		local
			l_save_msg_scroll: INTEGER_32
			l_save_State: INTEGER_32
			l_save_did_emsg: INTEGER_32
			l_save_cmd_silent: INTEGER_32
			l_save_msg_silent: INTEGER_32
			l_save_emsg_silent: INTEGER_32
			l_save_redir_off: INTEGER_32
			l_typeaheadbuf: CE_ARRAY [PD_TASAVE_T]
			l_typeahead_saved: INTEGER_32
			l_save_ignore_script: INTEGER_32
			l_save_ex_normal_busy: INTEGER_32
			l_n: INTEGER_32
			l_cmdline: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_TASAVE_T]} l_typeaheadbuf.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_save_msg_scroll := (create {P_GLOBALS_STATIC}).msg_scroll.item
					l_save_State := (create {P_GLOBALS_STATIC}).State.item
					l_save_did_emsg := (create {P_GLOBALS_STATIC}).did_emsg.item
					l_save_cmd_silent := (create {P_GLOBALS_STATIC}).cmd_silent.item
					l_save_msg_silent := (create {P_GLOBALS_STATIC}).msg_silent.item
					l_save_emsg_silent := (create {P_GLOBALS_STATIC}).emsg_silent.item
					l_save_redir_off := (create {P_GLOBALS_STATIC}).redir_off.item
					l_typeahead_saved := 0
					l_save_ignore_script := 0
					l_cmdline := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_tail := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer);
					(create {P_TERM_STATIC}).settmode (2);
					(create {P_TERM_STATIC}).starttermcap;
					(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item + 1;
					(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1;
					(create {P_GLOBALS_STATIC}).did_emsg.item := 0;
					(create {P_GLOBALS_STATIC}).cmd_silent.item := 0;
					(create {P_GLOBALS_STATIC}).msg_silent.item := 0;
					(create {P_GLOBALS_STATIC}).emsg_silent.item := 0;
					(create {P_GLOBALS_STATIC}).redir_off.item := 1;
					(create {P_GLOBALS_STATIC}).State.item := 1
					if not ((create {P_GLOBALS_STATIC}).debug_did_msg.item).to_boolean then
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Entering Debug mode.  Type %"cont%" to continue."))))).do_nothing
					end
					if not ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
						(create {P_MESSAGE_STATIC}).msg ((create {P_GLOBALS_STATIC}).sourcing_name.item).do_nothing
					end
					if (create {P_GLOBALS_STATIC}).sourcing_lnum.item /= 0 then
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("line %%ld: %%s")))), (create {P_GLOBALS_STATIC}).sourcing_lnum.item, a_cmd]).do_nothing
					else
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("cmd: %%s")))), a_cmd]).do_nothing
					end
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 24 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False;
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 1;
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
						l_save_ex_normal_busy := (create {P_GLOBALS_STATIC}).ex_normal_busy.item;
						(create {P_GLOBALS_STATIC}).ex_normal_busy.item := 0
						if not debug_greedy.item.to_boolean then
							l_typeaheadbuf.item.save_typeahead
							l_typeahead_saved := 1
							l_save_ignore_script := (create {P_GLOBALS_STATIC}).ignore_script.item;
							(create {P_GLOBALS_STATIC}).ignore_script.item := 1
						end
						l_cmdline := (create {P_EX_GETLN_STATIC}).getcmdline_prompt (('>').code, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						if l_typeahead_saved.to_boolean then
							l_typeaheadbuf.item.restore_typeahead;
							(create {P_GLOBALS_STATIC}).ignore_script.item := l_save_ignore_script
						end
						(create {P_GLOBALS_STATIC}).ex_normal_busy.item := l_save_ex_normal_busy;
						(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
						if l_cmdline.is_void then
							l_pos := -1 + 23 -- skip if block
						end
				when 3 then -- if:
						l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_cmdline)
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 99 then l_pos := -1 + 5
						when 110 then l_pos := -1 + 6
						when 115 then l_pos := -1 + 7
						when 102 then l_pos := -1 + 8
						when 113 then l_pos := -1 + 9
						when 105 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 5 then -- switch 1, case 99
						last_cmd.item := 1
						l_tail := ce_string ("ont")
						l_pos := -1 + 12 -- switch 1; break
				when 6 then -- switch 1, case 110
						last_cmd.item := 2
						l_tail := ce_string ("ext")
						l_pos := -1 + 12 -- switch 1; break
				when 7 then -- switch 1, case 115
						last_cmd.item := 3
						l_tail := ce_string ("tep")
						l_pos := -1 + 12 -- switch 1; break
				when 8 then -- switch 1, case 102
						last_cmd.item := 4
						l_tail := ce_string ("inish")
						l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 113
						last_cmd.item := 5
						l_tail := ce_string ("uit")
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 105
						last_cmd.item := 6
						l_tail := ce_string ("nterrupt")
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
						last_cmd.item := 0
				when 12 then -- switch 1, done:
						if last_cmd.item /= 0 then
							l_p___0 := l_p___0 + 1
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0.item).to_integer_32 /= 0 then
									if (l_p___0.item).to_integer_32 /= (l_tail[0]).to_integer_32 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___0 := l_p___0 + 1
									l_tail := l_tail + 1
								end
							end
							l_break := False
							if (l_p___0.item).to_integer_32 < 127 then
								if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
									last_cmd.item := 0
								end
							end
						end
				when 13 then -- if done
						if last_cmd.item = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 14 then -- if:
						inspect last_cmd.item -- switch 2 head
						when 1 then l_pos := -1 + 15
						when 2 then l_pos := -1 + 16
						when 3 then l_pos := -1 + 17
						when 4 then l_pos := -1 + 18
						when 5 then l_pos := -1 + 19
						when 6 then l_pos := -1 + 20
						else l_pos := -1 + 21
						end
				when 15 then -- switch 2, case 1;
						(create {P_GLOBALS_STATIC}).debug_break_level.item := -1
						l_pos := -1 + 21 -- switch 2; break
				when 16 then -- switch 2, case 2;
						(create {P_GLOBALS_STATIC}).debug_break_level.item := (create {P_GLOBALS_STATIC}).ex_nesting_level.item
						l_pos := -1 + 21 -- switch 2; break
				when 17 then -- switch 2, case 3;
						(create {P_GLOBALS_STATIC}).debug_break_level.item := 9_999
						l_pos := -1 + 21 -- switch 2; break
				when 18 then -- switch 2, case 4;
						(create {P_GLOBALS_STATIC}).debug_break_level.item := (create {P_GLOBALS_STATIC}).ex_nesting_level.item - 1
						l_pos := -1 + 21 -- switch 2; break
				when 19 then -- switch 2, case 5;
						(create {P_GLOBALS_STATIC}).got_int.item := 1;
						(create {P_GLOBALS_STATIC}).debug_break_level.item := -1
						l_pos := -1 + 21 -- switch 2; break
				when 20 then -- switch 2, case 6;
						(create {P_GLOBALS_STATIC}).got_int.item := 1;
						(create {P_GLOBALS_STATIC}).debug_break_level.item := 9_999
						last_cmd.item := 3
						l_pos := -1 + 21 -- switch 2; break
				when 21 then -- switch 2, done:
						l_break := True
				when 22 then -- if done
						if not (l_return or l_break) then
							l_n := (create {P_GLOBALS_STATIC}).debug_break_level.item;
							(create {P_GLOBALS_STATIC}).debug_break_level.item := -1;
							(create {P_EX_DOCMD_STATIC}).do_cmdline (l_cmdline, (create {P_EX_GETLN_STATIC}).getexline_address, create {CE_VOID_POINTER}.make_shared (default_pointer), 17).do_nothing;
							(create {P_GLOBALS_STATIC}).debug_break_level.item := l_n;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmdline))
						end
				when 23 then -- if done
						if not (l_return or l_break) then
							(create {P_GLOBALS_STATIC}).lines_left.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32
						end
						l_pos := -1 + 1 -- back to loop condition
				when 24 then -- loop done
					l_break := False;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmdline));
					(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1;
					(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
					(create {P_SCREEN_STATIC}).redraw_all_later (40);
					(create {P_GLOBALS_STATIC}).need_wait_return.item := 0;
					(create {P_GLOBALS_STATIC}).msg_scroll.item := l_save_msg_scroll;
					(create {P_GLOBALS_STATIC}).lines_left.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32;
					(create {P_GLOBALS_STATIC}).State.item := l_save_State;
					(create {P_GLOBALS_STATIC}).did_emsg.item := l_save_did_emsg;
					(create {P_GLOBALS_STATIC}).cmd_silent.item := l_save_cmd_silent;
					(create {P_GLOBALS_STATIC}).msg_silent.item := l_save_msg_silent;
					(create {P_GLOBALS_STATIC}).emsg_silent.item := l_save_emsg_silent;
					(create {P_GLOBALS_STATIC}).redir_off.item := l_save_redir_off;
					(create {P_GLOBALS_STATIC}).debug_did_msg.item := 1
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dbg_check_breakpoint (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			debug_skipped.item := 0
			if not debug_breakpoint_name.item.is_void then
				if not (a_eap.item.skip).to_boolean then
					if (debug_breakpoint_name.item[0]).to_integer_32 = 128 then
						if (debug_breakpoint_name.item[1]).to_integer_32 = 253 then
							if (debug_breakpoint_name.item[2]).to_integer_32 = 82 then
								l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<SNR>"))
							else
								l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							end
						else
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						end
					else
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
					end
					if (l_p___0.item).to_integer_32 = 0 then
						l_tmp := 0
					else
						l_tmp := 3
					end
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Breakpoint in %"%%s%%s%" line %%ld")))), l_p___0, debug_breakpoint_name.item + l_tmp, debug_breakpoint_lnum.item]).do_nothing
					debug_breakpoint_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					do_debug (a_eap.item.cmd)
				else
					debug_skipped.item := 1
					debug_skipped_name.item := debug_breakpoint_name.item
					debug_breakpoint_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
			elseif (create {P_GLOBALS_STATIC}).ex_nesting_level.item <= (create {P_GLOBALS_STATIC}).debug_break_level.item then
				if not (a_eap.item.skip).to_boolean then
					do_debug (a_eap.item.cmd)
				else
					debug_skipped.item := 1
					debug_skipped_name.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
			end
		end

	ex_breaklist (a_eap: CE_POINTER [PD_EXARG])
		local
			l_bp___0: CE_POINTER [PD_DEBUGGY]
			l_i___0: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			if dbg_breakp.item.item.ga_len = 0 then
				(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("No breakpoints defined"))))).do_nothing
			else
				l_i___0 := 0
				from
				until
					not (l_i___0 < dbg_breakp.item.item.ga_len)
				loop
					l_bp___0 := create {CE_CLASS_POINTER [PD_DEBUGGY]}.make_cast (dbg_breakp.item.item.ga_data) + l_i___0
					if l_bp___0.item.dbg_type = 1 then
						l_tmp___0 := ce_string ("func")
					else
						l_tmp___0 := ce_string ("file")
					end
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%%3d  %%s %%s  line %%ld")))), l_bp___0.item.dbg_nr, l_tmp___0, l_bp___0.item.dbg_name, l_bp___0.item.dbg_lnum]).do_nothing
					l_i___0 := l_i___0 + 1
				end
			end
		end

	dbg_find_breakpoint (a_file: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_after: INTEGER_32): INTEGER_32
		do
			Result := (dbg_breakp.item.item.debuggy_find (a_file, a_fname, a_after, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
		end

	dbg_breakpoint (a_name___1: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32)
		do
			debug_breakpoint_name.item := a_name___1
			debug_breakpoint_lnum.item := a_lnum
		end

	profile_start (a_tm: CE_POINTER [SD_TIMEVAL])
		require
			not a_tm.is_void
		do
			gettimeofday (a_tm, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
		end

	profile_end (a_tm: CE_POINTER [SD_TIMEVAL])
		require
			not a_tm.is_void
		local
			l_now: CE_ARRAY [SD_TIMEVAL]
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_now.make (<<1>>)

			gettimeofday (l_now, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
			a_tm.item.tv_usec := l_now.item.tv_usec - a_tm.item.tv_usec
			a_tm.item.tv_sec := l_now.item.tv_sec - a_tm.item.tv_sec
			if a_tm.item.tv_usec < 0 then
				a_tm.item.tv_usec := a_tm.item.tv_usec + (1_000_000)
				a_tm.item.tv_sec := (a_tm.item.tv_sec) - 1
			end
		end

	profile_sub (a_tm, a_tm2: CE_POINTER [SD_TIMEVAL])
		require
			not a_tm.is_void
			not a_tm2.is_void
		do
			a_tm.item.tv_usec := a_tm.item.tv_usec - (a_tm2.item.tv_usec)
			a_tm.item.tv_sec := a_tm.item.tv_sec - (a_tm2.item.tv_sec)
			if a_tm.item.tv_usec < 0 then
				a_tm.item.tv_usec := a_tm.item.tv_usec + (1_000_000)
				a_tm.item.tv_sec := (a_tm.item.tv_sec) - 1
			end
		end

	profile_msg (a_tm: CE_POINTER [SD_TIMEVAL]): CE_POINTER [INTEGER_8]
		require
			not a_tm.is_void
		do
			sprintf ([buf.item, ce_string ("%%3ld.%%06ld"), a_tm.item.tv_sec, a_tm.item.tv_usec]).do_nothing
			Result := buf.item
		end

	profile_setlimit (a_msec: INTEGER_32; a_tm: CE_POINTER [SD_TIMEVAL])
		local
			l_usec: INTEGER_32
		do
			if a_msec <= 0 then
				profile_zero (a_tm)
			else
				gettimeofday (a_tm, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				l_usec := a_tm.item.tv_usec + a_msec * 1_000
				a_tm.item.tv_usec := l_usec \\ 1_000_000
				a_tm.item.tv_sec := a_tm.item.tv_sec + (l_usec // 1_000_000)
			end
		end

	profile_passed_limit (a_tm: CE_POINTER [SD_TIMEVAL]): INTEGER_32
		require
			not a_tm.is_void
		local
			l_now: CE_ARRAY [SD_TIMEVAL]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_now.make (<<1>>)

			if a_tm.item.tv_sec = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				gettimeofday (l_now, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				if l_now.item.tv_sec > a_tm.item.tv_sec then
					l_tmp := 1
				elseif l_now.item.tv_sec = a_tm.item.tv_sec then
					if l_now.item.tv_usec > a_tm.item.tv_usec then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				Result := l_tmp
			end
		end

	profile_zero (a_tm: CE_POINTER [SD_TIMEVAL])
		require
			not a_tm.is_void
		do
			a_tm.item.tv_usec := (0).to_integer_32
			a_tm.item.tv_sec := (0).to_integer_32
		end

	autowrite (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_forceit: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_OPTION_STATIC}).p_aw.item.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if not (((create {P_OPTION_STATIC}).p_awa.item.item).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						Result := 0
						l_return := True
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if not ((a_buf___6.item.bt_dontwrite).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						Result := 0
						l_return := True
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if a_forceit.to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (a_buf___6.item.b_p_ro).to_boolean then
							Result := 0
							l_return := True
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if (a_buf___6.item.b_ffname).is_void then
							Result := 0
							l_return := True
						end
				when 14 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						Result := 0
						l_return := True
				when 16 then -- if done
					if not l_return then
						l_r := a_buf___6.item.buf_write_all (a_forceit)
						if ((create {P_BUFFER_STATIC}).buf_valid (a_buf___6)).to_boolean then
							if (a_buf___6.item.bufIsChanged).to_boolean then
								l_r := 0
							end
						end
						Result := l_r
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	autowrite_all
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_OPTION_STATIC}).p_aw.item.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (((create {P_OPTION_STATIC}).p_awa.item.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if not ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
							l_return := True
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_return := True
				when 7 then -- if done
					if not l_return then
						l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
						from
						until
							l_buf___6.is_void
						loop
							if (l_buf___6.item.bufIsChanged).to_boolean then
								if not (l_buf___6.item.b_p_ro).to_boolean then
									l_buf___6.item.buf_write_all (0).do_nothing
									if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
										l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
									end
								end
							end
							l_buf___6 := l_buf___6.item.b_next
						end
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_changed (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_checkaw, a_mult_win, a_forceit, a_allbuf: INTEGER_32): INTEGER_32
		local
			l_buf2: CE_POINTER [PD_FILE_BUFFER]
			l_count___2: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_forceit.to_boolean then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if not ((a_buf___6.item.bufIsChanged).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						if not (a_mult_win.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 5 then -- else:
						if not (a_buf___6.item.b_nwindows <= 1) then
							l_pos := -1 + 16 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if a_checkaw.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else:
						if (autowrite (a_buf___6, a_forceit)) /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if not (((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
							l_count___2 := 0
							if a_allbuf.to_boolean then
								l_buf2 := (create {P_GLOBALS_STATIC}).firstbuf.item
								from
								until
									l_buf2.is_void
								loop
									if (l_buf2.item.bufIsChanged).to_boolean then
										if not (l_buf2.item.b_ffname).is_void then
											l_count___2 := l_count___2 + 1
										elseif ((create {P_GLOBALS_STATIC}).cmdmod.item.item.browse).to_boolean then
											l_count___2 := l_count___2 + 1
										end
									end
									l_buf2 := l_buf2.item.b_next
								end
							end
							if not ((create {P_BUFFER_STATIC}).buf_valid (a_buf___6)).to_boolean then
								Result := 0
								l_return := True
							end
							if not l_return then
								a_buf___6.item.dialog_changed ((l_count___2 > 1).to_integer)
								if not ((create {P_BUFFER_STATIC}).buf_valid (a_buf___6)).to_boolean then
									Result := 0
									l_return := True
								end
							end
							if not l_return then
								Result := (a_buf___6.item.bufIsChanged)
								l_return := True
							end
						end
				when 15 then -- if done
						if not l_return then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nowrtmsg.item)))))).do_nothing
							Result := 1
							l_return := True
						end
				when 16 then -- if done | if done | if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_changed_any (a_hidden: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_save___0: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (l_return or l_break) then
						l_pos := -1 + 14 -- skip loop
					end
				when 1 then -- loop body:
						l_break := False
						if a_hidden.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_UNDO_STATIC}).curbufIsChanged).to_boolean then
							l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else: | _L___0:
						l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
				when 5 then -- loop condition:
						if not (not (l_break) and then (not l_buf___6.is_void)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if a_hidden.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_buf___6.item.b_nwindows /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (l_buf___6.item.bufIsChanged).to_boolean then
							l_break := True
						end
				when 11 then -- if done
						if not (l_break) then
							l_buf___6 := l_buf___6.item.b_next
						end
						l_pos := -1 + 5 -- back to loop condition
				when 12 then -- loop done
						l_break := False
				when 13 then
						if l_buf___6.is_void then
							Result := 0
							l_return := True
						end
						if not l_return then
							if (check_changed (l_buf___6, (create {P_OPTION_STATIC}).p_awa.item.item, 1, 0, 1)).to_boolean then
								if ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
									l_break := True
								end
							end
						end
						l_pos := -1 + 0 -- back to loop condition
				when 14 then -- loop done
					if not l_return then
						l_break := False;
						(create {P_GLOBALS_STATIC}).exiting.item := 0
						if not ((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean then
								if (create {P_GLOBALS_STATIC}).vgetc_busy.item > 0 then
									(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item;
									(create {P_GLOBALS_STATIC}).msg_col.item := 0;
									(create {P_GLOBALS_STATIC}).msg_didout.item := 0
								end
								if not (l_buf___6.item.buf_spname).is_void then
									l_tmp___5 := create {CE_NATURAL_8_POINTER}.make_cast ((l_buf___6.item.buf_spname))
								else
									l_tmp___5 := l_buf___6.item.b_fname
								end
								if ((create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E162: No write since last change for buffer %"%%s%"")))), l_tmp___5)).to_boolean then
									l_save___0 := (create {P_GLOBALS_STATIC}).no_wait_return.item;
									(create {P_GLOBALS_STATIC}).no_wait_return.item := 0;
									(create {P_MESSAGE_STATIC}).wait_return (0);
									(create {P_GLOBALS_STATIC}).no_wait_return.item := l_save___0
								end
							end
						end
						if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
							from
							until
								not (not (l_return or l_break) and then (not l_wp___0.is_void))
							loop
								l_break := False
								if (l_wp___0.item.w_buffer).is_equal (l_buf___6) then
									(create {P_WINDOW_STATIC}).win_goto (l_wp___0)
									if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
										Result := 1
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_wp___0 := l_wp___0.item.w_next
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							(create {P_BUFFER_STATIC}).set_curbuf (l_buf___6, 0)
						end
						Result := 1
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_fname: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noname.item)))))).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	ex_last (a_eap: CE_POINTER [PD_EXARG])
		do
			do_argfile (a_eap, ((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_len - 1)
		end

	do_argfile (a_eap: CE_POINTER [PD_EXARG]; a_argn: INTEGER_32)
		local
			l_other: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_old_arg_idx: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___10: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_arg_idx := (create {P_GLOBALS_STATIC}).curwin.item.item.w_arg_idx
					if not (a_argn < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 3 then -- else:
						if not (a_argn >= ((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_len) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___1:
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_len <= 1 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E163: There is only one file to edit"))))).do_nothing
						elseif a_argn < 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E164: Cannot go before first file"))))).do_nothing
						else
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E165: Cannot go beyond last file"))))).do_nothing
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 6 then -- else:;
						(create {P_MARK_STATIC}).setpcmark;
						(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1
						if ((a_eap.item.cmd).item).to_integer_32 /= 115 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 9 then -- else:
						if (create {P_GLOBALS_STATIC}).cmdmod.item.item.tab = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if ((create {P_WINDOW_STATIC}).win_split (0, 0)) = 0 then
							l_return := True
						end
						if not l_return then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb := 0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						l_other := 1
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_hide).to_boolean then
							l_p___0 := (create {P_BUFFER_STATIC}).fix_fname (((create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_data) + a_argn).item.alist_name))
							l_other := (create {P_BUFFER_STATIC}).otherfile (l_p___0);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
						if not ((((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_hide).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 13 then -- if:
						if l_other.to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if (check_changed ((create {P_GLOBALS_STATIC}).curbuf.item, 1, (not l_other.to_boolean).to_integer, a_eap.item.forceit, 0)).to_boolean then
							l_return := True
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 14 -- goto _L
				when 17 then -- if done | if done
						if not l_return then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_arg_idx := a_argn
							if a_argn = ((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_len - 1 then
								if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).is_equal ((create {P_GLOBALS_STATIC}).global_alist.item) then
									(create {P_GLOBALS_STATIC}).arg_had_last.item := 1
								end
							end
							if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer).item.buf_hide).to_boolean then
								l_tmp___8 := 1
							else
								l_tmp___8 := 0
							end
							if (a_eap.item.forceit).to_boolean then
								l_tmp___10 := 8
							else
								l_tmp___10 := 0
							end
							if ((create {P_EX_CMDS_STATIC}).do_ecmd (0, ((create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast (((create {P_GLOBALS_STATIC}).curwin.item.item.w_alist).item.al_ga.ga_data) + (create {P_GLOBALS_STATIC}).curwin.item.item.w_arg_idx).item.alist_name), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), a_eap, (-1).to_integer_32, l_tmp___8 + l_tmp___10, (create {P_GLOBALS_STATIC}).curwin.item)) = 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_arg_idx := l_old_arg_idx
							elseif a_eap.item.cmdidx /= 10 then
								(create {P_MARK_STATIC}).setmark (('%'').code).do_nothing
							end
						end
				when 18 then -- if done
					if not l_return then
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	source_callback (a_fname: CE_POINTER [NATURAL_8]; a_cookie: CE_POINTER [ANY])
		do
			do_source (a_fname, 0, 0).do_nothing
		end

	source_runtime (a_name___1: CE_POINTER [NATURAL_8]; a_all: INTEGER_32): INTEGER_32
		do
			Result := (do_in_runtimepath (a_name___1, a_all, source_callback_address, create {CE_VOID_POINTER}.make_shared (default_pointer)))
		end

	do_in_runtimepath (a_name___1: CE_POINTER [NATURAL_8]; a_all: INTEGER_32; a_callback: CE_ROUTINE; a_cookie: CE_POINTER [ANY]): INTEGER_32
		local
			l_rtp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_np: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_buf___6: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_rtp_copy: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_num_files: CE_ARRAY [INTEGER_32]
			l_files: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_i___0: INTEGER_32
			l_did_one: INTEGER_32
			l_tmp___3: NATURAL_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_rtp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_np.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_buf___6.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_num_files.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_files.make (<<1>>)

			l_did_one := 0
			l_rtp_copy := (create {P_MISC2_STATIC}).vim_strsave ((create {P_OPTION_STATIC}).p_rtp.item.item)
			l_buf___6.item := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
			if not (l_buf___6.item).is_void then
				if not l_rtp_copy.is_void then
					if (create {P_OPTION_STATIC}).p_verbose.item.item > 1 then
						(create {P_MESSAGE_STATIC}).verbose_enter;
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Searching for %"%%s%" in %"%%s%"")))), create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_rtp.item.item)]).do_nothing;
						(create {P_MESSAGE_STATIC}).verbose_leave
					end
					l_rtp.item := l_rtp_copy
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if (l_rtp.item.item).to_integer_32 /= 0 then
							if not a_all.to_boolean then
								if l_did_one.to_boolean then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_return or l_break) then
							(create {P_MISC2_STATIC}).copy_option_part (l_rtp, l_buf___6.item, 4_096, ce_string (",")).do_nothing
							l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6.item))
							if (l_tmp___3 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1)))) + {NATURAL_32} 2 < {NATURAL_32} 4_096 then
								(create {P_MISC1_STATIC}).add_pathsep (l_buf___6.item)
								l_tail := l_buf___6.item + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6.item))).to_integer_32
								l_np.item := a_name___1
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (l_np.item.item).to_integer_32 /= 0 then
										if not a_all.to_boolean then
											if l_did_one.to_boolean then
												l_break := True
											end
										end
									else
										l_break := True
									end
									if not (l_return or l_break) then
										(create {P_MISC2_STATIC}).copy_option_part (l_np, l_tail, 4_096 - (l_tail.distance ((l_buf___6.item))), ce_string ("%T ")).do_nothing
										if (create {P_OPTION_STATIC}).p_verbose.item.item > 2 then
											(create {P_MESSAGE_STATIC}).verbose_enter;
											(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Searching for %"%%s%"")))), l_buf___6.item]).do_nothing;
											(create {P_MESSAGE_STATIC}).verbose_leave
										end
										if ((create {P_MISC1_STATIC}).gen_expand_wildcards (1, l_buf___6, l_num_files, l_files, 2)) = 1 then
											l_i___0 := 0
											from
											until
												not (not (l_break) and then (l_i___0 < l_num_files.item))
											loop
												l_break := False
												a_callback.call ([l_files.item[l_i___0], a_cookie])
												l_did_one := 1
												if not a_all.to_boolean then
													l_break := True
												end
												if not (l_break) then
													l_i___0 := l_i___0 + 1
												end
											end
											l_break := False;
											(create {P_MISC1_STATIC}).FreeWild (l_num_files.item, l_files.item)
										end
									end
								end
								l_break := False
							end
						end
					end
					l_break := False
				end
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_rtp_copy))
			if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
				if not l_did_one.to_boolean then
					(create {P_MESSAGE_STATIC}).verbose_enter;
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("not found in %'runtimepath%': %"%%s%"")))), a_name___1]).do_nothing;
					(create {P_MESSAGE_STATIC}).verbose_leave
				end
			end
			if l_did_one.to_boolean then
				l_tmp___6 := 1
			else
				l_tmp___6 := 0
			end
			Result := l_tmp___6
		end

	source_breakpoint (a_cookie: CE_POINTER [ANY]): CE_POINTER [INTEGER_32]
		do
			Result := (create {CE_INTEGER_32_POINTER}.make_shared ((create {CE_CLASS_POINTER [PD_SOURCE_COOKIE]}.make_cast (a_cookie)).c_pointer + (create {PD_SOURCE_COOKIE}.make).offset_of ("breakpoint")))
		end

	source_dbg_tick (a_cookie: CE_POINTER [ANY]): CE_POINTER [INTEGER_32]
		do
			Result := (create {CE_INTEGER_32_POINTER}.make_shared ((create {CE_CLASS_POINTER [PD_SOURCE_COOKIE]}.make_cast (a_cookie)).c_pointer + (create {PD_SOURCE_COOKIE}.make).offset_of ("dbg_tick")))
		end

	source_level (a_cookie: CE_POINTER [ANY]): INTEGER_32
		do
			Result := ((create {CE_CLASS_POINTER [PD_SOURCE_COOKIE]}.make_cast (a_cookie)).item.level)
		end

	fopen_noinh_readbin (a_filename: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		local
			l_fd_tmp: INTEGER_32
			l_fdflags: INTEGER_32
			l_return: BOOLEAN
		do
			l_fd_tmp := (open ([a_filename, 0, 0]))
			if l_fd_tmp = -1 then
				Result := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_fdflags := (fcntl ([l_fd_tmp, 1]))
				if l_fdflags >= 0 then
					if ((l_fdflags).bit_and (1)) = 0 then
						fcntl ([l_fd_tmp, 2, (l_fdflags).bit_or (1)]).do_nothing
					end
				end
				Result := (fdopen (l_fd_tmp, ce_string ("r")))
			end
		end

	do_source (a_fname: CE_POINTER [NATURAL_8]; a_check_other, a_is_vimrc: INTEGER_32): INTEGER_32
		local
			l_cookie: CE_ARRAY [PD_SOURCE_COOKIE]
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_fname_exp: CE_POINTER [NATURAL_8]
			l_firstline: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_save_current_SID: INTEGER_32
			l_save_funccalp: CE_POINTER [ANY]
			l_save_debug_break_level: INTEGER_32
			l_si: CE_POINTER [PD_SCRIPTITEM_S]
			l_st: CE_ARRAY [SD_STAT]
			l_stat_ok: INTEGER_32
			l_tv_rel: CE_ARRAY [SD_TIMEVAL]
			l_tv_start: CE_ARRAY [SD_TIMEVAL]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_SOURCE_COOKIE]} l_cookie.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tv_rel.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tv_start.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_firstline := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_retval := 0
					l_save_debug_break_level := (create {P_GLOBALS_STATIC}).debug_break_level.item
					l_si := create {CE_CLASS_POINTER [PD_SCRIPTITEM_S]}.make_shared (default_pointer)
					l_p___0 := (create {P_MISC1_STATIC}).expand_env_save (a_fname)
					if l_p___0.is_void then
						Result := l_retval
						l_return := True
					end
					if not l_return then
						l_fname_exp := (create {P_BUFFER_STATIC}).fix_fname (l_p___0);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						if l_fname_exp.is_void then
							Result := l_retval
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_fname_exp)).to_boolean then
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Cannot source a directory: %"%%s%"")))), a_fname]).do_nothing
							l_pos := -1 + 31 -- goto theend
						end
				when 2 then
						if ((create {P_FILEIO_STATIC}).has_autocmd ({PC_AUTO_EVENT}.EVENT_SOURCECMD, l_fname_exp, create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))).to_boolean then
							if ((create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_SOURCECMD, l_fname_exp, l_fname_exp, 0, (create {P_GLOBALS_STATIC}).curbuf.item)).to_boolean then
								if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
									l_retval := 0
								else
									l_retval := 1
								end
								l_pos := -1 + 31 -- goto theend
							end
						end
				when 3 then;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_SOURCEPRE, l_fname_exp, l_fname_exp, 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						l_cookie.item.fp := fopen_noinh_readbin (create {CE_INTEGER_8_POINTER}.make_cast (l_fname_exp))
						if not ((l_cookie.item.fp).is_void) then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if not (a_check_other.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 5 then -- if:
						l_p___0 := (create {P_MISC1_STATIC}).gettail (l_fname_exp)
						if (l_p___0.item).to_integer_32 /= 46 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 8 then -- else:
						if (l_p___0.item).to_integer_32 /= 95 then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)), ce_string ("vimrc"))) /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 12 then -- else:
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)), ce_string ("gvimrc"))) /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else:
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)), ce_string ("exrc"))) /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if (l_p___0.item).to_integer_32 = 95 then
							l_p___0.item := (('.').code).to_natural_8
						else
							l_p___0.item := (('_').code).to_natural_8
						end
						l_cookie.item.fp := fopen_noinh_readbin (create {CE_INTEGER_8_POINTER}.make_cast (l_fname_exp))
				when 17 then -- if done | if done | if done | if done | if done | if done
						if (l_cookie.item.fp).is_void then
							if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
								(create {P_MESSAGE_STATIC}).verbose_enter
								if ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("could not source %"%%s%"")))), a_fname]).do_nothing
								else
									(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("line %%ld: could not source %"%%s%"")))), (create {P_GLOBALS_STATIC}).sourcing_lnum.item, a_fname]).do_nothing
								end
								(create {P_MESSAGE_STATIC}).verbose_leave
							end
							l_pos := -1 + 31 -- goto theend
						end
				when 18 then
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 1 then
							(create {P_MESSAGE_STATIC}).verbose_enter
							if ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("sourcing %"%%s%"")))), a_fname]).do_nothing
							else
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("line %%ld: sourcing %"%%s%"")))), (create {P_GLOBALS_STATIC}).sourcing_lnum.item, a_fname]).do_nothing
							end
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
						if a_is_vimrc = 1 then
							(create {P_OPTION_STATIC}).vimrc_found (l_fname_exp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("MYVIMRC")))
						elseif a_is_vimrc = 2 then
							(create {P_OPTION_STATIC}).vimrc_found (l_fname_exp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("MYGVIMRC")))
						end
						l_cookie.item.nextline := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_cookie.item.finished := 0
						l_cookie.item.breakpoint := dbg_find_breakpoint (1, l_fname_exp, (0).to_integer_32)
						l_cookie.item.fname := l_fname_exp
						l_cookie.item.dbg_tick := (create {P_GLOBALS_STATIC}).debug_tick.item
						l_cookie.item.level := (create {P_GLOBALS_STATIC}).ex_nesting_level.item
						l_save_sourcing_name := (create {P_GLOBALS_STATIC}).sourcing_name.item;
						(create {P_GLOBALS_STATIC}).sourcing_name.item := l_fname_exp
						l_save_sourcing_lnum := (create {P_GLOBALS_STATIC}).sourcing_lnum.item;
						(create {P_GLOBALS_STATIC}).sourcing_lnum.item := (0).to_integer_32
						l_cookie.item.conv.vc_type := 0
						l_firstline := getsourceline (0, create {CE_VOID_POINTER}.make_cast (l_cookie), 0)
						if not l_firstline.is_void then
							if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_firstline))) >= {NATURAL_32} 3 then
								if (l_firstline[0]).to_integer_32 = 239 then
									if (l_firstline[1]).to_integer_32 = 187 then
										if (l_firstline[2]).to_integer_32 = 191 then
											(create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (l_cookie.item.c_pointer + (create {PD_SOURCE_COOKIE}.make).offset_of ("conv"))).item.convert_setup (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("utf-8")), (create {P_OPTION_STATIC}).p_enc.item.item).do_nothing
											l_p___0 := (create {P_MBYTE_STATIC}).string_convert (create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (l_cookie.item.c_pointer + (create {PD_SOURCE_COOKIE}.make).offset_of ("conv")), l_firstline + 3, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
											if l_p___0.is_void then
												l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (l_firstline + 3)
											end
											if not l_p___0.is_void then
												(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_firstline))
												l_firstline := l_p___0
											end
										end
									end
								end
							end
						end
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							(create {P_MAIN_STATIC}).time_push (create {CE_VOID_POINTER}.make_cast (l_tv_rel), create {CE_VOID_POINTER}.make_cast (l_tv_start))
						end
						l_save_funccalp := (create {P_EVAL_STATIC}).save_funccal
						l_save_current_SID := (create {P_GLOBALS_STATIC}).current_SID.item
						l_stat_ok := ((stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname_exp), l_st)) >= 0).to_integer;
						(create {P_GLOBALS_STATIC}).current_SID.item := script_items.item.item.ga_len
				when 19 then -- loop condition:
						if not (not (l_break) and then ((create {P_GLOBALS_STATIC}).current_SID.item > 0)) then
							l_pos := -1 + 26 -- skip loop
						end
				when 20 then -- loop body:
						l_break := False
						l_si := create {CE_CLASS_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.item.item.ga_data) + ((create {P_GLOBALS_STATIC}).current_SID.item - 1)
						if (l_si.item.sn_name).is_void then
							l_pos := -1 + 25 -- skip if block
						end
				when 21 then -- if:
						if not (l_stat_ok.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if (l_si.item.sn_dev_valid).to_boolean then
							if l_si.item.sn_dev = l_st.item.st_dev then
								if l_si.item.sn_ino = l_st.item.st_ino then
									l_break := True
								else
									l_pos := -1 + 24 -- goto _L___2
								end
							else
								l_pos := -1 + 24 -- goto _L___2
							end
						else
							l_pos := -1 + 24 -- goto _L___2
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___2:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_si.item.sn_name), create {CE_INTEGER_8_POINTER}.make_cast (l_fname_exp))) = 0 then
							l_break := True
						end
				when 25 then -- if done
						if not (l_break) then
							(create {P_GLOBALS_STATIC}).current_SID.item := (create {P_GLOBALS_STATIC}).current_SID.item - 1
						end
						l_pos := -1 + 19 -- back to loop condition
				when 26 then -- loop done
						l_break := False
						if (create {P_GLOBALS_STATIC}).current_SID.item /= 0 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						last_current_SID.item := last_current_SID.item + 1;
						(create {P_GLOBALS_STATIC}).current_SID.item := last_current_SID.item
						if (script_items.item.item.ga_grow ((create {P_GLOBALS_STATIC}).current_SID.item - script_items.item.item.ga_len)) = 0 then
							l_pos := -1 + 30 -- goto almosttheend
						end
				when 28 then
						from
						until
							not (script_items.item.item.ga_len < (create {P_GLOBALS_STATIC}).current_SID.item)
						loop
							script_items.item.item.ga_len := (script_items.item.item.ga_len) + 1;
							(create {CE_CLASS_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.item.item.ga_data) + (script_items.item.item.ga_len - 1)).item.sn_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						l_si := create {CE_CLASS_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.item.item.ga_data) + ((create {P_GLOBALS_STATIC}).current_SID.item - 1)
						l_si.item.sn_name := l_fname_exp
						l_fname_exp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if l_stat_ok.to_boolean then
							l_si.item.sn_dev_valid := 1
							l_si.item.sn_dev := l_st.item.st_dev
							l_si.item.sn_ino := l_st.item.st_ino
						else
							l_si.item.sn_dev_valid := 0
						end
						(create {P_EVAL_STATIC}).new_script_vars ((create {P_GLOBALS_STATIC}).current_SID.item)
				when 29 then -- if done;
						(create {P_EX_DOCMD_STATIC}).do_cmdline (l_firstline, getsourceline_address, create {CE_VOID_POINTER}.make_cast (l_cookie), 7).do_nothing
						l_retval := 1
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item)))))).do_nothing
						end
						(create {P_GLOBALS_STATIC}).sourcing_name.item := l_save_sourcing_name;
						(create {P_GLOBALS_STATIC}).sourcing_lnum.item := l_save_sourcing_lnum
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 1 then
							(create {P_MESSAGE_STATIC}).verbose_enter;
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("finished sourcing %%s")))), a_fname]).do_nothing
							if not ((create {P_GLOBALS_STATIC}).sourcing_name.item).is_void then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("continuing in %%s")))), (create {P_GLOBALS_STATIC}).sourcing_name.item]).do_nothing
							end
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("sourcing %%s"), a_fname]).do_nothing;
							(create {P_MAIN_STATIC}).time_msg (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_VOID_POINTER}.make_cast (l_tv_start));
							(create {P_MAIN_STATIC}).time_pop (create {CE_VOID_POINTER}.make_cast (l_tv_rel))
						end
						if l_save_debug_break_level > (create {P_GLOBALS_STATIC}).ex_nesting_level.item then
							if (create {P_GLOBALS_STATIC}).debug_break_level.item = (create {P_GLOBALS_STATIC}).ex_nesting_level.item then
								(create {P_GLOBALS_STATIC}).debug_break_level.item := (create {P_GLOBALS_STATIC}).debug_break_level.item + 1
							end
						end
				when 30 then -- almosttheend:;
						(create {P_GLOBALS_STATIC}).current_SID.item := l_save_current_SID;
						(create {P_EVAL_STATIC}).restore_funccal (l_save_funccalp)
						fclose (l_cookie.item.fp).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cookie.item.nextline));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_firstline));
						(create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (l_cookie.item.c_pointer + (create {PD_SOURCE_COOKIE}.make).offset_of ("conv"))).item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
				when 31 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fname_exp))
						Result := l_retval
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_scriptnames (a_eap: CE_POINTER [PD_EXARG])
		local
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_i___0 := 1
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i___0 <= script_items.item.item.ga_len then
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if not ((create {CE_CLASS_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.item.item.ga_data) + (l_i___0 - 1)).item.sn_name).is_void then
						(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%3d: %%s")), l_i___0, (create {CE_CLASS_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.item.item.ga_data) + (l_i___0 - 1)).item.sn_name]).do_nothing
					end
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
		end

	get_scriptname (a_id: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_id = -1 then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("modeline")))))
				l_return := True
			end
			if not l_return and then (a_id = -2) then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("--cmd argument")))))
				l_return := True
			end
			if not l_return and then (a_id = -3) then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("-c argument")))))
				l_return := True
			end
			if not l_return and then (a_id = -4) then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("environment variable")))))
				l_return := True
			end
			if not l_return and then (a_id = -5) then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("error handler")))))
				l_return := True
			end
			if not l_return then
				Result := ((create {CE_CLASS_POINTER [PD_SCRIPTITEM_S]}.make_cast (script_items.item.item.ga_data) + (a_id - 1)).item.sn_name)
			end
		end

	getsourceline (a_c: INTEGER_32; a_cookie: CE_POINTER [ANY]; a_indent: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_sp: CE_POINTER [PD_SOURCE_COOKIE]
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_break: BOOLEAN
		do
			create {CE_NATURAL_8_POINTER} l_p___0.make
			create {CE_NATURAL_8_POINTER} l_s.make

			l_sp := create {CE_CLASS_POINTER [PD_SOURCE_COOKIE]}.make_cast (a_cookie)
			if l_sp.item.dbg_tick < (create {P_GLOBALS_STATIC}).debug_tick.item then
				l_sp.item.breakpoint := dbg_find_breakpoint (1, l_sp.item.fname, (create {P_GLOBALS_STATIC}).sourcing_lnum.item)
				l_sp.item.dbg_tick := (create {P_GLOBALS_STATIC}).debug_tick.item
			end
			if (l_sp.item.finished).to_boolean then
				l_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			elseif (l_sp.item.nextline).is_void then
				l_line := get_one_sourceline (l_sp)
			else
				l_line := l_sp.item.nextline
				l_sp.item.nextline := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
				(create {P_GLOBALS_STATIC}).sourcing_lnum.item := (create {P_GLOBALS_STATIC}).sourcing_lnum.item + 1
			end
			if not l_line.is_void then
				if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('C').code)).is_void then
					(create {P_GLOBALS_STATIC}).sourcing_lnum.item := (create {P_GLOBALS_STATIC}).sourcing_lnum.item - 1
					from
					until
						(l_break)
					loop
						l_break := False
						l_sp.item.nextline := get_one_sourceline (l_sp)
						if (l_sp.item.nextline).is_void then
							l_break := True
						end
						if not (l_break) then
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_sp.item.nextline)
							if (l_p___0.item).to_integer_32 /= 92 then
								l_break := True
							end
						end
						if not (l_break) then
							l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))
							l_s := (create {P_MISC2_STATIC}).alloc (l_tmp + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))))
							if l_s.is_void then
								l_break := True
							end
						end
						if not (l_break) then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (l_line)).do_nothing
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1))).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line))
							l_line := l_s;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_sp.item.nextline))
						end
					end
					l_break := False
				end
			end
			if not l_line.is_void then
				if l_sp.item.conv.vc_type /= 0 then
					l_s := (create {P_MBYTE_STATIC}).string_convert (create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (l_sp.c_pointer + (create {PD_SOURCE_COOKIE}.make).offset_of ("conv")), l_line, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					if not l_s.is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_line))
						l_line := l_s
					end
				end
			end
			if l_sp.item.breakpoint /= 0 then
				if l_sp.item.breakpoint <= (create {P_GLOBALS_STATIC}).sourcing_lnum.item then
					dbg_breakpoint (l_sp.item.fname, (create {P_GLOBALS_STATIC}).sourcing_lnum.item)
					l_sp.item.breakpoint := dbg_find_breakpoint (1, l_sp.item.fname, (create {P_GLOBALS_STATIC}).sourcing_lnum.item)
					l_sp.item.dbg_tick := (create {P_GLOBALS_STATIC}).debug_tick.item
				end
			end
			Result := l_line
		end

	get_one_sourceline (a_sp: CE_POINTER [PD_SOURCE_COOKIE]): CE_POINTER [NATURAL_8]
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			l_have_read: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_buf___6.make

			l_have_read := 0
			l_ga.item.ga_init2 (1, 250);
			(create {P_GLOBALS_STATIC}).sourcing_lnum.item := (create {P_GLOBALS_STATIC}).sourcing_lnum.item + 1
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_continue := False
				if (l_ga.item.ga_grow (120)) = 0 then
					l_break := True
				end
				if not (l_return or l_break or l_continue) then
					l_buf___6 := create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data)
					if (fgets ((create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6) + l_ga.item.ga_len), l_ga.item.ga_maxlen - l_ga.item.ga_len, a_sp.item.fp)).is_void then
						l_break := True
					end
				end
				if not (l_return or l_break or l_continue) then
					l_len := l_ga.item.ga_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_ga.item.ga_len)))).to_integer_32
					l_have_read := 1
					l_ga.item.ga_len := l_len
					if l_ga.item.ga_maxlen - l_ga.item.ga_len = 1 then
						if (l_buf___6[(l_len - 1)]).to_integer_32 /= 10 then
							l_continue := True
						end
					end
				end
				if not (l_return or l_break or l_continue) and then (l_len >= 1) then
					if (l_buf___6[(l_len - 1)]).to_integer_32 = 10 then
						l_c := l_len - 2
						from
						until
							(l_break)
						loop
							l_break := False
							if l_c >= 0 then
								if (l_buf___6[l_c]).to_integer_32 /= 22 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_c := l_c - 1
							end
						end
						l_break := False
						if ((l_len).bit_and (1)) /= ((l_c).bit_and (1)) then
							(create {P_GLOBALS_STATIC}).sourcing_lnum.item := (create {P_GLOBALS_STATIC}).sourcing_lnum.item + 1
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_buf___6[(l_len - 1)] := (('%/0/').code).to_natural_8
						end
					end
				end
				if not (l_return or l_break or l_continue) then
					(create {P_MISC1_STATIC}).line_breakcheck
					l_break := True
				end
				if (not l_return and not l_break) then
					
				end
			end
			l_break := False
			l_continue := False
			if l_have_read.to_boolean then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data))
				l_return := True
			end
			if not l_return then
				(create {P_MISC2_STATIC}).vim_free (l_ga.item.ga_data)
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	source_finished (a_fgetline: CE_ROUTINE; a_cookie: CE_POINTER [ANY]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if ((create {P_EX_DOCMD_STATIC}).getline_equal (a_fgetline, a_cookie, getsourceline_address)).to_boolean then
				if ((create {CE_CLASS_POINTER [PD_SOURCE_COOKIE]}.make_cast (((create {P_EX_DOCMD_STATIC}).getline_cookie (a_fgetline, a_cookie)))).item.finished).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	get_locale_val (a_what: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_loc: CE_POINTER [INTEGER_8]
		do
			l_loc := setlocale (a_what, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
			Result := l_loc
		end

	get_mess_lang: CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((get_locale_val (5)))
			Result := l_p___0
		end

	set_lang_var
		local
			l_loc: CE_POINTER [NATURAL_8]
		do
			l_loc := create {CE_NATURAL_8_POINTER}.make_cast ((get_locale_val (0)));
			(create {P_EVAL_STATIC}).set_vim_var_string (14, l_loc, -1)
			l_loc := create {CE_NATURAL_8_POINTER}.make_cast ((get_locale_val (5)));
			(create {P_EVAL_STATIC}).set_vim_var_string (12, l_loc, -1)
			l_loc := create {CE_NATURAL_8_POINTER}.make_cast ((get_locale_val (2)));
			(create {P_EVAL_STATIC}).set_vim_var_string (13, l_loc, -1)
		end

	get_lang_arg (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_idx = 0 then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("messages")))
				l_return := True
			end
			if not l_return and then (a_idx = 1) then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ctype")))
				l_return := True
			end
			if not l_return and then (a_idx = 2) then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("time")))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

feature {ANY} -- routine addresses

	ex_breaklist_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_breaklist)
		end

	ex_last_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_last)
		end

	source_callback_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent source_callback)
		end

	ex_scriptnames_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_scriptnames)
		end

	getsourceline_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent getsourceline)
		end

	get_lang_arg_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_lang_arg)
		end

end
