class
	P_FOLD_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	e_nofold: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("E490: No fold found")
		end

	invalid_top: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	invalid_bot: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	prev_lnum___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	prev_lnum_lvl: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	foldstartmarkerlen: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	foldendmarker: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	foldendmarkerlen: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

feature {ANY} -- public routines

	hasFolding (a_lnum: INTEGER_32; a_firstp, a_lastp: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curwin.item).item.hasFoldingWin (a_lnum, a_firstp, a_lastp, 1, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer)))
		end

	foldLevel (a_lnum: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if invalid_top.item /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:;
						((create {P_GLOBALS_STATIC}).curwin.item).item.checkupdate
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_lnum /= prev_lnum___0.item then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if prev_lnum_lvl.item >= 0 then
							Result := prev_lnum_lvl.item
							l_return := True
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_lnum >= invalid_top.item then
							if a_lnum <= invalid_bot.item then
								Result := (-1)
								l_return := True
							end
						end
				when 7 then -- if done
					if not l_return then
						if not (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						Result := (foldLevelWin ((create {P_GLOBALS_STATIC}).curwin.item, a_lnum))
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	closeFold (a_lnum, a_count___2: INTEGER_32)
		do
			setFoldRepeat (a_lnum, a_count___2, 0)
		end

	opFoldRange (a_first___0, a_last: INTEGER_32; a_opening, a_recurse___2, a_had_visual: INTEGER_32)
		local
			l_done___2: CE_ARRAY [INTEGER_32]
			l_lnum: INTEGER_32
			l_lnum_next: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_done___2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lnum_next.make (<<1>>)

			l_done___2.item := 0
			l_lnum := a_first___0
			from
			until
				not (l_lnum <= a_last)
			loop
				l_lnum_next.item := l_lnum
				if a_opening.to_boolean then
					if not a_recurse___2.to_boolean then
						hasFolding (l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum_next).do_nothing
					end
				end
				setManualFold (l_lnum, a_opening, a_recurse___2, l_done___2).do_nothing
				if not a_opening.to_boolean then
					if not a_recurse___2.to_boolean then
						hasFolding (l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum_next).do_nothing
					end
				end
				l_lnum := l_lnum_next.item + 1
			end
			if l_done___2.item = 0 then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_nofold.item)))).do_nothing
			end
			if a_had_visual.to_boolean then
				(create {P_SCREEN_STATIC}).redraw_curbuf_later (20)
			end
		end

	openFold (a_lnum, a_count___2: INTEGER_32)
		do
			setFoldRepeat (a_lnum, a_count___2, 1)
		end

	foldOpenCursor
		local
			l_done___2: CE_ARRAY [INTEGER_32]
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_done___2.make (<<1>>);

			((create {P_GLOBALS_STATIC}).curwin.item).item.checkupdate
			if (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
				from
				until
					(l_break)
				loop
					l_break := False
					l_done___2.item := 0
					setManualFold ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 1, 0, l_done___2).do_nothing
					if not ((l_done___2.item).bit_and (1)).to_boolean then
						l_break := True
					end
				end
				l_break := False
			end
		end

	newFoldLevel
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			((create {P_GLOBALS_STATIC}).curwin.item).item.newFoldLevelWin
			if (((create {P_GLOBALS_STATIC}).curwin.item).item.foldmethodIsDiff).to_boolean then
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb).to_boolean then
					l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
					from
					until
						l_wp___0.is_void
					loop
						if not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							if (l_wp___0.item.foldmethodIsDiff).to_boolean then
								if (l_wp___0.item.w_onebuf_opt.wo_scb).to_boolean then
									l_wp___0.item.w_onebuf_opt.wo_fdl := (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fdl
									l_wp___0.item.newFoldLevelWin
								end
							end
						end
						l_wp___0 := l_wp___0.item.w_next
					end
				end
			end
		end

	foldCheckClose
		do
			if ((create {P_OPTION_STATIC}).p_fcl.item.item.item).to_integer_32 /= 0 then
				((create {P_GLOBALS_STATIC}).curwin.item).item.checkupdate
				if ((create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.checkCloseRec ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fdl).to_integer_32)).to_boolean then
					(create {P_MOVE_STATIC}).changed_window_setting
				end
			end
		end

	foldManualAllowed (a_create: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (((create {P_GLOBALS_STATIC}).curwin.item).item.foldmethodIsManual).to_boolean then
				Result := 1
				l_return := True
			elseif (((create {P_GLOBALS_STATIC}).curwin.item).item.foldmethodIsMarker).to_boolean then
				Result := 1
				l_return := True
			end
			if not l_return then
				if a_create.to_boolean then
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E350: Cannot create fold with current %'foldmethod%'"))))).do_nothing
				else
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E351: Cannot delete fold with current %'foldmethod%'"))))).do_nothing
				end
				Result := 0
			end
		end

	foldCreate (a_start___1, a_end: INTEGER_32)
		local
			l_start___1: INTEGER_32
			l_end: INTEGER_32
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_fold_ga: CE_ARRAY [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_cont: INTEGER_32
			l_use_level: INTEGER_32
			l_closed: INTEGER_32
			l_level: INTEGER_32
			l_start_rel: INTEGER_32
			l_end_rel: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_fold_ga.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_start___1 := a_start___1
					l_end := a_end
					l_use_level := 0
					l_closed := 0
					l_level := 0
					l_start_rel := l_start___1
					l_end_rel := l_end
					if l_start___1 > l_end then
						l_end := l_start_rel
						l_start___1 := l_end_rel
						l_start_rel := l_start___1
						l_end_rel := l_end
					end
					if (((create {P_GLOBALS_STATIC}).curwin.item).item.foldmethodIsMarker).to_boolean then
						foldCreateMarkers (l_start___1, l_end)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:;
						((create {P_GLOBALS_STATIC}).curwin.item).item.checkupdate
						l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 16 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not (l_gap.item.foldFind (l_start_rel, l_fp)).to_boolean then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						if not (l_fp.item.item.fd_top + l_fp.item.item.fd_len > l_end_rel) then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
						l_start_rel := l_start_rel - (l_fp.item.item.fd_top)
						l_end_rel := l_end_rel - (l_fp.item.item.fd_top)
						if not (l_use_level.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (l_fp.item.item.fd_flags).to_integer_32 /= 2 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						l_use_level := 1
						if l_level.to_integer_32 >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fdl then
							l_closed := 1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						if (l_fp.item.item.fd_flags).to_integer_32 = 1 then
							l_closed := 1
						end
				when 12 then -- if done
						l_level := l_level + 1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_break := True
				when 15 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 16 then -- loop done
						l_break := False
						l_i___0 := (l_fp.item).distance ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data)))
						if (l_gap.item.ga_grow (1)) = 1 then
							l_fp.item := create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data) + l_i___0
							l_fold_ga.item.ga_init2 (((create {PD_FOLD_T}.make).structure_size.to_natural_32).to_integer_32, 10)
							l_cont := 0
							from
							until
								not (not (l_break) and then (l_i___0 + l_cont < l_gap.item.ga_len))
							loop
								l_break := False
								if (l_fp.item + l_cont).item.fd_top > l_end_rel then
									l_break := True
								end
								if not (l_break) then
									l_cont := l_cont + 1
								end
							end
							l_break := False
							if l_cont > 0 then
								if (l_fold_ga.item.ga_grow (l_cont)) = 1 then
									if l_start_rel > l_fp.item.item.fd_top then
										l_start_rel := l_fp.item.item.fd_top
									end
									if l_end_rel < ((l_fp.item + (l_cont - 1)).item.fd_top + (l_fp.item + (l_cont - 1)).item.fd_len) - 1 then
										l_end_rel := ((l_fp.item + (l_cont - 1)).item.fd_top + (l_fp.item + (l_cont - 1)).item.fd_len) - 1
									end
									memmove (l_fold_ga.item.ga_data, create {CE_VOID_POINTER}.make_cast (l_fp.item), (create {PD_FOLD_T}.make).structure_size.to_natural_32 * l_cont.to_natural_32).do_nothing
									l_fold_ga.item.ga_len := l_fold_ga.item.ga_len + l_cont
									l_i___0 := l_i___0 + l_cont
									l_j := 0
									from
									until
										not (l_j < l_cont)
									loop
										(create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_fold_ga.item.ga_data) + l_j).item.fd_top := (create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_fold_ga.item.ga_data) + l_j).item.fd_top - l_start_rel
										l_j := l_j + 1
									end
								end
							end
							if l_i___0 < l_gap.item.ga_len then
								memmove (create {CE_VOID_POINTER}.make_cast ((l_fp.item + 1)), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_FOLD_T]}.make_cast (l_gap.item.ga_data) + l_i___0)), (create {PD_FOLD_T}.make).structure_size.to_natural_32 * (l_gap.item.ga_len - l_i___0).to_natural_32).do_nothing
							end
							l_gap.item.ga_len := (l_gap.item.ga_len + 1) - l_cont
							l_fp.item.item.fd_nested := (l_fold_ga.item).twin
							l_fp.item.item.fd_top := l_start_rel
							l_fp.item.item.fd_len := (l_end_rel - l_start_rel) + 1
							if l_use_level.to_boolean then
								if not l_closed.to_boolean then
									if l_level.to_integer_32 < (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fdl then
										closeFold (l_start___1, 1)
									end
								end
							end
							if not l_use_level.to_boolean then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_fold_manual := (1).to_integer_8
							end
							l_fp.item.item.fd_flags := (1).to_integer_8
							l_fp.item.item.fd_small := (2).to_integer_8;
							(create {P_MOVE_STATIC}).changed_window_setting
						end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	foldInitWin (a_newwin: CE_POINTER [PD_WINDOW_S])
		do
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_newwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.ga_init2 (((create {PD_FOLD_T}.make).structure_size.to_natural_32).to_integer_32, 10)
		end

	foldAdjustVisual
		local
			l_start___1: CE_POINTER [PD_POS_T]
			l_end: CE_POINTER [PD_POS_T]
			l_ptr: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				l_return := True
			elseif not (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
				l_return := True
			end
			if not l_return then
				if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
					l_tmp___1 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer
				else
					if (create {P_GLOBALS_STATIC}).VIsual.item.item.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
						l_tmp___0 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer
					else
						l_tmp___0 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.coladd < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer
					end
					l_tmp___1 := l_tmp___0
				end
				if l_tmp___1.to_boolean then
					l_start___1 := (create {P_GLOBALS_STATIC}).VIsual.item
					l_end := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
				elseif (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
					if (create {P_GLOBALS_STATIC}).VIsual.item.item.col = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd then
							l_start___1 := (create {P_GLOBALS_STATIC}).VIsual.item
							l_end := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
						else
							l_start___1 := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							l_end := (create {P_GLOBALS_STATIC}).VIsual.item
						end
					else
						l_start___1 := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
						l_end := (create {P_GLOBALS_STATIC}).VIsual.item
					end
				else
					l_start___1 := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
					l_end := (create {P_GLOBALS_STATIC}).VIsual.item
				end
				if (hasFolding (l_start___1.item.lnum, create {CE_INTEGER_32_POINTER}.make_shared (l_start___1.c_pointer + (create {PD_POS_T}.make).offset_of ("lnum")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))).to_boolean then
					l_start___1.item.col := 0
				end
				if (hasFolding (l_end.item.lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (l_end.c_pointer + (create {PD_POS_T}.make).offset_of ("lnum")))).to_boolean then
					l_ptr := (create {P_MEMLINE_STATIC}).ml_get (l_end.item.lnum)
					l_end.item.col := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32
					if l_end.item.col > 0 then
						if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 111 then
							l_end.item.col := (l_end.item.col) - 1
						end
					end
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						(create {P_MBYTE_STATIC}).mb_adjust_cursor
					end
				end
			end
		end

	foldAdjustCursor
		do
			hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor") + (create {PD_POS_T}.make).offset_of ("lnum")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
		end

	foldLevelWin (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_lnum: INTEGER_32): INTEGER_32
		local
			l_fp: CE_ARRAY [CE_POINTER [PD_FOLD_T]]
			l_lnum_rel: INTEGER_32
			l_level: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_FOLD_T]} l_fp.make (<<1>>)

			l_lnum_rel := a_lnum
			l_level := 0
			l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))
			from
			until
				(l_break)
			loop
				l_break := False
				if not (l_gap.item.foldFind (l_lnum_rel, l_fp)).to_boolean then
					l_break := True
				end
				if not (l_break) then
					l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_fp.item.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))
					l_lnum_rel := l_lnum_rel - (l_fp.item.item.fd_top)
					l_level := l_level + 1
				end
			end
			l_break := False
			Result := l_level
		end

	setFoldRepeat (a_lnum, a_count___2: INTEGER_32; a_do_open: INTEGER_32)
		local
			l_done___2: CE_ARRAY [INTEGER_32]
			l_n: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_done___2.make (<<1>>)

			l_n := 0
			from
			until
				not (not (l_break) and then (l_n < a_count___2))
			loop
				l_break := False
				l_done___2.item := 0
				setManualFold (a_lnum, a_do_open, 0, l_done___2).do_nothing
				if not ((l_done___2.item).bit_and (1)).to_boolean then
					if l_n = 0 then
						if not ((l_done___2.item).bit_and (2)).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_nofold.item)))).do_nothing
						end
					end
					l_break := True
				end
				if not (l_break) then
					l_n := l_n + 1
				end
			end
			l_break := False
		end

	setManualFold (a_lnum: INTEGER_32; a_opening, a_recurse___2: INTEGER_32; a_donep: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_dlnum: INTEGER_32
		do
			if (((create {P_GLOBALS_STATIC}).curwin.item).item.foldmethodIsDiff).to_boolean then
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb).to_boolean then
					l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
					from
					until
						l_wp___0.is_void
					loop
						if not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							if (l_wp___0.item.foldmethodIsDiff).to_boolean then
								if (l_wp___0.item.w_onebuf_opt.wo_scb).to_boolean then
									l_dlnum := (create {P_DIFF_STATIC}).diff_lnum_win ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_wp___0)
									if l_dlnum /= 0 then
										l_wp___0.item.setManualFoldWin (l_dlnum, a_opening, a_recurse___2, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
									end
								end
							end
						end
						l_wp___0 := l_wp___0.item.w_next
					end
				end
			end
			Result := (((create {P_GLOBALS_STATIC}).curwin.item).item.setManualFoldWin (a_lnum, a_opening, a_recurse___2, a_donep))
		end

	foldMarkAdjust (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_line1, a_line2, a_amount, a_amount_after: INTEGER_32)
		local
			l_line1: INTEGER_32
			l_line2: INTEGER_32
		do
			l_line1 := a_line1
			l_line2 := a_line2
			if a_amount = 2_147_483_647 then
				if l_line2 >= l_line1 then
					if l_line2 - l_line1 >= -a_amount_after then
						l_line2 := (l_line1 - a_amount_after) - 1
					end
				end
			end
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
				if a_amount = 1 then
					if l_line2 = 2_147_483_647 then
						l_line1 := l_line1 - 1
					end
				end
			end
			(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_wp___0.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_folds"))).item.foldMarkAdjustRecurse (l_line1, l_line2, a_amount, a_amount_after)
		end

	check_closed (a_win: CE_POINTER [PD_WINDOW_S]; a_fp: CE_POINTER [PD_FOLD_T]; a_use_levelp: CE_POINTER [INTEGER_32]; a_level: INTEGER_32; a_maybe_smallp: CE_POINTER [INTEGER_32]; a_lnum_off: INTEGER_32): INTEGER_32
		require
			not a_fp.is_void
			not a_use_levelp.is_void
		local
			l_closed: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_closed := 0
					if not ((a_use_levelp.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_fp.item.fd_flags).to_integer_32 /= 2 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						a_use_levelp.item := 1
						if a_level.to_integer_32 >= a_win.item.w_onebuf_opt.wo_fdl then
							l_closed := 1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if (a_fp.item.fd_flags).to_integer_32 = 1 then
							l_closed := 1
						end
				when 7 then -- if done
					if (a_fp.item.fd_small).to_integer_32 = 2 then
						a_maybe_smallp.item := 1
					end
					if l_closed.to_boolean then
						if (a_maybe_smallp.item).to_boolean then
							a_fp.item.fd_small := (2).to_integer_8
						end
						checkSmall (a_win, a_fp, a_lnum_off)
						if (a_fp.item.fd_small).to_integer_32 = 1 then
							l_closed := 0
						end
					end
					Result := l_closed
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	checkSmall (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_fp: CE_POINTER [PD_FOLD_T]; a_lnum_off: INTEGER_32)
		require
			not a_fp.is_void
		local
			l_count___2: INTEGER_32
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_fp.item.fd_small).to_integer_32 = 2 then
				(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (a_fp.c_pointer + (create {PD_FOLD_T}.make).offset_of ("fd_nested"))).item.setSmallMaybe
				if a_fp.item.fd_len > (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fml then
					a_fp.item.fd_small := (0).to_integer_8
				else
					l_count___2 := 0
					l_n := 0
					from
					until
						not (not (l_return) and then (l_n.to_integer_32 < a_fp.item.fd_len))
					loop
						l_count___2 := l_count___2 + (a_wp___0.item.plines_win_nofold ((a_fp.item.fd_top + a_lnum_off) + l_n.to_integer_32))
						if l_count___2.to_integer_32 > (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fml then
							a_fp.item.fd_small := (0).to_integer_8
							l_return := True
						end
						if not l_return then
							l_n := l_n + 1
						end
					end
					if not l_return then
						a_fp.item.fd_small := (1).to_integer_8
					end
				end
			end
			if not l_return then
			end
		end

	foldCreateMarkers (a_start___1, a_end: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma).to_boolean then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_modifiable.item)))))).do_nothing
				l_return := True
			end
			if not l_return then
				((create {P_GLOBALS_STATIC}).curwin.item).item.parseMarker
				foldAddMarker (a_start___1, (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fmr, foldstartmarkerlen.item)
				foldAddMarker (a_end, foldendmarker.item, foldendmarkerlen.item);
				(create {P_MISC1_STATIC}).changed_lines (a_start___1, 0, a_end, 0)
			end
		end

	foldAddMarker (a_lnum: INTEGER_32; a_marker: CE_POINTER [NATURAL_8]; a_markerlen: INTEGER_32)
		local
			l_cms: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_line_len: INTEGER_32
			l_newline: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_cms := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cms
			l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((strstr (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cms), ce_string ("%%s"))))
			l_line := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
			l_line_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32
			if ((create {P_UNDO_STATIC}).u_save (a_lnum - 1, a_lnum + 1)) = 1 then
				l_newline := (create {P_MISC2_STATIC}).alloc (((l_line_len + a_markerlen).to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_cms)))) + {NATURAL_32} 1)
				if l_newline.is_void then
					l_return := True
				end
				if not l_return then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_newline), create {CE_INTEGER_8_POINTER}.make_cast (l_line)).do_nothing
					if l_p___0.is_void then
						(create {P_MISC2_STATIC}).vim_strncpy (l_newline + l_line_len, a_marker, a_markerlen.to_natural_32)
					else
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_newline + l_line_len)), create {CE_INTEGER_8_POINTER}.make_cast (l_cms)).do_nothing
						strncpy (create {CE_INTEGER_8_POINTER}.make_cast (((l_newline + l_line_len) + (l_p___0.distance (l_cms)))), create {CE_INTEGER_8_POINTER}.make_cast (a_marker), a_markerlen.to_natural_32).do_nothing
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((((l_newline + l_line_len) + (l_p___0.distance (l_cms))) + a_markerlen)), create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 2))).do_nothing
					end
					(create {P_MEMLINE_STATIC}).ml_replace (a_lnum, l_newline, 0).do_nothing
				end
			end
			if not l_return then
			end
		end

	foldtext_cleanup (a_str___1: CE_POINTER [NATURAL_8])
		require
			not a_str___1.is_void
		local
			l_cms_start: CE_POINTER [NATURAL_8]
			l_cms_slen: INTEGER_32
			l_cms_end: CE_POINTER [NATURAL_8]
			l_cms_elen: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_did1: INTEGER_32
			l_did2: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cms_slen := 0
					l_cms_elen := 0
					l_did1 := 0
					l_did2 := 0
					l_cms_start := (create {P_CHARSET_STATIC}).skipwhite ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cms)
					l_cms_slen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_cms_start))).to_integer_32
					from
					until
						(l_break)
					loop
						l_break := False
						if l_cms_slen > 0 then
							if (l_cms_start[(l_cms_slen - 1)]).to_integer_32 /= 32 then
								if (l_cms_start[(l_cms_slen - 1)]).to_integer_32 /= 9 then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_cms_slen := l_cms_slen - 1
						end
					end
					l_break := False
					l_cms_end := create {CE_NATURAL_8_POINTER}.make_cast ((strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_cms_start), ce_string ("%%s"))))
					if not l_cms_end.is_void then
						l_cms_elen := l_cms_slen - (l_cms_end.distance (l_cms_start))
						l_cms_slen := l_cms_end.distance (l_cms_start)
						from
						until
							(l_break)
						loop
							l_break := False
							if l_cms_slen > 0 then
								if (l_cms_start[(l_cms_slen - 1)]).to_integer_32 /= 32 then
									if (l_cms_start[(l_cms_slen - 1)]).to_integer_32 /= 9 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_cms_slen := l_cms_slen - 1
							end
						end
						l_break := False
						l_s := (create {P_CHARSET_STATIC}).skipwhite (l_cms_end + 2)
						l_cms_elen := l_cms_elen - (l_s.distance (l_cms_end))
						l_cms_end := l_s
					end
					((create {P_GLOBALS_STATIC}).curwin.item).item.parseMarker
					l_s := a_str___1
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_s.item).to_integer_32 /= 0)) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_len := 0
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fmr), foldstartmarkerlen.item.to_natural_32)) = 0 then
							l_len := foldstartmarkerlen.item
						elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (foldendmarker.item), foldendmarkerlen.item.to_natural_32)) = 0 then
							l_len := foldendmarkerlen.item
						end
						if not (l_len > 0) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_s[l_len]).to_integer_32 >= 48 then
							if (l_s[l_len]).to_integer_32 <= 57 then
								l_len := l_len + 1
							end
						end
						l_p___0 := l_s
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (a_str___1.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0[-1]).to_integer_32 /= 32 then
									if (l_p___0[-1]).to_integer_32 /= 9 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0 := l_p___0 - 1
							end
						end
						l_break := False
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 >= ((a_str___1 + l_cms_slen).c_pointer.to_integer_32).to_natural_32 then
							if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 - l_cms_slen)), create {CE_INTEGER_8_POINTER}.make_cast (l_cms_start), l_cms_slen.to_natural_32)) = 0 then
								l_len := l_len + ((l_s.distance (l_p___0)) + l_cms_slen)
								l_s := l_p___0 - l_cms_slen
							end
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 5 then -- else:
						if l_cms_end.is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 6 then -- if:
						if l_did1.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_cms_slen > 0 then
							if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (l_cms_start), l_cms_slen.to_natural_32)) = 0 then
								l_len := l_cms_slen
								l_did1 := 1
							else
								l_pos := -1 + 9 -- goto _L___0
							end
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						if not l_did2.to_boolean then
							if l_cms_elen > 0 then
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (l_cms_end), l_cms_elen.to_natural_32)) = 0 then
									l_len := l_cms_elen
									l_did2 := 1
								end
							end
						end
				when 10 then -- if done | if done
						if l_len /= 0 then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_s[l_len]).to_integer_32 /= 32 then
									if (l_s[l_len]).to_integer_32 /= 9 then
										l_break := True
									end
								end
								if not (l_break) then
									l_len := l_len + 1
								end
							end
							l_break := False
							memmove (create {CE_VOID_POINTER}.make_cast (l_s), create {CE_VOID_POINTER}.make_cast ((l_s + l_len)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_s + l_len)))) + {NATURAL_32} 1).do_nothing
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___8 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s]))
							else
								l_tmp___8 := 1
							end
							l_s := l_s + l_tmp___8
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
