class
	P_IF_XCMDSRV_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_X11_XLIB_STATIC
	S_TIME_STATIC
	S_SYS_SELECT_STATIC
	S_CTYPE_STATIC
	S_UNISTD_STATIC
	VIM_ASSEMBLER

feature {ANY} -- public attributes

	pendingCommands: CE_STATIC [CE_POINTER [PD_PENDINGCOMMAND]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_PENDINGCOMMAND]}.make_shared (default_pointer)
		end

	serverReply: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, 0, 0, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

	registryProperty: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

	vimProperty: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

	got_x_error: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	empty_prop: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
		end

	serial: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	serverRegisterName (a_dpy: CE_POINTER [ANY]; a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_res: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_res := DoRegisterName (a_dpy, a_name___1)
					if not (l_res < 0) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_i___0 := 1
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if l_res < -1 then
							l_tmp := gettext (ce_string ("Unable to register a command server name"));
							(create {P_MESSAGE_STATIC}).msg_attr (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), (create {P_GLOBALS_STATIC}).highlight_attr.item[17]).do_nothing
							Result := 0
							l_return := True
						elseif l_i___0 >= 1_000 then
							l_tmp := gettext (ce_string ("Unable to register a command server name"));
							(create {P_MESSAGE_STATIC}).msg_attr (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), (create {P_GLOBALS_STATIC}).highlight_attr.item[17]).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							if l_p___0.is_void then
								l_p___0 := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))) + {NATURAL_32} 10)
							end
							if l_p___0.is_void then
								l_res := -10
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								l_tmp___1 := l_i___0
								l_i___0 := l_i___0 + 1
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("%%s%%d"), a_name___1, l_tmp___1]).do_nothing
								l_res := DoRegisterName (a_dpy, l_p___0)
							end
							if (not l_return and not l_break) and then (not (l_res < 0)) then
								l_pos := -1 + 5 -- break
							end
						end
				when 4 then
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						if not l_return then
							l_break := False
							l_continue := False;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
				when 6 then -- if done
					if not l_return then
						Result := 1
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	DoRegisterName (a_dpy: CE_POINTER [ANY]; a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_w: NATURAL_32
			l_old_handler: CE_ROUTINE
			l_propInfo: CE_ARRAY [NATURAL_8]
			l_status: INTEGER_32
			l_dummyInt: CE_ARRAY [INTEGER_32]
			l_dummyUns: CE_ARRAY [NATURAL_32]
			l_dummyWin: CE_ARRAY [NATURAL_32]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_propInfo.make (<<120>>)
			create {CE_INTEGER_32_ARRAY} l_dummyInt.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dummyUns.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dummyWin.make (<<1>>)

			if (create {P_GLOBALS_STATIC}).commProperty.item = {NATURAL_32} 0 then
				if (SendInit (a_dpy)) < 0 then
					Result := (-2)
					l_return := True
				end
			end
			if not l_return then
				XGrabServer (a_dpy).do_nothing
				l_w := LookupName (a_dpy, a_name___1, 0, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
				if l_w /= {NATURAL_32} 0 then
					l_old_handler := XSetErrorHandler (x_error_check_address)
					l_status := XGetGeometry (a_dpy, l_w, l_dummyWin, l_dummyInt, l_dummyInt, l_dummyUns, l_dummyUns, l_dummyUns, l_dummyUns)
					XSetErrorHandler (l_old_handler).do_nothing
					if l_status /= 0 then
						if l_w /= (create {P_GLOBALS_STATIC}).commWindow.item then
							XUngrabServer (a_dpy).do_nothing
							XFlush (a_dpy).do_nothing
							Result := (-1)
							l_return := True
						end
					end
					if not l_return then
						LookupName (a_dpy, a_name___1, 1, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					end
				end
			end
			if not l_return then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_propInfo), ce_string ("%%x %%.*s"), ((create {P_GLOBALS_STATIC}).commWindow.item).to_natural_32, 100, a_name___1]).do_nothing
				l_old_handler := XSetErrorHandler (x_error_check_address)
				got_x_error.item := 0
				XChangeProperty (a_dpy, ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty.item, (31).to_natural_32, 8, 2, create {CE_NATURAL_8_POINTER}.make_cast (l_propInfo), ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_propInfo))) + {NATURAL_32} 1).to_integer_32).do_nothing
				XUngrabServer (a_dpy).do_nothing
				XSync (a_dpy, 0).do_nothing
				XSetErrorHandler (l_old_handler).do_nothing
				if not got_x_error.item.to_boolean then
					(create {P_EVAL_STATIC}).set_vim_var_string (27, a_name___1, -1);
					(create {P_GLOBALS_STATIC}).serverName.item := (create {P_MISC2_STATIC}).vim_strsave (a_name___1);
					(create {P_GLOBALS_STATIC}).need_maketitle.item := 1
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := (-2)
			end
		end

	serverChangeRegisteredWindow (a_dpy: CE_POINTER [ANY]; a_newwin: NATURAL_32)
		local
			l_propInfo: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_propInfo.make (<<120>>);

			(create {P_GLOBALS_STATIC}).commWindow.item := a_newwin
			if (SendInit (a_dpy)) < 0 then
				l_return := True
			end
			if not l_return then
				XGrabServer (a_dpy).do_nothing
				DeleteAnyLingerer (a_dpy, a_newwin)
				if not ((create {P_GLOBALS_STATIC}).serverName.item).is_void then
					LookupName (a_dpy, (create {P_GLOBALS_STATIC}).serverName.item, 1, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_propInfo), ce_string ("%%x %%.*s"), a_newwin.to_natural_32, 100, (create {P_GLOBALS_STATIC}).serverName.item]).do_nothing
					XChangeProperty (a_dpy, ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty.item, (31).to_natural_32, 8, 2, create {CE_NATURAL_8_POINTER}.make_cast (l_propInfo), ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_propInfo))) + {NATURAL_32} 1).to_integer_32).do_nothing
				end
				XUngrabServer (a_dpy).do_nothing
			end
		end

	serverSendToVim (a_dpy: CE_POINTER [ANY]; a_name___1, a_cmd: CE_POINTER [NATURAL_8]; a_result___2: CE_POINTER [CE_POINTER [NATURAL_8]]; a_server: CE_POINTER [NATURAL_32]; a_asExpr, a_localLoop, a_silent: INTEGER_32): INTEGER_32
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_w: NATURAL_32
			l_property: CE_POINTER [NATURAL_8]
			l_length: INTEGER_32
			l_res: INTEGER_32
			l_pending: CE_ARRAY [PD_PENDINGCOMMAND]
			l_loosename: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ret: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___6: NATURAL_32
			l_tmp___7: NATURAL_32
			l_tmp___10: INTEGER_32
			l_pcPtr: CE_POINTER [PD_PENDINGCOMMAND]
			l_tmp___13: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PENDINGCOMMAND]} l_pending.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_loosename.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name___1 := a_name___1
					l_loosename.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if not a_result___2.is_void then
						a_result___2.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
					if l_name___1.is_void then
						l_name___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("GVIM"))
					elseif (l_name___1.item).to_integer_32 = 0 then
						l_name___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("GVIM"))
					end
					if (create {P_GLOBALS_STATIC}).commProperty.item = {NATURAL_32} 0 then
						if not a_dpy.is_void then
							if (SendInit (a_dpy)) < 0 then
								Result := (-1)
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not (a_dpy.is_void) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 4 then -- else:
						if ((create {P_GLOBALS_STATIC}).serverName.item).is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).serverName.item))) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if a_asExpr.to_boolean then
							l_ret := (create {P_MAIN_STATIC}).eval_client_expr_to_string (a_cmd)
							if not a_result___2.is_void then
								if l_ret.is_void then
									a_result___2.item := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invexprmsg.item))))))
								else
									a_result___2.item := l_ret
								end
							else
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ret))
							end
							if l_ret.is_void then
								l_tmp___1 := -1
							else
								l_tmp___1 := 0
							end
							Result := l_tmp___1
							l_return := True
						else
							(create {P_MAIN_STATIC}).server_to_input_buf (a_cmd)
						end
						if not l_return then
							Result := 0
							l_return := True
						end
				when 7 then -- if done | if done | if done
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							l_continue := False
							l_w := LookupName (a_dpy, l_name___1, 0, l_loosename)
							if l_w /= {NATURAL_32} 0 then
								if not (WindowValid (a_dpy, l_w)).to_boolean then
									if (not (l_loosename.item).is_void) then
										l_tmp___3 := l_loosename.item
									else
										l_tmp___3 := l_name___1
									end
									LookupName (a_dpy, l_tmp___3, 1, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
									l_continue := True
								end
							end
							if not (l_break or l_continue) then
								l_break := True
							end
						end
						l_break := False
						l_continue := False
						if l_w = {NATURAL_32} 0 then
							if not a_silent.to_boolean then
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noserver.item))))), l_name___1).do_nothing
							end
							Result := (-1)
							l_return := True
						elseif not (l_loosename.item).is_void then
							l_name___1 := l_loosename.item
						end
					end
					if not l_return then
						if not a_server.is_void then
							a_server.item := l_w
						end
						l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1))
						l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item))
						l_length := (((l_tmp___6 + l_tmp___7) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd)))) + {NATURAL_32} 14).to_integer_32
						l_property := ((create {P_MISC2_STATIC}).alloc (l_length.to_natural_32 + {NATURAL_32} 30))
						if a_asExpr.to_boolean then
							l_tmp___10 := ('c').code
						else
							l_tmp___10 := ('k').code
						end
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_property), ce_string ("%%c%%c%%c-n %%s%%c-E %%s%%c-s %%s"), 0, l_tmp___10, 0, l_name___1, 0, (create {P_OPTION_STATIC}).p_enc.item.item, 0, a_cmd]).do_nothing
						if l_name___1.is_equal (l_loosename.item) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_loosename.item))
						end
						serial.item := serial.item + 1
						sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_property) + l_length), ce_string ("%%c-r %%x %%d"), 0, ((create {P_GLOBALS_STATIC}).commWindow.item).to_natural_32, serial.item]).do_nothing
						l_length := (l_length.to_natural_32 + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_property + l_length) + 1)))) + {NATURAL_32} 1)).to_integer_32
						l_res := AppendPropCarefully (a_dpy, l_w, (create {P_GLOBALS_STATIC}).commProperty.item, l_property, l_length + 1);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_property))
						if l_res < 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E248: Failed to send command to the destination program"))))).do_nothing
							Result := (-1)
							l_return := True
						end
					end
					if not l_return and then (not a_asExpr.to_boolean) then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_pending.item.serial := serial.item
						l_pending.item.code := 0
						l_pending.item.result2 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_pending.item.nextPtr := pendingCommands.item
						pendingCommands.item := l_pending
						ServerWait (a_dpy, l_w, WaitForPend_address, create {CE_VOID_POINTER}.make_cast (l_pending), a_localLoop, 600)
						if pendingCommands.item.is_equal (l_pending) then
							pendingCommands.item := l_pending.item.nextPtr
						else
							l_pcPtr := pendingCommands.item
							from
							until
								not (not (l_break) and then (not l_pcPtr.is_void))
							loop
								l_break := False
								if (l_pcPtr.item.nextPtr).is_equal (l_pending) then
									l_pcPtr.item.nextPtr := l_pending.item.nextPtr
									l_break := True
								end
								if not (l_break or l_continue) then
									l_pcPtr := l_pcPtr.item.nextPtr
								end
							end
							l_break := False
						end
						if not a_result___2.is_void then
							a_result___2.item := l_pending.item.result2
						else
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pending.item.result2))
						end
						if l_pending.item.code = 0 then
							l_tmp___13 := 0
						else
							l_tmp___13 := -1
						end
						Result := l_tmp___13
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	WaitForPend (a_p___0: CE_POINTER [ANY]): INTEGER_32
		local
			l_pending: CE_POINTER [PD_PENDINGCOMMAND]
		do
			l_pending := create {CE_CLASS_POINTER [PD_PENDINGCOMMAND]}.make_cast (a_p___0)
			Result := (not (l_pending.item.result2).is_void).to_integer
		end

	WindowValid (a_dpy: CE_POINTER [ANY]; a_w: NATURAL_32): INTEGER_32
		local
			l_old_handler: CE_ROUTINE
			l_plist: CE_POINTER [NATURAL_32]
			l_numProp: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_numProp.make (<<1>>)

			l_old_handler := XSetErrorHandler (x_error_check_address)
			got_x_error.item := 0
			l_plist := XListProperties (a_dpy, a_w, l_numProp)
			XSync (a_dpy, 0).do_nothing
			XSetErrorHandler (l_old_handler).do_nothing
			if l_plist.is_void then
				Result := 0
				l_return := True
			elseif got_x_error.item.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < l_numProp.item))
				loop
					if l_plist[l_i___0] = vimProperty.item then
						XFree (create {CE_VOID_POINTER}.make_cast (l_plist)).do_nothing
						Result := 1
						l_return := True
					end
					if not l_return then
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not l_return then
				XFree (create {CE_VOID_POINTER}.make_cast (l_plist)).do_nothing
				Result := 0
			end
		end

	ServerWait (a_dpy: CE_POINTER [ANY]; a_w: NATURAL_32; a_endCond: CE_ROUTINE; a_endData: CE_POINTER [ANY]; a_localLoop, a_seconds: INTEGER_32)
		require
			not a_endCond.is_void
		local
			l_dpy: CE_ARRAY [CE_POINTER [ANY]]
			l_start___1: CE_ARRAY [INTEGER_32]
			l_now: CE_ARRAY [INTEGER_32]
			l_lastChk: INTEGER_32
			l_event: CE_ARRAY [SD_XEVENT]
			l_e: CE_POINTER [SD_XPROPERTYEVENT]
			l_fds: CE_ARRAY [SD_FD_SET]
			l_tv: CE_ARRAY [SD_TIMEVAL]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [ANY]} l_dpy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_start___1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_now.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_XEVENT]} l_event.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_FD_SET]} l_fds.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_tv.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l___d1.make (<<1>>)

			l_dpy.item := a_dpy
			l_lastChk := (0).to_integer_32
			l_e := create {CE_CLASS_POINTER [SD_XPROPERTYEVENT]}.make_cast (l_event)
			time (l_start___1).do_nothing
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if (a_endCond.integer_32_item ([a_endData])) /= 0 then
					l_break := True
				end
				if not (l_return or l_break) then
					time (l_now).do_nothing
					if a_seconds >= 0 then
						if l_now.item - l_start___1.item >= a_seconds.to_integer_32 then
							l_break := True
						end
					end
				end
				if not (l_return or l_break) and then (l_now.item /= l_lastChk) then
					l_lastChk := l_now.item
					if not (WindowValid (l_dpy.item, a_w)).to_boolean then
						l_break := True
					end
					if not (l_return or l_break) then
						serverEventProc (l_dpy.item, create {CE_CLASS_POINTER [SD_XEVENT]}.make_shared (default_pointer))
					end
				end
				if not (l_return or l_break) then
					if a_localLoop.to_boolean then
						l_tv.item.tv_sec := (0).to_integer_32
						l_tv.item.tv_usec := (50_000).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							asm1 (l___d0, l___d1, l_fds)
							l_break := True
						end
						l_break := False
						asm2 (l_fds, l_dpy)
						if (select2 ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (l_dpy.item)).item.fd + 1, l_fds, create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), create {CE_CLASS_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_tv)) < 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							from
							until
								(l_break)
							loop
								l_break := False
								if not ((XEventsQueued (l_dpy.item, 1)) > 0) then
									l_break := True
								end
								if not (l_break) then
									XNextEvent (l_dpy.item, l_event).do_nothing
									if l_event.item.type = 28 then
										if l_e.item.window = (create {P_GLOBALS_STATIC}).commWindow.item then
											serverEventProc (l_dpy.item, l_event)
										end
									end
								end
							end
							l_break := False
						end
					else
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_break := True
						end
						if not (l_return or l_break) then
							(create {P_UI_STATIC}).ui_delay (50, 1);
							(create {P_UI_STATIC}).ui_breakcheck
						end
					end
				end
			end
			l_break := False
		end

	serverGetVimNames (a_dpy: CE_POINTER [ANY]): CE_POINTER [NATURAL_8]
		local
			l_regProp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_entry: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_numItems: CE_ARRAY [NATURAL_32]
			l_w: CE_ARRAY [NATURAL_32]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_regProp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_numItems.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_w.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			if registryProperty.item = {NATURAL_32} 0 then
				if (SendInit (a_dpy)) < 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_ga.item.ga_init2 (1, 100)
				if (GetRegProp (a_dpy, l_regProp, l_numItems, 1)) = 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_ga.item.ga_init2 (1, 100)
				l_p___0 := l_regProp.item
				from
				until
					not (not (l_return) and then ((l_p___0.distance ((l_regProp.item))).to_natural_32 < l_numItems.item))
				loop
					l_entry := l_p___0
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item).to_integer_32 /= 0 then
							if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
					if (l_p___0.item).to_integer_32 /= 0 then
						l_w.item := (0).to_natural_32
						sscanf ([create {CE_INTEGER_8_POINTER}.make_cast (l_entry), ce_string ("%%x"), l_w]).do_nothing
						if (WindowValid (a_dpy, (l_w.item).to_natural_32)).to_boolean then
							l_ga.item.ga_concat (l_p___0 + 1)
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
						end
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0 := l_p___0 + 1
						end
					end
					l_p___0 := l_p___0 + 1
				end
				if not (l_regProp.item).is_equal (empty_prop.item) then
					XFree (create {CE_VOID_POINTER}.make_cast (l_regProp.item)).do_nothing
				end
				l_ga.item.ga_append (('%/0/').code)
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data))
			end
		end

	ServerReplyFind (a_w: NATURAL_32; a_op: NATURAL_32): CE_POINTER [PD_SERVERREPLY]
		local
			l_p___0: CE_POINTER [PD_SERVERREPLY]
			l_e: CE_ARRAY [PD_SERVERREPLY]
			l_i___0: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_SERVERREPLY]} l_e.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := create {CE_CLASS_POINTER [PD_SERVERREPLY]}.make_cast (serverReply.item.item.ga_data)
					l_i___0 := 0
					from
					until
						not (not (l_break) and then (l_i___0 < serverReply.item.item.ga_len))
					loop
						l_break := False
						if l_p___0.item.id = a_w then
							l_break := True
						end
						if not (l_break) then
							l_i___0 := l_i___0 + 1
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
					if l_i___0 >= serverReply.item.item.ga_len then
						l_p___0 := create {CE_CLASS_POINTER [PD_SERVERREPLY]}.make_shared (default_pointer)
					end
					if not (l_p___0.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_op = {NATURAL_32} 1 then
							if serverReply.item.item.ga_growsize = 0 then
								serverReply.item.item.ga_init2 (((create {PD_SERVERREPLY}.make).structure_size.to_natural_32).to_integer_32, 1)
							end
							if (serverReply.item.item.ga_grow (1)) = 1 then
								l_p___0 := create {CE_CLASS_POINTER [PD_SERVERREPLY]}.make_cast (serverReply.item.item.ga_data) + serverReply.item.item.ga_len
								l_e.item.id := a_w;
								(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_e.item.c_pointer + (create {PD_SERVERREPLY}.make).offset_of ("strings"))).item.ga_init2 (1, 100)
								memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (l_e), (create {PD_SERVERREPLY}.make).structure_size.to_natural_32).do_nothing
								serverReply.item.item.ga_len := (serverReply.item.item.ga_len) + 1
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if not l_p___0.is_void then
							if a_op = {NATURAL_32} 2 then
								(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_p___0.c_pointer + (create {PD_SERVERREPLY}.make).offset_of ("strings"))).item.ga_clear
								memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), ((serverReply.item.item.ga_len - l_i___0) - 1).to_natural_32 * (create {PD_SERVERREPLY}.make).structure_size.to_natural_32).do_nothing
								serverReply.item.item.ga_len := (serverReply.item.item.ga_len) - 1
							end
						end
				when 4 then
					Result := l_p___0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	serverStrToWin (a_str___1: CE_POINTER [NATURAL_8]): NATURAL_32
		local
			l_id: CE_ARRAY [NATURAL_32]
		do
			create {CE_NATURAL_32_ARRAY} l_id.make (<<1>>)

			l_id.item := {NATURAL_32} 0
			sscanf ([create {CE_INTEGER_8_POINTER}.make_cast (a_str___1), ce_string ("0x%%x"), l_id]).do_nothing
			if (l_id.item).to_natural_32 = {NATURAL_32} 0 then
				(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E573: Invalid server id used: %%s")))), a_str___1).do_nothing
			end
			Result := (l_id.item).to_natural_32
		end

	serverSendReply (a_name___1, a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_property: CE_POINTER [NATURAL_8]
			l_length: INTEGER_32
			l_res: INTEGER_32
			l_dpy: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
			l_win: NATURAL_32
			l_tmp___4: NATURAL_32
			l_return: BOOLEAN
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				l_tmp___0 := ((create {P_GUI_GTK_X11_STATIC}).gui_mch_get_display)
			else
				l_tmp___0 := (create {P_GLOBALS_STATIC}).xterm_dpy.item.item
			end
			l_dpy := l_tmp___0
			l_win := (serverStrToWin (a_name___1))
			if (create {P_GLOBALS_STATIC}).commProperty.item = {NATURAL_32} 0 then
				if (SendInit (l_dpy)) < 0 then
					Result := (-2)
					l_return := True
				end
			end
			if not l_return then
				if not (WindowValid (l_dpy, l_win)).to_boolean then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_tmp___4 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item))
				l_length := ((l_tmp___4 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1)))) + {NATURAL_32} 14).to_integer_32
				l_property := ((create {P_MISC2_STATIC}).alloc (l_length.to_natural_32 + {NATURAL_32} 30))
				if not l_property.is_void then
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_property), ce_string ("%%cn%%c-E %%s%%c-n %%s%%c-w %%x"), 0, 0, (create {P_OPTION_STATIC}).p_enc.item.item, 0, a_str___1, 0, ((create {P_GLOBALS_STATIC}).commWindow.item).to_natural_32]).do_nothing
					l_length := (l_length.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_property + l_length))))).to_integer_32
					l_res := AppendPropCarefully (l_dpy, l_win, (create {P_GLOBALS_STATIC}).commProperty.item, l_property, l_length + 1);
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_property))
					Result := l_res
					l_return := True
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	WaitForReply (a_p___0: CE_POINTER [ANY]): INTEGER_32
		local
			l_w: CE_POINTER [NATURAL_32]
		do
			l_w := create {CE_NATURAL_32_POINTER}.make_cast (a_p___0)
			Result := (not (ServerReplyFind (l_w.item, {PC_SERVERREPLYOP}.SROP_Find)).is_void).to_integer
		end

	serverReadReply (a_dpy: CE_POINTER [ANY]; a_win: NATURAL_32; a_str___1: CE_POINTER [CE_POINTER [NATURAL_8]]; a_localLoop: INTEGER_32): INTEGER_32
		local
			l_win: CE_ARRAY [NATURAL_32]
			l_len: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [PD_SERVERREPLY]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_win.make (<<1>>)

			l_win.item := a_win
			ServerWait (a_dpy, l_win.item, WaitForReply_address, create {CE_VOID_POINTER}.make_cast (l_win), a_localLoop, -1)
			l_p___0 := ServerReplyFind (l_win.item, {PC_SERVERREPLYOP}.SROP_Find)
			if not l_p___0.is_void then
				if l_p___0.item.strings.ga_len > 0 then
					a_str___1.item := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (l_p___0.item.strings.ga_data))
					l_len := ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1.item))) + {NATURAL_32} 1).to_integer_32
					if l_len < l_p___0.item.strings.ga_len then
						l_s := create {CE_NATURAL_8_POINTER}.make_cast (l_p___0.item.strings.ga_data)
						memmove (create {CE_VOID_POINTER}.make_cast (l_s), create {CE_VOID_POINTER}.make_cast ((l_s + l_len)), (l_p___0.item.strings.ga_len - l_len).to_natural_32).do_nothing
						l_p___0.item.strings.ga_len := l_p___0.item.strings.ga_len - l_len
					else
						(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_p___0.c_pointer + (create {PD_SERVERREPLY}.make).offset_of ("strings"))).item.ga_clear
						ServerReplyFind (l_win.item, {PC_SERVERREPLYOP}.SROP_Delete).do_nothing
					end
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	serverPeekReply (a_dpy: CE_POINTER [ANY]; a_win: NATURAL_32; a_str___1: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_SERVERREPLY]
			l_return: BOOLEAN
		do
			l_p___0 := ServerReplyFind (a_win, {PC_SERVERREPLYOP}.SROP_Find)
			if not l_p___0.is_void then
				if l_p___0.item.strings.ga_len > 0 then
					if not a_str___1.is_void then
						a_str___1.item := create {CE_NATURAL_8_POINTER}.make_cast (l_p___0.item.strings.ga_data)
					end
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				if not (WindowValid (a_dpy, a_win)).to_boolean then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	SendInit (a_dpy: CE_POINTER [ANY]): INTEGER_32
		local
			l_old_handler: CE_ROUTINE
			l_tmp: INTEGER_32
			l_tmp___2: INTEGER_32
		do
			l_old_handler := XSetErrorHandler (x_error_check_address)
			got_x_error.item := 0
			if (create {P_GLOBALS_STATIC}).commProperty.item = {NATURAL_32} 0 then
				(create {P_GLOBALS_STATIC}).commProperty.item := XInternAtom (a_dpy, ce_string ("Comm"), 0)
			end
			if vimProperty.item = {NATURAL_32} 0 then
				vimProperty.item := XInternAtom (a_dpy, ce_string ("Vim"), 0)
			end
			if registryProperty.item = {NATURAL_32} 0 then
				registryProperty.item := XInternAtom (a_dpy, ce_string ("VimRegistry"), 0)
			end
			if (create {P_GLOBALS_STATIC}).commWindow.item = {NATURAL_32} 0 then
				l_tmp := getpid;
				(create {P_GLOBALS_STATIC}).commWindow.item := XCreateSimpleWindow (a_dpy, (XDefaultRootWindow (a_dpy)), l_tmp, 0, {NATURAL_32} 10, {NATURAL_32} 10, {NATURAL_32} 0, ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + (create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.default_screen).item.white_pixel, ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + (create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.default_screen).item.white_pixel)
				XSelectInput (a_dpy, (create {P_GLOBALS_STATIC}).commWindow.item, (1).bit_shift_left (22)).do_nothing
				XGrabServer (a_dpy).do_nothing
				DeleteAnyLingerer (a_dpy, (create {P_GLOBALS_STATIC}).commWindow.item)
				XUngrabServer (a_dpy).do_nothing
			end
			XChangeProperty (a_dpy, (create {P_GLOBALS_STATIC}).commWindow.item, vimProperty.item, (31).to_natural_32, 8, 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("7.3")), (strlen (ce_string ("7.3"))).to_integer_32 + 1).do_nothing
			XSync (a_dpy, 0).do_nothing
			XSetErrorHandler (l_old_handler).do_nothing
			if got_x_error.item.to_boolean then
				l_tmp___2 := -1
			else
				l_tmp___2 := 0
			end
			Result := l_tmp___2
		end

	LookupName (a_dpy: CE_POINTER [ANY]; a_name___1: CE_POINTER [NATURAL_8]; a_delete: INTEGER_32; a_loose: CE_POINTER [CE_POINTER [NATURAL_8]]): NATURAL_32
		local
			l_regProp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_entry: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_numItems: CE_ARRAY [NATURAL_32]
			l_returnValue: CE_ARRAY [NATURAL_32]
			l_count___2: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_regProp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_numItems.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_returnValue.make (<<1>>)

			if (GetRegProp (a_dpy, l_regProp, l_numItems, 0)) = 0 then
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				l_returnValue.item := (0).to_natural_32
				l_entry := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_p___0 := l_regProp.item
				from
				until
					not (not (l_return or l_break) and then ((l_p___0.distance ((l_regProp.item))).to_natural_32 < l_numItems.item))
				loop
					l_break := False
					l_entry := l_p___0
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item).to_integer_32 /= 0 then
							if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
					if (l_p___0.item).to_integer_32 /= 0 then
						if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))) = 0 then
							sscanf ([create {CE_INTEGER_8_POINTER}.make_cast (l_entry), ce_string ("%%x"), l_returnValue]).do_nothing
							l_break := True
						end
					end
					if not (l_return or l_break) then
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0 := l_p___0 + 1
						end
						l_p___0 := l_p___0 + 1
					end
				end
				l_break := False
				if not a_loose.is_void then
					if l_returnValue.item = {NATURAL_32} 0 then
						if not (IsSerialName (a_name___1)).to_boolean then
							l_p___0 := l_regProp.item
							from
							until
								not (not (l_return or l_break) and then ((l_p___0.distance ((l_regProp.item))).to_natural_32 < l_numItems.item))
							loop
								l_break := False
								l_entry := l_p___0
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___0.item).to_integer_32 /= 0 then
										if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break) then
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
								if (l_p___0.item).to_integer_32 /= 0 then
									if (IsSerialName (l_p___0 + 1)).to_boolean then
										if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))))) = 0 then
											sscanf ([create {CE_INTEGER_8_POINTER}.make_cast (l_entry), ce_string ("%%x"), l_returnValue]).do_nothing
											a_loose.item := (create {P_MISC2_STATIC}).vim_strsave (l_p___0 + 1)
											l_break := True
										end
									end
								end
								if not (l_return or l_break) then
									from
									until
										(l_p___0.item).to_integer_32 = 0
									loop
										l_p___0 := l_p___0 + 1
									end
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
						end
					end
				end
				if a_delete.to_boolean then
					if l_returnValue.item /= {NATURAL_32} 0 then
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0 := l_p___0 + 1
						end
						l_p___0 := l_p___0 + 1
						l_count___2 := (l_numItems.item - (l_p___0.distance ((l_regProp.item))).to_natural_32).to_integer_32
						if l_count___2 > 0 then
							memmove (create {CE_VOID_POINTER}.make_cast (l_entry), create {CE_VOID_POINTER}.make_cast (l_p___0), l_count___2.to_natural_32).do_nothing
						end
						XChangeProperty (a_dpy, ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty.item, (31).to_natural_32, 8, 0, l_regProp.item, (l_numItems.item - (l_p___0.distance (l_entry)).to_natural_32).to_integer_32).do_nothing
						XSync (a_dpy, 0).do_nothing
					end
				end
				if not (l_regProp.item).is_equal (empty_prop.item) then
					XFree (create {CE_VOID_POINTER}.make_cast (l_regProp.item)).do_nothing
				end
				Result := (l_returnValue.item).to_natural_32
			end
		end

	DeleteAnyLingerer (a_dpy: CE_POINTER [ANY]; a_win: NATURAL_32)
		local
			l_regProp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_entry: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_numItems: CE_ARRAY [NATURAL_32]
			l_wwin: CE_ARRAY [NATURAL_32]
			l_lastHalf: INTEGER_32
			l_return, l_continue: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_regProp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_numItems.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_wwin.make (<<1>>)

			l_entry := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if (GetRegProp (a_dpy, l_regProp, l_numItems, 0)) = 0 then
				l_return := True
			end
			if not l_return then
				l_p___0 := l_regProp.item
				from
				until
					not (not (l_return) and then ((l_p___0.distance ((l_regProp.item))).to_natural_32 < l_numItems.item))
				loop
					l_continue := False
					if (l_p___0.item).to_integer_32 /= 0 then
						sscanf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("%%x"), l_wwin]).do_nothing
						if (l_wwin.item).to_natural_32 = a_win then
							l_entry := l_p___0
							from
							until
								(l_p___0.item).to_integer_32 = 0
							loop
								l_p___0 := l_p___0 + 1
							end
							l_p___0 := l_p___0 + 1
							l_lastHalf := (l_numItems.item - (l_p___0.distance ((l_regProp.item))).to_natural_32).to_integer_32
							if l_lastHalf > 0 then
								memmove (create {CE_VOID_POINTER}.make_cast (l_entry), create {CE_VOID_POINTER}.make_cast (l_p___0), l_lastHalf.to_natural_32).do_nothing
							end
							l_numItems.item := ((l_entry.distance ((l_regProp.item))) + l_lastHalf).to_natural_32
							l_p___0 := l_entry
							l_continue := True
						end
					end
					if not (l_return or l_continue) then
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0 := l_p___0 + 1
						end
						l_p___0 := l_p___0 + 1
					end
					if (not l_return) then
						
					end
				end
				l_continue := False
				if not l_entry.is_void then
					XChangeProperty (a_dpy, ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty.item, (31).to_natural_32, 8, 0, l_regProp.item, l_p___0.distance ((l_regProp.item))).do_nothing
					XSync (a_dpy, 0).do_nothing
				end
				if not (l_regProp.item).is_equal (empty_prop.item) then
					XFree (create {CE_VOID_POINTER}.make_cast (l_regProp.item)).do_nothing
				end
			end
		end

	GetRegProp (a_dpy: CE_POINTER [ANY]; a_regPropp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_numItemsp: CE_POINTER [NATURAL_32]; a_domsg: INTEGER_32): INTEGER_32
		require
			not a_regPropp.is_void
		local
			l_result___2: INTEGER_32
			l_actualFormat: CE_ARRAY [INTEGER_32]
			l_bytesAfter: CE_ARRAY [NATURAL_32]
			l_actualType: CE_ARRAY [NATURAL_32]
			l_old_handler: CE_ROUTINE
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_actualFormat.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_bytesAfter.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_actualType.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_regPropp.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_old_handler := XSetErrorHandler (x_error_check_address)
					got_x_error.item := 0
					l_result___2 := XGetWindowProperty (a_dpy, ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty.item, 0, 100_000, 0, (31).to_natural_32, l_actualType, l_actualFormat, a_numItemsp, l_bytesAfter, a_regPropp)
					XSync (a_dpy, 0).do_nothing
					XSetErrorHandler (l_old_handler).do_nothing
					if got_x_error.item.to_boolean then
						Result := 0
						l_return := True
					end
					if not l_return and then (l_actualType.item = {NATURAL_32} 0) then
						a_numItemsp.item := (0).to_natural_32
						a_regPropp.item := empty_prop.item
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if l_result___2 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if l_actualFormat.item = 8 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_actualType.item = {NATURAL_32} 31 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if not (a_regPropp.item).is_void then
							XFree (create {CE_VOID_POINTER}.make_cast (a_regPropp.item)).do_nothing
						end
						XDeleteProperty (a_dpy, ((create {CE_CLASS_POINTER [SD_XPRIVDISPLAY]}.make_cast (a_dpy)).item.screens + 0).item.root, registryProperty.item).do_nothing
						if a_domsg.to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E251: VIM instance registry property is badly formed.  Deleted!"))))).do_nothing
						end
						Result := 0
						l_return := True
				when 9 then -- if done | if done | if done
					if not l_return then
						Result := 1
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	serverEventProc (a_dpy: CE_POINTER [ANY]; a_eventPtr: CE_POINTER [SD_XEVENT])
		local
			l_propInfo: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_result___2: INTEGER_32
			l_actualFormat: CE_ARRAY [INTEGER_32]
			l_code: CE_ARRAY [INTEGER_32]
			l_numItems: CE_ARRAY [NATURAL_32]
			l_bytesAfter: CE_ARRAY [NATURAL_32]
			l_actualType: CE_ARRAY [NATURAL_32]
			l_tofree: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_resWindow: NATURAL_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_script: CE_POINTER [NATURAL_8]
			l_serial___0: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_res: CE_POINTER [NATURAL_8]
			l_asKeys: INTEGER_32
			l_reply: CE_ARRAY [PD_GROWARRAY]
			l_enc: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_32
			l_serial___1: CE_ARRAY [INTEGER_32]
			l_gotSerial: INTEGER_32
			l_res___0: CE_POINTER [NATURAL_8]
			l_pcPtr: CE_POINTER [PD_PENDINGCOMMAND]
			l_enc___0: CE_POINTER [NATURAL_8]
			l_win: NATURAL_32
			l_u: CE_ARRAY [NATURAL_32]
			l_gotWindow: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [PD_SERVERREPLY]
			l_enc___1: CE_POINTER [NATURAL_8]
			l_winstr: CE_ARRAY [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_propInfo.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_actualFormat.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_code.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_numItems.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_bytesAfter.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_actualType.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_tofree.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_reply.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_serial___1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_u.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_winstr.make (<<30>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not a_eventPtr.is_void then
						if a_eventPtr.item.xproperty.atom /= (create {P_GLOBALS_STATIC}).commProperty.item then
							l_return := True
						elseif a_eventPtr.item.xproperty.state /= 0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_propInfo.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_result___2 := XGetWindowProperty (a_dpy, (create {P_GLOBALS_STATIC}).commWindow.item, (create {P_GLOBALS_STATIC}).commProperty.item, 0, 100_000, 1, (31).to_natural_32, l_actualType, l_actualFormat, l_numItems, l_bytesAfter, l_propInfo)
						if l_result___2 = 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 4 then -- else:
						if l_actualType.item = {NATURAL_32} 31 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_actualFormat.item = 8 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if not (l_propInfo.item).is_void then
							XFree (create {CE_VOID_POINTER}.make_cast (l_propInfo.item)).do_nothing
						end
						l_return := True
				when 9 then -- if done | if done | if done
					if l_return then
						l_pos := -1 + 66 -- skip if block
					end
				when 10 then -- if:
						l_p___0 := l_propInfo.item
				when 11 then -- loop condition:
						if not (not (l_return) and then ((l_p___0.distance ((l_propInfo.item))).to_natural_32 < l_numItems.item)) then
							l_pos := -1 + 65 -- skip loop
						end
				when 12 then -- loop body:
						l_continue := False
						if (l_p___0.item).to_integer_32 = 0 then
							l_p___0 := l_p___0 + 1
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 64 -- skip if block
						end
				when 13 then -- if:
						if (l_p___0.item).to_integer_32 /= 99 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 64
				when 16 then -- else:
						if (l_p___0.item).to_integer_32 /= 107 then
							l_pos := -1 + 32 -- skip if block
						end
				when 17 then -- if: | _L___3:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_pos := -1 + 30 -- skip if block
						end
				when 18 then -- if:
						l_asKeys := ((l_p___0.item).to_integer_32 = 107).to_integer
						l_p___0 := l_p___0 + (2)
						l_name___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_resWindow := (0).to_natural_32
						l_serial___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						l_script := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_enc := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 19 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 28 -- skip loop
						end
				when 20 then -- loop body:
						l_break := False
						if (l_p___0.distance ((l_propInfo.item))).to_natural_32 < l_numItems.item then
							if (l_p___0.item).to_integer_32 /= 45 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 27 -- skip if block
						end
				when 21 then -- if:
						inspect (l_p___0[1]).to_integer_32 -- switch 1 head
						when 114 then l_pos := -1 + 22
						when 110 then l_pos := -1 + 23
						when 115 then l_pos := -1 + 24
						when 69 then l_pos := -1 + 25
						else l_pos := -1 + 26
						end
				when 22 then -- switch 1, case 114
						l_end := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + 2)
						l_resWindow := (0).to_natural_32
						from
						until
							(l_break)
						loop
							l_break := False
							if not ((create {P_CHARSET_STATIC}).vim_isxdigit ((l_end.item).to_integer_32)).to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_resWindow := {NATURAL_32} 16 * l_resWindow + ((create {P_CHARSET_STATIC}).hex2nr ((l_end.item).to_integer_32)).to_natural_32
								l_end := l_end + 1
							end
						end
						l_break := False
						if l_end.is_equal (l_p___0 + 2) then
							l_resWindow := (0).to_natural_32
						elseif (l_end.item).to_integer_32 /= 32 then
							l_resWindow := (0).to_natural_32
						else
							l_serial___0 := l_end + 1
							l_p___0 := l_serial___0;
							(create {P_GLOBALS_STATIC}).clientWindow.item := l_resWindow
						end
						l_pos := -1 + 26 -- switch 1; break
				when 23 then -- switch 1, case 110
						if (l_p___0[2]).to_integer_32 = 32 then
							l_name___1 := l_p___0 + 3
						end
						l_pos := -1 + 26 -- switch 1; break
				when 24 then -- switch 1, case 115
						if (l_p___0[2]).to_integer_32 = 32 then
							l_script := l_p___0 + 3
						end
						l_pos := -1 + 26 -- switch 1; break
				when 25 then -- switch 1, case 69
						if (l_p___0[2]).to_integer_32 = 32 then
							l_enc := l_p___0 + 3
						end
						l_pos := -1 + 26 -- switch 1; break
				when 26 then -- switch 1, done:
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0 := l_p___0 + 1
						end
						l_p___0 := l_p___0 + 1
				when 27 then -- if done
						l_pos := -1 + 19 -- back to loop condition
				when 28 then -- loop done
						l_break := False
						if l_script.is_void then
							l_continue := True
						elseif l_name___1.is_void then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							if l_resWindow /= {NATURAL_32} 0 then
								l_reply.item.ga_init2 (1, 100)
								l_reply.item.ga_grow (({NATURAL_32} 50 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item)))).to_integer_32).do_nothing
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_reply.item.ga_data), ce_string ("%%cr%%c-E %%s%%c-s %%s%%c-r "), 0, 0, (create {P_OPTION_STATIC}).p_enc.item.item, 0, l_serial___0, 0]).do_nothing
								l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_enc.item.item))
								l_reply.item.ga_len := (({NATURAL_32} 14 + l_tmp___2) + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_serial___0)))).to_integer_32
							end
							l_res := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							if not ((create {P_GLOBALS_STATIC}).serverName.item).is_void then
								if (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).serverName.item))) = 0 then
									l_script := (create {P_MAIN_STATIC}).serverConvert (l_enc, l_script, l_tofree)
									if l_asKeys.to_boolean then
										(create {P_MAIN_STATIC}).server_to_input_buf (l_script)
									else
										l_res := (create {P_MAIN_STATIC}).eval_client_expr_to_string (l_script)
									end
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tofree.item))
								end
							end
							if l_resWindow /= {NATURAL_32} 0 then
								if not l_res.is_void then
									l_reply.item.ga_concat (l_res)
								elseif l_asKeys = 0 then
									l_reply.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invexprmsg.item))))))
									l_reply.item.ga_append (0)
									l_reply.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-c 1")))
								end
								l_reply.item.ga_append (('%/0/').code)
								AppendPropCarefully (a_dpy, l_resWindow, (create {P_GLOBALS_STATIC}).commProperty.item, create {CE_NATURAL_8_POINTER}.make_cast (l_reply.item.ga_data), l_reply.item.ga_len).do_nothing
								l_reply.item.ga_clear
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_res))
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						l_pos := -1 + 32 -- goto _L___2
				when 31 then -- if done | if block done, skip else block:
						l_pos := -1 + 64
				when 32 then -- else: | _L___2:
						if (l_p___0.item).to_integer_32 /= 114 then
							l_pos := -1 + 48 -- skip if block
						end
				when 33 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_pos := -1 + 46 -- skip if block
						end
				when 34 then -- if:
						l_p___0 := l_p___0 + (2)
						l_gotSerial := 0
						l_res___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						l_code.item := 0
						l_enc___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 35 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 44 -- skip loop
						end
				when 36 then -- loop body:
						l_break := False
						if (l_p___0.distance ((l_propInfo.item))).to_natural_32 < l_numItems.item then
							if (l_p___0.item).to_integer_32 /= 45 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 43 -- skip if block
						end
				when 37 then -- if:
						inspect (l_p___0[1]).to_integer_32 -- switch 2 head
						when 114 then l_pos := -1 + 38
						when 69 then l_pos := -1 + 39
						when 115 then l_pos := -1 + 40
						when 99 then l_pos := -1 + 41
						else l_pos := -1 + 42
						end
				when 38 then -- switch 2, case 114
						if (l_p___0[2]).to_integer_32 = 32 then
							l_res___0 := l_p___0 + 3
						end
						l_pos := -1 + 42 -- switch 2; break
				when 39 then -- switch 2, case 69
						if (l_p___0[2]).to_integer_32 = 32 then
							l_enc___0 := l_p___0 + 3
						end
						l_pos := -1 + 42 -- switch 2; break
				when 40 then -- switch 2, case 115
						if (sscanf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_p___0) + 2), ce_string (" %%d"), l_serial___1])) = 1 then
							l_gotSerial := 1
						end
						l_pos := -1 + 42 -- switch 2; break
				when 41 then -- switch 2, case 99
						if (sscanf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_p___0) + 2), ce_string (" %%d"), l_code])) /= 1 then
							l_code.item := 0
						end
						l_pos := -1 + 42 -- switch 2; break
				when 42 then -- switch 2, done:
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0 := l_p___0 + 1
						end
						l_p___0 := l_p___0 + 1
				when 43 then -- if done
						l_pos := -1 + 35 -- back to loop condition
				when 44 then -- loop done
						l_break := False
						if not l_gotSerial.to_boolean then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_pcPtr := pendingCommands.item
							from
							until
								not (not (l_break) and then (not l_pcPtr.is_void))
							loop
								l_break := False
								l_continue := False
								if l_serial___1.item /= l_pcPtr.item.serial then
									l_continue := True
								elseif not (l_pcPtr.item.result2).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_pcPtr.item.code := l_code.item
									if not l_res___0.is_void then
										l_res___0 := (create {P_MAIN_STATIC}).serverConvert (l_enc___0, l_res___0, l_tofree)
										if (l_tofree.item).is_void then
											l_res___0 := (create {P_MISC2_STATIC}).vim_strsave (l_res___0)
										end
										l_pcPtr.item.result2 := l_res___0
									else
										l_pcPtr.item.result2 := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
									end
									l_break := True
								end
								if (not l_break) then
									l_pcPtr := l_pcPtr.item.nextPtr
								end
							end
							l_break := False
							l_continue := False
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:
						l_pos := -1 + 48 -- goto _L___1
				when 47 then -- if done | if block done, skip else block:
						l_pos := -1 + 64
				when 48 then -- else: | _L___1:
						if (l_p___0.item).to_integer_32 /= 110 then
							l_pos := -1 + 63 -- skip if block
						end
				when 49 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_pos := -1 + 61 -- skip if block
						end
				when 50 then -- if:
						l_win := (0).to_natural_32
						l_p___0 := l_p___0 + (2)
						l_gotWindow := 0
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						l_enc___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 51 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 59 -- skip loop
						end
				when 52 then -- loop body:
						l_break := False
						if (l_p___0.distance ((l_propInfo.item))).to_natural_32 < l_numItems.item then
							if (l_p___0.item).to_integer_32 /= 45 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 58 -- skip if block
						end
				when 53 then -- if:
						inspect (l_p___0[1]).to_integer_32 -- switch 3 head
						when 110 then l_pos := -1 + 54
						when 69 then l_pos := -1 + 55
						when 119 then l_pos := -1 + 56
						else l_pos := -1 + 57
						end
				when 54 then -- switch 3, case 110
						if (l_p___0[2]).to_integer_32 = 32 then
							l_str___1 := l_p___0 + 3
						end
						l_pos := -1 + 57 -- switch 3; break
				when 55 then -- switch 3, case 69
						if (l_p___0[2]).to_integer_32 = 32 then
							l_enc___1 := l_p___0 + 3
						end
						l_pos := -1 + 57 -- switch 3; break
				when 56 then -- switch 3, case 119
						if (sscanf ([(create {CE_INTEGER_8_POINTER}.make_cast (l_p___0) + 2), ce_string (" %%x"), l_u])) = 1 then
							l_win := (l_u.item).to_natural_32
							l_gotWindow := 1
						end
						l_pos := -1 + 57 -- switch 3; break
				when 57 then -- switch 3, done:
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0 := l_p___0 + 1
						end
						l_p___0 := l_p___0 + 1
				when 58 then -- if done
						l_pos := -1 + 51 -- back to loop condition
				when 59 then -- loop done
						l_break := False
						if not l_gotWindow.to_boolean then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_str___1 := (create {P_MAIN_STATIC}).serverConvert (l_enc___1, l_str___1, l_tofree)
							l_r := ServerReplyFind (l_win, {PC_SERVERREPLYOP}.SROP_Add)
							if not l_r.is_void then
								(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_r.c_pointer + (create {PD_SERVERREPLY}.make).offset_of ("strings"))).item.ga_concat (l_str___1);
								(create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (l_r.c_pointer + (create {PD_SERVERREPLY}.make).offset_of ("strings"))).item.ga_append (('%/0/').code)
							end
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_winstr), ce_string ("0x%%x"), l_win.to_natural_32]).do_nothing;
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_REMOTEREPLY, l_winstr, l_str___1, 1, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tofree.item))
						end
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 61 then -- else:
						l_pos := -1 + 63 -- goto _L___0
				when 62 then -- if done | if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else: | _L___0:
						from
						until
							(l_p___0.item).to_integer_32 = 0
						loop
							l_p___0 := l_p___0 + 1
						end
						l_p___0 := l_p___0 + 1
				when 64 then -- if done | if done | if done | if done
						if (not l_return) then
							
						end
						l_pos := -1 + 11 -- back to loop condition
				when 65 then -- loop done
						l_continue := False
						XFree (create {CE_VOID_POINTER}.make_cast (l_propInfo.item)).do_nothing
				when 66 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	AppendPropCarefully (a_dpy: CE_POINTER [ANY]; a_window, a_property: NATURAL_32; a_value: CE_POINTER [NATURAL_8]; a_length: INTEGER_32): INTEGER_32
		local
			l_old_handler: CE_ROUTINE
			l_tmp: INTEGER_32
		do
			l_old_handler := XSetErrorHandler (x_error_check_address)
			got_x_error.item := 0
			XChangeProperty (a_dpy, a_window, a_property, (31).to_natural_32, 8, 2, a_value, a_length).do_nothing
			XSync (a_dpy, 0).do_nothing
			XSetErrorHandler (l_old_handler).do_nothing
			if got_x_error.item.to_boolean then
				l_tmp := -1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	x_error_check (a_dpy: CE_POINTER [ANY]; a_error_event: CE_POINTER [SD_XERROREVENT]): INTEGER_32
		do
			got_x_error.item := 1
			Result := 0
		end

	IsSerialName (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_len: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1))).to_integer_32
			if l_len > 1 then
				if ((create {P_CHARSET_STATIC}).vim_isdigit ((a_str___1[(l_len - 1)]).to_integer_32)).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

feature {ANY} -- routine addresses

	WaitForPend_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent WaitForPend)
		end

	WaitForReply_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent WaitForReply)
		end

	x_error_check_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent x_error_check)
		end

end
