class
	P_MEMFILE_STATIC

inherit
	CE_UTILITIES
	S_SYS_STAT_STATIC
	S_UNISTD_STATIC
	S_LIBINTL_STATIC

feature {ANY} -- public attributes

	total_mem_used: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

feature {ANY} -- public routines

	mf_open (a_fname: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): CE_POINTER [PD_MEMFILE]
		local
			l_mfp: CE_POINTER [PD_MEMFILE]
			l_i___0: INTEGER_32
			l_size: INTEGER_32
			l_stf: CE_ARRAY [SD_STAT]
			l_shift: INTEGER_32
			l_page_size: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_stf.make (<<1>>)

			l_mfp := create {CE_CLASS_POINTER [PD_MEMFILE]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_MEMFILE}.make).structure_size.to_natural_32)))
			if l_mfp.is_void then
				Result := (create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if a_fname.is_void then
					l_mfp.item.mf_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_mfp.item.mf_ffname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_mfp.item.mf_fd := -1
				else
					l_mfp.item.mf_do_open (a_fname, a_flags___0)
					if l_mfp.item.mf_fd < 0 then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_mfp))
						Result := (create {CE_CLASS_POINTER [PD_MEMFILE]}.make_shared (default_pointer))
						l_return := True
					end
				end
			end
			if not l_return then
				l_mfp.item.mf_free_first := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
				l_mfp.item.mf_used_first := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
				l_mfp.item.mf_used_last := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
				l_mfp.item.mf_dirty := 0
				l_mfp.item.mf_used_count := {NATURAL_32} 0
				l_i___0 := 0
				from
				until
					not (l_i___0 < 64)
				loop
					l_mfp.item.mf_hash[l_i___0] := create {CE_CLASS_POINTER [PD_BLOCK_HDR]}.make_shared (default_pointer)
					l_mfp.item.mf_trans[l_i___0] := create {CE_CLASS_POINTER [PD_NR_TRANS]}.make_shared (default_pointer)
					l_i___0 := l_i___0 + 1
				end
				l_mfp.item.mf_page_size := {NATURAL_32} 4_096
				l_mfp.item.mf_old_key := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				if l_mfp.item.mf_fd >= 0 then
					if (fstat (l_mfp.item.mf_fd, l_stf)) = 0 then
						if l_stf.item.st_blksize >= 1_048 then
							if l_stf.item.st_blksize <= 50_000 then
								l_mfp.item.mf_page_size := (l_stf.item.st_blksize).to_natural_32
							end
						end
					end
				end
				if l_mfp.item.mf_fd < 0 then
					l_mfp.item.mf_blocknr_max := (0).to_integer_32
				elseif ((a_flags___0).bit_and (640)).to_boolean then
					l_mfp.item.mf_blocknr_max := (0).to_integer_32
				else
					l_size := lseek (l_mfp.item.mf_fd, 0, 2)
					if l_size <= 0 then
						l_mfp.item.mf_blocknr_max := (0).to_integer_32
					else
						l_mfp.item.mf_blocknr_max := (((l_size.to_natural_32 + (l_mfp.item.mf_page_size).to_natural_32) - {NATURAL_32} 1) // (l_mfp.item.mf_page_size).to_natural_32).to_integer_32
					end
				end
				l_mfp.item.mf_blocknr_min := (-1).to_integer_32
				l_mfp.item.mf_neg_count := (0).to_integer_32
				l_mfp.item.mf_infile_count := l_mfp.item.mf_blocknr_max
				l_shift := 10
				l_page_size := l_mfp.item.mf_page_size
				from
				until
					(l_break)
				loop
					l_break := False
					if l_shift > 0 then
						if ((l_page_size).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_page_size := (l_page_size).bit_shift_right ((1))
						l_shift := l_shift - 1
					end
				end
				l_break := False
				l_mfp.item.mf_used_count_max := ((((create {P_OPTION_STATIC}).p_mm.item.item).bit_shift_left (l_shift)).to_natural_32 // l_page_size.to_natural_32).to_natural_32
				if l_mfp.item.mf_used_count_max < {NATURAL_32} 10 then
					l_mfp.item.mf_used_count_max := {NATURAL_32} 10
				end
				Result := l_mfp
			end
		end

	mf_close (a_mfp: CE_POINTER [PD_MEMFILE]; a_del_file: INTEGER_32)
		local
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_nextp: CE_POINTER [PD_BLOCK_HDR]
			l_tp: CE_POINTER [PD_NR_TRANS]
			l_tpnext: CE_POINTER [PD_NR_TRANS]
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if a_mfp.is_void then
				l_return := True
			end
			if not l_return then
				if a_mfp.item.mf_fd >= 0 then
					if (close (a_mfp.item.mf_fd)) < 0 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_swapclose.item)))))).do_nothing
					end
				end
				if a_del_file.to_boolean then
					if not (a_mfp.item.mf_fname).is_void then
						unlink (create {CE_INTEGER_8_POINTER}.make_cast (a_mfp.item.mf_fname)).do_nothing
					end
				end
				l_hp := a_mfp.item.mf_used_first
				from
				until
					l_hp.is_void
				loop
					total_mem_used.item := total_mem_used.item - ((l_hp.item.bh_page_count).to_natural_32 * a_mfp.item.mf_page_size).to_natural_32
					l_nextp := l_hp.item.bh_next
					l_hp.item.mf_free_bhdr
					l_hp := l_nextp
				end
				from
				until
					(a_mfp.item.mf_free_first).is_void
				loop
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((a_mfp.item.mf_rem_free)))
				end
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < 64))
				loop
					l_tp := a_mfp.item.mf_trans[l_i___0]
					from
					until
						l_tp.is_void
					loop
						l_tpnext := l_tp.item.nt_next;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tp))
						l_tp := l_tpnext
					end
					l_i___0 := l_i___0 + 1
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_mfp.item.mf_fname));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_mfp.item.mf_ffname));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_mfp))
			end
		end

	mf_put (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR]; a_dirty, a_infile: INTEGER_32)
		require
			not a_hp.is_void
		local
			l_flags___0: INTEGER_32
		do
			l_flags___0 := (a_hp.item.bh_flags).to_integer_32
			if ((l_flags___0).bit_and (2)) = 0 then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E293: block was not locked"))))).do_nothing
			end
			l_flags___0 := (l_flags___0).bit_and ((-3))
			if a_dirty.to_boolean then
				l_flags___0 := (l_flags___0).bit_or ((1))
				a_mfp.item.mf_dirty := 1
			end
			a_hp.item.bh_flags := l_flags___0.to_integer_8
			if a_infile.to_boolean then
				mf_trans_add (a_mfp, a_hp).do_nothing
			end
		end

	mf_rem_hash (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR])
		require
			not a_hp.is_void
		do
			if (a_hp.item.bh_hash_prev).is_void then
				a_mfp.item.mf_hash[(a_hp.item.bh_bnum).bit_and (63)] := a_hp.item.bh_hash_next
			else
				(a_hp.item.bh_hash_prev).item.bh_hash_next := a_hp.item.bh_hash_next
			end
			if (not (a_hp.item.bh_hash_next).is_void) then
				(a_hp.item.bh_hash_next).item.bh_hash_prev := a_hp.item.bh_hash_prev
			end
		end

	mf_release_all: INTEGER_32
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_mfp: CE_POINTER [PD_MEMFILE]
			l_hp: CE_POINTER [PD_BLOCK_HDR]
			l_retval: INTEGER_32
			l_return: BOOLEAN
		do
			l_retval := 0
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				not (not (l_return) and then (not l_buf___6.is_void))
			loop
				l_mfp := l_buf___6.item.b_ml.ml_mfp
				if not l_mfp.is_void then
					if l_mfp.item.mf_fd < 0 then
						if (l_buf___6.item.b_may_swap).to_boolean then
							l_buf___6.item.ml_open_file
						end
					end
					if l_mfp.item.mf_fd >= 0 then
						l_hp := l_mfp.item.mf_used_last
						from
						until
							l_hp.is_void
						loop
							if not (((l_hp.item.bh_flags).to_integer_32).bit_and (2)).to_boolean then
								if not (((l_hp.item.bh_flags).to_integer_32).bit_and (1)).to_boolean then
									l_mfp.item.mf_rem_used (l_hp)
									mf_rem_hash (l_mfp, l_hp)
									l_hp.item.mf_free_bhdr
									l_hp := l_mfp.item.mf_used_last
									l_retval := 1
								elseif (l_mfp.item.mf_write (l_hp)) /= 0 then
									l_mfp.item.mf_rem_used (l_hp)
									mf_rem_hash (l_mfp, l_hp)
									l_hp.item.mf_free_bhdr
									l_hp := l_mfp.item.mf_used_last
									l_retval := 1
								else
									l_hp := l_hp.item.bh_prev
								end
							else
								l_hp := l_hp.item.bh_prev
							end
						end
					end
				end
				l_buf___6 := l_buf___6.item.b_next
			end
			Result := l_retval
		end

	mf_trans_add (a_mfp: CE_POINTER [PD_MEMFILE]; a_hp: CE_POINTER [PD_BLOCK_HDR]): INTEGER_32
		require
			not a_hp.is_void
		local
			l_freep: CE_POINTER [PD_BLOCK_HDR]
			l_new_bnum: INTEGER_32
			l_hash: INTEGER_32
			l_np: CE_POINTER [PD_NR_TRANS]
			l_page_count___0: INTEGER_32
			l_return: BOOLEAN
		do
			if a_hp.item.bh_bnum >= 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_np := create {CE_CLASS_POINTER [PD_NR_TRANS]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_NR_TRANS}.make).structure_size.to_natural_32)))
				if l_np.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_freep := a_mfp.item.mf_free_first
				l_page_count___0 := a_hp.item.bh_page_count
				if not l_freep.is_void then
					if l_freep.item.bh_page_count >= l_page_count___0 then
						l_new_bnum := l_freep.item.bh_bnum
						if l_freep.item.bh_page_count > l_page_count___0 then
							l_freep.item.bh_bnum := l_freep.item.bh_bnum + l_page_count___0.to_integer_32
							l_freep.item.bh_page_count := l_freep.item.bh_page_count - l_page_count___0
						else
							l_freep := a_mfp.item.mf_rem_free;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_freep))
						end
					else
						l_new_bnum := a_mfp.item.mf_blocknr_max
						a_mfp.item.mf_blocknr_max := a_mfp.item.mf_blocknr_max + l_page_count___0.to_integer_32
					end
				else
					l_new_bnum := a_mfp.item.mf_blocknr_max
					a_mfp.item.mf_blocknr_max := a_mfp.item.mf_blocknr_max + l_page_count___0.to_integer_32
				end
				l_np.item.nt_old_bnum := a_hp.item.bh_bnum
				l_np.item.nt_new_bnum := l_new_bnum
				mf_rem_hash (a_mfp, a_hp)
				a_hp.item.bh_bnum := l_new_bnum
				a_mfp.item.mf_ins_hash (a_hp)
				l_hash := ((l_np.item.nt_old_bnum).bit_and (63)).to_integer_32
				l_np.item.nt_next := a_mfp.item.mf_trans[l_hash]
				a_mfp.item.mf_trans[l_hash] := l_np
				if not (l_np.item.nt_next).is_void then
					(l_np.item.nt_next).item.nt_prev := l_np
				end
				l_np.item.nt_prev := create {CE_CLASS_POINTER [PD_NR_TRANS]}.make_shared (default_pointer)
				Result := 1
			end
		end

	mf_fullname (a_mfp: CE_POINTER [PD_MEMFILE])
		do
			if not a_mfp.is_void then
				if not (a_mfp.item.mf_fname).is_void then
					if not (a_mfp.item.mf_ffname).is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_mfp.item.mf_fname))
						a_mfp.item.mf_fname := a_mfp.item.mf_ffname
						a_mfp.item.mf_ffname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					end
				end
			end
		end

end
