class
	P_SHA256_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	hexit: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<65>>)
		end

	sha_self_test_msg: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("abc"),
					ce_string ("abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	sha_self_test_vector: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad"),
					ce_string ("248d6a61d20638b8e5c026930c3e6039a33ce45964ff2167f6ecedd419db06c1"),
					ce_string ("cdc76e5c9914fb9281a1c7e284d73e67f1809a48a497200e046d39ccc7112cd0")
				>>)
		end

	failures: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	sha256_self_tested: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	sha256_update (a_ctx: CE_POINTER [PD_CONTEXT_SHA256_T]; a_input: CE_POINTER [NATURAL_8]; a_length: NATURAL_32)
		local
			l_input: CE_POINTER [NATURAL_8]
			l_length: NATURAL_32
			l_left: NATURAL_32
			l_fill: NATURAL_32
			l_return: BOOLEAN
		do
			l_input := a_input
			l_length := a_length
			if l_length = {NATURAL_32} 0 then
				l_return := True
			end
			if not l_return then
				l_left := (a_ctx.item.total[0]).bit_and ({NATURAL_32} 63)
				l_fill := {NATURAL_32} 64 - l_left
				a_ctx.item.total[0] := a_ctx.item.total[0] + l_length
				a_ctx.item.total[0] := (a_ctx.item.total[0]).bit_and (({NATURAL_32} 4_294_967_295))
				if a_ctx.item.total[0] < l_length then
					a_ctx.item.total[1] := (a_ctx.item.total[1]) + 1
				end
				if l_left.to_boolean then
					if l_length >= l_fill then
						memcpy (create {CE_VOID_POINTER}.make_cast ((a_ctx.item.buffer + l_left.to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_input), l_fill).do_nothing
						a_ctx.item.sha256_process (create {CE_NATURAL_8_POINTER}.make_cast ((a_ctx.item.buffer)))
						l_length := l_length - l_fill
						l_input := l_input + l_fill.to_integer_32
						l_left := (0).to_natural_32
					end
				end
				from
				until
					not (l_length >= {NATURAL_32} 64)
				loop
					a_ctx.item.sha256_process (l_input)
					l_length := l_length - ({NATURAL_32} 64)
					l_input := l_input + (64)
				end
				if l_length.to_boolean then
					memcpy (create {CE_VOID_POINTER}.make_cast ((a_ctx.item.buffer + l_left.to_integer_32)), create {CE_VOID_POINTER}.make_cast (l_input), l_length).do_nothing
				end
			end
		end

	sha256_bytes (a_buf___6: CE_POINTER [NATURAL_8]; a_buf_len: INTEGER_32; a_salt: CE_POINTER [NATURAL_8]; a_salt_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_sha256sum: CE_ARRAY [NATURAL_8]
			l_j: INTEGER_32
			l_ctx: CE_ARRAY [PD_CONTEXT_SHA256_T]
		do
			create {CE_NATURAL_8_ARRAY} l_sha256sum.make (<<32>>)
			create {CE_CLASS_ARRAY [PD_CONTEXT_SHA256_T]} l_ctx.make (<<1>>)

			sha256_self_test.do_nothing
			l_ctx.item.sha256_start
			sha256_update (l_ctx, a_buf___6, a_buf_len.to_natural_32)
			if not a_salt.is_void then
				sha256_update (l_ctx, a_salt, a_salt_len.to_natural_32)
			end
			l_ctx.item.sha256_finish (create {CE_NATURAL_8_POINTER}.make_cast (l_sha256sum))
			l_j := 0
			from
			until
				not (l_j < 32)
			loop
				sprintf ([(create {CE_INTEGER_8_POINTER}.make_cast (hexit.item) + l_j * 2), ce_string ("%%02x"), (l_sha256sum[l_j]).to_integer_32]).do_nothing
				l_j := l_j + 1
			end
			hexit.item[(({PLATFORM}.Natural_8_bytes.to_natural_32 * (65).to_natural_32) - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_natural_8
			Result := hexit.item
		end

	sha256_key (a_buf___6, a_salt: CE_POINTER [NATURAL_8]; a_salt_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_buf___6.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
				l_return := True
			elseif (a_buf___6.item).to_integer_32 = 0 then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
				l_return := True
			end
			if not l_return then
				Result := (sha256_bytes (a_buf___6, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6))).to_integer_32, a_salt, a_salt_len))
			end
		end

	sha256_self_test: INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_output: CE_ARRAY [INTEGER_8]
			l_ctx: CE_ARRAY [PD_CONTEXT_SHA256_T]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_sha256sum: CE_ARRAY [NATURAL_8]
			l_hexit___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_output.make (<<65>>)
			create {CE_CLASS_ARRAY [PD_CONTEXT_SHA256_T]} l_ctx.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<1_000>>)
			create {CE_NATURAL_8_ARRAY} l_sha256sum.make (<<32>>)

			if sha256_self_tested.item > 0 then
				if failures.item > 0 then
					l_tmp := 0
				else
					l_tmp := 1
				end
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				sha256_self_tested.item := 1
				l_i___0 := 0
				from
				until
					not (not (l_return) and then (l_i___0 < 3))
				loop
					if l_i___0 < 2 then
						l_hexit___0 := sha256_bytes (create {CE_NATURAL_8_POINTER}.make_cast (sha_self_test_msg.item[l_i___0]), (strlen (sha_self_test_msg.item[l_i___0])).to_integer_32, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
						strcpy (l_output, create {CE_INTEGER_8_POINTER}.make_cast (l_hexit___0)).do_nothing
					else
						l_ctx.item.sha256_start
						memset (create {CE_VOID_POINTER}.make_cast (l_buf___6), ('a').code, (1_000).to_natural_32).do_nothing
						l_j := 0
						from
						until
							not (l_j < 1_000)
						loop
							sha256_update (l_ctx, l_buf___6, (1_000).to_natural_32)
							l_j := l_j + 1
						end
						l_ctx.item.sha256_finish (create {CE_NATURAL_8_POINTER}.make_cast (l_sha256sum))
						l_j := 0
						from
						until
							not (l_j < 32)
						loop
							sprintf ([(l_output + l_j * 2), ce_string ("%%02x"), (l_sha256sum[l_j]).to_integer_32]).do_nothing
							l_j := l_j + 1
						end
					end
					if (memcmp (create {CE_VOID_POINTER}.make_cast (l_output), create {CE_VOID_POINTER}.make_cast (sha_self_test_vector.item[l_i___0]), (64).to_natural_32)).to_boolean then
						failures.item := failures.item + 1
						l_output[(({PLATFORM}.Integer_8_bytes.to_natural_32 * (65).to_natural_32) - {NATURAL_32} 1).to_integer_32] := (('%/0/').code).to_integer_8
					end
					l_i___0 := l_i___0 + 1
				end
				if failures.item > 0 then
					l_tmp___2 := 0
				else
					l_tmp___2 := 1
				end
				Result := l_tmp___2
			end
		end

end
