class
	PD_AFFFILE_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} af_enc.make
			create af_pref.make
			create af_suff.make
			create af_comp.make
		end

feature {ANY} -- fields

	af_enc: CE_POINTER [NATURAL_8] assign set_af_enc

	af_flagtype: INTEGER_32 assign set_af_flagtype

	af_rare: NATURAL_32 assign set_af_rare

	af_keepcase: NATURAL_32 assign set_af_keepcase

	af_bad: NATURAL_32 assign set_af_bad

	af_needaffix: NATURAL_32 assign set_af_needaffix

	af_circumfix: NATURAL_32 assign set_af_circumfix

	af_needcomp: NATURAL_32 assign set_af_needcomp

	af_comproot: NATURAL_32 assign set_af_comproot

	af_compforbid: NATURAL_32 assign set_af_compforbid

	af_comppermit: NATURAL_32 assign set_af_comppermit

	af_nosuggest: NATURAL_32 assign set_af_nosuggest

	af_pfxpostpone: INTEGER_32 assign set_af_pfxpostpone

	af_pref: PD_HASHTABLE_S assign set_af_pref

	af_suff: PD_HASHTABLE_S assign set_af_suff

	af_comp: PD_HASHTABLE_S assign set_af_comp

feature {ANY} -- field setters

	set_af_enc (a_af_enc: CE_POINTER [NATURAL_8])
		do
			af_enc := a_af_enc
			update_memory_field ("af_enc")
		end

	set_af_flagtype (a_af_flagtype: INTEGER_32)
		do
			af_flagtype := a_af_flagtype
			update_memory_field ("af_flagtype")
		end

	set_af_rare (a_af_rare: NATURAL_32)
		do
			af_rare := a_af_rare
			update_memory_field ("af_rare")
		end

	set_af_keepcase (a_af_keepcase: NATURAL_32)
		do
			af_keepcase := a_af_keepcase
			update_memory_field ("af_keepcase")
		end

	set_af_bad (a_af_bad: NATURAL_32)
		do
			af_bad := a_af_bad
			update_memory_field ("af_bad")
		end

	set_af_needaffix (a_af_needaffix: NATURAL_32)
		do
			af_needaffix := a_af_needaffix
			update_memory_field ("af_needaffix")
		end

	set_af_circumfix (a_af_circumfix: NATURAL_32)
		do
			af_circumfix := a_af_circumfix
			update_memory_field ("af_circumfix")
		end

	set_af_needcomp (a_af_needcomp: NATURAL_32)
		do
			af_needcomp := a_af_needcomp
			update_memory_field ("af_needcomp")
		end

	set_af_comproot (a_af_comproot: NATURAL_32)
		do
			af_comproot := a_af_comproot
			update_memory_field ("af_comproot")
		end

	set_af_compforbid (a_af_compforbid: NATURAL_32)
		do
			af_compforbid := a_af_compforbid
			update_memory_field ("af_compforbid")
		end

	set_af_comppermit (a_af_comppermit: NATURAL_32)
		do
			af_comppermit := a_af_comppermit
			update_memory_field ("af_comppermit")
		end

	set_af_nosuggest (a_af_nosuggest: NATURAL_32)
		do
			af_nosuggest := a_af_nosuggest
			update_memory_field ("af_nosuggest")
		end

	set_af_pfxpostpone (a_af_pfxpostpone: INTEGER_32)
		do
			af_pfxpostpone := a_af_pfxpostpone
			update_memory_field ("af_pfxpostpone")
		end

	set_af_pref (a_af_pref: PD_HASHTABLE_S)
		do
			af_pref := a_af_pref
			update_memory_field ("af_pref")
		end

	set_af_suff (a_af_suff: PD_HASHTABLE_S)
		do
			af_suff := a_af_suff
			update_memory_field ("af_suff")
		end

	set_af_comp (a_af_comp: PD_HASHTABLE_S)
		do
			af_comp := a_af_comp
			update_memory_field ("af_comp")
		end

feature {ANY} -- public routines

	spell_free_aff
		local
			l_ht: CE_POINTER [PD_HASHTABLE_S]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_todo: INTEGER_32
			l_ah: CE_POINTER [PD_AFFHEADER_S]
			l_ae: CE_POINTER [PD_AFFENTRY_S]
			l_return, l_break: BOOLEAN
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (af_enc))
			update_class_fields -- Current might have been changed; synchronize
			l_ht := create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref"))
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_todo := (l_ht.item.ht_used).to_integer_32
				l_hi___1 := l_ht.item.ht_array
				from
				until
					not (not (l_return) and then (l_todo > 0))
				loop
					if not ((l_hi___1.item.hi_key).is_void) then
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_todo := l_todo - 1
							l_ah := create {CE_CLASS_POINTER [PD_AFFHEADER_S]}.make_cast (l_hi___1.item.hi_key)
							l_ae := l_ah.item.ah_first
							from
							until
								l_ae.is_void
							loop
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ae.item.ae_prog))
								update_class_fields -- Current might have been changed; synchronize
								l_ae := l_ae.item.ae_next
							end
						end
					end
					l_hi___1 := l_hi___1 + 1
				end
				if l_ht.is_equal (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff"))) then
					l_break := True
				end
				if not (l_return or l_break) then
					l_ht := create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff"))
				end
			end
			l_break := False;
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_pref"))).item.hash_clear
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_suff"))).item.hash_clear
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp"))).item.hash_clear
			update_class_fields -- Current might have been changed; synchronize
		end

	get_affix_flags (a_afflist: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_flags___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
		do
			l_flags___0 := 0
			if af_keepcase /= {NATURAL_32} 0 then
				l_tmp := (create {P_SPELL_STATIC}).flag_in_afflist (af_flagtype, a_afflist, af_keepcase)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp.to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((192))
				end
			end
			if af_rare /= {NATURAL_32} 0 then
				l_tmp___0 := (create {P_SPELL_STATIC}).flag_in_afflist (af_flagtype, a_afflist, af_rare)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((8))
				end
			end
			if af_bad /= {NATURAL_32} 0 then
				l_tmp___1 := (create {P_SPELL_STATIC}).flag_in_afflist (af_flagtype, a_afflist, af_bad)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((16))
				end
			end
			if af_needcomp /= {NATURAL_32} 0 then
				l_tmp___2 := (create {P_SPELL_STATIC}).flag_in_afflist (af_flagtype, a_afflist, af_needcomp)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___2.to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((512))
				end
			end
			if af_comproot /= {NATURAL_32} 0 then
				l_tmp___3 := (create {P_SPELL_STATIC}).flag_in_afflist (af_flagtype, a_afflist, af_comproot)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((2_048))
				end
			end
			if af_nosuggest /= {NATURAL_32} 0 then
				l_tmp___4 := (create {P_SPELL_STATIC}).flag_in_afflist (af_flagtype, a_afflist, af_nosuggest)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___4.to_boolean then
					l_flags___0 := (l_flags___0).bit_or ((1_024))
				end
			end
			Result := l_flags___0
		end

feature {ANY}

	copy (a_other: like Current)
		do
			af_enc := a_other.af_enc
			af_flagtype := a_other.af_flagtype
			af_rare := a_other.af_rare
			af_keepcase := a_other.af_keepcase
			af_bad := a_other.af_bad
			af_needaffix := a_other.af_needaffix
			af_circumfix := a_other.af_circumfix
			af_needcomp := a_other.af_needcomp
			af_comproot := a_other.af_comproot
			af_compforbid := a_other.af_compforbid
			af_comppermit := a_other.af_comppermit
			af_nosuggest := a_other.af_nosuggest
			af_pfxpostpone := a_other.af_pfxpostpone
			af_pref := a_other.af_pref.twin
			af_suff := a_other.af_suff.twin
			af_comp := a_other.af_comp.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				af_enc.is_equal (a_other.af_enc) and
				af_flagtype = a_other.af_flagtype and
				af_rare = a_other.af_rare and
				af_keepcase = a_other.af_keepcase and
				af_bad = a_other.af_bad and
				af_needaffix = a_other.af_needaffix and
				af_circumfix = a_other.af_circumfix and
				af_needcomp = a_other.af_needcomp and
				af_comproot = a_other.af_comproot and
				af_compforbid = a_other.af_compforbid and
				af_comppermit = a_other.af_comppermit and
				af_nosuggest = a_other.af_nosuggest and
				af_pfxpostpone = a_other.af_pfxpostpone and
				af_pref.is_equal (a_other.af_pref) and
				af_suff.is_equal (a_other.af_suff) and
				af_comp.is_equal (a_other.af_comp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("af_enc"),
					create {CE_STRUCTURE_FIELD}.make ("af_flagtype"),
					create {CE_STRUCTURE_FIELD}.make ("af_rare"),
					create {CE_STRUCTURE_FIELD}.make ("af_keepcase"),
					create {CE_STRUCTURE_FIELD}.make ("af_bad"),
					create {CE_STRUCTURE_FIELD}.make ("af_needaffix"),
					create {CE_STRUCTURE_FIELD}.make ("af_circumfix"),
					create {CE_STRUCTURE_FIELD}.make ("af_needcomp"),
					create {CE_STRUCTURE_FIELD}.make ("af_comproot"),
					create {CE_STRUCTURE_FIELD}.make ("af_compforbid"),
					create {CE_STRUCTURE_FIELD}.make ("af_comppermit"),
					create {CE_STRUCTURE_FIELD}.make ("af_nosuggest"),
					create {CE_STRUCTURE_FIELD}.make ("af_pfxpostpone"),
					create {CE_STRUCTURE_FIELD}.make ("af_pref"),
					create {CE_STRUCTURE_FIELD}.make ("af_suff"),
					create {CE_STRUCTURE_FIELD}.make ("af_comp")
				>>)
			init_structure_info
		end

end
