class
	PD_AFFHEADER_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} ah_key.make (<<17>>)
			create {CE_CLASS_POINTER [PD_AFFENTRY_S]} ah_first.make
		end

feature {ANY} -- fields

	ah_key: CE_ARRAY [NATURAL_8]

	ah_flag: NATURAL_32 assign set_ah_flag

	ah_newID: INTEGER_32 assign set_ah_newID

	ah_combine: INTEGER_32 assign set_ah_combine

	ah_follows: INTEGER_32 assign set_ah_follows

	ah_first: CE_POINTER [PD_AFFENTRY_S] assign set_ah_first

feature {ANY} -- field setters

	set_ah_flag (a_ah_flag: NATURAL_32)
		do
			ah_flag := a_ah_flag
			update_memory_field ("ah_flag")
		end

	set_ah_newID (a_ah_newID: INTEGER_32)
		do
			ah_newID := a_ah_newID
			update_memory_field ("ah_newID")
		end

	set_ah_combine (a_ah_combine: INTEGER_32)
		do
			ah_combine := a_ah_combine
			update_memory_field ("ah_combine")
		end

	set_ah_follows (a_ah_follows: INTEGER_32)
		do
			ah_follows := a_ah_follows
			update_memory_field ("ah_follows")
		end

	set_ah_first (a_ah_first: CE_POINTER [PD_AFFENTRY_S])
		do
			ah_first := a_ah_first
			update_memory_field ("ah_first")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ah_key := a_other.ah_key.twin
			ah_flag := a_other.ah_flag
			ah_newID := a_other.ah_newID
			ah_combine := a_other.ah_combine
			ah_follows := a_other.ah_follows
			ah_first := a_other.ah_first
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ah_key.is_equal (a_other.ah_key) and
				ah_flag = a_other.ah_flag and
				ah_newID = a_other.ah_newID and
				ah_combine = a_other.ah_combine and
				ah_follows = a_other.ah_follows and
				ah_first.is_equal (a_other.ah_first)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ah_key", <<17>>),
					create {CE_STRUCTURE_FIELD}.make ("ah_flag"),
					create {CE_STRUCTURE_FIELD}.make ("ah_newID"),
					create {CE_STRUCTURE_FIELD}.make ("ah_combine"),
					create {CE_STRUCTURE_FIELD}.make ("ah_follows"),
					create {CE_STRUCTURE_FIELD}.make ("ah_first")
				>>)
			init_structure_info
		end

end
