class
	PD_AUTOPAT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} pat.make
			create {CE_CLASS_POINTER [PD_REGPROG_T]} reg_prog.make
			create {CE_CLASS_POINTER [PD_AUTOCMD]} cmds.make
			create {CE_CLASS_POINTER [PD_AUTOPAT]} next.make
		end

feature {ANY} -- fields

	group: INTEGER_32 assign set_group

	pat: CE_POINTER [NATURAL_8] assign set_pat

	patlen: INTEGER_32 assign set_patlen

	reg_prog: CE_POINTER [PD_REGPROG_T] assign set_reg_prog

	allow_dirs: INTEGER_8 assign set_allow_dirs

	last: INTEGER_8 assign set_last

	cmds: CE_POINTER [PD_AUTOCMD] assign set_cmds

	next: CE_POINTER [PD_AUTOPAT] assign set_next

	buflocal_nr: INTEGER_32 assign set_buflocal_nr

feature {ANY} -- field setters

	set_group (a_group: INTEGER_32)
		do
			group := a_group
			update_memory_field ("group")
		end

	set_pat (a_pat: CE_POINTER [NATURAL_8])
		do
			pat := a_pat
			update_memory_field ("pat")
		end

	set_patlen (a_patlen: INTEGER_32)
		do
			patlen := a_patlen
			update_memory_field ("patlen")
		end

	set_reg_prog (a_reg_prog: CE_POINTER [PD_REGPROG_T])
		do
			reg_prog := a_reg_prog
			update_memory_field ("reg_prog")
		end

	set_allow_dirs (a_allow_dirs: INTEGER_8)
		do
			allow_dirs := a_allow_dirs
			update_memory_field ("allow_dirs")
		end

	set_last (a_last: INTEGER_8)
		do
			last := a_last
			update_memory_field ("last")
		end

	set_cmds (a_cmds: CE_POINTER [PD_AUTOCMD])
		do
			cmds := a_cmds
			update_memory_field ("cmds")
		end

	set_next (a_next: CE_POINTER [PD_AUTOPAT])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_buflocal_nr (a_buflocal_nr: INTEGER_32)
		do
			buflocal_nr := a_buflocal_nr
			update_memory_field ("buflocal_nr")
		end

feature {ANY} -- public routines

	au_remove_pat
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (pat))
			update_class_fields -- Current might have been changed; synchronize
			Current.pat := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.buflocal_nr := -1
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_FILEIO_STATIC}).au_need_clean.item := 1
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			group := a_other.group
			pat := a_other.pat
			patlen := a_other.patlen
			reg_prog := a_other.reg_prog
			allow_dirs := a_other.allow_dirs
			last := a_other.last
			cmds := a_other.cmds
			next := a_other.next
			buflocal_nr := a_other.buflocal_nr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				group = a_other.group and
				pat.is_equal (a_other.pat) and
				patlen = a_other.patlen and
				reg_prog.is_equal (a_other.reg_prog) and
				allow_dirs = a_other.allow_dirs and
				last = a_other.last and
				cmds.is_equal (a_other.cmds) and
				next.is_equal (a_other.next) and
				buflocal_nr = a_other.buflocal_nr
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("pat"),
					create {CE_STRUCTURE_FIELD}.make ("patlen"),
					create {CE_STRUCTURE_FIELD}.make ("reg_prog"),
					create {CE_STRUCTURE_FIELD}.make ("allow_dirs"),
					create {CE_STRUCTURE_FIELD}.make ("last"),
					create {CE_STRUCTURE_FIELD}.make ("cmds"),
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("buflocal_nr")
				>>)
			init_structure_info
		end

end
