class
	PD_BUF_STATE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]} bs_extmatch.make
		end

feature {ANY} -- fields

	bs_idx: INTEGER_32 assign set_bs_idx

	bs_flags: INTEGER_32 assign set_bs_flags

	bs_extmatch: CE_POINTER [PD_REG_EXTMATCH_T] assign set_bs_extmatch

feature {ANY} -- field setters

	set_bs_idx (a_bs_idx: INTEGER_32)
		do
			bs_idx := a_bs_idx
			update_memory_field ("bs_idx")
		end

	set_bs_flags (a_bs_flags: INTEGER_32)
		do
			bs_flags := a_bs_flags
			update_memory_field ("bs_flags")
		end

	set_bs_extmatch (a_bs_extmatch: CE_POINTER [PD_REG_EXTMATCH_T])
		do
			bs_extmatch := a_bs_extmatch
			update_memory_field ("bs_extmatch")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bs_idx := a_other.bs_idx
			bs_flags := a_other.bs_flags
			bs_extmatch := a_other.bs_extmatch
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bs_idx = a_other.bs_idx and
				bs_flags = a_other.bs_flags and
				bs_extmatch.is_equal (a_other.bs_extmatch)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bs_idx"),
					create {CE_STRUCTURE_FIELD}.make ("bs_flags"),
					create {CE_STRUCTURE_FIELD}.make ("bs_extmatch")
				>>)
			init_structure_info
		end

end
