class
	PD_BW_INFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_ICONV_STATIC
		redefine
			copy,
			is_equal
		end
	S_BITS_ERRNO_STATIC
		redefine
			copy,
			is_equal
		end
	S_UNISTD_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} bw_buf.make
			create {CE_NATURAL_8_ARRAY} bw_rest.make (<<30>>)
			create {CE_NATURAL_8_POINTER} bw_conv_buf.make
			create {CE_VOID_POINTER} bw_iconv_fd.make
			Precursor
		end

feature {ANY} -- fields

	bw_fd: INTEGER_32 assign set_bw_fd

	bw_buf: CE_POINTER [NATURAL_8] assign set_bw_buf

	bw_len: INTEGER_32 assign set_bw_len

	bw_flags: INTEGER_32 assign set_bw_flags

	bw_rest: CE_ARRAY [NATURAL_8]

	bw_restlen: INTEGER_32 assign set_bw_restlen

	bw_first: INTEGER_32 assign set_bw_first

	bw_conv_buf: CE_POINTER [NATURAL_8] assign set_bw_conv_buf

	bw_conv_buflen: INTEGER_32 assign set_bw_conv_buflen

	bw_conv_error: INTEGER_32 assign set_bw_conv_error

	bw_conv_error_lnum: INTEGER_32 assign set_bw_conv_error_lnum

	bw_start_lnum: INTEGER_32 assign set_bw_start_lnum

	bw_iconv_fd: CE_POINTER [ANY] assign set_bw_iconv_fd

feature {ANY} -- field setters

	set_bw_fd (a_bw_fd: INTEGER_32)
		do
			bw_fd := a_bw_fd
			update_memory_field ("bw_fd")
		end

	set_bw_buf (a_bw_buf: CE_POINTER [NATURAL_8])
		do
			bw_buf := a_bw_buf
			update_memory_field ("bw_buf")
		end

	set_bw_len (a_bw_len: INTEGER_32)
		do
			bw_len := a_bw_len
			update_memory_field ("bw_len")
		end

	set_bw_flags (a_bw_flags: INTEGER_32)
		do
			bw_flags := a_bw_flags
			update_memory_field ("bw_flags")
		end

	set_bw_restlen (a_bw_restlen: INTEGER_32)
		do
			bw_restlen := a_bw_restlen
			update_memory_field ("bw_restlen")
		end

	set_bw_first (a_bw_first: INTEGER_32)
		do
			bw_first := a_bw_first
			update_memory_field ("bw_first")
		end

	set_bw_conv_buf (a_bw_conv_buf: CE_POINTER [NATURAL_8])
		do
			bw_conv_buf := a_bw_conv_buf
			update_memory_field ("bw_conv_buf")
		end

	set_bw_conv_buflen (a_bw_conv_buflen: INTEGER_32)
		do
			bw_conv_buflen := a_bw_conv_buflen
			update_memory_field ("bw_conv_buflen")
		end

	set_bw_conv_error (a_bw_conv_error: INTEGER_32)
		do
			bw_conv_error := a_bw_conv_error
			update_memory_field ("bw_conv_error")
		end

	set_bw_conv_error_lnum (a_bw_conv_error_lnum: INTEGER_32)
		do
			bw_conv_error_lnum := a_bw_conv_error_lnum
			update_memory_field ("bw_conv_error_lnum")
		end

	set_bw_start_lnum (a_bw_start_lnum: INTEGER_32)
		do
			bw_start_lnum := a_bw_start_lnum
			update_memory_field ("bw_start_lnum")
		end

	set_bw_iconv_fd (a_bw_iconv_fd: CE_POINTER [ANY])
		do
			bw_iconv_fd := a_bw_iconv_fd
			update_memory_field ("bw_iconv_fd")
		end

feature {ANY} -- public routines

	buf_write_bytes: INTEGER_32
		local
			l_wlen: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_flags___0: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_c: NATURAL_32
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_l: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_from: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_fromlen: CE_ARRAY [NATURAL_32]
			l_to: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tolen: CE_ARRAY [NATURAL_32]
			l_fp: CE_POINTER [INTEGER_8]
			l_save_len: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [INTEGER_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_from.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_fromlen.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_to.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_tolen.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := bw_buf
					l_len := bw_len
					l_flags___0 := bw_flags
					if ((l_flags___0).bit_and (8_192)).to_boolean then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						if not (((l_flags___0).bit_and (2)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_p___0.item := bw_conv_buf
						update_class_fields -- Current might have been changed; synchronize
						l_wlen := 0
						from
						until
							not (l_wlen < l_len)
						loop
							l_tmp := (create {P_MBYTE_STATIC}).utf_char2bytes ((l_buf___6[l_wlen]).to_integer_32, l_p___0.item)
							update_class_fields -- Current might have been changed; synchronize
							l_p___0.item := l_p___0.item + l_tmp
							update_class_fields -- Current might have been changed; synchronize
							l_wlen := l_wlen + 1
						end
						l_buf___6 := bw_conv_buf
						l_len := (l_p___0.item).distance (bw_conv_buf)
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 4 then -- else:
						if not (((l_flags___0).bit_and (29)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if ((l_flags___0).bit_and (1)).to_boolean then
							l_p___0.item := l_buf___6
							update_class_fields -- Current might have been changed; synchronize
						else
							l_p___0.item := bw_conv_buf
							update_class_fields -- Current might have been changed; synchronize
						end
						l_wlen := 0
				when 6 then -- loop condition:
						if not (not (l_return or l_break) and then (l_wlen < l_len)) then
							l_pos := -1 + 12 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						if l_wlen /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if bw_restlen /= 0 then
							l_l := 30 - bw_restlen
							if l_l > l_len then
								l_l := l_len
							end
							memmove (create {CE_VOID_POINTER}.make_cast ((bw_rest + bw_restlen)), create {CE_VOID_POINTER}.make_cast (l_buf___6), l_l.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_n := (create {P_MBYTE_STATIC}).utf_ptr2len_len (bw_rest, bw_restlen + l_l)
							update_class_fields -- Current might have been changed; synchronize
							if l_n > bw_restlen + l_len then
								if bw_restlen + l_len > 30 then
									Result := 0
									l_return := True
								end
								if not l_return then
									Current.bw_restlen := bw_restlen + l_len
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
							end
							if not (l_return or l_break) then
								if l_n > 1 then
									l_tmp___0 := (create {P_MBYTE_STATIC}).utf_ptr2char (bw_rest)
									update_class_fields -- Current might have been changed; synchronize
									l_c := l_tmp___0.to_natural_32
								else
									l_c := (bw_rest[0]).to_natural_32
								end
								if l_n >= bw_restlen then
									l_n := l_n - bw_restlen
									Current.bw_restlen := 0
									update_class_fields -- Current might have been changed; synchronize
								else
									Current.bw_restlen := bw_restlen - l_n
									update_class_fields -- Current might have been changed; synchronize
									memmove (create {CE_VOID_POINTER}.make_cast (bw_rest), create {CE_VOID_POINTER}.make_cast ((bw_rest + l_n)), bw_restlen.to_natural_32).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_n := 0
								end
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						l_n := (create {P_MBYTE_STATIC}).utf_ptr2len_len (l_buf___6 + l_wlen, l_len - l_wlen)
						update_class_fields -- Current might have been changed; synchronize
						if l_n > l_len - l_wlen then
							if l_len - l_wlen > 30 then
								Result := 0
								l_return := True
							end
							if not l_return then
								Current.bw_restlen := l_len - l_wlen
								update_class_fields -- Current might have been changed; synchronize
								memmove (create {CE_VOID_POINTER}.make_cast (bw_rest), create {CE_VOID_POINTER}.make_cast ((l_buf___6 + l_wlen)), bw_restlen.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
						end
						if not (l_return or l_break) then
							if l_n > 1 then
								l_tmp___1 := (create {P_MBYTE_STATIC}).utf_ptr2char (l_buf___6 + l_wlen)
								update_class_fields -- Current might have been changed; synchronize
								l_c := l_tmp___1.to_natural_32
							else
								l_c := (l_buf___6[l_wlen]).to_natural_32
							end
						end
				when 11 then
						if not (l_return or l_break) then
							l_tmp___2 := (create {P_FILEIO_STATIC}).ucs2bytes (l_c, l_p___0, l_flags___0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2.to_boolean then
								if not bw_conv_error.to_boolean then
									Current.bw_conv_error := 1
									update_class_fields -- Current might have been changed; synchronize
									Current.bw_conv_error_lnum := bw_start_lnum
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if l_c = {NATURAL_32} 10 then
								Current.bw_start_lnum := bw_start_lnum + 1
								update_class_fields -- Current might have been changed; synchronize
							end
							l_wlen := l_wlen + l_n
						end
						l_pos := -1 + 6 -- back to loop condition
				when 12 then -- loop done
						if not l_return then
							l_break := False
							if ((l_flags___0).bit_and (1)).to_boolean then
								l_len := (l_p___0.item).distance (l_buf___6)
							else
								l_buf___6 := bw_conv_buf
								l_len := (l_p___0.item).distance (bw_conv_buf)
							end
						end
				when 13 then -- if done | if done
						if not (not l_return and then ((bw_iconv_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if bw_restlen > 0 then
							l_fromlen.item := (l_len + bw_restlen).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l_fp := (create {CE_INTEGER_8_POINTER}.make_cast (bw_conv_buf) + bw_conv_buflen) - (l_fromlen.item).to_integer_32
							memmove (create {CE_VOID_POINTER}.make_cast (l_fp), create {CE_VOID_POINTER}.make_cast (bw_rest), bw_restlen.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast ((l_fp + bw_restlen)), create {CE_VOID_POINTER}.make_cast (l_buf___6), l_len.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_from.item := l_fp
							update_class_fields -- Current might have been changed; synchronize
							l_tolen.item := bw_conv_buflen.to_natural_32 - l_fromlen.item
							update_class_fields -- Current might have been changed; synchronize
						else
							l_from.item := create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6)
							update_class_fields -- Current might have been changed; synchronize
							l_fromlen.item := l_len.to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l_tolen.item := bw_conv_buflen.to_natural_32
							update_class_fields -- Current might have been changed; synchronize
						end
						l_to.item := create {CE_INTEGER_8_POINTER}.make_cast (bw_conv_buf)
						update_class_fields -- Current might have been changed; synchronize
						if bw_first.to_boolean then
							l_save_len := l_tolen.item
							iconv (bw_iconv_fd, create {CE_POINTER_POINTER [INTEGER_8]}.make_shared (default_pointer), create {CE_NATURAL_32_POINTER}.make_shared (default_pointer), l_to, l_tolen).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							if (l_to.item).is_void then
								l_to.item := create {CE_INTEGER_8_POINTER}.make_cast (bw_conv_buf)
								update_class_fields -- Current might have been changed; synchronize
								l_tolen.item := l_save_len
								update_class_fields -- Current might have been changed; synchronize
							end
							Current.bw_first := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_tmp___3 := iconv (bw_iconv_fd, l_from, l_fromlen, l_to, l_tolen)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3 /= {NATURAL_32} 4_294_967_295 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_tmp___4 := errno_location
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.item /= 22 then
							Current.bw_conv_error := 1
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L___0:
						if l_fromlen.item > {NATURAL_32} 30 then
							Current.bw_conv_error := 1
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
				when 18 then
						if not l_return then
							if l_fromlen.item > {NATURAL_32} 0 then
								memmove (create {CE_VOID_POINTER}.make_cast (bw_rest), create {CE_VOID_POINTER}.make_cast (l_from.item), l_fromlen.item).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							Current.bw_restlen := (l_fromlen.item).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							l_buf___6 := bw_conv_buf
							l_len := (create {CE_NATURAL_8_POINTER}.make_cast (l_to.item)).distance (bw_conv_buf)
						end
				when 19 then -- if done | if done
					if not l_return then
						if ((l_flags___0).bit_and (4_096)).to_boolean then
							(create {P_MISC2_STATIC}).crypt_encode (l_buf___6, l_len.to_natural_32, l_buf___6)
							update_class_fields -- Current might have been changed; synchronize
						end
						from
						until
							not (not (l_return) and then (l_len > 0))
						loop
							l_wlen := write (bw_fd, create {CE_VOID_POINTER}.make_cast (l_buf___6), l_len.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_wlen <= 0 then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_len := l_len - l_wlen
								l_buf___6 := l_buf___6 + l_wlen
							end
						end
					end
					if not l_return then
						Result := 1
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bw_fd := a_other.bw_fd
			bw_buf := a_other.bw_buf
			bw_len := a_other.bw_len
			bw_flags := a_other.bw_flags
			bw_rest := a_other.bw_rest.twin
			bw_restlen := a_other.bw_restlen
			bw_first := a_other.bw_first
			bw_conv_buf := a_other.bw_conv_buf
			bw_conv_buflen := a_other.bw_conv_buflen
			bw_conv_error := a_other.bw_conv_error
			bw_conv_error_lnum := a_other.bw_conv_error_lnum
			bw_start_lnum := a_other.bw_start_lnum
			bw_iconv_fd := a_other.bw_iconv_fd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bw_fd = a_other.bw_fd and
				bw_buf.is_equal (a_other.bw_buf) and
				bw_len = a_other.bw_len and
				bw_flags = a_other.bw_flags and
				bw_rest.is_equal (a_other.bw_rest) and
				bw_restlen = a_other.bw_restlen and
				bw_first = a_other.bw_first and
				bw_conv_buf.is_equal (a_other.bw_conv_buf) and
				bw_conv_buflen = a_other.bw_conv_buflen and
				bw_conv_error = a_other.bw_conv_error and
				bw_conv_error_lnum = a_other.bw_conv_error_lnum and
				bw_start_lnum = a_other.bw_start_lnum and
				bw_iconv_fd.is_equal (a_other.bw_iconv_fd)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bw_fd"),
					create {CE_STRUCTURE_FIELD}.make ("bw_buf"),
					create {CE_STRUCTURE_FIELD}.make ("bw_len"),
					create {CE_STRUCTURE_FIELD}.make ("bw_flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("bw_rest", <<30>>),
					create {CE_STRUCTURE_FIELD}.make ("bw_restlen"),
					create {CE_STRUCTURE_FIELD}.make ("bw_first"),
					create {CE_STRUCTURE_FIELD}.make ("bw_conv_buf"),
					create {CE_STRUCTURE_FIELD}.make ("bw_conv_buflen"),
					create {CE_STRUCTURE_FIELD}.make ("bw_conv_error"),
					create {CE_STRUCTURE_FIELD}.make ("bw_conv_error_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("bw_start_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("bw_iconv_fd")
				>>)
			init_structure_info
		end

end
