class
	PD_CMDMOD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	minlen: INTEGER_32 assign set_minlen

	has_count: INTEGER_32 assign set_has_count

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_minlen (a_minlen: INTEGER_32)
		do
			minlen := a_minlen
			update_memory_field ("minlen")
		end

	set_has_count (a_has_count: INTEGER_32)
		do
			has_count := a_has_count
			update_memory_field ("has_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			minlen := a_other.minlen
			has_count := a_other.has_count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				minlen = a_other.minlen and
				has_count = a_other.has_count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("minlen"),
					create {CE_STRUCTURE_FIELD}.make ("has_count")
				>>)
			init_structure_info
		end

end
