class
	PD_CONDSTACK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_16_ARRAY} cs_flags.make (<<50>>)
			create {CE_INTEGER_8_ARRAY} cs_pending.make (<<50>>)
			create cs_pend.make
			create {CE_POINTER_ARRAY [ANY]} cs_forinfo.make (<<50>>)
			create {CE_INTEGER_32_ARRAY} cs_line.make (<<50>>)
			create {CE_CLASS_POINTER [PD_ESLIST_ELEM]} cs_emsg_silent_list.make
			Precursor
		end

feature {ANY} -- fields

	cs_flags: CE_ARRAY [INTEGER_16]

	cs_pending: CE_ARRAY [INTEGER_8]

	cs_pend: PD_CS_PEND assign set_cs_pend

	cs_forinfo: CE_ARRAY [CE_POINTER [ANY]]

	cs_line: CE_ARRAY [INTEGER_32]

	cs_idx: INTEGER_32 assign set_cs_idx

	cs_looplevel: INTEGER_32 assign set_cs_looplevel

	cs_trylevel: INTEGER_32 assign set_cs_trylevel

	cs_emsg_silent_list: CE_POINTER [PD_ESLIST_ELEM] assign set_cs_emsg_silent_list

	cs_lflags: INTEGER_8 assign set_cs_lflags

feature {ANY} -- field setters

	set_cs_pend (a_cs_pend: PD_CS_PEND)
		do
			cs_pend := a_cs_pend
			update_memory_field ("cs_pend")
		end

	set_cs_idx (a_cs_idx: INTEGER_32)
		do
			cs_idx := a_cs_idx
			update_memory_field ("cs_idx")
		end

	set_cs_looplevel (a_cs_looplevel: INTEGER_32)
		do
			cs_looplevel := a_cs_looplevel
			update_memory_field ("cs_looplevel")
		end

	set_cs_trylevel (a_cs_trylevel: INTEGER_32)
		do
			cs_trylevel := a_cs_trylevel
			update_memory_field ("cs_trylevel")
		end

	set_cs_emsg_silent_list (a_cs_emsg_silent_list: CE_POINTER [PD_ESLIST_ELEM])
		do
			cs_emsg_silent_list := a_cs_emsg_silent_list
			update_memory_field ("cs_emsg_silent_list")
		end

	set_cs_lflags (a_cs_lflags: INTEGER_8)
		do
			cs_lflags := a_cs_lflags
			update_memory_field ("cs_lflags")
		end

feature {ANY} -- public routines

	cleanup_conditionals (a_searched_cond, a_inclusive: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_stop: INTEGER_32
			l_elem: CE_POINTER [PD_ESLIST_ELEM]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_stop := 0
					l_idx := cs_idx
				when 1 then -- loop condition:
					if not (not (l_break) and then (l_idx >= 0)) then
						l_pos := -1 + 17 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not ((((cs_flags[l_idx]).to_integer_32).bit_and (256)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 3 then -- if:
						if not (((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 6 then -- else:
						if not (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 9 then -- else:
						if not ((((cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if: | _L:
						inspect (cs_pending[l_idx]).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 11
						when 16 then l_pos := -1 + 12
						when 8 then l_pos := -1 + 12
						when 32 then l_pos := -1 + 12
						when 24 then l_pos := -1 + 13
						else l_pos := -1 + 14
						end
				when 11 then -- switch 1, case 0
						l_pos := -1 + 15 -- switch 1; break
				when 12 then -- switch 1, case 16 | switch 1, case 8 | switch 1, case 32;
						(create {P_EX_EVAL_STATIC}).report_discard_pending ((cs_pending[l_idx]).to_integer_32, create {CE_VOID_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						cs_pending[l_idx] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 15 -- switch 1; break
				when 13 then -- switch 1, case 24;
						(create {P_EX_EVAL_STATIC}).report_discard_pending (24, cs_pend.csp_rv[l_idx])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EVAL_STATIC}).discard_pending_return (cs_pend.csp_rv[l_idx])
						update_class_fields -- Current might have been changed; synchronize
						cs_pending[l_idx] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, default:
						if (((cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
							if (((cs_pending[l_idx]).to_integer_32).bit_and (4)).to_boolean then
								(create {P_EX_EVAL_STATIC}).discard_exception (create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]}.make_cast (cs_pend.csp_ex[l_idx]), 0)
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_EX_EVAL_STATIC}).report_discard_pending ((cs_pending[l_idx]).to_integer_32, create {CE_VOID_POINTER}.make_shared (default_pointer))
								update_class_fields -- Current might have been changed; synchronize
							end
							cs_pending[l_idx] := (0).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 15 -- switch 1; break
				when 15 then -- switch 1, done: | if done | if done
						if not (((cs_flags[l_idx]).to_integer_32).bit_and (512)).to_boolean then
							if (((cs_flags[l_idx]).to_integer_32).bit_and (2)).to_boolean then
								if (((cs_flags[l_idx]).to_integer_32).bit_and (2_048)).to_boolean then
									finish_exception (create {CE_CLASS_POINTER [PD_VIM_EXCEPTION]}.make_cast (cs_pend.csp_ex[l_idx]))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if (((cs_flags[l_idx]).to_integer_32).bit_and (1)).to_boolean then
								if a_searched_cond = 0 then
									if not a_inclusive.to_boolean then
										l_break := True
									end
								end
								if not (l_break) then
									l_stop := 1
								end
							end
						end
				when 16 then -- if done
						if not (l_break) and then ((((cs_flags[l_idx]).to_integer_32).bit_and (a_searched_cond)).to_boolean) then
							if not a_inclusive.to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_stop := 1
							end
						end
						if not (l_break) then
							cs_flags[l_idx] := (((cs_flags[l_idx]).to_integer_32).bit_and (-3)).to_integer_16
							update_class_fields -- Current might have been changed; synchronize
							if l_stop.to_boolean then
								if a_searched_cond /= 4_352 then
									l_break := True
								end
							end
						end
						if not (l_break) then
							if (((cs_flags[l_idx]).to_integer_32).bit_and (256)).to_boolean then
								if (((cs_flags[l_idx]).to_integer_32).bit_and (4_096)).to_boolean then
									l_elem := cs_emsg_silent_list
									Current.cs_emsg_silent_list := l_elem.item.next
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).emsg_silent.item := l_elem.item.saved_emsg_silent
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_elem))
									update_class_fields -- Current might have been changed; synchronize
									cs_flags[l_idx] := (((cs_flags[l_idx]).to_integer_32).bit_and (-4_097)).to_integer_16
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if l_stop.to_boolean then
								l_break := True
							end
						end
						if not (l_break) then
							l_idx := l_idx - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 17 then -- loop done
					l_break := False
					Result := l_idx
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	rewind_conditionals (a_idx, a_cond_type: INTEGER_32; a_cond_level: CE_POINTER [INTEGER_32])
		do
			from
			until
				not (cs_idx > a_idx)
			loop
				if (((cs_flags[cs_idx]).to_integer_32).bit_and (a_cond_type)).to_boolean then
					a_cond_level.item := (a_cond_level.item) - 1
					update_class_fields -- Current might have been changed; synchronize
				end
				if (((cs_flags[cs_idx]).to_integer_32).bit_and (16)).to_boolean then
					(create {P_EVAL_STATIC}).free_for_info (cs_forinfo[cs_idx])
					update_class_fields -- Current might have been changed; synchronize
				end
				Current.cs_idx := cs_idx - 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	do_throw
		local
			l_idx: INTEGER_32
			l_inactivate_try: INTEGER_32
		do
			l_inactivate_try := 0
			l_idx := ((create {CE_CLASS_POINTER [PD_CONDSTACK]}.make_shared (c_pointer))).item.cleanup_conditionals (0, l_inactivate_try)
			update_class_fields -- Current might have been changed; synchronize
			if l_idx >= 0 then
				if not (((cs_flags[l_idx]).to_integer_32).bit_and (2_048)).to_boolean then
					if (((cs_flags[l_idx]).to_integer_32).bit_and (2)).to_boolean then
						cs_flags[l_idx] := (((cs_flags[l_idx]).to_integer_32).bit_or (1_024)).to_integer_16
						update_class_fields -- Current might have been changed; synchronize
					else
						cs_flags[l_idx] := (((cs_flags[l_idx]).to_integer_32).bit_and (-1_025)).to_integer_16
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				cs_flags[l_idx] := (((cs_flags[l_idx]).to_integer_32).bit_and (-3)).to_integer_16
				update_class_fields -- Current might have been changed; synchronize
				cs_pend.csp_ex[l_idx] := create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).current_exception.item)
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_GLOBALS_STATIC}).did_throw.item := 1
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_CONDSTACK} -- private routines

	finish_exception (a_excp: CE_POINTER [PD_VIM_EXCEPTION])
		do
			if not a_excp.is_equal ((create {P_GLOBALS_STATIC}).caught_stack.item) then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_internal.item)))))).do_nothing
			end
			(create {P_GLOBALS_STATIC}).caught_stack.item := (create {P_GLOBALS_STATIC}).caught_stack.item.item.caught
			if not ((create {P_GLOBALS_STATIC}).caught_stack.item).is_void then
				(create {P_EVAL_STATIC}).set_vim_var_string (29, (create {P_GLOBALS_STATIC}).caught_stack.item.item.value, -1)
				if (((create {P_GLOBALS_STATIC}).caught_stack.item.item.throw_name).item).to_integer_32 /= 0 then
					if (create {P_GLOBALS_STATIC}).caught_stack.item.item.throw_lnum /= 0 then
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("%%s, line %%ld"))), (create {P_GLOBALS_STATIC}).caught_stack.item.item.throw_name, (create {P_GLOBALS_STATIC}).caught_stack.item.item.throw_lnum]).do_nothing
					else
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("%%s"), (create {P_GLOBALS_STATIC}).caught_stack.item.item.throw_name]).do_nothing
					end
					(create {P_EVAL_STATIC}).set_vim_var_string (30, (create {P_GLOBALS_STATIC}).IObuff.item, -1)
				else
					(create {P_EVAL_STATIC}).set_vim_var_string (30, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1)
				end
			else
				(create {P_EVAL_STATIC}).set_vim_var_string (29, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1);
				(create {P_EVAL_STATIC}).set_vim_var_string (30, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1)
			end
			(create {P_EX_EVAL_STATIC}).discard_exception (a_excp, 1)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cs_flags := a_other.cs_flags.twin
			cs_pending := a_other.cs_pending.twin
			cs_pend := a_other.cs_pend.twin
			cs_forinfo := a_other.cs_forinfo.twin
			cs_line := a_other.cs_line.twin
			cs_idx := a_other.cs_idx
			cs_looplevel := a_other.cs_looplevel
			cs_trylevel := a_other.cs_trylevel
			cs_emsg_silent_list := a_other.cs_emsg_silent_list
			cs_lflags := a_other.cs_lflags
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cs_flags.is_equal (a_other.cs_flags) and
				cs_pending.is_equal (a_other.cs_pending) and
				cs_pend.is_equal (a_other.cs_pend) and
				cs_forinfo.is_equal (a_other.cs_forinfo) and
				cs_line.is_equal (a_other.cs_line) and
				cs_idx = a_other.cs_idx and
				cs_looplevel = a_other.cs_looplevel and
				cs_trylevel = a_other.cs_trylevel and
				cs_emsg_silent_list.is_equal (a_other.cs_emsg_silent_list) and
				cs_lflags = a_other.cs_lflags
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cs_flags", <<50>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cs_pending", <<50>>),
					create {CE_STRUCTURE_FIELD}.make ("cs_pend"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cs_forinfo", <<50>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cs_line", <<50>>),
					create {CE_STRUCTURE_FIELD}.make ("cs_idx"),
					create {CE_STRUCTURE_FIELD}.make ("cs_looplevel"),
					create {CE_STRUCTURE_FIELD}.make ("cs_trylevel"),
					create {CE_STRUCTURE_FIELD}.make ("cs_emsg_silent_list"),
					create {CE_STRUCTURE_FIELD}.make ("cs_lflags")
				>>)
			init_structure_info
		end

end
