class
	PD_CURSOR_ENTRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
		end

feature {ANY} -- fields

	shape: INTEGER_32 assign set_shape

	mshape: INTEGER_32 assign set_mshape

	percentage: INTEGER_32 assign set_percentage

	blinkwait: INTEGER_32 assign set_blinkwait

	blinkon: INTEGER_32 assign set_blinkon

	blinkoff: INTEGER_32 assign set_blinkoff

	id: INTEGER_32 assign set_id

	id_lm: INTEGER_32 assign set_id_lm

	name: CE_POINTER [INTEGER_8] assign set_name

	used_for: INTEGER_8 assign set_used_for

feature {ANY} -- field setters

	set_shape (a_shape: INTEGER_32)
		do
			shape := a_shape
			update_memory_field ("shape")
		end

	set_mshape (a_mshape: INTEGER_32)
		do
			mshape := a_mshape
			update_memory_field ("mshape")
		end

	set_percentage (a_percentage: INTEGER_32)
		do
			percentage := a_percentage
			update_memory_field ("percentage")
		end

	set_blinkwait (a_blinkwait: INTEGER_32)
		do
			blinkwait := a_blinkwait
			update_memory_field ("blinkwait")
		end

	set_blinkon (a_blinkon: INTEGER_32)
		do
			blinkon := a_blinkon
			update_memory_field ("blinkon")
		end

	set_blinkoff (a_blinkoff: INTEGER_32)
		do
			blinkoff := a_blinkoff
			update_memory_field ("blinkoff")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_id_lm (a_id_lm: INTEGER_32)
		do
			id_lm := a_id_lm
			update_memory_field ("id_lm")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_used_for (a_used_for: INTEGER_8)
		do
			used_for := a_used_for
			update_memory_field ("used_for")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			shape := a_other.shape
			mshape := a_other.mshape
			percentage := a_other.percentage
			blinkwait := a_other.blinkwait
			blinkon := a_other.blinkon
			blinkoff := a_other.blinkoff
			id := a_other.id
			id_lm := a_other.id_lm
			name := a_other.name
			used_for := a_other.used_for
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				shape = a_other.shape and
				mshape = a_other.mshape and
				percentage = a_other.percentage and
				blinkwait = a_other.blinkwait and
				blinkon = a_other.blinkon and
				blinkoff = a_other.blinkoff and
				id = a_other.id and
				id_lm = a_other.id_lm and
				name.is_equal (a_other.name) and
				used_for = a_other.used_for
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("shape"),
					create {CE_STRUCTURE_FIELD}.make ("mshape"),
					create {CE_STRUCTURE_FIELD}.make ("percentage"),
					create {CE_STRUCTURE_FIELD}.make ("blinkwait"),
					create {CE_STRUCTURE_FIELD}.make ("blinkon"),
					create {CE_STRUCTURE_FIELD}.make ("blinkoff"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("id_lm"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("used_for")
				>>)
			init_structure_info
		end

end
