class
	PD_DICTITEM_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create di_tv.make
			create {CE_NATURAL_8_ARRAY} di_key.make (<<1>>)
			Precursor
		end

feature {ANY} -- fields

	di_tv: PD_TYPVAL_T assign set_di_tv

	di_flags: NATURAL_8 assign set_di_flags

	di_key: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_di_tv (a_di_tv: PD_TYPVAL_T)
		do
			di_tv := a_di_tv
			update_memory_field ("di_tv")
		end

	set_di_flags (a_di_flags: NATURAL_8)
		do
			di_flags := a_di_flags
			update_memory_field ("di_flags")
		end

feature {ANY} -- public routines

	dictitem_copy: CE_POINTER [PD_DICTITEM_S]
		local
			l_di: CE_POINTER [PD_DICTITEM_S]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (di_key))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_MISC2_STATIC}).alloc ((create {PD_DICTITEM_S}.make).structure_size.to_natural_32 + l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			l_di := create {CE_CLASS_POINTER [PD_DICTITEM_S]}.make_cast (l_tmp___0)
			if not l_di.is_void then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_di.item.di_key)), create {CE_INTEGER_8_POINTER}.make_cast (di_key)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_di.item.di_flags := (0).to_natural_8
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv"))).item.copy_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_di.c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv")))
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_di
		end

feature {ANY}

	copy (a_other: like Current)
		do
			di_tv := a_other.di_tv.twin
			di_flags := a_other.di_flags
			di_key := a_other.di_key.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				di_tv.is_equal (a_other.di_tv) and
				di_flags = a_other.di_flags and
				di_key.is_equal (a_other.di_key)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("di_tv"),
					create {CE_STRUCTURE_FIELD}.make ("di_flags"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("di_key", <<1>>)
				>>)
			init_structure_info
		end

end
