class
	PD_ENC_ALIAS_TABLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} name.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	canon: INTEGER_32 assign set_canon

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_canon (a_canon: INTEGER_32)
		do
			canon := a_canon
			update_memory_field ("canon")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			canon := a_other.canon
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				canon = a_other.canon
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("canon")
				>>)
			init_structure_info
		end

end
