class
	PD_GTKFORM

inherit
	PD_GTKFORM_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create container.make
			create {CE_CLASS_POINTER [SD_GLIST]} children.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} bin_window.make
		end

feature {ANY} -- fields

	container: SD_GTKCONTAINER assign set_container

	children: CE_POINTER [SD_GLIST] assign set_children

	width: NATURAL_32 assign set_width

	height: NATURAL_32 assign set_height

	bin_window: CE_POINTER [SD_GDKDRAWABLE] assign set_bin_window

	visibility: NATURAL_32 assign set_visibility

	configure_serial: NATURAL_32 assign set_configure_serial

	freeze_count: INTEGER_32 assign set_freeze_count

feature {ANY} -- field setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container := a_container
			update_memory_field ("container")
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			children := a_children
			update_memory_field ("children")
		end

	set_width (a_width: NATURAL_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: NATURAL_32)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_bin_window (a_bin_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			bin_window := a_bin_window
			update_memory_field ("bin_window")
		end

	set_visibility (a_visibility: NATURAL_32)
		do
			visibility := a_visibility
			update_memory_field ("visibility")
		end

	set_configure_serial (a_configure_serial: NATURAL_32)
		do
			configure_serial := a_configure_serial
			update_memory_field ("configure_serial")
		end

	set_freeze_count (a_freeze_count: INTEGER_32)
		do
			freeze_count := a_freeze_count
			update_memory_field ("freeze_count")
		end

feature {ANY} -- public routines

	gtk_form_init
		do
			Current.children := create {CE_CLASS_POINTER [SD_GLIST]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.width := (1).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.height := (1).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.bin_window := create {CE_CLASS_POINTER [SD_GDKDRAWABLE]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.configure_serial := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			Current.visibility := {SC_GDKVISIBILITYSTATE}.GDK_VISIBILITY_PARTIAL
			update_class_fields -- Current might have been changed; synchronize
			Current.freeze_count := 0
			update_class_fields -- Current might have been changed; synchronize
		end

	gtk_form_position_children
		local
			l_tmp_list: CE_POINTER [SD_GLIST]
		do
			l_tmp_list := children
			from
			until
				l_tmp_list.is_void
			loop
				(create {P_GUI_GTK_F_STATIC}).gtk_form_position_child ((create {CE_CLASS_POINTER [PD_GTKFORM]}.make_shared (c_pointer)), create {CE_CLASS_POINTER [PD_GTKFORMCHILD]}.make_cast (l_tmp_list.item.data), 0)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp_list := l_tmp_list.item.next
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			container := a_other.container.twin
			children := a_other.children
			width := a_other.width
			height := a_other.height
			bin_window := a_other.bin_window
			visibility := a_other.visibility
			configure_serial := a_other.configure_serial
			freeze_count := a_other.freeze_count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				container.is_equal (a_other.container) and
				children.is_equal (a_other.children) and
				width = a_other.width and
				height = a_other.height and
				bin_window.is_equal (a_other.bin_window) and
				visibility = a_other.visibility and
				configure_serial = a_other.configure_serial and
				freeze_count = a_other.freeze_count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("container"),
					create {CE_STRUCTURE_FIELD}.make ("children"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("bin_window"),
					create {CE_STRUCTURE_FIELD}.make ("visibility"),
					create {CE_STRUCTURE_FIELD}.make ("configure_serial"),
					create {CE_STRUCTURE_FIELD}.make ("freeze_count")
				>>)
			init_structure_info
		end

end
