class
	PD_GUISCROLLBAR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_GTK_GTK_STATIC
		redefine
			copy,
			is_equal
		end
	S_GLIB_OBJECT_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_WINDOW_S]} wp.make
			create {CE_CLASS_POINTER [SD_GTKWIDGET]} id.make
			Precursor
		end

feature {ANY} -- fields

	ident: INTEGER_32 assign set_ident

	wp: CE_POINTER [PD_WINDOW_S] assign set_wp

	type: INTEGER_32 assign set_type

	value: INTEGER_32 assign set_value

	size: INTEGER_32 assign set_size

	max: INTEGER_32 assign set_max

	top: INTEGER_32 assign set_top

	height: INTEGER_32 assign set_height

	width: INTEGER_32 assign set_width

	status_height: INTEGER_32 assign set_status_height

	id: CE_POINTER [SD_GTKWIDGET] assign set_id

	handler_id: NATURAL_32 assign set_handler_id

feature {ANY} -- field setters

	set_ident (a_ident: INTEGER_32)
		do
			ident := a_ident
			update_memory_field ("ident")
		end

	set_wp (a_wp: CE_POINTER [PD_WINDOW_S])
		do
			wp := a_wp
			update_memory_field ("wp")
		end

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_value (a_value: INTEGER_32)
		do
			value := a_value
			update_memory_field ("value")
		end

	set_size (a_size: INTEGER_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_max (a_max: INTEGER_32)
		do
			max := a_max
			update_memory_field ("max")
		end

	set_top (a_top: INTEGER_32)
		do
			top := a_top
			update_memory_field ("top")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_status_height (a_status_height: INTEGER_32)
		do
			status_height := a_status_height
			update_memory_field ("status_height")
		end

	set_id (a_id: CE_POINTER [SD_GTKWIDGET])
		do
			id := a_id
			update_memory_field ("id")
		end

	set_handler_id (a_handler_id: NATURAL_32)
		do
			handler_id := a_handler_id
			update_memory_field ("handler_id")
		end

feature {PD_GUISCROLLBAR} -- private attributes

	sbar_ident: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	gui_create_scrollbar (a_type: INTEGER_32; a_wp___0: CE_POINTER [PD_WINDOW_S])
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_tmp := sbar_ident.item
			sbar_ident.item := sbar_ident.item + 1
			Current.ident := l_tmp.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			Current.wp := a_wp___0
			update_class_fields -- Current might have been changed; synchronize
			Current.type := a_type
			update_class_fields -- Current might have been changed; synchronize
			Current.value := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.size := 1
			update_class_fields -- Current might have been changed; synchronize
			Current.max := 1
			update_class_fields -- Current might have been changed; synchronize
			Current.top := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.height := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.width := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.status_height := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_wp___0.is_void then
				l_tmp___0 := 1
			else
				l_tmp___0 := 0
			end
			((create {CE_CLASS_POINTER [PD_GUISCROLLBAR]}.make_shared (c_pointer))).item.gui_mch_create_scrollbar (l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
		end

	gui_mch_set_scrollbar_thumb (a_val___0, a_size, a_max: INTEGER_32)
		local
			l_adjustment: CE_POINTER [SD_GTKADJUSTMENT]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [SD_GTYPEINSTANCE]
		do
			if not id.is_void then
				l_tmp := gtk_range_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				l_adjustment := gtk_range_get_adjustment (create {CE_CLASS_POINTER [SD_GTKRANGE]}.make_cast (l_tmp___0))
				update_class_fields -- Current might have been changed; synchronize
				l_adjustment.item.lower := 0.0
				update_class_fields -- Current might have been changed; synchronize
				l_adjustment.item.value := a_val___0.to_double
				update_class_fields -- Current might have been changed; synchronize
				l_adjustment.item.upper := (a_max + 1).to_double
				update_class_fields -- Current might have been changed; synchronize
				l_adjustment.item.page_size := a_size.to_double
				update_class_fields -- Current might have been changed; synchronize
				if a_size < 3 then
					l_adjustment.item.page_increment := (1).to_double
					update_class_fields -- Current might have been changed; synchronize
				else
					l_adjustment.item.page_increment := (a_size - 2).to_double
					update_class_fields -- Current might have been changed; synchronize
				end
				l_adjustment.item.step_increment := 1.0
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := gtk_object_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_adjustment), l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
				g_signal_handler_block (create {CE_VOID_POINTER}.make_cast (l_tmp___2), handler_id)
				update_class_fields -- Current might have been changed; synchronize
				gtk_adjustment_changed (l_adjustment)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := gtk_object_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___4 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_adjustment), l_tmp___3)
				update_class_fields -- Current might have been changed; synchronize
				g_signal_handler_unblock (create {CE_VOID_POINTER}.make_cast (l_tmp___4), handler_id)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gui_mch_set_scrollbar_pos (a_x___0, a_y, a_w, a_h: INTEGER_32)
		local
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
		do
			if not id.is_void then
				l_tmp := (create {P_GUI_GTK_F_STATIC}).gtk_form_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.formwin), l_tmp)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GUI_GTK_F_STATIC}).gtk_form_move_resize (create {CE_CLASS_POINTER [PD_GTKFORM]}.make_cast (l_tmp___0), id, a_x___0, a_y, a_w, a_h)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gui_mch_create_scrollbar (a_orient: INTEGER_32)
		local
			l_adjustment: CE_POINTER [SD_GTKADJUSTMENT]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___1: NATURAL_32
			l_tmp___2: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [SD_GTYPEINSTANCE]
			l_tmp___5: NATURAL_32
			l_tmp___6: CE_POINTER [SD_GTYPEINSTANCE]
			l_break: BOOLEAN
		do
			if a_orient = 1 then
				Current.id := gtk_hscrollbar_new (create {CE_CLASS_POINTER [SD_GTKADJUSTMENT]}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			elseif a_orient = 0 then
				Current.id := gtk_vscrollbar_new (create {CE_CLASS_POINTER [SD_GTKADJUSTMENT]}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
			end
			if not id.is_void then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp := gtk_object_get_type
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp)
					update_class_fields; -- Current might have been changed; synchronize
					(create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___0)).item.flags := ((create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___0)).item.flags).bit_and (({NATURAL_32} 4_294_965_247))
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_tmp___1 := (create {P_GUI_GTK_F_STATIC}).gtk_form_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast ((create {P_GUI_STATIC}).gui.item.item.formwin), l_tmp___1)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GUI_GTK_F_STATIC}).gtk_form_put (create {CE_CLASS_POINTER [PD_GTKFORM]}.make_cast (l_tmp___2), id, 0, 0)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := gtk_range_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___4 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (id), l_tmp___3)
				update_class_fields -- Current might have been changed; synchronize
				l_adjustment := gtk_range_get_adjustment (create {CE_CLASS_POINTER [SD_GTKRANGE]}.make_cast (l_tmp___4))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___5 := gtk_object_get_type
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___6 := g_type_check_instance_cast (create {CE_CLASS_POINTER [SD_GTYPEINSTANCE]}.make_cast (l_adjustment), l_tmp___5)
				update_class_fields -- Current might have been changed; synchronize
				Current.handler_id := gtk_signal_connect_full (create {CE_CLASS_POINTER [SD_GTKOBJECT]}.make_cast (l_tmp___6), ce_string ("value_changed"), ((create {P_GUI_GTK_STATIC}).adjustment_value_changed_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer + ident), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	gui_mch_enable_scrollbar (a_flag: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if id.is_void then
				l_return := True
			end
			if not l_return then
				if a_flag.to_boolean then
					gtk_widget_show (id)
					update_class_fields -- Current might have been changed; synchronize
				else
					gtk_widget_hide (id)
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_GUI_GTK_X11_STATIC}).update_window_manager_hints (0, 0)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ident := a_other.ident
			wp := a_other.wp
			type := a_other.type
			value := a_other.value
			size := a_other.size
			max := a_other.max
			top := a_other.top
			height := a_other.height
			width := a_other.width
			status_height := a_other.status_height
			id := a_other.id
			handler_id := a_other.handler_id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ident = a_other.ident and
				wp.is_equal (a_other.wp) and
				type = a_other.type and
				value = a_other.value and
				size = a_other.size and
				max = a_other.max and
				top = a_other.top and
				height = a_other.height and
				width = a_other.width and
				status_height = a_other.status_height and
				id.is_equal (a_other.id) and
				handler_id = a_other.handler_id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ident"),
					create {CE_STRUCTURE_FIELD}.make ("wp"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("value"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("max"),
					create {CE_STRUCTURE_FIELD}.make ("top"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("status_height"),
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("handler_id")
				>>)
			init_structure_info
		end

end
