class
	PD_LINEOFF_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	lnum: INTEGER_32 assign set_lnum

	fill: INTEGER_32 assign set_fill

	height: INTEGER_32 assign set_height

feature {ANY} -- field setters

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_fill (a_fill: INTEGER_32)
		do
			fill := a_fill
			update_memory_field ("fill")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

feature {ANY} -- public routines

	topline_back
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_tmp___0 := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, lnum)
			update_class_fields -- Current might have been changed; synchronize
			if fill < l_tmp___0 then
				Current.fill := fill + 1
				update_class_fields -- Current might have been changed; synchronize
				Current.height := 1
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.lnum := lnum - 1
				update_class_fields -- Current might have been changed; synchronize
				Current.fill := 0
				update_class_fields -- Current might have been changed; synchronize
				if lnum < 1 then
					Current.height := 2_147_483_647
					update_class_fields -- Current might have been changed; synchronize
				else
					l_tmp := (create {P_FOLD_STATIC}).hasFolding (lnum, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_LINEOFF_T}.make).offset_of ("lnum")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						Current.height := 1
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.height := (create {P_MISC1_STATIC}).plines_nofill (lnum)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	botline_forw
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_tmp___0 := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, lnum + 1)
			update_class_fields -- Current might have been changed; synchronize
			if fill < l_tmp___0 then
				Current.fill := fill + 1
				update_class_fields -- Current might have been changed; synchronize
				Current.height := 1
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.lnum := lnum + 1
				update_class_fields -- Current might have been changed; synchronize
				Current.fill := 0
				update_class_fields -- Current might have been changed; synchronize
				if lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
					Current.height := 2_147_483_647
					update_class_fields -- Current might have been changed; synchronize
				else
					l_tmp := (create {P_FOLD_STATIC}).hasFolding (lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_LINEOFF_T}.make).offset_of ("lnum")))
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						Current.height := 1
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.height := (create {P_MISC1_STATIC}).plines_nofill (lnum)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
		end

	botline_topline
		local
			l_tmp: INTEGER_32
		do
			if fill > 0 then
				Current.lnum := lnum + 1
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, lnum)
				update_class_fields -- Current might have been changed; synchronize
				Current.fill := (l_tmp - fill) + 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	topline_botline
		local
			l_tmp: INTEGER_32
		do
			if fill > 0 then
				l_tmp := (create {P_DIFF_STATIC}).diff_check_fill ((create {P_GLOBALS_STATIC}).curwin.item, lnum)
				update_class_fields -- Current might have been changed; synchronize
				Current.fill := (l_tmp - fill) + 1
				update_class_fields -- Current might have been changed; synchronize
				Current.lnum := lnum - 1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lnum := a_other.lnum
			fill := a_other.fill
			height := a_other.height
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lnum = a_other.lnum and
				fill = a_other.fill and
				height = a_other.height
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("fill"),
					create {CE_STRUCTURE_FIELD}.make ("height")
				>>)
			init_structure_info
		end

end
