class
	PD_LISTITEM_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_LISTITEM_S]} li_next.make
			create {CE_CLASS_POINTER [PD_LISTITEM_S]} li_prev.make
			create li_tv.make
		end

feature {ANY} -- fields

	li_next: CE_POINTER [PD_LISTITEM_S] assign set_li_next

	li_prev: CE_POINTER [PD_LISTITEM_S] assign set_li_prev

	li_tv: PD_TYPVAL_T assign set_li_tv

feature {ANY} -- field setters

	set_li_next (a_li_next: CE_POINTER [PD_LISTITEM_S])
		do
			li_next := a_li_next
			update_memory_field ("li_next")
		end

	set_li_prev (a_li_prev: CE_POINTER [PD_LISTITEM_S])
		do
			li_prev := a_li_prev
			update_memory_field ("li_prev")
		end

	set_li_tv (a_li_tv: PD_TYPVAL_T)
		do
			li_tv := a_li_tv
			update_memory_field ("li_tv")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			li_next := a_other.li_next
			li_prev := a_other.li_prev
			li_tv := a_other.li_tv.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				li_next.is_equal (a_other.li_next) and
				li_prev.is_equal (a_other.li_prev) and
				li_tv.is_equal (a_other.li_tv)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("li_next"),
					create {CE_STRUCTURE_FIELD}.make ("li_prev"),
					create {CE_STRUCTURE_FIELD}.make ("li_tv")
				>>)
			init_structure_info
		end

end
