class
	PD_LISTVAR_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_LISTITEM_S]} lv_first.make
			create {CE_CLASS_POINTER [PD_LISTITEM_S]} lv_last.make
			create {CE_CLASS_POINTER [PD_LISTWATCH_S]} lv_watch.make
			create {CE_CLASS_POINTER [PD_LISTITEM_S]} lv_idx_item.make
			create {CE_CLASS_POINTER [PD_LISTVAR_S]} lv_copylist.make
			create {CE_CLASS_POINTER [PD_LISTVAR_S]} lv_used_next.make
			create {CE_CLASS_POINTER [PD_LISTVAR_S]} lv_used_prev.make
		end

feature {ANY} -- fields

	lv_first: CE_POINTER [PD_LISTITEM_S] assign set_lv_first

	lv_last: CE_POINTER [PD_LISTITEM_S] assign set_lv_last

	lv_refcount: INTEGER_32 assign set_lv_refcount

	lv_len: INTEGER_32 assign set_lv_len

	lv_watch: CE_POINTER [PD_LISTWATCH_S] assign set_lv_watch

	lv_idx: INTEGER_32 assign set_lv_idx

	lv_idx_item: CE_POINTER [PD_LISTITEM_S] assign set_lv_idx_item

	lv_copyID: INTEGER_32 assign set_lv_copyID

	lv_copylist: CE_POINTER [PD_LISTVAR_S] assign set_lv_copylist

	lv_lock: INTEGER_8 assign set_lv_lock

	lv_used_next: CE_POINTER [PD_LISTVAR_S] assign set_lv_used_next

	lv_used_prev: CE_POINTER [PD_LISTVAR_S] assign set_lv_used_prev

feature {ANY} -- field setters

	set_lv_first (a_lv_first: CE_POINTER [PD_LISTITEM_S])
		do
			lv_first := a_lv_first
			update_memory_field ("lv_first")
		end

	set_lv_last (a_lv_last: CE_POINTER [PD_LISTITEM_S])
		do
			lv_last := a_lv_last
			update_memory_field ("lv_last")
		end

	set_lv_refcount (a_lv_refcount: INTEGER_32)
		do
			lv_refcount := a_lv_refcount
			update_memory_field ("lv_refcount")
		end

	set_lv_len (a_lv_len: INTEGER_32)
		do
			lv_len := a_lv_len
			update_memory_field ("lv_len")
		end

	set_lv_watch (a_lv_watch: CE_POINTER [PD_LISTWATCH_S])
		do
			lv_watch := a_lv_watch
			update_memory_field ("lv_watch")
		end

	set_lv_idx (a_lv_idx: INTEGER_32)
		do
			lv_idx := a_lv_idx
			update_memory_field ("lv_idx")
		end

	set_lv_idx_item (a_lv_idx_item: CE_POINTER [PD_LISTITEM_S])
		do
			lv_idx_item := a_lv_idx_item
			update_memory_field ("lv_idx_item")
		end

	set_lv_copyID (a_lv_copyID: INTEGER_32)
		do
			lv_copyID := a_lv_copyID
			update_memory_field ("lv_copyID")
		end

	set_lv_copylist (a_lv_copylist: CE_POINTER [PD_LISTVAR_S])
		do
			lv_copylist := a_lv_copylist
			update_memory_field ("lv_copylist")
		end

	set_lv_lock (a_lv_lock: INTEGER_8)
		do
			lv_lock := a_lv_lock
			update_memory_field ("lv_lock")
		end

	set_lv_used_next (a_lv_used_next: CE_POINTER [PD_LISTVAR_S])
		do
			lv_used_next := a_lv_used_next
			update_memory_field ("lv_used_next")
		end

	set_lv_used_prev (a_lv_used_prev: CE_POINTER [PD_LISTVAR_S])
		do
			lv_used_prev := a_lv_used_prev
			update_memory_field ("lv_used_prev")
		end

feature {ANY} -- public routines

	ins_compl_add_list
		local
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_dir___0: INTEGER_32
			l_tmp: INTEGER_32
			l_break: BOOLEAN
		do
			l_dir___0 := (create {P_EDIT_STATIC}).compl_direction.item
			l_li := lv_first
			from
			until
				not (not (l_break) and then (not l_li.is_void))
			loop
				l_break := False
				l_tmp := (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv"))).item.ins_compl_add_tv (l_dir___0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 1 then
					l_dir___0 := 1
				elseif ((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean then
					l_break := True
				end
				if not (l_break) then
					l_li := l_li.item.li_next
				end
			end
			l_break := False
		end

	list_rem_watch (a_lwrem: CE_POINTER [PD_LISTWATCH_S])
		local
			l_lw: CE_POINTER [PD_LISTWATCH_S]
			l_lwp: CE_POINTER [CE_POINTER [PD_LISTWATCH_S]]
			l_break: BOOLEAN
		do
			l_lwp := create {CE_POINTER_POINTER [PD_LISTWATCH_S]}.make_shared (c_pointer + (create {PD_LISTVAR_S}.make).offset_of ("lv_watch"))
			l_lw := lv_watch
			from
			until
				not (not (l_break) and then (not l_lw.is_void))
			loop
				l_break := False
				if l_lw.is_equal (a_lwrem) then
					l_lwp.item := l_lw.item.lw_next
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				if not (l_break) then
					l_lwp := create {CE_POINTER_POINTER [PD_LISTWATCH_S]}.make_shared (l_lw.c_pointer + (create {PD_LISTWATCH_S}.make).offset_of ("lw_next"))
					l_lw := l_lw.item.lw_next
				end
			end
			l_break := False
		end

	list_fix_watch (a_item: CE_POINTER [PD_LISTITEM_S])
		local
			l_lw: CE_POINTER [PD_LISTWATCH_S]
		do
			l_lw := lv_watch
			from
			until
				l_lw.is_void
			loop
				if (l_lw.item.lw_item).is_equal (a_item) then
					l_lw.item.lw_item := a_item.item.li_next
					update_class_fields -- Current might have been changed; synchronize
				end
				l_lw := l_lw.item.lw_next
			end
		end

	list_free (a_recurse___2: INTEGER_32)
		local
			l_item: CE_POINTER [PD_LISTITEM_S]
		do
			if lv_used_prev.is_void then
				(create {P_EVAL_STATIC}).first_list.item := lv_used_next
				update_class_fields -- Current might have been changed; synchronize
			else
				lv_used_prev.item.lv_used_next := lv_used_next
				update_class_fields -- Current might have been changed; synchronize
			end
			if not lv_used_next.is_void then
				lv_used_next.item.lv_used_prev := lv_used_prev
				update_class_fields -- Current might have been changed; synchronize
			end
			l_item := lv_first
			from
			until
				l_item.is_void
			loop
				Current.lv_first := l_item.item.li_next
				update_class_fields -- Current might have been changed; synchronize
				if a_recurse___2.to_boolean then
					(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_item.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")))
					update_class_fields -- Current might have been changed; synchronize
				elseif (l_item.item.li_tv.v_type).to_integer_32 /= 4 then
					if (l_item.item.li_tv.v_type).to_integer_32 /= 5 then
						(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_item.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_item))
				update_class_fields -- Current might have been changed; synchronize
				l_item := lv_first
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_shared (c_pointer))
			update_class_fields -- Current might have been changed; synchronize
		end

	list_append (a_item: CE_POINTER [PD_LISTITEM_S])
		require
			not a_item.is_void
		do
			if lv_last.is_void then
				Current.lv_first := a_item
				update_class_fields -- Current might have been changed; synchronize
				Current.lv_last := a_item
				update_class_fields -- Current might have been changed; synchronize
				a_item.item.li_prev := create {CE_CLASS_POINTER [PD_LISTITEM_S]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			else
				lv_last.item.li_next := a_item
				update_class_fields -- Current might have been changed; synchronize
				a_item.item.li_prev := lv_last
				update_class_fields -- Current might have been changed; synchronize
				Current.lv_last := a_item
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.lv_len := lv_len + 1
			update_class_fields -- Current might have been changed; synchronize
			a_item.item.li_next := create {CE_CLASS_POINTER [PD_LISTITEM_S]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	list_remove (a_item, a_item2: CE_POINTER [PD_LISTITEM_S])
		require
			not a_item.is_void
			not a_item2.is_void
		local
			l_ip: CE_POINTER [PD_LISTITEM_S]
			l_break: BOOLEAN
		do
			l_ip := a_item
			from
			until
				not (not (l_break) and then (not l_ip.is_void))
			loop
				l_break := False
				Current.lv_len := lv_len - 1
				update_class_fields; -- Current might have been changed; synchronize
				((create {CE_CLASS_POINTER [PD_LISTVAR_S]}.make_shared (c_pointer))).item.list_fix_watch (l_ip)
				update_class_fields -- Current might have been changed; synchronize
				if l_ip.is_equal (a_item2) then
					l_break := True
				end
				if not (l_break) then
					l_ip := l_ip.item.li_next
				end
			end
			l_break := False
			if (a_item2.item.li_next).is_void then
				Current.lv_last := a_item.item.li_prev
				update_class_fields -- Current might have been changed; synchronize
			else
				(a_item2.item.li_next).item.li_prev := a_item.item.li_prev
				update_class_fields -- Current might have been changed; synchronize
			end
			if (a_item.item.li_prev).is_void then
				Current.lv_first := a_item2.item.li_next
				update_class_fields -- Current might have been changed; synchronize
			else
				(a_item.item.li_prev).item.li_next := a_item2.item.li_next
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.lv_idx_item := create {CE_CLASS_POINTER [PD_LISTITEM_S]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	listitem_remove (a_item: CE_POINTER [PD_LISTITEM_S])
		do
			((create {CE_CLASS_POINTER [PD_LISTVAR_S]}.make_shared (c_pointer))).item.list_remove (a_item, a_item)
			update_class_fields -- Current might have been changed; synchronize
			listitem_free (a_item)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_LISTVAR_S} -- private routines

	listitem_free (a_item: CE_POINTER [PD_LISTITEM_S])
		do
			(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (a_item.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_item))
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lv_first := a_other.lv_first
			lv_last := a_other.lv_last
			lv_refcount := a_other.lv_refcount
			lv_len := a_other.lv_len
			lv_watch := a_other.lv_watch
			lv_idx := a_other.lv_idx
			lv_idx_item := a_other.lv_idx_item
			lv_copyID := a_other.lv_copyID
			lv_copylist := a_other.lv_copylist
			lv_lock := a_other.lv_lock
			lv_used_next := a_other.lv_used_next
			lv_used_prev := a_other.lv_used_prev
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lv_first.is_equal (a_other.lv_first) and
				lv_last.is_equal (a_other.lv_last) and
				lv_refcount = a_other.lv_refcount and
				lv_len = a_other.lv_len and
				lv_watch.is_equal (a_other.lv_watch) and
				lv_idx = a_other.lv_idx and
				lv_idx_item.is_equal (a_other.lv_idx_item) and
				lv_copyID = a_other.lv_copyID and
				lv_copylist.is_equal (a_other.lv_copylist) and
				lv_lock = a_other.lv_lock and
				lv_used_next.is_equal (a_other.lv_used_next) and
				lv_used_prev.is_equal (a_other.lv_used_prev)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lv_first"),
					create {CE_STRUCTURE_FIELD}.make ("lv_last"),
					create {CE_STRUCTURE_FIELD}.make ("lv_refcount"),
					create {CE_STRUCTURE_FIELD}.make ("lv_len"),
					create {CE_STRUCTURE_FIELD}.make ("lv_watch"),
					create {CE_STRUCTURE_FIELD}.make ("lv_idx"),
					create {CE_STRUCTURE_FIELD}.make ("lv_idx_item"),
					create {CE_STRUCTURE_FIELD}.make ("lv_copyID"),
					create {CE_STRUCTURE_FIELD}.make ("lv_copylist"),
					create {CE_STRUCTURE_FIELD}.make ("lv_lock"),
					create {CE_STRUCTURE_FIELD}.make ("lv_used_next"),
					create {CE_STRUCTURE_FIELD}.make ("lv_used_prev")
				>>)
			init_structure_info
		end

end
