class
	PD_LOOP_COOKIE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GROWARRAY]} lines_gap.make
			create getline.make
			create {CE_VOID_POINTER} cookie.make
		end

feature {ANY} -- fields

	lines_gap: CE_POINTER [PD_GROWARRAY] assign set_lines_gap

	current_line: INTEGER_32 assign set_current_line

	repeating: INTEGER_32 assign set_repeating

	getline: CE_ROUTINE assign set_getline

	cookie: CE_POINTER [ANY] assign set_cookie

feature {ANY} -- field setters

	set_lines_gap (a_lines_gap: CE_POINTER [PD_GROWARRAY])
		do
			lines_gap := a_lines_gap
			update_memory_field ("lines_gap")
		end

	set_current_line (a_current_line: INTEGER_32)
		do
			current_line := a_current_line
			update_memory_field ("current_line")
		end

	set_repeating (a_repeating: INTEGER_32)
		do
			repeating := a_repeating
			update_memory_field ("repeating")
		end

	set_getline (a_getline: CE_ROUTINE)
		do
			getline := a_getline
			update_memory_field ("getline")
		end

	set_cookie (a_cookie: CE_POINTER [ANY])
		do
			cookie := a_cookie
			update_memory_field ("cookie")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lines_gap := a_other.lines_gap
			current_line := a_other.current_line
			repeating := a_other.repeating
			getline := a_other.getline
			cookie := a_other.cookie
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lines_gap.is_equal (a_other.lines_gap) and
				current_line = a_other.current_line and
				repeating = a_other.repeating and
				getline.is_equal (a_other.getline) and
				cookie.is_equal (a_other.cookie)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lines_gap"),
					create {CE_STRUCTURE_FIELD}.make ("current_line"),
					create {CE_STRUCTURE_FIELD}.make ("repeating"),
					create {CE_STRUCTURE_FIELD}.make ("getline"),
					create {CE_STRUCTURE_FIELD}.make ("cookie")
				>>)
			init_structure_info
		end

end
