class
	PD_LVAL_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} ll_name.make
			create {CE_NATURAL_8_POINTER} ll_exp_name.make
			create {CE_CLASS_POINTER [PD_TYPVAL_T]} ll_tv.make
			create {CE_CLASS_POINTER [PD_LISTITEM_S]} ll_li.make
			create {CE_CLASS_POINTER [PD_LISTVAR_S]} ll_list.make
			create {CE_CLASS_POINTER [PD_DICTVAR_S]} ll_dict.make
			create {CE_CLASS_POINTER [PD_DICTITEM_S]} ll_di.make
			create {CE_NATURAL_8_POINTER} ll_newkey.make
			Precursor
		end

feature {ANY} -- fields

	ll_name: CE_POINTER [NATURAL_8] assign set_ll_name

	ll_exp_name: CE_POINTER [NATURAL_8] assign set_ll_exp_name

	ll_tv: CE_POINTER [PD_TYPVAL_T] assign set_ll_tv

	ll_li: CE_POINTER [PD_LISTITEM_S] assign set_ll_li

	ll_list: CE_POINTER [PD_LISTVAR_S] assign set_ll_list

	ll_range: INTEGER_32 assign set_ll_range

	ll_n1: INTEGER_32 assign set_ll_n1

	ll_n2: INTEGER_32 assign set_ll_n2

	ll_empty2: INTEGER_32 assign set_ll_empty2

	ll_dict: CE_POINTER [PD_DICTVAR_S] assign set_ll_dict

	ll_di: CE_POINTER [PD_DICTITEM_S] assign set_ll_di

	ll_newkey: CE_POINTER [NATURAL_8] assign set_ll_newkey

feature {ANY} -- field setters

	set_ll_name (a_ll_name: CE_POINTER [NATURAL_8])
		do
			ll_name := a_ll_name
			update_memory_field ("ll_name")
		end

	set_ll_exp_name (a_ll_exp_name: CE_POINTER [NATURAL_8])
		do
			ll_exp_name := a_ll_exp_name
			update_memory_field ("ll_exp_name")
		end

	set_ll_tv (a_ll_tv: CE_POINTER [PD_TYPVAL_T])
		do
			ll_tv := a_ll_tv
			update_memory_field ("ll_tv")
		end

	set_ll_li (a_ll_li: CE_POINTER [PD_LISTITEM_S])
		do
			ll_li := a_ll_li
			update_memory_field ("ll_li")
		end

	set_ll_list (a_ll_list: CE_POINTER [PD_LISTVAR_S])
		do
			ll_list := a_ll_list
			update_memory_field ("ll_list")
		end

	set_ll_range (a_ll_range: INTEGER_32)
		do
			ll_range := a_ll_range
			update_memory_field ("ll_range")
		end

	set_ll_n1 (a_ll_n1: INTEGER_32)
		do
			ll_n1 := a_ll_n1
			update_memory_field ("ll_n1")
		end

	set_ll_n2 (a_ll_n2: INTEGER_32)
		do
			ll_n2 := a_ll_n2
			update_memory_field ("ll_n2")
		end

	set_ll_empty2 (a_ll_empty2: INTEGER_32)
		do
			ll_empty2 := a_ll_empty2
			update_memory_field ("ll_empty2")
		end

	set_ll_dict (a_ll_dict: CE_POINTER [PD_DICTVAR_S])
		do
			ll_dict := a_ll_dict
			update_memory_field ("ll_dict")
		end

	set_ll_di (a_ll_di: CE_POINTER [PD_DICTITEM_S])
		do
			ll_di := a_ll_di
			update_memory_field ("ll_di")
		end

	set_ll_newkey (a_ll_newkey: CE_POINTER [NATURAL_8])
		do
			ll_newkey := a_ll_newkey
			update_memory_field ("ll_newkey")
		end

feature {ANY} -- public routines

	clear_lval
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ll_exp_name))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (ll_newkey))
			update_class_fields -- Current might have been changed; synchronize
		end

	set_var_lval (a_endp: CE_POINTER [NATURAL_8]; a_rettv: CE_POINTER [PD_TYPVAL_T]; a_copy: INTEGER_32; a_op: CE_POINTER [NATURAL_8])
		local
			l_cc___0: INTEGER_32
			l_ri: CE_POINTER [PD_LISTITEM_S]
			l_di: CE_POINTER [PD_DICTITEM_S]
			l_tv: CE_ARRAY [PD_TYPVAL_T]
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_tv.make (<<1>>)

			if ll_tv.is_void then
				l_tmp___2 := (create {P_EVAL_STATIC}).check_changedtick (ll_name)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___2.to_boolean then
					l_cc___0 := (a_endp.item).to_integer_32
					a_endp.item := (('%/0/').code).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					if not a_op.is_void then
						if (a_op.item).to_integer_32 /= 61 then
							l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (ll_name))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := (create {P_EVAL_STATIC}).get_var_tv (ll_name, l_tmp___0.to_integer_32, l_tv, 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1 = 1 then
								l_tmp := tv_op (l_tv, a_rettv, a_op)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp = 1 then
									(create {P_EVAL_STATIC}).set_var (ll_name, l_tv, 0)
									update_class_fields -- Current might have been changed; synchronize
								end
								(create {P_EVAL_STATIC}).clear_tv (l_tv)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(create {P_EVAL_STATIC}).set_var (ll_name, a_rettv, a_copy)
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						(create {P_EVAL_STATIC}).set_var (ll_name, a_rettv, a_copy)
						update_class_fields -- Current might have been changed; synchronize
					end
					a_endp.item := l_cc___0.to_natural_8
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				if ll_newkey.is_void then
					l_tmp___10 := (ll_tv.item.v_lock).to_integer_32
				else
					l_tmp___10 := ((ll_tv.item.vval.v_dict).item.dv_lock).to_integer_32
				end
				l_tmp___11 := (create {P_EVAL_STATIC}).tv_check_lock (l_tmp___10, ll_name)
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___11.to_boolean then
					if ll_range.to_boolean then
						l_ri := (a_rettv.item.vval.v_list).item.lv_first
						from
						until
							not (not (l_break) and then (not l_ri.is_void))
						loop
							l_break := False
							if not a_op.is_void then
								if (a_op.item).to_integer_32 /= 61 then
									tv_op (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (ll_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")), create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_ri.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")), a_op).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (ll_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")))
									update_class_fields; -- Current might have been changed; synchronize
									(create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_ri.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv"))).item.copy_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (ll_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")))
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_EVAL_STATIC}).clear_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (ll_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")))
								update_class_fields; -- Current might have been changed; synchronize
								(create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_ri.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv"))).item.copy_tv (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (ll_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv")))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_ri := l_ri.item.li_next
							if l_ri.is_void then
								l_break := True
							elseif not ll_empty2.to_boolean then
								if ll_n2 = ll_n1 then
									l_break := True
								end
							end
							if not (l_break) and then ((ll_li.item.li_next).is_void) then
								l_tmp___3 := (create {P_EVAL_STATIC}).list_append_number (ll_list, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___3 = 0 then
									l_ri := create {CE_CLASS_POINTER [PD_LISTITEM_S]}.make_shared (default_pointer)
									l_break := True
								end
							end
							if not (l_break) then
								Current.ll_li := ll_li.item.li_next
								update_class_fields -- Current might have been changed; synchronize
								Current.ll_n1 := ll_n1 + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if not l_ri.is_void then
							l_tmp___4 := gettext (ce_string ("E710: List value has more items than target"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							if ll_empty2.to_boolean then
								if not ll_li.is_void then
									if not (ll_li.item.li_next).is_void then
										l_tmp___6 := 1
									else
										l_tmp___6 := 0
									end
								else
									l_tmp___6 := 0
								end
								l_tmp___7 := l_tmp___6
							else
								l_tmp___7 := (ll_n1 /= ll_n2).to_integer
							end
							if l_tmp___7.to_boolean then
								l_tmp___5 := gettext (ce_string ("E711: List value has not enough items"))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					else
						if not ll_newkey.is_void then
							if not a_op.is_void then
								if (a_op.item).to_integer_32 /= 61 then
									l_tmp___8 := gettext ((create {P_EVAL_STATIC}).e_letwrong.item)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___8), a_op).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
							end
							if not l_return then
								l_di := (create {P_EVAL_STATIC}).dictitem_alloc (ll_newkey)
								update_class_fields -- Current might have been changed; synchronize
								if l_di.is_void then
									l_return := True
								end
							end
							if not l_return then
								l_tmp___9 := (create {P_EVAL_STATIC}).dict_add (ll_tv.item.vval.v_dict, l_di)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___9 = 0 then
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_di))
									update_class_fields -- Current might have been changed; synchronize
									l_return := True
								end
							end
							if not l_return then
								Current.ll_tv := create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_di.c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv"))
								update_class_fields -- Current might have been changed; synchronize
							end
						elseif not a_op.is_void then
							if (a_op.item).to_integer_32 /= 61 then
								tv_op (ll_tv, a_rettv, a_op).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							else
								(create {P_EVAL_STATIC}).clear_tv (ll_tv)
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(create {P_EVAL_STATIC}).clear_tv (ll_tv)
							update_class_fields -- Current might have been changed; synchronize
						end
						if not l_return then
							if a_copy.to_boolean then
								a_rettv.item.copy_tv (ll_tv)
								update_class_fields -- Current might have been changed; synchronize
							else
								ll_tv.item := (a_rettv.item).twin
								update_class_fields -- Current might have been changed; synchronize
								ll_tv.item.v_lock := (0).to_integer_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_EVAL_STATIC}).init_tv (a_rettv)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
			end
			if not l_return then
			end
		end

feature {PD_LVAL_S} -- private routines

	tv_op (a_tv1, a_tv2: CE_POINTER [PD_TYPVAL_T]; a_op: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_tv2.is_void
		local
			l_n: INTEGER_32
			l_numbuf: CE_ARRAY [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_f: REAL_64
			l_f___0: REAL_64
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_numbuf.make (<<30>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_tv2.item.v_type).to_integer_32 = 3 then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if (a_tv2.item.v_type).to_integer_32 = 5 then
							l_pos := -1 + 20 -- skip if block
						end
				when 2 then -- if:
						inspect (a_tv1.item.v_type).to_integer_32 -- switch 1 head
						when 5 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 3
						when 4 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 17
						else l_pos := -1 + 20
						end
				when 3 then -- switch 1, case 5 | switch 1, case 3
						l_pos := -1 + 20 -- switch 1; break
				when 4 then -- switch 1, case 4
						if (a_op.item).to_integer_32 /= 43 then
							l_pos := -1 + 20 -- switch 1; break
						elseif (a_tv2.item.v_type).to_integer_32 /= 4 then
							l_pos := -1 + 20 -- switch 1; break
						end
				when 5 then
						if not (a_tv1.item.vval.v_list).is_void then
							if not (a_tv2.item.vval.v_list).is_void then
								(create {P_EVAL_STATIC}).list_extend (a_tv1.item.vval.v_list, a_tv2.item.vval.v_list, create {CE_CLASS_POINTER [PD_LISTITEM_S]}.make_shared (default_pointer)).do_nothing
							end
						end
						Result := 1
						l_return := True
				when 6 then -- switch 1, case 1 | switch 1, case 2
						if l_return then
							l_pos := -1 + 17 -- skip if block
						end
				when 7 then -- if:
						if (a_tv2.item.v_type).to_integer_32 = 4 then
							l_pos := -1 + 20 -- switch 1; break
						end
				when 8 then
						if (a_op.item).to_integer_32 /= 43 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 11 then -- else:
						if (a_op.item).to_integer_32 /= 45 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | _L:
						l_n := a_tv1.item.get_tv_number
						if (a_tv2.item.v_type).to_integer_32 = 6 then
							l_f := l_n.to_double
							if (a_op.item).to_integer_32 = 43 then
								l_f := l_f + (a_tv2.item.vval.v_float)
							else
								l_f := l_f - (a_tv2.item.vval.v_float)
							end
							(create {P_EVAL_STATIC}).clear_tv (a_tv1)
							a_tv1.item.v_type := (6).to_integer_8
							a_tv1.item.vval.v_float := l_f
						else
							if (a_op.item).to_integer_32 = 43 then
								l_n := l_n + (a_tv2.item.get_tv_number)
							else
								l_n := l_n - (a_tv2.item.get_tv_number)
							end
							(create {P_EVAL_STATIC}).clear_tv (a_tv1)
							a_tv1.item.v_type := (1).to_integer_8
							a_tv1.item.vval.v_number := l_n.to_integer_32
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if (a_tv2.item.v_type).to_integer_32 = 6 then
							l_pos := -1 + 20 -- switch 1; break
						end
				when 15 then
						l_s := a_tv1.item.get_tv_string
						l_s := (create {P_MISC1_STATIC}).concat_str (l_s, (a_tv2.item.get_tv_string_buf (l_numbuf)));
						(create {P_EVAL_STATIC}).clear_tv (a_tv1)
						a_tv1.item.v_type := (2).to_integer_8
						a_tv1.item.vval.v_string := l_s
				when 16 then -- if done
						Result := 1
						l_return := True
				when 17 then -- switch 1, case 6
						if l_return then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if (a_op.item).to_integer_32 = 46 then
							l_pos := -1 + 20 -- switch 1; break
						elseif (a_tv2.item.v_type).to_integer_32 /= 6 then
							if (a_tv2.item.v_type).to_integer_32 /= 1 then
								if (a_tv2.item.v_type).to_integer_32 /= 2 then
									l_pos := -1 + 20 -- switch 1; break
								end
							end
						end
				when 19 then
						if (a_tv2.item.v_type).to_integer_32 = 6 then
							l_f___0 := a_tv2.item.vval.v_float
						else
							l_f___0 := (a_tv2.item.get_tv_number).to_double
						end
						if (a_op.item).to_integer_32 = 43 then
							a_tv1.item.vval.v_float := a_tv1.item.vval.v_float + l_f___0
						else
							a_tv1.item.vval.v_float := a_tv1.item.vval.v_float - l_f___0
						end
						Result := 1
						l_return := True
				when 20 then -- switch 1, done: | if done | if done
					if not l_return then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext ((create {P_EVAL_STATIC}).e_letwrong.item))), a_op).do_nothing
						Result := 0
					end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ll_name := a_other.ll_name
			ll_exp_name := a_other.ll_exp_name
			ll_tv := a_other.ll_tv
			ll_li := a_other.ll_li
			ll_list := a_other.ll_list
			ll_range := a_other.ll_range
			ll_n1 := a_other.ll_n1
			ll_n2 := a_other.ll_n2
			ll_empty2 := a_other.ll_empty2
			ll_dict := a_other.ll_dict
			ll_di := a_other.ll_di
			ll_newkey := a_other.ll_newkey
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ll_name.is_equal (a_other.ll_name) and
				ll_exp_name.is_equal (a_other.ll_exp_name) and
				ll_tv.is_equal (a_other.ll_tv) and
				ll_li.is_equal (a_other.ll_li) and
				ll_list.is_equal (a_other.ll_list) and
				ll_range = a_other.ll_range and
				ll_n1 = a_other.ll_n1 and
				ll_n2 = a_other.ll_n2 and
				ll_empty2 = a_other.ll_empty2 and
				ll_dict.is_equal (a_other.ll_dict) and
				ll_di.is_equal (a_other.ll_di) and
				ll_newkey.is_equal (a_other.ll_newkey)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ll_name"),
					create {CE_STRUCTURE_FIELD}.make ("ll_exp_name"),
					create {CE_STRUCTURE_FIELD}.make ("ll_tv"),
					create {CE_STRUCTURE_FIELD}.make ("ll_li"),
					create {CE_STRUCTURE_FIELD}.make ("ll_list"),
					create {CE_STRUCTURE_FIELD}.make ("ll_range"),
					create {CE_STRUCTURE_FIELD}.make ("ll_n1"),
					create {CE_STRUCTURE_FIELD}.make ("ll_n2"),
					create {CE_STRUCTURE_FIELD}.make ("ll_empty2"),
					create {CE_STRUCTURE_FIELD}.make ("ll_dict"),
					create {CE_STRUCTURE_FIELD}.make ("ll_di"),
					create {CE_STRUCTURE_FIELD}.make ("ll_newkey")
				>>)
			init_structure_info
		end

end
