class
	PD_MEMLINE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_MEMFILE]} ml_mfp.make
			create {CE_CLASS_POINTER [PD_INFO_POINTER]} ml_stack.make
			create {CE_NATURAL_8_POINTER} ml_line_ptr.make
			create {CE_CLASS_POINTER [PD_BLOCK_HDR]} ml_locked.make
			create {CE_CLASS_POINTER [PD_ML_CHUNKSIZE]} ml_chunksize.make
		end

feature {ANY} -- fields

	ml_line_count: INTEGER_32 assign set_ml_line_count

	ml_mfp: CE_POINTER [PD_MEMFILE] assign set_ml_mfp

	ml_flags: INTEGER_32 assign set_ml_flags

	ml_stack: CE_POINTER [PD_INFO_POINTER] assign set_ml_stack

	ml_stack_top: INTEGER_32 assign set_ml_stack_top

	ml_stack_size: INTEGER_32 assign set_ml_stack_size

	ml_line_lnum: INTEGER_32 assign set_ml_line_lnum

	ml_line_ptr: CE_POINTER [NATURAL_8] assign set_ml_line_ptr

	ml_locked: CE_POINTER [PD_BLOCK_HDR] assign set_ml_locked

	ml_locked_low: INTEGER_32 assign set_ml_locked_low

	ml_locked_high: INTEGER_32 assign set_ml_locked_high

	ml_locked_lineadd: INTEGER_32 assign set_ml_locked_lineadd

	ml_chunksize: CE_POINTER [PD_ML_CHUNKSIZE] assign set_ml_chunksize

	ml_numchunks: INTEGER_32 assign set_ml_numchunks

	ml_usedchunks: INTEGER_32 assign set_ml_usedchunks

feature {ANY} -- field setters

	set_ml_line_count (a_ml_line_count: INTEGER_32)
		do
			ml_line_count := a_ml_line_count
			update_memory_field ("ml_line_count")
		end

	set_ml_mfp (a_ml_mfp: CE_POINTER [PD_MEMFILE])
		do
			ml_mfp := a_ml_mfp
			update_memory_field ("ml_mfp")
		end

	set_ml_flags (a_ml_flags: INTEGER_32)
		do
			ml_flags := a_ml_flags
			update_memory_field ("ml_flags")
		end

	set_ml_stack (a_ml_stack: CE_POINTER [PD_INFO_POINTER])
		do
			ml_stack := a_ml_stack
			update_memory_field ("ml_stack")
		end

	set_ml_stack_top (a_ml_stack_top: INTEGER_32)
		do
			ml_stack_top := a_ml_stack_top
			update_memory_field ("ml_stack_top")
		end

	set_ml_stack_size (a_ml_stack_size: INTEGER_32)
		do
			ml_stack_size := a_ml_stack_size
			update_memory_field ("ml_stack_size")
		end

	set_ml_line_lnum (a_ml_line_lnum: INTEGER_32)
		do
			ml_line_lnum := a_ml_line_lnum
			update_memory_field ("ml_line_lnum")
		end

	set_ml_line_ptr (a_ml_line_ptr: CE_POINTER [NATURAL_8])
		do
			ml_line_ptr := a_ml_line_ptr
			update_memory_field ("ml_line_ptr")
		end

	set_ml_locked (a_ml_locked: CE_POINTER [PD_BLOCK_HDR])
		do
			ml_locked := a_ml_locked
			update_memory_field ("ml_locked")
		end

	set_ml_locked_low (a_ml_locked_low: INTEGER_32)
		do
			ml_locked_low := a_ml_locked_low
			update_memory_field ("ml_locked_low")
		end

	set_ml_locked_high (a_ml_locked_high: INTEGER_32)
		do
			ml_locked_high := a_ml_locked_high
			update_memory_field ("ml_locked_high")
		end

	set_ml_locked_lineadd (a_ml_locked_lineadd: INTEGER_32)
		do
			ml_locked_lineadd := a_ml_locked_lineadd
			update_memory_field ("ml_locked_lineadd")
		end

	set_ml_chunksize (a_ml_chunksize: CE_POINTER [PD_ML_CHUNKSIZE])
		do
			ml_chunksize := a_ml_chunksize
			update_memory_field ("ml_chunksize")
		end

	set_ml_numchunks (a_ml_numchunks: INTEGER_32)
		do
			ml_numchunks := a_ml_numchunks
			update_memory_field ("ml_numchunks")
		end

	set_ml_usedchunks (a_ml_usedchunks: INTEGER_32)
		do
			ml_usedchunks := a_ml_usedchunks
			update_memory_field ("ml_usedchunks")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ml_line_count := a_other.ml_line_count
			ml_mfp := a_other.ml_mfp
			ml_flags := a_other.ml_flags
			ml_stack := a_other.ml_stack
			ml_stack_top := a_other.ml_stack_top
			ml_stack_size := a_other.ml_stack_size
			ml_line_lnum := a_other.ml_line_lnum
			ml_line_ptr := a_other.ml_line_ptr
			ml_locked := a_other.ml_locked
			ml_locked_low := a_other.ml_locked_low
			ml_locked_high := a_other.ml_locked_high
			ml_locked_lineadd := a_other.ml_locked_lineadd
			ml_chunksize := a_other.ml_chunksize
			ml_numchunks := a_other.ml_numchunks
			ml_usedchunks := a_other.ml_usedchunks
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ml_line_count = a_other.ml_line_count and
				ml_mfp.is_equal (a_other.ml_mfp) and
				ml_flags = a_other.ml_flags and
				ml_stack.is_equal (a_other.ml_stack) and
				ml_stack_top = a_other.ml_stack_top and
				ml_stack_size = a_other.ml_stack_size and
				ml_line_lnum = a_other.ml_line_lnum and
				ml_line_ptr.is_equal (a_other.ml_line_ptr) and
				ml_locked.is_equal (a_other.ml_locked) and
				ml_locked_low = a_other.ml_locked_low and
				ml_locked_high = a_other.ml_locked_high and
				ml_locked_lineadd = a_other.ml_locked_lineadd and
				ml_chunksize.is_equal (a_other.ml_chunksize) and
				ml_numchunks = a_other.ml_numchunks and
				ml_usedchunks = a_other.ml_usedchunks
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ml_line_count"),
					create {CE_STRUCTURE_FIELD}.make ("ml_mfp"),
					create {CE_STRUCTURE_FIELD}.make ("ml_flags"),
					create {CE_STRUCTURE_FIELD}.make ("ml_stack"),
					create {CE_STRUCTURE_FIELD}.make ("ml_stack_top"),
					create {CE_STRUCTURE_FIELD}.make ("ml_stack_size"),
					create {CE_STRUCTURE_FIELD}.make ("ml_line_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("ml_line_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("ml_locked"),
					create {CE_STRUCTURE_FIELD}.make ("ml_locked_low"),
					create {CE_STRUCTURE_FIELD}.make ("ml_locked_high"),
					create {CE_STRUCTURE_FIELD}.make ("ml_locked_lineadd"),
					create {CE_STRUCTURE_FIELD}.make ("ml_chunksize"),
					create {CE_STRUCTURE_FIELD}.make ("ml_numchunks"),
					create {CE_STRUCTURE_FIELD}.make ("ml_usedchunks")
				>>)
			init_structure_info
		end

end
