class
	PD_PAT_PTR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SYN_PATTERN]} pp_synp.make
			create {CE_CLASS_POINTER [PD_PAT_PTR]} pp_next.make
		end

feature {ANY} -- fields

	pp_synp: CE_POINTER [PD_SYN_PATTERN] assign set_pp_synp

	pp_matchgroup_id: INTEGER_32 assign set_pp_matchgroup_id

	pp_next: CE_POINTER [PD_PAT_PTR] assign set_pp_next

feature {ANY} -- field setters

	set_pp_synp (a_pp_synp: CE_POINTER [PD_SYN_PATTERN])
		do
			pp_synp := a_pp_synp
			update_memory_field ("pp_synp")
		end

	set_pp_matchgroup_id (a_pp_matchgroup_id: INTEGER_32)
		do
			pp_matchgroup_id := a_pp_matchgroup_id
			update_memory_field ("pp_matchgroup_id")
		end

	set_pp_next (a_pp_next: CE_POINTER [PD_PAT_PTR])
		do
			pp_next := a_pp_next
			update_memory_field ("pp_next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pp_synp := a_other.pp_synp
			pp_matchgroup_id := a_other.pp_matchgroup_id
			pp_next := a_other.pp_next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pp_synp.is_equal (a_other.pp_synp) and
				pp_matchgroup_id = a_other.pp_matchgroup_id and
				pp_next.is_equal (a_other.pp_next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pp_synp"),
					create {CE_STRUCTURE_FIELD}.make ("pp_matchgroup_id"),
					create {CE_STRUCTURE_FIELD}.make ("pp_next")
				>>)
			init_structure_info
		end

end
