class
	PD_PAT_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} pat.make
			create {CE_NATURAL_8_POINTER} head.make
			create regmatch.make
		end

feature {ANY} -- fields

	pat: CE_POINTER [NATURAL_8] assign set_pat

	len: INTEGER_32 assign set_len

	head: CE_POINTER [NATURAL_8] assign set_head

	headlen: INTEGER_32 assign set_headlen

	regmatch: PD_REGMATCH_T assign set_regmatch

feature {ANY} -- field setters

	set_pat (a_pat: CE_POINTER [NATURAL_8])
		do
			pat := a_pat
			update_memory_field ("pat")
		end

	set_len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_head (a_head: CE_POINTER [NATURAL_8])
		do
			head := a_head
			update_memory_field ("head")
		end

	set_headlen (a_headlen: INTEGER_32)
		do
			headlen := a_headlen
			update_memory_field ("headlen")
		end

	set_regmatch (a_regmatch: PD_REGMATCH_T)
		do
			regmatch := a_regmatch
			update_memory_field ("regmatch")
		end

feature {ANY} -- public routines

	prepare_pats (a_has_re: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
		do
			Current.head := pat
			update_class_fields -- Current might have been changed; synchronize
			Current.headlen := len
			update_class_fields -- Current might have been changed; synchronize
			if a_has_re.to_boolean then
				if (pat[0]).to_integer_32 = 94 then
					Current.head := pat + 1
					update_class_fields -- Current might have been changed; synchronize
				elseif (pat[0]).to_integer_32 = 92 then
					if (pat[1]).to_integer_32 = 60 then
						Current.head := pat + 2
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				if head.is_equal (pat) then
					Current.headlen := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					Current.headlen := 0
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						not (not (l_break) and then ((head[headlen]).to_integer_32 /= 0))
					loop
						l_break := False
						if ((create {P_OPTION_STATIC}).p_magic.item.item).to_boolean then
							l_tmp := ce_string (".[~*\$")
						else
							l_tmp := ce_string ("\$")
						end
						l_tmp___0 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), (head[headlen]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___0.is_void then
							l_break := True
						end
						if not (l_break) then
							Current.headlen := headlen + 1
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_break := False
				end
				if (create {P_OPTION_STATIC}).p_tl.item.item /= 0 then
					if headlen.to_integer_32 > (create {P_OPTION_STATIC}).p_tl.item.item then
						Current.headlen := ((create {P_OPTION_STATIC}).p_tl.item.item).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			if a_has_re.to_boolean then
				if ((create {P_OPTION_STATIC}).p_magic.item.item).to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
				regmatch.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (pat, l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
			else
				regmatch.regprog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pat := a_other.pat
			len := a_other.len
			head := a_other.head
			headlen := a_other.headlen
			regmatch := a_other.regmatch.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pat.is_equal (a_other.pat) and
				len = a_other.len and
				head.is_equal (a_other.head) and
				headlen = a_other.headlen and
				regmatch.is_equal (a_other.regmatch)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pat"),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("head"),
					create {CE_STRUCTURE_FIELD}.make ("headlen"),
					create {CE_STRUCTURE_FIELD}.make ("regmatch")
				>>)
			init_structure_info
		end

end
