class
	PD_POS_T

inherit
	PD_POS_T_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	lnum: INTEGER_32 assign set_lnum

	col: INTEGER_32 assign set_col

	coladd: INTEGER_32 assign set_coladd

feature {ANY} -- field setters

	set_lnum (a_lnum: INTEGER_32)
		do
			lnum := a_lnum
			update_memory_field ("lnum")
		end

	set_col (a_col: INTEGER_32)
		do
			col := a_col
			update_memory_field ("col")
		end

	set_coladd (a_coladd: INTEGER_32)
		do
			coladd := a_coladd
			update_memory_field ("coladd")
		end

feature {ANY} -- public routines

	mark_line (a_lead_len: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if lnum = 0 then
				l_tmp := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-invalid-")))
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
				l_return := True
			elseif lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
				l_tmp := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-invalid-")))
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				l_tmp___0 := (create {P_MEMLINE_STATIC}).ml_get (lnum)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := (create {P_CHARSET_STATIC}).skipwhite (l_tmp___0)
				update_class_fields -- Current might have been changed; synchronize
				l_s := (create {P_MISC2_STATIC}).vim_strnsave (l_tmp___1, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if l_s.is_void then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_len := 0
				l_p___0 := l_s
				from
				until
					not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					l_break := False
					l_tmp___4 := (create {P_CHARSET_STATIC}).ptr2cells (l_p___0)
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_len + l_tmp___4
					if l_len.to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item - a_lead_len.to_integer_32 then
						l_break := True
					end
					if not (l_break) then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___2 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := l_tmp___2
						else
							l_tmp___3 := 1
						end
						l_p___0 := l_p___0 + l_tmp___3
					end
				end
				l_break := False
				l_p___0.item := (('%/0/').code).to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				Result := l_s
			end
		end

	write_one_mark (a_fp_out: CE_POINTER [SD_IO_FILE]; a_c: INTEGER_32)
		do
			if lnum /= 0 then
				fprintf ([a_fp_out, ce_string ("%T%%c%T%%ld%T%%d%N"), a_c, lnum, col]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	ml_get_pos: CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_tmp := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (lnum, 0)
			update_class_fields -- Current might have been changed; synchronize
			Result := (l_tmp + col)
		end

	gchar_pos: INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer))).item.ml_get_pos
			update_class_fields -- Current might have been changed; synchronize
			l_ptr := l_tmp
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_ptr])
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___0
				l_return := True
			end
			if not l_return then
				Result := (l_ptr.item).to_integer_32
			end
		end

	cin_skip2pos: INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_break: BOOLEAN
		do
			l_line := (create {P_MEMLINE_STATIC}).ml_get (lnum)
			update_class_fields -- Current might have been changed; synchronize
			l_p___0 := l_line
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p___0.item).to_boolean then
					if not (l_p___0.distance (l_line) < col) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_tmp := (create {P_MISC1_STATIC}).cin_iscomment (l_p___0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp.to_boolean then
						l_p___0 := (create {P_MISC1_STATIC}).cin_skipcomment (l_p___0)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_p___0 := (create {P_MISC1_STATIC}).skip_string (l_p___0)
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := l_p___0 + 1
					end
				end
			end
			l_break := False
			Result := (l_p___0.distance (l_line))
		end

	corr_ind_maxparen (a_ind_maxparen: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			l_n := lnum - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			if l_n > 0 then
				if l_n < (a_ind_maxparen // 2).to_integer_32 then
					Result := (a_ind_maxparen - l_n.to_integer_32)
					l_return := True
				end
			end
			if not l_return then
				Result := a_ind_maxparen
			end
		end

	coladvance2 (a_addspaces, a_finetune, a_wcol: INTEGER_32): INTEGER_32
		local
			l_wcol: INTEGER_32
			l_idx: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_csize: INTEGER_32
			l_one_more: INTEGER_32
			l_head___0: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_width: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_correct: INTEGER_32
			l_newline: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_t: INTEGER_32
			l_linelen___0: INTEGER_32
			l_tmp___7: NATURAL_32
			l_correct___0: INTEGER_32
			l_newline___0: CE_POINTER [NATURAL_8]
			l_t___0: INTEGER_32
			l_s: INTEGER_32
			l_v: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_scol: CE_ARRAY [INTEGER_32]
			l_ecol: CE_ARRAY [INTEGER_32]
			l_b: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_head___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_scol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_ecol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_wcol := a_wcol
					l_col := 0
					l_csize := 0
					l_head___0.item := 0
					update_class_fields -- Current might have been changed; synchronize
					if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp := 1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 /= 111 then
							l_tmp := 1
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (((create {P_OPTION_STATIC}).ve_flags.item.item).bit_and ({NATURAL_32} 8)).to_boolean then
							if l_wcol.to_integer_32 < 2_147_483_647 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 10 then -- if done | if done
					l_one_more := l_tmp
					l_line := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (lnum, 0)
					update_class_fields -- Current might have been changed; synchronize
					if not (l_wcol.to_integer_32 >= 2_147_483_647) then
						l_pos := -1 + 17 -- skip if block
					end
				when 11 then -- if:
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))
						update_class_fields -- Current might have been changed; synchronize
						l_idx := (l_tmp___0.to_integer_32 - 1) + l_one_more
						l_col := l_wcol
						if not (a_addspaces.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if not (a_finetune.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___0:
						if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							l_tmp___1 := (create {P_CHARSET_STATIC}).linetabsize (l_line)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := l_tmp___1 + l_one_more
							update_class_fields -- Current might have been changed; synchronize
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant > 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant) - 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 16 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 24
				when 17 then -- else:
						l_tmp___2 := ((create {P_GLOBALS_STATIC}).curwin.item).item.win_col_off
						update_class_fields -- Current might have been changed; synchronize
						l_width := (create {P_GLOBALS_STATIC}).curwin.item.item.w_width - l_tmp___2
						if a_finetune.to_boolean then
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_width /= 0 then
									if l_wcol >= l_width then
										l_csize := (create {P_CHARSET_STATIC}).linetabsize (l_line)
										update_class_fields -- Current might have been changed; synchronize
										if l_csize > 0 then
											l_csize := l_csize - 1
										end
										if l_wcol // l_width > l_csize // l_width then
											if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)) = 0 then
												l_wcol := (l_csize // l_width + 1) * l_width - 1
											elseif l_wcol > l_csize + 1 then
												l_wcol := (l_csize // l_width + 1) * l_width - 1
											end
										end
									end
								end
							end
						end
						l_idx := -1
						l_ptr := l_line
						from
						until
							(l_break)
						loop
							l_break := False
							if l_col <= l_wcol then
								if (l_ptr.item).to_integer_32 = 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_csize := ((create {P_GLOBALS_STATIC}).curwin.item).item.win_lbr_chartabsize (l_ptr, l_col, l_head___0)
								update_class_fields -- Current might have been changed; synchronize
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___3 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___4 := l_tmp___3
								else
									l_tmp___4 := 1
								end
								l_ptr := l_ptr + l_tmp___4
								l_col := l_col + l_csize
							end
						end
						l_break := False
						l_idx := l_ptr.distance (l_line)
						if l_col > l_wcol then
							l_idx := l_idx - 1
							l_csize := l_csize - (l_head___0.item)
							l_col := l_col - l_csize
						else
							l_tmp___5 := (create {P_MISC2_STATIC}).virtual_active
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___5.to_boolean then
								if l_one_more = 0 then
									l_idx := l_idx - 1
									l_csize := l_csize - (l_head___0.item)
									l_col := l_col - l_csize
								end
							end
						end
						l_tmp___10 := (create {P_MISC2_STATIC}).virtual_active
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___10.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 18 then -- if:
						if not (a_addspaces.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 19 then -- if:
						if l_col = l_wcol then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if l_col /= l_wcol + 1 then
							l_pos := -1 + 23 -- goto _L___1
						else
							l_pos := -1 + 22 -- goto _L___2
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 22 then -- else: | _L___2:
						if not (l_csize > 1) then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L___1:
						if (l_line[l_idx]).to_integer_32 = 0 then
							l_correct := l_wcol - l_col
							l_tmp___6 := (create {P_MISC2_STATIC}).alloc (((l_idx + l_correct) + 1).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							l_newline := l_tmp___6
							if l_newline.is_void then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_t := 0
								from
								until
									not (l_t < l_idx)
								loop
									l_newline[l_t] := l_line[l_t]
									update_class_fields -- Current might have been changed; synchronize
									l_t := l_t + 1
								end
								l_t := 0
								from
								until
									not (l_t < l_correct)
								loop
									l_newline[(l_t + l_idx)] := ((' ').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_t := l_t + 1
								end
								l_newline[(l_idx + l_correct)] := (('%/0/').code).to_natural_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MEMLINE_STATIC}).ml_replace (lnum, l_newline, 0).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MISC1_STATIC}).changed_bytes (lnum, l_idx)
								update_class_fields -- Current might have been changed; synchronize
								l_idx := l_idx + l_correct
								l_col := l_wcol
							end
						else
							l_tmp___7 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))
							update_class_fields -- Current might have been changed; synchronize
							l_linelen___0 := l_tmp___7.to_integer_32
							l_correct___0 := ((l_wcol - l_col) - l_csize) + 1
							l_s := 0
							if -l_correct___0 > l_csize then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_newline___0 := (create {P_MISC2_STATIC}).alloc ((l_linelen___0 + l_csize).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_newline___0.is_void then
									Result := 0
									l_return := True
								end
							end
							if not l_return then
								l_t___0 := 0
								from
								until
									not (not (l_return) and then (l_t___0 < l_linelen___0))
								loop
									if l_t___0 /= l_idx then
										l_tmp___8 := l_s
										l_s := l_s + 1
										l_newline___0[l_tmp___8] := l_line[l_t___0]
										update_class_fields -- Current might have been changed; synchronize
									else
										l_v := 0
										from
										until
											not (l_v < l_csize)
										loop
											l_tmp___9 := l_s
											l_s := l_s + 1
											l_newline___0[l_tmp___9] := ((' ').code).to_natural_8
											update_class_fields -- Current might have been changed; synchronize
											l_v := l_v + 1
										end
									end
									l_t___0 := l_t___0 + 1
								end
								l_newline___0[((l_linelen___0 + l_csize) - 1)] := (('%/0/').code).to_natural_8
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MEMLINE_STATIC}).ml_replace (lnum, l_newline___0, 0).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MISC1_STATIC}).changed_bytes (lnum, l_idx)
								update_class_fields -- Current might have been changed; synchronize
								l_idx := l_idx + ((l_csize - 1) + l_correct___0)
								l_col := l_col + l_correct___0
							end
						end
				when 24 then -- if done | if done | if done | if done
					if not l_return then
						if l_idx < 0 then
							Current.col := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.col := l_idx
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.coladd := 0
						update_class_fields -- Current might have been changed; synchronize
						if a_finetune.to_boolean then
							if l_wcol.to_integer_32 = 2_147_483_647 then
								if not l_one_more.to_boolean then
									((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer)), l_scol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_ecol)
									update_class_fields -- Current might have been changed; synchronize
									Current.coladd := l_ecol.item - l_scol.item
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_b := l_wcol - l_col
								if l_b > 0 then
									if l_b.to_integer_32 < 2_147_483_647 - (2 * (create {P_GLOBALS_STATIC}).curwin.item.item.w_width).to_integer_32 then
										Current.coladd := l_b
										update_class_fields -- Current might have been changed; synchronize
									end
								end
								l_col := l_col + l_b
							end
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer))).item.mb_adjustpos
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_col < l_wcol then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						Result := 1
					end
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	inc: INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer))).item.ml_get_pos
			update_class_fields -- Current might have been changed; synchronize
			l_p___0 := l_tmp
			if (l_p___0.item).to_integer_32 /= 0 then
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
					update_class_fields -- Current might have been changed; synchronize
					l_l := l_tmp___0
					Current.col := col + l_l
					update_class_fields -- Current might have been changed; synchronize
					if (l_p___0[l_l]).to_integer_32 /= 0 then
						l_tmp___1 := 0
					else
						l_tmp___1 := 2
					end
					Result := l_tmp___1
					l_return := True
				end
				if not l_return then
					Current.col := col + 1
					update_class_fields -- Current might have been changed; synchronize
					Current.coladd := 0
					update_class_fields -- Current might have been changed; synchronize
					if (l_p___0[1]).to_integer_32 /= 0 then
						l_tmp___2 := 0
					else
						l_tmp___2 := 2
					end
					Result := l_tmp___2
					l_return := True
				end
			end
			if not l_return and then (lnum /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
				Current.col := 0
				update_class_fields -- Current might have been changed; synchronize
				Current.lnum := lnum + 1
				update_class_fields -- Current might have been changed; synchronize
				Current.coladd := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := (-1)
			end
		end

	incl: INTEGER_32
		local
			l_r: INTEGER_32
		do
			l_r := ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer))).item.inc
			update_class_fields -- Current might have been changed; synchronize
			if l_r >= 1 then
				if col.to_boolean then
					l_r := ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer))).item.inc
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_r
		end

	dec: INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			Current.coladd := 0
			update_class_fields -- Current might have been changed; synchronize
			if col > 0 then
				Current.col := col - 1
				update_class_fields -- Current might have been changed; synchronize
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_p___0 := (create {P_MEMLINE_STATIC}).ml_get (lnum)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_p___0, l_p___0 + col])
					update_class_fields -- Current might have been changed; synchronize
					Current.col := col - l_tmp
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := 0
				l_return := True
			end
			if not l_return and then (lnum > 1) then
				Current.lnum := lnum - 1
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := (create {P_MEMLINE_STATIC}).ml_get (lnum)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
				update_class_fields -- Current might have been changed; synchronize
				Current.col := l_tmp___0.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_tmp___1 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_p___0, l_p___0 + col])
					update_class_fields -- Current might have been changed; synchronize
					Current.col := col - l_tmp___1
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := (-1)
			end
		end

	decl: INTEGER_32
		local
			l_r: INTEGER_32
		do
			l_r := ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer))).item.dec
			update_class_fields -- Current might have been changed; synchronize
			if l_r = 1 then
				if col.to_boolean then
					l_r := ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer))).item.dec
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_r
		end

	mb_adjustpos
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (col > 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (coladd > 1) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_p___0 := (create {P_MEMLINE_STATIC}).ml_get (lnum)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_p___0, l_p___0 + col])
						update_class_fields -- Current might have been changed; synchronize
						Current.col := col - l_tmp
						update_class_fields -- Current might have been changed; synchronize
						if coladd = 1 then
							if (l_p___0[col]).to_integer_32 /= 9 then
								l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0 + col])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___1 := (create {P_CHARSET_STATIC}).vim_isprintc (l_tmp___0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1.to_boolean then
									l_tmp___2 := (create {P_CHARSET_STATIC}).ptr2cells (l_p___0 + col)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___2 > 1 then
										Current.coladd := 0
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_start_of_word
		local
			l_line: CE_POINTER [NATURAL_8]
			l_cclass: INTEGER_32
			l_col: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_line := (create {P_MEMLINE_STATIC}).ml_get (lnum)
			update_class_fields -- Current might have been changed; synchronize
			l_cclass := get_mouse_class (l_line + col)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				not (not (l_break) and then (col > 0))
			loop
				l_break := False
				l_col := col - 1
				l_tmp := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, l_line + l_col])
				update_class_fields -- Current might have been changed; synchronize
				l_col := l_col - l_tmp
				l_tmp___0 := get_mouse_class (l_line + l_col)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0 /= l_cclass then
					l_break := True
				end
				if not (l_break) then
					Current.col := l_col
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False
		end

	find_end_of_word
		local
			l_line: CE_POINTER [NATURAL_8]
			l_cclass: INTEGER_32
			l_col: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
		do
			l_line := (create {P_MEMLINE_STATIC}).ml_get (lnum)
			update_class_fields -- Current might have been changed; synchronize
			if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101 then
				if col > 0 then
					Current.col := col - 1
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, l_line + col])
					update_class_fields -- Current might have been changed; synchronize
					Current.col := col - l_tmp
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_cclass := get_mouse_class (l_line + col)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				not (not (l_break) and then ((l_line[col]).to_integer_32 /= 0))
			loop
				l_break := False
				l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_line + col])
				update_class_fields -- Current might have been changed; synchronize
				l_col := col + l_tmp___0
				l_tmp___1 := get_mouse_class (l_line + l_col)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1 /= l_cclass then
					if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101 then
						Current.col := l_col
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				if not (l_break) then
					Current.col := l_col
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			l_break := False
		end

	unserialize_pos (a_fp: CE_POINTER [SD_IO_FILE])
		local
			l_tmp: INTEGER_32
		do
			l_tmp := (create {P_MISC2_STATIC}).get4c (a_fp)
			update_class_fields -- Current might have been changed; synchronize
			Current.lnum := l_tmp.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if lnum < 0 then
				Current.lnum := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.col := (create {P_MISC2_STATIC}).get4c (a_fp)
			update_class_fields -- Current might have been changed; synchronize
			if col < 0 then
				Current.col := 0
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.coladd := (create {P_MISC2_STATIC}).get4c (a_fp)
			update_class_fields -- Current might have been changed; synchronize
			if coladd < 0 then
				Current.coladd := 0
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	getvpos (a_wcol: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_tmp := (create {P_MISC2_STATIC}).virtual_active
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (c_pointer))).item.coladvance2 (0, l_tmp, a_wcol)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp___0
		end

feature {PD_POS_T} -- private routines

	get_mouse_class (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_c: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_p___0[0]).to_integer_32]).to_integer_32 > 1 then
					Result := ((create {P_MBYTE_STATIC}).mb_get_class (a_p___0))
					l_return := True
				end
			end
			if not l_return then
				l_c := (a_p___0.item).to_integer_32
				if l_c = 32 then
					Result := 0
					l_return := True
				elseif l_c = 9 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_CHARSET_STATIC}).vim_iswordc (l_c)).to_boolean then
					Result := 2
					l_return := True
				end
			end
			if not l_return and then (l_c /= 0) then
				if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-+*/%%<>&|^!=")), l_c)).is_void then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := l_c
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lnum := a_other.lnum
			col := a_other.col
			coladd := a_other.coladd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lnum = a_other.lnum and
				col = a_other.col and
				coladd = a_other.coladd
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lnum"),
					create {CE_STRUCTURE_FIELD}.make ("col"),
					create {CE_STRUCTURE_FIELD}.make ("coladd")
				>>)
			init_structure_info
		end

end
