class
	PD_PRT_PS_RESOURCE_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_ARRAY} name.make (<<64>>)
			create {CE_NATURAL_8_ARRAY} filename.make (<<4_097>>)
			create {CE_NATURAL_8_ARRAY} title.make (<<256>>)
			create {CE_NATURAL_8_ARRAY} version.make (<<256>>)
			Precursor
		end

feature {ANY} -- fields

	name: CE_ARRAY [NATURAL_8]

	filename: CE_ARRAY [NATURAL_8]

	type: INTEGER_32 assign set_type

	title: CE_ARRAY [NATURAL_8]

	version: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

feature {PD_PRT_PS_RESOURCE_S} -- private attributes

	prt_resource_types: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("procset"),
					ce_string ("encoding"),
					ce_string ("cmap")
				>>)
		end

	prt_resfile: CE_STATIC [CE_ARRAY [PD_PRT_RESFILE_BUFFER_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_PRT_RESFILE_BUFFER_S]}.make (<<1>>)
		end

	prt_dsc_table: CE_STATIC [CE_ARRAY [PD_PRT_DSC_COMMENT_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_PRT_DSC_COMMENT_S]}.make_initialized (<<
					create {PD_PRT_DSC_COMMENT_S}.make_initialized ([ce_string ("%%%%Title:"), ((("%%%%Title:").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32, 1]),
					create {PD_PRT_DSC_COMMENT_S}.make_initialized ([ce_string ("%%%%Version:"), ((("%%%%Version:").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32, 2]),
					create {PD_PRT_DSC_COMMENT_S}.make_initialized ([ce_string ("%%%%EndComments:"), ((("%%%%EndComments:").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32, 3])
				>>)
		end

feature {ANY} -- public routines

	prt_open_resource: INTEGER_32
		local
			l_offset: INTEGER_32
			l_seen_all: INTEGER_32
			l_seen_title: INTEGER_32
			l_seen_version: INTEGER_32
			l_fd_resource: CE_POINTER [SD_IO_FILE]
			l_dsc_line: CE_ARRAY [PD_PRT_DSC_LINE_S]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: NATURAL_32
			l_tmp___6: INTEGER_32
			l_tmp___7: NATURAL_32
			l_tmp___8: CE_POINTER [INTEGER_8]
			l_tmp___9: NATURAL_32
			l_tmp___10: INTEGER_32
			l_tmp___11: NATURAL_32
			l_tmp___12: CE_POINTER [INTEGER_8]
			l_tmp___13: NATURAL_32
			l_tmp___14: INTEGER_32
			l_tmp___15: NATURAL_32
			l_tmp___16: INTEGER_32
			l_tmp___17: NATURAL_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_PRT_DSC_LINE_S]} l_dsc_line.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fd_resource := fopen (create {CE_INTEGER_8_POINTER}.make_cast (filename), ce_string ("r"))
					update_class_fields -- Current might have been changed; synchronize
					if l_fd_resource.is_void then
						l_tmp := gettext (ce_string ("E624: Can%'t open file %"%%s%""))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), filename).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
						l_return := True
					end
					if not l_return then
						memset (create {CE_VOID_POINTER}.make_cast ((prt_resfile.item.item.buffer)), ('%/0/').code, (2_048).to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := fread (create {CE_VOID_POINTER}.make_cast ((prt_resfile.item.item.buffer)), {PLATFORM}.Natural_8_bytes.to_natural_32, (2_048).to_natural_32, l_fd_resource)
						update_class_fields -- Current might have been changed; synchronize
						prt_resfile.item.item.len := l_tmp___0.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := ferror (l_fd_resource)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.to_boolean then
							l_tmp___1 := gettext (ce_string ("E457: Can%'t read PostScript resource file %"%%s%""))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1), filename).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							fclose (l_fd_resource).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						fclose (l_fd_resource).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						prt_resfile.item.item.line_end := -1
						update_class_fields -- Current might have been changed; synchronize
						prt_resfile.item.item.line_start := 0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3 := prt_resfile_next_line
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___3.to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_offset := 0
						l_tmp___5 := strlen (ce_string ("%%!PS-Adobe-"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___6 := prt_resfile_strncmp (l_offset, ce_string ("%%!PS-Adobe-"), l_tmp___5.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___6 /= 0 then
							l_tmp___4 := gettext (ce_string ("E618: file %"%%s%" is not a PostScript resource file"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4), filename).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_tmp___7 := strlen (ce_string ("%%!PS-Adobe-"))
						update_class_fields -- Current might have been changed; synchronize
						l_offset := l_offset + l_tmp___7.to_integer_32
						l_offset := prt_resfile_skip_nonws (l_offset)
						update_class_fields -- Current might have been changed; synchronize
						if l_offset = -1 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_offset := prt_resfile_skip_ws (l_offset)
						update_class_fields -- Current might have been changed; synchronize
						if l_offset = -1 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_tmp___9 := strlen (ce_string ("Resource-"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___10 := prt_resfile_strncmp (l_offset, ce_string ("Resource-"), l_tmp___9.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___10 /= 0 then
							l_tmp___8 := gettext (ce_string ("E619: file %"%%s%" is not a supported PostScript resource file"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___8), filename).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_tmp___11 := strlen (ce_string ("Resource-"))
						update_class_fields -- Current might have been changed; synchronize
						l_offset := l_offset + l_tmp___11.to_integer_32
						l_tmp___17 := strlen (ce_string ("ProcSet"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___18 := prt_resfile_strncmp (l_offset, ce_string ("ProcSet"), l_tmp___17.to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___18 = 0 then
							Current.type := 0
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___15 := strlen (ce_string ("Encoding"))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___16 := prt_resfile_strncmp (l_offset, ce_string ("Encoding"), l_tmp___15.to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___16 = 0 then
								Current.type := 1
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___13 := strlen (ce_string ("CMap"))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___14 := prt_resfile_strncmp (l_offset, ce_string ("CMap"), l_tmp___13.to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___14 = 0 then
									Current.type := 2
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___12 := gettext (ce_string ("E619: file %"%%s%" is not a supported PostScript resource file"))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___12), filename).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									Result := 0
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						title[0] := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						version[0] := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_seen_title := 0
						l_seen_version := 0
						l_seen_all := 0
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not l_seen_all.to_boolean then
							l_tmp___19 := prt_next_dsc (l_dsc_line)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___19.to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						inspect l_dsc_line.item.type -- switch 1 head
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when -1 then l_pos := -1 + 8 -- -1
						else l_pos := -1 + 9
						end
				when 5 then -- switch 1, case 1;
						(create {P_MISC2_STATIC}).vim_strncpy (title, l_dsc_line.item.string, (l_dsc_line.item.len).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_seen_title := 1
						if l_seen_version.to_boolean then
							l_seen_all := 1
						end
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 2;
						(create {P_MISC2_STATIC}).vim_strncpy (version, l_dsc_line.item.string, (l_dsc_line.item.len).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_seen_version := 1
						if l_seen_title.to_boolean then
							l_seen_all := 1
						end
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 3
						l_seen_all := 1
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, case -1
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						if not l_seen_title.to_boolean then
							l_tmp___20 := gettext (ce_string ("E619: file %"%%s%" is not a supported PostScript resource file"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___20), filename).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						elseif not l_seen_version.to_boolean then
							l_tmp___20 := gettext (ce_string ("E619: file %"%%s%" is not a supported PostScript resource file"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___20), filename).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
				when 11 then -- if done
					if not l_return then
						Result := 1
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prt_add_resource: INTEGER_32
		local
			l_fd_resource: CE_POINTER [SD_IO_FILE]
			l_resource_buffer: CE_ARRAY [NATURAL_8]
			l_bytes_read: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_resource_buffer.make (<<512>>)

			l_fd_resource := fopen (create {CE_INTEGER_8_POINTER}.make_cast (filename), ce_string ("r"))
			update_class_fields -- Current might have been changed; synchronize
			if l_fd_resource.is_void then
				l_tmp := gettext (ce_string ("E456: Can%'t open file %"%%s%""))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), filename).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("BeginResource"), prt_resource_types.item[type], create {CE_INTEGER_8_POINTER}.make_cast (title))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("BeginDocument"), create {CE_INTEGER_8_POINTER}.make_cast (filename))
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_bytes_read := fread (create {CE_VOID_POINTER}.make_cast (l_resource_buffer), {PLATFORM}.Natural_8_bytes.to_natural_32, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (512).to_natural_32), l_fd_resource)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := ferror (l_fd_resource)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___1.to_boolean then
						l_tmp___0 := gettext (ce_string ("E457: Can%'t read PostScript resource file %"%%s%""))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0), filename).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						fclose (l_fd_resource).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
						l_return := True
					end
					if not l_return then
						if l_bytes_read = {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							(create {P_HARDCOPY_STATIC}).prt_write_file_raw_len (l_resource_buffer, l_bytes_read.to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if ((create {P_HARDCOPY_STATIC}).prt_file_error.item).to_boolean then
								fclose (l_fd_resource).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				fclose (l_fd_resource).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("EndDocument"))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("EndResource"))
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

feature {PD_PRT_PS_RESOURCE_S} -- private routines

	prt_next_dsc (a_p_dsc_line: CE_POINTER [PD_PRT_DSC_LINE_S]): INTEGER_32
		local
			l_comment: INTEGER_32
			l_offset: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if not (prt_resfile_next_line).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (prt_resfile_strncmp (0, ce_string ("%%%%"), 2)) /= 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_comment := 0
				from
				until
					not (not (l_break) and then (l_comment < (((create {PD_PRT_DSC_COMMENT_S}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_PRT_DSC_COMMENT_S}.make).structure_size.to_natural_32).to_integer_32))
				loop
					l_break := False
					if (prt_resfile_strncmp (0, prt_dsc_table.item[l_comment].string, prt_dsc_table.item[l_comment].len)) = 0 then
						l_break := True
					end
					if not (l_break) then
						l_comment := l_comment + 1
					end
				end
				l_break := False
				if l_comment.to_natural_32 /= ((create {PD_PRT_DSC_COMMENT_S}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_PRT_DSC_COMMENT_S}.make).structure_size.to_natural_32 then
					a_p_dsc_line.item.type := prt_dsc_table.item[l_comment].type
					l_offset := prt_dsc_table.item[l_comment].len
				else
					a_p_dsc_line.item.type := -1
					l_offset := prt_resfile_skip_nonws (0)
					if l_offset = -1 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				l_offset := prt_resfile_skip_ws (l_offset)
				if l_offset = -1 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				a_p_dsc_line.item.string := prt_resfile.item.item.buffer + prt_resfile.item.item.line_start + l_offset
				a_p_dsc_line.item.len := prt_resfile.item.item.line_end - (prt_resfile.item.item.line_start + l_offset)
				Result := 1
			end
		end

	prt_resfile_next_line: INTEGER_32
		local
			l_idx: INTEGER_32
			l_break: BOOLEAN
		do
			l_idx := prt_resfile.item.item.line_end + 1
			from
			until
				not (not (l_break) and then (l_idx < prt_resfile.item.item.len))
			loop
				l_break := False
				if (prt_resfile.item.item.buffer[l_idx]).to_integer_32 /= 10 then
					if (prt_resfile.item.item.buffer[l_idx]).to_integer_32 /= 13 then
						l_break := True
					end
				end
				if not (l_break) then
					l_idx := l_idx + 1
				end
			end
			l_break := False
			prt_resfile.item.item.line_start := l_idx
			from
			until
				not (not (l_break) and then (l_idx < prt_resfile.item.item.len))
			loop
				l_break := False
				if (prt_resfile.item.item.buffer[l_idx]).to_integer_32 = 10 then
					l_break := True
				elseif (prt_resfile.item.item.buffer[l_idx]).to_integer_32 = 13 then
					l_break := True
				end
				if not (l_break) then
					l_idx := l_idx + 1
				end
			end
			l_break := False
			prt_resfile.item.item.line_end := l_idx
			Result := (l_idx < prt_resfile.item.item.len).to_integer
		end

	prt_resfile_strncmp (a_offset: INTEGER_32; a_string___0: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_len > prt_resfile.item.item.line_end - (prt_resfile.item.item.line_start + a_offset) then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((prt_resfile.item.item.buffer + prt_resfile.item.item.line_start + a_offset)), a_string___0, a_len.to_natural_32))
			end
		end

	prt_resfile_skip_nonws (a_offset: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_return: BOOLEAN
		do
			l_idx := prt_resfile.item.item.line_start + a_offset
			from
			until
				not (not (l_return) and then (l_idx < prt_resfile.item.item.line_end))
			loop
				if ((((ctype_b_loc).item[(prt_resfile.item.item.buffer[l_idx]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
					Result := (l_idx - prt_resfile.item.item.line_start)
					l_return := True
				end
				if not l_return then
					l_idx := l_idx + 1
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

	prt_resfile_skip_ws (a_offset: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
			l_return: BOOLEAN
		do
			l_idx := prt_resfile.item.item.line_start + a_offset
			from
			until
				not (not (l_return) and then (l_idx < prt_resfile.item.item.line_end))
			loop
				if not ((((ctype_b_loc).item[(prt_resfile.item.item.buffer[l_idx]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
					Result := (l_idx - prt_resfile.item.item.line_start)
					l_return := True
				end
				if not l_return then
					l_idx := l_idx + 1
				end
			end
			if not l_return then
				Result := (-1)
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name.twin
			filename := a_other.filename.twin
			type := a_other.type
			title := a_other.title.twin
			version := a_other.version.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				filename.is_equal (a_other.filename) and
				type = a_other.type and
				title.is_equal (a_other.title) and
				version.is_equal (a_other.version)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("name", <<64>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("filename", <<4_097>>),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("title", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("version", <<256>>)
				>>)
			init_structure_info
		end

end
