class
	PD_PRT_SETTINGS_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_TIME_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create number.make
			create {CE_NATURAL_8_POINTER} jobname.make
			create {CE_NATURAL_8_POINTER} outfile.make
			create {CE_NATURAL_8_POINTER} arguments.make
			Precursor
		end

feature {ANY} -- fields

	n_collated_copies: INTEGER_32 assign set_n_collated_copies

	n_uncollated_copies: INTEGER_32 assign set_n_uncollated_copies

	duplex: INTEGER_32 assign set_duplex

	chars_per_line: INTEGER_32 assign set_chars_per_line

	lines_per_page: INTEGER_32 assign set_lines_per_page

	has_color: INTEGER_32 assign set_has_color

	number: PD_PRT_TEXT_ATTR_T assign set_number

	modec: INTEGER_32 assign set_modec

	do_syntax: INTEGER_32 assign set_do_syntax

	user_abort: INTEGER_32 assign set_user_abort

	jobname: CE_POINTER [NATURAL_8] assign set_jobname

	outfile: CE_POINTER [NATURAL_8] assign set_outfile

	arguments: CE_POINTER [NATURAL_8] assign set_arguments

feature {ANY} -- field setters

	set_n_collated_copies (a_n_collated_copies: INTEGER_32)
		do
			n_collated_copies := a_n_collated_copies
			update_memory_field ("n_collated_copies")
		end

	set_n_uncollated_copies (a_n_uncollated_copies: INTEGER_32)
		do
			n_uncollated_copies := a_n_uncollated_copies
			update_memory_field ("n_uncollated_copies")
		end

	set_duplex (a_duplex: INTEGER_32)
		do
			duplex := a_duplex
			update_memory_field ("duplex")
		end

	set_chars_per_line (a_chars_per_line: INTEGER_32)
		do
			chars_per_line := a_chars_per_line
			update_memory_field ("chars_per_line")
		end

	set_lines_per_page (a_lines_per_page: INTEGER_32)
		do
			lines_per_page := a_lines_per_page
			update_memory_field ("lines_per_page")
		end

	set_has_color (a_has_color: INTEGER_32)
		do
			has_color := a_has_color
			update_memory_field ("has_color")
		end

	set_number (a_number: PD_PRT_TEXT_ATTR_T)
		do
			number := a_number
			update_memory_field ("number")
		end

	set_modec (a_modec: INTEGER_32)
		do
			modec := a_modec
			update_memory_field ("modec")
		end

	set_do_syntax (a_do_syntax: INTEGER_32)
		do
			do_syntax := a_do_syntax
			update_memory_field ("do_syntax")
		end

	set_user_abort (a_user_abort: INTEGER_32)
		do
			user_abort := a_user_abort
			update_memory_field ("user_abort")
		end

	set_jobname (a_jobname: CE_POINTER [NATURAL_8])
		do
			jobname := a_jobname
			update_memory_field ("jobname")
		end

	set_outfile (a_outfile: CE_POINTER [NATURAL_8])
		do
			outfile := a_outfile
			update_memory_field ("outfile")
		end

	set_arguments (a_arguments: CE_POINTER [NATURAL_8])
		do
			arguments := a_arguments
			update_memory_field ("arguments")
		end

feature {ANY} -- public routines

	mch_print_begin: INTEGER_32
		local
			l_now: CE_ARRAY [INTEGER_32]
			l_bbox: CE_ARRAY [INTEGER_32]
			l_p_time: CE_POINTER [INTEGER_8]
			l_left: CE_ARRAY [REAL_64]
			l_right: CE_ARRAY [REAL_64]
			l_top: CE_ARRAY [REAL_64]
			l_bottom: CE_ARRAY [REAL_64]
			l_res_prolog: CE_ARRAY [PD_PRT_PS_RESOURCE_S]
			l_res_encoding: CE_ARRAY [PD_PRT_PS_RESOURCE_S]
			l_buffer: CE_ARRAY [INTEGER_8]
			l_p_encoding: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_res_cidfont: CE_ARRAY [PD_PRT_PS_RESOURCE_S]
			l_res_cmap: CE_ARRAY [PD_PRT_PS_RESOURCE_S]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_props: INTEGER_32
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: CE_POINTER [INTEGER_8]
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: CE_POINTER [INTEGER_8]
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: CE_POINTER [INTEGER_8]
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: CE_POINTER [INTEGER_8]
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___30: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_now.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_bbox.make (<<4>>)
			create {CE_REAL_64_ARRAY} l_left.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_right.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_top.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_bottom.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PRT_PS_RESOURCE_S]} l_res_prolog.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PRT_PS_RESOURCE_S]} l_res_encoding.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_buffer.make (<<256>>)
			create {CE_NATURAL_8_POINTER} l_p_encoding.make
			create {CE_CLASS_ARRAY [PD_PRT_PS_RESOURCE_S]} l_res_cidfont.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_PRT_PS_RESOURCE_S]} l_res_cmap.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					prt_dsc_start
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("Title"), create {CE_INTEGER_8_POINTER}.make_cast (jobname))
					update_class_fields -- Current might have been changed; synchronize
					l_tmp := (create {P_MISC2_STATIC}).get_user_name (create {CE_NATURAL_8_POINTER}.make_cast (l_buffer), 256)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp.to_boolean then
						strcpy (l_buffer, ce_string ("Unknown")).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("For"), l_buffer)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("Creator"), ce_string ("VIM - Vi IMproved 7.3 (2010 Aug 15)"))
					update_class_fields -- Current might have been changed; synchronize
					l_now.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					l_p_time := ctime (l_now)
					update_class_fields -- Current might have been changed; synchronize
					l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (l_p_time), ('%N').code)
					update_class_fields -- Current might have been changed; synchronize
					if not l_p___0.is_void then
						l_p___0.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("CreationDate"), l_p_time)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("DocumentData"), ce_string ("Clean8Bit"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("Orientation"), ce_string ("Portrait"))
					update_class_fields -- Current might have been changed; synchronize
					prt_dsc_text (ce_string ("Pages"), ce_string ("atend"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("PageOrder"), ce_string ("Ascend"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_HARDCOPY_STATIC}).prt_page_margins (((create {P_HARDCOPY_STATIC}).prt_mediasize.item[(create {P_HARDCOPY_STATIC}).prt_media.item].width).to_double, ((create {P_HARDCOPY_STATIC}).prt_mediasize.item[(create {P_HARDCOPY_STATIC}).prt_media.item].height).to_double, l_left, l_right, l_top, l_bottom)
					update_class_fields -- Current might have been changed; synchronize
					l_bbox[0] := (l_left.item).truncated_to_integer
					update_class_fields -- Current might have been changed; synchronize
					if ((create {P_HARDCOPY_STATIC}).prt_portrait.item).to_boolean then
						l_tmp___0 := (create {P_HARDCOPY_STATIC}).prt_header_height
						update_class_fields -- Current might have been changed; synchronize
						l_bbox[1] := (l_top.item - ((lines_per_page + l_tmp___0).to_real * (create {P_HARDCOPY_STATIC}).prt_line_height.item).to_double).truncated_to_integer
						update_class_fields -- Current might have been changed; synchronize
						l_bbox[2] := ((l_left.item + (chars_per_line.to_real * (create {P_HARDCOPY_STATIC}).prt_char_width.item).to_double) + 0.5).truncated_to_integer
						update_class_fields -- Current might have been changed; synchronize
						l_bbox[3] := (l_top.item + 0.5).truncated_to_integer
						update_class_fields -- Current might have been changed; synchronize
					else
						l_bbox[1] := (l_bottom.item).truncated_to_integer
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := (create {P_HARDCOPY_STATIC}).prt_header_height
						update_class_fields -- Current might have been changed; synchronize
						l_bbox[2] := ((l_left.item + ((lines_per_page + l_tmp___1).to_real * (create {P_HARDCOPY_STATIC}).prt_line_height.item).to_double) + 0.5).truncated_to_integer
						update_class_fields -- Current might have been changed; synchronize
						l_bbox[3] := ((l_bottom.item + (chars_per_line.to_real * (create {P_HARDCOPY_STATIC}).prt_char_width.item).to_double) + 0.5).truncated_to_integer
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_HARDCOPY_STATIC}).prt_dsc_ints (ce_string ("BoundingBox"), 4, l_bbox)
					update_class_fields -- Current might have been changed; synchronize
					prt_dsc_docmedia ((create {P_HARDCOPY_STATIC}).prt_mediasize.item[(create {P_HARDCOPY_STATIC}).prt_media.item].name, ((create {P_HARDCOPY_STATIC}).prt_mediasize.item[(create {P_HARDCOPY_STATIC}).prt_media.item].width).to_double, ((create {P_HARDCOPY_STATIC}).prt_mediasize.item[(create {P_HARDCOPY_STATIC}).prt_media.item].height).to_double, (0).to_double, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					update_class_fields -- Current might have been changed; synchronize
					if not ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
						prt_dsc_font_resource (ce_string ("DocumentNeededResources"), (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item)
						update_class_fields -- Current might have been changed; synchronize
					elseif ((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean then
						prt_dsc_font_resource (ce_string ("DocumentNeededResources"), (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
						if ((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean then
							l_tmp___2 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						else
							l_tmp___2 := ce_string ("DocumentNeededResources")
						end
						prt_dsc_font_resource (l_tmp___2, (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item)
						update_class_fields -- Current might have been changed; synchronize
						if not ((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean then
							(create {P_HARDCOPY_STATIC}).prt_dsc_resources (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("cmap"), (create {P_HARDCOPY_STATIC}).prt_cmap.item)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_tmp___4 := prt_find_resource (ce_string ("prolog"), l_res_prolog)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___4.to_boolean then
						l_tmp___3 := gettext (ce_string ("E456: Can%'t find PostScript resource file %"prolog.ps%""))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
						l_return := True
					end
					if not l_return then
						l_tmp___5 := l_res_prolog.item.prt_open_resource
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___5.to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_tmp___6 := prt_check_resource (l_res_prolog, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("1.4")))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___6.to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return and then (((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean) then
						l_tmp___8 := prt_find_resource (ce_string ("cidfont"), l_res_cidfont)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___8.to_boolean then
							l_tmp___7 := gettext (ce_string ("E456: Can%'t find PostScript resource file %"cidfont.ps%""))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___7)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
						if not l_return then
							l_tmp___9 := l_res_cidfont.item.prt_open_resource
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___9.to_boolean then
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							l_tmp___10 := prt_check_resource (l_res_cidfont, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("1.0")))
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___10.to_boolean then
								Result := 0
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						l_p_encoding := (create {P_MBYTE_STATIC}).enc_skip ((create {P_OPTION_STATIC}).p_penc.item.item)
						update_class_fields -- Current might have been changed; synchronize
						if (l_p_encoding.item).to_integer_32 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 5 then -- else:
						l_tmp___14 := prt_find_resource (create {CE_INTEGER_8_POINTER}.make_cast (l_p_encoding), l_res_encoding)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___14.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if: | _L___0:
						l_p_encoding := (create {P_MBYTE_STATIC}).enc_skip ((create {P_OPTION_STATIC}).p_enc.item.item)
						update_class_fields -- Current might have been changed; synchronize
						l_props := (create {P_MBYTE_STATIC}).enc_canon_props (l_p_encoding)
						update_class_fields -- Current might have been changed; synchronize
						if ((l_props).bit_and (1)).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						l_tmp___13 := prt_find_resource (create {CE_INTEGER_8_POINTER}.make_cast (l_p_encoding), l_res_encoding)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___13.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_p_encoding := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("latin1"))
						l_tmp___12 := prt_find_resource (create {CE_INTEGER_8_POINTER}.make_cast (l_p_encoding), l_res_encoding)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___12.to_boolean then
							l_tmp___11 := gettext (ce_string ("E456: Can%'t find PostScript resource file %"%%s.ps%""))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___11), l_p_encoding).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
				when 11 then -- if done | if done | if done
						if not l_return then
							l_tmp___15 := l_res_encoding.item.prt_open_resource
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___15.to_boolean then
								Result := 0
								l_return := True
							end
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_p_encoding := (create {P_MBYTE_STATIC}).enc_skip ((create {P_OPTION_STATIC}).p_penc.item.item)
						update_class_fields -- Current might have been changed; synchronize
						if (l_p_encoding.item).to_integer_32 = 0 then
							l_p_encoding := (create {P_MBYTE_STATIC}).enc_skip ((create {P_OPTION_STATIC}).p_enc.item.item)
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean then
							l_tmp___17 := prt_find_resource ((create {P_HARDCOPY_STATIC}).prt_ascii_encoding.item, l_res_encoding)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___17.to_boolean then
								l_tmp___16 := gettext (ce_string ("E456: Can%'t find PostScript resource file %"%%s.ps%""))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___16), create {CE_NATURAL_8_POINTER}.make_cast ((create {P_HARDCOPY_STATIC}).prt_ascii_encoding.item)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							end
							if not l_return then
								l_tmp___18 := l_res_encoding.item.prt_open_resource
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___18.to_boolean then
									Result := 0
									l_return := True
								end
							end
						end
				when 14 then -- if done | if done
					if not l_return then
						(create {P_HARDCOPY_STATIC}).prt_conv.item.item.vc_type := 0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___21 := (create {P_MBYTE_STATIC}).enc_canon_props ((create {P_OPTION_STATIC}).p_enc.item.item)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___22 := (create {P_MBYTE_STATIC}).enc_canon_props (l_p_encoding)
						update_class_fields -- Current might have been changed; synchronize
						if not ((((l_tmp___21).bit_and (l_tmp___22))).bit_and (1)).to_boolean then
							l_tmp___20 := ((create {P_HARDCOPY_STATIC}).prt_conv.item).item.convert_setup ((create {P_OPTION_STATIC}).p_enc.item.item, l_p_encoding)
							update_class_fields -- Current might have been changed; synchronize
							if 0 = l_tmp___20 then
								l_tmp___19 := gettext (ce_string ("E620: Unable to convert to print encoding %"%%s%""))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___19), l_p_encoding).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							end
							if not l_return then
								(create {P_HARDCOPY_STATIC}).prt_do_conv.item := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
					if not l_return then
						(create {P_HARDCOPY_STATIC}).prt_do_conv.item := ((create {P_HARDCOPY_STATIC}).prt_conv.item.item.vc_type /= 0).to_integer
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							if ((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean then
								l_tmp___24 := prt_find_resource ((create {P_HARDCOPY_STATIC}).prt_cmap.item, l_res_cmap)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___24.to_boolean then
									l_tmp___23 := gettext (ce_string ("E456: Can%'t find PostScript resource file %"%%s.ps%""))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___23), create {CE_NATURAL_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_cmap.item))).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									Result := 0
									l_return := True
								end
								if not l_return then
									l_tmp___25 := l_res_cmap.item.prt_open_resource
									update_class_fields -- Current might have been changed; synchronize
									if not l_tmp___25.to_boolean then
										Result := 0
										l_return := True
									end
								end
							end
						end
					end
					if not l_return then
						strcpy (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_prolog.item.title))).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						strcat (l_buffer, ce_string (" ")).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						strcat (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_prolog.item.version))).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("DocumentSuppliedResources"), ce_string ("procset"), l_buffer)
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							strcpy (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_cidfont.item.title))).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcat (l_buffer, ce_string (" ")).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcat (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_cidfont.item.version))).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_HARDCOPY_STATIC}).prt_dsc_resources (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("procset"), l_buffer)
							update_class_fields -- Current might have been changed; synchronize
							if ((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean then
								strcpy (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_cmap.item.title))).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								strcat (l_buffer, ce_string (" ")).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								strcat (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_cmap.item.version))).do_nothing
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_HARDCOPY_STATIC}).prt_dsc_resources (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("cmap"), l_buffer)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if not ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							strcpy (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_encoding.item.title))).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcat (l_buffer, ce_string (" ")).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcat (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_encoding.item.version))).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_HARDCOPY_STATIC}).prt_dsc_resources (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("encoding"), l_buffer)
							update_class_fields -- Current might have been changed; synchronize
						elseif ((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean then
							strcpy (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_encoding.item.title))).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcat (l_buffer, ce_string (" ")).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcat (l_buffer, create {CE_INTEGER_8_POINTER}.make_cast ((l_res_encoding.item.version))).do_nothing
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_HARDCOPY_STATIC}).prt_dsc_resources (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("encoding"), l_buffer)
							update_class_fields -- Current might have been changed; synchronize
						end
						prt_dsc_requirements ((create {P_HARDCOPY_STATIC}).prt_duplex.item, (create {P_HARDCOPY_STATIC}).prt_tumble.item, (create {P_HARDCOPY_STATIC}).prt_collate.item, do_syntax, (create {P_HARDCOPY_STATIC}).prt_num_copies.item)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("EndComments"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("BeginDefaults"))
						update_class_fields -- Current might have been changed; synchronize
						if not ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							prt_dsc_font_resource (ce_string ("PageResources"), (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item)
							update_class_fields -- Current might have been changed; synchronize
						elseif ((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean then
							prt_dsc_font_resource (ce_string ("PageResources"), (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item)
							update_class_fields -- Current might have been changed; synchronize
						end
						if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							if ((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean then
								l_tmp___26 := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp___26 := ce_string ("PageResources")
							end
							prt_dsc_font_resource (l_tmp___26, (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item)
							update_class_fields -- Current might have been changed; synchronize
							if not ((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean then
								(create {P_HARDCOPY_STATIC}).prt_dsc_resources (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("cmap"), (create {P_HARDCOPY_STATIC}).prt_cmap.item)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						(create {P_HARDCOPY_STATIC}).prt_dsc_textline (ce_string ("PageMedia"), (create {P_HARDCOPY_STATIC}).prt_mediasize.item[(create {P_HARDCOPY_STATIC}).prt_media.item].name)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("EndDefaults"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("BeginProlog"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___27 := l_res_prolog.item.prt_add_resource
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___27.to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return and then (((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean) then
						l_tmp___28 := l_res_cidfont.item.prt_add_resource
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___28.to_boolean then
							Result := 0
							l_return := True
						end
						if not l_return and then (((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean) then
							l_tmp___29 := l_res_cmap.item.prt_add_resource
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___29.to_boolean then
								Result := 0
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 15 then -- if:
						if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 18 then -- else:
						if not (((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 19 then -- if: | _L___1:
						l_tmp___30 := l_res_encoding.item.prt_add_resource
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___30.to_boolean then
							Result := 0
							l_return := True
						end
				when 20 then -- if done | if done
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 21 then -- if:;
						(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("EndProlog"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("BeginSetup"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_write_int (((create {P_HARDCOPY_STATIC}).prt_mediasize.item[(create {P_HARDCOPY_STATIC}).prt_media.item].width).truncated_to_integer)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_write_int (((create {P_HARDCOPY_STATIC}).prt_mediasize.item[(create {P_HARDCOPY_STATIC}).prt_media.item].height).truncated_to_integer)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_write_int (0)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("sps%N"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_write_int ((create {P_HARDCOPY_STATIC}).prt_num_copies.item)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("nc%N"))
						update_class_fields -- Current might have been changed; synchronize
						prt_write_boolean ((create {P_HARDCOPY_STATIC}).prt_duplex.item)
						update_class_fields -- Current might have been changed; synchronize
						prt_write_boolean ((create {P_HARDCOPY_STATIC}).prt_tumble.item)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("dt%N"))
						update_class_fields -- Current might have been changed; synchronize
						prt_write_boolean ((create {P_HARDCOPY_STATIC}).prt_collate.item)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("c%N"))
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L___2
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 24 then -- else:
						if not (((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 25 then -- if: | _L___2:
						if ((create {P_HARDCOPY_STATIC}).prt_use_courier.item).to_boolean then
							l_p_encoding := create {CE_NATURAL_8_POINTER}.make_cast ((create {P_HARDCOPY_STATIC}).prt_ascii_encoding.item)
						end
						(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.ps_fontname[0])
						update_class_fields -- Current might have been changed; synchronize
						prt_def_font (ce_string ("F0"), create {CE_INTEGER_8_POINTER}.make_cast (l_p_encoding), ((create {P_HARDCOPY_STATIC}).prt_line_height.item).truncated_to_integer, (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.ps_fontname[0])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.ps_fontname[1])
						update_class_fields -- Current might have been changed; synchronize
						prt_def_font (ce_string ("F1"), create {CE_INTEGER_8_POINTER}.make_cast (l_p_encoding), ((create {P_HARDCOPY_STATIC}).prt_line_height.item).truncated_to_integer, (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.ps_fontname[1])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.ps_fontname[2])
						update_class_fields -- Current might have been changed; synchronize
						prt_def_font (ce_string ("F2"), create {CE_INTEGER_8_POINTER}.make_cast (l_p_encoding), ((create {P_HARDCOPY_STATIC}).prt_line_height.item).truncated_to_integer, (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.ps_fontname[2])
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.ps_fontname[3])
						update_class_fields -- Current might have been changed; synchronize
						prt_def_font (ce_string ("F3"), create {CE_INTEGER_8_POINTER}.make_cast (l_p_encoding), ((create {P_HARDCOPY_STATIC}).prt_line_height.item).truncated_to_integer, (create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.ps_fontname[3])
						update_class_fields -- Current might have been changed; synchronize
				when 26 then -- if done
						if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
							(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[0])
							update_class_fields -- Current might have been changed; synchronize
							if not ((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean then
								(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("cmap"), (create {P_HARDCOPY_STATIC}).prt_cmap.item)
								update_class_fields -- Current might have been changed; synchronize
							end
							prt_def_cidfont (ce_string ("CF0"), ((create {P_HARDCOPY_STATIC}).prt_line_height.item).truncated_to_integer, (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[0])
							update_class_fields -- Current might have been changed; synchronize
							if not ((create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[1]).is_void then
								(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[1])
								update_class_fields -- Current might have been changed; synchronize
								if not ((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean then
									(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("cmap"), (create {P_HARDCOPY_STATIC}).prt_cmap.item)
									update_class_fields -- Current might have been changed; synchronize
								end
								prt_def_cidfont (ce_string ("CF1"), ((create {P_HARDCOPY_STATIC}).prt_line_height.item).truncated_to_integer, (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[1])
								update_class_fields -- Current might have been changed; synchronize
							else
								prt_dup_cidfont (ce_string ("CF0"), ce_string ("CF1"))
								update_class_fields -- Current might have been changed; synchronize
							end
							if not ((create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[2]).is_void then
								(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[2])
								update_class_fields -- Current might have been changed; synchronize
								if not ((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean then
									(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("cmap"), (create {P_HARDCOPY_STATIC}).prt_cmap.item)
									update_class_fields -- Current might have been changed; synchronize
								end
								prt_def_cidfont (ce_string ("CF2"), ((create {P_HARDCOPY_STATIC}).prt_line_height.item).truncated_to_integer, (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[2])
								update_class_fields -- Current might have been changed; synchronize
							else
								prt_dup_cidfont (ce_string ("CF0"), ce_string ("CF2"))
								update_class_fields -- Current might have been changed; synchronize
							end
							if not ((create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[3]).is_void then
								(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("font"), (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[3])
								update_class_fields -- Current might have been changed; synchronize
								if not ((create {P_HARDCOPY_STATIC}).prt_custom_cmap.item).to_boolean then
									(create {P_HARDCOPY_STATIC}).prt_dsc_resources (ce_string ("IncludeResource"), ce_string ("cmap"), (create {P_HARDCOPY_STATIC}).prt_cmap.item)
									update_class_fields -- Current might have been changed; synchronize
								end
								prt_def_cidfont (ce_string ("CF3"), ((create {P_HARDCOPY_STATIC}).prt_line_height.item).truncated_to_integer, (create {P_HARDCOPY_STATIC}).prt_ps_mb_font.item.item.ps_fontname[3])
								update_class_fields -- Current might have been changed; synchronize
							else
								prt_dup_cidfont (ce_string ("CF1"), ce_string ("CF3"))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						prt_def_var (ce_string ("UO"), ((create {P_HARDCOPY_STATIC}).prt_ps_font.item.item.uline_offset).to_double * (((create {P_HARDCOPY_STATIC}).prt_line_height.item).to_double / 1000.0), 2)
						update_class_fields -- Current might have been changed; synchronize
						prt_def_var (ce_string ("UW"), ((create {P_HARDCOPY_STATIC}).prt_ps_font.item.item.uline_width).to_double * (((create {P_HARDCOPY_STATIC}).prt_line_height.item).to_double / 1000.0), 2)
						update_class_fields -- Current might have been changed; synchronize
						prt_def_var (ce_string ("BO"), ((create {P_HARDCOPY_STATIC}).prt_bgcol_offset.item).to_double, 2)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_HARDCOPY_STATIC}).prt_dsc_noarg (ce_string ("EndSetup"))
						update_class_fields -- Current might have been changed; synchronize
						Result := (not ((create {P_HARDCOPY_STATIC}).prt_file_error.item).to_boolean).to_integer
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_PRT_SETTINGS_T} -- private routines

	prt_write_boolean (a_b: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			if a_b.to_boolean then
				l_tmp := ce_string ("T")
			else
				l_tmp := ce_string ("F")
			end
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ce_string ("%%s "), l_tmp]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)
		end

	prt_def_font (a_new_name, a_encoding: CE_POINTER [INTEGER_8]; a_height: INTEGER_32; a_font: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/_%%s /VIM-%%s /%%s ref%N"), a_new_name, a_encoding, a_font]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)
			if ((create {P_HARDCOPY_STATIC}).prt_out_mbyte.item).to_boolean then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ce_string ("/%%s %%d %%f /_%%s sffs%N"), a_new_name, a_height, 500. / ((create {P_HARDCOPY_STATIC}).prt_ps_courier_font.item.item.wx).to_double, a_new_name]).do_nothing
			else
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/%%s %%d /_%%s ffs%N"), a_new_name, a_height, a_new_name]).do_nothing
			end
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)
		end

	prt_def_cidfont (a_new_name: CE_POINTER [INTEGER_8]; a_height: INTEGER_32; a_cidfont: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/_%%s /%%s[/%%s] vim_composefont%N"), a_new_name, (create {P_HARDCOPY_STATIC}).prt_cmap.item, a_cidfont]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item);
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/%%s %%d /_%%s ffs%N"), a_new_name, a_height, a_new_name]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)
		end

	prt_dup_cidfont (a_original_name, a_new_name: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/%%s %%s d%N"), a_new_name, a_original_name]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)
		end

	prt_def_var (a_name___1: CE_POINTER [INTEGER_8]; a_value: REAL_64; a_prec: INTEGER_32)
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("/%%s "), a_name___1]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item);
			(create {P_HARDCOPY_STATIC}).prt_write_real (a_value, a_prec)
			sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ce_string ("d%N")]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)
		end

	prt_find_resource (a_name___1: CE_POINTER [INTEGER_8]; a_resource: CE_POINTER [PD_PRT_PS_RESOURCE_S]): INTEGER_32
		require
			not a_name___1.is_void
			not a_resource.is_void
		local
			l_buffer: CE_ARRAY [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buffer.make (<<4_097>>)

			strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((a_resource.item.name)), a_name___1).do_nothing
			strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), ce_string ("print")).do_nothing;
			(create {P_MISC1_STATIC}).add_pathsep (l_buffer)
			strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), a_name___1).do_nothing
			strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buffer), ce_string (".ps")).do_nothing
			a_resource.item.filename[0] := (('%/0/').code).to_natural_8
			if ((create {P_EX_CMDS2_STATIC}).do_in_runtimepath (l_buffer, 0, (create {P_HARDCOPY_STATIC}).prt_resource_name_address, create {CE_VOID_POINTER}.make_cast ((a_resource.item.filename)))).to_boolean then
				if (a_resource.item.filename[0]).to_integer_32 /= 0 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	prt_check_resource (a_resource: CE_POINTER [PD_PRT_PS_RESOURCE_S]; a_version: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_resource.is_void
		local
			l_return: BOOLEAN
		do
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((a_resource.item.version)), create {CE_INTEGER_8_POINTER}.make_cast (a_version), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_version))))).to_boolean then
				(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E621: %"%%s%" resource file has wrong version")))), a_resource.item.name).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	prt_dsc_start
		do
			(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("%%!PS-Adobe-3.0%N"))
		end

	prt_dsc_text (a_comment, a_text: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%%%s: (%%s)%N"), a_comment, a_text]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)
		end

	prt_dsc_font_resource (a_resource: CE_POINTER [INTEGER_8]; a_ps_font: CE_POINTER [PD_PRT_PS_FONT_S])
		require
			not a_ps_font.is_void
		local
			l_i___0: INTEGER_32
		do
			(create {P_HARDCOPY_STATIC}).prt_dsc_resources (a_resource, ce_string ("font"), a_ps_font.item.ps_fontname[0])
			l_i___0 := 1
			from
			until
				not (l_i___0 <= 3)
			loop
				if not (a_ps_font.item.ps_fontname[l_i___0]).is_void then
					(create {P_HARDCOPY_STATIC}).prt_dsc_resources (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), ce_string ("font"), a_ps_font.item.ps_fontname[l_i___0])
				end
				l_i___0 := l_i___0 + 1
			end
		end

	prt_dsc_requirements (a_duplex, a_tumble, a_collate, a_color, a_num_copies: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if not a_duplex.to_boolean then
				if not a_collate.to_boolean then
					if not a_color.to_boolean then
						if not (a_num_copies > 1) then
							l_return := True
						end
					end
				end
			end
			if not l_return then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ce_string ("%%%%%%%%Requirements:")]).do_nothing;
				(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)
				if a_duplex.to_boolean then
					(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string (" duplex"))
					if a_tumble.to_boolean then
						(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("(tumble)"))
					end
				end
				if a_collate.to_boolean then
					(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string (" collate"))
				end
				if a_color.to_boolean then
					(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string (" color"))
				end
				if a_num_copies > 1 then
					(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string (" numcopies("))
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ce_string ("%%d"), a_num_copies]).do_nothing;
					(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item);
					(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string (")"))
				end
				(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("%N"))
			end
		end

	prt_dsc_docmedia (a_paper_name: CE_POINTER [INTEGER_8]; a_width, a_height, a_weight: REAL_64; a_colour, a_type: CE_POINTER [INTEGER_8])
		do
			(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HARDCOPY_STATIC}).prt_line_buffer.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (257).to_natural_32), ce_string ("%%%%%%%%DocumentMedia: %%s "), a_paper_name]).do_nothing;
			(create {P_HARDCOPY_STATIC}).prt_write_file ((create {P_HARDCOPY_STATIC}).prt_line_buffer.item);
			(create {P_HARDCOPY_STATIC}).prt_write_real (a_width, 2);
			(create {P_HARDCOPY_STATIC}).prt_write_real (a_height, 2);
			(create {P_HARDCOPY_STATIC}).prt_write_real (a_weight, 2)
			if a_colour.is_void then
				(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("()"))
			else
				(create {P_HARDCOPY_STATIC}).prt_write_string (a_colour)
			end
			(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string (" "))
			if a_type.is_void then
				(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("()"))
			else
				(create {P_HARDCOPY_STATIC}).prt_write_string (a_type)
			end
			(create {P_HARDCOPY_STATIC}).prt_write_string (ce_string ("%N"))
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n_collated_copies := a_other.n_collated_copies
			n_uncollated_copies := a_other.n_uncollated_copies
			duplex := a_other.duplex
			chars_per_line := a_other.chars_per_line
			lines_per_page := a_other.lines_per_page
			has_color := a_other.has_color
			number := a_other.number.twin
			modec := a_other.modec
			do_syntax := a_other.do_syntax
			user_abort := a_other.user_abort
			jobname := a_other.jobname
			outfile := a_other.outfile
			arguments := a_other.arguments
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n_collated_copies = a_other.n_collated_copies and
				n_uncollated_copies = a_other.n_uncollated_copies and
				duplex = a_other.duplex and
				chars_per_line = a_other.chars_per_line and
				lines_per_page = a_other.lines_per_page and
				has_color = a_other.has_color and
				number.is_equal (a_other.number) and
				modec = a_other.modec and
				do_syntax = a_other.do_syntax and
				user_abort = a_other.user_abort and
				jobname.is_equal (a_other.jobname) and
				outfile.is_equal (a_other.outfile) and
				arguments.is_equal (a_other.arguments)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n_collated_copies"),
					create {CE_STRUCTURE_FIELD}.make ("n_uncollated_copies"),
					create {CE_STRUCTURE_FIELD}.make ("duplex"),
					create {CE_STRUCTURE_FIELD}.make ("chars_per_line"),
					create {CE_STRUCTURE_FIELD}.make ("lines_per_page"),
					create {CE_STRUCTURE_FIELD}.make ("has_color"),
					create {CE_STRUCTURE_FIELD}.make ("number"),
					create {CE_STRUCTURE_FIELD}.make ("modec"),
					create {CE_STRUCTURE_FIELD}.make ("do_syntax"),
					create {CE_STRUCTURE_FIELD}.make ("user_abort"),
					create {CE_STRUCTURE_FIELD}.make ("jobname"),
					create {CE_STRUCTURE_FIELD}.make ("outfile"),
					create {CE_STRUCTURE_FIELD}.make ("arguments")
				>>)
			init_structure_info
		end

end
