class
	PD_PRT_TEXT_ATTR_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	fg_color: NATURAL_32 assign set_fg_color

	bg_color: NATURAL_32 assign set_bg_color

	bold: INTEGER_32 assign set_bold

	italic: INTEGER_32 assign set_italic

	underline: INTEGER_32 assign set_underline

	undercurl: INTEGER_32 assign set_undercurl

feature {ANY} -- field setters

	set_fg_color (a_fg_color: NATURAL_32)
		do
			fg_color := a_fg_color
			update_memory_field ("fg_color")
		end

	set_bg_color (a_bg_color: NATURAL_32)
		do
			bg_color := a_bg_color
			update_memory_field ("bg_color")
		end

	set_bold (a_bold: INTEGER_32)
		do
			bold := a_bold
			update_memory_field ("bold")
		end

	set_italic (a_italic: INTEGER_32)
		do
			italic := a_italic
			update_memory_field ("italic")
		end

	set_underline (a_underline: INTEGER_32)
		do
			underline := a_underline
			update_memory_field ("underline")
		end

	set_undercurl (a_undercurl: INTEGER_32)
		do
			undercurl := a_undercurl
			update_memory_field ("undercurl")
		end

feature {PD_PRT_TEXT_ATTR_T} -- private attributes

	cterm_color_8: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					0, 16_711_680, 65_280, 16_776_960, 255, 16_711_935, 65_535, 16_777_215
				>>)
		end

	cterm_color_16: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					0, 192, 32_768, 16_512, 12_582_912, 12_583_104, 8_421_376, 12_632_256, 8_421_504, 6_316_287, 65_280,
					65_535, 16_744_576, 16_728_319, 16_776_960, 16_777_215
				>>)
		end

feature {ANY} -- public routines

	prt_get_attr (a_hl_id, a_modec: INTEGER_32)
		local
			l_colorindex: INTEGER_32
			l_fg_color: NATURAL_32
			l_bg_color: NATURAL_32
			l_color: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
		do
			l_tmp := (create {P_SYNTAX_STATIC}).highlight_has_attr (a_hl_id, 2, a_modec)
			update_class_fields -- Current might have been changed; synchronize
			Current.bold := (not l_tmp.is_void).to_integer
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := (create {P_SYNTAX_STATIC}).highlight_has_attr (a_hl_id, 4, a_modec)
			update_class_fields -- Current might have been changed; synchronize
			Current.italic := (not l_tmp___0.is_void).to_integer
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := (create {P_SYNTAX_STATIC}).highlight_has_attr (a_hl_id, 8, a_modec)
			update_class_fields -- Current might have been changed; synchronize
			Current.underline := (not l_tmp___1.is_void).to_integer
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___2 := (create {P_SYNTAX_STATIC}).highlight_has_attr (a_hl_id, 16, a_modec)
			update_class_fields -- Current might have been changed; synchronize
			Current.undercurl := (not l_tmp___2.is_void).to_integer
			update_class_fields -- Current might have been changed; synchronize
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				l_bg_color := highlight_gui_color_rgb (a_hl_id, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_bg_color = {NATURAL_32} 0 then
					l_bg_color := (16_777_215).to_natural_32
				end
				l_fg_color := highlight_gui_color_rgb (a_hl_id, 1)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_bg_color := (16_777_215).to_natural_32
				l_tmp___3 := (create {P_SYNTAX_STATIC}).highlight_color (a_hl_id, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fg")), a_modec)
				update_class_fields -- Current might have been changed; synchronize
				l_color := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___3)
				if l_color.is_void then
					l_colorindex := 0
				else
					l_colorindex := atoi (l_color)
					update_class_fields -- Current might have been changed; synchronize
				end
				if l_colorindex >= 0 then
					if l_colorindex < (create {P_GLOBALS_STATIC}).t_colors.item then
						l_fg_color := prt_get_term_color (l_colorindex)
						update_class_fields -- Current might have been changed; synchronize
					else
						l_fg_color := (0).to_natural_32
					end
				else
					l_fg_color := (0).to_natural_32
				end
			end
			if l_fg_color = {NATURAL_32} 16_777_215 then
				l_fg_color := (0).to_natural_32
			elseif ((create {P_OPTION_STATIC}).p_bg.item.item.item).to_integer_32 = 100 then
				l_fg_color := darken_rgb (l_fg_color)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.fg_color := l_fg_color
			update_class_fields -- Current might have been changed; synchronize
			Current.bg_color := l_bg_color
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_PRT_TEXT_ATTR_T} -- private routines

	darken_rgb (a_rgb: NATURAL_32): NATURAL_32
		do
			Result := ((((((a_rgb).bit_shift_right (17))).bit_shift_left (16)) + ((((((a_rgb).bit_and ({NATURAL_32} 65_280))).bit_shift_right (9))).bit_shift_left (8))) + ((((a_rgb).bit_and ({NATURAL_32} 255))).bit_shift_right (1)))
		end

	prt_get_term_color (a_colorindex: INTEGER_32): NATURAL_32
		local
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).t_colors.item > 8 then
				Result := (cterm_color_16.item[a_colorindex \\ 16])
				l_return := True
			end
			if not l_return then
				Result := (cterm_color_8.item[a_colorindex \\ 8])
			end
		end

	highlight_gui_color_rgb (a_id, a_fg: INTEGER_32): NATURAL_32
		local
			l_color: INTEGER_32
			l_return: BOOLEAN
		do
			if a_id <= 0 then
				Result := (0).to_natural_32
				l_return := True
			elseif a_id > (create {P_SYNTAX_STATIC}).highlight_ga.item.item.ga_len then
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				if a_fg.to_boolean then
					l_color := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast ((create {P_SYNTAX_STATIC}).highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui_fg
				else
					l_color := (create {CE_CLASS_POINTER [PD_HL_GROUP]}.make_cast ((create {P_SYNTAX_STATIC}).highlight_ga.item.item.ga_data) + (a_id - 1)).item.sg_gui_bg
				end
				if l_color = -11_111 then
					Result := (0).to_natural_32
					l_return := True
				end
			end
			if not l_return then
				Result := ((create {P_GUI_GTK_X11_STATIC}).gui_mch_get_rgb (l_color))
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fg_color := a_other.fg_color
			bg_color := a_other.bg_color
			bold := a_other.bold
			italic := a_other.italic
			underline := a_other.underline
			undercurl := a_other.undercurl
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fg_color = a_other.fg_color and
				bg_color = a_other.bg_color and
				bold = a_other.bold and
				italic = a_other.italic and
				underline = a_other.underline and
				undercurl = a_other.undercurl
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fg_color"),
					create {CE_STRUCTURE_FIELD}.make ("bg_color"),
					create {CE_STRUCTURE_FIELD}.make ("bold"),
					create {CE_STRUCTURE_FIELD}.make ("italic"),
					create {CE_STRUCTURE_FIELD}.make ("underline"),
					create {CE_STRUCTURE_FIELD}.make ("undercurl")
				>>)
			init_structure_info
		end

end
