class
	PD_REGMMATCH_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_REGPROG_T]} regprog.make
			create {CE_CLASS_ARRAY [PD_LPOS_T]} startpos.make (<<10>>)
			create {CE_CLASS_ARRAY [PD_LPOS_T]} endpos.make (<<10>>)
		end

feature {ANY} -- fields

	regprog: CE_POINTER [PD_REGPROG_T] assign set_regprog

	startpos: CE_ARRAY [PD_LPOS_T]

	endpos: CE_ARRAY [PD_LPOS_T]

	rmm_ic: INTEGER_32 assign set_rmm_ic

	rmm_maxcol: INTEGER_32 assign set_rmm_maxcol

feature {ANY} -- field setters

	set_regprog (a_regprog: CE_POINTER [PD_REGPROG_T])
		do
			regprog := a_regprog
			update_memory_field ("regprog")
		end

	set_rmm_ic (a_rmm_ic: INTEGER_32)
		do
			rmm_ic := a_rmm_ic
			update_memory_field ("rmm_ic")
		end

	set_rmm_maxcol (a_rmm_maxcol: INTEGER_32)
		do
			rmm_maxcol := a_rmm_maxcol
			update_memory_field ("rmm_maxcol")
		end

feature {ANY} -- public routines

	vim_regexec_multi (a_win: CE_POINTER [PD_WINDOW_S]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_lnum: INTEGER_32; a_col: INTEGER_32; a_tm: CE_POINTER [SD_TIMEVAL]): INTEGER_32
		local
			l_r: INTEGER_32
			l_save_curbuf: CE_POINTER [PD_FILE_BUFFER]
		do
			l_save_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item;
			(create {P_REGEXP_STATIC}).reg_match.item := create {CE_CLASS_POINTER [PD_REGMATCH_T]}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_mmatch.item := (create {CE_CLASS_POINTER [PD_REGMMATCH_T]}.make_shared (c_pointer))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_buf.item := a_buf___6
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_win.item := a_win
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_firstlnum.item := a_lnum
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_maxline.item := (create {P_REGEXP_STATIC}).reg_buf.item.item.b_ml.ml_line_count - a_lnum
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).reg_line_lbr.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_ic.item := rmm_ic
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_icombine.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_REGEXP_STATIC}).ireg_maxcol.item := rmm_maxcol
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).curbuf.item := a_buf___6
			update_class_fields -- Current might have been changed; synchronize
			l_r := (create {P_REGEXP_STATIC}).vim_regexec_both (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), a_col, a_tm)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).curbuf.item := l_save_curbuf
			update_class_fields -- Current might have been changed; synchronize
			Result := l_r
		end

	first_submatch: INTEGER_32
		local
			l_submatch: INTEGER_32
			l_break: BOOLEAN
		do
			l_submatch := 1
			from
			until
				not (not (l_break) and then (not (startpos[l_submatch].lnum >= 0)))
			loop
				l_break := False
				if l_submatch = 9 then
					l_submatch := 0
					l_break := True
				end
				if not (l_break) then
					l_submatch := l_submatch + 1
				end
			end
			l_break := False
			Result := l_submatch
		end

	syn_regexec (a_lnum: INTEGER_32; a_col: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			Current.rmm_maxcol := ((create {P_SYNTAX_STATIC}).syn_buf.item.item.b_p_smc).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := ((create {CE_CLASS_POINTER [PD_REGMMATCH_T]}.make_shared (c_pointer))).item.vim_regexec_multi ((create {P_SYNTAX_STATIC}).syn_win.item, (create {P_SYNTAX_STATIC}).syn_buf.item, a_lnum, a_col, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp > 0 then
				startpos[0].lnum := startpos[0].lnum + a_lnum
				update_class_fields -- Current might have been changed; synchronize
				endpos[0].lnum := endpos[0].lnum + a_lnum
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			regprog := a_other.regprog
			startpos := a_other.startpos.twin
			endpos := a_other.endpos.twin
			rmm_ic := a_other.rmm_ic
			rmm_maxcol := a_other.rmm_maxcol
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				regprog.is_equal (a_other.regprog) and
				startpos.is_equal (a_other.startpos) and
				endpos.is_equal (a_other.endpos) and
				rmm_ic = a_other.rmm_ic and
				rmm_maxcol = a_other.rmm_maxcol
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("regprog"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("startpos", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("endpos", <<10>>),
					create {CE_STRUCTURE_FIELD}.make ("rmm_ic"),
					create {CE_STRUCTURE_FIELD}.make ("rmm_maxcol")
				>>)
			init_structure_info
		end

end
