class
	PD_REGPROG_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} regmust.make
			create {CE_NATURAL_8_ARRAY} program.make (<<1>>)
			Precursor
		end

feature {ANY} -- fields

	regstart: INTEGER_32 assign set_regstart

	reganch: NATURAL_8 assign set_reganch

	regmust: CE_POINTER [NATURAL_8] assign set_regmust

	regmlen: INTEGER_32 assign set_regmlen

	regflags: NATURAL_32 assign set_regflags

	reghasz: NATURAL_8 assign set_reghasz

	program: CE_ARRAY [NATURAL_8]

feature {ANY} -- field setters

	set_regstart (a_regstart: INTEGER_32)
		do
			regstart := a_regstart
			update_memory_field ("regstart")
		end

	set_reganch (a_reganch: NATURAL_8)
		do
			reganch := a_reganch
			update_memory_field ("reganch")
		end

	set_regmust (a_regmust: CE_POINTER [NATURAL_8])
		do
			regmust := a_regmust
			update_memory_field ("regmust")
		end

	set_regmlen (a_regmlen: INTEGER_32)
		do
			regmlen := a_regmlen
			update_memory_field ("regmlen")
		end

	set_regflags (a_regflags: NATURAL_32)
		do
			regflags := a_regflags
			update_memory_field ("regflags")
		end

	set_reghasz (a_reghasz: NATURAL_8)
		do
			reghasz := a_reghasz
			update_memory_field ("reghasz")
		end

feature {PD_REGPROG_T} -- private attributes

	reg_startzp: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make (<<10>>)
		end

	reg_endzp: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make (<<10>>)
		end

	reg_startzpos: CE_STATIC [CE_ARRAY [PD_LPOS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LPOS_T]}.make (<<10>>)
		end

	reg_endzpos: CE_STATIC [CE_ARRAY [PD_LPOS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LPOS_T]}.make (<<10>>)
		end

	need_clear_zsubexpr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	brace_min: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<10>>)
		end

	brace_max: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<10>>)
		end

	brace_count: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<10>>)
		end

	behind_pos: CE_STATIC [CE_ARRAY [PD_REGSAVE_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_REGSAVE_T]}.make (<<1>>)
		end

	bl_minval: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	bl_maxval: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	e_maxmempat: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('E').code).to_natural_8, (('3').code).to_natural_8, (('6').code).to_natural_8, (('3').code).to_natural_8,
					((':').code).to_natural_8, ((' ').code).to_natural_8, (('p').code).to_natural_8, (('a').code).to_natural_8,
					(('t').code).to_natural_8, (('t').code).to_natural_8, (('e').code).to_natural_8, (('r').code).to_natural_8,
					(('n').code).to_natural_8, ((' ').code).to_natural_8, (('u').code).to_natural_8, (('s').code).to_natural_8,
					(('e').code).to_natural_8, (('s').code).to_natural_8, ((' ').code).to_natural_8, (('m').code).to_natural_8,
					(('o').code).to_natural_8, (('r').code).to_natural_8, (('e').code).to_natural_8, ((' ').code).to_natural_8,
					(('m').code).to_natural_8, (('e').code).to_natural_8, (('m').code).to_natural_8, (('o').code).to_natural_8,
					(('r').code).to_natural_8, (('y').code).to_natural_8, ((' ').code).to_natural_8, (('t').code).to_natural_8,
					(('h').code).to_natural_8, (('a').code).to_natural_8, (('n').code).to_natural_8, ((' ').code).to_natural_8,
					(('%'').code).to_natural_8, (('m').code).to_natural_8, (('a').code).to_natural_8, (('x').code).to_natural_8,
					(('m').code).to_natural_8, (('e').code).to_natural_8, (('m').code).to_natural_8, (('p').code).to_natural_8,
					(('a').code).to_natural_8, (('t').code).to_natural_8, (('t').code).to_natural_8, (('e').code).to_natural_8,
					(('r').code).to_natural_8, (('n').code).to_natural_8, (('%'').code).to_natural_8, (('%/0/').code).to_natural_8
				>>)
		end

	need_clear_subexpr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	reginput: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

feature {ANY} -- public routines

	re_multiline: INTEGER_32
		do
			Result := ((regflags).bit_and ({NATURAL_32} 4)).to_integer_32
		end

	regtry (a_col: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			reginput.item := (create {P_REGEXP_STATIC}).regline.item + a_col
			need_clear_subexpr.item := 1
			if reghasz.to_integer_32 = 1 then
				need_clear_zsubexpr.item := 1
			end
			l_tmp := regmatch (program + 1)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				cleanup_subexpr
				update_class_fields -- Current might have been changed; synchronize
				if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
					if ((create {P_REGEXP_STATIC}).reg_startpos.item + 0).item.lnum < 0 then
						((create {P_REGEXP_STATIC}).reg_startpos.item + 0).item.lnum := (0).to_integer_32
						update_class_fields; -- Current might have been changed; synchronize
						((create {P_REGEXP_STATIC}).reg_startpos.item + 0).item.col := a_col
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((create {P_REGEXP_STATIC}).reg_endpos.item + 0).item.lnum < 0 then
						((create {P_REGEXP_STATIC}).reg_endpos.item + 0).item.lnum := (create {P_REGEXP_STATIC}).reglnum.item
						update_class_fields; -- Current might have been changed; synchronize
						((create {P_REGEXP_STATIC}).reg_endpos.item + 0).item.col := reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item))
						update_class_fields -- Current might have been changed; synchronize
					else
						(create {P_REGEXP_STATIC}).reglnum.item := ((create {P_REGEXP_STATIC}).reg_endpos.item + 0).item.lnum
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					if ((create {P_REGEXP_STATIC}).reg_startp.item[0]).is_void then
						(create {P_REGEXP_STATIC}).reg_startp.item[0] := (create {P_REGEXP_STATIC}).regline.item + a_col
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((create {P_REGEXP_STATIC}).reg_endp.item[0]).is_void then
						(create {P_REGEXP_STATIC}).reg_endp.item[0] := reginput.item
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				(create {P_REGEXP_STATIC}).unref_extmatch ((create {P_GLOBALS_STATIC}).re_extmatch_out.item)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).re_extmatch_out.item := create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				if reghasz.to_integer_32 = 1 then
					cleanup_zsubexpr
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).re_extmatch_out.item := make_extmatch
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := 0
					from
					until
						not (l_i___0 < 10)
					loop
						if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
							if reg_startzpos.item[l_i___0].lnum >= 0 then
								if reg_endzpos.item[l_i___0].lnum = reg_startzpos.item[l_i___0].lnum then
									l_tmp___0 := (create {P_REGEXP_STATIC}).reg_getline (reg_startzpos.item[l_i___0].lnum)
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_GLOBALS_STATIC}).re_extmatch_out.item.item.matches[l_i___0] := (create {P_MISC2_STATIC}).vim_strnsave (l_tmp___0 + reg_startzpos.item[l_i___0].col, reg_endzpos.item[l_i___0].col - reg_startzpos.item[l_i___0].col)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						elseif not (reg_startzp.item[l_i___0]).is_void then
							if not (reg_endzp.item[l_i___0]).is_void then
								(create {P_GLOBALS_STATIC}).re_extmatch_out.item.item.matches[l_i___0] := (create {P_MISC2_STATIC}).vim_strnsave (reg_startzp.item[l_i___0], (reg_endzp.item[l_i___0]).distance ((reg_startzp.item[l_i___0])))
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_i___0 := l_i___0 + 1
					end
				end
				Result := (1 + (create {P_REGEXP_STATIC}).reglnum.item)
			end
		end

feature {PD_REGPROG_T} -- private routines

	cleanup_subexpr
		do
			if need_clear_subexpr.item.to_boolean then
				if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
					memset (create {CE_VOID_POINTER}.make_cast ((create {P_REGEXP_STATIC}).reg_startpos.item), 255, (create {PD_LPOS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 10).do_nothing
					memset (create {CE_VOID_POINTER}.make_cast ((create {P_REGEXP_STATIC}).reg_endpos.item), 255, (create {PD_LPOS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 10).do_nothing
				else
					memset (create {CE_VOID_POINTER}.make_cast ((create {P_REGEXP_STATIC}).reg_startp.item), 0, {PLATFORM}.Pointer_bytes.to_natural_32 * {NATURAL_32} 10).do_nothing
					memset (create {CE_VOID_POINTER}.make_cast ((create {P_REGEXP_STATIC}).reg_endp.item), 0, {PLATFORM}.Pointer_bytes.to_natural_32 * {NATURAL_32} 10).do_nothing
				end
				need_clear_subexpr.item := 0
			end
		end

	make_extmatch: CE_POINTER [PD_REG_EXTMATCH_T]
		local
			l_em: CE_POINTER [PD_REG_EXTMATCH_T]
		do
			l_em := create {CE_CLASS_POINTER [PD_REG_EXTMATCH_T]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((create {PD_REG_EXTMATCH_T}.make).structure_size.to_natural_32)))
			if not l_em.is_void then
				l_em.item.refcnt := (1).to_integer_16
			end
			Result := l_em
		end

	regmatch (a_scan: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_scan: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_next: CE_POINTER [NATURAL_8]
			l_op: INTEGER_32
			l_c: INTEGER_32
			l_rp: CE_POINTER [PD_REGITEM_S]
			l_no: INTEGER_32
			l_status: INTEGER_32
			l_tmp___0: INTEGER_32
			l_mark: INTEGER_32
			l_cmp: INTEGER_32
			l_pos___3: CE_POINTER [PD_POS_T]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_top: CE_ARRAY [PD_POS_T]
			l_bot: CE_ARRAY [PD_POS_T]
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp___6: CE_POINTER [PD_WINDOW_S]
			l_mode: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_start___1: CE_ARRAY [INTEGER_32]
			l_end: CE_ARRAY [INTEGER_32]
			l_start2: CE_ARRAY [INTEGER_32]
			l_end2: CE_ARRAY [INTEGER_32]
			l_cols: INTEGER_32
			l_tmp___13: CE_POINTER [PD_WINDOW_S]
			l_this_class: INTEGER_32
			l_this_class___0: INTEGER_32
			l_prev_class: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___30: INTEGER_32
			l_tmp___33: INTEGER_32
			l_tmp___36: INTEGER_32
			l_tmp___39: INTEGER_32
			l_tmp___42: INTEGER_32
			l_tmp___45: INTEGER_32
			l_tmp___48: INTEGER_32
			l_tmp___50: INTEGER_32
			l_tmp___52: INTEGER_32
			l_tmp___54: INTEGER_32
			l_tmp___56: INTEGER_32
			l_tmp___58: INTEGER_32
			l_tmp___60: INTEGER_32
			l_tmp___62: INTEGER_32
			l_tmp___64: INTEGER_32
			l_tmp___66: INTEGER_32
			l_tmp___68: INTEGER_32
			l_tmp___70: INTEGER_32
			l_tmp___72: INTEGER_32
			l_tmp___74: INTEGER_32
			l_tmp___76: INTEGER_32
			l_tmp___78: INTEGER_32
			l_tmp___80: INTEGER_32
			l_tmp___82: INTEGER_32
			l_len: CE_ARRAY [INTEGER_32]
			l_opnd: CE_POINTER [NATURAL_8]
			l_tmp___87: INTEGER_32
			l_tmp___90: INTEGER_32
			l_i___0: INTEGER_32
			l_len___0: INTEGER_32
			l_opnd___0: CE_POINTER [NATURAL_8]
			l_opndc: INTEGER_32
			l_inpc: INTEGER_32
			l_i___1: INTEGER_32
			l_bp___0: CE_POINTER [PD_BACKPOS_S]
			l_len___1: CE_ARRAY [INTEGER_32]
			l_clnum: INTEGER_32
			l_ccol: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len___2: CE_ARRAY [INTEGER_32]
			l_tmp___106: CE_POINTER [INTEGER_8]
			l_tmp___107: INTEGER_32
			l_rst: PD_REGSTAR_S
			l_tmp___111: INTEGER_32
			l_tmp___113: INTEGER_32
			l_tmp___117: INTEGER_32
			l_tmp___119: INTEGER_32
			l_rst___0: CE_POINTER [PD_REGSTAR_S]
			l_tmp___125: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_scan.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_top.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_bot.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_start___1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_end.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_start2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_end2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_len___1.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_len___2.make (<<1>>)
			create l_rst.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_scan.item := a_scan;
					(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := 0;
					(create {P_REGEXP_STATIC}).backpos.item.item.ga_len := 0
				when 1 then -- loop condition:
					if (l_return) then
						l_pos := -1 + 259 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False;
						(create {P_MISC1_STATIC}).fast_breakcheck
				when 3 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 228 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_status := 1
							l_break := True
						elseif (l_scan.item).is_void then
							l_status := 1
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 227 -- skip if block
						end
				when 5 then -- if:
						l_status := 2
						l_next := (create {P_REGEXP_STATIC}).regnext (l_scan.item)
						l_op := (l_scan.item.item).to_integer_32
						if ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_op >= 50 then
							if l_op <= 78 then
								if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
									if (reginput.item.item).to_integer_32 = 0 then
										if (create {P_REGEXP_STATIC}).reglnum.item <= (create {P_REGEXP_STATIC}).reg_maxline.item then
											reg_nextline
										else
											l_pos := -1 + 8 -- goto _L___25
										end
									else
										l_pos := -1 + 8 -- goto _L___25
									end
								else
									l_pos := -1 + 8 -- goto _L___25
								end
							else
								l_pos := -1 + 8 -- goto _L___25
							end
						else
							l_pos := -1 + 8 -- goto _L___25
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 226
				when 8 then -- else: | _L___25:
						if not (((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if l_op >= 50 then
							if l_op <= 78 then
								if (reginput.item.item).to_integer_32 = 10 then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
									else
										l_tmp___0 := 1
									end
									reginput.item := reginput.item + l_tmp___0
								else
									l_pos := -1 + 11 -- goto _L___21
								end
							else
								l_pos := -1 + 11 -- goto _L___21
							end
						else
							l_pos := -1 + 11 -- goto _L___21
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 226
				when 11 then -- else: | _L___21:
						if l_op >= 50 then
							if l_op <= 78 then
								l_op := l_op - (30)
							end
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([reginput.item])
						else
							l_c := (reginput.item.item).to_integer_32
						end
						inspect l_op -- switch 1 head
						when 1 then l_pos := -1 + 12
						when 2 then l_pos := -1 + 13
						when 201 then l_pos := -1 + 14
						when 202 then l_pos := -1 + 15
						when 203 then l_pos := -1 + 16
						when 207 then l_pos := -1 + 17
						when 208 then l_pos := -1 + 18
						when 204 then l_pos := -1 + 38
						when 205 then l_pos := -1 + 39
						when 206 then l_pos := -1 + 40
						when 15 then l_pos := -1 + 41
						when 16 then l_pos := -1 + 42
						when 20 then l_pos := -1 + 43
						when 23 then l_pos := -1 + 44
						when 24 then l_pos := -1 + 45
						when 25 then l_pos := -1 + 50
						when 26 then l_pos := -1 + 51
						when 27 then l_pos := -1 + 56
						when 28 then l_pos := -1 + 57
						when 29 then l_pos := -1 + 62
						when 30 then l_pos := -1 + 63
						when 31 then l_pos := -1 + 68
						when 32 then l_pos := -1 + 76
						when 33 then l_pos := -1 + 77
						when 34 then l_pos := -1 + 78
						when 35 then l_pos := -1 + 86
						when 36 then l_pos := -1 + 87
						when 37 then l_pos := -1 + 95
						when 38 then l_pos := -1 + 96
						when 39 then l_pos := -1 + 104
						when 40 then l_pos := -1 + 105
						when 41 then l_pos := -1 + 113
						when 42 then l_pos := -1 + 114
						when 43 then l_pos := -1 + 122
						when 44 then l_pos := -1 + 123
						when 45 then l_pos := -1 + 131
						when 46 then l_pos := -1 + 132
						when 47 then l_pos := -1 + 140
						when 48 then l_pos := -1 + 141
						when 5 then l_pos := -1 + 149
						when 21 then l_pos := -1 + 158
						when 22 then l_pos := -1 + 158
						when 200 then l_pos := -1 + 159
						when 6 then l_pos := -1 + 169
						when 4 then l_pos := -1 + 170
						when 80 then l_pos := -1 + 171
						when 81 then l_pos := -1 + 171
						when 82 then l_pos := -1 + 171
						when 83 then l_pos := -1 + 171
						when 84 then l_pos := -1 + 171
						when 85 then l_pos := -1 + 171
						when 86 then l_pos := -1 + 171
						when 87 then l_pos := -1 + 171
						when 88 then l_pos := -1 + 171
						when 89 then l_pos := -1 + 171
						when 150 then l_pos := -1 + 172
						when 151 then l_pos := -1 + 172
						when 111 then l_pos := -1 + 173
						when 112 then l_pos := -1 + 173
						when 113 then l_pos := -1 + 173
						when 114 then l_pos := -1 + 173
						when 115 then l_pos := -1 + 173
						when 116 then l_pos := -1 + 173
						when 117 then l_pos := -1 + 173
						when 118 then l_pos := -1 + 173
						when 119 then l_pos := -1 + 173
						when 90 then l_pos := -1 + 174
						when 91 then l_pos := -1 + 174
						when 92 then l_pos := -1 + 174
						when 93 then l_pos := -1 + 174
						when 94 then l_pos := -1 + 174
						when 95 then l_pos := -1 + 174
						when 96 then l_pos := -1 + 174
						when 97 then l_pos := -1 + 174
						when 98 then l_pos := -1 + 174
						when 99 then l_pos := -1 + 174
						when 121 then l_pos := -1 + 175
						when 122 then l_pos := -1 + 175
						when 123 then l_pos := -1 + 175
						when 124 then l_pos := -1 + 175
						when 125 then l_pos := -1 + 175
						when 126 then l_pos := -1 + 175
						when 127 then l_pos := -1 + 175
						when 128 then l_pos := -1 + 175
						when 129 then l_pos := -1 + 175
						when 101 then l_pos := -1 + 176
						when 102 then l_pos := -1 + 176
						when 103 then l_pos := -1 + 176
						when 104 then l_pos := -1 + 176
						when 105 then l_pos := -1 + 176
						when 106 then l_pos := -1 + 176
						when 107 then l_pos := -1 + 176
						when 108 then l_pos := -1 + 176
						when 109 then l_pos := -1 + 176
						when 131 then l_pos := -1 + 200
						when 132 then l_pos := -1 + 200
						when 133 then l_pos := -1 + 200
						when 134 then l_pos := -1 + 200
						when 135 then l_pos := -1 + 200
						when 136 then l_pos := -1 + 200
						when 137 then l_pos := -1 + 200
						when 138 then l_pos := -1 + 200
						when 139 then l_pos := -1 + 200
						when 3 then l_pos := -1 + 201
						when 17 then l_pos := -1 + 202
						when 140 then l_pos := -1 + 203
						when 141 then l_pos := -1 + 203
						when 142 then l_pos := -1 + 203
						when 143 then l_pos := -1 + 203
						when 144 then l_pos := -1 + 203
						when 145 then l_pos := -1 + 203
						when 146 then l_pos := -1 + 203
						when 147 then l_pos := -1 + 203
						when 148 then l_pos := -1 + 203
						when 149 then l_pos := -1 + 203
						when 14 then l_pos := -1 + 205
						when 7 then l_pos := -1 + 205
						when 8 then l_pos := -1 + 205
						when 10 then l_pos := -1 + 207
						when 9 then l_pos := -1 + 207
						when 13 then l_pos := -1 + 207
						when 11 then l_pos := -1 + 208
						when 12 then l_pos := -1 + 208
						when 19 then l_pos := -1 + 209
						when 18 then l_pos := -1 + 210
						when 0 then l_pos := -1 + 224
						else l_pos := -1 + 225
						end
				when 12 then -- switch 1, case 1
						if not reginput.item.is_equal ((create {P_REGEXP_STATIC}).regline.item) then
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 13 then -- switch 1, case 2
						if l_c /= 0 then
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 14 then -- switch 1, case 201
						if (create {P_REGEXP_STATIC}).reglnum.item /= 0 then
							l_status := 5
						elseif not reginput.item.is_equal ((create {P_REGEXP_STATIC}).regline.item) then
							l_status := 5
						elseif ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
							if (create {P_REGEXP_STATIC}).reg_firstlnum.item > 1 then
								l_status := 5
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 15 then -- switch 1, case 202
						if (create {P_REGEXP_STATIC}).reglnum.item /= (create {P_REGEXP_STATIC}).reg_maxline.item then
							l_status := 5
						elseif l_c /= 0 then
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 16 then -- switch 1, case 203
						if ((create {P_REGEXP_STATIC}).reg_win.item).is_void then
							l_status := 5
						elseif (create {P_REGEXP_STATIC}).reglnum.item + (create {P_REGEXP_STATIC}).reg_firstlnum.item /= (create {P_REGEXP_STATIC}).reg_win.item.item.w_cursor.lnum then
							l_status := 5
						elseif reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item)) /= (create {P_REGEXP_STATIC}).reg_win.item.item.w_cursor.col then
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 17 then -- switch 1, case 207
						l_mark := ((l_scan.item + 3)[0]).to_integer_32
						l_cmp := ((l_scan.item + 3)[1]).to_integer_32
						l_pos___3 := (create {P_MARK_STATIC}).getmark (l_mark, 0)
						if l_pos___3.is_void then
							l_status := 5
						elseif l_pos___3.item.lnum <= 0 then
							l_status := 5
						else
							if l_pos___3.item.lnum = (create {P_REGEXP_STATIC}).reglnum.item + (create {P_REGEXP_STATIC}).reg_firstlnum.item then
								if l_pos___3.item.col = reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item)) then
									if l_cmp = 60 then
										l_tmp___1 := 1
									elseif l_cmp = 62 then
										l_tmp___1 := 1
									else
										l_tmp___1 := 0
									end
									l_tmp___3 := l_tmp___1
								else
									if l_pos___3.item.col < reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item)) then
										l_tmp___2 := (l_cmp /= 62).to_integer
									else
										l_tmp___2 := (l_cmp /= 60).to_integer
									end
									l_tmp___3 := l_tmp___2
								end
								l_tmp___5 := l_tmp___3
							else
								if l_pos___3.item.lnum < (create {P_REGEXP_STATIC}).reglnum.item + (create {P_REGEXP_STATIC}).reg_firstlnum.item then
									l_tmp___4 := (l_cmp /= 62).to_integer
								else
									l_tmp___4 := (l_cmp /= 60).to_integer
								end
								l_tmp___5 := l_tmp___4
							end
							if l_tmp___5.to_boolean then
								l_status := 5
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 18 then -- switch 1, case 208
						if ((create {P_REGEXP_STATIC}).reg_buf.item).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_status := 5
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 21 then -- else:
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_status := 5
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 24 then -- else:
						if ((create {P_REGEXP_STATIC}).reg_win.item).is_void then
							l_tmp___6 := (create {P_GLOBALS_STATIC}).curwin.item
						else
							l_tmp___6 := (create {P_REGEXP_STATIC}).reg_win.item
						end
						l_wp___0 := l_tmp___6
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= l_wp___0.item.w_cursor.lnum then
								l_tmp___8 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < l_wp___0.item.w_cursor.lnum).to_integer
							else
								if (create {P_GLOBALS_STATIC}).VIsual.item.item.col /= l_wp___0.item.w_cursor.col then
									l_tmp___7 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col < l_wp___0.item.w_cursor.col).to_integer
								else
									l_tmp___7 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.coladd < l_wp___0.item.w_cursor.coladd).to_integer
								end
								l_tmp___8 := l_tmp___7
							end
							if l_tmp___8.to_boolean then
								l_top.item := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin
								l_bot.item := (l_wp___0.item.w_cursor).twin
							else
								l_top.item := (l_wp___0.item.w_cursor).twin
								l_bot.item := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin
							end
							l_mode := (create {P_GLOBALS_STATIC}).VIsual_mode.item
						else
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_start.lnum /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end.lnum then
								l_tmp___10 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_start.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end.lnum).to_integer
							else
								if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_start.col /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end.col then
									l_tmp___9 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_start.col < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end.col).to_integer
								else
									l_tmp___9 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_start.coladd < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end.coladd).to_integer
								end
								l_tmp___10 := l_tmp___9
							end
							if l_tmp___10.to_boolean then
								l_top.item := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_start).twin
								l_bot.item := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end).twin
							else
								l_top.item := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end).twin
								l_bot.item := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_start).twin
							end
							l_mode := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_mode
						end
						l_lnum := (create {P_REGEXP_STATIC}).reglnum.item + (create {P_REGEXP_STATIC}).reg_firstlnum.item
						l_col := reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item))
						if not (l_lnum < l_top.item.lnum) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_status := 5
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 27 then -- else:
						if not (l_lnum > l_bot.item.lnum) then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if:
						l_status := 5
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 30 then -- else:
						if l_mode /= 118 then
							l_pos := -1 + 36 -- skip if block
						end
				when 31 then -- if:
						if l_lnum /= l_top.item.lnum then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if l_col < l_top.item.col then
							l_status := 5
						else
							l_pos := -1 + 34 -- goto _L
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else: | _L:
						if l_lnum = l_bot.item.lnum then
							if l_col >= l_bot.item.col + (((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 /= 101).to_integer then
								l_status := 5
							end
						end
				when 35 then -- if done | if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						if l_mode = 22 then
							l_wp___0.item.getvvcol (l_top, l_start___1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_end)
							l_wp___0.item.getvvcol (l_bot, l_start2, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_end2)
							if l_start2.item < l_start___1.item then
								l_start___1.item := l_start2.item
							end
							if l_end2.item > l_end.item then
								l_end.item := l_end2.item
							end
							if (l_top.item.col).to_integer_32 = 2_147_483_647 then
								l_end.item := (2_147_483_647).to_integer_32
							elseif (l_bot.item.col).to_integer_32 = 2_147_483_647 then
								l_end.item := (2_147_483_647).to_integer_32
							end
							l_cols := (create {P_CHARSET_STATIC}).win_linetabsize (l_wp___0, (create {P_REGEXP_STATIC}).regline.item, reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item)))
							if l_cols < l_start___1.item then
								l_status := 5
							elseif l_cols > l_end.item - (((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101).to_integer then
								l_status := 5
							end
						end
				when 37 then -- if done | if done | if done | if done
						l_pos := -1 + 226 -- switch 1; break
				when 38 then -- switch 1, case 204
						if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
							l_status := 5
						elseif not (re_num_cmp (((create {P_REGEXP_STATIC}).reglnum.item + (create {P_REGEXP_STATIC}).reg_firstlnum.item).to_natural_32, l_scan.item)).to_boolean then
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 39 then -- switch 1, case 205
						if not (re_num_cmp ((reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item))).to_natural_32 + {NATURAL_32} 1, l_scan.item)).to_boolean then
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 40 then -- switch 1, case 206
						if ((create {P_REGEXP_STATIC}).reg_win.item).is_void then
							l_tmp___13 := (create {P_GLOBALS_STATIC}).curwin.item
						else
							l_tmp___13 := (create {P_REGEXP_STATIC}).reg_win.item
						end
						if not (re_num_cmp (((create {P_CHARSET_STATIC}).win_linetabsize (l_tmp___13, (create {P_REGEXP_STATIC}).regline.item, reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item)))).to_natural_32 + {NATURAL_32} 1, l_scan.item)).to_boolean then
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 41 then -- switch 1, case 15
						if l_c = 0 then
							l_status := 5
						elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_this_class := (create {P_MBYTE_STATIC}).mb_get_class (reginput.item)
							if l_this_class <= 1 then
								l_status := 5
							elseif (reg_prev_class) = l_this_class then
								l_status := 5
							end
						elseif ((create {P_CHARSET_STATIC}).vim_iswordc (l_c)).to_boolean then
							if (reginput.item.c_pointer.to_integer_32).to_natural_32 > (((create {P_REGEXP_STATIC}).regline.item).c_pointer.to_integer_32).to_natural_32 then
								if ((create {P_CHARSET_STATIC}).vim_iswordc ((reginput.item[-1]).to_integer_32)).to_boolean then
									l_status := 5
								end
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 42 then -- switch 1, case 16
						if reginput.item.is_equal ((create {P_REGEXP_STATIC}).regline.item) then
							l_status := 5
						elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_this_class___0 := (create {P_MBYTE_STATIC}).mb_get_class (reginput.item)
							l_prev_class := reg_prev_class
							if l_this_class___0 = l_prev_class then
								l_status := 5
							elseif l_prev_class = 0 then
								l_status := 5
							elseif l_prev_class = 1 then
								l_status := 5
							end
						elseif ((create {P_CHARSET_STATIC}).vim_iswordc ((reginput.item[-1]).to_integer_32)).to_boolean then
							if (reginput.item[0]).to_integer_32 /= 0 then
								if ((create {P_CHARSET_STATIC}).vim_iswordc (l_c)).to_boolean then
									l_status := 5
								end
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 43 then -- switch 1, case 20
						if l_c = 0 then
							l_status := 5
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___22 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___22 := 1
							end
							reginput.item := reginput.item + l_tmp___22
						end
						l_pos := -1 + 226 -- switch 1; break
				when 44 then -- switch 1, case 23
						if ((create {P_CHARSET_STATIC}).vim_isIDc (l_c)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___24 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___24 := 1
							end
							reginput.item := reginput.item + l_tmp___24
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 45 then -- switch 1, case 24
						if not ((reginput.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						if (reginput.item.item).to_integer_32 <= 57 then
							l_status := 5
						else
							l_pos := -1 + 48 -- goto _L___0
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else: | _L___0:
						if ((create {P_CHARSET_STATIC}).vim_isIDc (l_c)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___27 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___27 := 1
							end
							reginput.item := reginput.item + l_tmp___27
						else
							l_status := 5
						end
				when 49 then
						l_pos := -1 + 226 -- switch 1; break
				when 50 then -- switch 1, case 25
						if ((create {P_CHARSET_STATIC}).vim_iswordp (reginput.item)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___30 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___30 := 1
							end
							reginput.item := reginput.item + l_tmp___30
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 51 then -- switch 1, case 26
						if not ((reginput.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						if (reginput.item.item).to_integer_32 <= 57 then
							l_status := 5
						else
							l_pos := -1 + 54 -- goto _L___1
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 54 then -- else: | _L___1:
						if ((create {P_CHARSET_STATIC}).vim_iswordp (reginput.item)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___33 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___33 := 1
							end
							reginput.item := reginput.item + l_tmp___33
						else
							l_status := 5
						end
				when 55 then
						l_pos := -1 + 226 -- switch 1; break
				when 56 then -- switch 1, case 27
						if ((create {P_CHARSET_STATIC}).vim_isfilec (l_c)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___36 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___36 := 1
							end
							reginput.item := reginput.item + l_tmp___36
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 57 then -- switch 1, case 28
						if not ((reginput.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if (reginput.item.item).to_integer_32 <= 57 then
							l_status := 5
						else
							l_pos := -1 + 60 -- goto _L___2
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else: | _L___2:
						if ((create {P_CHARSET_STATIC}).vim_isfilec (l_c)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___39 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___39 := 1
							end
							reginput.item := reginput.item + l_tmp___39
						else
							l_status := 5
						end
				when 61 then
						l_pos := -1 + 226 -- switch 1; break
				when 62 then -- switch 1, case 29
						if ((create {P_CHARSET_STATIC}).ptr2cells (reginput.item)) /= 1 then
							l_status := 5
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___42 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___42 := 1
							end
							reginput.item := reginput.item + l_tmp___42
						end
						l_pos := -1 + 226 -- switch 1; break
				when 63 then -- switch 1, case 30
						if not ((reginput.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if (reginput.item.item).to_integer_32 <= 57 then
							l_status := 5
						else
							l_pos := -1 + 66 -- goto _L___3
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else: | _L___3:
						if ((create {P_CHARSET_STATIC}).ptr2cells (reginput.item)) /= 1 then
							l_status := 5
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___45 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___45 := 1
							end
							reginput.item := reginput.item + l_tmp___45
						end
				when 67 then
						l_pos := -1 + 226 -- switch 1; break
				when 68 then -- switch 1, case 31
						if l_c /= 32 then
							l_pos := -1 + 71 -- skip if block
						end
				when 69 then -- if:
						l_pos := -1 + 72 -- goto _L___4
				when 70 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 71 then -- else:
						if l_c /= 9 then
							l_pos := -1 + 74 -- skip if block
						end
				when 72 then -- if: | _L___4:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___48 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___48 := 1
						end
						reginput.item := reginput.item + l_tmp___48
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 74 then -- else:
						l_status := 5
				when 75 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 76 then -- switch 1, case 32
						if l_c = 0 then
							l_status := 5
						elseif l_c = 32 then
							l_status := 5
						elseif l_c = 9 then
							l_status := 5
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___50 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___50 := 1
							end
							reginput.item := reginput.item + l_tmp___50
						end
						l_pos := -1 + 226 -- switch 1; break
				when 77 then -- switch 1, case 33
						if l_c < 256 then
							if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (1)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___52 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___52 := 1
								end
								reginput.item := reginput.item + l_tmp___52
							else
								l_status := 5
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 78 then -- switch 1, case 34
						if l_c /= 0 then
							l_pos := -1 + 81 -- skip if block
						end
				when 79 then -- if:
						l_status := 5
				when 80 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 81 then -- else:
						if not (l_c < 256) then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (1)).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 84 -- goto _L___5
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else: | _L___5:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___54 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___54 := 1
						end
						reginput.item := reginput.item + l_tmp___54
				when 85 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 86 then -- switch 1, case 35
						if l_c < 256 then
							if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (2)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___56 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___56 := 1
								end
								reginput.item := reginput.item + l_tmp___56
							else
								l_status := 5
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 87 then -- switch 1, case 36
						if l_c /= 0 then
							l_pos := -1 + 90 -- skip if block
						end
				when 88 then -- if:
						l_status := 5
				when 89 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 90 then -- else:
						if not (l_c < 256) then
							l_pos := -1 + 93 -- skip if block
						end
				when 91 then -- if:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (2)).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 93 -- goto _L___6
						end
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 93 then -- else: | _L___6:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___58 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___58 := 1
						end
						reginput.item := reginput.item + l_tmp___58
				when 94 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 95 then -- switch 1, case 37
						if l_c < 256 then
							if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (4)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___60 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___60 := 1
								end
								reginput.item := reginput.item + l_tmp___60
							else
								l_status := 5
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 96 then -- switch 1, case 38
						if l_c /= 0 then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						l_status := 5
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 99 then -- else:
						if not (l_c < 256) then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (4)).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 102 -- goto _L___7
						end
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else: | _L___7:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___62 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___62 := 1
						end
						reginput.item := reginput.item + l_tmp___62
				when 103 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 104 then -- switch 1, case 39
						if l_c < 256 then
							if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (8)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___64 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___64 := 1
								end
								reginput.item := reginput.item + l_tmp___64
							else
								l_status := 5
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 105 then -- switch 1, case 40
						if l_c /= 0 then
							l_pos := -1 + 108 -- skip if block
						end
				when 106 then -- if:
						l_status := 5
				when 107 then -- if block done, skip else block:
						l_pos := -1 + 112
				when 108 then -- else:
						if not (l_c < 256) then
							l_pos := -1 + 111 -- skip if block
						end
				when 109 then -- if:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (8)).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 111 -- goto _L___8
						end
				when 110 then -- if block done, skip else block:
						l_pos := -1 + 112
				when 111 then -- else: | _L___8:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___66 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___66 := 1
						end
						reginput.item := reginput.item + l_tmp___66
				when 112 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 113 then -- switch 1, case 41
						if l_c < 256 then
							if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (16)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___68 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___68 := 1
								end
								reginput.item := reginput.item + l_tmp___68
							else
								l_status := 5
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 114 then -- switch 1, case 42
						if l_c /= 0 then
							l_pos := -1 + 117 -- skip if block
						end
				when 115 then -- if:
						l_status := 5
				when 116 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 117 then -- else:
						if not (l_c < 256) then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (16)).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 120 -- goto _L___9
						end
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 120 then -- else: | _L___9:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___70 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___70 := 1
						end
						reginput.item := reginput.item + l_tmp___70
				when 121 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 122 then -- switch 1, case 43
						if l_c < 256 then
							if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (32)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___72 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___72 := 1
								end
								reginput.item := reginput.item + l_tmp___72
							else
								l_status := 5
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 123 then -- switch 1, case 44
						if l_c /= 0 then
							l_pos := -1 + 126 -- skip if block
						end
				when 124 then -- if:
						l_status := 5
				when 125 then -- if block done, skip else block:
						l_pos := -1 + 130
				when 126 then -- else:
						if not (l_c < 256) then
							l_pos := -1 + 129 -- skip if block
						end
				when 127 then -- if:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (32)).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 129 -- goto _L___10
						end
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 130
				when 129 then -- else: | _L___10:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___74 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___74 := 1
						end
						reginput.item := reginput.item + l_tmp___74
				when 130 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 131 then -- switch 1, case 45
						if l_c < 256 then
							if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (64)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___76 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___76 := 1
								end
								reginput.item := reginput.item + l_tmp___76
							else
								l_status := 5
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 132 then -- switch 1, case 46
						if l_c /= 0 then
							l_pos := -1 + 135 -- skip if block
						end
				when 133 then -- if:
						l_status := 5
				when 134 then -- if block done, skip else block:
						l_pos := -1 + 139
				when 135 then -- else:
						if not (l_c < 256) then
							l_pos := -1 + 138 -- skip if block
						end
				when 136 then -- if:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (64)).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 138 -- goto _L___11
						end
				when 137 then -- if block done, skip else block:
						l_pos := -1 + 139
				when 138 then -- else: | _L___11:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___78 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___78 := 1
						end
						reginput.item := reginput.item + l_tmp___78
				when 139 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 140 then -- switch 1, case 47
						if l_c < 256 then
							if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (128)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___80 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___80 := 1
								end
								reginput.item := reginput.item + l_tmp___80
							else
								l_status := 5
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 141 then -- switch 1, case 48
						if l_c /= 0 then
							l_pos := -1 + 144 -- skip if block
						end
				when 142 then -- if:
						l_status := 5
				when 143 then -- if block done, skip else block:
						l_pos := -1 + 148
				when 144 then -- else:
						if not (l_c < 256) then
							l_pos := -1 + 147 -- skip if block
						end
				when 145 then -- if:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[l_c]).to_integer_32).bit_and (128)).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 147 -- goto _L___12
						end
				when 146 then -- if block done, skip else block:
						l_pos := -1 + 148
				when 147 then -- else: | _L___12:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___82 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
						else
							l_tmp___82 := 1
						end
						reginput.item := reginput.item + l_tmp___82
				when 148 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 149 then -- switch 1, case 5
						l_opnd := l_scan.item + 3
						if (l_opnd.item).to_integer_32 = (reginput.item.item).to_integer_32 then
							l_pos := -1 + 152 -- skip if block
						end
				when 150 then -- if:
						if not ((create {P_REGEXP_STATIC}).ireg_ic.item).to_boolean then
							l_status := 5
						elseif not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_tmp___87 := (create {P_CHARSET_STATIC}).vim_tolower ((l_opnd.item).to_integer_32)
							if l_tmp___87 /= ((create {P_CHARSET_STATIC}).vim_tolower ((reginput.item.item).to_integer_32)) then
								l_status := 5
							else
								l_pos := -1 + 152 -- goto _L___14
							end
						else
							l_pos := -1 + 152 -- goto _L___14
						end
				when 151 then -- if block done, skip else block:
						l_pos := -1 + 157
				when 152 then -- else: | _L___14:
						if ((l_opnd.item).to_integer_32 = 0) then
							l_pos := -1 + 157 -- skip if block
						end
				when 153 then -- if:
						if (l_opnd[1]).to_integer_32 /= 0 then
							l_pos := -1 + 156 -- skip if block
						end
				when 154 then -- if:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if ((create {P_REGEXP_STATIC}).ireg_ic.item).to_boolean then
								l_pos := -1 + 156 -- goto _L___13
							else
								reginput.item := reginput.item + 1
							end
						else
							reginput.item := reginput.item + 1
						end
				when 155 then -- if block done, skip else block:
						l_pos := -1 + 157
				when 156 then -- else: | _L___13:
						l_len.item := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_opnd))).to_integer_32
						if ((create {P_REGEXP_STATIC}).cstrncmp (l_opnd, reginput.item, l_len)) /= 0 then
							l_status := 5
						elseif ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (reginput.item + l_len.item)))).to_boolean then
								if not ((create {P_REGEXP_STATIC}).ireg_icombine.item).to_boolean then
									l_status := 5
								end
							else
								reginput.item := reginput.item + (l_len.item)
							end
						else
							reginput.item := reginput.item + (l_len.item)
						end
				when 157 then -- if done | if done
						l_pos := -1 + 226 -- switch 1; break
				when 158 then -- switch 1, case 21 | switch 1, case 22
						if l_c = 0 then
							l_status := 5
						elseif (((create {P_REGEXP_STATIC}).cstrchr (l_scan.item + 3, l_c)).is_void) = (l_op = 21) then
							l_status := 5
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___90 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___90 := 1
							end
							reginput.item := reginput.item + l_tmp___90
						end
						l_pos := -1 + 226 -- switch 1; break
				when 159 then -- switch 1, case 200
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 167 -- skip if block
						end
				when 160 then -- if:
						l_opndc := 0
						l_opnd___0 := l_scan.item + 3
						l_len___0 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_opnd___0])
						if l_len___0 < 2 then
							l_status := 5
							l_pos := -1 + 226 -- switch 1; break
						end
				when 161 then
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_opndc := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_opnd___0])
						end
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 164 -- skip if block
						end
				when 162 then -- if:
						if ((create {P_MBYTE_STATIC}).utf_iscomposing (l_opndc)).to_boolean then
							l_status := 5
							l_i___0 := 0
							from
							until
								not (not (l_break) and then ((reginput.item[l_i___0]).to_integer_32 /= 0))
							loop
								l_break := False
								l_inpc := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([reginput.item + l_i___0])
								if ((create {P_MBYTE_STATIC}).utf_iscomposing (l_inpc)).to_boolean then
									if l_opndc = l_inpc then
										l_len___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item + l_i___0]))
										l_status := 4
										l_break := True
									end
								elseif l_i___0 > 0 then
									l_break := True
								end
								if not (l_break) then
									l_i___0 := l_i___0 + ((create {P_MBYTE_STATIC}).utf_char2len (l_inpc))
								end
							end
							l_break := False
						else
							l_pos := -1 + 164 -- goto _L___15
						end
				when 163 then -- if block done, skip else block:
						l_pos := -1 + 165
				when 164 then -- else: | _L___15:
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < l_len___0))
						loop
							l_break := False
							if (l_opnd___0[l_i___0]).to_integer_32 /= (reginput.item[l_i___0]).to_integer_32 then
								l_status := 5
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
				when 165 then
						reginput.item := reginput.item + l_len___0
				when 166 then -- if block done, skip else block:
						l_pos := -1 + 168
				when 167 then -- else:
						l_status := 5
				when 168 then -- if done
						l_pos := -1 + 226 -- switch 1; break
				when 169 then -- switch 1, case 6
						l_pos := -1 + 226 -- switch 1; break
				when 170 then -- switch 1, case 4
						l_bp___0 := create {CE_CLASS_POINTER [PD_BACKPOS_S]}.make_cast ((create {P_REGEXP_STATIC}).backpos.item.item.ga_data)
						l_i___1 := 0
						from
						until
							not (not (l_break) and then (l_i___1 < (create {P_REGEXP_STATIC}).backpos.item.item.ga_len))
						loop
							l_break := False
							if ((l_bp___0 + l_i___1).item.bp_scan).is_equal (l_scan.item) then
								l_break := True
							end
							if not (l_break) then
								l_i___1 := l_i___1 + 1
							end
						end
						l_break := False
						if l_i___1 = (create {P_REGEXP_STATIC}).backpos.item.item.ga_len then
							if (((create {P_REGEXP_STATIC}).backpos.item).item.ga_grow (1)) = 0 then
								l_status := 1
							else
								l_bp___0 := create {CE_CLASS_POINTER [PD_BACKPOS_S]}.make_cast ((create {P_REGEXP_STATIC}).backpos.item.item.ga_data);
								(l_bp___0 + l_i___1).item.bp_scan := l_scan.item;
								(create {P_REGEXP_STATIC}).backpos.item.item.ga_len := ((create {P_REGEXP_STATIC}).backpos.item.item.ga_len) + 1
							end
						elseif (reg_save_equal (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared ((l_bp___0 + l_i___1).c_pointer + (create {PD_BACKPOS_S}.make).offset_of ("bp_pos")))).to_boolean then
							l_status := 5
						end
						if l_status /= 1 then
							if l_status /= 5 then
								reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared ((l_bp___0 + l_i___1).c_pointer + (create {PD_BACKPOS_S}.make).offset_of ("bp_pos")), (create {P_REGEXP_STATIC}).backpos.item)
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 171 then -- switch 1, case 80 | switch 1, case 81 | switch 1, case 82 | switch 1, case 83 | switch 1, case 84 | switch 1, case 85 | switch 1, case 86 | switch 1, case 87 | switch 1, case 88 | switch 1, case 89
						l_no := l_op - 80
						cleanup_subexpr
						l_rp := regstack_push ({PC_REGSTATE_E}.RS_MOPEN, l_scan.item)
						if l_rp.is_void then
							l_status := 1
						else
							l_rp.item.rs_no := l_no.to_integer_16
							if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
								save_se_multi (create {CE_CLASS_POINTER [PD_SAVE_SE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("sesave")), (create {P_REGEXP_STATIC}).reg_startpos.item + l_no)
							else
								save_se_one (create {CE_CLASS_POINTER [PD_SAVE_SE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("sesave")), (create {P_REGEXP_STATIC}).reg_startp.item + l_no)
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 172 then -- switch 1, case 150 | switch 1, case 151
						if (regstack_push ({PC_REGSTATE_E}.RS_NOPEN, l_scan.item)).is_void then
							l_status := 1
						end
						l_pos := -1 + 226 -- switch 1; break
				when 173 then -- switch 1, case 111 | switch 1, case 112 | switch 1, case 113 | switch 1, case 114 | switch 1, case 115 | switch 1, case 116 | switch 1, case 117 | switch 1, case 118 | switch 1, case 119
						l_no := l_op - 110
						cleanup_zsubexpr
						l_rp := regstack_push ({PC_REGSTATE_E}.RS_ZOPEN, l_scan.item)
						if l_rp.is_void then
							l_status := 1
						else
							l_rp.item.rs_no := l_no.to_integer_16
							if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
								save_se_multi (create {CE_CLASS_POINTER [PD_SAVE_SE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("sesave")), reg_startzpos.item + l_no)
							else
								save_se_one (create {CE_CLASS_POINTER [PD_SAVE_SE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("sesave")), reg_startzp.item + l_no)
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 174 then -- switch 1, case 90 | switch 1, case 91 | switch 1, case 92 | switch 1, case 93 | switch 1, case 94 | switch 1, case 95 | switch 1, case 96 | switch 1, case 97 | switch 1, case 98 | switch 1, case 99
						l_no := l_op - 90
						cleanup_subexpr
						l_rp := regstack_push ({PC_REGSTATE_E}.RS_MCLOSE, l_scan.item)
						if l_rp.is_void then
							l_status := 1
						else
							l_rp.item.rs_no := l_no.to_integer_16
							if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
								save_se_multi (create {CE_CLASS_POINTER [PD_SAVE_SE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("sesave")), (create {P_REGEXP_STATIC}).reg_endpos.item + l_no)
							else
								save_se_one (create {CE_CLASS_POINTER [PD_SAVE_SE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("sesave")), (create {P_REGEXP_STATIC}).reg_endp.item + l_no)
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 175 then -- switch 1, case 121 | switch 1, case 122 | switch 1, case 123 | switch 1, case 124 | switch 1, case 125 | switch 1, case 126 | switch 1, case 127 | switch 1, case 128 | switch 1, case 129
						l_no := l_op - 120
						cleanup_zsubexpr
						l_rp := regstack_push ({PC_REGSTATE_E}.RS_ZCLOSE, l_scan.item)
						if l_rp.is_void then
							l_status := 1
						else
							l_rp.item.rs_no := l_no.to_integer_16
							if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
								save_se_multi (create {CE_CLASS_POINTER [PD_SAVE_SE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("sesave")), reg_endzpos.item + l_no)
							else
								save_se_one (create {CE_CLASS_POINTER [PD_SAVE_SE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("sesave")), reg_endzp.item + l_no)
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 176 then -- switch 1, case 101 | switch 1, case 102 | switch 1, case 103 | switch 1, case 104 | switch 1, case 105 | switch 1, case 106 | switch 1, case 107 | switch 1, case 108 | switch 1, case 109
						l_no := l_op - 100
						cleanup_subexpr
						if (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
							l_pos := -1 + 179 -- skip if block
						end
				when 177 then -- if:
						if ((create {P_REGEXP_STATIC}).reg_startp.item[l_no]).is_void then
							l_len___1.item := 0
						elseif ((create {P_REGEXP_STATIC}).reg_endp.item[l_no]).is_void then
							l_len___1.item := 0
						else
							l_len___1.item := ((create {P_REGEXP_STATIC}).reg_endp.item[l_no]).distance (((create {P_REGEXP_STATIC}).reg_startp.item[l_no]))
							if ((create {P_REGEXP_STATIC}).cstrncmp ((create {P_REGEXP_STATIC}).reg_startp.item[l_no], reginput.item, l_len___1)) /= 0 then
								l_status := 5
							end
						end
				when 178 then -- if block done, skip else block:
						l_pos := -1 + 199
				when 179 then -- else:
						if not (((create {P_REGEXP_STATIC}).reg_startpos.item + l_no).item.lnum < 0) then
							l_pos := -1 + 182 -- skip if block
						end
				when 180 then -- if:
						l_len___1.item := 0
				when 181 then -- if block done, skip else block:
						l_pos := -1 + 199
				when 182 then -- else:
						if not (((create {P_REGEXP_STATIC}).reg_endpos.item + l_no).item.lnum < 0) then
							l_pos := -1 + 185 -- skip if block
						end
				when 183 then -- if:
						l_len___1.item := 0
				when 184 then -- if block done, skip else block:
						l_pos := -1 + 199
				when 185 then -- else:
						if ((create {P_REGEXP_STATIC}).reg_startpos.item + l_no).item.lnum /= (create {P_REGEXP_STATIC}).reglnum.item then
							l_pos := -1 + 188 -- skip if block
						end
				when 186 then -- if:
						if ((create {P_REGEXP_STATIC}).reg_endpos.item + l_no).item.lnum = (create {P_REGEXP_STATIC}).reglnum.item then
							l_len___1.item := ((create {P_REGEXP_STATIC}).reg_endpos.item + l_no).item.col - ((create {P_REGEXP_STATIC}).reg_startpos.item + l_no).item.col
							if ((create {P_REGEXP_STATIC}).cstrncmp ((create {P_REGEXP_STATIC}).regline.item + ((create {P_REGEXP_STATIC}).reg_startpos.item + l_no).item.col, reginput.item, l_len___1)) /= 0 then
								l_status := 5
							end
						else
							l_pos := -1 + 188 -- goto _L___17
						end
				when 187 then -- if block done, skip else block:
						l_pos := -1 + 199
				when 188 then -- else: | _L___17:
						l_ccol := ((create {P_REGEXP_STATIC}).reg_startpos.item + l_no).item.col
						l_clnum := ((create {P_REGEXP_STATIC}).reg_startpos.item + l_no).item.lnum
				when 189 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 198 -- skip loop
						end
				when 190 then -- loop body:
						l_break := False
						if ((create {P_REGEXP_STATIC}).regline.item).is_equal ((create {P_REGEXP_STATIC}).reg_tofree.item) then
							l_pos := -1 + 197 -- skip if block
						end
				when 191 then -- if:
						l_len___1.item := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).regline.item))).to_integer_32
						if not (((create {P_REGEXP_STATIC}).reg_tofree.item).is_void) then
							l_pos := -1 + 194 -- skip if block
						end
				when 192 then -- if:
						l_pos := -1 + 195 -- goto _L___16
				when 193 then -- if block done, skip else block:
						l_pos := -1 + 196
				when 194 then -- else:
						if not (l_len___1.item >= ((create {P_REGEXP_STATIC}).reg_tofreelen.item).to_integer_32) then
							l_pos := -1 + 196 -- skip if block
						end
				when 195 then -- if: | _L___16:
						l_len___1.item := l_len___1.item + (50);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast ((create {P_REGEXP_STATIC}).reg_tofree.item));
						(create {P_REGEXP_STATIC}).reg_tofree.item := (create {P_MISC2_STATIC}).alloc ((l_len___1.item).to_natural_32)
						if ((create {P_REGEXP_STATIC}).reg_tofree.item).is_void then
							l_status := 1
							l_break := True
						end
						if not (l_break) then
							(create {P_REGEXP_STATIC}).reg_tofreelen.item := (l_len___1.item).to_natural_32
						end
				when 196 then -- if done
						if not (l_break) then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).reg_tofree.item), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).regline.item)).do_nothing
							reginput.item := (create {P_REGEXP_STATIC}).reg_tofree.item + (reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item)));
							(create {P_REGEXP_STATIC}).regline.item := (create {P_REGEXP_STATIC}).reg_tofree.item
						end
				when 197 then -- if done
						if not (l_break) then
							l_p___0 := (create {P_REGEXP_STATIC}).reg_getline (l_clnum)
							if l_clnum = ((create {P_REGEXP_STATIC}).reg_endpos.item + l_no).item.lnum then
								l_len___1.item := ((create {P_REGEXP_STATIC}).reg_endpos.item + l_no).item.col - l_ccol
							else
								l_len___1.item := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + l_ccol)))).to_integer_32
							end
							if ((create {P_REGEXP_STATIC}).cstrncmp (l_p___0 + l_ccol, reginput.item, l_len___1)) /= 0 then
								l_status := 5
								l_break := True
							end
						end
						if not (l_break) and then (l_clnum = ((create {P_REGEXP_STATIC}).reg_endpos.item + l_no).item.lnum) then
							l_break := True
						end
						if not (l_break) and then ((create {P_REGEXP_STATIC}).reglnum.item >= (create {P_REGEXP_STATIC}).reg_maxline.item) then
							l_status := 5
							l_break := True
						end
						if not (l_break) then
							reg_nextline
							l_clnum := l_clnum + 1
							l_ccol := 0
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_status := 1
								l_break := True
							end
						end
						l_pos := -1 + 189 -- back to loop condition
				when 198 then -- loop done
						l_break := False
				when 199 then -- if done | if done | if done
						reginput.item := reginput.item + (l_len___1.item)
						l_pos := -1 + 226 -- switch 1; break
				when 200 then -- switch 1, case 131 | switch 1, case 132 | switch 1, case 133 | switch 1, case 134 | switch 1, case 135 | switch 1, case 136 | switch 1, case 137 | switch 1, case 138 | switch 1, case 139
						cleanup_zsubexpr
						l_no := l_op - 130
						if not ((create {P_GLOBALS_STATIC}).re_extmatch_in.item).is_void then
							if not ((create {P_GLOBALS_STATIC}).re_extmatch_in.item.item.matches[l_no]).is_void then
								l_len___2.item := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).re_extmatch_in.item.item.matches[l_no]))).to_integer_32
								if ((create {P_REGEXP_STATIC}).cstrncmp ((create {P_GLOBALS_STATIC}).re_extmatch_in.item.item.matches[l_no], reginput.item, l_len___2)) /= 0 then
									l_status := 5
								else
									reginput.item := reginput.item + (l_len___2.item)
								end
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 201 then -- switch 1, case 3
						if (l_next.item).to_integer_32 /= 3 then
							l_next := l_scan.item + 3
						else
							l_rp := regstack_push ({PC_REGSTATE_E}.RS_BRANCH, l_scan.item)
							if l_rp.is_void then
								l_status := 1
							else
								l_status := 3
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 202 then -- switch 1, case 17
						if (l_next.item).to_integer_32 = 14 then
							bl_minval.item := (((((l_scan.item[3]).to_integer_32).bit_shift_left (24)) + (((l_scan.item[4]).to_integer_32).bit_shift_left (16))) + (((l_scan.item[5]).to_integer_32).bit_shift_left (8))) + (l_scan.item[6]).to_integer_32
							bl_maxval.item := ((((((l_scan.item + 4)[3]).to_integer_32).bit_shift_left (24)) + ((((l_scan.item + 4)[4]).to_integer_32).bit_shift_left (16))) + ((((l_scan.item + 4)[5]).to_integer_32).bit_shift_left (8))) + ((l_scan.item + 4)[6]).to_integer_32
						elseif (l_next.item).to_integer_32 >= 140 then
							if (l_next.item).to_integer_32 < 150 then
								l_no := (l_next.item).to_integer_32 - 140
								brace_min.item[l_no] := (((((l_scan.item[3]).to_integer_32).bit_shift_left (24)) + (((l_scan.item[4]).to_integer_32).bit_shift_left (16))) + (((l_scan.item[5]).to_integer_32).bit_shift_left (8))) + (l_scan.item[6]).to_integer_32
								brace_max.item[l_no] := ((((((l_scan.item + 4)[3]).to_integer_32).bit_shift_left (24)) + ((((l_scan.item + 4)[4]).to_integer_32).bit_shift_left (16))) + ((((l_scan.item + 4)[5]).to_integer_32).bit_shift_left (8))) + ((l_scan.item + 4)[6]).to_integer_32
								brace_count.item[l_no] := 0
							else
								l_tmp___106 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_internal.item)));
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___106)).do_nothing
								l_status := 1
							end
						else
							l_tmp___106 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_internal.item)));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___106)).do_nothing
							l_status := 1
						end
						l_pos := -1 + 226 -- switch 1; break
				when 203 then -- switch 1, case 140 | switch 1, case 141 | switch 1, case 142 | switch 1, case 143 | switch 1, case 144 | switch 1, case 145 | switch 1, case 146 | switch 1, case 147 | switch 1, case 148 | switch 1, case 149
						l_no := l_op - 140
						brace_count.item[l_no] := (brace_count.item[l_no]) + 1
						if brace_min.item[l_no] <= brace_max.item[l_no] then
							l_tmp___107 := brace_min.item[l_no]
						else
							l_tmp___107 := brace_max.item[l_no]
						end
						if (brace_count.item[l_no]).to_integer_32 <= l_tmp___107 then
							l_rp := regstack_push ({PC_REGSTATE_E}.RS_BRCPLX_MORE, l_scan.item)
							if l_rp.is_void then
								l_status := 1
							else
								l_rp.item.rs_no := l_no.to_integer_16
								reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
								l_next := l_scan.item + 3
							end
							l_pos := -1 + 226 -- switch 1; break
						end
				when 204 then
						if brace_min.item[l_no] <= brace_max.item[l_no] then
							if (brace_count.item[l_no]).to_integer_32 <= brace_max.item[l_no] then
								l_rp := regstack_push ({PC_REGSTATE_E}.RS_BRCPLX_LONG, l_scan.item)
								if l_rp.is_void then
									l_status := 1
								else
									l_rp.item.rs_no := l_no.to_integer_16
									reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
									l_next := l_scan.item + 3
								end
							end
						elseif (brace_count.item[l_no]).to_integer_32 <= brace_min.item[l_no] then
							l_rp := regstack_push ({PC_REGSTATE_E}.RS_BRCPLX_SHORT, l_scan.item)
							if l_rp.is_void then
								l_status := 1
							else
								reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 205 then -- switch 1, case 14 | switch 1, case 7 | switch 1, case 8
						if (l_next.item).to_integer_32 = 5 then
							l_rst.nextb := (l_next[3]).to_integer_32
							if ((create {P_REGEXP_STATIC}).ireg_ic.item).to_boolean then
								if ((create {P_CHARSET_STATIC}).vim_isupper (l_rst.nextb)).to_boolean then
									l_rst.nextb_ic := (create {P_CHARSET_STATIC}).vim_tolower (l_rst.nextb)
								else
									l_rst.nextb_ic := (create {P_CHARSET_STATIC}).vim_toupper (l_rst.nextb)
								end
							else
								l_rst.nextb_ic := l_rst.nextb
							end
						else
							l_rst.nextb := ('%/0/').code
							l_rst.nextb_ic := ('%/0/').code
						end
						if l_op /= 14 then
							if l_op = 7 then
								l_rst.minval := 0
							else
								l_rst.minval := 1
							end
							l_rst.maxval := (32_767).bit_shift_left (16)
						else
							l_rst.minval := bl_minval.item
							l_rst.maxval := bl_maxval.item
						end
						l_rst.count := (regrepeat (l_scan.item + 3, l_rst.maxval)).to_integer_32
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_status := 1
							l_pos := -1 + 226 -- switch 1; break
						end
				when 206 then
						if l_rst.minval <= l_rst.maxval then
							l_tmp___113 := (l_rst.count >= l_rst.minval).to_integer
						else
							l_tmp___113 := (l_rst.count >= l_rst.maxval).to_integer
						end
						if l_tmp___113.to_boolean then
							if ((((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32).bit_shift_right (10)).to_integer_32 >= (create {P_OPTION_STATIC}).p_mmp.item.item then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_maxmempat.item))))).do_nothing
								l_status := 1
							elseif (((create {P_REGEXP_STATIC}).regstack.item).item.ga_grow (((create {PD_REGSTAR_S}.make).structure_size.to_natural_32).to_integer_32)) = 0 then
								l_status := 1
							else
								(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 + (create {PD_REGSTAR_S}.make).structure_size.to_natural_32).to_integer_32
								if l_rst.minval <= l_rst.maxval then
									l_tmp___111 := 12
								else
									l_tmp___111 := 13
								end
								l_rp := regstack_push (l_tmp___111.to_natural_32, l_scan.item)
								if l_rp.is_void then
									l_status := 1
								else
									create {CE_CLASS_POINTER [PD_REGSTAR_S]}.make_cast (l_rp)[-1] := l_rst.twin
									l_status := 3
								end
							end
						else
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 207 then -- switch 1, case 10 | switch 1, case 9 | switch 1, case 13
						l_rp := regstack_push ({PC_REGSTATE_E}.RS_NOMATCH, l_scan.item)
						if l_rp.is_void then
							l_status := 1
						else
							l_rp.item.rs_no := l_op.to_integer_16
							reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
							l_next := l_scan.item + 3
						end
						l_pos := -1 + 226 -- switch 1; break
				when 208 then -- switch 1, case 11 | switch 1, case 12
						if ((((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32).bit_shift_right (10)).to_integer_32 >= (create {P_OPTION_STATIC}).p_mmp.item.item then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_maxmempat.item))))).do_nothing
							l_status := 1
						elseif (((create {P_REGEXP_STATIC}).regstack.item).item.ga_grow (((create {PD_REGBEHIND_S}.make).structure_size.to_natural_32).to_integer_32)) = 0 then
							l_status := 1
						else
							(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 + (create {PD_REGBEHIND_S}.make).structure_size.to_natural_32).to_integer_32
							l_rp := regstack_push ({PC_REGSTATE_E}.RS_BEHIND1, l_scan.item)
							if l_rp.is_void then
								l_status := 1
							else
								save_subexpr (create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1)
								l_rp.item.rs_no := l_op.to_integer_16
								reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
							end
						end
						l_pos := -1 + 226 -- switch 1; break
				when 209 then -- switch 1, case 19
						if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
							if behind_pos.item.item.rs_u.pos.col /= reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item)) then
								l_status := 5
							elseif behind_pos.item.item.rs_u.pos.lnum /= (create {P_REGEXP_STATIC}).reglnum.item then
								l_status := 5
							end
						elseif not (behind_pos.item.item.rs_u.ptr).is_equal (reginput.item) then
							l_status := 5
						end
						l_pos := -1 + 226 -- switch 1; break
				when 210 then -- switch 1, case 18
						if l_c = 0 then
							l_pos := -1 + 213 -- skip if block
						end
				when 211 then -- if:
						l_pos := -1 + 220 -- goto _L___19
				when 212 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 213 then -- else:
						if (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
							l_pos := -1 + 216 -- skip if block
						end
				when 214 then -- if:
						l_pos := -1 + 220 -- goto _L___19
				when 215 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 216 then -- else:
						if not ((create {P_REGEXP_STATIC}).reglnum.item > (create {P_REGEXP_STATIC}).reg_maxline.item) then
							l_pos := -1 + 219 -- skip if block
						end
				when 217 then -- if:
						l_pos := -1 + 220 -- goto _L___19
				when 218 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 219 then -- else:
						if not (((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean) then
							l_pos := -1 + 222 -- skip if block
						end
				when 220 then -- if: | _L___19:
						if l_c /= 10 then
							l_status := 5
						elseif not ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
							l_status := 5
						else
							l_pos := -1 + 222 -- goto _L___18
						end
				when 221 then -- if block done, skip else block:
						l_pos := -1 + 223
				when 222 then -- else: | _L___18:
						if ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___117 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
							else
								l_tmp___117 := 1
							end
							reginput.item := reginput.item + l_tmp___117
						else
							reg_nextline
						end
				when 223 then -- if done | if done | if done
						l_pos := -1 + 226 -- switch 1; break
				when 224 then -- switch 1, case 0
						l_status := 4
						l_pos := -1 + 226 -- switch 1; break
				when 225 then -- switch 1, default:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_re_corr.item)))))).do_nothing
						l_status := 1
						l_pos := -1 + 226 -- switch 1; break
				when 226 then -- switch 1, done: | if done
						if l_status /= 2 then
							l_break := True
						end
				when 227 then -- if done
						if not (l_return or l_break) then
							l_scan.item := l_next
						end
						l_pos := -1 + 3 -- back to loop condition
				when 228 then -- loop done
						l_break := False
				when 229 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 252 -- skip loop
						end
				when 230 then -- loop body:
						l_break := False
						if (create {P_REGEXP_STATIC}).regstack.item.item.ga_len > 0 then
							if l_status = 1 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 251 -- skip if block
						end
				when 231 then -- if:
						l_rp := create {CE_CLASS_POINTER [PD_REGITEM_S]}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).regstack.item.item.ga_data) + (create {P_REGEXP_STATIC}).regstack.item.item.ga_len)) - 1
						inspect (l_rp.item.rs_state).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 232
						when 1 then l_pos := -1 + 233
						when 3 then l_pos := -1 + 234
						when 2 then l_pos := -1 + 235
						when 4 then l_pos := -1 + 236
						when 5 then l_pos := -1 + 237
						when 6 then l_pos := -1 + 238
						when 7 then l_pos := -1 + 239
						when 8 then l_pos := -1 + 240
						when 9 then l_pos := -1 + 241
						when 10 then l_pos := -1 + 242
						when 11 then l_pos := -1 + 243
						when 12 then l_pos := -1 + 248
						when 13 then l_pos := -1 + 248
						else l_pos := -1 + 250
						end
				when 232 then -- switch 2, case 0
						regstack_pop (l_scan)
						l_pos := -1 + 250 -- switch 2; break
				when 233 then -- switch 2, case 1
						if l_status = 5 then
							if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
								(create {P_REGEXP_STATIC}).reg_startpos.item[(l_rp.item.rs_no).to_integer_32] := (l_rp.item.rs_un.sesave.se_u.pos).twin
							else
								(create {P_REGEXP_STATIC}).reg_startp.item[(l_rp.item.rs_no).to_integer_32] := l_rp.item.rs_un.sesave.se_u.ptr
							end
						end
						regstack_pop (l_scan)
						l_pos := -1 + 250 -- switch 2; break
				when 234 then -- switch 2, case 3
						if l_status = 5 then
							if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
								reg_startzpos.item[(l_rp.item.rs_no).to_integer_32] := (l_rp.item.rs_un.sesave.se_u.pos).twin
							else
								reg_startzp.item[(l_rp.item.rs_no).to_integer_32] := l_rp.item.rs_un.sesave.se_u.ptr
							end
						end
						regstack_pop (l_scan)
						l_pos := -1 + 250 -- switch 2; break
				when 235 then -- switch 2, case 2
						if l_status = 5 then
							if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
								(create {P_REGEXP_STATIC}).reg_endpos.item[(l_rp.item.rs_no).to_integer_32] := (l_rp.item.rs_un.sesave.se_u.pos).twin
							else
								(create {P_REGEXP_STATIC}).reg_endp.item[(l_rp.item.rs_no).to_integer_32] := l_rp.item.rs_un.sesave.se_u.ptr
							end
						end
						regstack_pop (l_scan)
						l_pos := -1 + 250 -- switch 2; break
				when 236 then -- switch 2, case 4
						if l_status = 5 then
							if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
								reg_endzpos.item[(l_rp.item.rs_no).to_integer_32] := (l_rp.item.rs_un.sesave.se_u.pos).twin
							else
								reg_endzp.item[(l_rp.item.rs_no).to_integer_32] := l_rp.item.rs_un.sesave.se_u.ptr
							end
						end
						regstack_pop (l_scan)
						l_pos := -1 + 250 -- switch 2; break
				when 237 then -- switch 2, case 5
						if l_status = 4 then
							regstack_pop (l_scan)
						else
							if l_status /= 3 then
								reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
								l_scan.item := l_rp.item.rs_scan
							end
							if (l_scan.item).is_void then
								l_status := 5
								regstack_pop (l_scan)
							elseif (l_scan.item.item).to_integer_32 /= 3 then
								l_status := 5
								regstack_pop (l_scan)
							else
								l_rp.item.rs_scan := (create {P_REGEXP_STATIC}).regnext (l_scan.item)
								reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
								l_scan.item := l_scan.item + (3)
							end
						end
						l_pos := -1 + 250 -- switch 2; break
				when 238 then -- switch 2, case 6
						if l_status = 5 then
							reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
							brace_count.item[(l_rp.item.rs_no).to_integer_32] := (brace_count.item[(l_rp.item.rs_no).to_integer_32]) - 1
						end
						regstack_pop (l_scan)
						l_pos := -1 + 250 -- switch 2; break
				when 239 then -- switch 2, case 7
						if l_status = 5 then
							reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
							brace_count.item[(l_rp.item.rs_no).to_integer_32] := (brace_count.item[(l_rp.item.rs_no).to_integer_32]) - 1
							l_status := 2
						end
						regstack_pop (l_scan)
						if l_status = 2 then
							l_scan.item := (create {P_REGEXP_STATIC}).regnext (l_scan.item)
						end
						l_pos := -1 + 250 -- switch 2; break
				when 240 then -- switch 2, case 8
						if l_status = 5 then
							reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
						end
						regstack_pop (l_scan)
						if l_status = 5 then
							l_scan.item := l_scan.item + (3)
							l_status := 2
						end
						l_pos := -1 + 250 -- switch 2; break
				when 241 then -- switch 2, case 9
						if (l_rp.item.rs_no).to_integer_32 = 10 then
							l_tmp___119 := 4
						else
							l_tmp___119 := 5
						end
						if l_status = l_tmp___119 then
							l_status := 5
						else
							l_status := 2
							if (l_rp.item.rs_no).to_integer_32 /= 13 then
								reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
							end
						end
						regstack_pop (l_scan)
						if l_status = 2 then
							l_scan.item := (create {P_REGEXP_STATIC}).regnext (l_scan.item)
						end
						l_pos := -1 + 250 -- switch 2; break
				when 242 then -- switch 2, case 10
						if l_status = 5 then
							regstack_pop (l_scan);
							(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 - (create {PD_REGBEHIND_S}.make).structure_size.to_natural_32).to_integer_32
						else
							reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared ((create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1).c_pointer + (create {PD_REGBEHIND_S}.make).offset_of ("save_after")), (create {P_REGEXP_STATIC}).backpos.item);
							(create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1).item.save_behind := (behind_pos.item.item).twin
							behind_pos.item.item := (l_rp.item.rs_un.regsave).twin
							l_rp.item.rs_state := {PC_REGSTATE_E}.RS_BEHIND2
							reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
							l_scan.item := l_rp.item.rs_scan + 3
						end
						l_pos := -1 + 250 -- switch 2; break
				when 243 then -- switch 2, case 11
						if l_status /= 4 then
							l_pos := -1 + 246 -- skip if block
						end
				when 244 then -- if:
						if (reg_save_equal (behind_pos.item)).to_boolean then
							behind_pos.item.item := ((create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1).item.save_behind).twin
							if (l_rp.item.rs_no).to_integer_32 = 11 then
								reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared ((create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1).c_pointer + (create {PD_REGBEHIND_S}.make).offset_of ("save_after")), (create {P_REGEXP_STATIC}).backpos.item)
							else
								l_status := 5
								restore_subexpr (create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1)
							end
							regstack_pop (l_scan);
							(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 - (create {PD_REGBEHIND_S}.make).structure_size.to_natural_32).to_integer_32
						else
							l_pos := -1 + 246 -- goto _L___26
						end
				when 245 then -- if block done, skip else block:
						l_pos := -1 + 247
				when 246 then -- else: | _L___26:
						l_no := 1
						if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
							if l_rp.item.rs_un.regsave.rs_u.pos.col = 0 then
								if l_rp.item.rs_un.regsave.rs_u.pos.lnum < behind_pos.item.item.rs_u.pos.lnum then
									l_no := 0
								else
									l_rp.item.rs_un.regsave.rs_u.pos.lnum := (l_rp.item.rs_un.regsave.rs_u.pos.lnum) - 1
									if ((create {P_REGEXP_STATIC}).reg_getline (l_rp.item.rs_un.regsave.rs_u.pos.lnum)).is_void then
										l_no := 0
									else
										reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
										l_rp.item.rs_un.regsave.rs_u.pos.col := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).regline.item))).to_integer_32
									end
								end
							else
								l_rp.item.rs_un.regsave.rs_u.pos.col := (l_rp.item.rs_un.regsave.rs_u.pos.col) - 1
							end
						elseif (l_rp.item.rs_un.regsave.rs_u.ptr).is_equal ((create {P_REGEXP_STATIC}).regline.item) then
							l_no := 0
						else
							l_rp.item.rs_un.regsave.rs_u.ptr := (l_rp.item.rs_un.regsave.rs_u.ptr) - 1
						end
						if l_no = 1 then
							reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
							l_scan.item := l_rp.item.rs_scan + 3
							if l_status = 4 then
								l_status := 5
								restore_subexpr (create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1)
							end
						else
							behind_pos.item.item := ((create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1).item.save_behind).twin
							if (l_rp.item.rs_no).to_integer_32 = 12 then
								reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared ((create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1).c_pointer + (create {PD_REGBEHIND_S}.make).offset_of ("save_after")), (create {P_REGEXP_STATIC}).backpos.item)
								l_status := 4
							elseif l_status = 4 then
								l_status := 5
								restore_subexpr (create {CE_CLASS_POINTER [PD_REGBEHIND_S]}.make_cast (l_rp) - 1)
							end
							regstack_pop (l_scan);
							(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 - (create {PD_REGBEHIND_S}.make).structure_size.to_natural_32).to_integer_32
						end
				when 247 then
						l_pos := -1 + 250 -- switch 2; break
				when 248 then -- switch 2, case 12 | switch 2, case 13
						l_rst___0 := create {CE_CLASS_POINTER [PD_REGSTAR_S]}.make_cast (l_rp) - 1
						if l_status = 4 then
							regstack_pop (l_scan);
							(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 - (create {PD_REGSTAR_S}.make).structure_size.to_natural_32).to_integer_32
							l_pos := -1 + 250 -- switch 2; break
						end
				when 249 then
						if l_status /= 3 then
							reg_restore (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if l_status /= 3 then
								if l_rp.item.rs_state = {NATURAL_32} 12 then
									l_rst___0.item.count := (l_rst___0.item.count) - 1
									if l_rst___0.item.count < l_rst___0.item.minval then
										l_break := True
									end
									if not (l_return or l_break) then
										if reginput.item.is_equal ((create {P_REGEXP_STATIC}).regline.item) then
											(create {P_REGEXP_STATIC}).reglnum.item := (create {P_REGEXP_STATIC}).reglnum.item - 1;
											(create {P_REGEXP_STATIC}).regline.item := (create {P_REGEXP_STATIC}).reg_getline ((create {P_REGEXP_STATIC}).reglnum.item)
											if ((create {P_REGEXP_STATIC}).regline.item).is_void then
												l_break := True
											end
											if not (l_return or l_break) then
												reginput.item := (create {P_REGEXP_STATIC}).regline.item + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).regline.item))).to_integer_32;
												(create {P_MISC1_STATIC}).fast_breakcheck
											end
										else
											if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
												l_tmp___125 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([(create {P_REGEXP_STATIC}).regline.item, reginput.item - 1])) + 1
											else
												l_tmp___125 := 1
											end
											reginput.item := reginput.item - l_tmp___125
										end
									end
								else
									if l_rst___0.item.count = l_rst___0.item.minval then
										l_break := True
									elseif (regrepeat (l_rp.item.rs_scan + 3, 1)) = 0 then
										l_break := True
									end
									if not (l_return or l_break) then
										l_rst___0.item.count := (l_rst___0.item.count) + 1
									end
								end
								if not (l_return or l_break) and then (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
									l_break := True
								end
							else
								l_status := 5
							end
							if not (l_return or l_break) then
								if l_rst___0.item.nextb = 0 then
									reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
									l_scan.item := (create {P_REGEXP_STATIC}).regnext (l_rp.item.rs_scan)
									l_status := 2
									l_break := True
								elseif (reginput.item.item).to_integer_32 = l_rst___0.item.nextb then
									reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
									l_scan.item := (create {P_REGEXP_STATIC}).regnext (l_rp.item.rs_scan)
									l_status := 2
									l_break := True
								elseif (reginput.item.item).to_integer_32 = l_rst___0.item.nextb_ic then
									reg_save (create {CE_CLASS_POINTER [PD_REGSAVE_T]}.make_shared (l_rp.c_pointer + (create {PD_REGITEM_S}.make).offset_of ("rs_un") + (create {PD_RS_UN}.make).offset_of ("regsave")), (create {P_REGEXP_STATIC}).backpos.item)
									l_scan.item := (create {P_REGEXP_STATIC}).regnext (l_rp.item.rs_scan)
									l_status := 2
									l_break := True
								end
							end
						end
						l_break := False
						if l_status /= 2 then
							regstack_pop (l_scan);
							(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 - (create {PD_REGSTAR_S}.make).structure_size.to_natural_32).to_integer_32
							l_status := 5
						end
						l_pos := -1 + 250 -- switch 2; break
				when 250 then -- switch 2, done:
						if l_status = 2 then
							l_break := True
						elseif l_rp.is_equal (create {CE_CLASS_POINTER [PD_REGITEM_S]}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).regstack.item.item.ga_data) + (create {P_REGEXP_STATIC}).regstack.item.item.ga_len)) - 1) then
							l_break := True
						end
				when 251 then -- if done
						l_pos := -1 + 229 -- back to loop condition
				when 252 then -- loop done
						l_break := False
						if l_status = 2 then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 258 -- skip if block
						end
				when 253 then -- if:
						if (create {P_REGEXP_STATIC}).regstack.item.item.ga_len /= 0 then
							l_pos := -1 + 256 -- skip if block
						end
				when 254 then -- if:
						l_pos := -1 + 257 -- goto _L___27
				when 255 then -- if block done, skip else block:
						l_pos := -1 + 258
				when 256 then -- else:
						if l_status /= 1 then
							l_pos := -1 + 258 -- skip if block
						end
				when 257 then -- if: | _L___27:
						if (l_scan.item).is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_re_corr.item)))))).do_nothing
						end
						if l_status = 1 then
							(create {P_GLOBALS_STATIC}).got_int.item := 1
						end
						Result := (l_status = 4).to_integer
						l_return := True
				when 258 then -- if done | if done
						if (not l_return) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 259 then -- loop done
					if not l_return then
						l_continue := False
					end
				when 260 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cleanup_zsubexpr
		do
			if need_clear_zsubexpr.item.to_boolean then
				if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
					memset (create {CE_VOID_POINTER}.make_cast (reg_startzpos.item), 255, (create {PD_LPOS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 10).do_nothing
					memset (create {CE_VOID_POINTER}.make_cast (reg_endzpos.item), 255, (create {PD_LPOS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 10).do_nothing
				else
					memset (create {CE_VOID_POINTER}.make_cast (reg_startzp.item), 0, {PLATFORM}.Pointer_bytes.to_natural_32 * {NATURAL_32} 10).do_nothing
					memset (create {CE_VOID_POINTER}.make_cast (reg_endzp.item), 0, {PLATFORM}.Pointer_bytes.to_natural_32 * {NATURAL_32} 10).do_nothing
				end
				need_clear_zsubexpr.item := 0
			end
		end

	reg_prev_class: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if (reginput.item.c_pointer.to_integer_32).to_natural_32 > (((create {P_REGEXP_STATIC}).regline.item).c_pointer.to_integer_32).to_natural_32 then
				Result := ((create {P_MBYTE_STATIC}).mb_get_class ((reginput.item - 1) - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([(create {P_REGEXP_STATIC}).regline.item, reginput.item - 1]))))
				l_return := True
			end
			if not l_return then
				Result := (-1)
			end
		end

	regstack_push (a_state: NATURAL_32; a_scan: CE_POINTER [NATURAL_8]): CE_POINTER [PD_REGITEM_S]
		local
			l_rp: CE_POINTER [PD_REGITEM_S]
			l_return: BOOLEAN
		do
			if ((((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32).bit_shift_right (10)).to_integer_32 >= (create {P_OPTION_STATIC}).p_mmp.item.item then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_maxmempat.item))))).do_nothing
				Result := (create {CE_CLASS_POINTER [PD_REGITEM_S]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if (((create {P_REGEXP_STATIC}).regstack.item).item.ga_grow (((create {PD_REGITEM_S}.make).structure_size.to_natural_32).to_integer_32)) = 0 then
					Result := (create {CE_CLASS_POINTER [PD_REGITEM_S]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_rp := create {CE_CLASS_POINTER [PD_REGITEM_S]}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).regstack.item.item.ga_data) + (create {P_REGEXP_STATIC}).regstack.item.item.ga_len))
				l_rp.item.rs_state := a_state
				l_rp.item.rs_scan := a_scan;
				(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 + (create {PD_REGITEM_S}.make).structure_size.to_natural_32).to_integer_32
				Result := l_rp
			end
		end

	regstack_pop (a_scan: CE_POINTER [CE_POINTER [NATURAL_8]])
		require
			not a_scan.is_void
		local
			l_rp: CE_POINTER [PD_REGITEM_S]
		do
			l_rp := create {CE_CLASS_POINTER [PD_REGITEM_S]}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast ((create {P_REGEXP_STATIC}).regstack.item.item.ga_data) + (create {P_REGEXP_STATIC}).regstack.item.item.ga_len)) - 1
			a_scan.item := l_rp.item.rs_scan;
			(create {P_REGEXP_STATIC}).regstack.item.item.ga_len := (((create {P_REGEXP_STATIC}).regstack.item.item.ga_len).to_natural_32 - (create {PD_REGITEM_S}.make).structure_size.to_natural_32).to_integer_32
		end

	regrepeat (a_p___0: CE_POINTER [NATURAL_8]; a_maxcount: INTEGER_32): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_count___2: INTEGER_32
			l_scan: CE_POINTER [NATURAL_8]
			l_opnd: CE_POINTER [NATURAL_8]
			l_mask: INTEGER_32
			l_testval: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___11: INTEGER_32
			l_l: INTEGER_32
			l_cu: INTEGER_32
			l_cl: INTEGER_32
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_cf: INTEGER_32
			l_len___0: INTEGER_32
			l_tmp___20: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := 0
					l_testval := 0
					l_scan := reginput.item
					l_opnd := a_p___0 + 3
					inspect (a_p___0.item).to_integer_32 -- switch 1 head
					when 20 then l_pos := -1 + 1
					when 50 then l_pos := -1 + 1
					when 23 then l_pos := -1 + 2
					when 53 then l_pos := -1 + 2
					when 24 then l_pos := -1 + 3
					when 54 then l_pos := -1 + 3
					when 25 then l_pos := -1 + 16
					when 55 then l_pos := -1 + 16
					when 26 then l_pos := -1 + 17
					when 56 then l_pos := -1 + 17
					when 27 then l_pos := -1 + 30
					when 57 then l_pos := -1 + 30
					when 28 then l_pos := -1 + 31
					when 58 then l_pos := -1 + 31
					when 29 then l_pos := -1 + 44
					when 59 then l_pos := -1 + 44
					when 30 then l_pos := -1 + 45
					when 60 then l_pos := -1 + 45
					when 31 then l_pos := -1 + 61
					when 61 then l_pos := -1 + 61
					when 32 then l_pos := -1 + 72
					when 62 then l_pos := -1 + 72
					when 33 then l_pos := -1 + 73
					when 63 then l_pos := -1 + 73
					when 34 then l_pos := -1 + 74
					when 64 then l_pos := -1 + 74
					when 35 then l_pos := -1 + 75
					when 65 then l_pos := -1 + 75
					when 36 then l_pos := -1 + 76
					when 66 then l_pos := -1 + 76
					when 37 then l_pos := -1 + 77
					when 67 then l_pos := -1 + 77
					when 38 then l_pos := -1 + 78
					when 68 then l_pos := -1 + 78
					when 39 then l_pos := -1 + 79
					when 69 then l_pos := -1 + 79
					when 40 then l_pos := -1 + 80
					when 70 then l_pos := -1 + 80
					when 41 then l_pos := -1 + 81
					when 71 then l_pos := -1 + 81
					when 42 then l_pos := -1 + 82
					when 72 then l_pos := -1 + 82
					when 43 then l_pos := -1 + 83
					when 73 then l_pos := -1 + 83
					when 44 then l_pos := -1 + 84
					when 74 then l_pos := -1 + 84
					when 45 then l_pos := -1 + 85
					when 75 then l_pos := -1 + 85
					when 46 then l_pos := -1 + 86
					when 76 then l_pos := -1 + 86
					when 47 then l_pos := -1 + 87
					when 77 then l_pos := -1 + 87
					when 48 then l_pos := -1 + 88
					when 78 then l_pos := -1 + 88
					when 5 then l_pos := -1 + 89
					when 200 then l_pos := -1 + 90
					when 21 then l_pos := -1 + 91
					when 51 then l_pos := -1 + 91
					when 22 then l_pos := -1 + 92
					when 52 then l_pos := -1 + 92
					when 18 then l_pos := -1 + 105
					else l_pos := -1 + 115
					end
				when 1 then -- switch 1, case 20 | switch 1, case 50
					from
					until
						not (not (l_return or l_break) and then (l_count___2 < a_maxcount))
					loop
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_scan.item).to_integer_32 /= 0 then
								if not (l_count___2 < a_maxcount) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_count___2 := l_count___2 + 1
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_scan]))
								else
									l_tmp___0 := 1
								end
								l_scan := l_scan + l_tmp___0
							end
						end
						l_break := False
						if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
							l_break := True
						elseif (a_p___0.item).to_integer_32 >= 50 then
							if (a_p___0.item).to_integer_32 <= 78 then
								if (create {P_REGEXP_STATIC}).reglnum.item > (create {P_REGEXP_STATIC}).reg_maxline.item then
									l_break := True
								elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
									l_break := True
								elseif l_count___2 = a_maxcount then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break) then
							l_count___2 := l_count___2 + 1
							reg_nextline
							l_scan := reginput.item
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						end
					end
					l_break := False
					l_pos := -1 + 116 -- switch 1; break
				when 2 then -- switch 1, case 23 | switch 1, case 53
					l_testval := 1
				when 3 then -- switch 1, case 24 | switch 1, case 54
					if not (not (l_break) and then (l_count___2 < a_maxcount)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 4 then -- loop body:
						l_break := False
						if not (((create {P_CHARSET_STATIC}).vim_isIDc ((l_scan.item).to_integer_32)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if not (l_testval.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 11 -- goto _L___1
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if not ((l_scan.item).to_integer_32 >= 48) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (l_scan.item).to_integer_32 <= 57 then
							l_pos := -1 + 13 -- goto _L
						else
							l_pos := -1 + 11 -- goto _L___1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___1:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___2 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_scan]))
						else
							l_tmp___2 := 1
						end
						l_scan := l_scan + l_tmp___2
				when 12 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if (l_scan.item).to_integer_32 = 0 then
							if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
								l_break := True
							elseif (a_p___0.item).to_integer_32 >= 50 then
								if (a_p___0.item).to_integer_32 <= 78 then
									if (create {P_REGEXP_STATIC}).reglnum.item > (create {P_REGEXP_STATIC}).reg_maxline.item then
										l_break := True
									elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								reg_nextline
								l_scan := reginput.item
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_break := True
								end
							end
						elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
							if (l_scan.item).to_integer_32 = 10 then
								if (a_p___0.item).to_integer_32 >= 50 then
									if (a_p___0.item).to_integer_32 <= 78 then
										l_scan := l_scan + 1
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
				when 14 then
						if not (l_return or l_break) then
							l_count___2 := l_count___2 + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 15 then -- loop done
					l_break := False
					l_pos := -1 + 116 -- switch 1; break
				when 16 then -- switch 1, case 25 | switch 1, case 55
					l_testval := 1
				when 17 then -- switch 1, case 26 | switch 1, case 56
					if not (not (l_break) and then (l_count___2 < a_maxcount)) then
						l_pos := -1 + 29 -- skip loop
					end
				when 18 then -- loop body:
						l_break := False
						if not (((create {P_CHARSET_STATIC}).vim_iswordp (l_scan)).to_boolean) then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if not (l_testval.to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 25 -- goto _L___4
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if not ((l_scan.item).to_integer_32 >= 48) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if (l_scan.item).to_integer_32 <= 57 then
							l_pos := -1 + 27 -- goto _L___2
						else
							l_pos := -1 + 25 -- goto _L___4
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___4:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___5 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_scan]))
						else
							l_tmp___5 := 1
						end
						l_scan := l_scan + l_tmp___5
				when 26 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___2:
						if (l_scan.item).to_integer_32 = 0 then
							if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
								l_break := True
							elseif (a_p___0.item).to_integer_32 >= 50 then
								if (a_p___0.item).to_integer_32 <= 78 then
									if (create {P_REGEXP_STATIC}).reglnum.item > (create {P_REGEXP_STATIC}).reg_maxline.item then
										l_break := True
									elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								reg_nextline
								l_scan := reginput.item
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_break := True
								end
							end
						elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
							if (l_scan.item).to_integer_32 = 10 then
								if (a_p___0.item).to_integer_32 >= 50 then
									if (a_p___0.item).to_integer_32 <= 78 then
										l_scan := l_scan + 1
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
				when 28 then
						if not (l_return or l_break) then
							l_count___2 := l_count___2 + 1
						end
						l_pos := -1 + 17 -- back to loop condition
				when 29 then -- loop done
					l_break := False
					l_pos := -1 + 116 -- switch 1; break
				when 30 then -- switch 1, case 27 | switch 1, case 57
					l_testval := 1
				when 31 then -- switch 1, case 28 | switch 1, case 58
					if not (not (l_break) and then (l_count___2 < a_maxcount)) then
						l_pos := -1 + 43 -- skip loop
					end
				when 32 then -- loop body:
						l_break := False
						if not (((create {P_CHARSET_STATIC}).vim_isfilec ((l_scan.item).to_integer_32)).to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 33 then -- if:
						if not (l_testval.to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 39 -- goto _L___7
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 36 then -- else:
						if not ((l_scan.item).to_integer_32 >= 48) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if (l_scan.item).to_integer_32 <= 57 then
							l_pos := -1 + 41 -- goto _L___5
						else
							l_pos := -1 + 39 -- goto _L___7
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else: | _L___7:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___8 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_scan]))
						else
							l_tmp___8 := 1
						end
						l_scan := l_scan + l_tmp___8
				when 40 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___5:
						if (l_scan.item).to_integer_32 = 0 then
							if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
								l_break := True
							elseif (a_p___0.item).to_integer_32 >= 50 then
								if (a_p___0.item).to_integer_32 <= 78 then
									if (create {P_REGEXP_STATIC}).reglnum.item > (create {P_REGEXP_STATIC}).reg_maxline.item then
										l_break := True
									elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								reg_nextline
								l_scan := reginput.item
								if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
									l_break := True
								end
							end
						elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
							if (l_scan.item).to_integer_32 = 10 then
								if (a_p___0.item).to_integer_32 >= 50 then
									if (a_p___0.item).to_integer_32 <= 78 then
										l_scan := l_scan + 1
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
				when 42 then
						if not (l_return or l_break) then
							l_count___2 := l_count___2 + 1
						end
						l_pos := -1 + 31 -- back to loop condition
				when 43 then -- loop done
					l_break := False
					l_pos := -1 + 116 -- switch 1; break
				when 44 then -- switch 1, case 29 | switch 1, case 59
					l_testval := 1
				when 45 then -- switch 1, case 30 | switch 1, case 60
					if not (not (l_break) and then (l_count___2 < a_maxcount)) then
						l_pos := -1 + 60 -- skip loop
					end
				when 46 then -- loop body:
						l_break := False
						if (l_scan.item).to_integer_32 /= 0 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
							l_break := True
						elseif (a_p___0.item).to_integer_32 >= 50 then
							if (a_p___0.item).to_integer_32 <= 78 then
								if (create {P_REGEXP_STATIC}).reglnum.item > (create {P_REGEXP_STATIC}).reg_maxline.item then
									l_break := True
								elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break) then
							reg_nextline
							l_scan := reginput.item
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						end
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 49 then -- else:
						if ((create {P_CHARSET_STATIC}).ptr2cells (l_scan)) /= 1 then
							l_pos := -1 + 58 -- skip if block
						end
				when 50 then -- if:
						if not (l_testval.to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_pos := -1 + 56 -- goto _L___10
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 53 then -- else:
						if not ((l_scan.item).to_integer_32 >= 48) then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						if (l_scan.item).to_integer_32 <= 57 then
							l_pos := -1 + 58 -- goto _L___8
						else
							l_pos := -1 + 56 -- goto _L___10
						end
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 56 then -- else: | _L___10:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___11 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_scan]))
						else
							l_tmp___11 := 1
						end
						l_scan := l_scan + l_tmp___11
				when 57 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___8:
						if ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
							if (l_scan.item).to_integer_32 = 10 then
								if (a_p___0.item).to_integer_32 >= 50 then
									if (a_p___0.item).to_integer_32 <= 78 then
										l_scan := l_scan + 1
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
				when 59 then -- if done
						if not (l_return or l_break) then
							l_count___2 := l_count___2 + 1
						end
						l_pos := -1 + 45 -- back to loop condition
				when 60 then -- loop done
					l_break := False
					l_pos := -1 + 116 -- switch 1; break
				when 61 then -- switch 1, case 31 | switch 1, case 61
					l_mask := 256
					l_testval := l_mask
				when 62 then -- do_class:
					if not (not (l_break) and then (l_count___2 < a_maxcount)) then
						l_pos := -1 + 71 -- skip loop
					end
				when 63 then -- loop body:
						l_break := False
						if (l_scan.item).to_integer_32 /= 0 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
							l_break := True
						elseif (a_p___0.item).to_integer_32 >= 50 then
							if (a_p___0.item).to_integer_32 <= 78 then
								if (create {P_REGEXP_STATIC}).reglnum.item > (create {P_REGEXP_STATIC}).reg_maxline.item then
									l_break := True
								elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break) then
							reg_nextline
							l_scan := reginput.item
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 70
				when 66 then -- else:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_scan])
						if l_l > 1 then
							if l_testval /= 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_scan := l_scan + l_l
							end
						else
							l_pos := -1 + 69 -- goto _L___11
						end
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 70
				when 69 then -- else: | _L___11:
						if ((((create {P_REGEXP_STATIC}).class_tab.item[(l_scan.item).to_integer_32]).to_integer_32).bit_and (l_mask)) = l_testval then
							l_scan := l_scan + 1
						elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
							if (l_scan.item).to_integer_32 = 10 then
								if (a_p___0.item).to_integer_32 >= 50 then
									if (a_p___0.item).to_integer_32 <= 78 then
										l_scan := l_scan + 1
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
				when 70 then -- if done
						if not (l_return or l_break) then
							l_count___2 := l_count___2 + 1
						end
						l_pos := -1 + 62 -- back to loop condition
				when 71 then -- loop done
					l_break := False
					l_pos := -1 + 116 -- switch 1; break
				when 72 then -- switch 1, case 32 | switch 1, case 62
					l_mask := 256
					l_pos := -1 + 62 -- goto do_class
				when 73 then -- switch 1, case 33 | switch 1, case 63
					l_mask := 1
					l_testval := l_mask
					l_pos := -1 + 62 -- goto do_class
				when 74 then -- switch 1, case 34 | switch 1, case 64
					l_mask := 1
					l_pos := -1 + 62 -- goto do_class
				when 75 then -- switch 1, case 35 | switch 1, case 65
					l_mask := 2
					l_testval := l_mask
					l_pos := -1 + 62 -- goto do_class
				when 76 then -- switch 1, case 36 | switch 1, case 66
					l_mask := 2
					l_pos := -1 + 62 -- goto do_class
				when 77 then -- switch 1, case 37 | switch 1, case 67
					l_mask := 4
					l_testval := l_mask
					l_pos := -1 + 62 -- goto do_class
				when 78 then -- switch 1, case 38 | switch 1, case 68
					l_mask := 4
					l_pos := -1 + 62 -- goto do_class
				when 79 then -- switch 1, case 39 | switch 1, case 69
					l_mask := 8
					l_testval := l_mask
					l_pos := -1 + 62 -- goto do_class
				when 80 then -- switch 1, case 40 | switch 1, case 70
					l_mask := 8
					l_pos := -1 + 62 -- goto do_class
				when 81 then -- switch 1, case 41 | switch 1, case 71
					l_mask := 16
					l_testval := l_mask
					l_pos := -1 + 62 -- goto do_class
				when 82 then -- switch 1, case 42 | switch 1, case 72
					l_mask := 16
					l_pos := -1 + 62 -- goto do_class
				when 83 then -- switch 1, case 43 | switch 1, case 73
					l_mask := 32
					l_testval := l_mask
					l_pos := -1 + 62 -- goto do_class
				when 84 then -- switch 1, case 44 | switch 1, case 74
					l_mask := 32
					l_pos := -1 + 62 -- goto do_class
				when 85 then -- switch 1, case 45 | switch 1, case 75
					l_mask := 64
					l_testval := l_mask
					l_pos := -1 + 62 -- goto do_class
				when 86 then -- switch 1, case 46 | switch 1, case 76
					l_mask := 64
					l_pos := -1 + 62 -- goto do_class
				when 87 then -- switch 1, case 47 | switch 1, case 77
					l_mask := 128
					l_testval := l_mask
					l_pos := -1 + 62 -- goto do_class
				when 88 then -- switch 1, case 48 | switch 1, case 78
					l_mask := 128
					l_pos := -1 + 62 -- goto do_class
				when 89 then -- switch 1, case 5
					if ((create {P_REGEXP_STATIC}).ireg_ic.item).to_boolean then
						l_cu := (create {P_CHARSET_STATIC}).vim_toupper ((l_opnd.item).to_integer_32)
						l_cl := (create {P_CHARSET_STATIC}).vim_tolower ((l_opnd.item).to_integer_32)
						from
						until
							(l_break)
						loop
							l_break := False
							if l_count___2 < a_maxcount then
								if (l_scan.item).to_integer_32 /= l_cu then
									if (l_scan.item).to_integer_32 /= l_cl then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_count___2 := l_count___2 + 1
								l_scan := l_scan + 1
							end
						end
						l_break := False
					else
						l_cu := (l_opnd.item).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if l_count___2 < a_maxcount then
								if (l_scan.item).to_integer_32 /= l_cu then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_count___2 := l_count___2 + 1
								l_scan := l_scan + 1
							end
						end
						l_break := False
					end
					l_pos := -1 + 116 -- switch 1; break
				when 90 then -- switch 1, case 200
					l_cf := 0
					l_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_opnd])
					if l_len > 1 then
						if ((create {P_REGEXP_STATIC}).ireg_ic.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
								l_cf := (create {P_MBYTE_STATIC}).utf_fold (((create {P_MBYTE_STATIC}).utf_ptr2char (l_opnd)))
							end
						end
						from
						until
							not (not (l_return or l_break) and then (l_count___2 < a_maxcount))
						loop
							l_break := False
							l_i___0 := 0
							from
							until
								not (not (l_break) and then (l_i___0 < l_len))
							loop
								l_break := False
								if (l_opnd[l_i___0]).to_integer_32 /= (l_scan[l_i___0]).to_integer_32 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_i___0 := l_i___0 + 1
								end
							end
							l_break := False
							if l_i___0 < l_len then
								if not ((create {P_REGEXP_STATIC}).ireg_ic.item).to_boolean then
									l_break := True
								elseif not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									l_break := True
								elseif ((create {P_MBYTE_STATIC}).utf_fold (((create {P_MBYTE_STATIC}).utf_ptr2char (l_scan)))) /= l_cf then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_scan := l_scan + l_len
								l_count___2 := l_count___2 + 1
							end
						end
						l_break := False
					end
					l_pos := -1 + 116 -- switch 1; break
				when 91 then -- switch 1, case 21 | switch 1, case 51
					l_testval := 1
				when 92 then -- switch 1, case 22 | switch 1, case 52
					if not (not (l_break) and then (l_count___2 < a_maxcount)) then
						l_pos := -1 + 104 -- skip loop
					end
				when 93 then -- loop body:
						l_break := False
						if (l_scan.item).to_integer_32 /= 0 then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
							l_break := True
						elseif (a_p___0.item).to_integer_32 >= 50 then
							if (a_p___0.item).to_integer_32 <= 78 then
								if (create {P_REGEXP_STATIC}).reglnum.item > (create {P_REGEXP_STATIC}).reg_maxline.item then
									l_break := True
								elseif ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break) then
							reg_nextline
							l_scan := reginput.item
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						end
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 96 then -- else:
						if not (((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						if (l_scan.item).to_integer_32 = 10 then
							if (a_p___0.item).to_integer_32 >= 50 then
								if (a_p___0.item).to_integer_32 <= 78 then
									l_scan := l_scan + 1
								else
									l_pos := -1 + 99 -- goto _L___14
								end
							else
								l_pos := -1 + 99 -- goto _L___14
							end
						else
							l_pos := -1 + 99 -- goto _L___14
						end
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 99 then -- else: | _L___14:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						l_len___0 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_scan])
						if l_len___0 > 1 then
							if (((create {P_REGEXP_STATIC}).cstrchr (l_opnd, ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_scan])))).is_void) = l_testval.to_boolean then
								l_break := True
							end
							if not (l_return or l_break) then
								l_scan := l_scan + l_len___0
							end
						else
							l_pos := -1 + 102 -- goto _L___12
						end
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else: | _L___12:
						if (((create {P_REGEXP_STATIC}).cstrchr (l_opnd, (l_scan.item).to_integer_32)).is_void) = l_testval.to_boolean then
							l_break := True
						end
						if not (l_return or l_break) then
							l_scan := l_scan + 1
						end
				when 103 then -- if done | if done
						if not (l_return or l_break) then
							l_count___2 := l_count___2 + 1
						end
						l_pos := -1 + 92 -- back to loop condition
				when 104 then -- loop done
					l_break := False
					l_pos := -1 + 116 -- switch 1; break
				when 105 then -- switch 1, case 18
					if (l_break) then
						l_pos := -1 + 114 -- skip loop
					end
				when 106 then -- loop body:
						l_break := False
						if not (l_count___2 < a_maxcount) then
							l_pos := -1 + 112 -- skip if block
						end
				when 107 then -- if:
						if (l_scan.item).to_integer_32 /= 0 then
							l_pos := -1 + 110 -- skip if block
						end
				when 108 then -- if:
						if (create {P_REGEXP_STATIC}).reglnum.item <= (create {P_REGEXP_STATIC}).reg_maxline.item then
							if not ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
								if not (((create {P_REGEXP_STATIC}).reg_match.item).is_void) then
									l_pos := -1 + 110 -- goto _L___17
								end
							else
								l_pos := -1 + 110 -- goto _L___17
							end
						else
							l_pos := -1 + 110 -- goto _L___17
						end
				when 109 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 110 then -- else: | _L___17:
						if (l_scan.item).to_integer_32 = 10 then
							if not ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
				when 111 then -- if done | if block done, skip else block:
						l_pos := -1 + 113
				when 112 then -- else:
						l_break := True
				when 113 then
						if not (l_return or l_break) then
							l_count___2 := l_count___2 + 1
							if ((create {P_REGEXP_STATIC}).reg_line_lbr.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___20 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([reginput.item]))
								else
									l_tmp___20 := 1
								end
								reginput.item := reginput.item + l_tmp___20
							else
								reg_nextline
							end
							l_scan := reginput.item
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						end
						l_pos := -1 + 105 -- back to loop condition
				when 114 then -- loop done
					l_break := False
					l_pos := -1 + 116 -- switch 1; break
				when 115 then -- switch 1, default:;
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_re_corr.item)))))).do_nothing
					l_pos := -1 + 116 -- switch 1; break
				when 116 then -- switch 1, done:
					reginput.item := l_scan
					Result := l_count___2.to_integer_32
				when 117 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	reg_nextline
		do
			(create {P_REGEXP_STATIC}).reglnum.item := (create {P_REGEXP_STATIC}).reglnum.item + 1;
			(create {P_REGEXP_STATIC}).regline.item := (create {P_REGEXP_STATIC}).reg_getline ((create {P_REGEXP_STATIC}).reglnum.item)
			reginput.item := (create {P_REGEXP_STATIC}).regline.item;
			(create {P_MISC1_STATIC}).fast_breakcheck
		end

	save_subexpr (a_bp___0: CE_POINTER [PD_REGBEHIND_S])
		require
			not a_bp___0.is_void
		local
			l_i___0: INTEGER_32
		do
			a_bp___0.item.save_need_clear_subexpr := need_clear_subexpr.item
			if not need_clear_subexpr.item.to_boolean then
				l_i___0 := 0
				from
				until
					not (l_i___0 < 10)
				loop
					if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
						a_bp___0.item.save_start[l_i___0].se_u.pos := ((create {P_REGEXP_STATIC}).reg_startpos.item[l_i___0]).twin
						a_bp___0.item.save_end[l_i___0].se_u.pos := ((create {P_REGEXP_STATIC}).reg_endpos.item[l_i___0]).twin
					else
						a_bp___0.item.save_start[l_i___0].se_u.ptr := (create {P_REGEXP_STATIC}).reg_startp.item[l_i___0]
						a_bp___0.item.save_end[l_i___0].se_u.ptr := (create {P_REGEXP_STATIC}).reg_endp.item[l_i___0]
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	restore_subexpr (a_bp___0: CE_POINTER [PD_REGBEHIND_S])
		require
			not a_bp___0.is_void
		local
			l_i___0: INTEGER_32
		do
			need_clear_subexpr.item := a_bp___0.item.save_need_clear_subexpr
			if not need_clear_subexpr.item.to_boolean then
				l_i___0 := 0
				from
				until
					not (l_i___0 < 10)
				loop
					if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
						(create {P_REGEXP_STATIC}).reg_startpos.item[l_i___0] := (a_bp___0.item.save_start[l_i___0].se_u.pos).twin;
						(create {P_REGEXP_STATIC}).reg_endpos.item[l_i___0] := (a_bp___0.item.save_end[l_i___0].se_u.pos).twin
					else
						(create {P_REGEXP_STATIC}).reg_startp.item[l_i___0] := a_bp___0.item.save_start[l_i___0].se_u.ptr;
						(create {P_REGEXP_STATIC}).reg_endp.item[l_i___0] := a_bp___0.item.save_end[l_i___0].se_u.ptr
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	reg_save (a_save___0: CE_POINTER [PD_REGSAVE_T]; a_gap: CE_POINTER [PD_GROWARRAY])
		require
			not a_save___0.is_void
			not a_gap.is_void
		do
			if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
				a_save___0.item.rs_u.pos.col := reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item))
				a_save___0.item.rs_u.pos.lnum := (create {P_REGEXP_STATIC}).reglnum.item
			else
				a_save___0.item.rs_u.ptr := reginput.item
			end
			a_save___0.item.rs_len := a_gap.item.ga_len
		end

	reg_restore (a_save___0: CE_POINTER [PD_REGSAVE_T]; a_gap: CE_POINTER [PD_GROWARRAY])
		require
			not a_save___0.is_void
			not a_gap.is_void
		do
			if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
				if (create {P_REGEXP_STATIC}).reglnum.item /= a_save___0.item.rs_u.pos.lnum then
					(create {P_REGEXP_STATIC}).reglnum.item := a_save___0.item.rs_u.pos.lnum;
					(create {P_REGEXP_STATIC}).regline.item := (create {P_REGEXP_STATIC}).reg_getline ((create {P_REGEXP_STATIC}).reglnum.item)
				end
				reginput.item := (create {P_REGEXP_STATIC}).regline.item + a_save___0.item.rs_u.pos.col
			else
				reginput.item := a_save___0.item.rs_u.ptr
			end
			a_gap.item.ga_len := a_save___0.item.rs_len
		end

	reg_save_equal (a_save___0: CE_POINTER [PD_REGSAVE_T]): INTEGER_32
		require
			not a_save___0.is_void
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_REGEXP_STATIC}).reg_match.item).is_void then
				if (create {P_REGEXP_STATIC}).reglnum.item = a_save___0.item.rs_u.pos.lnum then
					if reginput.item.is_equal ((create {P_REGEXP_STATIC}).regline.item + a_save___0.item.rs_u.pos.col) then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
				Result := l_tmp
				l_return := True
			end
			if not l_return then
				Result := (reginput.item.is_equal (a_save___0.item.rs_u.ptr)).to_integer
			end
		end

	save_se_multi (a_savep: CE_POINTER [PD_SAVE_SE_T]; a_posp: CE_POINTER [PD_LPOS_T])
		require
			not a_savep.is_void
			not a_posp.is_void
		do
			a_savep.item.se_u.pos := (a_posp.item).twin
			a_posp.item.lnum := (create {P_REGEXP_STATIC}).reglnum.item
			a_posp.item.col := reginput.item.distance (((create {P_REGEXP_STATIC}).regline.item))
		end

	save_se_one (a_savep: CE_POINTER [PD_SAVE_SE_T]; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]])
		require
			not a_savep.is_void
			not a_pp.is_void
		do
			a_savep.item.se_u.ptr := a_pp.item
			a_pp.item := reginput.item
		end

	re_num_cmp (a_val___0: NATURAL_32; a_scan: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_scan.is_void
		local
			l_n: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := ((((((a_scan[3]).to_integer_32).bit_shift_left (24)) + (((a_scan[4]).to_integer_32).bit_shift_left (16))) + (((a_scan[5]).to_integer_32).bit_shift_left (8))) + (a_scan[6]).to_integer_32).to_natural_32
			if (a_scan[7]).to_integer_32 = 62 then
				Result := (a_val___0 > l_n).to_integer
				l_return := True
			end
			if not l_return and then ((a_scan[7]).to_integer_32 = 60) then
				Result := (a_val___0 < l_n).to_integer
				l_return := True
			end
			if not l_return then
				Result := (a_val___0 = l_n).to_integer
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			regstart := a_other.regstart
			reganch := a_other.reganch
			regmust := a_other.regmust
			regmlen := a_other.regmlen
			regflags := a_other.regflags
			reghasz := a_other.reghasz
			program := a_other.program.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				regstart = a_other.regstart and
				reganch = a_other.reganch and
				regmust.is_equal (a_other.regmust) and
				regmlen = a_other.regmlen and
				regflags = a_other.regflags and
				reghasz = a_other.reghasz and
				program.is_equal (a_other.program)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("regstart"),
					create {CE_STRUCTURE_FIELD}.make ("reganch"),
					create {CE_STRUCTURE_FIELD}.make ("regmust"),
					create {CE_STRUCTURE_FIELD}.make ("regmlen"),
					create {CE_STRUCTURE_FIELD}.make ("regflags"),
					create {CE_STRUCTURE_FIELD}.make ("reghasz"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("program", <<1>>)
				>>)
			init_structure_info
		end

end
