class
	PD_SCRIPTITEM_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} sn_name.make
		end

feature {ANY} -- fields

	sn_name: CE_POINTER [NATURAL_8] assign set_sn_name

	sn_dev_valid: INTEGER_32 assign set_sn_dev_valid

	sn_dev: NATURAL_64 assign set_sn_dev

	sn_ino: NATURAL_32 assign set_sn_ino

feature {ANY} -- field setters

	set_sn_name (a_sn_name: CE_POINTER [NATURAL_8])
		do
			sn_name := a_sn_name
			update_memory_field ("sn_name")
		end

	set_sn_dev_valid (a_sn_dev_valid: INTEGER_32)
		do
			sn_dev_valid := a_sn_dev_valid
			update_memory_field ("sn_dev_valid")
		end

	set_sn_dev (a_sn_dev: NATURAL_64)
		do
			sn_dev := a_sn_dev
			update_memory_field ("sn_dev")
		end

	set_sn_ino (a_sn_ino: NATURAL_32)
		do
			sn_ino := a_sn_ino
			update_memory_field ("sn_ino")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sn_name := a_other.sn_name
			sn_dev_valid := a_other.sn_dev_valid
			sn_dev := a_other.sn_dev
			sn_ino := a_other.sn_ino
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sn_name.is_equal (a_other.sn_name) and
				sn_dev_valid = a_other.sn_dev_valid and
				sn_dev = a_other.sn_dev and
				sn_ino = a_other.sn_ino
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sn_name"),
					create {CE_STRUCTURE_FIELD}.make ("sn_dev_valid"),
					create {CE_STRUCTURE_FIELD}.make ("sn_dev"),
					create {CE_STRUCTURE_FIELD}.make ("sn_ino")
				>>)
			init_structure_info
		end

end
