class
	PD_SERVERREPLY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create strings.make
		end

feature {ANY} -- fields

	id: NATURAL_32 assign set_id

	strings: PD_GROWARRAY assign set_strings

feature {ANY} -- field setters

	set_id (a_id: NATURAL_32)
		do
			id := a_id
			update_memory_field ("id")
		end

	set_strings (a_strings: PD_GROWARRAY)
		do
			strings := a_strings
			update_memory_field ("strings")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			id := a_other.id
			strings := a_other.strings.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				id = a_other.id and
				strings.is_equal (a_other.strings)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("id"),
					create {CE_STRUCTURE_FIELD}.make ("strings")
				>>)
			init_structure_info
		end

end
