class
	PD_SIGN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SIGN]} sn_next.make
			create {CE_NATURAL_8_POINTER} sn_name.make
			create {CE_NATURAL_8_POINTER} sn_icon.make
			create {CE_VOID_POINTER} sn_image.make
			create {CE_NATURAL_8_POINTER} sn_text.make
		end

feature {ANY} -- fields

	sn_next: CE_POINTER [PD_SIGN] assign set_sn_next

	sn_typenr: INTEGER_32 assign set_sn_typenr

	sn_name: CE_POINTER [NATURAL_8] assign set_sn_name

	sn_icon: CE_POINTER [NATURAL_8] assign set_sn_icon

	sn_image: CE_POINTER [ANY] assign set_sn_image

	sn_text: CE_POINTER [NATURAL_8] assign set_sn_text

	sn_line_hl: INTEGER_32 assign set_sn_line_hl

	sn_text_hl: INTEGER_32 assign set_sn_text_hl

feature {ANY} -- field setters

	set_sn_next (a_sn_next: CE_POINTER [PD_SIGN])
		do
			sn_next := a_sn_next
			update_memory_field ("sn_next")
		end

	set_sn_typenr (a_sn_typenr: INTEGER_32)
		do
			sn_typenr := a_sn_typenr
			update_memory_field ("sn_typenr")
		end

	set_sn_name (a_sn_name: CE_POINTER [NATURAL_8])
		do
			sn_name := a_sn_name
			update_memory_field ("sn_name")
		end

	set_sn_icon (a_sn_icon: CE_POINTER [NATURAL_8])
		do
			sn_icon := a_sn_icon
			update_memory_field ("sn_icon")
		end

	set_sn_image (a_sn_image: CE_POINTER [ANY])
		do
			sn_image := a_sn_image
			update_memory_field ("sn_image")
		end

	set_sn_text (a_sn_text: CE_POINTER [NATURAL_8])
		do
			sn_text := a_sn_text
			update_memory_field ("sn_text")
		end

	set_sn_line_hl (a_sn_line_hl: INTEGER_32)
		do
			sn_line_hl := a_sn_line_hl
			update_memory_field ("sn_line_hl")
		end

	set_sn_text_hl (a_sn_text_hl: INTEGER_32)
		do
			sn_text_hl := a_sn_text_hl
			update_memory_field ("sn_text_hl")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sn_next := a_other.sn_next
			sn_typenr := a_other.sn_typenr
			sn_name := a_other.sn_name
			sn_icon := a_other.sn_icon
			sn_image := a_other.sn_image
			sn_text := a_other.sn_text
			sn_line_hl := a_other.sn_line_hl
			sn_text_hl := a_other.sn_text_hl
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sn_next.is_equal (a_other.sn_next) and
				sn_typenr = a_other.sn_typenr and
				sn_name.is_equal (a_other.sn_name) and
				sn_icon.is_equal (a_other.sn_icon) and
				sn_image.is_equal (a_other.sn_image) and
				sn_text.is_equal (a_other.sn_text) and
				sn_line_hl = a_other.sn_line_hl and
				sn_text_hl = a_other.sn_text_hl
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sn_next"),
					create {CE_STRUCTURE_FIELD}.make ("sn_typenr"),
					create {CE_STRUCTURE_FIELD}.make ("sn_name"),
					create {CE_STRUCTURE_FIELD}.make ("sn_icon"),
					create {CE_STRUCTURE_FIELD}.make ("sn_image"),
					create {CE_STRUCTURE_FIELD}.make ("sn_text"),
					create {CE_STRUCTURE_FIELD}.make ("sn_line_hl"),
					create {CE_STRUCTURE_FIELD}.make ("sn_text_hl")
				>>)
			init_structure_info
		end

end
