class
	PD_SPAT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} pat.make
			create off.make
		end

feature {ANY} -- fields

	pat: CE_POINTER [NATURAL_8] assign set_pat

	magic: INTEGER_32 assign set_magic

	no_scs: INTEGER_32 assign set_no_scs

	off: PD_SOFFSET assign set_off

feature {ANY} -- field setters

	set_pat (a_pat: CE_POINTER [NATURAL_8])
		do
			pat := a_pat
			update_memory_field ("pat")
		end

	set_magic (a_magic: INTEGER_32)
		do
			magic := a_magic
			update_memory_field ("magic")
		end

	set_no_scs (a_no_scs: INTEGER_32)
		do
			no_scs := a_no_scs
			update_memory_field ("no_scs")
		end

	set_off (a_off: PD_SOFFSET)
		do
			off := a_off
			update_memory_field ("off")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pat := a_other.pat
			magic := a_other.magic
			no_scs := a_other.no_scs
			off := a_other.off.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pat.is_equal (a_other.pat) and
				magic = a_other.magic and
				no_scs = a_other.no_scs and
				off.is_equal (a_other.off)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pat"),
					create {CE_STRUCTURE_FIELD}.make ("magic"),
					create {CE_STRUCTURE_FIELD}.make ("no_scs"),
					create {CE_STRUCTURE_FIELD}.make ("off")
				>>)
			init_structure_info
		end

end
