class
	PD_SYN_STATE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_SYN_STATE]} sst_next.make
			create sst_union.make
			create {CE_INTEGER_16_POINTER} sst_next_list.make
		end

feature {ANY} -- fields

	sst_next: CE_POINTER [PD_SYN_STATE] assign set_sst_next

	sst_lnum: INTEGER_32 assign set_sst_lnum

	sst_union: PD_SST_UNION assign set_sst_union

	sst_next_flags: INTEGER_32 assign set_sst_next_flags

	sst_stacksize: INTEGER_32 assign set_sst_stacksize

	sst_next_list: CE_POINTER [INTEGER_16] assign set_sst_next_list

	sst_tick: NATURAL_16 assign set_sst_tick

	sst_change_lnum: INTEGER_32 assign set_sst_change_lnum

feature {ANY} -- field setters

	set_sst_next (a_sst_next: CE_POINTER [PD_SYN_STATE])
		do
			sst_next := a_sst_next
			update_memory_field ("sst_next")
		end

	set_sst_lnum (a_sst_lnum: INTEGER_32)
		do
			sst_lnum := a_sst_lnum
			update_memory_field ("sst_lnum")
		end

	set_sst_union (a_sst_union: PD_SST_UNION)
		do
			sst_union := a_sst_union
			update_memory_field ("sst_union")
		end

	set_sst_next_flags (a_sst_next_flags: INTEGER_32)
		do
			sst_next_flags := a_sst_next_flags
			update_memory_field ("sst_next_flags")
		end

	set_sst_stacksize (a_sst_stacksize: INTEGER_32)
		do
			sst_stacksize := a_sst_stacksize
			update_memory_field ("sst_stacksize")
		end

	set_sst_next_list (a_sst_next_list: CE_POINTER [INTEGER_16])
		do
			sst_next_list := a_sst_next_list
			update_memory_field ("sst_next_list")
		end

	set_sst_tick (a_sst_tick: NATURAL_16)
		do
			sst_tick := a_sst_tick
			update_memory_field ("sst_tick")
		end

	set_sst_change_lnum (a_sst_change_lnum: INTEGER_32)
		do
			sst_change_lnum := a_sst_change_lnum
			update_memory_field ("sst_change_lnum")
		end

feature {ANY} -- public routines

	clear_syn_state
		local
			l_i___0: INTEGER_32
			l_gap: CE_POINTER [PD_GROWARRAY]
		do
			if sst_stacksize > 7 then
				l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_shared (c_pointer + (create {PD_SYN_STATE}.make).offset_of ("sst_union") + (create {PD_SST_UNION}.make).offset_of ("sst_ga"))
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_gap.item.ga_len)
				loop
					(create {P_REGEXP_STATIC}).unref_extmatch ((create {CE_CLASS_POINTER [PD_BUF_STATE]}.make_cast (l_gap.item.ga_data) + l_i___0).item.bs_extmatch)
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
				l_gap.item.ga_clear
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i___0 := 0
				from
				until
					not (l_i___0 < sst_stacksize)
				loop
					(create {P_REGEXP_STATIC}).unref_extmatch (sst_union.sst_stack[l_i___0].bs_extmatch)
					update_class_fields -- Current might have been changed; synchronize
					l_i___0 := l_i___0 + 1
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sst_next := a_other.sst_next
			sst_lnum := a_other.sst_lnum
			sst_union := a_other.sst_union.twin
			sst_next_flags := a_other.sst_next_flags
			sst_stacksize := a_other.sst_stacksize
			sst_next_list := a_other.sst_next_list
			sst_tick := a_other.sst_tick
			sst_change_lnum := a_other.sst_change_lnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sst_next.is_equal (a_other.sst_next) and
				sst_lnum = a_other.sst_lnum and
				sst_union.is_equal (a_other.sst_union) and
				sst_next_flags = a_other.sst_next_flags and
				sst_stacksize = a_other.sst_stacksize and
				sst_next_list.is_equal (a_other.sst_next_list) and
				sst_tick = a_other.sst_tick and
				sst_change_lnum = a_other.sst_change_lnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sst_next"),
					create {CE_STRUCTURE_FIELD}.make ("sst_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("sst_union"),
					create {CE_STRUCTURE_FIELD}.make ("sst_next_flags"),
					create {CE_STRUCTURE_FIELD}.make ("sst_stacksize"),
					create {CE_STRUCTURE_FIELD}.make ("sst_next_list"),
					create {CE_STRUCTURE_FIELD}.make ("sst_tick"),
					create {CE_STRUCTURE_FIELD}.make ("sst_change_lnum")
				>>)
			init_structure_info
		end

end
