class
	PD_TAG_POINTERS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} tagname.make
			create {CE_NATURAL_8_POINTER} tagname_end.make
			create {CE_NATURAL_8_POINTER} fname.make
			create {CE_NATURAL_8_POINTER} fname_end.make
			create {CE_NATURAL_8_POINTER} command.make
			create {CE_NATURAL_8_POINTER} command_end.make
			create {CE_NATURAL_8_POINTER} tag_fname.make
			create {CE_NATURAL_8_POINTER} tagkind.make
			create {CE_NATURAL_8_POINTER} tagkind_end.make
			Precursor
		end

feature {ANY} -- fields

	tagname: CE_POINTER [NATURAL_8] assign set_tagname

	tagname_end: CE_POINTER [NATURAL_8] assign set_tagname_end

	fname: CE_POINTER [NATURAL_8] assign set_fname

	fname_end: CE_POINTER [NATURAL_8] assign set_fname_end

	command: CE_POINTER [NATURAL_8] assign set_command

	command_end: CE_POINTER [NATURAL_8] assign set_command_end

	tag_fname: CE_POINTER [NATURAL_8] assign set_tag_fname

	tagkind: CE_POINTER [NATURAL_8] assign set_tagkind

	tagkind_end: CE_POINTER [NATURAL_8] assign set_tagkind_end

feature {ANY} -- field setters

	set_tagname (a_tagname: CE_POINTER [NATURAL_8])
		do
			tagname := a_tagname
			update_memory_field ("tagname")
		end

	set_tagname_end (a_tagname_end: CE_POINTER [NATURAL_8])
		do
			tagname_end := a_tagname_end
			update_memory_field ("tagname_end")
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			fname := a_fname
			update_memory_field ("fname")
		end

	set_fname_end (a_fname_end: CE_POINTER [NATURAL_8])
		do
			fname_end := a_fname_end
			update_memory_field ("fname_end")
		end

	set_command (a_command: CE_POINTER [NATURAL_8])
		do
			command := a_command
			update_memory_field ("command")
		end

	set_command_end (a_command_end: CE_POINTER [NATURAL_8])
		do
			command_end := a_command_end
			update_memory_field ("command_end")
		end

	set_tag_fname (a_tag_fname: CE_POINTER [NATURAL_8])
		do
			tag_fname := a_tag_fname
			update_memory_field ("tag_fname")
		end

	set_tagkind (a_tagkind: CE_POINTER [NATURAL_8])
		do
			tagkind := a_tagkind
			update_memory_field ("tagkind")
		end

	set_tagkind_end (a_tagkind_end: CE_POINTER [NATURAL_8])
		do
			tagkind_end := a_tagkind_end
			update_memory_field ("tagkind_end")
		end

feature {ANY} -- public routines

	parse_tag_line (a_lbuf: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_lbuf.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			Current.tagname := a_lbuf
			update_class_fields -- Current might have been changed; synchronize
			l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (a_lbuf, ('%T').code)
			update_class_fields -- Current might have been changed; synchronize
			if l_p___0.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				Current.tagname_end := l_p___0
				update_class_fields -- Current might have been changed; synchronize
				if (l_p___0.item).to_integer_32 /= 0 then
					l_p___0 := l_p___0 + 1
				end
				Current.fname := l_p___0
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('%T').code)
				update_class_fields -- Current might have been changed; synchronize
				if l_p___0.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Current.fname_end := l_p___0
				update_class_fields -- Current might have been changed; synchronize
				if (l_p___0.item).to_integer_32 /= 0 then
					l_p___0 := l_p___0 + 1
				end
				if (l_p___0.item).to_integer_32 = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Current.command := l_p___0
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	test_for_static: INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_len := fname_end.distance (fname)
			l_p___0 := tagname + l_len
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (tagname_end.c_pointer.to_integer_32).to_natural_32 then
				if (l_p___0.item).to_integer_32 = 58 then
					l_tmp := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (tagname), create {CE_INTEGER_8_POINTER}.make_cast (fname), l_len.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp = 0 then
						Current.tagname := l_p___0 + 1
						update_class_fields -- Current might have been changed; synchronize
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				l_p___0 := command
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('%T').code)
					update_class_fields -- Current might have been changed; synchronize
					if l_p___0.is_void then
						l_break := True
					end
					if not (l_return or l_break) then
						l_p___0 := l_p___0 + 1
						l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("file:"), (5).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 = 0 then
							Result := 1
							l_return := True
						end
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

	parse_match (a_lbuf: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_lbuf.is_void
		local
			l_lbuf: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pc: CE_POINTER [NATURAL_8]
			l_pt: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_pt.make

			l_lbuf := a_lbuf
			Current.tag_fname := l_lbuf + 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (tag_fname))
			update_class_fields -- Current might have been changed; synchronize
			l_lbuf := l_lbuf + (l_tmp + {NATURAL_32} 2).to_integer_32
			l_retval := ((create {CE_CLASS_POINTER [PD_TAG_POINTERS]}.make_shared (c_pointer))).item.parse_tag_line (l_lbuf)
			update_class_fields -- Current might have been changed; synchronize
			Current.tagkind := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.command_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			if l_retval = 1 then
				l_p___0.item := command
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := (create {P_TAG_STATIC}).find_extra (l_p___0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3 = 1 then
					Current.command_end := l_p___0.item
					update_class_fields -- Current might have been changed; synchronize
					l_p___0.item := l_p___0.item + (2)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_p___0.item
					l_p___0.item := l_p___0.item + 1
					update_class_fields -- Current might have been changed; synchronize
					if (l_tmp___2.item).to_integer_32 = 9 then
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item.item).to_integer_32 < 127 then
								l_tmp___1 := ctype_b_loc
								update_class_fields -- Current might have been changed; synchronize
								if not (((l_tmp___1.item[(l_p___0.item.item).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("kind:"), (5).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___0 = 0 then
									Current.tagkind := l_p___0.item + 5
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
							end
							if not (l_break) then
								l_pc := (create {P_MISC2_STATIC}).vim_strchr (l_p___0.item, (':').code)
								update_class_fields -- Current might have been changed; synchronize
								l_pt := (create {P_MISC2_STATIC}).vim_strchr (l_p___0.item, ('%T').code)
								update_class_fields -- Current might have been changed; synchronize
								if l_pc.is_void then
									Current.tagkind := l_p___0.item
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								elseif not l_pt.is_void then
									if (l_pc.c_pointer.to_integer_32).to_natural_32 > (l_pt.c_pointer.to_integer_32).to_natural_32 then
										Current.tagkind := l_p___0.item
										update_class_fields -- Current might have been changed; synchronize
										l_break := True
									end
								end
							end
							if not (l_break) and then (l_pt.is_void) then
								l_break := True
							end
							if not (l_break) then
								l_p___0.item := l_pt + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
					end
				end
				if not tagkind.is_void then
					l_p___0.item := tagkind
					update_class_fields -- Current might have been changed; synchronize
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item.item).to_boolean then
							if (l_p___0.item.item).to_integer_32 /= 9 then
								if (l_p___0.item.item).to_integer_32 /= 13 then
									if (l_p___0.item.item).to_integer_32 = 10 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_p___0.item := l_p___0.item + 1
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_break := False
					Current.tagkind_end := l_p___0.item
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			Result := l_retval
		end

	tag_full_fname: CE_POINTER [NATURAL_8]
		local
			l_fullname: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
		do
			l_c := (fname_end.item).to_integer_32
			fname_end.item := (('%/0/').code).to_natural_8
			update_class_fields -- Current might have been changed; synchronize
			l_fullname := (create {P_TAG_STATIC}).expand_tag_fname (fname, tag_fname, 0)
			update_class_fields -- Current might have been changed; synchronize
			fname_end.item := l_c.to_natural_8
			update_class_fields -- Current might have been changed; synchronize
			Result := l_fullname
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tagname := a_other.tagname
			tagname_end := a_other.tagname_end
			fname := a_other.fname
			fname_end := a_other.fname_end
			command := a_other.command
			command_end := a_other.command_end
			tag_fname := a_other.tag_fname
			tagkind := a_other.tagkind
			tagkind_end := a_other.tagkind_end
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tagname.is_equal (a_other.tagname) and
				tagname_end.is_equal (a_other.tagname_end) and
				fname.is_equal (a_other.fname) and
				fname_end.is_equal (a_other.fname_end) and
				command.is_equal (a_other.command) and
				command_end.is_equal (a_other.command_end) and
				tag_fname.is_equal (a_other.tag_fname) and
				tagkind.is_equal (a_other.tagkind) and
				tagkind_end.is_equal (a_other.tagkind_end)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tagname"),
					create {CE_STRUCTURE_FIELD}.make ("tagname_end"),
					create {CE_STRUCTURE_FIELD}.make ("fname"),
					create {CE_STRUCTURE_FIELD}.make ("fname_end"),
					create {CE_STRUCTURE_FIELD}.make ("command"),
					create {CE_STRUCTURE_FIELD}.make ("command_end"),
					create {CE_STRUCTURE_FIELD}.make ("tag_fname"),
					create {CE_STRUCTURE_FIELD}.make ("tagkind"),
					create {CE_STRUCTURE_FIELD}.make ("tagkind_end")
				>>)
			init_structure_info
		end

end
