class
	PD_TAG_SEARCH_INFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	low_offset: INTEGER_32 assign set_low_offset

	high_offset: INTEGER_32 assign set_high_offset

	curr_offset: INTEGER_32 assign set_curr_offset

	curr_offset_used: INTEGER_32 assign set_curr_offset_used

	match_offset: INTEGER_32 assign set_match_offset

	low_char: INTEGER_32 assign set_low_char

	high_char: INTEGER_32 assign set_high_char

feature {ANY} -- field setters

	set_low_offset (a_low_offset: INTEGER_32)
		do
			low_offset := a_low_offset
			update_memory_field ("low_offset")
		end

	set_high_offset (a_high_offset: INTEGER_32)
		do
			high_offset := a_high_offset
			update_memory_field ("high_offset")
		end

	set_curr_offset (a_curr_offset: INTEGER_32)
		do
			curr_offset := a_curr_offset
			update_memory_field ("curr_offset")
		end

	set_curr_offset_used (a_curr_offset_used: INTEGER_32)
		do
			curr_offset_used := a_curr_offset_used
			update_memory_field ("curr_offset_used")
		end

	set_match_offset (a_match_offset: INTEGER_32)
		do
			match_offset := a_match_offset
			update_memory_field ("match_offset")
		end

	set_low_char (a_low_char: INTEGER_32)
		do
			low_char := a_low_char
			update_memory_field ("low_char")
		end

	set_high_char (a_high_char: INTEGER_32)
		do
			high_char := a_high_char
			update_memory_field ("high_char")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			low_offset := a_other.low_offset
			high_offset := a_other.high_offset
			curr_offset := a_other.curr_offset
			curr_offset_used := a_other.curr_offset_used
			match_offset := a_other.match_offset
			low_char := a_other.low_char
			high_char := a_other.high_char
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				low_offset = a_other.low_offset and
				high_offset = a_other.high_offset and
				curr_offset = a_other.curr_offset and
				curr_offset_used = a_other.curr_offset_used and
				match_offset = a_other.match_offset and
				low_char = a_other.low_char and
				high_char = a_other.high_char
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("low_offset"),
					create {CE_STRUCTURE_FIELD}.make ("high_offset"),
					create {CE_STRUCTURE_FIELD}.make ("curr_offset"),
					create {CE_STRUCTURE_FIELD}.make ("curr_offset_used"),
					create {CE_STRUCTURE_FIELD}.make ("match_offset"),
					create {CE_STRUCTURE_FIELD}.make ("low_char"),
					create {CE_STRUCTURE_FIELD}.make ("high_char")
				>>)
			init_structure_info
		end

end
