class
	PD_TASAVE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create save_typebuf.make
			create save_stuffbuff.make
			create {CE_NATURAL_8_POINTER} save_inputbuf.make
			Precursor
		end

feature {ANY} -- fields

	save_typebuf: PD_TYPEBUF_T assign set_save_typebuf

	typebuf_valid: INTEGER_32 assign set_typebuf_valid

	old_char: INTEGER_32 assign set_old_char

	old_mod_mask: INTEGER_32 assign set_old_mod_mask

	save_stuffbuff: PD_BUFFHEADER assign set_save_stuffbuff

	save_inputbuf: CE_POINTER [NATURAL_8] assign set_save_inputbuf

feature {ANY} -- field setters

	set_save_typebuf (a_save_typebuf: PD_TYPEBUF_T)
		do
			save_typebuf := a_save_typebuf
			update_memory_field ("save_typebuf")
		end

	set_typebuf_valid (a_typebuf_valid: INTEGER_32)
		do
			typebuf_valid := a_typebuf_valid
			update_memory_field ("typebuf_valid")
		end

	set_old_char (a_old_char: INTEGER_32)
		do
			old_char := a_old_char
			update_memory_field ("old_char")
		end

	set_old_mod_mask (a_old_mod_mask: INTEGER_32)
		do
			old_mod_mask := a_old_mod_mask
			update_memory_field ("old_mod_mask")
		end

	set_save_stuffbuff (a_save_stuffbuff: PD_BUFFHEADER)
		do
			save_stuffbuff := a_save_stuffbuff
			update_memory_field ("save_stuffbuff")
		end

	set_save_inputbuf (a_save_inputbuf: CE_POINTER [NATURAL_8])
		do
			save_inputbuf := a_save_inputbuf
			update_memory_field ("save_inputbuf")
		end

feature {ANY} -- public routines

	save_typeahead
		local
			l_tmp: INTEGER_32
		do
			Current.save_typebuf := ((create {P_GLOBALS_STATIC}).typebuf.item).twin
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := (create {P_GETCHAR_STATIC}).alloc_typebuf
			update_class_fields -- Current might have been changed; synchronize
			Current.typebuf_valid := (l_tmp = 1).to_integer
			update_class_fields -- Current might have been changed; synchronize
			if not typebuf_valid.to_boolean then
				(create {P_GLOBALS_STATIC}).typebuf.item := save_typebuf.twin
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.old_char := (create {P_GETCHAR_STATIC}).old_char.item
			update_class_fields -- Current might have been changed; synchronize
			Current.old_mod_mask := (create {P_GETCHAR_STATIC}).old_mod_mask.item
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GETCHAR_STATIC}).old_char.item := -1
			update_class_fields -- Current might have been changed; synchronize
			Current.save_stuffbuff := ((create {P_GLOBALS_STATIC}).stuffbuff.item.item).twin
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).stuffbuff.item.item.bh_first.b_next := create {CE_CLASS_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.save_inputbuf := get_input_buf
			update_class_fields -- Current might have been changed; synchronize
		end

	restore_typeahead
		do
			if typebuf_valid.to_boolean then
				(create {P_GETCHAR_STATIC}).free_typebuf
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).typebuf.item := save_typebuf.twin
				update_class_fields -- Current might have been changed; synchronize
			end
			(create {P_GETCHAR_STATIC}).old_char.item := old_char
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GETCHAR_STATIC}).old_mod_mask.item := old_mod_mask
			update_class_fields; -- Current might have been changed; synchronize
			((create {P_GLOBALS_STATIC}).stuffbuff.item).item.free_buff
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GLOBALS_STATIC}).stuffbuff.item.item := save_stuffbuff.twin
			update_class_fields -- Current might have been changed; synchronize
			set_input_buf (save_inputbuf)
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_TASAVE_T} -- private routines

	get_input_buf: CE_POINTER [NATURAL_8]
		local
			l_gap: CE_POINTER [PD_GROWARRAY]
		do
			l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_cast (((create {P_MISC2_STATIC}).alloc ((create {PD_GROWARRAY}.make).structure_size.to_natural_32)))
			if not l_gap.is_void then
				l_gap.item.ga_data := create {CE_VOID_POINTER}.make_cast (((create {P_MISC2_STATIC}).alloc (((create {P_UI_STATIC}).inbufcount.item).to_natural_32 + {NATURAL_32} 1)))
				if not (l_gap.item.ga_data).is_void then
					memmove (l_gap.item.ga_data, create {CE_VOID_POINTER}.make_cast (((create {P_UI_STATIC}).inbuf.item)), ((create {P_UI_STATIC}).inbufcount.item).to_natural_32).do_nothing
				end
				l_gap.item.ga_len := (create {P_UI_STATIC}).inbufcount.item
			end
			(create {P_UI_STATIC}).trash_input_buf
			Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_gap))
		end

	set_input_buf (a_p___0: CE_POINTER [NATURAL_8])
		local
			l_gap: CE_POINTER [PD_GROWARRAY]
		do
			l_gap := create {CE_CLASS_POINTER [PD_GROWARRAY]}.make_cast (a_p___0)
			if not l_gap.is_void then
				if not (l_gap.item.ga_data).is_void then
					memmove (create {CE_VOID_POINTER}.make_cast (((create {P_UI_STATIC}).inbuf.item)), l_gap.item.ga_data, (l_gap.item.ga_len).to_natural_32).do_nothing;
					(create {P_UI_STATIC}).inbufcount.item := l_gap.item.ga_len;
					(create {P_MISC2_STATIC}).vim_free (l_gap.item.ga_data)
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_gap))
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			save_typebuf := a_other.save_typebuf.twin
			typebuf_valid := a_other.typebuf_valid
			old_char := a_other.old_char
			old_mod_mask := a_other.old_mod_mask
			save_stuffbuff := a_other.save_stuffbuff.twin
			save_inputbuf := a_other.save_inputbuf
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				save_typebuf.is_equal (a_other.save_typebuf) and
				typebuf_valid = a_other.typebuf_valid and
				old_char = a_other.old_char and
				old_mod_mask = a_other.old_mod_mask and
				save_stuffbuff.is_equal (a_other.save_stuffbuff) and
				save_inputbuf.is_equal (a_other.save_inputbuf)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("save_typebuf"),
					create {CE_STRUCTURE_FIELD}.make ("typebuf_valid"),
					create {CE_STRUCTURE_FIELD}.make ("old_char"),
					create {CE_STRUCTURE_FIELD}.make ("old_mod_mask"),
					create {CE_STRUCTURE_FIELD}.make ("save_stuffbuff"),
					create {CE_STRUCTURE_FIELD}.make ("save_inputbuf")
				>>)
			init_structure_info
		end

end
