class
	PD_TYPEBUF_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} tb_buf.make
			create {CE_NATURAL_8_POINTER} tb_noremap.make
		end

feature {ANY} -- fields

	tb_buf: CE_POINTER [NATURAL_8] assign set_tb_buf

	tb_noremap: CE_POINTER [NATURAL_8] assign set_tb_noremap

	tb_buflen: INTEGER_32 assign set_tb_buflen

	tb_off: INTEGER_32 assign set_tb_off

	tb_len: INTEGER_32 assign set_tb_len

	tb_maplen: INTEGER_32 assign set_tb_maplen

	tb_silent: INTEGER_32 assign set_tb_silent

	tb_no_abbr_cnt: INTEGER_32 assign set_tb_no_abbr_cnt

	tb_change_cnt: INTEGER_32 assign set_tb_change_cnt

feature {ANY} -- field setters

	set_tb_buf (a_tb_buf: CE_POINTER [NATURAL_8])
		do
			tb_buf := a_tb_buf
			update_memory_field ("tb_buf")
		end

	set_tb_noremap (a_tb_noremap: CE_POINTER [NATURAL_8])
		do
			tb_noremap := a_tb_noremap
			update_memory_field ("tb_noremap")
		end

	set_tb_buflen (a_tb_buflen: INTEGER_32)
		do
			tb_buflen := a_tb_buflen
			update_memory_field ("tb_buflen")
		end

	set_tb_off (a_tb_off: INTEGER_32)
		do
			tb_off := a_tb_off
			update_memory_field ("tb_off")
		end

	set_tb_len (a_tb_len: INTEGER_32)
		do
			tb_len := a_tb_len
			update_memory_field ("tb_len")
		end

	set_tb_maplen (a_tb_maplen: INTEGER_32)
		do
			tb_maplen := a_tb_maplen
			update_memory_field ("tb_maplen")
		end

	set_tb_silent (a_tb_silent: INTEGER_32)
		do
			tb_silent := a_tb_silent
			update_memory_field ("tb_silent")
		end

	set_tb_no_abbr_cnt (a_tb_no_abbr_cnt: INTEGER_32)
		do
			tb_no_abbr_cnt := a_tb_no_abbr_cnt
			update_memory_field ("tb_no_abbr_cnt")
		end

	set_tb_change_cnt (a_tb_change_cnt: INTEGER_32)
		do
			tb_change_cnt := a_tb_change_cnt
			update_memory_field ("tb_change_cnt")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tb_buf := a_other.tb_buf
			tb_noremap := a_other.tb_noremap
			tb_buflen := a_other.tb_buflen
			tb_off := a_other.tb_off
			tb_len := a_other.tb_len
			tb_maplen := a_other.tb_maplen
			tb_silent := a_other.tb_silent
			tb_no_abbr_cnt := a_other.tb_no_abbr_cnt
			tb_change_cnt := a_other.tb_change_cnt
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tb_buf.is_equal (a_other.tb_buf) and
				tb_noremap.is_equal (a_other.tb_noremap) and
				tb_buflen = a_other.tb_buflen and
				tb_off = a_other.tb_off and
				tb_len = a_other.tb_len and
				tb_maplen = a_other.tb_maplen and
				tb_silent = a_other.tb_silent and
				tb_no_abbr_cnt = a_other.tb_no_abbr_cnt and
				tb_change_cnt = a_other.tb_change_cnt
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tb_buf"),
					create {CE_STRUCTURE_FIELD}.make ("tb_noremap"),
					create {CE_STRUCTURE_FIELD}.make ("tb_buflen"),
					create {CE_STRUCTURE_FIELD}.make ("tb_off"),
					create {CE_STRUCTURE_FIELD}.make ("tb_len"),
					create {CE_STRUCTURE_FIELD}.make ("tb_maplen"),
					create {CE_STRUCTURE_FIELD}.make ("tb_silent"),
					create {CE_STRUCTURE_FIELD}.make ("tb_no_abbr_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("tb_change_cnt")
				>>)
			init_structure_info
		end

end
