class
	PD_VIMCLIPBOARD

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_X11_INTRINSIC_STATIC
		redefine
			copy,
			is_equal
		end
	S_X11_XLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_GTK_GTK_STATIC
		redefine
			copy,
			is_equal
		end
	S_TIME_STATIC
		redefine
			copy,
			is_equal
		end
	S_GDK_GDK_STATIC
		redefine
			copy,
			is_equal
		end
	S_GLIB_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create start.make
			create end2.make
			create prev.make
			create {CE_VOID_POINTER} gtk_sel_atom.make
			Precursor
		end

feature {ANY} -- fields

	available: INTEGER_32 assign set_available

	owned: INTEGER_32 assign set_owned

	start: PD_POS_T assign set_start

	end2: PD_POS_T assign set_end2

	vmode: INTEGER_32 assign set_vmode

	origin_row: NATURAL_16 assign set_origin_row

	origin_start_col: NATURAL_16 assign set_origin_start_col

	origin_end_col: NATURAL_16 assign set_origin_end_col

	word_start_col: NATURAL_16 assign set_word_start_col

	word_end_col: NATURAL_16 assign set_word_end_col

	prev: PD_POS_T assign set_prev

	state: NATURAL_16 assign set_state

	mode: NATURAL_16 assign set_mode

	sel_atom: NATURAL_32 assign set_sel_atom

	gtk_sel_atom: CE_POINTER [ANY] assign set_gtk_sel_atom

feature {ANY} -- field setters

	set_available (a_available: INTEGER_32)
		do
			available := a_available
			update_memory_field ("available")
		end

	set_owned (a_owned: INTEGER_32)
		do
			owned := a_owned
			update_memory_field ("owned")
		end

	set_start (a_start: PD_POS_T)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_end2 (a_end2: PD_POS_T)
		do
			end2 := a_end2
			update_memory_field ("end2")
		end

	set_vmode (a_vmode: INTEGER_32)
		do
			vmode := a_vmode
			update_memory_field ("vmode")
		end

	set_origin_row (a_origin_row: NATURAL_16)
		do
			origin_row := a_origin_row
			update_memory_field ("origin_row")
		end

	set_origin_start_col (a_origin_start_col: NATURAL_16)
		do
			origin_start_col := a_origin_start_col
			update_memory_field ("origin_start_col")
		end

	set_origin_end_col (a_origin_end_col: NATURAL_16)
		do
			origin_end_col := a_origin_end_col
			update_memory_field ("origin_end_col")
		end

	set_word_start_col (a_word_start_col: NATURAL_16)
		do
			word_start_col := a_word_start_col
			update_memory_field ("word_start_col")
		end

	set_word_end_col (a_word_end_col: NATURAL_16)
		do
			word_end_col := a_word_end_col
			update_memory_field ("word_end_col")
		end

	set_prev (a_prev: PD_POS_T)
		do
			prev := a_prev
			update_memory_field ("prev")
		end

	set_state (a_state: NATURAL_16)
		do
			state := a_state
			update_memory_field ("state")
		end

	set_mode (a_mode: NATURAL_16)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_sel_atom (a_sel_atom: NATURAL_32)
		do
			sel_atom := a_sel_atom
			update_memory_field ("sel_atom")
		end

	set_gtk_sel_atom (a_gtk_sel_atom: CE_POINTER [ANY])
		do
			gtk_sel_atom := a_gtk_sel_atom
			update_memory_field ("gtk_sel_atom")
		end

feature {PD_VIMCLIPBOARD} -- private attributes

	success: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

feature {ANY} -- public routines

	clip_get_selection
		local
			l_old_y_previous: CE_POINTER [PD_YANKREG]
			l_old_y_current: CE_POINTER [PD_YANKREG]
			l_old_cursor: PD_POS_T
			l_old_visual: PD_POS_T
			l_old_visual_mode: INTEGER_32
			l_old_curswant: INTEGER_32
			l_old_set_curswant: INTEGER_32
			l_old_op_start: PD_POS_T
			l_old_op_end: PD_POS_T
			l_oa: CE_ARRAY [PD_OPARG_S]
			l_ca: CE_ARRAY [PD_CMDARG_S]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_OPARG_S]} l_oa.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_CMDARG_S]} l_ca.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (owned.to_boolean) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not ((c_pointer = ((create {P_GLOBALS_STATIC}).clip_plus.item).c_pointer)) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not ((create {P_OPS_STATIC}).y_regs.item[38].y_array).is_void then
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (c_pointer = ((create {P_GLOBALS_STATIC}).clip_star.item).c_pointer) then
							if not ((create {P_OPS_STATIC}).y_regs.item[37].y_array).is_void then
								l_return := True
							end
						end
				when 5 then
						if not l_return then
							l_old_y_previous := (create {P_OPS_STATIC}).y_previous.item
							l_old_y_current := (create {P_OPS_STATIC}).y_current.item
							l_old_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							l_old_curswant := (create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant
							l_old_set_curswant := (create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant
							l_old_op_start := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start).twin
							l_old_op_end := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end).twin
							l_old_visual := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin
							l_old_visual_mode := (create {P_GLOBALS_STATIC}).VIsual_mode.item;
							(create {P_OPS_STATIC}).clear_oparg (l_oa)
							update_class_fields -- Current might have been changed; synchronize
							if (c_pointer = ((create {P_GLOBALS_STATIC}).clip_plus.item).c_pointer) then
								l_oa.item.regname := ('+').code
								update_class_fields -- Current might have been changed; synchronize
							else
								l_oa.item.regname := ('*').code
								update_class_fields -- Current might have been changed; synchronize
							end
							l_oa.item.op_type := 2
							update_class_fields -- Current might have been changed; synchronize
							memset (create {CE_VOID_POINTER}.make_cast (l_ca), 0, (create {PD_CMDARG_S}.make).structure_size.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_ca.item.oap := l_oa
							update_class_fields -- Current might have been changed; synchronize
							l_ca.item.cmdchar := ('y').code
							update_class_fields -- Current might have been changed; synchronize
							l_ca.item.count1 := 1
							update_class_fields -- Current might have been changed; synchronize
							l_ca.item.retval := 2
							update_class_fields -- Current might have been changed; synchronize
							l_ca.item.do_pending_operator (0, 1)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OPS_STATIC}).y_previous.item := l_old_y_previous
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_OPS_STATIC}).y_current.item := l_old_y_current
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_cursor.twin
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MOVE_STATIC}).changed_cline_bef_curs
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := l_old_curswant
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := l_old_set_curswant
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := l_old_op_start.twin
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end := l_old_op_end.twin
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).VIsual.item.item := l_old_visual.twin
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).VIsual_mode.item := l_old_visual_mode
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:;
						(create {P_OPS_STATIC}).clip_free_selection ((create {CE_CLASS_POINTER [PD_VIMCLIPBOARD]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
						clip_gen_request_selection ((create {CE_CLASS_POINTER [PD_VIMCLIPBOARD]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done
					if not l_return then
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_own_selection
		local
			l_was_owned: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (available.to_boolean) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_was_owned := owned
						l_tmp := clip_gen_own_selection ((create {CE_CLASS_POINTER [PD_VIMCLIPBOARD]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
						Current.owned := (l_tmp = 1).to_integer
						update_class_fields -- Current might have been changed; synchronize
						if l_was_owned.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						if not ((c_pointer = ((create {P_GLOBALS_STATIC}).clip_star.item).c_pointer)) then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if not (owned.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_tmp___0 := (create {P_MISC2_STATIC}).get_real_state
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 /= 2 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						l_tmp___1 := (create {P_MISC2_STATIC}).get_real_state
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 /= 4_096 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_tmp___2 := (create {P_UI_STATIC}).clip_isautosel
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.to_boolean then
							if (create {P_GLOBALS_STATIC}).highlight_attr.item[15] /= (create {P_GLOBALS_STATIC}).highlight_attr.item[16] then
								(create {P_SCREEN_STATIC}).redraw_curbuf_later (25)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 9 then -- if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_lose_selection
		local
			l_was_owned: INTEGER_32
			l_visual_selection: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_was_owned := owned
					l_visual_selection := ((c_pointer = ((create {P_GLOBALS_STATIC}).clip_star.item).c_pointer)).to_integer;
					(create {P_OPS_STATIC}).clip_free_selection ((create {CE_CLASS_POINTER [PD_VIMCLIPBOARD]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					Current.owned := 0
					update_class_fields -- Current might have been changed; synchronize
					if l_visual_selection.to_boolean then
						(create {P_UI_STATIC}).clip_clear_selection
						update_class_fields -- Current might have been changed; synchronize
					end
					clip_gen_lose_selection ((create {CE_CLASS_POINTER [PD_VIMCLIPBOARD]}.make_shared (c_pointer)))
					update_class_fields -- Current might have been changed; synchronize
					if not (l_visual_selection.to_boolean) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if not (l_was_owned.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						l_tmp := (create {P_MISC2_STATIC}).get_real_state
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp /= 2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						l_tmp___0 := (create {P_MISC2_STATIC}).get_real_state
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 /= 4_096 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_tmp___1 := (create {P_UI_STATIC}).clip_isautosel
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							if (create {P_GLOBALS_STATIC}).highlight_attr.item[15] /= (create {P_GLOBALS_STATIC}).highlight_attr.item[16] then
								(create {P_SCREEN_STATIC}).update_curbuf (25)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_SCREEN_STATIC}).setcursor
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_TERM_STATIC}).cursor_on
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_TERM_STATIC}).out_flush
								update_class_fields -- Current might have been changed; synchronize
								if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
									(create {P_GUI_STATIC}).gui_update_cursor (1, 0)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 7 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_update_modeless_selection (a_row1, a_col1, a_row2, a_col2: INTEGER_32)
		do
			if a_row1.to_integer_32 /= start.lnum then
				(create {P_UI_STATIC}).clip_invert_area (a_row1, a_col1, (start.lnum).to_integer_32, start.col, 3)
				update_class_fields -- Current might have been changed; synchronize
				start.lnum := a_row1.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				start.col := a_col1
				update_class_fields -- Current might have been changed; synchronize
			elseif a_col1 /= start.col then
				(create {P_UI_STATIC}).clip_invert_area (a_row1, a_col1, (start.lnum).to_integer_32, start.col, 3)
				update_class_fields -- Current might have been changed; synchronize
				start.lnum := a_row1.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				start.col := a_col1
				update_class_fields -- Current might have been changed; synchronize
			end
			if a_row2.to_integer_32 /= end2.lnum then
				(create {P_UI_STATIC}).clip_invert_area ((end2.lnum).to_integer_32, end2.col, a_row2, a_col2, 3)
				update_class_fields -- Current might have been changed; synchronize
				end2.lnum := a_row2.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				end2.col := a_col2
				update_class_fields -- Current might have been changed; synchronize
			elseif a_col2 /= end2.col then
				(create {P_UI_STATIC}).clip_invert_area ((end2.lnum).to_integer_32, end2.col, a_row2, a_col2, 3)
				update_class_fields -- Current might have been changed; synchronize
				end2.lnum := a_row2.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				end2.col := a_col2
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	clip_x11_lose_selection (a_myShell: CE_POINTER [ANY])
		do
			XtDisownSelection (a_myShell, sel_atom, (0).to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
		end

	clip_x11_own_selection (a_myShell: CE_POINTER [ANY]): INTEGER_32
		local
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			l_tmp := XtWindow (a_myShell)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := XtDisplay (a_myShell)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___1 := XChangeProperty (l_tmp___0, l_tmp, sel_atom, (create {P_UI_STATIC}).timestamp_atom.item, 32, 2, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
			update_class_fields -- Current might have been changed; synchronize
			if not l_tmp___1.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_tmp___2 := XtDisplay (a_myShell)
				update_class_fields -- Current might have been changed; synchronize
				XFlush (l_tmp___2).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	clip_mch_own_selection: INTEGER_32
		local
			l_success___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_success___0 := gtk_selection_owner_set ((create {P_GUI_STATIC}).gui.item.item.drawarea, gtk_sel_atom, (create {P_GUI_GTK_X11_STATIC}).clipboard_event_time.item)
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_GUI_GTK_X11_STATIC}).gui_mch_update
			update_class_fields -- Current might have been changed; synchronize
			if l_success___0.to_boolean then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

feature {PD_VIMCLIPBOARD} -- private routines

	clip_gen_own_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD]): INTEGER_32
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				Result := (a_cbd.item.clip_mch_own_selection)
			else
				Result := (clip_xterm_own_selection (a_cbd))
			end
		end

	clip_xterm_own_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD]): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not ((create {P_OS_UNIX_STATIC}).xterm_Shell.item).is_void then
				Result := (a_cbd.item.clip_x11_own_selection ((create {P_OS_UNIX_STATIC}).xterm_Shell.item))
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	clip_gen_lose_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				clip_mch_lose_selection (a_cbd)
			else
				clip_xterm_lose_selection (a_cbd)
			end
		end

	clip_xterm_lose_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if not ((create {P_OS_UNIX_STATIC}).xterm_Shell.item).is_void then
				a_cbd.item.clip_x11_lose_selection ((create {P_OS_UNIX_STATIC}).xterm_Shell.item)
			end
		end

	clip_gen_request_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				clip_mch_request_selection (a_cbd)
			else
				clip_xterm_request_selection (a_cbd)
			end
		end

	clip_xterm_request_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
			if not ((create {P_OS_UNIX_STATIC}).xterm_Shell.item).is_void then
				clip_x11_request_selection ((create {P_OS_UNIX_STATIC}).xterm_Shell.item, (create {P_GLOBALS_STATIC}).xterm_dpy.item.item, a_cbd)
			end
		end

	clip_x11_request_selection (a_myShell, a_dpy: CE_POINTER [ANY]; a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_event: CE_ARRAY [SD_XEVENT]
			l_type: NATURAL_32
			l_i___0: INTEGER_32
			l_start_time: INTEGER_32
			l_timed_out___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_XEVENT]} l_event.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_timed_out___0 := 0
					l_i___0 := 0
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (l_i___0 < 5)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						inspect l_i___0 -- switch 1 head
						when 0 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 5
						when 3 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 3 then -- switch 1, case 0
						l_type := (create {P_UI_STATIC}).vimenc_atom.item
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 1
						l_type := (create {P_UI_STATIC}).vim_atom.item
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 2
						l_type := (create {P_UI_STATIC}).compound_text_atom.item
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 3
						l_type := (create {P_UI_STATIC}).text_atom.item
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						l_type := (31).to_natural_32
				when 8 then -- switch 1, done:
						success.item.item := 2
						XtGetSelectionValue (a_myShell, a_cbd.item.sel_atom, l_type, (create {P_UI_STATIC}).clip_x11_request_selection_cb_address, create {CE_VOID_POINTER}.make_cast (success.item), (0).to_natural_32)
						XFlush (a_dpy).do_nothing
						l_start_time := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						from
						until
							not (not (l_break) and then (success.item.item = 2))
						loop
							l_break := False
							l_continue := False
							if (XCheckTypedEvent (a_dpy, 31, l_event)).to_boolean then
								XtDispatchEvent (l_event).do_nothing
								l_continue := True
							elseif (XCheckTypedEvent (a_dpy, 30, l_event)).to_boolean then
								XtDispatchEvent (l_event).do_nothing
								l_continue := True
							elseif (XCheckTypedEvent (a_dpy, 28, l_event)).to_boolean then
								XtDispatchEvent (l_event).do_nothing
								l_continue := True
							end
							if not (l_break or l_continue) then
								if (time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))) > l_start_time + 2 then
									l_timed_out___0 := 1
									l_break := True
								end
							end
							if not (l_break or l_continue) then
								XSync (a_dpy, 0).do_nothing;
								(create {P_UI_STATIC}).ui_delay (1, 1)
							end
						end
						l_break := False
						l_continue := False
						if success.item.item = 1 then
							l_return := True
						end
						if not l_return then
							if l_timed_out___0.to_boolean then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					if not l_return then
						l_break := False
						yank_cut_buffer0 (a_dpy, a_cbd)
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clip_mch_request_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_target: CE_POINTER [ANY]
			l_i___0: NATURAL_32
			l_start___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_i___0 := {NATURAL_32} 0
			from
			until
				not (not (l_return) and then (l_i___0 < ((create {SD_GTKTARGETENTRY}.make).structure_size.to_natural_32 * (7).to_natural_32) // (create {SD_GTKTARGETENTRY}.make).structure_size.to_natural_32))
			loop
				l_continue := False
				if not ((create {P_GLOBALS_STATIC}).clip_html.item).to_boolean then
					if (create {P_GUI_GTK_X11_STATIC}).selection_targets.item[l_i___0.to_integer_32].info = {NATURAL_32} 4 then
						l_continue := True
					end
				end
				if not (l_return or l_break or l_continue) then
					(create {P_GUI_GTK_X11_STATIC}).received_selection.item := 0
					l_target := gdk_atom_intern ((create {P_GUI_GTK_X11_STATIC}).selection_targets.item[l_i___0.to_integer_32].target, 0)
					gtk_selection_convert ((create {P_GUI_STATIC}).gui.item.item.drawarea, a_cbd.item.gtk_sel_atom, l_target, (0).to_natural_32).do_nothing
					l_start___1 := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					from
					until
						(l_break)
					loop
						l_break := False
						if (create {P_GUI_GTK_X11_STATIC}).received_selection.item = 0 then
							if not ((time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))) < l_start___1 + 3) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							g_main_context_iteration (create {CE_VOID_POINTER}.make_shared (default_pointer), 1).do_nothing
						end
					end
					l_break := False
					if (create {P_GUI_GTK_X11_STATIC}).received_selection.item /= 2 then
						l_return := True
					end
				end
				if (not l_return) then
					l_i___0 := l_i___0 + 1
				end
			end
			if not l_return then
				l_continue := False
				yank_cut_buffer0 ((gdk_x11_drawable_get_xdisplay ((gdk_x11_window_get_drawable_impl (((create {P_GUI_STATIC}).gui.item.item.mainwin).item.window)))), a_cbd)
			end
		end

	yank_cut_buffer0 (a_dpy: CE_POINTER [ANY]; a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		local
			l_nbytes: CE_ARRAY [INTEGER_32]
			l_buffer: CE_POINTER [NATURAL_8]
			l_done___2: INTEGER_32
			l_conv_buf: CE_POINTER [NATURAL_8]
			l_vc: CE_ARRAY [PD_VIMCONV_T]
		do
			create {CE_INTEGER_32_ARRAY} l_nbytes.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_VIMCONV_T]} l_vc.make (<<1>>)

			l_nbytes.item := 0
			l_buffer := create {CE_NATURAL_8_POINTER}.make_cast ((XFetchBuffer (a_dpy, l_nbytes, 0)))
			if l_nbytes.item > 0 then
				l_done___2 := 0
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_vc.item.vc_type := 0
					if (l_vc.item.convert_setup (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("latin1")), (create {P_OPTION_STATIC}).p_enc.item.item)) = 1 then
						l_conv_buf := (create {P_MBYTE_STATIC}).string_convert (l_vc, l_buffer, l_nbytes)
						if not l_conv_buf.is_void then
							(create {P_OPS_STATIC}).clip_yank_selection (0, l_conv_buf, (l_nbytes.item).to_integer_32, a_cbd);
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_conv_buf))
							l_done___2 := 1
						end
						l_vc.item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
					end
				end
				if not l_done___2.to_boolean then
					(create {P_OPS_STATIC}).clip_yank_selection (0, l_buffer, (l_nbytes.item).to_integer_32, a_cbd)
				end
				XFree (create {CE_VOID_POINTER}.make_cast (l_buffer)).do_nothing
				if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
					(create {P_MESSAGE_STATIC}).verbose_enter;
					(create {P_MESSAGE_STATIC}).verb_msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Used CUT_BUFFER0 instead of empty selection"))))).do_nothing;
					(create {P_MESSAGE_STATIC}).verbose_leave
				end
			end
		end

	clip_mch_lose_selection (a_cbd: CE_POINTER [PD_VIMCLIPBOARD])
		do
		end

feature {ANY}

	copy (a_other: like Current)
		do
			available := a_other.available
			owned := a_other.owned
			start := a_other.start.twin
			end2 := a_other.end2.twin
			vmode := a_other.vmode
			origin_row := a_other.origin_row
			origin_start_col := a_other.origin_start_col
			origin_end_col := a_other.origin_end_col
			word_start_col := a_other.word_start_col
			word_end_col := a_other.word_end_col
			prev := a_other.prev.twin
			state := a_other.state
			mode := a_other.mode
			sel_atom := a_other.sel_atom
			gtk_sel_atom := a_other.gtk_sel_atom
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				available = a_other.available and
				owned = a_other.owned and
				start.is_equal (a_other.start) and
				end2.is_equal (a_other.end2) and
				vmode = a_other.vmode and
				origin_row = a_other.origin_row and
				origin_start_col = a_other.origin_start_col and
				origin_end_col = a_other.origin_end_col and
				word_start_col = a_other.word_start_col and
				word_end_col = a_other.word_end_col and
				prev.is_equal (a_other.prev) and
				state = a_other.state and
				mode = a_other.mode and
				sel_atom = a_other.sel_atom and
				gtk_sel_atom.is_equal (a_other.gtk_sel_atom)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("available"),
					create {CE_STRUCTURE_FIELD}.make ("owned"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("end2"),
					create {CE_STRUCTURE_FIELD}.make ("vmode"),
					create {CE_STRUCTURE_FIELD}.make ("origin_row"),
					create {CE_STRUCTURE_FIELD}.make ("origin_start_col"),
					create {CE_STRUCTURE_FIELD}.make ("origin_end_col"),
					create {CE_STRUCTURE_FIELD}.make ("word_start_col"),
					create {CE_STRUCTURE_FIELD}.make ("word_end_col"),
					create {CE_STRUCTURE_FIELD}.make ("prev"),
					create {CE_STRUCTURE_FIELD}.make ("state"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("sel_atom"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_sel_atom")
				>>)
			init_structure_info
		end

end
