class
	PD_VIMCONV_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_ICONV_STATIC
		redefine
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} vc_fd.make
			Precursor
		end

feature {ANY} -- fields

	vc_type: INTEGER_32 assign set_vc_type

	vc_factor: INTEGER_32 assign set_vc_factor

	vc_fd: CE_POINTER [ANY] assign set_vc_fd

	vc_fail: INTEGER_32 assign set_vc_fail

feature {ANY} -- field setters

	set_vc_type (a_vc_type: INTEGER_32)
		do
			vc_type := a_vc_type
			update_memory_field ("vc_type")
		end

	set_vc_factor (a_vc_factor: INTEGER_32)
		do
			vc_factor := a_vc_factor
			update_memory_field ("vc_factor")
		end

	set_vc_fd (a_vc_fd: CE_POINTER [ANY])
		do
			vc_fd := a_vc_fd
			update_memory_field ("vc_fd")
		end

	set_vc_fail (a_vc_fail: INTEGER_32)
		do
			vc_fail := a_vc_fail
			update_memory_field ("vc_fail")
		end

feature {ANY} -- public routines

	convert_setup_ext (a_from: CE_POINTER [NATURAL_8]; a_from_unicode_is_utf8: INTEGER_32; a_to: CE_POINTER [NATURAL_8]; a_to_unicode_is_utf8: INTEGER_32): INTEGER_32
		local
			l_from_prop: INTEGER_32
			l_to_prop: INTEGER_32
			l_from_is_utf8: INTEGER_32
			l_to_is_utf8: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [ANY]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if vc_type = 5 then
						if (vc_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							iconv_close (vc_fd).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					Current.vc_type := 0
					update_class_fields -- Current might have been changed; synchronize
					Current.vc_factor := 1
					update_class_fields -- Current might have been changed; synchronize
					Current.vc_fail := 0
					update_class_fields -- Current might have been changed; synchronize
					if a_from.is_void then
						Result := 1
						l_return := True
					elseif (a_from.item).to_integer_32 = 0 then
						Result := 1
						l_return := True
					elseif a_to.is_void then
						Result := 1
						l_return := True
					elseif (a_to.item).to_integer_32 = 0 then
						Result := 1
						l_return := True
					else
						l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_from), create {CE_INTEGER_8_POINTER}.make_cast (a_to))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						l_from_prop := (create {P_MBYTE_STATIC}).enc_canon_props (a_from)
						update_class_fields -- Current might have been changed; synchronize
						l_to_prop := (create {P_MBYTE_STATIC}).enc_canon_props (a_to)
						update_class_fields -- Current might have been changed; synchronize
						if a_from_unicode_is_utf8.to_boolean then
							l_from_is_utf8 := (l_from_prop).bit_and (4)
						else
							l_from_is_utf8 := (l_from_prop = 4).to_integer
						end
						if a_to_unicode_is_utf8.to_boolean then
							l_to_is_utf8 := (l_to_prop).bit_and (4)
						else
							l_to_is_utf8 := (l_to_prop = 4).to_integer
						end
						if not (((l_from_prop).bit_and (512)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_to_is_utf8.to_boolean then
							Current.vc_type := 1
							update_class_fields -- Current might have been changed; synchronize
							Current.vc_factor := 2
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 4 -- goto _L___2
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else: | _L___2:
						if not (((l_from_prop).bit_and (1_024)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_to_is_utf8.to_boolean then
							Current.vc_type := 2
							update_class_fields -- Current might have been changed; synchronize
							Current.vc_factor := 3
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 7 -- goto _L___1
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else: | _L___1:
						if not (l_from_is_utf8.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if ((l_to_prop).bit_and (512)).to_boolean then
							Current.vc_type := 3
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else: | _L___0:
						if not (l_from_is_utf8.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if ((l_to_prop).bit_and (1_024)).to_boolean then
							Current.vc_type := 4
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 13 -- goto _L
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L:
						if l_from_is_utf8.to_boolean then
							l_tmp___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("utf-8"))
						else
							l_tmp___0 := a_from
						end
						if l_to_is_utf8.to_boolean then
							l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("utf-8"))
						else
							l_tmp___1 := a_to
						end
						l_tmp___2 := (create {P_MBYTE_STATIC}).my_iconv_open (l_tmp___1, l_tmp___0)
						update_class_fields -- Current might have been changed; synchronize
						Current.vc_fd := l_tmp___2
						update_class_fields -- Current might have been changed; synchronize
						if (vc_fd.c_pointer.to_integer_32).to_natural_32 /= ((create {CE_VOID_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							Current.vc_type := 5
							update_class_fields -- Current might have been changed; synchronize
							Current.vc_factor := 4
							update_class_fields -- Current might have been changed; synchronize
						end
				when 14 then -- if done | if done | if done
						if vc_type = 0 then
							Result := 0
							l_return := True
						end
				when 15 then -- if done
					if not l_return then
						Result := 1
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	convert_setup (a_from, a_to: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (c_pointer))).item.convert_setup_ext (a_from, 1, a_to, 1)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

feature {ANY}

	copy (a_other: like Current)
		do
			vc_type := a_other.vc_type
			vc_factor := a_other.vc_factor
			vc_fd := a_other.vc_fd
			vc_fail := a_other.vc_fail
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				vc_type = a_other.vc_type and
				vc_factor = a_other.vc_factor and
				vc_fd.is_equal (a_other.vc_fd) and
				vc_fail = a_other.vc_fail
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("vc_type"),
					create {CE_STRUCTURE_FIELD}.make ("vc_factor"),
					create {CE_STRUCTURE_FIELD}.make ("vc_fd"),
					create {CE_STRUCTURE_FIELD}.make ("vc_fail")
				>>)
			init_structure_info
		end

end
