class
	PD_VIMOPTION

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} fullname.make
			create {CE_INTEGER_8_POINTER} shortname.make
			create {CE_NATURAL_8_POINTER} var.make
			create {CE_POINTER_ARRAY [NATURAL_8]} def_val.make (<<2>>)
			Precursor
		end

feature {ANY} -- fields

	fullname: CE_POINTER [INTEGER_8] assign set_fullname

	shortname: CE_POINTER [INTEGER_8] assign set_shortname

	flags: NATURAL_32 assign set_flags

	var: CE_POINTER [NATURAL_8] assign set_var

	indir: NATURAL_32 assign set_indir

	def_val: CE_ARRAY [CE_POINTER [NATURAL_8]]

	scriptID: INTEGER_32 assign set_scriptID

feature {ANY} -- field setters

	set_fullname (a_fullname: CE_POINTER [INTEGER_8])
		do
			fullname := a_fullname
			update_memory_field ("fullname")
		end

	set_shortname (a_shortname: CE_POINTER [INTEGER_8])
		do
			shortname := a_shortname
			update_memory_field ("shortname")
		end

	set_flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_var (a_var: CE_POINTER [NATURAL_8])
		do
			var := a_var
			update_memory_field ("var")
		end

	set_indir (a_indir: NATURAL_32)
		do
			indir := a_indir
			update_memory_field ("indir")
		end

	set_scriptID (a_scriptID: INTEGER_32)
		do
			scriptID := a_scriptID
			update_memory_field ("scriptID")
		end

feature {ANY} -- public routines

	optval_default (a_varp: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_dvi: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if a_varp.is_void then
				Result := 1
				l_return := True
			end
			if not l_return then
				if ((flags).bit_and ({NATURAL_32} 1_024)).to_boolean then
					l_dvi := 0
				elseif ((create {P_OPTION_STATIC}).p_cp.item.item).to_boolean then
					l_dvi := 0
				else
					l_dvi := 1
				end
				if ((flags).bit_and ({NATURAL_32} 2)).to_boolean then
					Result := ((create {CE_INTEGER_32_POINTER}.make_cast (a_varp)).item = ((def_val[l_dvi]).c_pointer.to_integer_32).to_integer_32).to_integer
					l_return := True
				end
			end
			if not l_return and then (((flags).bit_and ({NATURAL_32} 1)).to_boolean) then
				Result := ((create {CE_INTEGER_32_POINTER}.make_cast (a_varp)).item = (((def_val[l_dvi]).c_pointer.to_integer_32).to_integer_32).to_integer_32).to_integer
				l_return := True
			end
			if not l_return then
				l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (a_varp)).item), create {CE_INTEGER_8_POINTER}.make_cast (def_val[l_dvi]))
				update_class_fields -- Current might have been changed; synchronize
				Result := (l_tmp = 0).to_integer
			end
		end

	showoneopt (a_opt_flags: INTEGER_32)
		local
			l_varp: CE_POINTER [NATURAL_8]
			l_save_silent: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_save_silent := (create {P_GLOBALS_STATIC}).silent_mode.item;
					(create {P_GLOBALS_STATIC}).silent_mode.item := 0
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).info_message.item := 1
					update_class_fields -- Current might have been changed; synchronize
					l_varp := ((create {CE_CLASS_POINTER [PD_VIMOPTION]}.make_shared (c_pointer))).item.get_varp_scope (a_opt_flags)
					update_class_fields -- Current might have been changed; synchronize
					if not (((flags).bit_and ({NATURAL_32} 1)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_varp.is_equal (create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_changed"))) then
							l_tmp := (create {P_UNDO_STATIC}).curbufIsChanged
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp.to_boolean then
								l_tmp___0 := 0
							else
								l_tmp___0 := 1
							end
							l_tmp___1 := l_tmp___0
						else
							l_tmp___1 := (not ((create {CE_INTEGER_32_POINTER}.make_cast (l_varp)).item).to_boolean).to_integer
						end
						if l_tmp___1.to_boolean then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("no")))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if ((flags).bit_and ({NATURAL_32} 1)).to_boolean then
							if (create {CE_INTEGER_32_POINTER}.make_cast (l_varp)).item < 0 then
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("--")))
								update_class_fields -- Current might have been changed; synchronize
							else
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("  ")))
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("  ")))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 4 then;
					(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (fullname))
					update_class_fields -- Current might have been changed; synchronize
					if not ((flags).bit_and ({NATURAL_32} 1)).to_boolean then
						(create {P_MESSAGE_STATIC}).msg_putchar (('=').code)
						update_class_fields; -- Current might have been changed; synchronize
						((create {CE_CLASS_POINTER [PD_VIMOPTION]}.make_shared (c_pointer))).item.option_value2string (a_opt_flags)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).msg_outtrans ((create {P_GLOBALS_STATIC}).NameBuff.item.item).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					(create {P_GLOBALS_STATIC}).silent_mode.item := l_save_silent
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_GLOBALS_STATIC}).info_message.item := 0
					update_class_fields -- Current might have been changed; synchronize
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	istermoption: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if (fullname[0]).to_integer_32 = 116 then
				if (fullname[1]).to_integer_32 = 95 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	get_varp: CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if var.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 103 -- skip if block
					end
				when 1 then -- if:
						inspect indir.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 20505 then l_pos := -1 + 3 -- (20_505).to_natural_32
						when 20522 then l_pos := -1 + 4 -- (20_522).to_natural_32
						when 20530 then l_pos := -1 + 5 -- (20_530).to_natural_32
						when 20481 then l_pos := -1 + 6 -- (20_481).to_natural_32
						when 20545 then l_pos := -1 + 7 -- (20_545).to_natural_32
						when 20502 then l_pos := -1 + 8 -- (20_502).to_natural_32
						when 20503 then l_pos := -1 + 9 -- (20_503).to_natural_32
						when 20499 then l_pos := -1 + 10 -- (20_499).to_natural_32
						when 20500 then l_pos := -1 + 11 -- (20_500).to_natural_32
						when 20484 then l_pos := -1 + 12 -- (20_484).to_natural_32
						when 20485 then l_pos := -1 + 13 -- (20_485).to_natural_32
						when 20486 then l_pos := -1 + 14 -- (20_486).to_natural_32
						when 20508 then l_pos := -1 + 15 -- (20_508).to_natural_32
						when 20495 then l_pos := -1 + 16 -- (20_495).to_natural_32
						when 12312 then l_pos := -1 + 17 -- (12_312).to_natural_32
						when 8192 then l_pos := -1 + 18 -- (8_192).to_natural_32
						when 8212 then l_pos := -1 + 19 -- (8_212).to_natural_32
						when 8213 then l_pos := -1 + 20 -- (8_213).to_natural_32
						when 8214 then l_pos := -1 + 21 -- (8_214).to_natural_32
						when 8215 then l_pos := -1 + 22 -- (8_215).to_natural_32
						when 8194 then l_pos := -1 + 23 -- (8_194).to_natural_32
						when 8195 then l_pos := -1 + 24 -- (8_195).to_natural_32
						when 8196 then l_pos := -1 + 25 -- (8_196).to_natural_32
						when 8197 then l_pos := -1 + 26 -- (8_197).to_natural_32
						when 8198 then l_pos := -1 + 27 -- (8_198).to_natural_32
						when 8199 then l_pos := -1 + 28 -- (8_199).to_natural_32
						when 8200 then l_pos := -1 + 29 -- (8_200).to_natural_32
						when 8201 then l_pos := -1 + 30 -- (8_201).to_natural_32
						when 8202 then l_pos := -1 + 31 -- (8_202).to_natural_32
						when 8203 then l_pos := -1 + 32 -- (8_203).to_natural_32
						when 8204 then l_pos := -1 + 33 -- (8_204).to_natural_32
						when 8206 then l_pos := -1 + 34 -- (8_206).to_natural_32
						when 8207 then l_pos := -1 + 35 -- (8_207).to_natural_32
						when 8208 then l_pos := -1 + 36 -- (8_208).to_natural_32
						when 8217 then l_pos := -1 + 37 -- (8_217).to_natural_32
						when 8218 then l_pos := -1 + 38 -- (8_218).to_natural_32
						when 8209 then l_pos := -1 + 39 -- (8_209).to_natural_32
						when 8211 then l_pos := -1 + 40 -- (8_211).to_natural_32
						when 8219 then l_pos := -1 + 41 -- (8_219).to_natural_32
						when 8205 then l_pos := -1 + 42 -- (8_205).to_natural_32
						when 8210 then l_pos := -1 + 43 -- (8_210).to_natural_32
						when 8193 then l_pos := -1 + 44 -- (8_193).to_natural_32
						when 16384 then l_pos := -1 + 45 -- (16_384).to_natural_32
						when 16391 then l_pos := -1 + 46 -- (16_391).to_natural_32
						when 16393 then l_pos := -1 + 47 -- (16_393).to_natural_32
						when 16386 then l_pos := -1 + 48 -- (16_386).to_natural_32
						when 16387 then l_pos := -1 + 49 -- (16_387).to_natural_32
						when 16392 then l_pos := -1 + 50 -- (16_392).to_natural_32
						when 16394 then l_pos := -1 + 51 -- (16_394).to_natural_32
						when 16395 then l_pos := -1 + 52 -- (16_395).to_natural_32
						when 16396 then l_pos := -1 + 53 -- (16_396).to_natural_32
						when 16397 then l_pos := -1 + 54 -- (16_397).to_natural_32
						when 16398 then l_pos := -1 + 55 -- (16_398).to_natural_32
						when 16401 then l_pos := -1 + 56 -- (16_401).to_natural_32
						when 16400 then l_pos := -1 + 57 -- (16_400).to_natural_32
						when 16402 then l_pos := -1 + 58 -- (16_402).to_natural_32
						when 16405 then l_pos := -1 + 59 -- (16_405).to_natural_32
						when 16433 then l_pos := -1 + 60 -- (16_433).to_natural_32
						when 16408 then l_pos := -1 + 61 -- (16_408).to_natural_32
						when 16410 then l_pos := -1 + 62 -- (16_410).to_natural_32
						when 16411 then l_pos := -1 + 63 -- (16_411).to_natural_32
						when 16414 then l_pos := -1 + 64 -- (16_414).to_natural_32
						when 16417 then l_pos := -1 + 65 -- (16_417).to_natural_32
						when 16416 then l_pos := -1 + 66 -- (16_416).to_natural_32
						when 16415 then l_pos := -1 + 67 -- (16_415).to_natural_32
						when 16418 then l_pos := -1 + 68 -- (16_418).to_natural_32
						when 16419 then l_pos := -1 + 69 -- (16_419).to_natural_32
						when 16423 then l_pos := -1 + 70 -- (16_423).to_natural_32
						when 16424 then l_pos := -1 + 71 -- (16_424).to_natural_32
						when 16422 then l_pos := -1 + 72 -- (16_422).to_natural_32
						when 16420 then l_pos := -1 + 73 -- (16_420).to_natural_32
						when 16421 then l_pos := -1 + 74 -- (16_421).to_natural_32
						when 16413 then l_pos := -1 + 75 -- (16_413).to_natural_32
						when 16425 then l_pos := -1 + 76 -- (16_425).to_natural_32
						when 16427 then l_pos := -1 + 77 -- (16_427).to_natural_32
						when 16429 then l_pos := -1 + 78 -- (16_429).to_natural_32
						when 16431 then l_pos := -1 + 79 -- (16_431).to_natural_32
						when 16428 then l_pos := -1 + 80 -- (16_428).to_natural_32
						when 16430 then l_pos := -1 + 81 -- (16_430).to_natural_32
						when 16432 then l_pos := -1 + 82 -- (16_432).to_natural_32
						when 16435 then l_pos := -1 + 83 -- (16_435).to_natural_32
						when 16436 then l_pos := -1 + 84 -- (16_436).to_natural_32
						when 16437 then l_pos := -1 + 85 -- (16_437).to_natural_32
						when 16438 then l_pos := -1 + 86 -- (16_438).to_natural_32
						when 16439 then l_pos := -1 + 87 -- (16_439).to_natural_32
						when 16445 then l_pos := -1 + 88 -- (16_445).to_natural_32
						when 16446 then l_pos := -1 + 89 -- (16_446).to_natural_32
						when 16448 then l_pos := -1 + 90 -- (16_448).to_natural_32
						when 16440 then l_pos := -1 + 91 -- (16_440).to_natural_32
						when 16441 then l_pos := -1 + 92 -- (16_441).to_natural_32
						when 16442 then l_pos := -1 + 93 -- (16_442).to_natural_32
						when 16443 then l_pos := -1 + 94 -- (16_443).to_natural_32
						when 16444 then l_pos := -1 + 95 -- (16_444).to_natural_32
						when 16447 then l_pos := -1 + 96 -- (16_447).to_natural_32
						when 16450 then l_pos := -1 + 97 -- (16_450).to_natural_32
						when 16451 then l_pos := -1 + 98 -- (16_451).to_natural_32
						when 16452 then l_pos := -1 + 99 -- (16_452).to_natural_32
						when 16453 then l_pos := -1 + 100 -- (16_453).to_natural_32
						when 16454 then l_pos := -1 + 101 -- (16_454).to_natural_32
						else l_pos := -1 + 102
						end
				when 2 then -- switch 1, case 0
						Result := var
						l_return := True
				when 3 then -- switch 1, case (20505).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ep).item).to_integer_32 /= 0 then
								l_tmp := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ep"))))
							else
								l_tmp := var
							end
							Result := l_tmp
							l_return := True
						end
				when 4 then -- switch 1, case (20522).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_kp).item).to_integer_32 /= 0 then
								l_tmp___0 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_kp"))))
							else
								l_tmp___0 := var
							end
							Result := l_tmp___0
							l_return := True
						end
				when 5 then -- switch 1, case (20530).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_path).item).to_integer_32 /= 0 then
								l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_path"))))
							else
								l_tmp___1 := var
							end
							Result := l_tmp___1
							l_return := True
						end
				when 6 then -- switch 1, case (20481).to_natural_32
						if not l_return then
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ar >= 0 then
								l_tmp___2 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ar"))))
							else
								l_tmp___2 := var
							end
							Result := l_tmp___2
							l_return := True
						end
				when 7 then -- switch 1, case (20545).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tags).item).to_integer_32 /= 0 then
								l_tmp___3 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_tags"))))
							else
								l_tmp___3 := var
							end
							Result := l_tmp___3
							l_return := True
						end
				when 8 then -- switch 1, case (20502).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_def).item).to_integer_32 /= 0 then
								l_tmp___4 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_def"))))
							else
								l_tmp___4 := var
							end
							Result := l_tmp___4
							l_return := True
						end
				when 9 then -- switch 1, case (20503).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_inc).item).to_integer_32 /= 0 then
								l_tmp___5 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_inc"))))
							else
								l_tmp___5 := var
							end
							Result := l_tmp___5
							l_return := True
						end
				when 10 then -- switch 1, case (20499).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_dict).item).to_integer_32 /= 0 then
								l_tmp___6 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_dict"))))
							else
								l_tmp___6 := var
							end
							Result := l_tmp___6
							l_return := True
						end
				when 11 then -- switch 1, case (20500).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tsr).item).to_integer_32 /= 0 then
								l_tmp___7 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_tsr"))))
							else
								l_tmp___7 := var
							end
							Result := l_tmp___7
							l_return := True
						end
				when 12 then -- switch 1, case (20484).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_efm).item).to_integer_32 /= 0 then
								l_tmp___8 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_efm"))))
							else
								l_tmp___8 := var
							end
							Result := l_tmp___8
							l_return := True
						end
				when 13 then -- switch 1, case (20485).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_gp).item).to_integer_32 /= 0 then
								l_tmp___9 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_gp"))))
							else
								l_tmp___9 := var
							end
							Result := l_tmp___9
							l_return := True
						end
				when 14 then -- switch 1, case (20486).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_mp).item).to_integer_32 /= 0 then
								l_tmp___10 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_mp"))))
							else
								l_tmp___10 := var
							end
							Result := l_tmp___10
							l_return := True
						end
				when 15 then -- switch 1, case (20508).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bexpr).item).to_integer_32 /= 0 then
								l_tmp___11 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bexpr"))))
							else
								l_tmp___11 := var
							end
							Result := l_tmp___11
							l_return := True
						end
				when 16 then -- switch 1, case (20495).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cm).item).to_integer_32 /= 0 then
								l_tmp___12 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cm"))))
							else
								l_tmp___12 := var
							end
							Result := l_tmp___12
							l_return := True
						end
				when 17 then -- switch 1, case (12312).to_natural_32
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_stl).item).to_integer_32 /= 0 then
								l_tmp___13 := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_stl"))))
							else
								l_tmp___13 := var
							end
							Result := l_tmp___13
							l_return := True
						end
				when 18 then -- switch 1, case (8192).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_list")))))
							l_return := True
						end
				when 19 then -- switch 1, case (8212).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_spell")))))
							l_return := True
						end
				when 20 then -- switch 1, case (8213).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_cuc")))))
							l_return := True
						end
				when 21 then -- switch 1, case (8214).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_cul")))))
							l_return := True
						end
				when 22 then -- switch 1, case (8215).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_cc")))))
							l_return := True
						end
				when 23 then -- switch 1, case (8194).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_diff")))))
							l_return := True
						end
				when 24 then -- switch 1, case (8195).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fdc")))))
							l_return := True
						end
				when 25 then -- switch 1, case (8196).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fen")))))
							l_return := True
						end
				when 26 then -- switch 1, case (8197).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fdi")))))
							l_return := True
						end
				when 27 then -- switch 1, case (8198).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fdl")))))
							l_return := True
						end
				when 28 then -- switch 1, case (8199).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fdm")))))
							l_return := True
						end
				when 29 then -- switch 1, case (8200).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fml")))))
							l_return := True
						end
				when 30 then -- switch 1, case (8201).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fdn")))))
							l_return := True
						end
				when 31 then -- switch 1, case (8202).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fde")))))
							l_return := True
						end
				when 32 then -- switch 1, case (8203).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fdt")))))
							l_return := True
						end
				when 33 then -- switch 1, case (8204).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_fmr")))))
							l_return := True
						end
				when 34 then -- switch 1, case (8206).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_nu")))))
							l_return := True
						end
				when 35 then -- switch 1, case (8207).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_rnu")))))
							l_return := True
						end
				when 36 then -- switch 1, case (8208).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_nuw")))))
							l_return := True
						end
				when 37 then -- switch 1, case (8217).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_wfh")))))
							l_return := True
						end
				when 38 then -- switch 1, case (8218).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_wfw")))))
							l_return := True
						end
				when 39 then -- switch 1, case (8209).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_pvw")))))
							l_return := True
						end
				when 40 then -- switch 1, case (8211).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_scr")))))
							l_return := True
						end
				when 41 then -- switch 1, case (8219).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_wrap")))))
							l_return := True
						end
				when 42 then -- switch 1, case (8205).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_lbr")))))
							l_return := True
						end
				when 43 then -- switch 1, case (8210).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_scb")))))
							l_return := True
						end
				when 44 then -- switch 1, case (8193).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_crb")))))
							l_return := True
						end
				when 45 then -- switch 1, case (16384).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ai")))))
							l_return := True
						end
				when 46 then -- switch 1, case (16391).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bin")))))
							l_return := True
						end
				when 47 then -- switch 1, case (16393).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bomb")))))
							l_return := True
						end
				when 48 then -- switch 1, case (16386).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bh")))))
							l_return := True
						end
				when 49 then -- switch 1, case (16387).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bt")))))
							l_return := True
						end
				when 50 then -- switch 1, case (16392).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bl")))))
							l_return := True
						end
				when 51 then -- switch 1, case (16394).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ci")))))
							l_return := True
						end
				when 52 then -- switch 1, case (16395).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cin")))))
							l_return := True
						end
				when 53 then -- switch 1, case (16396).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cink")))))
							l_return := True
						end
				when 54 then -- switch 1, case (16397).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cino")))))
							l_return := True
						end
				when 55 then -- switch 1, case (16398).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cinw")))))
							l_return := True
						end
				when 56 then -- switch 1, case (16401).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_com")))))
							l_return := True
						end
				when 57 then -- switch 1, case (16400).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cms")))))
							l_return := True
						end
				when 58 then -- switch 1, case (16402).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cpt")))))
							l_return := True
						end
				when 59 then -- switch 1, case (16405).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cfu")))))
							l_return := True
						end
				when 60 then -- switch 1, case (16433).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ofu")))))
							l_return := True
						end
				when 61 then -- switch 1, case (16408).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_eol")))))
							l_return := True
						end
				when 62 then -- switch 1, case (16410).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_et")))))
							l_return := True
						end
				when 63 then -- switch 1, case (16411).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_fenc")))))
							l_return := True
						end
				when 64 then -- switch 1, case (16414).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ff")))))
							l_return := True
						end
				when 65 then -- switch 1, case (16417).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ft")))))
							l_return := True
						end
				when 66 then -- switch 1, case (16416).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_fo")))))
							l_return := True
						end
				when 67 then -- switch 1, case (16415).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_flp")))))
							l_return := True
						end
				when 68 then -- switch 1, case (16418).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_iminsert")))))
							l_return := True
						end
				when 69 then -- switch 1, case (16419).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_imsearch")))))
							l_return := True
						end
				when 70 then -- switch 1, case (16423).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_inf")))))
							l_return := True
						end
				when 71 then -- switch 1, case (16424).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_isk")))))
							l_return := True
						end
				when 72 then -- switch 1, case (16422).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_inex")))))
							l_return := True
						end
				when 73 then -- switch 1, case (16420).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_inde")))))
							l_return := True
						end
				when 74 then -- switch 1, case (16421).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_indk")))))
							l_return := True
						end
				when 75 then -- switch 1, case (16413).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_fex")))))
							l_return := True
						end
				when 76 then -- switch 1, case (16425).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_key")))))
							l_return := True
						end
				when 77 then -- switch 1, case (16427).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_lisp")))))
							l_return := True
						end
				when 78 then -- switch 1, case (16429).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ml")))))
							l_return := True
						end
				when 79 then -- switch 1, case (16431).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_mps")))))
							l_return := True
						end
				when 80 then -- switch 1, case (16428).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ma")))))
							l_return := True
						end
				when 81 then -- switch 1, case (16430).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_changed")))))
							l_return := True
						end
				when 82 then -- switch 1, case (16432).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_nf")))))
							l_return := True
						end
				when 83 then -- switch 1, case (16435).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_pi")))))
							l_return := True
						end
				when 84 then -- switch 1, case (16436).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_qe")))))
							l_return := True
						end
				when 85 then -- switch 1, case (16437).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ro")))))
							l_return := True
						end
				when 86 then -- switch 1, case (16438).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_si")))))
							l_return := True
						end
				when 87 then -- switch 1, case (16439).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_sn")))))
							l_return := True
						end
				when 88 then -- switch 1, case (16445).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_sts")))))
							l_return := True
						end
				when 89 then -- switch 1, case (16446).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_sua")))))
							l_return := True
						end
				when 90 then -- switch 1, case (16448).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_swf")))))
							l_return := True
						end
				when 91 then -- switch 1, case (16440).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_smc")))))
							l_return := True
						end
				when 92 then -- switch 1, case (16441).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_syn")))))
							l_return := True
						end
				when 93 then -- switch 1, case (16442).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_p_spc")))))
							l_return := True
						end
				when 94 then -- switch 1, case (16443).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_p_spf")))))
							l_return := True
						end
				when 95 then -- switch 1, case (16444).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).c_pointer + (create {PD_SYNBLOCK_T}.make).offset_of ("b_p_spl")))))
							l_return := True
						end
				when 96 then -- switch 1, case (16447).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_sw")))))
							l_return := True
						end
				when 97 then -- switch 1, case (16450).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ts")))))
							l_return := True
						end
				when 98 then -- switch 1, case (16451).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_tw")))))
							l_return := True
						end
				when 99 then -- switch 1, case (16452).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_tx")))))
							l_return := True
						end
				when 100 then -- switch 1, case (16453).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_udf")))))
							l_return := True
						end
				when 101 then -- switch 1, case (16454).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_wm")))))
							l_return := True
						end
				when 102 then -- switch 1, default:
						if not l_return then
							l_tmp___14 := gettext (ce_string ("E356: get_varp ERROR"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___14)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 103 then -- switch 1, done: | if done
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_wm")))))
					end
				when 104 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	option_value2string (a_opt_flags: INTEGER_32)
		local
			l_varp: CE_POINTER [NATURAL_8]
			l_wc: CE_ARRAY [INTEGER_32]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_wc.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_varp := ((create {CE_CLASS_POINTER [PD_VIMOPTION]}.make_shared (c_pointer))).item.get_varp_scope (a_opt_flags)
					update_class_fields -- Current might have been changed; synchronize
					if not (((flags).bit_and ({NATURAL_32} 2)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_wc.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := (create {P_OPTION_STATIC}).wc_use_keyname (l_varp, l_wc)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1.to_boolean then
							l_tmp := (create {P_MISC2_STATIC}).get_special_key_name ((l_wc.item).to_integer_32, 0)
							update_class_fields -- Current might have been changed; synchronize
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						elseif l_wc.item /= 0 then
							l_tmp___0 := (create {P_CHARSET_STATIC}).transchar ((l_wc.item).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___0)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							sprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), ce_string ("%%ld"), (create {CE_INTEGER_32_POINTER}.make_cast (l_varp)).item]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						l_varp := (create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_varp)).item
						if not (l_varp.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:;
						(create {P_GLOBALS_STATIC}).NameBuff.item.item[0] := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (var.is_equal ((create {P_OPTION_STATIC}).p_key.item)) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_varp.item).to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), ce_string ("*****")).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if ((flags).bit_and ({NATURAL_32} 16)).to_boolean then
							(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_varp, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 0)
							update_class_fields -- Current might have been changed; synchronize
						elseif var.is_equal ((create {P_OPTION_STATIC}).p_pt.item) then
							str2specialbuf ((create {P_OPTION_STATIC}).p_pt.item.item, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096)
							update_class_fields -- Current might have been changed; synchronize
						else
							(create {P_MISC2_STATIC}).vim_strncpy ((create {P_GLOBALS_STATIC}).NameBuff.item.item, l_varp, (4_095).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_varp_scope (a_opt_flags: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((a_opt_flags).bit_and (2)).to_boolean then
						if indir /= {NATURAL_32} 0 then
							if (var.c_pointer.to_integer_32).to_natural_32 = ((create {CE_NATURAL_8_POINTER}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
								l_tmp := ((create {CE_CLASS_POINTER [PD_VIMOPTION]}.make_shared (c_pointer))).item.get_varp
								update_class_fields -- Current might have been changed; synchronize
								Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (l_tmp) + ((create {PD_WINOPT_T}.make).structure_size.to_natural_32).to_integer_32)))
								l_return := True
							end
							if not l_return then
								Result := var
								l_return := True
							end
						end
					end
					if not (not l_return and then (((a_opt_flags).bit_and (4)).to_boolean)) then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						if not (((indir.to_integer_32).bit_and (4_096)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 2 then -- if:
						inspect indir.to_integer_32 -- switch 1 head
						when 20484 then l_pos := -1 + 3 -- (20_484).to_natural_32
						when 20485 then l_pos := -1 + 4 -- (20_485).to_natural_32
						when 20486 then l_pos := -1 + 5 -- (20_486).to_natural_32
						when 20505 then l_pos := -1 + 6 -- (20_505).to_natural_32
						when 20522 then l_pos := -1 + 7 -- (20_522).to_natural_32
						when 20530 then l_pos := -1 + 8 -- (20_530).to_natural_32
						when 20481 then l_pos := -1 + 9 -- (20_481).to_natural_32
						when 20545 then l_pos := -1 + 10 -- (20_545).to_natural_32
						when 20502 then l_pos := -1 + 11 -- (20_502).to_natural_32
						when 20503 then l_pos := -1 + 12 -- (20_503).to_natural_32
						when 20499 then l_pos := -1 + 13 -- (20_499).to_natural_32
						when 20500 then l_pos := -1 + 14 -- (20_500).to_natural_32
						when 20508 then l_pos := -1 + 15 -- (20_508).to_natural_32
						when 20495 then l_pos := -1 + 16 -- (20_495).to_natural_32
						when 12312 then l_pos := -1 + 17 -- (12_312).to_natural_32
						else l_pos := -1 + 18
						end
				when 3 then -- switch 1, case (20484).to_natural_32
						Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_efm")))))
						l_return := True
				when 4 then -- switch 1, case (20485).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_gp")))))
							l_return := True
						end
				when 5 then -- switch 1, case (20486).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_mp")))))
							l_return := True
						end
				when 6 then -- switch 1, case (20505).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ep")))))
							l_return := True
						end
				when 7 then -- switch 1, case (20522).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_kp")))))
							l_return := True
						end
				when 8 then -- switch 1, case (20530).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_path")))))
							l_return := True
						end
				when 9 then -- switch 1, case (20481).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_ar")))))
							l_return := True
						end
				when 10 then -- switch 1, case (20545).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_tags")))))
							l_return := True
						end
				when 11 then -- switch 1, case (20502).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_def")))))
							l_return := True
						end
				when 12 then -- switch 1, case (20503).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_inc")))))
							l_return := True
						end
				when 13 then -- switch 1, case (20499).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_dict")))))
							l_return := True
						end
				when 14 then -- switch 1, case (20500).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_tsr")))))
							l_return := True
						end
				when 15 then -- switch 1, case (20508).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_bexpr")))))
							l_return := True
						end
				when 16 then -- switch 1, case (20495).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_cm")))))
							l_return := True
						end
				when 17 then -- switch 1, case (12312).to_natural_32
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_POINTER_POINTER [NATURAL_8]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_onebuf_opt") + (create {PD_WINOPT_T}.make).offset_of ("wo_stl")))))
							l_return := True
						end
				when 18 then -- switch 1, done:
						if not l_return then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 19 then -- if done | if done
					if not l_return then
						l_tmp___0 := ((create {CE_CLASS_POINTER [PD_VIMOPTION]}.make_shared (c_pointer))).item.get_varp
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___0
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_VIMOPTION} -- private routines

	str2specialbuf (a_sp, a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		require
			not a_buf___6.is_void
		local
			l_sp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_s: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_sp.make (<<1>>)

			l_sp.item := a_sp
			a_buf___6.item := (('%/0/').code).to_natural_8
			from
			until
				not ((l_sp.item.item).to_boolean)
			loop
				l_s := (create {P_MESSAGE_STATIC}).str2special (l_sp, 0)
				l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))
				if (l_tmp + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6)))).to_integer_32 < a_len then
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (l_s)).do_nothing
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fullname := a_other.fullname
			shortname := a_other.shortname
			flags := a_other.flags
			var := a_other.var
			indir := a_other.indir
			def_val := a_other.def_val.twin
			scriptID := a_other.scriptID
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fullname.is_equal (a_other.fullname) and
				shortname.is_equal (a_other.shortname) and
				flags = a_other.flags and
				var.is_equal (a_other.var) and
				indir = a_other.indir and
				def_val.is_equal (a_other.def_val) and
				scriptID = a_other.scriptID
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fullname"),
					create {CE_STRUCTURE_FIELD}.make ("shortname"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("var"),
					create {CE_STRUCTURE_FIELD}.make ("indir"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("def_val", <<2>>),
					create {CE_STRUCTURE_FIELD}.make ("scriptID")
				>>)
			init_structure_info
		end

end
