class
	PD_WININFO_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_WININFO_S]} wi_next.make
			create {CE_CLASS_POINTER [PD_WININFO_S]} wi_prev.make
			create {CE_CLASS_POINTER [PD_WINDOW_S]} wi_win.make
			create wi_fpos.make
			create wi_opt.make
			create wi_folds.make
		end

feature {ANY} -- fields

	wi_next: CE_POINTER [PD_WININFO_S] assign set_wi_next

	wi_prev: CE_POINTER [PD_WININFO_S] assign set_wi_prev

	wi_win: CE_POINTER [PD_WINDOW_S] assign set_wi_win

	wi_fpos: PD_POS_T assign set_wi_fpos

	wi_optset: INTEGER_32 assign set_wi_optset

	wi_opt: PD_WINOPT_T assign set_wi_opt

	wi_fold_manual: INTEGER_32 assign set_wi_fold_manual

	wi_folds: PD_GROWARRAY assign set_wi_folds

feature {ANY} -- field setters

	set_wi_next (a_wi_next: CE_POINTER [PD_WININFO_S])
		do
			wi_next := a_wi_next
			update_memory_field ("wi_next")
		end

	set_wi_prev (a_wi_prev: CE_POINTER [PD_WININFO_S])
		do
			wi_prev := a_wi_prev
			update_memory_field ("wi_prev")
		end

	set_wi_win (a_wi_win: CE_POINTER [PD_WINDOW_S])
		do
			wi_win := a_wi_win
			update_memory_field ("wi_win")
		end

	set_wi_fpos (a_wi_fpos: PD_POS_T)
		do
			wi_fpos := a_wi_fpos
			update_memory_field ("wi_fpos")
		end

	set_wi_optset (a_wi_optset: INTEGER_32)
		do
			wi_optset := a_wi_optset
			update_memory_field ("wi_optset")
		end

	set_wi_opt (a_wi_opt: PD_WINOPT_T)
		do
			wi_opt := a_wi_opt
			update_memory_field ("wi_opt")
		end

	set_wi_fold_manual (a_wi_fold_manual: INTEGER_32)
		do
			wi_fold_manual := a_wi_fold_manual
			update_memory_field ("wi_fold_manual")
		end

	set_wi_folds (a_wi_folds: PD_GROWARRAY)
		do
			wi_folds := a_wi_folds
			update_memory_field ("wi_folds")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wi_next := a_other.wi_next
			wi_prev := a_other.wi_prev
			wi_win := a_other.wi_win
			wi_fpos := a_other.wi_fpos.twin
			wi_optset := a_other.wi_optset
			wi_opt := a_other.wi_opt.twin
			wi_fold_manual := a_other.wi_fold_manual
			wi_folds := a_other.wi_folds.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wi_next.is_equal (a_other.wi_next) and
				wi_prev.is_equal (a_other.wi_prev) and
				wi_win.is_equal (a_other.wi_win) and
				wi_fpos.is_equal (a_other.wi_fpos) and
				wi_optset = a_other.wi_optset and
				wi_opt.is_equal (a_other.wi_opt) and
				wi_fold_manual = a_other.wi_fold_manual and
				wi_folds.is_equal (a_other.wi_folds)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("wi_next"),
					create {CE_STRUCTURE_FIELD}.make ("wi_prev"),
					create {CE_STRUCTURE_FIELD}.make ("wi_win"),
					create {CE_STRUCTURE_FIELD}.make ("wi_fpos"),
					create {CE_STRUCTURE_FIELD}.make ("wi_optset"),
					create {CE_STRUCTURE_FIELD}.make ("wi_opt"),
					create {CE_STRUCTURE_FIELD}.make ("wi_fold_manual"),
					create {CE_STRUCTURE_FIELD}.make ("wi_folds")
				>>)
			init_structure_info
		end

end
