class
	PD_WN_U2

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_WORDNODE_S] assign set_next

	wnode: CE_POINTER [PD_WORDNODE_S] assign set_wnode

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_WORDNODE_S])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_wnode (a_wnode: CE_POINTER [PD_WORDNODE_S])
		do
			wnode := a_wnode
			update_memory_field ("wnode")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			wnode := a_other.wnode
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				wnode.is_equal (a_other.wnode)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("wnode")
				>>)
			init_structure_info
		end

end
