class
	PD_XFILEMARK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create fmark.make
			create {CE_NATURAL_8_POINTER} fname.make
			Precursor
		end

feature {ANY} -- fields

	fmark: PD_FILEMARK assign set_fmark

	fname: CE_POINTER [NATURAL_8] assign set_fname

feature {ANY} -- field setters

	set_fmark (a_fmark: PD_FILEMARK)
		do
			fmark := a_fmark
			update_memory_field ("fmark")
		end

	set_fname (a_fname: CE_POINTER [NATURAL_8])
		do
			fname := a_fname
			update_memory_field ("fname")
		end

feature {ANY} -- public routines

	fname2fnum
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: NATURAL_32
		do
			if not fname.is_void then
				if (fname[0]).to_integer_32 = 126 then
					if (fname[1]).to_integer_32 = 47 then
						(create {P_MISC1_STATIC}).expand_env (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("~/")), (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item))
						update_class_fields -- Current might have been changed; synchronize
						l_len := l_tmp.to_integer_32;
						(create {P_MISC2_STATIC}).vim_strncpy ((create {P_GLOBALS_STATIC}).NameBuff.item.item + l_len, fname + 2, ((4_096 - l_len) - 1).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
					else
						(create {P_MISC2_STATIC}).vim_strncpy ((create {P_GLOBALS_STATIC}).NameBuff.item.item, fname, (4_095).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					(create {P_MISC2_STATIC}).vim_strncpy ((create {P_GLOBALS_STATIC}).NameBuff.item.item, fname, (4_095).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_OS_UNIX_STATIC}).mch_dirname ((create {P_GLOBALS_STATIC}).IObuff.item, 1_025).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_p___0 := (create {P_FILEIO_STATIC}).shorten_fname ((create {P_GLOBALS_STATIC}).NameBuff.item.item, (create {P_GLOBALS_STATIC}).IObuff.item)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_BUFFER_STATIC}).buflist_new ((create {P_GLOBALS_STATIC}).NameBuff.item.item, l_p___0, (1).to_integer_32, 0).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	write_one_filemark (a_fp: CE_POINTER [SD_IO_FILE]; a_c1, a_c2: INTEGER_32)
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if fmark.mark.lnum = 0 then
				l_return := True
			end
			if not l_return then
				if fmark.fnum /= 0 then
					l_name___1 := (create {P_BUFFER_STATIC}).buflist_nr2name (fmark.fnum, 1, 0)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_name___1 := fname
				end
				if not l_name___1.is_void then
					if (l_name___1.item).to_integer_32 /= 0 then
						fprintf ([a_fp, ce_string ("%%c%%c  %%ld  %%ld  "), a_c1, a_c2, fmark.mark.lnum, (fmark.mark.col).to_integer_32]).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EX_CMDS_STATIC}).viminfo_writestring (a_fp, l_name___1)
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				if fmark.fnum /= 0 then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_name___1))
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fmark := a_other.fmark.twin
			fname := a_other.fname
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fmark.is_equal (a_other.fmark) and
				fname.is_equal (a_other.fname)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fmark"),
					create {CE_STRUCTURE_FIELD}.make ("fname")
				>>)
			init_structure_info
		end

end
