class
	S_UNISTD_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	environ: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_environ
		do
			create {CE_POINTER_POINTER [INTEGER_8]} Result.make_shared (c_environ)
		end

	c_environ: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)environ;"
		end

	set_environ (a_environ: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			c_set_environ (a_environ.c_pointer)
		end

	c_set_environ (a_environ: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"environ = (char * *)$a_environ;"
		end

feature {ANY} -- public routines

	unlink (a___name: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a___name.is_void
		do
			Result := c_unlink (a___name.c_pointer)
		end

	c_unlink (a___name: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return unlink($a___name);"
		end

	close (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return close($a___fd);"
		end

	readlink (a___path, a___buf: CE_POINTER [INTEGER_8]; a___len: NATURAL_32): INTEGER_32
		require
			not a___path.is_void
			not a___buf.is_void
		do
			Result := c_readlink (a___path.c_pointer, a___buf.c_pointer, a___len)
		end

	c_readlink (a___path: POINTER; a___buf: POINTER; a___len: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return readlink($a___path, $a___buf, $a___len);"
		end

	fchown (a___fd: INTEGER_32; a___owner: NATURAL_32; a___group: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fchown($a___fd, $a___owner, $a___group);"
		end

	getuid: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return getuid();"
		end

	getgid: NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return getgid();"
		end

	access (a___name: CE_POINTER [INTEGER_8]; a___type: INTEGER_32): INTEGER_32
		require
			not a___name.is_void
		do
			Result := c_access (a___name.c_pointer, a___type)
		end

	c_access (a___name: POINTER; a___type: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return access($a___name, $a___type);"
		end

	lseek (a___fd: INTEGER_32; a___offset: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return lseek($a___fd, $a___offset, $a___whence);"
		end

	read (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a___fd, a___buf.c_pointer, a___nbytes)
		end

	c_read (a___fd: INTEGER_32; a___buf: POINTER; a___nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return read($a___fd, $a___buf, $a___nbytes);"
		end

	write (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_write (a___fd, a___buf.c_pointer, a___n)
		end

	c_write (a___fd: INTEGER_32; a___buf: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return write($a___fd, $a___buf, $a___n);"
		end

	dup (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return dup($a___fd);"
		end

	rmdir (a___path: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a___path.is_void
		do
			Result := c_rmdir (a___path.c_pointer)
		end

	c_rmdir (a___path: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return rmdir($a___path);"
		end

	fsync (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fsync($a___fd);"
		end

	getpid: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return getpid();"
		end

	isatty (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return isatty($a___fd);"
		end

	sync
		external
			"C inline use <vim.h>"
		alias
			"sync();"
		end

	pipe (a___pipedes: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_pipe (a___pipedes.c_pointer)
		end

	c_pipe (a___pipedes: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return pipe($a___pipedes);"
		end

	chdir (a___path: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a___path.is_void
		do
			Result := c_chdir (a___path.c_pointer)
		end

	c_chdir (a___path: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return chdir($a___path);"
		end

	fchdir (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fchdir($a___fd);"
		end

	getcwd (a___buf: CE_POINTER [INTEGER_8]; a___size: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_getcwd (a___buf.c_pointer, a___size))
		end

	c_getcwd (a___buf: POINTER; a___size: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)getcwd($a___buf, $a___size);"
		end

	execvp (a___file: CE_POINTER [INTEGER_8]; a___argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a___file.is_void
		do
			Result := c_execvp (a___file.c_pointer, a___argv.c_pointer)
		end

	c_execvp (a___file: POINTER; a___argv: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return execvp($a___file, $a___argv);"
		end

	exit2 (a___status: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"_exit($a___status);"
		ensure
			False
		end

	sysconf (a___name: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return sysconf($a___name);"
		end

	setsid: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return setsid();"
		end

	fork: INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return eiffel_fork();"
		end

	sleep (a___seconds: NATURAL_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return sleep($a___seconds);"
		end

end
