class
	SD_GDKDRAGCONTEXT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_instance.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} source_window.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} dest_window.make
			create {CE_CLASS_POINTER [SD_GLIST]} targets.make
			create {CE_VOID_POINTER} windowing_data.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	protocol: NATURAL_32 assign set_protocol

	is_source: INTEGER_32 assign set_is_source

	source_window: CE_POINTER [SD_GDKDRAWABLE] assign set_source_window

	dest_window: CE_POINTER [SD_GDKDRAWABLE] assign set_dest_window

	targets: CE_POINTER [SD_GLIST] assign set_targets

	actions: NATURAL_32 assign set_actions

	suggested_action: NATURAL_32 assign set_suggested_action

	action: NATURAL_32 assign set_action

	start_time: NATURAL_32 assign set_start_time

	windowing_data: CE_POINTER [ANY] assign set_windowing_data

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_protocol (a_protocol: NATURAL_32)
		do
			protocol := a_protocol
			update_memory_field ("protocol")
		end

	set_is_source (a_is_source: INTEGER_32)
		do
			is_source := a_is_source
			update_memory_field ("is_source")
		end

	set_source_window (a_source_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			source_window := a_source_window
			update_memory_field ("source_window")
		end

	set_dest_window (a_dest_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			dest_window := a_dest_window
			update_memory_field ("dest_window")
		end

	set_targets (a_targets: CE_POINTER [SD_GLIST])
		do
			targets := a_targets
			update_memory_field ("targets")
		end

	set_actions (a_actions: NATURAL_32)
		do
			actions := a_actions
			update_memory_field ("actions")
		end

	set_suggested_action (a_suggested_action: NATURAL_32)
		do
			suggested_action := a_suggested_action
			update_memory_field ("suggested_action")
		end

	set_action (a_action: NATURAL_32)
		do
			action := a_action
			update_memory_field ("action")
		end

	set_start_time (a_start_time: NATURAL_32)
		do
			start_time := a_start_time
			update_memory_field ("start_time")
		end

	set_windowing_data (a_windowing_data: CE_POINTER [ANY])
		do
			windowing_data := a_windowing_data
			update_memory_field ("windowing_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			protocol := a_other.protocol
			is_source := a_other.is_source
			source_window := a_other.source_window
			dest_window := a_other.dest_window
			targets := a_other.targets
			actions := a_other.actions
			suggested_action := a_other.suggested_action
			action := a_other.action
			start_time := a_other.start_time
			windowing_data := a_other.windowing_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				protocol = a_other.protocol and
				is_source = a_other.is_source and
				source_window.is_equal (a_other.source_window) and
				dest_window.is_equal (a_other.dest_window) and
				targets.is_equal (a_other.targets) and
				actions = a_other.actions and
				suggested_action = a_other.suggested_action and
				action = a_other.action and
				start_time = a_other.start_time and
				windowing_data.is_equal (a_other.windowing_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("protocol"),
					create {CE_STRUCTURE_FIELD}.make ("is_source"),
					create {CE_STRUCTURE_FIELD}.make ("source_window"),
					create {CE_STRUCTURE_FIELD}.make ("dest_window"),
					create {CE_STRUCTURE_FIELD}.make ("targets"),
					create {CE_STRUCTURE_FIELD}.make ("actions"),
					create {CE_STRUCTURE_FIELD}.make ("suggested_action"),
					create {CE_STRUCTURE_FIELD}.make ("action"),
					create {CE_STRUCTURE_FIELD}.make ("start_time"),
					create {CE_STRUCTURE_FIELD}.make ("windowing_data")
				>>)
			init_structure_info
		end

end
