class
	SD_GDKEVENTGRABBROKEN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} window.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} grab_window.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	send_event: INTEGER_8 assign set_send_event

	keyboard: INTEGER_32 assign set_keyboard

	implicit: INTEGER_32 assign set_implicit

	grab_window: CE_POINTER [SD_GDKDRAWABLE] assign set_grab_window

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_send_event (a_send_event: INTEGER_8)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_keyboard (a_keyboard: INTEGER_32)
		do
			keyboard := a_keyboard
			update_memory_field ("keyboard")
		end

	set_implicit (a_implicit: INTEGER_32)
		do
			implicit := a_implicit
			update_memory_field ("implicit")
		end

	set_grab_window (a_grab_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			grab_window := a_grab_window
			update_memory_field ("grab_window")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			window := a_other.window
			send_event := a_other.send_event
			keyboard := a_other.keyboard
			implicit := a_other.implicit
			grab_window := a_other.grab_window
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				window.is_equal (a_other.window) and
				send_event = a_other.send_event and
				keyboard = a_other.keyboard and
				implicit = a_other.implicit and
				grab_window.is_equal (a_other.grab_window)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("keyboard"),
					create {CE_STRUCTURE_FIELD}.make ("implicit"),
					create {CE_STRUCTURE_FIELD}.make ("grab_window")
				>>)
			init_structure_info
		end

end
