class
	SD_GDKGC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_instance.make
			create {CE_CLASS_POINTER [SD_GDKCOLORMAP]} colormap.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	clip_x_origin: INTEGER_32 assign set_clip_x_origin

	clip_y_origin: INTEGER_32 assign set_clip_y_origin

	ts_x_origin: INTEGER_32 assign set_ts_x_origin

	ts_y_origin: INTEGER_32 assign set_ts_y_origin

	colormap: CE_POINTER [SD_GDKCOLORMAP] assign set_colormap

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_clip_x_origin (a_clip_x_origin: INTEGER_32)
		do
			clip_x_origin := a_clip_x_origin
			update_memory_field ("clip_x_origin")
		end

	set_clip_y_origin (a_clip_y_origin: INTEGER_32)
		do
			clip_y_origin := a_clip_y_origin
			update_memory_field ("clip_y_origin")
		end

	set_ts_x_origin (a_ts_x_origin: INTEGER_32)
		do
			ts_x_origin := a_ts_x_origin
			update_memory_field ("ts_x_origin")
		end

	set_ts_y_origin (a_ts_y_origin: INTEGER_32)
		do
			ts_y_origin := a_ts_y_origin
			update_memory_field ("ts_y_origin")
		end

	set_colormap (a_colormap: CE_POINTER [SD_GDKCOLORMAP])
		do
			colormap := a_colormap
			update_memory_field ("colormap")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			clip_x_origin := a_other.clip_x_origin
			clip_y_origin := a_other.clip_y_origin
			ts_x_origin := a_other.ts_x_origin
			ts_y_origin := a_other.ts_y_origin
			colormap := a_other.colormap
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				clip_x_origin = a_other.clip_x_origin and
				clip_y_origin = a_other.clip_y_origin and
				ts_x_origin = a_other.ts_x_origin and
				ts_y_origin = a_other.ts_y_origin and
				colormap.is_equal (a_other.colormap)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("clip_x_origin"),
					create {CE_STRUCTURE_FIELD}.make ("clip_y_origin"),
					create {CE_STRUCTURE_FIELD}.make ("ts_x_origin"),
					create {CE_STRUCTURE_FIELD}.make ("ts_y_origin"),
					create {CE_STRUCTURE_FIELD}.make ("colormap")
				>>)
			init_structure_info
		end

end
