class
	SD_GDKIMAGE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_instance.make
			create {CE_CLASS_POINTER [SD_GDKVISUAL]} visual.make
			create {CE_VOID_POINTER} mem.make
			create {CE_CLASS_POINTER [SD_GDKCOLORMAP]} colormap.make
			create {CE_VOID_POINTER} windowing_data.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	type: NATURAL_32 assign set_type

	visual: CE_POINTER [SD_GDKVISUAL] assign set_visual

	byte_order: NATURAL_32 assign set_byte_order

	width: INTEGER_32 assign set_width

	height: INTEGER_32 assign set_height

	depth: NATURAL_16 assign set_depth

	bpp: NATURAL_16 assign set_bpp

	bpl: NATURAL_16 assign set_bpl

	bits_per_pixel: NATURAL_16 assign set_bits_per_pixel

	mem: CE_POINTER [ANY] assign set_mem

	colormap: CE_POINTER [SD_GDKCOLORMAP] assign set_colormap

	windowing_data: CE_POINTER [ANY] assign set_windowing_data

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_visual (a_visual: CE_POINTER [SD_GDKVISUAL])
		do
			visual := a_visual
			update_memory_field ("visual")
		end

	set_byte_order (a_byte_order: NATURAL_32)
		do
			byte_order := a_byte_order
			update_memory_field ("byte_order")
		end

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: INTEGER_32)
		do
			height := a_height
			update_memory_field ("height")
		end

	set_depth (a_depth: NATURAL_16)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

	set_bpp (a_bpp: NATURAL_16)
		do
			bpp := a_bpp
			update_memory_field ("bpp")
		end

	set_bpl (a_bpl: NATURAL_16)
		do
			bpl := a_bpl
			update_memory_field ("bpl")
		end

	set_bits_per_pixel (a_bits_per_pixel: NATURAL_16)
		do
			bits_per_pixel := a_bits_per_pixel
			update_memory_field ("bits_per_pixel")
		end

	set_mem (a_mem: CE_POINTER [ANY])
		do
			mem := a_mem
			update_memory_field ("mem")
		end

	set_colormap (a_colormap: CE_POINTER [SD_GDKCOLORMAP])
		do
			colormap := a_colormap
			update_memory_field ("colormap")
		end

	set_windowing_data (a_windowing_data: CE_POINTER [ANY])
		do
			windowing_data := a_windowing_data
			update_memory_field ("windowing_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			type := a_other.type
			visual := a_other.visual
			byte_order := a_other.byte_order
			width := a_other.width
			height := a_other.height
			depth := a_other.depth
			bpp := a_other.bpp
			bpl := a_other.bpl
			bits_per_pixel := a_other.bits_per_pixel
			mem := a_other.mem
			colormap := a_other.colormap
			windowing_data := a_other.windowing_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				type = a_other.type and
				visual.is_equal (a_other.visual) and
				byte_order = a_other.byte_order and
				width = a_other.width and
				height = a_other.height and
				depth = a_other.depth and
				bpp = a_other.bpp and
				bpl = a_other.bpl and
				bits_per_pixel = a_other.bits_per_pixel and
				mem.is_equal (a_other.mem) and
				colormap.is_equal (a_other.colormap) and
				windowing_data.is_equal (a_other.windowing_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("visual"),
					create {CE_STRUCTURE_FIELD}.make ("byte_order"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height"),
					create {CE_STRUCTURE_FIELD}.make ("depth"),
					create {CE_STRUCTURE_FIELD}.make ("bpp"),
					create {CE_STRUCTURE_FIELD}.make ("bpl"),
					create {CE_STRUCTURE_FIELD}.make ("bits_per_pixel"),
					create {CE_STRUCTURE_FIELD}.make ("mem"),
					create {CE_STRUCTURE_FIELD}.make ("colormap"),
					create {CE_STRUCTURE_FIELD}.make ("windowing_data")
				>>)
			init_structure_info
		end

end
