class
	SD_GDKKEYBOARDGRABINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} window.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} native_window.make
		end

feature {ANY} -- fields

	window: CE_POINTER [SD_GDKDRAWABLE] assign set_window

	native_window: CE_POINTER [SD_GDKDRAWABLE] assign set_native_window

	serial: NATURAL_32 assign set_serial

	owner_events: INTEGER_32 assign set_owner_events

	time: NATURAL_32 assign set_time

feature {ANY} -- field setters

	set_window (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			window := a_window
			update_memory_field ("window")
		end

	set_native_window (a_native_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			native_window := a_native_window
			update_memory_field ("native_window")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_owner_events (a_owner_events: INTEGER_32)
		do
			owner_events := a_owner_events
			update_memory_field ("owner_events")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			window := a_other.window
			native_window := a_other.native_window
			serial := a_other.serial
			owner_events := a_other.owner_events
			time := a_other.time
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				window.is_equal (a_other.window) and
				native_window.is_equal (a_other.native_window) and
				serial = a_other.serial and
				owner_events = a_other.owner_events and
				time = a_other.time
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("native_window"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("owner_events"),
					create {CE_STRUCTURE_FIELD}.make ("time")
				>>)
			init_structure_info
		end

end
