class
	SD_GDKVISUAL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent_instance.make
		end

feature {ANY} -- fields

	parent_instance: SD_GOBJECT assign set_parent_instance

	type: NATURAL_32 assign set_type

	depth: INTEGER_32 assign set_depth

	byte_order: NATURAL_32 assign set_byte_order

	colormap_size: INTEGER_32 assign set_colormap_size

	bits_per_rgb: INTEGER_32 assign set_bits_per_rgb

	red_mask: NATURAL_32 assign set_red_mask

	red_shift: INTEGER_32 assign set_red_shift

	red_prec: INTEGER_32 assign set_red_prec

	green_mask: NATURAL_32 assign set_green_mask

	green_shift: INTEGER_32 assign set_green_shift

	green_prec: INTEGER_32 assign set_green_prec

	blue_mask: NATURAL_32 assign set_blue_mask

	blue_shift: INTEGER_32 assign set_blue_shift

	blue_prec: INTEGER_32 assign set_blue_prec

feature {ANY} -- field setters

	set_parent_instance (a_parent_instance: SD_GOBJECT)
		do
			parent_instance := a_parent_instance
			update_memory_field ("parent_instance")
		end

	set_type (a_type: NATURAL_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_depth (a_depth: INTEGER_32)
		do
			depth := a_depth
			update_memory_field ("depth")
		end

	set_byte_order (a_byte_order: NATURAL_32)
		do
			byte_order := a_byte_order
			update_memory_field ("byte_order")
		end

	set_colormap_size (a_colormap_size: INTEGER_32)
		do
			colormap_size := a_colormap_size
			update_memory_field ("colormap_size")
		end

	set_bits_per_rgb (a_bits_per_rgb: INTEGER_32)
		do
			bits_per_rgb := a_bits_per_rgb
			update_memory_field ("bits_per_rgb")
		end

	set_red_mask (a_red_mask: NATURAL_32)
		do
			red_mask := a_red_mask
			update_memory_field ("red_mask")
		end

	set_red_shift (a_red_shift: INTEGER_32)
		do
			red_shift := a_red_shift
			update_memory_field ("red_shift")
		end

	set_red_prec (a_red_prec: INTEGER_32)
		do
			red_prec := a_red_prec
			update_memory_field ("red_prec")
		end

	set_green_mask (a_green_mask: NATURAL_32)
		do
			green_mask := a_green_mask
			update_memory_field ("green_mask")
		end

	set_green_shift (a_green_shift: INTEGER_32)
		do
			green_shift := a_green_shift
			update_memory_field ("green_shift")
		end

	set_green_prec (a_green_prec: INTEGER_32)
		do
			green_prec := a_green_prec
			update_memory_field ("green_prec")
		end

	set_blue_mask (a_blue_mask: NATURAL_32)
		do
			blue_mask := a_blue_mask
			update_memory_field ("blue_mask")
		end

	set_blue_shift (a_blue_shift: INTEGER_32)
		do
			blue_shift := a_blue_shift
			update_memory_field ("blue_shift")
		end

	set_blue_prec (a_blue_prec: INTEGER_32)
		do
			blue_prec := a_blue_prec
			update_memory_field ("blue_prec")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent_instance := a_other.parent_instance.twin
			type := a_other.type
			depth := a_other.depth
			byte_order := a_other.byte_order
			colormap_size := a_other.colormap_size
			bits_per_rgb := a_other.bits_per_rgb
			red_mask := a_other.red_mask
			red_shift := a_other.red_shift
			red_prec := a_other.red_prec
			green_mask := a_other.green_mask
			green_shift := a_other.green_shift
			green_prec := a_other.green_prec
			blue_mask := a_other.blue_mask
			blue_shift := a_other.blue_shift
			blue_prec := a_other.blue_prec
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent_instance.is_equal (a_other.parent_instance) and
				type = a_other.type and
				depth = a_other.depth and
				byte_order = a_other.byte_order and
				colormap_size = a_other.colormap_size and
				bits_per_rgb = a_other.bits_per_rgb and
				red_mask = a_other.red_mask and
				red_shift = a_other.red_shift and
				red_prec = a_other.red_prec and
				green_mask = a_other.green_mask and
				green_shift = a_other.green_shift and
				green_prec = a_other.green_prec and
				blue_mask = a_other.blue_mask and
				blue_shift = a_other.blue_shift and
				blue_prec = a_other.blue_prec
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent_instance"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("depth"),
					create {CE_STRUCTURE_FIELD}.make ("byte_order"),
					create {CE_STRUCTURE_FIELD}.make ("colormap_size"),
					create {CE_STRUCTURE_FIELD}.make ("bits_per_rgb"),
					create {CE_STRUCTURE_FIELD}.make ("red_mask"),
					create {CE_STRUCTURE_FIELD}.make ("red_shift"),
					create {CE_STRUCTURE_FIELD}.make ("red_prec"),
					create {CE_STRUCTURE_FIELD}.make ("green_mask"),
					create {CE_STRUCTURE_FIELD}.make ("green_shift"),
					create {CE_STRUCTURE_FIELD}.make ("green_prec"),
					create {CE_STRUCTURE_FIELD}.make ("blue_mask"),
					create {CE_STRUCTURE_FIELD}.make ("blue_shift"),
					create {CE_STRUCTURE_FIELD}.make ("blue_prec")
				>>)
			init_structure_info
		end

end
