class
	SD_GERROR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} message.make
		end

feature {ANY} -- fields

	domain: NATURAL_32 assign set_domain

	code: INTEGER_32 assign set_code

	message: CE_POINTER [INTEGER_8] assign set_message

feature {ANY} -- field setters

	set_domain (a_domain: NATURAL_32)
		do
			domain := a_domain
			update_memory_field ("domain")
		end

	set_code (a_code: INTEGER_32)
		do
			code := a_code
			update_memory_field ("code")
		end

	set_message (a_message: CE_POINTER [INTEGER_8])
		do
			message := a_message
			update_memory_field ("message")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			domain := a_other.domain
			code := a_other.code
			message := a_other.message
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				domain = a_other.domain and
				code = a_other.code and
				message.is_equal (a_other.message)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("domain"),
					create {CE_STRUCTURE_FIELD}.make ("code"),
					create {CE_STRUCTURE_FIELD}.make ("message")
				>>)
			init_structure_info
		end

end
