class
	SD_GSOURCEFUNCS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create prepare.make
			create check2.make
			create dispatch.make
			create finalize.make
			create closure_callback.make
			create closure_marshal.make
		end

feature {ANY} -- fields

	prepare: CE_ROUTINE assign set_prepare

	check2: CE_ROUTINE assign set_check2

	dispatch: CE_ROUTINE assign set_dispatch

	finalize: CE_ROUTINE assign set_finalize

	closure_callback: CE_ROUTINE assign set_closure_callback

	closure_marshal: CE_ROUTINE assign set_closure_marshal

feature {ANY} -- field setters

	set_prepare (a_prepare: CE_ROUTINE)
		do
			prepare := a_prepare
			update_memory_field ("prepare")
		end

	set_check2 (a_check2: CE_ROUTINE)
		do
			check2 := a_check2
			update_memory_field ("check2")
		end

	set_dispatch (a_dispatch: CE_ROUTINE)
		do
			dispatch := a_dispatch
			update_memory_field ("dispatch")
		end

	set_finalize (a_finalize: CE_ROUTINE)
		do
			finalize := a_finalize
			update_memory_field ("finalize")
		end

	set_closure_callback (a_closure_callback: CE_ROUTINE)
		do
			closure_callback := a_closure_callback
			update_memory_field ("closure_callback")
		end

	set_closure_marshal (a_closure_marshal: CE_ROUTINE)
		do
			closure_marshal := a_closure_marshal
			update_memory_field ("closure_marshal")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			prepare := a_other.prepare
			check2 := a_other.check2
			dispatch := a_other.dispatch
			finalize := a_other.finalize
			closure_callback := a_other.closure_callback
			closure_marshal := a_other.closure_marshal
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				prepare.is_equal (a_other.prepare) and
				check2.is_equal (a_other.check2) and
				dispatch.is_equal (a_other.dispatch) and
				finalize.is_equal (a_other.finalize) and
				closure_callback.is_equal (a_other.closure_callback) and
				closure_marshal.is_equal (a_other.closure_marshal)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("prepare"),
					create {CE_STRUCTURE_FIELD}.make ("check2"),
					create {CE_STRUCTURE_FIELD}.make ("dispatch"),
					create {CE_STRUCTURE_FIELD}.make ("finalize"),
					create {CE_STRUCTURE_FIELD}.make ("closure_callback"),
					create {CE_STRUCTURE_FIELD}.make ("closure_marshal")
				>>)
			init_structure_info
		end

end
