class
	SD_GSTRING

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} str.make
		end

feature {ANY} -- fields

	str: CE_POINTER [INTEGER_8] assign set_str

	len: NATURAL_32 assign set_len

	allocated_len: NATURAL_32 assign set_allocated_len

feature {ANY} -- field setters

	set_str (a_str: CE_POINTER [INTEGER_8])
		do
			str := a_str
			update_memory_field ("str")
		end

	set_len (a_len: NATURAL_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_allocated_len (a_allocated_len: NATURAL_32)
		do
			allocated_len := a_allocated_len
			update_memory_field ("allocated_len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			str := a_other.str
			len := a_other.len
			allocated_len := a_other.allocated_len
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				str.is_equal (a_other.str) and
				len = a_other.len and
				allocated_len = a_other.allocated_len
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("str"),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("allocated_len")
				>>)
			init_structure_info
		end

end
