class
	SD_GTKACCELGROUP

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create parent.make
			create {CE_CLASS_POINTER [SD_GSLIST]} acceleratables.make
			create {CE_CLASS_POINTER [SD_GTKACCELGROUPENTRY]} priv_accels.make
		end

feature {ANY} -- fields

	parent: SD_GOBJECT assign set_parent

	lock_count: NATURAL_32 assign set_lock_count

	modifier_mask: NATURAL_32 assign set_modifier_mask

	acceleratables: CE_POINTER [SD_GSLIST] assign set_acceleratables

	n_accels: NATURAL_32 assign set_n_accels

	priv_accels: CE_POINTER [SD_GTKACCELGROUPENTRY] assign set_priv_accels

feature {ANY} -- field setters

	set_parent (a_parent: SD_GOBJECT)
		do
			parent := a_parent
			update_memory_field ("parent")
		end

	set_lock_count (a_lock_count: NATURAL_32)
		do
			lock_count := a_lock_count
			update_memory_field ("lock_count")
		end

	set_modifier_mask (a_modifier_mask: NATURAL_32)
		do
			modifier_mask := a_modifier_mask
			update_memory_field ("modifier_mask")
		end

	set_acceleratables (a_acceleratables: CE_POINTER [SD_GSLIST])
		do
			acceleratables := a_acceleratables
			update_memory_field ("acceleratables")
		end

	set_n_accels (a_n_accels: NATURAL_32)
		do
			n_accels := a_n_accels
			update_memory_field ("n_accels")
		end

	set_priv_accels (a_priv_accels: CE_POINTER [SD_GTKACCELGROUPENTRY])
		do
			priv_accels := a_priv_accels
			update_memory_field ("priv_accels")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			parent := a_other.parent.twin
			lock_count := a_other.lock_count
			modifier_mask := a_other.modifier_mask
			acceleratables := a_other.acceleratables
			n_accels := a_other.n_accels
			priv_accels := a_other.priv_accels
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				parent.is_equal (a_other.parent) and
				lock_count = a_other.lock_count and
				modifier_mask = a_other.modifier_mask and
				acceleratables.is_equal (a_other.acceleratables) and
				n_accels = a_other.n_accels and
				priv_accels.is_equal (a_other.priv_accels)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("parent"),
					create {CE_STRUCTURE_FIELD}.make ("lock_count"),
					create {CE_STRUCTURE_FIELD}.make ("modifier_mask"),
					create {CE_STRUCTURE_FIELD}.make ("acceleratables"),
					create {CE_STRUCTURE_FIELD}.make ("n_accels"),
					create {CE_STRUCTURE_FIELD}.make ("priv_accels")
				>>)
			init_structure_info
		end

end
