class
	SD_GTKIMAGE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create misc.make
			create data.make
			create {CE_CLASS_POINTER [SD_GDKDRAWABLE]} mask.make
		end

feature {ANY} -- fields

	misc: SD_GTKMISC assign set_misc

	storage_type: NATURAL_32 assign set_storage_type

	data: SD_DATA4 assign set_data

	mask: CE_POINTER [SD_GDKDRAWABLE] assign set_mask

	icon_size: NATURAL_32 assign set_icon_size

feature {ANY} -- field setters

	set_misc (a_misc: SD_GTKMISC)
		do
			misc := a_misc
			update_memory_field ("misc")
		end

	set_storage_type (a_storage_type: NATURAL_32)
		do
			storage_type := a_storage_type
			update_memory_field ("storage_type")
		end

	set_data (a_data: SD_DATA4)
		do
			data := a_data
			update_memory_field ("data")
		end

	set_mask (a_mask: CE_POINTER [SD_GDKDRAWABLE])
		do
			mask := a_mask
			update_memory_field ("mask")
		end

	set_icon_size (a_icon_size: NATURAL_32)
		do
			icon_size := a_icon_size
			update_memory_field ("icon_size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			misc := a_other.misc.twin
			storage_type := a_other.storage_type
			data := a_other.data.twin
			mask := a_other.mask
			icon_size := a_other.icon_size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				misc.is_equal (a_other.misc) and
				storage_type = a_other.storage_type and
				data.is_equal (a_other.data) and
				mask.is_equal (a_other.mask) and
				icon_size = a_other.icon_size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("misc"),
					create {CE_STRUCTURE_FIELD}.make ("storage_type"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("mask"),
					create {CE_STRUCTURE_FIELD}.make ("icon_size")
				>>)
			init_structure_info
		end

end
