class
	SD_GTKIMAGEGICONDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} icon.make
			create {CE_VOID_POINTER} pixbuf.make
		end

feature {ANY} -- fields

	icon: CE_POINTER [ANY] assign set_icon

	pixbuf: CE_POINTER [ANY] assign set_pixbuf

	theme_change_id: NATURAL_32 assign set_theme_change_id

feature {ANY} -- field setters

	set_icon (a_icon: CE_POINTER [ANY])
		do
			icon := a_icon
			update_memory_field ("icon")
		end

	set_pixbuf (a_pixbuf: CE_POINTER [ANY])
		do
			pixbuf := a_pixbuf
			update_memory_field ("pixbuf")
		end

	set_theme_change_id (a_theme_change_id: NATURAL_32)
		do
			theme_change_id := a_theme_change_id
			update_memory_field ("theme_change_id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			icon := a_other.icon
			pixbuf := a_other.pixbuf
			theme_change_id := a_other.theme_change_id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				icon.is_equal (a_other.icon) and
				pixbuf.is_equal (a_other.pixbuf) and
				theme_change_id = a_other.theme_change_id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("icon"),
					create {CE_STRUCTURE_FIELD}.make ("pixbuf"),
					create {CE_STRUCTURE_FIELD}.make ("theme_change_id")
				>>)
			init_structure_info
		end

end
