class
	SD_GTKLABEL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	misc: SD_GTKMISC assign set_misc

	label: CE_POINTER [INTEGER_8] assign set_label

	jtype: NATURAL_32 assign set_jtype

	wrap: NATURAL_32 assign set_wrap

	use_underline: NATURAL_32 assign set_use_underline

	use_markup: NATURAL_32 assign set_use_markup

	ellipsize: NATURAL_32 assign set_ellipsize

	single_line_mode: NATURAL_32 assign set_single_line_mode

	have_transform: NATURAL_32 assign set_have_transform

	in_click: NATURAL_32 assign set_in_click

	wrap_mode: NATURAL_32 assign set_wrap_mode

	pattern_set: NATURAL_32 assign set_pattern_set

	track_links: NATURAL_32 assign set_track_links

	mnemonic_keyval: NATURAL_32 assign set_mnemonic_keyval

	text: CE_POINTER [INTEGER_8] assign set_text

	attrs: CE_POINTER [ANY] assign set_attrs

	effective_attrs: CE_POINTER [ANY] assign set_effective_attrs

	layout: CE_POINTER [ANY] assign set_layout

	mnemonic_widget: CE_POINTER [SD_GTKWIDGET] assign set_mnemonic_widget

	mnemonic_window: CE_POINTER [SD_GTKWINDOW] assign set_mnemonic_window

	select_info: CE_POINTER [ANY] assign set_select_info

feature {ANY} -- field setters

	set_misc (a_misc: SD_GTKMISC)
		do
			misc := a_misc
			update_memory_field ("misc")
		end

	set_label (a_label: CE_POINTER [INTEGER_8])
		do
			label := a_label
			update_memory_field ("label")
		end

	set_jtype (a_jtype: NATURAL_32)
		do
			jtype := a_jtype
			update_memory_field ("jtype")
		end

	set_wrap (a_wrap: NATURAL_32)
		do
			wrap := a_wrap
			update_memory_field ("wrap")
		end

	set_use_underline (a_use_underline: NATURAL_32)
		do
			use_underline := a_use_underline
			update_memory_field ("use_underline")
		end

	set_use_markup (a_use_markup: NATURAL_32)
		do
			use_markup := a_use_markup
			update_memory_field ("use_markup")
		end

	set_ellipsize (a_ellipsize: NATURAL_32)
		do
			ellipsize := a_ellipsize
			update_memory_field ("ellipsize")
		end

	set_single_line_mode (a_single_line_mode: NATURAL_32)
		do
			single_line_mode := a_single_line_mode
			update_memory_field ("single_line_mode")
		end

	set_have_transform (a_have_transform: NATURAL_32)
		do
			have_transform := a_have_transform
			update_memory_field ("have_transform")
		end

	set_in_click (a_in_click: NATURAL_32)
		do
			in_click := a_in_click
			update_memory_field ("in_click")
		end

	set_wrap_mode (a_wrap_mode: NATURAL_32)
		do
			wrap_mode := a_wrap_mode
			update_memory_field ("wrap_mode")
		end

	set_pattern_set (a_pattern_set: NATURAL_32)
		do
			pattern_set := a_pattern_set
			update_memory_field ("pattern_set")
		end

	set_track_links (a_track_links: NATURAL_32)
		do
			track_links := a_track_links
			update_memory_field ("track_links")
		end

	set_mnemonic_keyval (a_mnemonic_keyval: NATURAL_32)
		do
			mnemonic_keyval := a_mnemonic_keyval
			update_memory_field ("mnemonic_keyval")
		end

	set_text (a_text: CE_POINTER [INTEGER_8])
		do
			text := a_text
			update_memory_field ("text")
		end

	set_attrs (a_attrs: CE_POINTER [ANY])
		do
			attrs := a_attrs
			update_memory_field ("attrs")
		end

	set_effective_attrs (a_effective_attrs: CE_POINTER [ANY])
		do
			effective_attrs := a_effective_attrs
			update_memory_field ("effective_attrs")
		end

	set_layout (a_layout: CE_POINTER [ANY])
		do
			layout := a_layout
			update_memory_field ("layout")
		end

	set_mnemonic_widget (a_mnemonic_widget: CE_POINTER [SD_GTKWIDGET])
		do
			mnemonic_widget := a_mnemonic_widget
			update_memory_field ("mnemonic_widget")
		end

	set_mnemonic_window (a_mnemonic_window: CE_POINTER [SD_GTKWINDOW])
		do
			mnemonic_window := a_mnemonic_window
			update_memory_field ("mnemonic_window")
		end

	set_select_info (a_select_info: CE_POINTER [ANY])
		do
			select_info := a_select_info
			update_memory_field ("select_info")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			misc := a_other.misc.twin
			label := a_other.label
			jtype := a_other.jtype
			wrap := a_other.wrap
			use_underline := a_other.use_underline
			use_markup := a_other.use_markup
			ellipsize := a_other.ellipsize
			single_line_mode := a_other.single_line_mode
			have_transform := a_other.have_transform
			in_click := a_other.in_click
			wrap_mode := a_other.wrap_mode
			pattern_set := a_other.pattern_set
			track_links := a_other.track_links
			mnemonic_keyval := a_other.mnemonic_keyval
			text := a_other.text
			attrs := a_other.attrs
			effective_attrs := a_other.effective_attrs
			layout := a_other.layout
			mnemonic_widget := a_other.mnemonic_widget
			mnemonic_window := a_other.mnemonic_window
			select_info := a_other.select_info
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				misc.is_equal (a_other.misc) and
				label.is_equal (a_other.label) and
				jtype = a_other.jtype and
				wrap = a_other.wrap and
				use_underline = a_other.use_underline and
				use_markup = a_other.use_markup and
				ellipsize = a_other.ellipsize and
				single_line_mode = a_other.single_line_mode and
				have_transform = a_other.have_transform and
				in_click = a_other.in_click and
				wrap_mode = a_other.wrap_mode and
				pattern_set = a_other.pattern_set and
				track_links = a_other.track_links and
				mnemonic_keyval = a_other.mnemonic_keyval and
				text.is_equal (a_other.text) and
				attrs.is_equal (a_other.attrs) and
				effective_attrs.is_equal (a_other.effective_attrs) and
				layout.is_equal (a_other.layout) and
				mnemonic_widget.is_equal (a_other.mnemonic_widget) and
				mnemonic_window.is_equal (a_other.mnemonic_window) and
				select_info.is_equal (a_other.select_info)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("misc"),
					create {CE_STRUCTURE_FIELD}.make ("label"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("jtype"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("wrap"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("use_underline"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("use_markup"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("ellipsize"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("single_line_mode"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("have_transform"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("in_click"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("wrap_mode"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("pattern_set"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("track_links"),
					create {CE_STRUCTURE_FIELD}.make ("mnemonic_keyval"),
					create {CE_STRUCTURE_FIELD}.make ("text"),
					create {CE_STRUCTURE_FIELD}.make ("attrs"),
					create {CE_STRUCTURE_FIELD}.make ("effective_attrs"),
					create {CE_STRUCTURE_FIELD}.make ("layout"),
					create {CE_STRUCTURE_FIELD}.make ("mnemonic_widget"),
					create {CE_STRUCTURE_FIELD}.make ("mnemonic_window"),
					create {CE_STRUCTURE_FIELD}.make ("select_info")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkLabel);
					if(strcmp(field_name, "mnemonic_keyval") == 0) return offsetof(struct _GtkLabel, mnemonic_keyval);
				} else {
					struct _GtkLabel *p = (struct _GtkLabel *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "jtype") == 0) p->jtype = (unsigned int)$a_value;
						else if(strcmp(field_name, "wrap") == 0) p->wrap = (unsigned int)$a_value;
						else if(strcmp(field_name, "use_underline") == 0) p->use_underline = (unsigned int)$a_value;
						else if(strcmp(field_name, "use_markup") == 0) p->use_markup = (unsigned int)$a_value;
						else if(strcmp(field_name, "ellipsize") == 0) p->ellipsize = (unsigned int)$a_value;
						else if(strcmp(field_name, "single_line_mode") == 0) p->single_line_mode = (unsigned int)$a_value;
						else if(strcmp(field_name, "have_transform") == 0) p->have_transform = (unsigned int)$a_value;
						else if(strcmp(field_name, "in_click") == 0) p->in_click = (unsigned int)$a_value;
						else if(strcmp(field_name, "wrap_mode") == 0) p->wrap_mode = (unsigned int)$a_value;
						else if(strcmp(field_name, "pattern_set") == 0) p->pattern_set = (unsigned int)$a_value;
						else if(strcmp(field_name, "track_links") == 0) p->track_links = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "jtype") == 0) return p->jtype;
						if(strcmp(field_name, "wrap") == 0) return p->wrap;
						if(strcmp(field_name, "use_underline") == 0) return p->use_underline;
						if(strcmp(field_name, "use_markup") == 0) return p->use_markup;
						if(strcmp(field_name, "ellipsize") == 0) return p->ellipsize;
						if(strcmp(field_name, "single_line_mode") == 0) return p->single_line_mode;
						if(strcmp(field_name, "have_transform") == 0) return p->have_transform;
						if(strcmp(field_name, "in_click") == 0) return p->in_click;
						if(strcmp(field_name, "wrap_mode") == 0) return p->wrap_mode;
						if(strcmp(field_name, "pattern_set") == 0) return p->pattern_set;
						if(strcmp(field_name, "track_links") == 0) return p->track_links;
					}
				}
			]"
		end

end
