class
	SD_GTKMENU

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	menu_shell: SD_GTKMENUSHELL assign set_menu_shell

	parent_menu_item: CE_POINTER [SD_GTKWIDGET] assign set_parent_menu_item

	old_active_menu_item: CE_POINTER [SD_GTKWIDGET] assign set_old_active_menu_item

	accel_group: CE_POINTER [SD_GTKACCELGROUP] assign set_accel_group

	accel_path: CE_POINTER [INTEGER_8] assign set_accel_path

	position_func: CE_ROUTINE assign set_position_func

	position_func_data: CE_POINTER [ANY] assign set_position_func_data

	toggle_size: NATURAL_32 assign set_toggle_size

	toplevel: CE_POINTER [SD_GTKWIDGET] assign set_toplevel

	tearoff_window: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_window

	tearoff_hbox: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_hbox

	tearoff_scrollbar: CE_POINTER [SD_GTKWIDGET] assign set_tearoff_scrollbar

	tearoff_adjustment: CE_POINTER [SD_GTKADJUSTMENT] assign set_tearoff_adjustment

	view_window: CE_POINTER [SD_GDKDRAWABLE] assign set_view_window

	bin_window: CE_POINTER [SD_GDKDRAWABLE] assign set_bin_window

	scroll_offset: INTEGER_32 assign set_scroll_offset

	saved_scroll_offset: INTEGER_32 assign set_saved_scroll_offset

	scroll_step: INTEGER_32 assign set_scroll_step

	timeout_id: NATURAL_32 assign set_timeout_id

	navigation_region: CE_POINTER [ANY] assign set_navigation_region

	navigation_timeout: NATURAL_32 assign set_navigation_timeout

	needs_destruction_ref_count: NATURAL_32 assign set_needs_destruction_ref_count

	torn_off: NATURAL_32 assign set_torn_off

	tearoff_active: NATURAL_32 assign set_tearoff_active

	scroll_fast: NATURAL_32 assign set_scroll_fast

	upper_arrow_visible: NATURAL_32 assign set_upper_arrow_visible

	lower_arrow_visible: NATURAL_32 assign set_lower_arrow_visible

	upper_arrow_prelight: NATURAL_32 assign set_upper_arrow_prelight

	lower_arrow_prelight: NATURAL_32 assign set_lower_arrow_prelight

feature {ANY} -- field setters

	set_menu_shell (a_menu_shell: SD_GTKMENUSHELL)
		do
			menu_shell := a_menu_shell
			update_memory_field ("menu_shell")
		end

	set_parent_menu_item (a_parent_menu_item: CE_POINTER [SD_GTKWIDGET])
		do
			parent_menu_item := a_parent_menu_item
			update_memory_field ("parent_menu_item")
		end

	set_old_active_menu_item (a_old_active_menu_item: CE_POINTER [SD_GTKWIDGET])
		do
			old_active_menu_item := a_old_active_menu_item
			update_memory_field ("old_active_menu_item")
		end

	set_accel_group (a_accel_group: CE_POINTER [SD_GTKACCELGROUP])
		do
			accel_group := a_accel_group
			update_memory_field ("accel_group")
		end

	set_accel_path (a_accel_path: CE_POINTER [INTEGER_8])
		do
			accel_path := a_accel_path
			update_memory_field ("accel_path")
		end

	set_position_func (a_position_func: CE_ROUTINE)
		do
			position_func := a_position_func
			update_memory_field ("position_func")
		end

	set_position_func_data (a_position_func_data: CE_POINTER [ANY])
		do
			position_func_data := a_position_func_data
			update_memory_field ("position_func_data")
		end

	set_toggle_size (a_toggle_size: NATURAL_32)
		do
			toggle_size := a_toggle_size
			update_memory_field ("toggle_size")
		end

	set_toplevel (a_toplevel: CE_POINTER [SD_GTKWIDGET])
		do
			toplevel := a_toplevel
			update_memory_field ("toplevel")
		end

	set_tearoff_window (a_tearoff_window: CE_POINTER [SD_GTKWIDGET])
		do
			tearoff_window := a_tearoff_window
			update_memory_field ("tearoff_window")
		end

	set_tearoff_hbox (a_tearoff_hbox: CE_POINTER [SD_GTKWIDGET])
		do
			tearoff_hbox := a_tearoff_hbox
			update_memory_field ("tearoff_hbox")
		end

	set_tearoff_scrollbar (a_tearoff_scrollbar: CE_POINTER [SD_GTKWIDGET])
		do
			tearoff_scrollbar := a_tearoff_scrollbar
			update_memory_field ("tearoff_scrollbar")
		end

	set_tearoff_adjustment (a_tearoff_adjustment: CE_POINTER [SD_GTKADJUSTMENT])
		do
			tearoff_adjustment := a_tearoff_adjustment
			update_memory_field ("tearoff_adjustment")
		end

	set_view_window (a_view_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			view_window := a_view_window
			update_memory_field ("view_window")
		end

	set_bin_window (a_bin_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			bin_window := a_bin_window
			update_memory_field ("bin_window")
		end

	set_scroll_offset (a_scroll_offset: INTEGER_32)
		do
			scroll_offset := a_scroll_offset
			update_memory_field ("scroll_offset")
		end

	set_saved_scroll_offset (a_saved_scroll_offset: INTEGER_32)
		do
			saved_scroll_offset := a_saved_scroll_offset
			update_memory_field ("saved_scroll_offset")
		end

	set_scroll_step (a_scroll_step: INTEGER_32)
		do
			scroll_step := a_scroll_step
			update_memory_field ("scroll_step")
		end

	set_timeout_id (a_timeout_id: NATURAL_32)
		do
			timeout_id := a_timeout_id
			update_memory_field ("timeout_id")
		end

	set_navigation_region (a_navigation_region: CE_POINTER [ANY])
		do
			navigation_region := a_navigation_region
			update_memory_field ("navigation_region")
		end

	set_navigation_timeout (a_navigation_timeout: NATURAL_32)
		do
			navigation_timeout := a_navigation_timeout
			update_memory_field ("navigation_timeout")
		end

	set_needs_destruction_ref_count (a_needs_destruction_ref_count: NATURAL_32)
		do
			needs_destruction_ref_count := a_needs_destruction_ref_count
			update_memory_field ("needs_destruction_ref_count")
		end

	set_torn_off (a_torn_off: NATURAL_32)
		do
			torn_off := a_torn_off
			update_memory_field ("torn_off")
		end

	set_tearoff_active (a_tearoff_active: NATURAL_32)
		do
			tearoff_active := a_tearoff_active
			update_memory_field ("tearoff_active")
		end

	set_scroll_fast (a_scroll_fast: NATURAL_32)
		do
			scroll_fast := a_scroll_fast
			update_memory_field ("scroll_fast")
		end

	set_upper_arrow_visible (a_upper_arrow_visible: NATURAL_32)
		do
			upper_arrow_visible := a_upper_arrow_visible
			update_memory_field ("upper_arrow_visible")
		end

	set_lower_arrow_visible (a_lower_arrow_visible: NATURAL_32)
		do
			lower_arrow_visible := a_lower_arrow_visible
			update_memory_field ("lower_arrow_visible")
		end

	set_upper_arrow_prelight (a_upper_arrow_prelight: NATURAL_32)
		do
			upper_arrow_prelight := a_upper_arrow_prelight
			update_memory_field ("upper_arrow_prelight")
		end

	set_lower_arrow_prelight (a_lower_arrow_prelight: NATURAL_32)
		do
			lower_arrow_prelight := a_lower_arrow_prelight
			update_memory_field ("lower_arrow_prelight")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			menu_shell := a_other.menu_shell.twin
			parent_menu_item := a_other.parent_menu_item
			old_active_menu_item := a_other.old_active_menu_item
			accel_group := a_other.accel_group
			accel_path := a_other.accel_path
			position_func := a_other.position_func
			position_func_data := a_other.position_func_data
			toggle_size := a_other.toggle_size
			toplevel := a_other.toplevel
			tearoff_window := a_other.tearoff_window
			tearoff_hbox := a_other.tearoff_hbox
			tearoff_scrollbar := a_other.tearoff_scrollbar
			tearoff_adjustment := a_other.tearoff_adjustment
			view_window := a_other.view_window
			bin_window := a_other.bin_window
			scroll_offset := a_other.scroll_offset
			saved_scroll_offset := a_other.saved_scroll_offset
			scroll_step := a_other.scroll_step
			timeout_id := a_other.timeout_id
			navigation_region := a_other.navigation_region
			navigation_timeout := a_other.navigation_timeout
			needs_destruction_ref_count := a_other.needs_destruction_ref_count
			torn_off := a_other.torn_off
			tearoff_active := a_other.tearoff_active
			scroll_fast := a_other.scroll_fast
			upper_arrow_visible := a_other.upper_arrow_visible
			lower_arrow_visible := a_other.lower_arrow_visible
			upper_arrow_prelight := a_other.upper_arrow_prelight
			lower_arrow_prelight := a_other.lower_arrow_prelight
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				menu_shell.is_equal (a_other.menu_shell) and
				parent_menu_item.is_equal (a_other.parent_menu_item) and
				old_active_menu_item.is_equal (a_other.old_active_menu_item) and
				accel_group.is_equal (a_other.accel_group) and
				accel_path.is_equal (a_other.accel_path) and
				position_func.is_equal (a_other.position_func) and
				position_func_data.is_equal (a_other.position_func_data) and
				toggle_size = a_other.toggle_size and
				toplevel.is_equal (a_other.toplevel) and
				tearoff_window.is_equal (a_other.tearoff_window) and
				tearoff_hbox.is_equal (a_other.tearoff_hbox) and
				tearoff_scrollbar.is_equal (a_other.tearoff_scrollbar) and
				tearoff_adjustment.is_equal (a_other.tearoff_adjustment) and
				view_window.is_equal (a_other.view_window) and
				bin_window.is_equal (a_other.bin_window) and
				scroll_offset = a_other.scroll_offset and
				saved_scroll_offset = a_other.saved_scroll_offset and
				scroll_step = a_other.scroll_step and
				timeout_id = a_other.timeout_id and
				navigation_region.is_equal (a_other.navigation_region) and
				navigation_timeout = a_other.navigation_timeout and
				needs_destruction_ref_count = a_other.needs_destruction_ref_count and
				torn_off = a_other.torn_off and
				tearoff_active = a_other.tearoff_active and
				scroll_fast = a_other.scroll_fast and
				upper_arrow_visible = a_other.upper_arrow_visible and
				lower_arrow_visible = a_other.lower_arrow_visible and
				upper_arrow_prelight = a_other.upper_arrow_prelight and
				lower_arrow_prelight = a_other.lower_arrow_prelight
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("menu_shell"),
					create {CE_STRUCTURE_FIELD}.make ("parent_menu_item"),
					create {CE_STRUCTURE_FIELD}.make ("old_active_menu_item"),
					create {CE_STRUCTURE_FIELD}.make ("accel_group"),
					create {CE_STRUCTURE_FIELD}.make ("accel_path"),
					create {CE_STRUCTURE_FIELD}.make ("position_func"),
					create {CE_STRUCTURE_FIELD}.make ("position_func_data"),
					create {CE_STRUCTURE_FIELD}.make ("toggle_size"),
					create {CE_STRUCTURE_FIELD}.make ("toplevel"),
					create {CE_STRUCTURE_FIELD}.make ("tearoff_window"),
					create {CE_STRUCTURE_FIELD}.make ("tearoff_hbox"),
					create {CE_STRUCTURE_FIELD}.make ("tearoff_scrollbar"),
					create {CE_STRUCTURE_FIELD}.make ("tearoff_adjustment"),
					create {CE_STRUCTURE_FIELD}.make ("view_window"),
					create {CE_STRUCTURE_FIELD}.make ("bin_window"),
					create {CE_STRUCTURE_FIELD}.make ("scroll_offset"),
					create {CE_STRUCTURE_FIELD}.make ("saved_scroll_offset"),
					create {CE_STRUCTURE_FIELD}.make ("scroll_step"),
					create {CE_STRUCTURE_FIELD}.make ("timeout_id"),
					create {CE_STRUCTURE_FIELD}.make ("navigation_region"),
					create {CE_STRUCTURE_FIELD}.make ("navigation_timeout"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("needs_destruction_ref_count"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("torn_off"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("tearoff_active"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("scroll_fast"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("upper_arrow_visible"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("lower_arrow_visible"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("upper_arrow_prelight"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("lower_arrow_prelight")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkMenu);
				} else {
					struct _GtkMenu *p = (struct _GtkMenu *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "needs_destruction_ref_count") == 0) p->needs_destruction_ref_count = (unsigned int)$a_value;
						else if(strcmp(field_name, "torn_off") == 0) p->torn_off = (unsigned int)$a_value;
						else if(strcmp(field_name, "tearoff_active") == 0) p->tearoff_active = (unsigned int)$a_value;
						else if(strcmp(field_name, "scroll_fast") == 0) p->scroll_fast = (unsigned int)$a_value;
						else if(strcmp(field_name, "upper_arrow_visible") == 0) p->upper_arrow_visible = (unsigned int)$a_value;
						else if(strcmp(field_name, "lower_arrow_visible") == 0) p->lower_arrow_visible = (unsigned int)$a_value;
						else if(strcmp(field_name, "upper_arrow_prelight") == 0) p->upper_arrow_prelight = (unsigned int)$a_value;
						else if(strcmp(field_name, "lower_arrow_prelight") == 0) p->lower_arrow_prelight = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "needs_destruction_ref_count") == 0) return p->needs_destruction_ref_count;
						if(strcmp(field_name, "torn_off") == 0) return p->torn_off;
						if(strcmp(field_name, "tearoff_active") == 0) return p->tearoff_active;
						if(strcmp(field_name, "scroll_fast") == 0) return p->scroll_fast;
						if(strcmp(field_name, "upper_arrow_visible") == 0) return p->upper_arrow_visible;
						if(strcmp(field_name, "lower_arrow_visible") == 0) return p->lower_arrow_visible;
						if(strcmp(field_name, "upper_arrow_prelight") == 0) return p->upper_arrow_prelight;
						if(strcmp(field_name, "lower_arrow_prelight") == 0) return p->lower_arrow_prelight;
					}
				}
			]"
		end

end
