class
	SD_GTKMENUITEM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	item: SD_GTKITEM assign set_item

	submenu: CE_POINTER [SD_GTKWIDGET] assign set_submenu

	event_window: CE_POINTER [SD_GDKDRAWABLE] assign set_event_window

	toggle_size: NATURAL_16 assign set_toggle_size

	accelerator_width: NATURAL_16 assign set_accelerator_width

	accel_path: CE_POINTER [INTEGER_8] assign set_accel_path

	show_submenu_indicator: NATURAL_32 assign set_show_submenu_indicator

	submenu_placement: NATURAL_32 assign set_submenu_placement

	submenu_direction: NATURAL_32 assign set_submenu_direction

	right_justify: NATURAL_32 assign set_right_justify

	timer_from_keypress: NATURAL_32 assign set_timer_from_keypress

	from_menubar: NATURAL_32 assign set_from_menubar

	timer: NATURAL_32 assign set_timer

feature {ANY} -- field setters

	set_item (a_item: SD_GTKITEM)
		do
			item := a_item
			update_memory_field ("item")
		end

	set_submenu (a_submenu: CE_POINTER [SD_GTKWIDGET])
		do
			submenu := a_submenu
			update_memory_field ("submenu")
		end

	set_event_window (a_event_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			event_window := a_event_window
			update_memory_field ("event_window")
		end

	set_toggle_size (a_toggle_size: NATURAL_16)
		do
			toggle_size := a_toggle_size
			update_memory_field ("toggle_size")
		end

	set_accelerator_width (a_accelerator_width: NATURAL_16)
		do
			accelerator_width := a_accelerator_width
			update_memory_field ("accelerator_width")
		end

	set_accel_path (a_accel_path: CE_POINTER [INTEGER_8])
		do
			accel_path := a_accel_path
			update_memory_field ("accel_path")
		end

	set_show_submenu_indicator (a_show_submenu_indicator: NATURAL_32)
		do
			show_submenu_indicator := a_show_submenu_indicator
			update_memory_field ("show_submenu_indicator")
		end

	set_submenu_placement (a_submenu_placement: NATURAL_32)
		do
			submenu_placement := a_submenu_placement
			update_memory_field ("submenu_placement")
		end

	set_submenu_direction (a_submenu_direction: NATURAL_32)
		do
			submenu_direction := a_submenu_direction
			update_memory_field ("submenu_direction")
		end

	set_right_justify (a_right_justify: NATURAL_32)
		do
			right_justify := a_right_justify
			update_memory_field ("right_justify")
		end

	set_timer_from_keypress (a_timer_from_keypress: NATURAL_32)
		do
			timer_from_keypress := a_timer_from_keypress
			update_memory_field ("timer_from_keypress")
		end

	set_from_menubar (a_from_menubar: NATURAL_32)
		do
			from_menubar := a_from_menubar
			update_memory_field ("from_menubar")
		end

	set_timer (a_timer: NATURAL_32)
		do
			timer := a_timer
			update_memory_field ("timer")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			item := a_other.item.twin
			submenu := a_other.submenu
			event_window := a_other.event_window
			toggle_size := a_other.toggle_size
			accelerator_width := a_other.accelerator_width
			accel_path := a_other.accel_path
			show_submenu_indicator := a_other.show_submenu_indicator
			submenu_placement := a_other.submenu_placement
			submenu_direction := a_other.submenu_direction
			right_justify := a_other.right_justify
			timer_from_keypress := a_other.timer_from_keypress
			from_menubar := a_other.from_menubar
			timer := a_other.timer
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				item.is_equal (a_other.item) and
				submenu.is_equal (a_other.submenu) and
				event_window.is_equal (a_other.event_window) and
				toggle_size = a_other.toggle_size and
				accelerator_width = a_other.accelerator_width and
				accel_path.is_equal (a_other.accel_path) and
				show_submenu_indicator = a_other.show_submenu_indicator and
				submenu_placement = a_other.submenu_placement and
				submenu_direction = a_other.submenu_direction and
				right_justify = a_other.right_justify and
				timer_from_keypress = a_other.timer_from_keypress and
				from_menubar = a_other.from_menubar and
				timer = a_other.timer
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("item"),
					create {CE_STRUCTURE_FIELD}.make ("submenu"),
					create {CE_STRUCTURE_FIELD}.make ("event_window"),
					create {CE_STRUCTURE_FIELD}.make ("toggle_size"),
					create {CE_STRUCTURE_FIELD}.make ("accelerator_width"),
					create {CE_STRUCTURE_FIELD}.make ("accel_path"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("show_submenu_indicator"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("submenu_placement"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("submenu_direction"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("right_justify"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("timer_from_keypress"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("from_menubar"),
					create {CE_STRUCTURE_FIELD}.make ("timer")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkMenuItem);
					if(strcmp(field_name, "timer") == 0) return offsetof(struct _GtkMenuItem, timer);
				} else {
					struct _GtkMenuItem *p = (struct _GtkMenuItem *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "show_submenu_indicator") == 0) p->show_submenu_indicator = (unsigned int)$a_value;
						else if(strcmp(field_name, "submenu_placement") == 0) p->submenu_placement = (unsigned int)$a_value;
						else if(strcmp(field_name, "submenu_direction") == 0) p->submenu_direction = (unsigned int)$a_value;
						else if(strcmp(field_name, "right_justify") == 0) p->right_justify = (unsigned int)$a_value;
						else if(strcmp(field_name, "timer_from_keypress") == 0) p->timer_from_keypress = (unsigned int)$a_value;
						else if(strcmp(field_name, "from_menubar") == 0) p->from_menubar = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "show_submenu_indicator") == 0) return p->show_submenu_indicator;
						if(strcmp(field_name, "submenu_placement") == 0) return p->submenu_placement;
						if(strcmp(field_name, "submenu_direction") == 0) return p->submenu_direction;
						if(strcmp(field_name, "right_justify") == 0) return p->right_justify;
						if(strcmp(field_name, "timer_from_keypress") == 0) return p->timer_from_keypress;
						if(strcmp(field_name, "from_menubar") == 0) return p->from_menubar;
					}
				}
			]"
		end

end
