class
	SD_GTKSELECTIONDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} selection.make
			create {CE_VOID_POINTER} target.make
			create {CE_VOID_POINTER} type.make
			create {CE_NATURAL_8_POINTER} data.make
			create {CE_CLASS_POINTER [SD_GDKDISPLAY]} display.make
		end

feature {ANY} -- fields

	selection: CE_POINTER [ANY] assign set_selection

	target: CE_POINTER [ANY] assign set_target

	type: CE_POINTER [ANY] assign set_type

	format: INTEGER_32 assign set_format

	data: CE_POINTER [NATURAL_8] assign set_data

	length: INTEGER_32 assign set_length

	display: CE_POINTER [SD_GDKDISPLAY] assign set_display

feature {ANY} -- field setters

	set_selection (a_selection: CE_POINTER [ANY])
		do
			selection := a_selection
			update_memory_field ("selection")
		end

	set_target (a_target: CE_POINTER [ANY])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_type (a_type: CE_POINTER [ANY])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_format (a_format: INTEGER_32)
		do
			format := a_format
			update_memory_field ("format")
		end

	set_data (a_data: CE_POINTER [NATURAL_8])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_length (a_length: INTEGER_32)
		do
			length := a_length
			update_memory_field ("length")
		end

	set_display (a_display: CE_POINTER [SD_GDKDISPLAY])
		do
			display := a_display
			update_memory_field ("display")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			selection := a_other.selection
			target := a_other.target
			type := a_other.type
			format := a_other.format
			data := a_other.data
			length := a_other.length
			display := a_other.display
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				selection.is_equal (a_other.selection) and
				target.is_equal (a_other.target) and
				type.is_equal (a_other.type) and
				format = a_other.format and
				data.is_equal (a_other.data) and
				length = a_other.length and
				display.is_equal (a_other.display)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("selection"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("format"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("length"),
					create {CE_STRUCTURE_FIELD}.make ("display")
				>>)
			init_structure_info
		end

end
