class
	SD_GTKTOOLBAR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	container: SD_GTKCONTAINER assign set_container

	num_children: INTEGER_32 assign set_num_children

	children: CE_POINTER [SD_GLIST] assign set_children

	orientation: NATURAL_32 assign set_orientation

	style: NATURAL_32 assign set_style

	icon_size: NATURAL_32 assign set_icon_size

	tooltips: CE_POINTER [SD_GTKTOOLTIPS] assign set_tooltips

	button_maxw: INTEGER_32 assign set_button_maxw

	button_maxh: INTEGER_32 assign set_button_maxh

	gtk_reserved1: NATURAL_32 assign set_gtk_reserved1

	gtk_reserved2: NATURAL_32 assign set_gtk_reserved2

	style_set: NATURAL_32 assign set_style_set

	icon_size_set: NATURAL_32 assign set_icon_size_set

feature {ANY} -- field setters

	set_container (a_container: SD_GTKCONTAINER)
		do
			container := a_container
			update_memory_field ("container")
		end

	set_num_children (a_num_children: INTEGER_32)
		do
			num_children := a_num_children
			update_memory_field ("num_children")
		end

	set_children (a_children: CE_POINTER [SD_GLIST])
		do
			children := a_children
			update_memory_field ("children")
		end

	set_orientation (a_orientation: NATURAL_32)
		do
			orientation := a_orientation
			update_memory_field ("orientation")
		end

	set_style (a_style: NATURAL_32)
		do
			style := a_style
			update_memory_field ("style")
		end

	set_icon_size (a_icon_size: NATURAL_32)
		do
			icon_size := a_icon_size
			update_memory_field ("icon_size")
		end

	set_tooltips (a_tooltips: CE_POINTER [SD_GTKTOOLTIPS])
		do
			tooltips := a_tooltips
			update_memory_field ("tooltips")
		end

	set_button_maxw (a_button_maxw: INTEGER_32)
		do
			button_maxw := a_button_maxw
			update_memory_field ("button_maxw")
		end

	set_button_maxh (a_button_maxh: INTEGER_32)
		do
			button_maxh := a_button_maxh
			update_memory_field ("button_maxh")
		end

	set_gtk_reserved1 (a_gtk_reserved1: NATURAL_32)
		do
			gtk_reserved1 := a_gtk_reserved1
			update_memory_field ("gtk_reserved1")
		end

	set_gtk_reserved2 (a_gtk_reserved2: NATURAL_32)
		do
			gtk_reserved2 := a_gtk_reserved2
			update_memory_field ("gtk_reserved2")
		end

	set_style_set (a_style_set: NATURAL_32)
		do
			style_set := a_style_set
			update_memory_field ("style_set")
		end

	set_icon_size_set (a_icon_size_set: NATURAL_32)
		do
			icon_size_set := a_icon_size_set
			update_memory_field ("icon_size_set")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			container := a_other.container.twin
			num_children := a_other.num_children
			children := a_other.children
			orientation := a_other.orientation
			style := a_other.style
			icon_size := a_other.icon_size
			tooltips := a_other.tooltips
			button_maxw := a_other.button_maxw
			button_maxh := a_other.button_maxh
			gtk_reserved1 := a_other.gtk_reserved1
			gtk_reserved2 := a_other.gtk_reserved2
			style_set := a_other.style_set
			icon_size_set := a_other.icon_size_set
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				container.is_equal (a_other.container) and
				num_children = a_other.num_children and
				children.is_equal (a_other.children) and
				orientation = a_other.orientation and
				style = a_other.style and
				icon_size = a_other.icon_size and
				tooltips.is_equal (a_other.tooltips) and
				button_maxw = a_other.button_maxw and
				button_maxh = a_other.button_maxh and
				gtk_reserved1 = a_other.gtk_reserved1 and
				gtk_reserved2 = a_other.gtk_reserved2 and
				style_set = a_other.style_set and
				icon_size_set = a_other.icon_size_set
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("container"),
					create {CE_STRUCTURE_FIELD}.make ("num_children"),
					create {CE_STRUCTURE_FIELD}.make ("children"),
					create {CE_STRUCTURE_FIELD}.make ("orientation"),
					create {CE_STRUCTURE_FIELD}.make ("style"),
					create {CE_STRUCTURE_FIELD}.make ("icon_size"),
					create {CE_STRUCTURE_FIELD}.make ("tooltips"),
					create {CE_STRUCTURE_FIELD}.make ("button_maxw"),
					create {CE_STRUCTURE_FIELD}.make ("button_maxh"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved1"),
					create {CE_STRUCTURE_FIELD}.make ("gtk_reserved2"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("style_set"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("icon_size_set")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <gtk/gtk.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _GtkToolbar);
				} else {
					struct _GtkToolbar *p = (struct _GtkToolbar *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "style_set") == 0) p->style_set = (unsigned int)$a_value;
						else if(strcmp(field_name, "icon_size_set") == 0) p->icon_size_set = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "style_set") == 0) return p->style_set;
						if(strcmp(field_name, "icon_size_set") == 0) return p->icon_size_set;
					}
				}
			]"
		end

end
