class
	SD_PANGOGLYPHGEOMETRY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	width: INTEGER_32 assign set_width

	x_offset: INTEGER_32 assign set_x_offset

	y_offset: INTEGER_32 assign set_y_offset

feature {ANY} -- field setters

	set_width (a_width: INTEGER_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_x_offset (a_x_offset: INTEGER_32)
		do
			x_offset := a_x_offset
			update_memory_field ("x_offset")
		end

	set_y_offset (a_y_offset: INTEGER_32)
		do
			y_offset := a_y_offset
			update_memory_field ("y_offset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			width := a_other.width
			x_offset := a_other.x_offset
			y_offset := a_other.y_offset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				width = a_other.width and
				x_offset = a_other.x_offset and
				y_offset = a_other.y_offset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("x_offset"),
					create {CE_STRUCTURE_FIELD}.make ("y_offset")
				>>)
			init_structure_info
		end

end
