class
	SD_PANGOGLYPHVISATTR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	is_cluster_start: NATURAL_32 assign set_is_cluster_start

feature {ANY} -- field setters

	set_is_cluster_start (a_is_cluster_start: NATURAL_32)
		do
			is_cluster_start := a_is_cluster_start
			update_memory_field ("is_cluster_start")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			is_cluster_start := a_other.is_cluster_start
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				is_cluster_start = a_other.is_cluster_start
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_bitfield ("is_cluster_start")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline use <pango/pango.h>"
		alias
			"[
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct _PangoGlyphVisAttr);
				} else {
					struct _PangoGlyphVisAttr *p = (struct _PangoGlyphVisAttr *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "is_cluster_start") == 0) p->is_cluster_start = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "is_cluster_start") == 0) return p->is_cluster_start;
					}
				}
			]"
		end

end
