class
	SD_SIGPOLL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	si_band: INTEGER_32 assign set_si_band

	si_fd: INTEGER_32 assign set_si_fd

feature {ANY} -- field setters

	set_si_band (a_si_band: INTEGER_32)
		do
			si_band := a_si_band
			update_memory_field ("si_band")
		end

	set_si_fd (a_si_fd: INTEGER_32)
		do
			si_fd := a_si_fd
			update_memory_field ("si_fd")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_band := a_other.si_band
			si_fd := a_other.si_fd
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_band = a_other.si_band and
				si_fd = a_other.si_fd
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_band"),
					create {CE_STRUCTURE_FIELD}.make ("si_fd")
				>>)
			init_structure_info
		end

end
