class
	SD_WAIT_STOPPED

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal,
			bitfield_helper
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- has bitfields; back with memory for correct semantics
		end

feature {ANY} -- fields

	w_stopval: NATURAL_32 assign set_w_stopval

	w_stopsig: NATURAL_32 assign set_w_stopsig

feature {ANY} -- field setters

	set_w_stopval (a_w_stopval: NATURAL_32)
		do
			w_stopval := a_w_stopval
			update_memory_field ("w_stopval")
		end

	set_w_stopsig (a_w_stopsig: NATURAL_32)
		do
			w_stopsig := a_w_stopsig
			update_memory_field ("w_stopsig")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			w_stopval := a_other.w_stopval
			w_stopsig := a_other.w_stopsig
			create_memory_copy -- has bitfields; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				w_stopval = a_other.w_stopval and
				w_stopsig = a_other.w_stopsig
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_bitfield ("w_stopval"),
					create {CE_STRUCTURE_FIELD}.make_bitfield ("w_stopsig")
				>>)
			init_structure_info
		end

	bitfield_helper (a_operation: INTEGER_32; a_field_name, a_struct_pointer: POINTER; a_value: NATURAL_64): NATURAL_64
		external
			"C inline"
		alias
			"[
				struct __anonstruct___wait_stopped_23 {
					unsigned int __w_stopval : 8;
					unsigned int __w_stopsig : 8;
					unsigned int : 16;
				};
				char *field_name = (char *)$a_field_name;
				if($a_operation == 1) {
					if(field_name == (char *)0) return sizeof(struct __anonstruct___wait_stopped_23);
				} else {
					struct __anonstruct___wait_stopped_23 *p = (struct __anonstruct___wait_stopped_23 *)$a_struct_pointer;
					if($a_operation == 2) {
						     if(strcmp(field_name, "w_stopval") == 0) p->__w_stopval = (unsigned int)$a_value;
						else if(strcmp(field_name, "w_stopsig") == 0) p->__w_stopsig = (unsigned int)$a_value;
					} else if($a_operation == 3) {
						if(strcmp(field_name, "w_stopval") == 0) return p->__w_stopval;
						if(strcmp(field_name, "w_stopsig") == 0) return p->__w_stopsig;
					}
				}
			]"
		end

end
