class
	SD_XCROSSINGEVENT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} display.make
		end

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	serial: NATURAL_32 assign set_serial

	send_event: INTEGER_32 assign set_send_event

	display: CE_POINTER [ANY] assign set_display

	window: NATURAL_32 assign set_window

	root: NATURAL_32 assign set_root

	subwindow: NATURAL_32 assign set_subwindow

	time: NATURAL_32 assign set_time

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	x_root: INTEGER_32 assign set_x_root

	y_root: INTEGER_32 assign set_y_root

	mode: INTEGER_32 assign set_mode

	detail: INTEGER_32 assign set_detail

	same_screen: INTEGER_32 assign set_same_screen

	focus: INTEGER_32 assign set_focus

	state: NATURAL_32 assign set_state

feature {ANY} -- field setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_serial (a_serial: NATURAL_32)
		do
			serial := a_serial
			update_memory_field ("serial")
		end

	set_send_event (a_send_event: INTEGER_32)
		do
			send_event := a_send_event
			update_memory_field ("send_event")
		end

	set_display (a_display: CE_POINTER [ANY])
		do
			display := a_display
			update_memory_field ("display")
		end

	set_window (a_window: NATURAL_32)
		do
			window := a_window
			update_memory_field ("window")
		end

	set_root (a_root: NATURAL_32)
		do
			root := a_root
			update_memory_field ("root")
		end

	set_subwindow (a_subwindow: NATURAL_32)
		do
			subwindow := a_subwindow
			update_memory_field ("subwindow")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_x_root (a_x_root: INTEGER_32)
		do
			x_root := a_x_root
			update_memory_field ("x_root")
		end

	set_y_root (a_y_root: INTEGER_32)
		do
			y_root := a_y_root
			update_memory_field ("y_root")
		end

	set_mode (a_mode: INTEGER_32)
		do
			mode := a_mode
			update_memory_field ("mode")
		end

	set_detail (a_detail: INTEGER_32)
		do
			detail := a_detail
			update_memory_field ("detail")
		end

	set_same_screen (a_same_screen: INTEGER_32)
		do
			same_screen := a_same_screen
			update_memory_field ("same_screen")
		end

	set_focus (a_focus: INTEGER_32)
		do
			focus := a_focus
			update_memory_field ("focus")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			serial := a_other.serial
			send_event := a_other.send_event
			display := a_other.display
			window := a_other.window
			root := a_other.root
			subwindow := a_other.subwindow
			time := a_other.time
			x := a_other.x
			y := a_other.y
			x_root := a_other.x_root
			y_root := a_other.y_root
			mode := a_other.mode
			detail := a_other.detail
			same_screen := a_other.same_screen
			focus := a_other.focus
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				serial = a_other.serial and
				send_event = a_other.send_event and
				display.is_equal (a_other.display) and
				window = a_other.window and
				root = a_other.root and
				subwindow = a_other.subwindow and
				time = a_other.time and
				x = a_other.x and
				y = a_other.y and
				x_root = a_other.x_root and
				y_root = a_other.y_root and
				mode = a_other.mode and
				detail = a_other.detail and
				same_screen = a_other.same_screen and
				focus = a_other.focus and
				state = a_other.state
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("serial"),
					create {CE_STRUCTURE_FIELD}.make ("send_event"),
					create {CE_STRUCTURE_FIELD}.make ("display"),
					create {CE_STRUCTURE_FIELD}.make ("window"),
					create {CE_STRUCTURE_FIELD}.make ("root"),
					create {CE_STRUCTURE_FIELD}.make ("subwindow"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("x_root"),
					create {CE_STRUCTURE_FIELD}.make ("y_root"),
					create {CE_STRUCTURE_FIELD}.make ("mode"),
					create {CE_STRUCTURE_FIELD}.make ("detail"),
					create {CE_STRUCTURE_FIELD}.make ("same_screen"),
					create {CE_STRUCTURE_FIELD}.make ("focus"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
