class
	SD_XWMHINTS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	flags: INTEGER_32 assign set_flags

	input: INTEGER_32 assign set_input

	initial_state: INTEGER_32 assign set_initial_state

	icon_pixmap: NATURAL_32 assign set_icon_pixmap

	icon_window: NATURAL_32 assign set_icon_window

	icon_x: INTEGER_32 assign set_icon_x

	icon_y: INTEGER_32 assign set_icon_y

	icon_mask: NATURAL_32 assign set_icon_mask

	window_group: NATURAL_32 assign set_window_group

feature {ANY} -- field setters

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_input (a_input: INTEGER_32)
		do
			input := a_input
			update_memory_field ("input")
		end

	set_initial_state (a_initial_state: INTEGER_32)
		do
			initial_state := a_initial_state
			update_memory_field ("initial_state")
		end

	set_icon_pixmap (a_icon_pixmap: NATURAL_32)
		do
			icon_pixmap := a_icon_pixmap
			update_memory_field ("icon_pixmap")
		end

	set_icon_window (a_icon_window: NATURAL_32)
		do
			icon_window := a_icon_window
			update_memory_field ("icon_window")
		end

	set_icon_x (a_icon_x: INTEGER_32)
		do
			icon_x := a_icon_x
			update_memory_field ("icon_x")
		end

	set_icon_y (a_icon_y: INTEGER_32)
		do
			icon_y := a_icon_y
			update_memory_field ("icon_y")
		end

	set_icon_mask (a_icon_mask: NATURAL_32)
		do
			icon_mask := a_icon_mask
			update_memory_field ("icon_mask")
		end

	set_window_group (a_window_group: NATURAL_32)
		do
			window_group := a_window_group
			update_memory_field ("window_group")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			flags := a_other.flags
			input := a_other.input
			initial_state := a_other.initial_state
			icon_pixmap := a_other.icon_pixmap
			icon_window := a_other.icon_window
			icon_x := a_other.icon_x
			icon_y := a_other.icon_y
			icon_mask := a_other.icon_mask
			window_group := a_other.window_group
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				flags = a_other.flags and
				input = a_other.input and
				initial_state = a_other.initial_state and
				icon_pixmap = a_other.icon_pixmap and
				icon_window = a_other.icon_window and
				icon_x = a_other.icon_x and
				icon_y = a_other.icon_y and
				icon_mask = a_other.icon_mask and
				window_group = a_other.window_group
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("input"),
					create {CE_STRUCTURE_FIELD}.make ("initial_state"),
					create {CE_STRUCTURE_FIELD}.make ("icon_pixmap"),
					create {CE_STRUCTURE_FIELD}.make ("icon_window"),
					create {CE_STRUCTURE_FIELD}.make ("icon_x"),
					create {CE_STRUCTURE_FIELD}.make ("icon_y"),
					create {CE_STRUCTURE_FIELD}.make ("icon_mask"),
					create {CE_STRUCTURE_FIELD}.make ("window_group")
				>>)
			init_structure_info
		end

end
