class
	P_HTTP_STATIC

inherit
	CE_UTILITIES
	S_CTYPE_STATIC
	S_STRING_STATIC

feature {ANY} -- public routines

	Curl_copy_header_value (a_h: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_h.is_void
		local
			l_h: CE_POINTER [INTEGER_8]
			l_start: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_value: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_h := a_h
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_h[0]).to_boolean then
					if (l_h[0]).to_integer_32 = 58 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_h := l_h + 1
				end
			end
			l_break := False
			if (l_h[0]).to_boolean then
				l_h := l_h + 1
			end
			l_start := l_h
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_start[0]).to_boolean then
					if not ((((ctype_b_loc).item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_start := l_start + 1
				end
			end
			l_break := False
			l_end := (strchr (l_start, ('%R').code))
			if l_end.is_void then
				l_end := (strchr (l_start, ('%N').code))
			end
			if l_end.is_void then
				l_end := (strchr (l_start, ('%/0/').code))
			end
			if l_end.is_void then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_end.c_pointer.to_integer_32).to_natural_32 > (l_start.c_pointer.to_integer_32).to_natural_32 then
						if not ((((ctype_b_loc).item[((l_end[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_end := l_end - 1
					end
				end
				l_break := False
				l_len := ((l_end.distance (l_start)) + 1).to_natural_32
				l_value := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_len + {NATURAL_32} 1]))))
				if l_value.is_void then
					Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_value), create {CE_VOID_POINTER}.make_cast (l_start), l_len).do_nothing
				l_value[l_len.to_integer_32] := (0).to_integer_8
				Result := l_value
			end
		end

	readmoredata (a_buffer: CE_POINTER [INTEGER_8]; a_size, a_nitems: NATURAL_32; a_userp: CE_POINTER [ANY]): NATURAL_32
		local
			l_conn: CE_POINTER [PD_CONNECTDATA]
			l_http: CE_POINTER [PD_HTTP]
			l_fullsize: NATURAL_32
			l_return: BOOLEAN
		do
			l_conn := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_cast (a_userp)
			l_http := (l_conn.item.data).item.state.proto.http
			l_fullsize := a_size * a_nitems
			if {INTEGER_64} 0 = l_http.item.postsize then
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				(l_conn.item.data).item.req.forbidchunk := (l_http.item.sending = {NATURAL_32} 1)
				if l_http.item.postsize <= l_fullsize.to_integer_64 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_buffer), create {CE_VOID_POINTER}.make_cast (l_http.item.postdata), (l_http.item.postsize).to_natural_32).do_nothing
					l_fullsize := (l_http.item.postsize).to_natural_32
					if (l_http.item.backup.postsize).to_boolean then
						l_http.item.postdata := l_http.item.backup.postdata
						l_http.item.postsize := l_http.item.backup.postsize
						l_conn.item.fread_func := l_http.item.backup.fread_func
						l_conn.item.fread_in := l_http.item.backup.fread_in
						l_http.item.sending := (l_http.item.sending + {NATURAL_32} 1)
						l_http.item.backup.postsize := (0).to_integer_64
					else
						l_http.item.postsize := (0).to_integer_64
					end
					Result := l_fullsize
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (a_buffer), create {CE_VOID_POINTER}.make_cast (l_http.item.postdata), l_fullsize).do_nothing
				l_http.item.postdata := l_http.item.postdata + l_fullsize.to_integer_32
				l_http.item.postsize := l_http.item.postsize - l_fullsize.to_integer_64
				Result := l_fullsize
			end
		end

	Curl_compareheader (a_headerline, a_header, a_content: CE_POINTER [INTEGER_8]): BOOLEAN
		require
			not a_header.is_void
		local
			l_hlen: NATURAL_32
			l_clen: NATURAL_32
			l_len: NATURAL_32
			l_start: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_hlen := (strlen (a_header))
			if not ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (a_headerline, a_header, l_hlen)).to_boolean then
				Result := (0).to_boolean
				l_return := True
			end
			if not l_return then
				l_start := a_headerline + l_hlen.to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_start[0]).to_boolean then
						if not ((((ctype_b_loc).item[((l_start[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_start := l_start + 1
					end
				end
				l_break := False
				l_end := (strchr (l_start, ('%R').code))
				if l_end.is_void then
					l_end := (strchr (l_start, ('%N').code))
					if l_end.is_void then
						l_end := (strchr (l_start, ('%/0/').code))
					end
				end
				l_len := (l_end.distance (l_start)).to_natural_32
				l_clen := strlen (a_content)
				from
				until
					not (not (l_return) and then (l_len >= l_clen))
				loop
					if ((create {P_RAWSTR_STATIC}).Curl_raw_nequal (l_start, a_content, l_clen)).to_boolean then
						Result := (1).to_boolean
						l_return := True
					end
					if not l_return then
						l_len := l_len - 1
						l_start := l_start + 1
					end
				end
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

feature {ANY} -- routine addresses

	readmoredata_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent readmoredata)
		end

end
