class
	P_MULTI_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	LIBCURL_ASSEMBLER

feature {ANY} -- public routines

	sh_freeentry (a_freethis: CE_POINTER [ANY])
		local
			l_p: CE_POINTER [PD_CURL_SH_ENTRY]
		do
			l_p := create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_cast (a_freethis)
			if (not l_p.is_void) then
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_p)])
			end
		end

	fd_key_compare (a_k1: CE_POINTER [ANY]; a_k1_len: NATURAL_32; a_k2: CE_POINTER [ANY]; a_k2_len: NATURAL_32): NATURAL_32
		do
			Result := ((create {CE_INTEGER_32_POINTER}.make_cast (a_k1)).item = (create {CE_INTEGER_32_POINTER}.make_cast (a_k2)).item).to_integer.to_natural_32
		end

	hash_fd (a_key: CE_POINTER [ANY]; a_key_length, a_slots_num: NATURAL_32): NATURAL_32
		local
			l_fd: INTEGER_32
		do
			l_fd := (create {CE_INTEGER_32_POINTER}.make_cast (a_key)).item
			Result := (l_fd \\ a_slots_num.to_integer_32).to_natural_32
		end

	sh_init: CE_POINTER [PD_CURL_HASH]
		do
			Result := ((create {P_HASH_STATIC}).Curl_hash_alloc (911, hash_fd_address, fd_key_compare_address, sh_freeentry_address))
		end

	multi_freeamsg (a_a, a_b: CE_POINTER [ANY])
		do
		end

	curl_multi_init: CE_POINTER [ANY]
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_CURL_MULTI}.make).structure_size.to_natural_32]))))
					if l_multi.is_void then
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_multi.item.type := 764_702
						l_multi.item.hostcache := (create {P_HOSTIP_STATIC}).Curl_mk_dnscache
						if (l_multi.item.hostcache).is_void then
							l_pos := -1 + 7 -- goto error
						end
				when 2 then
						l_multi.item.sockhash := sh_init
						if (l_multi.item.sockhash).is_void then
							l_pos := -1 + 7 -- goto error
						end
				when 3 then
						l_multi.item.connc := (create {P_URL_STATIC}).Curl_mk_connc (1, -1)
						if (l_multi.item.connc).is_void then
							l_pos := -1 + 7 -- goto error
						end
				when 4 then
						l_multi.item.msglist := (create {P_LLIST_STATIC}).Curl_llist_alloc (multi_freeamsg_address)
						if (l_multi.item.msglist).is_void then
							l_pos := -1 + 7 -- goto error
						end
				when 5 then
						l_multi.item.easy.next := create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + (create {PD_CURL_MULTI}.make).offset_of ("easy"))
						l_multi.item.easy.prev := create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + (create {PD_CURL_MULTI}.make).offset_of ("easy"))
						Result := (create {CE_VOID_POINTER}.make_cast (l_multi))
						l_return := True
				when 6 then -- if done
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 7 then -- if: | error:
						if (not (l_multi.item.sockhash).is_void) then
							(create {P_HASH_STATIC}).Curl_hash_destroy (l_multi.item.sockhash)
						end
						if (not (l_multi.item.hostcache).is_void) then
							(create {P_HASH_STATIC}).Curl_hash_destroy (l_multi.item.hostcache)
						end
						if (not (l_multi.item.connc).is_void) then
							(l_multi.item.connc).item.Curl_rm_connc
						end
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_multi)])
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_multi_add_handle (a_multi_handle, a_easy_handle: CE_POINTER [ANY]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_cl: CE_POINTER [PD_CLOSURE]
			l_prev: CE_POINTER [PD_CLOSURE]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_next: CE_POINTER [PD_CLOSURE]
			l_newmax: INTEGER_32
			l_res: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)
			l_prev := create {CE_CLASS_POINTER [PD_CLOSURE]}.make_shared (default_pointer)
			l_data := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle)
			if (not l_multi.is_void) then
				if l_multi.item.type /= 764_702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					l_return := True
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				l_return := True
			end
			if not l_return and then ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle)).item.magic /= {NATURAL_32} 3_235_830_701) then
				Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
				l_return := True
			end
			if not l_return and then (not ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle)).item.multi).is_void) then
				Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
				l_return := True
			end
			if not l_return then
				l_data.item.state.timeoutlist := (create {P_LLIST_STATIC}).Curl_llist_alloc (multi_freetimeout_address)
				if (l_data.item.state.timeoutlist).is_void then
					Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_easy := create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_CURL_ONE_EASY}.make).structure_size.to_natural_32]))))
				if l_easy.is_void then
					Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
					l_return := True
				end
			end
			if not l_return then
				l_cl := l_multi.item.closure
				from
				until
					not (not (l_break) and then (not l_cl.is_void))
				loop
					l_break := False
					l_next := l_cl.item.next
					if (l_cl.item.easy_handle).is_equal (a_easy_handle) then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_cl)])
						if (not l_prev.is_void) then
							l_prev.item.next := l_next
						else
							l_multi.item.closure := l_next
						end
						l_break := True
					end
					if not (l_break) then
						l_prev := l_cl
						l_cl := l_next
					end
				end
				l_break := False
				l_easy.item.easy_handle := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle)
				l_easy.item.multistate ({PC_CURLMSTATE}.CURLM_STATE_INIT);
				(l_easy.item.easy_handle).item.multi_pos := l_easy
				if (not ((l_easy.item.easy_handle).item.dns.hostcache).is_void) then
					if (l_easy.item.easy_handle).item.dns.hostcachetype = {NATURAL_32} 1 then
						(create {P_HASH_STATIC}).Curl_hash_destroy ((l_easy.item.easy_handle).item.dns.hostcache);
						(l_easy.item.easy_handle).item.dns.hostcache := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer);
						(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
					end
				end
				if ((l_easy.item.easy_handle).item.dns.hostcache).is_void then
					(l_easy.item.easy_handle).item.dns.hostcache := l_multi.item.hostcache;
					(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_MULTI
				elseif (l_easy.item.easy_handle).item.dns.hostcachetype = {NATURAL_32} 0 then
					(l_easy.item.easy_handle).item.dns.hostcache := l_multi.item.hostcache;
					(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_MULTI
				end
				if (not ((l_easy.item.easy_handle).item.state.connc).is_void) then
					if ((l_easy.item.easy_handle).item.state.connc).item.type = {NATURAL_32} 0 then
						((l_easy.item.easy_handle).item.state.connc).item.Curl_rm_connc;
						(l_easy.item.easy_handle).item.state.connc := l_multi.item.connc
					end
				else
					(l_easy.item.easy_handle).item.state.connc := l_multi.item.connc
				end
				((l_easy.item.easy_handle).item.state.connc).item.type := {PC_TYPE2}.CONNCACHE_MULTI
				l_easy.item.next := create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + (create {PD_CURL_MULTI}.make).offset_of ("easy"))
				l_easy.item.prev := l_multi.item.easy.prev
				l_multi.item.easy.prev := l_easy;
				(l_easy.item.prev).item.next := l_easy;
				(create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle)).item.Curl_easy_addmulti (a_multi_handle);
				(l_easy.item.easy_handle).item.set.one_easy := l_easy;
				(l_easy.item.easy_handle).item.Curl_expire (1)
				l_multi.item.num_easy := (l_multi.item.num_easy) + 1
				if (l_multi.item.num_easy * 4).to_integer_32 > (l_multi.item.connc).item.num then
					l_newmax := (l_multi.item.num_easy * 4).to_integer_32
					if (l_multi.item.maxconnects).to_boolean then
						if l_multi.item.maxconnects < l_newmax then
							l_newmax := l_multi.item.maxconnects
						end
					end
					if l_newmax > (l_multi.item.connc).item.num then
						l_res := ((create {P_URL_STATIC}).Curl_ch_connc (create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (a_easy_handle), l_multi.item.connc, l_newmax))
						if l_res /= {NATURAL_32} 0 then
							curl_multi_remove_handle (a_multi_handle, a_easy_handle).do_nothing
							Result := ({PC_CURLMCODE}.CURLM_OUT_OF_MEMORY)
							l_return := True
						end
					end
				end
			end
			if not l_return then
				l_multi.item.num_alive := (l_multi.item.num_alive) + 1
				memset (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (l_multi.c_pointer + (create {PD_CURL_MULTI}.make).offset_of ("timer_lastcall")))), 0, (create {SD_TIMEVAL}.make).structure_size.to_natural_32).do_nothing
				l_multi.item.update_timer.do_nothing
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

	curl_multi_remove_handle (a_multi_handle, a_curl_handle: CE_POINTER [ANY]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_data: CE_POINTER [PD_SESSIONHANDLE]
			l_premature: BOOLEAN
			l_easy_owns_conn: BOOLEAN
			l_tmp: INTEGER_32
			l_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_msg: CE_POINTER [PD_CURL_MESSAGE]
			l_return, l_break: BOOLEAN
		do
			l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)
			l_data := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl_handle)
			if (not l_multi.is_void) then
				if l_multi.item.type /= 764_702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					l_return := True
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				l_return := True
			end
			if not l_return and then ((create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (a_curl_handle)).item.magic /= {NATURAL_32} 3_235_830_701) then
				Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
				l_return := True
			end
			if not l_return then
				l_easy := l_data.item.multi_pos
				if (not l_easy.is_void) then
					l_premature := (l_easy.item.state < {NATURAL_32} 15)
					if (not (l_easy.item.easy_conn).is_void) then
						if ((l_easy.item.easy_conn).item.data).is_equal (l_easy.item.easy_handle) then
							l_tmp := 1
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_easy_owns_conn := l_tmp.to_boolean
					if l_premature then
						l_multi.item.num_alive := (l_multi.item.num_alive) - 1
					end
					if (not (l_easy.item.easy_conn).is_void) then
						if ((l_easy.item.easy_conn).item.send_pipe).item.size + ((l_easy.item.easy_conn).item.recv_pipe).item.size > {NATURAL_32} 1 then
							if l_easy.item.state > {NATURAL_32} 6 then
								if l_easy.item.state < {NATURAL_32} 15 then
									(l_easy.item.easy_conn).item.bits.close := (1).to_boolean;
									(l_easy.item.easy_conn).item.data := l_easy.item.easy_handle
								end
							end
						end
					end
					(l_easy.item.easy_handle).item.Curl_expire (0)
					if (not (l_data.item.state.timeoutlist).is_void) then
						(create {P_LLIST_STATIC}).Curl_llist_destroy (l_data.item.state.timeoutlist, create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_data.item.state.timeoutlist := create {CE_CLASS_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
					end
					if (l_easy.item.easy_handle).item.dns.hostcachetype = {NATURAL_32} 3 then
						(l_easy.item.easy_handle).item.dns.hostcache := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer);
						(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
					end
					if (not (l_easy.item.easy_conn).is_void) then
						if l_easy_owns_conn then
							(create {P_URL_STATIC}).Curl_done (create {CE_POINTER_POINTER [PD_CONNECTDATA]}.make_shared (l_easy.c_pointer + (create {PD_CURL_ONE_EASY}.make).offset_of ("easy_conn")), l_easy.item.result2, l_premature).do_nothing
							if (not (l_easy.item.easy_conn).is_void) then
								(l_easy.item.easy_conn).item.data := l_easy.item.easy_handle
							end
						else
							(create {P_URL_STATIC}).Curl_getoff_all_pipelines (l_easy.item.easy_handle, l_easy.item.easy_conn)
						end
					end
					l_multi.item.multi_connc_remove_handle (l_easy.item.easy_handle)
					if ((l_easy.item.easy_handle).item.state.connc).item.type = {NATURAL_32} 1 then
						(l_easy.item.easy_handle).item.state.connc := create {CE_CLASS_POINTER [PD_CONNCACHE]}.make_shared (default_pointer);
						(l_easy.item.easy_handle).item.state.lastconnect := -1
						if (not (l_easy.item.easy_conn).is_void) then
							if l_easy_owns_conn then
								if ((l_easy.item.easy_conn).item.send_pipe).item.size + ((l_easy.item.easy_conn).item.recv_pipe).item.size = {NATURAL_32} 0 then
									(l_easy.item.easy_conn).item.connectindex := -1
								end
							end
						end
					end
					l_easy.item.state := {PC_CURLMSTATE}.CURLM_STATE_COMPLETED
					singlesocket (l_multi, l_easy);
					(l_easy.item.easy_handle).item.Curl_easy_addmulti (create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_e := (l_multi.item.msglist).item.head
					from
					until
						not (not (l_break) and then (not l_e.is_void))
					loop
						l_break := False
						l_msg := create {CE_CLASS_POINTER [PD_CURL_MESSAGE]}.make_cast (l_e.item.ptr)
						if (l_msg.item.extmsg.easy_handle).is_equal (l_easy.item.easy_handle) then
							(l_multi.item.msglist).item.Curl_llist_remove (l_e, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
							l_break := True
						end
						if not (l_break) then
							l_e := l_e.item.next
						end
					end
					l_break := False
					if (not (l_easy.item.prev).is_void) then
						(l_easy.item.prev).item.next := l_easy.item.next
					end
					if (not (l_easy.item.next).is_void) then
						(l_easy.item.next).item.prev := l_easy.item.prev
					end
					(l_easy.item.easy_handle).item.set.one_easy := create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]}.make_shared (default_pointer);
					(l_easy.item.easy_handle).item.multi_pos := create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]}.make_shared (default_pointer);
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_easy)])
					l_multi.item.num_easy := (l_multi.item.num_easy) - 1
					l_multi.item.update_timer.do_nothing
					Result := ({PC_CURLMCODE}.CURLM_OK)
				else
					Result := ({PC_CURLMCODE}.CURLM_BAD_EASY_HANDLE)
				end
			end
		end

	curl_multi_fdset (a_multi_handle: CE_POINTER [ANY]; a_read_fd_set, a_write_fd_set, a_exc_fd_set: CE_POINTER [SD_FD_SET]; a_max_fd: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_write_fd_set: CE_ARRAY [CE_POINTER [SD_FD_SET]]
			l_read_fd_set: CE_ARRAY [CE_POINTER [SD_FD_SET]]
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_this_max_fd: INTEGER_32
			l_sockbunch: CE_ARRAY [CE_ARRAY [INTEGER_32]]
			l_bitmap: INTEGER_32
			l_i: CE_ARRAY [INTEGER_32]
			l_s: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [SD_FD_SET]} l_write_fd_set.make (<<1>>)
			create {CE_POINTER_ARRAY [SD_FD_SET]} l_read_fd_set.make (<<1>>)
			create {CE_ARRAY_ARRAY [INTEGER_32]} l_sockbunch.make (<<1, 5>>)
			create {CE_INTEGER_32_ARRAY} l_i.make (<<1>>)

			l_write_fd_set.item := a_write_fd_set
			l_read_fd_set.item := a_read_fd_set
			l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)
			l_this_max_fd := -1
			if (not l_multi.is_void) then
				if l_multi.item.type /= 764_702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					l_return := True
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				l_return := True
			end
			if not l_return then
				l_easy := l_multi.item.easy.next
				from
				until
					not (not (l_return) and then (not l_easy.is_equal (create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + (create {PD_CURL_MULTI}.make).offset_of ("easy")))))
				loop
					l_bitmap := l_easy.item.multi_getsock (l_sockbunch.item, 5)
					l_i.item := 0
					from
					until
						not (not (l_break) and then (l_i.item < 5))
					loop
						l_break := False
						l_s := -1
						if ((l_bitmap).bit_and (((1).bit_shift_left (l_i.item)))).to_boolean then
							asm1 (l_read_fd_set, l_sockbunch, l_i)
							l_s := l_sockbunch.item[l_i.item]
						end
						if ((l_bitmap).bit_and (((1).bit_shift_left ((16 + l_i.item))))).to_boolean then
							asm2 (l_write_fd_set, l_sockbunch, l_i)
							l_s := l_sockbunch.item[l_i.item]
						end
						if l_s = -1 then
							l_break := True
						elseif l_s > l_this_max_fd then
							l_this_max_fd := l_s
						end
						if not (l_break) then
							l_i.item := l_i.item + 1
						end
					end
					l_break := False
					l_easy := l_easy.item.next
				end
				a_max_fd.item := l_this_max_fd
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

	curl_multi_cleanup (a_multi_handle: CE_POINTER [ANY]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_easy: CE_POINTER [PD_CURL_ONE_EASY]
			l_nexteasy: CE_POINTER [PD_CURL_ONE_EASY]
			l_i: INTEGER_32
			l_cl: CE_POINTER [PD_CLOSURE]
			l_n: CE_POINTER [PD_CLOSURE]
		do
			l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)
			if (not l_multi.is_void) then
				if l_multi.item.type = 764_702 then
					l_multi.item.type := 0;
					(create {P_HASH_STATIC}).Curl_hash_destroy (l_multi.item.hostcache);
					(create {P_HASH_STATIC}).Curl_hash_destroy (l_multi.item.sockhash)
					l_multi.item.hostcache := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
					l_multi.item.sockhash := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer)
					l_i := 0
					from
					until
						not (l_i.to_integer_32 < (l_multi.item.connc).item.num)
					loop
						if (not ((l_multi.item.connc).item.connects[l_i]).is_void) then
							if ((((l_multi.item.connc).item.connects[l_i]).item.protocol).bit_and (((((((1).bit_shift_left (2))).bit_or (((1).bit_shift_left (12))))).bit_or (((1).bit_shift_left (14)))).to_integer_32)).to_boolean then
								(create {P_URL_STATIC}).Curl_disconnect ((l_multi.item.connc).item.connects[l_i]).do_nothing;
								(l_multi.item.connc).item.connects[l_i] := create {CE_CLASS_POINTER [PD_CONNECTDATA]}.make_shared (default_pointer)
							end
						end
						l_i := l_i + 1
					end
					l_cl := l_multi.item.closure
					from
					until
						l_cl.is_void
					loop
						(l_cl.item.easy_handle).item.state.shared_conn := create {CE_VOID_POINTER}.make_shared (default_pointer)
						if (l_cl.item.easy_handle).item.state.closed then
							(l_cl.item.easy_handle).item.Curl_close.do_nothing
						end
						l_n := l_cl.item.next;
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_cl)])
						l_cl := l_n
					end
					(l_multi.item.connc).item.Curl_rm_connc;
					(create {P_LLIST_STATIC}).Curl_llist_destroy (l_multi.item.msglist, create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_easy := l_multi.item.easy.next
					from
					until
						l_easy.is_equal (create {CE_CLASS_POINTER [PD_CURL_ONE_EASY]}.make_shared (l_multi.c_pointer + (create {PD_CURL_MULTI}.make).offset_of ("easy")))
					loop
						l_nexteasy := l_easy.item.next
						if (l_easy.item.easy_handle).item.dns.hostcachetype = {NATURAL_32} 3 then
							(l_easy.item.easy_handle).item.dns.hostcache := create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (default_pointer);
							(l_easy.item.easy_handle).item.dns.hostcachetype := {PC_HOSTCACHETYPE}.HCACHE_NONE
						end
						(l_easy.item.easy_handle).item.state.connc := create {CE_CLASS_POINTER [PD_CONNCACHE]}.make_shared (default_pointer);
						(l_easy.item.easy_handle).item.Curl_easy_addmulti (create {CE_VOID_POINTER}.make_shared (default_pointer));
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_easy)])
						l_easy := l_nexteasy
					end
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_multi)])
					Result := ({PC_CURLMCODE}.CURLM_OK)
				else
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
			end
		end

	curl_multi_info_read (a_multi_handle: CE_POINTER [ANY]; a_msgs_in_queue: CE_POINTER [INTEGER_32]): CE_POINTER [PD_CURLMSG]
		require
			not a_msgs_in_queue.is_void
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_msg: CE_POINTER [PD_CURL_MESSAGE]
			l_e: CE_POINTER [PD_CURL_LLIST_ELEMENT]
		do
			l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)
			a_msgs_in_queue.item := 0
			if (not l_multi.is_void) then
				if l_multi.item.type = 764_702 then
					if ((l_multi.item.msglist).item.Curl_llist_count).to_boolean then
						l_e := (l_multi.item.msglist).item.head
						l_msg := create {CE_CLASS_POINTER [PD_CURL_MESSAGE]}.make_cast (l_e.item.ptr);
						(l_multi.item.msglist).item.Curl_llist_remove (l_e, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
						a_msgs_in_queue.item := ((l_multi.item.msglist).item.Curl_llist_count).to_integer_32
						Result := (create {CE_CLASS_POINTER [PD_CURLMSG]}.make_shared (l_msg.c_pointer + (create {PD_CURL_MESSAGE}.make).offset_of ("extmsg")))
					else
						Result := (create {CE_CLASS_POINTER [PD_CURLMSG]}.make_shared (default_pointer))
					end
				else
					Result := (create {CE_CLASS_POINTER [PD_CURLMSG]}.make_shared (default_pointer))
				end
			else
				Result := (create {CE_CLASS_POINTER [PD_CURLMSG]}.make_shared (default_pointer))
			end
		end

	singlesocket (a_multi: CE_POINTER [PD_CURL_MULTI]; a_easy: CE_POINTER [PD_CURL_ONE_EASY])
		require
			not a_easy.is_void
		local
			l_socks: CE_ARRAY [INTEGER_32]
			l_i: INTEGER_32
			l_entry: CE_POINTER [PD_CURL_SH_ENTRY]
			l_s: CE_ARRAY [INTEGER_32]
			l_num: INTEGER_32
			l_curraction: NATURAL_32
			l_easy_by_hash: CE_POINTER [PD_CURL_ONE_EASY]
			l_remove_sock_from_hash: BOOLEAN
			l_action: INTEGER_32
			l_j: INTEGER_32
			l_easy_conn: CE_POINTER [PD_CONNECTDATA]
			l_tmp___4: CE_POINTER [ANY]
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_socks.make (<<5>>)
			create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]} l_entry.make
			create {CE_INTEGER_32_ARRAY} l_s.make (<<1>>)

			l_i := 0
			from
			until
				not (l_i < 5)
			loop
				l_socks[l_i] := -1
				l_i := l_i + 1
			end
			l_curraction := (a_easy.item.multi_getsock (l_socks, 5)).to_natural_32
			l_i := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_continue := False
				if l_i < 5 then
					if not ((l_curraction).bit_and (((((1).bit_shift_left (l_i))).bit_or (((1).bit_shift_left ((16 + l_i))))).to_natural_32)).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break or l_continue) then
					l_action := 0
					l_s.item := l_socks[l_i]
					l_entry := create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_cast (((a_multi.item.sockhash).item.Curl_hash_pick (create {CE_VOID_POINTER}.make_cast (l_s), {PLATFORM}.Integer_32_bytes.to_natural_32)))
					if ((l_curraction).bit_and (((1).bit_shift_left (l_i)).to_natural_32)).to_boolean then
						l_action := (l_action).bit_or ((1))
					end
					if ((l_curraction).bit_and (((1).bit_shift_left ((16 + l_i))).to_natural_32)).to_boolean then
						l_action := (l_action).bit_or ((2))
					end
					if (not l_entry.is_void) then
						if l_entry.item.action = l_action then
							l_continue := True
						end
					else
						l_entry := (a_multi.item.sockhash).item.sh_addentry (l_s.item, a_easy.item.easy_handle)
						if l_entry.is_void then
							l_return := True
						end
					end
				end
				if not (l_return or l_break or l_continue) then
					(a_multi.item.socket_cb).call ([create {CE_VOID_POINTER}.make_cast (a_easy.item.easy_handle), l_s.item, l_action, a_multi.item.socket_userp, l_entry.item.socketp])
					l_entry.item.action := l_action
				end
				if (not l_return and not l_break) then
					l_i := l_i + 1
				end
			end
			if not l_return then
				l_break := False
				l_continue := False
				l_num := l_i
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < a_easy.item.numsocks))
				loop
					l_s.item := a_easy.item.sockets[l_i]
					l_j := 0
					from
					until
						not (not (l_break) and then (l_j < l_num))
					loop
						l_break := False
						if l_s.item = l_socks[l_j] then
							l_s.item := -1
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_j := l_j + 1
						end
					end
					l_break := False
					if l_s.item /= -1 then
						l_remove_sock_from_hash := (1).to_boolean
						l_entry := create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_cast (((a_multi.item.sockhash).item.Curl_hash_pick (create {CE_VOID_POINTER}.make_cast (l_s), {PLATFORM}.Integer_32_bytes.to_natural_32)))
						if (not l_entry.is_void) then
							l_easy_by_hash := (l_entry.item.easy).item.multi_pos
							l_easy_conn := l_easy_by_hash.item.easy_conn
							if (not l_easy_conn.is_void) then
								if (not (l_easy_conn.item.recv_pipe).is_void) then
									if (l_easy_conn.item.recv_pipe).item.size > {NATURAL_32} 1 then
										l_remove_sock_from_hash := (0).to_boolean
										if (l_entry.item.easy).is_equal (a_easy.item.easy_handle) then
											if (isHandleAtHead (a_easy.item.easy_handle, l_easy_conn.item.recv_pipe)) then
												l_entry.item.easy := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast ((((l_easy_conn.item.recv_pipe).item.head).item.next).item.ptr)
											else
												l_entry.item.easy := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (((l_easy_conn.item.recv_pipe).item.head).item.ptr)
											end
										end
									end
								end
								if (not (l_easy_conn.item.send_pipe).is_void) then
									if (l_easy_conn.item.send_pipe).item.size > {NATURAL_32} 1 then
										l_remove_sock_from_hash := (0).to_boolean
										if (l_entry.item.easy).is_equal (a_easy.item.easy_handle) then
											if (isHandleAtHead (a_easy.item.easy_handle, l_easy_conn.item.send_pipe)) then
												l_entry.item.easy := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast ((((l_easy_conn.item.send_pipe).item.head).item.next).item.ptr)
											else
												l_entry.item.easy := create {CE_CLASS_POINTER [PD_SESSIONHANDLE]}.make_cast (((l_easy_conn.item.send_pipe).item.head).item.ptr)
											end
										end
									end
								end
							end
						else
							l_remove_sock_from_hash := (0).to_boolean
						end
						if l_remove_sock_from_hash then
							if (not l_entry.is_void) then
								l_tmp___4 := l_entry.item.socketp
							else
								l_tmp___4 := create {CE_VOID_POINTER}.make_shared (default_pointer)
							end
							(a_multi.item.socket_cb).call ([create {CE_VOID_POINTER}.make_cast (a_easy.item.easy_handle), l_s.item, 4, a_multi.item.socket_userp, l_tmp___4]);
							(a_multi.item.sockhash).item.sh_delentry (l_s.item)
						end
					end
					l_i := l_i + 1
				end
				memcpy (create {CE_VOID_POINTER}.make_cast ((a_easy.item.sockets)), create {CE_VOID_POINTER}.make_cast (l_socks), l_num.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
				a_easy.item.numsocks := l_num
			end
		end

	curl_multi_setopt (a_args: TUPLE [a_multi_handle: CE_POINTER [ANY]; a_option: NATURAL_32]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_res: INTEGER_32
			l_param: CE_VA_LIST
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_param.make_shared (default_pointer)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_args.a_multi_handle)
					l_res := {PC_CURLMCODE}.CURLM_OK
					if (not l_multi.is_void) then
						if l_multi.item.type /= 764_702 then
							Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
							l_return := True
						end
					else
						Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
						l_return := True
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_param := create {CE_VA_LIST}.make (a_args, agent curl_multi_setopt)
						inspect a_args.a_option.to_integer_32 -- switch 1 head
						when 20001 then l_pos := -1 + 2
						when 10002 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 20004 then l_pos := -1 + 5
						when 10005 then l_pos := -1 + 6
						when 6 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 2 then -- switch 1, case 20001
						l_multi.item.socket_cb := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 9 -- switch 1; break
				when 3 then -- switch 1, case 10002
						l_multi.item.socket_userp := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
						l_pos := -1 + 9 -- switch 1; break
				when 4 then -- switch 1, case 3
						l_multi.item.pipelining_enabled := (0 /= (l_param.integer_32_item))
						l_pos := -1 + 9 -- switch 1; break
				when 5 then -- switch 1, case 20004
						l_multi.item.timer_cb := (create {CE_ROUTINE}.make_cast (l_param.pointer_item))
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 10005
						l_multi.item.timer_userp := (create {CE_VOID_POINTER}.make_cast (l_param.pointer_item))
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 6
						l_multi.item.maxconnects := l_param.integer_32_item
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						l_res := {PC_CURLMCODE}.CURLM_UNKNOWN_OPTION
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						Result := l_res
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	curl_multi_socket (a_multi_handle: CE_POINTER [ANY]; a_s: INTEGER_32; a_running_handles: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := ((create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).item.multi_socket ((0).to_boolean, a_s, 0, a_running_handles))
			if 0 >= l_result then
				(create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).item.update_timer.do_nothing
			end
			Result := l_result
		end

	curl_multi_socket_action (a_multi_handle: CE_POINTER [ANY]; a_s, a_ev_bitmask: INTEGER_32; a_running_handles: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := ((create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).item.multi_socket ((0).to_boolean, a_s, a_ev_bitmask, a_running_handles))
			if 0 >= l_result then
				(create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).item.update_timer.do_nothing
			end
			Result := l_result
		end

	curl_multi_socket_all (a_multi_handle: CE_POINTER [ANY]; a_running_handles: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_result: INTEGER_32
		do
			l_result := ((create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).item.multi_socket ((1).to_boolean, -1, 0, a_running_handles))
			if 0 >= l_result then
				(create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)).item.update_timer.do_nothing
			end
			Result := l_result
		end

	curl_multi_timeout (a_multi_handle: CE_POINTER [ANY]; a_timeout_ms: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_return: BOOLEAN
		do
			l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)
			if (not l_multi.is_void) then
				if l_multi.item.type /= 764_702 then
					Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
					l_return := True
				end
			else
				Result := ({PC_CURLMCODE}.CURLM_BAD_HANDLE)
				l_return := True
			end
			if not l_return then
				Result := (l_multi.item.multi_timeout (a_timeout_ms))
			end
		end

	isHandleAtHead (a_handle: CE_POINTER [PD_SESSIONHANDLE]; a_pipeline: CE_POINTER [PD_CURL_LLIST]): BOOLEAN
		require
			not a_pipeline.is_void
		local
			l_curr: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_return: BOOLEAN
		do
			l_curr := a_pipeline.item.head
			if (not l_curr.is_void) then
				Result := ((l_curr.item.ptr).is_equal (a_handle))
				l_return := True
			end
			if not l_return then
				Result := (0).to_boolean
			end
		end

	multi_freetimeout (a_user, a_entryptr: CE_POINTER [ANY])
		do
			(create {P_EASY_STATIC}).Curl_cfree.item.call ([a_entryptr])
		end

	curl_multi_assign (a_multi_handle: CE_POINTER [ANY]; a_s: INTEGER_32; a_hashp: CE_POINTER [ANY]): INTEGER_32
		local
			l_s: CE_ARRAY [INTEGER_32]
			l_there: CE_POINTER [PD_CURL_SH_ENTRY]
			l_multi: CE_POINTER [PD_CURL_MULTI]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_s.make (<<1>>)

			l_s.item := a_s
			l_there := create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_shared (default_pointer)
			l_multi := create {CE_CLASS_POINTER [PD_CURL_MULTI]}.make_cast (a_multi_handle)
			if l_s.item /= -1 then
				l_there := create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_cast (((l_multi.item.sockhash).item.Curl_hash_pick (create {CE_VOID_POINTER}.make_cast (l_s), {PLATFORM}.Integer_32_bytes.to_natural_32)))
			end
			if l_there.is_void then
				Result := ({PC_CURLMCODE}.CURLM_BAD_SOCKET)
				l_return := True
			end
			if not l_return then
				l_there.item.socketp := a_hashp
				Result := ({PC_CURLMCODE}.CURLM_OK)
			end
		end

feature {ANY} -- routine addresses

	sh_freeentry_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sh_freeentry)
		end

	fd_key_compare_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent fd_key_compare)
		end

	hash_fd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent hash_fd)
		end

	multi_freeamsg_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent multi_freeamsg)
		end

	multi_freetimeout_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent multi_freetimeout)
		end

end
