class
	P_SLIST_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	slist_get_last (a_list: CE_POINTER [PD_CURL_SLIST]): CE_POINTER [PD_CURL_SLIST]
		local
			l_item: CE_POINTER [PD_CURL_SLIST]
			l_return: BOOLEAN
		do
			if a_list.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_item := a_list
				from
				until
					(l_item.item.next).is_void
				loop
					l_item := l_item.item.next
				end
				Result := l_item
			end
		end

	curl_slist_append (a_list: CE_POINTER [PD_CURL_SLIST]; a_data: CE_POINTER [INTEGER_8]): CE_POINTER [PD_CURL_SLIST]
		local
			l_last: CE_POINTER [PD_CURL_SLIST]
			l_new_item: CE_POINTER [PD_CURL_SLIST]
			l_dupdata: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_new_item := create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_CURL_SLIST}.make).structure_size.to_natural_32]))))
			if (not l_new_item.is_void) then
				l_dupdata := (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([a_data])))
				if (not l_dupdata.is_void) then
					l_new_item.item.next := create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer)
					l_new_item.item.data := l_dupdata
				else
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_new_item)])
					Result := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
					l_return := True
				end
			else
				Result := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return and then (not a_list.is_void) then
				l_last := slist_get_last (a_list)
				l_last.item.next := l_new_item
				Result := a_list
				l_return := True
			end
			if not l_return then
				Result := l_new_item
			end
		end

	Curl_slist_duplicate (a_inlist: CE_POINTER [PD_CURL_SLIST]): CE_POINTER [PD_CURL_SLIST]
		local
			l_inlist: CE_POINTER [PD_CURL_SLIST]
			l_outlist: CE_POINTER [PD_CURL_SLIST]
			l_tmp: CE_POINTER [PD_CURL_SLIST]
			l_return: BOOLEAN
		do
			l_inlist := a_inlist
			l_outlist := create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer)
			from
			until
				not (not (l_return) and then (not l_inlist.is_void))
			loop
				l_tmp := curl_slist_append (l_outlist, l_inlist.item.data)
				if l_tmp.is_void then
					curl_slist_free_all (l_outlist)
					Result := (create {CE_CLASS_POINTER [PD_CURL_SLIST]}.make_shared (default_pointer))
					l_return := True
				end
				if not l_return then
					l_outlist := l_tmp
					l_inlist := l_inlist.item.next
				end
			end
			if not l_return then
				Result := l_outlist
			end
		end

	curl_slist_free_all (a_list: CE_POINTER [PD_CURL_SLIST])
		local
			l_next: CE_POINTER [PD_CURL_SLIST]
			l_item: CE_POINTER [PD_CURL_SLIST]
			l_return, l_break: BOOLEAN
		do
			if a_list.is_void then
				l_return := True
			end
			if not l_return then
				l_item := a_list
				from
				until
					(l_break)
				loop
					l_break := False
					l_next := l_item.item.next
					if (not (l_item.item.data).is_void) then
						(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_item.item.data)])
					end
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_item)])
					l_item := l_next
					if l_next.is_void then
						l_break := True
					end
				end
				l_break := False
			end
		end

end
