class
	PD_BACK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create fread_func.make
			create {CE_VOID_POINTER} fread_in.make
			create {CE_INTEGER_8_POINTER} postdata.make
		end

feature {ANY} -- fields

	fread_func: CE_ROUTINE assign set_fread_func

	fread_in: CE_POINTER [ANY] assign set_fread_in

	postdata: CE_POINTER [INTEGER_8] assign set_postdata

	postsize: INTEGER_64 assign set_postsize

feature {ANY} -- field setters

	set_fread_func (a_fread_func: CE_ROUTINE)
		do
			fread_func := a_fread_func
			update_memory_field ("fread_func")
		end

	set_fread_in (a_fread_in: CE_POINTER [ANY])
		do
			fread_in := a_fread_in
			update_memory_field ("fread_in")
		end

	set_postdata (a_postdata: CE_POINTER [INTEGER_8])
		do
			postdata := a_postdata
			update_memory_field ("postdata")
		end

	set_postsize (a_postsize: INTEGER_64)
		do
			postsize := a_postsize
			update_memory_field ("postsize")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fread_func := a_other.fread_func
			fread_in := a_other.fread_in
			postdata := a_other.postdata
			postsize := a_other.postsize
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fread_func.is_equal (a_other.fread_func) and
				fread_in.is_equal (a_other.fread_in) and
				postdata.is_equal (a_other.postdata) and
				postsize = a_other.postsize
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fread_func"),
					create {CE_STRUCTURE_FIELD}.make ("fread_in"),
					create {CE_STRUCTURE_FIELD}.make ("postdata"),
					create {CE_STRUCTURE_FIELD}.make ("postsize")
				>>)
			init_structure_info
		end

end
