class
	PD_BACKUP

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create write_function.make
			create {CE_CLASS_POINTER [SD_IO_FILE]} file_descriptor.make
		end

feature {ANY} -- fields

	write_function: CE_ROUTINE assign set_write_function

	file_descriptor: CE_POINTER [SD_IO_FILE] assign set_file_descriptor

feature {ANY} -- field setters

	set_write_function (a_write_function: CE_ROUTINE)
		do
			write_function := a_write_function
			update_memory_field ("write_function")
		end

	set_file_descriptor (a_file_descriptor: CE_POINTER [SD_IO_FILE])
		do
			file_descriptor := a_file_descriptor
			update_memory_field ("file_descriptor")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			write_function := a_other.write_function
			file_descriptor := a_other.file_descriptor
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				write_function.is_equal (a_other.write_function) and
				file_descriptor.is_equal (a_other.file_descriptor)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("write_function"),
					create {CE_STRUCTURE_FIELD}.make ("file_descriptor")
				>>)
			init_structure_info
		end

end
