class
	PD_CURL_FILEINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} filename.make
			create strings.make
			create {CE_INTEGER_8_POINTER} b_data.make
		end

feature {ANY} -- fields

	filename: CE_POINTER [INTEGER_8] assign set_filename

	filetype: NATURAL_32 assign set_filetype

	time: INTEGER_32 assign set_time

	perm: NATURAL_32 assign set_perm

	uid: INTEGER_32 assign set_uid

	gid: INTEGER_32 assign set_gid

	size: INTEGER_64 assign set_size

	hardlinks: INTEGER_32 assign set_hardlinks

	strings: PD_STRINGS assign set_strings

	flags: NATURAL_32 assign set_flags

	b_data: CE_POINTER [INTEGER_8] assign set_b_data

	b_size: NATURAL_32 assign set_b_size

	b_used: NATURAL_32 assign set_b_used

feature {ANY} -- field setters

	set_filename (a_filename: CE_POINTER [INTEGER_8])
		do
			filename := a_filename
			update_memory_field ("filename")
		end

	set_filetype (a_filetype: NATURAL_32)
		do
			filetype := a_filetype
			update_memory_field ("filetype")
		end

	set_time (a_time: INTEGER_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_perm (a_perm: NATURAL_32)
		do
			perm := a_perm
			update_memory_field ("perm")
		end

	set_uid (a_uid: INTEGER_32)
		do
			uid := a_uid
			update_memory_field ("uid")
		end

	set_gid (a_gid: INTEGER_32)
		do
			gid := a_gid
			update_memory_field ("gid")
		end

	set_size (a_size: INTEGER_64)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_hardlinks (a_hardlinks: INTEGER_32)
		do
			hardlinks := a_hardlinks
			update_memory_field ("hardlinks")
		end

	set_strings (a_strings: PD_STRINGS)
		do
			strings := a_strings
			update_memory_field ("strings")
		end

	set_flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_b_data (a_b_data: CE_POINTER [INTEGER_8])
		do
			b_data := a_b_data
			update_memory_field ("b_data")
		end

	set_b_size (a_b_size: NATURAL_32)
		do
			b_size := a_b_size
			update_memory_field ("b_size")
		end

	set_b_used (a_b_used: NATURAL_32)
		do
			b_used := a_b_used
			update_memory_field ("b_used")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			filename := a_other.filename
			filetype := a_other.filetype
			time := a_other.time
			perm := a_other.perm
			uid := a_other.uid
			gid := a_other.gid
			size := a_other.size
			hardlinks := a_other.hardlinks
			strings := a_other.strings.twin
			flags := a_other.flags
			b_data := a_other.b_data
			b_size := a_other.b_size
			b_used := a_other.b_used
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				filename.is_equal (a_other.filename) and
				filetype = a_other.filetype and
				time = a_other.time and
				perm = a_other.perm and
				uid = a_other.uid and
				gid = a_other.gid and
				size = a_other.size and
				hardlinks = a_other.hardlinks and
				strings.is_equal (a_other.strings) and
				flags = a_other.flags and
				b_data.is_equal (a_other.b_data) and
				b_size = a_other.b_size and
				b_used = a_other.b_used
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("filename"),
					create {CE_STRUCTURE_FIELD}.make ("filetype"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("perm"),
					create {CE_STRUCTURE_FIELD}.make ("uid"),
					create {CE_STRUCTURE_FIELD}.make ("gid"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("hardlinks"),
					create {CE_STRUCTURE_FIELD}.make ("strings"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("b_data"),
					create {CE_STRUCTURE_FIELD}.make ("b_size"),
					create {CE_STRUCTURE_FIELD}.make ("b_used")
				>>)
			init_structure_info
		end

end
