class
	PD_CURL_HASH

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_POINTER_POINTER [PD_CURL_LLIST]} table.make
			create hash_func.make
			create comp_func.make
			create dtor.make
			Precursor
		end

feature {ANY} -- fields

	table: CE_POINTER [CE_POINTER [PD_CURL_LLIST]] assign set_table

	hash_func: CE_ROUTINE assign set_hash_func

	comp_func: CE_ROUTINE assign set_comp_func

	dtor: CE_ROUTINE assign set_dtor

	slots: INTEGER_32 assign set_slots

	size: NATURAL_32 assign set_size

feature {ANY} -- field setters

	set_table (a_table: CE_POINTER [CE_POINTER [PD_CURL_LLIST]])
		do
			table := a_table
			update_memory_field ("table")
		end

	set_hash_func (a_hash_func: CE_ROUTINE)
		do
			hash_func := a_hash_func
			update_memory_field ("hash_func")
		end

	set_comp_func (a_comp_func: CE_ROUTINE)
		do
			comp_func := a_comp_func
			update_memory_field ("comp_func")
		end

	set_dtor (a_dtor: CE_ROUTINE)
		do
			dtor := a_dtor
			update_memory_field ("dtor")
		end

	set_slots (a_slots: INTEGER_32)
		do
			slots := a_slots
			update_memory_field ("slots")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY} -- public routines

	Curl_hash_init (a_slots: INTEGER_32; a_hfunc, a_comparator, a_dtor: CE_ROUTINE): INTEGER_32
		local
			l_i: INTEGER_32
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if not a_slots.to_boolean then
				Result := 1
				l_return := True
			elseif a_hfunc.is_void then
				Result := 1
				l_return := True
			elseif a_comparator.is_void then
				Result := 1
				l_return := True
			elseif a_dtor.is_void then
				Result := 1
				l_return := True
			end
			if not l_return then
				Current.hash_func := a_hfunc
				update_class_fields -- Current might have been changed; synchronize
				Current.comp_func := a_comparator
				update_class_fields -- Current might have been changed; synchronize
				Current.dtor := a_dtor
				update_class_fields -- Current might have been changed; synchronize
				Current.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				Current.slots := a_slots
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([a_slots.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				Current.table := create {CE_POINTER_POINTER [PD_CURL_LLIST]}.make_cast (l_tmp)
				update_class_fields -- Current might have been changed; synchronize
				if (not table.is_void) then
					l_i := 0
					from
					until
						not (not (l_return) and then (l_i < a_slots))
					loop
						table[l_i] := (create {P_LLIST_STATIC}).Curl_llist_alloc ((create {P_HASH_STATIC}).hash_element_dtor_address)
						update_class_fields -- Current might have been changed; synchronize
						if (table[l_i]).is_void then
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___0 := l_i
								l_i := l_i - 1
								if not l_tmp___0.to_boolean then
									l_break := True
								end
								if not (l_break) then
									(create {P_LLIST_STATIC}).Curl_llist_destroy (table[l_i], create {CE_VOID_POINTER}.make_shared (default_pointer))
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							l_break := False;
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (table)])
							update_class_fields -- Current might have been changed; synchronize
							Result := 1
							l_return := True
						end
						if not l_return then
							l_i := l_i + 1
						end
					end
					if not l_return then
						Result := 0
					end
				else
					Result := 1
				end
			end
		end

	Curl_hash_add (a_key: CE_POINTER [ANY]; a_key_len: NATURAL_32; a_p: CE_POINTER [ANY]): CE_POINTER [ANY]
		local
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_le: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_l: CE_POINTER [PD_CURL_LLIST]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_tmp := hash_func.natural_32_item ([a_key, a_key_len, slots.to_natural_32])
			update_class_fields -- Current might have been changed; synchronize
			l_l := table[l_tmp.to_integer_32]
			l_le := l_l.item.head
			from
			until
				not (not (l_break) and then (not l_le.is_void))
			loop
				l_break := False
				l_he := create {CE_CLASS_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (l_le.item.ptr)
				l_tmp___0 := comp_func.natural_32_item ([create {CE_VOID_POINTER}.make_cast (l_he.item.key), l_he.item.key_len, a_key, a_key_len])
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					l_l.item.Curl_llist_remove (l_le, create {CE_VOID_POINTER}.make_shared (c_pointer)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Current.size := size - 1
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				if not (l_break) then
					l_le := l_le.item.next
				end
			end
			l_break := False
			l_he := mk_hash_element (a_key, a_key_len, a_p)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_he.is_void) then
				l_tmp___1 := (create {P_LLIST_STATIC}).Curl_llist_insert_next (l_l, l_l.item.tail, create {CE_VOID_POINTER}.make_cast (l_he))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					Current.size := size + 1
					update_class_fields -- Current might have been changed; synchronize
					Result := a_p
					l_return := True
				end
				if not l_return then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_he.item.key)])
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_he)])
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

	Curl_hash_delete (a_key: CE_POINTER [ANY]; a_key_len: NATURAL_32): INTEGER_32
		local
			l_le: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_l: CE_POINTER [PD_CURL_LLIST]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return: BOOLEAN
		do
			l_tmp := hash_func.natural_32_item ([a_key, a_key_len, slots.to_natural_32])
			update_class_fields -- Current might have been changed; synchronize
			l_l := table[l_tmp.to_integer_32]
			l_le := l_l.item.head
			from
			until
				not (not (l_return) and then (not l_le.is_void))
			loop
				l_he := create {CE_CLASS_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (l_le.item.ptr)
				l_tmp___0 := comp_func.natural_32_item ([create {CE_VOID_POINTER}.make_cast (l_he.item.key), l_he.item.key_len, a_key, a_key_len])
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					l_l.item.Curl_llist_remove (l_le, create {CE_VOID_POINTER}.make_shared (c_pointer)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Result := 0
					l_return := True
				end
				if not l_return then
					l_le := l_le.item.next
				end
			end
			if not l_return then
				Result := 1
			end
		end

	Curl_hash_pick (a_key: CE_POINTER [ANY]; a_key_len: NATURAL_32): CE_POINTER [ANY]
		local
			l_le: CE_POINTER [PD_CURL_LLIST_ELEMENT]
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_l: CE_POINTER [PD_CURL_LLIST]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return: BOOLEAN
		do
			l_tmp := hash_func.natural_32_item ([a_key, a_key_len, slots.to_natural_32])
			update_class_fields -- Current might have been changed; synchronize
			l_l := table[l_tmp.to_integer_32]
			l_le := l_l.item.head
			from
			until
				not (not (l_return) and then (not l_le.is_void))
			loop
				l_he := create {CE_CLASS_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast (l_le.item.ptr)
				l_tmp___0 := comp_func.natural_32_item ([create {CE_VOID_POINTER}.make_cast (l_he.item.key), l_he.item.key_len, a_key, a_key_len])
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					Result := (l_he.item.ptr)
					l_return := True
				end
				if not l_return then
					l_le := l_le.item.next
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

	Curl_hash_clean
		local
			l_i: INTEGER_32
		do
			l_i := 0
			from
			until
				not (l_i < slots)
			loop
				(create {P_LLIST_STATIC}).Curl_llist_destroy (table[l_i], create {CE_VOID_POINTER}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				table[l_i] := create {CE_CLASS_POINTER [PD_CURL_LLIST]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (table)])
			update_class_fields -- Current might have been changed; synchronize
		end

	sh_addentry (a_s: INTEGER_32; a_data: CE_POINTER [PD_SESSIONHANDLE]): CE_POINTER [PD_CURL_SH_ENTRY]
		local
			l_s: CE_ARRAY [INTEGER_32]
			l_there: CE_POINTER [PD_CURL_SH_ENTRY]
			l_tmp: CE_POINTER [ANY]
			l_check: CE_POINTER [PD_CURL_SH_ENTRY]
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___1: CE_POINTER [ANY]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_s.make (<<1>>)

			l_s.item := a_s
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := ((create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (c_pointer))).item.Curl_hash_pick (create {CE_VOID_POINTER}.make_cast (l_s), {PLATFORM}.Integer_32_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_there := create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_cast (l_tmp)
			if (not l_there.is_void) then
				Result := l_there
				l_return := True
			end
			if not l_return then
				l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_ccalloc.item.pointer_item ([(1).to_natural_32, (create {PD_CURL_SH_ENTRY}.make).structure_size.to_natural_32]))
				update_class_fields -- Current might have been changed; synchronize
				l_check := create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_cast (l_tmp___0)
				if l_check.is_void then
					Result := (create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_check.item.easy := a_data
				update_class_fields -- Current might have been changed; synchronize
				l_check.item.socket := l_s.item
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := ((create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (c_pointer))).item.Curl_hash_add (create {CE_VOID_POINTER}.make_cast (l_s), {PLATFORM}.Integer_32_bytes.to_natural_32, create {CE_VOID_POINTER}.make_cast (l_check))
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.is_void then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_check)])
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				Result := l_check
			end
		end

	sh_delentry (a_s: INTEGER_32)
		local
			l_s: CE_ARRAY [INTEGER_32]
			l_there: CE_POINTER [PD_CURL_SH_ENTRY]
			l_tmp: CE_POINTER [ANY]
		do
			create {CE_INTEGER_32_ARRAY} l_s.make (<<1>>)

			l_s.item := a_s
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := ((create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (c_pointer))).item.Curl_hash_pick (create {CE_VOID_POINTER}.make_cast (l_s), {PLATFORM}.Integer_32_bytes.to_natural_32)
			update_class_fields -- Current might have been changed; synchronize
			l_there := create {CE_CLASS_POINTER [PD_CURL_SH_ENTRY]}.make_cast (l_tmp)
			if (not l_there.is_void) then
				((create {CE_CLASS_POINTER [PD_CURL_HASH]}.make_shared (c_pointer))).item.Curl_hash_delete (create {CE_VOID_POINTER}.make_cast (l_s), {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
		end

feature {PD_CURL_HASH} -- private routines

	mk_hash_element (a_key: CE_POINTER [ANY]; a_key_len: NATURAL_32; a_p: CE_POINTER [ANY]): CE_POINTER [PD_CURL_HASH_ELEMENT]
		local
			l_he: CE_POINTER [PD_CURL_HASH_ELEMENT]
			l_dupkey: CE_POINTER [ANY]
		do
			l_he := create {CE_CLASS_POINTER [PD_CURL_HASH_ELEMENT]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_CURL_HASH_ELEMENT}.make).structure_size.to_natural_32]))))
			if (not l_he.is_void) then
				l_dupkey := (create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([a_key_len])))
				if (not l_dupkey.is_void) then
					memcpy (l_dupkey, a_key, a_key_len).do_nothing
					l_he.item.key := create {CE_INTEGER_8_POINTER}.make_cast (l_dupkey)
					l_he.item.key_len := a_key_len
					l_he.item.ptr := a_p
				else
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_he)])
					l_he := create {CE_CLASS_POINTER [PD_CURL_HASH_ELEMENT]}.make_shared (default_pointer)
				end
			end
			Result := l_he
		end

feature {ANY}

	copy (a_other: like Current)
		do
			table := a_other.table
			hash_func := a_other.hash_func
			comp_func := a_other.comp_func
			dtor := a_other.dtor
			slots := a_other.slots
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				table.is_equal (a_other.table) and
				hash_func.is_equal (a_other.hash_func) and
				comp_func.is_equal (a_other.comp_func) and
				dtor.is_equal (a_other.dtor) and
				slots = a_other.slots and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("table"),
					create {CE_STRUCTURE_FIELD}.make ("hash_func"),
					create {CE_STRUCTURE_FIELD}.make ("comp_func"),
					create {CE_STRUCTURE_FIELD}.make ("dtor"),
					create {CE_STRUCTURE_FIELD}.make ("slots"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
