class
	PD_CURL_HASH_ELEMENT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} ptr.make
			create {CE_INTEGER_8_POINTER} key.make
		end

feature {ANY} -- fields

	ptr: CE_POINTER [ANY] assign set_ptr

	key: CE_POINTER [INTEGER_8] assign set_key

	key_len: NATURAL_32 assign set_key_len

feature {ANY} -- field setters

	set_ptr (a_ptr: CE_POINTER [ANY])
		do
			ptr := a_ptr
			update_memory_field ("ptr")
		end

	set_key (a_key: CE_POINTER [INTEGER_8])
		do
			key := a_key
			update_memory_field ("key")
		end

	set_key_len (a_key_len: NATURAL_32)
		do
			key_len := a_key_len
			update_memory_field ("key_len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ptr := a_other.ptr
			key := a_other.key
			key_len := a_other.key_len
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ptr.is_equal (a_other.ptr) and
				key.is_equal (a_other.key) and
				key_len = a_other.key_len
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ptr"),
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("key_len")
				>>)
			init_structure_info
		end

end
