class
	PD_CURL_HTTPPOST

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_CURL_HTTPPOST]} next.make
			create {CE_INTEGER_8_POINTER} name.make
			create {CE_INTEGER_8_POINTER} contents.make
			create {CE_INTEGER_8_POINTER} buffer.make
			create {CE_INTEGER_8_POINTER} contenttype.make
			create {CE_CLASS_POINTER [PD_CURL_SLIST]} contentheader.make
			create {CE_CLASS_POINTER [PD_CURL_HTTPPOST]} more.make
			create {CE_INTEGER_8_POINTER} showfilename.make
			create {CE_VOID_POINTER} userp.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_CURL_HTTPPOST] assign set_next

	name: CE_POINTER [INTEGER_8] assign set_name

	namelength: INTEGER_32 assign set_namelength

	contents: CE_POINTER [INTEGER_8] assign set_contents

	contentslength: INTEGER_32 assign set_contentslength

	buffer: CE_POINTER [INTEGER_8] assign set_buffer

	bufferlength: INTEGER_32 assign set_bufferlength

	contenttype: CE_POINTER [INTEGER_8] assign set_contenttype

	contentheader: CE_POINTER [PD_CURL_SLIST] assign set_contentheader

	more: CE_POINTER [PD_CURL_HTTPPOST] assign set_more

	flags: INTEGER_32 assign set_flags

	showfilename: CE_POINTER [INTEGER_8] assign set_showfilename

	userp: CE_POINTER [ANY] assign set_userp

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_CURL_HTTPPOST])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_namelength (a_namelength: INTEGER_32)
		do
			namelength := a_namelength
			update_memory_field ("namelength")
		end

	set_contents (a_contents: CE_POINTER [INTEGER_8])
		do
			contents := a_contents
			update_memory_field ("contents")
		end

	set_contentslength (a_contentslength: INTEGER_32)
		do
			contentslength := a_contentslength
			update_memory_field ("contentslength")
		end

	set_buffer (a_buffer: CE_POINTER [INTEGER_8])
		do
			buffer := a_buffer
			update_memory_field ("buffer")
		end

	set_bufferlength (a_bufferlength: INTEGER_32)
		do
			bufferlength := a_bufferlength
			update_memory_field ("bufferlength")
		end

	set_contenttype (a_contenttype: CE_POINTER [INTEGER_8])
		do
			contenttype := a_contenttype
			update_memory_field ("contenttype")
		end

	set_contentheader (a_contentheader: CE_POINTER [PD_CURL_SLIST])
		do
			contentheader := a_contentheader
			update_memory_field ("contentheader")
		end

	set_more (a_more: CE_POINTER [PD_CURL_HTTPPOST])
		do
			more := a_more
			update_memory_field ("more")
		end

	set_flags (a_flags: INTEGER_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set_showfilename (a_showfilename: CE_POINTER [INTEGER_8])
		do
			showfilename := a_showfilename
			update_memory_field ("showfilename")
		end

	set_userp (a_userp: CE_POINTER [ANY])
		do
			userp := a_userp
			update_memory_field ("userp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			name := a_other.name
			namelength := a_other.namelength
			contents := a_other.contents
			contentslength := a_other.contentslength
			buffer := a_other.buffer
			bufferlength := a_other.bufferlength
			contenttype := a_other.contenttype
			contentheader := a_other.contentheader
			more := a_other.more
			flags := a_other.flags
			showfilename := a_other.showfilename
			userp := a_other.userp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				name.is_equal (a_other.name) and
				namelength = a_other.namelength and
				contents.is_equal (a_other.contents) and
				contentslength = a_other.contentslength and
				buffer.is_equal (a_other.buffer) and
				bufferlength = a_other.bufferlength and
				contenttype.is_equal (a_other.contenttype) and
				contentheader.is_equal (a_other.contentheader) and
				more.is_equal (a_other.more) and
				flags = a_other.flags and
				showfilename.is_equal (a_other.showfilename) and
				userp.is_equal (a_other.userp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("namelength"),
					create {CE_STRUCTURE_FIELD}.make ("contents"),
					create {CE_STRUCTURE_FIELD}.make ("contentslength"),
					create {CE_STRUCTURE_FIELD}.make ("buffer"),
					create {CE_STRUCTURE_FIELD}.make ("bufferlength"),
					create {CE_STRUCTURE_FIELD}.make ("contenttype"),
					create {CE_STRUCTURE_FIELD}.make ("contentheader"),
					create {CE_STRUCTURE_FIELD}.make ("more"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("showfilename"),
					create {CE_STRUCTURE_FIELD}.make ("userp")
				>>)
			init_structure_info
		end

end
