class
	PD_CURL_KHKEY

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} key.make
		end

feature {ANY} -- fields

	key: CE_POINTER [INTEGER_8] assign set_key

	len: NATURAL_32 assign set_len

	keytype: NATURAL_32 assign set_keytype

feature {ANY} -- field setters

	set_key (a_key: CE_POINTER [INTEGER_8])
		do
			key := a_key
			update_memory_field ("key")
		end

	set_len (a_len: NATURAL_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set_keytype (a_keytype: NATURAL_32)
		do
			keytype := a_keytype
			update_memory_field ("keytype")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			key := a_other.key
			len := a_other.len
			keytype := a_other.keytype
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				key.is_equal (a_other.key) and
				len = a_other.len and
				keytype = a_other.keytype
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("keytype")
				>>)
			init_structure_info
		end

end
