class
	PD_FTP

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_64_POINTER} bytecountp.make
			create {CE_INTEGER_8_POINTER} user.make
			create {CE_INTEGER_8_POINTER} passwd.make
		end

feature {ANY} -- fields

	bytecountp: CE_POINTER [INTEGER_64] assign set_bytecountp

	user: CE_POINTER [INTEGER_8] assign set_user

	passwd: CE_POINTER [INTEGER_8] assign set_passwd

	transfer: NATURAL_32 assign set_transfer

	downloadsize: INTEGER_64 assign set_downloadsize

feature {ANY} -- field setters

	set_bytecountp (a_bytecountp: CE_POINTER [INTEGER_64])
		do
			bytecountp := a_bytecountp
			update_memory_field ("bytecountp")
		end

	set_user (a_user: CE_POINTER [INTEGER_8])
		do
			user := a_user
			update_memory_field ("user")
		end

	set_passwd (a_passwd: CE_POINTER [INTEGER_8])
		do
			passwd := a_passwd
			update_memory_field ("passwd")
		end

	set_transfer (a_transfer: NATURAL_32)
		do
			transfer := a_transfer
			update_memory_field ("transfer")
		end

	set_downloadsize (a_downloadsize: INTEGER_64)
		do
			downloadsize := a_downloadsize
			update_memory_field ("downloadsize")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bytecountp := a_other.bytecountp
			user := a_other.user
			passwd := a_other.passwd
			transfer := a_other.transfer
			downloadsize := a_other.downloadsize
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bytecountp.is_equal (a_other.bytecountp) and
				user.is_equal (a_other.user) and
				passwd.is_equal (a_other.passwd) and
				transfer = a_other.transfer and
				downloadsize = a_other.downloadsize
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bytecountp"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("passwd"),
					create {CE_STRUCTURE_FIELD}.make ("transfer"),
					create {CE_STRUCTURE_FIELD}.make ("downloadsize")
				>>)
			init_structure_info
		end

end
