class
	PD_HMAC_PARAMS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create hmac_hinit.make
			create hmac_hupdate.make
			create hmac_hfinal.make
		end

feature {ANY} -- fields

	hmac_hinit: CE_ROUTINE assign set_hmac_hinit

	hmac_hupdate: CE_ROUTINE assign set_hmac_hupdate

	hmac_hfinal: CE_ROUTINE assign set_hmac_hfinal

	hmac_ctxtsize: NATURAL_32 assign set_hmac_ctxtsize

	hmac_maxkeylen: NATURAL_32 assign set_hmac_maxkeylen

	hmac_resultlen: NATURAL_32 assign set_hmac_resultlen

feature {ANY} -- field setters

	set_hmac_hinit (a_hmac_hinit: CE_ROUTINE)
		do
			hmac_hinit := a_hmac_hinit
			update_memory_field ("hmac_hinit")
		end

	set_hmac_hupdate (a_hmac_hupdate: CE_ROUTINE)
		do
			hmac_hupdate := a_hmac_hupdate
			update_memory_field ("hmac_hupdate")
		end

	set_hmac_hfinal (a_hmac_hfinal: CE_ROUTINE)
		do
			hmac_hfinal := a_hmac_hfinal
			update_memory_field ("hmac_hfinal")
		end

	set_hmac_ctxtsize (a_hmac_ctxtsize: NATURAL_32)
		do
			hmac_ctxtsize := a_hmac_ctxtsize
			update_memory_field ("hmac_ctxtsize")
		end

	set_hmac_maxkeylen (a_hmac_maxkeylen: NATURAL_32)
		do
			hmac_maxkeylen := a_hmac_maxkeylen
			update_memory_field ("hmac_maxkeylen")
		end

	set_hmac_resultlen (a_hmac_resultlen: NATURAL_32)
		do
			hmac_resultlen := a_hmac_resultlen
			update_memory_field ("hmac_resultlen")
		end

feature {PD_HMAC_PARAMS} -- private attributes

	hmac_ipad: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(54).to_natural_8
				>>)
		end

	hmac_opad: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(92).to_natural_8
				>>)
		end

feature {ANY} -- public routines

	Curl_HMAC_init (a_key: CE_POINTER [NATURAL_8]; a_keylen: NATURAL_32): CE_POINTER [PD_HMAC_CONTEXT]
		local
			l_key: CE_POINTER [NATURAL_8]
			l_keylen: NATURAL_32
			l_i: NATURAL_32
			l_ctxt: CE_POINTER [PD_HMAC_CONTEXT]
			l_hkey: CE_POINTER [NATURAL_8]
			l_b: CE_ARRAY [NATURAL_8]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_b.make (<<1>>)

			l_key := a_key
			l_keylen := a_keylen
			l_i := ((create {PD_HMAC_CONTEXT}.make).structure_size.to_natural_32 + ({NATURAL_32} 2 * hmac_ctxtsize)) + hmac_resultlen
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([l_i]))
			update_class_fields -- Current might have been changed; synchronize
			l_ctxt := create {CE_CLASS_POINTER [PD_HMAC_CONTEXT]}.make_cast (l_tmp)
			if l_ctxt.is_void then
				Result := l_ctxt
				l_return := True
			end
			if not l_return then
				l_ctxt.item.hmac_hash := (create {CE_CLASS_POINTER [PD_HMAC_PARAMS]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				l_ctxt.item.hmac_hashctxt1 := create {CE_VOID_POINTER}.make_cast ((l_ctxt + 1))
				update_class_fields -- Current might have been changed; synchronize
				l_ctxt.item.hmac_hashctxt2 := create {CE_VOID_POINTER}.make_cast ((create {CE_INTEGER_8_POINTER}.make_cast (l_ctxt.item.hmac_hashctxt1) + hmac_ctxtsize.to_integer_32))
				update_class_fields -- Current might have been changed; synchronize
				if l_keylen > hmac_maxkeylen then
					hmac_hinit.call ([l_ctxt.item.hmac_hashctxt1])
					update_class_fields -- Current might have been changed; synchronize
					hmac_hupdate.call ([l_ctxt.item.hmac_hashctxt1, l_key, l_keylen])
					update_class_fields -- Current might have been changed; synchronize
					l_hkey := create {CE_NATURAL_8_POINTER}.make_cast (l_ctxt.item.hmac_hashctxt2) + hmac_ctxtsize.to_integer_32
					hmac_hfinal.call ([l_hkey, l_ctxt.item.hmac_hashctxt1])
					update_class_fields -- Current might have been changed; synchronize
					l_key := l_hkey
					l_keylen := hmac_resultlen
				end
				hmac_hinit.call ([l_ctxt.item.hmac_hashctxt1])
				update_class_fields -- Current might have been changed; synchronize
				hmac_hinit.call ([l_ctxt.item.hmac_hashctxt2])
				update_class_fields -- Current might have been changed; synchronize
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_keylen)
				loop
					l_b.item := (((l_key.item).to_integer_32).bit_xor ((hmac_ipad.item.item).to_integer_32)).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					hmac_hupdate.call ([l_ctxt.item.hmac_hashctxt1, l_b, {NATURAL_32} 1])
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := l_key
					l_key := l_key + 1
					l_b.item := (((l_tmp___0.item).to_integer_32).bit_xor ((hmac_opad.item.item).to_integer_32)).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					hmac_hupdate.call ([l_ctxt.item.hmac_hashctxt2, l_b, {NATURAL_32} 1])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				from
				until
					not (l_i < hmac_maxkeylen)
				loop
					hmac_hupdate.call ([l_ctxt.item.hmac_hashctxt1, hmac_ipad.item, {NATURAL_32} 1])
					update_class_fields -- Current might have been changed; synchronize
					hmac_hupdate.call ([l_ctxt.item.hmac_hashctxt2, hmac_opad.item, {NATURAL_32} 1])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := l_ctxt
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hmac_hinit := a_other.hmac_hinit
			hmac_hupdate := a_other.hmac_hupdate
			hmac_hfinal := a_other.hmac_hfinal
			hmac_ctxtsize := a_other.hmac_ctxtsize
			hmac_maxkeylen := a_other.hmac_maxkeylen
			hmac_resultlen := a_other.hmac_resultlen
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hmac_hinit.is_equal (a_other.hmac_hinit) and
				hmac_hupdate.is_equal (a_other.hmac_hupdate) and
				hmac_hfinal.is_equal (a_other.hmac_hfinal) and
				hmac_ctxtsize = a_other.hmac_ctxtsize and
				hmac_maxkeylen = a_other.hmac_maxkeylen and
				hmac_resultlen = a_other.hmac_resultlen
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hmac_hinit"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_hupdate"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_hfinal"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_ctxtsize"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_maxkeylen"),
					create {CE_STRUCTURE_FIELD}.make ("hmac_resultlen")
				>>)
			init_structure_info
		end

end
