class
	PD_NAMES

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_CURL_HASH]} hostcache.make
		end

feature {ANY} -- fields

	hostcache: CE_POINTER [PD_CURL_HASH] assign set_hostcache

	hostcachetype: NATURAL_32 assign set_hostcachetype

feature {ANY} -- field setters

	set_hostcache (a_hostcache: CE_POINTER [PD_CURL_HASH])
		do
			hostcache := a_hostcache
			update_memory_field ("hostcache")
		end

	set_hostcachetype (a_hostcachetype: NATURAL_32)
		do
			hostcachetype := a_hostcachetype
			update_memory_field ("hostcachetype")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			hostcache := a_other.hostcache
			hostcachetype := a_other.hostcachetype
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				hostcache.is_equal (a_other.hostcache) and
				hostcachetype = a_other.hostcachetype
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("hostcache"),
					create {CE_STRUCTURE_FIELD}.make ("hostcachetype")
				>>)
			init_structure_info
		end

end
