class
	PD_NUM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	as_signed: INTEGER_64 assign set_as_signed

	as_unsigned: NATURAL_64 assign set_as_unsigned

feature {ANY} -- field setters

	set_as_signed (a_as_signed: INTEGER_64)
		do
			as_signed := a_as_signed
			update_memory_field ("as_signed")
		end

	set_as_unsigned (a_as_unsigned: NATURAL_64)
		do
			as_unsigned := a_as_unsigned
			update_memory_field ("as_unsigned")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			as_signed := a_other.as_signed
			as_unsigned := a_other.as_unsigned
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				as_signed = a_other.as_signed and
				as_unsigned = a_other.as_unsigned
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("as_signed"),
					create {CE_STRUCTURE_FIELD}.make ("as_unsigned")
				>>)
			init_structure_info
		end

end
