class
	PD_OFFSETS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	filename: NATURAL_32 assign set_filename

	user: NATURAL_32 assign set_user

	group: NATURAL_32 assign set_group

	time: NATURAL_32 assign set_time

	perm: NATURAL_32 assign set_perm

	symlink_target: NATURAL_32 assign set_symlink_target

feature {ANY} -- field setters

	set_filename (a_filename: NATURAL_32)
		do
			filename := a_filename
			update_memory_field ("filename")
		end

	set_user (a_user: NATURAL_32)
		do
			user := a_user
			update_memory_field ("user")
		end

	set_group (a_group: NATURAL_32)
		do
			group := a_group
			update_memory_field ("group")
		end

	set_time (a_time: NATURAL_32)
		do
			time := a_time
			update_memory_field ("time")
		end

	set_perm (a_perm: NATURAL_32)
		do
			perm := a_perm
			update_memory_field ("perm")
		end

	set_symlink_target (a_symlink_target: NATURAL_32)
		do
			symlink_target := a_symlink_target
			update_memory_field ("symlink_target")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			filename := a_other.filename
			user := a_other.user
			group := a_other.group
			time := a_other.time
			perm := a_other.perm
			symlink_target := a_other.symlink_target
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				filename = a_other.filename and
				user = a_other.user and
				group = a_other.group and
				time = a_other.time and
				perm = a_other.perm and
				symlink_target = a_other.symlink_target
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("filename"),
					create {CE_STRUCTURE_FIELD}.make ("user"),
					create {CE_STRUCTURE_FIELD}.make ("group"),
					create {CE_STRUCTURE_FIELD}.make ("time"),
					create {CE_STRUCTURE_FIELD}.make ("perm"),
					create {CE_STRUCTURE_FIELD}.make ("symlink_target")
				>>)
			init_structure_info
		end

end
