class
	PD_POP3_CONN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create pp.make
			create {CE_INTEGER_8_POINTER} mailbox.make
		end

feature {ANY} -- fields

	pp: PD_PINGPONG assign set_pp

	mailbox: CE_POINTER [INTEGER_8] assign set_mailbox

	eob: NATURAL_32 assign set_eob

	state: NATURAL_32 assign set_state

feature {ANY} -- field setters

	set_pp (a_pp: PD_PINGPONG)
		do
			pp := a_pp
			update_memory_field ("pp")
		end

	set_mailbox (a_mailbox: CE_POINTER [INTEGER_8])
		do
			mailbox := a_mailbox
			update_memory_field ("mailbox")
		end

	set_eob (a_eob: NATURAL_32)
		do
			eob := a_eob
			update_memory_field ("eob")
		end

	set_state (a_state: NATURAL_32)
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pp := a_other.pp.twin
			mailbox := a_other.mailbox
			eob := a_other.eob
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pp.is_equal (a_other.pp) and
				mailbox.is_equal (a_other.mailbox) and
				eob = a_other.eob and
				state = a_other.state
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pp"),
					create {CE_STRUCTURE_FIELD}.make ("mailbox"),
					create {CE_STRUCTURE_FIELD}.make ("eob"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
