class
	PD_RTSP_CONN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} rtp_buf.make
		end

feature {ANY} -- fields

	rtp_buf: CE_POINTER [INTEGER_8] assign set_rtp_buf

	rtp_bufsize: INTEGER_32 assign set_rtp_bufsize

	rtp_channel: INTEGER_32 assign set_rtp_channel

feature {ANY} -- field setters

	set_rtp_buf (a_rtp_buf: CE_POINTER [INTEGER_8])
		do
			rtp_buf := a_rtp_buf
			update_memory_field ("rtp_buf")
		end

	set_rtp_bufsize (a_rtp_bufsize: INTEGER_32)
		do
			rtp_bufsize := a_rtp_bufsize
			update_memory_field ("rtp_bufsize")
		end

	set_rtp_channel (a_rtp_channel: INTEGER_32)
		do
			rtp_channel := a_rtp_channel
			update_memory_field ("rtp_channel")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rtp_buf := a_other.rtp_buf
			rtp_bufsize := a_other.rtp_bufsize
			rtp_channel := a_other.rtp_channel
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rtp_buf.is_equal (a_other.rtp_buf) and
				rtp_bufsize = a_other.rtp_bufsize and
				rtp_channel = a_other.rtp_channel
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rtp_buf"),
					create {CE_STRUCTURE_FIELD}.make ("rtp_bufsize"),
					create {CE_STRUCTURE_FIELD}.make ("rtp_channel")
				>>)
			init_structure_info
		end

end
