class
	PD_SINGLEREQUEST

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_64_POINTER} bytecountp.make
			create {CE_INTEGER_64_POINTER} writebytecountp.make
			create start.make
			create now.make
			create {CE_INTEGER_8_POINTER} hbufp.make
			create {CE_INTEGER_8_POINTER} str.make
			create {CE_INTEGER_8_POINTER} str_start.make
			create {CE_INTEGER_8_POINTER} end_ptr.make
			create {CE_INTEGER_8_POINTER} p.make
			create start100.make
			create {CE_INTEGER_8_POINTER} buf.make
			create {CE_INTEGER_8_POINTER} uploadbuf.make
			create {CE_INTEGER_8_POINTER} location.make
			create {CE_INTEGER_8_POINTER} newurl.make
			create {CE_INTEGER_8_POINTER} upload_fromhere.make
		end

feature {ANY} -- fields

	size: INTEGER_64 assign set_size

	bytecountp: CE_POINTER [INTEGER_64] assign set_bytecountp

	maxdownload: INTEGER_64 assign set_maxdownload

	writebytecountp: CE_POINTER [INTEGER_64] assign set_writebytecountp

	bytecount: INTEGER_64 assign set_bytecount

	writebytecount: INTEGER_64 assign set_writebytecount

	headerbytecount: INTEGER_32 assign set_headerbytecount

	deductheadercount: INTEGER_32 assign set_deductheadercount

	start: SD_TIMEVAL assign set_start

	now: SD_TIMEVAL assign set_now

	header: BOOLEAN assign set_header

	badheader: NATURAL_32 assign set_badheader

	headerline: INTEGER_32 assign set_headerline

	hbufp: CE_POINTER [INTEGER_8] assign set_hbufp

	hbuflen: NATURAL_32 assign set_hbuflen

	str: CE_POINTER [INTEGER_8] assign set_str

	str_start: CE_POINTER [INTEGER_8] assign set_str_start

	end_ptr: CE_POINTER [INTEGER_8] assign set_end_ptr

	p: CE_POINTER [INTEGER_8] assign set_p

	content_range: BOOLEAN assign set_content_range

	offset: INTEGER_64 assign set_offset

	httpcode: INTEGER_32 assign set_httpcode

	start100: SD_TIMEVAL assign set_start100

	exp100: NATURAL_32 assign set_exp100

	content_encoding: INTEGER_32 assign set_content_encoding

	timeofdoc: INTEGER_32 assign set_timeofdoc

	bodywrites: INTEGER_32 assign set_bodywrites

	buf: CE_POINTER [INTEGER_8] assign set_buf

	uploadbuf: CE_POINTER [INTEGER_8] assign set_uploadbuf

	maxfd: INTEGER_32 assign set_maxfd

	keepon: INTEGER_32 assign set_keepon

	upload_done: BOOLEAN assign set_upload_done

	ignorebody: BOOLEAN assign set_ignorebody

	ignorecl: BOOLEAN assign set_ignorecl

	location: CE_POINTER [INTEGER_8] assign set_location

	newurl: CE_POINTER [INTEGER_8] assign set_newurl

	upload_present: INTEGER_32 assign set_upload_present

	upload_fromhere: CE_POINTER [INTEGER_8] assign set_upload_fromhere

	chunk: BOOLEAN assign set_chunk

	upload_chunky: BOOLEAN assign set_upload_chunky

	getheader: BOOLEAN assign set_getheader

	forbidchunk: BOOLEAN assign set_forbidchunk

feature {ANY} -- field setters

	set_size (a_size: INTEGER_64)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_bytecountp (a_bytecountp: CE_POINTER [INTEGER_64])
		do
			bytecountp := a_bytecountp
			update_memory_field ("bytecountp")
		end

	set_maxdownload (a_maxdownload: INTEGER_64)
		do
			maxdownload := a_maxdownload
			update_memory_field ("maxdownload")
		end

	set_writebytecountp (a_writebytecountp: CE_POINTER [INTEGER_64])
		do
			writebytecountp := a_writebytecountp
			update_memory_field ("writebytecountp")
		end

	set_bytecount (a_bytecount: INTEGER_64)
		do
			bytecount := a_bytecount
			update_memory_field ("bytecount")
		end

	set_writebytecount (a_writebytecount: INTEGER_64)
		do
			writebytecount := a_writebytecount
			update_memory_field ("writebytecount")
		end

	set_headerbytecount (a_headerbytecount: INTEGER_32)
		do
			headerbytecount := a_headerbytecount
			update_memory_field ("headerbytecount")
		end

	set_deductheadercount (a_deductheadercount: INTEGER_32)
		do
			deductheadercount := a_deductheadercount
			update_memory_field ("deductheadercount")
		end

	set_start (a_start: SD_TIMEVAL)
		do
			start := a_start
			update_memory_field ("start")
		end

	set_now (a_now: SD_TIMEVAL)
		do
			now := a_now
			update_memory_field ("now")
		end

	set_header (a_header: BOOLEAN)
		do
			header := a_header
			update_memory_field ("header")
		end

	set_badheader (a_badheader: NATURAL_32)
		do
			badheader := a_badheader
			update_memory_field ("badheader")
		end

	set_headerline (a_headerline: INTEGER_32)
		do
			headerline := a_headerline
			update_memory_field ("headerline")
		end

	set_hbufp (a_hbufp: CE_POINTER [INTEGER_8])
		do
			hbufp := a_hbufp
			update_memory_field ("hbufp")
		end

	set_hbuflen (a_hbuflen: NATURAL_32)
		do
			hbuflen := a_hbuflen
			update_memory_field ("hbuflen")
		end

	set_str (a_str: CE_POINTER [INTEGER_8])
		do
			str := a_str
			update_memory_field ("str")
		end

	set_str_start (a_str_start: CE_POINTER [INTEGER_8])
		do
			str_start := a_str_start
			update_memory_field ("str_start")
		end

	set_end_ptr (a_end_ptr: CE_POINTER [INTEGER_8])
		do
			end_ptr := a_end_ptr
			update_memory_field ("end_ptr")
		end

	set_p (a_p: CE_POINTER [INTEGER_8])
		do
			p := a_p
			update_memory_field ("p")
		end

	set_content_range (a_content_range: BOOLEAN)
		do
			content_range := a_content_range
			update_memory_field ("content_range")
		end

	set_offset (a_offset: INTEGER_64)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

	set_httpcode (a_httpcode: INTEGER_32)
		do
			httpcode := a_httpcode
			update_memory_field ("httpcode")
		end

	set_start100 (a_start100: SD_TIMEVAL)
		do
			start100 := a_start100
			update_memory_field ("start100")
		end

	set_exp100 (a_exp100: NATURAL_32)
		do
			exp100 := a_exp100
			update_memory_field ("exp100")
		end

	set_content_encoding (a_content_encoding: INTEGER_32)
		do
			content_encoding := a_content_encoding
			update_memory_field ("content_encoding")
		end

	set_timeofdoc (a_timeofdoc: INTEGER_32)
		do
			timeofdoc := a_timeofdoc
			update_memory_field ("timeofdoc")
		end

	set_bodywrites (a_bodywrites: INTEGER_32)
		do
			bodywrites := a_bodywrites
			update_memory_field ("bodywrites")
		end

	set_buf (a_buf: CE_POINTER [INTEGER_8])
		do
			buf := a_buf
			update_memory_field ("buf")
		end

	set_uploadbuf (a_uploadbuf: CE_POINTER [INTEGER_8])
		do
			uploadbuf := a_uploadbuf
			update_memory_field ("uploadbuf")
		end

	set_maxfd (a_maxfd: INTEGER_32)
		do
			maxfd := a_maxfd
			update_memory_field ("maxfd")
		end

	set_keepon (a_keepon: INTEGER_32)
		do
			keepon := a_keepon
			update_memory_field ("keepon")
		end

	set_upload_done (a_upload_done: BOOLEAN)
		do
			upload_done := a_upload_done
			update_memory_field ("upload_done")
		end

	set_ignorebody (a_ignorebody: BOOLEAN)
		do
			ignorebody := a_ignorebody
			update_memory_field ("ignorebody")
		end

	set_ignorecl (a_ignorecl: BOOLEAN)
		do
			ignorecl := a_ignorecl
			update_memory_field ("ignorecl")
		end

	set_location (a_location: CE_POINTER [INTEGER_8])
		do
			location := a_location
			update_memory_field ("location")
		end

	set_newurl (a_newurl: CE_POINTER [INTEGER_8])
		do
			newurl := a_newurl
			update_memory_field ("newurl")
		end

	set_upload_present (a_upload_present: INTEGER_32)
		do
			upload_present := a_upload_present
			update_memory_field ("upload_present")
		end

	set_upload_fromhere (a_upload_fromhere: CE_POINTER [INTEGER_8])
		do
			upload_fromhere := a_upload_fromhere
			update_memory_field ("upload_fromhere")
		end

	set_chunk (a_chunk: BOOLEAN)
		do
			chunk := a_chunk
			update_memory_field ("chunk")
		end

	set_upload_chunky (a_upload_chunky: BOOLEAN)
		do
			upload_chunky := a_upload_chunky
			update_memory_field ("upload_chunky")
		end

	set_getheader (a_getheader: BOOLEAN)
		do
			getheader := a_getheader
			update_memory_field ("getheader")
		end

	set_forbidchunk (a_forbidchunk: BOOLEAN)
		do
			forbidchunk := a_forbidchunk
			update_memory_field ("forbidchunk")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			bytecountp := a_other.bytecountp
			maxdownload := a_other.maxdownload
			writebytecountp := a_other.writebytecountp
			bytecount := a_other.bytecount
			writebytecount := a_other.writebytecount
			headerbytecount := a_other.headerbytecount
			deductheadercount := a_other.deductheadercount
			start := a_other.start.twin
			now := a_other.now.twin
			header := a_other.header
			badheader := a_other.badheader
			headerline := a_other.headerline
			hbufp := a_other.hbufp
			hbuflen := a_other.hbuflen
			str := a_other.str
			str_start := a_other.str_start
			end_ptr := a_other.end_ptr
			p := a_other.p
			content_range := a_other.content_range
			offset := a_other.offset
			httpcode := a_other.httpcode
			start100 := a_other.start100.twin
			exp100 := a_other.exp100
			content_encoding := a_other.content_encoding
			timeofdoc := a_other.timeofdoc
			bodywrites := a_other.bodywrites
			buf := a_other.buf
			uploadbuf := a_other.uploadbuf
			maxfd := a_other.maxfd
			keepon := a_other.keepon
			upload_done := a_other.upload_done
			ignorebody := a_other.ignorebody
			ignorecl := a_other.ignorecl
			location := a_other.location
			newurl := a_other.newurl
			upload_present := a_other.upload_present
			upload_fromhere := a_other.upload_fromhere
			chunk := a_other.chunk
			upload_chunky := a_other.upload_chunky
			getheader := a_other.getheader
			forbidchunk := a_other.forbidchunk
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				bytecountp.is_equal (a_other.bytecountp) and
				maxdownload = a_other.maxdownload and
				writebytecountp.is_equal (a_other.writebytecountp) and
				bytecount = a_other.bytecount and
				writebytecount = a_other.writebytecount and
				headerbytecount = a_other.headerbytecount and
				deductheadercount = a_other.deductheadercount and
				start.is_equal (a_other.start) and
				now.is_equal (a_other.now) and
				header = a_other.header and
				badheader = a_other.badheader and
				headerline = a_other.headerline and
				hbufp.is_equal (a_other.hbufp) and
				hbuflen = a_other.hbuflen and
				str.is_equal (a_other.str) and
				str_start.is_equal (a_other.str_start) and
				end_ptr.is_equal (a_other.end_ptr) and
				p.is_equal (a_other.p) and
				content_range = a_other.content_range and
				offset = a_other.offset and
				httpcode = a_other.httpcode and
				start100.is_equal (a_other.start100) and
				exp100 = a_other.exp100 and
				content_encoding = a_other.content_encoding and
				timeofdoc = a_other.timeofdoc and
				bodywrites = a_other.bodywrites and
				buf.is_equal (a_other.buf) and
				uploadbuf.is_equal (a_other.uploadbuf) and
				maxfd = a_other.maxfd and
				keepon = a_other.keepon and
				upload_done = a_other.upload_done and
				ignorebody = a_other.ignorebody and
				ignorecl = a_other.ignorecl and
				location.is_equal (a_other.location) and
				newurl.is_equal (a_other.newurl) and
				upload_present = a_other.upload_present and
				upload_fromhere.is_equal (a_other.upload_fromhere) and
				chunk = a_other.chunk and
				upload_chunky = a_other.upload_chunky and
				getheader = a_other.getheader and
				forbidchunk = a_other.forbidchunk
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("bytecountp"),
					create {CE_STRUCTURE_FIELD}.make ("maxdownload"),
					create {CE_STRUCTURE_FIELD}.make ("writebytecountp"),
					create {CE_STRUCTURE_FIELD}.make ("bytecount"),
					create {CE_STRUCTURE_FIELD}.make ("writebytecount"),
					create {CE_STRUCTURE_FIELD}.make ("headerbytecount"),
					create {CE_STRUCTURE_FIELD}.make ("deductheadercount"),
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("now"),
					create {CE_STRUCTURE_FIELD}.make ("header"),
					create {CE_STRUCTURE_FIELD}.make ("badheader"),
					create {CE_STRUCTURE_FIELD}.make ("headerline"),
					create {CE_STRUCTURE_FIELD}.make ("hbufp"),
					create {CE_STRUCTURE_FIELD}.make ("hbuflen"),
					create {CE_STRUCTURE_FIELD}.make ("str"),
					create {CE_STRUCTURE_FIELD}.make ("str_start"),
					create {CE_STRUCTURE_FIELD}.make ("end_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("content_range"),
					create {CE_STRUCTURE_FIELD}.make ("offset"),
					create {CE_STRUCTURE_FIELD}.make ("httpcode"),
					create {CE_STRUCTURE_FIELD}.make ("start100"),
					create {CE_STRUCTURE_FIELD}.make ("exp100"),
					create {CE_STRUCTURE_FIELD}.make ("content_encoding"),
					create {CE_STRUCTURE_FIELD}.make ("timeofdoc"),
					create {CE_STRUCTURE_FIELD}.make ("bodywrites"),
					create {CE_STRUCTURE_FIELD}.make ("buf"),
					create {CE_STRUCTURE_FIELD}.make ("uploadbuf"),
					create {CE_STRUCTURE_FIELD}.make ("maxfd"),
					create {CE_STRUCTURE_FIELD}.make ("keepon"),
					create {CE_STRUCTURE_FIELD}.make ("upload_done"),
					create {CE_STRUCTURE_FIELD}.make ("ignorebody"),
					create {CE_STRUCTURE_FIELD}.make ("ignorecl"),
					create {CE_STRUCTURE_FIELD}.make ("location"),
					create {CE_STRUCTURE_FIELD}.make ("newurl"),
					create {CE_STRUCTURE_FIELD}.make ("upload_present"),
					create {CE_STRUCTURE_FIELD}.make ("upload_fromhere"),
					create {CE_STRUCTURE_FIELD}.make ("chunk"),
					create {CE_STRUCTURE_FIELD}.make ("upload_chunky"),
					create {CE_STRUCTURE_FIELD}.make ("getheader"),
					create {CE_STRUCTURE_FIELD}.make ("forbidchunk")
				>>)
			init_structure_info
		end

end
