class
	PD_TELNET

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_32_ARRAY} us.make (<<256>>)
			create {CE_INTEGER_32_ARRAY} usq.make (<<256>>)
			create {CE_INTEGER_32_ARRAY} us_preferred.make (<<256>>)
			create {CE_INTEGER_32_ARRAY} him.make (<<256>>)
			create {CE_INTEGER_32_ARRAY} himq.make (<<256>>)
			create {CE_INTEGER_32_ARRAY} him_preferred.make (<<256>>)
			create {CE_INTEGER_8_ARRAY} subopt_ttype.make (<<32>>)
			create {CE_INTEGER_8_ARRAY} subopt_xdisploc.make (<<128>>)
			create {CE_CLASS_POINTER [PD_CURL_SLIST]} telnet_vars.make
			create {CE_NATURAL_8_ARRAY} subbuffer.make (<<512>>)
			create {CE_NATURAL_8_POINTER} subpointer.make
			create {CE_NATURAL_8_POINTER} subend.make
		end

feature {ANY} -- fields

	please_negotiate: INTEGER_32 assign set_please_negotiate

	already_negotiated: INTEGER_32 assign set_already_negotiated

	us: CE_ARRAY [INTEGER_32]

	usq: CE_ARRAY [INTEGER_32]

	us_preferred: CE_ARRAY [INTEGER_32]

	him: CE_ARRAY [INTEGER_32]

	himq: CE_ARRAY [INTEGER_32]

	him_preferred: CE_ARRAY [INTEGER_32]

	subopt_ttype: CE_ARRAY [INTEGER_8]

	subopt_xdisploc: CE_ARRAY [INTEGER_8]

	telnet_vars: CE_POINTER [PD_CURL_SLIST] assign set_telnet_vars

	subbuffer: CE_ARRAY [NATURAL_8]

	subpointer: CE_POINTER [NATURAL_8] assign set_subpointer

	subend: CE_POINTER [NATURAL_8] assign set_subend

	telrcv_state: NATURAL_32 assign set_telrcv_state

feature {ANY} -- field setters

	set_please_negotiate (a_please_negotiate: INTEGER_32)
		do
			please_negotiate := a_please_negotiate
			update_memory_field ("please_negotiate")
		end

	set_already_negotiated (a_already_negotiated: INTEGER_32)
		do
			already_negotiated := a_already_negotiated
			update_memory_field ("already_negotiated")
		end

	set_telnet_vars (a_telnet_vars: CE_POINTER [PD_CURL_SLIST])
		do
			telnet_vars := a_telnet_vars
			update_memory_field ("telnet_vars")
		end

	set_subpointer (a_subpointer: CE_POINTER [NATURAL_8])
		do
			subpointer := a_subpointer
			update_memory_field ("subpointer")
		end

	set_subend (a_subend: CE_POINTER [NATURAL_8])
		do
			subend := a_subend
			update_memory_field ("subend")
		end

	set_telrcv_state (a_telrcv_state: NATURAL_32)
		do
			telrcv_state := a_telrcv_state
			update_memory_field ("telrcv_state")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			please_negotiate := a_other.please_negotiate
			already_negotiated := a_other.already_negotiated
			us := a_other.us.twin
			usq := a_other.usq.twin
			us_preferred := a_other.us_preferred.twin
			him := a_other.him.twin
			himq := a_other.himq.twin
			him_preferred := a_other.him_preferred.twin
			subopt_ttype := a_other.subopt_ttype.twin
			subopt_xdisploc := a_other.subopt_xdisploc.twin
			telnet_vars := a_other.telnet_vars
			subbuffer := a_other.subbuffer.twin
			subpointer := a_other.subpointer
			subend := a_other.subend
			telrcv_state := a_other.telrcv_state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				please_negotiate = a_other.please_negotiate and
				already_negotiated = a_other.already_negotiated and
				us.is_equal (a_other.us) and
				usq.is_equal (a_other.usq) and
				us_preferred.is_equal (a_other.us_preferred) and
				him.is_equal (a_other.him) and
				himq.is_equal (a_other.himq) and
				him_preferred.is_equal (a_other.him_preferred) and
				subopt_ttype.is_equal (a_other.subopt_ttype) and
				subopt_xdisploc.is_equal (a_other.subopt_xdisploc) and
				telnet_vars.is_equal (a_other.telnet_vars) and
				subbuffer.is_equal (a_other.subbuffer) and
				subpointer.is_equal (a_other.subpointer) and
				subend.is_equal (a_other.subend) and
				telrcv_state = a_other.telrcv_state
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("please_negotiate"),
					create {CE_STRUCTURE_FIELD}.make ("already_negotiated"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("us", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("usq", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("us_preferred", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("him", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("himq", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("him_preferred", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("subopt_ttype", <<32>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("subopt_xdisploc", <<128>>),
					create {CE_STRUCTURE_FIELD}.make ("telnet_vars"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("subbuffer", <<512>>),
					create {CE_STRUCTURE_FIELD}.make ("subpointer"),
					create {CE_STRUCTURE_FIELD}.make ("subend"),
					create {CE_STRUCTURE_FIELD}.make ("telrcv_state")
				>>)
			init_structure_info
		end

end
