class
	SD_IFADDRS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [SD_IFADDRS]} ifa_next.make
			create {CE_INTEGER_8_POINTER} ifa_name.make
			create {CE_CLASS_POINTER [SD_SOCKADDR]} ifa_addr.make
			create {CE_CLASS_POINTER [SD_SOCKADDR]} ifa_netmask.make
			create ifa_ifu.make
			create {CE_VOID_POINTER} ifa_data.make
		end

feature {ANY} -- fields

	ifa_next: CE_POINTER [SD_IFADDRS] assign set_ifa_next

	ifa_name: CE_POINTER [INTEGER_8] assign set_ifa_name

	ifa_flags: NATURAL_32 assign set_ifa_flags

	ifa_addr: CE_POINTER [SD_SOCKADDR] assign set_ifa_addr

	ifa_netmask: CE_POINTER [SD_SOCKADDR] assign set_ifa_netmask

	ifa_ifu: SD_IFA_IFU assign set_ifa_ifu

	ifa_data: CE_POINTER [ANY] assign set_ifa_data

feature {ANY} -- field setters

	set_ifa_next (a_ifa_next: CE_POINTER [SD_IFADDRS])
		do
			ifa_next := a_ifa_next
			update_memory_field ("ifa_next")
		end

	set_ifa_name (a_ifa_name: CE_POINTER [INTEGER_8])
		do
			ifa_name := a_ifa_name
			update_memory_field ("ifa_name")
		end

	set_ifa_flags (a_ifa_flags: NATURAL_32)
		do
			ifa_flags := a_ifa_flags
			update_memory_field ("ifa_flags")
		end

	set_ifa_addr (a_ifa_addr: CE_POINTER [SD_SOCKADDR])
		do
			ifa_addr := a_ifa_addr
			update_memory_field ("ifa_addr")
		end

	set_ifa_netmask (a_ifa_netmask: CE_POINTER [SD_SOCKADDR])
		do
			ifa_netmask := a_ifa_netmask
			update_memory_field ("ifa_netmask")
		end

	set_ifa_ifu (a_ifa_ifu: SD_IFA_IFU)
		do
			ifa_ifu := a_ifa_ifu
			update_memory_field ("ifa_ifu")
		end

	set_ifa_data (a_ifa_data: CE_POINTER [ANY])
		do
			ifa_data := a_ifa_data
			update_memory_field ("ifa_data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ifa_next := a_other.ifa_next
			ifa_name := a_other.ifa_name
			ifa_flags := a_other.ifa_flags
			ifa_addr := a_other.ifa_addr
			ifa_netmask := a_other.ifa_netmask
			ifa_ifu := a_other.ifa_ifu.twin
			ifa_data := a_other.ifa_data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ifa_next.is_equal (a_other.ifa_next) and
				ifa_name.is_equal (a_other.ifa_name) and
				ifa_flags = a_other.ifa_flags and
				ifa_addr.is_equal (a_other.ifa_addr) and
				ifa_netmask.is_equal (a_other.ifa_netmask) and
				ifa_ifu.is_equal (a_other.ifa_ifu) and
				ifa_data.is_equal (a_other.ifa_data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ifa_next"),
					create {CE_STRUCTURE_FIELD}.make ("ifa_name"),
					create {CE_STRUCTURE_FIELD}.make ("ifa_flags"),
					create {CE_STRUCTURE_FIELD}.make ("ifa_addr"),
					create {CE_STRUCTURE_FIELD}.make ("ifa_netmask"),
					create {CE_STRUCTURE_FIELD}.make ("ifa_ifu"),
					create {CE_STRUCTURE_FIELD}.make ("ifa_data")
				>>)
			init_structure_info
		end

end
