class
	SD_SIGINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create sifields.make
		end

feature {ANY} -- fields

	si_signo: INTEGER_32 assign set_si_signo

	si_errno: INTEGER_32 assign set_si_errno

	si_code: INTEGER_32 assign set_si_code

	sifields: SD_SIFIELDS assign set_sifields

feature {ANY} -- field setters

	set_si_signo (a_si_signo: INTEGER_32)
		do
			si_signo := a_si_signo
			update_memory_field ("si_signo")
		end

	set_si_errno (a_si_errno: INTEGER_32)
		do
			si_errno := a_si_errno
			update_memory_field ("si_errno")
		end

	set_si_code (a_si_code: INTEGER_32)
		do
			si_code := a_si_code
			update_memory_field ("si_code")
		end

	set_sifields (a_sifields: SD_SIFIELDS)
		do
			sifields := a_sifields
			update_memory_field ("sifields")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_signo := a_other.si_signo
			si_errno := a_other.si_errno
			si_code := a_other.si_code
			sifields := a_other.sifields.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_signo = a_other.si_signo and
				si_errno = a_other.si_errno and
				si_code = a_other.si_code and
				sifields.is_equal (a_other.sifields)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_signo"),
					create {CE_STRUCTURE_FIELD}.make ("si_errno"),
					create {CE_STRUCTURE_FIELD}.make ("si_code"),
					create {CE_STRUCTURE_FIELD}.make ("sifields")
				>>)
			init_structure_info
		end

end
