class
	P_ASSERT_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gmp_assert_header (a_filename: CE_POINTER [INTEGER_8]; a_linenum: INTEGER_32)
		do
			if not a_filename.is_void then
				if (a_filename[0]).to_integer_32 /= 0 then
					Io.error.put_string (eif_string (a_filename) + ":")
					if a_linenum /= -1 then
						Io.error.put_string (a_linenum.out + ": ")
					end
				end
			end
		end

	gmp_assert_fail (a_filename: CE_POINTER [INTEGER_8]; a_linenum: INTEGER_32; a_expr: CE_POINTER [INTEGER_8])
		require
			not a_expr.is_void
		do
			gmp_assert_header (a_filename, a_linenum)
			Io.error.put_string ("GNU MP assertion failed: " + eif_string (a_expr) + "%N")
			abort
		end

end
