class
	P_CFDIV_R_2EXP_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpz_cfdiv_r_2exp (a_dir: INTEGER_32; a_w, a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		require
			not a_u.is_void
		local
			l_cnt: NATURAL_32
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_i: INTEGER_32
			l_up: CE_POINTER [NATURAL_32]
			l_wp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_high: NATURAL_32
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_tmp___2: CE_POINTER [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_wp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cnt := a_cnt
					l_usize := (a_u.item.mp_size).to_integer_32
					if l_usize = 0 then
						a_w.item.mp_size := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
						l_cnt := l_cnt \\ ({NATURAL_32} 32)
						if l_usize >= 0 then
							l_abs_usize := l_usize
						else
							l_abs_usize := -l_usize
						end
						l_up := a_u.item.mp_d
						if not (((l_usize).bit_xor (a_dir.to_integer_32)) < 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_w.is_equal (a_u) then
							if l_abs_usize <= l_limb_cnt then
								l_return := True
							end
							if not l_return then
								l_wp.item := a_w.item.mp_d
							end
						else
							if l_abs_usize < l_limb_cnt + 1 then
								l_i := l_abs_usize
							else
								l_i := l_limb_cnt + 1
							end
							if (builtin_expect ((l_i > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
								a_w.item.gmpz_realloc (l_i).do_nothing
							end
							l_wp.item := a_w.item.mp_d
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_wp.item, l_up, l_i)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							if l_abs_usize <= l_limb_cnt then
								a_w.item.mp_size := l_usize.to_integer_32
								l_return := True
							end
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 4 then -- else:
						if l_abs_usize <= l_limb_cnt then
							l_pos := -1 + 11 -- goto negate
						end
				when 5 then
						l_i := (0).to_integer_32
				when 6 then -- loop condition:
						if not (l_i < l_limb_cnt) then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						if l_up[l_i] /= {NATURAL_32} 0 then
							l_pos := -1 + 11 -- goto negate
						end
				when 8 then
						l_i := l_i + 1
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done
						if ((l_up[l_limb_cnt]).bit_and (((({NATURAL_32} 1).bit_shift_left (l_cnt.to_integer_32)) - {NATURAL_32} 1))) /= {NATURAL_32} 0 then
							l_pos := -1 + 11 -- goto negate
						end
				when 10 then
						a_w.item.mp_size := 0
						l_return := True
						if l_return then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | negate:
						if (builtin_expect ((l_limb_cnt + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							a_w.item.gmpz_realloc (l_limb_cnt + 1).do_nothing
						end
						l_up := a_u.item.mp_d
						l_wp.item := a_w.item.mp_d
						if l_abs_usize < l_limb_cnt + 1 then
							l_i := l_abs_usize
						else
							l_i := l_limb_cnt + 1
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___d := l_wp.item
							l___s := l_up
							l___n := l_i
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___1 := l___d
								l___d := l___d + 1
								l_tmp___2 := l___s
								l___s := l___s + 1
								l_tmp___1.item := (((l_tmp___2.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							not (l_i <= l_limb_cnt)
						loop
							l_wp.item[l_i] := {NATURAL_32} 4_294_967_295
							l_i := l_i + 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							asm9 (l___ptr_dummy, l_wp)
							l_break := True
						end
						l_break := False
						l_usize := -l_usize
				when 12 then -- if done | if done | if done
					if not l_return then
						l_high := l_wp.item[l_limb_cnt]
						l_high := (l_high).bit_and (((({NATURAL_32} 1).bit_shift_left (l_cnt.to_integer_32)) - {NATURAL_32} 1))
						l_wp.item[l_limb_cnt] := l_high
						from
						until
							not (not (l_return) and then (l_high = {NATURAL_32} 0))
						loop
							l_limb_cnt := l_limb_cnt - 1
							if l_limb_cnt < 0 then
								a_w.item.mp_size := 0
								l_return := True
							end
							if not l_return then
								l_high := l_wp.item[l_limb_cnt]
							end
						end
					end
					if not l_return then
						l_limb_cnt := l_limb_cnt + 1
						if l_usize >= 0 then
							a_w.item.mp_size := l_limb_cnt.to_integer_32
						else
							a_w.item.mp_size := (-l_limb_cnt).to_integer_32
						end
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_cdiv_r_2exp (a_w, a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		require
			not a_u.is_void
		do
			gmpz_cfdiv_r_2exp (1, a_w, a_u, a_cnt)
		end

end
