class
	P_PRINTFFUNS_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	gmp_fprintf_funs: CE_STATIC [CE_ARRAY [PD_DOPRNT_FUNS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_DOPRNT_FUNS_T]}.make_initialized (<<
					create {PD_DOPRNT_FUNS_T}.make_initialized ([(vfprintf_address), (gmp_fprintf_memory_address), (gmp_fprintf_reps_address), create {CE_ROUTINE}.make_shared (default_pointer)])
				>>)
		end

feature {ANY} -- public routines

	gmp_fprintf_memory (a_fp: CE_POINTER [SD_IO_FILE]; a_str: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		do
			Result := (fwrite (create {CE_VOID_POINTER}.make_cast (a_str), (1).to_natural_32, a_len, a_fp)).to_integer_32
		end

	gmp_fprintf_reps (a_fp: CE_POINTER [SD_IO_FILE]; a_c, a_reps: INTEGER_32): INTEGER_32
		local
			l_buf: CE_ARRAY [INTEGER_8]
			l_i: INTEGER_32
			l_piece: INTEGER_32
			l_ret: INTEGER_32
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_buf.make (<<256>>)

			if a_reps.to_natural_32 < ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32) then
				l_tmp := a_reps.to_natural_32
			else
				l_tmp := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32)
			end
			memset (create {CE_VOID_POINTER}.make_cast (l_buf), a_c, l_tmp).do_nothing
			l_i := a_reps
			from
			until
				not (not (l_return) and then (l_i > 0))
			loop
				if l_i.to_natural_32 < ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32) then
					l_piece := l_i
				else
					l_piece := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32).to_integer_32
				end
				l_ret := (fwrite (create {CE_VOID_POINTER}.make_cast (l_buf), (1).to_natural_32, l_piece.to_natural_32, a_fp)).to_integer_32
				if l_ret = -1 then
					Result := l_ret
					l_return := True
				end
				if not l_return then
					l_i := (l_i.to_natural_32 - ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32)).to_integer_32
				end
			end
			if not l_return then
				Result := a_reps
			end
		end

feature {ANY} -- routine addresses

	gmp_fprintf_memory_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gmp_fprintf_memory)
		end

	gmp_fprintf_reps_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gmp_fprintf_reps)
		end

end
