class
	P_SPRINTFFUNS_STATIC

inherit
	CE_UTILITIES
	S_STDIO_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	gmp_sprintf_funs: CE_STATIC [CE_ARRAY [PD_DOPRNT_FUNS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_DOPRNT_FUNS_T]}.make_initialized (<<
					create {PD_DOPRNT_FUNS_T}.make_initialized ([(gmp_sprintf_format_address), (gmp_sprintf_memory_address), (gmp_sprintf_reps_address), (gmp_sprintf_final_address)])
				>>)
		end

feature {ANY} -- public routines

	gmp_sprintf_format (a_bufp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_fmt: CE_POINTER [INTEGER_8]; a_ap: CE_VA_LIST): INTEGER_32
		require
			not a_bufp.is_void
		local
			l_ap: CE_VA_LIST
			l_buf: CE_POINTER [INTEGER_8]
			l_ret: INTEGER_32
		do
			l_ap := a_ap.twin
			l_buf := a_bufp.item
			vsprintf (l_buf, a_fmt, l_ap.twin).do_nothing
			l_ret := (strlen (l_buf)).to_integer_32
			a_bufp.item := l_buf + l_ret
			Result := l_ret
		end

	gmp_sprintf_memory (a_bufp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_str: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		require
			not a_bufp.is_void
		local
			l_buf: CE_POINTER [INTEGER_8]
		do
			l_buf := a_bufp.item
			a_bufp.item := l_buf + a_len.to_integer_32
			memcpy (create {CE_VOID_POINTER}.make_cast (l_buf), create {CE_VOID_POINTER}.make_cast (a_str), a_len).do_nothing
			Result := a_len.to_integer_32
		end

	gmp_sprintf_reps (a_bufp: CE_POINTER [CE_POINTER [INTEGER_8]]; a_c, a_reps: INTEGER_32): INTEGER_32
		require
			not a_bufp.is_void
		local
			l_buf: CE_POINTER [INTEGER_8]
		do
			l_buf := a_bufp.item
			a_bufp.item := l_buf + a_reps
			memset (create {CE_VOID_POINTER}.make_cast (l_buf), a_c, a_reps.to_natural_32).do_nothing
			Result := a_reps
		end

	gmp_sprintf_final (a_bufp: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_bufp.is_void
		local
			l_buf: CE_POINTER [INTEGER_8]
		do
			l_buf := a_bufp.item
			l_buf[0] := (('%/0/').code).to_integer_8
			Result := 0
		end

feature {ANY} -- routine addresses

	gmp_sprintf_format_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gmp_sprintf_format)
		end

	gmp_sprintf_memory_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gmp_sprintf_memory)
		end

	gmp_sprintf_reps_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gmp_sprintf_reps)
		end

	gmp_sprintf_final_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gmp_sprintf_final)
		end

end
