class
	P_SQRMOD_BNM1_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	mpn_bc_sqrmod_bnm1 (a_rp, a_ap: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_rp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			l_rp.item := a_rp;
			(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_ap, a_rn)
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_rp.item, a_tp, (a_tp + a_rn), a_rn)
			from
			until
				(l_break)
			loop
				l_break := False
				asm232 (l___ptr_dummy, l_rp, l_cy)
				l_break := True
			end
			l_break := False
		end

	mpn_bc_sqrmod_bnp1 (a_rp, a_ap: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_tp.is_void
		local
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_rp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)

			l_rp.item := a_rp;
			(create {P_SQR_STATIC}).gmpn_sqr (a_tp, a_ap, a_rn + 1)
			l_cy.item := a_tp[2 * a_rn] + ((create {P_GMP_STATIC}).gmpn_sub_n (l_rp.item, a_tp, (a_tp + a_rn), a_rn))
			l_rp.item[a_rn] := (0).to_natural_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm233 (l___ptr_dummy, l_rp, l_cy)
				l_break := True
			end
			l_break := False
		end

	gmpn_sqrmod_bnm1 (a_rp: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_tp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_cy___0: CE_ARRAY [NATURAL_32]
			l_hi: NATURAL_32
			l_am1: CE_POINTER [NATURAL_32]
			l_anm: INTEGER_32
			l_so: CE_POINTER [NATURAL_32]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_k: INTEGER_32
			l_ap1: CE_POINTER [NATURAL_32]
			l_anp: INTEGER_32
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_mask: INTEGER_32
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_tp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_rp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___4.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tp.item := a_tp
					l_rp.item := a_rp
					if ((a_rn).bit_and (1)) = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if 18 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_rn >= 18 then
							l_n.item := (a_rn).bit_shift_right (1)
							if (builtin_expect ((a_an > l_n.item).to_integer, 1)).to_boolean then
								l_so := l_tp.item + l_n.item
								l_am1 := l_tp.item
								l_cy___0.item := (create {P_GMP_STATIC}).gmpn_add (l_tp.item, a_ap, l_n.item, a_ap + l_n.item, a_an - l_n.item)
								from
								until
									(l_break)
								loop
									l_break := False
									asm234 (l___ptr_dummy___0, l_tp, l_cy___0)
									l_break := True
								end
								l_break := False
								l_anm := l_n.item
							else
								l_so := l_tp.item
								l_am1 := a_ap
								l_anm := a_an
							end
							gmpn_sqrmod_bnm1 (l_rp.item, l_n.item, l_am1, l_anm, l_so)
							if (builtin_expect ((a_an > l_n.item).to_integer, 1)).to_boolean then
								l_ap1 := ((l_tp.item + 2 * l_n.item) + 2)
								l_cy___0.item := (create {P_GMP_STATIC}).gmpn_sub ((l_tp.item + 2 * l_n.item) + 2, a_ap, l_n.item, a_ap + l_n.item, a_an - l_n.item);
								((l_tp.item + 2 * l_n.item) + 2)[l_n.item] := (0).to_natural_32
								from
								until
									(l_break)
								loop
									l_break := False
									asm235 (l___ptr_dummy___1, l_tp, l_n, l_cy___0)
									l_break := True
								end
								l_break := False
								l_anp := ((l_n.item).to_natural_32 + l_ap1[l_n.item]).to_integer_32
							else
								l_ap1 := a_ap
								l_anp := a_an
							end
							if 565 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_n.item >= 565 then
									l_k := (create {P_MUL_FFT_STATIC}).gmpn_fft_best_k (l_n.item, 1)
									l_mask := ((1).bit_shift_left (l_k)) - 1
									from
									until
										not (((l_n.item).bit_and (l_mask.to_integer_32)).to_boolean)
									loop
										l_k := l_k - 1
										l_mask := (l_mask).bit_shift_right ((1))
									end
								else
									l_k := 0
								end
							else
								l_k := 0
							end
							if l_k >= 4 then
								l_tp.item[l_n.item] := (create {P_MUL_FFT_STATIC}).gmpn_mul_fft (l_tp.item, l_n.item, l_ap1, l_anp, l_ap1, l_anp, l_k)
							elseif (builtin_expect ((l_ap1.is_equal (a_ap)).to_integer, 0)).to_boolean then
								(create {P_SQR_STATIC}).gmpn_sqr (l_tp.item, a_ap, a_an)
								l_anp := 2 * a_an - l_n.item
								l_cy___0.item := (create {P_GMP_STATIC}).gmpn_sub (l_tp.item, l_tp.item, l_n.item, (l_tp.item + l_n.item), l_anp)
								l_tp.item[l_n.item] := (0).to_natural_32
								from
								until
									(l_break)
								loop
									l_break := False
									asm236 (l___ptr_dummy___2, l_tp, l_cy___0)
									l_break := True
								end
								l_break := False
							else
								mpn_bc_sqrmod_bnp1 (l_tp.item, l_ap1, l_n.item, l_tp.item)
							end
							l_cy___0.item := (create {P_GMP_IMPL_STATIC}).gmpn_add_nc (l_rp.item, l_rp.item, l_tp.item, l_n.item, l_tp.item[l_n.item])
							l_cy___0.item := l_cy___0.item + ((l_rp.item[0]).bit_and ({NATURAL_32} 1));
							(create {P_GMP_STATIC}).gmpn_rshift (l_rp.item, l_rp.item, l_n.item, {NATURAL_32} 1).do_nothing
							l_hi := (((l_cy___0.item).bit_shift_left (31))).bit_and ({NATURAL_32} 4_294_967_295)
							l_cy___0.item := (l_cy___0.item).bit_shift_right ((1))
							l_rp.item[(l_n.item - 1)] := (l_rp.item[(l_n.item - 1)]).bit_or (l_hi)
							from
							until
								(l_break)
							loop
								l_break := False
								asm237 (l___ptr_dummy___3, l_rp, l_cy___0)
								l_break := True
							end
							l_break := False
							if (builtin_expect ((2 * a_an < a_rn).to_integer, 0)).to_boolean then
								l_cy___0.item := (create {P_GMP_STATIC}).gmpn_sub_n (l_rp.item + l_n.item, l_rp.item, l_tp.item, 2 * a_an - l_n.item)
								l_cy___0.item := l_tp.item[l_n.item] + ((create {P_GMP_IMPL_STATIC}).gmpn_sub_nc ((l_tp.item + 2 * a_an) - l_n.item, ((l_rp.item + 2 * a_an) - l_n.item), ((l_tp.item + 2 * a_an) - l_n.item), a_rn - 2 * a_an, l_cy___0.item))
								l_cy___0.item := (create {P_GMP_STATIC}).gmpn_sub_1 (l_rp.item, l_rp.item, 2 * a_an, l_cy___0.item)
							else
								l_cy___0.item := l_tp.item[l_n.item] + ((create {P_GMP_STATIC}).gmpn_sub_n (l_rp.item + l_n.item, l_rp.item, l_tp.item, l_n.item))
								from
								until
									(l_break)
								loop
									l_break := False
									asm238 (l___ptr_dummy___4, l_rp, l_cy___0)
									l_break := True
								end
								l_break := False
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if (builtin_expect ((a_an < a_rn).to_integer, 0)).to_boolean then
							if (builtin_expect ((2 * a_an <= a_rn).to_integer, 0)).to_boolean then
								(create {P_SQR_STATIC}).gmpn_sqr (l_rp.item, a_ap, a_an)
							else
								(create {P_SQR_STATIC}).gmpn_sqr (l_tp.item, a_ap, a_an)
								l_cy.item := (create {P_GMP_STATIC}).gmpn_add (l_rp.item, l_tp.item, a_rn, (l_tp.item + a_rn), 2 * a_an - a_rn)
								from
								until
									(l_break)
								loop
									l_break := False
									asm239 (l___ptr_dummy, l_rp, l_cy)
									l_break := True
								end
								l_break := False
							end
						else
							mpn_bc_sqrmod_bnm1 (l_rp.item, a_ap, a_rn, l_tp.item)
						end
				when 7 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_sqrmod_bnm1_next_size (a_n: INTEGER_32): INTEGER_32
		local
			l_nh: INTEGER_32
			l_return: BOOLEAN
		do
			if 18 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if not (a_n >= 18) then
					Result := a_n
					l_return := True
				end
			else
				Result := a_n
				l_return := True
			end
			if not l_return then
				if 69 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (a_n >= 69) then
						Result := (((a_n + 1)).bit_and (-2))
						l_return := True
					end
				else
					Result := (((a_n + 1)).bit_and (-2))
					l_return := True
				end
			end
			if not l_return then
				if 137 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (a_n >= 137) then
						Result := (((a_n + 3)).bit_and (-4))
						l_return := True
					end
				else
					Result := (((a_n + 3)).bit_and (-4))
					l_return := True
				end
			end
			if not l_return then
				l_nh := ((a_n + 1)).bit_shift_right (1)
				if 472 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_nh >= 472) then
						Result := (((a_n + 7)).bit_and (-8))
						l_return := True
					end
				else
					Result := (((a_n + 7)).bit_and (-8))
					l_return := True
				end
			end
			if not l_return then
				Result := (2 * ((create {P_MUL_FFT_STATIC}).gmpn_fft_next_size (l_nh, ((create {P_MUL_FFT_STATIC}).gmpn_fft_best_k (l_nh, 1)))))
			end
		end

end
