class
	PD_BASES

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	chars_per_limb: INTEGER_32 assign set_chars_per_limb

	chars_per_bit_exactly: REAL_64 assign set_chars_per_bit_exactly

	big_base: NATURAL_32 assign set_big_base

	big_base_inverted: NATURAL_32 assign set_big_base_inverted

feature {ANY} -- field setters

	set_chars_per_limb (a_chars_per_limb: INTEGER_32)
		do
			chars_per_limb := a_chars_per_limb
			update_memory_field ("chars_per_limb")
		end

	set_chars_per_bit_exactly (a_chars_per_bit_exactly: REAL_64)
		do
			chars_per_bit_exactly := a_chars_per_bit_exactly
			update_memory_field ("chars_per_bit_exactly")
		end

	set_big_base (a_big_base: NATURAL_32)
		do
			big_base := a_big_base
			update_memory_field ("big_base")
		end

	set_big_base_inverted (a_big_base_inverted: NATURAL_32)
		do
			big_base_inverted := a_big_base_inverted
			update_memory_field ("big_base_inverted")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			chars_per_limb := a_other.chars_per_limb
			chars_per_bit_exactly := a_other.chars_per_bit_exactly
			big_base := a_other.big_base
			big_base_inverted := a_other.big_base_inverted
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				chars_per_limb = a_other.chars_per_limb and
				chars_per_bit_exactly = a_other.chars_per_bit_exactly and
				big_base = a_other.big_base and
				big_base_inverted = a_other.big_base_inverted
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("chars_per_limb"),
					create {CE_STRUCTURE_FIELD}.make ("chars_per_bit_exactly"),
					create {CE_STRUCTURE_FIELD}.make ("big_base"),
					create {CE_STRUCTURE_FIELD}.make ("big_base_inverted")
				>>)
			init_structure_info
		end

end
