class
	PD_MPQ_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_GCC_BUILTIN_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create mp_num.make
			create mp_den.make
			Precursor
		end

feature {ANY} -- fields

	mp_num: PD_MPZ_STRUCT assign set_mp_num

	mp_den: PD_MPZ_STRUCT assign set_mp_den

feature {ANY} -- field setters

	set_mp_num (a_mp_num: PD_MPZ_STRUCT)
		do
			mp_num := a_mp_num
			update_memory_field ("mp_num")
		end

	set_mp_den (a_mp_den: PD_MPZ_STRUCT)
		do
			mp_den := a_mp_den
			update_memory_field ("mp_den")
		end

feature {ANY} -- public routines

	gmpq_abs (a_src: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_src.is_void
		local
			l_num_size: INTEGER_32
			l_num_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_den_size: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_num_size := (a_src.item.mp_num.mp_size).to_integer_32
			if l_num_size >= 0 then
				l_tmp := l_num_size
			else
				l_tmp := -l_num_size
			end
			l_num_abs_size := l_tmp
			if not (c_pointer = (a_src).c_pointer) then
				l_den_size := (a_src.item.mp_den.mp_size).to_integer_32
				l_tmp___0 := builtin_expect ((l_num_abs_size > (mp_num.mp_alloc).to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_num_abs_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_tmp___1 := builtin_expect ((l_den_size > (mp_den.mp_alloc).to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_realloc (l_den_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (mp_num.mp_d, a_src.item.mp_num.mp_d, l_num_abs_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (mp_den.mp_d, a_src.item.mp_den.mp_d, l_den_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				mp_den.mp_size := l_den_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			mp_num.mp_size := l_num_abs_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_canonicalize
		local
			l_gcd: CE_ARRAY [PD_MPZ_STRUCT]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: CE_POINTER [ANY]
			l_tmp___30: CE_POINTER [ANY]
			l_tmp___33: INTEGER_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_tmp___37: INTEGER_32
			l_tmp___38: INTEGER_32
			l_tmp___39: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gcd.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			if mp_den.mp_size = 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l___x := l_gcd
				if mp_num.mp_size >= 0 then
					l_tmp___4 := mp_num.mp_size
				else
					l_tmp___4 := -mp_num.mp_size
				end
				if mp_den.mp_size >= 0 then
					l_tmp___5 := mp_den.mp_size
				else
					l_tmp___5 := -mp_den.mp_size
				end
				if l_tmp___4 > l_tmp___5 then
					if mp_num.mp_size >= 0 then
						l_tmp___1 := mp_num.mp_size
					else
						l_tmp___1 := -mp_num.mp_size
					end
					l_tmp___3 := l_tmp___1
				else
					if mp_den.mp_size >= 0 then
						l_tmp___2 := mp_den.mp_size
					else
						l_tmp___2 := -mp_den.mp_size
					end
					l_tmp___3 := l_tmp___2
				end
				l___x.item.mp_alloc := 1 + l_tmp___3
				update_class_fields -- Current might have been changed; synchronize
				if mp_num.mp_size >= 0 then
					l_tmp___36 := mp_num.mp_size
				else
					l_tmp___36 := -mp_num.mp_size
				end
				if mp_den.mp_size >= 0 then
					l_tmp___37 := mp_den.mp_size
				else
					l_tmp___37 := -mp_den.mp_size
				end
				if l_tmp___36 > l_tmp___37 then
					if mp_num.mp_size >= 0 then
						l_tmp___33 := mp_num.mp_size
					else
						l_tmp___33 := -mp_num.mp_size
					end
					l_tmp___35 := l_tmp___33
				else
					if mp_den.mp_size >= 0 then
						l_tmp___34 := mp_den.mp_size
					else
						l_tmp___34 := -mp_den.mp_size
					end
					l_tmp___35 := l_tmp___34
				end
				l_tmp___38 := builtin_expect (((1 + l_tmp___35).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___38.to_boolean then
					if mp_num.mp_size >= 0 then
						l_tmp___19 := mp_num.mp_size
					else
						l_tmp___19 := -mp_num.mp_size
					end
					if mp_den.mp_size >= 0 then
						l_tmp___20 := mp_den.mp_size
					else
						l_tmp___20 := -mp_den.mp_size
					end
					if l_tmp___19 > l_tmp___20 then
						if mp_num.mp_size >= 0 then
							l_tmp___16 := mp_num.mp_size
						else
							l_tmp___16 := -mp_num.mp_size
						end
						l_tmp___18 := l_tmp___16
					else
						if mp_den.mp_size >= 0 then
							l_tmp___17 := mp_den.mp_size
						else
							l_tmp___17 := -mp_den.mp_size
						end
						l_tmp___18 := l_tmp___17
					end
					l_tmp___30 := (l_aaf.new ((1 + l_tmp___18).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				else
					if mp_num.mp_size >= 0 then
						l_tmp___27 := mp_num.mp_size
					else
						l_tmp___27 := -mp_num.mp_size
					end
					if mp_den.mp_size >= 0 then
						l_tmp___28 := mp_den.mp_size
					else
						l_tmp___28 := -mp_den.mp_size
					end
					if l_tmp___27 > l_tmp___28 then
						if mp_num.mp_size >= 0 then
							l_tmp___24 := mp_num.mp_size
						else
							l_tmp___24 := -mp_num.mp_size
						end
						l_tmp___26 := l_tmp___24
					else
						if mp_den.mp_size >= 0 then
							l_tmp___25 := mp_den.mp_size
						else
							l_tmp___25 := -mp_den.mp_size
						end
						l_tmp___26 := l_tmp___25
					end
					l_tmp___29 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (1 + l_tmp___26).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___30 := l_tmp___29
				end
				l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___30)
				update_class_fields -- Current might have been changed; synchronize
				l_break := True
			end
			l_break := False
			l_gcd.item.gmpz_gcd ((create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))), (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))))
			update_class_fields -- Current might have been changed; synchronize
			if l_gcd[0].mp_size = 1 then
				if l_gcd[0].mp_d[0] /= {NATURAL_32} 1 then
					(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
				update_class_fields -- Current might have been changed; synchronize
			end
			if mp_den.mp_size < 0 then
				mp_num.mp_size := -mp_num.mp_size
				update_class_fields -- Current might have been changed; synchronize
				mp_den.mp_size := -mp_den.mp_size
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp___39 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___39.to_boolean then
					(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_break := True
			end
			l_break := False
		end

	gmpq_clear
		do
			(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (mp_num.mp_d), (mp_num.mp_alloc * 4).to_natural_32])
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (mp_den.mp_d), (mp_den.mp_alloc * 4).to_natural_32])
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_cmp (a_op2: CE_POINTER [PD_MPQ_STRUCT]): INTEGER_32
		require
			not a_op2.is_void
		local
			l_num1_size: INTEGER_32
			l_den1_size: INTEGER_32
			l_num2_size: INTEGER_32
			l_den2_size: INTEGER_32
			l_tmp1_size: INTEGER_32
			l_tmp2_size: INTEGER_32
			l_tmp1_ptr: CE_POINTER [NATURAL_32]
			l_tmp2_ptr: CE_POINTER [NATURAL_32]
			l_num1_sign: INTEGER_32
			l_cc: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_cnt1: INTEGER_32
			l_cnt2: INTEGER_32
			l_bits1: NATURAL_32
			l_bits2: NATURAL_32
			l_tmp___11: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: INTEGER_32
			l_tmp___14: NATURAL_32
			l_tmp___15: NATURAL_32
			l_tmp___16: NATURAL_32
			l_tmp___17: NATURAL_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_num1_size := (mp_num.mp_size).to_integer_32
			l_den1_size := (mp_den.mp_size).to_integer_32
			l_num2_size := (a_op2.item.mp_num.mp_size).to_integer_32
			l_den2_size := (a_op2.item.mp_den.mp_size).to_integer_32
			if l_num1_size = 0 then
				Result := (-l_num2_size).to_integer_32
				l_return := True
			end
			if not l_return and then (l_num2_size = 0) then
				Result := l_num1_size.to_integer_32
				l_return := True
			end
			if not l_return and then (((l_num1_size).bit_xor (l_num2_size)) < 0) then
				Result := l_num1_size.to_integer_32
				l_return := True
			end
			if not l_return then
				l_num1_sign := l_num1_size
				if l_num1_size >= 0 then
					l_num1_size := l_num1_size
				else
					l_num1_size := -l_num1_size
				end
				if l_num2_size >= 0 then
					l_num2_size := l_num2_size
				else
					l_num2_size := -l_num2_size
				end
				l_tmp1_size := l_num1_size + l_den2_size
				l_tmp2_size := l_num2_size + l_den1_size
				if l_tmp1_size > l_tmp2_size + 1 then
					Result := l_num1_sign.to_integer_32
					l_return := True
				end
			end
			if not l_return and then (l_tmp2_size > l_tmp1_size + 1) then
				Result := (-l_num1_sign).to_integer_32
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt1 := builtin_clzl (mp_num.mp_d[(l_num1_size - 1)])
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt2 := builtin_clzl (a_op2.item.mp_den.mp_d[(l_den2_size - 1)])
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_bits1 := ((l_tmp1_size * 32 - l_cnt1.to_integer_32) - l_cnt2.to_integer_32).to_natural_32
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt1 := builtin_clzl (a_op2.item.mp_num.mp_d[(l_num2_size - 1)])
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt2 := builtin_clzl (mp_den.mp_d[(l_den1_size - 1)])
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_bits2 := ((l_tmp2_size * 32 - l_cnt1.to_integer_32) - l_cnt2.to_integer_32).to_natural_32
				if l_bits1 > l_bits2 + {NATURAL_32} 1 then
					Result := l_num1_sign.to_integer_32
					l_return := True
				end
			end
			if not l_return and then (l_bits2 > l_bits1 + {NATURAL_32} 1) then
				Result := (-l_num1_sign).to_integer_32
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___13 := builtin_expect (((l_tmp1_size + l_tmp2_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___13.to_boolean then
						l_tmp___12 := (l_aaf.new (((l_tmp1_size + l_tmp2_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___11 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_tmp1_size + l_tmp2_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___12 := l_tmp___11
					end
					l_tmp1_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___12)
					l_tmp2_ptr := l_tmp1_ptr + l_tmp1_size
					l_break := True
				end
				l_break := False
				if l_num1_size >= l_den2_size then
					l_tmp___14 := (create {P_MUL_STATIC}).gmpn_mul (l_tmp1_ptr, mp_num.mp_d, l_num1_size, a_op2.item.mp_den.mp_d, l_den2_size)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp1_size := l_tmp1_size - ({NATURAL_32} 0 = l_tmp___14).to_integer
				else
					l_tmp___15 := (create {P_MUL_STATIC}).gmpn_mul (l_tmp1_ptr, a_op2.item.mp_den.mp_d, l_den2_size, mp_num.mp_d, l_num1_size)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp1_size := l_tmp1_size - ({NATURAL_32} 0 = l_tmp___15).to_integer
				end
				if l_num2_size >= l_den1_size then
					l_tmp___16 := (create {P_MUL_STATIC}).gmpn_mul (l_tmp2_ptr, a_op2.item.mp_num.mp_d, l_num2_size, mp_den.mp_d, l_den1_size)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp2_size := l_tmp2_size - ({NATURAL_32} 0 = l_tmp___16).to_integer
				else
					l_tmp___17 := (create {P_MUL_STATIC}).gmpn_mul (l_tmp2_ptr, mp_den.mp_d, l_den1_size, a_op2.item.mp_num.mp_d, l_num2_size)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp2_size := l_tmp2_size - ({NATURAL_32} 0 = l_tmp___17).to_integer
				end
				if l_tmp1_size - l_tmp2_size /= 0 then
					l_cc := (l_tmp1_size - l_tmp2_size).to_integer_32
				else
					l_tmp___18 := (create {P_GMP_STATIC}).gmpn_cmp (l_tmp1_ptr, l_tmp2_ptr, l_tmp1_size)
					update_class_fields -- Current might have been changed; synchronize
					l_cc := l_tmp___18
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___19 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___19.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				if l_num1_sign < 0 then
					l_tmp___20 := -l_cc
				else
					l_tmp___20 := l_cc
				end
				Result := l_tmp___20
			end
		end

	gmpq_cmp_si (a_n: INTEGER_32; a_d: NATURAL_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_qabs: CE_ARRAY [PD_MPQ_STRUCT]
			l_tmp___0: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_MPQ_STRUCT]} l_qabs.make (<<1>>)

			if mp_num.mp_size >= 0 then
				if a_n >= 0 then
					l_tmp := ((create {CE_CLASS_POINTER [PD_MPQ_STRUCT]}.make_shared (c_pointer))).item.gmpq_cmp_ui (a_n.to_natural_32, a_d)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_tmp
				else
					Result := 1
				end
			elseif a_n >= 0 then
				Result := (-1)
			else
				if mp_num.mp_size >= 0 then
					l_qabs[0].mp_num.mp_size := mp_num.mp_size
					update_class_fields -- Current might have been changed; synchronize
				else
					l_qabs[0].mp_num.mp_size := (-mp_num.mp_size)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_qabs[0].mp_num.mp_d := mp_num.mp_d
				update_class_fields -- Current might have been changed; synchronize
				l_qabs[0].mp_den.mp_size := mp_den.mp_size
				update_class_fields -- Current might have been changed; synchronize
				l_qabs[0].mp_den.mp_d := mp_den.mp_d
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := (create {CE_CLASS_POINTER [PD_MPQ_STRUCT]}.make_cast (l_qabs)).item.gmpq_cmp_ui ((-a_n).to_natural_32, a_d)
				update_class_fields -- Current might have been changed; synchronize
				Result := (-l_tmp___0)
			end
		end

	gmpq_cmp_ui (a_num2, a_den2: NATURAL_32): INTEGER_32
		local
			l_num1_size: INTEGER_32
			l_den1_size: INTEGER_32
			l_tmp1_size: INTEGER_32
			l_tmp2_size: INTEGER_32
			l_tmp1_ptr: CE_POINTER [NATURAL_32]
			l_tmp2_ptr: CE_POINTER [NATURAL_32]
			l_cy_limb: NATURAL_32
			l_cc: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_num1_size := (mp_num.mp_size).to_integer_32
			l_den1_size := (mp_den.mp_size).to_integer_32
			if a_den2 = {NATURAL_32} 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_num1_size = 0 then
				Result := (-(a_num2 /= {NATURAL_32} 0).to_integer).to_integer
				l_return := True
			end
			if not l_return and then (l_num1_size < 0) then
				Result := l_num1_size.to_integer_32
				l_return := True
			end
			if not l_return and then (a_num2 = {NATURAL_32} 0) then
				Result := l_num1_size.to_integer_32
				l_return := True
			end
			if not l_return and then (l_num1_size > l_den1_size + 1) then
				Result := l_num1_size.to_integer_32
				l_return := True
			end
			if not l_return and then (l_den1_size > l_num1_size + 1) then
				Result := (-l_num1_size).to_integer_32
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := builtin_expect (((l_num1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___3.to_boolean then
					l_tmp___2 := (l_aaf.new (((l_num1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_num1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := l_tmp___1
				end
				l_tmp1_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
				l_tmp___8 := builtin_expect (((l_den1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___8.to_boolean then
					l_tmp___7 := (l_aaf.new (((l_den1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___6 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_den1_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___7 := l_tmp___6
				end
				l_tmp2_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
				l_cy_limb := (create {P_GMP_STATIC}).gmpn_mul_1 (l_tmp1_ptr, mp_num.mp_d, l_num1_size, a_den2)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp1_ptr[l_num1_size] := l_cy_limb
				update_class_fields -- Current might have been changed; synchronize
				l_tmp1_size := l_num1_size + (l_cy_limb /= {NATURAL_32} 0).to_integer
				l_cy_limb := (create {P_GMP_STATIC}).gmpn_mul_1 (l_tmp2_ptr, mp_den.mp_d, l_den1_size, a_num2)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp2_ptr[l_den1_size] := l_cy_limb
				update_class_fields -- Current might have been changed; synchronize
				l_tmp2_size := l_den1_size + (l_cy_limb /= {NATURAL_32} 0).to_integer
				if l_tmp1_size - l_tmp2_size /= 0 then
					l_cc := (l_tmp1_size - l_tmp2_size).to_integer_32
				else
					l_tmp___9 := (create {P_GMP_STATIC}).gmpn_cmp (l_tmp1_ptr, l_tmp2_ptr, l_tmp1_size)
					update_class_fields -- Current might have been changed; synchronize
					l_cc := l_tmp___9
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___10 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___10.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				Result := l_cc
			end
		end

	gmpq_div (a_op1, a_op2: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_op1.is_void
			not a_op2.is_void
		local
			l_gcd1: CE_ARRAY [PD_MPZ_STRUCT]
			l_gcd2: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp1: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp2: CE_ARRAY [PD_MPZ_STRUCT]
			l_numtmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_op1_num_size: INTEGER_32
			l_op1_den_size: INTEGER_32
			l_op2_num_size: INTEGER_32
			l_op2_den_size: INTEGER_32
			l_alloc: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___3: INTEGER_32
			l___x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___6: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l___x___1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___11: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___13: INTEGER_32
			l___x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___16: CE_POINTER [ANY]
			l_tmp___17: CE_POINTER [ANY]
			l_tmp___18: INTEGER_32
			l___x___3: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___21: CE_POINTER [ANY]
			l_tmp___22: CE_POINTER [ANY]
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gcd1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gcd2.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_tmp1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_tmp2.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_numtmp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			if a_op1.item.mp_num.mp_size >= 0 then
				l_op1_num_size := (a_op1.item.mp_num.mp_size).to_integer_32
			else
				l_op1_num_size := (-a_op1.item.mp_num.mp_size).to_integer_32
			end
			l_op1_den_size := (a_op1.item.mp_den.mp_size).to_integer_32
			if a_op2.item.mp_num.mp_size >= 0 then
				l_op2_num_size := (a_op2.item.mp_num.mp_size).to_integer_32
			else
				l_op2_num_size := (-a_op2.item.mp_num.mp_size).to_integer_32
			end
			l_op2_den_size := (a_op2.item.mp_den.mp_size).to_integer_32
			if l_op2_num_size = 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_op1_num_size = 0 then
				mp_num.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				mp_den.mp_d[0] := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				mp_den.mp_size := 1
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				if l_op1_num_size < l_op2_num_size then
					l_alloc := l_op1_num_size
				else
					l_alloc := l_op2_num_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x := l_gcd1
					l___x.item.mp_alloc := l_alloc.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___3 := builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___3.to_boolean then
						l_tmp___2 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___1 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := l_tmp___1
					end
					l___x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___2)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				if l_op1_den_size < l_op2_den_size then
					l_alloc := l_op1_den_size
				else
					l_alloc := l_op2_den_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___0 := l_gcd2
					l___x___0.item.mp_alloc := l_alloc.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___8 := builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___8.to_boolean then
						l_tmp___7 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___6 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___7 := l_tmp___6
					end
					l___x___0.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___7)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				if l_op1_num_size > l_op2_num_size then
					l_alloc := l_op1_num_size
				else
					l_alloc := l_op2_num_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___1 := l_tmp1
					l___x___1.item.mp_alloc := l_alloc.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___13 := builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___13.to_boolean then
						l_tmp___12 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___11 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___12 := l_tmp___11
					end
					l___x___1.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___12)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				if l_op1_den_size > l_op2_den_size then
					l_alloc := l_op1_den_size
				else
					l_alloc := l_op2_den_size
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___2 := l_tmp2
					l___x___2.item.mp_alloc := l_alloc.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___18 := builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___18.to_boolean then
						l_tmp___17 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___16 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___17 := l_tmp___16
					end
					l___x___2.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___17)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_alloc := l_op1_num_size + l_op2_den_size
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___x___3 := l_numtmp
					l___x___3.item.mp_alloc := l_alloc.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___23 := builtin_expect ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___23.to_boolean then
						l_tmp___22 := (l_aaf.new ((l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___21 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, (l_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___22 := l_tmp___21
					end
					l___x___3.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___22)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_gcd1.item.gmpz_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")))
				update_class_fields -- Current might have been changed; synchronize
				l_gcd2.item.gmpz_gcd (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd1))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp2, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd2))
				update_class_fields -- Current might have been changed; synchronize
				l_numtmp.item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd1))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_DIVEGCD_STATIC}).gmpz_divexact_gcd (l_tmp2, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd2))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_mul (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_set (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_numtmp))
				update_class_fields -- Current might have been changed; synchronize
				if mp_den.mp_size < 0 then
					mp_den.mp_size := -mp_den.mp_size
					update_class_fields -- Current might have been changed; synchronize
					mp_num.mp_size := -mp_num.mp_size
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___24 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___24.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
			end
		end

	gmpq_get_d: REAL_64
		local
			l_res: REAL_64
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_nsize: INTEGER_32
			l_dsize: INTEGER_32
			l_qsize: INTEGER_32
			l_prospective_qsize: INTEGER_32
			l_zeros: INTEGER_32
			l_chop: INTEGER_32
			l_tsize: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_exp: INTEGER_32
			l_qarr: CE_ARRAY [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: CE_POINTER [ANY]
			l_tmp___16: CE_POINTER [ANY]
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___19: CE_POINTER [NATURAL_32]
			l_tmp___20: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_NATURAL_32_ARRAY} l_qarr.make (<<(({NATURAL_32} 1 + (({PLATFORM}.Real_64_bytes.to_natural_32 + {NATURAL_32} 4) - {NATURAL_32} 1) // {NATURAL_32} 4) + {NATURAL_32} 1).to_integer_32>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)

			l_nsize := (mp_num.mp_size).to_integer_32
			l_dsize := (mp_den.mp_size).to_integer_32
			l_sign_quotient := l_nsize
			l_qp := l_qarr
			l_tmp := builtin_expect ((l_nsize = 0).to_integer, 0)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp.to_boolean then
				Result := (0.0)
				l_return := True
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				if l_nsize >= 0 then
					l_nsize := l_nsize
				else
					l_nsize := -l_nsize
				end
				if l_dsize >= 0 then
					l_dsize := l_dsize
				else
					l_dsize := -l_dsize
				end
				l_np := mp_num.mp_d
				l_dp := mp_den.mp_d
				l_prospective_qsize := (l_nsize - l_dsize) + 1
				l_qsize := (({NATURAL_32} 1 + (({PLATFORM}.Real_64_bytes.to_natural_32 + {NATURAL_32} 4) - {NATURAL_32} 1) // {NATURAL_32} 4) + {NATURAL_32} 1).to_integer_32
				l_zeros := l_qsize - l_prospective_qsize
				l_exp := -l_zeros * 32
				if -l_zeros > 0 then
					l_chop := -l_zeros
				else
					l_chop := (0).to_integer_32
				end
				l_np := l_np + l_chop
				l_nsize := l_nsize - l_chop
				l_zeros := l_zeros + l_chop
				l_tsize := l_nsize + l_zeros
				if l_zeros > 0 then
					l_tmp___17 := l_tsize
				else
					l_tmp___17 := (0).to_integer_32
				end
				l_tmp___18 := builtin_expect (((l_dsize + l_tmp___17).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___18.to_boolean then
					if l_zeros > 0 then
						l_tmp___12 := l_tsize
					else
						l_tmp___12 := (0).to_integer_32
					end
					l_tmp___16 := (l_aaf.new (((l_dsize + l_tmp___12).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					if l_zeros > 0 then
						l_tmp___14 := l_tsize
					else
						l_tmp___14 := (0).to_integer_32
					end
					l_tmp___15 := (create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_dsize + l_tmp___14).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___16 := l_tmp___15
				end
				l_remp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___16)
				l_tp := l_remp + l_dsize
				if l_zeros > 0 then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_zeros /= 0 then
							l___dst := l_tp
							l___n := l_zeros
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___19 := l___dst
								l___dst := l___dst + 1
								l_tmp___19.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp + l_zeros, l_np, l_nsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_np := l_tp
					l_nsize := l_tsize
				end
				(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_remp, (0).to_integer_32, l_np, l_nsize, l_dp, l_dsize)
				update_class_fields -- Current might have been changed; synchronize
				l_qsize := l_qsize - (l_qp[(l_qsize - 1)] = {NATURAL_32} 0).to_integer
				l_res := (create {P_GET_D_STATIC}).gmpn_get_d (l_qp, l_qsize, l_sign_quotient, l_exp)
				update_class_fields -- Current might have been changed; synchronize
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp___20 := builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___20.to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
						update_class_fields -- Current might have been changed; synchronize
					end
					l_break := True
				end
				l_break := False
				Result := l_res
			end
		end

	gmpq_init
		local
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: CE_POINTER [ANY]
		do
			mp_num.mp_alloc := 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			mp_num.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp)
			update_class_fields -- Current might have been changed; synchronize
			mp_num.mp_size := 0
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_alloc := 1
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([(4).to_natural_32]))
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp___0)
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_d[0] := (1).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_size := 1
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_inp_str (a_fp: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32): NATURAL_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_nread: NATURAL_32
			l_c: INTEGER_32
			l_return: BOOLEAN
		do
			l_fp := a_fp
			if l_fp.is_void then
				l_fp := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
			end
			mp_den.mp_size := 1
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_d[0] := (1).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_nread := gmpz_inp_str (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), l_fp, a_base)
			update_class_fields -- Current might have been changed; synchronize
			if l_nread = {NATURAL_32} 0 then
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				l_c := IO_getc (l_fp)
				update_class_fields -- Current might have been changed; synchronize
				l_nread := l_nread + 1
				if l_c = 47 then
					l_c := IO_getc (l_fp)
					update_class_fields -- Current might have been changed; synchronize
					l_nread := l_nread + 1
					l_nread := gmpz_inp_str_nowhite (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), l_fp, a_base, l_c, l_nread)
					update_class_fields -- Current might have been changed; synchronize
					if l_nread = {NATURAL_32} 0 then
						mp_num.mp_size := 0
						update_class_fields -- Current might have been changed; synchronize
						mp_den.mp_size := 1
						update_class_fields -- Current might have been changed; synchronize
						mp_den.mp_d[0] := (1).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					ungetc (l_c, l_fp).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_nread := l_nread - 1
				end
				Result := l_nread
			end
		end

	gmpq_inv (a_src: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_src.is_void
		local
			l_num_size: INTEGER_32
			l_den_size: INTEGER_32
			l_alloc: INTEGER_32
			l_limb_ptr: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_num_size := (a_src.item.mp_num.mp_size).to_integer_32
			l_den_size := (a_src.item.mp_den.mp_size).to_integer_32
			if l_num_size = 0 then
				(create {P_ERRNO_STATIC}).gmp_divide_by_zero
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_num_size < 0 then
				l_num_size := -l_num_size
				l_den_size := -l_den_size
			end
			mp_den.mp_size := l_num_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			mp_num.mp_size := l_den_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			if (c_pointer = (a_src).c_pointer) then
				l_alloc := (mp_num.mp_alloc).to_integer_32
				l_limb_ptr := mp_num.mp_d
				mp_num.mp_alloc := mp_den.mp_alloc
				update_class_fields -- Current might have been changed; synchronize
				mp_num.mp_d := mp_den.mp_d
				update_class_fields -- Current might have been changed; synchronize
				mp_den.mp_alloc := l_alloc.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				mp_den.mp_d := l_limb_ptr
				update_class_fields -- Current might have been changed; synchronize
			else
				if l_den_size >= 0 then
					l_den_size := l_den_size
				else
					l_den_size := -l_den_size
				end
				if (mp_num.mp_alloc).to_integer_32 < l_den_size then
					(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_den_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				if (mp_den.mp_alloc).to_integer_32 < l_num_size then
					(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_realloc (l_num_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (mp_num.mp_d, a_src.item.mp_den.mp_d, l_den_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (mp_den.mp_d, a_src.item.mp_num.mp_d, l_num_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
		end

	gmpq_neg (a_src: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_src.is_void
		local
			l_num_size: INTEGER_32
			l_num_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_den_size: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_num_size := (a_src.item.mp_num.mp_size).to_integer_32
			if not (a_src.c_pointer = c_pointer) then
				if l_num_size >= 0 then
					l_tmp := l_num_size
				else
					l_tmp := -l_num_size
				end
				l_num_abs_size := l_tmp
				l_den_size := (a_src.item.mp_den.mp_size).to_integer_32
				l_tmp___0 := builtin_expect ((l_num_abs_size > (mp_num.mp_alloc).to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_num_abs_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				l_tmp___1 := builtin_expect ((l_den_size > (mp_den.mp_alloc).to_integer_32).to_integer, 0)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___1.to_boolean then
					(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_realloc (l_den_size).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (mp_num.mp_d, a_src.item.mp_num.mp_d, l_num_abs_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (mp_den.mp_d, a_src.item.mp_den.mp_d, l_den_size)
						update_class_fields -- Current might have been changed; synchronize
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				mp_den.mp_size := l_den_size.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			mp_num.mp_size := (-l_num_size).to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_set (a_src: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_src.is_void
		local
			l_num_size: INTEGER_32
			l_den_size: INTEGER_32
			l_abs_num_size: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_num_size := (a_src.item.mp_num.mp_size).to_integer_32
			if l_num_size >= 0 then
				l_abs_num_size := l_num_size
			else
				l_abs_num_size := -l_num_size
			end
			if (mp_num.mp_alloc).to_integer_32 < l_abs_num_size then
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_abs_num_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (mp_num.mp_d, a_src.item.mp_num.mp_d, l_abs_num_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			mp_num.mp_size := l_num_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_den_size := (a_src.item.mp_den.mp_size).to_integer_32
			if (mp_den.mp_alloc).to_integer_32 < l_den_size then
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_realloc (l_den_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (mp_den.mp_d, a_src.item.mp_den.mp_d, l_den_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			mp_den.mp_size := l_den_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_set_den (a_den: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_den.is_void
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_size := (a_den.item.mp_size).to_integer_32
			if l_size >= 0 then
				l_tmp := l_size
			else
				l_tmp := -l_size
			end
			l_abs_size := l_tmp
			if (mp_den.mp_alloc).to_integer_32 < l_abs_size then
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_realloc (l_abs_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (mp_den.mp_d, a_den.item.mp_d, l_abs_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			mp_den.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_set_num (a_num: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_num.is_void
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_size := (a_num.item.mp_size).to_integer_32
			if l_size >= 0 then
				l_tmp := l_size
			else
				l_tmp := -l_size
			end
			l_abs_size := l_tmp
			if (mp_num.mp_alloc).to_integer_32 < l_abs_size then
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_abs_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (mp_num.mp_d, a_num.item.mp_d, l_abs_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			mp_num.mp_size := l_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_set_si (a_num: INTEGER_32; a_den: NATURAL_32)
		local
			l_den: NATURAL_32
			l_abs_num: NATURAL_32
		do
			l_den := a_den
			if a_num >= 0 then
				l_abs_num := a_num.to_natural_32
			else
				l_abs_num := (-a_num).to_natural_32
			end
			if a_num = 0 then
				l_den := {NATURAL_32} 1
				mp_num.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
			else
				mp_num.mp_d[0] := l_abs_num
				update_class_fields -- Current might have been changed; synchronize
				if a_num > 0 then
					mp_num.mp_size := 1
					update_class_fields -- Current might have been changed; synchronize
				else
					mp_num.mp_size := -1
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			mp_den.mp_d[0] := l_den
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_size := (l_den /= {NATURAL_32} 0).to_integer
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_set_ui (a_num, a_den: NATURAL_32)
		local
			l_den: NATURAL_32
		do
			l_den := a_den
			if a_num = {NATURAL_32} 0 then
				l_den := {NATURAL_32} 1
				mp_num.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
			else
				mp_num.mp_d[0] := a_num
				update_class_fields -- Current might have been changed; synchronize
				mp_num.mp_size := 1
				update_class_fields -- Current might have been changed; synchronize
			end
			mp_den.mp_d[0] := l_den
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_size := (l_den /= {NATURAL_32} 0).to_integer
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_equal (a_op2: CE_POINTER [PD_MPQ_STRUCT]): INTEGER_32
		require
			not a_op2.is_void
		local
			l_num1_size: INTEGER_32
			l_num2_size: INTEGER_32
			l_den1_size: INTEGER_32
			l_den2_size: INTEGER_32
			l_i: INTEGER_32
			l_num1_ptr: CE_POINTER [NATURAL_32]
			l_num2_ptr: CE_POINTER [NATURAL_32]
			l_den1_ptr: CE_POINTER [NATURAL_32]
			l_den2_ptr: CE_POINTER [NATURAL_32]
			l_return: BOOLEAN
		do
			l_num1_size := (mp_num.mp_size).to_integer_32
			l_num2_size := (a_op2.item.mp_num.mp_size).to_integer_32
			if l_num1_size /= l_num2_size then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_num1_ptr := mp_num.mp_d
				l_num2_ptr := a_op2.item.mp_num.mp_d
				if l_num1_size >= 0 then
					l_num1_size := l_num1_size
				else
					l_num1_size := -l_num1_size
				end
				l_i := (0).to_integer_32
				from
				until
					not (not (l_return) and then (l_i < l_num1_size))
				loop
					if l_num1_ptr[l_i] /= l_num2_ptr[l_i] then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				l_den1_size := (mp_den.mp_size).to_integer_32
				l_den2_size := (a_op2.item.mp_den.mp_size).to_integer_32
				if l_den1_size /= l_den2_size then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_den1_ptr := mp_den.mp_d
				l_den2_ptr := a_op2.item.mp_den.mp_d
				l_i := (0).to_integer_32
				from
				until
					not (not (l_return) and then (l_i < l_den1_size))
				loop
					if l_den1_ptr[l_i] /= l_den2_ptr[l_i] then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gmpq_set_z (a_src: CE_POINTER [PD_MPZ_STRUCT])
		require
			not a_src.is_void
		local
			l_num_size: INTEGER_32
			l_abs_num_size: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_num_size := (a_src.item.mp_size).to_integer_32
			if l_num_size >= 0 then
				l_abs_num_size := l_num_size
			else
				l_abs_num_size := -l_num_size
			end
			if (mp_num.mp_alloc).to_integer_32 < l_abs_num_size then
				(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_abs_num_size).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_GMP_STATIC}).gmpn_copyi (mp_num.mp_d, a_src.item.mp_d, l_abs_num_size)
					update_class_fields -- Current might have been changed; synchronize
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			mp_num.mp_size := l_num_size.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_d[0] := (1).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_size := 1
			update_class_fields -- Current might have been changed; synchronize
		end

	gmpq_set_d (a_d: REAL_64)
		local
			l_d: REAL_64
			l_negative: INTEGER_32
			l_exp: INTEGER_32
			l_tp: CE_ARRAY [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_dn: INTEGER_32
			l_c: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_32]
			l_tmp___4: INTEGER_32
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_tp.make (<<3>>)
			create l_u.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
					from
					until
						(l_break)
					loop
						l_break := False
						l_u.d := l_d
						update_class_fields -- Current might have been changed; synchronize
						l_u.update_class_fields -- synchronize union
						l_tmp := builtin_expect ((l_u.s.exp = {NATURAL_32} 2_047).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.to_boolean then
							if l_u.s.manl = {NATURAL_32} 0 then
								if l_u.s.manh = {NATURAL_32} 0 then
									(create {P_INVALID_STATIC}).gmp_invalid_operation
									update_class_fields -- Current might have been changed; synchronize
								else
									(create {P_INVALID_STATIC}).gmp_invalid_operation
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								(create {P_INVALID_STATIC}).gmp_invalid_operation
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := True
					end
					l_break := False
					l_negative := (l_d < (0).to_double).to_integer
					if l_d >= (0).to_double then
						l_d := l_d
					else
						l_d := -l_d
					end
					l_tmp___0 := (create {P_EXTRACT_DBL_STATIC}).gmp_extract_double (l_tp, l_d)
					update_class_fields -- Current might have been changed; synchronize
					l_exp := l_tmp___0.to_integer_32
					if not (l_exp <= 1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 3 then -- else:
						if l_exp /= 2 then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_tp[0] = {NATURAL_32} 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if l_d = 0.0 then
							mp_num.mp_size := 0
							update_class_fields -- Current might have been changed; synchronize
							mp_den.mp_size := 1
							update_class_fields -- Current might have been changed; synchronize
							mp_den.mp_d[0] := (1).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
						if not l_return then
							l_dn := -l_exp
							l_tmp___1 := builtin_expect ((3 > mp_num.mp_alloc).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1.to_boolean then
								(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc ((3).to_integer_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							l_np := mp_num.mp_d
							if ((l_tp[0]).bit_or (l_tp[1])) = {NATURAL_32} 0 then
								l_np[0] := l_tp[2]
								update_class_fields -- Current might have been changed; synchronize
								l_nn := (1).to_integer_32
							elseif l_tp[0] = {NATURAL_32} 0 then
								l_np[1] := l_tp[2]
								update_class_fields -- Current might have been changed; synchronize
								l_np[0] := l_tp[1]
								update_class_fields -- Current might have been changed; synchronize
								l_nn := (2).to_integer_32
							else
								l_np[2] := l_tp[2]
								update_class_fields -- Current might have been changed; synchronize
								l_np[1] := l_tp[1]
								update_class_fields -- Current might have been changed; synchronize
								l_np[0] := l_tp[0]
								update_class_fields -- Current might have been changed; synchronize
								l_nn := (3).to_integer_32
							end
							l_dn := l_dn + (l_nn + 1)
							from
							until
								(l_break)
							loop
								l_break := False
								if not (l_dn > 0) then
									(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("set_d.c"), 101, ce_string ("dn > 0"))
									update_class_fields -- Current might have been changed; synchronize
								end
								l_break := True
							end
							l_break := False
							l_tmp___2 := builtin_expect ((l_dn > (mp_den.mp_alloc).to_integer_32).to_integer, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2.to_boolean then
								(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_realloc (l_dn).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
							l_dp := mp_den.mp_d
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_dn - 1 /= 0 then
									l___dst := l_dp
									l___n := l_dn - 1
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___3 := l___dst
										l___dst := l___dst + 1
										l_tmp___3.item := (0).to_natural_32
										update_class_fields -- Current might have been changed; synchronize
										l___n := l___n - 1
										if not l___n.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_dp[(l_dn - 1)] := (1).to_natural_32
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_c := builtin_ctzl ((l_np[0]).bit_or (l_dp[0]))
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							if l_c /= 0 then
								(create {P_GMP_STATIC}).gmpn_rshift (l_np, l_np, l_nn, l_c.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_nn := l_nn - (l_np[(l_nn - 1)] = {NATURAL_32} 0).to_integer;
								(create {P_GMP_STATIC}).gmpn_rshift (l_dp, l_dp, l_dn, l_c.to_natural_32).do_nothing
								update_class_fields -- Current might have been changed; synchronize
								l_dn := l_dn - (l_dp[(l_dn - 1)] = {NATURAL_32} 0).to_integer
							end
							mp_den.mp_size := l_dn.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							if l_negative.to_boolean then
								mp_num.mp_size := (-l_nn).to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							else
								mp_num.mp_size := l_nn.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 9 then -- else: | _L___0:
						l_nn := l_exp
						l_tmp___4 := builtin_expect ((l_nn > (mp_num.mp_alloc).to_integer_32).to_integer, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.to_boolean then
							(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_nn).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_np := mp_num.mp_d
						inspect l_nn.to_integer_32 -- switch 1 head
						when 3 then l_pos := -1 + 11
						when 2 then l_pos := -1 + 12
						else l_pos := -1 + 10
						end
				when 10 then -- switch 1, default:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_nn - 3 /= 0 then
								l___dst___0 := l_np
								l___n___0 := l_nn - 3
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___5 := l___dst___0
									l___dst___0 := l___dst___0 + 1
									l_tmp___5.item := (0).to_natural_32
									update_class_fields -- Current might have been changed; synchronize
									l___n___0 := l___n___0 - 1
									if not l___n___0.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_np := l_np + (l_nn - 3)
				when 11 then -- switch 1, case 3
						l_np[2] := l_tp[2]
						update_class_fields -- Current might have been changed; synchronize
						l_np[1] := l_tp[1]
						update_class_fields -- Current might have been changed; synchronize
						l_np[0] := l_tp[0]
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 13 -- switch 1; break
				when 12 then -- switch 1, case 2
						l_np[1] := l_tp[2]
						update_class_fields -- Current might have been changed; synchronize
						l_np[0] := l_tp[1]
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 13 -- switch 1; break
				when 13 then -- switch 1, done:
						l_dp := mp_den.mp_d
						l_dp[0] := (1).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
						mp_den.mp_size := 1
						update_class_fields -- Current might have been changed; synchronize
						if l_negative.to_boolean then
							mp_num.mp_size := (-l_nn).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						else
							mp_num.mp_size := l_nn.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
				when 14 then -- if done
					if not l_return then
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpq_set_f (a_f: CE_POINTER [PD_MPF_STRUCT])
		require
			not a_f.is_void
		local
			l_fexp: INTEGER_32
			l_fptr: CE_POINTER [NATURAL_32]
			l_fsize: INTEGER_32
			l_abs_fsize: INTEGER_32
			l_tmp: INTEGER_32
			l_flow: NATURAL_32
			l_num_ptr: CE_POINTER [NATURAL_32]
			l_tmp___0: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_32]
			l_num_ptr___0: CE_POINTER [NATURAL_32]
			l_den_ptr: CE_POINTER [NATURAL_32]
			l_den_size: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_shift: INTEGER_32
			l___dst___1: CE_POINTER [NATURAL_32]
			l___n___1: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_fexp := a_f.item.mp_exp
			l_fptr := a_f.item.mp_d
			l_fsize := (a_f.item.mp_size).to_integer_32
			if l_fsize >= 0 then
				l_tmp := l_fsize
			else
				l_tmp := -l_fsize
			end
			l_abs_fsize := l_tmp
			if l_fsize = 0 then
				mp_num.mp_size := 0
				update_class_fields -- Current might have been changed; synchronize
				mp_den.mp_size := 1
				update_class_fields -- Current might have been changed; synchronize
				mp_den.mp_d[0] := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_return := True
			end
			if not l_return then
				l_flow := l_fptr.item
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_return) and then (l_flow = {NATURAL_32} 0))
					loop
						l_abs_fsize := l_abs_fsize - 1
						l_fptr := l_fptr + 1
						l_flow := l_fptr.item
					end
					l_break := True
				end
				l_break := False
				if l_fexp >= l_abs_fsize then
					l_tmp___0 := builtin_expect ((l_fexp > (mp_num.mp_alloc).to_integer_32).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_fexp).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_num_ptr := mp_num.mp_d
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_fexp - l_abs_fsize /= 0 then
							l___dst := l_num_ptr
							l___n := l_fexp - l_abs_fsize
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___1 := l___dst
								l___dst := l___dst + 1
								l_tmp___1.item := (0).to_natural_32
								update_class_fields -- Current might have been changed; synchronize
								l___n := l___n - 1
								if not l___n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi ((l_num_ptr + l_fexp) - l_abs_fsize, l_fptr, l_abs_fsize)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_fsize >= 0 then
						mp_num.mp_size := l_fexp.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					else
						mp_num.mp_size := (-l_fexp).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
					mp_den.mp_size := 1
					update_class_fields -- Current might have been changed; synchronize
					mp_den.mp_d[0] := (1).to_natural_32
					update_class_fields -- Current might have been changed; synchronize
				else
					l_den_size := l_abs_fsize - l_fexp
					l_tmp___2 := builtin_expect ((l_abs_fsize > (mp_num.mp_alloc).to_integer_32).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___2.to_boolean then
						(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).item.gmpz_realloc (l_abs_fsize).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_tmp___3 := builtin_expect ((l_den_size + 1 > (mp_den.mp_alloc).to_integer_32).to_integer, 0)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___3.to_boolean then
						(create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_shared (c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).item.gmpz_realloc (l_den_size + 1).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_num_ptr___0 := mp_num.mp_d
					l_den_ptr := mp_den.mp_d
					if ((l_flow).bit_and ({NATURAL_32} 1)).to_boolean then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_num_ptr___0, l_fptr, l_abs_fsize)
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_den_size /= 0 then
								l___dst___0 := l_den_ptr
								l___n___0 := l_den_size
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___4 := l___dst___0
									l___dst___0 := l___dst___0 + 1
									l_tmp___4.item := (0).to_natural_32
									update_class_fields -- Current might have been changed; synchronize
									l___n___0 := l___n___0 - 1
									if not l___n___0.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_den_ptr[l_den_size] := (1).to_natural_32
						update_class_fields -- Current might have been changed; synchronize
					else
						l_den_size := l_den_size - 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_shift := builtin_ctzl (l_flow)
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_rshift (l_num_ptr___0, l_fptr, l_abs_fsize, l_shift.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_abs_fsize := l_abs_fsize - (l_num_ptr___0[(l_abs_fsize - 1)] = {NATURAL_32} 0).to_integer
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_den_size /= 0 then
								l___dst___1 := l_den_ptr
								l___n___1 := l_den_size
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___5 := l___dst___1
									l___dst___1 := l___dst___1 + 1
									l_tmp___5.item := (0).to_natural_32
									update_class_fields -- Current might have been changed; synchronize
									l___n___1 := l___n___1 - 1
									if not l___n___1.to_boolean then
										l_break := True
									end
								end
								l_break := False
							end
							l_break := True
						end
						l_break := False
						l_den_ptr[l_den_size] := ((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1))))).bit_shift_right ((l_shift - 1))
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_fsize >= 0 then
						mp_num.mp_size := l_abs_fsize.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					else
						mp_num.mp_size := (-l_abs_fsize).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
					mp_den.mp_size := (l_den_size + 1).to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	gmpq_swap (a_v: CE_POINTER [PD_MPQ_STRUCT])
		require
			not a_v.is_void
		local
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_ualloc: INTEGER_32
			l_valloc: INTEGER_32
		do
			l_ualloc := (mp_num.mp_alloc).to_integer_32
			l_valloc := (a_v.item.mp_num.mp_alloc).to_integer_32
			a_v.item.mp_num.mp_alloc := l_ualloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			mp_num.mp_alloc := l_valloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_usize := (mp_num.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_num.mp_size).to_integer_32
			a_v.item.mp_num.mp_size := l_usize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			mp_num.mp_size := l_vsize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_up := mp_num.mp_d
			l_vp := a_v.item.mp_num.mp_d
			a_v.item.mp_num.mp_d := l_up
			update_class_fields -- Current might have been changed; synchronize
			mp_num.mp_d := l_vp
			update_class_fields -- Current might have been changed; synchronize
			l_ualloc := (mp_den.mp_alloc).to_integer_32
			l_valloc := (a_v.item.mp_den.mp_alloc).to_integer_32
			a_v.item.mp_den.mp_alloc := l_ualloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_alloc := l_valloc.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_usize := (mp_den.mp_size).to_integer_32
			l_vsize := (a_v.item.mp_den.mp_size).to_integer_32
			a_v.item.mp_den.mp_size := l_usize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_size := l_vsize.to_integer_32
			update_class_fields -- Current might have been changed; synchronize
			l_up := mp_den.mp_d
			l_vp := a_v.item.mp_den.mp_d
			a_v.item.mp_den.mp_d := l_up
			update_class_fields -- Current might have been changed; synchronize
			mp_den.mp_d := l_vp
			update_class_fields -- Current might have been changed; synchronize
		end

feature {PD_MPQ_STRUCT} -- private routines

	gmpz_inp_str (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_c: INTEGER_32
			l_nread: NATURAL_32
			l_break: BOOLEAN
		do
			l_stream := a_stream
			if l_stream.is_void then
				l_stream := (create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
			end
			l_nread := (0).to_natural_32
			from
			until
				(l_break)
			loop
				l_break := False
				l_c := IO_getc (l_stream)
				l_nread := l_nread + 1
				if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8_192)).to_boolean then
					l_break := True
				end
			end
			l_break := False
			Result := (gmpz_inp_str_nowhite (a_x___2, l_stream, a_base, l_c, l_nread))
		end

	gmpz_inp_str_nowhite (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_stream: CE_POINTER [SD_IO_FILE]; a_base, a_c: INTEGER_32; a_nread: NATURAL_32): NATURAL_32
		local
			l_base: INTEGER_32
			l_c: INTEGER_32
			l_nread: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_alloc_size: NATURAL_32
			l_str_size: NATURAL_32
			l_negative: INTEGER_32
			l_xsize: INTEGER_32
			l_digit_value: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_dig: INTEGER_32
			l_old_alloc_size: NATURAL_32
			l_tmp___2: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_base := a_base
			l_c := a_c
			l_nread := a_nread
			l_digit_value := (create {P_MP_DV_TAB_STATIC}).gmp_digit_value_tab.item
			if l_base > 36 then
				l_digit_value := l_digit_value + (224)
				if l_base > 62 then
					Result := (0).to_natural_32
					l_return := True
				end
			end
			if not l_return then
				l_negative := 0
				if l_c = 45 then
					l_negative := 1
					l_c := IO_getc (a_stream)
					l_nread := l_nread + 1
				end
				if l_c = -1 then
					Result := (0).to_natural_32
					l_return := True
				else
					if l_base = 0 then
						l_tmp := 10
					else
						l_tmp := l_base
					end
					if (l_digit_value[l_c]).to_integer_32 >= l_tmp then
						Result := (0).to_natural_32
						l_return := True
					end
				end
			end
			if not l_return then
				if l_base = 0 then
					l_base := 10
					if l_c = 48 then
						l_base := 8
						l_c := IO_getc (a_stream)
						l_nread := l_nread + 1
						if l_c = 120 then
							l_base := 16
							l_c := IO_getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 88 then
							l_base := 16
							l_c := IO_getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 98 then
							l_base := 2
							l_c := IO_getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 66 then
							l_base := 2
							l_c := IO_getc (a_stream)
							l_nread := l_nread + 1
						end
					end
				end
				from
				until
					l_c /= 48
				loop
					l_c := IO_getc (a_stream)
					l_nread := l_nread + 1
				end
				l_alloc_size := (100).to_natural_32
				l_str := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_alloc_size]))))
				l_str_size := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_c /= -1))
				loop
					l_break := False
					l_dig := (l_digit_value[l_c]).to_integer_32
					if l_dig >= l_base then
						l_break := True
					end
					if not (l_break) then
						if l_str_size >= l_alloc_size then
							l_old_alloc_size := l_alloc_size
							l_alloc_size := (l_alloc_size * {NATURAL_32} 3) // {NATURAL_32} 2
							l_str := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_reallocate_func.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_str), l_old_alloc_size, l_alloc_size]))))
						end
						l_tmp___2 := l_str_size
						l_str_size := l_str_size + 1
						l_str[l_tmp___2.to_integer_32] := l_dig.to_integer_8
						l_c := IO_getc (a_stream)
					end
				end
				l_break := False
				l_nread := l_nread + l_str_size
				ungetc (l_c, a_stream).do_nothing
				l_nread := l_nread - 1
				if l_str_size = {NATURAL_32} 0 then
					a_x___2.item.mp_size := 0
				else
					l_xsize := 2 + (l_str_size.to_real_64 / ((32).to_double * (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base].chars_per_bit_exactly)).truncated_to_integer
					if (builtin_expect ((l_xsize > (a_x___2.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						a_x___2.item.gmpz_realloc (l_xsize).do_nothing
					end
					l_xsize := (create {P_SET_STR_STATIC}).gmpn_set_str (a_x___2.item.mp_d, create {CE_NATURAL_8_POINTER}.make_cast (l_str), l_str_size, l_base)
					if l_negative.to_boolean then
						a_x___2.item.mp_size := (-l_xsize).to_integer_32
					else
						a_x___2.item.mp_size := l_xsize.to_integer_32
					end
				end
				(create {P_MEMORY_STATIC}).gmp_free_func.item.call ([create {CE_VOID_POINTER}.make_cast (l_str), l_alloc_size])
				Result := l_nread
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_num := a_other.mp_num.twin
			mp_den := a_other.mp_den.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_num.is_equal (a_other.mp_num) and
				mp_den.is_equal (a_other.mp_den)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mp_num"),
					create {CE_STRUCTURE_FIELD}.make ("mp_den")
				>>)
			init_structure_info
		end

end
