class
	PD_TMP_ALIGN_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	l: NATURAL_32 assign set_l

	p: CE_POINTER [INTEGER_8] assign set_p

feature {ANY} -- field setters

	set_l (a_l: NATURAL_32)
		do
			l := a_l
			update_memory_field ("l")
		end

	set_p (a_p: CE_POINTER [INTEGER_8])
		do
			p := a_p
			update_memory_field ("p")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			l := a_other.l
			p := a_other.p
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				l = a_other.l and
				p.is_equal (a_other.p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("l"),
					create {CE_STRUCTURE_FIELD}.make ("p")
				>>)
			init_structure_info
		end

end
