class
	P_BESSEL_IN_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_sf_bessel_In_scaled_array (a_nmin, a_nmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_j: INTEGER_32
			l_j___0: INTEGER_32
			l_I0_scaled: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat: INTEGER_32
			l_ax: REAL_64
			l_two_over_x: REAL_64
			l_r_Inp1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_In: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_Inp1: REAL_64
			l_In: REAL_64
			l_Inm1: REAL_64
			l_n: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_I0_scaled.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_Inp1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_In.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_nmax < a_nmin) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_nmin < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_j := 0
						from
						until
							not (l_j <= a_nmax - a_nmin)
						loop
							a_result_array[l_j] := 0.0
							l_j := l_j + 1
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("bessel_In.c"), 120, 1)
							Result := 1
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_x = 0.0 then
							l_j___0 := 0
							from
							until
								not (l_j___0 <= a_nmax - a_nmin)
							loop
								a_result_array[l_j___0] := 0.0
								l_j___0 := l_j___0 + 1
							end
							if a_nmin = 0 then
								a_result_array[0] := 1.0
							end
							Result := 0
							l_return := True
						elseif a_nmax = 0 then
							l_stat := (l_I0_scaled.item.gsl_sf_bessel_I0_scaled_e2 (a_x))
							a_result_array[0] := l_I0_scaled.item.val
							Result := l_stat
							l_return := True
						else
							l_ax := (fabs (a_x))
							l_two_over_x := 2.0 / l_ax
							l_stat_0 := (l_r_Inp1.item.gsl_sf_bessel_In_scaled_e (a_nmax + 1, l_ax))
							l_stat_1 := (l_r_In.item.gsl_sf_bessel_In_scaled_e (a_nmax, l_ax))
							l_Inp1 := l_r_Inp1.item.val
							l_In := l_r_In.item.val
							l_n := a_nmax
							from
							until
								not (l_n >= a_nmin)
							loop
								a_result_array[(l_n - a_nmin)] := l_In
								l_Inm1 := l_Inp1 + (l_n.to_double * l_two_over_x) * l_In
								l_Inp1 := l_In
								l_In := l_Inm1
								l_n := l_n - 1
							end
							if a_x < 0.0 then
								l_n := a_nmin
								from
								until
									not (l_n <= a_nmax)
								loop
									if ((l_n).bit_and (1)).to_boolean then
										a_result_array[(l_n - a_nmin)] := -a_result_array[(l_n - a_nmin)]
									end
									l_n := l_n + 1
								end
							end
							if l_stat_0 /= 0 then
								l_tmp___4 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___3 := l_stat_1
								else
									l_tmp___3 := 0
								end
								l_tmp___4 := l_tmp___3
							end
							Result := l_tmp___4
							l_return := True
						end
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_bessel_In_array (a_nmin, a_nmax: INTEGER_32; a_x: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_ax: REAL_64
			l_j: INTEGER_32
			l_j___0: INTEGER_32
			l_eax: REAL_64
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_ax := (fabs (a_x))
			if l_ax > 7.0978271289338397e+02 - 1.0 then
				l_j := 0
				from
				until
					not (l_j <= a_nmax - a_nmin)
				loop
					a_result_array[l_j] := 0.0
					l_j := l_j + 1
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("overflow"), ce_string ("bessel_In.c"), 202, 16)
					Result := 16
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			else
				l_eax := (exp (l_ax))
				l_status := (gsl_sf_bessel_In_scaled_array (a_nmin, a_nmax, a_x, a_result_array))
				l_j___0 := 0
				from
				until
					not (l_j___0 <= a_nmax - a_nmin)
				loop
					a_result_array[l_j___0] := a_result_array[l_j___0] * l_eax
					l_j___0 := l_j___0 + 1
				end
				Result := l_status
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_sf_bessel_In (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_bessel_In_e (a_n, a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_bessel_In_e(n, x, &result)"), ce_string ("bessel_In.c"), 224, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
