class
	P_BETA_INC_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gsl_sf_beta_inc (a_a___5, a_b___0, a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_beta_inc_e (a_a___5, a_b___0, a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_beta_inc_e(a, b, x, &result)"), ce_string ("beta_inc.c"), 203, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	beta_cont_frac___0 (a_a___5, a_b___0, a_x, a_epsabs: REAL_64): REAL_64
		local
			l_max_iter: NATURAL_32
			l_cutoff: REAL_64
			l_iter_count: NATURAL_32
			l_cf: REAL_64
			l_num_term: REAL_64
			l_den_term: REAL_64
			l_k: INTEGER_32
			l_coeff: REAL_64
			l_delta_frac: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_max_iter := {NATURAL_32} 512
			l_cutoff := 2.0 * 2.2250738585072014e-308
			l_iter_count := {NATURAL_32} 0
			l_num_term := 1.0
			l_den_term := 1.0 - ((a_a___5 + a_b___0) * a_x) / (a_a___5 + 1.0)
			if (fabs (l_den_term)) < l_cutoff then
				l_den_term := (builtin_nanf (ce_string (""))).to_double
			end
			l_den_term := 1.0 / l_den_term
			l_cf := l_den_term
			from
			until
				not (not (l_break) and then (l_iter_count < l_max_iter))
			loop
				l_break := False
				l_k := (l_iter_count + {NATURAL_32} 1).to_integer_32
				l_coeff := ((l_k.to_double * (a_b___0 - l_k.to_double)) * a_x) / (((a_a___5 - 1.0) + (2 * l_k).to_double) * (a_a___5 + (2 * l_k).to_double))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				l_coeff := ((-(a_a___5 + l_k.to_double) * ((a_a___5 + a_b___0) + l_k.to_double)) * a_x) / ((a_a___5 + (2 * l_k).to_double) * ((a_a___5 + (2 * l_k).to_double) + 1.0))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				if (fabs (l_delta_frac - 1.0)) < 2.0 * 2.2204460492503131e-16 then
					l_break := True
				end
				if not (l_break) then
					if l_cf * (fabs (l_delta_frac - 1.0)) < a_epsabs then
						l_break := True
					end
				end
				if not (l_break) then
					l_iter_count := l_iter_count + 1
				end
			end
			l_break := False
			if l_iter_count >= l_max_iter then
				Result := (builtin_nanf (ce_string (""))).to_double
				l_return := True
			end
			if not l_return then
				Result := l_cf
			end
		end

	beta_inc_AXPY (a_A___0, a_Y, a_a___5, a_b___0, a_x: REAL_64): REAL_64
		local
			l_N: REAL_64
			l_N___0: REAL_64
			l_ln_beta: REAL_64
			l_ln_pre: REAL_64
			l_tmp___4: REAL_64
			l_prefactor: REAL_64
			l_epsabs: REAL_64
			l_cf: REAL_64
			l_epsabs___0: REAL_64
			l_cf___0: REAL_64
			l_term: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (a_A___0 * (0).to_double + a_Y)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (a_A___0 * (1).to_double + a_Y)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (a_a___5 > 1.e5) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_b___0 < (10).to_double then
							if a_x > a_a___5 / (a_a___5 + a_b___0) then
								l_N := a_a___5 + (a_b___0 - 1.0) / 2.0
								Result := (a_A___0 * ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_Q (a_b___0, -l_N * (log (a_x)))) + a_Y)
							else
								l_pos := -1 + 9 -- goto _L___2
							end
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___2:
						if not (a_b___0 > 1.e5) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_a___5 < (10).to_double then
							if a_x < a_b___0 / (a_a___5 + a_b___0) then
								l_N___0 := a_b___0 + (a_a___5 - 1.0) / 2.0
								Result := (a_A___0 * ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_P (a_a___5, -l_N___0 * (log1p (-a_x)))) + a_Y)
							else
								l_pos := -1 + 12 -- goto _L___0
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_ln_beta := ((create {P_BETA_STATIC}).gsl_sf_lnbeta (a_a___5, a_b___0))
						l_tmp___4 := log (a_x)
						l_ln_pre := (-l_ln_beta + a_a___5 * l_tmp___4) + a_b___0 * (log1p (-a_x))
						l_prefactor := (exp (l_ln_pre))
						if a_x < (a_a___5 + 1.0) / ((a_a___5 + a_b___0) + 2.0) then
							l_epsabs := (fabs (a_Y / ((a_A___0 * l_prefactor) / a_a___5))) * 2.2204460492503131e-16
							l_cf := (beta_cont_frac___0 (a_a___5, a_b___0, a_x, l_epsabs))
							Result := (a_A___0 * ((l_prefactor * l_cf) / a_a___5) + a_Y)
						else
							l_epsabs___0 := (fabs ((a_A___0 + a_Y) / ((a_A___0 * l_prefactor) / a_b___0))) * 2.2204460492503131e-16
							l_cf___0 := (beta_cont_frac___0 (a_b___0, a_a___5, 1.0 - a_x, l_epsabs___0))
							l_term := (l_prefactor * l_cf___0) / a_b___0
							if a_A___0 = -a_Y then
								Result := (-a_A___0 * l_term)
							else
								Result := (a_A___0 * ((1).to_double - l_term) + a_Y)
							end
						end
				when 13 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	beta_cont_frac___1 (a_a___5, a_b___0, a_x, a_epsabs: REAL_64): REAL_64
		local
			l_max_iter: NATURAL_32
			l_cutoff: REAL_64
			l_iter_count: NATURAL_32
			l_cf: REAL_64
			l_num_term: REAL_64
			l_den_term: REAL_64
			l_k: INTEGER_32
			l_coeff: REAL_64
			l_delta_frac: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_max_iter := {NATURAL_32} 512
			l_cutoff := 2.0 * 2.2250738585072014e-308
			l_iter_count := {NATURAL_32} 0
			l_num_term := 1.0
			l_den_term := 1.0 - ((a_a___5 + a_b___0) * a_x) / (a_a___5 + 1.0)
			if (fabs (l_den_term)) < l_cutoff then
				l_den_term := (builtin_nanf (ce_string (""))).to_double
			end
			l_den_term := 1.0 / l_den_term
			l_cf := l_den_term
			from
			until
				not (not (l_break) and then (l_iter_count < l_max_iter))
			loop
				l_break := False
				l_k := (l_iter_count + {NATURAL_32} 1).to_integer_32
				l_coeff := ((l_k.to_double * (a_b___0 - l_k.to_double)) * a_x) / (((a_a___5 - 1.0) + (2 * l_k).to_double) * (a_a___5 + (2 * l_k).to_double))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				l_coeff := ((-(a_a___5 + l_k.to_double) * ((a_a___5 + a_b___0) + l_k.to_double)) * a_x) / ((a_a___5 + (2 * l_k).to_double) * ((a_a___5 + (2 * l_k).to_double) + 1.0))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				if (fabs (l_delta_frac - 1.0)) < 2.0 * 2.2204460492503131e-16 then
					l_break := True
				end
				if not (l_break) then
					if l_cf * (fabs (l_delta_frac - 1.0)) < a_epsabs then
						l_break := True
					end
				end
				if not (l_break) then
					l_iter_count := l_iter_count + 1
				end
			end
			l_break := False
			if l_iter_count >= l_max_iter then
				Result := (builtin_nanf (ce_string (""))).to_double
				l_return := True
			end
			if not l_return then
				Result := l_cf
			end
		end

	beta_inc_AXPY___0 (a_A___0, a_Y, a_a___5, a_b___0, a_x: REAL_64): REAL_64
		local
			l_N: REAL_64
			l_N___0: REAL_64
			l_ln_beta: REAL_64
			l_ln_pre: REAL_64
			l_tmp___4: REAL_64
			l_prefactor: REAL_64
			l_epsabs: REAL_64
			l_cf: REAL_64
			l_epsabs___0: REAL_64
			l_cf___0: REAL_64
			l_term: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (a_A___0 * (0).to_double + a_Y)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (a_A___0 * (1).to_double + a_Y)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (a_a___5 > 1.e5) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_b___0 < (10).to_double then
							if a_x > a_a___5 / (a_a___5 + a_b___0) then
								l_N := a_a___5 + (a_b___0 - 1.0) / 2.0
								Result := (a_A___0 * ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_Q (a_b___0, -l_N * (log (a_x)))) + a_Y)
							else
								l_pos := -1 + 9 -- goto _L___2
							end
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___2:
						if not (a_b___0 > 1.e5) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_a___5 < (10).to_double then
							if a_x < a_b___0 / (a_a___5 + a_b___0) then
								l_N___0 := a_b___0 + (a_a___5 - 1.0) / 2.0
								Result := (a_A___0 * ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_P (a_a___5, -l_N___0 * (log1p (-a_x)))) + a_Y)
							else
								l_pos := -1 + 12 -- goto _L___0
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_ln_beta := ((create {P_BETA_STATIC}).gsl_sf_lnbeta (a_a___5, a_b___0))
						l_tmp___4 := log (a_x)
						l_ln_pre := (-l_ln_beta + a_a___5 * l_tmp___4) + a_b___0 * (log1p (-a_x))
						l_prefactor := (exp (l_ln_pre))
						if a_x < (a_a___5 + 1.0) / ((a_a___5 + a_b___0) + 2.0) then
							l_epsabs := (fabs (a_Y / ((a_A___0 * l_prefactor) / a_a___5))) * 2.2204460492503131e-16
							l_cf := (beta_cont_frac___1 (a_a___5, a_b___0, a_x, l_epsabs))
							Result := (a_A___0 * ((l_prefactor * l_cf) / a_a___5) + a_Y)
						else
							l_epsabs___0 := (fabs ((a_A___0 + a_Y) / ((a_A___0 * l_prefactor) / a_b___0))) * 2.2204460492503131e-16
							l_cf___0 := (beta_cont_frac___1 (a_b___0, a_a___5, 1.0 - a_x, l_epsabs___0))
							l_term := (l_prefactor * l_cf___0) / a_b___0
							if a_A___0 = -a_Y then
								Result := (-a_A___0 * l_term)
							else
								Result := (a_A___0 * ((1).to_double - l_term) + a_Y)
							end
						end
				when 13 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	beta_cont_frac___2 (a_a___5, a_b___0, a_x, a_epsabs: REAL_64): REAL_64
		local
			l_max_iter: NATURAL_32
			l_cutoff: REAL_64
			l_iter_count: NATURAL_32
			l_cf: REAL_64
			l_num_term: REAL_64
			l_den_term: REAL_64
			l_k: INTEGER_32
			l_coeff: REAL_64
			l_delta_frac: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_max_iter := {NATURAL_32} 512
			l_cutoff := 2.0 * 2.2250738585072014e-308
			l_iter_count := {NATURAL_32} 0
			l_num_term := 1.0
			l_den_term := 1.0 - ((a_a___5 + a_b___0) * a_x) / (a_a___5 + 1.0)
			if (fabs (l_den_term)) < l_cutoff then
				l_den_term := (builtin_nanf (ce_string (""))).to_double
			end
			l_den_term := 1.0 / l_den_term
			l_cf := l_den_term
			from
			until
				not (not (l_break) and then (l_iter_count < l_max_iter))
			loop
				l_break := False
				l_k := (l_iter_count + {NATURAL_32} 1).to_integer_32
				l_coeff := ((l_k.to_double * (a_b___0 - l_k.to_double)) * a_x) / (((a_a___5 - 1.0) + (2 * l_k).to_double) * (a_a___5 + (2 * l_k).to_double))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				l_coeff := ((-(a_a___5 + l_k.to_double) * ((a_a___5 + a_b___0) + l_k.to_double)) * a_x) / ((a_a___5 + (2 * l_k).to_double) * ((a_a___5 + (2 * l_k).to_double) + 1.0))
				l_den_term := 1.0 + l_coeff * l_den_term
				l_num_term := 1.0 + l_coeff / l_num_term
				if (fabs (l_den_term)) < l_cutoff then
					l_den_term := (builtin_nanf (ce_string (""))).to_double
				end
				if (fabs (l_num_term)) < l_cutoff then
					l_num_term := (builtin_nanf (ce_string (""))).to_double
				end
				l_den_term := 1.0 / l_den_term
				l_delta_frac := l_den_term * l_num_term
				l_cf := l_cf * l_delta_frac
				if (fabs (l_delta_frac - 1.0)) < 2.0 * 2.2204460492503131e-16 then
					l_break := True
				end
				if not (l_break) then
					if l_cf * (fabs (l_delta_frac - 1.0)) < a_epsabs then
						l_break := True
					end
				end
				if not (l_break) then
					l_iter_count := l_iter_count + 1
				end
			end
			l_break := False
			if l_iter_count >= l_max_iter then
				Result := (builtin_nanf (ce_string (""))).to_double
				l_return := True
			end
			if not l_return then
				Result := l_cf
			end
		end

	beta_inc_AXPY___1 (a_A___0, a_Y, a_a___5, a_b___0, a_x: REAL_64): REAL_64
		local
			l_N: REAL_64
			l_N___0: REAL_64
			l_ln_beta: REAL_64
			l_ln_pre: REAL_64
			l_tmp___4: REAL_64
			l_prefactor: REAL_64
			l_epsabs: REAL_64
			l_cf: REAL_64
			l_epsabs___0: REAL_64
			l_cf___0: REAL_64
			l_term: REAL_64
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (a_A___0 * (0).to_double + a_Y)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (a_A___0 * (1).to_double + a_Y)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (a_a___5 > 1.e5) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_b___0 < (10).to_double then
							if a_x > a_a___5 / (a_a___5 + a_b___0) then
								l_N := a_a___5 + (a_b___0 - 1.0) / 2.0
								Result := (a_A___0 * ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_Q (a_b___0, -l_N * (log (a_x)))) + a_Y)
							else
								l_pos := -1 + 9 -- goto _L___2
							end
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else: | _L___2:
						if not (a_b___0 > 1.e5) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_a___5 < (10).to_double then
							if a_x < a_b___0 / (a_a___5 + a_b___0) then
								l_N___0 := a_b___0 + (a_a___5 - 1.0) / 2.0
								Result := (a_A___0 * ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_P (a_a___5, -l_N___0 * (log1p (-a_x)))) + a_Y)
							else
								l_pos := -1 + 12 -- goto _L___0
							end
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_ln_beta := ((create {P_BETA_STATIC}).gsl_sf_lnbeta (a_a___5, a_b___0))
						l_tmp___4 := log (a_x)
						l_ln_pre := (-l_ln_beta + a_a___5 * l_tmp___4) + a_b___0 * (log1p (-a_x))
						l_prefactor := (exp (l_ln_pre))
						if a_x < (a_a___5 + 1.0) / ((a_a___5 + a_b___0) + 2.0) then
							l_epsabs := (fabs (a_Y / ((a_A___0 * l_prefactor) / a_a___5))) * 2.2204460492503131e-16
							l_cf := (beta_cont_frac___2 (a_a___5, a_b___0, a_x, l_epsabs))
							Result := (a_A___0 * ((l_prefactor * l_cf) / a_a___5) + a_Y)
						else
							l_epsabs___0 := (fabs ((a_A___0 + a_Y) / ((a_A___0 * l_prefactor) / a_b___0))) * 2.2204460492503131e-16
							l_cf___0 := (beta_cont_frac___2 (a_b___0, a_a___5, 1.0 - a_x, l_epsabs___0))
							l_term := (l_prefactor * l_cf___0) / a_b___0
							if a_A___0 = -a_Y then
								Result := (-a_A___0 * l_term)
							else
								Result := (a_A___0 * ((1).to_double - l_term) + a_Y)
							end
						end
				when 13 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
