class
	P_BISECTION_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	bisection_type: CE_STATIC [CE_ARRAY [PD_GSL_ROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ROOT_FSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_ROOT_FSOLVER_TYPE}.make_initialized ([ce_string ("bisection"), (create {PD_BISECTION_STATE_T}.make).structure_size.to_natural_32, (create {PD_GSL_FUNCTION_STRUCT_STATIC}).bisection_init_address, bisection_iterate_address])
				>>)
		end

	gsl_root_fsolver_bisection: CE_STATIC [CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := bisection_type.item
		end

feature {ANY} -- public routines

	bisection_iterate (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root, a_x_lower, a_x_upper: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_x_lower.is_void
			not a_x_upper.is_void
		local
			l_state: CE_POINTER [PD_BISECTION_STATE_T]
			l_x_bisect: REAL_64
			l_f_bisect: REAL_64
			l_x_left: REAL_64
			l_x_right: REAL_64
			l_f_lower: REAL_64
			l_f_upper: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_CLASS_POINTER [PD_BISECTION_STATE_T]}.make_cast (a_vstate)
					l_x_left := a_x_lower.item
					l_x_right := a_x_upper.item
					l_f_lower := l_state.item.f_lower
					l_f_upper := l_state.item.f_upper
					if l_f_lower = 0.0 then
						a_root.item := l_x_left
						a_x_upper.item := l_x_left
						Result := 0
						l_return := True
					end
					if not l_return and then (l_f_upper = 0.0) then
						a_root.item := l_x_right
						a_x_lower.item := l_x_right
						Result := 0
						l_return := True
					end
					if not l_return then
						l_x_bisect := (l_x_left + l_x_right) / 2.0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_f_bisect := (a_f.item.function).real_64_item ([l_x_bisect, a_f.item.params])
							if not ((create {P_INFNAN_STATIC}).gsl_finite (l_f_bisect)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).gsl_error (ce_string ("function value is not finite"), ce_string ("bisection.c"), 99, 9)
									Result := 9
									l_return := True
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if not l_return then
						l_break := False
						if l_f_bisect = 0.0 then
							a_root.item := l_x_bisect
							a_x_lower.item := l_x_bisect
							a_x_upper.item := l_x_bisect
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (l_f_lower > 0.0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_f_bisect < 0.0 then
							a_root.item := 0.5 * (l_x_left + l_x_bisect)
							a_x_upper.item := l_x_bisect
							l_state.item.f_upper := l_f_bisect
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_f_lower < 0.0 then
							if l_f_bisect > 0.0 then
								a_root.item := 0.5 * (l_x_left + l_x_bisect)
								a_x_upper.item := l_x_bisect
								l_state.item.f_upper := l_f_bisect
							else
								a_root.item := 0.5 * (l_x_bisect + l_x_right)
								a_x_lower.item := l_x_bisect
								l_state.item.f_lower := l_f_bisect
							end
						else
							a_root.item := 0.5 * (l_x_bisect + l_x_right)
							a_x_lower.item := l_x_bisect
							l_state.item.f_lower := l_f_bisect
						end
				when 5 then
						Result := 0
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	bisection_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent bisection_iterate)
		end

end
