class
	P_BRENT_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public attributes

	brent_type: CE_STATIC [CE_ARRAY [PD_GSL_MIN_FMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MIN_FMINIMIZER_TYPE]}.make_initialized (<<
					create {PD_GSL_MIN_FMINIMIZER_TYPE}.make_initialized ([ce_string ("brent"), (create {PD_BRENT_STATE_T}.make).structure_size.to_natural_32, (create {PD_GSL_FUNCTION_STRUCT_STATIC}).brent_init_address, (create {PD_GSL_FUNCTION_STRUCT_STATIC}).brent_iterate_address])
				>>)
		end

	gsl_min_fminimizer_brent: CE_STATIC [CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := brent_type.item
		end

	brent_type___0: CE_STATIC [CE_ARRAY [PD_GSL_ROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ROOT_FSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_ROOT_FSOLVER_TYPE}.make_initialized ([ce_string ("brent"), (create {PD_BRENT_STATE_T2}.make).structure_size.to_natural_32, (create {PD_GSL_FUNCTION_STRUCT_STATIC}).brent_init___0_address, brent_iterate___0_address])
				>>)
		end

	gsl_root_fsolver_brent: CE_STATIC [CE_POINTER [PD_GSL_ROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := brent_type___0.item
		end

feature {ANY} -- public routines

	brent_iterate___0 (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root, a_x_lower, a_x_upper: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_BRENT_STATE_T2]
			l_tol: REAL_64
			l_m___4: REAL_64
			l_ac_equal: INTEGER_32
			l_a___5: REAL_64
			l_b___0: REAL_64
			l_c___1: REAL_64
			l_fa: REAL_64
			l_fb: REAL_64
			l_fc: REAL_64
			l_d: REAL_64
			l_e: REAL_64
			l_tmp: REAL_64
			l_p: REAL_64
			l_q___3: REAL_64
			l_r___3: REAL_64
			l_s: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___11: REAL_64
			l_tmp___13: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_CLASS_POINTER [PD_BRENT_STATE_T2]}.make_cast (a_vstate)
					l_ac_equal := 0
					l_a___5 := l_state.item.a
					l_b___0 := l_state.item.b
					l_c___1 := l_state.item.c
					l_fa := l_state.item.fa
					l_fb := l_state.item.fb
					l_fc := l_state.item.fc
					l_d := l_state.item.d
					l_e := l_state.item.e
					if not (l_fb < (0).to_double) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_fc < (0).to_double then
							l_ac_equal := 1
							l_c___1 := l_a___5
							l_fc := l_fa
							l_d := l_b___0 - l_a___5
							l_e := l_b___0 - l_a___5
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_fb > (0).to_double then
							if l_fc > (0).to_double then
								l_ac_equal := 1
								l_c___1 := l_a___5
								l_fc := l_fa
								l_d := l_b___0 - l_a___5
								l_e := l_b___0 - l_a___5
							end
						end
				when 4 then
					l_tmp := fabs (l_fc)
					if l_tmp < (fabs (l_fb)) then
						l_ac_equal := 1
						l_a___5 := l_b___0
						l_b___0 := l_c___1
						l_c___1 := l_a___5
						l_fa := l_fb
						l_fb := l_fc
						l_fc := l_fa
					end
					l_tol := (0.5 * 2.2204460492503131e-16) * (fabs (l_b___0))
					l_m___4 := 0.5 * (l_c___1 - l_b___0)
					if l_fb = (0).to_double then
						a_root.item := l_b___0
						a_x_lower.item := l_b___0
						a_x_upper.item := l_b___0
						Result := 0
						l_return := True
					end
					if not l_return then
						if (fabs (l_m___4)) <= l_tol then
							a_root.item := l_b___0
							if l_b___0 < l_c___1 then
								a_x_lower.item := l_b___0
								a_x_upper.item := l_c___1
							else
								a_x_lower.item := l_c___1
								a_x_upper.item := l_b___0
							end
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						if (fabs (l_e)) < l_tol then
							l_d := l_m___4
							l_e := l_m___4
						else
							l_tmp___11 := fabs (l_fa)
							if l_tmp___11 <= (fabs (l_fb)) then
								l_d := l_m___4
								l_e := l_m___4
							else
								l_s := l_fb / l_fa
								if l_ac_equal.to_boolean then
									l_p := ((2).to_double * l_m___4) * l_s
									l_q___3 := (1).to_double - l_s
								else
									l_q___3 := l_fa / l_fc
									l_r___3 := l_fb / l_fc
									l_p := l_s * ((((2).to_double * l_m___4) * l_q___3) * (l_q___3 - l_r___3) - (l_b___0 - l_a___5) * (l_r___3 - (1).to_double))
									l_q___3 := ((l_q___3 - (1).to_double) * (l_r___3 - (1).to_double)) * (l_s - (1).to_double)
								end
								if l_p > (0).to_double then
									l_q___3 := -l_q___3
								else
									l_p := -l_p
								end
								l_tmp___8 := fabs (l_tol * l_q___3)
								if ((3).to_double * l_m___4) * l_q___3 - l_tmp___8 < (fabs (l_e * l_q___3)) then
									l_tmp___7 := ((3).to_double * l_m___4) * l_q___3 - (fabs (l_tol * l_q___3))
								else
									l_tmp___7 := (fabs (l_e * l_q___3))
								end
								if (2).to_double * l_p < l_tmp___7 then
									l_e := l_d
									l_d := l_p / l_q___3
								else
									l_d := l_m___4
									l_e := l_m___4
								end
							end
						end
						l_a___5 := l_b___0
						l_fa := l_fb
						if (fabs (l_d)) > l_tol then
							l_b___0 := l_b___0 + l_d
						else
							if l_m___4 > (0).to_double then
								l_tmp___13 := l_tol
							else
								l_tmp___13 := -l_tol
							end
							l_b___0 := l_b___0 + l_tmp___13
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_fb := (a_f.item.function).real_64_item ([l_b___0, a_f.item.params])
							if not ((create {P_INFNAN_STATIC}).gsl_finite (l_fb)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).gsl_error (ce_string ("function value is not finite"), ce_string ("brent.c"), 202, 9)
									Result := 9
									l_return := True
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								l_break := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 5 then -- if:
						l_break := False
						l_state.item.a := l_a___5
						l_state.item.b := l_b___0
						l_state.item.c := l_c___1
						l_state.item.d := l_d
						l_state.item.e := l_e
						l_state.item.fa := l_fa
						l_state.item.fb := l_fb
						l_state.item.fc := l_fc
						a_root.item := l_b___0
						if not (l_fb < (0).to_double) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_fc < (0).to_double then
							l_c___1 := l_a___5
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___0:
						if l_fb > (0).to_double then
							if l_fc > (0).to_double then
								l_c___1 := l_a___5
							end
						end
				when 9 then
						if l_b___0 < l_c___1 then
							a_x_lower.item := l_b___0
							a_x_upper.item := l_c___1
						else
							a_x_lower.item := l_c___1
							a_x_upper.item := l_b___0
						end
						Result := 0
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	brent_iterate___0_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent brent_iterate___0)
		end

end
