class
	P_CAUCHY_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_cauchy_pdf (a_x, a_a___5: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_p: REAL_64
		do
			l_u := a_x / a_a___5
			l_p := ((1).to_double / (3.14159265358979323846 * a_a___5)) / ((1).to_double + l_u * l_u)
			Result := l_p
		end

	gsl_cdf_cauchy_P (a_x, a_a___5: REAL_64): REAL_64
		local
			l_P___2: REAL_64
			l_u: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u > (-1).to_double then
				l_P___2 := 0.5 + (atan (l_u)) / 3.14159265358979323846
			else
				l_P___2 := (atan ((-1).to_double / l_u)) / 3.14159265358979323846
			end
			Result := l_P___2
		end

	gsl_cdf_cauchy_Q (a_x, a_a___5: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
			l_u: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u < (1).to_double then
				l_Q___1 := 0.5 - (atan (l_u)) / 3.14159265358979323846
			else
				l_Q___1 := (atan ((1).to_double / l_u)) / 3.14159265358979323846
			end
			Result := l_Q___1
		end

end
