class
	P_CAUCHYINV_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_cdf_cauchy_Pinv (a_P___2, a_a___5: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_return: BOOLEAN
		do
			if a_P___2 = 1.0 then
				Result := (builtin_inff).to_double
				l_return := True
			elseif a_P___2 = 0.0 then
				Result := (-(builtin_inff)).to_double
				l_return := True
			end
			if not l_return then
				if a_P___2 > 0.5 then
					l_x := a_a___5 * (tan (3.14159265358979323846 * (a_P___2 - 0.5)))
				else
					l_x := -a_a___5 / (tan (3.14159265358979323846 * a_P___2))
				end
				Result := l_x
			end
		end

	gsl_cdf_cauchy_Qinv (a_Q___1, a_a___5: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_return: BOOLEAN
		do
			if a_Q___1 = 0.0 then
				Result := (builtin_inff).to_double
				l_return := True
			elseif a_Q___1 = 1.0 then
				Result := (-(builtin_inff)).to_double
				l_return := True
			end
			if not l_return then
				if a_Q___1 > 0.5 then
					l_x := a_a___5 * (tan (3.14159265358979323846 * (0.5 - a_Q___1)))
				else
					l_x := a_a___5 / (tan (3.14159265358979323846 * a_Q___1))
				end
				Result := l_x
			end
		end

end
