class
	P_CHISQ_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_chisq_pdf (a_x, a_nu: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lngamma: REAL_64
		do
			if a_x <= (0).to_double then
				Result := (0).to_double
			else
				l_lngamma := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_nu / (2).to_double))
				l_p := (exp (((a_nu / (2).to_double - (1).to_double) * (log (a_x / (2).to_double)) - a_x / (2).to_double) - l_lngamma)) / (2).to_double
				Result := l_p
			end
		end

	gsl_cdf_chisq_P (a_x, a_nu: REAL_64): REAL_64
		do
			Result := ((create {P_GAMMA_STATIC}).gsl_cdf_gamma_P (a_x, a_nu / (2).to_double, 2.0))
		end

	gsl_cdf_chisq_Q (a_x, a_nu: REAL_64): REAL_64
		do
			Result := ((create {P_GAMMA_STATIC}).gsl_cdf_gamma_Q (a_x, a_nu / (2).to_double, 2.0))
		end

end
