class
	P_CONJUGATE_FR_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public attributes

	conjugate_fr_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE}.make_initialized ([ce_string ("conjugate_fr"), (create {PD_CONJUGATE_FR_STATE_T}.make).structure_size.to_natural_32, conjugate_fr_alloc_address, (create {PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT_STATIC}).conjugate_fr_set_address, conjugate_fr_iterate_address, conjugate_fr_restart_address, conjugate_fr_free_address])
				>>)
		end

	gsl_multimin_fdfminimizer_conjugate_fr: CE_STATIC [CE_POINTER [PD_GSL_MULTIMIN_FDFMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := conjugate_fr_type.item
		end

feature {ANY} -- public routines

	conjugate_fr_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_CONJUGATE_FR_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_CONJUGATE_FR_STATE_T]}.make_cast (a_vstate)
			l_state.item.x1 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
			if (l_state.item.x1).is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x1"), ce_string ("conjugate_fr.c"), 55, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.dx1 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.dx1).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dx1"), ce_string ("conjugate_fr.c"), 63, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.x2 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.x2).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dx1);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x2"), ce_string ("conjugate_fr.c"), 72, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.p := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.p).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x2);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dx1);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for p"), ce_string ("conjugate_fr.c"), 82, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.g0 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if (l_state.item.g0).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x2);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dx1);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for g0"), ce_string ("conjugate_fr.c"), 93, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	conjugate_fr_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_CONJUGATE_FR_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_CONJUGATE_FR_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.g0);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.p);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x2);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.dx1);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x1)
		end

	conjugate_fr_restart (a_vstate: CE_POINTER [ANY]): INTEGER_32
		local
			l_state: CE_POINTER [PD_CONJUGATE_FR_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_CONJUGATE_FR_STATE_T]}.make_cast (a_vstate)
			l_state.item.iter := 0
			Result := 0
		end

	conjugate_fr_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [REAL_64]; a_gradient, a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_f.is_void
			not a_dx.is_void
		local
			l_state: CE_POINTER [PD_CONJUGATE_FR_STATE_T]
			l_x1___0: CE_POINTER [PD_GSL_VECTOR]
			l_dx1: CE_POINTER [PD_GSL_VECTOR]
			l_x2___1: CE_POINTER [PD_GSL_VECTOR]
			l_p: CE_POINTER [PD_GSL_VECTOR]
			l_g0: CE_POINTER [PD_GSL_VECTOR]
			l_pnorm: REAL_64
			l_g0norm: REAL_64
			l_fa: REAL_64
			l_fb: CE_ARRAY [REAL_64]
			l_fc: REAL_64
			l_dir: REAL_64
			l_stepa: REAL_64
			l_stepb: CE_ARRAY [REAL_64]
			l_stepc: REAL_64
			l_tol: REAL_64
			l_g1norm: CE_ARRAY [REAL_64]
			l_pg: CE_ARRAY [REAL_64]
			l_beta: REAL_64
			l_return: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_fb.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_stepb.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_g1norm.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_pg.make (<<1>>)

			l_state := create {CE_CLASS_POINTER [PD_CONJUGATE_FR_STATE_T]}.make_cast (a_vstate)
			l_x1___0 := l_state.item.x1
			l_dx1 := l_state.item.dx1
			l_x2___1 := l_state.item.x2
			l_p := l_state.item.p
			l_g0 := l_state.item.g0
			l_pnorm := l_state.item.pnorm
			l_g0norm := l_state.item.g0norm
			l_fa := a_f.item
			l_stepa := 0.0
			l_stepc := l_state.item.step
			l_tol := l_state.item.tol
			if l_pnorm = 0.0 then
				a_dx.item.gsl_vector_set_zero
				Result := 27
				l_return := True
			elseif l_g0norm = 0.0 then
				a_dx.item.gsl_vector_set_zero
				Result := 27
				l_return := True
			end
			if not l_return then
				l_p.item.gsl_blas_ddot (a_gradient, l_pg).do_nothing
				if l_pg.item >= 0.0 then
					l_dir := 1.0
				else
					l_dir := -1.0
				end
				(create {P_DIRECTIONAL_MINIMIZE_STATIC}).take_step___1 (a_x, l_p, l_stepc, l_dir / l_pnorm, l_x1___0, a_dx)
				l_fc := (a_fdf.item.f).real_64_item ([l_x1___0, a_fdf.item.params])
				if l_fc < l_fa then
					l_state.item.step := l_stepc * 2.0
					a_f.item := l_fc
					a_x.item.gsl_vector_memcpy (l_x1___0).do_nothing;
					(a_fdf.item.df).call ([l_x1___0, a_fdf.item.params, a_gradient])
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				a_fdf.item.intermediate_point___1 (a_x, l_p, l_dir / l_pnorm, l_pg.item, l_stepa, l_stepc, l_fa, l_fc, l_x1___0, l_dx1, a_gradient, l_stepb, l_fb)
				if l_stepb.item = 0.0 then
					Result := 27
					l_return := True
				end
			end
			if not l_return then
				(create {P_DIRECTIONAL_MINIMIZE_STATIC}).minimize___1 (a_fdf, a_x, l_p, l_dir / l_pnorm, l_stepa, l_stepb.item, l_stepc, l_fa, l_fb.item, l_fc, l_tol, l_x1___0, l_dx1, l_x2___1, a_dx, a_gradient, create {CE_REAL_64_POINTER}.make_shared (l_state.c_pointer + (create {PD_CONJUGATE_FR_STATE_T}.make).offset_of ("step")), a_f, l_g1norm)
				a_x.item.gsl_vector_memcpy (l_x2___1).do_nothing
				l_state.item.iter := ((l_state.item.iter + 1).to_natural_32 \\ a_x.item.size).to_integer_32
				if l_state.item.iter = 0 then
					l_p.item.gsl_vector_memcpy (a_gradient).do_nothing
					l_state.item.pnorm := l_g1norm.item
				else
					l_beta := -(pow (l_g1norm.item / l_g0norm, 2.0))
					l_p.item.gsl_blas_dscal (-l_beta)
					a_gradient.item.gsl_blas_daxpy (1.0, l_p).do_nothing
					l_state.item.pnorm := l_p.item.gsl_blas_dnrm2
				end
				l_state.item.g0norm := l_g1norm.item
				l_g0.item.gsl_vector_memcpy (a_gradient).do_nothing
				Result := 0
			end
		end

feature {ANY} -- routine addresses

	conjugate_fr_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent conjugate_fr_alloc)
		end

	conjugate_fr_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent conjugate_fr_free)
		end

	conjugate_fr_restart_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent conjugate_fr_restart)
		end

	conjugate_fr_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent conjugate_fr_iterate)
		end

end
