class
	P_DHT_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_dht_alloc (a_size: NATURAL_32): CE_POINTER [PD_GSL_DHT_STRUCT]
		local
			l_t: CE_POINTER [PD_GSL_DHT_STRUCT]
			l_return, l_break: BOOLEAN
		do
			if a_size = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("size == 0"), ce_string ("dht.c"), 37, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_DHT_STRUCT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_t := create {CE_CLASS_POINTER [PD_GSL_DHT_STRUCT]}.make_cast ((malloc ((create {PD_GSL_DHT_STRUCT}.make).structure_size.to_natural_32)))
				if l_t.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("out of memory"), ce_string ("dht.c"), 43, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_DHT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_t.item.size := a_size
				l_t.item.xmax := -1.0
				l_t.item.nu := -1.0
				l_t.item.j := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_size + {NATURAL_32} 2) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_t.item.j).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_t))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("could not allocate memory for j"), ce_string ("dht.c"), 55, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_DHT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_t.item.Jjj := create {CE_REAL_64_POINTER}.make_cast ((malloc (((a_size * (a_size + {NATURAL_32} 1)) // {NATURAL_32} 2) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_t.item.Jjj).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_t.item.j))
					free (create {CE_VOID_POINTER}.make_cast (l_t))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("could not allocate memory for Jjj"), ce_string ("dht.c"), 63, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_DHT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_t.item.J2 := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_size + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_t.item.J2).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_t.item.Jjj))
					free (create {CE_VOID_POINTER}.make_cast (l_t.item.j))
					free (create {CE_VOID_POINTER}.make_cast (l_t))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("could not allocate memory for J2"), ce_string ("dht.c"), 72, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_DHT_STRUCT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_t
			end
		end

	gsl_dht_new (a_size: NATURAL_32; a_nu, a_xmax: REAL_64): CE_POINTER [PD_GSL_DHT_STRUCT]
		local
			l_status: INTEGER_32
			l_dht: CE_POINTER [PD_GSL_DHT_STRUCT]
			l_return: BOOLEAN
		do
			l_dht := (gsl_dht_alloc (a_size))
			if l_dht.is_void then
				Result := (create {CE_CLASS_POINTER [PD_GSL_DHT_STRUCT]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_status := l_dht.item.gsl_dht_init (a_nu, a_xmax)
				if l_status.to_boolean then
					Result := (create {CE_CLASS_POINTER [PD_GSL_DHT_STRUCT]}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				Result := l_dht
			end
		end

	gsl_dht_free (a_t: CE_POINTER [PD_GSL_DHT_STRUCT])
		local
			l_return: BOOLEAN
		do
			if a_t.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_t.item.J2))
				free (create {CE_VOID_POINTER}.make_cast (a_t.item.Jjj))
				free (create {CE_VOID_POINTER}.make_cast (a_t.item.j))
				free (create {CE_VOID_POINTER}.make_cast (a_t))
			end
		end

end
