class
	P_DNEWTON_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	dnewton_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIROOT_FSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIROOT_FSOLVER_TYPE}.make_initialized ([ce_string ("dnewton"), (create {PD_DNEWTON_STATE_T}.make).structure_size.to_natural_32, dnewton_alloc_address, (create {PD_GSL_MULTIROOT_FUNCTION_STRUCT_STATIC}).dnewton_set_address, (create {PD_GSL_MULTIROOT_FUNCTION_STRUCT_STATIC}).dnewton_iterate_address, dnewton_free_address])
				>>)
		end

	gsl_multiroot_fsolver_dnewton: CE_STATIC [CE_POINTER [PD_GSL_MULTIROOT_FSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := dnewton_type.item
		end

feature {ANY} -- public routines

	dnewton_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_DNEWTON_STATE_T]
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			l_J: CE_POINTER [PD_GSL_MATRIX]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_DNEWTON_STATE_T]}.make_cast (a_vstate)
			l_m___4 := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
			if l_m___4.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for lu"), ce_string ("dnewton.c"), 64, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.lu := l_m___4
				l_p := (create {P_INIT_STATIC}).gsl_permutation_calloc (a_n)
				if l_p.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for permutation"), ce_string ("dnewton.c"), 75, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.permutation := l_p
				l_J := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
				if l_J.is_void then
					(create {P_INIT_STATIC}).gsl_permutation_free (l_p);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for d"), ce_string ("dnewton.c"), 87, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.J := l_J
				Result := 0
			end
		end

	dnewton_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_DNEWTON_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_DNEWTON_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.J);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.lu);
			(create {P_INIT_STATIC}).gsl_permutation_free (l_state.item.permutation)
		end

feature {ANY} -- routine addresses

	dnewton_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent dnewton_alloc)
		end

	dnewton_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent dnewton_free)
		end

end
