class
	P_ERFC_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_sf_erfc (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_erfc_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_erfc_e(x, &result)"), ce_string ("erfc.c"), 438, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_log_erfc (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_log_erfc_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_log_erfc_e(x, &result)"), ce_string ("erfc.c"), 443, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_erf (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_erf_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_erf_e(x, &result)"), ce_string ("erfc.c"), 448, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_erf_Z (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_erf_Z_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_erf_Z_e(x, &result)"), ce_string ("erfc.c"), 453, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_erf_Q (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_erf_Q_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_erf_Q_e(x, &result)"), ce_string ("erfc.c"), 458, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_hazard (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_hazard_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_hazard_e(x, &result)"), ce_string ("erfc.c"), 463, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
