class
	P_EXPM1_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_expm1 (a_x: REAL_64): REAL_64
		local
			l_i: REAL_64
			l_sum: REAL_64
			l_term: REAL_64
			l_tmp: REAL_64
			l_break: BOOLEAN
		do
			if (fabs (a_x)) < 0.69314718055994530942 then
				l_i := 1.0
				l_sum := a_x
				l_term := a_x / 1.0
				from
				until
					(l_break)
				loop
					l_break := False
					l_i := l_i + (1).to_double
					l_term := l_term * (a_x / l_i)
					l_sum := l_sum + l_term
					l_tmp := fabs (l_term)
					if not (l_tmp > (fabs (l_sum)) * 2.2204460492503131e-16) then
						l_break := True
					end
				end
				l_break := False
				Result := l_sum
			else
				Result := ((exp (a_x)) - (1).to_double)
			end
		end

end
