class
	P_EXPPOW_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_exppow_pdf (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lngamma: REAL_64
		do
			l_lngamma := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma ((1).to_double + (1).to_double / a_b___0))
			l_p := ((1).to_double / ((2).to_double * a_a___5)) * (exp (-(pow ((fabs (a_x / a_a___5)), a_b___0)) - l_lngamma))
			Result := l_p
		end

	gsl_cdf_exppow_P (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_P___2: REAL_64
			l_P___3: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u < (0).to_double then
				l_P___2 := 0.5 * ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_Q (1.0 / a_b___0, (pow (-l_u, a_b___0))))
				Result := l_P___2
			else
				l_P___3 := 0.5 * (1.0 + ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_P (1.0 / a_b___0, (pow (l_u, a_b___0)))))
				Result := l_P___3
			end
		end

	gsl_cdf_exppow_Q (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_Q___1: REAL_64
			l_Q___2: REAL_64
		do
			l_u := a_x / a_a___5
			if l_u < (0).to_double then
				l_Q___1 := 0.5 * (1.0 + ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_P (1.0 / a_b___0, (pow (-l_u, a_b___0)))))
				Result := l_Q___1
			else
				l_Q___2 := 0.5 * ((create {P_GAMMA_INC_STATIC}).gsl_sf_gamma_inc_Q (1.0 / a_b___0, (pow (l_u, a_b___0))))
				Result := l_Q___2
			end
		end

end
