class
	P_FISHMAN18_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	ran_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("fishman18"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 1, (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32, ran_set_address, ran_get_address, ran_get_double_address])
				>>)
		end

	gsl_rng_fishman18: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran_type.item
		end

feature {ANY} -- public routines

	ran_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := (create {P_SCHRAGE_STATIC}).schrage_mult ({NATURAL_32} 62_089_911, l_state.item.x, {NATURAL_32} 2_147_483_647, {NATURAL_32} 46_341)
			Result := (l_state.item.x)
		end

	ran_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			Result := ((ran_get (create {CE_VOID_POINTER}.make_cast (l_state))).to_real_64 / 2147483647.0)
		end

	ran_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			if l_s \\ {NATURAL_32} 2_147_483_647 = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := l_s \\ {NATURAL_32} 2_147_483_647
		end

feature {ANY} -- routine addresses

	ran_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get)
		end

	ran_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_get_double)
		end

	ran_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran_set)
		end

end
