class
	P_GAUSSTAIL_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_gaussian_tail_pdf (a_x, a_a___5, a_sigma: REAL_64): REAL_64
		local
			l_N: REAL_64
			l_p: REAL_64
			l_u: REAL_64
			l_f: REAL_64
			l_tmp___1: REAL_64
		do
			if a_x < a_a___5 then
				Result := (0).to_double
			else
				l_u := a_x / a_sigma
				l_f := ((create {P_ERFC_STATIC}).gsl_sf_erfc (a_a___5 / ((sqrt (2.0)) * a_sigma)))
				l_N := 0.5 * l_f
				l_tmp___1 := sqrt ((2).to_double * 3.14159265358979323846)
				l_p := ((1).to_double / ((l_N * l_tmp___1) * a_sigma)) * (exp ((-l_u * l_u) / (2).to_double))
				Result := l_p
			end
		end

	gsl_ran_ugaussian_tail_pdf (a_x, a_a___5: REAL_64): REAL_64
		do
			Result := (gsl_ran_gaussian_tail_pdf (a_x, a_a___5, 1.0))
		end

end
