class
	P_GETSET_SOURCE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_matrix_complex_long_double_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_row_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] := l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_column_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[((l_stride * {NATURAL_32} 2) * l_i + l_k).to_integer_32] := l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_row_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] := l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_column_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[((l_stride * {NATURAL_32} 2) * l_i + l_k).to_integer_32] := l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_row_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] := l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_column_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + ({NATURAL_32} 2 * a_j).to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_v_data[((l_stride * {NATURAL_32} 2) * l_i + l_k).to_integer_32] := l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_row_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_double_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_96]
			l_column_data: CE_POINTER [REAL_96]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_get_row (a_v: CE_POINTER [PD_GSL_VECTOR]; a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_row_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_get_col (a_v: CE_POINTER [PD_GSL_VECTOR]; a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_64]
			l_column_data: CE_POINTER [REAL_64]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_float_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_row_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_float_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_column_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_row_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ulong_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_column_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_row_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_long_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_column_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uint_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_row_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uint_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_32]
			l_column_data: CE_POINTER [NATURAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_int_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_row_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_int_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_32]
			l_column_data: CE_POINTER [INTEGER_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_16]
			l_row_data: CE_POINTER [NATURAL_16]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_ushort_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_16]
			l_column_data: CE_POINTER [NATURAL_16]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_short_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_16]
			l_row_data: CE_POINTER [INTEGER_16]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_short_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_16]
			l_column_data: CE_POINTER [INTEGER_16]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_8]
			l_row_data: CE_POINTER [NATURAL_8]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_uchar_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [NATURAL_8]
			l_column_data: CE_POINTER [NATURAL_8]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_char_get_row (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_i: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_8]
			l_row_data: CE_POINTER [INTEGER_8]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 16, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 22, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := (a_m___4.item.data + (a_i * l_tda).to_integer_32)
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_j + l_k).to_integer_32] := l_row_data[(l_j + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_char_get_col (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_j: NATURAL_32): INTEGER_32
		require
			not a_m___4.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [INTEGER_8]
			l_column_data: CE_POINTER [INTEGER_8]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_m___4.item.size1
			l_N := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 57, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 63, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := (a_m___4.item.data + a_j.to_integer_32)
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 1)
					loop
						l_v_data[(l_stride * l_i + l_k).to_integer_32] := l_column_data[(l_i * l_tda + l_k).to_integer_32]
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

end
