class
	P_GNEWTON_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	gnewton_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIROOT_FDFSOLVER_TYPE}.make_initialized ([ce_string ("gnewton"), (create {PD_GNEWTON_STATE_T}.make).structure_size.to_natural_32, gnewton_alloc_address, (create {PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC}).gnewton_set_address, (create {PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC}).gnewton_iterate_address, gnewton_free_address])
				>>)
		end

	gsl_multiroot_fdfsolver_gnewton: CE_STATIC [CE_POINTER [PD_GSL_MULTIROOT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := gnewton_type.item
		end

feature {ANY} -- public routines

	gnewton_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_GNEWTON_STATE_T]
			l_d: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_m___4: CE_POINTER [PD_GSL_MATRIX]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_GNEWTON_STATE_T]}.make_cast (a_vstate)
			l_m___4 := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_n)
			if l_m___4.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for lu"), ce_string ("gnewton.c"), 64, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.lu := l_m___4
				l_p := (create {P_INIT_STATIC}).gsl_permutation_calloc (a_n)
				if l_p.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for permutation"), ce_string ("gnewton.c"), 75, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.permutation := l_p
				l_d := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_d.is_void then
					(create {P_INIT_STATIC}).gsl_permutation_free (l_p);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for d"), ce_string ("gnewton.c"), 87, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.d := l_d
				l_x_trial := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_x_trial.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_d);
					(create {P_INIT_STATIC}).gsl_permutation_free (l_p);
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_m___4)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("gnewton.c"), 100, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.x_trial := l_x_trial
				Result := 0
			end
		end

	gnewton_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_GNEWTON_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_GNEWTON_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.d);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x_trial);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.lu);
			(create {P_INIT_STATIC}).gsl_permutation_free (l_state.item.permutation)
		end

feature {ANY} -- routine addresses

	gnewton_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gnewton_alloc)
		end

	gnewton_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent gnewton_free)
		end

end
