class
	P_GSL_GSL_POLY_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_poly_eval (a_c___1: CE_POINTER [REAL_64]; a_len: INTEGER_32; a_x: REAL_64): REAL_64
		require
			not a_c___1.is_void
		local
			l_i: INTEGER_32
			l_ans: REAL_64
		do
			l_ans := a_c___1[(a_len - 1)]
			l_i := a_len - 1
			from
			until
				not (l_i > 0)
			loop
				l_ans := (a_c___1[(l_i - 1)] + (a_x * l_ans))
				l_i := l_i - 1
			end
			Result := l_ans
		end

	gsl_poly_complex_eval (a_c___1: CE_POINTER [REAL_64]; a_len: INTEGER_32; a_z: PD_GSL_COMPLEX): PD_GSL_COMPLEX
		require
			not a_c___1.is_void
		local
			l_i: INTEGER_32
			l_ans: PD_GSL_COMPLEX
			l_tmp: REAL_64
			l_return, l_break: BOOLEAN
		do
			create l_ans.make

			from
			until
				(l_break)
			loop
				l_break := False
				l_ans.dat[0] := a_c___1[(a_len - 1)]
				l_ans.dat[1] := 0.0
				l_break := True
			end
			l_break := False
			l_i := a_len - 1
			from
			until
				not (not (l_return) and then (l_i > 0))
			loop
				l_tmp := ((a_c___1[(l_i - 1)] + (a_z.dat[0] * l_ans.dat[0])) - (a_z.dat[1] * l_ans.dat[1]))
				from
				until
					(l_break)
				loop
					l_break := False
					l_ans.dat[1] := a_z.dat[1] * l_ans.dat[0] + a_z.dat[0] * l_ans.dat[1]
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_ans.dat[0] := l_tmp
					l_break := True
				end
				l_break := False
				l_i := l_i - 1
			end
			Result := l_ans.twin
		end

	gsl_complex_poly_complex_eval (a_c___1: CE_POINTER [PD_GSL_COMPLEX]; a_len: INTEGER_32; a_z: PD_GSL_COMPLEX): PD_GSL_COMPLEX
		require
			not a_c___1.is_void
		local
			l_i: INTEGER_32
			l_ans: PD_GSL_COMPLEX
			l_tmp: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_ans := (a_c___1[(a_len - 1)]).twin
			l_i := a_len - 1
			from
			until
				not (not (l_return) and then (l_i > 0))
			loop
				l_tmp := ((a_c___1 + (l_i - 1)).item.dat[0] + a_z.dat[0] * l_ans.dat[0]) - a_z.dat[1] * l_ans.dat[1]
				from
				until
					(l_break)
				loop
					l_break := False
					l_ans.dat[1] := ((a_c___1 + (l_i - 1)).item.dat[1] + a_z.dat[1] * l_ans.dat[0]) + a_z.dat[0] * l_ans.dat[1]
					l_break := True
				end
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					l_ans.dat[0] := l_tmp
					l_break := True
				end
				l_break := False
				l_i := l_i - 1
			end
			Result := l_ans.twin
		end

	gsl_poly_dd_eval (a_dd, a_xa: CE_POINTER [REAL_64]; a_size: NATURAL_32; a_x: REAL_64): REAL_64
		require
			not a_dd.is_void
		local
			l_i: NATURAL_32
			l_y: REAL_64
			l_tmp: NATURAL_32
			l_break: BOOLEAN
		do
			l_y := a_dd[(a_size - {NATURAL_32} 1).to_integer_32]
			l_i := a_size - {NATURAL_32} 1
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := l_i
				l_i := l_i - 1
				if not l_tmp.to_boolean then
					l_break := True
				end
				if not (l_break) then
					l_y := (a_dd[l_i.to_integer_32] + ((a_x - a_xa[l_i.to_integer_32]) * l_y))
				end
			end
			l_break := False
			Result := l_y
		end

end
