class
	P_GUMBEL1_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_cdf_gumbel1_P (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_P___2: REAL_64
		do
			l_u := a_a___5 * a_x - (log (a_b___0))
			l_P___2 := (exp (-(exp (-l_u))))
			Result := l_P___2
		end

	gsl_cdf_gumbel1_Q (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_Q___1: REAL_64
			l_P___2: REAL_64
		do
			l_u := a_a___5 * a_x - (log (a_b___0))
			l_P___2 := (exp (-(exp (-l_u))))
			if l_P___2 < 0.5 then
				l_Q___1 := (1).to_double - l_P___2
			else
				l_Q___1 := -(expm1 (-(exp (-l_u))))
			end
			Result := l_Q___1
		end

end
