class
	P_INIT2D_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_histogram2d_alloc (a_nx, a_ny: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM2D]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM2D]
			l_return, l_break: BOOLEAN
		do
			if a_nx = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("histogram2d length nx must be positive integer"), ce_string ("init2d.c"), 34, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_ny = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("histogram2d length ny must be positive integer"), ce_string ("init2d.c"), 40, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_h := create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_cast ((malloc ((create {PD_GSL_HISTOGRAM2D}.make).structure_size.to_natural_32)))
				if l_h.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d struct"), ce_string ("init2d.c"), 48, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.xrange := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_nx + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.xrange).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_h))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d x ranges"), ce_string ("init2d.c"), 58, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.yrange := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_ny + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.yrange).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_h.item.xrange))
					free (create {CE_VOID_POINTER}.make_cast (l_h))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d y ranges"), ce_string ("init2d.c"), 69, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.bin := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_nx * a_ny) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.bin).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_h.item.xrange))
					free (create {CE_VOID_POINTER}.make_cast (l_h.item.yrange))
					free (create {CE_VOID_POINTER}.make_cast (l_h))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram bins"), ce_string ("init2d.c"), 81, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.nx := a_nx
				l_h.item.ny := a_ny
				Result := l_h
			end
		end

	make_uniform (a_range: CE_POINTER [REAL_64]; a_n: NATURAL_32; a_xmin, a_xmax: REAL_64)
		local
			l_i: NATURAL_32
			l_f1: REAL_64
			l_f2: REAL_64
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i <= a_n)
			loop
				l_f1 := (a_n - l_i).to_real_64 / a_n.to_real_64
				l_f2 := l_i.to_real_64 / a_n.to_real_64
				a_range[l_i.to_integer_32] := l_f1 * a_xmin + l_f2 * a_xmax
				l_i := l_i + 1
			end
		end

	gsl_histogram2d_calloc_uniform (a_nx, a_ny: NATURAL_32; a_xmin, a_xmax, a_ymin, a_ymax: REAL_64): CE_POINTER [PD_GSL_HISTOGRAM2D]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM2D]
			l_return, l_break: BOOLEAN
		do
			if a_xmin >= a_xmax then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("xmin must be less than xmax"), ce_string ("init2d.c"), 112, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_ymin >= a_ymax) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("ymin must be less than ymax"), ce_string ("init2d.c"), 117, 4)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_h := gsl_histogram2d_calloc (a_nx, a_ny)
				if l_h.is_void then
					Result := l_h
					l_return := True
				end
			end
			if not l_return then
				make_uniform (l_h.item.xrange, a_nx, a_xmin, a_xmax)
				make_uniform (l_h.item.yrange, a_ny, a_ymin, a_ymax)
				Result := l_h
			end
		end

	gsl_histogram2d_calloc (a_nx, a_ny: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM2D]
		local
			l_h: CE_POINTER [PD_GSL_HISTOGRAM2D]
			l_i: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_nx = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("histogram2d length nx must be positive integer"), ce_string ("init2d.c"), 141, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_ny = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("histogram2d length ny must be positive integer"), ce_string ("init2d.c"), 147, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_h := create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_cast ((malloc ((create {PD_GSL_HISTOGRAM2D}.make).structure_size.to_natural_32)))
				if l_h.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d struct"), ce_string ("init2d.c"), 155, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.xrange := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_nx + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.xrange).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_h))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d x ranges"), ce_string ("init2d.c"), 165, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.yrange := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_ny + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.yrange).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_h.item.xrange))
					free (create {CE_VOID_POINTER}.make_cast (l_h))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram2d y ranges"), ce_string ("init2d.c"), 176, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_h.item.bin := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_nx * a_ny) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_h.item.bin).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_h.item.xrange))
					free (create {CE_VOID_POINTER}.make_cast (l_h.item.yrange))
					free (create {CE_VOID_POINTER}.make_cast (l_h))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram bins"), ce_string ("init2d.c"), 188, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM2D]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_nx + {NATURAL_32} 1)
				loop
					l_h.item.xrange[l_i.to_integer_32] := l_i.to_real_64
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_ny + {NATURAL_32} 1)
				loop
					l_h.item.yrange[l_i.to_integer_32] := l_i.to_real_64
					l_i := l_i + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_nx * a_ny)
				loop
					l_h.item.bin[l_i.to_integer_32] := (0).to_double
					l_i := l_i + 1
				end
				l_h.item.nx := a_nx
				l_h.item.ny := a_ny
				Result := l_h
			end
		end

	gsl_histogram2d_free (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D])
		local
			l_return: BOOLEAN
		do
			if a_h.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_h.item.xrange))
				free (create {CE_VOID_POINTER}.make_cast (a_h.item.yrange))
				free (create {CE_VOID_POINTER}.make_cast (a_h.item.bin))
				free (create {CE_VOID_POINTER}.make_cast (a_h))
			end
		end

end
