class
	P_LEGENDRE_H3D_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_sf_legendre_H3d_array (a_lmax: INTEGER_32; a_lambda, a_eta: REAL_64; a_result_array: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_ell: INTEGER_32
			l_ell___0: INTEGER_32
			l_H0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat: INTEGER_32
			l_r_Hlp1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Hl: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_lmax: INTEGER_32
			l_stat_lmaxm1: INTEGER_32
			l_stat_max: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_coth_eta: REAL_64
			l_stat_recursion: INTEGER_32
			l_Hlp1: REAL_64
			l_Hl: REAL_64
			l_Hlm1: REAL_64
			l_ell___1: INTEGER_32
			l_root_term_0: REAL_64
			l_root_term_1: REAL_64
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_H0.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_Hlp1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r_Hl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_eta < 0.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_lmax < 0) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_ell := 0
						from
						until
							not (l_ell <= a_lmax)
						loop
							a_result_array[l_ell] := 0.0
							l_ell := l_ell + 1
						end
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("legendre_H3d.c"), 503, 1)
							Result := 1
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_eta > 7.0978271289338397e+02 then
							l_ell___0 := 0
							from
							until
								not (l_ell___0 <= a_lmax)
							loop
								a_result_array[l_ell___0] := 0.0
								l_ell___0 := l_ell___0 + 1
							end
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("overflow"), ce_string ("legendre_H3d.c"), 509, 16)
								Result := 16
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						elseif a_lmax = 0 then
							l_stat := (l_H0.item.gsl_sf_legendre_H3d_e (0, a_lambda, a_eta))
							a_result_array[0] := l_H0.item.val
							Result := l_stat
							l_return := True
						else
							l_stat_lmax := (l_r_Hlp1.item.gsl_sf_legendre_H3d_e (a_lmax, a_lambda, a_eta))
							l_stat_lmaxm1 := (l_r_Hl.item.gsl_sf_legendre_H3d_e (a_lmax - 1, a_lambda, a_eta))
							if l_stat_lmax /= 0 then
								l_tmp___3 := l_stat_lmax
							else
								if l_stat_lmaxm1 /= 0 then
									l_tmp___2 := l_stat_lmaxm1
								else
									l_tmp___2 := 0
								end
								l_tmp___3 := l_tmp___2
							end
							l_stat_max := l_tmp___3
							l_coth_eta := 1.0 / (tanh (a_eta))
							l_stat_recursion := 0
							l_Hlp1 := l_r_Hlp1.item.val
							l_Hl := l_r_Hl.item.val
							a_result_array[a_lmax] := l_Hlp1
							a_result_array[(a_lmax - 1)] := l_Hl
							l_ell___1 := a_lmax - 1
							from
							until
								not (l_ell___1 > 0)
							loop
								l_root_term_0 := (hypot (a_lambda, l_ell___1.to_double))
								l_root_term_1 := (hypot (a_lambda, l_ell___1.to_double + 1.0))
								l_Hlm1 := (((2.0 * l_ell___1.to_double + 1.0) * l_coth_eta) * l_Hl - l_root_term_1 * l_Hlp1) / l_root_term_0
								a_result_array[(l_ell___1 - 1)] := l_Hlm1
								if not (l_Hlm1 < 1.7976931348623157e+308) then
									l_stat_recursion := 16
								end
								l_Hlp1 := l_Hl
								l_Hl := l_Hlm1
								l_ell___1 := l_ell___1 - 1
							end
							if l_stat_recursion /= 0 then
								l_tmp___8 := l_stat_recursion
							else
								if l_stat_max /= 0 then
									l_tmp___7 := l_stat_max
								else
									l_tmp___7 := 0
								end
								l_tmp___8 := l_tmp___7
							end
							Result := l_tmp___8
							l_return := True
						end
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_legendre_H3d_0 (a_lambda, a_eta: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_legendre_H3d_0_e (a_lambda, a_eta))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_legendre_H3d_0_e(lambda, eta, &result)"), ce_string ("legendre_H3d.c"), 557, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_legendre_H3d_1 (a_lambda, a_eta: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_legendre_H3d_1_e (a_lambda, a_eta))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_legendre_H3d_1_e(lambda, eta, &result)"), ce_string ("legendre_H3d.c"), 562, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_legendre_H3d (a_l: INTEGER_32; a_lambda, a_eta: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_legendre_H3d_e (a_l, a_lambda, a_eta))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_legendre_H3d_e(l, lambda, eta, &result)"), ce_string ("legendre_H3d.c"), 567, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
