class
	P_LMDER_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	lmder_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIFIT_FDFSOLVER_TYPE}.make_initialized ([ce_string ("lmder"), (create {PD_LMDER_STATE_T}.make).structure_size.to_natural_32, lmder_alloc_address, (create {PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT_STATIC}).lmder_set_address, lmder_iterate_address, lmder_free_address])
				>>)
		end

	lmsder_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIFIT_FDFSOLVER_TYPE}.make_initialized ([ce_string ("lmsder"), (create {PD_LMDER_STATE_T}.make).structure_size.to_natural_32, lmder_alloc_address, (create {PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT_STATIC}).lmsder_set_address, lmsder_iterate_address, lmder_free_address])
				>>)
		end

	gsl_multifit_fdfsolver_lmder: CE_STATIC [CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := lmder_type.item
		end

	gsl_multifit_fdfsolver_lmsder: CE_STATIC [CE_POINTER [PD_GSL_MULTIFIT_FDFSOLVER_TYPE]]
		once ("PROCESS")
			Result.item := lmsder_type.item
		end

feature {ANY} -- public routines

	lmder_alloc (a_vstate: CE_POINTER [ANY]; a_n, a_p: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_LMDER_STATE_T]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_qtf: CE_POINTER [PD_GSL_VECTOR]
			l_newton: CE_POINTER [PD_GSL_VECTOR]
			l_gradient: CE_POINTER [PD_GSL_VECTOR]
			l_x_trial: CE_POINTER [PD_GSL_VECTOR]
			l_f_trial: CE_POINTER [PD_GSL_VECTOR]
			l_df: CE_POINTER [PD_GSL_VECTOR]
			l_sdiag: CE_POINTER [PD_GSL_VECTOR]
			l_rptdx: CE_POINTER [PD_GSL_VECTOR]
			l_w: CE_POINTER [PD_GSL_VECTOR]
			l_work1: CE_POINTER [PD_GSL_VECTOR]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_tmp: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_LMDER_STATE_T]}.make_cast (a_vstate)
			l_r___3 := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_calloc (a_n, a_p)
			if l_r___3.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for r"), ce_string ("lmder.c"), 87, 8)
					Result := 8
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.r := l_r___3
				if a_n < a_p then
					l_tmp := a_n
				else
					l_tmp := a_p
				end
				l_tau := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (l_tmp)
				if l_tau.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for tau"), ce_string ("lmder.c"), 98, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.tau := l_tau
				l_diag := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if l_diag.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for diag"), ce_string ("lmder.c"), 110, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.diag := l_diag
				l_qtf := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_qtf.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for qtf"), ce_string ("lmder.c"), 123, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.qtf := l_qtf
				l_newton := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if l_newton.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for newton"), ce_string ("lmder.c"), 137, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.newton := l_newton
				l_gradient := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if l_gradient.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for gradient"), ce_string ("lmder.c"), 152, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.gradient := l_gradient
				l_x_trial := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if l_x_trial.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x_trial"), ce_string ("lmder.c"), 168, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.x_trial := l_x_trial
				l_f_trial := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_f_trial.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for f_trial"), ce_string ("lmder.c"), 185, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.f_trial := l_f_trial
				l_df := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_df.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for df"), ce_string ("lmder.c"), 203, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.df := l_df
				l_sdiag := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if l_sdiag.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for sdiag"), ce_string ("lmder.c"), 222, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.sdiag := l_sdiag
				l_rptdx := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_rptdx.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_sdiag)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rptdx"), ce_string ("lmder.c"), 243, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.rptdx := l_rptdx
				l_w := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_n)
				if l_w.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_sdiag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_rptdx)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for w"), ce_string ("lmder.c"), 264, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.w := l_w
				l_work1 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_calloc (a_p)
				if l_work1.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_sdiag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_rptdx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for work1"), ce_string ("lmder.c"), 286, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.work1 := l_work1
				l_perm := (create {P_INIT_STATIC}).gsl_permutation_calloc (a_p)
				if l_perm.is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_r___3);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_tau);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_diag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_qtf);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_newton);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_gradient);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_x_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_f_trial);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_df);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_sdiag);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_rptdx);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_w);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_work1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for perm"), ce_string ("lmder.c"), 309, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.perm := l_perm
				Result := 0
			end
		end

	lmder_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := ((create {P_LMITERATE_STATIC}).iterate (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 0))
			Result := l_status
		end

	lmsder_iterate (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := ((create {P_LMITERATE_STATIC}).iterate (a_vstate, a_fdf, a_x, a_f, a_J, a_dx, 1))
			Result := l_status
		end

	lmder_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_LMDER_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_LMDER_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_STATIC}).gsl_permutation_free (l_state.item.perm);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.work1);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.w);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.rptdx);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.sdiag);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.df);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.f_trial);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.x_trial);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.gradient);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.newton);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.qtf);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.diag);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.tau);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.r)
		end

feature {ANY} -- routine addresses

	lmder_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent lmder_alloc)
		end

	lmder_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent lmder_iterate)
		end

	lmsder_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent lmsder_iterate)
		end

	lmder_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent lmder_free)
		end

end
