class
	P_LMUTIL_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	scaled_enorm (a_d, a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		require
			not a_f.is_void
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
			l_di: REAL_64
			l_u: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (a_f.item.gsl_vector_get (l_i))
				l_di := (a_d.item.gsl_vector_get (l_i))
				l_u := l_di * l_fi
				l_e2 := l_e2 + (l_u * l_u)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	compute_actual_reduction (a_fnorm, a_fnorm1: REAL_64): REAL_64
		local
			l_actred: REAL_64
			l_u: REAL_64
		do
			if 0.1 * a_fnorm1 < a_fnorm then
				l_u := a_fnorm1 / a_fnorm
				l_actred := (1).to_double - l_u * l_u
			else
				l_actred := (-1).to_double
			end
			Result := l_actred
		end

	update_diag (a_J: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR])
		require
			not a_diag.is_void
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_n: NATURAL_32
			l_cnorm: REAL_64
			l_diagj: REAL_64
			l_sum: REAL_64
			l_Jij: REAL_64
			l_return: BOOLEAN
		do
			l_n := a_diag.item.size
			l_j := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_j < l_n))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_Jij := (a_J.item.gsl_matrix_get (l_i, l_j))
					l_sum := l_sum + (l_Jij * l_Jij)
					l_i := l_i + 1
				end
				if l_sum = (0).to_double then
					l_sum := 1.0
				end
				l_cnorm := sqrt (l_sum)
				l_diagj := a_diag.item.gsl_vector_get (l_j)
				if l_cnorm > l_diagj then
					a_diag.item.gsl_vector_set (l_j, l_cnorm)
				end
				l_j := l_j + 1
			end
		end

	compute_rptdx (a_r___3: CE_POINTER [PD_GSL_MATRIX]; a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_dx, a_rptdx: CE_POINTER [PD_GSL_VECTOR])
		require
			not a_dx.is_void
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_N: NATURAL_32
			l_sum: REAL_64
			l_pj: NATURAL_32
			l_tmp___0: REAL_64
			l_return: BOOLEAN
		do
			l_N := a_dx.item.size
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_N))
			loop
				l_sum := (0).to_double
				l_j := l_i
				from
				until
					not (l_j < l_N)
				loop
					l_pj := (a_p.item.gsl_permutation_get (l_j))
					l_tmp___0 := a_r___3.item.gsl_matrix_get (l_i, l_j)
					l_sum := l_sum + (l_tmp___0 * (a_dx.item.gsl_vector_get (l_pj)))
					l_j := l_j + 1
				end
				a_rptdx.item.gsl_vector_set (l_i, l_sum)
				l_i := l_i + 1
			end
		end

end
