class
	P_LOGNORMAL_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_lognormal_pdf (a_x, a_zeta, a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_p: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
		do
			if a_x <= (0).to_double then
				Result := (0).to_double
			else
				l_u := ((log (a_x)) - a_zeta) / a_sigma
				l_tmp___0 := fabs (a_sigma)
				l_tmp___1 := sqrt ((2).to_double * 3.14159265358979323846)
				l_p := ((1).to_double / ((a_x * l_tmp___0) * l_tmp___1)) * (exp (-(l_u * l_u) / (2).to_double))
				Result := l_p
			end
		end

	gsl_cdf_lognormal_P (a_x, a_zeta, a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_P___2: REAL_64
		do
			l_u := ((log (a_x)) - a_zeta) / a_sigma
			l_P___2 := ((create {P_GAUSS_STATIC}).gsl_cdf_ugaussian_P (l_u))
			Result := l_P___2
		end

	gsl_cdf_lognormal_Q (a_x, a_zeta, a_sigma: REAL_64): REAL_64
		local
			l_u: REAL_64
			l_Q___1: REAL_64
		do
			l_u := ((log (a_x)) - a_zeta) / a_sigma
			l_Q___1 := ((create {P_GAUSS_STATIC}).gsl_cdf_ugaussian_Q (l_u))
			Result := l_Q___1
		end

end
