class
	P_MATHIEU_ANGFUNC_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_sf_mathieu_ce (a_order: INTEGER_32; a_qq, a_zz: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_order: INTEGER_32
			l_even_odd: INTEGER_32
			l_ii: INTEGER_32
			l_status: INTEGER_32
			l_coeff: CE_ARRAY [REAL_64]
			l_norm___0: REAL_64
			l_fn: REAL_64
			l_factor: REAL_64
			l_aa: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_return: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_coeff.make (<<100>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_aa.make (<<1>>)

			l_order := a_order
			l_norm___0 := 0.0
			l_even_odd := 0
			if l_order \\ 2 /= 0 then
				l_even_odd := 1
			end
			if a_qq = 0.0 then
				l_norm___0 := 1.0
				if l_order = 0 then
					l_norm___0 := sqrt (2.0)
				end
				l_fn := (cos (l_order.to_double * a_zz)) / l_norm___0
				a_result.item.val := l_fn
				a_result.item.err := 2.0 * 2.2204460492503131e-16
				l_factor := fabs (l_fn)
				if l_factor > 1.0 then
					a_result.item.err := a_result.item.err * l_factor
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				if l_order < 0 then
					l_order := l_order * (-1)
				end
				l_status := (create {P_MATHIEU_CHARV_STATIC}).gsl_sf_mathieu_a (l_order, a_qq, l_aa)
				if l_status /= 0 then
					Result := l_status
					l_return := True
				end
			end
			if not l_return then
				l_status := (create {P_MATHIEU_COEFF_STATIC}).gsl_sf_mathieu_a_coeff (l_order, a_qq, l_aa.item.val, l_coeff)
				if l_status /= 0 then
					Result := l_status
					l_return := True
				end
			end
			if not l_return then
				if l_even_odd = 0 then
					l_fn := 0.0
					l_norm___0 := l_coeff[0] * l_coeff[0]
					l_ii := 0
					from
					until
						not (l_ii < 100)
					loop
						l_fn := l_fn + (l_coeff[l_ii] * (cos ((2.0 * l_ii.to_double) * a_zz)))
						l_norm___0 := l_norm___0 + (l_coeff[l_ii] * l_coeff[l_ii])
						l_ii := l_ii + 1
					end
				else
					l_fn := 0.0
					l_ii := 0
					from
					until
						not (l_ii < 100)
					loop
						l_fn := l_fn + (l_coeff[l_ii] * (cos ((2.0 * l_ii.to_double + 1.0) * a_zz)))
						l_norm___0 := l_norm___0 + (l_coeff[l_ii] * l_coeff[l_ii])
						l_ii := l_ii + 1
					end
				end
				l_norm___0 := sqrt (l_norm___0)
				l_fn := l_fn / l_norm___0
				a_result.item.val := l_fn
				a_result.item.err := 2.0 * 2.2204460492503131e-16
				l_factor := fabs (l_fn)
				if l_factor > 1.0 then
					a_result.item.err := a_result.item.err * l_factor
				end
				Result := 0
			end
		end

	gsl_sf_mathieu_se (a_order: INTEGER_32; a_qq, a_zz: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_order: INTEGER_32
			l_even_odd: INTEGER_32
			l_ii: INTEGER_32
			l_status: INTEGER_32
			l_coeff: CE_ARRAY [REAL_64]
			l_norm___0: REAL_64
			l_fn: REAL_64
			l_factor: REAL_64
			l_aa: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_return: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_coeff.make (<<100>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_aa.make (<<1>>)

			l_order := a_order
			l_norm___0 := 0.0
			l_even_odd := 0
			if l_order \\ 2 /= 0 then
				l_even_odd := 1
			end
			if l_order = 0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				l_return := True
			end
			if not l_return and then (a_qq = 0.0) then
				l_norm___0 := 1.0
				l_fn := sin (l_order.to_double * a_zz)
				a_result.item.val := l_fn
				a_result.item.err := 2.0 * 2.2204460492503131e-16
				l_factor := fabs (l_fn)
				if l_factor > 1.0 then
					a_result.item.err := a_result.item.err * l_factor
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				if l_order < 0 then
					l_order := l_order * (-1)
				end
				l_status := (create {P_MATHIEU_CHARV_STATIC}).gsl_sf_mathieu_b (l_order, a_qq, l_aa)
				if l_status /= 0 then
					Result := l_status
					l_return := True
				end
			end
			if not l_return then
				l_status := (create {P_MATHIEU_COEFF_STATIC}).gsl_sf_mathieu_b_coeff (l_order, a_qq, l_aa.item.val, l_coeff)
				if l_status /= 0 then
					Result := l_status
					l_return := True
				end
			end
			if not l_return then
				if l_even_odd = 0 then
					l_fn := 0.0
					l_ii := 0
					from
					until
						not (l_ii < 100)
					loop
						l_norm___0 := l_norm___0 + (l_coeff[l_ii] * l_coeff[l_ii])
						l_fn := l_fn + (l_coeff[l_ii] * (sin ((2.0 * (l_ii + 1).to_double) * a_zz)))
						l_ii := l_ii + 1
					end
				else
					l_fn := 0.0
					l_ii := 0
					from
					until
						not (l_ii < 100)
					loop
						l_norm___0 := l_norm___0 + (l_coeff[l_ii] * l_coeff[l_ii])
						l_fn := l_fn + (l_coeff[l_ii] * (sin ((2.0 * l_ii.to_double + (1).to_double) * a_zz)))
						l_ii := l_ii + 1
					end
				end
				l_norm___0 := sqrt (l_norm___0)
				l_fn := l_fn / l_norm___0
				a_result.item.val := l_fn
				a_result.item.err := 2.0 * 2.2204460492503131e-16
				l_factor := fabs (l_fn)
				if l_factor > 1.0 then
					a_result.item.err := a_result.item.err * l_factor
				end
				Result := 0
			end
		end

end
