class
	P_NIEDERREITER_2_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	nied2_type: CE_STATIC [CE_ARRAY [PD_GSL_QRNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_QRNG_TYPE]}.make_initialized (<<
					create {PD_GSL_QRNG_TYPE}.make_initialized ([ce_string ("niederreiter-base-2"), {NATURAL_32} 12, nied2_state_size_address, nied2_init_address, nied2_get_address])
				>>)
		end

	gsl_qrng_niederreiter_2: CE_STATIC [CE_POINTER [PD_GSL_QRNG_TYPE]]
		once ("PROCESS")
			Result.item := nied2_type.item
		end

	primitive_poly: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_32]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_32]}.make_initialized (<<
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 0, 0, 0, 0, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							0, 1, 0, 0, 0, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 1, 0, 0, 0, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 1, 1, 0, 0, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 1, 0, 1, 0, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 0, 1, 1, 0, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 1, 0, 0, 1, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 0, 0, 1, 1, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 1, 1, 1, 1, 0
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 0, 1, 0, 0, 1
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 0, 0, 1, 0, 1
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 1, 1, 1, 0, 1
						>>),
					create {CE_INTEGER_32_ARRAY}.make_initialized (<<
							1, 1, 1, 0, 1, 1
						>>)
				>>)
		end

	poly_degree: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					0, 1, 1, 2, 3, 3, 4, 4, 4, 5, 5, 5, 5
				>>)
		end

	recip: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (1.0 / (({NATURAL_32} 1).bit_shift_left (31)).to_real_64)
		end

feature {ANY} -- public routines

	nied2_state_size (a_dimension: NATURAL_32): NATURAL_32
		do
			Result := ((create {PD_NIED2_STATE_T}.make).structure_size.to_natural_32)
		end

	poly_multiply (a_pa: CE_POINTER [INTEGER_32]; a_pa_degree: INTEGER_32; a_pb: CE_POINTER [INTEGER_32]; a_pb_degree: INTEGER_32; a_pc, a_pc_degree: CE_POINTER [INTEGER_32])
		require
			not a_pc_degree.is_void
		local
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_pt: CE_ARRAY [INTEGER_32]
			l_pt_degree: INTEGER_32
			l_term: INTEGER_32
			l_conv_term: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_pt.make (<<51>>)

			l_pt_degree := a_pa_degree + a_pb_degree
			l_k := 0
			from
			until
				not (not (l_return) and then (l_k <= l_pt_degree))
			loop
				l_term := 0
				l_j := 0
				from
				until
					not (l_j <= l_k)
				loop
					l_conv_term := ((a_pa[(l_k - l_j)] * a_pb[l_j]) \\ 2)
					l_term := (l_term + l_conv_term) \\ 2
					l_j := l_j + 1
				end
				l_pt[l_k] := l_term
				l_k := l_k + 1
			end
			l_k := 0
			from
			until
				not (l_k <= l_pt_degree)
			loop
				a_pc[l_k] := l_pt[l_k]
				l_k := l_k + 1
			end
			l_k := l_pt_degree + 1
			from
			until
				not (l_k <= 50)
			loop
				a_pc[l_k] := 0
				l_k := l_k + 1
			end
			a_pc_degree.item := l_pt_degree
		end

	calculate_v (a_px: CE_POINTER [INTEGER_32]; a_px_degree: INTEGER_32; a_pb, a_pb_degree, a_v: CE_POINTER [INTEGER_32]; a_maxv: INTEGER_32)
		require
			not a_pb_degree.is_void
			not a_v.is_void
		local
			l_nonzero_element: INTEGER_32
			l_arbitrary_element: INTEGER_32
			l_ph: CE_ARRAY [INTEGER_32]
			l_bigm: INTEGER_32
			l_m___4: INTEGER_32
			l_r___3: INTEGER_32
			l_k: INTEGER_32
			l_kj: INTEGER_32
			l_term: INTEGER_32
			l_term___0: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_ph.make (<<51>>)

			l_nonzero_element := 1
			l_arbitrary_element := 1
			l_bigm := a_pb_degree.item
			l_k := 0
			from
			until
				not (l_k <= 50)
			loop
				l_ph[l_k] := a_pb[l_k]
				l_k := l_k + 1
			end
			poly_multiply (a_px, a_px_degree, a_pb, a_pb_degree.item, a_pb, a_pb_degree)
			l_m___4 := a_pb_degree.item
			l_kj := l_bigm
			l_r___3 := 0
			from
			until
				not (l_r___3 < l_kj)
			loop
				a_v[l_r___3] := 0
				l_r___3 := l_r___3 + 1
			end
			a_v[l_kj] := 1
			if l_kj >= l_bigm then
				l_r___3 := l_kj + 1
				from
				until
					not (l_r___3 < l_m___4)
				loop
					a_v[l_r___3] := l_arbitrary_element
					l_r___3 := l_r___3 + 1
				end
			else
				l_term := l_ph[l_kj] \\ 2
				l_r___3 := l_kj + 1
				from
				until
					not (l_r___3 < l_bigm)
				loop
					a_v[l_r___3] := l_arbitrary_element
					l_term := (l_term + (l_ph[l_r___3] * a_v[l_r___3]) \\ 2) \\ 2
					l_r___3 := l_r___3 + 1
				end
				a_v[l_bigm] := (l_nonzero_element + l_term) \\ 2
				l_r___3 := l_bigm + 1
				from
				until
					not (l_r___3 < l_m___4)
				loop
					a_v[l_r___3] := l_arbitrary_element
					l_r___3 := l_r___3 + 1
				end
			end
			l_r___3 := 0
			from
			until
				not (not (l_return) and then (l_r___3 <= a_maxv - l_m___4))
			loop
				l_term___0 := 0
				l_k := 0
				from
				until
					not (l_k < l_m___4)
				loop
					l_term___0 := (l_term___0 + (a_pb[l_k] * a_v[(l_r___3 + l_k)]) \\ 2) \\ 2
					l_k := l_k + 1
				end
				a_v[(l_r___3 + l_m___4)] := l_term___0
				l_r___3 := l_r___3 + 1
			end
		end

	calculate_cj (a_ns: CE_POINTER [PD_NIED2_STATE_T]; a_dimension: NATURAL_32)
		local
			l_ci: CE_ARRAY [CE_ARRAY [INTEGER_32]]
			l_v: CE_ARRAY [INTEGER_32]
			l_r___3: INTEGER_32
			l_i_dim: NATURAL_32
			l_poly_index: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_u: INTEGER_32
			l_pb: CE_ARRAY [INTEGER_32]
			l_px: CE_ARRAY [INTEGER_32]
			l_px_degree: INTEGER_32
			l_pb_degree: CE_ARRAY [INTEGER_32]
			l_term: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_ARRAY_ARRAY [INTEGER_32]} l_ci.make (<<31, 31>>)
			create {CE_INTEGER_32_ARRAY} l_v.make (<<82>>)
			create {CE_INTEGER_32_ARRAY} l_pb.make (<<51>>)
			create {CE_INTEGER_32_ARRAY} l_px.make (<<51>>)
			create {CE_INTEGER_32_ARRAY} l_pb_degree.make (<<1>>)

			l_i_dim := {NATURAL_32} 0
			from
			until
				not (not (l_return) and then (l_i_dim < a_dimension))
			loop
				l_poly_index := (l_i_dim + {NATURAL_32} 1).to_integer_32
				l_u := 0
				l_px_degree := poly_degree.item[l_poly_index]
				l_pb_degree.item := 0
				l_k := 0
				from
				until
					not (l_k <= l_px_degree)
				loop
					l_px[l_k] := (primitive_poly.item[l_poly_index])[l_k]
					l_pb[l_k] := 0
					l_k := l_k + 1
				end
				from
				until
					not (l_k < 51)
				loop
					l_px[l_k] := 0
					l_pb[l_k] := 0
					l_k := l_k + 1
				end
				l_pb[0] := 1
				l_j := 0
				from
				until
					not (not (l_return) and then (l_j < 31))
				loop
					if l_u = 0 then
						calculate_v (create {CE_INTEGER_32_POINTER}.make_cast (l_px), l_px_degree, l_pb, l_pb_degree, l_v, 81)
					end
					l_r___3 := 0
					from
					until
						not (l_r___3 < 31)
					loop
						(l_ci[l_r___3])[l_j] := l_v[l_r___3 + l_u]
						l_r___3 := l_r___3 + 1
					end
					l_u := l_u + 1
					if l_u = l_px_degree then
						l_u := 0
					end
					l_j := l_j + 1
				end
				l_r___3 := 0
				from
				until
					not (not (l_return) and then (l_r___3 < 31))
				loop
					l_term := 0
					l_j := 0
					from
					until
						not (l_j < 31)
					loop
						l_term := 2 * l_term + (l_ci[l_r___3])[l_j]
						l_j := l_j + 1
					end
					(a_ns.item.cj[l_r___3])[l_i_dim.to_integer_32] := l_term
					l_r___3 := l_r___3 + 1
				end
				l_i_dim := l_i_dim + 1
			end
		end

	nied2_init (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32): INTEGER_32
		local
			l_n_state: CE_POINTER [PD_NIED2_STATE_T]
			l_i_dim: NATURAL_32
			l_return: BOOLEAN
		do
			l_n_state := create {CE_CLASS_POINTER [PD_NIED2_STATE_T]}.make_cast (a_state)
			if a_dimension < {NATURAL_32} 1 then
				Result := 4
				l_return := True
			elseif a_dimension > {NATURAL_32} 12 then
				Result := 4
				l_return := True
			end
			if not l_return then
				calculate_cj (l_n_state, a_dimension)
				l_i_dim := {NATURAL_32} 0
				from
				until
					not (l_i_dim < a_dimension)
				loop
					l_n_state.item.nextq[l_i_dim.to_integer_32] := 0
					l_i_dim := l_i_dim + 1
				end
				l_n_state.item.sequence_count := {NATURAL_32} 0
				Result := 0
			end
		end

	nied2_get (a_state: CE_POINTER [ANY]; a_dimension: NATURAL_32; a_v: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_n_state: CE_POINTER [PD_NIED2_STATE_T]
			l_r___3: INTEGER_32
			l_c___1: INTEGER_32
			l_i_dim: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_n_state := create {CE_CLASS_POINTER [PD_NIED2_STATE_T]}.make_cast (a_state)
			l_i_dim := {NATURAL_32} 0
			from
			until
				not (l_i_dim < a_dimension)
			loop
				a_v[l_i_dim.to_integer_32] := ((l_n_state.item.nextq[l_i_dim.to_integer_32]).to_double * recip.item)
				l_i_dim := l_i_dim + 1
			end
			l_r___3 := 0
			l_c___1 := (l_n_state.item.sequence_count).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				if l_c___1 \\ 2 = 1 then
					l_r___3 := l_r___3 + 1
					l_c___1 := l_c___1 // (2)
				else
					l_break := True
				end
			end
			l_break := False
			if l_r___3 >= 31 then
				Result := 5
				l_return := True
			end
			if not l_return then
				l_i_dim := {NATURAL_32} 0
				from
				until
					not (l_i_dim < a_dimension)
				loop
					l_n_state.item.nextq[l_i_dim.to_integer_32] := (l_n_state.item.nextq[l_i_dim.to_integer_32]).bit_xor (((l_n_state.item.cj[l_r___3])[l_i_dim.to_integer_32]))
					l_i_dim := l_i_dim + 1
				end
				l_n_state.item.sequence_count := (l_n_state.item.sequence_count) + 1
				Result := 0
			end
		end

feature {ANY} -- routine addresses

	nied2_state_size_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nied2_state_size)
		end

	nied2_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nied2_init)
		end

	nied2_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nied2_get)
		end

end
