class
	P_PARETOINV_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_cdf_pareto_Pinv (a_P___2, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_return: BOOLEAN
		do
			if a_P___2 = 1.0 then
				Result := (builtin_inff).to_double
				l_return := True
			elseif a_P___2 = 0.0 then
				Result := a_b___0
				l_return := True
			end
			if not l_return then
				l_x := a_b___0 * (exp (-(log1p (-a_P___2)) / a_a___5))
				Result := l_x
			end
		end

	gsl_cdf_pareto_Qinv (a_Q___1, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_return: BOOLEAN
		do
			if a_Q___1 = 0.0 then
				Result := (builtin_inff).to_double
				l_return := True
			elseif a_Q___1 = 1.0 then
				Result := a_b___0
				l_return := True
			end
			if not l_return then
				l_x := a_b___0 * (exp (-(log (a_Q___1)) / a_a___5))
				Result := l_x
			end
		end

end
