class
	P_PDF_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_histogram_pdf_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_HISTOGRAM_PDF]
		local
			l_p: CE_POINTER [PD_GSL_HISTOGRAM_PDF]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("histogram pdf length n must be positive integer"), ce_string ("pdf.c"), 64, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_p := create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_cast ((malloc ((create {PD_GSL_HISTOGRAM_PDF}.make).structure_size.to_natural_32)))
				if l_p.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram pdf struct"), ce_string ("pdf.c"), 72, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.range := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_n + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_p.item.range).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_p))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram pdf ranges"), ce_string ("pdf.c"), 82, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.sum := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_n + {NATURAL_32} 1) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_p.item.sum).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_p.item.range))
					free (create {CE_VOID_POINTER}.make_cast (l_p))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for histogram pdf sums"), ce_string ("pdf.c"), 93, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_HISTOGRAM_PDF]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_p.item.n := a_n
				Result := l_p
			end
		end

	gsl_histogram_pdf_free (a_p: CE_POINTER [PD_GSL_HISTOGRAM_PDF])
		local
			l_return: BOOLEAN
		do
			if a_p.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_p.item.range))
				free (create {CE_VOID_POINTER}.make_cast (a_p.item.sum))
				free (create {CE_VOID_POINTER}.make_cast (a_p))
			end
		end

end
