class
	P_RAN1_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_147_483_647).to_integer_32
		end

	a___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (16_807).to_integer_32
		end

	q: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (127_773).to_integer_32
		end

	r: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_836).to_integer_32
		end

	ran1_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ran1"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 1, (create {PD_RAN1_STATE_T}.make).structure_size.to_natural_32, ran1_set_address, ran1_get_address, ran1_get_double_address])
				>>)
		end

	gsl_rng_ran1: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran1_type.item
		end

feature {ANY} -- public routines

	ran1_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN1_STATE_T]
			l_x: NATURAL_32
			l_h: INTEGER_32
			l_t: INTEGER_32
			l_j: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN1_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_h := (l_x // q.item.to_natural_32).to_integer_32
			l_t := (a___0.item.to_natural_32 * (l_x - (l_h * q.item).to_natural_32) - (l_h * r.item).to_natural_32).to_integer_32
			if l_t < 0 then
				l_state.item.x := (l_t + m.item).to_natural_32
			else
				l_state.item.x := l_t.to_natural_32
			end
			l_j := l_state.item.n // {NATURAL_32} 67_108_864
			l_state.item.n := l_state.item.shuffle[l_j.to_integer_32]
			l_state.item.shuffle[l_j.to_integer_32] := l_state.item.x
			Result := (l_state.item.n)
		end

	ran1_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_x_max: REAL_32
			l_x: REAL_32
			l_return: BOOLEAN
		do
			l_x_max := (1).to_real - {REAL_32} 1.2e-7
			l_x := (ran1_get (a_vstate)).to_real_32 / {REAL_32} 2147483647.0
			if l_x > l_x_max then
				Result := l_x_max.to_double
				l_return := True
			end
			if not l_return then
				Result := l_x.to_double
			end
		end

	ran1_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN1_STATE_T]
			l_i: INTEGER_32
			l_h: INTEGER_32
			l_t: INTEGER_32
			l_h___0: INTEGER_32
			l_t___0: INTEGER_32
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN1_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_i := 0
			from
			until
				not (l_i < 8)
			loop
				l_h := (l_s // q.item.to_natural_32).to_integer_32
				l_t := (a___0.item.to_natural_32 * (l_s - (l_h * q.item).to_natural_32) - (l_h * r.item).to_natural_32).to_integer_32
				if l_t < 0 then
					l_t := l_t + m.item
				end
				l_s := l_t.to_natural_32
				l_i := l_i + 1
			end
			l_i := 31
			from
			until
				not (l_i >= 0)
			loop
				l_h___0 := (l_s // q.item.to_natural_32).to_integer_32
				l_t___0 := (a___0.item.to_natural_32 * (l_s - (l_h___0 * q.item).to_natural_32) - (l_h___0 * r.item).to_natural_32).to_integer_32
				if l_t___0 < 0 then
					l_t___0 := l_t___0 + m.item
				end
				l_s := l_t___0.to_natural_32
				l_state.item.shuffle[l_i] := l_s
				l_i := l_i - 1
			end
			l_state.item.x := l_s
			l_state.item.n := l_s
		end

feature {ANY} -- routine addresses

	ran1_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran1_get)
		end

	ran1_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran1_get_double)
		end

	ran1_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran1_set)
		end

end
