class
	P_RAN2_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m1___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_147_483_563).to_integer_32
		end

	a12: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (40_014).to_integer_32
		end

	q12: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (53_668).to_integer_32
		end

	r1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (12_211).to_integer_32
		end

	m2___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_147_483_399).to_integer_32
		end

	a22: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (40_692).to_integer_32
		end

	q22: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (52_774).to_integer_32
		end

	r2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (3_791).to_integer_32
		end

	ran2_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ran2"), {NATURAL_32} 2_147_483_562, {NATURAL_32} 1, (create {PD_RAN2_STATE_T}.make).structure_size.to_natural_32, ran2_set_address, ran2_get_address, ran2_get_double_address])
				>>)
		end

	gsl_rng_ran2: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ran2_type.item
		end

feature {ANY} -- public routines

	ran2_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN2_STATE_T]
			l_x: NATURAL_32
			l_y: NATURAL_32
			l_h1: INTEGER_32
			l_t1: INTEGER_32
			l_h2: INTEGER_32
			l_t2: INTEGER_32
			l_j: NATURAL_32
			l_delta___0: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAN2_STATE_T]}.make_cast (a_vstate)
			l_x := l_state.item.x
			l_y := l_state.item.y
			l_h1 := (l_x // q12.item.to_natural_32).to_integer_32
			l_t1 := (a12.item.to_natural_32 * (l_x - (l_h1 * q12.item).to_natural_32) - (l_h1 * r1.item).to_natural_32).to_integer_32
			l_h2 := (l_y // q22.item.to_natural_32).to_integer_32
			l_t2 := (a22.item.to_natural_32 * (l_y - (l_h2 * q22.item).to_natural_32) - (l_h2 * r2.item).to_natural_32).to_integer_32
			if l_t1 < 0 then
				l_t1 := l_t1 + m1___0.item
			end
			if l_t2 < 0 then
				l_t2 := l_t2 + m2___0.item
			end
			l_state.item.x := l_t1.to_natural_32
			l_state.item.y := l_t2.to_natural_32
			l_j := l_state.item.n // {NATURAL_32} 67_108_862
			l_delta___0 := (l_state.item.shuffle[l_j.to_integer_32] - l_t2.to_natural_32).to_integer_32
			if l_delta___0 < 1 then
				l_delta___0 := l_delta___0 + (m1___0.item - 1)
			end
			l_state.item.n := l_delta___0.to_natural_32
			l_state.item.shuffle[l_j.to_integer_32] := l_t1.to_natural_32
			Result := (l_state.item.n)
		end

	ran2_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_x_max: REAL_32
			l_x: REAL_32
			l_return: BOOLEAN
		do
			l_x_max := (1).to_real - {REAL_32} 1.2e-7
			l_x := (ran2_get (a_vstate)).to_real_32 / {REAL_32} 2147483563.0
			if l_x > l_x_max then
				Result := l_x_max.to_double
				l_return := True
			end
			if not l_return then
				Result := l_x.to_double
			end
		end

	ran2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN2_STATE_T]
			l_i: INTEGER_32
			l_h: INTEGER_32
			l_t: INTEGER_32
			l_h___0: INTEGER_32
			l_t___0: INTEGER_32
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RAN2_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.y := l_s
			l_i := 0
			from
			until
				not (l_i < 8)
			loop
				l_h := (l_s // q12.item.to_natural_32).to_integer_32
				l_t := (a12.item.to_natural_32 * (l_s - (l_h * q12.item).to_natural_32) - (l_h * r1.item).to_natural_32).to_integer_32
				if l_t < 0 then
					l_t := l_t + m1___0.item
				end
				l_s := l_t.to_natural_32
				l_i := l_i + 1
			end
			l_i := 31
			from
			until
				not (l_i >= 0)
			loop
				l_h___0 := (l_s // q12.item.to_natural_32).to_integer_32
				l_t___0 := (a12.item.to_natural_32 * (l_s - (l_h___0 * q12.item).to_natural_32) - (l_h___0 * r1.item).to_natural_32).to_integer_32
				if l_t___0 < 0 then
					l_t___0 := l_t___0 + m1___0.item
				end
				l_s := l_t___0.to_natural_32
				l_state.item.shuffle[l_i] := l_s
				l_i := l_i - 1
			end
			l_state.item.x := l_s
			l_state.item.n := l_s
		end

feature {ANY} -- routine addresses

	ran2_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran2_get)
		end

	ran2_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran2_get_double)
		end

	ran2_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ran2_set)
		end

end
