class
	P_RAND48_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public attributes

	a0___1: CE_STATIC [NATURAL_16]
		once ("PROCESS")
			Result.item := (58_989).to_natural_16
		end

	a1___2: CE_STATIC [NATURAL_16]
		once ("PROCESS")
			Result.item := (57_068).to_natural_16
		end

	a2___1: CE_STATIC [NATURAL_16]
		once ("PROCESS")
			Result.item := (5).to_natural_16
		end

	c0: CE_STATIC [NATURAL_16]
		once ("PROCESS")
			Result.item := (11).to_natural_16
		end

	rand48_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("rand48"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_RAND48_STATE_T}.make).structure_size.to_natural_32, rand48_set_address, rand48_get_address, rand48_get_double_address])
				>>)
		end

	gsl_rng_rand48: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := rand48_type.item
		end

feature {ANY} -- public routines

	rand48_advance (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RAND48_STATE_T]
			l_x0: NATURAL_32
			l_x1___0: NATURAL_32
			l_x2___1: NATURAL_32
			l_a___5: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RAND48_STATE_T]}.make_cast (a_vstate)
			l_x0 := (l_state.item.x0).to_natural_32
			l_x1___0 := (l_state.item.x1).to_natural_32
			l_x2___1 := (l_state.item.x2).to_natural_32
			l_a___5 := a0___1.item.to_natural_32 * l_x0 + c0.item.to_natural_32
			l_state.item.x0 := ((l_a___5).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_a___5 := (l_a___5).bit_shift_right ((16))
			l_a___5 := l_a___5 + (a0___1.item.to_natural_32 * l_x1___0 + a1___2.item.to_natural_32 * l_x0)
			l_state.item.x1 := ((l_a___5).bit_and ({NATURAL_32} 65_535)).to_natural_16
			l_a___5 := (l_a___5).bit_shift_right ((16))
			l_a___5 := l_a___5 + ((a0___1.item.to_natural_32 * l_x2___1 + a1___2.item.to_natural_32 * l_x1___0) + a2___1.item.to_natural_32 * l_x0)
			l_state.item.x2 := ((l_a___5).bit_and ({NATURAL_32} 65_535)).to_natural_16
		end

	rand48_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_x1___0: NATURAL_32
			l_x2___1: NATURAL_32
			l_state: CE_POINTER [PD_RAND48_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAND48_STATE_T]}.make_cast (a_vstate)
			rand48_advance (create {CE_VOID_POINTER}.make_cast (l_state))
			l_x2___1 := (l_state.item.x2).to_natural_32
			l_x1___0 := (l_state.item.x1).to_natural_32
			Result := (((l_x2___1).bit_shift_left (16)) + l_x1___0)
		end

	rand48_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAND48_STATE_T]
			l_tmp: REAL_64
			l_tmp___0: REAL_64
		do
			l_state := create {CE_CLASS_POINTER [PD_RAND48_STATE_T]}.make_cast (a_vstate)
			rand48_advance (create {CE_VOID_POINTER}.make_cast (l_state))
			l_tmp := ldexp ((l_state.item.x2).to_real_64, -16)
			l_tmp___0 := ldexp ((l_state.item.x1).to_real_64, -32)
			Result := ((l_tmp + l_tmp___0) + (ldexp ((l_state.item.x0).to_real_64, -48)))
		end

	rand48_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RAND48_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RAND48_STATE_T]}.make_cast (a_vstate)
			if a_s = {NATURAL_32} 0 then
				l_state.item.x0 := (13_070).to_natural_16
				l_state.item.x1 := (43_981).to_natural_16
				l_state.item.x2 := (4_660).to_natural_16
			else
				l_state.item.x0 := (13_070).to_natural_16
				l_state.item.x1 := ((a_s).bit_and ({NATURAL_32} 65_535)).to_natural_16
				l_state.item.x2 := ((((a_s).bit_shift_right (16))).bit_and ({NATURAL_32} 65_535)).to_natural_16
			end
		end

feature {ANY} -- routine addresses

	rand48_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rand48_get)
		end

	rand48_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rand48_get_double)
		end

	rand48_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rand48_set)
		end

end
