class
	P_RANLUX_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	mask_hi: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (({NATURAL_32} 16_777_215).bit_not)
		end

	two24___0: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (16_777_216).to_natural_32
		end

	ranlux_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranlux"), {NATURAL_32} 16_777_215, {NATURAL_32} 0, (create {PD_RANLUX_STATE_T}.make).structure_size.to_natural_32, ranlux_set_address, ranlux_get_address, ranlux_get_double_address])
				>>)
		end

	ranlux389_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranlux389"), {NATURAL_32} 16_777_215, {NATURAL_32} 0, (create {PD_RANLUX_STATE_T}.make).structure_size.to_natural_32, ranlux389_set_address, ranlux_get_address, ranlux_get_double_address])
				>>)
		end

	gsl_rng_ranlux: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranlux_type.item
		end

	gsl_rng_ranlux389: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranlux389_type.item
		end

feature {ANY} -- public routines

	ranlux_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANLUX_STATE_T]
			l_skip: NATURAL_32
			l_r___3: NATURAL_32
			l_i: NATURAL_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RANLUX_STATE_T]}.make_cast (a_vstate)
			l_skip := l_state.item.skip
			l_r___3 := (l_state.item.increment_state___1)
			l_state.item.n := (l_state.item.n) + 1
			if l_state.item.n = {NATURAL_32} 24 then
				l_state.item.n := {NATURAL_32} 0
				l_i := {NATURAL_32} 0
				from
				until
					not (l_i < l_skip)
				loop
					l_state.item.increment_state___1.do_nothing
					l_i := l_i + 1
				end
			end
			Result := l_r___3
		end

	ranlux_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((ranlux_get (a_vstate)).to_real_64 / 16777216.0)
		end

	ranlux_set_lux (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32; a_luxury: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANLUX_STATE_T]
			l_i: INTEGER_32
			l_seed: INTEGER_32
			l_k: NATURAL_32
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RANLUX_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 314_159_265
			end
			l_seed := l_s.to_integer_32
			l_i := 0
			from
			until
				not (l_i < 24)
			loop
				l_k := (l_seed // 53_668).to_natural_32
				l_seed := ({NATURAL_32} 40_014 * (l_seed.to_natural_32 - l_k * {NATURAL_32} 53_668) - l_k * {NATURAL_32} 12_211).to_integer_32
				if l_seed < 0 then
					l_seed := l_seed + (2_147_483_563)
				end
				l_state.item.u[l_i] := (l_seed.to_natural_32 \\ two24___0.item)
				l_i := l_i + 1
			end
			l_state.item.i := {NATURAL_32} 23
			l_state.item.j := {NATURAL_32} 9
			l_state.item.n := {NATURAL_32} 0
			l_state.item.skip := a_luxury - {NATURAL_32} 24
			if ((l_state.item.u[23]).bit_and (mask_hi.item)).to_boolean then
				l_state.item.carry := {NATURAL_32} 1
			else
				l_state.item.carry := {NATURAL_32} 0
			end
		end

	ranlux_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlux_set_lux (a_vstate, a_s, {NATURAL_32} 223)
		end

	ranlux389_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlux_set_lux (a_vstate, a_s, {NATURAL_32} 389)
		end

feature {ANY} -- routine addresses

	ranlux_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlux_get)
		end

	ranlux_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlux_get_double)
		end

	ranlux_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlux_set)
		end

	ranlux389_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlux389_set)
		end

end
