class
	P_RANLXD_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	next___0: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 0
				>>)
		end

	one_bit___0: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (1.0 / 281474976710656.0)
		end

	ranlxd1_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranlxd1"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_RANLXD_STATE_T}.make).structure_size.to_natural_32, ranlxd1_set_address, ranlxd_get_address, ranlxd_get_double_address])
				>>)
		end

	ranlxd2_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranlxd2"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_RANLXD_STATE_T}.make).structure_size.to_natural_32, ranlxd2_set_address, ranlxd_get_address, ranlxd_get_double_address])
				>>)
		end

	gsl_rng_ranlxd1: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranlxd1_type.item
		end

	gsl_rng_ranlxd2: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranlxd2_type.item
		end

feature {ANY} -- public routines

	ranlxd_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		do
			Result := ((ranlxd_get_double (a_vstate)) * 4294967296.0).truncated_to_integer_64.to_natural_32
		end

	ranlxd_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RANLXD_STATE_T]
			l_ir: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RANLXD_STATE_T]}.make_cast (a_vstate)
			l_ir := (l_state.item.ir).to_integer_32
			l_state.item.ir := (next___0.item[l_ir]).to_natural_32
			if l_state.item.ir = l_state.item.ir_old then
				l_state.item.increment_state___0
			end
			Result := (l_state.item.xdbl[(l_state.item.ir).to_integer_32])
		end

	ranlxd_set_lux (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32; a_luxury: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RANLXD_STATE_T]
			l_ibit: INTEGER_32
			l_jbit: INTEGER_32
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_l: INTEGER_32
			l_xbit: CE_ARRAY [INTEGER_32]
			l_x: REAL_64
			l_y: REAL_64
			l_seed: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_xbit.make (<<31>>)

			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_RANLXD_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_seed := l_s.to_integer_32
			l_i := ((l_seed.to_natural_32).bit_and ({NATURAL_32} 4_294_967_295)).to_integer_32
			l_k := 0
			from
			until
				not (l_k < 31)
			loop
				l_xbit[l_k] := l_i \\ 2
				l_i := l_i // (2)
				l_k := l_k + 1
			end
			l_ibit := 0
			l_jbit := 18
			l_k := 0
			from
			until
				not (not (l_return) and then (l_k < 12))
			loop
				l_x := (0).to_double
				l_l := 1
				from
				until
					not (l_l <= 48)
				loop
					l_y := ((l_xbit[l_ibit] + 1) \\ 2).to_double
					l_x := l_x + (l_x + l_y)
					l_xbit[l_ibit] := (l_xbit[l_ibit] + l_xbit[l_jbit]) \\ 2
					l_ibit := (l_ibit + 1) \\ 31
					l_jbit := (l_jbit + 1) \\ 31
					l_l := l_l + 1
				end
				l_state.item.xdbl[l_k] := (one_bit___0.item * l_x)
				l_k := l_k + 1
			end
			l_state.item.carry := (0).to_double
			l_state.item.ir := {NATURAL_32} 11
			l_state.item.jr := {NATURAL_32} 7
			l_state.item.ir_old := {NATURAL_32} 0
			l_state.item.pr := a_luxury
		end

	ranlxd1_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlxd_set_lux (a_vstate, a_s, {NATURAL_32} 202)
		end

	ranlxd2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		do
			ranlxd_set_lux (a_vstate, a_s, {NATURAL_32} 397)
		end

feature {ANY} -- routine addresses

	ranlxd_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxd_get)
		end

	ranlxd_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxd_get_double)
		end

	ranlxd1_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxd1_set)
		end

	ranlxd2_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranlxd2_set)
		end

end
