class
	P_RANMAR_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	two24: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (16_777_216).to_natural_32
		end

	ranmar_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("ranmar"), {NATURAL_32} 16_777_215, {NATURAL_32} 0, (create {PD_RANMAR_STATE_T}.make).structure_size.to_natural_32, ranmar_set_address, ranmar_get_address, ranmar_get_double_address])
				>>)
		end

	gsl_rng_ranmar: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := ranmar_type.item
		end

feature {ANY} -- public routines

	ranmar_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RANMAR_STATE_T]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_carry: INTEGER_32
			l_delta___0: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_RANMAR_STATE_T]}.make_cast (a_vstate)
			l_i := l_state.item.i
			l_j := l_state.item.j
			l_carry := l_state.item.carry
			l_delta___0 := (l_state.item.u[l_i.to_integer_32] - l_state.item.u[l_j.to_integer_32]).to_integer_32
			if l_delta___0 < 0 then
				l_delta___0 := (l_delta___0.to_natural_32 + two24.item).to_integer_32
			end
			l_state.item.u[l_i.to_integer_32] := l_delta___0.to_natural_32
			if l_i = {NATURAL_32} 0 then
				l_i := {NATURAL_32} 96
			else
				l_i := l_i - 1
			end
			l_state.item.i := l_i
			if l_j = {NATURAL_32} 0 then
				l_j := {NATURAL_32} 96
			else
				l_j := l_j - 1
			end
			l_state.item.j := l_j
			l_carry := l_carry + (-7_654_321)
			if l_carry < 0 then
				l_carry := (l_carry.to_natural_32 + (two24.item - {NATURAL_32} 3)).to_integer_32
			end
			l_state.item.carry := l_carry
			l_delta___0 := l_delta___0 + (-l_carry)
			if l_delta___0 < 0 then
				l_delta___0 := (l_delta___0.to_natural_32 + two24.item).to_integer_32
			end
			Result := l_delta___0.to_natural_32
		end

	ranmar_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((ranmar_get (a_vstate)).to_real_64 / 16777216.0)
		end

	ranmar_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_state: CE_POINTER [PD_RANMAR_STATE_T]
			l_ij: NATURAL_32
			l_kl: NATURAL_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_l: INTEGER_32
			l_a___5: INTEGER_32
			l_b___0: INTEGER_32
			l_sum: NATURAL_32
			l_t: NATURAL_32
			l_m___4: NATURAL_32
			l_return: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RANMAR_STATE_T]}.make_cast (a_vstate)
			l_ij := a_s // {NATURAL_32} 30_082
			l_kl := a_s \\ {NATURAL_32} 30_082
			l_i := ((l_ij // {NATURAL_32} 177) \\ {NATURAL_32} 177 + {NATURAL_32} 2).to_integer_32
			l_j := (l_ij \\ {NATURAL_32} 177 + {NATURAL_32} 2).to_integer_32
			l_k := ((l_kl // {NATURAL_32} 169) \\ {NATURAL_32} 178 + {NATURAL_32} 1).to_integer_32
			l_l := (l_kl \\ {NATURAL_32} 169).to_integer_32
			l_a___5 := 0
			from
			until
				not (not (l_return) and then (l_a___5 < 97))
			loop
				l_sum := {NATURAL_32} 0
				l_t := two24.item
				l_b___0 := 0
				from
				until
					not (l_b___0 < 24)
				loop
					l_m___4 := ((((l_i * l_j) \\ 179) * l_k) \\ 179).to_natural_32
					l_i := l_j
					l_j := l_k
					l_k := l_m___4.to_integer_32
					l_l := (53 * l_l + 1) \\ 169
					l_t := (l_t).bit_shift_right ((1))
					if (l_l.to_natural_32 * l_m___4) \\ {NATURAL_32} 64 >= {NATURAL_32} 32 then
						l_sum := l_sum + l_t
					end
					l_b___0 := l_b___0 + 1
				end
				l_state.item.u[l_a___5] := l_sum
				l_a___5 := l_a___5 + 1
			end
			l_state.item.i := {NATURAL_32} 96
			l_state.item.j := {NATURAL_32} 32
			l_state.item.carry := 362_436
		end

feature {ANY} -- routine addresses

	ranmar_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranmar_get)
		end

	ranmar_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranmar_get_double)
		end

	ranmar_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ranmar_set)
		end

end
