class
	P_RK2SIMP_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	rk2simp_type: CE_STATIC [CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ODEIV_STEP_TYPE]}.make_initialized (<<
					create {PD_GSL_ODEIV_STEP_TYPE}.make_initialized ([ce_string ("rk2simp"), 0, 1, rk2simp_alloc_address, rk2simp_apply_address, rk2simp_reset_address, rk2simp_order_address, rk2simp_free_address])
				>>)
		end

	gsl_odeiv_step_rk2simp: CE_STATIC [CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := rk2simp_type.item
		end

feature {ANY} -- public routines

	rk2simp_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK2SIMP_STATE_T]}.make_cast ((malloc ((create {PD_RK2SIMP_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rk2simp_state"), ce_string ("rk2simp.c"), 62, 8)
					Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.Y1 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.Y1).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for Y1"), ce_string ("rk2simp.c"), 70, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk2simp.c"), 79, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0_orig := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0_orig).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0_orig"), ce_string ("rk2simp.c"), 89, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.ytmp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk2simp.c"), 100, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.dfdy := create {CE_REAL_64_POINTER}.make_cast ((malloc ((a_dim * a_dim) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.dfdy).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dfdy"), ce_string ("rk2simp.c"), 112, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.dfdt := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.dfdt).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdy))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for dfdt"), ce_string ("rk2simp.c"), 125, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y_onestep := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdy))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdt))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y_onestep"), ce_string ("rk2simp.c"), 139, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.p := (create {P_INIT_STATIC}).gsl_permutation_alloc (a_dim)
				if (l_state.item.p).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdy))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdt))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for p"), ce_string ("rk2simp.c"), 153, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_cast (l_state))
			end
		end

	rk2simp_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		require
			not a_sys.is_void
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
			l_i: NATURAL_32
			l_y0___0: CE_POINTER [REAL_64]
			l_y0_orig: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK2SIMP_STATE_T]}.make_cast (a_vstate)
			l_y0___0 := l_state.item.y0
			l_y0_orig := l_state.item.y0_orig
			l_y_onestep := l_state.item.y_onestep
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y0___0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y0_orig), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y_onestep), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			l_s := (l_state.item.rk2simp_step (l_y_onestep, a_h, a_t, a_dim, a_sys))
			if l_s /= 0 then
				Result := l_s
				l_return := True
			end
			if not l_return then
				l_s___0 := (l_state.item.rk2simp_step (a_y, a_h / 2.0, a_t, a_dim, a_sys))
				if l_s___0 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___0
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_y0___0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___1 := (l_state.item.rk2simp_step (a_y, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys))
				if l_s___1 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___1
					l_return := True
				end
			end
			if not l_return and then (not a_dydt_out.is_void) then
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
				if l_s___2 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0_orig), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___2
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := (4.0 * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])) / 3.0
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk2simp_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK2SIMP_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdt), 0, (a_dim * a_dim) * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdt), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y_onestep), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk2simp_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK2SIMP_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_CLASS_POINTER [PD_RK2SIMP_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 2
		end

	rk2simp_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK2SIMP_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK2SIMP_STATE_T]}.make_cast (a_vstate)
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.Y1))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0_orig))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdy))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.dfdt))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_onestep));
			(create {P_INIT_STATIC}).gsl_permutation_free (l_state.item.p)
			free (create {CE_VOID_POINTER}.make_cast (l_state))
		end

feature {ANY} -- routine addresses

	rk2simp_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk2simp_alloc)
		end

	rk2simp_apply_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk2simp_apply)
		end

	rk2simp_reset_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk2simp_reset)
		end

	rk2simp_order_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk2simp_order)
		end

	rk2simp_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk2simp_free)
		end

end
