class
	P_RK4_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	rk4_type: CE_STATIC [CE_ARRAY [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_ODEIV_STEP_TYPE]}.make_initialized (<<
					create {PD_GSL_ODEIV_STEP_TYPE}.make_initialized ([ce_string ("rk4"), 1, 1, rk4_alloc_address, rk4_apply_address, rk4_reset_address, rk4_order_address, rk4_free_address])
				>>)
		end

	gsl_odeiv_step_rk4: CE_STATIC [CE_POINTER [PD_GSL_ODEIV_STEP_TYPE]]
		once ("PROCESS")
			Result.item := rk4_type.item
		end

feature {ANY} -- public routines

	rk4_alloc (a_dim: NATURAL_32): CE_POINTER [ANY]
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4_STATE_T]}.make_cast ((malloc ((create {PD_RK4_STATE_T}.make).structure_size.to_natural_32)))
			if l_state.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rk4_state"), ce_string ("rk4.c"), 57, 8)
					Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.k := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k"), ce_string ("rk4.c"), 65, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.k1 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.k1).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for k1"), ce_string ("rk4.c"), 74, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y0 := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y0).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y0"), ce_string ("rk4.c"), 84, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.ytmp := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.ytmp).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk4.c"), 95, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y_onestep := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_dim * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_state.item.y_onestep).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
					free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
					free (create {CE_VOID_POINTER}.make_cast (l_state))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ytmp"), ce_string ("rk4.c"), 107, 8)
						Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_cast (l_state))
			end
		end

	rk4_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		require
			not a_sys.is_void
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
			l_i: NATURAL_32
			l_k: CE_POINTER [REAL_64]
			l_k1: CE_POINTER [REAL_64]
			l_y0: CE_POINTER [REAL_64]
			l_y_onestep: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_s___0: INTEGER_32
			l_s___1: INTEGER_32
			l_s___2: INTEGER_32
			l_s___3: INTEGER_32
			l_s___4: INTEGER_32
			l_return: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4_STATE_T]}.make_cast (a_vstate)
			l_k := l_state.item.k
			l_k1 := l_state.item.k1
			l_y0 := l_state.item.y0
			l_y_onestep := l_state.item.y_onestep
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			if not a_dydt_in.is_void then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k), create {CE_VOID_POINTER}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			else
				l_s := ((a_sys.item.function).integer_32_item ([a_t, l_y0, l_k, a_sys.item.params]))
				if l_s /= 0 then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k1), create {CE_VOID_POINTER}.make_cast (l_k), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast (l_y_onestep), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___0 := (l_state.item.rk4_step (l_y_onestep, a_h, a_t, a_dim, a_sys))
				if l_s___0 /= 0 then
					Result := l_s___0
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k), create {CE_VOID_POINTER}.make_cast (l_k1), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___1 := (l_state.item.rk4_step (a_y, a_h / 2.0, a_t, a_dim, a_sys))
				if l_s___1 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___1
					l_return := True
				end
			end
			if not l_return then
				l_s___2 := ((a_sys.item.function).integer_32_item ([a_t + a_h / 2.0, a_y, l_k, a_sys.item.params]))
				if l_s___2 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___2
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k1), create {CE_VOID_POINTER}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				memcpy (create {CE_VOID_POINTER}.make_cast (l_y0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				l_s___3 := (l_state.item.rk4_step (a_y, a_h / 2.0, a_t + a_h / 2.0, a_dim, a_sys))
				if l_s___3 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_k1), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___3
					l_return := True
				end
			end
			if not l_return and then (not a_dydt_out.is_void) then
				l_s___4 := ((a_sys.item.function).integer_32_item ([a_t + a_h, a_y, a_dydt_out, a_sys.item.params]))
				if l_s___4 /= 0 then
					memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_k1), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
					Result := l_s___4
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := (4.0 * (a_y[l_i.to_integer_32] - l_y_onestep[l_i.to_integer_32])) / 15.0
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk4_reset (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4_STATE_T]}.make_cast (a_vstate)
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.k1), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y0), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (l_state.item.y_onestep), 0, a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			Result := 0
		end

	rk4_order (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4_STATE_T]}.make_cast (a_vstate)
			l_state := create {CE_CLASS_POINTER [PD_RK4_STATE_T]}.make_shared (default_pointer)
			Result := {NATURAL_32} 4
		end

	rk4_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_RK4_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_RK4_STATE_T]}.make_cast (a_vstate)
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.k1))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y0))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.ytmp))
			free (create {CE_VOID_POINTER}.make_cast (l_state.item.y_onestep))
			free (create {CE_VOID_POINTER}.make_cast (l_state))
		end

feature {ANY} -- routine addresses

	rk4_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4_alloc)
		end

	rk4_apply_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4_apply)
		end

	rk4_reset_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4_reset)
		end

	rk4_order_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4_order)
		end

	rk4_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent rk4_free)
		end

end
