class
	P_SHUFFLE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	swap (a_base: CE_POINTER [ANY]; a_size, a_i, a_j: NATURAL_32)
		local
			l_a___5: CE_POINTER [INTEGER_8]
			l_b___0: CE_POINTER [INTEGER_8]
			l_s: NATURAL_32
			l_tmp: INTEGER_8
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_a___5 := create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (a_size * a_i).to_integer_32
			l_b___0 := create {CE_INTEGER_8_POINTER}.make_cast (a_base) + (a_size * a_j).to_integer_32
			l_s := a_size
			if a_i = a_j then
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp := l_a___5[0]
					l_tmp___0 := l_a___5
					l_a___5 := l_a___5 + 1
					l_tmp___0[0] := l_b___0[0]
					l_tmp___1 := l_b___0
					l_b___0 := l_b___0 + 1
					l_tmp___1[0] := l_tmp
					l_s := l_s - 1
					if not (l_s > {NATURAL_32} 0) then
						l_break := True
					end
				end
				l_break := False
			end
		end

	copy2 (a_dest: CE_POINTER [ANY]; a_i: NATURAL_32; a_src: CE_POINTER [ANY]; a_j, a_size: NATURAL_32)
		local
			l_a___5: CE_POINTER [INTEGER_8]
			l_b___0: CE_POINTER [INTEGER_8]
			l_s: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			l_a___5 := create {CE_INTEGER_8_POINTER}.make_cast (a_dest) + (a_size * a_i).to_integer_32
			l_b___0 := create {CE_INTEGER_8_POINTER}.make_cast (a_src) + (a_size * a_j).to_integer_32
			l_s := a_size
			from
			until
				(l_break)
			loop
				l_break := False
				l_tmp := l_a___5
				l_a___5 := l_a___5 + 1
				l_tmp___0 := l_b___0
				l_b___0 := l_b___0 + 1
				l_tmp[0] := l_tmp___0[0]
				l_s := l_s - 1
				if not (l_s > {NATURAL_32} 0) then
					l_break := True
				end
			end
			l_break := False
		end

	gsl_ran_shuffle (a_r___3: CE_POINTER [PD_GSL_RNG]; a_base: CE_POINTER [ANY]; a_n, a_size: NATURAL_32)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
		do
			l_i := a_n - {NATURAL_32} 1
			from
			until
				not (l_i > {NATURAL_32} 0)
			loop
				l_j := (a_r___3.item.gsl_rng_uniform_int ((l_i + {NATURAL_32} 1).to_natural_32)).to_natural_32
				swap (a_base, a_size, l_i, l_j)
				l_i := l_i - 1
			end
		end

	gsl_ran_choose (a_r___3: CE_POINTER [PD_GSL_RNG]; a_dest: CE_POINTER [ANY]; a_k: NATURAL_32; a_src: CE_POINTER [ANY]; a_n, a_size: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_j := (0).to_natural_32
			if a_k > a_n then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("k is greater than n, cannot sample more than n items"), ce_string ("shuffle.c"), 95, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					(l_break)
				loop
					l_break := False
					if l_i < a_n then
						if not (l_j < a_k) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						if (a_n - l_i).to_real_64 * (a_r___3.item.gsl_rng_uniform) < (a_k - l_j).to_real_64 then
							copy2 (a_dest, l_j, a_src, l_i, a_size)
							l_j := l_j + 1
						end
						l_i := l_i + 1
					end
				end
				l_break := False
				Result := 0
			end
		end

	gsl_ran_sample (a_r___3: CE_POINTER [PD_GSL_RNG]; a_dest: CE_POINTER [ANY]; a_k: NATURAL_32; a_src: CE_POINTER [ANY]; a_n, a_size: NATURAL_32)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
		do
			l_j := (0).to_natural_32
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_k)
			loop
				l_j := (a_r___3.item.gsl_rng_uniform_int (a_n.to_natural_32)).to_natural_32
				copy2 (a_dest, l_i, a_src, l_j, a_size)
				l_i := l_i + 1
			end
		end

end
