class
	P_SIMPLEX_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	nmsimplex_type: CE_STATIC [CE_ARRAY [PD_GSL_MULTIMIN_FMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_MULTIMIN_FMINIMIZER_TYPE]}.make_initialized (<<
					create {PD_GSL_MULTIMIN_FMINIMIZER_TYPE}.make_initialized ([ce_string ("nmsimplex"), (create {PD_NMSIMPLEX_STATE_T}.make).structure_size.to_natural_32, nmsimplex_alloc_address, (create {PD_GSL_MULTIMIN_FUNCTION_STRUCT_STATIC}).nmsimplex_set_address, nmsimplex_iterate_address, nmsimplex_free_address])
				>>)
		end

	gsl_multimin_fminimizer_nmsimplex: CE_STATIC [CE_POINTER [PD_GSL_MULTIMIN_FMINIMIZER_TYPE]]
		once ("PROCESS")
			Result.item := nmsimplex_type.item
		end

feature {ANY} -- public routines

	nmsimplex_alloc (a_vstate: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]
			l_return, l_break: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_NMSIMPLEX_STATE_T]}.make_cast (a_vstate)
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid number of parameters specified"), ce_string ("simplex.c"), 196, 4)
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_state.item.x1 := (create {P_INIT_SOURCE_STATIC}).gsl_matrix_alloc (a_n + {NATURAL_32} 1, a_n)
				if (l_state.item.x1).is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x1"), ce_string ("simplex.c"), 203, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.y1 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n + {NATURAL_32} 1)
				if (l_state.item.y1).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.x1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y"), ce_string ("simplex.c"), 211, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.ws1 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
				if (l_state.item.ws1).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.x1);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.y1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ws1"), ce_string ("simplex.c"), 220, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_state.item.ws2 := (create {P_INIT_SOURCE_STATIC}).gsl_vector_alloc (a_n)
				if (l_state.item.ws2).is_void then
					(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.x1);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.y1);
					(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.ws1)
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for ws2"), ce_string ("simplex.c"), 230, 8)
						Result := 8
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	nmsimplex_free (a_vstate: CE_POINTER [ANY])
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_NMSIMPLEX_STATE_T]}.make_cast (a_vstate);
			(create {P_INIT_SOURCE_STATIC}).gsl_matrix_free (l_state.item.x1);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.y1);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.ws1);
			(create {P_INIT_SOURCE_STATIC}).gsl_vector_free (l_state.item.ws2)
		end

	nmsimplex_iterate (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_size, a_fval: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_x.is_void
		local
			l_state: CE_POINTER [PD_NMSIMPLEX_STATE_T]
			l_xc: CE_POINTER [PD_GSL_VECTOR]
			l_xc2: CE_POINTER [PD_GSL_VECTOR]
			l_y1___0: CE_POINTER [PD_GSL_VECTOR]
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_n: NATURAL_32
			l_i: NATURAL_32
			l_hi: NATURAL_32
			l_s_hi: NATURAL_32
			l_lo: NATURAL_32
			l_dhi: REAL_64
			l_ds_hi: REAL_64
			l_dlo: REAL_64
			l_status: INTEGER_32
			l_val: REAL_64
			l_val2: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_state := create {CE_CLASS_POINTER [PD_NMSIMPLEX_STATE_T]}.make_cast (a_vstate)
					l_xc := l_state.item.ws1
					l_xc2 := l_state.item.ws2
					l_y1___0 := l_state.item.y1
					l_x1___0 := l_state.item.x1
					l_n := l_y1___0.item.size
					if l_xc.item.size /= a_x.item.size then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("incompatible size of x"), ce_string ("simplex.c"), 340, 4)
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_dlo := l_y1___0.item.gsl_vector_get ((0).to_natural_32)
						l_dhi := l_dlo
						l_hi := (0).to_natural_32
						l_lo := (0).to_natural_32
						l_ds_hi := l_y1___0.item.gsl_vector_get ((1).to_natural_32)
						l_s_hi := (1).to_natural_32
						l_i := (1).to_natural_32
						from
						until
							not (l_i < l_n)
						loop
							l_val := l_y1___0.item.gsl_vector_get (l_i)
							if l_val < l_dlo then
								l_dlo := l_val
								l_lo := l_i
							elseif l_val > l_dhi then
								l_ds_hi := l_dhi
								l_s_hi := l_hi
								l_dhi := l_val
								l_hi := l_i
							elseif l_val > l_ds_hi then
								l_ds_hi := l_val
								l_s_hi := l_i
							end
							l_i := l_i + 1
						end
						l_val := l_state.item.nmsimplex_move_corner (-1.0, l_hi, l_xc, a_f)
						if not (((create {P_INFNAN_STATIC}).gsl_finite (l_val)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_val < (l_y1___0.item.gsl_vector_get (l_lo)) then
							l_val2 := l_state.item.nmsimplex_move_corner (-2.0, l_hi, l_xc2, a_f)
							if ((create {P_INFNAN_STATIC}).gsl_finite (l_val2)).to_boolean then
								if l_val2 < (l_y1___0.item.gsl_vector_get (l_lo)) then
									l_x1___0.item.gsl_matrix_set_row (l_hi, l_xc2).do_nothing
									l_y1___0.item.gsl_vector_set (l_hi, l_val2)
								else
									l_x1___0.item.gsl_matrix_set_row (l_hi, l_xc).do_nothing
									l_y1___0.item.gsl_vector_set (l_hi, l_val)
								end
							else
								l_x1___0.item.gsl_matrix_set_row (l_hi, l_xc).do_nothing
								l_y1___0.item.gsl_vector_set (l_hi, l_val)
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else: | _L___1:
						if not (((create {P_INFNAN_STATIC}).gsl_finite (l_val)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if not (l_val > (l_y1___0.item.gsl_vector_get (l_s_hi))) then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if: | _L___0:
						if ((create {P_INFNAN_STATIC}).gsl_finite (l_val)).to_boolean then
							if l_val <= (l_y1___0.item.gsl_vector_get (l_hi)) then
								l_x1___0.item.gsl_matrix_set_row (l_hi, l_xc).do_nothing
								l_y1___0.item.gsl_vector_set (l_hi, l_val)
							end
						end
						l_val2 := l_state.item.nmsimplex_move_corner (0.5, l_hi, l_xc2, a_f)
						if not (((create {P_INFNAN_STATIC}).gsl_finite (l_val2)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_val2 <= (l_y1___0.item.gsl_vector_get (l_hi)) then
							(l_state.item.x1).item.gsl_matrix_set_row (l_hi, l_xc2).do_nothing
							l_y1___0.item.gsl_vector_set (l_hi, l_val2)
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						l_status := l_state.item.nmsimplex_contract_by_best (l_lo, l_xc, a_f)
						if l_status /= 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("nmsimplex_contract_by_best failed"), ce_string ("simplex.c"), 430, 5)
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_x1___0.item.gsl_matrix_set_row (l_hi, l_xc).do_nothing
						l_y1___0.item.gsl_vector_set (l_hi, l_val)
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_pos := -1 + 6 -- goto _L___0
				when 14 then -- if done | if done
					if not l_return then
						l_lo := l_y1___0.item.gsl_vector_min_index;
						(create {P_GETSET_SOURCE_STATIC}).gsl_matrix_get_row (a_x, l_x1___0, l_lo).do_nothing
						a_fval.item := l_y1___0.item.gsl_vector_get (l_lo)
						a_size.item := l_state.item.nmsimplex_size
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	nmsimplex_alloc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nmsimplex_alloc)
		end

	nmsimplex_free_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nmsimplex_free)
		end

	nmsimplex_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nmsimplex_iterate)
		end

end
