class
	P_SLATEC_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	P: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (4_194_304).to_integer_32
		end

	a1___1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (1_536).to_integer_32
		end

	a0___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (1_029).to_integer_32
		end

	a1ma0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (507).to_integer_32
		end

	c: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (1_731).to_integer_32
		end

	slatec_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("slatec"), {NATURAL_32} 4_194_303, {NATURAL_32} 0, (create {PD_SLATEC_STATE_T}.make).structure_size.to_natural_32, slatec_set_address, slatec_get_address, slatec_get_double_address])
				>>)
		end

	gsl_rng_slatec: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := slatec_type.item
		end

feature {ANY} -- public routines

	slatec_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_y0: INTEGER_32
			l_y1: INTEGER_32
			l_state: CE_POINTER [PD_SLATEC_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_SLATEC_STATE_T]}.make_cast (a_vstate)
			l_y0 := (a0___0.item * l_state.item.x0)
			l_y1 := ((a1___1.item * l_state.item.x1 + a1ma0.item * (l_state.item.x0 - l_state.item.x1)) + l_y0)
			l_y0 := l_y0 + c.item
			l_state.item.x0 := l_y0 \\ 2_048
			l_y1 := l_y1 + ((l_y0 - l_state.item.x0) // 2_048)
			l_state.item.x1 := l_y1 \\ 2_048
			Result := (l_state.item.x1 * 2_048 + l_state.item.x0).to_natural_32
		end

	slatec_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((slatec_get (a_vstate)).to_real_64 / 4194304.0)
		end

	slatec_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_SLATEC_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_SLATEC_STATE_T]}.make_cast (a_vstate)
			l_s := l_s \\ ({NATURAL_32} 8)
			l_s := l_s * (P.item // 8).to_natural_32
			l_state.item.x0 := (l_s \\ {NATURAL_32} 2_048).to_integer_32
			l_state.item.x1 := ((l_s - (l_state.item.x0).to_natural_32) // {NATURAL_32} 2_048).to_integer_32
		end

feature {ANY} -- routine addresses

	slatec_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent slatec_get)
		end

	slatec_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent slatec_get_double)
		end

	slatec_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent slatec_set)
		end

end
