class
	P_SPLINE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_spline_alloc (a_T: CE_POINTER [PD_GSL_INTERP_TYPE]; a_size: NATURAL_32): CE_POINTER [PD_GSL_SPLINE]
		local
			l_spline: CE_POINTER [PD_GSL_SPLINE]
			l_return, l_break: BOOLEAN
		do
			l_spline := create {CE_CLASS_POINTER [PD_GSL_SPLINE]}.make_cast ((malloc ((create {PD_GSL_SPLINE}.make).structure_size.to_natural_32)))
			if l_spline.is_void then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for spline struct"), ce_string ("spline.c"), 34, 8)
					Result := (create {CE_CLASS_POINTER [PD_GSL_SPLINE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_spline.item.interp := a_T.item.gsl_interp_alloc (a_size)
				if (l_spline.item.interp).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_spline))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for interp"), ce_string ("spline.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_SPLINE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_spline.item.x := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_spline.item.x).is_void then
					(create {P_INTERP_STATIC}).gsl_interp_free (l_spline.item.interp)
					free (create {CE_VOID_POINTER}.make_cast (l_spline))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for x"), ce_string ("spline.c"), 51, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_SPLINE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_spline.item.y := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_size * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_spline.item.y).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_spline.item.x));
					(create {P_INTERP_STATIC}).gsl_interp_free (l_spline.item.interp)
					free (create {CE_VOID_POINTER}.make_cast (l_spline))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for y"), ce_string ("spline.c"), 61, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_SPLINE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_spline.item.size := a_size
				Result := l_spline
			end
		end

	gsl_spline_free (a_spline: CE_POINTER [PD_GSL_SPLINE])
		local
			l_return: BOOLEAN
		do
			if a_spline.is_void then
				l_return := True
			end
			if not l_return then
				(create {P_INTERP_STATIC}).gsl_interp_free (a_spline.item.interp)
				free (create {CE_VOID_POINTER}.make_cast (a_spline.item.x))
				free (create {CE_VOID_POINTER}.make_cast (a_spline.item.y))
				free (create {CE_VOID_POINTER}.make_cast (a_spline))
			end
		end

end
