class
	P_TRIG_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public attributes

	sinc_data: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					1.133648177811747875422, -0.532677564732557348781, -0.068293048346633177859, 0.033403684226353715020,
					0.001485679893925747818, -0.000734421305768455295, -0.000016837282388837229, 0.000008359950146618018,
					0.000000117382095601192, -0.000000058413665922724, -0.000000000554763755743, 0.000000000276434190426,
					0.000000000001895374892, -0.000000000000945237101, -0.000000000000004900690, 0.000000000000002445383,
					0.000000000000000009925
				>>)
		end

	sinc_cs: CE_STATIC [CE_ARRAY [PD_CHEB_SERIES_STRUCT]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CHEB_SERIES_STRUCT]}.make_initialized (<<
					create {PD_CHEB_SERIES_STRUCT}.make_initialized ([sinc_data.item, 16, (-1).to_double, (1).to_double, 10])
				>>)
		end

feature {ANY} -- public routines

	gsl_sf_angle_restrict_symm_e (a_theta: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_theta.is_void
		local
			l_r___3: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r___3.make (<<1>>)

			l_stat := (l_r___3.item.gsl_sf_angle_restrict_symm_err_e (a_theta.item))
			a_theta.item := l_r___3.item.val
			Result := l_stat
		end

	gsl_sf_angle_restrict_pos_e (a_theta: CE_POINTER [REAL_64]): INTEGER_32
		require
			not a_theta.is_void
		local
			l_r___3: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r___3.make (<<1>>)

			l_stat := (l_r___3.item.gsl_sf_angle_restrict_pos_err_e (a_theta.item))
			a_theta.item := l_r___3.item.val
			Result := l_stat
		end

	gsl_sf_sinc_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		require
			not a_result.is_void
		local
			l_ax: REAL_64
			l_r___3: REAL_64
			l_s: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_s: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_s.make (<<1>>)

			l_ax := (fabs (a_x))
			if l_ax < 0.8 then
				Result := (sinc_cs.item.item.cheb_eval_e (2.0 * l_ax - 1.0, a_result))
			elseif l_ax < 100.0 then
				a_result.item.val := (sin (3.14159265358979323846 * l_ax)) / (3.14159265358979323846 * l_ax)
				a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := 0
			else
				l_r___3 := 3.14159265358979323846 * l_ax
				l_stat_s := (l_s.item.gsl_sf_sin_e (l_r___3))
				a_result.item.val := l_s.item.val / l_r___3
				a_result.item.err := l_s.item.err / l_r___3 + (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				Result := l_stat_s
			end
		end

	gsl_sf_sin (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_sin_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_sin_e(x, &result)"), ce_string ("trig.c"), 726, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_cos (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_cos_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_cos_e(x, &result)"), ce_string ("trig.c"), 731, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_hypot (a_x, a_y: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_hypot_e (a_x, a_y))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_hypot_e(x, y, &result)"), ce_string ("trig.c"), 736, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_lnsinh (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_lnsinh_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_lnsinh_e(x, &result)"), ce_string ("trig.c"), 741, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_lncosh (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_lncosh_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_lncosh_e(x, &result)"), ce_string ("trig.c"), 746, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_angle_restrict_symm (a_theta: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_result.make (<<1>>)

			l_result.item := a_theta
			l_status := (gsl_sf_angle_restrict_symm_e (l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_angle_restrict_symm_e(&result)"), ce_string ("trig.c"), 752, l_status)
					Result := (l_result.item)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item)
			end
		end

	gsl_sf_angle_restrict_pos (a_theta: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [REAL_64]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_64_ARRAY} l_result.make (<<1>>)

			l_result.item := a_theta
			l_status := (gsl_sf_angle_restrict_pos_e (l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_angle_restrict_pos_e(&result)"), ce_string ("trig.c"), 758, l_status)
					Result := (l_result.item)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item)
			end
		end

	gsl_sf_sinc (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (gsl_sf_sinc_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_sinc_e(x, &result)"), ce_string ("trig.c"), 770, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
