class
	P_UNI_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m1___1: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (32_767).to_natural_32
		end

	m2___1: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (256).to_natural_32
		end

	uni_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("uni"), {NATURAL_32} 32_766, {NATURAL_32} 0, (create {PD_UNI_STATE_T}.make).structure_size.to_natural_32, uni_set_address, uni_get_address, uni_get_double_address])
				>>)
		end

	gsl_rng_uni: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := uni_type.item
		end

feature {ANY} -- public routines

	uni_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_UNI_STATE_T]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_UNI_STATE_T]}.make_cast (a_vstate)
			l_i := l_state.item.i
			l_j := l_state.item.j
			l_k := (l_state.item.m[l_i] - l_state.item.m[l_j]).to_integer_32
			if l_k < 0 then
				l_k := (l_k.to_natural_32 + m1___1.item.to_natural_32).to_integer_32
			end
			l_state.item.m[l_j] := l_k.to_natural_32
			if l_i = 0 then
				l_state.item.i := 16
			else
				l_state.item.i := (l_state.item.i) - 1
			end
			if l_j = 0 then
				l_state.item.j := 16
			else
				l_state.item.j := (l_state.item.j) - 1
			end
			Result := l_k.to_natural_32
		end

	uni_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((uni_get (a_vstate)).to_real_64 / 32767.0)
		end

	uni_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_seed: NATURAL_32
			l_k0: NATURAL_32
			l_k1: NATURAL_32
			l_j0: NATURAL_32
			l_j1: NATURAL_32
			l_state: CE_POINTER [PD_UNI_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_UNI_STATE_T]}.make_cast (a_vstate)
			l_s := {NATURAL_32} 2 * l_s + {NATURAL_32} 1
			if l_s < m1___1.item.to_natural_32 then
				l_seed := l_s.to_natural_32
			else
				l_seed := m1___1.item
			end
			l_k0 := {NATURAL_32} 9_069 \\ m2___1.item
			l_k1 := {NATURAL_32} 9_069 // m2___1.item
			l_j0 := l_seed \\ m2___1.item
			l_j1 := l_seed // m2___1.item
			l_i := {NATURAL_32} 0
			from
			until
				not (l_i < {NATURAL_32} 17)
			loop
				l_seed := l_j0 * l_k0
				l_j1 := ((l_seed // m2___1.item + l_j0 * l_k1) + l_j1 * l_k0) \\ (m2___1.item // {NATURAL_32} 2)
				l_j0 := l_seed \\ m2___1.item
				l_state.item.m[l_i.to_integer_32] := (l_j0 + (m2___1.item * l_j1)).to_natural_32
				l_i := l_i + 1
			end
			l_state.item.i := 4
			l_state.item.j := 16
		end

feature {ANY} -- routine addresses

	uni_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent uni_get)
		end

	uni_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent uni_get_double)
		end

	uni_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent uni_set)
		end

end
