class
	P_WORKSPACE_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_integration_workspace_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]
		local
			l_w: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("workspace length n must be positive integer"), ce_string ("workspace.c"), 33, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_w := create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_cast ((malloc ((create {PD_GSL_INTEGRATION_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_w.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for workspace struct"), ce_string ("workspace.c"), 42, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.alist := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.alist).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for alist ranges"), ce_string ("workspace.c"), 52, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.blist := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.blist).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.alist))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for blist ranges"), ce_string ("workspace.c"), 63, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.rlist := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.rlist).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.blist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.alist))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for rlist ranges"), ce_string ("workspace.c"), 75, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.elist := create {CE_REAL_64_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.elist).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.rlist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.blist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.alist))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for elist ranges"), ce_string ("workspace.c"), 89, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.order := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Natural_32_bytes.to_natural_32)))
				if (l_w.item.order).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.elist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.rlist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.blist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.alist))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for order ranges"), ce_string ("workspace.c"), 103, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.level := create {CE_NATURAL_32_POINTER}.make_cast ((malloc (a_n * {PLATFORM}.Natural_32_bytes.to_natural_32)))
				if (l_w.item.level).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.order))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.elist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.rlist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.blist))
					free (create {CE_VOID_POINTER}.make_cast (l_w.item.alist))
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for order ranges"), ce_string ("workspace.c"), 118, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_INTEGRATION_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_w.item.size := (0).to_natural_32
				l_w.item.limit := a_n
				l_w.item.maximum_level := (0).to_natural_32
				Result := l_w
			end
		end

	gsl_integration_workspace_free (a_w: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.level))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.order))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.elist))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.rlist))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.blist))
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.alist))
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
