class
	P_ZSOLVE_INIT_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public routines

	gsl_poly_complex_workspace_alloc (a_n: NATURAL_32): CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]
		local
			l_nc: NATURAL_32
			l_w: CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix size n must be positive integer"), ce_string ("zsolve_init.c"), 36, 1)
					Result := (create {CE_CLASS_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_w := create {CE_CLASS_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]}.make_cast ((malloc ((create {PD_GSL_POLY_COMPLEX_WORKSPACE}.make).structure_size.to_natural_32)))
				if l_w.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for struct"), ce_string ("zsolve_init.c"), 44, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_nc := a_n - {NATURAL_32} 1
				l_w.item.nc := l_nc
				l_w.item.matrix := create {CE_REAL_64_POINTER}.make_cast ((malloc ((l_nc * l_nc) * {PLATFORM}.Real_64_bytes.to_natural_32)))
				if (l_w.item.matrix).is_void then
					free (create {CE_VOID_POINTER}.make_cast (l_w))
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for workspace matrix"), ce_string ("zsolve_init.c"), 58, 8)
						Result := (create {CE_CLASS_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				Result := l_w
			end
		end

	gsl_poly_complex_workspace_free (a_w: CE_POINTER [PD_GSL_POLY_COMPLEX_WORKSPACE])
		local
			l_return: BOOLEAN
		do
			if a_w.is_void then
				l_return := True
			end
			if not l_return then
				free (create {CE_VOID_POINTER}.make_cast (a_w.item.matrix))
				free (create {CE_VOID_POINTER}.make_cast (a_w))
			end
		end

end
