class
	PD_CHEB_SERIES_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} c.make
			Precursor
		end

feature {ANY} -- fields

	c: CE_POINTER [REAL_64] assign set_c

	order: INTEGER_32 assign set_order

	a: REAL_64 assign set_a

	b: REAL_64 assign set_b

	order_sp: INTEGER_32 assign set_order_sp

feature {ANY} -- field setters

	set_c (a_c: CE_POINTER [REAL_64])
		do
			c := a_c
			update_memory_field ("c")
		end

	set_order (a_order: INTEGER_32)
		do
			order := a_order
			update_memory_field ("order")
		end

	set_a (a_a: REAL_64)
		do
			a := a_a
			update_memory_field ("a")
		end

	set_b (a_b: REAL_64)
		do
			b := a_b
			update_memory_field ("b")
		end

	set_order_sp (a_order_sp: INTEGER_32)
		do
			order_sp := a_order_sp
			update_memory_field ("order_sp")
		end

feature {ANY} -- public routines

	cheb_eval_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		require
			not a_result.is_void
		local
			l_j: INTEGER_32
			l_d: REAL_64
			l_dd: REAL_64
			l_y: REAL_64
			l_y2: REAL_64
			l_e: REAL_64
			l_temp: REAL_64
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: REAL_64
			l_temp___0: REAL_64
			l_tmp___2: REAL_64
			l_tmp___3: REAL_64
			l_tmp___4: REAL_64
			l_tmp___5: REAL_64
		do
			l_d := 0.0
			l_dd := 0.0
			l_y := ((2.0 * a_x - a) - b) / (b - a)
			l_y2 := 2.0 * l_y
			l_e := 0.0
			l_j := order
			from
			until
				not (l_j >= 1)
			loop
				l_temp := l_d
				l_d := (l_y2 * l_d - l_dd) + c[l_j]
				l_tmp := fabs (l_y2 * l_temp)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := fabs (l_dd)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := fabs (c[l_j])
				update_class_fields -- Current might have been changed; synchronize
				l_e := l_e + ((l_tmp + l_tmp___0) + l_tmp___1)
				l_dd := l_temp
				l_j := l_j - 1
			end
			l_temp___0 := l_d
			l_d := (l_y * l_d - l_dd) + 0.5 * c[0]
			l_tmp___2 := fabs (l_y * l_temp___0)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___3 := fabs (l_dd)
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___4 := fabs (c[0])
			update_class_fields -- Current might have been changed; synchronize
			l_e := l_e + ((l_tmp___2 + l_tmp___3) + 0.5 * l_tmp___4)
			a_result.item.val := l_d
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___5 := fabs (c[order])
			update_class_fields -- Current might have been changed; synchronize
			a_result.item.err := 2.2204460492503131e-16 * l_e + l_tmp___5
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

feature {ANY}

	copy (a_other: like Current)
		do
			c := a_other.c
			order := a_other.order
			a := a_other.a
			b := a_other.b
			order_sp := a_other.order_sp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				c.is_equal (a_other.c) and
				order = a_other.order and
				a = a_other.a and
				b = a_other.b and
				order_sp = a_other.order_sp
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("c"),
					create {CE_STRUCTURE_FIELD}.make ("order"),
					create {CE_STRUCTURE_FIELD}.make ("a"),
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("order_sp")
				>>)
			init_structure_info
		end

end
