class
	PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBIO_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_96_POINTER} data.make
			Precursor
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	data: CE_POINTER [REAL_96] assign set_data

feature {ANY} -- field setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_data (a_data: CE_POINTER [REAL_96])
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY} -- public routines

	gsl_block_complex_long_double_size: NATURAL_32
		do
			Result := size
		end

	gsl_block_complex_long_double_data: CE_POINTER [REAL_96]
		do
			Result := data
		end

	gsl_block_complex_long_double_fread (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_items: NATURAL_32
			l_tmp: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_n := size
			l_data := data
			l_tmp := fread (create {CE_VOID_POINTER}.make_cast (l_data), {NATURAL_32} 2 * {CE_UTILITIES}.Real_96_bytes.to_natural_32, l_n, a_stream)
			update_class_fields -- Current might have been changed; synchronize
			l_items := l_tmp
			if l_items /= l_n then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("fread failed"), ce_string ("fwrite_source.c"), 31, 5)
					update_class_fields -- Current might have been changed; synchronize
					Result := 5
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_long_double_fwrite (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_items: NATURAL_32
			l_tmp: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_n := size
			l_data := data
			l_tmp := fwrite (create {CE_VOID_POINTER}.make_cast (l_data), {NATURAL_32} 2 * {CE_UTILITIES}.Real_96_bytes.to_natural_32, l_n, a_stream)
			update_class_fields -- Current might have been changed; synchronize
			l_items := l_tmp
			if l_items /= l_n then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("fwrite failed"), ce_string ("fwrite_source.c"), 48, 5)
					update_class_fields -- Current might have been changed; synchronize
					Result := 5
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_long_double_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_n := size
			l_data := data
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 2))
				loop
					if l_k > 0 then
						l_status := IO_putc ((' ').code, a_stream)
						update_class_fields -- Current might have been changed; synchronize
						if l_status = -1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 44, 5)
								update_class_fields -- Current might have been changed; synchronize
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_status := fprintf ([a_stream, a_format, l_data[({NATURAL_32} 2 * l_i + l_k.to_natural_32).to_integer_32]])
						update_class_fields -- Current might have been changed; synchronize
						if l_status < 0 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("fprintf failed"), ce_string ("fprintf_source.c"), 52, 5)
								update_class_fields -- Current might have been changed; synchronize
								Result := 5
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_status := IO_putc (('%N').code, a_stream)
					update_class_fields -- Current might have been changed; synchronize
					if l_status = -1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("putc failed"), ce_string ("fprintf_source.c"), 60, 5)
							update_class_fields -- Current might have been changed; synchronize
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_block_complex_long_double_fscanf (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_data: CE_POINTER [REAL_96]
			l_i: NATURAL_32
			l_k: INTEGER_32
			l_tmp: CE_ARRAY [REAL_96]
			l_status: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_REAL_96_ARRAY} l_tmp.make (<<1>>)

			l_n := size
			l_data := data
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_n))
			loop
				l_k := 0
				from
				until
					not (not (l_return) and then (l_k < 2))
				loop
					l_tmp___0 := fscanf ([a_stream, ce_string ("%%Lg"), l_tmp])
					update_class_fields -- Current might have been changed; synchronize
					l_status := l_tmp___0
					l_data[({NATURAL_32} 2 * l_i + l_k.to_natural_32).to_integer_32] := l_tmp.item
					update_class_fields -- Current might have been changed; synchronize
					if l_status /= 1 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("fscanf failed"), ce_string ("fprintf_source.c"), 90, 5)
							update_class_fields -- Current might have been changed; synchronize
							Result := 5
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_matrix_complex_long_double_alloc_from_block (a_offset, a_n1, a_n2, a_d2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]
		local
			l_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 97, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 102, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_d2 < a_n2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension d2 must be greater than n2"), ce_string ("init_source.c"), 107, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif size < a_offset + a_n1 * a_d2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix size exceeds available block size"), ce_string ("init_source.c"), 112, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_cast (l_tmp)
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 120, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := data + ({NATURAL_32} 2 * a_offset).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.tda := a_d2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.block := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := l_m___4
			end
		end

	gsl_vector_complex_long_double_alloc_from_block (a_offset, a_n, a_stride: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 90, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("init_source.c"), 95, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (size <= a_offset + (a_n - {NATURAL_32} 1) * a_stride) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector would extend past end of block"), ce_string ("init_source.c"), 100, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_cast (l_tmp)
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 108, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := data + ({NATURAL_32} 2 * a_offset).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.stride := a_stride
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.block := (create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (c_pointer))
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := l_v
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			data := a_other.data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
