class
	PD_GSL_BSPLINE_DERIV_WORKSPACE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} A.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} dB.make
		end

feature {ANY} -- fields

	k: NATURAL_32 assign set_k

	A: CE_POINTER [PD_GSL_MATRIX] assign set_A

	dB: CE_POINTER [PD_GSL_MATRIX] assign set_dB

feature {ANY} -- field setters

	set_k (a_k: NATURAL_32)
		do
			k := a_k
			update_memory_field ("k")
		end

	set_A (a_A: CE_POINTER [PD_GSL_MATRIX])
		do
			A := a_A
			update_memory_field ("A")
		end

	set_dB (a_dB: CE_POINTER [PD_GSL_MATRIX])
		do
			dB := a_dB
			update_memory_field ("dB")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			k := a_other.k
			A := a_other.A
			dB := a_other.dB
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				k = a_other.k and
				A.is_equal (a_other.A) and
				dB.is_equal (a_other.dB)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("k"),
					create {CE_STRUCTURE_FIELD}.make ("A"),
					create {CE_STRUCTURE_FIELD}.make ("dB")
				>>)
			init_structure_info
		end

end
