class
	PD_GSL_MIN_FMINIMIZER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE]} type.make
			create {CE_CLASS_POINTER [PD_GSL_FUNCTION_STRUCT]} function.make
			create {CE_VOID_POINTER} state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE] assign set_type

	function: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_function

	x_minimum: REAL_64 assign set_x_minimum

	x_lower: REAL_64 assign set_x_lower

	x_upper: REAL_64 assign set_x_upper

	f_minimum: REAL_64 assign set_f_minimum

	f_lower: REAL_64 assign set_f_lower

	f_upper: REAL_64 assign set_f_upper

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- field setters

	set_type (a_type: CE_POINTER [PD_GSL_MIN_FMINIMIZER_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_function (a_function: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			function := a_function
			update_memory_field ("function")
		end

	set_x_minimum (a_x_minimum: REAL_64)
		do
			x_minimum := a_x_minimum
			update_memory_field ("x_minimum")
		end

	set_x_lower (a_x_lower: REAL_64)
		do
			x_lower := a_x_lower
			update_memory_field ("x_lower")
		end

	set_x_upper (a_x_upper: REAL_64)
		do
			x_upper := a_x_upper
			update_memory_field ("x_upper")
		end

	set_f_minimum (a_f_minimum: REAL_64)
		do
			f_minimum := a_f_minimum
			update_memory_field ("f_minimum")
		end

	set_f_lower (a_f_lower: REAL_64)
		do
			f_lower := a_f_lower
			update_memory_field ("f_lower")
		end

	set_f_upper (a_f_upper: REAL_64)
		do
			f_upper := a_f_upper
			update_memory_field ("f_upper")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY} -- public routines

	gsl_min_fminimizer_set_with_values (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper: REAL_64): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					Current.function := a_f
					update_class_fields -- Current might have been changed; synchronize
					Current.x_minimum := a_x_minimum
					update_class_fields -- Current might have been changed; synchronize
					Current.x_lower := a_x_lower
					update_class_fields -- Current might have been changed; synchronize
					Current.x_upper := a_x_upper
					update_class_fields -- Current might have been changed; synchronize
					if a_x_lower > a_x_upper then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid interval (lower > upper)"), ce_string ("fsolver.c"), 111, 4)
							update_class_fields -- Current might have been changed; synchronize
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (a_x_minimum >= a_x_upper) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not (a_x_minimum <= a_x_lower) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("x_minimum must lie inside interval (lower < x < upper)"), ce_string ("fsolver.c"), 117, 4)
							update_class_fields -- Current might have been changed; synchronize
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 6 then -- if done | if done
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 7 then -- if:
						Current.f_lower := a_f_lower
						update_class_fields -- Current might have been changed; synchronize
						Current.f_upper := a_f_upper
						update_class_fields -- Current might have been changed; synchronize
						Current.f_minimum := a_f_minimum
						update_class_fields -- Current might have been changed; synchronize
						if not (a_f_minimum >= a_f_lower) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (a_f_minimum >= a_f_upper) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L___0:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("endpoints do not enclose a minimum"), ce_string ("fsolver.c"), 126, 4)
							update_class_fields -- Current might have been changed; synchronize
							Result := 4
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 12 then -- if done | if done
					if not l_return then
						l_tmp := (type.item.set).integer_32_item ([state, function, a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper])
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_min_fminimizer_iterate: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := (type.item.iterate).integer_32_item ([state, function, create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("x_minimum")), create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("f_minimum")), create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("x_lower")), create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("f_lower")), create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("x_upper")), create {CE_REAL_64_POINTER}.make_shared (c_pointer + (create {PD_GSL_MIN_FMINIMIZER}.make).offset_of ("f_upper"))])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_min_fminimizer_name: CE_POINTER [INTEGER_8]
		do
			Result := (type.item.name)
		end

	gsl_min_fminimizer_minimum: REAL_64
		do
			Result := x_minimum
		end

	gsl_min_fminimizer_x_minimum: REAL_64
		do
			Result := x_minimum
		end

	gsl_min_fminimizer_x_lower: REAL_64
		do
			Result := x_lower
		end

	gsl_min_fminimizer_x_upper: REAL_64
		do
			Result := x_upper
		end

	gsl_min_fminimizer_f_minimum: REAL_64
		do
			Result := f_minimum
		end

	gsl_min_fminimizer_f_lower: REAL_64
		do
			Result := f_lower
		end

	gsl_min_fminimizer_f_upper: REAL_64
		do
			Result := f_upper
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			function := a_other.function
			x_minimum := a_other.x_minimum
			x_lower := a_other.x_lower
			x_upper := a_other.x_upper
			f_minimum := a_other.f_minimum
			f_lower := a_other.f_lower
			f_upper := a_other.f_upper
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				function.is_equal (a_other.function) and
				x_minimum = a_other.x_minimum and
				x_lower = a_other.x_lower and
				x_upper = a_other.x_upper and
				f_minimum = a_other.f_minimum and
				f_lower = a_other.f_lower and
				f_upper = a_other.f_upper and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("x_minimum"),
					create {CE_STRUCTURE_FIELD}.make ("x_lower"),
					create {CE_STRUCTURE_FIELD}.make ("x_upper"),
					create {CE_STRUCTURE_FIELD}.make ("f_minimum"),
					create {CE_STRUCTURE_FIELD}.make ("f_lower"),
					create {CE_STRUCTURE_FIELD}.make ("f_upper"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
