class
	PD_GSL_MONTE_PLAIN_STATE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} x.make
		end

feature {ANY} -- fields

	dim: NATURAL_32 assign set_dim

	x: CE_POINTER [REAL_64] assign set_x

feature {ANY} -- field setters

	set_dim (a_dim: NATURAL_32)
		do
			dim := a_dim
			update_memory_field ("dim")
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			x := a_x
			update_memory_field ("x")
		end

feature {ANY} -- public routines

	gsl_monte_plain_init: INTEGER_32
		local
			l_i: NATURAL_32
		do
			l_i := (0).to_natural_32
			from
			until
				not (l_i < dim)
			loop
				x[l_i.to_integer_32] := 0.0
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			Result := 0
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dim := a_other.dim
			x := a_other.x
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dim = a_other.dim and
				x.is_equal (a_other.x)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dim"),
					create {CE_STRUCTURE_FIELD}.make ("x")
				>>)
			init_structure_info
		end

end
