class
	PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT

inherit
	PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create f.make
			create df.make
			create fdf.make
			create {CE_VOID_POINTER} params.make
			Precursor
		end

feature {ANY} -- fields

	f: CE_ROUTINE assign set_f

	df: CE_ROUTINE assign set_df

	fdf: CE_ROUTINE assign set_fdf

	n: NATURAL_32 assign set_n

	p: NATURAL_32 assign set_p

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- field setters

	set_f (a_f: CE_ROUTINE)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_df (a_df: CE_ROUTINE)
		do
			df := a_df
			update_memory_field ("df")
		end

	set_fdf (a_fdf: CE_ROUTINE)
		do
			fdf := a_fdf
			update_memory_field ("fdf")
		end

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_p (a_p: NATURAL_32)
		do
			p := a_p
			update_memory_field ("p")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {ANY} -- public routines

	set (a_vstate: CE_POINTER [ANY]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_scale: INTEGER_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_LMDER_STATE_T]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_work1: CE_POINTER [PD_GSL_VECTOR]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_signum: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_signum.make (<<1>>)

			l_state := create {CE_CLASS_POINTER [PD_LMDER_STATE_T]}.make_cast (a_vstate)
			l_r___3 := l_state.item.r
			l_tau := l_state.item.tau
			l_diag := l_state.item.diag
			l_work1 := l_state.item.work1
			l_perm := l_state.item.perm
			l_tmp := fdf.integer_32_item ([a_x, params, a_f, a_J])
			update_class_fields -- Current might have been changed; synchronize
			l_status := l_tmp
			if l_status.to_boolean then
				Result := l_status
				l_return := True
			end
			if not l_return then
				l_state.item.par := (0).to_double
				update_class_fields -- Current might have been changed; synchronize
				l_state.item.iter := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_state.item.fnorm := a_f.item.enorm
				update_class_fields -- Current might have been changed; synchronize
				a_dx.item.gsl_vector_set_all (0.0)
				update_class_fields -- Current might have been changed; synchronize
				if a_scale.to_boolean then
					compute_diag (a_J, l_diag)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_diag.item.gsl_vector_set_all (1.0)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_state.item.xnorm := (create {P_LMUTIL_STATIC}).scaled_enorm (l_diag, a_x)
				update_class_fields -- Current might have been changed; synchronize
				l_state.item.delta := compute_delta (l_diag, a_x)
				update_class_fields -- Current might have been changed; synchronize
				l_r___3.item.gsl_matrix_memcpy (a_J).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_r___3.item.gsl_linalg_QRPT_decomp (l_tau, l_perm, l_signum, l_work1).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(l_state.item.rptdx).item.gsl_vector_set_zero
				update_class_fields; -- Current might have been changed; synchronize
				(l_state.item.w).item.gsl_vector_set_zero
				update_class_fields; -- Current might have been changed; synchronize
				(l_state.item.f_trial).item.gsl_vector_set_zero
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	lmder_set (a_vstate: CE_POINTER [ANY]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]}.make_shared (c_pointer))).item.set (a_vstate, a_x, a_f, a_J, a_dx, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_status := l_tmp
			Result := l_status
		end

	lmsder_set (a_vstate: CE_POINTER [ANY]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]}.make_shared (c_pointer))).item.set (a_vstate, a_x, a_f, a_J, a_dx, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_status := l_tmp
			Result := l_status
		end

feature {PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT} -- private routines

	compute_delta (a_diag, a_x: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		require
			not a_x.is_void
		local
			l_Dx: REAL_64
			l_factor: REAL_64
			l_tmp___0: REAL_64
		do
			l_Dx := ((create {P_LMUTIL_STATIC}).scaled_enorm (a_diag, a_x))
			l_factor := (100).to_double
			if l_Dx > (0).to_double then
				l_tmp___0 := l_factor * l_Dx
			else
				l_tmp___0 := l_factor
			end
			Result := l_tmp___0
		end

	compute_diag (a_J: CE_POINTER [PD_GSL_MATRIX]; a_diag: CE_POINTER [PD_GSL_VECTOR])
		require
			not a_J.is_void
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_n: NATURAL_32
			l_p: NATURAL_32
			l_sum: REAL_64
			l_Jij: REAL_64
			l_return: BOOLEAN
		do
			l_n := a_J.item.size1
			l_p := a_J.item.size2
			l_j := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_j < l_p))
			loop
				l_sum := (0).to_double
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_n)
				loop
					l_Jij := (a_J.item.gsl_matrix_get (l_i, l_j))
					l_sum := l_sum + (l_Jij * l_Jij)
					l_i := l_i + 1
				end
				if l_sum = (0).to_double then
					l_sum := 1.0
				end
				a_diag.item.gsl_vector_set (l_j, (sqrt (l_sum)))
				l_j := l_j + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			df := a_other.df
			fdf := a_other.fdf
			n := a_other.n
			p := a_other.p
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f.is_equal (a_other.f) and
				df.is_equal (a_other.df) and
				fdf.is_equal (a_other.fdf) and
				n = a_other.n and
				p = a_other.p and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("df"),
					create {CE_STRUCTURE_FIELD}.make ("fdf"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("p"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
