class
	PD_GSL_ODEIV_STEP

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_ODEIV_STEP_TYPE]} type.make
			create {CE_VOID_POINTER} state.make
		end

feature {ANY} -- fields

	type: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE] assign set_type

	dimension: NATURAL_32 assign set_dimension

	state: CE_POINTER [ANY] assign set_state

feature {ANY} -- field setters

	set_type (a_type: CE_POINTER [PD_GSL_ODEIV_STEP_TYPE])
		do
			type := a_type
			update_memory_field ("type")
		end

	set_dimension (a_dimension: NATURAL_32)
		do
			dimension := a_dimension
			update_memory_field ("dimension")
		end

	set_state (a_state: CE_POINTER [ANY])
		do
			state := a_state
			update_memory_field ("state")
		end

feature {ANY} -- public routines

	gsl_odeiv_step_name: CE_POINTER [INTEGER_8]
		do
			Result := (type.item.name)
		end

	gsl_odeiv_step_order: NATURAL_32
		local
			l_tmp: NATURAL_32
		do
			l_tmp := (type.item.order).natural_32_item ([state])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_odeiv_step_apply (a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]; a_dydt: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := (type.item.apply).integer_32_item ([state, dimension, a_t, a_h, a_y, a_yerr, a_dydt_in, a_dydt_out, a_dydt])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_odeiv_step_reset: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			l_tmp := (type.item.reset).integer_32_item ([state, dimension])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			dimension := a_other.dimension
			state := a_other.state
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type.is_equal (a_other.type) and
				dimension = a_other.dimension and
				state.is_equal (a_other.state)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("dimension"),
					create {CE_STRUCTURE_FIELD}.make ("state")
				>>)
			init_structure_info
		end

end
