class
	PD_GSL_ODEIV_SYSTEM

inherit
	PD_GSL_ODEIV_SYSTEM_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create function.make
			create jacobian.make
			create {CE_VOID_POINTER} params.make
			Precursor
		end

feature {ANY} -- fields

	function: CE_ROUTINE assign set_function

	jacobian: CE_ROUTINE assign set_jacobian

	dimension: NATURAL_32 assign set_dimension

	params: CE_POINTER [ANY] assign set_params

feature {ANY} -- field setters

	set_function (a_function: CE_ROUTINE)
		do
			function := a_function
			update_memory_field ("function")
		end

	set_jacobian (a_jacobian: CE_ROUTINE)
		do
			jacobian := a_jacobian
			update_memory_field ("jacobian")
		end

	set_dimension (a_dimension: NATURAL_32)
		do
			dimension := a_dimension
			update_memory_field ("dimension")
		end

	set_params (a_params: CE_POINTER [ANY])
		do
			params := a_params
			update_memory_field ("params")
		end

feature {PD_GSL_ODEIV_SYSTEM} -- private attributes

	Abar: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(14005451.0 / 335480064.0), 0.0, 0.0, 0.0, 0.0, (-59238493.0 / 1068277825.0), (181606767.0 / 758867731.0),
					(561292985.0 / 797845732.0), (-1041891430.0 / 1371343529.0), (760417239.0 / 1151165299.0), (118820643.0 / 751138087.0),
					(-528747749.0 / 2220607170.0), (1.0 / 4.0)
				>>)
		end

	A: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(13451932.0 / 455176623.0), 0.0, 0.0, 0.0, 0.0, (-808719846.0 / 976000145.0), (1757004468.0 / 5645159321.0),
					(656045339.0 / 265891186.0), (-3867574721.0 / 1518517206.0), (465885868.0 / 322736535.0), (53011238.0 / 667516719.0),
					(2.0 / 45.0)
				>>)
		end

	ah: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(1.0 / 18.0), (1.0 / 12.0), (1.0 / 8.0), (5.0 / 16.0), (3.0 / 8.0), (59.0 / 400.0), (93.0 / 200.0),
					(5490023248.0 / 9719169821.0), (13.0 / 20.0), (1201146811.0 / 1299019798.0)
				>>)
		end

	b21: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (1.0 / 18.0)
		end

	b3: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(1.0 / 48.0), (1.0 / 16.0)
				>>)
		end

	b4: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(1.0 / 32.0), 0.0, (3.0 / 32.0)
				>>)
		end

	b5: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(5.0 / 16.0), 0.0, (-75.0 / 64.0), (75.0 / 64.0)
				>>)
		end

	b6: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(3.0 / 80.0), 0.0, 0.0, (3.0 / 16.0), (3.0 / 20.0)
				>>)
		end

	b7: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(29443841.0 / 614563906.0), 0.0, 0.0, (77736538.0 / 692538347.0), (-28693883.0 / 1125000000.0), (23124283.0 / 1800000000.0)
				>>)
		end

	b8: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(16016141.0 / 946692911.0), 0.0, 0.0, (61564180.0 / 158732637.0), (22789713.0 / 633445777.0), (545815736.0 / 2771057229.0),
					(-180193667.0 / 1043307555.0)
				>>)
		end

	b9: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(39632708.0 / 573591083.0), 0.0, 0.0, (-433636366.0 / 683701615.0), (-421739975.0 / 2616292301.0),
					(100302831.0 / 723423059.0), (790204164.0 / 839813087.0), (800635310.0 / 3783071287.0)
				>>)
		end

	b10: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(246121993.0 / 1340847787.0), 0.0, 0.0, (-37695042795.0 / 15268766246.0), (-309121744.0 / 1061227803.0),
					(-12992083.0 / 490766935.0), (6005943493.0 / 2108947869.0), (393006217.0 / 1396673457.0), (123872331.0 / 1001029789.0)
				>>)
		end

	b11: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(-1028468189.0 / 846180014.0), 0.0, 0.0, (8478235783.0 / 508512852.0), (1311729495.0 / 1432422823.0),
					(-10304129995.0 / 1701304382.0), (-48777925059.0 / 3047939560.0), (15336726248.0 / 1032824649.0),
					(-45442868181.0 / 3398467696.0), (3065993473.0 / 597172653.0)
				>>)
		end

	b12: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(185892177.0 / 718116043.0), 0.0, 0.0, (-3185094517.0 / 667107341.0), (-477755414.0 / 1098053517.0),
					(-703635378.0 / 230739211.0), (5731566787.0 / 1027545527.0), (5232866602.0 / 850066563.0), (-4093664535.0 / 808688257.0),
					(3962137247.0 / 1805957418.0), (65686358.0 / 487910083.0)
				>>)
		end

	b13: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(403863854.0 / 491063109.0), 0.0, 0.0, (-5068492393.0 / 434740067.0), (-411421997.0 / 543043805.0),
					(652783627.0 / 914296604.0), (11173962825.0 / 925320556.0), (-13158990841.0 / 6184727034.0), (3936647629.0 / 1978049680.0),
					(-160528059.0 / 685178525.0), (248638103.0 / 1413531060.0), 0.0
				>>)
		end

	ah___0: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(1.0 / 5.0), 0.3, (3.0 / 5.0), 1.0, (7.0 / 8.0)
				>>)
		end

	b21___0: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (1.0 / 5.0)
		end

	b3___0: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(3.0 / 40.0), (9.0 / 40.0)
				>>)
		end

	b4___0: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.3, (-0.9), 1.2
				>>)
		end

	b5___0: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(-11.0 / 54.0), 2.5, (-70.0 / 27.0), (35.0 / 27.0)
				>>)
		end

	b6___0: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(1631.0 / 55296.0), (175.0 / 512.0), (575.0 / 13824.0), (44275.0 / 110592.0), (253.0 / 4096.0)
				>>)
		end

	c1: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (37.0 / 378.0)
		end

	c3: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (250.0 / 621.0)
		end

	c4: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (125.0 / 594.0)
		end

	c6: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (512.0 / 1771.0)
		end

	ec: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.0, (37.0 / 378.0 - 2825.0 / 27648.0), 0.0, (250.0 / 621.0 - 18575.0 / 48384.0), (125.0 / 594.0 - 13525.0 / 55296.0),
					(-277.0 / 14336.0), (512.0 / 1771.0 - 0.25)
				>>)
		end

	ah___1: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(1.0 / 4.0), (3.0 / 8.0), (12.0 / 13.0), 1.0, (1.0 / 2.0)
				>>)
		end

	b3___1: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(3.0 / 32.0), (9.0 / 32.0)
				>>)
		end

	b4___1: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(1932.0 / 2197.0), (-7200.0 / 2197.0), (7296.0 / 2197.0)
				>>)
		end

	b5___1: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(8341.0 / 4104.0), (-32832.0 / 4104.0), (29440.0 / 4104.0), (-845.0 / 4104.0)
				>>)
		end

	b6___1: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					(-6080.0 / 20520.0), (41040.0 / 20520.0), (-28352.0 / 20520.0), (9295.0 / 20520.0), (-5643.0 / 20520.0)
				>>)
		end

	c1___0: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (902880.0 / 7618050.0)
		end

	c3___0: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (3953664.0 / 7618050.0)
		end

	c4___0: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (3855735.0 / 7618050.0)
		end

	c5: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (-1371249.0 / 7618050.0)
		end

	c6___0: CE_STATIC [REAL_64]
		once ("PROCESS")
			Result.item := (277020.0 / 7618050.0)
		end

	ec___0: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					0.0, (1.0 / 360.0), 0.0, (-128.0 / 4275.0), (-2197.0 / 75240.0), (1.0 / 50.0), (2.0 / 55.0)
				>>)
		end

feature {ANY} -- public routines

	rk8pd_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK8PD_STATE_T]
			l_i: NATURAL_32
			l_ytmp: CE_POINTER [REAL_64]
			l_y0: CE_POINTER [REAL_64]
			l_k1: CE_POINTER [REAL_64]
			l_k2: CE_POINTER [REAL_64]
			l_k3: CE_POINTER [REAL_64]
			l_k4: CE_POINTER [REAL_64]
			l_k5: CE_POINTER [REAL_64]
			l_k6: CE_POINTER [REAL_64]
			l_k7: CE_POINTER [REAL_64]
			l_k8: CE_POINTER [REAL_64]
			l_k9: CE_POINTER [REAL_64]
			l_k10: CE_POINTER [REAL_64]
			l_k11: CE_POINTER [REAL_64]
			l_k12: CE_POINTER [REAL_64]
			l_k13: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_tmp: INTEGER_32
			l_s___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_s___1: INTEGER_32
			l_tmp___1: INTEGER_32
			l_s___2: INTEGER_32
			l_tmp___2: INTEGER_32
			l_s___3: INTEGER_32
			l_tmp___3: INTEGER_32
			l_s___4: INTEGER_32
			l_tmp___4: INTEGER_32
			l_s___5: INTEGER_32
			l_tmp___5: INTEGER_32
			l_s___6: INTEGER_32
			l_tmp___6: INTEGER_32
			l_s___7: INTEGER_32
			l_tmp___7: INTEGER_32
			l_s___8: INTEGER_32
			l_tmp___8: INTEGER_32
			l_s___9: INTEGER_32
			l_tmp___9: INTEGER_32
			l_s___10: INTEGER_32
			l_tmp___10: INTEGER_32
			l_s___11: INTEGER_32
			l_tmp___11: INTEGER_32
			l_ksum8: REAL_64
			l_s___12: INTEGER_32
			l_tmp___12: INTEGER_32
			l_ksum8___0: REAL_64
			l_ksum7: REAL_64
			l_return: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK8PD_STATE_T]}.make_cast (a_vstate)
			l_ytmp := l_state.item.ytmp
			l_y0 := l_state.item.y0
			l_k1 := l_state.item.k[0]
			l_k2 := l_state.item.k[1]
			l_k3 := l_state.item.k[2]
			l_k4 := l_state.item.k[3]
			l_k5 := l_state.item.k[4]
			l_k6 := l_state.item.k[5]
			l_k7 := l_state.item.k[6]
			l_k8 := l_state.item.k[7]
			l_k9 := l_state.item.k[8]
			l_k10 := l_state.item.k[9]
			l_k11 := l_state.item.k[10]
			l_k12 := l_state.item.k[11]
			l_k13 := l_state.item.k[12]
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if not a_dydt_in.is_void then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k1), create {CE_VOID_POINTER}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp := function.integer_32_item ([a_t, a_y, l_k1, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s := l_tmp
				if l_s /= 0 then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((b21.item * a_h) * l_k1[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___0 := function.integer_32_item ([a_t + (ah.item[0] * a_h), l_ytmp, l_k2, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___0 := l_tmp___0
				if l_s___0 /= 0 then
					Result := l_s___0
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (b3.item[0] * l_k1[l_i.to_integer_32] + b3.item[1] * l_k2[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___1 := function.integer_32_item ([a_t + (ah.item[1] * a_h), l_ytmp, l_k3, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___1 := l_tmp___1
				if l_s___1 /= 0 then
					Result := l_s___1
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (b4.item[0] * l_k1[l_i.to_integer_32] + b4.item[2] * l_k3[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___2 := function.integer_32_item ([a_t + (ah.item[2] * a_h), l_ytmp, l_k4, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___2 := l_tmp___2
				if l_s___2 /= 0 then
					Result := l_s___2
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((b5.item[0] * l_k1[l_i.to_integer_32] + b5.item[2] * l_k3[l_i.to_integer_32]) + b5.item[3] * l_k4[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___3 := function.integer_32_item ([a_t + (ah.item[3] * a_h), l_ytmp, l_k5, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___3 := l_tmp___3
				if l_s___3 /= 0 then
					Result := l_s___3
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((b6.item[0] * l_k1[l_i.to_integer_32] + b6.item[3] * l_k4[l_i.to_integer_32]) + b6.item[4] * l_k5[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___4 := function.integer_32_item ([a_t + (ah.item[4] * a_h), l_ytmp, l_k6, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___4 := l_tmp___4
				if l_s___4 /= 0 then
					Result := l_s___4
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((b7.item[0] * l_k1[l_i.to_integer_32] + b7.item[3] * l_k4[l_i.to_integer_32]) + b7.item[4] * l_k5[l_i.to_integer_32]) + b7.item[5] * l_k6[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___5 := function.integer_32_item ([a_t + (ah.item[5] * a_h), l_ytmp, l_k7, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___5 := l_tmp___5
				if l_s___5 /= 0 then
					Result := l_s___5
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((b8.item[0] * l_k1[l_i.to_integer_32] + b8.item[3] * l_k4[l_i.to_integer_32]) + b8.item[4] * l_k5[l_i.to_integer_32]) + b8.item[5] * l_k6[l_i.to_integer_32]) + b8.item[6] * l_k7[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___6 := function.integer_32_item ([a_t + (ah.item[6] * a_h), l_ytmp, l_k8, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___6 := l_tmp___6
				if l_s___6 /= 0 then
					Result := l_s___6
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((((b9.item[0] * l_k1[l_i.to_integer_32] + b9.item[3] * l_k4[l_i.to_integer_32]) + b9.item[4] * l_k5[l_i.to_integer_32]) + b9.item[5] * l_k6[l_i.to_integer_32]) + b9.item[6] * l_k7[l_i.to_integer_32]) + b9.item[7] * l_k8[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___7 := function.integer_32_item ([a_t + (ah.item[7] * a_h), l_ytmp, l_k9, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___7 := l_tmp___7
				if l_s___7 /= 0 then
					Result := l_s___7
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((((b10.item[0] * l_k1[l_i.to_integer_32] + b10.item[3] * l_k4[l_i.to_integer_32]) + b10.item[4] * l_k5[l_i.to_integer_32]) + b10.item[5] * l_k6[l_i.to_integer_32]) + b10.item[6] * l_k7[l_i.to_integer_32]) + b10.item[7] * l_k8[l_i.to_integer_32]) + b10.item[8] * l_k9[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___8 := function.integer_32_item ([a_t + (ah.item[8] * a_h), l_ytmp, l_k10, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___8 := l_tmp___8
				if l_s___8 /= 0 then
					Result := l_s___8
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((((((b11.item[0] * l_k1[l_i.to_integer_32] + b11.item[3] * l_k4[l_i.to_integer_32]) + b11.item[4] * l_k5[l_i.to_integer_32]) + b11.item[5] * l_k6[l_i.to_integer_32]) + b11.item[6] * l_k7[l_i.to_integer_32]) + b11.item[7] * l_k8[l_i.to_integer_32]) + b11.item[8] * l_k9[l_i.to_integer_32]) + b11.item[9] * l_k10[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___9 := function.integer_32_item ([a_t + (ah.item[9] * a_h), l_ytmp, l_k11, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___9 := l_tmp___9
				if l_s___9 /= 0 then
					Result := l_s___9
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((((((b12.item[0] * l_k1[l_i.to_integer_32] + b12.item[3] * l_k4[l_i.to_integer_32]) + b12.item[4] * l_k5[l_i.to_integer_32]) + b12.item[5] * l_k6[l_i.to_integer_32]) + b12.item[6] * l_k7[l_i.to_integer_32]) + b12.item[7] * l_k8[l_i.to_integer_32]) + b12.item[8] * l_k9[l_i.to_integer_32]) + b12.item[9] * l_k10[l_i.to_integer_32]) + b12.item[10] * l_k11[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___10 := function.integer_32_item ([a_t + a_h, l_ytmp, l_k12, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___10 := l_tmp___10
				if l_s___10 /= 0 then
					Result := l_s___10
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((((((((b13.item[0] * l_k1[l_i.to_integer_32] + b13.item[3] * l_k4[l_i.to_integer_32]) + b13.item[4] * l_k5[l_i.to_integer_32]) + b13.item[5] * l_k6[l_i.to_integer_32]) + b13.item[6] * l_k7[l_i.to_integer_32]) + b13.item[7] * l_k8[l_i.to_integer_32]) + b13.item[8] * l_k9[l_i.to_integer_32]) + b13.item[9] * l_k10[l_i.to_integer_32]) + b13.item[10] * l_k11[l_i.to_integer_32]) + b13.item[11] * l_k12[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___11 := function.integer_32_item ([a_t + a_h, l_ytmp, l_k13, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___11 := l_tmp___11
				if l_s___11 /= 0 then
					Result := l_s___11
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ksum8 := ((((((((Abar.item[0] * l_k1[l_i.to_integer_32] + Abar.item[5] * l_k6[l_i.to_integer_32]) + Abar.item[6] * l_k7[l_i.to_integer_32]) + Abar.item[7] * l_k8[l_i.to_integer_32]) + Abar.item[8] * l_k9[l_i.to_integer_32]) + Abar.item[9] * l_k10[l_i.to_integer_32]) + Abar.item[10] * l_k11[l_i.to_integer_32]) + Abar.item[11] * l_k12[l_i.to_integer_32]) + Abar.item[12] * l_k13[l_i.to_integer_32])
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (a_h * l_ksum8)
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				if not a_dydt_out.is_void then
					l_tmp___12 := function.integer_32_item ([a_t + a_h, a_y, a_dydt_out, params])
					update_class_fields -- Current might have been changed; synchronize
					l_s___12 := l_tmp___12
					if l_s___12 /= 0 then
						memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := l_s___12
						l_return := True
					end
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ksum8___0 := ((((((((Abar.item[0] * l_k1[l_i.to_integer_32] + Abar.item[5] * l_k6[l_i.to_integer_32]) + Abar.item[6] * l_k7[l_i.to_integer_32]) + Abar.item[7] * l_k8[l_i.to_integer_32]) + Abar.item[8] * l_k9[l_i.to_integer_32]) + Abar.item[9] * l_k10[l_i.to_integer_32]) + Abar.item[10] * l_k11[l_i.to_integer_32]) + Abar.item[11] * l_k12[l_i.to_integer_32]) + Abar.item[12] * l_k13[l_i.to_integer_32])
					l_ksum7 := (((((((A.item[0] * l_k1[l_i.to_integer_32] + A.item[5] * l_k6[l_i.to_integer_32]) + A.item[6] * l_k7[l_i.to_integer_32]) + A.item[7] * l_k8[l_i.to_integer_32]) + A.item[8] * l_k9[l_i.to_integer_32]) + A.item[9] * l_k10[l_i.to_integer_32]) + A.item[10] * l_k11[l_i.to_integer_32]) + A.item[11] * l_k12[l_i.to_integer_32])
					a_yerr[l_i.to_integer_32] := a_h * (l_ksum7 - l_ksum8___0)
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rkck_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RKCK_STATE_T]
			l_i: NATURAL_32
			l_k1: CE_POINTER [REAL_64]
			l_k2: CE_POINTER [REAL_64]
			l_k3: CE_POINTER [REAL_64]
			l_k4: CE_POINTER [REAL_64]
			l_k5: CE_POINTER [REAL_64]
			l_k6: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_y0: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_tmp: INTEGER_32
			l_s___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_s___1: INTEGER_32
			l_tmp___1: INTEGER_32
			l_s___2: INTEGER_32
			l_tmp___2: INTEGER_32
			l_s___3: INTEGER_32
			l_tmp___3: INTEGER_32
			l_s___4: INTEGER_32
			l_tmp___4: INTEGER_32
			l_d_i: REAL_64
			l_s___5: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RKCK_STATE_T]}.make_cast (a_vstate)
			l_k1 := l_state.item.k1
			l_k2 := l_state.item.k2
			l_k3 := l_state.item.k3
			l_k4 := l_state.item.k4
			l_k5 := l_state.item.k5
			l_k6 := l_state.item.k6
			l_ytmp := l_state.item.ytmp
			l_y0 := l_state.item.y0
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if not a_dydt_in.is_void then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k1), create {CE_VOID_POINTER}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp := function.integer_32_item ([a_t, a_y, l_k1, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s := l_tmp
				if l_s /= 0 then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((b21___0.item * a_h) * l_k1[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___0 := function.integer_32_item ([a_t + (ah___0.item[0] * a_h), l_ytmp, l_k2, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___0 := l_tmp___0
				if l_s___0 /= 0 then
					Result := l_s___0
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (b3___0.item[0] * l_k1[l_i.to_integer_32] + b3___0.item[1] * l_k2[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___1 := function.integer_32_item ([a_t + (ah___0.item[1] * a_h), l_ytmp, l_k3, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___1 := l_tmp___1
				if l_s___1 /= 0 then
					Result := l_s___1
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((b4___0.item[0] * l_k1[l_i.to_integer_32] + b4___0.item[1] * l_k2[l_i.to_integer_32]) + b4___0.item[2] * l_k3[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___2 := function.integer_32_item ([a_t + (ah___0.item[2] * a_h), l_ytmp, l_k4, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___2 := l_tmp___2
				if l_s___2 /= 0 then
					Result := l_s___2
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((b5___0.item[0] * l_k1[l_i.to_integer_32] + b5___0.item[1] * l_k2[l_i.to_integer_32]) + b5___0.item[2] * l_k3[l_i.to_integer_32]) + b5___0.item[3] * l_k4[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___3 := function.integer_32_item ([a_t + (ah___0.item[3] * a_h), l_ytmp, l_k5, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___3 := l_tmp___3
				if l_s___3 /= 0 then
					Result := l_s___3
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((b6___0.item[0] * l_k1[l_i.to_integer_32] + b6___0.item[1] * l_k2[l_i.to_integer_32]) + b6___0.item[2] * l_k3[l_i.to_integer_32]) + b6___0.item[3] * l_k4[l_i.to_integer_32]) + b6___0.item[4] * l_k5[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___4 := function.integer_32_item ([a_t + (ah___0.item[4] * a_h), l_ytmp, l_k6, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___4 := l_tmp___4
				if l_s___4 /= 0 then
					Result := l_s___4
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_d_i := (((c1.item * l_k1[l_i.to_integer_32] + c3.item * l_k3[l_i.to_integer_32]) + c4.item * l_k4[l_i.to_integer_32]) + c6.item * l_k6[l_i.to_integer_32])
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (a_h * l_d_i)
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				if not a_dydt_out.is_void then
					l_tmp___5 := function.integer_32_item ([a_t + a_h, a_y, a_dydt_out, params])
					update_class_fields -- Current might have been changed; synchronize
					l_s___5 := l_tmp___5
					if l_s___5 /= 0 then
						memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := l_s___5
						l_return := True
					end
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := a_h * ((((ec.item[1] * l_k1[l_i.to_integer_32] + ec.item[3] * l_k3[l_i.to_integer_32]) + ec.item[4] * l_k4[l_i.to_integer_32]) + ec.item[5] * l_k5[l_i.to_integer_32]) + ec.item[6] * l_k6[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rk2_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RK2_STATE_T]
			l_i: NATURAL_32
			l_k1: CE_POINTER [REAL_64]
			l_k2: CE_POINTER [REAL_64]
			l_k3: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_tmp: INTEGER_32
			l_s___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_s___1: INTEGER_32
			l_tmp___1: INTEGER_32
			l_ksum3: REAL_64
			l_s___2: INTEGER_32
			l_tmp___2: INTEGER_32
			l_ksum3___0: REAL_64
			l_return: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RK2_STATE_T]}.make_cast (a_vstate)
			l_k1 := l_state.item.k1
			l_k2 := l_state.item.k2
			l_k3 := l_state.item.k3
			l_ytmp := l_state.item.ytmp
			if not a_dydt_in.is_void then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k1), create {CE_VOID_POINTER}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp := function.integer_32_item ([a_t, a_y, l_k1, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s := l_tmp
				if l_s /= 0 then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (0.5 * a_h) * l_k1[l_i.to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___0 := function.integer_32_item ([a_t + 0.5 * a_h, l_ytmp, l_k2, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___0 := l_tmp___0
				if l_s___0 /= 0 then
					Result := l_s___0
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (-l_k1[l_i.to_integer_32] + 2.0 * l_k2[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___1 := function.integer_32_item ([a_t + a_h, l_ytmp, l_k3, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___1 := l_tmp___1
				if l_s___1 /= 0 then
					Result := l_s___1
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_ksum3 := ((l_k1[l_i.to_integer_32] + 4.0 * l_k2[l_i.to_integer_32]) + l_k3[l_i.to_integer_32]) / 6.0
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (a_h * l_ksum3)
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				if not a_dydt_out.is_void then
					l_tmp___2 := function.integer_32_item ([a_t + a_h, a_y, a_dydt_out, params])
					update_class_fields -- Current might have been changed; synchronize
					l_s___2 := l_tmp___2
					if l_s___2 /= 0 then
						memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_ytmp), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := l_s___2
						l_return := True
					end
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ksum3___0 := ((l_k1[l_i.to_integer_32] + 4.0 * l_k2[l_i.to_integer_32]) + l_k3[l_i.to_integer_32]) / 6.0
					a_yerr[l_i.to_integer_32] := a_h * (l_k2[l_i.to_integer_32] - l_ksum3___0)
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	rkf45_apply (a_vstate: CE_POINTER [ANY]; a_dim: NATURAL_32; a_t, a_h: REAL_64; a_y, a_yerr, a_dydt_in, a_dydt_out: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_state: CE_POINTER [PD_RKF45_STATE_T]
			l_i: NATURAL_32
			l_k1: CE_POINTER [REAL_64]
			l_k2: CE_POINTER [REAL_64]
			l_k3: CE_POINTER [REAL_64]
			l_k4: CE_POINTER [REAL_64]
			l_k5: CE_POINTER [REAL_64]
			l_k6: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_y0: CE_POINTER [REAL_64]
			l_s: INTEGER_32
			l_tmp: INTEGER_32
			l_s___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_s___1: INTEGER_32
			l_tmp___1: INTEGER_32
			l_s___2: INTEGER_32
			l_tmp___2: INTEGER_32
			l_s___3: INTEGER_32
			l_tmp___3: INTEGER_32
			l_s___4: INTEGER_32
			l_tmp___4: INTEGER_32
			l_d_i: REAL_64
			l_s___5: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return: BOOLEAN
		do
			l_state := create {CE_CLASS_POINTER [PD_RKF45_STATE_T]}.make_cast (a_vstate)
			l_k1 := l_state.item.k1
			l_k2 := l_state.item.k2
			l_k3 := l_state.item.k3
			l_k4 := l_state.item.k4
			l_k5 := l_state.item.k5
			l_k6 := l_state.item.k6
			l_ytmp := l_state.item.ytmp
			l_y0 := l_state.item.y0
			memcpy (create {CE_VOID_POINTER}.make_cast (l_y0), create {CE_VOID_POINTER}.make_cast (a_y), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			if not a_dydt_in.is_void then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_k1), create {CE_VOID_POINTER}.make_cast (a_dydt_in), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp := function.integer_32_item ([a_t, a_y, l_k1, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s := l_tmp
				if l_s /= 0 then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + ((ah___1.item[0] * a_h) * l_k1[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___0 := function.integer_32_item ([a_t + (ah___1.item[0] * a_h), l_ytmp, l_k2, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___0 := l_tmp___0
				if l_s___0 /= 0 then
					Result := l_s___0
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (b3___1.item[0] * l_k1[l_i.to_integer_32] + b3___1.item[1] * l_k2[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___1 := function.integer_32_item ([a_t + (ah___1.item[1] * a_h), l_ytmp, l_k3, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___1 := l_tmp___1
				if l_s___1 /= 0 then
					Result := l_s___1
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((b4___1.item[0] * l_k1[l_i.to_integer_32] + b4___1.item[1] * l_k2[l_i.to_integer_32]) + b4___1.item[2] * l_k3[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___2 := function.integer_32_item ([a_t + (ah___1.item[2] * a_h), l_ytmp, l_k4, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___2 := l_tmp___2
				if l_s___2 /= 0 then
					Result := l_s___2
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * (((b5___1.item[0] * l_k1[l_i.to_integer_32] + b5___1.item[1] * l_k2[l_i.to_integer_32]) + b5___1.item[2] * l_k3[l_i.to_integer_32]) + b5___1.item[3] * l_k4[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___3 := function.integer_32_item ([a_t + (ah___1.item[3] * a_h), l_ytmp, l_k5, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___3 := l_tmp___3
				if l_s___3 /= 0 then
					Result := l_s___3
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_ytmp[l_i.to_integer_32] := a_y[l_i.to_integer_32] + a_h * ((((b6___1.item[0] * l_k1[l_i.to_integer_32] + b6___1.item[1] * l_k2[l_i.to_integer_32]) + b6___1.item[2] * l_k3[l_i.to_integer_32]) + b6___1.item[3] * l_k4[l_i.to_integer_32]) + b6___1.item[4] * l_k5[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				l_tmp___4 := function.integer_32_item ([a_t + (ah___1.item[4] * a_h), l_ytmp, l_k6, params])
				update_class_fields -- Current might have been changed; synchronize
				l_s___4 := l_tmp___4
				if l_s___4 /= 0 then
					Result := l_s___4
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					l_d_i := ((((c1___0.item * l_k1[l_i.to_integer_32] + c3___0.item * l_k3[l_i.to_integer_32]) + c4___0.item * l_k4[l_i.to_integer_32]) + c5.item * l_k5[l_i.to_integer_32]) + c6___0.item * l_k6[l_i.to_integer_32])
					a_y[l_i.to_integer_32] := a_y[l_i.to_integer_32] + (a_h * l_d_i)
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				if not a_dydt_out.is_void then
					l_tmp___5 := function.integer_32_item ([a_t + a_h, a_y, a_dydt_out, params])
					update_class_fields -- Current might have been changed; synchronize
					l_s___5 := l_tmp___5
					if l_s___5 /= 0 then
						memcpy (create {CE_VOID_POINTER}.make_cast (a_y), create {CE_VOID_POINTER}.make_cast (l_y0), a_dim * {PLATFORM}.Real_64_bytes.to_natural_32).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := l_s___5
						l_return := True
					end
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_yerr[l_i.to_integer_32] := a_h * ((((ec___0.item[1] * l_k1[l_i.to_integer_32] + ec___0.item[3] * l_k3[l_i.to_integer_32]) + ec___0.item[4] * l_k4[l_i.to_integer_32]) + ec___0.item[5] * l_k5[l_i.to_integer_32]) + ec___0.item[6] * l_k6[l_i.to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			function := a_other.function
			jacobian := a_other.jacobian
			dimension := a_other.dimension
			params := a_other.params
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				function.is_equal (a_other.function) and
				jacobian.is_equal (a_other.jacobian) and
				dimension = a_other.dimension and
				params.is_equal (a_other.params)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("function"),
					create {CE_STRUCTURE_FIELD}.make ("jacobian"),
					create {CE_STRUCTURE_FIELD}.make ("dimension"),
					create {CE_STRUCTURE_FIELD}.make ("params")
				>>)
			init_structure_info
		end

end
