class
	PD_GSL_VECTOR_COMPLEX

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} data.make
			create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]} block.make
			Precursor
		end

feature {ANY} -- fields

	size: NATURAL_32 assign set_size

	stride: NATURAL_32 assign set_stride

	data: CE_POINTER [REAL_64] assign set_data

	block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT] assign set_block

	owner: INTEGER_32 assign set_owner

feature {ANY} -- field setters

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set_stride (a_stride: NATURAL_32)
		do
			stride := a_stride
			update_memory_field ("stride")
		end

	set_data (a_data: CE_POINTER [REAL_64])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_block (a_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT])
		do
			block := a_block
			update_memory_field ("block")
		end

	set_owner (a_owner: INTEGER_32)
		do
			owner := a_owner
			update_memory_field ("owner")
		end

feature {ANY} -- public routines

	gsl_vector_complex_get (a_i: NATURAL_32): PD_GSL_COMPLEX
		do
			Result := ((create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((data + (({NATURAL_32} 2 * a_i) * stride).to_integer_32))).item).twin
		end

	gsl_vector_complex_set (a_i: NATURAL_32; a_z: PD_GSL_COMPLEX)
		do
			(create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((data + (({NATURAL_32} 2 * a_i) * stride).to_integer_32))).item := a_z.twin
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_vector_complex_ptr (a_i: NATURAL_32): CE_POINTER [PD_GSL_COMPLEX]
		do
			Result := (create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((data + (({NATURAL_32} 2 * a_i) * stride).to_integer_32)))
		end

	gsl_vector_complex_const_ptr (a_i: NATURAL_32): CE_POINTER [PD_GSL_COMPLEX]
		do
			Result := (create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((data + (({NATURAL_32} 2 * a_i) * stride).to_integer_32)))
		end

	gsl_blas_zdotu (a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_dotu: CE_POINTER [PD_GSL_COMPLEX]): INTEGER_32
		require
			not a_Y.is_void
		local
			l_return, l_break: BOOLEAN
		do
			if size = a_Y.item.size then
				cblas_zdotu_sub (size.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_dotu.item.dat)))
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
				l_return := True
			else
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 158, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_blas_zdotc (a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_dotc: CE_POINTER [PD_GSL_COMPLEX]): INTEGER_32
		require
			not a_Y.is_void
		local
			l_return, l_break: BOOLEAN
		do
			if size = a_Y.item.size then
				cblas_zdotc_sub (size.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_dotc.item.dat)))
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
				l_return := True
			else
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 175, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_blas_dznrm2: REAL_64
		local
			l_tmp: REAL_64
		do
			l_tmp := cblas_dznrm2 (size.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_blas_dzasum: REAL_64
		local
			l_tmp: REAL_64
		do
			l_tmp := cblas_dzasum (size.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_blas_izamax: NATURAL_32
		local
			l_tmp: NATURAL_32
		do
			l_tmp := cblas_izamax (size.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	gsl_blas_zswap (a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		require
			not a_Y.is_void
		local
			l_return, l_break: BOOLEAN
		do
			if size = a_Y.item.size then
				cblas_zswap (size.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
				l_return := True
			else
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 316, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_blas_zcopy (a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		require
			not a_Y.is_void
		local
			l_return, l_break: BOOLEAN
		do
			if size = a_Y.item.size then
				cblas_zcopy (size.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
				l_return := True
			else
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 380, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_blas_zaxpy (a_alpha: PD_GSL_COMPLEX; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		require
			not a_Y.is_void
		local
			l_return, l_break: BOOLEAN
		do
			if size = a_Y.item.size then
				cblas_zaxpy (size.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
				l_return := True
			else
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 446, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_blas_zscal (a_alpha: PD_GSL_COMPLEX)
		do
			cblas_zscal (size.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_blas_zdscal (a_alpha: REAL_64)
		do
			cblas_zdscal (size.to_integer_32, a_alpha, create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32)
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_blas_zgeru (a_alpha: PD_GSL_COMPLEX; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		require
			not a_A___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if size /= l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_Y.item.size = l_N then
							cblas_zgeru ({PC_CBLAS_ORDER}.CblasRowMajor, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_058, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 4 then
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_zgerc (a_alpha: PD_GSL_COMPLEX; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		require
			not a_A___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_A___0.item.size1
					l_N := a_A___0.item.size2
					if size /= l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_Y.item.size = l_N then
							cblas_zgerc ({PC_CBLAS_ORDER}.CblasRowMajor, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), stride.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast (a_A___0.item.data), (a_A___0.item.tda).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_104, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 4 then
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_linalg_complex_householder_transform: PD_GSL_COMPLEX
		local
			l_n: NATURAL_32
			l_alpha: PD_GSL_COMPLEX
			l_tmp: PD_GSL_COMPLEX
			l_absa: REAL_64
			l_tmp___0: REAL_64
			l_beta_r: REAL_64
			l_tmp___1: INTEGER_32
			l_tau: PD_GSL_COMPLEX
			l_beta: PD_GSL_COMPLEX
			l_tmp___2: PD_GSL_COMPLEX
			l_tau___0: PD_GSL_COMPLEX
			l_beta_r___0: REAL_64
			l_x: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_tmp___3: PD_GSL_VECTOR_COMPLEX_VIEW
			l_alpha___0: PD_GSL_COMPLEX
			l_tmp___4: PD_GSL_COMPLEX
			l_absa___0: REAL_64
			l_tmp___5: REAL_64
			l_xnorm: REAL_64
			l_tmp___6: REAL_64
			l_zero: PD_GSL_COMPLEX
			l_tmp___7: PD_GSL_COMPLEX
			l_tmp___8: INTEGER_32
			l_tmp___9: REAL_64
			l_amb: PD_GSL_COMPLEX
			l_tmp___10: PD_GSL_COMPLEX
			l_s: PD_GSL_COMPLEX
			l_tmp___11: PD_GSL_COMPLEX
			l_beta___0: PD_GSL_COMPLEX
			l_tmp___12: PD_GSL_COMPLEX
			l_return: BOOLEAN
		do
			create l_tau.make
			create l_tau___0.make
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]} l_x.make (<<1>>)

			l_n := size
			if l_n = {NATURAL_32} 1 then
				l_tmp := (((create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (c_pointer))).item.gsl_vector_complex_get ((0).to_natural_32)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_alpha := l_tmp.twin
				l_tmp___0 := (create {P_MATH_STATIC}).gsl_complex_abs (l_alpha.twin)
				update_class_fields -- Current might have been changed; synchronize
				l_absa := l_tmp___0
				if l_alpha.dat[0] >= (0).to_double then
					l_tmp___1 := 1
				else
					l_tmp___1 := -1
				end
				l_beta_r := (-l_tmp___1).to_double * l_absa
				if l_beta_r = 0.0 then
					l_tau.dat[0] := 0.0
					update_class_fields -- Current might have been changed; synchronize
					l_tau.dat[1] := 0.0
					update_class_fields -- Current might have been changed; synchronize
				else
					l_tau.dat[0] := (l_beta_r - l_alpha.dat[0]) / l_beta_r
					update_class_fields -- Current might have been changed; synchronize
					l_tau.dat[1] := -l_alpha.dat[1] / l_beta_r
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___2 := ((create {P_GSL_GSL_COMPLEX_MATH_STATIC}).gsl_complex_rect (l_beta_r, 0.0)).twin
					update_class_fields -- Current might have been changed; synchronize
					l_beta := l_tmp___2.twin;
					((create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (c_pointer))).item.gsl_vector_complex_set ((0).to_natural_32, l_beta.twin)
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_tau.twin
			else
				l_tmp___3 := (((create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (c_pointer))).item.gsl_vector_complex_subvector ((1).to_natural_32, l_n - {NATURAL_32} 1)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_x.item := l_tmp___3.twin
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___4 := (((create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (c_pointer))).item.gsl_vector_complex_get ((0).to_natural_32)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_alpha___0 := l_tmp___4.twin
				l_tmp___5 := (create {P_MATH_STATIC}).gsl_complex_abs (l_alpha___0.twin)
				update_class_fields -- Current might have been changed; synchronize
				l_absa___0 := l_tmp___5
				l_tmp___6 := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).item.gsl_blas_dznrm2
				update_class_fields -- Current might have been changed; synchronize
				l_xnorm := l_tmp___6
				if l_xnorm = (0).to_double then
					if l_alpha___0.dat[1] = (0).to_double then
						l_tmp___7 := ((create {P_GSL_GSL_COMPLEX_MATH_STATIC}).gsl_complex_rect (0.0, 0.0)).twin
						update_class_fields -- Current might have been changed; synchronize
						l_zero := l_tmp___7.twin
						Result := l_zero.twin
						l_return := True
					end
				end
				if not l_return then
					if l_alpha___0.dat[0] >= (0).to_double then
						l_tmp___8 := 1
					else
						l_tmp___8 := -1
					end
					l_tmp___9 := hypot (l_absa___0, l_xnorm)
					update_class_fields -- Current might have been changed; synchronize
					l_beta_r___0 := (-l_tmp___8).to_double * l_tmp___9
					l_tau___0.dat[0] := (l_beta_r___0 - l_alpha___0.dat[0]) / l_beta_r___0
					update_class_fields -- Current might have been changed; synchronize
					l_tau___0.dat[1] := -l_alpha___0.dat[1] / l_beta_r___0
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___10 := (gsl_complex_sub_real (l_alpha___0.twin, l_beta_r___0)).twin
					update_class_fields -- Current might have been changed; synchronize
					l_amb := l_tmp___10.twin
					l_tmp___11 := ((create {P_MATH_STATIC}).gsl_complex_inverse (l_amb.twin)).twin
					update_class_fields -- Current might have been changed; synchronize
					l_s := l_tmp___11.twin;
					(create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_x.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).item.gsl_blas_zscal (l_s.twin)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___12 := ((create {P_GSL_GSL_COMPLEX_MATH_STATIC}).gsl_complex_rect (l_beta_r___0, 0.0)).twin
					update_class_fields -- Current might have been changed; synchronize
					l_beta___0 := l_tmp___12.twin;
					((create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (c_pointer))).item.gsl_vector_complex_set ((0).to_natural_32, l_beta___0.twin)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_tau___0.twin
				end
			end
		end

	gsl_linalg_complex_householder_hv (a_tau: PD_GSL_COMPLEX; a_w: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_N: NATURAL_32
			l_z0: PD_GSL_COMPLEX
			l_tmp: PD_GSL_COMPLEX
			l_z1: CE_ARRAY [PD_GSL_COMPLEX]
			l_z: PD_GSL_COMPLEX
			l_tz: PD_GSL_COMPLEX
			l_ntz: PD_GSL_COMPLEX
			l_v1: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_CONST_VIEW]
			l_tmp___0: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_w1: CE_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]
			l_tmp___1: PD_GSL_VECTOR_COMPLEX_VIEW
			l_w0: PD_GSL_COMPLEX
			l_tmp___2: PD_GSL_COMPLEX
			l_w0ntz: PD_GSL_COMPLEX
			l_tmp___3: PD_GSL_COMPLEX
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_COMPLEX]} l_z1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_COMPLEX_CONST_VIEW]} l_v1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_COMPLEX_VIEW]} l_w1.make (<<1>>)

			l_N := size
			if a_tau.dat[0] = 0.0 then
				if a_tau.dat[1] = 0.0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_tmp := (a_w.item.gsl_vector_complex_get ((0).to_natural_32)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_z0 := l_tmp.twin
				l_tmp___0 := (((create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (c_pointer))).item.gsl_vector_complex_const_subvector ((1).to_natural_32, l_N - {NATURAL_32} 1)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_v1.item := l_tmp___0.twin
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := (a_w.item.gsl_vector_complex_subvector ((1).to_natural_32, l_N - {NATURAL_32} 1)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_w1.item := l_tmp___1.twin
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))).item.gsl_blas_zdotc ((create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_w1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))), l_z1).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_z := ((create {P_MATH_STATIC}).gsl_complex_add (l_z0.twin, (l_z1.item).twin)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_tz := ((create {P_MATH_STATIC}).gsl_complex_mul (a_tau.twin, l_z.twin)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_ntz := (gsl_complex_negative (l_tz.twin)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := (a_w.item.gsl_vector_complex_get ((0).to_natural_32)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_w0 := l_tmp___2.twin
				l_tmp___3 := ((create {P_MATH_STATIC}).gsl_complex_add (l_w0.twin, l_ntz.twin)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_w0ntz := l_tmp___3.twin
				a_w.item.gsl_vector_complex_set ((0).to_natural_32, l_w0ntz.twin)
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_v1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_CONST_VIEW}.make).offset_of ("vector"))).item.gsl_blas_zaxpy (l_ntz.twin, create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (l_w1.item.c_pointer + (create {PD_GSL_VECTOR_COMPLEX_VIEW}.make).offset_of ("vector"))).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	gsl_matrix_complex_view_vector (a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.size2 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.tda := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif stride /= {NATURAL_32} 1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n1 * a_n2 > size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size2 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.tda := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.data := data
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.tda := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.matrix := l_m___4.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_view_vector_with_tda (a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.size2 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.tda := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif stride /= {NATURAL_32} 1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n1 * a_tda > size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size2 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.tda := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.data := data
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.tda := a_tda
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.matrix := l_m___4.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_const_view_vector (a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.size2 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.tda := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 102, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 107, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif stride /= {NATURAL_32} 1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 112, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n1 * a_n2 > size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 117, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size2 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.tda := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.data := data
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.tda := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.matrix := l_m___4.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_const_view_vector_with_tda (a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.size2 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.tda := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 147, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 152, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif stride /= {NATURAL_32} 1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector must have unit stride"), ce_string ("view_source.c"), 157, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 162, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n1 * a_tda > size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix size exceeds size of original"), ce_string ("view_source.c"), 167, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size2 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.tda := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.data := data
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.tda := a_tda
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.matrix := l_m___4.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_vector_complex_isnull: INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := size
			l_stride := stride
			l_j := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_k < {NATURAL_32} 2))
				loop
					if data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] /= 0.0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_j := l_j + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_vector_complex_ispos: INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := size
			l_stride := stride
			l_j := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_k < {NATURAL_32} 2))
				loop
					if data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] <= 0.0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_j := l_j + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_vector_complex_isneg: INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := size
			l_stride := stride
			l_j := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_k < {NATURAL_32} 2))
				loop
					if data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] >= 0.0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_j := l_j + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_vector_complex_isnonneg: INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_n := size
			l_stride := stride
			l_j := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_k < {NATURAL_32} 2))
				loop
					if data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] < 0.0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_k := l_k + 1
					end
				end
				if not l_return then
					l_j := l_j + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_vector_complex_swap (a_w: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		require
			not a_w.is_void
		local
			l_d1: CE_POINTER [REAL_64]
			l_d2: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_s1: NATURAL_32
			l_s2: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_d1 := data
			l_d2 := a_w.item.data
			l_size := size
			l_s1 := {NATURAL_32} 2 * stride
			l_s2 := {NATURAL_32} 2 * a_w.item.stride
			if size /= a_w.item.size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector lengths must be equal"), ce_string ("swap_source.c"), 32, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_size))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_d1[(l_i * l_s1 + l_k).to_integer_32]
						l_d1[(l_i * l_s1 + l_k).to_integer_32] := l_d2[(l_i * l_s2 + l_k).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_d2[(l_i * l_s2 + l_k).to_integer_32] := l_tmp
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_swap_elements (a_i, a_j: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_data := data
			l_size := size
			l_stride := stride
			if a_i >= l_size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first index is out of range"), ce_string ("swap_source.c"), 57, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_j >= l_size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second index is out of range"), ce_string ("swap_source.c"), 62, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				if a_i /= a_j then
					l_s := {NATURAL_32} 2 * l_stride
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_data[(a_j * l_s + l_k).to_integer_32]
						l_data[(a_j * l_s + l_k).to_integer_32] := l_data[(a_i * l_s + l_k).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_data[(a_i * l_s + l_k).to_integer_32] := l_tmp
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_vector_complex_reverse: INTEGER_32
		local
			l_data: CE_POINTER [REAL_64]
			l_size: NATURAL_32
			l_stride: NATURAL_32
			l_s: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_tmp: REAL_64
			l_return: BOOLEAN
		do
			l_data := data
			l_size := size
			l_stride := stride
			l_s := {NATURAL_32} 2 * l_stride
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size // {NATURAL_32} 2))
			loop
				l_j := (l_size - l_i) - {NATURAL_32} 1
				l_k := (0).to_natural_32
				from
				until
					not (l_k < {NATURAL_32} 2)
				loop
					l_tmp := l_data[(l_j * l_s + l_k).to_integer_32]
					l_data[(l_j * l_s + l_k).to_integer_32] := l_data[(l_i * l_s + l_k).to_integer_32]
					update_class_fields -- Current might have been changed; synchronize
					l_data[(l_i * l_s + l_k).to_integer_32] := l_tmp
					update_class_fields -- Current might have been changed; synchronize
					l_k := l_k + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_add (a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_N := size
			if a_b___0.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 27, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			else
				l_stride_a := stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] + (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] + (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_vector_complex_sub (a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_N := size
			if a_b___0.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 53, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			else
				l_stride_a := stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] - (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] - (a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32])
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_vector_complex_mul (a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_ar: REAL_64
			l_ai: REAL_64
			l_br: REAL_64
			l_bi: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_N := size
			if a_b___0.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 79, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			else
				l_stride_a := stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_ar := data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32]
					l_ai := data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32]
					l_br := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32]
					l_bi := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32]
					data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := l_ar * l_br - l_ai * l_bi
					update_class_fields -- Current might have been changed; synchronize
					data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := l_ar * l_bi + l_ai * l_br
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_vector_complex_div (a_b___0: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_ar: REAL_64
			l_ai: REAL_64
			l_br: REAL_64
			l_bi: REAL_64
			l_s: REAL_64
			l_tmp: REAL_64
			l_sbr: REAL_64
			l_sbi: REAL_64
			l_return, l_break: BOOLEAN
		do
			l_N := size
			if a_b___0.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_complex_source.c"), 111, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			else
				l_stride_a := stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					l_ar := data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32]
					l_ai := data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32]
					l_br := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b).to_integer_32]
					l_bi := a_b___0.item.data[(({NATURAL_32} 2 * l_i) * l_stride_b + {NATURAL_32} 1).to_integer_32]
					l_tmp := hypot (l_br, l_bi)
					update_class_fields -- Current might have been changed; synchronize
					l_s := 1.0 / l_tmp
					l_sbr := l_s * l_br
					l_sbi := l_s * l_bi
					data[(({NATURAL_32} 2 * l_i) * l_stride_a).to_integer_32] := (l_ar * l_sbr + l_ai * l_sbi) * l_s
					update_class_fields -- Current might have been changed; synchronize
					data[(({NATURAL_32} 2 * l_i) * l_stride_a + {NATURAL_32} 1).to_integer_32] := (l_ai * l_sbr - l_ar * l_sbi) * l_s
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_vector_complex_scale (a_x: PD_GSL_COMPLEX): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_xr: REAL_64
			l_xi: REAL_64
			l_ar: REAL_64
			l_ai: REAL_64
		do
			l_N := size
			l_stride := stride
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				l_ar := data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32]
				l_ai := data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32]
				data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] := l_ar * l_xr - l_ai * l_xi
				update_class_fields -- Current might have been changed; synchronize
				data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] := l_ar * l_xi + l_ai * l_xr
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_add_constant (a_x: PD_GSL_COMPLEX): INTEGER_32
		local
			l_N: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_xr: REAL_64
			l_xi: REAL_64
		do
			l_N := size
			l_stride := stride
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_N)
			loop
				data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] := data[(({NATURAL_32} 2 * l_i) * l_stride).to_integer_32] + l_xr
				update_class_fields -- Current might have been changed; synchronize
				data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] := data[(({NATURAL_32} 2 * l_i) * l_stride + {NATURAL_32} 1).to_integer_32] + l_xi
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_vector_complex_const_real: PD_GSL_VECTOR_CONST_VIEW
		local
			l_s: PD_GSL_VECTOR
			l_view: PD_GSL_VECTOR_CONST_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_s.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_s.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_s.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_s.data := data
			update_class_fields -- Current might have been changed; synchronize
			l_s.size := size
			update_class_fields -- Current might have been changed; synchronize
			l_s.stride := {NATURAL_32} 2 * stride
			update_class_fields -- Current might have been changed; synchronize
			l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_s.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector := l_s.twin
			update_class_fields -- Current might have been changed; synchronize
			Result := l_view.twin
		end

	gsl_vector_complex_const_imag: PD_GSL_VECTOR_CONST_VIEW
		local
			l_s: PD_GSL_VECTOR
			l_view: PD_GSL_VECTOR_CONST_VIEW
		do
			create l_s.make
			create l_view.make

			l_s.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_s.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_s.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_s.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_s.data := (data + 1)
			update_class_fields -- Current might have been changed; synchronize
			l_s.size := size
			update_class_fields -- Current might have been changed; synchronize
			l_s.stride := {NATURAL_32} 2 * stride
			update_class_fields -- Current might have been changed; synchronize
			l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_s.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector := l_s.twin
			update_class_fields -- Current might have been changed; synchronize
			Result := l_view.twin
		end

	gsl_vector_complex_fread (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_tmp := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_complex_raw_fread (a_stream, data, size, stride)
			update_class_fields -- Current might have been changed; synchronize
			l_status := l_tmp
			Result := l_status
		end

	gsl_vector_complex_fwrite (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_tmp := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_complex_raw_fwrite (a_stream, data, size, stride)
			update_class_fields -- Current might have been changed; synchronize
			l_status := l_tmp
			Result := l_status
		end

	gsl_vector_complex_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_tmp := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_complex_raw_fprintf (a_stream, data, size, stride, a_format)
			update_class_fields -- Current might have been changed; synchronize
			l_status := l_tmp
			Result := l_status
		end

	gsl_vector_complex_fscanf (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_tmp := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_complex_raw_fscanf (a_stream, data, size, stride)
			update_class_fields -- Current might have been changed; synchronize
			l_status := l_tmp
			Result := l_status
		end

	gsl_vector_complex_subvector (a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_offset + (a_n - {NATURAL_32} 1) >= size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := data + (({NATURAL_32} 2 * stride) * a_offset).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_s.stride := stride
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_s.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_vector_complex_subvector_with_stride (a_offset, a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := data + (({NATURAL_32} 2 * stride) * a_offset).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_s.stride := stride * a_stride
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_s.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_vector_complex_const_subvector (a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 28, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_offset + (a_n - {NATURAL_32} 1) >= size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 34, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := (data + (({NATURAL_32} 2 * stride) * a_offset).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_s.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_s.stride := stride
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_s.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_vector_complex_const_subvector_with_stride (a_offset, a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_s: PD_GSL_VECTOR_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_s.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("subvector_source.c"), 59, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("subvector_source.c"), 65, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("view would extend past end of vector"), ce_string ("subvector_source.c"), 71, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := (data + (({NATURAL_32} 2 * stride) * a_offset).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_s.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_s.stride := (stride * a_stride)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_s.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_vector_complex_alloc_from_vector (a_offset, a_n, a_stride: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("init_source.c"), 131, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("init_source.c"), 136, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_offset + (a_n - {NATURAL_32} 1) * a_stride >= size) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector would extend past end of block"), ce_string ("init_source.c"), 141, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_VECTOR_COMPLEX}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_cast (l_tmp)
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("init_source.c"), 149, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := data + (({NATURAL_32} 2 * stride) * a_offset).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.stride := a_stride * stride
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := l_v
			end
		end

	gsl_vector_complex_set_all (a_x: PD_GSL_COMPLEX)
		local
			l_data: CE_POINTER [REAL_64]
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_i: NATURAL_32
		do
			l_data := data
			l_n := size
			l_stride := stride
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				(create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((l_data + (({NATURAL_32} 2 * l_i) * l_stride).to_integer_32))).item := a_x.twin
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
		end

	gsl_vector_complex_set_zero
		local
			l_data: CE_POINTER [REAL_64]
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_zero: PD_GSL_COMPLEX
			l_i: NATURAL_32
		do
			create l_zero.make

			l_data := data
			l_n := size
			l_stride := stride
			l_zero.dat[0] := 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_zero.dat[1] := 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				(create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((l_data + (({NATURAL_32} 2 * l_i) * l_stride).to_integer_32))).item := l_zero.twin
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
		end

	gsl_vector_complex_set_basis (a_i: NATURAL_32): INTEGER_32
		local
			l_data: CE_POINTER [REAL_64]
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_zero: PD_GSL_COMPLEX
			l_one: PD_GSL_COMPLEX
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create l_zero.make
			create l_one.make

			l_data := data
			l_n := size
			l_stride := stride
			l_zero.dat[0] := 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_zero.dat[1] := 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_one.dat[0] := 1.0
			update_class_fields -- Current might have been changed; synchronize
			l_one.dat[1] := 0.0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= l_n then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("index out of range"), ce_string ("init_source.c"), 219, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_k := (0).to_natural_32
				from
				until
					not (l_k < l_n)
				loop
					(create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((l_data + (({NATURAL_32} 2 * l_k) * l_stride).to_integer_32))).item := l_zero.twin
					update_class_fields -- Current might have been changed; synchronize
					l_k := l_k + 1
				end
				(create {CE_CLASS_POINTER [PD_GSL_COMPLEX]}.make_cast ((l_data + (({NATURAL_32} 2 * a_i) * l_stride).to_integer_32))).item := l_one.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

feature {PD_GSL_VECTOR_COMPLEX} -- private routines

	gsl_complex_sub_real (a_a___5: PD_GSL_COMPLEX; a_x: REAL_64): PD_GSL_COMPLEX
		local
			l_z: PD_GSL_COMPLEX
			l_break: BOOLEAN
		do
			create l_z.make

			from
			until
				(l_break)
			loop
				l_break := False
				l_z.dat[0] := a_a___5.dat[0] - a_x
				l_z.dat[1] := a_a___5.dat[1]
				l_break := True
			end
			l_break := False
			Result := l_z.twin
		end

	gsl_complex_negative (a_a___5: PD_GSL_COMPLEX): PD_GSL_COMPLEX
		local
			l_z: PD_GSL_COMPLEX
			l_break: BOOLEAN
		do
			create l_z.make

			from
			until
				(l_break)
			loop
				l_break := False
				l_z.dat[0] := -a_a___5.dat[0]
				l_z.dat[1] := -a_a___5.dat[1]
				l_break := True
			end
			l_break := False
			Result := l_z.twin
		end

	cblas_dzasum (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32): REAL_64
		local
			l_r___3: REAL_64
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: REAL_64
			l_return: BOOLEAN
		do
			l_r___3 := 0.0
			l_ix := 0
			if a_incX <= 0 then
				Result := (0).to_double
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_tmp := fabs (create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix])
					l_r___3 := l_r___3 + (l_tmp + (fabs (create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)])))
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
				Result := l_r___3
			end
		end

	cblas_dznrm2 (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32): REAL_64
		local
			l_scale: REAL_64
			l_ssq: REAL_64
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_x: REAL_64
			l_y: REAL_64
			l_ax: REAL_64
			l_ay: REAL_64
			l_return: BOOLEAN
		do
			l_scale := 0.0
			l_ssq := 1.0
			l_ix := 0
			if a_N = 0 then
				Result := (0).to_double
				l_return := True
			elseif a_incX < 1 then
				Result := (0).to_double
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_x := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
					l_y := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
					if l_x /= 0.0 then
						l_ax := (fabs (l_x))
						if l_scale < l_ax then
							l_ssq := 1.0 + (l_ssq * (l_scale / l_ax)) * (l_scale / l_ax)
							l_scale := l_ax
						else
							l_ssq := l_ssq + ((l_ax / l_scale) * (l_ax / l_scale))
						end
					end
					if l_y /= 0.0 then
						l_ay := (fabs (l_y))
						if l_scale < l_ay then
							l_ssq := 1.0 + (l_ssq * (l_scale / l_ay)) * (l_scale / l_ay)
							l_scale := l_ay
						else
							l_ssq := l_ssq + ((l_ay / l_scale) * (l_ay / l_scale))
						end
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
				Result := (l_scale * (sqrt (l_ssq)))
			end
		end

	cblas_zaxpy (a_N: INTEGER_32; a_alpha, a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_alpha_real: REAL_64
			l_alpha_imag: REAL_64
			l_x_real: REAL_64
			l_x_imag: REAL_64
			l_return: BOOLEAN
		do
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_ix := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_iy := l_tmp___0
			l_alpha_real := create {CE_REAL_64_POINTER}.make_cast (a_alpha)[0]
			l_alpha_imag := create {CE_REAL_64_POINTER}.make_cast (a_alpha)[1]
			if (fabs (l_alpha_real)) = (0).to_double then
				if (fabs (l_alpha_imag)) = (0).to_double then
					l_return := True
				end
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_x_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
					l_x_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
					create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_iy] := create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_iy] + (l_alpha_real * l_x_real - l_alpha_imag * l_x_imag)
					create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)] := create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)] + (l_alpha_real * l_x_imag + l_alpha_imag * l_x_real)
					l_ix := l_ix + a_incX
					l_iy := l_iy + a_incY
					l_i := l_i + 1
				end
			end
		end

	cblas_zcopy (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_ix := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_iy := l_tmp___0
			l_i := 0
			from
			until
				not (l_i < a_N)
			loop
				create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_iy] := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
				create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)] := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
				l_ix := l_ix + a_incX
				l_iy := l_iy + a_incY
				l_i := l_i + 1
			end
		end

	cblas_zdotc_sub (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32; a_result: CE_POINTER [ANY])
		local
			l_r_real: REAL_64
			l_r_imag: REAL_64
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_x_real: REAL_64
			l_x_imag: REAL_64
			l_y_real: REAL_64
			l_y_imag: REAL_64
		do
			l_r_real := 0.0
			l_r_imag := 0.0
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_ix := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_iy := l_tmp___0
			l_i := 0
			from
			until
				not (l_i < a_N)
			loop
				l_x_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
				l_x_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
				l_y_real := create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_iy]
				l_y_imag := create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)]
				l_r_real := l_r_real + (l_x_real * l_y_real - (-1.0 * l_x_imag) * l_y_imag)
				l_r_imag := l_r_imag + (l_x_real * l_y_imag + (-1.0 * l_x_imag) * l_y_real)
				l_ix := l_ix + a_incX
				l_iy := l_iy + a_incY
				l_i := l_i + 1
			end
			create {CE_REAL_64_POINTER}.make_cast (a_result)[0] := l_r_real
			create {CE_REAL_64_POINTER}.make_cast (a_result)[1] := l_r_imag
		end

	cblas_zdotu_sub (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32; a_result: CE_POINTER [ANY])
		local
			l_r_real: REAL_64
			l_r_imag: REAL_64
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_x_real: REAL_64
			l_x_imag: REAL_64
			l_y_real: REAL_64
			l_y_imag: REAL_64
		do
			l_r_real := 0.0
			l_r_imag := 0.0
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_ix := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_iy := l_tmp___0
			l_i := 0
			from
			until
				not (l_i < a_N)
			loop
				l_x_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
				l_x_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
				l_y_real := create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_iy]
				l_y_imag := create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)]
				l_r_real := l_r_real + (l_x_real * l_y_real - (1.0 * l_x_imag) * l_y_imag)
				l_r_imag := l_r_imag + (l_x_real * l_y_imag + (1.0 * l_x_imag) * l_y_real)
				l_ix := l_ix + a_incX
				l_iy := l_iy + a_incY
				l_i := l_i + 1
			end
			create {CE_REAL_64_POINTER}.make_cast (a_result)[0] := l_r_real
			create {CE_REAL_64_POINTER}.make_cast (a_result)[1] := l_r_imag
		end

	cblas_zdscal (a_N: INTEGER_32; a_alpha: REAL_64; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_return: BOOLEAN
		do
			l_ix := 0
			if a_incX <= 0 then
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix] := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix] * a_alpha
					create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] * a_alpha
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			end
		end

	cblas_zgerc (a_order: NATURAL_32; a_M, a_N: INTEGER_32; a_alpha, a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_alpha_real: REAL_64
			l_alpha_imag: REAL_64
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_X_real: REAL_64
			l_X_imag: REAL_64
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			l_jy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_Y_real: REAL_64
			l_Y_imag: REAL_64
			l_jy___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_Y_real___0: REAL_64
			l_Y_imag___0: REAL_64
			l_tmp_real___0: REAL_64
			l_tmp_imag___0: REAL_64
			l_ix___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_X_real___0: REAL_64
			l_X_imag___0: REAL_64
			l_return: BOOLEAN
		do
			l_alpha_real := create {CE_REAL_64_POINTER}.make_cast (a_alpha)[0]
			l_alpha_imag := create {CE_REAL_64_POINTER}.make_cast (a_alpha)[1]
			if a_order = {NATURAL_32} 101 then
				if a_incX > 0 then
					l_tmp := 0
				else
					l_tmp := (a_M - 1) * -a_incX
				end
				l_ix := l_tmp
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < a_M))
				loop
					l_X_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
					l_X_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
					l_tmp_real := l_alpha_real * l_X_real - l_alpha_imag * l_X_imag
					l_tmp_imag := l_alpha_imag * l_X_real + l_alpha_real * l_X_imag
					if a_incY > 0 then
						l_tmp___0 := 0
					else
						l_tmp___0 := (a_N - 1) * -a_incY
					end
					l_jy := l_tmp___0
					l_j := 0
					from
					until
						not (l_j < a_N)
					loop
						l_Y_real := create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_jy]
						l_Y_imag := (-create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_jy + 1)])
						create {CE_REAL_64_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)] := create {CE_REAL_64_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)] + (l_Y_real * l_tmp_real - l_Y_imag * l_tmp_imag)
						create {CE_REAL_64_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)] := create {CE_REAL_64_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)] + (l_Y_imag * l_tmp_real + l_Y_real * l_tmp_imag)
						l_jy := l_jy + a_incY
						l_j := l_j + 1
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			elseif a_order = {NATURAL_32} 102 then
				if a_incY > 0 then
					l_tmp___1 := 0
				else
					l_tmp___1 := (a_N - 1) * -a_incY
				end
				l_jy___0 := l_tmp___1
				l_j := 0
				from
				until
					not (not (l_return) and then (l_j < a_N))
				loop
					l_Y_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_jy___0]
					l_Y_imag___0 := (-create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_jy___0 + 1)])
					l_tmp_real___0 := l_alpha_real * l_Y_real___0 - l_alpha_imag * l_Y_imag___0
					l_tmp_imag___0 := l_alpha_imag * l_Y_real___0 + l_alpha_real * l_Y_imag___0
					if a_incX > 0 then
						l_tmp___2 := 0
					else
						l_tmp___2 := (a_M - 1) * -a_incX
					end
					l_ix___0 := l_tmp___2
					l_i := 0
					from
					until
						not (l_i < a_M)
					loop
						l_X_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0]
						l_X_imag___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
						create {CE_REAL_64_POINTER}.make_cast (a_A___0)[2 * (l_i + a_lda * l_j)] := create {CE_REAL_64_POINTER}.make_cast (a_A___0)[2 * (l_i + a_lda * l_j)] + (l_X_real___0 * l_tmp_real___0 - l_X_imag___0 * l_tmp_imag___0)
						create {CE_REAL_64_POINTER}.make_cast (a_A___0)[(2 * (l_i + a_lda * l_j) + 1)] := create {CE_REAL_64_POINTER}.make_cast (a_A___0)[(2 * (l_i + a_lda * l_j) + 1)] + (l_X_imag___0 * l_tmp_real___0 + l_X_real___0 * l_tmp_imag___0)
						l_ix___0 := l_ix___0 + a_incX
						l_i := l_i + 1
					end
					l_jy___0 := l_jy___0 + a_incY
					l_j := l_j + 1
				end
			else
				(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_gerc.h"), ce_string ("unrecognized operation")])
			end
		end

	cblas_zgeru (a_order: NATURAL_32; a_M, a_N: INTEGER_32; a_alpha, a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_alpha_real: REAL_64
			l_alpha_imag: REAL_64
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_X_real: REAL_64
			l_X_imag: REAL_64
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
			l_jy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_Y_real: REAL_64
			l_Y_imag: REAL_64
			l_jy___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_Y_real___0: REAL_64
			l_Y_imag___0: REAL_64
			l_tmp_real___0: REAL_64
			l_tmp_imag___0: REAL_64
			l_ix___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_X_real___0: REAL_64
			l_X_imag___0: REAL_64
			l_return: BOOLEAN
		do
			l_alpha_real := create {CE_REAL_64_POINTER}.make_cast (a_alpha)[0]
			l_alpha_imag := create {CE_REAL_64_POINTER}.make_cast (a_alpha)[1]
			if a_order = {NATURAL_32} 101 then
				if a_incX > 0 then
					l_tmp := 0
				else
					l_tmp := (a_M - 1) * -a_incX
				end
				l_ix := l_tmp
				l_i := 0
				from
				until
					not (not (l_return) and then (l_i < a_M))
				loop
					l_X_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
					l_X_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
					l_tmp_real := l_alpha_real * l_X_real - l_alpha_imag * l_X_imag
					l_tmp_imag := l_alpha_imag * l_X_real + l_alpha_real * l_X_imag
					if a_incY > 0 then
						l_tmp___0 := 0
					else
						l_tmp___0 := (a_N - 1) * -a_incY
					end
					l_jy := l_tmp___0
					l_j := 0
					from
					until
						not (l_j < a_N)
					loop
						l_Y_real := create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_jy]
						l_Y_imag := create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_jy + 1)]
						create {CE_REAL_64_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)] := create {CE_REAL_64_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)] + (l_Y_real * l_tmp_real - l_Y_imag * l_tmp_imag)
						create {CE_REAL_64_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)] := create {CE_REAL_64_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)] + (l_Y_imag * l_tmp_real + l_Y_real * l_tmp_imag)
						l_jy := l_jy + a_incY
						l_j := l_j + 1
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			elseif a_order = {NATURAL_32} 102 then
				if a_incY > 0 then
					l_tmp___1 := 0
				else
					l_tmp___1 := (a_N - 1) * -a_incY
				end
				l_jy___0 := l_tmp___1
				l_j := 0
				from
				until
					not (not (l_return) and then (l_j < a_N))
				loop
					l_Y_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_jy___0]
					l_Y_imag___0 := create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_jy___0 + 1)]
					l_tmp_real___0 := l_alpha_real * l_Y_real___0 - l_alpha_imag * l_Y_imag___0
					l_tmp_imag___0 := l_alpha_imag * l_Y_real___0 + l_alpha_real * l_Y_imag___0
					if a_incX > 0 then
						l_tmp___2 := 0
					else
						l_tmp___2 := (a_M - 1) * -a_incX
					end
					l_ix___0 := l_tmp___2
					l_i := 0
					from
					until
						not (l_i < a_M)
					loop
						l_X_real___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix___0]
						l_X_imag___0 := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
						create {CE_REAL_64_POINTER}.make_cast (a_A___0)[2 * (l_i + a_lda * l_j)] := create {CE_REAL_64_POINTER}.make_cast (a_A___0)[2 * (l_i + a_lda * l_j)] + (l_X_real___0 * l_tmp_real___0 - l_X_imag___0 * l_tmp_imag___0)
						create {CE_REAL_64_POINTER}.make_cast (a_A___0)[(2 * (l_i + a_lda * l_j) + 1)] := create {CE_REAL_64_POINTER}.make_cast (a_A___0)[(2 * (l_i + a_lda * l_j) + 1)] + (l_X_imag___0 * l_tmp_real___0 + l_X_real___0 * l_tmp_imag___0)
						l_ix___0 := l_ix___0 + a_incX
						l_i := l_i + 1
					end
					l_jy___0 := l_jy___0 + a_incY
					l_j := l_j + 1
				end
			else
				(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_geru.h"), ce_string ("unrecognized operation")])
			end
		end

	cblas_zscal (a_N: INTEGER_32; a_alpha, a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_alpha_real: REAL_64
			l_alpha_imag: REAL_64
			l_x_real: REAL_64
			l_x_imag: REAL_64
			l_return: BOOLEAN
		do
			l_ix := 0
			l_alpha_real := create {CE_REAL_64_POINTER}.make_cast (a_alpha)[0]
			l_alpha_imag := create {CE_REAL_64_POINTER}.make_cast (a_alpha)[1]
			if a_incX <= 0 then
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_x_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
					l_x_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
					create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix] := l_x_real * l_alpha_real - l_x_imag * l_alpha_imag
					create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_x_real * l_alpha_imag + l_x_imag * l_alpha_real
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			end
		end

	cblas_zswap (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp_real: REAL_64
			l_tmp_imag: REAL_64
		do
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_ix := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_iy := l_tmp___0
			l_i := 0
			from
			until
				not (l_i < a_N)
			loop
				l_tmp_real := create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix]
				l_tmp_imag := create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
				create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix] := create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_iy]
				create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)]
				create {CE_REAL_64_POINTER}.make_cast (a_Y)[2 * l_iy] := l_tmp_real
				create {CE_REAL_64_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)] := l_tmp_imag
				l_ix := l_ix + a_incX
				l_iy := l_iy + a_incY
				l_i := l_i + 1
			end
		end

	cblas_izamax (a_N: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32): NATURAL_32
		local
			l_max: REAL_64
			l_ix: INTEGER_32
			l_i: INTEGER_32
			l_result: NATURAL_32
			l_a___5: REAL_64
			l_tmp: REAL_64
			l_return: BOOLEAN
		do
			l_max := 0.0
			l_ix := 0
			l_result := (0).to_natural_32
			if a_incX <= 0 then
				Result := (0).to_natural_32
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < a_N)
				loop
					l_tmp := fabs (create {CE_REAL_64_POINTER}.make_cast (a_X)[2 * l_ix])
					l_a___5 := l_tmp + (fabs (create {CE_REAL_64_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]))
					if l_a___5 > l_max then
						l_max := l_a___5
						l_result := l_i.to_natural_32
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
				Result := l_result
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size := a_other.size
			stride := a_other.stride
			data := a_other.data
			block := a_other.block
			owner := a_other.owner
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size = a_other.size and
				stride = a_other.stride and
				data.is_equal (a_other.data) and
				block.is_equal (a_other.block) and
				owner = a_other.owner
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("stride"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("owner")
				>>)
			init_structure_info
		end

end
