class
	PD_HYBRID_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} J.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} q.make
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} r.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} tau.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} diag.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} qtf.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} newton.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} gradient.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} x_trial.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} f_trial.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} df.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} qtdf.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} rdx.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} w.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} v.make
		end

feature {ANY} -- fields

	iter: NATURAL_32 assign set_iter

	ncfail: NATURAL_32 assign set_ncfail

	ncsuc: NATURAL_32 assign set_ncsuc

	nslow1: NATURAL_32 assign set_nslow1

	nslow2: NATURAL_32 assign set_nslow2

	fnorm: REAL_64 assign set_fnorm

	delta: REAL_64 assign set_delta

	J: CE_POINTER [PD_GSL_MATRIX] assign set_J

	q: CE_POINTER [PD_GSL_MATRIX] assign set_q

	r: CE_POINTER [PD_GSL_MATRIX] assign set_r

	tau: CE_POINTER [PD_GSL_VECTOR] assign set_tau

	diag: CE_POINTER [PD_GSL_VECTOR] assign set_diag

	qtf: CE_POINTER [PD_GSL_VECTOR] assign set_qtf

	newton: CE_POINTER [PD_GSL_VECTOR] assign set_newton

	gradient: CE_POINTER [PD_GSL_VECTOR] assign set_gradient

	x_trial: CE_POINTER [PD_GSL_VECTOR] assign set_x_trial

	f_trial: CE_POINTER [PD_GSL_VECTOR] assign set_f_trial

	df: CE_POINTER [PD_GSL_VECTOR] assign set_df

	qtdf: CE_POINTER [PD_GSL_VECTOR] assign set_qtdf

	rdx: CE_POINTER [PD_GSL_VECTOR] assign set_rdx

	w: CE_POINTER [PD_GSL_VECTOR] assign set_w

	v: CE_POINTER [PD_GSL_VECTOR] assign set_v

feature {ANY} -- field setters

	set_iter (a_iter: NATURAL_32)
		do
			iter := a_iter
			update_memory_field ("iter")
		end

	set_ncfail (a_ncfail: NATURAL_32)
		do
			ncfail := a_ncfail
			update_memory_field ("ncfail")
		end

	set_ncsuc (a_ncsuc: NATURAL_32)
		do
			ncsuc := a_ncsuc
			update_memory_field ("ncsuc")
		end

	set_nslow1 (a_nslow1: NATURAL_32)
		do
			nslow1 := a_nslow1
			update_memory_field ("nslow1")
		end

	set_nslow2 (a_nslow2: NATURAL_32)
		do
			nslow2 := a_nslow2
			update_memory_field ("nslow2")
		end

	set_fnorm (a_fnorm: REAL_64)
		do
			fnorm := a_fnorm
			update_memory_field ("fnorm")
		end

	set_delta (a_delta: REAL_64)
		do
			delta := a_delta
			update_memory_field ("delta")
		end

	set_J (a_J: CE_POINTER [PD_GSL_MATRIX])
		do
			J := a_J
			update_memory_field ("J")
		end

	set_q (a_q: CE_POINTER [PD_GSL_MATRIX])
		do
			q := a_q
			update_memory_field ("q")
		end

	set_r (a_r: CE_POINTER [PD_GSL_MATRIX])
		do
			r := a_r
			update_memory_field ("r")
		end

	set_tau (a_tau: CE_POINTER [PD_GSL_VECTOR])
		do
			tau := a_tau
			update_memory_field ("tau")
		end

	set_diag (a_diag: CE_POINTER [PD_GSL_VECTOR])
		do
			diag := a_diag
			update_memory_field ("diag")
		end

	set_qtf (a_qtf: CE_POINTER [PD_GSL_VECTOR])
		do
			qtf := a_qtf
			update_memory_field ("qtf")
		end

	set_newton (a_newton: CE_POINTER [PD_GSL_VECTOR])
		do
			newton := a_newton
			update_memory_field ("newton")
		end

	set_gradient (a_gradient: CE_POINTER [PD_GSL_VECTOR])
		do
			gradient := a_gradient
			update_memory_field ("gradient")
		end

	set_x_trial (a_x_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			x_trial := a_x_trial
			update_memory_field ("x_trial")
		end

	set_f_trial (a_f_trial: CE_POINTER [PD_GSL_VECTOR])
		do
			f_trial := a_f_trial
			update_memory_field ("f_trial")
		end

	set_df (a_df: CE_POINTER [PD_GSL_VECTOR])
		do
			df := a_df
			update_memory_field ("df")
		end

	set_qtdf (a_qtdf: CE_POINTER [PD_GSL_VECTOR])
		do
			qtdf := a_qtdf
			update_memory_field ("qtdf")
		end

	set_rdx (a_rdx: CE_POINTER [PD_GSL_VECTOR])
		do
			rdx := a_rdx
			update_memory_field ("rdx")
		end

	set_w (a_w: CE_POINTER [PD_GSL_VECTOR])
		do
			w := a_w
			update_memory_field ("w")
		end

	set_v (a_v: CE_POINTER [PD_GSL_VECTOR])
		do
			v := a_v
			update_memory_field ("v")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			iter := a_other.iter
			ncfail := a_other.ncfail
			ncsuc := a_other.ncsuc
			nslow1 := a_other.nslow1
			nslow2 := a_other.nslow2
			fnorm := a_other.fnorm
			delta := a_other.delta
			J := a_other.J
			q := a_other.q
			r := a_other.r
			tau := a_other.tau
			diag := a_other.diag
			qtf := a_other.qtf
			newton := a_other.newton
			gradient := a_other.gradient
			x_trial := a_other.x_trial
			f_trial := a_other.f_trial
			df := a_other.df
			qtdf := a_other.qtdf
			rdx := a_other.rdx
			w := a_other.w
			v := a_other.v
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				iter = a_other.iter and
				ncfail = a_other.ncfail and
				ncsuc = a_other.ncsuc and
				nslow1 = a_other.nslow1 and
				nslow2 = a_other.nslow2 and
				fnorm = a_other.fnorm and
				delta = a_other.delta and
				J.is_equal (a_other.J) and
				q.is_equal (a_other.q) and
				r.is_equal (a_other.r) and
				tau.is_equal (a_other.tau) and
				diag.is_equal (a_other.diag) and
				qtf.is_equal (a_other.qtf) and
				newton.is_equal (a_other.newton) and
				gradient.is_equal (a_other.gradient) and
				x_trial.is_equal (a_other.x_trial) and
				f_trial.is_equal (a_other.f_trial) and
				df.is_equal (a_other.df) and
				qtdf.is_equal (a_other.qtdf) and
				rdx.is_equal (a_other.rdx) and
				w.is_equal (a_other.w) and
				v.is_equal (a_other.v)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("iter"),
					create {CE_STRUCTURE_FIELD}.make ("ncfail"),
					create {CE_STRUCTURE_FIELD}.make ("ncsuc"),
					create {CE_STRUCTURE_FIELD}.make ("nslow1"),
					create {CE_STRUCTURE_FIELD}.make ("nslow2"),
					create {CE_STRUCTURE_FIELD}.make ("fnorm"),
					create {CE_STRUCTURE_FIELD}.make ("delta"),
					create {CE_STRUCTURE_FIELD}.make ("J"),
					create {CE_STRUCTURE_FIELD}.make ("q"),
					create {CE_STRUCTURE_FIELD}.make ("r"),
					create {CE_STRUCTURE_FIELD}.make ("tau"),
					create {CE_STRUCTURE_FIELD}.make ("diag"),
					create {CE_STRUCTURE_FIELD}.make ("qtf"),
					create {CE_STRUCTURE_FIELD}.make ("newton"),
					create {CE_STRUCTURE_FIELD}.make ("gradient"),
					create {CE_STRUCTURE_FIELD}.make ("x_trial"),
					create {CE_STRUCTURE_FIELD}.make ("f_trial"),
					create {CE_STRUCTURE_FIELD}.make ("df"),
					create {CE_STRUCTURE_FIELD}.make ("qtdf"),
					create {CE_STRUCTURE_FIELD}.make ("rdx"),
					create {CE_STRUCTURE_FIELD}.make ("w"),
					create {CE_STRUCTURE_FIELD}.make ("v")
				>>)
			init_structure_info
		end

end
