class
	PD_NMSIMPLEX_STATE_T_119__

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_GSL_MATRIX]} x1.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} y1.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} ws1.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} ws2.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} center.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} delta.make
			create {CE_CLASS_POINTER [PD_GSL_VECTOR]} xmc.make
			Precursor
		end

feature {ANY} -- fields

	x1: CE_POINTER [PD_GSL_MATRIX] assign set_x1

	y1: CE_POINTER [PD_GSL_VECTOR] assign set_y1

	ws1: CE_POINTER [PD_GSL_VECTOR] assign set_ws1

	ws2: CE_POINTER [PD_GSL_VECTOR] assign set_ws2

	center: CE_POINTER [PD_GSL_VECTOR] assign set_center

	delta: CE_POINTER [PD_GSL_VECTOR] assign set_delta

	xmc: CE_POINTER [PD_GSL_VECTOR] assign set_xmc

	S2: REAL_64 assign set_S2

	count: NATURAL_32 assign set_count

feature {ANY} -- field setters

	set_x1 (a_x1: CE_POINTER [PD_GSL_MATRIX])
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

	set_y1 (a_y1: CE_POINTER [PD_GSL_VECTOR])
		do
			y1 := a_y1
			update_memory_field ("y1")
		end

	set_ws1 (a_ws1: CE_POINTER [PD_GSL_VECTOR])
		do
			ws1 := a_ws1
			update_memory_field ("ws1")
		end

	set_ws2 (a_ws2: CE_POINTER [PD_GSL_VECTOR])
		do
			ws2 := a_ws2
			update_memory_field ("ws2")
		end

	set_center (a_center: CE_POINTER [PD_GSL_VECTOR])
		do
			center := a_center
			update_memory_field ("center")
		end

	set_delta (a_delta: CE_POINTER [PD_GSL_VECTOR])
		do
			delta := a_delta
			update_memory_field ("delta")
		end

	set_xmc (a_xmc: CE_POINTER [PD_GSL_VECTOR])
		do
			xmc := a_xmc
			update_memory_field ("xmc")
		end

	set_S2 (a_S2: REAL_64)
		do
			S2 := a_S2
			update_memory_field ("S2")
		end

	set_count (a_count: NATURAL_32)
		do
			count := a_count
			update_memory_field ("count")
		end

feature {ANY} -- public routines

	try_corner_move (a_coeff: REAL_64; a_corner: NATURAL_32; a_xc: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]): REAL_64
		require
			not a_xc.is_void
			not a_f.is_void
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_P___2: NATURAL_32
			l_newval: REAL_64
			l_alpha: REAL_64
			l_beta: REAL_64
			l_row: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_tmp: PD_GSL_VECTOR_CONST_VIEW
		do
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_CONST_VIEW]} l_row.make (<<1>>)

			l_x1___0 := x1
			l_P___2 := l_x1___0.item.size1
			l_alpha := (((1).to_double - a_coeff) * l_P___2.to_real_64) / (l_P___2.to_real_64 - 1.0)
			l_beta := (l_P___2.to_real_64 * a_coeff - 1.0) / (l_P___2.to_real_64 - 1.0)
			l_tmp := (l_x1___0.item.gsl_matrix_const_row (a_corner)).twin
			update_class_fields -- Current might have been changed; synchronize
			l_row.item := l_tmp.twin
			update_class_fields -- Current might have been changed; synchronize
			a_xc.item.gsl_vector_memcpy (center).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			a_xc.item.gsl_blas_dscal (l_alpha)
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_row.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))).item.gsl_blas_daxpy (l_beta, a_xc).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_newval := (a_f.item.f).real_64_item ([a_xc, a_f.item.params])
			update_class_fields -- Current might have been changed; synchronize
			Result := l_newval
		end

	update_point (a_i: NATURAL_32; a_x: CE_POINTER [PD_GSL_VECTOR]; a_val: REAL_64)
		require
			not a_x.is_void
		local
			l_x_orig: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_tmp: PD_GSL_VECTOR_CONST_VIEW
			l_P___2: NATURAL_32
			l_d: REAL_64
			l_tmp___0: REAL_64
			l_xmcd: CE_ARRAY [REAL_64]
			l_alpha: REAL_64
		do
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_CONST_VIEW]} l_x_orig.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_xmcd.make (<<1>>)

			l_tmp := (x1.item.gsl_matrix_const_row (a_i)).twin
			update_class_fields -- Current might have been changed; synchronize
			l_x_orig.item := l_tmp.twin
			update_class_fields -- Current might have been changed; synchronize
			l_P___2 := x1.item.size1
			delta.item.gsl_vector_memcpy (a_x).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			(create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_x_orig.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))).item.gsl_blas_daxpy (-1.0, delta).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			xmc.item.gsl_vector_memcpy ((create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_x_orig.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector")))).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			center.item.gsl_blas_daxpy (-1.0, xmc).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := delta.item.gsl_blas_dnrm2
			update_class_fields -- Current might have been changed; synchronize
			l_d := l_tmp___0
			xmc.item.gsl_blas_ddot (delta, l_xmcd).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Current.S2 := S2 + ((2.0 / l_P___2.to_real_64) * l_xmcd.item + ((l_P___2.to_real_64 - 1.0) / l_P___2.to_real_64) * ((l_d * l_d) / l_P___2.to_real_64))
			update_class_fields -- Current might have been changed; synchronize
			l_alpha := 1.0 / l_P___2.to_real_64;
			(create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_x_orig.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))).item.gsl_blas_daxpy (-l_alpha, center).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			a_x.item.gsl_blas_daxpy (l_alpha, center).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			x1.item.gsl_matrix_set_row (a_i, a_x).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			y1.item.gsl_vector_set (a_i, a_val)
			update_class_fields -- Current might have been changed; synchronize
		end

	contract_by_best (a_best: NATURAL_32; a_xc: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]): INTEGER_32
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_y1___0: CE_POINTER [PD_GSL_VECTOR]
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_newval: REAL_64
			l_status: INTEGER_32
			l_tmp: REAL_64
			l_tmp___0: REAL_64
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_x1___0 := x1
			l_y1___0 := y1
			l_status := 0
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_x1___0.item.size1))
			loop
				if l_i /= a_best then
					l_j := (0).to_natural_32
					from
					until
						not (l_j < l_x1___0.item.size2)
					loop
						l_tmp := l_x1___0.item.gsl_matrix_get (l_i, l_j)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___0 := l_x1___0.item.gsl_matrix_get (a_best, l_j)
						update_class_fields -- Current might have been changed; synchronize
						l_newval := 0.5 * (l_tmp + l_tmp___0)
						l_x1___0.item.gsl_matrix_set (l_i, l_j, l_newval)
						update_class_fields -- Current might have been changed; synchronize
						l_j := l_j + 1
					end
					(create {P_GETSET_SOURCE_STATIC}).gsl_matrix_get_row (a_xc, l_x1___0, l_i).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_newval := (a_f.item.f).real_64_item ([a_xc, a_f.item.params])
					update_class_fields -- Current might have been changed; synchronize
					l_y1___0.item.gsl_vector_set (l_i, l_newval)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___1 := (create {P_INFNAN_STATIC}).gsl_finite (l_newval)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___1.to_boolean then
						l_status := 9
					end
				end
				l_i := l_i + 1
			end
			((create {CE_CLASS_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_shared (c_pointer))).item.compute_center (center).do_nothing
			update_class_fields; -- Current might have been changed; synchronize
			((create {CE_CLASS_POINTER [PD_NMSIMPLEX_STATE_T_119__]}.make_shared (c_pointer))).item.compute_size (center).do_nothing
			update_class_fields -- Current might have been changed; synchronize
			Result := l_status
		end

	compute_center (a_center: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_center.is_void
		local
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_P___2: NATURAL_32
			l_i: NATURAL_32
			l_row: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_tmp: PD_GSL_VECTOR_CONST_VIEW
			l_alpha: REAL_64
		do
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_CONST_VIEW]} l_row.make (<<1>>)

			l_x1___0 := x1
			l_P___2 := l_x1___0.item.size1
			a_center.item.gsl_vector_set_zero
			update_class_fields -- Current might have been changed; synchronize
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_P___2)
			loop
				l_tmp := (l_x1___0.item.gsl_matrix_const_row (l_i)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_row.item := l_tmp.twin
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_row.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector"))).item.gsl_blas_daxpy (1.0, a_center).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			l_alpha := 1.0 / l_P___2.to_real_64
			a_center.item.gsl_blas_dscal (l_alpha)
			update_class_fields -- Current might have been changed; synchronize
			Result := 0
		end

	compute_size (a_center: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_s: CE_POINTER [PD_GSL_VECTOR]
			l_x1___0: CE_POINTER [PD_GSL_MATRIX]
			l_P___2: NATURAL_32
			l_i: NATURAL_32
			l_ss: REAL_64
			l_t: REAL_64
			l_tmp: REAL_64
		do
			l_s := ws1
			l_x1___0 := x1
			l_P___2 := l_x1___0.item.size1
			l_ss := 0.0
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_P___2)
			loop
				(create {P_GETSET_SOURCE_STATIC}).gsl_matrix_get_row (l_s, l_x1___0, l_i).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				a_center.item.gsl_blas_daxpy (-1.0, l_s).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_t := l_s.item.gsl_blas_dnrm2
				update_class_fields -- Current might have been changed; synchronize
				l_ss := l_ss + (l_t * l_t)
				l_i := l_i + 1
			end
			Current.S2 := l_ss / l_P___2.to_real_64
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := sqrt (l_ss / l_P___2.to_real_64)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x1 := a_other.x1
			y1 := a_other.y1
			ws1 := a_other.ws1
			ws2 := a_other.ws2
			center := a_other.center
			delta := a_other.delta
			xmc := a_other.xmc
			S2 := a_other.S2
			count := a_other.count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x1.is_equal (a_other.x1) and
				y1.is_equal (a_other.y1) and
				ws1.is_equal (a_other.ws1) and
				ws2.is_equal (a_other.ws2) and
				center.is_equal (a_other.center) and
				delta.is_equal (a_other.delta) and
				xmc.is_equal (a_other.xmc) and
				S2 = a_other.S2 and
				count = a_other.count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x1"),
					create {CE_STRUCTURE_FIELD}.make ("y1"),
					create {CE_STRUCTURE_FIELD}.make ("ws1"),
					create {CE_STRUCTURE_FIELD}.make ("ws2"),
					create {CE_STRUCTURE_FIELD}.make ("center"),
					create {CE_STRUCTURE_FIELD}.make ("delta"),
					create {CE_STRUCTURE_FIELD}.make ("xmc"),
					create {CE_STRUCTURE_FIELD}.make ("S2"),
					create {CE_STRUCTURE_FIELD}.make ("count")
				>>)
			init_structure_info
		end

end
