class
	PD_RAN1_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_32_ARRAY} shuffle.make (<<32>>)
		end

feature {ANY} -- fields

	x: NATURAL_32 assign set_x

	n: NATURAL_32 assign set_n

	shuffle: CE_ARRAY [NATURAL_32]

feature {ANY} -- field setters

	set_x (a_x: NATURAL_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_n (a_n: NATURAL_32)
		do
			n := a_n
			update_memory_field ("n")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			n := a_other.n
			shuffle := a_other.shuffle.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				n = a_other.n and
				shuffle.is_equal (a_other.shuffle)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("shuffle", <<32>>)
				>>)
			init_structure_info
		end

end
