class
	PD_RK2_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} k1.make
			create {CE_REAL_64_POINTER} k2.make
			create {CE_REAL_64_POINTER} k3.make
			create {CE_REAL_64_POINTER} ytmp.make
		end

feature {ANY} -- fields

	k1: CE_POINTER [REAL_64] assign set_k1

	k2: CE_POINTER [REAL_64] assign set_k2

	k3: CE_POINTER [REAL_64] assign set_k3

	ytmp: CE_POINTER [REAL_64] assign set_ytmp

feature {ANY} -- field setters

	set_k1 (a_k1: CE_POINTER [REAL_64])
		do
			k1 := a_k1
			update_memory_field ("k1")
		end

	set_k2 (a_k2: CE_POINTER [REAL_64])
		do
			k2 := a_k2
			update_memory_field ("k2")
		end

	set_k3 (a_k3: CE_POINTER [REAL_64])
		do
			k3 := a_k3
			update_memory_field ("k3")
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			ytmp := a_ytmp
			update_memory_field ("ytmp")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			k1 := a_other.k1
			k2 := a_other.k2
			k3 := a_other.k3
			ytmp := a_other.ytmp
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				k1.is_equal (a_other.k1) and
				k2.is_equal (a_other.k2) and
				k3.is_equal (a_other.k3) and
				ytmp.is_equal (a_other.ytmp)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("k1"),
					create {CE_STRUCTURE_FIELD}.make ("k2"),
					create {CE_STRUCTURE_FIELD}.make ("k3"),
					create {CE_STRUCTURE_FIELD}.make ("ytmp")
				>>)
			init_structure_info
		end

end
