class
	PD_RK2SIMP_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_64_POINTER} Y1.make
			create {CE_REAL_64_POINTER} y0.make
			create {CE_REAL_64_POINTER} y0_orig.make
			create {CE_REAL_64_POINTER} ytmp.make
			create {CE_REAL_64_POINTER} dfdy.make
			create {CE_REAL_64_POINTER} dfdt.make
			create {CE_REAL_64_POINTER} y_onestep.make
			create {CE_CLASS_POINTER [PD_GSL_PERMUTATION_STRUCT]} p.make
		end

feature {ANY} -- fields

	Y1: CE_POINTER [REAL_64] assign set_Y1

	y0: CE_POINTER [REAL_64] assign set_y0

	y0_orig: CE_POINTER [REAL_64] assign set_y0_orig

	ytmp: CE_POINTER [REAL_64] assign set_ytmp

	dfdy: CE_POINTER [REAL_64] assign set_dfdy

	dfdt: CE_POINTER [REAL_64] assign set_dfdt

	y_onestep: CE_POINTER [REAL_64] assign set_y_onestep

	p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT] assign set_p

feature {ANY} -- field setters

	set_Y1 (a_Y1: CE_POINTER [REAL_64])
		do
			Y1 := a_Y1
			update_memory_field ("Y1")
		end

	set_y0 (a_y0: CE_POINTER [REAL_64])
		do
			y0 := a_y0
			update_memory_field ("y0")
		end

	set_y0_orig (a_y0_orig: CE_POINTER [REAL_64])
		do
			y0_orig := a_y0_orig
			update_memory_field ("y0_orig")
		end

	set_ytmp (a_ytmp: CE_POINTER [REAL_64])
		do
			ytmp := a_ytmp
			update_memory_field ("ytmp")
		end

	set_dfdy (a_dfdy: CE_POINTER [REAL_64])
		do
			dfdy := a_dfdy
			update_memory_field ("dfdy")
		end

	set_dfdt (a_dfdt: CE_POINTER [REAL_64])
		do
			dfdt := a_dfdt
			update_memory_field ("dfdt")
		end

	set_y_onestep (a_y_onestep: CE_POINTER [REAL_64])
		do
			y_onestep := a_y_onestep
			update_memory_field ("y_onestep")
		end

	set_p (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT])
		do
			p := a_p
			update_memory_field ("p")
		end

feature {ANY} -- public routines

	rk2simp_step (a_y: CE_POINTER [REAL_64]; a_h, a_t: REAL_64; a_dim: NATURAL_32; a_sys: CE_POINTER [PD_GSL_ODEIV_SYSTEM]): INTEGER_32
		require
			not a_sys.is_void
		local
			l_y0___0: CE_POINTER [REAL_64]
			l_Y1: CE_POINTER [REAL_64]
			l_ytmp: CE_POINTER [REAL_64]
			l_i: NATURAL_32
			l_s: INTEGER_32
			l_ps: CE_ARRAY [INTEGER_32]
			l_J: CE_ARRAY [PD_GSL_MATRIX_VIEW]
			l_tmp: PD_GSL_MATRIX_VIEW
			l_tmp___0: INTEGER_32
			l_y0_view: CE_ARRAY [PD_GSL_VECTOR_CONST_VIEW]
			l_tmp___1: PD_GSL_VECTOR_CONST_VIEW
			l_ytmp_view: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tmp___2: PD_GSL_VECTOR_VIEW
			l_Y1_view: CE_ARRAY [PD_GSL_VECTOR_VIEW]
			l_tmp___3: PD_GSL_VECTOR_VIEW
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_ps.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_MATRIX_VIEW]} l_J.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_CONST_VIEW]} l_y0_view.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_ytmp_view.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_VECTOR_VIEW]} l_Y1_view.make (<<1>>)

			l_y0___0 := y0
			l_Y1 := Y1
			l_ytmp := ytmp
			l_tmp := ((create {P_VIEW_SOURCE_STATIC}).gsl_matrix_view_array (dfdy, a_dim, a_dim)).twin
			update_class_fields -- Current might have been changed; synchronize
			l_J.item := l_tmp.twin
			update_class_fields -- Current might have been changed; synchronize
			l_s := (a_sys.item.jacobian).integer_32_item ([a_t, l_y0___0, dfdy, dfdt, a_sys.item.params])
			update_class_fields -- Current might have been changed; synchronize
			if l_s /= 0 then
				Result := l_s
				l_return := True
			end
			if not l_return then
				(create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_J.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_matrix_scale (-a_h / 2.0).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_J.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_matrix_add_diagonal (1.0).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := (create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_J.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_linalg_LU_decomp (p, l_ps)
				update_class_fields -- Current might have been changed; synchronize
				l_s := l_s + l_tmp___0
				if l_s /= 0 then
					Result := 5
					l_return := True
				end
			end
			if not l_return then
				l_s := (a_sys.item.function).integer_32_item ([a_t + 0.5 * a_h, l_y0___0, l_ytmp, a_sys.item.params])
				update_class_fields -- Current might have been changed; synchronize
				if l_s /= 0 then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				l_tmp___1 := (gsl_vector_const_view_array (l_y0___0, a_dim)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_y0_view.item := l_tmp___1.twin
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___2 := ((create {P_VIEW_SOURCE_STATIC}).gsl_vector_view_array (l_ytmp, a_dim)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_ytmp_view.item := l_tmp___2.twin
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := ((create {P_VIEW_SOURCE_STATIC}).gsl_vector_view_array (l_Y1, a_dim)).twin
				update_class_fields -- Current might have been changed; synchronize
				l_Y1_view.item := l_tmp___3.twin
				update_class_fields -- Current might have been changed; synchronize
				l_s := (create {CE_CLASS_POINTER [PD_GSL_MATRIX]}.make_shared (l_J.item.c_pointer + (create {PD_GSL_MATRIX_VIEW}.make).offset_of ("matrix"))).item.gsl_linalg_LU_solve (p, (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_ytmp_view.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))), create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_Y1_view.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")))
				update_class_fields; -- Current might have been changed; synchronize
				(create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_Y1_view.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector"))).item.gsl_vector_scale (0.5 * a_h).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				gsl_vector_add (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_Y1_view.item.c_pointer + (create {PD_GSL_VECTOR_VIEW}.make).offset_of ("vector")), (create {CE_CLASS_POINTER [PD_GSL_VECTOR]}.make_shared (l_y0_view.item.c_pointer + (create {PD_GSL_VECTOR_CONST_VIEW}.make).offset_of ("vector")))).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				l_s := (a_sys.item.function).integer_32_item ([a_t + 0.5 * a_h, l_Y1, l_ytmp, a_sys.item.params])
				update_class_fields -- Current might have been changed; synchronize
				if l_s /= 0 then
					Result := l_s
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_dim)
				loop
					a_y[l_i.to_integer_32] := (l_y0___0[l_i.to_integer_32] + (a_h * l_ytmp[l_i.to_integer_32]))
					update_class_fields -- Current might have been changed; synchronize
					l_i := l_i + 1
				end
				Result := l_s
			end
		end

feature {PD_RK2SIMP_STATE_T} -- private routines

	gsl_vector_add (a_a___5, a_b___0: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		require
			not a_a___5.is_void
			not a_b___0.is_void
		local
			l_N: NATURAL_32
			l_stride_a: NATURAL_32
			l_stride_b: NATURAL_32
			l_i: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_N := a_a___5.item.size
			if a_b___0.item.size /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vectors must have same length"), ce_string ("oper_source.c"), 27, 19)
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			else
				l_stride_a := a_a___5.item.stride
				l_stride_b := a_b___0.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_N)
				loop
					a_a___5.item.data[(l_i * l_stride_a).to_integer_32] := a_a___5.item.data[(l_i * l_stride_a).to_integer_32] + (a_b___0.item.data[(l_i * l_stride_b).to_integer_32])
					l_i := l_i + 1
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	gsl_vector_const_view_array (a_base: CE_POINTER [REAL_64]; a_n: NATURAL_32): PD_GSL_VECTOR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CONST_VIEW
			l_v: PD_GSL_VECTOR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			Y1 := a_other.Y1
			y0 := a_other.y0
			y0_orig := a_other.y0_orig
			ytmp := a_other.ytmp
			dfdy := a_other.dfdy
			dfdt := a_other.dfdt
			y_onestep := a_other.y_onestep
			p := a_other.p
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				Y1.is_equal (a_other.Y1) and
				y0.is_equal (a_other.y0) and
				y0_orig.is_equal (a_other.y0_orig) and
				ytmp.is_equal (a_other.ytmp) and
				dfdy.is_equal (a_other.dfdy) and
				dfdt.is_equal (a_other.dfdt) and
				y_onestep.is_equal (a_other.y_onestep) and
				p.is_equal (a_other.p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("Y1"),
					create {CE_STRUCTURE_FIELD}.make ("y0"),
					create {CE_STRUCTURE_FIELD}.make ("y0_orig"),
					create {CE_STRUCTURE_FIELD}.make ("ytmp"),
					create {CE_STRUCTURE_FIELD}.make ("dfdy"),
					create {CE_STRUCTURE_FIELD}.make ("dfdt"),
					create {CE_STRUCTURE_FIELD}.make ("y_onestep"),
					create {CE_STRUCTURE_FIELD}.make ("p")
				>>)
			init_structure_info
		end

end
