class
	PD_SOBOL_STATE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_32_ARRAY} last_numerator_vec.make (<<40>>)
			create {CE_ARRAY_ARRAY [INTEGER_32]} v_direction.make (<<30, 40>>)
		end

feature {ANY} -- fields

	sequence_count: NATURAL_32 assign set_sequence_count

	last_denominator_inv: REAL_64 assign set_last_denominator_inv

	last_numerator_vec: CE_ARRAY [INTEGER_32]

	v_direction: CE_ARRAY [CE_ARRAY [INTEGER_32]]

feature {ANY} -- field setters

	set_sequence_count (a_sequence_count: NATURAL_32)
		do
			sequence_count := a_sequence_count
			update_memory_field ("sequence_count")
		end

	set_last_denominator_inv (a_last_denominator_inv: REAL_64)
		do
			last_denominator_inv := a_last_denominator_inv
			update_memory_field ("last_denominator_inv")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sequence_count := a_other.sequence_count
			last_denominator_inv := a_other.last_denominator_inv
			last_numerator_vec := a_other.last_numerator_vec.twin
			v_direction := a_other.v_direction.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sequence_count = a_other.sequence_count and
				last_denominator_inv = a_other.last_denominator_inv and
				last_numerator_vec.is_equal (a_other.last_numerator_vec) and
				v_direction.is_equal (a_other.v_direction)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sequence_count"),
					create {CE_STRUCTURE_FIELD}.make ("last_denominator_inv"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("last_numerator_vec", <<40>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("v_direction", <<30, 40>>)
				>>)
			init_structure_info
		end

end
