class
	PD_U5

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	d: REAL_64 assign set_d

	ieee: PD_IEEE2 assign set_ieee

feature {ANY} -- field setters

	set_d (a_d: REAL_64)
		do
			d := a_d
			update_memory_field ("d")
		end

	set_ieee (a_ieee: PD_IEEE2)
		do
			ieee := a_ieee
			update_memory_field ("ieee")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			d := a_other.d
			ieee := a_other.ieee.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				d = a_other.d and
				ieee.is_equal (a_other.ieee)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("d"),
					create {CE_STRUCTURE_FIELD}.make ("ieee")
				>>)
			init_structure_info
		end

end
