class
	S_MATH_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	acos (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return acos($a___x);"
		end

	asin (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return asin($a___x);"
		end

	atan (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return atan($a___x);"
		end

	atan2 (a___y: REAL_64; a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return atan2($a___y, $a___x);"
		end

	cos (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return cos($a___x);"
		end

	sin (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return sin($a___x);"
		end

	cosh (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return cosh($a___x);"
		end

	sinh (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return sinh($a___x);"
		end

	tanh (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return tanh($a___x);"
		end

	acosh (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return acosh($a___x);"
		end

	atanh (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return atanh($a___x);"
		end

	exp (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return exp($a___x);"
		end

	log (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return log($a___x);"
		end

	log1p (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return log1p($a___x);"
		end

	pow (a___x: REAL_64; a___y: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return pow($a___x, $a___y);"
		end

	sqrt (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return sqrt($a___x);"
		end

	hypot (a___x: REAL_64; a___y: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return hypot($a___x, $a___y);"
		end

	fabs (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return fabs($a___x);"
		end

	isnan (a___value: REAL_64): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isnan($a___value);"
		end

	isnanf (a___value: REAL_32): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isnanf($a___value);"
		end

	isnanl (a___value: REAL_96): INTEGER_32
		do
			Result := c_isnanl (a___value.c_pointer)
		end

	c_isnanl (a___value: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isnanl(*(long double *)$a___value);"
		end

	floor (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return floor($a___x);"
		end

	ceil (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return ceil($a___x);"
		end

	frexp (a___x: REAL_64; a___exponent: CE_POINTER [INTEGER_32]): REAL_64
		do
			Result := c_frexp (a___x, a___exponent.c_pointer)
		end

	c_frexp (a___x: REAL_64; a___exponent: POINTER): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return frexp($a___x, $a___exponent);"
		end

	ldexp (a___x: REAL_64; a___exponent: INTEGER_32): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return ldexp($a___x, $a___exponent);"
		end

	tan (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return tan($a___x);"
		end

	fmod (a___x: REAL_64; a___y: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return fmod($a___x, $a___y);"
		end

	finite (a___value: REAL_64): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return finite($a___value);"
		end

	isinf (a___value: REAL_64): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isinf($a___value);"
		end

	finite2 (a___value: REAL_64): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __finite($a___value);"
		end

	isinff (a___value: REAL_32): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isinff($a___value);"
		end

	finitef (a___value: REAL_32): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __finitef($a___value);"
		end

	isinfl (a___value: REAL_96): INTEGER_32
		do
			Result := c_isinfl (a___value.c_pointer)
		end

	c_isinfl (a___value: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __isinfl(*(long double *)$a___value);"
		end

	finitel (a___value: REAL_96): INTEGER_32
		do
			Result := c_finitel (a___value.c_pointer)
		end

	c_finitel (a___value: POINTER): INTEGER_32
		external
			"C inline use <libgsl.h>"
		alias
			"return __finitel(*(long double *)$a___value);"
		end

	expm1 (a___x: REAL_64): REAL_64
		external
			"C inline use <libgsl.h>"
		alias
			"return expm1($a___x);"
		end

end
