class
	P_EDIT_STATIC

inherit
	CE_UTILITIES
	S_LIBINTL_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC
	S_CTYPE_STATIC

feature {ANY} -- public attributes

	ctrl_x_msgs: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string (" Keyword completion (^N^P)"),
					ce_string (" ^X mode (^]^D^E^F^I^K^L^N^O^Ps^U^V^Y)"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					ce_string (" Whole line completion (^L^N^P)"),
					ce_string (" File name completion (^F^N^P)"),
					ce_string (" Tag completion (^]^N^P)"),
					ce_string (" Path pattern completion (^N^P)"),
					ce_string (" Definition completion (^D^N^P)"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer),
					ce_string (" Dictionary completion (^K^N^P)"),
					ce_string (" Thesaurus completion (^T^N^P)"),
					ce_string (" Command-line completion (^V^N^P)"),
					ce_string (" User defined completion (^U^N^P)"),
					ce_string (" Omni completion (^O^N^P)"),
					ce_string (" Spelling suggestion (s^N^P)"),
					ce_string (" Keyword Local completion (^N^P)")
				>>)
		end

	e_hitend: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("Hit end of paragraph%/0/")
		end

	compl_first_match: CE_STATIC [CE_POINTER [PD_COMPL_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_shared (default_pointer)
		end

	compl_curr_match: CE_STATIC [CE_POINTER [PD_COMPL_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_shared (default_pointer)
		end

	compl_shown_match: CE_STATIC [CE_POINTER [PD_COMPL_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_shared (default_pointer)
		end

	compl_enter_selects: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_leader: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	compl_get_longest: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_used_match: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	compl_was_interrupted: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_restarting: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_started: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_busy: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_matches: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_pattern: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	compl_direction: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	compl_shows_dir: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	compl_pending: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_startpos: CE_STATIC [CE_ARRAY [PD_POS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_POS_T]}.make (<<1>>)
		end

	compl_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_orig_text: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	compl_cont_mode: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	compl_xp: CE_STATIC [CE_ARRAY [PD_EXPAND]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_EXPAND]}.make (<<1>>)
		end

	spell_bad_len: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	Insstart_textlen: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	Insstart_blank_vcol: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	last_insert: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	last_insert_skip: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	new_insert_skip: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	did_restart_edit: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	can_cindent: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	old_indent: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	ins_need_undo: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	did_add_space: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	o_lnum: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	pc_status: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pc_bytes: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<22>>)
		end

	pc_attr: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make (<<1>>)
		end

	pc_row: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	pc_col: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	compl_match_array: CE_STATIC [CE_POINTER [PD_PUMITEM_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer)
		end

	compl_match_arraysize: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	wp: CE_STATIC [CE_POINTER [PD_WINDOW_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make
		end

	first_match_pos: CE_STATIC [CE_ARRAY [PD_POS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_POS_T]}.make (<<1>>)
		end

	last_match_pos: CE_STATIC [CE_ARRAY [PD_POS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_POS_T]}.make (<<1>>)
		end

	e_cpt: CE_STATIC [CE_ARRAY [CE_POINTER [NATURAL_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [NATURAL_8]}.make_initialized (<<
					create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				>>)
		end

	found_all: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	ins_buf: CE_STATIC [CE_POINTER [PD_FILE_BUFFER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
		end

	count: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	match_ref: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<81>>)
		end

	replace_stack: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	replace_stack_nr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	replace_stack_len: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	disabled_redraw: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	edit (a_cmdchar, a_startln: INTEGER_32; a_count___2: INTEGER_32): INTEGER_32
		local
			l_count___2: CE_ARRAY [INTEGER_32]
			l_c: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_lastc___0: INTEGER_32
			l_mincol: INTEGER_32
			l_i___0: INTEGER_32
			l_did_backspace: INTEGER_32
			l_line_is_white: INTEGER_32
			l_old_topline___0: CE_ARRAY [INTEGER_32]
			l_old_topfill___0: INTEGER_32
			l_inserted_space: CE_ARRAY [INTEGER_32]
			l_replaceState: INTEGER_32
			l_nomove: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___41: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_count___2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_old_topline___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_inserted_space.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2.item := a_count___2
					l_c := 0
					l_did_backspace := 1
					l_line_is_white := 0
					l_old_topline___0.item := (0).to_integer_32
					l_old_topfill___0 := -1
					l_inserted_space.item := 0
					l_replaceState := 80
					l_nomove := 0
					did_restart_edit.item := (create {P_GLOBALS_STATIC}).restart_edit.item;
					(create {P_SCREEN_STATIC}).check_for_delay (1)
					if (create {P_GLOBALS_STATIC}).sandbox.item /= 0 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_sandbox.item)))))).do_nothing
						Result := 0
						l_return := True
					end
					if not l_return and then ((create {P_GLOBALS_STATIC}).textlock.item /= 0) then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_secure.item)))))).do_nothing
						Result := 0
						l_return := True
					end
					if not l_return then
						if compl_started.item.to_boolean then
							l_tmp___1 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_secure.item)));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
							Result := 0
							l_return := True
						elseif compl_busy.item.to_boolean then
							l_tmp___1 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_secure.item)));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
							Result := 0
							l_return := True
						elseif ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_tmp___1 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_secure.item)));
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 166 -- skip if block
					end
				when 1 then -- if:
						ins_compl_clear
						if a_cmdchar /= 114 then
							if a_cmdchar /= 118 then
								if a_cmdchar = 82 then
									l_ptr := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("r"))
								elseif a_cmdchar = 86 then
									l_ptr := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("v"))
								else
									l_ptr := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("i"))
								end
								(create {P_EVAL_STATIC}).set_vim_var_string (33, l_ptr, 1);
								(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_INSERTENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
							end
						end
						if (create {P_GLOBALS_STATIC}).where_paste_started.item.lnum /= 0 then
							(create {P_GLOBALS_STATIC}).Insstart.item.item := ((create {P_GLOBALS_STATIC}).where_paste_started.item).twin
						else
							(create {P_GLOBALS_STATIC}).Insstart.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							if a_startln.to_boolean then
								(create {P_GLOBALS_STATIC}).Insstart.item.item.col := 0
							end
						end
						Insstart_textlen.item := ((create {P_CHARSET_STATIC}).linetabsize (((create {P_MEMLINE_STATIC}).ml_get_curline)))
						Insstart_blank_vcol.item := (2_147_483_647).to_integer_32
						if not ((create {P_GLOBALS_STATIC}).did_ai.item).to_boolean then
							(create {P_GLOBALS_STATIC}).ai_col.item := 0
						end
						if a_cmdchar = 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 3 then -- if:;
						(create {P_GETCHAR_STATIC}).ResetRedobuff;
						(create {P_GETCHAR_STATIC}).AppendNumberToRedobuff (l_count___2.item)
						if a_cmdchar /= 86 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_cmdchar /= 118 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:;
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (('g').code)
						if a_cmdchar = 118 then
							l_tmp___5 := ('r').code
						else
							l_tmp___5 := ('R').code
						end
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (l_tmp___5)
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:;
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_cmdchar)
						if a_cmdchar = 103 then
							(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (('I').code)
						elseif a_cmdchar = 114 then
							l_count___2.item := 1
						end
				when 10 then -- if done | if done | if done
						if a_cmdchar = 82 then
							(create {P_GLOBALS_STATIC}).State.item := 80
						elseif a_cmdchar = 86 then
							(create {P_GLOBALS_STATIC}).State.item := 208
							l_replaceState := 208;
							(create {P_GLOBALS_STATIC}).orig_line_count.item := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count).to_integer_32;
							(create {P_GLOBALS_STATIC}).vr_lines_changed.item := 1
						elseif a_cmdchar = 118 then
							(create {P_GLOBALS_STATIC}).State.item := 208
							l_replaceState := 208;
							(create {P_GLOBALS_STATIC}).orig_line_count.item := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count).to_integer_32;
							(create {P_GLOBALS_STATIC}).vr_lines_changed.item := 1
						else
							(create {P_GLOBALS_STATIC}).State.item := 16
						end
						(create {P_GLOBALS_STATIC}).stop_insert_mode.item := 0;
						(create {P_MOVE_STATIC}).curs_columns (1)
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert = 1 then
							(create {P_GLOBALS_STATIC}).State.item := ((create {P_GLOBALS_STATIC}).State.item).bit_or ((32))
						end
						(create {P_MBYTE_STATIC}).im_set_active (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert = 2).to_integer);
						(create {P_TERM_STATIC}).setmouse;
						(create {P_NORMAL_STATIC}).clear_showcmd
						if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 11 then -- if:
						if not (((create {P_GETCHAR_STATIC}).stuff_empty).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 12 then -- if:
						if ((create {P_GLOBALS_STATIC}).where_paste_started.item.lnum).to_boolean then
							(create {P_GLOBALS_STATIC}).arrow_used.item := 0
						else
							(create {P_GLOBALS_STATIC}).arrow_used.item := 1
						end
						(create {P_GLOBALS_STATIC}).restart_edit.item := 0;
						(create {P_MOVE_STATIC}).validate_virtcol;
						(create {P_MOVE_STATIC}).update_curswant
						if not (((create {P_GLOBALS_STATIC}).ins_at_eol.item).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = o_lnum.item then
							l_pos := -1 + 16 -- goto _L___0
						else
							l_pos := -1 + 15 -- goto _L___1
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 15 then -- else: | _L___1:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant > (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol) then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L___0:
						l_ptr := ((create {P_MEMLINE_STATIC}).ml_get_curline) + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						if (l_ptr.item).to_integer_32 /= 0 then
							if (l_ptr[1]).to_integer_32 = 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_i___0 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
								if (l_ptr[l_i___0]).to_integer_32 = 0 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + l_i___0
								end
							end
						end
				when 17 then -- if done;
						(create {P_GLOBALS_STATIC}).ins_at_eol.item := 0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:;
						(create {P_GLOBALS_STATIC}).arrow_used.item := 0
				when 20 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:;
						(create {P_GLOBALS_STATIC}).arrow_used.item := 0
				when 22 then -- if done;
						(create {P_GLOBALS_STATIC}).need_start_insertmode.item := 0
						ins_need_undo.item := 1;
						(create {P_GLOBALS_STATIC}).where_paste_started.item.lnum := (0).to_integer_32
						can_cindent.item := 1
						if not ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
							if did_restart_edit.item = 0 then
								(create {P_FOLD_STATIC}).foldOpenCursor
							end
						end
						l_i___0 := 0
						if ((create {P_OPTION_STATIC}).p_smd.item.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
								l_i___0 := (create {P_SCREEN_STATIC}).showmode
							end
						end
						if not ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
							if did_restart_edit.item = 0 then
								if l_i___0 = 0 then
									l_tmp___8 := 0
								else
									l_tmp___8 := l_i___0 + 1
								end
								(create {P_MISC1_STATIC}).change_warning (l_tmp___8)
							end
						end
						(create {P_UI_STATIC}).ui_cursor_shape;
						(create {P_DIGRAPH_STATIC}).do_digraph (-1).do_nothing
						l_ptr := (create {P_GETCHAR_STATIC}).get_inserted
						if l_ptr.is_void then
							new_insert_skip.item := 0
						else
							new_insert_skip.item := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr))
						end
						old_indent.item := 0
				when 23 then -- loop condition:
						if (l_return) then
							l_pos := -1 + 166 -- skip loop
						end
				when 24 then -- loop body:
						l_continue := False
						if ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
							l_count___2.item := 0
						end
						if ((create {P_GLOBALS_STATIC}).stop_insert_mode.item).to_boolean then
							l_count___2.item := 0
							l_pos := -1 + 76 -- goto doESCkey
						end
				when 25 then
						if not ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
						end
						if ((create {P_GETCHAR_STATIC}).stuff_empty).to_boolean then
							(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 0
							if ((create {P_GLOBALS_STATIC}).need_check_timestamps.item).to_boolean then
								(create {P_FILEIO_STATIC}).check_timestamps (0).do_nothing
							end
						end
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
						if ((create {P_GLOBALS_STATIC}).need_mouse_correct.item).to_boolean then
							(create {P_GUI_STATIC}).gui_mouse_correct
						end
						if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 256)).to_boolean then
							(create {P_FOLD_STATIC}).foldOpenCursor
						end
						if not ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
							(create {P_FOLD_STATIC}).foldCheckClose
						end
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_mod_set).to_boolean) then
							l_pos := -1 + 37 -- skip if block
						end
				when 26 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean) then
							l_pos := -1 + 37 -- skip if block
						end
				when 27 then -- if:
						if l_did_backspace.to_boolean then
							l_pos := -1 + 37 -- skip if block
						end
				when 28 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline /= l_old_topline___0.item then
							l_pos := -1 + 37 -- skip if block
						end
				when 29 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill /= l_old_topfill___0 then
							l_pos := -1 + 37 -- skip if block
						end
				when 30 then -- if:
						l_mincol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol;
						(create {P_MOVE_STATIC}).validate_cursor_col
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol).to_integer_32 < l_mincol.to_integer_32 - (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts) then
							l_pos := -1 + 37 -- skip if block
						end
				when 31 then -- if:
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow).to_integer_32 /= (((create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow + (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) - 1).to_integer_32 - (create {P_OPTION_STATIC}).p_so.item.item then
							l_pos := -1 + 37 -- skip if block
						end
				when 32 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___2
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 35 then -- else:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill > 0) then
							l_pos := -1 + 37 -- skip if block
						end
				when 36 then -- if: | _L___2:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill > 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill) - 1
						elseif ((create {P_FOLD_STATIC}).hasFolding ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_old_topline___0)).to_boolean then
							((create {P_GLOBALS_STATIC}).curwin.item).item.set_topline (l_old_topline___0.item + 1)
						else
							((create {P_GLOBALS_STATIC}).curwin.item).item.set_topline ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline + 1)
						end
				when 37 then -- if done | if done | if done | if done | if done | if done | if done | if done;
						(create {P_MOVE_STATIC}).update_topline
						l_did_backspace := 0;
						(create {P_MOVE_STATIC}).validate_cursor
						ins_redraw (1)
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb).to_boolean then
							(create {P_NORMAL_STATIC}).do_check_scrollbind (1)
						end
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_crb).to_boolean then
							(create {P_MOVE_STATIC}).do_check_cursorbind
						end
						(create {P_MOVE_STATIC}).update_curswant
						l_old_topline___0.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
						l_old_topfill___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill;
						(create {P_GLOBALS_STATIC}).dont_scroll.item := 0
						l_lastc___0 := l_c
						from
						until
							(l_break)
						loop
							l_break := False
							l_c := (create {P_GETCHAR_STATIC}).safe_vgetc
							if l_c /= -(253 + ((53).bit_shift_left (8))) then
								l_break := True
							end
						end
						l_break := False;
						(create {P_GLOBALS_STATIC}).did_cursorhold.item := 1
						if not (compl_started.item.to_boolean) then
							l_pos := -1 + 50 -- skip if block
						end
				when 38 then -- if:
						if not ((pum_wanted).to_boolean) then
							l_pos := -1 + 50 -- skip if block
						end
				when 39 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col >= compl_col.item) then
							l_pos := -1 + 50 -- skip if block
						end
				when 40 then -- if:
						if not (compl_shown_match.item.is_void) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_pos := -1 + 44 -- goto _L___4
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 43 then -- else:
						if compl_shown_match.item.is_equal (compl_shown_match.item.item.cp_next) then
							l_pos := -1 + 50 -- skip if block
						end
				when 44 then -- if: | _L___4:
						if l_c /= -(107 + ((98).bit_shift_left (8))) then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						l_pos := -1 + 48 -- goto _L___3
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 47 then -- else:
						if l_c /= 8 then
							l_pos := -1 + 49 -- skip if block
						end
				when 48 then -- if: | _L___3:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > compl_col.item then
							l_c := ins_compl_bs
							if l_c = 0 then
								l_continue := True
							end
						end
				when 49 then -- if done
						if not (l_return or l_break or l_continue) and then (not compl_used_match.item.to_boolean) then
							if l_c = 12 then
								if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
									ins_compl_addfrommatch
									l_continue := True
								elseif (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_shown_match.item.item.cp_str))).to_integer_32 > (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - compl_col.item then
									ins_compl_addfrommatch
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								if (ins_compl_accept_char (l_c)).to_boolean then
									ins_compl_addleader (l_c)
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								if l_c = 25 then
									ins_compl_delete
									ins_compl_insert
								elseif compl_enter_selects.item.to_boolean then
									if l_c = 13 then
										ins_compl_delete
										ins_compl_insert
									elseif l_c = -(75 + ((65).bit_shift_left (8))) then
										ins_compl_delete
										ins_compl_insert
									elseif l_c = 10 then
										ins_compl_delete
										ins_compl_insert
									end
								end
							end
						end
				when 50 then -- if done | if done | if done | if done
						if not (l_return or l_break or l_continue) then
							compl_get_longest.item := 0
							if (ins_compl_prep (l_c)).to_boolean then
								l_continue := True
							end
						end
						if not (not (l_return or l_break or l_continue) and then (l_c = 28)) then
							l_pos := -1 + 58 -- skip if block
						end
				when 51 then -- if:
						ins_redraw (0);
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1;
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
						l_c := (create {P_GETCHAR_STATIC}).plain_vgetc;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
						if l_c = 14 then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						if l_c /= 7 then
							if l_c /= 15 then
								(create {P_GETCHAR_STATIC}).vungetc (l_c)
								l_c := 28
							else
								l_pos := -1 + 54 -- goto _L___7
							end
						else
							l_pos := -1 + 54 -- goto _L___7
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 54 then -- else: | _L___7:
						if l_c /= 7 then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
							l_continue := True
						else
							l_pos := -1 + 57 -- goto _L___5
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else: | _L___5:
						if l_c = 15 then
							ins_ctrl_o;
							(create {P_GLOBALS_STATIC}).ins_at_eol.item := 0
							l_nomove := 1
						end
						l_count___2.item := 0
						l_pos := -1 + 76 -- goto doESCkey
				when 58 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 65 -- skip if block
						end
				when 59 then -- if:
						l_c := (create {P_DIGRAPH_STATIC}).do_digraph (l_c)
						if l_c /= 22 then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						l_pos := -1 + 63 -- goto _L___8
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 64
				when 62 then -- else:
						if l_c /= 17 then
							l_pos := -1 + 64 -- skip if block
						end
				when 63 then -- if: | _L___8:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 11 then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 64 then -- if done
						if l_c = 22 then
							ins_ctrl_v
							l_c := 22
							l_continue := True
						elseif l_c = 17 then
							ins_ctrl_v
							l_c := 22
							l_continue := True
						end
				when 65 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 71 -- skip if block
						end
				when 66 then -- if:
						if not ((cindent_on).to_boolean) then
							l_pos := -1 + 70 -- skip if block
						end
				when 67 then -- if:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_line_is_white := (create {P_MISC1_STATIC}).inindent (0)
						if (in_cinkeys (l_c, ('!').code, l_line_is_white)).to_boolean then
							l_pos := -1 + 164 -- goto force_cindent
						end
				when 69 then
						if can_cindent.item.to_boolean then
							if (in_cinkeys (l_c, ('*').code, l_line_is_white)).to_boolean then
								if (stop_arrow) = 1 then
									(create {P_MISC1_STATIC}).do_c_expr_indent
								end
							end
						end
				when 70 then -- if done | if done
						if (ins_start_select (l_c)).to_boolean then
							l_continue := True
						end
				when 71 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 160 -- skip if block
						end
				when 72 then -- if:
						inspect l_c -- switch 1 head
						when 27 then l_pos := -1 + 73
						when 3 then l_pos := -1 + 74
						when 26 then l_pos := -1 + 77
						when 15 then l_pos := -1 + 80
						when -18795 then l_pos := -1 + 84 -- -(107 + ((73).bit_shift_left (8)))
						when -20477 then l_pos := -1 + 84 -- -(253 + ((79).bit_shift_left (8)))
						when -22773 then l_pos := -1 + 85 -- -(245 + ((88).bit_shift_left (8)))
						when -12581 then l_pos := -1 + 86 -- -(37 + ((49).bit_shift_left (8)))
						when -12651 then l_pos := -1 + 86 -- -(107 + ((49).bit_shift_left (8)))
						when -14845 then l_pos := -1 + 86 -- -(253 + ((57).bit_shift_left (8)))
						when -16966 then l_pos := -1 + 87 -- -(70 + ((66).bit_shift_left (8)))
						when -22783 then l_pos := -1 + 88 -- -(255 + ((88).bit_shift_left (8)))
						when 0 then l_pos := -1 + 88
						when 1 then l_pos := -1 + 88
						when 18 then l_pos := -1 + 90
						when 7 then l_pos := -1 + 91
						when 30 then l_pos := -1 + 92
						when 4 then l_pos := -1 + 93
						when 20 then l_pos := -1 + 94
						when -17515 then l_pos := -1 + 99 -- -(107 + ((68).bit_shift_left (8)))
						when -20733 then l_pos := -1 + 99 -- -(253 + ((80).bit_shift_left (8)))
						when -25195 then l_pos := -1 + 100 -- -(107 + ((98).bit_shift_left (8)))
						when 8 then l_pos := -1 + 100
						when 23 then l_pos := -1 + 101
						when 21 then l_pos := -1 + 102
						when -11517 then l_pos := -1 + 104 -- -(253 + ((44).bit_shift_left (8)))
						when -17917 then l_pos := -1 + 104 -- -(253 + ((69).bit_shift_left (8)))
						when -11773 then l_pos := -1 + 104 -- -(253 + ((45).bit_shift_left (8)))
						when -12029 then l_pos := -1 + 104 -- -(253 + ((46).bit_shift_left (8)))
						when -18173 then l_pos := -1 + 104 -- -(253 + ((70).bit_shift_left (8)))
						when -12285 then l_pos := -1 + 104 -- -(253 + ((47).bit_shift_left (8)))
						when -12541 then l_pos := -1 + 104 -- -(253 + ((48).bit_shift_left (8)))
						when -12797 then l_pos := -1 + 104 -- -(253 + ((49).bit_shift_left (8)))
						when -13053 then l_pos := -1 + 104 -- -(253 + ((50).bit_shift_left (8)))
						when -13309 then l_pos := -1 + 104 -- -(253 + ((51).bit_shift_left (8)))
						when -13565 then l_pos := -1 + 104 -- -(253 + ((52).bit_shift_left (8)))
						when -23037 then l_pos := -1 + 104 -- -(253 + ((89).bit_shift_left (8)))
						when -23293 then l_pos := -1 + 104 -- -(253 + ((90).bit_shift_left (8)))
						when -23549 then l_pos := -1 + 104 -- -(253 + ((91).bit_shift_left (8)))
						when -23805 then l_pos := -1 + 104 -- -(253 + ((92).bit_shift_left (8)))
						when -24061 then l_pos := -1 + 104 -- -(253 + ((93).bit_shift_left (8)))
						when -24317 then l_pos := -1 + 104 -- -(253 + ((94).bit_shift_left (8)))
						when -19453 then l_pos := -1 + 105 -- -(253 + ((75).bit_shift_left (8)))
						when -19709 then l_pos := -1 + 106 -- -(253 + ((76).bit_shift_left (8)))
						when -19965 then l_pos := -1 + 107 -- -(253 + ((77).bit_shift_left (8)))
						when -20221 then l_pos := -1 + 108 -- -(253 + ((78).bit_shift_left (8)))
						when -22768 then l_pos := -1 + 109 -- -(240 + ((88).bit_shift_left (8)))
						when -22767 then l_pos := -1 + 109 -- -(239 + ((88).bit_shift_left (8)))
						when -13821 then l_pos := -1 + 110 -- -(253 + ((53).bit_shift_left (8)))
						when -24829 then l_pos := -1 + 111 -- -(253 + ((96).bit_shift_left (8)))
						when -22777 then l_pos := -1 + 112 -- -(249 + ((88).bit_shift_left (8)))
						when -22776 then l_pos := -1 + 113 -- -(248 + ((88).bit_shift_left (8)))
						when -26731 then l_pos := -1 + 114 -- -(107 + ((104).bit_shift_left (8)))
						when -12619 then l_pos := -1 + 114 -- -(75 + ((49).bit_shift_left (8)))
						when -12835 then l_pos := -1 + 114 -- -(35 + ((50).bit_shift_left (8)))
						when -22525 then l_pos := -1 + 114 -- -(253 + ((87).bit_shift_left (8)))
						when -14144 then l_pos := -1 + 115 -- -(64 + ((55).bit_shift_left (8)))
						when -13387 then l_pos := -1 + 115 -- -(75 + ((52).bit_shift_left (8)))
						when -14122 then l_pos := -1 + 115 -- -(42 + ((55).bit_shift_left (8)))
						when -22781 then l_pos := -1 + 115 -- -(253 + ((88).bit_shift_left (8)))
						when -27755 then l_pos := -1 + 116 -- -(107 + ((108).bit_shift_left (8)))
						when -13347 then l_pos := -1 + 117 -- -(35 + ((52).bit_shift_left (8)))
						when -22013 then l_pos := -1 + 117 -- -(253 + ((85).bit_shift_left (8)))
						when -29291 then l_pos := -1 + 118 -- -(107 + ((114).bit_shift_left (8)))
						when -26917 then l_pos := -1 + 119 -- -(37 + ((105).bit_shift_left (8)))
						when -22269 then l_pos := -1 + 119 -- -(253 + ((86).bit_shift_left (8)))
						when -30059 then l_pos := -1 + 120 -- -(107 + ((117).bit_shift_left (8)))
						when -1277 then l_pos := -1 + 122 -- -(253 + ((4).bit_shift_left (8)))
						when -20587 then l_pos := -1 + 122 -- -(107 + ((80).bit_shift_left (8)))
						when -13131 then l_pos := -1 + 122 -- -(75 + ((51).bit_shift_left (8)))
						when -25707 then l_pos := -1 + 124 -- -(107 + ((100).bit_shift_left (8)))
						when -1533 then l_pos := -1 + 126 -- -(253 + ((5).bit_shift_left (8)))
						when -20075 then l_pos := -1 + 126 -- -(107 + ((78).bit_shift_left (8)))
						when -13643 then l_pos := -1 + 126 -- -(75 + ((53).bit_shift_left (8)))
						when -24573 then l_pos := -1 + 128 -- -(253 + ((95).bit_shift_left (8)))
						when -17003 then l_pos := -1 + 129 -- -(107 + ((66).bit_shift_left (8)))
						when 9 then l_pos := -1 + 130
						when -16715 then l_pos := -1 + 133 -- -(75 + ((65).bit_shift_left (8)))
						when 13 then l_pos := -1 + 134
						when 10 then l_pos := -1 + 134
						when 11 then l_pos := -1 + 138
						when 24 then l_pos := -1 + 143
						when 29 then l_pos := -1 + 144
						when 6 then l_pos := -1 + 146
						when 115 then l_pos := -1 + 148
						when 19 then l_pos := -1 + 148
						when 12 then l_pos := -1 + 150
						when 16 then l_pos := -1 + 155
						when 14 then l_pos := -1 + 155
						when 25 then l_pos := -1 + 157
						when 5 then l_pos := -1 + 157
						else l_pos := -1 + 158
						end
				when 73 then -- switch 1, case 27
						if (echeck_abbr (283)).to_boolean then
							l_pos := -1 + 160 -- switch 1; break
						end
				when 74 then -- switch 1, case 3
						if l_c = 3 then
							if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
								(create {P_GLOBALS_STATIC}).cmdwin_result.item := -(253 + ((53).bit_shift_left (8)));
								(create {P_GLOBALS_STATIC}).got_int.item := 0
								l_nomove := 1
								l_pos := -1 + 76 -- goto doESCkey
							end
						end
				when 75 then -- do_intr:
						if ((create {P_MISC1_STATIC}).goto_im).to_boolean then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								(create {P_GETCHAR_STATIC}).vgetc.do_nothing;
								(create {P_GLOBALS_STATIC}).got_int.item := 0
							else
								(create {P_MISC1_STATIC}).vim_beep
							end
							l_pos := -1 + 160 -- switch 1; break
						end
				when 76 then -- doESCkey:
						if ((create {P_GLOBALS_STATIC}).ins_at_eol.item).to_boolean then
							if ((create {P_MISC1_STATIC}).gchar_cursor) = 0 then
								o_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							end
						end
						if (ins_esc (l_count___2, a_cmdchar, l_nomove)).to_boolean then
							if a_cmdchar /= 114 then
								if a_cmdchar /= 118 then
									(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_INSERTLEAVE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
								end
							end
							(create {P_GLOBALS_STATIC}).did_cursorhold.item := 0
							Result := (l_c = 15).to_integer
							l_return := True
						end
						if not l_return then
							l_continue := True
						end
				when 77 then -- switch 1, case 26
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if not ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
							l_pos := -1 + 159 -- goto normalchar
						end
				when 79 then;
						(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":st%R")))
						l_c := 15
				when 80 then -- switch 1, case 15
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 84 -- skip if block
						end
				when 81 then -- if:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 13 then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 82 then
						if (echeck_abbr (271)).to_boolean then
							l_pos := -1 + 160 -- switch 1; break
						end
				when 83 then
						ins_ctrl_o
						if (((create {P_OPTION_STATIC}).ve_flags.item.item).bit_and ({NATURAL_32} 8)).to_boolean then
							(create {P_GLOBALS_STATIC}).ins_at_eol.item := 0
							l_nomove := 1
						end
						l_count___2.item := 0
						l_pos := -1 + 76 -- goto doESCkey
				when 84 then -- switch 1, case -(107 + (73 << 8)) | switch 1, case -(253 + (79 << 8))
						if not (l_return or l_break or l_continue) then
							ins_insert (l_replaceState)
						end
						l_pos := -1 + 160 -- switch 1; break
				when 85 then -- switch 1, case -(245 + (88 << 8))
						l_pos := -1 + 160 -- switch 1; break
				when 86 then -- switch 1, case -(37 + (49 << 8)) | switch 1, case -(107 + (49 << 8)) | switch 1, case -(253 + (57 << 8));
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (-(37 + ((49).bit_shift_left (8))))
						if ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
							(create {P_GLOBALS_STATIC}).need_start_insertmode.item := 1
						end
						l_pos := -1 + 76 -- goto doESCkey
				when 87 then -- switch 1, case -(70 + (66 << 8));
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
						l_i___0 := (create {P_GETCHAR_STATIC}).plain_vgetc;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
						(create {P_NETBEANS_STATIC}).netbeans_keycommand (l_i___0).do_nothing
						l_pos := -1 + 160 -- switch 1; break
				when 88 then -- switch 1, case -(255 + (88 << 8)) | switch 1, case 0 | switch 1, case 1
						if (stuff_inserted (('%/0/').code, 1, (l_c = 1).to_integer)) = 0 then
							if l_c /= 1 then
								if not ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
									l_pos := -1 + 76 -- goto doESCkey
								end
							end
						end
				when 89 then
						l_inserted_space.item := 0
						l_pos := -1 + 160 -- switch 1; break
				when 90 then -- switch 1, case 18
						ins_reg
						auto_format (0, 1)
						l_inserted_space.item := 0
						l_pos := -1 + 160 -- switch 1; break
				when 91 then -- switch 1, case 7
						ins_ctrl_g
						l_pos := -1 + 160 -- switch 1; break
				when 92 then -- switch 1, case 30
						ins_ctrl_hat
						l_pos := -1 + 160 -- switch 1; break
				when 93 then -- switch 1, case 4
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 263 then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 94 then -- switch 1, case 20
						if l_c /= 20 then
							l_pos := -1 + 98 -- skip if block
						end
				when 95 then -- if:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 266 then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						if (has_compl_option (0)).to_boolean then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 97 then
						l_pos := -1 + 160 -- switch 1; break
				when 98 then -- if done
						ins_shift (l_c, l_lastc___0)
						auto_format (0, 1)
						l_inserted_space.item := 0
						l_pos := -1 + 160 -- switch 1; break
				when 99 then -- switch 1, case -(107 + (68 << 8)) | switch 1, case -(253 + (80 << 8))
						ins_del
						auto_format (0, 1)
						l_pos := -1 + 160 -- switch 1; break
				when 100 then -- switch 1, case -(107 + (98 << 8)) | switch 1, case 8
						l_did_backspace := ins_bs (l_c, 1, l_inserted_space)
						auto_format (0, 1)
						l_pos := -1 + 160 -- switch 1; break
				when 101 then -- switch 1, case 23
						l_did_backspace := ins_bs (l_c, 2, l_inserted_space)
						auto_format (0, 1)
						l_pos := -1 + 160 -- switch 1; break
				when 102 then -- switch 1, case 21
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 12 then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 103 then
						l_did_backspace := ins_bs (l_c, 4, l_inserted_space)
						auto_format (0, 1)
						l_inserted_space.item := 0
						l_pos := -1 + 160 -- switch 1; break
				when 104 then -- switch 1, case -(253 + (44 << 8)) | switch 1, case -(253 + (69 << 8)) | switch 1, case -(253 + (45 << 8)) | switch 1, case -(253 + (46 << 8)) | switch 1, case -(253 + (70 << 8)) | switch 1, case -(253 + (47 << 8)) | switch 1, case -(253 + (48 << 8)) | switch 1, case -(253 + (49 << 8)) | switch 1, case -(253 + (50 << 8)) | switch 1, case -(253 + (51 << 8)) | switch 1, case -(253 + (52 << 8)) | switch 1, case -(253 + (89 << 8)) | switch 1, case -(253 + (90 << 8)) | switch 1, case -(253 + (91 << 8)) | switch 1, case -(253 + (92 << 8)) | switch 1, case -(253 + (93 << 8)) | switch 1, case -(253 + (94 << 8))
						ins_mouse (l_c)
						l_pos := -1 + 160 -- switch 1; break
				when 105 then -- switch 1, case -(253 + (75 << 8))
						ins_mousescroll (0)
						l_pos := -1 + 160 -- switch 1; break
				when 106 then -- switch 1, case -(253 + (76 << 8))
						ins_mousescroll (1)
						l_pos := -1 + 160 -- switch 1; break
				when 107 then -- switch 1, case -(253 + (77 << 8))
						ins_mousescroll (-1)
						l_pos := -1 + 160 -- switch 1; break
				when 108 then -- switch 1, case -(253 + (78 << 8))
						ins_mousescroll (-2)
						l_pos := -1 + 160 -- switch 1; break
				when 109 then -- switch 1, case -(240 + (88 << 8)) | switch 1, case -(239 + (88 << 8))
						ins_tabline (l_c)
						l_pos := -1 + 160 -- switch 1; break
				when 110 then -- switch 1, case -(253 + (53 << 8))
						l_pos := -1 + 160 -- switch 1; break
				when 111 then -- switch 1, case -(253 + (96 << 8));
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_CURSORHOLDI, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing;
						(create {P_GLOBALS_STATIC}).did_cursorhold.item := 1
						l_pos := -1 + 160 -- switch 1; break
				when 112 then -- switch 1, case -(249 + (88 << 8))
						ins_scroll
						l_pos := -1 + 160 -- switch 1; break
				when 113 then -- switch 1, case -(248 + (88 << 8))
						ins_horscroll
						l_pos := -1 + 160 -- switch 1; break
				when 114 then -- switch 1, case -(107 + (104 << 8)) | switch 1, case -(75 + (49 << 8)) | switch 1, case -(35 + (50 << 8)) | switch 1, case -(253 + (87 << 8))
						ins_home (l_c)
						l_pos := -1 + 160 -- switch 1; break
				when 115 then -- switch 1, case -(64 + (55 << 8)) | switch 1, case -(75 + (52 << 8)) | switch 1, case -(42 + (55 << 8)) | switch 1, case -(253 + (88 << 8))
						ins_end (l_c)
						l_pos := -1 + 160 -- switch 1; break
				when 116 then -- switch 1, case -(107 + (108 << 8))
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean then
							ins_s_left
						else
							ins_left
						end
						l_pos := -1 + 160 -- switch 1; break
				when 117 then -- switch 1, case -(35 + (52 << 8)) | switch 1, case -(253 + (85 << 8))
						ins_s_left
						l_pos := -1 + 160 -- switch 1; break
				when 118 then -- switch 1, case -(107 + (114 << 8))
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean then
							ins_s_right
						else
							ins_right
						end
						l_pos := -1 + 160 -- switch 1; break
				when 119 then -- switch 1, case -(37 + (105 << 8)) | switch 1, case -(253 + (86 << 8))
						ins_s_right
						l_pos := -1 + 160 -- switch 1; break
				when 120 then -- switch 1, case -(107 + (117 << 8))
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 121 then
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean then
							ins_pageup
						else
							ins_up (0)
						end
						l_pos := -1 + 160 -- switch 1; break
				when 122 then -- switch 1, case -(253 + (4 << 8)) | switch 1, case -(107 + (80 << 8)) | switch 1, case -(75 + (51 << 8))
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 123 then
						ins_pageup
						l_pos := -1 + 160 -- switch 1; break
				when 124 then -- switch 1, case -(107 + (100 << 8))
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 125 then
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean then
							ins_pagedown
						else
							ins_down (0)
						end
						l_pos := -1 + 160 -- switch 1; break
				when 126 then -- switch 1, case -(253 + (5 << 8)) | switch 1, case -(107 + (78 << 8)) | switch 1, case -(75 + (53 << 8))
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 127 then
						ins_pagedown
						l_pos := -1 + 160 -- switch 1; break
				when 128 then -- switch 1, case -(253 + (95 << 8))
						ins_drop
						l_pos := -1 + 160 -- switch 1; break
				when 129 then -- switch 1, case -(107 + (66 << 8))
						l_c := ('%T').code
				when 130 then -- switch 1, case 9
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 262 then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 131 then
						l_inserted_space.item := 0
						if (ins_tab).to_boolean then
							l_pos := -1 + 159 -- goto normalchar
						end
				when 132 then
						auto_format (0, 1)
						l_pos := -1 + 160 -- switch 1; break
				when 133 then -- switch 1, case -(75 + (65 << 8))
						l_c := ('%R').code
				when 134 then -- switch 1, case 13 | switch 1, case 10
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_quickfix).to_boolean then
							if l_c = 13 then
								if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_llist_ref).is_void then
									(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".cc"))).do_nothing
								else
									(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".ll"))).do_nothing
								end
								l_pos := -1 + 160 -- switch 1; break
							end
						end
				when 135 then
						if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
							(create {P_GLOBALS_STATIC}).cmdwin_result.item := ('%R').code
							l_pos := -1 + 76 -- goto doESCkey
						end
				when 136 then
						if (ins_eol (l_c)).to_boolean then
							if not ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
								l_pos := -1 + 76 -- goto doESCkey
							end
						end
				when 137 then
						auto_format (0, 0)
						l_inserted_space.item := 0
						l_pos := -1 + 160 -- switch 1; break
				when 138 then -- switch 1, case 11
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 265 then
							l_pos := -1 + 141 -- skip if block
						end
				when 139 then -- if:
						if (has_compl_option (1)).to_boolean then
							l_pos := -1 + 156 -- goto docomplete
						end
				when 140 then
						l_pos := -1 + 160 -- switch 1; break
				when 141 then
						l_c := ins_digraph
						if l_c = 0 then
							l_pos := -1 + 160 -- switch 1; break
						end
				when 142 then
						l_pos := -1 + 159 -- goto normalchar
				when 143 then -- switch 1, case 24
						ins_ctrl_x
						l_pos := -1 + 160 -- switch 1; break
				when 144 then -- switch 1, case 29
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 261 then
							l_pos := -1 + 159 -- goto normalchar
						end
				when 145 then
						l_pos := -1 + 156 -- goto docomplete
				when 146 then -- switch 1, case 6
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 4 then
							l_pos := -1 + 159 -- goto normalchar
						end
				when 147 then
						l_pos := -1 + 156 -- goto docomplete
				when 148 then -- switch 1, case 115 | switch 1, case 19
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 14 then
							l_pos := -1 + 159 -- goto normalchar
						end
				when 149 then
						l_pos := -1 + 156 -- goto docomplete
				when 150 then -- switch 1, case 12
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 3 then
							l_pos := -1 + 155 -- skip if block
						end
				when 151 then -- if:
						if not (((create {P_OPTION_STATIC}).p_im.item.item).to_boolean) then
							l_pos := -1 + 154 -- skip if block
						end
				when 152 then -- if:
						if (echeck_abbr (268)).to_boolean then
							l_pos := -1 + 160 -- switch 1; break
						end
				when 153 then
						l_pos := -1 + 76 -- goto doESCkey
				when 154 then
						l_pos := -1 + 159 -- goto normalchar
				when 155 then -- switch 1, case 16 | switch 1, case 14
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cpt).item).to_integer_32 = 0 then
							if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
								if not (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (32)).to_boolean then
									l_pos := -1 + 159 -- goto normalchar
								end
							end
						end
				when 156 then -- docomplete:
						compl_busy.item := 1
						if (ins_complete (l_c)) = 0 then
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
						end
						compl_busy.item := 0
						l_pos := -1 + 160 -- switch 1; break
				when 157 then -- switch 1, case 25 | switch 1, case 5
						l_c := ins_ctrl_ey (l_c)
						l_pos := -1 + 160 -- switch 1; break
				when 158 then -- switch 1, default:
						if l_c = (create {P_GLOBALS_STATIC}).intr_char.item then
							l_pos := -1 + 75 -- goto do_intr
						end
				when 159 then -- normalchar:
						ins_try_si (l_c)
						if l_c = 32 then
							l_inserted_space.item := 1
							if ((create {P_MISC1_STATIC}).inindent (0)).to_boolean then
								can_cindent.item := 0
							end
							if Insstart_blank_vcol.item.to_integer_32 = 2_147_483_647 then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
									Insstart_blank_vcol.item := get_nolist_virtcol
								end
							end
						end
						if ((create {P_CHARSET_STATIC}).vim_iswordc (l_c)).to_boolean then
							insert_special (l_c, 0, 0)
						else
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								if l_c >= 256 then
									l_tmp___41 := l_c + 256
								else
									l_tmp___41 := l_c
								end
							else
								l_tmp___41 := l_c
							end
							if not (echeck_abbr (l_tmp___41)).to_boolean then
								insert_special (l_c, 0, 0)
							end
						end
						auto_format (0, 1);
						(create {P_FOLD_STATIC}).foldOpenCursor
						l_pos := -1 + 160 -- switch 1; break
				when 160 then -- switch 1, done: | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 165 -- skip if block
						end
				when 161 then -- if:
						if l_c /= -(253 + ((96).bit_shift_left (8))) then
							(create {P_GLOBALS_STATIC}).did_cursorhold.item := 0
						end
						if ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
							l_inserted_space.item := 0
						end
						if not (can_cindent.item.to_boolean) then
							l_pos := -1 + 165 -- skip if block
						end
				when 162 then -- if:
						if not ((cindent_on).to_boolean) then
							l_pos := -1 + 165 -- skip if block
						end
				when 163 then -- if:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
							l_pos := -1 + 165 -- skip if block
						end
				when 164 then -- if: | force_cindent:
						if (in_cinkeys (l_c, (' ').code, l_line_is_white)).to_boolean then
							if (stop_arrow) = 1 then
								(create {P_MISC1_STATIC}).do_c_expr_indent
							end
						end
				when 165 then -- if done | if done | if done | if done
						if (not l_return) then
							
						end
						l_pos := -1 + 23 -- back to loop condition
				when 166 then -- loop done | if done
					if not l_return then
						l_continue := False
					end
				when 167 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_redraw (a_ready: INTEGER_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if not (a_ready.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if not (((create {P_FILEIO_STATIC}).has_cursormovedI).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 3 then -- if:
						if (create {P_GLOBALS_STATIC}).last_cursormoved.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (create {P_GLOBALS_STATIC}).last_cursormoved.item.col = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
							if (create {P_GLOBALS_STATIC}).last_cursormoved.item.coladd /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd then
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if not ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							if (((create {P_GLOBALS_STATIC}).curwin.item).item.syntax_present).to_boolean then
								if ((create {P_GLOBALS_STATIC}).must_redraw.item).to_boolean then
									(create {P_SCREEN_STATIC}).update_screen (0)
								end
							end
							if ((create {P_FILEIO_STATIC}).has_cursormovedI).to_boolean then
								(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_CURSORMOVEDI, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
							end
							(create {P_GLOBALS_STATIC}).last_cursormoved.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						end
				when 7 then -- if done | if done
						if ((create {P_GLOBALS_STATIC}).must_redraw.item).to_boolean then
							(create {P_SCREEN_STATIC}).update_screen (0)
						elseif ((create {P_GLOBALS_STATIC}).clear_cmdline.item).to_boolean then
							(create {P_SCREEN_STATIC}).showmode.do_nothing
						elseif ((create {P_GLOBALS_STATIC}).redraw_cmdline.item).to_boolean then
							(create {P_SCREEN_STATIC}).showmode.do_nothing
						end
						(create {P_SCREEN_STATIC}).showruler (0);
						(create {P_SCREEN_STATIC}).setcursor;
						(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_ctrl_v
		local
			l_c: INTEGER_32
		do
			ins_redraw (0)
			if ((create {P_SCREEN_STATIC}).redrawing).to_boolean then
				if not ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
					edit_putchar (('^').code, 1)
				end
			end
			(create {P_GETCHAR_STATIC}).AppendToRedobuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/22/")));
			(create {P_NORMAL_STATIC}).add_to_showcmd_c (22)
			l_c := get_literal
			edit_unputchar;
			(create {P_NORMAL_STATIC}).clear_showcmd
			insert_special (l_c, 0, 1)
		end

	edit_putchar (a_c, a_highlight: INTEGER_32)
		local
			l_attr: INTEGER_32
		do
			if not ((create {P_GLOBALS_STATIC}).ScreenLines.item).is_void then
				(create {P_MOVE_STATIC}).update_topline;
				(create {P_MOVE_STATIC}).validate_cursor
				if a_highlight.to_boolean then
					l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[0]
				else
					l_attr := 0
				end
				pc_row.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow + (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow
				pc_col.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wincol
				pc_status.item := 0
				pc_col.item := pc_col.item + ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol)
				if ((create {P_MBYTE_STATIC}).mb_lefthalve (pc_row.item, pc_col.item)).to_boolean then
					pc_status.item := 2
				end
				if pc_status.item = 0 then
					(create {P_SCREEN_STATIC}).screen_getbytes (pc_row.item, pc_col.item, pc_bytes.item, pc_attr.item)
					pc_status.item := 3
				end
				(create {P_SCREEN_STATIC}).screen_putchar (a_c, pc_row.item, pc_col.item, l_attr)
			end
		end

	edit_unputchar
		do
			if pc_status.item /= 0 then
				if pc_row.item >= (create {P_GLOBALS_STATIC}).msg_scrolled.item then
					if pc_status.item = 1 then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol) + 1
					end
					if pc_status.item = 1 then
						(create {P_SCREEN_STATIC}).redrawWinline ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0)
					elseif pc_status.item = 2 then
						(create {P_SCREEN_STATIC}).redrawWinline ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0)
					else
						(create {P_SCREEN_STATIC}).screen_puts (pc_bytes.item, pc_row.item - (create {P_GLOBALS_STATIC}).msg_scrolled.item, pc_col.item, pc_attr.item.item)
					end
				end
			end
		end

	display_dollar (a_col: INTEGER_32)
		local
			l_save_col: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if not ((create {P_SCREEN_STATIC}).redrawing).to_boolean then
				l_return := True
			end
			if not l_return then
				(create {P_TERM_STATIC}).cursor_off
				l_save_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := a_col
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_curline;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_p___0, l_p___0 + a_col]))
				end
				(create {P_MOVE_STATIC}).curs_columns (0)
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_wcol < (create {P_GLOBALS_STATIC}).curwin.item.item.w_width then
					edit_putchar (('$').code, 0);
					(create {P_GLOBALS_STATIC}).dollar_vcol.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol
				end
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_save_col
			end
		end

	undisplay_dollar
		do
			if ((create {P_GLOBALS_STATIC}).dollar_vcol.item).to_boolean then
				(create {P_GLOBALS_STATIC}).dollar_vcol.item := 0;
				(create {P_SCREEN_STATIC}).redrawWinline ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0)
			end
		end

	change_indent (a_type, a_amount, a_round, a_replaced, a_call_changed_bytes: INTEGER_32)
		local
			l_replaced: INTEGER_32
			l_vcol: INTEGER_32
			l_last_vcol: INTEGER_32
			l_insstart_less: INTEGER_32
			l_new_cursor_col: INTEGER_32
			l_i___0: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_save_p_list: INTEGER_32
			l_start_col: INTEGER_32
			l_vc: INTEGER_32
			l_orig_col: INTEGER_32
			l_new_line: CE_POINTER [NATURAL_8]
			l_orig_line: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_save_State: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_replaced := a_replaced
			l_orig_col := 0
			l_orig_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
				l_orig_line := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get_curline))
				l_orig_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			end
			l_save_p_list := (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := 0
			l_vc := (create {P_CHARSET_STATIC}).getvcol_nolist (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
			l_vcol := l_vc
			l_start_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			l_new_cursor_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			beginline (1)
			l_new_cursor_col := l_new_cursor_col - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
			l_insstart_less := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			if l_new_cursor_col < 0 then
				l_vcol := ((create {P_MISC1_STATIC}).get_indent) - l_vcol
			end
			if l_new_cursor_col > 0 then
				l_start_col := -1
			end
			if a_type = 1 then
				if a_call_changed_bytes.to_boolean then
					l_tmp___1 := 1
				else
					l_tmp___1 := 0
				end
				(create {P_MISC1_STATIC}).set_indent (a_amount, l_tmp___1).do_nothing
			else
				l_save_State := (create {P_GLOBALS_STATIC}).State.item
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
					(create {P_GLOBALS_STATIC}).State.item := 16
				end
				(create {P_OPS_STATIC}).shift_line ((a_type = 3).to_integer, a_round, 1, a_call_changed_bytes);
				(create {P_GLOBALS_STATIC}).State.item := l_save_State
			end
			l_insstart_less := l_insstart_less - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
			if l_new_cursor_col >= 0 then
				if l_new_cursor_col = 0 then
					l_insstart_less := 2_147_483_647
				end
				l_new_cursor_col := l_new_cursor_col + ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
			elseif not (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
				l_new_cursor_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			else
				l_vcol := ((create {P_MISC1_STATIC}).get_indent) - l_vcol
				if l_vcol < 0 then
					l_tmp___3 := 0
				else
					l_tmp___3 := l_vcol
				end
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol := l_tmp___3
				l_last_vcol := 0
				l_vcol := l_last_vcol
				l_new_cursor_col := -1
				l_ptr := (create {P_MEMLINE_STATIC}).ml_get_curline
				from
				until
					not (l_vcol <= (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol)
				loop
					l_last_vcol := l_vcol
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						if l_new_cursor_col >= 0 then
							l_new_cursor_col := l_new_cursor_col + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr + l_new_cursor_col]))
						else
							l_new_cursor_col := l_new_cursor_col + 1
						end
					else
						l_new_cursor_col := l_new_cursor_col + 1
					end
					l_vcol := l_vcol + ((create {P_CHARSET_STATIC}).lbr_chartabsize (l_ptr + l_new_cursor_col, l_vcol))
				end
				l_vcol := l_last_vcol
				if l_vcol /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_new_cursor_col
					l_i___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol - l_vcol
					l_ptr := (create {P_MISC2_STATIC}).alloc ((l_i___0 + 1).to_natural_32)
					if not l_ptr.is_void then
						l_new_cursor_col := l_new_cursor_col + l_i___0
						l_ptr[l_i___0] := (('%/0/').code).to_natural_8
						from
						until
							(l_break)
						loop
							l_break := False
							l_i___0 := l_i___0 - 1
							if not (l_i___0 >= 0) then
								l_break := True
							end
							if not (l_break) then
								l_ptr[l_i___0] := ((' ').code).to_natural_8
							end
						end
						l_break := False;
						(create {P_MISC1_STATIC}).ins_str (l_ptr);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr))
					end
				end
				l_insstart_less := 2_147_483_647
			end
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := l_save_p_list
			if l_new_cursor_col <= 0 then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
			else
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_new_cursor_col
			end
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
			(create {P_MOVE_STATIC}).changed_cline_bef_curs
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
					if (create {P_GLOBALS_STATIC}).Insstart.item.item.col /= 0 then
						if (create {P_GLOBALS_STATIC}).Insstart.item.item.col <= l_insstart_less then
							(create {P_GLOBALS_STATIC}).Insstart.item.item.col := 0
						else
							(create {P_GLOBALS_STATIC}).Insstart.item.item.col := (create {P_GLOBALS_STATIC}).Insstart.item.item.col - l_insstart_less
						end
					end
				end
				if (create {P_GLOBALS_STATIC}).ai_col.item <= l_insstart_less then
					(create {P_GLOBALS_STATIC}).ai_col.item := 0
				else
					(create {P_GLOBALS_STATIC}).ai_col.item := (create {P_GLOBALS_STATIC}).ai_col.item - l_insstart_less
				end
			end
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
				if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
					if l_start_col >= 0 then
						from
						until
							not (l_start_col > (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
						loop
							replace_join (0)
							l_start_col := l_start_col - 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if not (l_start_col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) then
								if not l_replaced.to_boolean then
									l_break := True
								end
							end
							if not (l_break) then
								replace_push (('%/0/').code)
								if l_replaced.to_boolean then
									replace_push (l_replaced)
									l_replaced := ('%/0/').code
								end
								l_start_col := l_start_col + 1
							end
						end
						l_break := False
					end
				end
			end
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
				if l_orig_line.is_void then
					l_return := True
				end
				if not l_return then
					l_new_line := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get_curline))
					if l_new_line.is_void then
						l_return := True
					end
				end
				if not l_return then
					l_new_line[(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col] := (('%/0/').code).to_natural_8;
					(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_orig_line, 0).do_nothing;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_orig_col
					backspace_until_column (0);
					(create {P_MISC1_STATIC}).ins_bytes (l_new_line);
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_line))
				end
			end
			if not l_return then
			end
		end

	truncate_spaces (a_line: CE_POINTER [NATURAL_8])
		require
			not a_line.is_void
		local
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_i___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_line))).to_integer_32 - 1
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i___0 >= 0 then
					if (a_line[l_i___0]).to_integer_32 /= 32 then
						if (a_line[l_i___0]).to_integer_32 /= 9 then
							l_break := True
						end
					end
				else
					l_break := True
				end
				if not (l_break) then
					if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
						replace_join (0)
					end
					l_i___0 := l_i___0 - 1
				end
			end
			l_break := False
			a_line[(l_i___0 + 1)] := (('%/0/').code).to_natural_8
		end

	backspace_until_column (a_col: INTEGER_32)
		local
			l_break: BOOLEAN
		do
			from
			until
				not (not (l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > a_col))
			loop
				l_break := False;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 1
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
					replace_do_bs (a_col)
				elseif not (del_char_after_col (a_col)).to_boolean then
					l_break := True
				end
			end
			l_break := False
		end

	del_char_after_col (a_limit_col: INTEGER_32): INTEGER_32
		local
			l_ecol: INTEGER_32
			l_l: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				if a_limit_col >= 0 then
					l_ecol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + 1;
					(create {P_MBYTE_STATIC}).mb_adjust_cursor
					from
					until
						not (not (l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < a_limit_col))
					loop
						l_break := False
						l_l := ((create {P_MBYTE_STATIC}).utf_ptr2len (((create {P_MEMLINE_STATIC}).ml_get_cursor)))
						if l_l = 0 then
							l_break := True
						end
						if not (l_break) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + l_l
						end
					end
					l_break := False
					if (((create {P_MEMLINE_STATIC}).ml_get_cursor).item).to_integer_32 = 0 then
						Result := 0
						l_return := True
					elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = l_ecol then
						Result := 0
						l_return := True
					end
					if not l_return then
						(create {P_MISC1_STATIC}).del_bytes ((l_ecol - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer_32, 0, 1).do_nothing
					end
				else
					(create {P_MISC1_STATIC}).del_char (0).do_nothing
				end
			else
				(create {P_MISC1_STATIC}).del_char (0).do_nothing
			end
			if not l_return then
				Result := 1
			end
		end

	ins_ctrl_x
		do
			if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 11 then
				if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (4)).to_boolean then
					(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_or ((6))
				else
					(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
				end
				(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 1;
				(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ctrl_x_msgs.item[((create {P_GLOBALS_STATIC}).ctrl_x_mode.item).bit_and (-257)])));
				(create {P_GLOBALS_STATIC}).edit_submode_pre.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
				(create {P_SCREEN_STATIC}).showmode.do_nothing
			end
		end

	has_compl_option (a_dict_opt: INTEGER_32): INTEGER_32
		local
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
		do
			if a_dict_opt.to_boolean then
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_dict).item).to_integer_32 = 0 then
					if ((create {P_OPTION_STATIC}).p_dict.item.item.item).to_integer_32 = 0 then
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_spell).to_boolean then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
				else
					l_tmp___2 := 0
				end
				l_tmp___4 := l_tmp___2
			else
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tsr).item).to_integer_32 = 0 then
					if ((create {P_OPTION_STATIC}).p_tsr.item.item.item).to_integer_32 = 0 then
						l_tmp___3 := 1
					else
						l_tmp___3 := 0
					end
				else
					l_tmp___3 := 0
				end
				l_tmp___4 := l_tmp___3
			end
			if l_tmp___4.to_boolean then
				(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 0;
				(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				if a_dict_opt.to_boolean then
					l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%'dictionary%' option is empty"))))
				else
					l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("%'thesaurus%' option is empty"))))
				end
				(create {P_MESSAGE_STATIC}).msg_attr (l_tmp___1, (create {P_GLOBALS_STATIC}).highlight_attr.item[3]).do_nothing
				if (create {P_GLOBALS_STATIC}).emsg_silent.item = 0 then
					(create {P_MISC1_STATIC}).vim_beep;
					(create {P_SCREEN_STATIC}).setcursor;
					(create {P_TERM_STATIC}).out_flush;
					(create {P_UI_STATIC}).ui_delay (2_000, 0)
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	vim_is_ctrl_x_key (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_c = 18 then
						Result := 1
						l_return := True
					end
					if not l_return then
						if (ins_compl_pum_key (a_c)).to_boolean then
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						inspect (create {P_GLOBALS_STATIC}).ctrl_x_mode.item -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 3
						when 2 then l_pos := -1 + 4
						when 3 then l_pos := -1 + 5
						when 4 then l_pos := -1 + 6
						when 265 then l_pos := -1 + 7
						when 266 then l_pos := -1 + 8
						when 261 then l_pos := -1 + 9
						when 262 then l_pos := -1 + 10
						when 263 then l_pos := -1 + 11
						when 11 then l_pos := -1 + 12
						when 12 then l_pos := -1 + 13
						when 13 then l_pos := -1 + 14
						when 14 then l_pos := -1 + 15
						else l_pos := -1 + 16
						end
				when 2 then -- switch 1, case 0
						if a_c = 14 then
							l_tmp___0 := 1
						elseif a_c = 16 then
							l_tmp___0 := 1
						elseif a_c = 24 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
						Result := l_tmp___0
						l_return := True
				when 3 then -- switch 1, case 1
						if not l_return then
							if a_c = 24 then
								l_tmp___1 := 1
							elseif a_c = 25 then
								l_tmp___1 := 1
							elseif a_c = 5 then
								l_tmp___1 := 1
							elseif a_c = 12 then
								l_tmp___1 := 1
							elseif a_c = 6 then
								l_tmp___1 := 1
							elseif a_c = 29 then
								l_tmp___1 := 1
							elseif a_c = 9 then
								l_tmp___1 := 1
							elseif a_c = 4 then
								l_tmp___1 := 1
							elseif a_c = 16 then
								l_tmp___1 := 1
							elseif a_c = 14 then
								l_tmp___1 := 1
							elseif a_c = 20 then
								l_tmp___1 := 1
							elseif a_c = 22 then
								l_tmp___1 := 1
							elseif a_c = 17 then
								l_tmp___1 := 1
							elseif a_c = 21 then
								l_tmp___1 := 1
							elseif a_c = 15 then
								l_tmp___1 := 1
							elseif a_c = 19 then
								l_tmp___1 := 1
							elseif a_c = 115 then
								l_tmp___1 := 1
							else
								l_tmp___1 := 0
							end
							Result := l_tmp___1
							l_return := True
						end
				when 4 then -- switch 1, case 2
						if not l_return then
							if a_c = 25 then
								l_tmp___2 := 1
							elseif a_c = 5 then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
							Result := l_tmp___2
							l_return := True
						end
				when 5 then -- switch 1, case 3
						if not l_return then
							if a_c = 12 then
								l_tmp___3 := 1
							elseif a_c = 16 then
								l_tmp___3 := 1
							elseif a_c = 14 then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
							Result := l_tmp___3
							l_return := True
						end
				when 6 then -- switch 1, case 4
						if not l_return then
							if a_c = 6 then
								l_tmp___4 := 1
							elseif a_c = 16 then
								l_tmp___4 := 1
							elseif a_c = 14 then
								l_tmp___4 := 1
							else
								l_tmp___4 := 0
							end
							Result := l_tmp___4
							l_return := True
						end
				when 7 then -- switch 1, case 265
						if not l_return then
							if a_c = 11 then
								l_tmp___5 := 1
							elseif a_c = 16 then
								l_tmp___5 := 1
							elseif a_c = 14 then
								l_tmp___5 := 1
							else
								l_tmp___5 := 0
							end
							Result := l_tmp___5
							l_return := True
						end
				when 8 then -- switch 1, case 266
						if not l_return then
							if a_c = 20 then
								l_tmp___6 := 1
							elseif a_c = 16 then
								l_tmp___6 := 1
							elseif a_c = 14 then
								l_tmp___6 := 1
							else
								l_tmp___6 := 0
							end
							Result := l_tmp___6
							l_return := True
						end
				when 9 then -- switch 1, case 261
						if not l_return then
							if a_c = 29 then
								l_tmp___7 := 1
							elseif a_c = 16 then
								l_tmp___7 := 1
							elseif a_c = 14 then
								l_tmp___7 := 1
							else
								l_tmp___7 := 0
							end
							Result := l_tmp___7
							l_return := True
						end
				when 10 then -- switch 1, case 262
						if not l_return then
							if a_c = 16 then
								l_tmp___8 := 1
							elseif a_c = 14 then
								l_tmp___8 := 1
							else
								l_tmp___8 := 0
							end
							Result := l_tmp___8
							l_return := True
						end
				when 11 then -- switch 1, case 263
						if not l_return then
							if a_c = 4 then
								l_tmp___9 := 1
							elseif a_c = 16 then
								l_tmp___9 := 1
							elseif a_c = 14 then
								l_tmp___9 := 1
							else
								l_tmp___9 := 0
							end
							Result := l_tmp___9
							l_return := True
						end
				when 12 then -- switch 1, case 11
						if not l_return then
							if a_c = 22 then
								l_tmp___10 := 1
							elseif a_c = 17 then
								l_tmp___10 := 1
							elseif a_c = 16 then
								l_tmp___10 := 1
							elseif a_c = 14 then
								l_tmp___10 := 1
							elseif a_c = 24 then
								l_tmp___10 := 1
							else
								l_tmp___10 := 0
							end
							Result := l_tmp___10
							l_return := True
						end
				when 13 then -- switch 1, case 12
						if not l_return then
							if a_c = 21 then
								l_tmp___11 := 1
							elseif a_c = 16 then
								l_tmp___11 := 1
							elseif a_c = 14 then
								l_tmp___11 := 1
							else
								l_tmp___11 := 0
							end
							Result := l_tmp___11
							l_return := True
						end
				when 14 then -- switch 1, case 13
						if not l_return then
							if a_c = 15 then
								l_tmp___12 := 1
							elseif a_c = 16 then
								l_tmp___12 := 1
							elseif a_c = 14 then
								l_tmp___12 := 1
							else
								l_tmp___12 := 0
							end
							Result := l_tmp___12
							l_return := True
						end
				when 15 then -- switch 1, case 14
						if not l_return then
							if a_c = 19 then
								l_tmp___13 := 1
							elseif a_c = 16 then
								l_tmp___13 := 1
							elseif a_c = 14 then
								l_tmp___13 := 1
							else
								l_tmp___13 := 0
							end
							Result := l_tmp___13
							l_return := True
						end
				when 16 then -- switch 1, done: | if done
					if not l_return then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_internal.item)))))).do_nothing
						Result := 0
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_accept_char (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (((create {P_GLOBALS_STATIC}).ctrl_x_mode.item).bit_and (256)).to_boolean then
						Result := ((create {P_CHARSET_STATIC}).vim_isIDc (a_c))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect (create {P_GLOBALS_STATIC}).ctrl_x_mode.item -- switch 1 head
						when 4 then l_pos := -1 + 2
						when 11 then l_pos := -1 + 3
						when 13 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 4
						if ((create {P_CHARSET_STATIC}).vim_isfilec (a_c)).to_boolean then
							if ((create {P_MISC1_STATIC}).vim_ispathsep (a_c)).to_boolean then
								l_tmp___2 := 0
							else
								l_tmp___2 := 1
							end
						else
							l_tmp___2 := 0
						end
						Result := l_tmp___2
						l_return := True
				when 3 then -- switch 1, case 11 | switch 1, case 13
						if not l_return then
							if ((create {P_CHARSET_STATIC}).vim_isprintc (a_c)).to_boolean then
								if a_c = 32 then
									l_tmp___4 := 0
								elseif a_c = 9 then
									l_tmp___4 := 0
								else
									l_tmp___4 := 1
								end
							else
								l_tmp___4 := 0
							end
							Result := l_tmp___4
							l_return := True
						end
				when 4 then -- switch 1, case 3
						if not l_return then
							Result := ((create {P_CHARSET_STATIC}).vim_isprintc (a_c))
							l_return := True
						end
				when 5 then -- switch 1, done: | if done
					if not l_return then
						Result := ((create {P_CHARSET_STATIC}).vim_iswordc (a_c))
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_add_infercase (a_str___1: CE_POINTER [NATURAL_8]; a_len, a_icase: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_dir___0, a_flags___0: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_actual_len: INTEGER_32
			l_actual_compl_length: INTEGER_32
			l_min_len: INTEGER_32
			l_wca: CE_POINTER [INTEGER_32]
			l_has_lower: INTEGER_32
			l_was_letter: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___13: INTEGER_32
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___17: INTEGER_32
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___20: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_has_lower := 0
			l_was_letter := 0
			if ((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_inf).to_boolean then
					if a_len > 0 then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_p___0.item := a_str___1
							l_actual_len := 0
							from
							until
								(l_p___0.item.item).to_integer_32 = 0
							loop
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
								else
									l_tmp___0 := 1
								end
								l_p___0.item := l_p___0.item + l_tmp___0
								l_actual_len := l_actual_len + 1
							end
						else
							l_actual_len := a_len
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_p___0.item := compl_orig_text.item
							l_actual_compl_length := 0
							from
							until
								(l_p___0.item.item).to_integer_32 = 0
							loop
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___2 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
								else
									l_tmp___2 := 1
								end
								l_p___0.item := l_p___0.item + l_tmp___2
								l_actual_compl_length := l_actual_compl_length + 1
							end
						else
							l_actual_compl_length := (create {P_GLOBALS_STATIC}).compl_length.item
						end
						if l_actual_len < l_actual_compl_length then
							l_min_len := l_actual_len
						else
							l_min_len := l_actual_compl_length
						end
						l_wca := create {CE_INTEGER_32_POINTER}.make_cast (((create {P_MISC2_STATIC}).alloc (l_actual_len.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)))
						if not l_wca.is_void then
							l_p___0.item := a_str___1
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_actual_len)
							loop
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_wca[l_i___0] := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)
								else
									l_tmp___4 := l_p___0.item
									l_p___0.item := l_p___0.item + 1
									l_wca[l_i___0] := (l_tmp___4.item).to_integer_32
								end
								l_i___0 := l_i___0 + 1
							end
							l_p___0.item := compl_orig_text.item
							l_i___0 := 0
							from
							until
								not (not (l_return or l_break) and then (l_i___0 < l_min_len))
							loop
								l_break := False
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_c := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)
								else
									l_tmp___5 := l_p___0.item
									l_p___0.item := l_p___0.item + 1
									l_c := (l_tmp___5.item).to_integer_32
								end
								if ((create {P_CHARSET_STATIC}).vim_islower (l_c)).to_boolean then
									l_has_lower := 1
									if ((create {P_CHARSET_STATIC}).vim_isupper (l_wca[l_i___0])).to_boolean then
										l_i___0 := l_actual_compl_length
										from
										until
											not (l_i___0 < l_actual_len)
										loop
											l_wca[l_i___0] := (create {P_CHARSET_STATIC}).vim_tolower (l_wca[l_i___0])
											l_i___0 := l_i___0 + 1
										end
										l_break := True
									end
								end
								if not (l_return or l_break) then
									l_i___0 := l_i___0 + 1
								end
							end
							l_break := False
							if not l_has_lower.to_boolean then
								l_p___0.item := compl_orig_text.item
								l_i___0 := 0
								from
								until
									not (not (l_return or l_break) and then (l_i___0 < l_min_len))
								loop
									l_break := False
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_c := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)
									else
										l_tmp___8 := l_p___0.item
										l_p___0.item := l_p___0.item + 1
										l_c := (l_tmp___8.item).to_integer_32
									end
									if l_was_letter.to_boolean then
										if ((create {P_CHARSET_STATIC}).vim_isupper (l_c)).to_boolean then
											if ((create {P_CHARSET_STATIC}).vim_islower (l_wca[l_i___0])).to_boolean then
												l_i___0 := l_actual_compl_length
												from
												until
													not (l_i___0 < l_actual_len)
												loop
													l_wca[l_i___0] := (create {P_CHARSET_STATIC}).vim_toupper (l_wca[l_i___0])
													l_i___0 := l_i___0 + 1
												end
												l_break := True
											end
										end
									end
									if not (l_return or l_break) then
										if ((create {P_CHARSET_STATIC}).vim_islower (l_c)).to_boolean then
											l_tmp___13 := 1
										elseif ((create {P_CHARSET_STATIC}).vim_isupper (l_c)).to_boolean then
											l_tmp___13 := 1
										else
											l_tmp___13 := 0
										end
										l_was_letter := l_tmp___13
										l_i___0 := l_i___0 + 1
									end
								end
								l_break := False
							end
							l_p___0.item := compl_orig_text.item
							l_i___0 := 0
							from
							until
								not (l_i___0 < l_min_len)
							loop
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_c := (create {P_MBYTE_STATIC}).mb_ptr2char_adv (l_p___0)
								else
									l_tmp___14 := l_p___0.item
									l_p___0.item := l_p___0.item + 1
									l_c := (l_tmp___14.item).to_integer_32
								end
								if ((create {P_CHARSET_STATIC}).vim_islower (l_c)).to_boolean then
									l_wca[l_i___0] := (create {P_CHARSET_STATIC}).vim_tolower (l_wca[l_i___0])
								elseif ((create {P_CHARSET_STATIC}).vim_isupper (l_c)).to_boolean then
									l_wca[l_i___0] := (create {P_CHARSET_STATIC}).vim_toupper (l_wca[l_i___0])
								end
								l_i___0 := l_i___0 + 1
							end
							l_p___0.item := (create {P_GLOBALS_STATIC}).IObuff.item
							l_i___0 := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if l_i___0 < l_actual_len then
									if not (((l_p___0.item).distance (((create {P_GLOBALS_STATIC}).IObuff.item))) + 6 < 1_025) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										l_tmp___17 := l_i___0
										l_i___0 := l_i___0 + 1
										l_p___0.item := l_p___0.item + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_wca[l_tmp___17], l_p___0.item]))
									else
										l_tmp___19 := l_p___0.item
										l_p___0.item := l_p___0.item + 1
										l_tmp___20 := l_i___0
										l_i___0 := l_i___0 + 1
										l_tmp___19.item := (l_wca[l_tmp___20]).to_natural_8
									end
								end
							end
							l_break := False
							l_p___0.item.item := (('%/0/').code).to_natural_8;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_wca))
						end
						Result := (ins_compl_add ((create {P_GLOBALS_STATIC}).IObuff.item, a_len, a_icase, a_fname, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), a_dir___0, a_flags___0, 0))
						l_return := True
					end
				end
			end
			if not l_return then
				Result := (ins_compl_add (a_str___1, a_len, a_icase, a_fname, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), a_dir___0, a_flags___0, 0))
			end
		end

	ins_compl_add (a_str___1: CE_POINTER [NATURAL_8]; a_len, a_icase: INTEGER_32; a_fname: CE_POINTER [NATURAL_8]; a_cptext: CE_POINTER [CE_POINTER [NATURAL_8]]; a_cdir, a_flags___0, a_adup: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_flags___0: INTEGER_32
			l_match: CE_POINTER [PD_COMPL_S]
			l_dir___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___5: CE_POINTER [PD_COMPL_S]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_len
					l_flags___0 := a_flags___0
					if a_cdir = 0 then
						l_tmp := compl_direction.item
					else
						l_tmp := a_cdir
					end
					l_dir___0 := l_tmp;
					(create {P_UI_STATIC}).ui_breakcheck
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						Result := 0
						l_return := True
					end
					if not l_return then
						if l_len < 0 then
							l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1))).to_integer_32
						end
						if not compl_first_match.item.is_void then
							if not a_adup.to_boolean then
								l_match := compl_first_match.item
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if not ((l_match.item.cp_flags).bit_and (1)).to_boolean then
										if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_match.item.cp_str), create {CE_INTEGER_8_POINTER}.make_cast (a_str___1), l_len.to_natural_32)) = 0 then
											if (l_match.item.cp_str[l_len]).to_integer_32 = 0 then
												Result := 2
												l_return := True
											end
										end
									end
									if not l_return then
										l_match := l_match.item.cp_next
										if not l_match.is_void then
											if l_match.is_equal (compl_first_match.item) then
												l_break := True
											end
										else
											l_break := True
										end
									end
								end
								if not l_return then
									l_break := False
								end
							end
						end
					end
					if not l_return then
						ins_compl_del_pum
						l_match := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((create {PD_COMPL_S}.make).structure_size.to_natural_32)))
						if l_match.is_void then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_match.item.cp_number := -1
						if ((l_flags___0).bit_and (1)).to_boolean then
							l_match.item.cp_number := 0
						end
						l_tmp___3 := (create {P_MISC2_STATIC}).vim_strnsave (a_str___1, l_len)
						l_match.item.cp_str := l_tmp___3
						if l_tmp___3.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_match))
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_match.item.cp_icase := a_icase.to_integer_8
						if a_fname.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not compl_curr_match.item.is_void then
							if not (compl_curr_match.item.item.cp_fname).is_void then
								if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), create {CE_INTEGER_8_POINTER}.make_cast (compl_curr_match.item.item.cp_fname))) = 0 then
									l_match.item.cp_fname := compl_curr_match.item.item.cp_fname
								else
									l_pos := -1 + 4 -- goto _L___1
								end
							else
								l_pos := -1 + 4 -- goto _L___1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___1:
						if not a_fname.is_void then
							l_match.item.cp_fname := (create {P_MISC2_STATIC}).vim_strsave (a_fname)
							l_flags___0 := (l_flags___0).bit_or ((2))
						else
							l_match.item.cp_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
				when 5 then
						l_match.item.cp_flags := l_flags___0
						if not a_cptext.is_void then
							l_i___0 := 0
							from
							until
								not (l_i___0 < 4)
							loop
								if not (a_cptext[l_i___0]).is_void then
									if ((a_cptext[l_i___0]).item).to_integer_32 /= 0 then
										l_match.item.cp_text[l_i___0] := (create {P_MISC2_STATIC}).vim_strsave (a_cptext[l_i___0])
									end
								end
								l_i___0 := l_i___0 + 1
							end
						end
						if compl_first_match.item.is_void then
							l_tmp___5 := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_shared (default_pointer)
							l_match.item.cp_prev := l_tmp___5
							l_match.item.cp_next := l_tmp___5
						elseif l_dir___0 = 1 then
							l_match.item.cp_next := compl_curr_match.item.item.cp_next
							l_match.item.cp_prev := compl_curr_match.item
						else
							l_match.item.cp_next := compl_curr_match.item
							l_match.item.cp_prev := compl_curr_match.item.item.cp_prev
						end
						if (not (l_match.item.cp_next).is_void) then
							(l_match.item.cp_next).item.cp_prev := l_match
						end
						if (not (l_match.item.cp_prev).is_void) then
							(l_match.item.cp_prev).item.cp_next := l_match
						else
							compl_first_match.item := l_match
						end
						compl_curr_match.item := l_match
						if compl_get_longest.item.to_boolean then
							if ((l_flags___0).bit_and (1)) = 0 then
								l_match.item.ins_compl_longest_match
							end
						end
						Result := 1
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_add_matches (a_num_matches___0: INTEGER_32; a_matches___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_icase: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_add_r: INTEGER_32
			l_dir___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_add_r := 1
			l_dir___0 := compl_direction.item
			l_i___0 := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i___0 < a_num_matches___0 then
					if l_add_r = 0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_add_r := ins_compl_add (a_matches___0[l_i___0], -1, a_icase, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), l_dir___0, 0, 0)
					if l_add_r = 1 then
						l_dir___0 := 1
					end
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False;
			(create {P_MISC1_STATIC}).FreeWild (a_num_matches___0, a_matches___0)
		end

	ins_compl_make_cyclic: INTEGER_32
		local
			l_match: CE_POINTER [PD_COMPL_S]
			l_count___2: INTEGER_32
			l_break: BOOLEAN
		do
			l_count___2 := 0
			if not compl_first_match.item.is_void then
				l_match := compl_first_match.item
				from
				until
					(l_break)
				loop
					l_break := False
					if not (l_match.item.cp_next).is_void then
						if (l_match.item.cp_next).is_equal (compl_first_match.item) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_match := l_match.item.cp_next
						l_count___2 := l_count___2 + 1
					end
				end
				l_break := False
				l_match.item.cp_next := compl_first_match.item
				compl_first_match.item.item.cp_prev := l_match
			end
			Result := l_count___2
		end

	set_completion (a_startcol: INTEGER_32; a_list: CE_POINTER [PD_LISTVAR_S])
		local
			l_startcol: INTEGER_32
			l_return: BOOLEAN
		do
			l_startcol := a_startcol
			if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
				ins_compl_prep ((' ').code).do_nothing
			end
			ins_compl_clear
			if (stop_arrow) = 0 then
				l_return := True
			end
			if not l_return then
				if l_startcol > (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
					l_startcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
				end
				compl_col.item := l_startcol;
				(create {P_GLOBALS_STATIC}).compl_length.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - l_startcol
				compl_orig_text.item := (create {P_MISC2_STATIC}).vim_strnsave (((create {P_MEMLINE_STATIC}).ml_get_curline) + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item)
				if compl_orig_text.item.is_void then
					l_return := True
				elseif (ins_compl_add (compl_orig_text.item, -1, (create {P_OPTION_STATIC}).p_ic.item.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 1, 0)) /= 1 then
					l_return := True
				end
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 3
				a_list.item.ins_compl_add_list
				compl_matches.item := ins_compl_make_cyclic
				compl_started.item := 1
				compl_used_match.item := 1;
				(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
				compl_curr_match.item := compl_first_match.item
				ins_complete (14).do_nothing;
				(create {P_TERM_STATIC}).out_flush
			end
		end

	ins_compl_upd_pum
		local
			l_h: INTEGER_32
		do
			if not compl_match_array.item.is_void then
				l_h := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height;
				(create {P_SCREEN_STATIC}).update_screen (0)
				if l_h /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cline_height then
					ins_compl_del_pum
				end
			end
		end

	ins_compl_del_pum
		do
			if not compl_match_array.item.is_void then
				(create {P_POPUPMNU_STATIC}).pum_undisplay;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_match_array.item))
				compl_match_array.item := create {CE_CLASS_POINTER [PD_PUMITEM_T]}.make_shared (default_pointer)
			end
		end

	pum_wanted: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cot.item.item, ('m').code)).is_void then
				Result := 0
				l_return := True
			end
			if not l_return and then ((create {P_GLOBALS_STATIC}).t_colors.item < 8) then
				if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := 1
			end
		end

	pum_enough_matches: INTEGER_32
		local
			l_compl: CE_POINTER [PD_COMPL_S]
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_compl := compl_first_match.item
			l_i___0 := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if l_compl.is_void then
					l_break := True
				elseif ((l_compl.item.cp_flags).bit_and (1)) = 0 then
					l_i___0 := l_i___0 + 1
					if l_i___0 = 2 then
						l_break := True
					end
				end
				if not (l_break) then
					l_compl := l_compl.item.cp_next
					if l_compl.is_equal (compl_first_match.item) then
						l_break := True
					end
				end
			end
			l_break := False
			if not (strstr (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_cot.item.item), ce_string ("menuone"))).is_void then
				Result := (l_i___0 >= 1).to_integer
				l_return := True
			end
			if not l_return then
				Result := (l_i___0 >= 2).to_integer
			end
		end

	ins_compl_show_pum
		local
			l_compl: CE_POINTER [PD_COMPL_S]
			l_shown_compl: CE_POINTER [PD_COMPL_S]
			l_did_find_shown_match: INTEGER_32
			l_shown_match_ok: INTEGER_32
			l_i___0: INTEGER_32
			l_cur: INTEGER_32
			l_col: INTEGER_32
			l_lead_len: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_shown_compl := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_shared (default_pointer)
					l_did_find_shown_match := 0
					l_shown_match_ok := 0
					l_cur := -1
					l_lead_len := 0
					if (pum_wanted).to_boolean then
						if not (pum_enough_matches).to_boolean then
							l_return := True
						end
					else
						l_return := True
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:;
						(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("if exists(%'g:loaded_matchparen%')|3match none|endif"))).do_nothing;
						(create {P_SCREEN_STATIC}).update_screen (0)
						if not (compl_match_array.item.is_void) then
							l_pos := -1 + 15 -- skip if block
						end
				when 2 then -- if:
						compl_match_arraysize.item := 0
						l_compl := compl_first_match.item
						if not compl_leader.item.is_void then
							l_lead_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_leader.item))).to_integer_32
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if ((l_compl.item.cp_flags).bit_and (1)) = 0 then
								if compl_leader.item.is_void then
									compl_match_arraysize.item := compl_match_arraysize.item + 1
								elseif (l_compl.item.ins_compl_equal (compl_leader.item, l_lead_len)).to_boolean then
									compl_match_arraysize.item := compl_match_arraysize.item + 1
								end
							end
							l_compl := l_compl.item.cp_next
							if not l_compl.is_void then
								if l_compl.is_equal (compl_first_match.item) then
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						if compl_match_arraysize.item = 0 then
							l_return := True
						end
						if l_return then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						compl_match_array.item := create {CE_CLASS_POINTER [PD_PUMITEM_T]}.make_cast (((create {P_MISC2_STATIC}).alloc_clear ((create {PD_PUMITEM_T}.make).structure_size.to_natural_32 * compl_match_arraysize.item.to_natural_32)))
						if compl_match_array.item.is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						if ((compl_shown_match.item.item.cp_flags).bit_and (1)).to_boolean then
							l_shown_match_ok := 1
						end
						l_i___0 := 0
						l_compl := compl_first_match.item
				when 5 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 13 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if ((l_compl.item.cp_flags).bit_and (1)) /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not (compl_leader.item.is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not ((l_compl.item.ins_compl_equal (compl_leader.item, l_lead_len)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if not l_shown_match_ok.to_boolean then
							if l_compl.is_equal (compl_shown_match.item) then
								compl_shown_match.item := l_compl
								l_did_find_shown_match := 1
								l_shown_match_ok := 1
							elseif l_did_find_shown_match.to_boolean then
								compl_shown_match.item := l_compl
								l_did_find_shown_match := 1
								l_shown_match_ok := 1
							else
								l_shown_compl := l_compl
							end
							l_cur := l_i___0
						end
						if not (l_compl.item.cp_text[0]).is_void then
							(compl_match_array.item + l_i___0).item.pum_text := l_compl.item.cp_text[0]
						else
							(compl_match_array.item + l_i___0).item.pum_text := l_compl.item.cp_str
						end
						(compl_match_array.item + l_i___0).item.pum_kind := l_compl.item.cp_text[2];
						(compl_match_array.item + l_i___0).item.pum_info := l_compl.item.cp_text[3]
						if not (l_compl.item.cp_text[1]).is_void then
							l_tmp___4 := l_i___0
							l_i___0 := l_i___0 + 1;
							(compl_match_array.item + l_tmp___4).item.pum_extra := l_compl.item.cp_text[1]
						else
							l_tmp___5 := l_i___0
							l_i___0 := l_i___0 + 1;
							(compl_match_array.item + l_tmp___5).item.pum_extra := l_compl.item.cp_fname
						end
				when 12 then -- if done | if done
						if l_compl.is_equal (compl_shown_match.item) then
							l_did_find_shown_match := 1
							if ((l_compl.item.cp_flags).bit_and (1)).to_boolean then
								l_shown_match_ok := 1
							end
							if not l_shown_match_ok.to_boolean then
								if not l_shown_compl.is_void then
									compl_shown_match.item := l_shown_compl
									l_shown_match_ok := 1
								end
							end
						end
						l_compl := l_compl.item.cp_next
						if not l_compl.is_void then
							if l_compl.is_equal (compl_first_match.item) then
								l_break := True
							end
						else
							l_break := True
						end
						l_pos := -1 + 5 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						if not l_shown_match_ok.to_boolean then
							l_cur := -1
						end
				when 14 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_i___0 := 0
						from
						until
							not (not (l_break) and then (l_i___0 < compl_match_arraysize.item))
						loop
							l_break := False
							if ((compl_match_array.item + l_i___0).item.pum_text).is_equal (compl_shown_match.item.item.cp_str) then
								l_cur := l_i___0
								l_break := True
							elseif ((compl_match_array.item + l_i___0).item.pum_text).is_equal (compl_shown_match.item.item.cp_text[0]) then
								l_cur := l_i___0
								l_break := True
							end
							if not (l_break) then
								l_i___0 := l_i___0 + 1
							end
						end
						l_break := False
				when 16 then -- if done | if done
					if not l_return and then (not compl_match_array.item.is_void) then
						l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := compl_col.item;
						(create {P_POPUPMNU_STATIC}).pum_display (compl_match_array.item, compl_match_arraysize.item, l_cur);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_dictionaries (a_dict_start, a_pat: CE_POINTER [NATURAL_8]; a_flags___0, a_thesaurus: INTEGER_32)
		local
			l_dict: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ptr: CE_POINTER [NATURAL_8]
			l_buf___6: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_files: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_count___2: CE_ARRAY [INTEGER_32]
			l_save_p_scs: INTEGER_32
			l_dir___0: CE_ARRAY [INTEGER_32]
			l_pat_esc: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_dict.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_buf___6.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_files.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_count___2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_dir___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dict.item := a_dict_start
					l_dir___0.item := compl_direction.item
					if (l_dict.item.item).to_integer_32 = 0 then
						if not a_thesaurus.to_boolean then
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_spell).to_boolean then
								l_dict.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spell"))
							else
								l_return := True
							end
						else
							l_return := True
						end
					end
					if not l_return then
						l_buf___6.item := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 512)
						if (l_buf___6.item).is_void then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						l_regmatch___0.item.regprog := create {CE_CLASS_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
						l_save_p_scs := (create {P_OPTION_STATIC}).p_scs.item.item
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_inf).to_boolean then
							(create {P_OPTION_STATIC}).p_scs.item.item := 0
						end
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						l_pat_esc := ((create {P_MISC2_STATIC}).vim_strsave_escaped (a_pat, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\"))))
						if l_pat_esc.is_void then
							l_pos := -1 + 20 -- goto theend
						end
				when 3 then
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_pat_esc))) + {NATURAL_32} 10
						l_ptr := (create {P_MISC2_STATIC}).alloc (l_len)
						if l_ptr.is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat_esc))
							l_pos := -1 + 20 -- goto theend
						end
				when 4 then;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), l_len, ce_string ("^\s*\zs\V%%s"), l_pat_esc]).do_nothing
						l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (l_ptr, 1);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat_esc));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr))
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if ((create {P_OPTION_STATIC}).p_magic.item.item).to_boolean then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
						l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (a_pat, l_tmp___1)
						if (l_regmatch___0.item.regprog).is_void then
							l_pos := -1 + 20 -- goto theend
						end
				when 7 then
						l_regmatch___0.item.rm_ic := (create {P_SEARCH_STATIC}).ignorecase (a_pat)
				when 8 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 9 then -- loop body:
						l_break := False
						if (l_dict.item.item).to_integer_32 /= 0 then
							if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).compl_interrupted.item).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if:
						if a_flags___0 /= 2 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_count___2.item := 1
						l_files.item := l_dict
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:;
						(create {P_MISC2_STATIC}).copy_option_part (l_dict, l_buf___6.item, 512, ce_string (",")).do_nothing
						if a_thesaurus.to_boolean then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6.item), ce_string ("spell"))) = 0 then
							l_count___2.item := -1
						else
							l_pos := -1 + 16 -- goto _L
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L:
						if not ((create {P_MISC2_STATIC}).vim_strchr (l_buf___6.item, ('`').code)).is_void then
							l_count___2.item := 0
						elseif ((create {P_MISC1_STATIC}).expand_wildcards (1, l_buf___6, l_count___2, l_files, 34)) /= 1 then
							l_count___2.item := 0
						end
				when 17 then -- if done
						if l_count___2.item = -1 then
							if (a_pat[0]).to_integer_32 = 92 then
								if (a_pat[1]).to_integer_32 = 60 then
									l_ptr := a_pat + 2
								else
									l_ptr := a_pat
								end
							else
								l_ptr := a_pat
							end
							(create {P_SPELL_STATIC}).spell_dump_compl (l_ptr, l_regmatch___0.item.rm_ic, l_dir___0, 0)
						elseif l_count___2.item > 0 then
							ins_compl_files (l_count___2.item, l_files.item, a_thesaurus, a_flags___0, l_regmatch___0, l_buf___6.item, l_dir___0)
							if a_flags___0 /= 2 then
								(create {P_MISC1_STATIC}).FreeWild (l_count___2.item, l_files.item)
							end
						end
						if a_flags___0 /= 0 then
							l_break := True
						end
				when 18 then -- if done
						l_pos := -1 + 8 -- back to loop condition
				when 19 then -- loop done
						l_break := False
				when 20 then -- theend:;
						(create {P_OPTION_STATIC}).p_scs.item.item := l_save_p_scs;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item))
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_files (a_count___2: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]]; a_thesaurus, a_flags___0: INTEGER_32; a_regmatch___0: CE_POINTER [PD_REGMATCH_T]; a_buf___6: CE_POINTER [NATURAL_8]; a_dir___0: CE_POINTER [INTEGER_32])
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_fp: CE_POINTER [SD_IO_FILE]
			l_add_r: INTEGER_32
			l_wstart: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if l_i___0 < a_count___2 then
					if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						if ((create {P_GLOBALS_STATIC}).compl_interrupted.item).to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_return or l_break) then
					l_fp := fopen (create {CE_INTEGER_8_POINTER}.make_cast (a_files[l_i___0]), ce_string ("r"))
					if a_flags___0 /= 2 then
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Scanning dictionary: %%s"))), create {CE_INTEGER_8_POINTER}.make_cast (a_files[l_i___0])]).do_nothing;
						(create {P_MESSAGE_STATIC}).msg_trunc_attr ((create {P_GLOBALS_STATIC}).IObuff.item, 1, (create {P_GLOBALS_STATIC}).highlight_attr.item[10]).do_nothing
					end
					if not l_fp.is_void then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								if not ((create {P_GLOBALS_STATIC}).compl_interrupted.item).to_boolean then
									if ((create {P_FILEIO_STATIC}).vim_fgets (a_buf___6, 512, l_fp)).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_ptr := a_buf___6
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if not (a_regmatch___0.item.vim_regexec (a_buf___6, l_ptr.distance (a_buf___6))).to_boolean then
										l_break := True
									end
									if not (l_return or l_break) then
										l_ptr := a_regmatch___0.item.startp[0]
										if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 3 then
											l_ptr := find_line_end (l_ptr)
										else
											l_ptr := find_word_end (l_ptr)
										end
										l_add_r := ins_compl_add_infercase (a_regmatch___0.item.startp[0], l_ptr.distance ((a_regmatch___0.item.startp[0])), (create {P_OPTION_STATIC}).p_ic.item.item, a_files[l_i___0], a_dir___0.item, 0)
										if a_thesaurus.to_boolean then
											l_ptr := a_buf___6
											from
											until
												not (not (l_return or l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean))
											loop
												l_break := False
												l_ptr := find_word_start (l_ptr)
												if (l_ptr.item).to_integer_32 = 0 then
													l_break := True
												elseif (l_ptr.item).to_integer_32 = 10 then
													l_break := True
												end
												if not (l_return or l_break) then
													l_wstart := l_ptr
													if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
														from
														until
															not (not (l_break) and then ((l_ptr.item).to_integer_32 /= 0))
														loop
															l_break := False
															l_l := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr]))
															if l_l < 2 then
																if not ((create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr.item).to_integer_32)).to_boolean then
																	l_break := True
																end
															end
															if not (l_break) then
																l_ptr := l_ptr + l_l
															end
														end
														l_break := False
													else
														l_ptr := find_word_end (l_ptr)
													end
													if not l_wstart.is_equal (a_regmatch___0.item.startp[0]) then
														l_add_r := ins_compl_add_infercase (l_wstart, l_ptr.distance (l_wstart), (create {P_OPTION_STATIC}).p_ic.item.item, a_files[l_i___0], a_dir___0.item, 0)
													end
												end
											end
											l_break := False
										end
										if l_add_r = 1 then
											a_dir___0.item := 1
										elseif l_add_r = 0 then
											l_break := True
										end
									end
									if not (l_return or l_break) then
										if (l_ptr.item).to_integer_32 = 10 then
											l_break := True
										elseif ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
											l_break := True
										end
									end
								end
								l_break := False;
								(create {P_MISC1_STATIC}).line_breakcheck
								ins_compl_check_keys (50)
							end
						end
						l_break := False
						fclose (l_fp).do_nothing
					end
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
		end

	find_word_start (a_ptr: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_ptr.is_void
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_ptr := a_ptr
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_ptr.item).to_integer_32 /= 0 then
						if (l_ptr.item).to_integer_32 /= 10 then
							if not (((create {P_MBYTE_STATIC}).mb_get_class (l_ptr)) <= 1) then
								l_break := True
							end
						else
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_ptr := l_ptr + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr]))
					end
				end
				l_break := False
			else
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_ptr.item).to_integer_32 /= 0 then
						if (l_ptr.item).to_integer_32 /= 10 then
							if ((create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr.item).to_integer_32)).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_ptr := l_ptr + 1
					end
				end
				l_break := False
			end
			Result := l_ptr
		end

	find_word_end (a_ptr: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_start_class: INTEGER_32
			l_break: BOOLEAN
		do
			l_ptr := a_ptr
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_start_class := (create {P_MBYTE_STATIC}).mb_get_class (l_ptr)
				if l_start_class > 1 then
					from
					until
						not (not (l_break) and then ((l_ptr.item).to_integer_32 /= 0))
					loop
						l_break := False
						l_ptr := l_ptr + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr]))
						if ((create {P_MBYTE_STATIC}).mb_get_class (l_ptr)) /= l_start_class then
							l_break := True
						end
					end
					l_break := False
				end
			else
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((create {P_CHARSET_STATIC}).vim_iswordc ((l_ptr.item).to_integer_32)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_ptr := l_ptr + 1
					end
				end
				l_break := False
			end
			Result := l_ptr
		end

	find_line_end (a_ptr: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_s := a_ptr + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_ptr))).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_s.c_pointer.to_integer_32).to_natural_32 > (a_ptr.c_pointer.to_integer_32).to_natural_32 then
					if (l_s[-1]).to_integer_32 /= 13 then
						if (l_s[-1]).to_integer_32 /= 10 then
							l_break := True
						end
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_s := l_s - 1
				end
			end
			l_break := False
			Result := l_s
		end

	ins_compl_free
		local
			l_match: CE_POINTER [PD_COMPL_S]
			l_i___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_pattern.item.item))
			compl_pattern.item.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_leader.item))
			compl_leader.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if compl_first_match.item.is_void then
				l_return := True
			end
			if not l_return then
				ins_compl_del_pum;
				(create {P_POPUPMNU_STATIC}).pum_clear
				compl_curr_match.item := compl_first_match.item
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_match := compl_curr_match.item
					compl_curr_match.item := compl_curr_match.item.item.cp_next;
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_match.item.cp_str))
					if ((l_match.item.cp_flags).bit_and (2)).to_boolean then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_match.item.cp_fname))
					end
					l_i___0 := 0
					from
					until
						not (l_i___0 < 4)
					loop
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_match.item.cp_text[l_i___0]))
						l_i___0 := l_i___0 + 1
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_match))
					if not compl_curr_match.item.is_void then
						if compl_curr_match.item.is_equal (compl_first_match.item) then
							l_break := True
						end
					else
						l_break := True
					end
				end
				l_break := False
				compl_curr_match.item := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_shared (default_pointer)
				compl_first_match.item := compl_curr_match.item
				compl_shown_match.item := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_shared (default_pointer)
			end
		end

	ins_compl_clear
		do
			(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
			compl_started.item := 0
			compl_matches.item := 0;
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_pattern.item.item))
			compl_pattern.item.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_leader.item))
			compl_leader.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_orig_text.item))
			compl_orig_text.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			compl_enter_selects.item := 0
		end

	ins_compl_active: INTEGER_32
		do
			Result := compl_started.item
		end

	ins_compl_bs: INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
			l_p___0 := l_line + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, l_p___0 - 1])) + 1
			else
				l_tmp___0 := 1
			end
			l_p___0 := l_p___0 - l_tmp___0
			if (l_p___0.distance (l_line)) - compl_col.item < 0 then
				Result := (-(107 + ((98).bit_shift_left (8))))
				l_return := True
			elseif (l_p___0.distance (l_line)) - compl_col.item = 0 then
				if (((create {P_GLOBALS_STATIC}).ctrl_x_mode.item).bit_and (13)) = 0 then
					Result := (-(107 + ((98).bit_shift_left (8))))
					l_return := True
				end
			end
			if not l_return then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col <= compl_col.item + (create {P_GLOBALS_STATIC}).compl_length.item then
					ins_compl_restart
				elseif compl_was_interrupted.item.to_boolean then
					ins_compl_restart
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_leader.item))
				compl_leader.item := (create {P_MISC2_STATIC}).vim_strnsave (l_line + compl_col.item, (l_p___0.distance (l_line)) - compl_col.item)
				if not compl_leader.item.is_void then
					ins_compl_new_leader
					Result := (('%/0/').code)
					l_return := True
				end
			end
			if not l_return then
				Result := (-(107 + ((98).bit_shift_left (8))))
			end
		end

	ins_compl_new_leader
		do
			ins_compl_del_pum
			ins_compl_delete;
			(create {P_MISC1_STATIC}).ins_bytes (compl_leader.item + (ins_compl_len))
			compl_used_match.item := 0
			if compl_started.item.to_boolean then
				ins_compl_set_original_text (compl_leader.item)
			else
				spell_bad_len.item := 0;
				(create {P_SCREEN_STATIC}).update_screen (0)
				if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
					(create {P_SCREEN_STATIC}).setcursor;
					(create {P_TERM_STATIC}).out_flush;
					(create {P_GUI_STATIC}).gui_update_cursor (0, 0)
				end
				compl_restarting.item := 1
				if (ins_complete (14)) = 0 then
					(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
				end
				compl_restarting.item := 0
			end
			compl_enter_selects.item := (not compl_used_match.item.to_boolean).to_integer
			ins_compl_show_pum
			if compl_match_array.item.is_void then
				compl_enter_selects.item := 0
			end
		end

	ins_compl_len: INTEGER_32
		local
			l_off___0: INTEGER_32
			l_return: BOOLEAN
		do
			l_off___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - compl_col.item
			if l_off___0 < 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := l_off___0
			end
		end

	ins_compl_addleader (a_c: INTEGER_32)
		local
			l_cc___0: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<22>>)

			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_cc___0 := (create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([a_c])
				if l_cc___0 > 1 then
					(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([a_c, l_buf___6])
					l_buf___6[l_cc___0] := (('%/0/').code).to_natural_8;
					(create {P_MISC1_STATIC}).ins_char_bytes (l_buf___6, l_cc___0)
				else
					(create {P_MISC1_STATIC}).ins_char (a_c)
				end
			else
				(create {P_MISC1_STATIC}).ins_char (a_c)
			end
			if compl_was_interrupted.item.to_boolean then
				ins_compl_restart
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_leader.item))
			compl_leader.item := (create {P_MISC2_STATIC}).vim_strnsave (((create {P_MEMLINE_STATIC}).ml_get_curline) + compl_col.item, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - compl_col.item)
			if not compl_leader.item.is_void then
				ins_compl_new_leader
			end
		end

	ins_compl_restart
		do
			ins_compl_free
			compl_started.item := 0
			compl_matches.item := 0;
			(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
			compl_cont_mode.item := 0
		end

	ins_compl_set_original_text (a_str___1: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			if ((compl_first_match.item.item.cp_flags).bit_and (1)).to_boolean then
				l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (a_str___1)
				if not l_p___0.is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_first_match.item.item.cp_str))
					compl_first_match.item.item.cp_str := l_p___0
				end
			end
		end

	ins_compl_addfrommatch
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_cp: CE_POINTER [PD_COMPL_S]
			l_return, l_break: BOOLEAN
		do
			l_len := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - compl_col.item
			l_p___0 := compl_shown_match.item.item.cp_str
			if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32 <= l_len then
				if ((compl_shown_match.item.item.cp_flags).bit_and (1)).to_boolean then
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_cp := compl_shown_match.item.item.cp_next
					from
					until
						(l_break)
					loop
						l_break := False
						if not l_cp.is_void then
							if l_cp.is_equal (compl_first_match.item) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if compl_leader.item.is_void then
								l_p___0 := l_cp.item.cp_str
								l_break := True
							elseif (l_cp.item.ins_compl_equal (compl_leader.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_leader.item))).to_integer_32)).to_boolean then
								l_p___0 := l_cp.item.cp_str
								l_break := True
							end
						end
						if not (l_break) then
							l_cp := l_cp.item.cp_next
						end
					end
					l_break := False
					if l_p___0.is_void then
						l_return := True
					elseif (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32 <= l_len then
						l_return := True
					end
				else
					l_return := True
				end
			end
			if not l_return then
				l_p___0 := l_p___0 + l_len
				l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
				ins_compl_addleader (l_c)
			end
		end

	ins_compl_prep (a_c: INTEGER_32): INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_want_cindent: INTEGER_32
			l_retval: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_temp: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___8: INTEGER_32
			l_prev_col___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					if a_c /= 18 then
						if (vim_is_ctrl_x_key (a_c)).to_boolean then
							(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
					end
					if a_c = -(245 + ((88).bit_shift_left (8))) then
						Result := l_retval
						l_return := True
					elseif a_c = -(253 + ((75).bit_shift_left (8))) then
						Result := l_retval
						l_return := True
					elseif a_c = -(253 + ((76).bit_shift_left (8))) then
						Result := l_retval
						l_return := True
					elseif a_c = -(253 + ((77).bit_shift_left (8))) then
						Result := l_retval
						l_return := True
					elseif a_c = -(253 + ((78).bit_shift_left (8))) then
						Result := l_retval
						l_return := True
					end
					if l_return then
						l_pos := -1 + 54 -- skip if block
					end
				when 1 then -- if:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 1 then
							l_tmp___0 := (create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cot.item.item, ('l').code)
							compl_get_longest.item := (not l_tmp___0.is_void).to_integer
							compl_used_match.item := 1
						elseif (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 0 then
							if not compl_started.item.to_boolean then
								l_tmp___0 := (create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cot.item.item, ('l').code)
								compl_get_longest.item := (not l_tmp___0.is_void).to_integer
								compl_used_match.item := 1
							end
						end
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 2 then -- if:
						inspect a_c -- switch 1 head
						when 5 then l_pos := -1 + 3
						when 25 then l_pos := -1 + 3
						when 12 then l_pos := -1 + 4
						when 6 then l_pos := -1 + 5
						when 11 then l_pos := -1 + 6
						when 18 then l_pos := -1 + 7
						when 20 then l_pos := -1 + 8
						when 21 then l_pos := -1 + 9
						when 15 then l_pos := -1 + 10
						when 115 then l_pos := -1 + 11
						when 19 then l_pos := -1 + 11
						when 29 then l_pos := -1 + 12
						when 9 then l_pos := -1 + 13
						when -17003 then l_pos := -1 + 13 -- -(107 + ((66).bit_shift_left (8)))
						when 4 then l_pos := -1 + 14
						when 22 then l_pos := -1 + 15
						when 17 then l_pos := -1 + 15
						when 16 then l_pos := -1 + 16
						when 14 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 3 then -- switch 1, case 5 | switch 1, case 25;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 2
						if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
							(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" (insert) Scroll (^E/^Y)"))))
						else
							(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" (replace) Scroll (^E/^Y)"))))
						end
						(create {P_GLOBALS_STATIC}).edit_submode_pre.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_SCREEN_STATIC}).showmode.do_nothing
						l_pos := -1 + 18 -- switch 1; break
				when 4 then -- switch 1, case 12;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 3
						l_pos := -1 + 18 -- switch 1; break
				when 5 then -- switch 1, case 6;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 4
						l_pos := -1 + 18 -- switch 1; break
				when 6 then -- switch 1, case 11;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 265
						l_pos := -1 + 18 -- switch 1; break
				when 7 then -- switch 1, case 18
						l_pos := -1 + 18 -- switch 1; break
				when 8 then -- switch 1, case 20;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 266
						l_pos := -1 + 18 -- switch 1; break
				when 9 then -- switch 1, case 21;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 12
						l_pos := -1 + 18 -- switch 1; break
				when 10 then -- switch 1, case 15;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 13
						l_pos := -1 + 18 -- switch 1; break
				when 11 then -- switch 1, case 115 | switch 1, case 19;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 14;
						(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item + 1
						spell_back_to_badword;
						(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item - 1
						l_pos := -1 + 18 -- switch 1; break
				when 12 then -- switch 1, case 29;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 261
						l_pos := -1 + 18 -- switch 1; break
				when 13 then -- switch 1, case 9 | switch 1, case -(107 + (66 << 8));
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 262
						l_pos := -1 + 18 -- switch 1; break
				when 14 then -- switch 1, case 4;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 263
						l_pos := -1 + 18 -- switch 1; break
				when 15 then -- switch 1, case 22 | switch 1, case 17;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 11
						l_pos := -1 + 18 -- switch 1; break
				when 16 then -- switch 1, case 16 | switch 1, case 14
						if not (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (6)).to_boolean then
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_or ((32))
						elseif compl_cont_mode.item /= 0 then
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((-33))
						end
				when 17 then -- switch 1, default:
						if a_c = 24 then
							if compl_cont_mode.item /= 0 then
								(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
							else
								compl_cont_mode.item := 1
							end
						end
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 0;
						(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
						(create {P_SCREEN_STATIC}).showmode.do_nothing
						l_pos := -1 + 18 -- switch 1; break
				when 18 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
							if not (vim_is_ctrl_x_key (a_c)).to_boolean then
								if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 2 then
									(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 0
								else
									(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 8
								end
								(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
							(create {P_SCREEN_STATIC}).showmode.do_nothing
						end
				when 20 then -- if done
						if not (compl_started.item.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L___9
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 23 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 8 then
							l_pos := -1 + 53 -- skip if block
						end
				when 24 then -- if: | _L___9:;
						(create {P_SCREEN_STATIC}).showmode.do_nothing
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if a_c /= 14 then
							if a_c /= 16 then
								if a_c /= 18 then
									if (ins_compl_pum_key (a_c)).to_boolean then
										l_pos := -1 + 27 -- goto _L___8
									else
										l_pos := -1 + 28 -- goto _L___4
									end
								else
									l_pos := -1 + 27 -- goto _L___8
								end
							else
								l_pos := -1 + 27 -- goto _L___8
							end
						else
							l_pos := -1 + 27 -- goto _L___8
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 27 then -- else: | _L___8:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 8 then
							l_pos := -1 + 53 -- skip if block
						end
				when 28 then -- if: | _L___4:
						if compl_curr_match.item.is_void then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 35 -- goto _L___1
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 31 then -- else:
						if compl_leader.item.is_void then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 35 -- goto _L___1
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 34 then -- else:
						if a_c /= 5 then
							l_pos := -1 + 40 -- skip if block
						end
				when 35 then -- if: | _L___1:
						l_temp := 0
						if compl_curr_match.item.is_void then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						if compl_used_match.item.to_boolean then
							if a_c /= 5 then
								l_ptr := compl_curr_match.item.item.cp_str
							else
								l_pos := -1 + 38 -- goto _L___0
							end
						else
							l_pos := -1 + 38 -- goto _L___0
						end
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else: | _L___0:
						if not compl_leader.item.is_void then
							l_ptr := compl_leader.item
						else
							l_ptr := compl_orig_text.item
						end
				when 39 then
						if not compl_orig_text.item.is_void then
							l_p___0 := compl_orig_text.item
							l_temp := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_p___0[l_temp]).to_integer_32 /= 0 then
									if (l_p___0[l_temp]).to_integer_32 /= (l_ptr[l_temp]).to_integer_32 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_temp := l_temp + 1
								end
							end
							l_break := False
							if l_temp > 0 then
								l_temp := l_temp - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([compl_orig_text.item, l_p___0 + l_temp]))
							end
							l_p___0 := l_p___0 + l_temp
							from
							until
								(l_p___0.item).to_integer_32 = 0
							loop
								(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (-(107 + ((98).bit_shift_left (8))))
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___6 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
								else
									l_tmp___6 := 1
								end
								l_p___0 := l_p___0 + l_tmp___6
							end
						end
						if not l_ptr.is_void then
							(create {P_GETCHAR_STATIC}).AppendToRedobuffLit (l_ptr + l_temp, -1)
						end
				when 40 then -- if done | if done
						if can_cindent.item.to_boolean then
							if (cindent_on).to_boolean then
								l_tmp___8 := 1
							else
								l_tmp___8 := 0
							end
						else
							l_tmp___8 := 0
						end
						l_want_cindent := l_tmp___8
						if compl_cont_mode.item = 3 then
							if l_want_cindent.to_boolean then
								(create {P_MISC1_STATIC}).do_c_expr_indent
								l_want_cindent := 0
							end
						else
							l_prev_col___2 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							if l_prev_col___2 > 0 then
								(create {P_MISC2_STATIC}).dec_cursor.do_nothing
							end
							if (stop_arrow) = 1 then
								insertchar (('%/0/').code, 0, -1)
							end
							if l_prev_col___2 > 0 then
								if (((create {P_MEMLINE_STATIC}).ml_get_curline)[(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col]).to_integer_32 /= 0 then
									(create {P_MISC2_STATIC}).inc_cursor.do_nothing
								end
							end
						end
						if a_c /= 25 then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_pos := -1 + 51 -- goto _L___3
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 43 then -- else:
						if not (compl_enter_selects.item.to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 44 then -- if:
						if a_c /= 13 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						l_pos := -1 + 51 -- goto _L___3
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 47 then -- else:
						if a_c /= -(75 + ((65).bit_shift_left (8))) then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						l_pos := -1 + 51 -- goto _L___3
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 50 then -- else:
						if a_c /= 10 then
							l_pos := -1 + 52 -- skip if block
						end
				when 51 then -- if: | _L___3:
						if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
							l_retval := 1
						end
				when 52 then -- if done | if done | if done | if done
						if a_c = 5 then
							ins_compl_delete
							if not compl_leader.item.is_void then
								(create {P_MISC1_STATIC}).ins_bytes (compl_leader.item + (ins_compl_len))
							elseif not compl_first_match.item.is_void then
								(create {P_MISC1_STATIC}).ins_bytes (compl_orig_text.item + (ins_compl_len))
							end
							l_retval := 1
						end
						auto_format (0, 1)
						ins_compl_free
						compl_started.item := 0
						compl_matches.item := 0;
						(create {P_MESSAGE_STATIC}).msg_clr_cmdline;
						(create {P_GLOBALS_STATIC}).ctrl_x_mode.item := 0
						compl_enter_selects.item := 0
						if not ((create {P_GLOBALS_STATIC}).edit_submode.item).is_void then
							(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
							(create {P_SCREEN_STATIC}).showmode.do_nothing
						end
						if l_want_cindent.to_boolean then
							if (in_cinkeys (259, (' ').code, ((create {P_MISC1_STATIC}).inindent (0)))).to_boolean then
								(create {P_MISC1_STATIC}).do_c_expr_indent
							end
						end
				when 53 then -- if done | if done | if done
						if not (vim_is_ctrl_x_key (a_c)).to_boolean then
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
							compl_cont_mode.item := 0
						end
						Result := l_retval
				when 54 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_next_buf (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_flag: INTEGER_32): CE_POINTER [PD_FILE_BUFFER]
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_buf___6 := a_buf___6
			if a_flag = 119 then
				if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
					wp.item := (create {P_GLOBALS_STATIC}).curwin.item
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if not (wp.item.item.w_next).is_void then
						wp.item := wp.item.item.w_next
					else
						wp.item := (create {P_GLOBALS_STATIC}).firstwin.item
					end
					if not wp.item.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
						if not ((wp.item.item.w_buffer).item.b_scanned).to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
				end
				l_break := False
				l_buf___6 := wp.item.item.w_buffer
			else
				from
				until
					(l_break)
				loop
					l_break := False
					if not (l_buf___6.item.b_next).is_void then
						l_buf___6 := l_buf___6.item.b_next
					else
						l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
					end
					if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
						if a_flag = 85 then
							l_tmp___0 := l_buf___6.item.b_p_bl
						else
							if not (l_buf___6.item.b_p_bl).to_boolean then
								l_tmp := 1
							elseif ((l_buf___6.item.b_ml.ml_mfp).is_void) /= (a_flag = 117) then
								l_tmp := 1
							else
								l_tmp := 0
							end
							l_tmp___0 := l_tmp
						end
						if not l_tmp___0.to_boolean then
							if not (l_buf___6.item.b_scanned).to_boolean then
								l_break := True
							end
						end
					else
						l_break := True
					end
				end
				l_break := False
			end
			Result := l_buf___6
		end

	expand_by_function (a_type: INTEGER_32; a_base: CE_POINTER [NATURAL_8])
		local
			l_matchlist: CE_POINTER [PD_LISTVAR_S]
			l_args: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_funcname: CE_POINTER [NATURAL_8]
			l_pos___3: PD_POS_T
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_args.make (<<2>>)

			if a_type = 12 then
				l_funcname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cfu
			else
				l_funcname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ofu
			end
			if (l_funcname.item).to_integer_32 = 0 then
				l_return := True
			end
			if not l_return then
				l_args[0] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("0"))
				l_args[1] := a_base
				l_pos___3 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				l_matchlist := create {CE_CLASS_POINTER [PD_LISTVAR_S]}.make_cast (((create {P_EVAL_STATIC}).call_func_retlist (l_funcname, 2, l_args, 0)));
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___3.twin
				if l_matchlist.is_void then
					l_return := True
				end
			end
			if not l_return then
				l_matchlist.item.ins_compl_add_list;
				(create {P_EVAL_STATIC}).list_unref (l_matchlist)
			end
		end

	ins_compl_get_exp (a_ini: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_pos___3: CE_POINTER [PD_POS_T]
			l_matches___0: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_save_p_scs: INTEGER_32
			l_save_p_ws: INTEGER_32
			l_save_p_ic: INTEGER_32
			l_i___0: INTEGER_32
			l_num_matches___0: CE_ARRAY [INTEGER_32]
			l_len: INTEGER_32
			l_found_new_match: INTEGER_32
			l_type: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_dict: CE_POINTER [NATURAL_8]
			l_dict_f: INTEGER_32
			l_old_match: CE_POINTER [PD_COMPL_S]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_flags___0: INTEGER_32
			l_tmp_ptr: CE_POINTER [NATURAL_8]
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_matches___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_num_matches___0.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_ptr.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_type := (create {P_GLOBALS_STATIC}).ctrl_x_mode.item
					l_dict := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_dict_f := 0
					if not compl_started.item.to_boolean then
						ins_buf.item := (create {P_GLOBALS_STATIC}).firstbuf.item
						from
						until
							ins_buf.item.is_void
						loop
							ins_buf.item.item.b_scanned := 0
							ins_buf.item := ins_buf.item.item.b_next
						end
						found_all.item := 0
						ins_buf.item := (create {P_GLOBALS_STATIC}).curbuf.item
						if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (32)).to_boolean then
							e_cpt.item.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("."))
						else
							e_cpt.item.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cpt
						end
						first_match_pos.item.item := (a_ini.item).twin
						last_match_pos.item.item := (first_match_pos.item.item).twin
					end
					l_old_match := compl_curr_match.item
					if compl_direction.item = 1 then
						l_pos___3 := last_match_pos.item
					else
						l_pos___3 := first_match_pos.item
					end
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 54 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						l_found_new_match := 0
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___3
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 5 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
							l_pos := -1 + 30 -- skip if block
						end
				when 6 then -- if: | _L___3:
						if compl_started.item.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___2
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 9 then -- else:
						if not (found_all.item.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 10 then -- if: | _L___2:
						found_all.item := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if (e_cpt.item.item.item).to_integer_32 /= 44 then
								if (e_cpt.item.item.item).to_integer_32 /= 32 then
									l_break := True
								end
							end
							if not (l_break) then
								e_cpt.item.item := e_cpt.item.item + 1
							end
						end
						l_break := False
						if (e_cpt.item.item.item).to_integer_32 /= 46 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_scanned).to_boolean then
							ins_buf.item := (create {P_GLOBALS_STATIC}).curbuf.item
							first_match_pos.item.item := (a_ini.item).twin
							if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 0 then
								first_match_pos.item.item.dec.do_nothing
							end
							last_match_pos.item.item := (first_match_pos.item.item).twin
							l_type := 0
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 13 then -- else: | _L___1:
						if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("buwU")), (e_cpt.item.item.item).to_integer_32)).is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						ins_buf.item := ins_compl_next_buf (ins_buf.item, (e_cpt.item.item.item).to_integer_32)
						if not ins_buf.item.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							if not (ins_buf.item.item.b_ml.ml_mfp).is_void then
								compl_started.item := 1
								last_match_pos.item.item.col := 0
								first_match_pos.item.item.col := last_match_pos.item.item.col
								first_match_pos.item.item.lnum := ins_buf.item.item.b_ml.ml_line_count + 1
								last_match_pos.item.item.lnum := (0).to_integer_32
								l_type := 0
							else
								found_all.item := 1
								if (ins_buf.item.item.b_fname).is_void then
									l_continue := True
								end
								if not (l_return or l_break or l_continue) then
									l_type := 265
									l_dict := ins_buf.item.item.b_fname
									l_dict_f := 2
								end
							end
							if not (l_return or l_break or l_continue) then
								if (ins_buf.item.item.b_fname).is_void then
									l_tmp___1 := (ins_buf.item.item.buf_spname)
								else
									if (ins_buf.item.item.b_sfname).is_void then
										l_tmp___0 := create {CE_INTEGER_8_POINTER}.make_cast (ins_buf.item.item.b_fname)
									else
										l_tmp___0 := create {CE_INTEGER_8_POINTER}.make_cast (ins_buf.item.item.b_sfname)
									end
									l_tmp___1 := l_tmp___0
								end
								(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, (gettext (ce_string ("Scanning: %%s"))), l_tmp___1]).do_nothing;
								(create {P_MESSAGE_STATIC}).msg_trunc_attr ((create {P_GLOBALS_STATIC}).IObuff.item, 1, (create {P_GLOBALS_STATIC}).highlight_attr.item[10]).do_nothing
							end
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 16 then -- else: | _L___0:
						if (e_cpt.item.item.item).to_integer_32 /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_break := True
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 19 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_type := -1
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else:
						if (e_cpt.item.item.item).to_integer_32 /= 107 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 25 then -- else:
						if (e_cpt.item.item.item).to_integer_32 /= 115 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L:
						if (e_cpt.item.item.item).to_integer_32 = 107 then
							l_type := 265
						else
							l_type := 266
						end
						e_cpt.item.item := e_cpt.item.item + 1
						if (e_cpt.item.item.item).to_integer_32 /= 44 then
							if (e_cpt.item.item.item).to_integer_32 /= 0 then
								l_dict := e_cpt.item.item
								l_dict_f := 1
							end
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						if (e_cpt.item.item.item).to_integer_32 = 105 then
							l_type := 262
						elseif (e_cpt.item.item.item).to_integer_32 = 100 then
							l_type := 263
						elseif (e_cpt.item.item.item).to_integer_32 = 93 then
							l_type := 261
							l_tmp___3 := gettext (ce_string ("Scanning tags."));
							(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, l_tmp___3]).do_nothing;
							(create {P_MESSAGE_STATIC}).msg_trunc_attr ((create {P_GLOBALS_STATIC}).IObuff.item, 1, (create {P_GLOBALS_STATIC}).highlight_attr.item[10]).do_nothing
						elseif (e_cpt.item.item.item).to_integer_32 = 116 then
							l_type := 261
							l_tmp___3 := gettext (ce_string ("Scanning tags."));
							(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, l_tmp___3]).do_nothing;
							(create {P_MESSAGE_STATIC}).msg_trunc_attr ((create {P_GLOBALS_STATIC}).IObuff.item, 1, (create {P_GLOBALS_STATIC}).highlight_attr.item[10]).do_nothing
						else
							l_type := -1
						end
				when 29 then -- if done | if done;
						(create {P_MISC2_STATIC}).copy_option_part (e_cpt.item, (create {P_GLOBALS_STATIC}).IObuff.item, 1_025, ce_string (",")).do_nothing
						found_all.item := 1
						if l_type = -1 then
							l_continue := True
						end
				when 30 then -- if done | if done | if done | if done | if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 53 -- skip if block
						end
				when 31 then -- if:
						inspect l_type -- switch 1 head
						when -1 then l_pos := -1 + 32 -- -1
						when 262 then l_pos := -1 + 33
						when 263 then l_pos := -1 + 33
						when 265 then l_pos := -1 + 34
						when 266 then l_pos := -1 + 34
						when 261 then l_pos := -1 + 35
						when 4 then l_pos := -1 + 36
						when 11 then l_pos := -1 + 37
						when 12 then l_pos := -1 + 38
						when 13 then l_pos := -1 + 38
						when 14 then l_pos := -1 + 39
						else l_pos := -1 + 40
						end
				when 32 then -- switch 1, case -1
						l_pos := -1 + 41 -- switch 1; break
				when 33 then -- switch 1, case 262 | switch 1, case 263
						if l_type = 263 then
							if not (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (16)).to_boolean then
								l_tmp___5 := 2
							else
								l_tmp___5 := 1
							end
						else
							l_tmp___5 := 1
						end
						(create {P_SEARCH_STATIC}).find_pattern_in_path (compl_pattern.item.item, compl_direction.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_pattern.item.item))).to_integer_32, 0, 0, l_tmp___5, 1, 5, (1).to_integer_32, 2_147_483_647)
						l_pos := -1 + 41 -- switch 1; break
				when 34 then -- switch 1, case 265 | switch 1, case 266
						if not l_dict.is_void then
							l_tmp___7 := l_dict_f
						else
							l_tmp___7 := 0
						end
						if not l_dict.is_void then
							l_tmp___11 := l_dict
						else
							if l_type = 266 then
								if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tsr).item).to_integer_32 = 0 then
									l_tmp___8 := (create {P_OPTION_STATIC}).p_tsr.item.item
								else
									l_tmp___8 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tsr
								end
								l_tmp___10 := l_tmp___8
							else
								if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_dict).item).to_integer_32 = 0 then
									l_tmp___9 := (create {P_OPTION_STATIC}).p_dict.item.item
								else
									l_tmp___9 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_dict
								end
								l_tmp___10 := l_tmp___9
							end
							l_tmp___11 := l_tmp___10
						end
						ins_compl_dictionaries (l_tmp___11, compl_pattern.item.item, l_tmp___7, (l_type = 266).to_integer)
						l_dict := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_pos := -1 + 41 -- switch 1; break
				when 35 then -- switch 1, case 261
						l_save_p_ic := (create {P_OPTION_STATIC}).p_ic.item.item;
						(create {P_OPTION_STATIC}).p_ic.item.item := (create {P_SEARCH_STATIC}).ignorecase (compl_pattern.item.item)
						if ((create {P_GLOBALS_STATIC}).ctrl_x_mode.item).to_boolean then
							l_tmp___12 := 32
						else
							l_tmp___12 := 0
						end
						if ((create {P_TAG_STATIC}).find_tags (compl_pattern.item.item, l_num_matches___0, l_matches___0, (78).bit_or (l_tmp___12), 300, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)) = 1 then
							if l_num_matches___0.item > 0 then
								ins_compl_add_matches (l_num_matches___0.item, l_matches___0.item, (create {P_OPTION_STATIC}).p_ic.item.item)
							end
						end
						(create {P_OPTION_STATIC}).p_ic.item.item := l_save_p_ic
						l_pos := -1 + 41 -- switch 1; break
				when 36 then -- switch 1, case 4
						if ((create {P_MISC1_STATIC}).expand_wildcards (1, compl_pattern.item, l_num_matches___0, l_matches___0, 43)) = 1 then
							(create {P_EX_GETLN_STATIC}).tilde_replace (compl_pattern.item.item, l_num_matches___0.item, l_matches___0.item)
							ins_compl_add_matches (l_num_matches___0.item, l_matches___0.item, 0)
						end
						l_pos := -1 + 41 -- switch 1; break
				when 37 then -- switch 1, case 11
						if (compl_xp.item.item.expand_cmdline (compl_pattern.item.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_pattern.item.item))).to_integer_32, l_num_matches___0, l_matches___0)) = -1 then
							ins_compl_add_matches (l_num_matches___0.item, l_matches___0.item, 0)
						end
						l_pos := -1 + 41 -- switch 1; break
				when 38 then -- switch 1, case 12 | switch 1, case 13
						expand_by_function (l_type, compl_pattern.item.item)
						l_pos := -1 + 41 -- switch 1; break
				when 39 then -- switch 1, case 14
						l_num_matches___0.item := (create {P_SPELL_STATIC}).expand_spelling (first_match_pos.item.item.lnum, compl_pattern.item.item, l_matches___0)
						if l_num_matches___0.item > 0 then
							ins_compl_add_matches (l_num_matches___0.item, l_matches___0.item, (create {P_OPTION_STATIC}).p_ic.item.item)
						end
						l_pos := -1 + 41 -- switch 1; break
				when 40 then -- switch 1, default:
						l_save_p_scs := (create {P_OPTION_STATIC}).p_scs.item.item
						if (ins_buf.item.item.b_p_inf).to_boolean then
							(create {P_OPTION_STATIC}).p_scs.item.item := 0
						end
						l_save_p_ws := (create {P_OPTION_STATIC}).p_ws.item.item
						if not ins_buf.item.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							(create {P_OPTION_STATIC}).p_ws.item.item := 0
						elseif (e_cpt.item.item.item).to_integer_32 = 46 then
							(create {P_OPTION_STATIC}).p_ws.item.item := 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							l_continue := False
							l_flags___0 := 0;
							(create {P_GLOBALS_STATIC}).msg_silent.item := (create {P_GLOBALS_STATIC}).msg_silent.item + 1
							if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 3 then
								l_found_new_match := ins_buf.item.item.search_for_exact_line (l_pos___3, compl_direction.item, compl_pattern.item.item)
							elseif (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (16)).to_boolean then
								l_found_new_match := ins_buf.item.item.search_for_exact_line (l_pos___3, compl_direction.item, compl_pattern.item.item)
							else
								l_found_new_match := (create {P_SEARCH_STATIC}).searchit (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), ins_buf.item, l_pos___3, compl_direction.item, compl_pattern.item.item, 1, 1_032, 2, (0).to_integer_32, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
							end
							(create {P_GLOBALS_STATIC}).msg_silent.item := (create {P_GLOBALS_STATIC}).msg_silent.item - 1
							if not compl_started.item.to_boolean then
								compl_started.item := 1
								first_match_pos.item.item := (l_pos___3.item).twin
								last_match_pos.item.item := (l_pos___3.item).twin
							elseif first_match_pos.item.item.lnum = last_match_pos.item.item.lnum then
								if first_match_pos.item.item.col = last_match_pos.item.item.col then
									l_found_new_match := 0
								end
							end
							if l_found_new_match = 0 then
								if ins_buf.item.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
									found_all.item := 1
								end
								l_break := True
							end
							if not (l_break or l_continue) and then ((((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean) then
								if ins_buf.item.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
									if a_ini.item.lnum = l_pos___3.item.lnum then
										if a_ini.item.col = l_pos___3.item.col then
											l_continue := True
										end
									end
								end
							end
							if not (l_break or l_continue) then
								l_ptr := (ins_buf.item.item.ml_get_buf (l_pos___3.item.lnum, 0)) + l_pos___3.item.col
								if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 3 then
									if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
										if l_pos___3.item.lnum >= ins_buf.item.item.b_ml.ml_line_count then
											l_continue := True
										end
										if not (l_break or l_continue) then
											l_ptr := ins_buf.item.item.ml_get_buf (l_pos___3.item.lnum + 1, 0)
											if not ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
												l_ptr := (create {P_CHARSET_STATIC}).skipwhite (l_ptr)
											end
										end
									end
									if not (l_break or l_continue) then
										l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32
									end
								else
									l_tmp_ptr := l_ptr
									if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
										l_tmp_ptr := l_tmp_ptr + ((create {P_GLOBALS_STATIC}).compl_length.item)
										if ((create {P_CHARSET_STATIC}).vim_iswordp (l_tmp_ptr)).to_boolean then
											l_continue := True
										end
										if not (l_break or l_continue) then
											l_tmp_ptr := find_word_start (l_tmp_ptr)
										end
									end
									if not (l_break or l_continue) then
										l_tmp_ptr := find_word_end (l_tmp_ptr)
										l_len := l_tmp_ptr.distance (l_ptr)
										if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
											if l_len = (create {P_GLOBALS_STATIC}).compl_length.item then
												if l_pos___3.item.lnum < ins_buf.item.item.b_ml.ml_line_count then
													strncpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), l_len.to_natural_32).do_nothing
													l_ptr := ins_buf.item.item.ml_get_buf (l_pos___3.item.lnum + 1, 0)
													l_ptr := (create {P_CHARSET_STATIC}).skipwhite (l_ptr)
													l_tmp_ptr := l_ptr
													l_tmp_ptr := find_word_start (l_tmp_ptr)
													l_tmp_ptr := find_word_end (l_tmp_ptr)
													if (l_tmp_ptr.c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
														if (l_ptr.item).to_integer_32 /= 41 then
															if ((create {P_GLOBALS_STATIC}).IObuff.item[(l_len - 1)]).to_integer_32 /= 9 then
																if ((create {P_GLOBALS_STATIC}).IObuff.item[(l_len - 1)]).to_integer_32 /= 32 then
																	l_tmp___20 := l_len
																	l_len := l_len + 1;
																	(create {P_GLOBALS_STATIC}).IObuff.item[l_tmp___20] := ((' ').code).to_natural_8
																end
																if ((create {P_OPTION_STATIC}).p_js.item.item).to_boolean then
																	if ((create {P_GLOBALS_STATIC}).IObuff.item[(l_len - 2)]).to_integer_32 = 46 then
																		l_tmp___21 := l_len
																		l_len := l_len + 1;
																		(create {P_GLOBALS_STATIC}).IObuff.item[l_tmp___21] := ((' ').code).to_natural_8
																	elseif ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('j').code)).is_void then
																		if ((create {P_GLOBALS_STATIC}).IObuff.item[(l_len - 2)]).to_integer_32 = 63 then
																			l_tmp___21 := l_len
																			l_len := l_len + 1;
																			(create {P_GLOBALS_STATIC}).IObuff.item[l_tmp___21] := ((' ').code).to_natural_8
																		elseif ((create {P_GLOBALS_STATIC}).IObuff.item[(l_len - 2)]).to_integer_32 = 33 then
																			l_tmp___21 := l_len
																			l_len := l_len + 1;
																			(create {P_GLOBALS_STATIC}).IObuff.item[l_tmp___21] := ((' ').code).to_natural_8
																		end
																	end
																end
															end
														end
														if l_tmp_ptr.distance (l_ptr) >= 1_025 - l_len then
															l_tmp_ptr := ((l_ptr + 1_025) - l_len) - 1
														end
														strncpy (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).IObuff.item + l_len)), create {CE_INTEGER_8_POINTER}.make_cast (l_ptr), (l_tmp_ptr.distance (l_ptr)).to_natural_32).do_nothing
														l_len := l_len + (l_tmp_ptr.distance (l_ptr))
														l_flags___0 := (l_flags___0).bit_or ((8))
													end
													(create {P_GLOBALS_STATIC}).IObuff.item[l_len] := (('%/0/').code).to_natural_8
													l_ptr := (create {P_GLOBALS_STATIC}).IObuff.item
												end
												if l_len = (create {P_GLOBALS_STATIC}).compl_length.item then
													l_continue := True
												end
											end
										end
									end
								end
							end
							if not (l_break or l_continue) then
								if ins_buf.item.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
									l_tmp___23 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								else
									l_tmp___23 := ins_buf.item.item.b_sfname
								end
								if (ins_compl_add_infercase (l_ptr, l_len, (create {P_OPTION_STATIC}).p_ic.item.item, l_tmp___23, 0, l_flags___0)) /= 2 then
									l_found_new_match := 1
									l_break := True
								end
							end
							if (not l_break) then
								
							end
						end
						l_break := False
						l_continue := False;
						(create {P_OPTION_STATIC}).p_scs.item.item := l_save_p_scs;
						(create {P_OPTION_STATIC}).p_ws.item.item := l_save_p_ws
				when 41 then -- switch 1, done:
						if l_type /= 0 then
							if not compl_curr_match.item.is_equal (l_old_match) then
								l_found_new_match := 1
							end
						end
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 0 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
							l_pos := -1 + 45 -- goto _L___5
						else
							l_pos := -1 + 44 -- goto _L___6
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 44 then -- else: | _L___6:
						if l_found_new_match = 0 then
							l_pos := -1 + 52 -- skip if block
						end
				when 45 then -- if: | _L___5:
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 50 -- skip if block
						end
				when 46 then -- if:
						if l_type /= -1 then
							ins_compl_check_keys (0)
						end
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 0 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
							l_break := True
						else
							l_pos := -1 + 49 -- goto _L___4
						end
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else: | _L___4:
						if ((create {P_GLOBALS_STATIC}).compl_interrupted.item).to_boolean then
							l_break := True
						end
				when 50 then -- if done
						if not (l_return or l_break or l_continue) then
							compl_started.item := 1
						end
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 52 then -- else:
						if l_type = 0 then
							ins_buf.item.item.b_scanned := 1
						elseif l_type = 262 then
							ins_buf.item.item.b_scanned := 1
						end
						compl_started.item := 0
				when 53 then -- if done | if done
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 54 then -- loop done
					l_break := False
					l_continue := False
					compl_started.item := 1
					if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
						l_pos := -1 + 57 -- skip if block
					end
				when 55 then -- if:
						l_pos := -1 + 58 -- goto _L___7
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 57 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
							l_pos := -1 + 59 -- skip if block
						end
				when 58 then -- if: | _L___7:
						if (e_cpt.item.item.item).to_integer_32 = 0 then
							l_found_new_match := 0
						end
				when 59 then -- if done
					l_i___0 := -1
					if l_found_new_match = 0 then
						l_i___0 := ins_compl_make_cyclic
					elseif (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
							l_i___0 := ins_compl_make_cyclic
						end
					end
					if compl_direction.item = 1 then
						compl_curr_match.item := l_old_match.item.cp_next
					else
						compl_curr_match.item := l_old_match.item.cp_prev
					end
					if compl_curr_match.item.is_void then
						compl_curr_match.item := l_old_match
					end
					Result := l_i___0
				when 60 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_delete
		local
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
		do
			if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
				l_tmp := (create {P_GLOBALS_STATIC}).compl_length.item
			else
				l_tmp := 0
			end
			l_i___0 := compl_col.item + l_tmp
			backspace_until_column (l_i___0);
			(create {P_MOVE_STATIC}).changed_cline_bef_curs
		end

	ins_compl_insert
		do
			(create {P_MISC1_STATIC}).ins_bytes (compl_shown_match.item.item.cp_str + (ins_compl_len))
			if ((compl_shown_match.item.item.cp_flags).bit_and (1)).to_boolean then
				compl_used_match.item := 0
			else
				compl_used_match.item := 1
			end
		end

	ins_compl_next (a_allow_get_expansion, a_count___2, a_insert_match: INTEGER_32): INTEGER_32
		local
			l_num_matches___0: INTEGER_32
			l_i___0: INTEGER_32
			l_todo: INTEGER_32
			l_found_compl: CE_POINTER [PD_COMPL_S]
			l_found_end: INTEGER_32
			l_advance: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___10: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_num_matches___0 := -1
					l_todo := a_count___2
					l_found_compl := create {CE_CLASS_POINTER [PD_COMPL_S]}.make_shared (default_pointer)
					l_found_end := 0
					if compl_leader.item.is_void then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if ((compl_shown_match.item.item.cp_flags).bit_and (1)) /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if (compl_shown_match.item.item.ins_compl_equal (compl_leader.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_leader.item))).to_integer_32)).to_boolean then
								l_break := True
							elseif not (compl_shown_match.item.item.cp_next).is_void then
								if (compl_shown_match.item.item.cp_next).is_equal (compl_first_match.item) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								compl_shown_match.item := compl_shown_match.item.item.cp_next
							end
						end
						l_break := False
						if compl_shows_dir.item /= -1 then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if (compl_shown_match.item.item.ins_compl_equal (compl_leader.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_leader.item))).to_integer_32)).to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not ((compl_shown_match.item.item.cp_next).is_void) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if not ((compl_shown_match.item.item.cp_next).is_equal (compl_first_match.item)) then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							if (compl_shown_match.item.item.ins_compl_equal (compl_leader.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_leader.item))).to_integer_32)).to_boolean then
								l_break := True
							elseif not (compl_shown_match.item.item.cp_prev).is_void then
								if (compl_shown_match.item.item.cp_prev).is_equal (compl_first_match.item) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								compl_shown_match.item := compl_shown_match.item.item.cp_prev
							end
						end
						l_break := False
				when 9 then -- if done | if done | if done | if done | if done
					if not (a_allow_get_expansion.to_boolean) then
						l_pos := -1 + 18 -- skip if block
					end
				when 10 then -- if:
						if not (a_insert_match.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 11 then -- if:
						if not (compl_get_longest.item.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						if not (compl_restarting.item.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___0:
						if compl_used_match.item.to_boolean then
							ins_compl_delete
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						ins_compl_delete
				when 18 then -- if done | if done | if done
					if a_count___2 /= 1 then
						l_tmp___5 := 1
					elseif not a_allow_get_expansion.to_boolean then
						l_tmp___5 := 1
					elseif not compl_get_longest.item.to_boolean then
						l_tmp___5 := 1
					else
						l_tmp___5 := 0
					end
					l_advance := l_tmp___5
					if compl_restarting.item.to_boolean then
						l_advance := 0
						compl_restarting.item := 0
					end
				when 19 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 30 -- skip loop
					end
				when 20 then -- loop body:
						l_break := False
						l_todo := l_todo - 1
						if not (l_todo >= 0) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 29 -- skip if block
						end
				when 21 then -- if:
						if compl_shows_dir.item /= 1 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not (compl_shown_match.item.item.cp_next).is_void then
							compl_shown_match.item := compl_shown_match.item.item.cp_next
							if not compl_first_match.item.is_void then
								if (compl_shown_match.item.item.cp_next).is_equal (compl_first_match.item) then
									l_tmp___6 := 1
								elseif compl_shown_match.item.is_equal (compl_first_match.item) then
									l_tmp___6 := 1
								else
									l_tmp___6 := 0
								end
							else
								l_tmp___6 := 0
							end
							l_found_end := l_tmp___6
						else
							l_pos := -1 + 24 -- goto _L___2
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else: | _L___2:
						if compl_shows_dir.item /= -1 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if not (compl_shown_match.item.item.cp_prev).is_void then
							l_found_end := (compl_shown_match.item.is_equal (compl_first_match.item)).to_integer
							compl_shown_match.item := compl_shown_match.item.item.cp_prev
							l_found_end := (l_found_end).bit_or ((compl_shown_match.item.is_equal (compl_first_match.item)).to_integer)
						else
							l_pos := -1 + 27 -- goto _L___1
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___1:
						if not a_allow_get_expansion.to_boolean then
							if l_advance.to_boolean then
								if compl_shows_dir.item = -1 then
									compl_pending.item := compl_pending.item - (l_todo + 1)
								else
									compl_pending.item := compl_pending.item + (l_todo + 1)
								end
							end
							Result := (-1)
							l_return := True
						end
						if not l_return then
							if l_advance.to_boolean then
								if compl_shows_dir.item = -1 then
									compl_pending.item := compl_pending.item - 1
								else
									compl_pending.item := compl_pending.item + 1
								end
							end
							l_num_matches___0 := ins_compl_get_exp (compl_startpos.item)
							from
							until
								(l_break)
							loop
								l_break := False
								if compl_pending.item /= 0 then
									if compl_direction.item = compl_shows_dir.item then
										if not l_advance.to_boolean then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									if compl_pending.item > 0 then
										if not (compl_shown_match.item.item.cp_next).is_void then
											compl_shown_match.item := compl_shown_match.item.item.cp_next
											compl_pending.item := compl_pending.item - 1
										end
									end
									if compl_pending.item < 0 then
										if not (compl_shown_match.item.item.cp_prev).is_void then
											compl_shown_match.item := compl_shown_match.item.item.cp_prev
											compl_pending.item := compl_pending.item + 1
										else
											l_break := True
										end
									else
										l_break := True
									end
								end
							end
							l_break := False
							l_found_end := 0
						end
				when 28 then -- if done
						if not l_return then
							if ((compl_shown_match.item.item.cp_flags).bit_and (1)) = 0 then
								if not compl_leader.item.is_void then
									if (compl_shown_match.item.item.ins_compl_equal (compl_leader.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_leader.item))).to_integer_32)).to_boolean then
										l_found_compl := compl_shown_match.item
									else
										l_todo := l_todo + 1
									end
								else
									l_found_compl := compl_shown_match.item
								end
							else
								l_found_compl := compl_shown_match.item
							end
							if l_found_end.to_boolean then
								if not l_found_compl.is_void then
									compl_shown_match.item := l_found_compl
									l_break := True
								end
								if not (l_return or l_break) then
									l_todo := 1
								end
							end
						end
				when 29 then -- if done
						l_pos := -1 + 19 -- back to loop condition
				when 30 then -- loop done
					if not l_return then
						l_break := False
						if a_insert_match.to_boolean then
							if not compl_get_longest.item.to_boolean then
								ins_compl_insert
							elseif compl_used_match.item.to_boolean then
								ins_compl_insert
							else
								(create {P_MISC1_STATIC}).ins_bytes (compl_leader.item + (ins_compl_len))
							end
						else
							compl_used_match.item := 0
						end
						if not a_allow_get_expansion.to_boolean then
							ins_compl_upd_pum;
							(create {P_SCREEN_STATIC}).update_screen (0)
							ins_compl_show_pum
							if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
								(create {P_SCREEN_STATIC}).setcursor;
								(create {P_TERM_STATIC}).out_flush;
								(create {P_GUI_STATIC}).gui_update_cursor (0, 0)
							end
							ins_compl_delete
						end
						if not a_insert_match.to_boolean then
							if not compl_match_array.item.is_void then
								l_tmp___10 := 1
							else
								l_tmp___10 := 0
							end
						else
							l_tmp___10 := 0
						end
						compl_enter_selects.item := l_tmp___10
						if not (compl_shown_match.item.item.cp_fname).is_void then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), ce_string ("match in file ")).do_nothing
							l_i___0 := (((create {P_CHARSET_STATIC}).vim_strsize (compl_shown_match.item.item.cp_fname)) + 16) - (create {P_GLOBALS_STATIC}).sc_col.item
							if l_i___0 <= 0 then
								l_i___0 := 0
							else
								strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), ce_string ("<")).do_nothing
							end
							strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), create {CE_INTEGER_8_POINTER}.make_cast ((compl_shown_match.item.item.cp_fname + l_i___0))).do_nothing;
							(create {P_MESSAGE_STATIC}).msg ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing;
							(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 0
						end
						Result := l_num_matches___0
					end
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_check_keys (a_frequency: INTEGER_32)
		local
			l_c: INTEGER_32
			l_tmp___0: INTEGER_32
			l_todo: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_GETCHAR_STATIC}).using_script).to_boolean then
						l_return := True
					end
					if not l_return then
						count.item := count.item + 1
						if count.item < a_frequency then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						count.item := 0
						l_c := (create {P_GETCHAR_STATIC}).vpeekc_any
						if l_c = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if not ((vim_is_ctrl_x_key (l_c)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_c /= 24 then
							if l_c /= 18 then
								l_c := (create {P_GETCHAR_STATIC}).safe_vgetc
								compl_shows_dir.item := ins_compl_key2dir (l_c)
								if l_c /= -(107 + ((117).bit_shift_left (8))) then
									if l_c /= -(107 + ((100).bit_shift_left (8))) then
										l_tmp___0 := 1
									else
										l_tmp___0 := 0
									end
								else
									l_tmp___0 := 0
								end
								ins_compl_next (0, (ins_compl_key2count (l_c)), l_tmp___0).do_nothing
							else
								l_pos := -1 + 5 -- goto _L___0
							end
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___0:
						l_c := (create {P_GETCHAR_STATIC}).safe_vgetc
						if l_c /= -(253 + ((53).bit_shift_left (8))) then
							if l_c /= 18 then
								if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
									(create {P_GLOBALS_STATIC}).compl_interrupted.item := 1
								end
							end
							(create {P_GETCHAR_STATIC}).vungetc (l_c)
						end
				when 6 then -- if done
						if compl_pending.item /= 0 then
							if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								if compl_pending.item > 0 then
									l_tmp___3 := compl_pending.item
								else
									l_tmp___3 := -compl_pending.item
								end
								l_todo := l_tmp___3
								compl_pending.item := 0
								ins_compl_next (0, l_todo, 1).do_nothing
							end
						end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_compl_key2dir (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_c = 16 then
				Result := (-1)
				l_return := True
			elseif a_c = 12 then
				Result := (-1)
				l_return := True
			elseif ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
				if a_c = -(107 + ((80).bit_shift_left (8))) then
					Result := (-1)
					l_return := True
				elseif a_c = -(75 + ((51).bit_shift_left (8))) then
					Result := (-1)
					l_return := True
				elseif a_c = -(253 + ((4).bit_shift_left (8))) then
					Result := (-1)
					l_return := True
				elseif a_c = -(107 + ((117).bit_shift_left (8))) then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Result := 1
			end
		end

	ins_compl_pum_key (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
				if a_c = -(107 + ((80).bit_shift_left (8))) then
					l_tmp___0 := 1
				elseif a_c = -(75 + ((51).bit_shift_left (8))) then
					l_tmp___0 := 1
				elseif a_c = -(253 + ((4).bit_shift_left (8))) then
					l_tmp___0 := 1
				elseif a_c = -(107 + ((78).bit_shift_left (8))) then
					l_tmp___0 := 1
				elseif a_c = -(75 + ((53).bit_shift_left (8))) then
					l_tmp___0 := 1
				elseif a_c = -(253 + ((5).bit_shift_left (8))) then
					l_tmp___0 := 1
				elseif a_c = -(107 + ((117).bit_shift_left (8))) then
					l_tmp___0 := 1
				elseif a_c = -(107 + ((100).bit_shift_left (8))) then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	ins_compl_key2count (a_c: INTEGER_32): INTEGER_32
		local
			l_h: INTEGER_32
			l_return: BOOLEAN
		do
			if (ins_compl_pum_key (a_c)).to_boolean then
				if a_c /= -(107 + ((117).bit_shift_left (8))) then
					if a_c /= -(107 + ((100).bit_shift_left (8))) then
						l_h := (create {P_POPUPMNU_STATIC}).pum_get_height
						if l_h > 3 then
							l_h := l_h - (2)
						end
						Result := l_h
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	ins_compl_use_match (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_c -- switch 1 head
					when -30059 then l_pos := -1 + 1 -- -(107 + ((117).bit_shift_left (8)))
					when -25707 then l_pos := -1 + 1 -- -(107 + ((100).bit_shift_left (8)))
					when -20075 then l_pos := -1 + 1 -- -(107 + ((78).bit_shift_left (8)))
					when -13643 then l_pos := -1 + 1 -- -(75 + ((53).bit_shift_left (8)))
					when -1533 then l_pos := -1 + 1 -- -(253 + ((5).bit_shift_left (8)))
					when -20587 then l_pos := -1 + 1 -- -(107 + ((80).bit_shift_left (8)))
					when -13131 then l_pos := -1 + 1 -- -(75 + ((51).bit_shift_left (8)))
					when -1277 then l_pos := -1 + 1 -- -(253 + ((4).bit_shift_left (8)))
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case -(107 + (117 << 8)) | switch 1, case -(107 + (100 << 8)) | switch 1, case -(107 + (78 << 8)) | switch 1, case -(75 + (53 << 8)) | switch 1, case -(253 + (5 << 8)) | switch 1, case -(107 + (80 << 8)) | switch 1, case -(75 + (51 << 8)) | switch 1, case -(253 + (4 << 8))
					Result := 0
					l_return := True
				when 2 then -- switch 1, done:
					if not l_return then
						Result := 1
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_complete (a_c: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_startcol: INTEGER_32
			l_curs_col: INTEGER_32
			l_n: INTEGER_32
			l_save_w_wrow: INTEGER_32
			l_prefix: CE_POINTER [NATURAL_8]
			l_base_class: INTEGER_32
			l_head_off: INTEGER_32
			l_args: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_col: INTEGER_32
			l_funcname: CE_POINTER [NATURAL_8]
			l_pos___3: PD_POS_T
			l_tmp___17: CE_POINTER [INTEGER_8]
			l_old: CE_POINTER [NATURAL_8]
			l_tmp___26: INTEGER_32
			l_tmp___29: CE_POINTER [INTEGER_8]
			l_number: INTEGER_32
			l_match: CE_POINTER [PD_COMPL_S]
			l_tmp___35: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_line.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_args.make (<<2>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_startcol := 0
					compl_direction.item := ins_compl_key2dir (a_c)
					if compl_started.item.to_boolean then
						l_pos := -1 + 56 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).did_ai.item := 0;
						(create {P_GLOBALS_STATIC}).did_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si_back.item := 0
						if (stop_arrow) = 0 then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 55 -- skip if block
						end
				when 2 then -- if:
						l_line := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
						l_curs_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						compl_pending.item := 0
						if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (6)) /= 6 then
							l_pos := -1 + 17 -- skip if block
						end
				when 3 then -- if:
						if compl_cont_mode.item /= (create {P_GLOBALS_STATIC}).ctrl_x_mode.item then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:;
						(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((-7))
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 7 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 262 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 263 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						if compl_startpos.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							compl_col.item := ((create {P_CHARSET_STATIC}).skipwhite (l_line)).distance (l_line)
							compl_startpos.item.item.col := compl_col.item
							compl_startpos.item.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((-17))
						else
							if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (8)).to_boolean then
								(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_or ((16))
								compl_startpos.item.item.col := ((create {P_CHARSET_STATIC}).skipwhite ((l_line + (create {P_GLOBALS_STATIC}).compl_length.item) + compl_startpos.item.item.col)).distance (l_line)
							end
							compl_col.item := compl_startpos.item.item.col
						end
						(create {P_GLOBALS_STATIC}).compl_length.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - compl_col.item
						if (create {P_GLOBALS_STATIC}).compl_length.item > 950 then
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((-17));
							(create {P_GLOBALS_STATIC}).compl_length.item := 950
							compl_col.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - (create {P_GLOBALS_STATIC}).compl_length.item
						end
						(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_or ((5))
						if (create {P_GLOBALS_STATIC}).compl_length.item < 1 then
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((32))
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 3 then
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := 5
						else
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
						end
				when 14 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:;
						(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((32))
				when 16 then -- if done | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:;
						(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((32))
				when 18 then
						if not (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
							compl_cont_mode.item := (create {P_GLOBALS_STATIC}).ctrl_x_mode.item
							if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
								(create {P_GLOBALS_STATIC}).compl_cont_status.item := 0
							end
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_or ((4))
							compl_startpos.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							l_startcol := l_curs_col
							compl_col.item := 0
						end
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_pos := -1 + 22 -- goto _L___3
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 21 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).ctrl_x_mode.item).bit_and (256)).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 22 then -- if: | _L___3:
						if not ((((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (16)).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___1
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 25 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 263 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___1:
						if not (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								l_startcol := l_startcol - 1
								if l_startcol >= 0 then
									if not ((create {P_CHARSET_STATIC}).vim_isIDc ((l_line[l_startcol]).to_integer_32)).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							end
							l_break := False
							l_startcol := l_startcol + 1
							compl_col.item := compl_col.item + l_startcol;
							(create {P_GLOBALS_STATIC}).compl_length.item := l_curs_col - l_startcol
						end
						if ((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean then
							compl_pattern.item.item := (create {P_CHARSET_STATIC}).str_foldcase (l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
						else
							compl_pattern.item.item := (create {P_MISC2_STATIC}).vim_strnsave (l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item)
						end
						if (compl_pattern.item.item).is_void then
							Result := 0
							l_return := True
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 28 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_prefix := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\<"))
						compl_pattern.item.item := (create {P_MISC2_STATIC}).alloc ((quote_meta (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item)) + {NATURAL_32} 2)
						if (compl_pattern.item.item).is_void then
							Result := 0
							l_return := True
						end
						if not l_return then
							if ((create {P_CHARSET_STATIC}).vim_iswordp (l_line + compl_col.item)).to_boolean then
								if compl_col.item > 0 then
									if ((create {P_CHARSET_STATIC}).vim_iswordp (((create {P_MBYTE_STATIC}).mb_prevptr (l_line, l_line + compl_col.item)))).to_boolean then
										l_prefix := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
									end
								end
							else
								l_prefix := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							end
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (compl_pattern.item.item), create {CE_INTEGER_8_POINTER}.make_cast (l_prefix)).do_nothing
							quote_meta (compl_pattern.item.item + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_prefix))).to_integer_32, l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item).do_nothing
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 31 then -- else:
						l_startcol := l_startcol - 1
						if not (l_startcol < 0) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 37 -- goto _L___0
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 34 then -- else:
						if not (((create {P_CHARSET_STATIC}).vim_iswordp (((create {P_MBYTE_STATIC}).mb_prevptr (l_line, (l_line + l_startcol) + 1)))).to_boolean) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_startcol := l_startcol - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, l_line + l_startcol]))
							l_base_class := (create {P_MBYTE_STATIC}).mb_get_class (l_line + l_startcol)
							from
							until
								(l_break)
							loop
								l_break := False
								l_startcol := l_startcol - 1
								if not (l_startcol >= 0) then
									l_break := True
								end
								if not (l_break) then
									l_head_off := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_line, l_line + l_startcol])
									if l_base_class /= ((create {P_MBYTE_STATIC}).mb_get_class ((l_line + l_startcol) - l_head_off)) then
										l_break := True
									end
								end
								if not (l_break) then
									l_startcol := l_startcol - l_head_off
								end
							end
							l_break := False
						else
							from
							until
								(l_break)
							loop
								l_break := False
								l_startcol := l_startcol - 1
								if l_startcol >= 0 then
									if not ((create {P_CHARSET_STATIC}).vim_iswordc ((l_line[l_startcol]).to_integer_32)).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							end
							l_break := False
						end
						l_startcol := l_startcol + 1
						compl_col.item := compl_col.item + l_startcol;
						(create {P_GLOBALS_STATIC}).compl_length.item := l_curs_col - l_startcol
						if (create {P_GLOBALS_STATIC}).compl_length.item = 1 then
							compl_pattern.item.item := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 7)
							if (compl_pattern.item.item).is_void then
								Result := 0
								l_return := True
							end
							if not l_return then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (compl_pattern.item.item), ce_string ("\<")).do_nothing
								quote_meta (compl_pattern.item.item + 2, l_line + compl_col.item, 1).do_nothing
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (compl_pattern.item.item), ce_string ("\k")).do_nothing
							end
						else
							compl_pattern.item.item := (create {P_MISC2_STATIC}).alloc ((quote_meta (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item)) + {NATURAL_32} 2)
							if (compl_pattern.item.item).is_void then
								Result := 0
								l_return := True
							end
							if not l_return then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (compl_pattern.item.item), ce_string ("\<")).do_nothing
								quote_meta (compl_pattern.item.item + 2, l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item).do_nothing
							end
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L___0:
						compl_pattern.item.item := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("\<\k\k")))
						if (compl_pattern.item.item).is_void then
							Result := 0
							l_return := True
						end
						if not l_return then
							compl_col.item := compl_col.item + l_curs_col;
							(create {P_GLOBALS_STATIC}).compl_length.item := 0
						end
				when 38 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 55
				when 39 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 3 then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						compl_col.item := ((create {P_CHARSET_STATIC}).skipwhite (l_line)).distance (l_line);
						(create {P_GLOBALS_STATIC}).compl_length.item := l_curs_col - compl_col.item
						if (create {P_GLOBALS_STATIC}).compl_length.item < 0 then
							(create {P_GLOBALS_STATIC}).compl_length.item := 0
						end
						if ((create {P_OPTION_STATIC}).p_ic.item.item).to_boolean then
							compl_pattern.item.item := (create {P_CHARSET_STATIC}).str_foldcase (l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
						else
							compl_pattern.item.item := (create {P_MISC2_STATIC}).vim_strnsave (l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item)
						end
						if (compl_pattern.item.item).is_void then
							Result := 0
							l_return := True
						end
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 42 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 4 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_startcol := l_startcol - 1
							if l_startcol >= 0 then
								if not ((create {P_CHARSET_STATIC}).vim_isfilec ((l_line[l_startcol]).to_integer_32)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
						end
						l_break := False
						l_startcol := l_startcol + 1
						compl_col.item := compl_col.item + l_startcol;
						(create {P_GLOBALS_STATIC}).compl_length.item := l_curs_col - l_startcol
						compl_pattern.item.item := (create {P_EX_GETLN_STATIC}).addstar (l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item, 2)
						if (compl_pattern.item.item).is_void then
							Result := 0
							l_return := True
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 45 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 11 then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						compl_pattern.item.item := (create {P_MISC2_STATIC}).vim_strnsave (l_line, l_curs_col)
						if (compl_pattern.item.item).is_void then
							Result := 0
							l_return := True
						end
						if not l_return then
							(create {P_EX_GETLN_STATIC}).set_cmd_context (compl_xp.item, compl_pattern.item.item, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (compl_pattern.item.item))).to_integer_32, l_curs_col)
							if compl_xp.item.item.xp_context = -2 then
								compl_col.item := l_curs_col
							elseif compl_xp.item.item.xp_context = 0 then
								compl_col.item := l_curs_col
							else
								compl_col.item := (compl_xp.item.item.xp_pattern).distance ((compl_pattern.item.item))
							end
							(create {P_GLOBALS_STATIC}).compl_length.item := l_curs_col - compl_col.item
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 48 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 12 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L___2
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 51 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 13 then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if: | _L___2:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 12 then
							l_funcname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cfu
						else
							l_funcname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ofu
						end
						if (l_funcname.item).to_integer_32 = 0 then
							if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 12 then
								l_tmp___17 := ce_string ("completefunc")
							else
								l_tmp___17 := ce_string ("omnifunc")
							end
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notset.item))))), create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___17)).do_nothing
							Result := 0
							l_return := True
						end
						if not l_return then
							l_args[0] := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("1"))
							l_args[1] := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							l_pos___3 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							l_col := ((create {P_EVAL_STATIC}).call_func_retnr (l_funcname, 2, l_args, 0)).to_integer_32;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___3.twin
							if l_col < 0 then
								l_col := l_curs_col
							end
							compl_col.item := l_col
							if compl_col.item > l_curs_col then
								compl_col.item := l_curs_col
							end
							l_line := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum);
							(create {P_GLOBALS_STATIC}).compl_length.item := l_curs_col - compl_col.item
							compl_pattern.item.item := (create {P_MISC2_STATIC}).vim_strnsave (l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item)
							if (compl_pattern.item.item).is_void then
								Result := 0
								l_return := True
							end
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 54 then -- else:
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 14 then
							if spell_bad_len.item > 0 then
								compl_col.item := l_curs_col - spell_bad_len.item
							else
								compl_col.item := (create {P_SPELL_STATIC}).spell_word_start (l_startcol)
							end
							if compl_col.item >= l_startcol then
								(create {P_GLOBALS_STATIC}).compl_length.item := 0
								compl_col.item := l_curs_col
							else
								(create {P_SPELL_STATIC}).spell_expand_check_cap (compl_col.item);
								(create {P_GLOBALS_STATIC}).compl_length.item := l_curs_col - compl_col.item
							end
							l_line := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
							compl_pattern.item.item := (create {P_MISC2_STATIC}).vim_strnsave (l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item)
							if (compl_pattern.item.item).is_void then
								Result := 0
								l_return := True
							end
						else
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item))))), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ins_complete()"))).do_nothing
							Result := 0
							l_return := True
						end
				when 55 then -- if done | if done | if done | if done | if done | if done | if done
						if not l_return then
							if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
								(create {P_GLOBALS_STATIC}).edit_submode_pre.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string (" Adding"))))
								if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 3 then
									l_old := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_com;
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_com := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
									compl_startpos.item.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
									compl_startpos.item.item.col := compl_col.item
									ins_eol (('%R').code).do_nothing;
									(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_com := l_old;
									(create {P_GLOBALS_STATIC}).compl_length.item := 0
									compl_col.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
								end
							else
								(create {P_GLOBALS_STATIC}).edit_submode_pre.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								compl_startpos.item.item.col := compl_col.item
							end
							if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (32)).to_boolean then
								(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ctrl_x_msgs.item[15])))
							else
								(create {P_GLOBALS_STATIC}).edit_submode.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ctrl_x_msgs.item[((create {P_GLOBALS_STATIC}).ctrl_x_mode.item).bit_and (-257)])))
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_orig_text.item))
							compl_orig_text.item := (create {P_MISC2_STATIC}).vim_strnsave (l_line + compl_col.item, (create {P_GLOBALS_STATIC}).compl_length.item)
							if compl_orig_text.item.is_void then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_pattern.item.item))
								compl_pattern.item.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_orig_text.item))
								compl_orig_text.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								Result := 0
								l_return := True
							elseif (ins_compl_add (compl_orig_text.item, -1, (create {P_OPTION_STATIC}).p_ic.item.item, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, 1, 0)) /= 1 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_pattern.item.item))
								compl_pattern.item.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (compl_orig_text.item))
								compl_orig_text.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								Result := 0
								l_return := True
							end
						end
						if not l_return then
							(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("-- Searching..."))));
							(create {P_GLOBALS_STATIC}).edit_submode_highl.item := {PC_HLF_T}.HLF_COUNT;
							(create {P_SCREEN_STATIC}).showmode.do_nothing;
							(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
							(create {P_TERM_STATIC}).out_flush
						end
				when 56 then -- if done
					if not l_return then
						compl_shown_match.item := compl_curr_match.item
						compl_shows_dir.item := compl_direction.item
						l_save_w_wrow := (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow
						l_tmp___26 := ins_compl_use_match (a_c)
						l_n := ins_compl_next (1, (ins_compl_key2count (a_c)), l_tmp___26)
						ins_compl_upd_pum
						if l_n > 1 then
							compl_matches.item := l_n
						end
						compl_curr_match.item := compl_shown_match.item
						compl_direction.item := compl_shows_dir.item
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
								(create {P_GETCHAR_STATIC}).vgetc.do_nothing;
								(create {P_GLOBALS_STATIC}).got_int.item := 0
							end
						end
						if compl_first_match.item.is_equal (compl_first_match.item.item.cp_next) then
							if (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
								if (create {P_GLOBALS_STATIC}).compl_length.item > 1 then
									(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (e_hitend.item)))
								else
									l_tmp___29 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_patnotf.item)));
									(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___29)
								end
							else
								l_tmp___29 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_patnotf.item)));
								(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___29)
							end
							(create {P_GLOBALS_STATIC}).edit_submode_highl.item := {PC_HLF_T}.HLF_E
							if (create {P_GLOBALS_STATIC}).compl_length.item > 1 then
								(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((-5))
							elseif (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (1)).to_boolean then
								(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((-5))
							elseif (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 0 then
								if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 262 then
									if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item /= 263 then
										(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((-5))
									end
								end
							end
						end
						if ((compl_curr_match.item.item.cp_flags).bit_and (8)).to_boolean then
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_or ((8))
						else
							(create {P_GLOBALS_STATIC}).compl_cont_status.item := ((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and ((-9))
						end
						if ((create {P_GLOBALS_STATIC}).edit_submode_extra.item).is_void then
							if ((compl_curr_match.item.item.cp_flags).bit_and (1)).to_boolean then
								(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Back at original"))));
								(create {P_GLOBALS_STATIC}).edit_submode_highl.item := {PC_HLF_T}.HLF_W
							elseif (((create {P_GLOBALS_STATIC}).compl_cont_status.item).bit_and (8)).to_boolean then
								(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Word from other line"))));
								(create {P_GLOBALS_STATIC}).edit_submode_highl.item := {PC_HLF_T}.HLF_COUNT
							elseif (compl_curr_match.item.item.cp_next).is_equal (compl_curr_match.item.item.cp_prev) then
								(create {P_GLOBALS_STATIC}).edit_submode_extra.item := create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("The only match"))));
								(create {P_GLOBALS_STATIC}).edit_submode_highl.item := {PC_HLF_T}.HLF_COUNT
							else
								if compl_curr_match.item.item.cp_number = -1 then
									l_number := 0
									if compl_direction.item = 1 then
										l_match := compl_curr_match.item.item.cp_prev
										from
										until
											(l_break)
										loop
											l_break := False
											if not l_match.is_void then
												if l_match.is_equal (compl_first_match.item) then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) and then (l_match.item.cp_number /= -1) then
												l_number := l_match.item.cp_number
												l_break := True
											end
											if not (l_break) then
												l_match := l_match.item.cp_prev
											end
										end
										l_break := False
										if not l_match.is_void then
											l_match := l_match.item.cp_next
											from
											until
												(l_break)
											loop
												l_break := False
												if not l_match.is_void then
													if l_match.item.cp_number /= -1 then
														l_break := True
													end
												else
													l_break := True
												end
												if not (l_break) then
													l_number := l_number + 1
													l_match.item.cp_number := l_number
													l_match := l_match.item.cp_next
												end
											end
											l_break := False
										end
									else
										l_match := compl_curr_match.item.item.cp_next
										from
										until
											(l_break)
										loop
											l_break := False
											if not l_match.is_void then
												if l_match.is_equal (compl_first_match.item) then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) and then (l_match.item.cp_number /= -1) then
												l_number := l_match.item.cp_number
												l_break := True
											end
											if not (l_break) then
												l_match := l_match.item.cp_next
											end
										end
										l_break := False
										if not l_match.is_void then
											l_match := l_match.item.cp_prev
											from
											until
												(l_break)
											loop
												l_break := False
												if (not l_match.is_void) then
													if l_match.item.cp_number /= -1 then
														l_break := True
													end
												else
													l_break := True
												end
												if not (l_break) then
													l_number := l_number + 1
													l_match.item.cp_number := l_number
													l_match := l_match.item.cp_prev
												end
											end
											l_break := False
										end
									end
								end
								if compl_curr_match.item.item.cp_number /= -1 then
									if compl_matches.item > 0 then
										(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (match_ref.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (81).to_natural_32), (gettext (ce_string ("match %%d of %%d"))), compl_curr_match.item.item.cp_number, compl_matches.item]).do_nothing
									else
										(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (match_ref.item), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (81).to_natural_32), (gettext (ce_string ("match %%d"))), compl_curr_match.item.item.cp_number]).do_nothing
									end
									(create {P_GLOBALS_STATIC}).edit_submode_extra.item := match_ref.item;
									(create {P_GLOBALS_STATIC}).edit_submode_highl.item := {PC_HLF_T}.HLF_R
									if ((create {P_GLOBALS_STATIC}).dollar_vcol.item).to_boolean then
										(create {P_MOVE_STATIC}).curs_columns (0)
									end
								end
							end
						end
						(create {P_SCREEN_STATIC}).showmode.do_nothing
						if not ((create {P_GLOBALS_STATIC}).edit_submode_extra.item).is_void then
							if not ((create {P_OPTION_STATIC}).p_smd.item.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).edit_submode_highl.item < {NATURAL_32} 41 then
									l_tmp___35 := (create {P_GLOBALS_STATIC}).highlight_attr.item[((create {P_GLOBALS_STATIC}).edit_submode_highl.item).to_integer_32]
								else
									l_tmp___35 := 0
								end
								(create {P_MESSAGE_STATIC}).msg_attr ((create {P_GLOBALS_STATIC}).edit_submode_extra.item, l_tmp___35).do_nothing
							end
						else
							(create {P_MESSAGE_STATIC}).msg_clr_cmdline
						end
						if not ((create {P_GLOBALS_STATIC}).compl_interrupted.item).to_boolean then
							l_n := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item;
							(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := 0;
							(create {P_SCREEN_STATIC}).setcursor
							if l_save_w_wrow /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_wrow then
								ins_compl_del_pum
							end
							ins_compl_show_pum;
							(create {P_SCREEN_STATIC}).setcursor;
							(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := l_n
						end
						compl_was_interrupted.item := (create {P_GLOBALS_STATIC}).compl_interrupted.item;
						(create {P_GLOBALS_STATIC}).compl_interrupted.item := 0
						Result := 1
					end
				when 57 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	quote_meta (a_dest, a_src: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): NATURAL_32
		local
			l_dest: CE_POINTER [NATURAL_8]
			l_src: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_m: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_mb_len: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dest := a_dest
					l_src := a_src
					l_len := a_len
					l_m := l_len.to_natural_32 + {NATURAL_32} 1
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_len := l_len - 1
						if not (l_len >= 0) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						inspect (l_src.item).to_integer_32 -- switch 1 head
						when 46 then l_pos := -1 + 4
						when 42 then l_pos := -1 + 4
						when 91 then l_pos := -1 + 4
						when 126 then l_pos := -1 + 5
						when 92 then l_pos := -1 + 6
						when 94 then l_pos := -1 + 7
						when 36 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 46 | switch 1, case 42 | switch 1, case 91
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 265 then
							l_pos := -1 + 8 -- switch 1; break
						elseif (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 266 then
							l_pos := -1 + 8 -- switch 1; break
						end
				when 5 then -- switch 1, case 126
						if not ((create {P_OPTION_STATIC}).p_magic.item.item).to_boolean then
							l_pos := -1 + 8 -- switch 1; break
						end
				when 6 then -- switch 1, case 92
						if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 265 then
							l_pos := -1 + 8 -- switch 1; break
						elseif (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 266 then
							l_pos := -1 + 8 -- switch 1; break
						end
				when 7 then -- switch 1, case 94 | switch 1, case 36
						l_m := l_m + 1
						if not l_dest.is_void then
							l_tmp := l_dest
							l_dest := l_dest + 1
							l_tmp.item := (('\').code).to_natural_8
						end
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
						if not l_dest.is_void then
							l_tmp___0 := l_dest
							l_dest := l_dest + 1
							l_tmp___0.item := l_src.item
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_mb_len := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_src])) - 1
							if l_mb_len > 0 then
								if l_len >= l_mb_len then
									l_i___0 := 0
									from
									until
										not (l_i___0 < l_mb_len)
									loop
										l_len := l_len - 1
										l_src := l_src + 1
										if not l_dest.is_void then
											l_tmp___2 := l_dest
											l_dest := l_dest + 1
											l_tmp___2.item := l_src.item
										end
										l_i___0 := l_i___0 + 1
									end
								end
							end
						end
						l_src := l_src + 1
				when 9 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					l_break := False
					if not l_dest.is_void then
						l_dest.item := (('%/0/').code).to_natural_8
					end
					Result := l_m
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_literal: INTEGER_32
		local
			l_cc___0: INTEGER_32
			l_nc: INTEGER_32
			l_i___0: INTEGER_32
			l_hex: INTEGER_32
			l_octal: INTEGER_32
			l_unicode: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hex := 0
					l_octal := 0
					l_unicode := 0
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						Result := 3
						l_return := True
					end
					if l_return then
						l_pos := -1 + 42 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
						end
						(create {P_GLOBALS_STATIC}).dont_scroll.item := 1;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
						l_cc___0 := 0
						l_i___0 := 0
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 41 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_nc := (create {P_GETCHAR_STATIC}).plain_vgetc
						if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
							if l_nc < 0 then
								l_tmp := 1
							elseif l_nc > 255 then
								l_tmp := 1
							else
								l_tmp := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_nc]).to_integer_32
							end
							if l_tmp = 1 then
								(create {P_NORMAL_STATIC}).add_to_showcmd (l_nc).do_nothing
							end
						end
						if l_nc /= 120 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_hex := 1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 6 then -- else:
						if l_nc /= 88 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_hex := 1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 9 then -- else:
						if l_nc /= 111 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_octal := 1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 12 then -- else:
						if l_nc /= 79 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_octal := 1
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 15 then -- else:
						if l_nc /= 117 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_unicode := l_nc
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 18 then -- else:
						if l_nc /= 85 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_unicode := l_nc
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 21 then -- else:
						if not (l_hex.to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						l_pos := -1 + 25 -- goto _L
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else:
						if l_unicode = 0 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if: | _L:
						if not ((create {P_CHARSET_STATIC}).vim_isxdigit (l_nc)).to_boolean then
							l_break := True
						end
						if not (l_break) then
							l_cc___0 := l_cc___0 * 16 + ((create {P_CHARSET_STATIC}).hex2nr (l_nc))
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						if l_octal.to_boolean then
							if l_nc < 48 then
								l_break := True
							elseif l_nc > 55 then
								l_break := True
							end
							if not (l_break) then
								l_cc___0 := (l_cc___0 * 8 + l_nc) - 48
							end
						else
							if l_nc >= 48 then
								if not (l_nc <= 57) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_cc___0 := (l_cc___0 * 10 + l_nc) - 48
							end
						end
				when 28 then -- if done
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
				when 29 then -- if done | if done | if done | if done | if done | if done
						if (l_break) then
							l_pos := -1 + 40 -- skip if block
						end
				when 30 then -- if:
						if l_cc___0 > 255 then
							if l_unicode = 0 then
								l_cc___0 := 255
							end
						end
						l_nc := 0
						if not (l_hex.to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if l_i___0 >= 2 then
							l_break := True
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 40
				when 33 then -- else:
						if not (l_unicode.to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 34 then -- if:
						if l_unicode /= 117 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if l_i___0 >= 4 then
							l_break := True
						else
							l_pos := -1 + 37 -- goto _L___0
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L___0:
						if l_unicode = 85 then
							if l_i___0 >= 8 then
								l_break := True
							end
						end
				when 38 then -- if done | if block done, skip else block:
						l_pos := -1 + 40
				when 39 then -- else:
						if l_i___0 >= 3 then
							l_break := True
						end
				when 40 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 41 then -- loop done
						l_break := False
						if l_i___0 = 0 then
							if l_nc = -(255 + ((88).bit_shift_left (8))) then
								l_cc___0 := ('%N').code
								l_nc := 0
							else
								l_cc___0 := l_nc
								l_nc := 0
							end
						end
						if l_cc___0 = 0 then
							l_cc___0 := ('%N').code
						end
						if ((create {P_GLOBALS_STATIC}).enc_dbcs.item).to_boolean then
							if ((l_cc___0).bit_and (255)) = 0 then
								l_cc___0 := ('?').code
							end
						end
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
						end
						if l_nc.to_boolean then
							(create {P_GETCHAR_STATIC}).vungetc (l_nc)
						end
						(create {P_GLOBALS_STATIC}).got_int.item := 0
						Result := l_cc___0
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	insert_special (a_c, a_allow_modmask, a_ctrlv: INTEGER_32)
		local
			l_c: INTEGER_32
			l_ctrlv: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_ctrlv := a_ctrlv
					if not (l_c < 0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).mod_mask.item.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not (a_allow_modmask.to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						l_p___0 := (create {P_MISC2_STATIC}).get_special_key_name (l_c, (create {P_GLOBALS_STATIC}).mod_mask.item.item)
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
						l_c := (l_p___0[(l_len - 1)]).to_integer_32
						if l_len > 2 then
							if (stop_arrow) = 0 then
								l_return := True
							end
							if not l_return then
								l_p___0[(l_len - 1)] := (('%/0/').code).to_natural_8;
								(create {P_MISC1_STATIC}).ins_str (l_p___0);
								(create {P_GETCHAR_STATIC}).AppendToRedobuffLit (l_p___0, -1)
								l_ctrlv := 0
							end
						end
				when 6 then -- if done | if done
					if not l_return then
						if (stop_arrow) = 1 then
							if l_ctrlv.to_boolean then
								l_tmp___1 := 4
							else
								l_tmp___1 := 0
							end
							insertchar (l_c, l_tmp___1, -1)
						end
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	insertchar (a_c, a_flags___0, a_second_indent: INTEGER_32)
		local
			l_c: INTEGER_32
			l_textwidth: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fo_ins_blank: INTEGER_32
			l_do_internal: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_lead_end: CE_ARRAY [NATURAL_8]
			l_middle_len: INTEGER_32
			l_end_len: INTEGER_32
			l_i___0: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_i___1: INTEGER_32
			l_virtcol: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_cc___0: INTEGER_32
			l_buf___7: CE_ARRAY [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_lead_end.make (<<50>>)
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<101>>)
			create {CE_NATURAL_8_ARRAY} l_buf___7.make (<<22>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_textwidth := comp_textwidth ((a_flags___0).bit_and (1))
					l_fo_ins_blank := (create {P_OPTION_STATIC}).has_format_option (('b').code)
					if not (l_textwidth > 0) then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 4 then -- else:
						if (l_c = 32) then
							l_pos := -1 + 21 -- skip if block
						end
				when 5 then -- if:
						if (l_c = 9) then
							l_pos := -1 + 21 -- skip if block
						end
				when 6 then -- if:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							if (((create {P_MEMLINE_STATIC}).ml_get_cursor).item).to_integer_32 = 0 then
								l_pos := -1 + 9 -- goto _L___4
							end
						else
							l_pos := -1 + 9 -- goto _L___4
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 9 then -- else: | _L___4:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 12 then -- else:
						if not (((create {P_OPTION_STATIC}).has_format_option (('l').code)).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 13 then -- if:
						if not (Insstart_textlen.item <= l_textwidth) then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if: | _L___2:
						if l_fo_ins_blank.to_boolean then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 18 -- goto _L___1
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 17 then -- else:
						if not (Insstart_blank_vcol.item <= l_textwidth) then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___1:
						l_do_internal := 1
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_fex).item).to_integer_32 /= 0 then
							if ((a_flags___0).bit_and (8)) = 0 then
								l_do_internal := (((create {P_OPS_STATIC}).fex_format ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 1, l_c)) /= 0).to_integer
								ins_need_undo.item := 1
							end
						end
						if l_do_internal.to_boolean then
							internal_format (l_textwidth, a_second_indent, a_flags___0, (l_c = 0).to_integer, l_c)
						end
				when 19 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 14 -- goto _L___2
				when 21 then -- if done | if done | if done | if done | if done | if done
					if l_c = 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 87 -- skip if block
					end
				when 22 then -- if:
						if ((create {P_GLOBALS_STATIC}).did_ai.item).to_boolean then
							if l_c = (create {P_GLOBALS_STATIC}).end_comment_pending.item then
								l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
								l_i___0 := (create {P_MISC1_STATIC}).get_leader_len (l_line, l_p___0, 0)
								if l_i___0 > 0 then
									if not ((create {P_MISC2_STATIC}).vim_strchr (l_p___0.item, ('m').code)).is_void then
										from
										until
											(l_break)
										loop
											l_break := False
											if (l_p___0.item.item).to_boolean then
												if (l_p___0.item[-1]).to_integer_32 = 58 then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) then
												l_p___0.item := l_p___0.item + 1
											end
										end
										l_break := False
										l_middle_len := (create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_lead_end, 50, ce_string (","))
										from
										until
											(l_break)
										loop
											l_break := False
											if l_middle_len > 0 then
												if (l_lead_end[l_middle_len - 1]).to_integer_32 /= 32 then
													if (l_lead_end[l_middle_len - 1]).to_integer_32 /= 9 then
														l_break := True
													end
												end
											else
												l_break := True
											end
											if not (l_break) then
												l_middle_len := l_middle_len - 1
											end
										end
										l_break := False
										from
										until
											(l_break)
										loop
											l_break := False
											if (l_p___0.item.item).to_boolean then
												if (l_p___0.item[-1]).to_integer_32 = 58 then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_break) then
												l_p___0.item := l_p___0.item + 1
											end
										end
										l_break := False
										l_end_len := (create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_lead_end, 50, ce_string (","))
										l_i___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
										from
										until
											(l_break)
										loop
											l_break := False
											l_i___0 := l_i___0 - 1
											if l_i___0 >= 0 then
												if (l_line[l_i___0]).to_integer_32 /= 32 then
													if (l_line[l_i___0]).to_integer_32 /= 9 then
														l_break := True
													end
												end
											else
												l_break := True
											end
										end
										l_break := False
										l_i___0 := l_i___0 + 1
										l_i___0 := l_i___0 - l_middle_len
										if l_i___0 >= 0 then
											if (l_lead_end[l_end_len - 1]).to_integer_32 = (create {P_GLOBALS_STATIC}).end_comment_pending.item then
												backspace_until_column (l_i___0);
												(create {P_MISC1_STATIC}).ins_bytes_len (l_lead_end, l_end_len - 1)
											end
										end
									end
								end
							end
						end
						(create {P_GLOBALS_STATIC}).end_comment_pending.item := ('%/0/').code;
						(create {P_GLOBALS_STATIC}).did_ai.item := 0;
						(create {P_GLOBALS_STATIC}).did_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si_back.item := 0;
						(create {P_GLOBALS_STATIC}).dont_scroll.item := 0
						if not (l_c < 32) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 32 -- goto _L___13
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 25 then -- else:
						if not (l_c >= 127) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 32 -- goto _L___13
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 28 then -- else:
						if l_c /= 48 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 32 -- goto _L___13
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 31 then -- else:
						if l_c /= 94 then
							l_pos := -1 + 37 -- skip if block
						end
				when 32 then -- if: | _L___13:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_cc___0 := (create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])
						if l_cc___0 > 1 then
							(create {P_GLOBALS_STATIC}).mb_char2bytes.item.call ([l_c, l_buf___7])
							l_buf___7[l_cc___0] := (('%/0/').code).to_natural_8;
							(create {P_MISC1_STATIC}).ins_char_bytes (l_buf___7, l_cc___0);
							(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (l_c)
						else
							l_pos := -1 + 35 -- goto _L___7
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else: | _L___7:;
						(create {P_MISC1_STATIC}).ins_char (l_c)
						if ((a_flags___0).bit_and (4)).to_boolean then
							redo_literal (l_c)
						else
							(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (l_c)
						end
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 87
				when 37 then -- else:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 41 -- goto _L___12
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 40 then -- else:
						if ((create {P_GLOBALS_STATIC}).mb_char2len.item.integer_32_item ([l_c])) /= 1 then
							l_pos := -1 + 86 -- skip if block
						end
				when 41 then -- if: | _L___12:
						if ((create {P_GETCHAR_STATIC}).vpeekc) = 0 then
							l_pos := -1 + 84 -- skip if block
						end
				when 42 then -- if:
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
							l_pos := -1 + 82 -- skip if block
						end
				when 43 then -- if:
						if not ((cindent_on).to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_pos := -1 + 32 -- goto _L___13
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 46 then -- else:
						l_virtcol := 0
						l_buf___6[0] := l_c.to_natural_8
						l_i___1 := 1
						if l_textwidth > 0 then
							l_virtcol := get_nolist_virtcol
						end
				when 47 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 80 -- skip loop
						end
				when 48 then -- loop body:
						l_break := False
						l_c := (create {P_GETCHAR_STATIC}).vpeekc
						if l_c = 0 then
							l_pos := -1 + 78 -- skip if block
						end
				when 49 then -- if:
						if not (l_c < 32) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_break := True
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 52 then -- else:
						if not (l_c >= 127) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_break := True
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 55 then -- else:
						if l_c /= 48 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_break := True
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 58 then -- else:
						if l_c /= 94 then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						l_break := True
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 61 then -- else:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 65 -- goto _L___6
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 77
				when 64 then -- else:
						if l_c < 0 then
							l_tmp___5 := 1
						elseif l_c > 255 then
							l_tmp___5 := 1
						else
							l_tmp___5 := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_c]).to_integer_32
						end
						if l_tmp___5 /= 1 then
							l_pos := -1 + 76 -- skip if block
						end
				when 65 then -- if: | _L___6:
						if not (l_i___1 < 100) then
							l_pos := -1 + 74 -- skip if block
						end
				when 66 then -- if:
						if l_textwidth /= 0 then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						l_pos := -1 + 70 -- goto _L___5
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 69 then -- else:
						l_virtcol := l_virtcol + ((create {P_CHARSET_STATIC}).byte2cells ((l_buf___6[l_i___1 - 1]).to_integer_32))
						if not (l_virtcol < l_textwidth) then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if: | _L___5:
						if not ((create {P_GLOBALS_STATIC}).no_abbr.item).to_boolean then
							if not ((create {P_CHARSET_STATIC}).vim_iswordc (l_c)).to_boolean then
								if ((create {P_CHARSET_STATIC}).vim_iswordc ((l_buf___6[l_i___1 - 1]).to_integer_32)).to_boolean then
									l_break := True
								end
							end
						end
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 72 then -- else:
						l_break := True
				when 73 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 75
				when 74 then -- else:
						l_break := True
				when 75 then -- if done | if block done, skip else block:
						l_pos := -1 + 77
				when 76 then -- else:
						l_break := True
				when 77 then -- if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 79
				when 78 then -- else:
						l_break := True
				when 79 then
						if not (l_break) then
							l_tmp___3 := l_i___1
							l_i___1 := l_i___1 + 1
							l_buf___6[l_tmp___3] := ((create {P_GETCHAR_STATIC}).vgetc).to_natural_8
						end
						l_pos := -1 + 47 -- back to loop condition
				when 80 then -- loop done
						l_break := False;
						(create {P_DIGRAPH_STATIC}).do_digraph (-1).do_nothing;
						(create {P_DIGRAPH_STATIC}).do_digraph ((l_buf___6[l_i___1 - 1]).to_integer_32).do_nothing
						l_buf___6[l_i___1] := (('%/0/').code).to_natural_8;
						(create {P_MISC1_STATIC}).ins_str (l_buf___6)
						if ((a_flags___0).bit_and (4)).to_boolean then
							redo_literal ((l_buf___6[0]).to_integer_32)
							l_i___1 := 1
						else
							l_i___1 := 0
						end
						if (l_buf___6[l_i___1]).to_integer_32 /= 0 then
							(create {P_GETCHAR_STATIC}).AppendToRedobuffLit (l_buf___6 + l_i___1, -1)
						end
				when 81 then -- if done | if block done, skip else block:
						l_pos := -1 + 83
				when 82 then -- else:
						l_pos := -1 + 32 -- goto _L___13
				when 83 then -- if done | if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else:
						l_pos := -1 + 32 -- goto _L___13
				when 85 then -- if done | if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else:
						l_pos := -1 + 32 -- goto _L___13
				when 87 then -- if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	internal_format (a_textwidth, a_second_indent, a_flags___0, a_format_only, a_c: INTEGER_32)
		local
			l_second_indent: INTEGER_32
			l_cc___0: INTEGER_32
			l_save_char: INTEGER_32
			l_haveto_redraw: INTEGER_32
			l_fo_ins_blank: INTEGER_32
			l_fo_multibyte: INTEGER_32
			l_fo_white_par: INTEGER_32
			l_first_line: INTEGER_32
			l_leader_len: INTEGER_32
			l_no_leader: INTEGER_32
			l_do_comments: INTEGER_32
			l_startcol: INTEGER_32
			l_wantcol: INTEGER_32
			l_foundcol: INTEGER_32
			l_end_foundcol: INTEGER_32
			l_len: INTEGER_32
			l_virtcol: INTEGER_32
			l_orig_col: INTEGER_32
			l_saved_text: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_end_col: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___32: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_second_indent := a_second_indent
					l_save_char := ('%/0/').code
					l_haveto_redraw := 0
					l_fo_ins_blank := ((create {P_OPTION_STATIC}).has_format_option (('b').code))
					l_fo_multibyte := ((create {P_OPTION_STATIC}).has_format_option (('m').code))
					l_fo_white_par := ((create {P_OPTION_STATIC}).has_format_option (('w').code))
					l_first_line := 1
					l_no_leader := 0
					l_do_comments := (a_flags___0).bit_and (2)
					if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean then
						if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
							if l_cc___0 = 32 then
								l_save_char := l_cc___0;
								(create {P_MISC1_STATIC}).pchar_cursor (('x').code)
							elseif l_cc___0 = 9 then
								l_save_char := l_cc___0;
								(create {P_MISC1_STATIC}).pchar_cursor (('x').code)
							end
						end
					end
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean)) then
						l_pos := -1 + 74 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_end_foundcol := 0
						l_orig_col := 0
						l_saved_text := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_tmp___2 := get_nolist_virtcol
						if a_c /= 0 then
							l_tmp___4 := a_c
						else
							l_tmp___4 := ((create {P_MISC1_STATIC}).gchar_cursor)
						end
						l_virtcol := l_tmp___2 + ((create {P_CHARSET_STATIC}).char2cells (l_tmp___4))
						if l_virtcol <= a_textwidth then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							if l_no_leader.to_boolean then
								l_do_comments := 0
							elseif not ((a_flags___0).bit_and (1)).to_boolean then
								if ((create {P_OPTION_STATIC}).has_format_option (('c').code)).to_boolean then
									l_do_comments := 1
								end
							end
							if l_do_comments.to_boolean then
								l_leader_len := (create {P_MISC1_STATIC}).get_leader_len (((create {P_MEMLINE_STATIC}).ml_get_curline), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
							else
								l_leader_len := 0
							end
							if l_leader_len = 0 then
								l_no_leader := 1
							end
							if not ((a_flags___0).bit_and (1)).to_boolean then
								if l_leader_len = 0 then
									if not ((create {P_OPTION_STATIC}).has_format_option (('t').code)).to_boolean then
										l_break := True
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_startcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							if l_startcol = 0 then
								l_break := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 61 -- skip if block
						end
				when 3 then -- if:;
						(create {P_MISC2_STATIC}).coladvance (a_textwidth).do_nothing
						l_wantcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_startcol
						l_foundcol := 0
				when 4 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 60 -- skip loop
						end
				when 5 then -- loop body:
						l_break := False
						l_continue := False
						if l_fo_ins_blank.to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((create {P_OPTION_STATIC}).has_format_option (('v').code)).to_boolean then
							l_pos := -1 + 8 -- goto _L___6
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L___6:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
							if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col >= (create {P_GLOBALS_STATIC}).Insstart.item.item.col) then
								l_break := True
							end
						end
				when 9 then
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 59 -- skip if block
						end
				when 10 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = l_startcol then
							if a_c /= 0 then
								l_cc___0 := a_c
							else
								l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
							end
						else
							l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
						end
						if l_cc___0 /= 32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___5
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 13 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 50 -- skip if block
						end
				when 14 then -- if: | _L___5:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 20 -- goto _L___4
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 17 then -- else:
						if not (((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 50 -- goto _L___3
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 20 then -- else: | _L___4:
						l_end_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
				when 21 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 33 -- skip loop
						end
				when 22 then -- loop body:
						l_break := False
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0) then
							l_pos := -1 + 31 -- skip if block
						end
				when 23 then -- if:
						if l_cc___0 /= 32 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 27 -- goto _L
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 26 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if: | _L:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean then
								l_break := True
							end
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_break := True
				when 30 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						l_break := True
				when 32 then
						if not (l_break) then
							(create {P_MISC2_STATIC}).dec_cursor.do_nothing
							l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
						end
						l_pos := -1 + 21 -- back to loop condition
				when 33 then -- loop done
						l_break := False
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= 0 then
							l_pos := -1 + 39 -- skip if block
						end
				when 34 then -- if:
						if l_cc___0 /= 32 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 38 -- goto _L___0
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 37 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 39 -- skip if block
						end
				when 38 then -- if: | _L___0:
						if not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_break := True
						elseif not ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean then
							l_break := True
						end
				when 39 then -- if done | if done
						if not (l_return or l_break or l_continue) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < l_leader_len) then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 48 -- skip if block
						end
				when 40 then -- if:
						if not (((create {P_OPTION_STATIC}).has_format_option (('1').code)).to_boolean) then
							l_pos := -1 + 48 -- skip if block
						end
				when 41 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = 0 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col <= l_leader_len) then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col;
						(create {P_MISC2_STATIC}).dec_cursor.do_nothing
						l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
						if l_cc___0 /= 32 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 46 -- goto _L___1
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 45 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 47 -- skip if block
						end
				when 46 then -- if: | _L___1:
						if not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_continue := True
						elseif not ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean then
							l_continue := True
						end
				when 47 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col
						end
				when 48 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							(create {P_MISC2_STATIC}).inc_cursor.do_nothing
							l_end_foundcol := l_end_col + 1
							l_foundcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col <= l_wantcol then
								l_break := True
							end
						end
				when 49 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 59
				when 50 then -- else: | _L___3:
						if not (l_cc___0 >= 256) then
							l_pos := -1 + 59 -- skip if block
						end
				when 51 then -- if:
						if not (l_fo_multibyte.to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 52 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= l_startcol then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < l_leader_len then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col;
								(create {P_MISC2_STATIC}).inc_cursor.do_nothing
								if l_foundcol /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
									l_foundcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
									l_end_foundcol := l_foundcol
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col <= l_wantcol then
										l_break := True
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col
							end
						end
						if not (l_return or l_break or l_continue) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = 0) then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 58 -- skip if block
						end
				when 53 then -- if:
						l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col;
						(create {P_MISC2_STATIC}).dec_cursor.do_nothing
						l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
						if l_cc___0 /= 32 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 57 -- goto _L___2
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 56 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 58 -- skip if block
						end
				when 57 then -- if: | _L___2:
						if not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_continue := True
						elseif not ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean then
							l_continue := True
						end
				when 58 then -- if done | if done
						if not (l_return or l_break or l_continue) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < l_leader_len) then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col
							l_foundcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							l_end_foundcol := l_foundcol
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col <= l_wantcol then
								l_break := True
							end
						end
				when 59 then -- if done | if done | if done | if done
						if not (l_return or l_break or l_continue) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = 0) then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							(create {P_MISC2_STATIC}).dec_cursor.do_nothing
						end
						l_pos := -1 + 4 -- back to loop condition
				when 60 then -- loop done
						l_break := False
						l_continue := False
						if l_foundcol = 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_startcol
							l_break := True
						end
				when 61 then -- if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 73 -- skip if block
						end
				when 62 then -- if:
						undisplay_dollar
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							l_orig_col := l_startcol
						else
							(create {P_GLOBALS_STATIC}).replace_offset.item := l_startcol - l_end_foundcol
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_foundcol
				when 63 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 72 -- skip loop
						end
				when 64 then -- loop body:
						l_break := False
						l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
						if l_cc___0 /= 32 then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_pos := -1 + 68 -- goto _L___7
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 67 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if: | _L___7:
						if not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_tmp___29 := 1
						elseif ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean then
							l_tmp___29 := 0
						else
							l_tmp___29 := 1
						end
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else:
						l_tmp___29 := 0
				when 71 then -- if done
						if l_tmp___29.to_boolean then
							if l_fo_white_par.to_boolean then
								if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < l_startcol) then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							(create {P_MISC2_STATIC}).inc_cursor.do_nothing
						end
						l_pos := -1 + 63 -- back to loop condition
				when 72 then -- loop done
						l_break := False
						l_startcol := l_startcol - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
						if l_startcol < 0 then
							l_startcol := 0
						end
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							l_saved_text := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get_cursor));
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_orig_col
							if l_saved_text.is_void then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_saved_text[l_startcol] := (('%/0/').code).to_natural_8
								if not l_fo_white_par.to_boolean then
									backspace_until_column (l_foundcol)
								end
							end
						elseif not l_fo_white_par.to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_foundcol
						end
				when 73 then -- if done
						if not (l_return or l_break or l_continue) then
							if l_fo_white_par.to_boolean then
								l_tmp___31 := 4
							else
								l_tmp___31 := 0
							end
							if l_do_comments.to_boolean then
								l_tmp___32 := 2
							else
								l_tmp___32 := 0
							end
							(create {P_MISC1_STATIC}).open_line (1, (9 + l_tmp___31) + l_tmp___32, old_indent.item).do_nothing
							old_indent.item := 0;
							(create {P_GLOBALS_STATIC}).replace_offset.item := 0
							if l_first_line.to_boolean then
								if l_second_indent < 0 then
									if ((create {P_OPTION_STATIC}).has_format_option (('n').code)).to_boolean then
										l_second_indent := (create {P_MISC1_STATIC}).get_number_indent ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)
									end
								end
								if l_second_indent >= 0 then
									if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
										change_indent (1, l_second_indent, 0, ('%/0/').code, 1)
									else
										(create {P_MISC1_STATIC}).set_indent (l_second_indent, 1).do_nothing
									end
								end
								l_first_line := 0
							end
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
								(create {P_MISC1_STATIC}).ins_bytes (l_saved_text);
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_saved_text))
							else
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + l_startcol
								l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get_curline)))).to_integer_32
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > l_len then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_len
								end
							end
							l_haveto_redraw := 1
							can_cindent.item := 1;
							(create {P_GLOBALS_STATIC}).did_ai.item := 0;
							(create {P_GLOBALS_STATIC}).did_si.item := 0;
							(create {P_GLOBALS_STATIC}).can_si.item := 0;
							(create {P_GLOBALS_STATIC}).can_si_back.item := 0;
							(create {P_MISC1_STATIC}).line_breakcheck
						end
						l_pos := -1 + 1 -- back to loop condition
				when 74 then -- loop done
					l_break := False
					if l_save_char /= 0 then
						(create {P_MISC1_STATIC}).pchar_cursor (l_save_char)
					end
					if not a_format_only.to_boolean then
						if l_haveto_redraw.to_boolean then
							(create {P_MOVE_STATIC}).update_topline;
							(create {P_SCREEN_STATIC}).redraw_curbuf_later (10)
						end
					end
				when 75 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	auto_format (a_trailblank, a_prev_line: INTEGER_32)
		local
			l_pos___3: PD_POS_T
			l_len: INTEGER_32
			l_old: CE_POINTER [NATURAL_8]
			l_new: CE_POINTER [NATURAL_8]
			l_pnew: CE_POINTER [NATURAL_8]
			l_wasatend: INTEGER_32
			l_cc___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_pos___3.make
			create {CE_NATURAL_8_POINTER} l_old.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_OPTION_STATIC}).has_format_option (('a').code)).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						l_pos___3 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						l_old := (create {P_MEMLINE_STATIC}).ml_get_curline
						check_auto_format (0)
						l_wasatend := (l_pos___3.col = (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_old))).to_integer_32).to_integer
						if (l_old.item).to_integer_32 = 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 2 then -- if:
						if a_trailblank.to_boolean then
							l_pos := -1 + 17 -- skip if block
						end
				when 3 then -- if:
						if not (l_wasatend.to_boolean) then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:;
						(create {P_MISC2_STATIC}).dec_cursor.do_nothing
						l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
						if l_cc___0 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___0:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean then
								l_pos := -1 + 10 -- goto _L
							end
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
							if ((create {P_OPTION_STATIC}).has_format_option (('1').code)).to_boolean then
								(create {P_MISC2_STATIC}).dec_cursor.do_nothing
							end
						end
				when 11 then -- if done
						l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
						if l_cc___0 /= 32 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___1:
						if not ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___3.twin
							l_return := True
						elseif not ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___3.twin
							l_return := True
						end
				when 16 then -- if done
						if not l_return then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___3.twin
						end
				when 17 then -- if done | if done | if done | if done
					if not l_return then
						if ((create {P_OPTION_STATIC}).has_format_option (('c').code)).to_boolean then
							if not ((create {P_OPTION_STATIC}).has_format_option (('t').code)).to_boolean then
								if ((create {P_MISC1_STATIC}).get_leader_len (l_old, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)) = 0 then
									l_return := True
								end
							end
						end
					end
					if not l_return and then (a_prev_line.to_boolean) then
						if not ((create {P_OPS_STATIC}).paragraph_start ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
							if ((create {P_UNDO_STATIC}).u_save_cursor) = 0 then
								l_return := True
							end
						end
					end
					if not l_return then
						(create {P_GLOBALS_STATIC}).saved_cursor.item.item := l_pos___3.twin;
						(create {P_OPS_STATIC}).format_lines ((-1).to_integer_32, 0);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := ((create {P_GLOBALS_STATIC}).saved_cursor.item.item).twin;
						(create {P_GLOBALS_STATIC}).saved_cursor.item.item.lnum := (0).to_integer_32
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count;
							(create {P_MISC2_STATIC}).coladvance ((2_147_483_647).to_integer_32).do_nothing
						else
							(create {P_MISC2_STATIC}).check_cursor_col
						end
						if not l_wasatend.to_boolean then
							if ((create {P_OPTION_STATIC}).has_format_option (('w').code)).to_boolean then
								l_new := (create {P_MEMLINE_STATIC}).ml_get_curline
								l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_new))).to_integer_32
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = l_len then
									l_pnew := (create {P_MISC2_STATIC}).vim_strnsave (l_new, l_len + 2)
									l_pnew[l_len] := ((' ').code).to_natural_8
									l_pnew[(l_len + 1)] := (('%/0/').code).to_natural_8;
									(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_pnew, 0).do_nothing
									did_add_space.item := 1
								else
									check_auto_format (0)
								end
							end
						end
						(create {P_MISC2_STATIC}).check_cursor
					end
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_auto_format (a_end_insert: INTEGER_32)
		local
			l_c: INTEGER_32
			l_cc___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := (' ').code
					if not (did_add_space.item.to_boolean) then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
						if l_cc___0 /= 32 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L___0
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if: | _L___0:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if not (((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor) + 1)))).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						did_add_space.item := 0
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if not a_end_insert.to_boolean then
							(create {P_MISC2_STATIC}).inc_cursor.do_nothing
							l_c := (create {P_MISC1_STATIC}).gchar_cursor;
							(create {P_MISC2_STATIC}).dec_cursor.do_nothing
						end
						if l_c /= 0 then
							(create {P_MISC1_STATIC}).del_char (0).do_nothing
							did_add_space.item := 0
						end
				when 12 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						did_add_space.item := 0
				when 14 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	comp_textwidth (a_ff: INTEGER_32): INTEGER_32
		local
			l_textwidth: INTEGER_32
		do
			l_textwidth := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tw).to_integer_32
			if l_textwidth = 0 then
				if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_wm).to_boolean then
					l_textwidth := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_width).to_integer_32 - (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_wm).to_integer_32
					if (create {P_GLOBALS_STATIC}).cmdwin_type.item /= 0 then
						l_textwidth := l_textwidth - 1
					end
					l_textwidth := (l_textwidth.to_integer_32 - (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fdc).to_integer_32
					if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer).item.b_signlist).is_void then
						l_textwidth := l_textwidth - 1
					elseif ((create {P_NETBEANS_STATIC}).netbeans_active).to_boolean then
						l_textwidth := l_textwidth - 1
					end
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_nu).to_boolean then
						l_textwidth := l_textwidth - (8)
					elseif ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_rnu).to_boolean then
						l_textwidth := l_textwidth - (8)
					end
				end
			end
			if l_textwidth < 0 then
				l_textwidth := 0
			end
			if a_ff.to_boolean then
				if l_textwidth = 0 then
					l_textwidth := (create {P_GLOBALS_STATIC}).curwin.item.item.w_width - 1
					if l_textwidth > 79 then
						l_textwidth := 79
					end
				end
			end
			Result := l_textwidth
		end

	redo_literal (a_c: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<10>>)

			if a_c >= 48 then
				if a_c <= 57 then
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (10).to_natural_32), ce_string ("%%03d"), a_c]).do_nothing;
					(create {P_GETCHAR_STATIC}).AppendToRedobuff (l_buf___6)
				else
					(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_c)
				end
			else
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_c)
			end
		end

	start_arrow (a_end_insert_pos: CE_POINTER [PD_POS_T])
		do
			if not ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
				(create {P_GETCHAR_STATIC}).AppendToRedobuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/")))
				stop_insert (a_end_insert_pos, 0);
				(create {P_GLOBALS_STATIC}).arrow_used.item := 1
			end
			check_spell_redraw
		end

	check_spell_redraw
		local
			l_lnum: INTEGER_32
		do
			if (create {P_GLOBALS_STATIC}).spell_redraw_lnum.item /= 0 then
				l_lnum := (create {P_GLOBALS_STATIC}).spell_redraw_lnum.item;
				(create {P_GLOBALS_STATIC}).spell_redraw_lnum.item := (0).to_integer_32;
				(create {P_SCREEN_STATIC}).redrawWinline (l_lnum, 0)
			end
		end

	spell_back_to_badword
		local
			l_tpos: CE_ARRAY [PD_POS_T]
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			spell_bad_len.item := ((create {P_GLOBALS_STATIC}).curwin.item).item.spell_move_to (-1, 1, 1, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer))
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= l_tpos.item.col then
				start_arrow (l_tpos)
			end
		end

	stop_arrow: INTEGER_32
		local
			l_tmp___3: INTEGER_32
		do
			if ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
				if ((create {P_UNDO_STATIC}).u_save_cursor) = 1 then
					(create {P_GLOBALS_STATIC}).arrow_used.item := 0
					ins_need_undo.item := 0
				end
				(create {P_GLOBALS_STATIC}).Insstart.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				Insstart_textlen.item := ((create {P_CHARSET_STATIC}).linetabsize (((create {P_MEMLINE_STATIC}).ml_get_curline)));
				(create {P_GLOBALS_STATIC}).ai_col.item := 0
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
					(create {P_GLOBALS_STATIC}).orig_line_count.item := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count).to_integer_32;
					(create {P_GLOBALS_STATIC}).vr_lines_changed.item := 1
				end
				(create {P_GETCHAR_STATIC}).ResetRedobuff;
				(create {P_GETCHAR_STATIC}).AppendToRedobuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("1i")))
				new_insert_skip.item := 2
			elseif ins_need_undo.item.to_boolean then
				if ((create {P_UNDO_STATIC}).u_save_cursor) = 1 then
					ins_need_undo.item := 0
				end
			end
			(create {P_FOLD_STATIC}).foldOpenCursor
			if ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
				l_tmp___3 := 0
			elseif ins_need_undo.item.to_boolean then
				l_tmp___3 := 0
			else
				l_tmp___3 := 1
			end
			Result := l_tmp___3
		end

	stop_insert (a_end_insert_pos: CE_POINTER [PD_POS_T]; a_esc: INTEGER_32)
		local
			l_cc___0: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_tpos: PD_POS_T
			l_tpos___0: PD_POS_T
			l_len: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_GETCHAR_STATIC}).stop_redo_ins
					replace_flush
					l_ptr := (create {P_GETCHAR_STATIC}).get_inserted
					if did_restart_edit.item = 0 then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (last_insert.item))
						last_insert.item := l_ptr
						last_insert_skip.item := new_insert_skip.item
					elseif not l_ptr.is_void then
						if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32 > new_insert_skip.item then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (last_insert.item))
							last_insert.item := l_ptr
							last_insert_skip.item := new_insert_skip.item
						else
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr))
						end
					else
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr))
					end
					if ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
						l_pos := -1 + 16 -- skip if block
					end
				when 1 then -- if:
						if a_end_insert_pos.is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						if ins_need_undo.item.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if not (((create {P_OPTION_STATIC}).has_format_option (('a').code)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_tpos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						l_cc___0 := ('x').code
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
							if ((create {P_MISC1_STATIC}).gchar_cursor) = 0 then
								(create {P_MISC2_STATIC}).dec_cursor.do_nothing
								l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
								if l_cc___0 /= 32 then
									if l_cc___0 /= 9 then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_tpos.twin
									end
								end
							end
						end
						auto_format (1, 0)
						if l_cc___0 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_cc___0 /= 9 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if ((create {P_MISC1_STATIC}).gchar_cursor) /= 0 then
							(create {P_MISC2_STATIC}).inc_cursor.do_nothing
						end
						if ((create {P_MISC1_STATIC}).gchar_cursor) = 0 then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = l_tpos.lnum then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = l_tpos.col then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := l_tpos.coladd
								end
							end
						end
				when 9 then -- if done | if done | if done
						check_auto_format (1)
						if not (((create {P_GLOBALS_STATIC}).did_ai.item).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						if not (a_esc.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 15 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 13 then -- else:
						if not (((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('I').code)).is_void) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = a_end_insert_pos.item.lnum then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L___0:
						if a_end_insert_pos.item.lnum <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_tpos___0 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (a_end_insert_pos.item).twin;
							(create {P_MISC2_STATIC}).check_cursor_col
							from
							until
								(l_break)
							loop
								l_break := False
								if ((create {P_MISC1_STATIC}).gchar_cursor) = 0 then
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 1
									end
								end
								l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
								if l_cc___0 /= 32 then
									if l_cc___0 /= 9 then
										l_break := True
									end
								end
								if not (l_break) then
									if ((create {P_MISC1_STATIC}).del_char (1)) = 0 then
										l_break := True
									end
								end
							end
							l_break := False
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= l_tpos___0.lnum then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_tpos___0.twin
							elseif l_cc___0 /= 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							end
							if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
									l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get_curline)))).to_integer_32
									if (create {P_GLOBALS_STATIC}).VIsual.item.item.col > l_len then
										(create {P_GLOBALS_STATIC}).VIsual.item.item.col := l_len;
										(create {P_GLOBALS_STATIC}).VIsual.item.item.coladd := 0
									end
								end
							end
						end
				when 16 then -- if done | if done | if done | if done | if done;
					(create {P_GLOBALS_STATIC}).did_ai.item := 0;
					(create {P_GLOBALS_STATIC}).did_si.item := 0;
					(create {P_GLOBALS_STATIC}).can_si.item := 0;
					(create {P_GLOBALS_STATIC}).can_si_back.item := 0
					if not a_end_insert_pos.is_void then
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start := ((create {P_GLOBALS_STATIC}).Insstart.item.item).twin;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end := (a_end_insert_pos.item).twin
					end
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_char2buf (a_c: INTEGER_32; a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_c: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_temp: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_temp.make (<<21>>)

			l_c := a_c
			l_s := a_s
			l_len := (create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_c, l_temp])
			l_i___0 := 0
			from
			until
				not (l_i___0 < l_len)
			loop
				l_c := (l_temp[l_i___0]).to_integer_32
				if l_c = 128 then
					l_tmp := l_s
					l_s := l_s + 1
					l_tmp.item := (128).to_natural_8
					l_tmp___0 := l_s
					l_s := l_s + 1
					l_tmp___0.item := (254).to_natural_8
					l_tmp___1 := l_s
					l_s := l_s + 1
					l_tmp___1.item := (('X').code).to_natural_8
				elseif l_c = 155 then
					l_tmp___2 := l_s
					l_s := l_s + 1
					l_tmp___2.item := (155).to_natural_8
					l_tmp___3 := l_s
					l_s := l_s + 1
					l_tmp___3.item := (253).to_natural_8
					l_tmp___4 := l_s
					l_s := l_s + 1
					l_tmp___4.item := (81).to_natural_8
				else
					l_tmp___5 := l_s
					l_s := l_s + 1
					l_tmp___5.item := l_c.to_natural_8
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_s
		end

	beginline (a_flags___0: INTEGER_32)
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((a_flags___0).bit_and (2)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not ((create {P_OPTION_STATIC}).p_sol.item.item).to_boolean then
							(create {P_MISC2_STATIC}).coladvance ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).do_nothing
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else: | _L___0:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
						if not (((a_flags___0).bit_and (3)).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						l_ptr := (create {P_MEMLINE_STATIC}).ml_get_curline
				when 5 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 14 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if (l_ptr.item).to_integer_32 /= 32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if (l_ptr.item).to_integer_32 /= 9 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						if ((a_flags___0).bit_and (4)).to_boolean then
							if (l_ptr[1]).to_integer_32 = 0 then
								l_break := True
							end
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_break := True
				when 13 then -- if done
						if not (l_break) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							l_ptr := l_ptr + 1
						end
						l_pos := -1 + 5 -- back to loop condition
				when 14 then -- loop done
						l_break := False
				when 15 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	oneright: INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_prevpos: PD_POS_T
			l_tmp: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
				l_prevpos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				l_ptr := (create {P_MEMLINE_STATIC}).ml_get_cursor
				l_tmp := (create {P_MISC2_STATIC}).getviscol
				if (l_ptr.item).to_integer_32 /= 9 then
					if ((create {P_CHARSET_STATIC}).vim_isprintc (((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_ptr])))).to_boolean then
						l_tmp___3 := ((create {P_CHARSET_STATIC}).ptr2cells (l_ptr))
					else
						l_tmp___3 := 1
					end
				else
					l_tmp___3 := 1
				end
				(create {P_MISC2_STATIC}).coladvance (l_tmp + l_tmp___3).do_nothing;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
				if l_prevpos.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
					l_tmp___6 := 1
				elseif l_prevpos.coladd /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd then
					l_tmp___6 := 1
				else
					l_tmp___6 := 0
				end
				Result := l_tmp___6
				l_return := True
			end
			if not l_return then
				l_ptr := (create {P_MEMLINE_STATIC}).ml_get_cursor
				if (l_ptr.item).to_integer_32 = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr])
				else
					l_l := 1
				end
				if (l_ptr[l_l]).to_integer_32 = 0 then
					if (((create {P_OPTION_STATIC}).ve_flags.item.item).bit_and ({NATURAL_32} 8)) = {NATURAL_32} 0 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + l_l;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
				Result := 1
			end
		end

	oneleft: INTEGER_32
		local
			l_width: INTEGER_32
			l_v: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_MISC2_STATIC}).virtual_active).to_boolean) then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_v := ((create {P_MISC2_STATIC}).getviscol)
						if l_v = 0 then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_width := 1
				when 3 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False;
						(create {P_MISC2_STATIC}).coladvance (l_v - l_width).do_nothing
						if ((create {P_OPTION_STATIC}).p_sbr.item.item.item).to_integer_32 /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_break := True
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if ((create {P_MISC2_STATIC}).getviscol) < l_v then
							l_break := True
						end
				when 8 then
						if not (l_break) then
							l_width := l_width + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 9 then -- loop done
						l_break := False
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd = 1 then
							l_ptr := (create {P_MEMLINE_STATIC}).ml_get_cursor
							if (l_ptr.item).to_integer_32 /= 9 then
								if ((create {P_CHARSET_STATIC}).vim_isprintc (((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_ptr])))).to_boolean then
									if ((create {P_CHARSET_STATIC}).ptr2cells (l_ptr)) > 1 then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
									end
								end
							end
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
						Result := 1
						l_return := True
				when 10 then -- if done | if done
					if not l_return and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = 0) then
						Result := 0
						l_return := True
					end
					if not l_return then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 1
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							(create {P_MBYTE_STATIC}).mb_adjust_cursor
						end
						Result := 1
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cursor_up (a_n: INTEGER_32; a_upd_topline: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)

			l_n := a_n
			if l_n > 0 then
				l_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
				if l_lnum.item <= 1 then
					Result := 0
					l_return := True
				elseif l_n >= l_lnum.item then
					if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('-').code)).is_void then
						Result := 0
						l_return := True
					end
				end
				if not l_return then
					if l_n >= l_lnum.item then
						l_lnum.item := (1).to_integer_32
					elseif (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
						(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___0 := l_n
							l_n := l_n - 1
							if not l_tmp___0.to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_lnum.item := l_lnum.item - 1
								if l_lnum.item <= 1 then
									l_break := True
								end
							end
							if not (l_break) then
								if l_n > 0 then
									(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
								elseif not (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
									if not (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 1)).to_boolean then
										(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing
									end
								end
							end
						end
						l_break := False
						if l_lnum.item < 1 then
							l_lnum.item := (1).to_integer_32
						end
					else
						l_lnum.item := l_lnum.item - l_n
					end
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).coladvance ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).do_nothing
				if a_upd_topline.to_boolean then
					(create {P_MOVE_STATIC}).update_topline
				end
				Result := 1
			end
		end

	cursor_down (a_n: INTEGER_32; a_upd_topline: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_last: CE_ARRAY [INTEGER_32]
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_last.make (<<1>>)

			l_n := a_n
			if l_n > 0 then
				l_lnum.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
				(create {P_FOLD_STATIC}).hasFolding (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnum).do_nothing
				if l_lnum.item >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
					Result := 0
					l_return := True
				elseif l_lnum.item + l_n > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
					if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('-').code)).is_void then
						Result := 0
						l_return := True
					end
				end
				if not l_return then
					if l_lnum.item + l_n >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
						l_lnum.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
					elseif (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___1 := l_n
							l_n := l_n - 1
							if not l_tmp___1.to_boolean then
								l_break := True
							end
							if not (l_break) then
								if ((create {P_FOLD_STATIC}).hasFolding (l_lnum.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_last)).to_boolean then
									l_lnum.item := l_last.item + 1
								else
									l_lnum.item := l_lnum.item + 1
								end
								if l_lnum.item >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
									l_break := True
								end
							end
						end
						l_break := False
						if l_lnum.item > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_lnum.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
						end
					else
						l_lnum.item := l_lnum.item + l_n
					end
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).coladvance ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).do_nothing
				if a_upd_topline.to_boolean then
					(create {P_MOVE_STATIC}).update_topline
				end
				Result := 1
			end
		end

	stuff_inserted (a_c: INTEGER_32; a_count___2: INTEGER_32; a_no_esc: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_esc_ptr: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_last_ptr: CE_POINTER [NATURAL_8]
			l_last: NATURAL_8
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_count___2 := a_count___2
					l_last := (('%/0/').code).to_natural_8
					l_ptr := get_last_insert
					if l_ptr.is_void then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_noinstext.item)))))).do_nothing
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_c /= 0 then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (a_c)
						end
						l_esc_ptr := ((create {P_MISC2_STATIC}).vim_strrchr (l_ptr, ('%/27/').code))
						if not l_esc_ptr.is_void then
							l_esc_ptr.item := (('%/0/').code).to_natural_8
						end
						if (not l_esc_ptr.is_void) then
							l_tmp___2 := l_esc_ptr
						else
							l_tmp___2 := l_ptr + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32
						end
						l_last_ptr := l_tmp___2 - 1
						if not ((l_last_ptr.c_pointer.to_integer_32).to_natural_32 >= (l_ptr.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						if (l_last_ptr.item).to_integer_32 /= 48 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if (l_last_ptr.item).to_integer_32 /= 94 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						if a_no_esc.to_boolean then
							l_last := l_last_ptr.item
							l_last_ptr.item := (('%/0/').code).to_natural_8
						elseif (l_ptr.item).to_integer_32 = 4 then
							if l_count___2 > 1 then
								l_last := l_last_ptr.item
								l_last_ptr.item := (('%/0/').code).to_natural_8
							end
						end
				when 7 then -- if done | if done
						from
						until
							(l_break)
						loop
							l_break := False;
							(create {P_GETCHAR_STATIC}).stuffReadbuff (l_ptr)
							if l_last.to_boolean then
								if l_last.to_integer_32 = 48 then
									l_tmp___3 := ce_string ("%/22/048")
								else
									l_tmp___3 := ce_string ("%/22/^")
								end
								(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3))
							end
							l_count___2 := l_count___2 - 1
							if not (l_count___2 > 0) then
								l_break := True
							end
						end
						l_break := False
						if l_last.to_boolean then
							l_last_ptr.item := l_last
						end
						if not l_esc_ptr.is_void then
							l_esc_ptr.item := (('%/27/').code).to_natural_8
						end
						if not a_no_esc.to_boolean then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (('%/27/').code)
						end
						Result := 1
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_last_insert: CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if last_insert.item.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (last_insert.item + last_insert_skip.item)
			end
		end

	get_last_insert_save: CE_POINTER [NATURAL_8]
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			if last_insert.item.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_s := (create {P_MISC2_STATIC}).vim_strsave (last_insert.item + last_insert_skip.item)
				if not l_s.is_void then
					l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
					if l_len > 0 then
						if (l_s[(l_len - 1)]).to_integer_32 = 27 then
							l_s[(l_len - 1)] := (('%/0/').code).to_natural_8
						end
					end
				end
				Result := l_s
			end
		end

	echeck_abbr (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
				Result := 0
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).no_abbr.item).to_boolean then
				Result := 0
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
					l_tmp := (create {P_GLOBALS_STATIC}).Insstart.item.item.col
				else
					l_tmp := 0
				end
				Result := ((create {P_GETCHAR_STATIC}).check_abbr (a_c, ((create {P_MEMLINE_STATIC}).ml_get_curline), (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col, l_tmp))
			end
		end

	replace_push (a_c: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if replace_stack_nr.item < ((create {P_GLOBALS_STATIC}).replace_offset.item).to_integer_32 then
				l_return := True
			end
			if not l_return and then (replace_stack_len.item <= replace_stack_nr.item) then
				replace_stack_len.item := replace_stack_len.item + (50)
				l_p___0 := (create {P_MISC2_STATIC}).lalloc (({PLATFORM}.Natural_8_bytes.to_natural_32).to_natural_32 * replace_stack_len.item.to_natural_32, 1)
				if l_p___0.is_void then
					replace_stack_len.item := replace_stack_len.item - (50)
					l_return := True
				end
				if not l_return then
					if not replace_stack.item.is_void then
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (replace_stack.item), (replace_stack_nr.item.to_natural_32 * ({PLATFORM}.Natural_8_bytes.to_natural_32).to_natural_32).to_natural_32).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (replace_stack.item))
					end
					replace_stack.item := l_p___0
				end
			end
			if not l_return then
				l_p___0 := (replace_stack.item + replace_stack_nr.item) - (create {P_GLOBALS_STATIC}).replace_offset.item
				if ((create {P_GLOBALS_STATIC}).replace_offset.item).to_boolean then
					memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), create {CE_VOID_POINTER}.make_cast (l_p___0), ((create {P_GLOBALS_STATIC}).replace_offset.item).to_natural_32 * {PLATFORM}.Natural_8_bytes.to_natural_32).do_nothing
				end
				l_p___0.item := a_c.to_natural_8
				replace_stack_nr.item := replace_stack_nr.item + 1
			end
		end

	replace_push_mb (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_l: INTEGER_32
			l_j: INTEGER_32
		do
			l_l := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_p___0]))
			l_j := l_l - 1
			from
			until
				not (l_j >= 0)
			loop
				replace_push ((a_p___0[l_j]).to_integer_32)
				l_j := l_j - 1
			end
			Result := l_l
		end

	replace_pop: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if replace_stack_nr.item = 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				replace_stack_nr.item := replace_stack_nr.item - 1
				Result := (replace_stack.item[replace_stack_nr.item]).to_integer_32
			end
		end

	replace_join (a_off___0: INTEGER_32)
		local
			l_off___0: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_off___0 := a_off___0
			l_i___0 := replace_stack_nr.item.to_integer_32
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_i___0 := l_i___0 - 1
				if not (l_i___0 >= 0) then
					l_break := True
				end
				if not (l_return or l_break) and then ((replace_stack.item[l_i___0]).to_integer_32 = 0) then
					l_tmp := l_off___0
					l_off___0 := l_off___0 - 1
					if l_tmp <= 0 then
						replace_stack_nr.item := replace_stack_nr.item - 1
						memmove (create {CE_VOID_POINTER}.make_cast ((replace_stack.item + l_i___0)), create {CE_VOID_POINTER}.make_cast (((replace_stack.item + l_i___0) + 1)), (replace_stack_nr.item - l_i___0.to_integer_32).to_natural_32).do_nothing
						l_return := True
					end
				end
			end
			if not l_return then
				l_break := False
			end
		end

	replace_pop_ins
		local
			l_cc___0: INTEGER_32
			l_oldState: INTEGER_32
			l_break: BOOLEAN
		do
			l_oldState := (create {P_GLOBALS_STATIC}).State.item;
			(create {P_GLOBALS_STATIC}).State.item := 1
			from
			until
				(l_break)
			loop
				l_break := False
				l_cc___0 := replace_pop
				if not (l_cc___0 > 0) then
					l_break := True
				end
				if not (l_break) then
					mb_replace_pop_ins (l_cc___0);
					(create {P_MISC2_STATIC}).dec_cursor.do_nothing
				end
			end
			l_break := False;
			(create {P_GLOBALS_STATIC}).State.item := l_oldState
		end

	mb_replace_pop_ins (a_cc___0: INTEGER_32)
		local
			l_n: INTEGER_32
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<21>>)

			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_n := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[a_cc___0]).to_integer_32
				if l_n > 1 then
					l_buf___6[0] := a_cc___0.to_natural_8
					l_i___0 := 1
					from
					until
						not (l_i___0 < l_n)
					loop
						l_buf___6[l_i___0] := (replace_pop).to_natural_8
						l_i___0 := l_i___0 + 1
					end
					(create {P_MISC1_STATIC}).ins_bytes_len (l_buf___6, l_n)
				else
					(create {P_MISC1_STATIC}).ins_char (a_cc___0)
				end
			else
				(create {P_MISC1_STATIC}).ins_char (a_cc___0)
			end
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_c := replace_pop
					if l_c = -1 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_n := ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_c]).to_integer_32
						if l_n = 1 then
							replace_push (l_c)
							l_break := True
						else
							l_buf___6[0] := l_c.to_natural_8
							l_i___0 := 1
							from
							until
								not (l_i___0 < l_n)
							loop
								l_buf___6[l_i___0] := (replace_pop).to_natural_8
								l_i___0 := l_i___0 + 1
							end
							if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (l_buf___6)))).to_boolean then
								(create {P_MISC1_STATIC}).ins_bytes_len (l_buf___6, l_n)
							else
								l_i___0 := l_n - 1
								from
								until
									not (l_i___0 >= 0)
								loop
									replace_push ((l_buf___6[l_i___0]).to_integer_32)
									l_i___0 := l_i___0 - 1
								end
								l_break := True
							end
						end
					end
				end
				l_break := False
			end
		end

	replace_flush
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (replace_stack.item))
			replace_stack.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			replace_stack_len.item := 0
			replace_stack_nr.item := 0
		end

	replace_do_bs (a_limit_col: INTEGER_32)
		local
			l_cc___0: INTEGER_32
			l_orig_len: INTEGER_32
			l_ins_len: INTEGER_32
			l_orig_vcols: INTEGER_32
			l_start_vcol: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_vcol: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_start_vcol.make (<<1>>)

			l_orig_len := 0
			l_orig_vcols := 0
			l_cc___0 := replace_pop
			if l_cc___0 > 0 then
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
					((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_start_vcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					l_orig_vcols := (create {P_CHARSET_STATIC}).chartabsize (((create {P_MEMLINE_STATIC}).ml_get_cursor), l_start_vcol.item)
				end
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					del_char_after_col (a_limit_col).do_nothing
					if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
						l_orig_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get_cursor)))).to_integer_32
					end
					replace_push (l_cc___0)
				else
					(create {P_MISC1_STATIC}).pchar_cursor (l_cc___0)
					if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
						l_orig_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get_cursor)))).to_integer_32 - 1
					end
				end
				replace_pop_ins
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
					l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_cursor
					l_ins_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32 - l_orig_len
					l_vcol := l_start_vcol.item
					l_i___0 := 0
					from
					until
						not (l_i___0 < l_ins_len)
					loop
						l_vcol := l_vcol + ((create {P_CHARSET_STATIC}).chartabsize (l_p___0 + l_i___0, l_vcol))
						l_i___0 := l_i___0 + (((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])) - 1)
						l_i___0 := l_i___0 + 1
					end
					l_vcol := l_vcol - (l_start_vcol.item);
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + l_ins_len
					from
					until
						(l_break)
					loop
						l_break := False
						if l_vcol > l_orig_vcols then
							if ((create {P_MISC1_STATIC}).gchar_cursor) /= 32 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							(create {P_MISC1_STATIC}).del_char (0).do_nothing
							l_orig_vcols := l_orig_vcols + 1
						end
					end
					l_break := False;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - l_ins_len
				end
				(create {P_MISC1_STATIC}).changed_bytes ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
			elseif l_cc___0 = 0 then
				del_char_after_col (a_limit_col).do_nothing
			end
		end

	cindent_on: INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cin).to_boolean then
					l_tmp := 1
				elseif (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_inde).item).to_integer_32 /= 0 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	fixthisline (a_get_the_indent: CE_ROUTINE)
		require
			not a_get_the_indent.is_void
		do
			change_indent (1, (a_get_the_indent.integer_32_item ([])), 0, 0, 1)
			if ((create {P_SEARCH_STATIC}).linewhite ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).to_boolean then
				(create {P_GLOBALS_STATIC}).did_ai.item := 1
			end
		end

	in_cinkeys (a_keytyped, a_when, a_line_is_empty: INTEGER_32): INTEGER_32
		local
			l_look: CE_POINTER [NATURAL_8]
			l_try_match: INTEGER_32
			l_try_match_word: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_icase: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___8: INTEGER_32
			l_match: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_n: CE_POINTER [NATURAL_8]
			l_tmp___16: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_keytyped = 0 then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 56 -- skip if block
					end
				when 1 then -- if:
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_inde).item).to_integer_32 /= 0 then
							l_look := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_indk
						else
							l_look := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cink
						end
				when 2 then -- loop condition:
						if not (not (l_return) and then ((l_look.item).to_boolean)) then
							l_pos := -1 + 56 -- skip loop
						end
				when 3 then -- loop body:
						inspect a_when -- switch 1 head
						when 42 then l_pos := -1 + 4
						when 33 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case 42
						l_try_match := ((l_look.item).to_integer_32 = 42).to_integer
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 33
						l_try_match := ((l_look.item).to_integer_32 = 33).to_integer
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						l_try_match := ((l_look.item).to_integer_32 /= 42).to_integer
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						if (l_look.item).to_integer_32 = 42 then
							l_look := l_look + 1
						elseif (l_look.item).to_integer_32 = 33 then
							l_look := l_look + 1
						end
						if (l_look.item).to_integer_32 = 48 then
							l_try_match_word := l_try_match
							if not a_line_is_empty.to_boolean then
								l_try_match := 0
							end
							l_look := l_look + 1
						else
							l_try_match_word := 0
						end
						if (l_look.item).to_integer_32 /= 94 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if (l_look[1]).to_integer_32 >= 63 then
							if (l_look[1]).to_integer_32 <= 95 then
								if l_try_match.to_boolean then
									if (l_look[1]).to_integer_32 < 97 then
										l_tmp := (l_look[1]).to_integer_32
									elseif (l_look[1]).to_integer_32 > 122 then
										l_tmp := (l_look[1]).to_integer_32
									else
										l_tmp := (l_look[1]).to_integer_32 - 32
									end
									if a_keytyped = ((l_tmp).bit_xor (64)) then
										Result := 1
										l_return := True
									end
								end
								if not l_return then
									l_look := l_look + (2)
								end
							else
								l_pos := -1 + 10 -- goto _L___5
							end
						else
							l_pos := -1 + 10 -- goto _L___5
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 10 then -- else: | _L___5:
						if (l_look.item).to_integer_32 /= 111 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_try_match.to_boolean then
							if a_keytyped = 257 then
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							l_look := l_look + 1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 13 then -- else:
						if (l_look.item).to_integer_32 /= 79 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_try_match.to_boolean then
							if a_keytyped = 258 then
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							l_look := l_look + 1
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 16 then -- else:
						if (l_look.item).to_integer_32 /= 101 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_try_match.to_boolean then
							if a_keytyped = 101 then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col >= 4 then
									l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_curline
									if ((create {P_CHARSET_STATIC}).skipwhite (l_p___0)).is_equal ((l_p___0 + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 4) then
										if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (((l_p___0 + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 4)), ce_string ("else"), (4).to_natural_32)) = 0 then
											Result := 1
											l_return := True
										end
									end
								end
							end
						end
						if not l_return then
							l_look := l_look + 1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 19 then -- else:
						if (l_look.item).to_integer_32 /= 58 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if l_try_match.to_boolean then
							if a_keytyped = 58 then
								l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_curline
								if ((create {P_MISC1_STATIC}).cin_iscase (l_p___0, 0)).to_boolean then
									Result := 1
									l_return := True
								elseif ((create {P_MISC1_STATIC}).cin_isscopedecl (l_p___0)).to_boolean then
									Result := 1
									l_return := True
								elseif ((create {P_MISC1_STATIC}).cin_islabel (30)).to_boolean then
									Result := 1
									l_return := True
								end
								if not l_return then
									l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_curline
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 2 then
										if (l_p___0[((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - 1)]).to_integer_32 = 58 then
											if (l_p___0[((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - 2)]).to_integer_32 = 58 then
												l_p___0[((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - 1)] := ((' ').code).to_natural_8
												if ((create {P_MISC1_STATIC}).cin_iscase (l_p___0, 0)).to_boolean then
													l_tmp___8 := 1
												elseif ((create {P_MISC1_STATIC}).cin_isscopedecl (l_p___0)).to_boolean then
													l_tmp___8 := 1
												elseif ((create {P_MISC1_STATIC}).cin_islabel (30)).to_boolean then
													l_tmp___8 := 1
												else
													l_tmp___8 := 0
												end
												l_i___0 := l_tmp___8
												l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_curline
												l_p___0[((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - 1)] := ((':').code).to_natural_8
												if l_i___0.to_boolean then
													Result := 1
													l_return := True
												end
											end
										end
									end
								end
							end
						end
						if not l_return then
							l_look := l_look + 1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 22 then -- else:
						if (l_look.item).to_integer_32 /= 60 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if l_try_match.to_boolean then
							if not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<>!*oOe0:")), (l_look[1]).to_integer_32)).is_void then
								if a_keytyped = (l_look[1]).to_integer_32 then
									Result := 1
									l_return := True
								end
							end
							if not l_return then
								if a_keytyped = ((create {P_MISC2_STATIC}).get_special_key_code (l_look + 1)) then
									Result := 1
									l_return := True
								end
							end
						end
						if not l_return then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_look.item).to_boolean then
									if (l_look.item).to_integer_32 = 62 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_look := l_look + 1
								end
							end
							l_break := False
							from
							until
								(l_look.item).to_integer_32 /= 62
							loop
								l_look := l_look + 1
							end
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 25 then -- else:
						if (l_look.item).to_integer_32 /= 61 then
							l_pos := -1 + 54 -- skip if block
						end
				when 26 then -- if:
						if (l_look[1]).to_integer_32 = 44 then
							l_pos := -1 + 52 -- skip if block
						end
				when 27 then -- if:
						if (l_look[1]).to_integer_32 = 0 then
							l_pos := -1 + 50 -- skip if block
						end
				when 28 then -- if:
						l_look := l_look + 1
						if (l_look.item).to_integer_32 = 126 then
							l_icase := 1
							l_look := l_look + 1
						else
							l_icase := 0
						end
						l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_look, (',').code)
						if l_p___0.is_void then
							l_p___0 := l_look + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_look))).to_integer_32
						end
						if not (l_try_match.to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 32 -- goto _L___1
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 48
				when 31 then -- else:
						if not (l_try_match_word.to_boolean) then
							l_pos := -1 + 48 -- skip if block
						end
				when 32 then -- if: | _L___1:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col >= l_p___0.distance (l_look)) then
							l_pos := -1 + 48 -- skip if block
						end
				when 33 then -- if:
						l_match := 0
						if a_keytyped /= 259 then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_s := l_line + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							from
							until
								not (not (l_break) and then ((l_s.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32))
							loop
								l_break := False
								l_n := (create {P_MBYTE_STATIC}).mb_prevptr (l_line, l_s)
								if not ((create {P_CHARSET_STATIC}).vim_iswordp (l_n)).to_boolean then
									l_break := True
								end
								if not (l_break) then
									l_s := l_n
								end
							end
							l_break := False
						else
							l_s := l_line + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							from
							until
								not (not (l_break) and then ((l_s.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32))
							loop
								l_break := False
								if not ((create {P_CHARSET_STATIC}).vim_iswordc ((l_s[-1]).to_integer_32)).to_boolean then
									l_break := True
								end
								if not (l_break) then
									l_s := l_s - 1
								end
							end
							l_break := False
						end
						if ((l_s + (l_p___0.distance (l_look))).c_pointer.to_integer_32).to_natural_32 <= ((l_line + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).c_pointer.to_integer_32).to_natural_32 then
							if l_icase.to_boolean then
								l_tmp___16 := ((create {P_MBYTE_STATIC}).mb_strnicmp (l_s, l_look, (l_p___0.distance (l_look)).to_natural_32))
							else
								l_tmp___16 := (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), create {CE_INTEGER_8_POINTER}.make_cast (l_look), (l_p___0.distance (l_look)).to_natural_32))
							end
							if l_tmp___16 = 0 then
								l_match := 1
							end
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 36 then -- else:
						if a_keytyped /= (l_p___0[-1]).to_integer_32 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 42 -- goto _L___0
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 39 then -- else:
						if not (l_icase.to_boolean) then
							l_pos := -1 + 47 -- skip if block
						end
				when 40 then -- if:
						if not (a_keytyped < 256) then
							l_pos := -1 + 47 -- skip if block
						end
				when 41 then -- if:
						l_tmp___21 := tolower (a_keytyped)
						if l_tmp___21 /= (tolower ((l_p___0[-1]).to_integer_32)) then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if: | _L___0:
						l_line := (create {P_MEMLINE_STATIC}).ml_get_cursor
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= l_p___0.distance (l_look) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 46 -- goto _L
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 47
				when 45 then -- else:
						if ((create {P_CHARSET_STATIC}).vim_iswordc ((l_line[(-(l_p___0.distance (l_look)) - 1)]).to_integer_32)).to_boolean then
							l_pos := -1 + 47 -- skip if block
						end
				when 46 then -- if: | _L:
						if l_icase.to_boolean then
							l_tmp___20 := ((create {P_MBYTE_STATIC}).mb_strnicmp (l_line - (l_p___0.distance (l_look)), l_look, (l_p___0.distance (l_look)).to_natural_32))
						else
							l_tmp___20 := (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_line - (l_p___0.distance (l_look)))), create {CE_INTEGER_8_POINTER}.make_cast (l_look), (l_p___0.distance (l_look)).to_natural_32))
						end
						if l_tmp___20 = 0 then
							l_match := 1
						end
				when 47 then -- if done | if done | if done | if done | if done | if done
						if l_match.to_boolean then
							if l_try_match_word.to_boolean then
								if not l_try_match.to_boolean then
									l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
									if ((create {P_CHARSET_STATIC}).skipwhite (l_line)).distance (l_line) /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - (l_p___0.distance (l_look)) then
										l_match := 0
									end
								end
							end
						end
						if l_match.to_boolean then
							Result := 1
							l_return := True
						end
				when 48 then -- if done | if done
						if not l_return then
							l_look := l_p___0
						end
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 51
				when 50 then -- else:
						l_pos := -1 + 54 -- goto _L___3
				when 51 then -- if done | if block done, skip else block:
						l_pos := -1 + 53
				when 52 then -- else:
						l_pos := -1 + 54 -- goto _L___3
				when 53 then -- if done | if block done, skip else block:
						l_pos := -1 + 55
				when 54 then -- else: | _L___3:
						if l_try_match.to_boolean then
							if (l_look.item).to_integer_32 = a_keytyped then
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							l_look := l_look + 1
						end
				when 55 then -- if done | if done | if done | if done | if done | if done
						if not l_return then
							l_look := (create {P_MISC1_STATIC}).skip_to_option_part (l_look)
						end
						l_pos := -1 + 2 -- back to loop condition
				when 56 then -- loop done | if done
					if not l_return then
						Result := 0
					end
				when 57 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_reg
		local
			l_need_redraw: INTEGER_32
			l_regname___0: INTEGER_32
			l_literally: INTEGER_32
			l_vis_active: INTEGER_32
			l_im_on: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_need_redraw := 0
					l_literally := 0
					l_vis_active := (create {P_GLOBALS_STATIC}).VIsual_active.item
					pc_status.item := 0
					if ((create {P_SCREEN_STATIC}).redrawing).to_boolean then
						if not ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
							ins_redraw (0)
							edit_putchar (('%"').code, 1);
							(create {P_NORMAL_STATIC}).add_to_showcmd_c (18)
						end
					end
					(create {P_GLOBALS_STATIC}).dont_scroll.item := 1;
					(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
					l_regname___0 := (create {P_GETCHAR_STATIC}).plain_vgetc
					if l_regname___0 = 18 then
						l_literally := l_regname___0;
						(create {P_NORMAL_STATIC}).add_to_showcmd_c (l_literally)
						l_regname___0 := (create {P_GETCHAR_STATIC}).plain_vgetc
					elseif l_regname___0 = 15 then
						l_literally := l_regname___0;
						(create {P_NORMAL_STATIC}).add_to_showcmd_c (l_literally)
						l_regname___0 := (create {P_GETCHAR_STATIC}).plain_vgetc
					elseif l_regname___0 = 16 then
						l_literally := l_regname___0;
						(create {P_NORMAL_STATIC}).add_to_showcmd_c (l_literally)
						l_regname___0 := (create {P_GETCHAR_STATIC}).plain_vgetc
					end
					(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
					(create {P_GLOBALS_STATIC}).no_u_sync.item := (create {P_GLOBALS_STATIC}).no_u_sync.item + 1
					if l_regname___0 = 61 then
						l_im_on := ((create {P_MBYTE_STATIC}).im_get_status)
						l_regname___0 := (create {P_OPS_STATIC}).get_expr_register
						if l_im_on.to_boolean then
							(create {P_MBYTE_STATIC}).im_set_active (1)
						end
					end
					if l_regname___0 /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:;
						(create {P_MISC1_STATIC}).vim_beep
						l_need_redraw := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if not (((create {P_OPS_STATIC}).valid_yank_reg (l_regname___0, 0)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_literally /= 15 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_literally /= 16 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L:;
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (18);
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (l_literally);
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (l_regname___0)
						if l_literally = 16 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
						(create {P_OPS_STATIC}).do_put (l_regname___0, -1, 1, (l_tmp___2).bit_or (2))
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if ((create {P_OPS_STATIC}).insert_reg (l_regname___0, l_literally)) = 0 then
							(create {P_MISC1_STATIC}).vim_beep
							l_need_redraw := 1
						elseif ((create {P_GLOBALS_STATIC}).stop_insert_mode.item).to_boolean then
							l_need_redraw := 1
						end
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:;
						(create {P_MISC1_STATIC}).vim_beep
						l_need_redraw := 1
				when 13 then -- if done;
					(create {P_GLOBALS_STATIC}).no_u_sync.item := (create {P_GLOBALS_STATIC}).no_u_sync.item - 1;
					(create {P_NORMAL_STATIC}).clear_showcmd
					if l_need_redraw.to_boolean then
						edit_unputchar
					elseif ((create {P_GETCHAR_STATIC}).stuff_empty).to_boolean then
						edit_unputchar
					end
					if not l_vis_active.to_boolean then
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							(create {P_NORMAL_STATIC}).end_visual_mode
						end
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_ctrl_g
		local
			l_c: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:;
					(create {P_SCREEN_STATIC}).setcursor;
					(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1
					l_c := (create {P_GETCHAR_STATIC}).plain_vgetc;
					(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1
					inspect l_c -- switch 1 head
					when -30059 then l_pos := -1 + 1 -- -(107 + ((117).bit_shift_left (8)))
					when 11 then l_pos := -1 + 1
					when 107 then l_pos := -1 + 1
					when -25707 then l_pos := -1 + 2 -- -(107 + ((100).bit_shift_left (8)))
					when 10 then l_pos := -1 + 2
					when 106 then l_pos := -1 + 2
					when 117 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case -(107 + (117 << 8)) | switch 1, case 11 | switch 1, case 107
					ins_up (1)
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case -(107 + (100 << 8)) | switch 1, case 10 | switch 1, case 106
					ins_down (1)
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 117;
					(create {P_UNDO_STATIC}).u_sync (1)
					ins_need_undo.item := 1;
					(create {P_GLOBALS_STATIC}).Insstart.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:;
					(create {P_MISC1_STATIC}).vim_beep
				when 5 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_ctrl_hat
		do
			if ((create {P_GETCHAR_STATIC}).map_to_exists_mode (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), 32, 0)).to_boolean then
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (32)).to_boolean then
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert := 0;
					(create {P_GLOBALS_STATIC}).State.item := ((create {P_GLOBALS_STATIC}).State.item).bit_and ((-33))
				else
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert := 1;
					(create {P_GLOBALS_STATIC}).State.item := ((create {P_GLOBALS_STATIC}).State.item).bit_or ((32));
					(create {P_MBYTE_STATIC}).im_set_active (0)
				end
			elseif ((create {P_MBYTE_STATIC}).im_get_status).to_boolean then
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert := 0;
				(create {P_MBYTE_STATIC}).im_set_active (0)
			else
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_iminsert := 2;
				(create {P_GLOBALS_STATIC}).State.item := ((create {P_GLOBALS_STATIC}).State.item).bit_and ((-33));
				(create {P_MBYTE_STATIC}).im_set_active (1)
			end
			(create {P_OPTION_STATIC}).set_iminsert_global;
			(create {P_SCREEN_STATIC}).showmode.do_nothing
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui_update_cursor (1, 0)
			end
		end

	ins_esc (a_count___2: CE_POINTER [INTEGER_32]; a_cmdchar, a_nomove: INTEGER_32): INTEGER_32
		local
			l_temp: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					check_spell_redraw
					l_temp := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
					if disabled_redraw.item.to_boolean then
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1
						disabled_redraw.item := 0
					end
					if not ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
						if a_cmdchar /= 114 then
							if a_cmdchar /= 118 then
								if ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
									l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%F"))
								else
									l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/"))
								end
								(create {P_GETCHAR_STATIC}).AppendToRedobuff (l_tmp)
							end
						end
						if a_count___2.item > 0 then
							(create {P_MISC1_STATIC}).line_breakcheck
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								a_count___2.item := 0
							end
						end
						a_count___2.item := (a_count___2.item) - 1
						if a_count___2.item > 0 then
							if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('X').code)).is_void then
								(create {P_GLOBALS_STATIC}).State.item := ((create {P_GLOBALS_STATIC}).State.item).bit_and ((-65))
							end
							(create {P_GETCHAR_STATIC}).start_redo_ins.do_nothing
							if a_cmdchar = 114 then
								(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/")))
							elseif a_cmdchar = 118 then
								(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/27/")))
							end
							(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item + 1
							disabled_redraw.item := 1
							Result := 0
							l_return := True
						end
						if not l_return then
							stop_insert (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), 1)
							undisplay_dollar
						end
					end
					if l_return then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
							if l_temp = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
							end
						end
						if not ((create {P_GLOBALS_STATIC}).cmdmod.item.item.keepjumps).to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_last_insert := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						end
						if a_nomove.to_boolean then
							l_pos := -1 + 18 -- skip if block
						end
				when 2 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 5 then -- else:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0) then
							l_pos := -1 + 18 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 9 then -- else:
						if ((create {P_MISC1_STATIC}).gchar_cursor) /= 0 then
							l_pos := -1 + 18 -- skip if block
						end
				when 10 then -- if:
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							l_pos := -1 + 18 -- skip if block
						end
				when 11 then -- if: | _L___0:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						if (create {P_OPTION_STATIC}).ve_flags.item.item /= {NATURAL_32} 4 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L:
						oneleft.do_nothing
						if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd) + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 1
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							(create {P_MBYTE_STATIC}).mb_adjust_cursor
						end
				when 18 then -- if done | if done | if done | if done | if done | if done | if done
						if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (32)).to_boolean then
							(create {P_UI_STATIC}).im_save_status (create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_p_iminsert")))
						end
						(create {P_MBYTE_STATIC}).im_set_active (0);
						(create {P_GLOBALS_STATIC}).State.item := 1;
						(create {P_MOVE_STATIC}).changed_cline_bef_curs;
						(create {P_TERM_STATIC}).setmouse;
						(create {P_UI_STATIC}).ui_cursor_shape
						if ((create {P_GLOBALS_STATIC}).Recording.item).to_boolean then
							(create {P_SCREEN_STATIC}).showmode.do_nothing
						elseif (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
							(create {P_SCREEN_STATIC}).showmode.do_nothing
						elseif ((create {P_OPTION_STATIC}).p_smd.item.item).to_boolean then
							(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))).do_nothing
						end
						Result := 1
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_start_select (a_c: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_GLOBALS_STATIC}).km_startsel.item).to_boolean) then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						inspect a_c -- switch 1 head
						when -12619 then l_pos := -1 + 2 -- -(75 + ((49).bit_shift_left (8)))
						when -13387 then l_pos := -1 + 2 -- -(75 + ((52).bit_shift_left (8)))
						when -20587 then l_pos := -1 + 2 -- -(107 + ((80).bit_shift_left (8)))
						when -13131 then l_pos := -1 + 2 -- -(75 + ((51).bit_shift_left (8)))
						when -20075 then l_pos := -1 + 2 -- -(107 + ((78).bit_shift_left (8)))
						when -13643 then l_pos := -1 + 2 -- -(75 + ((53).bit_shift_left (8)))
						when -13347 then l_pos := -1 + 3 -- -(35 + ((52).bit_shift_left (8)))
						when -26917 then l_pos := -1 + 3 -- -(37 + ((105).bit_shift_left (8)))
						when -1277 then l_pos := -1 + 3 -- -(253 + ((4).bit_shift_left (8)))
						when -1533 then l_pos := -1 + 3 -- -(253 + ((5).bit_shift_left (8)))
						when -14122 then l_pos := -1 + 3 -- -(42 + ((55).bit_shift_left (8)))
						when -12835 then l_pos := -1 + 3 -- -(35 + ((50).bit_shift_left (8)))
						else l_pos := -1 + 4
						end
				when 2 then -- switch 1, case -(75 + (49 << 8)) | switch 1, case -(75 + (52 << 8)) | switch 1, case -(107 + (80 << 8)) | switch 1, case -(75 + (51 << 8)) | switch 1, case -(107 + (78 << 8)) | switch 1, case -(75 + (53 << 8))
						if not (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean then
							l_pos := -1 + 4 -- switch 1; break
						end
				when 3 then -- switch 1, case -(35 + (52 << 8)) | switch 1, case -(37 + (105 << 8)) | switch 1, case -(253 + (4 << 8)) | switch 1, case -(253 + (5 << 8)) | switch 1, case -(42 + (55 << 8)) | switch 1, case -(35 + (50 << 8));
						(create {P_NORMAL_STATIC}).start_selection;
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (15)
						if ((create {P_GLOBALS_STATIC}).mod_mask.item.item).to_boolean then
							l_buf___6[0] := (128).to_natural_8
							l_buf___6[1] := (252).to_natural_8
							l_buf___6[2] := ((create {P_GLOBALS_STATIC}).mod_mask.item.item).to_natural_8
							l_buf___6[3] := (('%/0/').code).to_natural_8;
							(create {P_GETCHAR_STATIC}).stuffReadbuff (l_buf___6)
						end
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (a_c)
						Result := 1
						l_return := True
				when 4 then -- switch 1, done: | if done
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_insert (a_replaceState: INTEGER_32)
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
				l_tmp___0 := ce_string ("i")
			else
				if a_replaceState = 208 then
					l_tmp := ce_string ("v")
				else
					l_tmp := ce_string ("r")
				end
				l_tmp___0 := l_tmp
			end
			(create {P_EVAL_STATIC}).set_vim_var_string (33, create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0), 1);
			(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_INSERTCHANGE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
				(create {P_GLOBALS_STATIC}).State.item := (16).bit_or ((((create {P_GLOBALS_STATIC}).State.item).bit_and (32)))
			else
				(create {P_GLOBALS_STATIC}).State.item := (a_replaceState).bit_or ((((create {P_GLOBALS_STATIC}).State.item).bit_and (32)))
			end
			(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (-(107 + ((73).bit_shift_left (8))));
			(create {P_SCREEN_STATIC}).showmode.do_nothing;
			(create {P_UI_STATIC}).ui_cursor_shape
		end

	ins_ctrl_o
		do
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
				(create {P_GLOBALS_STATIC}).restart_edit.item := ('V').code
			elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
				(create {P_GLOBALS_STATIC}).restart_edit.item := ('R').code
			else
				(create {P_GLOBALS_STATIC}).restart_edit.item := ('I').code
			end
			if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
				(create {P_GLOBALS_STATIC}).ins_at_eol.item := 0
			else
				(create {P_GLOBALS_STATIC}).ins_at_eol.item := (((create {P_MISC1_STATIC}).gchar_cursor) = 0).to_integer
			end
		end

	ins_shift (a_c, a_lastc___0: INTEGER_32)
		local
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (stop_arrow) = 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_c)
						if a_c /= 4 then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if a_lastc___0 /= 48 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L___1
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if a_lastc___0 /= 94 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 1;
							(create {P_MISC1_STATIC}).del_char (0).do_nothing
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
								replace_pop_ins
							end
							if a_lastc___0 = 94 then
								old_indent.item := (create {P_MISC1_STATIC}).get_indent
							end
							change_indent (1, 0, 1, 0, 1)
						else
							l_pos := -1 + 10 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___0
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						if a_c = 4 then
							l_tmp___0 := 3
						else
							l_tmp___0 := 2
						end
						change_indent (l_tmp___0, 0, 1, 0, 1)
				when 11 then
						if ((create {P_GLOBALS_STATIC}).did_ai.item).to_boolean then
							if (((create {P_CHARSET_STATIC}).skipwhite (((create {P_MEMLINE_STATIC}).ml_get_curline))).item).to_integer_32 /= 0 then
								(create {P_GLOBALS_STATIC}).did_ai.item := 0
							end
						end
						(create {P_GLOBALS_STATIC}).did_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si_back.item := 0
						can_cindent.item := 0
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_del
		local
			l_temp: INTEGER_32
			l_return: BOOLEAN
		do
			if (stop_arrow) = 0 then
				l_return := True
			end
			if not l_return then
				if ((create {P_MISC1_STATIC}).gchar_cursor) = 0 then
					l_temp := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
					if ((create {P_OPTION_STATIC}).can_bs (('o').code)).to_boolean then
						if ((create {P_OPS_STATIC}).do_join (2, 0, 1)) = 0 then
							(create {P_MISC1_STATIC}).vim_beep
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_temp
						end
					else
						(create {P_MISC1_STATIC}).vim_beep
					end
				elseif ((create {P_MISC1_STATIC}).del_char (0)) = 0 then
					(create {P_MISC1_STATIC}).vim_beep
				end
				(create {P_GLOBALS_STATIC}).did_ai.item := 0;
				(create {P_GLOBALS_STATIC}).did_si.item := 0;
				(create {P_GLOBALS_STATIC}).can_si.item := 0;
				(create {P_GLOBALS_STATIC}).can_si_back.item := 0;
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (-(107 + ((68).bit_shift_left (8))))
			end
		end

	ins_bs_one (a_vcolp: CE_POINTER [INTEGER_32])
		do
			(create {P_MISC2_STATIC}).dec_cursor.do_nothing;
			((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), a_vcolp, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
					replace_do_bs (-1)
				elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col >= (create {P_GLOBALS_STATIC}).Insstart.item.item.col then
					replace_do_bs (-1)
				end
			else
				(create {P_MISC1_STATIC}).del_char (0).do_nothing
			end
		end

	ins_bs (a_c, a_mode: INTEGER_32; a_inserted_space_p: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_mode: INTEGER_32
			l_lnum: INTEGER_32
			l_cc___0: INTEGER_32
			l_temp: INTEGER_32
			l_save_col: INTEGER_32
			l_mincol: INTEGER_32
			l_did_backspace: INTEGER_32
			l_in_indent: INTEGER_32
			l_oldState: INTEGER_32
			l_cpc: CE_ARRAY [INTEGER_32]
			l_ptr: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_ts: INTEGER_32
			l_vcol: CE_ARRAY [INTEGER_32]
			l_want_vcol: CE_ARRAY [INTEGER_32]
			l_start_vcol: INTEGER_32
			l_tmp___12: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_cpc.make (<<6>>)
			create {CE_INTEGER_32_ARRAY} l_vcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_want_vcol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_mode := a_mode
					l_temp := 0
					l_did_backspace := 0
					if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (((create {P_MEMLINE_STATIC}).ml_get ((1).to_integer_32)).item).to_integer_32 = 0 then
							(create {P_MISC1_STATIC}).vim_beep
							Result := 0
							l_return := True
						else
							l_pos := -1 + 3 -- goto _L___4
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else: | _L___4:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = 0 then
							(create {P_MISC1_STATIC}).vim_beep
							Result := 0
							l_return := True
						else
							l_pos := -1 + 6 -- goto _L___3
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else: | _L___3:
						if not (((create {P_OPTION_STATIC}).can_bs (('s').code)).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if: | _L___2:
						if not (((create {P_OPTION_STATIC}).can_bs (('i').code)).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___1:
						if not ((create {P_OPTION_STATIC}).can_bs (('o').code)).to_boolean then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = 0 then
								(create {P_MISC1_STATIC}).vim_beep
								Result := 0
								l_return := True
							end
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if not ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).ai_col.item > 0 then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col <= (create {P_GLOBALS_STATIC}).ai_col.item then
									(create {P_MISC1_STATIC}).vim_beep
									Result := 0
									l_return := True
								else
									l_pos := -1 + 8 -- goto _L___1
								end
							else
								l_pos := -1 + 8 -- goto _L___1
							end
						else
							l_pos := -1 + 8 -- goto _L___1
						end
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if ((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean then
							(create {P_MISC1_STATIC}).vim_beep
							Result := 0
							l_return := True
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col <= (create {P_GLOBALS_STATIC}).Insstart.item.item.col then
								(create {P_MISC1_STATIC}).vim_beep
								Result := 0
								l_return := True
							else
								l_pos := -1 + 7 -- goto _L___2
							end
						else
							l_pos := -1 + 7 -- goto _L___2
						end
				when 13 then -- if done | if done
					if not l_return then
						if (stop_arrow) = 0 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_in_indent := (create {P_MISC1_STATIC}).inindent (0)
						if l_in_indent.to_boolean then
							can_cindent.item := 0
						end
						(create {P_GLOBALS_STATIC}).end_comment_pending.item := ('%/0/').code
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0 then
							if l_mode = 1 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd) - 1
								Result := 1
								l_return := True
							end
							if not l_return and then (l_mode = 2) then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
								Result := 1
								l_return := True
							end
							if not l_return then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
							end
						end
					end
					if l_return then
						l_pos := -1 + 67 -- skip if block
					end
				when 14 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= 0 then
							l_pos := -1 + 29 -- skip if block
						end
				when 15 then -- if:
						l_lnum := (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
							if ((create {P_UNDO_STATIC}).u_save ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 2, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1)) = 0 then
								Result := 0
								l_return := True
							end
							if not l_return then
								(create {P_GLOBALS_STATIC}).Insstart.item.item.lnum := ((create {P_GLOBALS_STATIC}).Insstart.item.item.lnum) - 1;
								(create {P_GLOBALS_STATIC}).Insstart.item.item.col := (2_147_483_647).to_integer_32
							end
						end
						if l_return then
							l_pos := -1 + 28 -- skip if block
						end
				when 16 then -- if:
						l_cc___0 := -1
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
							l_cc___0 := replace_pop
						end
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum <= l_lnum then
							(create {P_MISC2_STATIC}).dec_cursor.do_nothing
						else
							l_pos := -1 + 19 -- goto _L___6
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 19 then -- else: | _L___6:
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___5
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > ((create {P_GLOBALS_STATIC}).orig_line_count.item).to_integer_32) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if: | _L___5:
						l_temp := (create {P_MISC1_STATIC}).gchar_cursor;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
						if ((create {P_OPTION_STATIC}).has_format_option (('a').code)).to_boolean then
							if ((create {P_OPTION_STATIC}).has_format_option (('w').code)).to_boolean then
								l_ptr := (((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 1))
								l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32
								if l_len > 0 then
									if (l_ptr[(l_len - 1)]).to_integer_32 = 32 then
										l_ptr[(l_len - 1)] := (('%/0/').code).to_natural_8
									end
								end
							end
						end
						(create {P_OPS_STATIC}).do_join (2, 0, 0).do_nothing
						if l_temp = 0 then
							if ((create {P_MISC1_STATIC}).gchar_cursor) /= 0 then
								(create {P_MISC2_STATIC}).inc_cursor.do_nothing
							end
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:;
						(create {P_MISC2_STATIC}).dec_cursor.do_nothing
				when 26 then -- if done
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
							l_oldState := (create {P_GLOBALS_STATIC}).State.item;
							(create {P_GLOBALS_STATIC}).State.item := 1
							from
							until
								not (l_cc___0 > 0)
							loop
								l_save_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
								mb_replace_pop_ins (l_cc___0);
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_save_col
								l_cc___0 := replace_pop
							end
							replace_pop_ins;
							(create {P_GLOBALS_STATIC}).State.item := l_oldState
						end
				when 27 then;
						(create {P_GLOBALS_STATIC}).did_ai.item := 0
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 67
				when 29 then -- else:
						l_mincol := 0
						if l_mode /= 4 then
							l_pos := -1 + 35 -- skip if block
						end
				when 30 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 34 -- goto _L___7
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 33 then -- else:
						if not ((cindent_on).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 34 then -- if: | _L___7:
						l_save_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						beginline (1)
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < l_save_col then
							l_mincol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_save_col
				when 35 then -- if done | if done
						if l_mode /= 1 then
							l_pos := -1 + 59 -- skip if block
						end
				when 36 then -- if:
						if not (((create {P_OPTION_STATIC}).p_sta.item.item).to_boolean) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if l_in_indent.to_boolean then
							l_pos := -1 + 49 -- goto _L___12
						else
							l_pos := -1 + 39 -- goto _L___13
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 39 then -- else: | _L___13:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sts = 0 then
							l_pos := -1 + 57 -- skip if block
						end
				when 40 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0) then
							l_pos := -1 + 55 -- skip if block
						end
				when 41 then -- if:
						if (((create {P_MEMLINE_STATIC}).ml_get_cursor)[-1]).to_integer_32 /= 9 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						l_pos := -1 + 49 -- goto _L___12
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 44 then -- else:
						if (((create {P_MEMLINE_STATIC}).ml_get_cursor)[-1]).to_integer_32 /= 32 then
							l_pos := -1 + 53 -- skip if block
						end
				when 45 then -- if:
						if (a_inserted_space_p.item).to_boolean then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_pos := -1 + 49 -- goto _L___12
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 48 then -- else:
						if not (((create {P_GLOBALS_STATIC}).arrow_used.item).to_boolean) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if: | _L___12:
						a_inserted_space_p.item := 0
						if ((create {P_OPTION_STATIC}).p_sta.item.item).to_boolean then
							if l_in_indent.to_boolean then
								l_ts := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
							else
								l_ts := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sts).to_integer_32
							end
						else
							l_ts := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sts).to_integer_32
						end
						((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_vcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						l_start_vcol := l_vcol.item;
						(create {P_MISC2_STATIC}).dec_cursor.do_nothing;
						((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_want_vcol);
						(create {P_MISC2_STATIC}).inc_cursor.do_nothing
						l_want_vcol.item := (l_want_vcol.item // l_ts) * l_ts
						from
						until
							(l_break)
						loop
							l_break := False
							if l_vcol.item > l_want_vcol.item then
								l_cc___0 := (((create {P_MEMLINE_STATIC}).ml_get_cursor)[-1]).to_integer_32
								if l_cc___0 = 32 then
									l_tmp___12 := 1
								elseif l_cc___0 = 9 then
									l_tmp___12 := 1
								else
									l_tmp___12 := 0
								end
								if not l_tmp___12.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								ins_bs_one (l_vcol)
							end
						end
						l_break := False
						from
						until
							not (l_vcol.item < l_want_vcol.item)
						loop
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (create {P_GLOBALS_STATIC}).Insstart.item.item.col then
									(create {P_GLOBALS_STATIC}).Insstart.item.item.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
								end
							end
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
								(create {P_MISC1_STATIC}).ins_char ((' ').code)
							else
								(create {P_MISC1_STATIC}).ins_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
								if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
									replace_push (('%/0/').code)
								end
							end
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_vcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						end
						if l_vcol.item >= l_start_vcol then
							ins_bs_one (l_vcol)
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 52
				when 51 then -- else:
						l_pos := -1 + 59 -- goto _L___9
				when 52 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 54
				when 53 then -- else:
						l_pos := -1 + 59 -- goto _L___9
				when 54 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 56
				when 55 then -- else:
						l_pos := -1 + 59 -- goto _L___9
				when 56 then -- if done | if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else:
						l_pos := -1 + 59 -- goto _L___9
				when 58 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 66
				when 59 then -- else: | _L___9:
						if (l_break) then
							l_pos := -1 + 65 -- skip loop
						end
				when 60 then -- loop body:
						l_break := False;
						(create {P_MISC2_STATIC}).dec_cursor.do_nothing
						if l_mode /= 2 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if ((create {P_MISC2_STATIC}).vim_isspace (((create {P_MISC1_STATIC}).gchar_cursor))).to_boolean then
							l_pos := -1 + 63 -- goto _L___8
						else
							l_mode := 3
							l_temp := (create {P_CHARSET_STATIC}).vim_iswordc (((create {P_MISC1_STATIC}).gchar_cursor))
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else: | _L___8:
						if l_mode = 3 then
							l_cc___0 := (create {P_MISC1_STATIC}).gchar_cursor
							if ((create {P_MISC2_STATIC}).vim_isspace (l_cc___0)).to_boolean then
								(create {P_MISC2_STATIC}).inc_cursor.do_nothing
								l_break := True
							elseif ((create {P_CHARSET_STATIC}).vim_iswordc (l_cc___0)) /= l_temp then
								(create {P_MISC2_STATIC}).inc_cursor.do_nothing
								l_break := True
							end
						end
				when 64 then
						if not (l_break) then
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
								replace_do_bs (-1)
							else
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									if ((create {P_OPTION_STATIC}).p_deco.item.item).to_boolean then
										(create {P_MBYTE_STATIC}).utfc_ptr2char (((create {P_MEMLINE_STATIC}).ml_get_cursor), l_cpc).do_nothing
									end
								end
								(create {P_MISC1_STATIC}).del_char (0).do_nothing
								if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
									if ((create {P_OPTION_STATIC}).p_deco.item.item).to_boolean then
										if l_cpc[0] /= 0 then
											(create {P_MISC2_STATIC}).inc_cursor.do_nothing
										end
									end
								end
							end
							if l_mode = 1 then
								l_break := True
							end
						end
						if not (l_break) then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > l_mincol then
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = (create {P_GLOBALS_STATIC}).Insstart.item.item.col then
										l_break := True
									end
								end
							else
								l_break := True
							end
						end
						l_pos := -1 + 59 -- back to loop condition
				when 65 then -- loop done
						l_break := False
				when 66 then
						l_did_backspace := 1
				when 67 then -- if done | if done
					if not l_return then
						(create {P_GLOBALS_STATIC}).did_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si_back.item := 0
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col <= 1 then
							(create {P_GLOBALS_STATIC}).did_ai.item := 0
						end
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_c)
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (create {P_GLOBALS_STATIC}).Insstart.item.item.col then
								(create {P_GLOBALS_STATIC}).Insstart.item.item.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							end
						end
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('v').code)).is_void then
							if (create {P_GLOBALS_STATIC}).dollar_vcol.item = 0 then
								(create {P_GLOBALS_STATIC}).dollar_vcol.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol
							end
						end
						if l_did_backspace.to_boolean then
							(create {P_FOLD_STATIC}).foldOpenCursor
						end
						Result := l_did_backspace
					end
				when 68 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_mouse (a_c: INTEGER_32)
		local
			l_tpos: CE_ARRAY [PD_POS_T]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_new_curwin: CE_POINTER [PD_WINDOW_S]
			l_tmp___1: CE_POINTER [PD_POS_T]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
			if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if not ((create {P_TERM_STATIC}).mouse_has (('i').code)).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				undisplay_dollar
				l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				if ((create {P_NORMAL_STATIC}).do_mouse (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), a_c, -1, 1, 0)).to_boolean then
					l_new_curwin := (create {P_GLOBALS_STATIC}).curwin.item
					if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
						if ((create {P_WINDOW_STATIC}).win_valid (l_old_curwin___1)).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1;
							(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
						end
					end
					if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
						l_tmp___1 := l_tpos
					else
						l_tmp___1 := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
					end
					start_arrow (l_tmp___1)
					if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_new_curwin) then
						if ((create {P_WINDOW_STATIC}).win_valid (l_new_curwin)).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item := l_new_curwin;
							(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
						end
					end
					can_cindent.item := 1
				end
				(create {P_SCREEN_STATIC}).redraw_statuslines
			end
		end

	ins_mousescroll (a_dir___0: INTEGER_32)
		local
			l_tpos: CE_ARRAY [PD_POS_T]
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_did_scroll: INTEGER_32
			l_row: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_val___0: INTEGER_32
			l_step: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_row.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
					l_did_scroll := 0
					l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						if (create {P_GLOBALS_STATIC}).mouse_row.item >= 0 then
							if (create {P_GLOBALS_STATIC}).mouse_col.item >= 0 then
								l_row.item := (create {P_GLOBALS_STATIC}).mouse_row.item
								l_col.item := (create {P_GLOBALS_STATIC}).mouse_col.item;
								(create {P_GLOBALS_STATIC}).curwin.item := (create {P_UI_STATIC}).mouse_find_win (l_row, l_col);
								(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
							end
						end
					end
					if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
						undisplay_dollar
					end
					if not (((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean) then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if: | _L___0:
						if a_dir___0 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if a_dir___0 /= 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean then
							(create {P_NORMAL_STATIC}).scroll_redraw (a_dir___0, (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline - (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline)
						else
							(create {P_NORMAL_STATIC}).scroll_redraw (a_dir___0, 3)
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_step := 6
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean then
							l_step := (create {P_GLOBALS_STATIC}).curwin.item.item.w_width
						end
						if a_dir___0 = -2 then
							l_tmp := -l_step
						else
							l_tmp := l_step
						end
						l_val___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol + l_tmp
						if l_val___0 < 0 then
							l_val___0 := 0
						end
						(create {P_GUI_STATIC}).gui_do_horiz_scroll (l_val___0.to_natural_32, 1).do_nothing
				when 9 then -- if done
						l_did_scroll := 1
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 2 -- goto _L___0
				when 12 then;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_status := 1;
					(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1;
					(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
					if ((create {P_POPUPMNU_STATIC}).pum_visible).to_boolean then
						if l_did_scroll.to_boolean then
							(create {P_SCREEN_STATIC}).redraw_all_later (40)
							ins_compl_show_pum
						end
					end
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = l_tpos.item.lnum then
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = l_tpos.item.col then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd /= l_tpos.item.coladd then
								start_arrow (l_tpos)
								can_cindent.item := 1
							end
						else
							start_arrow (l_tpos)
							can_cindent.item := 1
						end
					else
						start_arrow (l_tpos)
						can_cindent.item := 1
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_tabline (a_c: INTEGER_32)
		do
			if a_c /= -(239 + ((88).bit_shift_left (8))) then
				undisplay_dollar
				start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
				can_cindent.item := 1
			elseif (create {P_GLOBALS_STATIC}).current_tabmenu.item /= 1 then
				undisplay_dollar
				start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
				can_cindent.item := 1
			elseif (create {P_GLOBALS_STATIC}).current_tab.item /= 0 then
				if (create {P_GLOBALS_STATIC}).current_tab.item /= ((create {P_WINDOW_STATIC}).tabpage_index ((create {P_GLOBALS_STATIC}).curtab.item)) then
					undisplay_dollar
					start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
					can_cindent.item := 1
				end
			end
			if a_c = -(240 + ((88).bit_shift_left (8))) then
				(create {P_WINDOW_STATIC}).goto_tabpage ((create {P_GLOBALS_STATIC}).current_tab.item)
			else
				(create {P_NORMAL_STATIC}).handle_tabmenu;
				(create {P_SCREEN_STATIC}).redraw_statuslines
			end
		end

	ins_scroll
		local
			l_tpos: CE_ARRAY [PD_POS_T]
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			undisplay_dollar
			l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			if ((create {P_GUI_STATIC}).gui_do_scroll).to_boolean then
				start_arrow (l_tpos)
				can_cindent.item := 1
			end
		end

	ins_horscroll
		local
			l_tpos: CE_ARRAY [PD_POS_T]
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			undisplay_dollar
			l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			if ((create {P_GUI_STATIC}).gui_do_horiz_scroll ((create {P_GLOBALS_STATIC}).scrollbar_value.item, 0)).to_boolean then
				start_arrow (l_tpos)
				can_cindent.item := 1
			end
		end

	ins_left
		local
			l_tpos: CE_ARRAY [PD_POS_T]
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 4)).to_boolean then
				if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
					(create {P_FOLD_STATIC}).foldOpenCursor
				end
			end
			undisplay_dollar
			l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			if (oneleft) = 1 then
				if not ((create {P_MBYTE_STATIC}).im_is_preediting).to_boolean then
					start_arrow (l_tpos)
				end
			elseif not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ww.item.item, ('[').code)).is_void then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1 then
					start_arrow (l_tpos);
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1;
					(create {P_MISC2_STATIC}).coladvance ((2_147_483_647).to_integer_32).do_nothing;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
				else
					(create {P_MISC1_STATIC}).vim_beep
				end
			else
				(create {P_MISC1_STATIC}).vim_beep
			end
		end

	ins_home (a_c: INTEGER_32)
		local
			l_tpos: CE_ARRAY [PD_POS_T]
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 4)).to_boolean then
				if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
					(create {P_FOLD_STATIC}).foldOpenCursor
				end
			end
			undisplay_dollar
			l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			if a_c = -(253 + ((87).bit_shift_left (8))) then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (1).to_integer_32
			end
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := 0
			start_arrow (l_tpos)
		end

	ins_end (a_c: INTEGER_32)
		local
			l_tpos: CE_ARRAY [PD_POS_T]
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 4)).to_boolean then
				if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
					(create {P_FOLD_STATIC}).foldOpenCursor
				end
			end
			undisplay_dollar
			l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			if a_c = -(253 + ((88).bit_shift_left (8))) then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
			end
			(create {P_MISC2_STATIC}).coladvance ((2_147_483_647).to_integer_32).do_nothing;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant := (2_147_483_647).to_integer_32
			start_arrow (l_tpos)
		end

	ins_s_left
		do
			if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 4)).to_boolean then
				if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
					(create {P_FOLD_STATIC}).foldOpenCursor
				end
			end
			undisplay_dollar
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1 then
				start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")));
				(create {P_SEARCH_STATIC}).bck_word (1, 0, 0).do_nothing;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
			elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
				start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")));
				(create {P_SEARCH_STATIC}).bck_word (1, 0, 0).do_nothing;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
			else
				(create {P_MISC1_STATIC}).vim_beep
			end
		end

	ins_right
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 4)).to_boolean then
						if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							(create {P_FOLD_STATIC}).foldOpenCursor
						end
					end
					undisplay_dollar
					if ((create {P_MISC1_STATIC}).gchar_cursor) = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (((create {P_MISC2_STATIC}).virtual_active).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")));
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
						if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
							oneright.do_nothing
						elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([((create {P_MEMLINE_STATIC}).ml_get_cursor)]))
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ww.item.item, (']').code)).is_void then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
								start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")));
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							else
								(create {P_MISC1_STATIC}).vim_beep
							end
						else
							(create {P_MISC1_STATIC}).vim_beep
						end
				when 7 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_s_right
		do
			if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 4)).to_boolean then
				if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
					(create {P_FOLD_STATIC}).foldOpenCursor
				end
			end
			undisplay_dollar
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
				start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")));
				(create {P_SEARCH_STATIC}).fwd_word (1, 0, 0).do_nothing;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
			elseif ((create {P_MISC1_STATIC}).gchar_cursor) /= 0 then
				start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")));
				(create {P_SEARCH_STATIC}).fwd_word (1, 0, 0).do_nothing;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
			else
				(create {P_MISC1_STATIC}).vim_beep
			end
		end

	ins_up (a_startcol: INTEGER_32)
		local
			l_tpos: CE_ARRAY [PD_POS_T]
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			l_old_topline___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
			l_old_topfill___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
			undisplay_dollar
			l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			if (cursor_up (1, 1)) = 1 then
				if a_startcol.to_boolean then
					(create {P_MISC2_STATIC}).coladvance (((create {P_CHARSET_STATIC}).getvcol_nolist ((create {P_GLOBALS_STATIC}).Insstart.item))).do_nothing
				end
				if l_old_topline___0 /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
					(create {P_SCREEN_STATIC}).redraw_later (10)
				elseif l_old_topfill___0 /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill then
					(create {P_SCREEN_STATIC}).redraw_later (10)
				end
				start_arrow (l_tpos)
				can_cindent.item := 1
			else
				(create {P_MISC1_STATIC}).vim_beep
			end
		end

	ins_pageup
		local
			l_tpos: CE_ARRAY [PD_POS_T]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			undisplay_dollar
			if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean then
				if not ((create {P_GLOBALS_STATIC}).first_tabpage.item.item.tp_next).is_void then
					start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")));
					(create {P_WINDOW_STATIC}).goto_tabpage (-1)
				end
				l_return := True
			end
			if not l_return then
				l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				if ((create {P_MOVE_STATIC}).onepage (-1, 1)) = 1 then
					start_arrow (l_tpos)
					can_cindent.item := 1
				else
					(create {P_MISC1_STATIC}).vim_beep
				end
			end
		end

	ins_down (a_startcol: INTEGER_32)
		local
			l_tpos: CE_ARRAY [PD_POS_T]
			l_old_topline___0: INTEGER_32
			l_old_topfill___0: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			l_old_topline___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
			l_old_topfill___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
			undisplay_dollar
			l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			if (cursor_down (1, 1)) = 1 then
				if a_startcol.to_boolean then
					(create {P_MISC2_STATIC}).coladvance (((create {P_CHARSET_STATIC}).getvcol_nolist ((create {P_GLOBALS_STATIC}).Insstart.item))).do_nothing
				end
				if l_old_topline___0 /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline then
					(create {P_SCREEN_STATIC}).redraw_later (10)
				elseif l_old_topfill___0 /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill then
					(create {P_SCREEN_STATIC}).redraw_later (10)
				end
				start_arrow (l_tpos)
				can_cindent.item := 1
			else
				(create {P_MISC1_STATIC}).vim_beep
			end
		end

	ins_pagedown
		local
			l_tpos: CE_ARRAY [PD_POS_T]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_tpos.make (<<1>>)

			undisplay_dollar
			if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean then
				if not ((create {P_GLOBALS_STATIC}).first_tabpage.item.item.tp_next).is_void then
					start_arrow (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")));
					(create {P_WINDOW_STATIC}).goto_tabpage (0)
				end
				l_return := True
			end
			if not l_return then
				l_tpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				if ((create {P_MOVE_STATIC}).onepage (1, 1)) = 1 then
					start_arrow (l_tpos)
					can_cindent.item := 1
				else
					(create {P_MISC1_STATIC}).vim_beep
				end
			end
		end

	ins_drop
		do
			(create {P_OPS_STATIC}).do_put (('~').code, -1, 1, 2)
		end

	ins_tab: INTEGER_32
		local
			l_ind: INTEGER_32
			l_i___0: INTEGER_32
			l_temp: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_saved_line: CE_POINTER [NATURAL_8]
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_fpos: CE_ARRAY [PD_POS_T]
			l_cursor: CE_POINTER [PD_POS_T]
			l_want_vcol: CE_ARRAY [INTEGER_32]
			l_vcol: CE_ARRAY [INTEGER_32]
			l_change_col: INTEGER_32
			l_save_list: INTEGER_32
			l_repl_off: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_pos___3.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_fpos.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_want_vcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_vcol.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if Insstart_blank_vcol.item.to_integer_32 = 2_147_483_647 then
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
							Insstart_blank_vcol.item := get_nolist_virtcol
						end
					end
					if (echeck_abbr (265)).to_boolean then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_ind := (create {P_MISC1_STATIC}).inindent (0)
						if l_ind.to_boolean then
							can_cindent.item := 0
						end
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_et).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if not (((create {P_OPTION_STATIC}).p_sta.item.item).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_ind.to_boolean then
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw then
								l_pos := -1 + 5 -- goto _L___0
							end
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L___0:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sts = 0 then
							Result := 1
							l_return := True
						end
				when 6 then -- if done | if done
					if not l_return then
						if (stop_arrow) = 0 then
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 7 then -- if:;
						(create {P_GLOBALS_STATIC}).did_ai.item := 0;
						(create {P_GLOBALS_STATIC}).did_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si.item := 0;
						(create {P_GLOBALS_STATIC}).can_si_back.item := 0;
						(create {P_GETCHAR_STATIC}).AppendToRedobuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%T")))
						if not (((create {P_OPTION_STATIC}).p_sta.item.item).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_ind.to_boolean then
							l_temp := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
						else
							l_pos := -1 + 10 -- goto _L___1
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___1:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sts > 0 then
							l_temp := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sts).to_integer_32
						else
							l_temp := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
						end
				when 11 then
						l_temp := l_temp - ((get_nolist_virtcol) \\ l_temp);
						(create {P_MISC1_STATIC}).ins_char ((' ').code)
						from
						until
							(l_break)
						loop
							l_break := False
							l_temp := l_temp - 1
							if not (l_temp > 0) then
								l_break := True
							end
							if not (l_break) then
								if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
									(create {P_MISC1_STATIC}).ins_char ((' ').code)
								else
									(create {P_MISC1_STATIC}).ins_str (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ")))
									if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
										replace_push (('%/0/').code)
									end
								end
							end
						end
						l_break := False
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_et).to_boolean then
							l_pos := -1 + 18 -- skip if block
						end
				when 12 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sts).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 17 -- goto _L___2
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 15 then -- else:
						if not (((create {P_OPTION_STATIC}).p_sta.item.item).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if not (l_ind.to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___2:
						l_saved_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_change_col := -1
						l_save_list := (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							l_pos___3.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							l_cursor := l_pos___3
							l_saved_line := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get_curline))
							if l_saved_line.is_void then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_ptr := l_saved_line + l_pos___3.item.col
							end
						else
							l_ptr := (create {P_MEMLINE_STATIC}).ml_get_cursor
							l_cursor := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
						end
						if not l_return then
							if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('L').code)).is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := 0
							end
							l_fpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							from
							until
								(l_break)
							loop
								l_break := False
								if l_fpos.item.col > 0 then
									if (l_ptr[-1]).to_integer_32 /= 32 then
										if (l_ptr[-1]).to_integer_32 /= 9 then
											l_break := True
										end
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_fpos.item.col := (l_fpos.item.col) - 1
									l_ptr := l_ptr - 1
								end
							end
							l_break := False
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
								if l_fpos.item.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
									if l_fpos.item.col < (create {P_GLOBALS_STATIC}).Insstart.item.item.col then
										l_ptr := l_ptr + ((create {P_GLOBALS_STATIC}).Insstart.item.item.col - l_fpos.item.col)
										l_fpos.item.col := (create {P_GLOBALS_STATIC}).Insstart.item.item.col
									end
								end
							end
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_fpos, l_vcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_cursor, l_want_vcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_ptr.item).to_integer_32 /= 32 then
									if (l_ptr.item).to_integer_32 /= 9 then
										l_break := True
									end
								end
								if not (l_break) then
									l_i___0 := (create {P_CHARSET_STATIC}).lbr_chartabsize (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%T")), l_vcol.item)
									if l_vcol.item + l_i___0 > l_want_vcol.item then
										l_break := True
									end
								end
								if not (l_break) then
									if (l_ptr.item).to_integer_32 /= 9 then
										l_ptr.item := (('%T').code).to_natural_8
										if l_change_col < 0 then
											l_change_col := l_fpos.item.col
											if l_fpos.item.lnum = (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum then
												if l_fpos.item.col < (create {P_GLOBALS_STATIC}).Insstart.item.item.col then
													(create {P_GLOBALS_STATIC}).Insstart.item.item.col := l_fpos.item.col
												end
											end
										end
									end
									l_fpos.item.col := (l_fpos.item.col) + 1
									l_ptr := l_ptr + 1
									l_vcol.item := l_vcol.item + l_i___0
								end
							end
							l_break := False
							if l_change_col >= 0 then
								l_repl_off := 0
								from
								until
									(l_break)
								loop
									l_break := False
									if l_vcol.item < l_want_vcol.item then
										if (l_ptr.item).to_integer_32 /= 32 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_vcol.item := l_vcol.item + ((create {P_CHARSET_STATIC}).lbr_chartabsize (l_ptr, l_vcol.item))
										l_ptr := l_ptr + 1
										l_repl_off := l_repl_off + 1
									end
								end
								l_break := False
								if l_vcol.item > l_want_vcol.item then
									l_ptr := l_ptr - 1
									l_repl_off := l_repl_off - 1
								end
								l_fpos.item.col := l_fpos.item.col + l_repl_off
								l_i___0 := l_cursor.item.col - l_fpos.item.col
								if l_i___0 > 0 then
									memmove (create {CE_VOID_POINTER}.make_cast (l_ptr), create {CE_VOID_POINTER}.make_cast ((l_ptr + l_i___0)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_ptr + l_i___0)))) + {NATURAL_32} 1).do_nothing
									if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
										if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
											l_temp := l_i___0
											from
											until
												(l_break)
											loop
												l_break := False
												l_temp := l_temp - 1
												if not (l_temp >= 0) then
													l_break := True
												end
												if not (l_break) then
													replace_join (l_repl_off)
												end
											end
											l_break := False
										end
									end
								end
								if ((create {P_NETBEANS_STATIC}).netbeans_active).to_boolean then
									(create {P_NETBEANS_STATIC}).netbeans_removed ((create {P_GLOBALS_STATIC}).curbuf.item, l_fpos.item.lnum, l_cursor.item.col, (l_i___0 + 1).to_integer_32);
									(create {P_NETBEANS_STATIC}).netbeans_inserted ((create {P_GLOBALS_STATIC}).curbuf.item, l_fpos.item.lnum, l_cursor.item.col, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%T")), 1)
								end
								l_cursor.item.col := l_cursor.item.col - l_i___0
								if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
									backspace_until_column (l_change_col);
									(create {P_MISC1_STATIC}).ins_bytes_len (l_saved_line + l_change_col, l_cursor.item.col - l_change_col)
								end
							end
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_saved_line))
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := l_save_list
						end
				when 18 then -- if done | if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ins_eol (a_c: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
		do
			if (echeck_abbr (a_c + 256)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (stop_arrow) = 0 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				undisplay_dollar
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
					if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
						replace_push (('%/0/').code)
					end
				end
				if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0 then
						(create {P_MISC2_STATIC}).coladvance (((create {P_MISC2_STATIC}).getviscol)).do_nothing
					end
				end
				(create {P_GETCHAR_STATIC}).AppendToRedobuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
				if ((create {P_OPTION_STATIC}).has_format_option (('r').code)).to_boolean then
					l_tmp___4 := 2
				else
					l_tmp___4 := 0
				end
				l_i___0 := (create {P_MISC1_STATIC}).open_line (1, l_tmp___4, old_indent.item)
				old_indent.item := 0
				can_cindent.item := 1;
				(create {P_FOLD_STATIC}).foldOpenCursor
				Result := (not l_i___0.to_boolean).to_integer
			end
		end

	ins_digraph: INTEGER_32
		local
			l_c: INTEGER_32
			l_cc___0: INTEGER_32
			l_return: BOOLEAN
		do
			pc_status.item := 0
			if ((create {P_SCREEN_STATIC}).redrawing).to_boolean then
				if not ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
					ins_redraw (0)
					edit_putchar (('?').code, 1);
					(create {P_NORMAL_STATIC}).add_to_showcmd_c (11)
				end
			end
			(create {P_GLOBALS_STATIC}).dont_scroll.item := 1;
			(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1;
			(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
			l_c := (create {P_GETCHAR_STATIC}).plain_vgetc;
			(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
			(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
			edit_unputchar
			if l_c < 0 then
				(create {P_NORMAL_STATIC}).clear_showcmd
				insert_special (l_c, 1, 0)
				Result := (('%/0/').code)
				l_return := True
			elseif ((create {P_GLOBALS_STATIC}).mod_mask.item.item).to_boolean then
				(create {P_NORMAL_STATIC}).clear_showcmd
				insert_special (l_c, 1, 0)
				Result := (('%/0/').code)
				l_return := True
			end
			if not l_return and then (l_c /= 27) then
				if ((create {P_SCREEN_STATIC}).redrawing).to_boolean then
					if not ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
						ins_redraw (0)
						if ((create {P_CHARSET_STATIC}).char2cells (l_c)) = 1 then
							edit_unputchar
							ins_redraw (0)
							edit_putchar (l_c, 1)
						end
						(create {P_NORMAL_STATIC}).add_to_showcmd_c (l_c)
					end
				end
				(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1;
				(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
				l_cc___0 := (create {P_GETCHAR_STATIC}).plain_vgetc;
				(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
				(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
				edit_unputchar
				if l_cc___0 /= 27 then
					(create {P_GETCHAR_STATIC}).AppendToRedobuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/22/")))
					l_c := (create {P_DIGRAPH_STATIC}).getdigraph (l_c, l_cc___0, 1);
					(create {P_NORMAL_STATIC}).clear_showcmd
					Result := l_c
					l_return := True
				end
			end
			if not l_return then
				(create {P_NORMAL_STATIC}).clear_showcmd
				Result := (('%/0/').code)
			end
		end

	ins_copychar (a_lnum: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_temp: INTEGER_32
			l_ptr: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prev_ptr: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ptr.make (<<1>>)

			if a_lnum < 1 then
				(create {P_MISC1_STATIC}).vim_beep
				Result := (('%/0/').code)
				l_return := True
			elseif a_lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
				(create {P_MISC1_STATIC}).vim_beep
				Result := (('%/0/').code)
				l_return := True
			end
			if not l_return then
				l_temp := 0
				l_ptr.item := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
				l_prev_ptr := l_ptr.item;
				(create {P_MOVE_STATIC}).validate_virtcol
				from
				until
					(l_break)
				loop
					l_break := False
					if l_temp < (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol then
						if (l_ptr.item.item).to_integer_32 = 0 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_prev_ptr := l_ptr.item
						l_temp := l_temp + ((create {P_CHARSET_STATIC}).lbr_chartabsize_adv (l_ptr, l_temp))
					end
				end
				l_break := False
				if l_temp > (create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol then
					l_ptr.item := l_prev_ptr
				end
				l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_ptr.item])
				if l_c = 0 then
					(create {P_MISC1_STATIC}).vim_beep
				end
				Result := l_c
			end
		end

	ins_ctrl_ey (a_tc___0: INTEGER_32): INTEGER_32
		local
			l_c: INTEGER_32
			l_tmp: INTEGER_32
			l_tw_save: INTEGER_32
		do
			l_c := a_tc___0
			if (create {P_GLOBALS_STATIC}).ctrl_x_mode.item = 2 then
				if l_c = 25 then
					(create {P_MOVE_STATIC}).scrolldown_clamp
				else
					(create {P_MOVE_STATIC}).scrollup_clamp
				end
				(create {P_SCREEN_STATIC}).redraw_later (10)
			else
				if l_c = 25 then
					l_tmp := -1
				else
					l_tmp := 1
				end
				l_c := ins_copychar ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + l_tmp.to_integer_32)
				if l_c /= 0 then
					if l_c < 256 then
						if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8)).to_boolean then
							(create {P_GETCHAR_STATIC}).AppendToRedobuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/22/")))
						end
					end
					l_tw_save := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tw;
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tw := -1
					insert_special (l_c, 1, 0);
					(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tw := l_tw_save
					l_c := 22
					auto_format (0, 1)
				end
			end
			Result := l_c
		end

	ins_try_si (a_c: INTEGER_32)
		local
			l_pos___3: CE_POINTER [PD_POS_T]
			l_old_pos: PD_POS_T
			l_ptr: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_temp: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((create {P_GLOBALS_STATIC}).did_si.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___2
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).can_si_back.item).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L___2:
						if a_c = 123 then
							l_pos := -1 + 8 -- goto _L___0
						else
							l_pos := -1 + 6 -- goto _L___1
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 6 then -- else: | _L___1:
						if not (((create {P_GLOBALS_STATIC}).can_si.item).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if a_c /= 125 then
							l_pos := -1 + 12 -- skip if block
						end
				when 8 then -- if: | _L___0:
						if a_c /= 125 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('{').code)
						if not l_pos___3.is_void then
							l_old_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							l_ptr := (create {P_MEMLINE_STATIC}).ml_get (l_pos___3.item.lnum)
							l_i___0 := l_pos___3.item.col
							if l_i___0 > 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l_i___0 := l_i___0 - 1
									if l_i___0 > 0 then
										if (l_ptr[l_i___0]).to_integer_32 /= 32 then
											if (l_ptr[l_i___0]).to_integer_32 /= 9 then
												l_break := True
											end
										end
									else
										l_break := True
									end
								end
								l_break := False
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_pos___3.item.lnum;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_i___0
							if (l_ptr[l_i___0]).to_integer_32 = 41 then
								l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('(').code)
								if not l_pos___3.is_void then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_pos___3.item).twin
								end
							end
							l_i___0 := (create {P_MISC1_STATIC}).get_indent;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_pos.twin
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
								change_indent (1, l_i___0, 0, ('%/0/').code, 1)
							else
								(create {P_MISC1_STATIC}).set_indent (l_i___0, 1).do_nothing
							end
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
							l_temp := 1
							if a_c = 123 then
								if ((create {P_GLOBALS_STATIC}).can_si_back.item).to_boolean then
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1 then
										l_old_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
										l_i___0 := (create {P_MISC1_STATIC}).get_indent
										from
										until
											not (not (l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1))
										loop
											l_break := False;
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
											l_ptr := (create {P_CHARSET_STATIC}).skipwhite (((create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)))
											if (l_ptr.item).to_integer_32 /= 35 then
												if (l_ptr.item).to_integer_32 /= 0 then
													l_break := True
												end
											end
										end
										l_break := False
										if ((create {P_MISC1_STATIC}).get_indent) >= l_i___0 then
											l_temp := 0
										end
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_pos.twin
									end
								end
							end
							if l_temp.to_boolean then
								(create {P_OPS_STATIC}).shift_line (1, 0, 1, 1)
							end
						end
				when 12 then -- if done | if done | if done | if done
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
						if ((create {P_GLOBALS_STATIC}).can_si.item).to_boolean then
							if a_c = 35 then
								old_indent.item := (create {P_MISC1_STATIC}).get_indent;
								(create {P_MISC1_STATIC}).set_indent (0, 1).do_nothing
							end
						end
					end
					if (create {P_GLOBALS_STATIC}).ai_col.item > (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
						(create {P_GLOBALS_STATIC}).ai_col.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_nolist_virtcol: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list).to_boolean then
				if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('L').code)).is_void then
					Result := ((create {P_CHARSET_STATIC}).getvcol_nolist (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))))
					l_return := True
				end
			end
			if not l_return then
				(create {P_MOVE_STATIC}).validate_virtcol
				Result := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol)
			end
		end

end
