class
	P_EX_CMDS_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_STDIO_STATIC
	S_SYS_STAT_STATIC
	S_UNISTD_STATIC
	S_FCNTL_STATIC
	S_LIBIO_STATIC
	S_STDLIB_STATIC
	S_CTYPE_STATIC

feature {ANY} -- public attributes

	sortbuf1: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	sortbuf2: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make
		end

	sort_ic: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	sort_nr: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	sort_abort: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	viminfo_errcnt: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	old_sub: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	global_need_beginline: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	mtable: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("*"),
					ce_string ("g*"),
					ce_string ("[*"),
					ce_string ("]*"),
					ce_string (":*"),
					ce_string ("/*"),
					ce_string ("/\*"),
					ce_string ("%"*"),
					ce_string ("**"),
					ce_string ("/\(\)"),
					ce_string ("?"),
					ce_string (":?"),
					ce_string ("?<CR>"),
					ce_string ("g?"),
					ce_string ("g?g?"),
					ce_string ("g??"),
					ce_string ("z?"),
					ce_string ("/\?"),
					ce_string ("/\z(\)"),
					ce_string ("\="),
					ce_string (":s\="),
					ce_string ("[count]"),
					ce_string ("[quotex]"),
					ce_string ("[range]"),
					ce_string ("[pattern]"),
					ce_string ("\|"),
					ce_string ("\%%$")
				>>)
		end

	rtable: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("star"),
					ce_string ("gstar"),
					ce_string ("[star"),
					ce_string ("]star"),
					ce_string (":star"),
					ce_string ("/star"),
					ce_string ("/\\star"),
					ce_string ("quotestar"),
					ce_string ("starstar"),
					ce_string ("/\\(\\)"),
					ce_string ("?"),
					ce_string (":?"),
					ce_string ("?<CR>"),
					ce_string ("g?"),
					ce_string ("g?g?"),
					ce_string ("g??"),
					ce_string ("z?"),
					ce_string ("/\\?"),
					ce_string ("/\\z(\\)"),
					ce_string ("\\="),
					ce_string (":s\\="),
					ce_string ("\[count]"),
					ce_string ("\[quotex]"),
					ce_string ("\[range]"),
					ce_string ("\[pattern]"),
					ce_string ("\\bar"),
					ce_string ("/\\%%\$")
				>>)
		end

	first_sign: CE_STATIC [CE_POINTER [PD_SIGN]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_SIGN]}.make_shared (default_pointer)
		end

	cmds: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("define"),
					ce_string ("undefine"),
					ce_string ("list"),
					ce_string ("place"),
					ce_string ("unplace"),
					ce_string ("jump"),
					create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				>>)
		end

	expand_what: CE_STATIC [NATURAL_32]
		once ("PROCESS")
		end

	cmdnames: CE_STATIC [CE_ARRAY [PD_CMDNAME]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CMDNAME]}.make_initialized (<<
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("append")), (create {PD_EXARG_STATIC}).ex_append_address, (3_150_083).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("abbreviate")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("abclear")), (create {PD_EXARG_STATIC}).ex_abclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("aboveleft")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("all")), (create {PD_EXARG_STATIC}).ex_all_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("amenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("anoremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("args")), (create {PD_EXARG_STATIC}).ex_args_address, (295_182).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("argadd")), (create {PD_EXARG_STATIC}).ex_argadd_address, (20_879).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("argdelete")), (create {PD_EXARG_STATIC}).ex_argdelete_address, (16_655).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("argdo")), (create {PD_EXARG_STATIC}).ex_listdo_address, (2_182).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("argedit")), (create {PD_EXARG_STATIC}).ex_argedit_address, (311_711).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("argglobal")), (create {PD_EXARG_STATIC}).ex_args_address, (295_182).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("arglocal")), (create {PD_EXARG_STATIC}).ex_args_address, (295_182).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("argument")), (create {PD_EXARG_STATIC}).ex_argument_address, (312_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ascii")), (create {PD_CMDARG_S_STATIC}).do_ascii_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("autocmd")), (create {PD_EXARG_STATIC}).ex_autocmd_address, (1_058_822).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("augroup")), (create {PD_EXARG_STATIC}).ex_autocmd_address, (1_048_854).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("aunmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("buffer")), (create {PD_EXARG_STATIC}).ex_buffer_address, (214_279).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bNext")), (create {PD_EXARG_STATIC}).ex_bprevious_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ball")), (create {PD_EXARG_STATIC}).ex_buffer_all_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("badd")), (create {P_EX_DOCMD_STATIC}).ex_edit_address, (1_081_756).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bdelete")), (create {PD_EXARG_STATIC}).ex_bunload_address, (83_207).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("behave")), (create {PD_EXARG_STATIC}).ex_behave_address, (1_048_980).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("belowright")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfirst")), (create {PD_EXARG_STATIC}).ex_brewind_address, (16_643).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("blast")), (create {PD_EXARG_STATIC}).ex_blast_address, (16_643).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bmodified")), (create {PD_EXARG_STATIC}).ex_bmodified_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bnext")), (create {PD_EXARG_STATIC}).ex_bnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("botright")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bprevious")), (create {PD_EXARG_STATIC}).ex_bprevious_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("brewind")), (create {PD_EXARG_STATIC}).ex_brewind_address, (16_643).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("break")), (create {PD_EXARG_STATIC}).ex_break_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("breakadd")), (create {PD_EXARG_STATIC}).ex_breakadd_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("breakdel")), (create {PD_EXARG_STATIC}).ex_breakdel_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("breaklist")), (create {P_EX_CMDS2_STATIC}).ex_breaklist_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("browse")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (1_050_756).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("buffers")), (create {P_BUFFER_STATIC}).buflist_list_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bufdo")), (create {PD_EXARG_STATIC}).ex_listdo_address, (2_182).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bunload")), (create {PD_EXARG_STATIC}).ex_bunload_address, (83_207).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bwipeout")), (create {PD_EXARG_STATIC}).ex_bunload_address, (214_279).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("change")), (create {PD_EXARG_STATIC}).ex_change_address, (3_147_075).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cNext")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cNfile")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cabbrev")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cabclear")), (create {PD_EXARG_STATIC}).ex_abclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("caddbuffer")), (create {PD_EXARG_STATIC}).ex_cbuffer_address, (16_661).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("caddexpr")), (create {PD_EXARG_STATIC}).ex_cexpr_address, (2_452).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("caddfile")), (create {PD_EXARG_STATIC}).ex_cfile_address, (284).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("call")), (create {PD_EXARG_STATIC}).ex_call_address, (1_575_045).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("catch")), (create {PD_EXARG_STATIC}).ex_catch_address, (1_572_868).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cbuffer")), (create {PD_EXARG_STATIC}).ex_cbuffer_address, (16_663).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cc")), (create {PD_EXARG_STATIC}).ex_cc_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cclose")), (create {PD_EXARG_STATIC}).ex_cclose_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cd")), (create {PD_EXARG_STATIC}).ex_cd_address, (1_048_862).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("center")), (create {PD_EXARG_STATIC}).ex_align_address, (3_146_053).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cexpr")), (create {PD_EXARG_STATIC}).ex_cexpr_address, (2_454).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cfile")), (create {PD_EXARG_STATIC}).ex_cfile_address, (286).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cfirst")), (create {PD_EXARG_STATIC}).ex_cc_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cgetfile")), (create {PD_EXARG_STATIC}).ex_cfile_address, (284).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cgetbuffer")), (create {PD_EXARG_STATIC}).ex_cbuffer_address, (16_661).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cgetexpr")), (create {PD_EXARG_STATIC}).ex_cexpr_address, (2_452).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("chdir")), (create {PD_EXARG_STATIC}).ex_cd_address, (1_048_862).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("changes")), (create {P_MARK_STATIC}).ex_changes_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("checkpath")), (create {PD_EXARG_STATIC}).ex_checkpath_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("checktime")), (create {PD_EXARG_STATIC}).ex_checktime_address, (83_205).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("clist")), (create {PD_EXARG_STATIC}).qf_list_address, (1_048_838).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("clast")), (create {PD_EXARG_STATIC}).ex_cc_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("close")), (create {P_EX_DOCMD_STATIC}).ex_close_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cmap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cmapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cnext")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cnewer")), (create {PD_EXARG_STATIC}).qf_age_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cnfile")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cnoremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cnoreabbrev")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cnoremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("copy")), (create {PD_EXARG_STATIC}).ex_copymove_address, (3_146_053).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("colder")), (create {PD_EXARG_STATIC}).qf_age_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("colorscheme")), (create {PD_EXARG_STATIC}).ex_colorscheme_address, (1_048_852).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("command")), (create {PD_EXARG_STATIC}).ex_command_address, (1_058_822).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("comclear")), (create {P_EX_DOCMD_STATIC}).ex_comclear_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("compiler")), (create {PD_EXARG_STATIC}).ex_compiler_address, (1_048_854).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("continue")), (create {PD_EXARG_STATIC}).ex_continue_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("confirm")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (1_050_756).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("copen")), (create {PD_EXARG_STATIC}).ex_copen_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cprevious")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cpfile")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cquit")), (create {P_EX_DOCMD_STATIC}).ex_cquit_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("crewind")), (create {PD_EXARG_STATIC}).ex_cc_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cscope")), (create {PD_EXARG_STATIC}).ex_ni_address, (2_060).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cstag")), (create {PD_EXARG_STATIC}).ex_ni_address, (278).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cunmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cunabbrev")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cunmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cwindow")), (create {PD_EXARG_STATIC}).ex_cwindow_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("delete")), (create {PD_EXARG_STATIC}).ex_operators_address, (3_147_585).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("delmarks")), (create {PD_EXARG_STATIC}).ex_delmarks_address, (1_048_838).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("debug")), (create {PD_EXARG_STATIC}).ex_debug_address, (1_575_044).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("debuggreedy")), (create {PD_EXARG_STATIC}).ex_debuggreedy_address, (1_069_313).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("delcommand")), (create {P_EX_DOCMD_STATIC}).ex_delcommand_address, (1_048_980).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("delfunction")), (create {PD_EXARG_STATIC}).ex_delfunction_address, (1_048_724).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("display")), (create {PD_EXARG_STATIC}).ex_display_address, (1_575_172).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diffupdate")), (create {P_DIFF_STATIC}).ex_diffupdate_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diffget")), (create {PD_CMDARG_S_STATIC}).ex_diffgetput_address, (2_097_413).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diffoff")), (create {P_DIFF_STATIC}).ex_diffoff_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diffpatch")), (create {P_DIFF_STATIC}).ex_diffpatch_address, (2_097_436).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diffput")), (create {PD_CMDARG_S_STATIC}).ex_diffgetput_address, (261).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diffsplit")), (create {P_DIFF_STATIC}).ex_diffsplit_address, (284).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("diffthis")), (create {P_DIFF_STATIC}).ex_diffthis_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("digraphs")), (create {PD_EXARG_STATIC}).ex_digraphs_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("djump")), (create {PD_EXARG_STATIC}).ex_findpat_address, (103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dlist")), (create {PD_EXARG_STATIC}).ex_findpat_address, (1_048_679).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("doautocmd")), (create {PD_EXARG_STATIC}).ex_doautocmd_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("doautoall")), (create {P_FILEIO_STATIC}).ex_doautoall_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("drop")), (create {PD_EXARG_STATIC}).ex_drop_address, (295_308).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dsearch")), (create {PD_EXARG_STATIC}).ex_findpat_address, (1_048_679).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dsplit")), (create {PD_EXARG_STATIC}).ex_findpat_address, (103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("edit")), (create {P_EX_DOCMD_STATIC}).ex_edit_address, (295_198).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("earlier")), (create {PD_EXARG_STATIC}).ex_later_address, (1_048_852).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("echo")), (create {PD_EXARG_STATIC}).ex_echo_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("echoerr")), (create {PD_EXARG_STATIC}).ex_execute_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("echohl")), (create {PD_EXARG_STATIC}).ex_echohl_address, (1_573_124).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("echomsg")), (create {PD_EXARG_STATIC}).ex_execute_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("echon")), (create {PD_EXARG_STATIC}).ex_echo_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("else")), (create {PD_EXARG_STATIC}).ex_else_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("elseif")), (create {PD_EXARG_STATIC}).ex_else_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("emenu")), (create {PD_EXARG_STATIC}).ex_emenu_address, (1_067_397).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("endif")), (create {PD_EXARG_STATIC}).ex_endif_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("endfunction")), (create {P_EX_EVAL_STATIC}).ex_endfunction_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("endfor")), (create {PD_EXARG_STATIC}).ex_endwhile_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("endtry")), (create {PD_EXARG_STATIC}).ex_endtry_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("endwhile")), (create {PD_EXARG_STATIC}).ex_endwhile_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("enew")), (create {P_EX_DOCMD_STATIC}).ex_edit_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ex")), (create {P_EX_DOCMD_STATIC}).ex_edit_address, (295_198).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("execute")), (create {PD_EXARG_STATIC}).ex_execute_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("exit")), (create {P_EX_DOCMD_STATIC}).ex_exit_address, (1_311_103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("exusage")), ex_exusage_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("file")), (create {PD_EXARG_STATIC}).ex_file_address, (20_767).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("files")), (create {P_BUFFER_STATIC}).buflist_list_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("filetype")), (create {PD_EXARG_STATIC}).ex_filetype_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("find")), (create {PD_EXARG_STATIC}).ex_find_address, (311_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("finally")), (create {PD_EXARG_STATIC}).ex_finally_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("finish")), (create {PD_EXARG_STATIC}).ex_finish_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("first")), (create {PD_EXARG_STATIC}).ex_rewind_address, (295_174).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fixdel")), do_fixdel_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("fold")), (create {P_EX_DOCMD_STATIC}).ex_fold_address, (1_573_185).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("foldclose")), (create {PD_EXARG_STATIC}).ex_foldopen_address, (1_573_187).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("folddoopen")), (create {PD_EXARG_STATIC}).ex_folddo_address, (2_213).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("folddoclosed")), (create {PD_EXARG_STATIC}).ex_folddo_address, (2_213).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("foldopen")), (create {PD_EXARG_STATIC}).ex_foldopen_address, (1_573_187).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("for")), (create {PD_EXARG_STATIC}).ex_while_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("function")), (create {PD_EXARG_STATIC}).ex_function_address, (1_048_582).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("global")), ex_global_address, (1_572_967).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("goto")), (create {PD_EXARG_STATIC}).ex_goto_address, (1_590_529).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("grep")), (create {PD_EXARG_STATIC}).ex_make_address, (18_831).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("grepadd")), (create {PD_EXARG_STATIC}).ex_make_address, (18_831).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("gui")), (create {PD_EXARG_STATIC}).ex_gui_address, (1_343_758).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("gvim")), (create {PD_EXARG_STATIC}).ex_gui_address, (1_343_758).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("help")), (create {PD_CMDARG_S_STATIC}).ex_help_address, (2_054).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("helpfind")), (create {P_GUI_GTK_STATIC}).ex_helpfind_address, (2_052).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("helpgrep")), (create {PD_EXARG_STATIC}).ex_helpgrep_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("helptags")), (create {PD_EXARG_STATIC}).ex_helptags_address, (1_048_972).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("hardcopy")), (create {PD_EXARG_STATIC}).ex_hardcopy_address, (1_319).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("highlight")), (create {PD_EXARG_STATIC}).ex_highlight_address, (1_573_126).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("hide")), (create {PD_EXARG_STATIC}).ex_hide_address, (2_054).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("history")), (create {PD_EXARG_STATIC}).ex_history_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("insert")), (create {PD_EXARG_STATIC}).ex_append_address, (3_145_987).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("iabbrev")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("iabclear")), (create {PD_EXARG_STATIC}).ex_abclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("if")), (create {PD_EXARG_STATIC}).ex_if_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ijump")), (create {PD_EXARG_STATIC}).ex_findpat_address, (103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ilist")), (create {PD_EXARG_STATIC}).ex_findpat_address, (1_048_679).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("imap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("imapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("imenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("inoremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("inoreabbrev")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("inoremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("intro")), (create {P_VERSION_STATIC}).ex_intro_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("isearch")), (create {PD_EXARG_STATIC}).ex_findpat_address, (1_048_679).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("isplit")), (create {PD_EXARG_STATIC}).ex_findpat_address, (103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("iunmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("iunabbrev")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("iunmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("join")), (create {PD_EXARG_STATIC}).ex_join_address, (7_341_379).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("jumps")), (create {P_MARK_STATIC}).ex_jumps_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("k")), (create {PD_EXARG_STATIC}).ex_mark_address, (1_573_141).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("keepmarks")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("keepjumps")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("keepalt")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("list")), (create {P_EX_DOCMD_STATIC}).ex_print_address, (5_244_225).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lNext")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lNfile")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("last")), (create {P_EX_CMDS2_STATIC}).ex_last_address, (295_174).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("language")), (create {PD_EXARG_STATIC}).ex_language_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("laddexpr")), (create {PD_EXARG_STATIC}).ex_cexpr_address, (2_452).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("laddbuffer")), (create {PD_EXARG_STATIC}).ex_cbuffer_address, (16_661).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("laddfile")), (create {PD_EXARG_STATIC}).ex_cfile_address, (284).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("later")), (create {PD_EXARG_STATIC}).ex_later_address, (1_048_852).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lbuffer")), (create {PD_EXARG_STATIC}).ex_cbuffer_address, (16_663).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lcd")), (create {PD_EXARG_STATIC}).ex_cd_address, (1_048_862).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lchdir")), (create {PD_EXARG_STATIC}).ex_cd_address, (1_048_862).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lclose")), (create {PD_EXARG_STATIC}).ex_cclose_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lcscope")), (create {PD_EXARG_STATIC}).ex_ni_address, (2_060).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("left")), (create {PD_EXARG_STATIC}).ex_align_address, (3_146_053).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("leftabove")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("let")), (create {PD_EXARG_STATIC}).ex_let_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lexpr")), (create {PD_EXARG_STATIC}).ex_cexpr_address, (2_454).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lfile")), (create {PD_EXARG_STATIC}).ex_cfile_address, (286).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lfirst")), (create {PD_EXARG_STATIC}).ex_cc_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lgetfile")), (create {PD_EXARG_STATIC}).ex_cfile_address, (284).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lgetbuffer")), (create {PD_EXARG_STATIC}).ex_cbuffer_address, (16_661).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lgetexpr")), (create {PD_EXARG_STATIC}).ex_cexpr_address, (2_452).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lgrep")), (create {PD_EXARG_STATIC}).ex_make_address, (18_831).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lgrepadd")), (create {PD_EXARG_STATIC}).ex_make_address, (18_831).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lhelpgrep")), (create {PD_EXARG_STATIC}).ex_helpgrep_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ll")), (create {PD_EXARG_STATIC}).ex_cc_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("llast")), (create {PD_EXARG_STATIC}).ex_cc_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("llist")), (create {PD_EXARG_STATIC}).qf_list_address, (1_048_838).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lmap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lmapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lmake")), (create {PD_EXARG_STATIC}).ex_make_address, (2_318).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lnoremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lnext")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lnewer")), (create {PD_EXARG_STATIC}).qf_age_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lnfile")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("loadview")), (create {PD_EXARG_STATIC}).ex_loadview_address, (284).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("loadkeymap")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_576).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lockmarks")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lockvar")), (create {PD_EXARG_STATIC}).ex_lockvar_address, (1_572_998).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lolder")), (create {PD_EXARG_STATIC}).qf_age_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lopen")), (create {PD_EXARG_STATIC}).ex_copen_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lprevious")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lpfile")), (create {PD_EXARG_STATIC}).ex_cnext_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lrewind")), (create {PD_EXARG_STATIC}).ex_cc_address, (17_667).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ltag")), (create {PD_EXARG_STATIC}).ex_tag_address, (16_662).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lua")), (create {PD_EXARG_STATIC}).ex_script_ni_address, (1_048_709).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("luado")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_741).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("luafile")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_733).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lunmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lvimgrep")), (create {PD_EXARG_STATIC}).ex_vimgrep_address, (18_831).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lvimgrepadd")), (create {PD_EXARG_STATIC}).ex_vimgrep_address, (18_831).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("lwindow")), (create {PD_EXARG_STATIC}).ex_cwindow_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ls")), (create {P_BUFFER_STATIC}).buflist_list_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("move")), (create {PD_EXARG_STATIC}).ex_copymove_address, (3_146_053).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mark")), (create {PD_EXARG_STATIC}).ex_mark_address, (1_573_141).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("make")), (create {PD_EXARG_STATIC}).ex_make_address, (2_318).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("map")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_078).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_838).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("marks")), (create {PD_EXARG_STATIC}).do_marks_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("match")), (create {PD_EXARG_STATIC}).ex_match_address, (1_064_965).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_559).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menutranslate")), (create {PD_EXARG_STATIC}).ex_menutranslate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("messages")), (create {P_MESSAGE_STATIC}).ex_messages_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mkexrc")), (create {PD_EXARG_STATIC}).ex_mkrc_address, (1_048_862).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mksession")), (create {PD_EXARG_STATIC}).ex_mkrc_address, (286).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mkspell")), (create {PD_EXARG_STATIC}).ex_mkspell_address, (2_446).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mkvimrc")), (create {PD_EXARG_STATIC}).ex_mkrc_address, (1_048_862).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mkview")), (create {PD_EXARG_STATIC}).ex_mkrc_address, (286).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mode")), (create {PD_EXARG_STATIC}).ex_mode_address, (1_048_852).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mzscheme")), (create {PD_EXARG_STATIC}).ex_script_ni_address, (1_573_029).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("mzfile")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_733).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("next")), (create {PD_EXARG_STATIC}).ex_next_address, (311_567).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nbkey")), (create {PD_EXARG_STATIC}).ex_nbkey_address, (16_516).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nbclose")), (create {P_NETBEANS_STATIC}).ex_nbclose_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nbstart")), (create {PD_EXARG_STATIC}).ex_nbstart_address, (1_048_852).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("new")), (create {PD_EXARG_STATIC}).ex_splitview_address, (311_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nmap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nmapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nnoremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nnoremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("noremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_078).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("noautocmd")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nohlsearch")), (create {P_EX_DOCMD_STATIC}).ex_nohlsearch_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("noreabbrev")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("noremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_559).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("normal")), (create {P_EX_DOCMD_STATIC}).ex_normal_address, (1_583_239).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("number")), (create {P_EX_DOCMD_STATIC}).ex_print_address, (5_244_225).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nunmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("nunmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("open")), (create {PD_EXARG_STATIC}).ex_open_address, (5).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("oldfiles")), (create {P_EVAL_STATIC}).ex_oldfiles_address, (1_573_122).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("omap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("omapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("omenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("only")), (create {PD_EXARG_STATIC}).ex_only_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("onoremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("onoremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("options")), (create {PD_EXARG_STATIC}).ex_options_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ounmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ounmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ownsyntax")), (create {PD_EXARG_STATIC}).ex_ownsyntax_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("print")), (create {P_EX_DOCMD_STATIC}).ex_print_address, (5_768_513).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("pclose")), (create {P_EX_DOCMD_STATIC}).ex_pclose_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("perl")), (create {PD_EXARG_STATIC}).ex_script_ni_address, (1_573_029).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("perldo")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_741).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("pedit")), (create {P_EX_DOCMD_STATIC}).ex_pedit_address, (295_198).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("pop")), (create {PD_EXARG_STATIC}).ex_tag_address, (21_763).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("popup")), (create {PD_EXARG_STATIC}).ex_popup_address, (1_051_014).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ppop")), (create {PD_EXARG_STATIC}).ex_ptag_address, (21_763).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("preserve")), (create {P_EX_DOCMD_STATIC}).ex_preserve_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("previous")), (create {PD_EXARG_STATIC}).ex_previous_address, (312_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("promptfind")), (create {P_GUI_GTK_STATIC}).gui_mch_find_dialog_address, (1_050_628).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("promptrepl")), (create {P_GUI_GTK_STATIC}).gui_mch_replace_dialog_address, (1_050_628).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("profile")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_838).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("profdel")), (create {PD_EXARG_STATIC}).ex_breakdel_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("psearch")), (create {PD_EXARG_STATIC}).ex_psearch_address, (103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptag")), (create {PD_EXARG_STATIC}).ex_ptag_address, (20_759).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptNext")), (create {PD_EXARG_STATIC}).ex_ptag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptfirst")), (create {PD_EXARG_STATIC}).ex_ptag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptjump")), (create {PD_EXARG_STATIC}).ex_ptag_address, (278).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptlast")), (create {PD_EXARG_STATIC}).ex_ptag_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptnext")), (create {PD_EXARG_STATIC}).ex_ptag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptprevious")), (create {PD_EXARG_STATIC}).ex_ptag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptrewind")), (create {PD_EXARG_STATIC}).ex_ptag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ptselect")), (create {PD_EXARG_STATIC}).ex_ptag_address, (278).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("put")), (create {PD_EXARG_STATIC}).ex_put_address, (3_150_659).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("pwd")), (create {PD_EXARG_STATIC}).ex_pwd_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("python")), (create {PD_EXARG_STATIC}).ex_script_ni_address, (1_048_709).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("pyfile")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_733).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("py3")), (create {PD_EXARG_STATIC}).ex_script_ni_address, (1_048_709).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("python3")), (create {PD_EXARG_STATIC}).ex_script_ni_address, (1_048_709).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("py3file")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_733).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("quit")), (create {P_EX_DOCMD_STATIC}).ex_quit_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("quitall")), (create {P_EX_DOCMD_STATIC}).ex_quit_all_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("qall")), (create {P_EX_DOCMD_STATIC}).ex_quit_all_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("read")), (create {PD_EXARG_STATIC}).ex_read_address, (3_412_319).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("recover")), (create {PD_EXARG_STATIC}).ex_recover_address, (286).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("redo")), (create {P_EX_DOCMD_STATIC}).ex_redo_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("redir")), (create {PD_EXARG_STATIC}).ex_redir_address, (1_048_846).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("redraw")), (create {PD_EXARG_STATIC}).ex_redraw_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("redrawstatus")), (create {PD_EXARG_STATIC}).ex_redrawstatus_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("registers")), (create {PD_EXARG_STATIC}).ex_display_address, (1_050_884).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("resize")), (create {PD_EXARG_STATIC}).ex_resize_address, (16_661).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("retab")), ex_retab_address, (3_146_103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("return")), (create {PD_EXARG_STATIC}).ex_return_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rewind")), (create {PD_EXARG_STATIC}).ex_rewind_address, (295_174).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("right")), (create {PD_EXARG_STATIC}).ex_align_address, (3_146_053).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rightbelow")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("runtime")), (create {PD_EXARG_STATIC}).ex_runtime_address, (1_573_262).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ruby")), (create {PD_EXARG_STATIC}).ex_script_ni_address, (1_048_709).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rubydo")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_741).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rubyfile")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_733).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rundo")), (create {PD_EXARG_STATIC}).ex_rundo_address, (140).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rviminfo")), (create {PD_EXARG_STATIC}).ex_viminfo_address, (1_048_862).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("substitute")), (create {PD_EXARG_STATIC}).do_sub_address, (1_048_645).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sNext")), (create {PD_EXARG_STATIC}).ex_previous_address, (312_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sargument")), (create {PD_EXARG_STATIC}).ex_argument_address, (312_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sall")), (create {PD_EXARG_STATIC}).ex_all_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sandbox")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("saveas")), (create {PD_EXARG_STATIC}).ex_write_address, (1_311_038).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sbuffer")), (create {PD_EXARG_STATIC}).ex_buffer_address, (214_279).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sbNext")), (create {PD_EXARG_STATIC}).ex_bprevious_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sball")), (create {PD_EXARG_STATIC}).ex_buffer_all_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sbfirst")), (create {PD_EXARG_STATIC}).ex_brewind_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sblast")), (create {PD_EXARG_STATIC}).ex_blast_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sbmodified")), (create {PD_EXARG_STATIC}).ex_bmodified_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sbnext")), (create {PD_EXARG_STATIC}).ex_bnext_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sbprevious")), (create {PD_EXARG_STATIC}).ex_bprevious_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sbrewind")), (create {PD_EXARG_STATIC}).ex_brewind_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("scriptnames")), (create {P_EX_CMDS2_STATIC}).ex_scriptnames_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("scriptencoding")), (create {PD_EXARG_STATIC}).ex_scriptencoding_address, (1_048_852).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("scscope")), (create {PD_EXARG_STATIC}).ex_ni_address, (2_052).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("set")), (create {PD_EXARG_STATIC}).ex_set_address, (1_573_124).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("setfiletype")), (create {P_EX_DOCMD_STATIC}).ex_setfiletype_address, (1_048_964).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("setglobal")), (create {PD_EXARG_STATIC}).ex_set_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("setlocal")), (create {PD_EXARG_STATIC}).ex_set_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sfind")), (create {PD_EXARG_STATIC}).ex_splitview_address, (311_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sfirst")), (create {PD_EXARG_STATIC}).ex_rewind_address, (295_174).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("shell")), (create {P_EX_DOCMD_STATIC}).ex_shell_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("simalt")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_980).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sign")), (create {PD_EXARG_STATIC}).ex_sign_address, (1_065_093).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("silent")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (1_575_046).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sleep")), (create {PD_EXARG_STATIC}).ex_sleep_address, (1_066_245).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("slast")), (create {P_EX_CMDS2_STATIC}).ex_last_address, (295_174).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smagic")), (create {PD_EXARG_STATIC}).ex_submagic_address, (1_048_645).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("smenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("snext")), (create {PD_EXARG_STATIC}).ex_next_address, (311_567).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sniff")), (create {PD_EXARG_STATIC}).ex_ni_address, (260).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("snomagic")), (create {PD_EXARG_STATIC}).ex_submagic_address, (1_048_645).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("snoremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("snoremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("source")), (create {PD_EXARG_STATIC}).ex_source_address, (1_573_150).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sort")), (create {PD_EXARG_STATIC}).ex_sort_address, (2_099_303).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("split")), (create {PD_EXARG_STATIC}).ex_splitview_address, (311_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spellgood")), (create {PD_EXARG_STATIC}).ex_spell_address, (16_775).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spelldump")), (create {P_SPELL_STATIC}).ex_spelldump_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spellinfo")), (create {P_SPELL_STATIC}).ex_spellinfo_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spellrepall")), (create {P_SPELL_STATIC}).ex_spellrepall_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spellundo")), (create {PD_EXARG_STATIC}).ex_spell_address, (16_775).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("spellwrong")), (create {PD_EXARG_STATIC}).ex_spell_address, (16_775).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sprevious")), (create {PD_EXARG_STATIC}).ex_previous_address, (312_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("srewind")), (create {PD_EXARG_STATIC}).ex_rewind_address, (295_174).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("stop")), (create {P_EX_DOCMD_STATIC}).ex_stop_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("stag")), (create {PD_EXARG_STATIC}).ex_stag_address, (20_759).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("startinsert")), (create {PD_EXARG_STATIC}).ex_startinsert_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("startgreplace")), (create {PD_EXARG_STATIC}).ex_startinsert_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("startreplace")), (create {PD_EXARG_STATIC}).ex_startinsert_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("stopinsert")), (create {P_EX_DOCMD_STATIC}).ex_stopinsert_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("stjump")), (create {PD_EXARG_STATIC}).ex_stag_address, (278).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("stselect")), (create {PD_EXARG_STATIC}).ex_stag_address, (278).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sunhide")), (create {PD_EXARG_STATIC}).ex_buffer_all_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sunmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sunmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("suspend")), (create {P_EX_DOCMD_STATIC}).ex_stop_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sview")), (create {PD_EXARG_STATIC}).ex_splitview_address, (311_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("swapname")), (create {P_EX_DOCMD_STATIC}).ex_swapname_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("syntax")), (create {PD_EXARG_STATIC}).ex_syntax_address, (1_050_628).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("syncbind")), (create {P_EX_DOCMD_STATIC}).ex_syncbind_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("t")), (create {PD_EXARG_STATIC}).ex_copymove_address, (3_146_053).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tNext")), (create {PD_EXARG_STATIC}).ex_tag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tag")), (create {PD_EXARG_STATIC}).ex_tag_address, (20_759).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tags")), (create {P_TAG_STATIC}).do_tags_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tab")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabclose")), (create {P_EX_DOCMD_STATIC}).ex_tabclose_address, (1_066_243).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabdo")), (create {PD_EXARG_STATIC}).ex_listdo_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabedit")), (create {PD_EXARG_STATIC}).ex_splitview_address, (315_679).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabfind")), (create {PD_EXARG_STATIC}).ex_splitview_address, (315_807).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabfirst")), (create {PD_EXARG_STATIC}).ex_tabnext_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabmove")), (create {PD_EXARG_STATIC}).ex_tabmove_address, (21_761).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tablast")), (create {PD_EXARG_STATIC}).ex_tabnext_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabnext")), (create {PD_EXARG_STATIC}).ex_tabnext_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabnew")), (create {PD_EXARG_STATIC}).ex_splitview_address, (315_679).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabonly")), (create {P_EX_DOCMD_STATIC}).ex_tabonly_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabprevious")), (create {PD_EXARG_STATIC}).ex_tabnext_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabNext")), (create {PD_EXARG_STATIC}).ex_tabnext_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabrewind")), (create {PD_EXARG_STATIC}).ex_tabnext_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabs")), (create {P_EX_DOCMD_STATIC}).ex_tabs_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tcl")), (create {PD_EXARG_STATIC}).ex_script_ni_address, (1_048_709).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tcldo")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_741).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tclfile")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_048_733).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tearoff")), (create {PD_EXARG_STATIC}).ex_ni_address, (1_051_012).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tfirst")), (create {PD_EXARG_STATIC}).ex_tag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("throw")), (create {PD_EXARG_STATIC}).ex_throw_address, (1_572_996).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tjump")), (create {PD_EXARG_STATIC}).ex_tag_address, (278).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tlast")), (create {PD_EXARG_STATIC}).ex_tag_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tnext")), (create {PD_EXARG_STATIC}).ex_tag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("topleft")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tprevious")), (create {PD_EXARG_STATIC}).ex_tag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("trewind")), (create {PD_EXARG_STATIC}).ex_tag_address, (20_739).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("try")), (create {PD_EXARG_STATIC}).ex_try_address, (1_573_120).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tselect")), (create {PD_EXARG_STATIC}).ex_tag_address, (278).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tunmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("undo")), (create {PD_EXARG_STATIC}).ex_undo_address, (1_070_337).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("undojoin")), (create {P_UNDO_STATIC}).ex_undojoin_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("undolist")), (create {P_UNDO_STATIC}).ex_undolist_address, (1_048_832).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("unabbreviate")), (create {PD_EXARG_STATIC}).ex_abbreviate_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("unhide")), (create {PD_EXARG_STATIC}).ex_buffer_all_address, (17_665).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("unlet")), (create {PD_EXARG_STATIC}).ex_unlet_address, (1_572_998).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("unlockvar")), (create {PD_EXARG_STATIC}).ex_lockvar_address, (1_572_998).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("unmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_078).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("unmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_078).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("unsilent")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (1_575_044).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("update")), ex_update_address, (262_527).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vglobal")), ex_global_address, (1_048_677).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("version")), (create {PD_EXARG_STATIC}).ex_version_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("verbose")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (1_591_429).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vertical")), (create {PD_EXARG_STATIC}).ex_wrongmodifier_address, (2_180).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("visual")), (create {P_EX_DOCMD_STATIC}).ex_edit_address, (295_198).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view")), (create {P_EX_DOCMD_STATIC}).ex_edit_address, (295_198).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vimgrep")), (create {PD_EXARG_STATIC}).ex_vimgrep_address, (18_831).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vimgrepadd")), (create {PD_EXARG_STATIC}).ex_vimgrep_address, (18_831).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("viusage")), ex_viusage_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vmap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vmapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vnoremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vnew")), (create {PD_EXARG_STATIC}).ex_splitview_address, (311_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vnoremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vsplit")), (create {PD_EXARG_STATIC}).ex_splitview_address, (311_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vunmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vunmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("write")), (create {PD_EXARG_STATIC}).ex_write_address, (1_311_103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wNext")), (create {PD_EXARG_STATIC}).ex_wnext_address, (278_879).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wall")), (create {PD_EXARG_STATIC}).do_wqall_address, (1_048_834).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("while")), (create {PD_EXARG_STATIC}).ex_while_address, (1_574_916).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("winsize")), (create {PD_EXARG_STATIC}).ex_winsize_address, (388).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wincmd")), (create {PD_EXARG_STATIC}).ex_wincmd_address, (16_533).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("windo")), (create {PD_EXARG_STATIC}).ex_listdo_address, (2_182).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("winpos")), (create {PD_EXARG_STATIC}).ex_winpos_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wnext")), (create {PD_EXARG_STATIC}).ex_wnext_address, (278_815).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wprevious")), (create {PD_EXARG_STATIC}).ex_wnext_address, (278_815).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wq")), (create {P_EX_DOCMD_STATIC}).ex_exit_address, (262_527).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wqall")), (create {PD_EXARG_STATIC}).do_wqall_address, (262_462).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wsverb")), (create {PD_EXARG_STATIC}).ex_ni_address, (16_516).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wundo")), (create {PD_EXARG_STATIC}).ex_wundo_address, (142).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("wviminfo")), (create {PD_EXARG_STATIC}).ex_viminfo_address, (1_048_862).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xit")), (create {P_EX_DOCMD_STATIC}).ex_exit_address, (1_311_103).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xall")), (create {PD_EXARG_STATIC}).do_wqall_address, (258).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xmap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xmapclear")), (create {PD_EXARG_STATIC}).ex_mapclear_address, (1_048_836).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xnoremap")), (create {PD_EXARG_STATIC}).ex_map_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xnoremenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_079_557).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xunmap")), (create {PD_EXARG_STATIC}).ex_unmap_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("xunmenu")), (create {PD_EXARG_STATIC}).ex_menu_address, (1_059_076).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("yank")), (create {PD_EXARG_STATIC}).ex_operators_address, (1_050_433).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("z")), (create {PD_EXARG_STATIC}).ex_z_address, (5_243_205).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("!")), (create {PD_EXARG_STATIC}).ex_bang_address, (1_048_655).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("#")), (create {P_EX_DOCMD_STATIC}).ex_print_address, (5_244_225).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("&")), (create {PD_EXARG_STATIC}).do_sub_address, (3_145_797).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*")), (create {PD_EXARG_STATIC}).ex_at_address, (1_048_901).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<")), (create {PD_EXARG_STATIC}).ex_operators_address, (7_341_377).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("=")), (create {PD_EXARG_STATIC}).ex_equal_address, (5_243_169).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string (">")), (create {PD_EXARG_STATIC}).ex_operators_address, (7_341_377).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("@")), (create {PD_EXARG_STATIC}).ex_at_address, (1_048_901).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Next")), (create {PD_EXARG_STATIC}).ex_previous_address, (312_583).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Print")), (create {P_EX_DOCMD_STATIC}).ex_print_address, (5_244_225).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("X")), (create {P_EX_DOCMD_STATIC}).ex_X_address, (256).to_natural_32]),
					create {PD_CMDNAME}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("~")), (create {PD_EXARG_STATIC}).do_sub_address, (3_145_797).to_natural_32])
				>>)
		end

feature {ANY} -- public routines

	sort_compare (a_s1, a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_l1: PD_SORTI_T
			l_l2: PD_SORTI_T
			l_result___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_l1 := ((create {CE_CLASS_POINTER [PD_SORTI_T]}.make_cast (a_s1)).item).twin
			l_l2 := ((create {CE_CLASS_POINTER [PD_SORTI_T]}.make_cast (a_s2)).item).twin
			l_result___2 := 0
			if sort_abort.item.to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_MISC1_STATIC}).fast_breakcheck
				if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
					sort_abort.item := 1
				end
				if sort_nr.item.to_boolean then
					l_result___2 := (l_l1.start_col_nr - l_l2.start_col_nr).to_integer_32
				else
					strncpy (create {CE_INTEGER_8_POINTER}.make_cast (sortbuf1.item), create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_MEMLINE_STATIC}).ml_get (l_l1.lnum)) + l_l1.start_col_nr)), ((l_l1.end_col_nr - l_l1.start_col_nr) + 1).to_natural_32).do_nothing
					sortbuf1.item[(l_l1.end_col_nr - l_l1.start_col_nr)] := (0).to_natural_8
					strncpy (create {CE_INTEGER_8_POINTER}.make_cast (sortbuf2.item), create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_MEMLINE_STATIC}).ml_get (l_l2.lnum)) + l_l2.start_col_nr)), ((l_l2.end_col_nr - l_l2.start_col_nr) + 1).to_natural_32).do_nothing
					sortbuf2.item[(l_l2.end_col_nr - l_l2.start_col_nr)] := (0).to_natural_8
					if sort_ic.item.to_boolean then
						l_result___2 := (strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (sortbuf1.item), create {CE_INTEGER_8_POINTER}.make_cast (sortbuf2.item)))
					else
						l_result___2 := (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (sortbuf1.item), create {CE_INTEGER_8_POINTER}.make_cast (sortbuf2.item)))
					end
				end
				if l_result___2 = 0 then
					Result := (l_l1.lnum - l_l2.lnum).to_integer_32
					l_return := True
				end
			end
			if not l_return then
				Result := l_result___2
			end
		end

	ex_retab (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
			l_got_tab: INTEGER_32
			l_num_spaces: INTEGER_32
			l_num_tabs: INTEGER_32
			l_len: INTEGER_32
			l_col: INTEGER_32
			l_vcol: INTEGER_32
			l_start_col: INTEGER_32
			l_start_vcol: INTEGER_32
			l_temp: INTEGER_32
			l_old_len: INTEGER_32
			l_ptr: CE_POINTER [NATURAL_8]
			l_new_line: CE_POINTER [NATURAL_8]
			l_did_undo: INTEGER_32
			l_new_ts: INTEGER_32
			l_save_list: INTEGER_32
			l_first_line: INTEGER_32
			l_last_line: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_got_tab := 0
					l_num_spaces := 0
					l_start_col := 0
					l_start_vcol := 0
					l_new_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer + 1)
					l_first_line := (0).to_integer_32
					l_last_line := (0).to_integer_32
					l_save_list := (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := 0
					l_new_ts := ((create {P_CHARSET_STATIC}).getdigits (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (a_eap.c_pointer + (create {PD_EXARG}.make).offset_of ("arg")))).to_integer_32
					if l_new_ts < 0 then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_positive.item)))))).do_nothing
						l_return := True
					end
					if l_return then
						l_pos := -1 + 30 -- skip if block
					end
				when 1 then -- if:
						if l_new_ts = 0 then
							l_new_ts := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
						end
						l_lnum := a_eap.item.line1
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 29 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							if not (l_lnum <= a_eap.item.line2) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 28 -- skip if block
						end
				when 4 then -- if:
						l_ptr := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
						l_col := 0
						l_vcol := 0
						l_did_undo := 0
				when 5 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 27 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if (l_ptr[l_col]).to_integer_32 /= 32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 9 then -- else:
						if (l_ptr[l_col]).to_integer_32 /= 9 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___1:
						if not l_got_tab.to_boolean then
							if l_num_spaces = 0 then
								l_start_vcol := l_vcol
								l_start_col := l_col
							end
						end
						if (l_ptr[l_col]).to_integer_32 = 32 then
							l_num_spaces := l_num_spaces + 1
						else
							l_got_tab := 1
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 12 then -- else:
						if not (l_got_tab.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if not ((a_eap.item.forceit).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 16 then -- if:
						if not (l_num_spaces > 1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if: | _L___0:
						l_num_spaces := l_vcol - l_start_vcol
						l_len := l_num_spaces
						l_num_tabs := 0
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_et).to_boolean then
							l_temp := (l_new_ts.to_integer_32 - l_start_vcol \\ l_new_ts.to_integer_32).to_integer_32
							if l_num_spaces >= l_temp.to_integer_32 then
								l_num_spaces := l_num_spaces - l_temp.to_integer_32
								l_num_tabs := l_num_tabs + 1
							end
							l_num_tabs := l_num_tabs + (l_num_spaces // l_new_ts.to_integer_32)
							l_num_spaces := l_num_spaces - ((l_num_spaces // l_new_ts.to_integer_32) * l_new_ts.to_integer_32)
						end
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_et).to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 20 then -- else:
						if not (l_got_tab.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 24 -- goto _L
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 23 then -- else:
						if not (l_num_spaces + l_num_tabs < l_len) then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L:
						if l_did_undo = 0 then
							l_did_undo := 1
							if ((create {P_UNDO_STATIC}).u_save (l_lnum - 1, l_lnum + 1)) = 0 then
								l_new_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								l_break := True
							end
						end
						if not (l_return or l_break) then
							l_len := l_num_spaces + l_num_tabs
							l_old_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32
							l_new_line := (create {P_MISC2_STATIC}).lalloc (((((l_old_len - l_col) + l_start_col) + l_len) + 1).to_natural_32, 1)
							if l_new_line.is_void then
								l_break := True
							end
						end
						if not (l_return or l_break) then
							if l_start_col > 0 then
								memmove (create {CE_VOID_POINTER}.make_cast (l_new_line), create {CE_VOID_POINTER}.make_cast (l_ptr), l_start_col.to_natural_32).do_nothing
							end
							memmove (create {CE_VOID_POINTER}.make_cast (((l_new_line + l_start_col) + l_len)), create {CE_VOID_POINTER}.make_cast ((l_ptr + l_col)), ((l_old_len - l_col) + 1).to_natural_32).do_nothing
							l_ptr := l_new_line + l_start_col
							l_col := 0
							from
							until
								not (l_col < l_len)
							loop
								if l_col < l_num_tabs then
									l_ptr[l_col] := (('%T').code).to_natural_8
								else
									l_ptr[l_col] := ((' ').code).to_natural_8
								end
								l_col := l_col + 1
							end
							(create {P_MEMLINE_STATIC}).ml_replace (l_lnum, l_new_line, 0).do_nothing
							if l_first_line = 0 then
								l_first_line := l_lnum
							end
							l_last_line := l_lnum
							l_ptr := l_new_line
							l_col := l_start_col + l_len
						end
				when 25 then -- if done | if done | if done | if done | if done
						if not (l_return or l_break) then
							l_got_tab := 0
							l_num_spaces := 0
						end
				when 26 then -- if done
						if not (l_return or l_break) and then ((l_ptr[l_col]).to_integer_32 = 0) then
							l_break := True
						end
						if not (l_return or l_break) then
							l_vcol := l_vcol + ((create {P_CHARSET_STATIC}).chartabsize (l_ptr + l_col, l_vcol.to_integer_32)).to_integer_32
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_col := l_col + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_ptr + l_col])).to_integer_32
							else
								l_col := l_col + 1
							end
						end
						l_pos := -1 + 5 -- back to loop condition
				when 27 then -- loop done
						l_break := False
						if l_new_line.is_void then
							l_break := True
						end
				when 28 then -- if done
						if not (l_return or l_break) then
							(create {P_MISC1_STATIC}).line_breakcheck
							l_lnum := l_lnum + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 29 then -- loop done
						l_break := False
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item)))))).do_nothing
						end
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts /= l_new_ts.to_integer_32 then
							(create {P_SCREEN_STATIC}).redraw_curbuf_later (40)
						end
						if l_first_line /= 0 then
							(create {P_MISC1_STATIC}).changed_lines (l_first_line, 0, l_last_line + 1, 0)
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := l_save_list;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts := l_new_ts.to_integer_32;
						(create {P_MISC2_STATIC}).coladvance ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).do_nothing;
						(create {P_UNDO_STATIC}).u_clearline
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_shell (a_cmd: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_save_nwr: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if (check_restricted).to_boolean then
				(create {P_MESSAGE_STATIC}).msg_end.do_nothing
				l_return := True
			elseif (check_secure).to_boolean then
				(create {P_MESSAGE_STATIC}).msg_end.do_nothing
				l_return := True
			end
			if not l_return then
				(create {P_MESSAGE_STATIC}).msg_putchar (('%R').code)
				if not ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
					(create {P_TERM_STATIC}).stoptermcap
				end
				(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
				if ((create {P_OPTION_STATIC}).p_warn.item.item).to_boolean then
					if not ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
						if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
							l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
							from
							until
								not (not (l_break) and then (not l_buf___6.is_void))
							loop
								l_break := False
								if (l_buf___6.item.bufIsChanged).to_boolean then
									(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("[No write since last change]%N")))))
									l_break := True
								end
								if not (l_break) then
									l_buf___6 := l_buf___6.item.b_next
								end
							end
							l_break := False
						end
					end
				end
				if not ((create {P_TERM_STATIC}).swapping_screen).to_boolean then
					(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item)
				end
				(create {P_TERM_STATIC}).cursor_on;
				(create {P_MISC2_STATIC}).call_shell (a_cmd, (4).bit_or (a_flags___0)).do_nothing;
				(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 0;
				(create {P_GLOBALS_STATIC}).need_check_timestamps.item := 1
				if not ((create {P_TERM_STATIC}).swapping_screen).to_boolean then
					(create {P_GLOBALS_STATIC}).msg_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - 1).to_integer_32;
					(create {P_GLOBALS_STATIC}).msg_col.item := 0
				end
				if ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
					if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
						(create {P_SCREEN_STATIC}).redraw_later_clear
					end
				else
					if a_cmd.is_void then
						if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
							(create {P_SCREEN_STATIC}).redraw_later_clear
						end
						(create {P_GLOBALS_STATIC}).need_wait_return.item := 0
					else
						l_save_nwr := (create {P_GLOBALS_STATIC}).no_wait_return.item
						if ((create {P_TERM_STATIC}).swapping_screen).to_boolean then
							(create {P_GLOBALS_STATIC}).no_wait_return.item := 0
						end
						(create {P_MESSAGE_STATIC}).wait_return (((create {P_GLOBALS_STATIC}).msg_silent.item = 0).to_integer);
						(create {P_GLOBALS_STATIC}).no_wait_return.item := l_save_nwr
					end
					(create {P_TERM_STATIC}).starttermcap
				end
				(create {P_GUI_STATIC}).display_errors;
				(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_SHELLCMDPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			end
		end

	make_filter_cmd (a_cmd, a_itmp, a_otmp: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_tmp___1: NATURAL_32
			l_return: BOOLEAN
		do
			l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_cmd))).to_natural_32 + {NATURAL_32} 3
			if not a_itmp.is_void then
				l_len := l_len + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_itmp))).to_natural_32 + {NATURAL_32} 9)
			end
			if not a_otmp.is_void then
				l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_otmp))
				l_len := l_len + ((l_tmp___1.to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_srr.item.item))).to_natural_32) + {NATURAL_32} 2)
			end
			l_buf___6 := (create {P_MISC2_STATIC}).lalloc (l_len, 1)
			if l_buf___6.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if not a_itmp.is_void then
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), l_len.to_natural_32, ce_string ("(%%s)"), create {CE_INTEGER_8_POINTER}.make_cast (a_cmd)]).do_nothing
				elseif not a_otmp.is_void then
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), l_len.to_natural_32, ce_string ("(%%s)"), create {CE_INTEGER_8_POINTER}.make_cast (a_cmd)]).do_nothing
				else
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (a_cmd)).do_nothing
				end
				if not a_itmp.is_void then
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string (" < ")).do_nothing
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (a_itmp)).do_nothing
				end
				if not a_otmp.is_void then
					append_redir (l_buf___6, l_len.to_integer_32, (create {P_OPTION_STATIC}).p_srr.item.item, a_otmp)
				end
				Result := l_buf___6
			end
		end

	append_redir (a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: INTEGER_32; a_opt, a_fname: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			l_end := a_buf___6 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6))).to_integer_32
			l_p___0 := a_opt
			from
			until
				(l_break)
			loop
				l_break := False
				l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('%%').code)
				if l_p___0.is_void then
					l_break := True
				end
				if not (l_break) and then ((l_p___0[1]).to_integer_32 = 115) then
					l_break := True
				end
				if not (l_break) then
					l_p___0 := l_p___0 + 1
				end
			end
			l_break := False
			if not l_p___0.is_void then
				l_end.item := ((' ').code).to_natural_8;
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_end) + 1, (a_buflen - ((l_end + 1).distance (a_buf___6))).to_natural_32, create {CE_INTEGER_8_POINTER}.make_cast (a_opt), create {CE_INTEGER_8_POINTER}.make_cast (a_fname)]).do_nothing
			else
				if not a_opt.is_equal ((create {P_OPTION_STATIC}).p_sp.item.item) then
					l_tmp___0 := ce_string (" %%s%%s")
				else
					l_tmp___0 := ce_string (" %%s %%s")
				end
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_end), (a_buflen - (l_end.distance (a_buf___6))).to_natural_32, l_tmp___0, create {CE_INTEGER_8_POINTER}.make_cast (a_opt), create {CE_INTEGER_8_POINTER}.make_cast (a_fname)]).do_nothing
			end
		end

	no_viminfo: INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if not ((create {P_GLOBALS_STATIC}).use_viminfo.item).is_void then
				if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).use_viminfo.item), ce_string ("NONE"))) = 0 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	read_viminfo (a_file: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_fname: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if (no_viminfo).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_fname := viminfo_filename (a_file)
				if l_fname.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_fp := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), ce_string ("r"))
				if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
					(create {P_MESSAGE_STATIC}).verbose_enter
					if l_fp.is_void then
						l_tmp___1 := (gettext (ce_string (" FAILED")))
					else
						l_tmp___1 := ce_string ("")
					end
					if ((a_flags___0).bit_and (8)).to_boolean then
						l_tmp___3 := (gettext (ce_string (" oldfiles")))
					else
						l_tmp___3 := ce_string ("")
					end
					if ((a_flags___0).bit_and (2)).to_boolean then
						l_tmp___5 := (gettext (ce_string (" marks")))
					else
						l_tmp___5 := ce_string ("")
					end
					if ((a_flags___0).bit_and (1)).to_boolean then
						l_tmp___7 := (gettext (ce_string (" info")))
					else
						l_tmp___7 := ce_string ("")
					end
					(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Reading viminfo file %"%%s%"%%s%%s%%s")))), l_fname, l_tmp___7, l_tmp___5, l_tmp___3, l_tmp___1]).do_nothing;
					(create {P_MESSAGE_STATIC}).verbose_leave
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fname))
				if l_fp.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				viminfo_errcnt.item := 0
				do_viminfo (l_fp, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer), a_flags___0)
				fclose (l_fp).do_nothing
				Result := 1
			end
		end

	write_viminfo (a_file: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32)
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_fp_in: CE_POINTER [SD_IO_FILE]
			l_fp_out: CE_POINTER [SD_IO_FILE]
			l_tempname: CE_POINTER [NATURAL_8]
			l_st_new: CE_ARRAY [SD_STAT]
			l_wp___0: CE_POINTER [NATURAL_8]
			l_umask_save: NATURAL_32
			l_shortname: INTEGER_32
			l_st_old: CE_ARRAY [SD_STAT]
			l_tt: INTEGER_32
			l_tmp___6: NATURAL_32
			l_tmp___8: NATURAL_32
			l_fd: INTEGER_32
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___18: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_new.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st_old.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp_in := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
					l_fp_out := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
					l_tempname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_shortname := 0
					if (no_viminfo).to_boolean then
						l_return := True
					end
					if not l_return then
						l_fname := viminfo_filename (a_file)
						if l_fname.is_void then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_fp_in := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), ce_string ("r"))
						if not (l_fp_in.is_void) then
							l_pos := -1 + 5 -- skip if block
						end
				when 2 then -- if:
						if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st_new)) = 0 then
							l_pos := -1 + 9 -- goto end
						end
				when 3 then
						l_umask_save := umask ((63).to_natural_32)
						l_fp_out := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), ce_string ("w"))
						umask (l_umask_save).do_nothing
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						l_st_old.item.st_dev := (0).to_natural_64
						l_st_old.item.st_ino := (0).to_natural_32
						l_st_old.item.st_mode := (384).to_natural_32
						if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_fname), l_st_old)) = 0 then
							if (getuid) /= {NATURAL_32} 0 then
								if l_st_old.item.st_uid = (getuid) then
									l_tmp___8 := (l_st_old.item.st_mode).bit_and ({NATURAL_32} 128)
								else
									if l_st_old.item.st_gid = (getgid) then
										l_tmp___6 := (l_st_old.item.st_mode).bit_and ({NATURAL_32} 16)
									else
										l_tmp___6 := (l_st_old.item.st_mode).bit_and ({NATURAL_32} 2)
									end
									l_tmp___8 := l_tmp___6
								end
								if not l_tmp___8.to_boolean then
									l_tt := (create {P_GLOBALS_STATIC}).msg_didany.item;
									(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E137: Viminfo file is not writable: %%s")))), l_fname).do_nothing;
									(create {P_GLOBALS_STATIC}).msg_didany.item := l_tt
									fclose (l_fp_in).do_nothing
									l_pos := -1 + 9 -- goto end
								end
							end
						end
				when 6 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_continue := False
							l_tempname := (create {P_FILEIO_STATIC}).buf_modname (l_shortname, l_fname, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (".tmp")), 0)
							if l_tempname.is_void then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname), l_st_new)) = 0 then
									if not l_shortname.to_boolean then
										if l_st_new.item.st_dev = l_st_old.item.st_dev then
											if l_st_new.item.st_ino = l_st_old.item.st_ino then
												(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
												l_tempname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
												l_shortname := 1
												l_continue := True
											end
										end
									end
									if not (l_return or l_break or l_continue) then
										l_wp___0 := (l_tempname + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname))).to_integer_32) - 5
										if (l_wp___0.c_pointer.to_integer_32).to_natural_32 < (((create {P_MISC1_STATIC}).gettail (l_tempname)).c_pointer.to_integer_32).to_natural_32 then
											l_wp___0 := (create {P_MISC1_STATIC}).gettail (l_tempname)
										end
										l_wp___0.item := (('z').code).to_natural_8
										from
										until
											(l_break)
										loop
											l_break := False
											if (stat (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname), l_st_new)) /= 0 then
												l_break := True
											end
											if not (l_break) and then ((l_wp___0.item).to_integer_32 = 97) then
												(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
												l_tempname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
												l_break := True
											end
											if not (l_break) then
												l_wp___0.item := ((l_wp___0.item).to_integer_32 - 1).to_natural_8
											end
										end
										l_break := False
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								l_break := True
							end
							if (not l_return and not l_break) then
								
							end
						end
						l_break := False
						l_continue := False
						if not l_tempname.is_void then
							l_umask_save := umask ((0).to_natural_32)
							l_fd := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_tempname), 131_265, ((((l_st_old.item.st_mode).bit_and ({NATURAL_32} 511))).bit_or ({NATURAL_32} 384)).to_integer_32])
							umask (l_umask_save).do_nothing
							if l_fd < 0 then
								l_fp_out := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
							else
								l_fp_out := fdopen (l_fd, ce_string ("w"))
							end
							if l_fp_out.is_void then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
								l_tempname := (create {P_FILEIO_STATIC}).vim_tempname (('o').code)
								if not l_tempname.is_void then
									l_fp_out := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname), ce_string ("w"))
								end
							end
							if not l_fp_out.is_void then
								(create {P_GLOBALS_STATIC}).ignored.item := fchown ((fileno (l_fp_out)), l_st_old.item.st_uid, l_st_old.item.st_gid)
							end
						end
				when 7 then -- if done
						if l_fp_out.is_void then
							if l_fp_in.is_void then
								l_tmp___15 := l_fname
							elseif l_tempname.is_void then
								l_tmp___15 := l_fname
							else
								l_tmp___15 := l_tempname
							end
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E138: Can%'t write viminfo file %%s!")))), l_tmp___15).do_nothing
							if not l_fp_in.is_void then
								fclose (l_fp_in).do_nothing
							end
							l_pos := -1 + 9 -- goto end
						end
				when 8 then
						if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
							(create {P_MESSAGE_STATIC}).verbose_enter;
							(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Writing viminfo file %"%%s%"")))), l_fname]).do_nothing;
							(create {P_MESSAGE_STATIC}).verbose_leave
						end
						viminfo_errcnt.item := 0
						if a_forceit.to_boolean then
							l_tmp___18 := 0
						else
							l_tmp___18 := 3
						end
						do_viminfo (l_fp_in, l_fp_out, l_tmp___18)
						fclose (l_fp_out).do_nothing
						if not l_fp_in.is_void then
							fclose (l_fp_in).do_nothing
							if viminfo_errcnt.item.to_boolean then
								unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname)).do_nothing
							elseif ((create {P_FILEIO_STATIC}).vim_rename (l_tempname, l_fname)) = -1 then
								unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname)).do_nothing
							end
						end
				when 9 then -- end:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fname));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	viminfo_filename (a_file: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_file: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_file := a_file
					if not (l_file.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (l_file.item).to_integer_32 /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not ((create {P_GLOBALS_STATIC}).use_viminfo.item).is_void then
							l_file := (create {P_GLOBALS_STATIC}).use_viminfo.item
						else
							l_file := (create {P_OPTION_STATIC}).find_viminfo_parameter (('n').code)
							if l_file.is_void then
								l_file := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$HOME/.viminfo"))
							elseif (l_file.item).to_integer_32 = 0 then
								l_file := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("$HOME/.viminfo"))
							end
						end
						(create {P_MISC1_STATIC}).expand_env (l_file, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096)
						l_file := (create {P_GLOBALS_STATIC}).NameBuff.item.item
				when 5 then -- if done
					Result := ((create {P_MISC2_STATIC}).vim_strsave (l_file))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_viminfo (a_fp_in, a_fp_out: CE_POINTER [SD_IO_FILE]; a_flags___0: INTEGER_32)
		local
			l_count___2: INTEGER_32
			l_eof: INTEGER_32
			l_vir: CE_ARRAY [PD_VIR_T]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_VIR_T]} l_vir.make (<<1>>)

			l_count___2 := 0
			l_eof := 0
			l_vir.item.vir_line := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 512)
			if (l_vir.item.vir_line).is_void then
				l_return := True
			end
			if not l_return then
				l_vir.item.vir_fd := a_fp_in
				l_vir.item.vir_conv.vc_type := 0
				if not a_fp_in.is_void then
					if ((a_flags___0).bit_and (1)).to_boolean then
						l_eof := l_vir.item.read_viminfo_up_to_marks ((a_flags___0).bit_and (4), (not a_fp_out.is_void).to_integer)
					else
						from
						until
							(l_break)
						loop
							l_break := False
							l_eof := l_vir.item.viminfo_readline
							if l_eof.to_boolean then
								l_break := True
							elseif (l_vir.item.vir_line[0]).to_integer_32 = 62 then
								l_break := True
							end
						end
						l_break := False
					end
				end
				if not a_fp_out.is_void then
					fprintf ([a_fp_out, (gettext (ce_string ("# This viminfo file was generated by Vim %%s.%N"))), ce_string ("7.3")]).do_nothing
					fputs ((gettext (ce_string ("# You may edit it if you%'re careful!%N%N"))), a_fp_out).do_nothing
					fputs ((gettext (ce_string ("# Value of %'encoding%' when this file was written%N"))), a_fp_out).do_nothing
					fprintf ([a_fp_out, ce_string ("*encoding=%%s%N%N"), (create {P_OPTION_STATIC}).p_enc.item.item]).do_nothing;
					(create {P_SEARCH_STATIC}).write_viminfo_search_pattern (a_fp_out)
					write_viminfo_sub_string (a_fp_out);
					(create {P_EX_GETLN_STATIC}).write_viminfo_history (a_fp_out);
					(create {P_OPS_STATIC}).write_viminfo_registers (a_fp_out);
					(create {P_EVAL_STATIC}).write_viminfo_varlist (a_fp_out);
					(create {P_MARK_STATIC}).write_viminfo_filemarks (a_fp_out);
					(create {P_BUFFER_STATIC}).write_viminfo_bufferlist (a_fp_out)
					l_count___2 := (create {P_MARK_STATIC}).write_viminfo_marks (a_fp_out)
				end
				if not a_fp_in.is_void then
					if ((a_flags___0).bit_and (14)).to_boolean then
						l_vir.item.copy_viminfo_marks (a_fp_out, l_count___2, l_eof, a_flags___0)
					end
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_vir.item.vir_line))
				if l_vir.item.vir_conv.vc_type /= 0 then
					(create {CE_CLASS_POINTER [PD_VIMCONV_T]}.make_shared (l_vir.item.c_pointer + (create {PD_VIR_T}.make).offset_of ("vir_conv"))).item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
				end
			end
		end

	viminfo_writestring (a_fd: CE_POINTER [SD_IO_FILE]; a_p___0: CE_POINTER [NATURAL_8])
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
					l_len := 0
					l_s := l_p___0
					from
					until
						(l_s.item).to_integer_32 = 0
					loop
						if (l_s.item).to_integer_32 = 22 then
							l_len := l_len + 1
						elseif (l_s.item).to_integer_32 = 10 then
							l_len := l_len + 1
						end
						l_len := l_len + 1
						l_s := l_s + 1
					end
					if l_len > 256 then
						fprintf ([a_fd, ce_string ("%/22/%%d%N<"), l_len + 3]).do_nothing
					end
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_tmp := l_p___0
						l_p___0 := l_p___0 + 1
						l_c := (l_tmp.item).to_integer_32
						if l_c = 0 then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if l_c /= 22 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_c /= 10 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						IO_putc (22, a_fd).do_nothing
						if l_c = 10 then
							l_c := ('n').code
						end
				when 8 then -- if done
						IO_putc (l_c, a_fd).do_nothing
				when 9 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					l_break := False
					IO_putc (('%N').code, a_fd).do_nothing
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_fixdel (a_eap: CE_POINTER [PD_EXARG])
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_p___0 := (create {P_TERM_STATIC}).find_termcode (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kb")))
			if not l_p___0.is_void then
				if (l_p___0.item).to_integer_32 = 127 then
					l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%B"))
				else
					l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/127/"))
				end
			else
				l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%/127/"))
			end
			(create {P_TERM_STATIC}).add_termcode (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kD")), l_tmp, 0)
		end

	print_line_no_prefix (a_lnum: INTEGER_32; a_use_number, a_list: INTEGER_32)
		local
			l_numbuf: CE_ARRAY [NATURAL_8]
			l_tmp: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_numbuf.make (<<30>>)

			if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_nu).to_boolean then
				l_tmp := ((create {P_GLOBALS_STATIC}).curwin.item).item.number_width;
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_numbuf), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (30).to_natural_32), ce_string ("%%*ld "), l_tmp, a_lnum]).do_nothing;
				(create {P_MESSAGE_STATIC}).msg_puts_attr (l_numbuf, (create {P_GLOBALS_STATIC}).highlight_attr.item[9])
			elseif a_use_number.to_boolean then
				l_tmp := ((create {P_GLOBALS_STATIC}).curwin.item).item.number_width;
				(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_numbuf), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (30).to_natural_32), ce_string ("%%*ld "), l_tmp, a_lnum]).do_nothing;
				(create {P_MESSAGE_STATIC}).msg_puts_attr (l_numbuf, (create {P_GLOBALS_STATIC}).highlight_attr.item[9])
			end
			(create {P_MESSAGE_STATIC}).msg_prt_line (((create {P_MEMLINE_STATIC}).ml_get (a_lnum)), a_list)
		end

	print_line (a_lnum: INTEGER_32; a_use_number, a_list: INTEGER_32)
		local
			l_save_silent: INTEGER_32
		do
			l_save_silent := (create {P_GLOBALS_STATIC}).silent_mode.item;
			(create {P_MESSAGE_STATIC}).msg_start;
			(create {P_GLOBALS_STATIC}).silent_mode.item := 0;
			(create {P_GLOBALS_STATIC}).info_message.item := 1
			print_line_no_prefix (a_lnum, a_use_number, a_list)
			if l_save_silent.to_boolean then
				(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code);
				(create {P_TERM_STATIC}).cursor_on;
				(create {P_TERM_STATIC}).out_flush;
				(create {P_GLOBALS_STATIC}).silent_mode.item := l_save_silent
			end
			(create {P_GLOBALS_STATIC}).info_message.item := 0
		end

	ex_update (a_eap: CE_POINTER [PD_EXARG])
		do
			if ((create {P_UNDO_STATIC}).curbufIsChanged).to_boolean then
				do_write (a_eap).do_nothing
			end
		end

	do_write (a_eap: CE_POINTER [PD_EXARG]): INTEGER_32
		local
			l_other: INTEGER_32
			l_fname: CE_POINTER [NATURAL_8]
			l_ffname: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
			l_free_fname: CE_POINTER [NATURAL_8]
			l_browse_file: CE_POINTER [NATURAL_8]
			l_alt_buf: CE_POINTER [PD_FILE_BUFFER]
			l_was_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_retval := 0
					l_free_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_browse_file := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_alt_buf := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					if (not_writing).to_boolean then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 35 -- skip if block
					end
				when 1 then -- if:
						l_ffname := a_eap.item.arg
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.browse).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_browse_file := (create {P_MESSAGE_STATIC}).do_browse (1, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Save As")))), l_ffname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item)
						if l_browse_file.is_void then
							l_pos := -1 + 34 -- goto theend
						end
				when 3 then
						l_ffname := l_browse_file
				when 4 then -- if done
						if (l_ffname.item).to_integer_32 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:
						if a_eap.item.cmdidx = 354 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_argreq.item)))))).do_nothing
							l_pos := -1 + 34 -- goto theend
						end
				when 6 then
						l_other := 0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_fname := l_ffname
						l_free_fname := (create {P_BUFFER_STATIC}).fix_fname (l_ffname)
						if not l_free_fname.is_void then
							l_ffname := l_free_fname
						end
						l_other := (create {P_BUFFER_STATIC}).otherfile (l_ffname)
				when 9 then -- if done
						if l_other.to_boolean then
							if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('A').code)).is_void then
								l_alt_buf := (create {P_BUFFER_STATIC}).setaltfname (l_ffname, l_fname, (1).to_integer_32)
							elseif a_eap.item.cmdidx = 354 then
								l_alt_buf := (create {P_BUFFER_STATIC}).setaltfname (l_ffname, l_fname, (1).to_integer_32)
							else
								l_alt_buf := (create {P_BUFFER_STATIC}).buflist_findname (l_ffname)
							end
							if not l_alt_buf.is_void then
								if not (l_alt_buf.item.b_ml.ml_mfp).is_void then
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_bufloaded.item)))))).do_nothing
									l_pos := -1 + 34 -- goto theend
								end
							end
						end
				when 10 then
						if not l_other.to_boolean then
							if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_dontwrite_msg).to_boolean then
								l_pos := -1 + 34 -- goto theend
							elseif ((create {P_EX_CMDS2_STATIC}).check_fname) = 0 then
								l_pos := -1 + 34 -- goto theend
							elseif (check_readonly (create {CE_INTEGER_32_POINTER}.make_shared (a_eap.c_pointer + (create {PD_EXARG}.make).offset_of ("forceit")), (create {P_GLOBALS_STATIC}).curbuf.item)).to_boolean then
								l_pos := -1 + 34 -- goto theend
							end
						end
				when 11 then
						if l_other.to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 12 then -- if:
						l_ffname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname
						l_fname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname
						if a_eap.item.line1 = 1 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 15 then -- else:
						if a_eap.item.line2 = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_pos := -1 + 27 -- skip if block
						end
				when 16 then -- if: | _L___0:
						if (a_eap.item.forceit).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 17 then -- if:
						if (a_eap.item.append).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 18 then -- if:
						if ((create {P_OPTION_STATIC}).p_wa.item.item).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if not (((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 22 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 23 then -- if: | _L:
						if ((create {P_MESSAGE_STATIC}).vim_dialog_yesno (4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Write partial file?")))), 2)) /= 2 then
							l_pos := -1 + 34 -- goto theend
						end
				when 24 then
						a_eap.item.forceit := 1
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E140: Use ! to write partial buffer"))))).do_nothing
						l_pos := -1 + 34 -- goto theend
				when 27 then -- if done | if done | if done | if done | if done | if done | if done
						if (check_overwrite (a_eap, (create {P_GLOBALS_STATIC}).curbuf.item, l_fname, l_ffname, l_other)) /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 28 then -- if:
						if a_eap.item.cmdidx /= 354 then
							l_pos := -1 + 33 -- skip if block
						end
				when 29 then -- if:
						if l_alt_buf.is_void then
							l_pos := -1 + 33 -- skip if block
						end
				when 30 then -- if:
						l_was_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPRE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPRE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_alt_buf).do_nothing
						if not ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_was_curbuf) then
							l_retval := 0
							l_pos := -1 + 34 -- goto theend
						elseif ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							l_retval := 0
							l_pos := -1 + 34 -- goto theend
						end
				when 31 then
						l_fname := l_alt_buf.item.b_fname
						l_alt_buf.item.b_fname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname := l_fname
						l_fname := l_alt_buf.item.b_ffname
						l_alt_buf.item.b_ffname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname := l_fname
						l_fname := l_alt_buf.item.b_sfname
						l_alt_buf.item.b_sfname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_sfname;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_sfname := l_fname;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_name_changed;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFFILEPOST, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_alt_buf).do_nothing
						if not (l_alt_buf.item.b_p_bl).to_boolean then
							l_alt_buf.item.b_p_bl := 1;
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFADD, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, l_alt_buf).do_nothing
						end
						if not ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_was_curbuf) then
							l_retval := 0
							l_pos := -1 + 34 -- goto theend
						elseif ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							l_retval := 0
							l_pos := -1 + 34 -- goto theend
						end
				when 32 then
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ft).item).to_integer_32 = 0 then
							if ((create {P_FILEIO_STATIC}).au_has_group (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("filetypedetect")))).to_boolean then
								(create {P_FILEIO_STATIC}).do_doautocmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("filetypedetect BufRead")), 1).do_nothing
							end
							(create {P_BUFFER_STATIC}).do_modelines (0)
						end
				when 33 then -- if done | if done
						l_retval := (create {P_FILEIO_STATIC}).buf_write ((create {P_GLOBALS_STATIC}).curbuf.item, l_ffname, l_fname, a_eap.item.line1, a_eap.item.line2, a_eap, a_eap.item.append, a_eap.item.forceit, 1, 0)
						if a_eap.item.cmdidx = 354 then
							if l_retval = 1 then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro := 0;
								(create {P_GLOBALS_STATIC}).redraw_tabline.item := 1
							end
							if ((create {P_OPTION_STATIC}).p_acd.item.item).to_boolean then
								(create {P_BUFFER_STATIC}).do_autochdir
							end
						end
				when 34 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_browse_file));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_free_fname))
						Result := l_retval
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_overwrite (a_eap: CE_POINTER [PD_EXARG]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_fname, a_ffname: CE_POINTER [NATURAL_8]; a_other: INTEGER_32): INTEGER_32
		local
			l_buff: CE_ARRAY [NATURAL_8]
			l_dir___0: CE_ARRAY [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_r: INTEGER_32
			l_swapname: CE_POINTER [NATURAL_8]
			l_buff___0: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buff.make (<<1_025>>)
			create {CE_NATURAL_8_ARRAY} l_dir___0.make (<<4_096>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buff___0.make (<<1_025>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_other.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 3 then -- else:
						if not (((a_buf___6.item.b_flags).bit_and (8)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 6 then -- else:
						if not (((a_buf___6.item.b_flags).bit_and (16)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('O').code)).is_void then
							l_pos := -1 + 10 -- goto _L___1
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 9 then -- else: | _L___2:
						if not (((a_buf___6.item.b_flags).bit_and (64)).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 10 then -- if: | _L___1:
						if ((create {P_OPTION_STATIC}).p_wa.item.item).to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 11 then -- if:
						if (a_buf___6.item.bt_nofile).to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 12 then -- if:
						if not (((create {P_MISC1_STATIC}).vim_fexists (a_ffname)).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 13 then -- if:
						if (a_eap.item.forceit).to_boolean then
							l_pos := -1 + 23 -- skip if block
						end
				when 14 then -- if:
						if (a_eap.item.append).to_boolean then
							l_pos := -1 + 23 -- skip if block
						end
				when 15 then -- if:
						if ((create {P_OS_UNIX_STATIC}).mch_isdir (a_ffname)).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_isadir2.item))))), a_ffname).do_nothing
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 23 -- skip if block
						end
				when 16 then -- if:
						if not (((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L:;
						(create {P_EX_DOCMD_STATIC}).dialog_msg (l_buff, (gettext (ce_string ("Overwrite existing file %"%%s%"?"))), a_fname)
						if ((create {P_MESSAGE_STATIC}).vim_dialog_yesno (4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_buff, 2)) /= 2 then
							Result := 0
							l_return := True
						end
						if not l_return then
							a_eap.item.forceit := 1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:;
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_exists.item)))))).do_nothing
						Result := 0
						l_return := True
				when 23 then -- if done | if done | if done | if done
						if not (not l_return and then (a_other.to_boolean)) then
							l_pos := -1 + 34 -- skip if block
						end
				when 24 then -- if:
						if ((create {P_GLOBALS_STATIC}).emsg_silent.item).to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 25 then -- if:
						if ((create {P_OPTION_STATIC}).p_dir.item.item.item).to_integer_32 = 0 then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_dir___0), ce_string (".")).do_nothing
						else
							l_p___0.item := (create {P_OPTION_STATIC}).p_dir.item.item;
							(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_dir___0, 4_096, ce_string (",")).do_nothing
						end
						l_swapname := (create {P_MEMLINE_STATIC}).makeswapname (a_fname, a_ffname, (create {P_GLOBALS_STATIC}).curbuf.item, l_dir___0)
						l_r := (create {P_MISC1_STATIC}).vim_fexists (l_swapname)
						if not (l_r.to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 26 then -- if:
						if not (((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_pos := -1 + 30 -- goto _L___0
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 29 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if: | _L___0:;
						(create {P_EX_DOCMD_STATIC}).dialog_msg (l_buff___0, (gettext (ce_string ("Swap file %"%%s%" exists, overwrite anyway?"))), l_swapname)
						if ((create {P_MESSAGE_STATIC}).vim_dialog_yesno (4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_buff___0, 2)) /= 2 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_swapname))
							Result := 0
							l_return := True
						end
						if not l_return then
							a_eap.item.forceit := 1
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:;
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E768: Swap file exists: %%s (:silent! overrides)")))), l_swapname).do_nothing;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_swapname))
						Result := 0
						l_return := True
				when 33 then -- if done | if done
						if not l_return then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_swapname))
						end
				when 34 then -- if done | if done | if done | if done | if done | if done | if done | if done
					if not l_return then
						Result := 1
					end
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	not_writing: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E142: File not written: Writing is disabled by %'write%' option"))))).do_nothing
				Result := 1
			end
		end

	check_readonly (a_forceit: CE_POINTER [INTEGER_32]; a_buf___6: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		require
			not a_forceit.is_void
		local
			l_st: CE_ARRAY [SD_STAT]
			l_buff: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buff.make (<<1_025>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_forceit.item).to_boolean then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if not ((a_buf___6.item.b_p_ro).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 4 then -- else:
						if not ((stat (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6.item.b_ffname), l_st)) >= 0) then
							l_pos := -1 + 14 -- skip if block
						end
				when 5 then -- if:
						if not (((create {P_FILEIO_STATIC}).check_file_readonly (a_buf___6.item.b_ffname, 511)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if not (((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.confirm).to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___0:
						if not (a_buf___6.item.b_fname).is_void then
							if (a_buf___6.item.b_p_ro).to_boolean then
								(create {P_EX_DOCMD_STATIC}).dialog_msg (l_buff, (gettext (ce_string ("%'readonly%' option is set for %"%%s%".%NDo you wish to write anyway?"))), a_buf___6.item.b_fname)
							else
								(create {P_EX_DOCMD_STATIC}).dialog_msg (l_buff, (gettext (ce_string ("File permissions of %"%%s%" are read-only.%NIt may still be possible to write it.%NDo you wish to try?"))), a_buf___6.item.b_fname)
							end
							if ((create {P_MESSAGE_STATIC}).vim_dialog_yesno (4, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_buff, 2)) = 2 then
								a_forceit.item := 1
								Result := 0
								l_return := True
							else
								Result := 1
								l_return := True
							end
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if (a_buf___6.item.b_p_ro).to_boolean then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_readonly.item)))))).do_nothing
						else
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E505: %"%%s%" is read-only (add ! to override)")))), a_buf___6.item.b_fname).do_nothing
						end
				when 13 then -- if done
						if not l_return then
							Result := 1
							l_return := True
						end
				when 14 then -- if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getfile (a_fnum___0: INTEGER_32; a_ffname, a_sfname: CE_POINTER [NATURAL_8]; a_setpm: INTEGER_32; a_lnum: INTEGER_32; a_forceit: INTEGER_32): INTEGER_32
		local
			l_sfname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ffname: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_other: INTEGER_32
			l_retval: INTEGER_32
			l_free_me: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_sfname.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ffname.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sfname.item := a_sfname
					l_ffname.item := a_ffname
					l_free_me := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if ((create {P_EX_GETLN_STATIC}).text_locked).to_boolean then
						Result := 1
						l_return := True
					end
					if not l_return then
						if ((create {P_EX_GETLN_STATIC}).curbuf_locked).to_boolean then
							Result := 1
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if a_fnum___0 = 0 then
							(create {P_BUFFER_STATIC}).fname_expand ((create {P_GLOBALS_STATIC}).curbuf.item, l_ffname, l_sfname)
							l_other := (create {P_BUFFER_STATIC}).otherfile (l_ffname.item)
							l_free_me := l_ffname.item
						else
							l_other := (a_fnum___0 /= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum).to_integer
						end
						if l_other.to_boolean then
							(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1
						end
						if l_other.to_boolean then
							if not a_forceit.to_boolean then
								if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows = 1 then
									if not (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_hide).to_boolean then
										if ((create {P_UNDO_STATIC}).curbufIsChanged).to_boolean then
											if ((create {P_EX_CMDS2_STATIC}).autowrite ((create {P_GLOBALS_STATIC}).curbuf.item, a_forceit)) = 0 then
												if ((create {P_OPTION_STATIC}).p_confirm.item.item).to_boolean then
													if ((create {P_OPTION_STATIC}).p_write.item.item).to_boolean then
														((create {P_GLOBALS_STATIC}).curbuf.item).item.dialog_changed (0)
													end
												end
												if ((create {P_UNDO_STATIC}).curbufIsChanged).to_boolean then
													if l_other.to_boolean then
														(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
													end
													(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nowrtmsg.item)))))).do_nothing
													l_retval := 2
													l_pos := -1 + 3 -- goto theend
												end
											end
										end
									end
								end
							end
						end
				when 2 then
						if l_other.to_boolean then
							(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1
						end
						if a_setpm.to_boolean then
							(create {P_MARK_STATIC}).setpcmark
						end
						if not l_other.to_boolean then
							if a_lnum /= 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := a_lnum
							end
							(create {P_MISC2_STATIC}).check_cursor_lnum;
							(create {P_EDIT_STATIC}).beginline (6)
							l_retval := 0
						else
							if (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_hide).to_boolean then
								l_tmp___7 := 1
							else
								l_tmp___7 := 0
							end
							if a_forceit.to_boolean then
								l_tmp___9 := 8
							else
								l_tmp___9 := 0
							end
							if (do_ecmd (a_fnum___0, l_ffname.item, l_sfname.item, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), a_lnum, l_tmp___7 + l_tmp___9, (create {P_GLOBALS_STATIC}).curwin.item)) = 1 then
								l_retval := -1
							else
								l_retval := 1
							end
						end
				when 3 then -- theend:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_free_me))
						Result := l_retval
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_ecmd (a_fnum___0: INTEGER_32; a_ffname, a_sfname: CE_POINTER [NATURAL_8]; a_eap: CE_POINTER [PD_EXARG]; a_newlnum: INTEGER_32; a_flags___0: INTEGER_32; a_oldwin: CE_POINTER [PD_WINDOW_S]): INTEGER_32
		local
			l_ffname: CE_POINTER [NATURAL_8]
			l_sfname: CE_POINTER [NATURAL_8]
			l_newlnum: INTEGER_32
			l_other_file: INTEGER_32
			l_oldbuf: INTEGER_32
			l_auto_buf: INTEGER_32
			l_new_name: CE_POINTER [NATURAL_8]
			l_did_set_swapcommand: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_free_fname: CE_POINTER [NATURAL_8]
			l_browse_file: CE_POINTER [NATURAL_8]
			l_retval: CE_ARRAY [INTEGER_32]
			l_n: INTEGER_32
			l_lnum: INTEGER_32
			l_topline: INTEGER_32
			l_newcol: INTEGER_32
			l_solcol: INTEGER_32
			l_pos___3: CE_POINTER [PD_POS_T]
			l_command: CE_POINTER [NATURAL_8]
			l_did_get_winopts: INTEGER_32
			l_readfile_flags: INTEGER_32
			l_tmp___2: INTEGER_32
			l_len: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tlnum: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___11: INTEGER_32
			l_p___1: CE_POINTER [NATURAL_8]
			l_win: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_msg_scroll_save: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_retval.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ffname := a_ffname
					l_sfname := a_sfname
					l_newlnum := a_newlnum
					l_auto_buf := 0
					l_new_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_did_set_swapcommand := 0
					l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
					l_free_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_browse_file := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_retval.item := 0
					l_topline := (0).to_integer_32
					l_newcol := -1
					l_solcol := -1
					l_command := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_did_get_winopts := 0
					l_readfile_flags := 0
					if not a_eap.is_void then
						l_command := a_eap.item.do_ecmd_cmd
					end
					if a_fnum___0 = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_fnum___0 = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
							Result := 1
							l_return := True
						end
						if not l_return then
							l_other_file := 1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).cmdmod.item.item.browse).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if ((create {P_FILEIO_STATIC}).au_has_group (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("FileExplorer")))).to_boolean then
							if l_ffname.is_void then
								l_ffname := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("."))
							elseif not ((create {P_OS_UNIX_STATIC}).mch_isdir (l_ffname)).to_boolean then
								l_ffname := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("."))
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else: | _L:
						l_browse_file := (create {P_MESSAGE_STATIC}).do_browse (0, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Edit File")))), l_ffname, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), (create {P_GLOBALS_STATIC}).curbuf.item)
						if l_browse_file.is_void then
							l_pos := -1 + 85 -- goto theend
						end
				when 8 then
						l_ffname := l_browse_file
				when 9 then -- if done
						if l_sfname.is_void then
							l_sfname := l_ffname
						end
						if ((a_flags___0).bit_and (16)).to_boolean then
							if l_ffname.is_void then
								l_pos := -1 + 85 -- goto theend
							elseif (l_ffname.item).to_integer_32 = 0 then
								l_pos := -1 + 85 -- goto theend
							end
						end
				when 10 then
						if not (l_ffname.is_void) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_other_file := 1
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 13 then -- else:
						if (l_ffname.item).to_integer_32 /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
							l_other_file := 0
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						if (l_ffname.item).to_integer_32 = 0 then
							l_ffname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname
							l_sfname := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname
						end
						l_free_fname := (create {P_BUFFER_STATIC}).fix_fname (l_ffname)
						if not l_free_fname.is_void then
							l_ffname := l_free_fname
						end
						l_other_file := (create {P_BUFFER_STATIC}).otherfile (l_ffname)
				when 17 then -- if done | if done
					if l_return then
						l_pos := -1 + 86 -- skip if block
					end
				when 18 then -- if:
						if l_other_file.to_boolean then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not ((a_flags___0).bit_and (4)).to_boolean then
							l_pos := -1 + 23 -- goto _L___1
						else
							l_pos := -1 + 21 -- goto _L___2
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 21 then -- else: | _L___2:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows /= 1 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if ((a_flags___0).bit_and (17)).to_boolean then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L___1:
						if ((create {P_EX_CMDS2_STATIC}).check_changed ((create {P_GLOBALS_STATIC}).curbuf.item, (create {P_OPTION_STATIC}).p_awa.item.item, (not l_other_file.to_boolean).to_integer, (a_flags___0).bit_and (8), 0)).to_boolean then
							if a_fnum___0 = 0 then
								if l_other_file.to_boolean then
									if not l_ffname.is_void then
										if l_newlnum < 0 then
											l_tmp___2 := (0).to_integer_32
										else
											l_tmp___2 := l_newlnum
										end
										(create {P_BUFFER_STATIC}).setaltfname (l_ffname, l_sfname, l_tmp___2).do_nothing
									end
								end
							end
							l_pos := -1 + 85 -- goto theend
						end
				when 24 then -- if done | if done;
						(create {P_NORMAL_STATIC}).reset_VIsual
						if l_command.is_void then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___3
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if not (l_newlnum > 0) then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L___3:
						if (((create {P_EVAL_STATIC}).get_vim_var_str (47)).item).to_integer_32 = 0 then
							if not l_command.is_void then
								l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_command))).to_integer_32 + 3
							else
								l_len := 30
							end
							l_p___0 := (create {P_MISC2_STATIC}).alloc (l_len.to_natural_32)
							if not l_p___0.is_void then
								if not l_command.is_void then
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_len.to_natural_32, ce_string (":%%s%R"), l_command]).do_nothing
								else
									(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_len.to_natural_32, ce_string ("%%ldG"), l_newlnum]).do_nothing
								end
								(create {P_EVAL_STATIC}).set_vim_var_string (47, l_p___0, -1)
								l_did_set_swapcommand := 1;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
							end
						end
				when 29 then -- if done
						if not (l_other_file.to_boolean) then
							l_pos := -1 + 59 -- skip if block
						end
				when 30 then -- if:
						if not ((a_flags___0).bit_and (16)).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).cmdmod.item.item.keepalt).to_boolean then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_alt_fnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum
							end
							if not a_oldwin.is_void then
								a_oldwin.item.buflist_altfpos
							end
						end
						if not (a_fnum___0.to_boolean) then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_buf___6 := (create {P_BUFFER_STATIC}).buflist_findnr (a_fnum___0)
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 33 then -- else:
						if ((a_flags___0).bit_and (16)).to_boolean then
							l_tlnum := 1
							if not l_command.is_void then
								l_tlnum := atol (create {CE_INTEGER_8_POINTER}.make_cast (l_command))
								if l_tlnum <= 0 then
									l_tlnum := 1
								end
							end
							(create {P_BUFFER_STATIC}).buflist_new (l_ffname, l_sfname, l_tlnum, 2).do_nothing
							l_pos := -1 + 85 -- goto theend
						end
				when 34 then
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_tmp___6 := 0
						else
							l_tmp___6 := 2
						end
						l_buf___6 := (create {P_BUFFER_STATIC}).buflist_new (l_ffname, l_sfname, 0, (1).bit_or (l_tmp___6))
				when 35 then -- if done
						if l_buf___6.is_void then
							l_pos := -1 + 85 -- goto theend
						end
				when 36 then
						if not ((l_buf___6.item.b_ml.ml_mfp).is_void) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_oldbuf := 0
						l_buf___6.item.b_nwindows := 0
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 39 then -- else:
						l_oldbuf := 1
						l_buf___6.item.buf_check_timestamp (0).do_nothing
						if ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_old_curbuf) then
								l_pos := -1 + 85 -- goto theend
							end
						else
							l_pos := -1 + 85 -- goto theend
						end
				when 40 then
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							l_pos := -1 + 85 -- goto theend
						end
				when 41 then
						if not (l_oldbuf.to_boolean) then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if l_newlnum = 0 then
							l_pos___3 := l_buf___6.item.buflist_findfpos
							l_newlnum := l_pos___3.item.lnum
							l_solcol := l_pos___3.item.col
						else
							l_pos := -1 + 44 -- goto _L___4
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___4:
						if l_newlnum = -1 then
							l_pos___3 := l_buf___6.item.buflist_findfpos
							l_newlnum := l_pos___3.item.lnum
							l_solcol := l_pos___3.item.col
						end
				when 45 then
						if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_pos := -1 + 56 -- skip if block
						end
				when 46 then -- if:
						if not (l_buf___6.item.b_fname).is_void then
							l_new_name := (create {P_MISC2_STATIC}).vim_strsave (l_buf___6.item.b_fname)
						end
						(create {P_GLOBALS_STATIC}).au_new_curbuf.item := l_buf___6;
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFLEAVE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
							delbuf_msg (l_new_name)
							l_pos := -1 + 85 -- goto theend
						end
				when 47 then
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_name))
							l_pos := -1 + 85 -- goto theend
						end
				when 48 then
						if not (l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item)) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_auto_buf := 1
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 54
				when 51 then -- else:
						if ((create {P_GLOBALS_STATIC}).curbuf.item).is_equal (l_old_curbuf) then
							(create {P_OPTION_STATIC}).buf_copy_options (l_buf___6, 1)
						end
						(create {P_UNDO_STATIC}).u_sync (0)
						if ((a_flags___0).bit_and (1)).to_boolean then
							l_tmp___11 := 0
						else
							l_tmp___11 := 2
						end
						(create {P_BUFFER_STATIC}).close_buffer (a_oldwin, (create {P_GLOBALS_STATIC}).curbuf.item, l_tmp___11)
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_name))
							l_pos := -1 + 85 -- goto theend
						end
				when 52 then
						if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
							delbuf_msg (l_new_name)
							l_pos := -1 + 85 -- goto theend
						end
				when 53 then
						if l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_auto_buf := 1
						else
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).is_equal (create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer).c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s"))) then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_s := create {CE_CLASS_POINTER [PD_SYNBLOCK_T]}.make_shared (l_buf___6.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_s"))
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer := l_buf___6;
							(create {P_GLOBALS_STATIC}).curbuf.item := l_buf___6;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows) + 1
							if ((create {P_OPTION_STATIC}).p_ffs.item.item.item).to_boolean then
								if not l_oldbuf.to_boolean then
									(create {P_MISC2_STATIC}).set_fileformat (((create {P_MISC2_STATIC}).default_fileformat), 4)
								end
							end
						end
						((create {P_GLOBALS_STATIC}).curbuf.item).item.get_winopts
						l_did_get_winopts := 1
				when 54 then -- if done;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_name));
						(create {P_GLOBALS_STATIC}).au_new_curbuf.item := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 56 then -- else:;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_nwindows) + 1
				when 57 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark.lnum := (1).to_integer_32;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_pcmark.col := 0
				when 58 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 59 then -- else:
						if ((a_flags___0).bit_and (16)).to_boolean then
							l_pos := -1 + 85 -- goto theend
						elseif ((create {P_EX_CMDS2_STATIC}).check_fname) = 0 then
							l_pos := -1 + 85 -- goto theend
						end
				when 60 then
						l_oldbuf := (a_flags___0).bit_and (4)
				when 61 then -- if done
						if not (((a_flags___0).bit_and (2)).to_boolean) then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 65 -- goto _L___5
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 68
				when 64 then -- else:
						if not (((create {P_GLOBALS_STATIC}).keep_help_flag.item).to_boolean) then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if: | _L___5:;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_help := 1;
						(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("buftype")), -1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("help")), 5, 0)
						l_p___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("!-~,^*,^|,^%",192-255"))
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_isk), create {CE_INTEGER_8_POINTER}.make_cast (l_p___1))) /= 0 then
							(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("isk")), -1, l_p___1, 5, 0);
							(create {P_OPTION_STATIC}).check_buf_options ((create {P_GLOBALS_STATIC}).curbuf.item);
							((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_init_chartab (0).do_nothing
						end
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts := 8;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := 0;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ma := 0;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_bin := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_nu := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_rnu := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fen := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_spell := 0
						l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item;
						(create {P_BUFFER_STATIC}).set_buflisted (0)
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 68
				when 67 then -- else:
						l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean then
							(create {P_BUFFER_STATIC}).set_buflisted (1)
						end
				when 68 then -- if done
						if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_pos := -1 + 85 -- goto theend
						end
				when 69 then
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							l_pos := -1 + 85 -- goto theend
						end
				when 70 then;
						(create {P_GLOBALS_STATIC}).did_filetype.item := 0
						if l_other_file.to_boolean then
							l_pos := -1 + 84 -- skip if block
						end
				when 71 then -- if:
						if l_oldbuf.to_boolean then
							l_pos := -1 + 84 -- skip if block
						end
				when 72 then -- if:;
						((create {P_GLOBALS_STATIC}).curwin.item).item.set_last_cursor
						if l_newlnum = -1 then
							l_newlnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							l_solcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						elseif l_newlnum = 0 then
							l_newlnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							l_solcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						end
						l_buf___6 := (create {P_GLOBALS_STATIC}).curbuf.item
						if not (l_buf___6.item.b_fname).is_void then
							l_new_name := (create {P_MISC2_STATIC}).vim_strsave (l_buf___6.item.b_fname)
						else
							l_new_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						if not ((create {P_OPTION_STATIC}).p_ur.item.item < 0) then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						l_pos := -1 + 76 -- goto _L___6
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 75 then -- else:
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count <= (create {P_OPTION_STATIC}).p_ur.item.item) then
							l_pos := -1 + 79 -- skip if block
						end
				when 76 then -- if: | _L___6:;
						(create {P_UNDO_STATIC}).u_sync (0)
						if ((create {P_UNDO_STATIC}).u_savecommon ((0).to_integer_32, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count + 1, (0).to_integer_32, 1)) = 0 then
							l_pos := -1 + 85 -- goto theend
						end
				when 77 then;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.u_unchanged;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_freeall (4)
						l_readfile_flags := 32
				when 78 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 79 then -- else:;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_freeall (0)
				when 80 then -- if done
						if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
							delbuf_msg (l_new_name)
							l_pos := -1 + 85 -- goto theend
						end
				when 81 then;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_new_name))
						if not l_buf___6.is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
							l_pos := -1 + 85 -- goto theend
						end
				when 82 then
						if ((create {P_EX_EVAL_STATIC}).aborting).to_boolean then
							l_pos := -1 + 85 -- goto theend
						end
				when 83 then;
						((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_clear_file;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_start.lnum := (0).to_integer_32;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_op_end.lnum := (0).to_integer_32
				when 84 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item + 1
						l_retval.item := 1;
						(create {P_MISC2_STATIC}).check_cursor;
						((create {P_GLOBALS_STATIC}).curwin.item).item.check_arg_idx;
						((create {P_GLOBALS_STATIC}).curwin.item).item.reset_synblock
						if not l_auto_buf.to_boolean then
							(create {P_WINDOW_STATIC}).curwin_init
							l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
							from
							until
								not (not (l_return) and then (not l_tp.is_void))
							loop
								if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
									l_win := (create {P_GLOBALS_STATIC}).firstwin.item
								else
									l_win := l_tp.item.tp_firstwin
								end
								from
								until
									l_win.is_void
								loop
									if (l_win.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
										l_win.item.foldUpdateAll
									end
									l_win := l_win.item.w_next
								end
								l_tp := l_tp.item.tp_next
							end
							if ((create {P_OPTION_STATIC}).p_acd.item.item).to_boolean then
								(create {P_BUFFER_STATIC}).do_autochdir
							end
							l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							l_topline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
							if not l_oldbuf.to_boolean then
								(create {P_GLOBALS_STATIC}).swap_exists_action.item := 1;
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_flags).bit_or ((2))
								if ((create {P_EX_EVAL_STATIC}).should_abort (((create {P_BUFFER_STATIC}).open_buffer (0, a_eap, l_readfile_flags)))).to_boolean then
									l_retval.item := 0
								end
								if (create {P_GLOBALS_STATIC}).swap_exists_action.item = 2 then
									l_retval.item := 0
								end
								(create {P_BUFFER_STATIC}).handle_swap_exists (l_old_curbuf)
							else
								(create {P_BUFFER_STATIC}).do_modelines (16);
								(create {P_FILEIO_STATIC}).apply_autocmds_retval ({PC_AUTO_EVENT}.EVENT_BUFENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item, l_retval).do_nothing;
								(create {P_FILEIO_STATIC}).apply_autocmds_retval ({PC_AUTO_EVENT}.EVENT_BUFWINENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item, l_retval).do_nothing
							end
							((create {P_GLOBALS_STATIC}).curwin.item).item.check_arg_idx
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= l_lnum then
								l_newlnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
								l_newcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
							end
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = l_topline then
								l_topline := (0).to_integer_32
							end
							(create {P_MOVE_STATIC}).changed_line_abv_curs;
							(create {P_BUFFER_STATIC}).maketitle
						end
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff).to_boolean then
							(create {P_DIFF_STATIC}).diff_buf_add ((create {P_GLOBALS_STATIC}).curbuf.item);
							(create {P_DIFF_STATIC}).diff_invalidate ((create {P_GLOBALS_STATIC}).curbuf.item)
						end
						if l_did_get_winopts.to_boolean then
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_spell).to_boolean then
								if ((((create {P_GLOBALS_STATIC}).curwin.item.item.w_s).item.b_p_spl).item).to_integer_32 /= 0 then
									(create {P_SPELL_STATIC}).did_set_spelllang ((create {P_GLOBALS_STATIC}).curwin.item).do_nothing
								end
							end
						end
						if l_command.is_void then
							if l_newcol >= 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_newlnum;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_newcol;
								(create {P_MISC2_STATIC}).check_cursor
							elseif l_newlnum > 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_newlnum;
								(create {P_MISC2_STATIC}).check_cursor_lnum
								if l_solcol >= 0 then
									if not ((create {P_OPTION_STATIC}).p_sol.item.item).to_boolean then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_solcol;
										(create {P_MISC2_STATIC}).check_cursor_col;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
									else
										(create {P_EDIT_STATIC}).beginline (6)
									end
								else
									(create {P_EDIT_STATIC}).beginline (6)
								end
							else
								if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
								end
								(create {P_EDIT_STATIC}).beginline (5)
							end
						end
						(create {P_WINDOW_STATIC}).check_lnums (0)
						if l_oldbuf.to_boolean then
							if not l_auto_buf.to_boolean then
								l_msg_scroll_save := (create {P_GLOBALS_STATIC}).msg_scroll.item
								if ((create {P_OPTION_STATIC}).shortmess (('O').code)).to_boolean then
									if not ((create {P_GLOBALS_STATIC}).exiting.item).to_boolean then
										if (create {P_OPTION_STATIC}).p_verbose.item.item = 0 then
											(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
										end
									end
								end
								if not ((create {P_GLOBALS_STATIC}).msg_scroll.item).to_boolean then
									(create {P_SCREEN_STATIC}).check_for_delay (0)
								end
								(create {P_MESSAGE_STATIC}).msg_start;
								(create {P_GLOBALS_STATIC}).msg_scroll.item := l_msg_scroll_save;
								(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 1;
								(create {P_BUFFER_STATIC}).fileinfo (0, 1, 0);
								(create {P_GLOBALS_STATIC}).msg_scrolled_ign.item := 0
							end
						end
						if not l_command.is_void then
							(create {P_EX_DOCMD_STATIC}).do_cmdline (l_command, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 1).do_nothing
						end
						(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item - 1
						if not ((create {P_GLOBALS_STATIC}).skip_redraw.item).to_boolean then
							l_n := (create {P_OPTION_STATIC}).p_so.item.item
							if l_topline = 0 then
								if l_command.is_void then
									(create {P_OPTION_STATIC}).p_so.item.item := 999
								end
							end
							(create {P_MOVE_STATIC}).update_topline;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_scbind_pos := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline;
							(create {P_OPTION_STATIC}).p_so.item.item := l_n;
							(create {P_SCREEN_STATIC}).redraw_curbuf_later (40)
						end
						if ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
							(create {P_GLOBALS_STATIC}).need_start_insertmode.item := 1
						end
						if ((create {P_OPTION_STATIC}).p_acd.item.item).to_boolean then
							(create {P_BUFFER_STATIC}).do_autochdir
						end
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
							if ((a_flags___0).bit_and (2)) /= 2 then
								(create {P_NETBEANS_STATIC}).netbeans_file_opened ((create {P_GLOBALS_STATIC}).curbuf.item)
							end
						end
				when 85 then -- theend:
						if l_did_set_swapcommand.to_boolean then
							(create {P_EVAL_STATIC}).set_vim_var_string (47, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1)
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_browse_file));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_free_fname))
						Result := (l_retval.item)
				when 86 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	delbuf_msg (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			if a_name___1.is_void then
				l_tmp := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
			else
				l_tmp := a_name___1
			end
			(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E143: Autocommands unexpectedly deleted new buffer %%s")))), l_tmp).do_nothing;
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_name___1));
			(create {P_GLOBALS_STATIC}).au_new_curbuf.item := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
		end

	check_restricted: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).restricted.item).to_boolean then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E145: Shell commands not allowed in rvim"))))).do_nothing
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	check_secure: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).secure.item).to_boolean then
				(create {P_GLOBALS_STATIC}).secure.item := 2;
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_curdir.item)))))).do_nothing
				Result := 1
				l_return := True
			end
			if not l_return and then ((create {P_GLOBALS_STATIC}).sandbox.item /= 0) then
				(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_sandbox.item)))))).do_nothing
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	do_sub_msg (a_count_only: INTEGER_32): INTEGER_32
		local
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_GLOBALS_STATIC}).sub_nsubs.item > (create {P_OPTION_STATIC}).p_report.item.item) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
							l_pos := -1 + 4 -- goto _L
						elseif (create {P_GLOBALS_STATIC}).sub_nlines.item > 1 then
							l_pos := -1 + 4 -- goto _L
						elseif (create {P_OPTION_STATIC}).p_report.item.item < 1 then
							l_pos := -1 + 4 -- goto _L
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else: | _L___0:
						if not (a_count_only.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if ((create {P_SCREEN_STATIC}).messaging).to_boolean then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), (gettext (ce_string ("(Interrupted) ")))).do_nothing
							else
								(create {P_GLOBALS_STATIC}).msg_buf.item[0] := (('%/0/').code).to_natural_8
							end
							if (create {P_GLOBALS_STATIC}).sub_nsubs.item = 1 then
								if a_count_only.to_boolean then
									l_tmp___2 := (gettext (ce_string ("1 match")))
								else
									l_tmp___2 := (gettext (ce_string ("1 substitution")))
								end
								(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (480).to_natural_32), ce_string ("%%s"), l_tmp___2]).do_nothing
							else
								if a_count_only.to_boolean then
									l_tmp___5 := (gettext (ce_string ("%%ld matches")))
								else
									l_tmp___5 := (gettext (ce_string ("%%ld substitutions")))
								end
								(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (480).to_natural_32), l_tmp___5, (create {P_GLOBALS_STATIC}).sub_nsubs.item]).do_nothing
							end
							if (create {P_GLOBALS_STATIC}).sub_nlines.item = 1 then
								(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (480).to_natural_32), ce_string ("%%s"), (gettext (ce_string (" on 1 line")))]).do_nothing
							else
								(create {P_MESSAGE_STATIC}).vim_snprintf_add ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (480).to_natural_32), (gettext (ce_string (" on %%ld lines"))), (create {P_GLOBALS_STATIC}).sub_nlines.item]).do_nothing
							end
							if ((create {P_MESSAGE_STATIC}).msg ((create {P_GLOBALS_STATIC}).msg_buf.item)).to_boolean then
								(create {P_MESSAGE_STATIC}).set_keep_msg ((create {P_GLOBALS_STATIC}).msg_buf.item, 0)
							end
							Result := 1
							l_return := True
						end
				when 5 then -- if done
					if not l_return and then (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item)))))).do_nothing
						Result := 1
						l_return := True
					end
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_global (a_eap: CE_POINTER [PD_EXARG])
		local
			l_lnum: INTEGER_32
			l_ndone: INTEGER_32
			l_type: INTEGER_32
			l_cmd: CE_POINTER [NATURAL_8]
			l_delim: NATURAL_8
			l_pat: CE_POINTER [NATURAL_8]
			l_regmatch___0: CE_ARRAY [PD_REGMMATCH_T]
			l_match: INTEGER_32
			l_which_pat: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_REGMMATCH_T]} l_regmatch___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ndone := 0
					if ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E147: Cannot do :global recursive"))))).do_nothing
						l_return := True
					end
					if not l_return then
						if (a_eap.item.forceit).to_boolean then
							l_type := ('v').code
						else
							l_type := ((a_eap.item.cmd).item).to_integer_32
						end
						l_cmd := a_eap.item.arg
						l_which_pat := 2
						if (l_cmd.item).to_integer_32 = 92 then
							l_cmd := l_cmd + 1
							if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/?&")), (l_cmd.item).to_integer_32)).is_void then
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_backslash.item)))))).do_nothing
								l_return := True
							end
							if not l_return then
								if (l_cmd.item).to_integer_32 = 38 then
									l_which_pat := 1
								else
									l_which_pat := 0
								end
								l_cmd := l_cmd + 1
								l_pat := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
							end
						elseif (l_cmd.item).to_integer_32 = 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E148: Regular expression missing from global"))))).do_nothing
							l_return := True
						else
							l_delim := l_cmd.item
							if l_delim.to_boolean then
								l_cmd := l_cmd + 1
							end
							l_pat := l_cmd
							l_cmd := (create {P_REGEXP_STATIC}).skip_regexp (l_cmd, l_delim.to_integer_32, (create {P_OPTION_STATIC}).p_magic.item.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (a_eap.c_pointer + (create {PD_EXARG}.make).offset_of ("arg")))
							if (l_cmd[0]).to_integer_32 = l_delim.to_integer_32 then
								l_tmp___3 := l_cmd
								l_cmd := l_cmd + 1
								l_tmp___3.item := (('%/0/').code).to_natural_8
							end
						end
					end
					if not l_return then
						if ((create {P_SEARCH_STATIC}).search_regcomp (l_pat, 2, l_which_pat, 32, l_regmatch___0)) = 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invcmd.item)))))).do_nothing
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						l_lnum := a_eap.item.line1
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if l_lnum <= a_eap.item.line2 then
							if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						l_match := (l_regmatch___0.item.vim_regexec_multi ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curbuf.item, l_lnum, 0, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_integer_32
						if l_type /= 103 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_match.to_boolean then
							(create {P_MEMLINE_STATIC}).ml_setmarked (l_lnum)
							l_ndone := l_ndone + 1
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_type = 118 then
							if not l_match.to_boolean then
								(create {P_MEMLINE_STATIC}).ml_setmarked (l_lnum)
								l_ndone := l_ndone + 1
							end
						end
				when 8 then;
						(create {P_MISC1_STATIC}).line_breakcheck
						l_lnum := l_lnum + 1
				when 9 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_interr.item)))))).do_nothing
						elseif l_ndone = 0 then
							if l_type = 118 then
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Pattern found in every line: %%s")))), l_pat]).do_nothing
							else
								(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_patnotf2.item))))), l_pat]).do_nothing
							end
						else
							global_exe (l_cmd)
						end
						(create {P_MEMLINE_STATIC}).ml_clearmarked;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog))
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	global_exe (a_cmd: CE_POINTER [NATURAL_8])
		local
			l_old_lcount: INTEGER_32
			l_lnum: INTEGER_32
			l_break: BOOLEAN
		do
			(create {P_MARK_STATIC}).setpcmark;
			(create {P_GLOBALS_STATIC}).msg_didout.item := 1;
			(create {P_GLOBALS_STATIC}).sub_nsubs.item := 0;
			(create {P_GLOBALS_STATIC}).sub_nlines.item := (0).to_integer_32
			global_need_beginline.item := 0;
			(create {P_GLOBALS_STATIC}).global_busy.item := 1
			l_old_lcount := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
			from
			until
				(l_break)
			loop
				l_break := False
				if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
					l_lnum := (create {P_MEMLINE_STATIC}).ml_firstmarked
					if l_lnum /= 0 then
						if (create {P_GLOBALS_STATIC}).global_busy.item /= 1 then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
					if (a_cmd.item).to_integer_32 = 0 then
						(create {P_EX_DOCMD_STATIC}).do_cmdline (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("p")), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 2).do_nothing
					elseif (a_cmd.item).to_integer_32 = 10 then
						(create {P_EX_DOCMD_STATIC}).do_cmdline (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("p")), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 2).do_nothing
					else
						(create {P_EX_DOCMD_STATIC}).do_cmdline (a_cmd, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 2).do_nothing
					end
					(create {P_UI_STATIC}).ui_breakcheck
				end
			end
			l_break := False;
			(create {P_GLOBALS_STATIC}).global_busy.item := 0
			if global_need_beginline.item.to_boolean then
				(create {P_EDIT_STATIC}).beginline (5)
			else
				(create {P_MISC2_STATIC}).check_cursor
			end
			(create {P_MOVE_STATIC}).changed_line_abv_curs
			if (create {P_GLOBALS_STATIC}).msg_col.item = 0 then
				if (create {P_GLOBALS_STATIC}).msg_scrolled.item = 0 then
					(create {P_GLOBALS_STATIC}).msg_didout.item := 0
				end
			end
			if not (do_sub_msg (0)).to_boolean then
				(create {P_MISC1_STATIC}).msgmore ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count - l_old_lcount)
			end
		end

	write_viminfo_sub_string (a_fp: CE_POINTER [SD_IO_FILE])
		do
			if ((create {P_OPTION_STATIC}).get_viminfo_parameter (('/').code)) /= 0 then
				if not old_sub.item.is_void then
					fputs ((gettext (ce_string ("%N# Last Substitute String:%N$"))), a_fp).do_nothing
					viminfo_writestring (a_fp, old_sub.item)
				end
			end
		end

	prepare_tagpreview (a_undo_sync: INTEGER_32): INTEGER_32
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1
			if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_pvw).to_boolean then
				l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				from
				until
					not (not (l_break) and then (not l_wp___0.is_void))
				loop
					l_break := False
					if (l_wp___0.item.w_onebuf_opt.wo_pvw).to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_wp___0 := l_wp___0.item.w_next
					end
				end
				l_break := False
				if not l_wp___0.is_void then
					(create {P_WINDOW_STATIC}).win_enter (l_wp___0, a_undo_sync)
				else
					if (create {P_GLOBALS_STATIC}).g_do_tagpreview.item > 0 then
						l_tmp := (create {P_GLOBALS_STATIC}).g_do_tagpreview.item
					else
						l_tmp := 0
					end
					if ((create {P_WINDOW_STATIC}).win_split (l_tmp, 0)) = 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_pvw := 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wfh := 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_fdc := 0
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	check_help_lang (a_arg: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_arg))).to_integer_32
			if l_len >= 3 then
				if (a_arg[(l_len - 3)]).to_integer_32 = 64 then
					if (a_arg[(l_len - 2)]).to_integer_32 < 127 then
						if ((((ctype_b_loc).item[(a_arg[(l_len - 2)]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
							if (a_arg[(l_len - 1)]).to_integer_32 < 127 then
								if ((((ctype_b_loc).item[(a_arg[(l_len - 1)]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
									a_arg[(l_len - 3)] := (('%/0/').code).to_natural_8
									Result := ((a_arg + l_len) - 2)
									l_return := True
								end
							end
						end
					end
				end
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	help_heuristic (a_matched_string: CE_POINTER [NATURAL_8]; a_offset, a_wrong_case: INTEGER_32): INTEGER_32
		require
			not a_matched_string.is_void
		local
			l_offset: INTEGER_32
			l_num_letters: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_offset := a_offset
					l_num_letters := 0
					l_p___0 := a_matched_string
					from
					until
						not ((l_p___0.item).to_boolean)
					loop
						if (l_p___0.item).to_integer_32 < 127 then
							if ((((ctype_b_loc).item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
								l_num_letters := l_num_letters + 1
							end
						end
						l_p___0 := l_p___0 + 1
					end
					if not ((a_matched_string[l_offset]).to_integer_32 < 127) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if ((((ctype_b_loc).item[(a_matched_string[l_offset]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							if l_offset > 0 then
								if (a_matched_string[(l_offset - 1)]).to_integer_32 < 127 then
									if ((((ctype_b_loc).item[(a_matched_string[(l_offset - 1)]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
										l_offset := l_offset + (10_000)
									else
										l_pos := -1 + 3 -- goto _L___1
									end
								else
									l_pos := -1 + 3 -- goto _L___1
								end
							else
								l_pos := -1 + 3 -- goto _L___1
							end
						else
							l_pos := -1 + 3 -- goto _L___1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___1:
						if l_offset > 2 then
							l_offset := l_offset * (200)
						end
				when 4 then
					if a_wrong_case.to_boolean then
						l_offset := l_offset + (5_000)
					end
					if (a_matched_string[0]).to_integer_32 = 43 then
						if (a_matched_string[1]).to_integer_32 /= 0 then
							l_offset := l_offset + (100)
						end
					end
					Result := (((100 * l_num_letters).to_natural_32 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_matched_string)))) + l_offset.to_natural_32).to_integer_32
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	help_compare (a_s1, a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_p1: CE_POINTER [INTEGER_8]
			l_p2: CE_POINTER [INTEGER_8]
		do
			l_p1 := ((create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_s1)).item + (strlen ((create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_s1)).item)).to_integer_32) + 1
			l_p2 := ((create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_s2)).item + (strlen ((create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_s2)).item)).to_integer_32) + 1
			Result := (strcmp (l_p1, l_p2))
		end

	find_help_tags (a_arg: CE_POINTER [NATURAL_8]; a_num_matches___0: CE_POINTER [INTEGER_32]; a_matches___0: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_keep_lang: INTEGER_32): INTEGER_32
		require
			not a_num_matches___0.is_void
			not a_matches___0.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_flags___0: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := (create {P_GLOBALS_STATIC}).IObuff.item
					l_i___0 := (({PLATFORM}.Pointer_bytes.to_natural_32 * (27).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32
					from
					until
						(l_break)
					loop
						l_break := False
						l_i___0 := l_i___0 - 1
						if not (l_i___0 >= 0) then
							l_break := True
						end
						if not (l_break) then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_arg), mtable.item[l_i___0])) = 0 then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_d), rtable.item[l_i___0]).do_nothing
								l_break := True
							end
						end
					end
					l_break := False
					if not (l_i___0 < 0) then
						l_pos := -1 + 41 -- skip if block
					end
				when 1 then -- if:
						if (a_arg[0]).to_integer_32 /= 92 then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						if (a_arg[1]).to_integer_32 = 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (a_arg[2]).to_integer_32 = 0 then
							l_pos := -1 + 7 -- goto _L___5
						else
							l_pos := -1 + 5 -- goto _L___6
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else: | _L___6:
						if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%_z@")), (a_arg[1]).to_integer_32)).is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if (a_arg[2]).to_integer_32 = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___5:
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("/\\")).do_nothing
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_d + 3)), create {CE_INTEGER_8_POINTER}.make_cast ((a_arg + 1))).do_nothing
						if (l_d[3]).to_integer_32 = 95 then
							if (l_d[4]).to_integer_32 = 36 then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_d + 4)), ce_string ("\$")).do_nothing
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___4
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___4
				when 12 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 41
				when 13 then -- else: | _L___4:
						if (a_arg[0]).to_integer_32 = 91 then
							if (a_arg[1]).to_integer_32 = 58 then
								l_tmp___0 := l_d
								l_d := l_d + 1
								l_tmp___0.item := (('\').code).to_natural_8
							elseif (a_arg[1]).to_integer_32 = 43 then
								if (a_arg[2]).to_integer_32 = 43 then
									l_tmp___0 := l_d
									l_d := l_d + 1
									l_tmp___0.item := (('\').code).to_natural_8
								end
							end
						end
						l_s := a_arg
				when 14 then -- loop condition:
						if not (not (l_break) and then ((l_s.item).to_boolean)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 15 then -- loop body:
						l_break := False
						l_continue := False
						if l_d.distance (((create {P_GLOBALS_STATIC}).IObuff.item)) > 1_015 then
							l_break := True
						end
						if (l_break or l_continue) then
							l_pos := -1 + 22 -- skip if block
						end
				when 16 then -- if:
						inspect (l_s.item).to_integer_32 -- switch 1 head
						when 124 then l_pos := -1 + 17
						when 34 then l_pos := -1 + 18
						when 42 then l_pos := -1 + 19
						when 63 then l_pos := -1 + 20
						when 36 then l_pos := -1 + 21
						when 46 then l_pos := -1 + 21
						when 126 then l_pos := -1 + 21
						else l_pos := -1 + 22
						end
				when 17 then -- switch 1, case 124
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("bar")).do_nothing
						l_d := l_d + (3)
						l_continue := True
				when 18 then -- switch 1, case 34
						if not (l_break or l_continue) then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("quote")).do_nothing
							l_d := l_d + (5)
							l_continue := True
						end
				when 19 then -- switch 1, case 42
						if not (l_break or l_continue) then
							l_tmp___1 := l_d
							l_d := l_d + 1
							l_tmp___1.item := (('.').code).to_natural_8
						end
						l_pos := -1 + 22 -- switch 1; break
				when 20 then -- switch 1, case 63
						l_tmp___2 := l_d
						l_d := l_d + 1
						l_tmp___2.item := (('.').code).to_natural_8
						l_continue := True
				when 21 then -- switch 1, case 36 | switch 1, case 46 | switch 1, case 126
						if not (l_break or l_continue) then
							l_tmp___3 := l_d
							l_d := l_d + 1
							l_tmp___3.item := (('\').code).to_natural_8
						end
						l_pos := -1 + 22 -- switch 1; break
				when 22 then -- switch 1, done: | if done
						if (l_break or l_continue) then
							l_pos := -1 + 39 -- skip if block
						end
				when 23 then -- if:
						if not ((l_s.item).to_integer_32 < 32) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 32 -- goto _L___1
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 26 then -- else:
						if (l_s.item).to_integer_32 /= 94 then
							l_pos := -1 + 38 -- skip if block
						end
				when 27 then -- if:
						if not ((l_s[1]).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 28 then -- if:
						if not ((l_s[1]).to_integer_32 < 127) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if ((((ctype_b_loc).item[(l_s[1]).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
							l_pos := -1 + 32 -- goto _L___1
						else
							l_pos := -1 + 31 -- goto _L___2
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 31 then -- else: | _L___2:
						if ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("?@[\]^")), (l_s[1]).to_integer_32)).is_void then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if: | _L___1:
						if (l_d.c_pointer.to_integer_32).to_natural_32 > (((create {P_GLOBALS_STATIC}).IObuff.item).c_pointer.to_integer_32).to_natural_32 then
							if (l_d[-1]).to_integer_32 /= 95 then
								l_tmp___4 := l_d
								l_d := l_d + 1
								l_tmp___4.item := (('_').code).to_natural_8
							end
						end
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("CTRL-")).do_nothing
						l_d := l_d + (5)
						if (l_s.item).to_integer_32 < 32 then
							l_tmp___5 := l_d
							l_d := l_d + 1
							l_tmp___5.item := ((l_s.item).to_integer_32 + 64).to_natural_8
							if (l_d[-1]).to_integer_32 = 92 then
								l_tmp___6 := l_d
								l_d := l_d + 1
								l_tmp___6.item := (('\').code).to_natural_8
							end
						else
							l_tmp___7 := l_d
							l_d := l_d + 1
							l_s := l_s + 1
							l_tmp___7.item := l_s.item
						end
						if (l_s[1]).to_integer_32 /= 0 then
							if (l_s[1]).to_integer_32 /= 95 then
								l_tmp___8 := l_d
								l_d := l_d + 1
								l_tmp___8.item := (('_').code).to_natural_8
							end
						end
						l_continue := True
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 38 -- goto _L___3
				when 35 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						l_pos := -1 + 38 -- goto _L___3
				when 37 then -- if done | if block done, skip else block:
						l_pos := -1 + 39
				when 38 then -- else: | _L___3:
						if (l_s.item).to_integer_32 = 94 then
							l_tmp___9 := l_d
							l_d := l_d + 1
							l_tmp___9.item := (('\').code).to_natural_8
						elseif (l_s[0]).to_integer_32 = 92 then
							if (l_s[1]).to_integer_32 /= 92 then
								if (a_arg.item).to_integer_32 = 47 then
									if l_s.is_equal (a_arg + 1) then
										l_tmp___10 := l_d
										l_d := l_d + 1
										l_tmp___10.item := (('\').code).to_natural_8
									end
								end
							end
						end
				when 39 then -- if done | if done
						if not (l_break or l_continue) then
							if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("CTRL-\_"), (7).to_natural_32)) = 0 then
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_d), ce_string ("CTRL-\\")).do_nothing
								l_d := l_d + (7)
								l_s := l_s + (6)
							end
							l_tmp___14 := l_d
							l_d := l_d + 1
							l_tmp___14.item := l_s.item
							if (l_s.item).to_integer_32 = 39 then
								if (l_s.c_pointer.to_integer_32).to_natural_32 > (a_arg.c_pointer.to_integer_32).to_natural_32 then
									if (a_arg.item).to_integer_32 = 39 then
										l_break := True
									end
								end
							end
						end
						if (not l_break) then
							l_s := l_s + 1
						end
						l_pos := -1 + 14 -- back to loop condition
				when 40 then -- loop done
						l_break := False
						l_continue := False
						l_d.item := (('%/0/').code).to_natural_8
				when 41 then -- if done
					a_matches___0.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ce_string (""))
					a_num_matches___0.item := 0
					l_flags___0 := 39
					if a_keep_lang.to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((128))
					end
					if ((create {P_TAG_STATIC}).find_tags ((create {P_GLOBALS_STATIC}).IObuff.item, a_num_matches___0, a_matches___0, l_flags___0, 2_147_483_647, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))) = 1 then
						if a_num_matches___0.item > 0 then
							qsort (create {CE_VOID_POINTER}.make_cast (a_matches___0.item), (a_num_matches___0.item).to_natural_32, {PLATFORM}.Pointer_bytes.to_natural_32, help_compare_address)
							from
							until
								not (a_num_matches___0.item > 300)
							loop
								a_num_matches___0.item := (a_num_matches___0.item) - 1;
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_matches___0.item[a_num_matches___0.item]))
							end
						end
					end
					Result := 1
				when 42 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	fix_help_buffer
		local
			l_lnum: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_in_example: INTEGER_32
			l_len: INTEGER_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_rt: CE_POINTER [NATURAL_8]
			l_mustfree: CE_ARRAY [INTEGER_32]
			l_fcount: CE_ARRAY [INTEGER_32]
			l_fnames: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_s: CE_POINTER [NATURAL_8]
			l_fi: INTEGER_32
			l_vc: CE_ARRAY [PD_VIMCONV_T]
			l_cp: CE_POINTER [NATURAL_8]
			l_this_utf: INTEGER_32
			l_l: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_mustfree.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fcount.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_fnames.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_VIMCONV_T]} l_vc.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_in_example := 0;
					(create {P_OPTION_STATIC}).set_option_value (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ft")), 0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("help")), 4)
					if (((create {P_GLOBALS_STATIC}).curwin.item).item.syntax_present).to_boolean then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_lnum := (1).to_integer_32
				when 2 then -- loop condition:
						if not (l_lnum <= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_line := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (l_lnum, 0)
						l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))).to_integer_32
						if l_in_example.to_boolean then
							if l_len > 0 then
								if (l_line[0]).to_integer_32 /= 32 then
									if (l_line[0]).to_integer_32 /= 9 then
										if (l_line[0]).to_integer_32 = 60 then
											l_line := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (l_lnum, 1)
											l_line[0] := ((' ').code).to_natural_8
										end
										l_in_example := 0
									end
								end
							end
						end
						if l_in_example.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not (l_len > 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if (l_line[(l_len - 1)]).to_integer_32 /= 62 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_len = 1 then
							l_line := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (l_lnum, 1)
							l_line[(l_len - 1)] := ((' ').code).to_natural_8
							l_in_example := 1
						elseif (l_line[(l_len - 2)]).to_integer_32 = 32 then
							l_line := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (l_lnum, 1)
							l_line[(l_len - 1)] := ((' ').code).to_natural_8
							l_in_example := 1
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						if (l_line[(l_len - 1)]).to_integer_32 = 126 then
							l_line := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (l_lnum, 1)
							l_line[(l_len - 1)] := ((' ').code).to_natural_8
						end
				when 9 then -- if done | if done
						l_lnum := l_lnum + 1
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done | if done
					if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MISC1_STATIC}).gettail ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fname))), ce_string ("help.txt"))) = 0 then
						l_lnum := (1).to_integer_32
						from
						until
							not (not (l_return or l_break) and then (l_lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count))
						loop
							l_break := False
							l_line := ((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf (l_lnum, 0)
							if not (strstr (create {CE_INTEGER_8_POINTER}.make_cast (l_line), ce_string ("*local-additions*"))).is_void then
								l_p___0.item := (create {P_OPTION_STATIC}).p_rtp.item.item
								from
								until
									not (not (l_return) and then ((l_p___0.item.item).to_integer_32 /= 0))
								loop
									(create {P_MISC2_STATIC}).copy_option_part (l_p___0, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, ce_string (",")).do_nothing
									l_mustfree.item := 0
									l_rt := (create {P_MISC1_STATIC}).vim_getenv (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("VIMRUNTIME")), l_mustfree)
									if ((create {P_MISC1_STATIC}).fullpathcmp (l_rt, (create {P_GLOBALS_STATIC}).NameBuff.item.item, 0)) /= 1 then
										(create {P_MISC1_STATIC}).add_pathsep ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
										strcat (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), ce_string ("doc/*.txt")).do_nothing
										if ((create {P_MISC1_STATIC}).gen_expand_wildcards (1, (create {P_GLOBALS_STATIC}).NameBuff.item, l_fcount, l_fnames, 34)) = 1 then
											if l_fcount.item > 0 then
												l_fi := 0
												from
												until
													not (not (l_return) and then (l_fi < l_fcount.item))
												loop
													l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_fnames.item[l_fi]), ce_string ("r"))
													if not l_fd.is_void then
														(create {P_FILEIO_STATIC}).vim_fgets ((create {P_GLOBALS_STATIC}).IObuff.item, 1_025, l_fd).do_nothing
														if ((create {P_GLOBALS_STATIC}).IObuff.item[0]).to_integer_32 = 42 then
															l_s := (create {P_MISC2_STATIC}).vim_strchr ((create {P_GLOBALS_STATIC}).IObuff.item + 1, ('*').code)
															if not l_s.is_void then
																l_this_utf := 2;
																(create {P_GLOBALS_STATIC}).IObuff.item[0] := (('|').code).to_natural_8
																l_s.item := (('|').code).to_natural_8
																from
																until
																	(l_s.item).to_integer_32 = 0
																loop
																	if (l_s.item).to_integer_32 = 13 then
																		l_s.item := (('%/0/').code).to_natural_8
																	elseif (l_s.item).to_integer_32 = 10 then
																		l_s.item := (('%/0/').code).to_natural_8
																	end
																	if (l_s.item).to_integer_32 >= 128 then
																		if l_this_utf /= 0 then
																			l_this_utf := 1
																			l_l := (create {P_MBYTE_STATIC}).utf_ptr2len (l_s)
																			if l_l = 1 then
																				l_this_utf := 0
																			end
																			l_s := l_s + (l_l - 1)
																		end
																	end
																	l_s := l_s + 1
																end
																l_vc.item.vc_type := 0
																if l_this_utf = 1 then
																	l_tmp___1 := ce_string ("utf-8")
																else
																	l_tmp___1 := ce_string ("latin1")
																end
																l_vc.item.convert_setup (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1), (create {P_OPTION_STATIC}).p_enc.item.item).do_nothing
																if l_vc.item.vc_type = 0 then
																	l_cp := (create {P_GLOBALS_STATIC}).IObuff.item
																else
																	l_cp := (create {P_MBYTE_STATIC}).string_convert (l_vc, (create {P_GLOBALS_STATIC}).IObuff.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
																	if l_cp.is_void then
																		l_cp := (create {P_GLOBALS_STATIC}).IObuff.item
																	end
																end
																l_vc.item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing;
																(create {P_MEMLINE_STATIC}).ml_append (l_lnum, l_cp, 0, 0).do_nothing
																if not l_cp.is_equal ((create {P_GLOBALS_STATIC}).IObuff.item) then
																	(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cp))
																end
																l_lnum := l_lnum + 1
															end
														end
														fclose (l_fd).do_nothing
													end
													l_fi := l_fi + 1
												end
												(create {P_MISC1_STATIC}).FreeWild (l_fcount.item, l_fnames.item)
											end
										end
									end
									if (l_mustfree.item).to_boolean then
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_rt))
									end
								end
								l_break := True
							end
							if not (l_return or l_break) then
								l_lnum := l_lnum + 1
							end
						end
						l_break := False
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ex_exusage (a_eap: CE_POINTER [PD_EXARG])
		do
			(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("help ex-cmd-index"))).do_nothing
		end

	ex_viusage (a_eap: CE_POINTER [PD_EXARG])
		do
			(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("help normal-index"))).do_nothing
		end

	sign_cmd_idx (a_begin_cmd, a_end_cmd: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_end_cmd.is_void
		local
			l_idx: INTEGER_32
			l_save___0: INTEGER_8
			l_break: BOOLEAN
		do
			l_save___0 := (a_end_cmd.item).to_integer_8
			a_end_cmd.item := (('%/0/').code).to_natural_8
			l_idx := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if (cmds.item[l_idx]).is_void then
					l_break := True
				elseif (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_begin_cmd), cmds.item[l_idx])) = 0 then
					l_break := True
				end
				if not (l_break) then
					l_idx := l_idx + 1
				end
			end
			l_break := False
			a_end_cmd.item := l_save___0.to_natural_8
			Result := l_idx
		end

	sign_gui_started
		local
			l_sp: CE_POINTER [PD_SIGN]
		do
			l_sp := first_sign.item
			from
			until
				l_sp.is_void
			loop
				if not (l_sp.item.sn_icon).is_void then
					l_sp.item.sn_image := (create {P_GUI_GTK_X11_STATIC}).gui_mch_register_sign (l_sp.item.sn_icon)
				end
				l_sp := l_sp.item.sn_next
			end
		end

	sign_get_image (a_typenr: INTEGER_32): CE_POINTER [ANY]
		local
			l_sp: CE_POINTER [PD_SIGN]
			l_return: BOOLEAN
		do
			l_sp := first_sign.item
			from
			until
				not (not (l_return) and then (not l_sp.is_void))
			loop
				if l_sp.item.sn_typenr = a_typenr then
					Result := (l_sp.item.sn_image)
					l_return := True
				end
				if not l_return then
					l_sp := l_sp.item.sn_next
				end
			end
			if not l_return then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

	get_sign_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_sp: CE_POINTER [PD_SIGN]
			l_current_idx: INTEGER_32
			l_define_arg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_place_arg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_unplace_arg: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_define_arg.make (<<5>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_place_arg.make (<<5>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_unplace_arg.make (<<3>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect expand_what.item.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 1 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					when 4 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 0
					Result := (create {CE_NATURAL_8_POINTER}.make_cast (cmds.item[a_idx]))
					l_return := True
				when 2 then -- switch 1, case 1
					if not l_return then
						l_define_arg[0] := ce_string ("icon=")
						l_define_arg[1] := ce_string ("linehl=")
						l_define_arg[2] := ce_string ("text=")
						l_define_arg[3] := ce_string ("texthl=")
						l_define_arg[4] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_define_arg[a_idx]))
						l_return := True
					end
				when 3 then -- switch 1, case 2
					if not l_return then
						l_place_arg[0] := ce_string ("line=")
						l_place_arg[1] := ce_string ("name=")
						l_place_arg[2] := ce_string ("file=")
						l_place_arg[3] := ce_string ("buffer=")
						l_place_arg[4] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_place_arg[a_idx]))
						l_return := True
					end
				when 4 then -- switch 1, case 3
					if not l_return then
						l_unplace_arg[0] := ce_string ("file=")
						l_unplace_arg[1] := ce_string ("buffer=")
						l_unplace_arg[2] := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
						Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_unplace_arg[a_idx]))
						l_return := True
					end
				when 5 then -- switch 1, case 4
					if not l_return then
						l_current_idx := 0
						l_sp := first_sign.item
						from
						until
							not (not (l_return) and then (not l_sp.is_void))
						loop
							l_tmp := l_current_idx
							l_current_idx := l_current_idx + 1
							if l_tmp = a_idx then
								Result := (l_sp.item.sn_name)
								l_return := True
							end
							if not l_return then
								l_sp := l_sp.item.sn_next
							end
						end
					end
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
				when 6 then -- switch 1, default:
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 7 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY} -- routine addresses

	sort_compare_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent sort_compare)
		end

	ex_retab_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_retab)
		end

	do_fixdel_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent do_fixdel)
		end

	ex_update_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_update)
		end

	ex_global_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_global)
		end

	help_compare_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent help_compare)
		end

	ex_exusage_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_exusage)
		end

	ex_viusage_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent ex_viusage)
		end

	get_sign_name_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_sign_name)
		end

end
