class
	P_MISC1_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_STDIO_STATIC
	S_STDLIB_STATIC
	S_PWD_STATIC
	S_UNISTD_STATIC
	S_SYS_STAT_STATIC
	S_SIGNAL_STATIC

feature {ANY} -- public attributes

	w_readonly: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("W10: Warning: Changing a readonly file")
		end

	homedir: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	name: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<100>>)
		end

	ind_hash_comment: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	pos___0: CE_STATIC [CE_ARRAY [PD_POS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_POS_T]}.make (<<1>>)
		end

	pos_copy___0: CE_STATIC [CE_ARRAY [PD_POS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_POS_T]}.make (<<1>>)
		end

	pos_copy___1: CE_STATIC [CE_ARRAY [PD_POS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_POS_T]}.make (<<1>>)
		end

	breakcheck_count: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	recursive___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	get_indent: INTEGER_32
		do
			Result := (get_indent_str (((create {P_MEMLINE_STATIC}).ml_get_curline), ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32))
		end

	get_indent_lnum (a_lnum: INTEGER_32): INTEGER_32
		do
			Result := (get_indent_str (((create {P_MEMLINE_STATIC}).ml_get (a_lnum)), ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32))
		end

	get_indent_str (a_ptr: CE_POINTER [NATURAL_8]; a_ts: INTEGER_32): INTEGER_32
		require
			not a_ptr.is_void
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			l_break: BOOLEAN
		do
			l_ptr := a_ptr
			l_count___2 := 0
			from
			until
				not (not (l_break) and then ((l_ptr.item).to_boolean))
			loop
				l_break := False
				if (l_ptr.item).to_integer_32 = 9 then
					l_count___2 := l_count___2 + (a_ts - l_count___2 \\ a_ts)
				elseif (l_ptr.item).to_integer_32 = 32 then
					l_count___2 := l_count___2 + 1
				else
					l_break := True
				end
				if not (l_break) then
					l_ptr := l_ptr + 1
				end
			end
			l_break := False
			Result := l_count___2
		end

	set_indent (a_size, a_flags___0: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_newline: CE_POINTER [NATURAL_8]
			l_oldline: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_todo: INTEGER_32
			l_ind_len: INTEGER_32
			l_line_len: INTEGER_32
			l_doit: INTEGER_32
			l_ind_done: INTEGER_32
			l_tab_pad: INTEGER_32
			l_retval: INTEGER_32
			l_orig_char_len: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_doit := 0
					l_ind_done := 0
					l_retval := 0
					l_orig_char_len := -1
					l_todo := a_size
					l_ind_len := 0
					l_oldline := (create {P_MEMLINE_STATIC}).ml_get_curline
					l_p___0 := l_oldline
					if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_et).to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 3 then -- else:
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_pi).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if not ((a_flags___0).bit_and (2)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_pi).to_boolean then
								l_ind_done := 0
								from
								until
									(l_break)
								loop
									l_break := False
									if l_todo > 0 then
										if (l_p___0.item).to_integer_32 /= 32 then
											if (l_p___0.item).to_integer_32 /= 9 then
												l_break := True
											end
										end
									else
										l_break := True
									end
									if not (l_break) then
										if (l_p___0.item).to_integer_32 = 9 then
											l_tab_pad := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32 - l_ind_done \\ ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
											if l_todo < l_tab_pad then
												l_break := True
											end
											if not (l_break) then
												l_todo := l_todo - l_tab_pad
												l_ind_len := l_ind_len + 1
												l_ind_done := l_ind_done + l_tab_pad
											end
										else
											l_todo := l_todo - 1
											l_ind_len := l_ind_len + 1
											l_ind_done := l_ind_done + 1
										end
									end
									if not (l_break) then
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
								if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_et).to_boolean then
									l_orig_char_len := l_ind_len
								end
								l_tab_pad := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32 - l_ind_done \\ ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
								if l_todo >= l_tab_pad then
									if l_orig_char_len = -1 then
										l_doit := 1
										l_todo := l_todo - l_tab_pad
										l_ind_len := l_ind_len + 1
									end
								end
							end
						end
						from
						until
							not (l_todo >= ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32)
						loop
							if (l_p___0.item).to_integer_32 /= 9 then
								l_doit := 1
							else
								l_p___0 := l_p___0 + 1
							end
							l_todo := l_todo - ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
							l_ind_len := l_ind_len + 1
						end
				when 6 then -- if done | if done
					from
					until
						not (l_todo > 0)
					loop
						if (l_p___0.item).to_integer_32 /= 32 then
							l_doit := 1
						else
							l_p___0 := l_p___0 + 1
						end
						l_todo := l_todo - 1
						l_ind_len := l_ind_len + 1
					end
					if not l_doit.to_boolean then
						if (l_p___0.item).to_integer_32 /= 32 then
							if (l_p___0.item).to_integer_32 /= 9 then
								if not ((a_flags___0).bit_and (2)).to_boolean then
									Result := 0
									l_return := True
								end
							end
						end
					end
					if not l_return then
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_p___0 := l_oldline
						else
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
						end
						l_line_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32 + 1
						if l_orig_char_len /= -1 then
							l_newline := (create {P_MISC2_STATIC}).alloc ((((l_orig_char_len + a_size) - l_ind_done) + l_line_len).to_natural_32)
							if l_newline.is_void then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_todo := a_size - l_ind_done
								l_ind_len := l_orig_char_len + l_todo
								l_p___0 := l_oldline
								l_s := l_newline
								from
								until
									not (l_orig_char_len > 0)
								loop
									l_tmp___0 := l_s
									l_s := l_s + 1
									l_tmp___1 := l_p___0
									l_p___0 := l_p___0 + 1
									l_tmp___0.item := l_tmp___1.item
									l_orig_char_len := l_orig_char_len - 1
								end
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p___0.item).to_integer_32 /= 32 then
										if (l_p___0.item).to_integer_32 /= 9 then
											l_break := True
										end
									end
									if not (l_break) then
										l_p___0 := l_p___0 + 1
									end
								end
								l_break := False
							end
						else
							l_todo := a_size
							l_newline := (create {P_MISC2_STATIC}).alloc ((l_ind_len + l_line_len).to_natural_32)
							if l_newline.is_void then
								Result := 0
								l_return := True
							end
							if not l_return then
								l_s := l_newline
							end
						end
					end
					if l_return then
						l_pos := -1 + 15 -- skip if block
					end
				when 7 then -- if:
						if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_et).to_boolean then
							if not ((a_flags___0).bit_and (2)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_pi).to_boolean then
									l_p___0 := l_oldline
									l_ind_done := 0
									from
									until
										(l_break)
									loop
										l_break := False
										if l_todo > 0 then
											if (l_p___0.item).to_integer_32 /= 32 then
												if (l_p___0.item).to_integer_32 /= 9 then
													l_break := True
												end
											end
										else
											l_break := True
										end
										if not (l_break) then
											if (l_p___0.item).to_integer_32 = 9 then
												l_tab_pad := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32 - l_ind_done \\ ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
												if l_todo < l_tab_pad then
													l_break := True
												end
												if not (l_break) then
													l_todo := l_todo - l_tab_pad
													l_ind_done := l_ind_done + l_tab_pad
												end
											else
												l_todo := l_todo - 1
												l_ind_done := l_ind_done + 1
											end
										end
										if not (l_break) then
											l_tmp___2 := l_s
											l_s := l_s + 1
											l_tmp___3 := l_p___0
											l_p___0 := l_p___0 + 1
											l_tmp___2.item := l_tmp___3.item
										end
									end
									l_break := False
									l_tab_pad := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32 - l_ind_done \\ ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
									if l_todo >= l_tab_pad then
										l_tmp___4 := l_s
										l_s := l_s + 1
										l_tmp___4.item := (('%T').code).to_natural_8
										l_todo := l_todo - l_tab_pad
									end
									l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
								end
							end
							from
							until
								not (l_todo >= ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32)
							loop
								l_tmp___5 := l_s
								l_s := l_s + 1
								l_tmp___5.item := (('%T').code).to_natural_8
								l_todo := l_todo - ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
							end
						end
						from
						until
							not (l_todo > 0)
						loop
							l_tmp___6 := l_s
							l_s := l_s + 1
							l_tmp___6.item := ((' ').code).to_natural_8
							l_todo := l_todo - 1
						end
						memmove (create {CE_VOID_POINTER}.make_cast (l_s), create {CE_VOID_POINTER}.make_cast (l_p___0), l_line_len.to_natural_32).do_nothing
						if ((a_flags___0).bit_and (4)).to_boolean then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if ((create {P_UNDO_STATIC}).u_savesub ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)) /= 1 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L___0:;
						(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_newline, 0).do_nothing
						if ((a_flags___0).bit_and (1)).to_boolean then
							changed_bytes ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0)
						end
						if (create {P_GLOBALS_STATIC}).saved_cursor.item.item.lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							if (create {P_GLOBALS_STATIC}).saved_cursor.item.item.col >= l_p___0.distance (l_oldline) then
								(create {P_GLOBALS_STATIC}).saved_cursor.item.item.col := (create {P_GLOBALS_STATIC}).saved_cursor.item.item.col + (l_ind_len - (l_p___0.distance (l_oldline)))
							end
						end
						l_retval := 1
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_newline))
				when 14 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_ind_len
						Result := l_retval
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	copy_indent (a_size: INTEGER_32; a_src: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_todo: INTEGER_32
			l_ind_len: INTEGER_32
			l_line_len: INTEGER_32
			l_tab_pad: INTEGER_32
			l_ind_done: INTEGER_32
			l_round: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_line_len := 0
			l_round := 1
			from
			until
				not (not (l_return) and then (l_round <= 2))
			loop
				l_todo := a_size
				l_ind_len := 0
				l_ind_done := 0
				l_s := a_src
				from
				until
					(l_break)
				loop
					l_break := False
					if l_todo > 0 then
						if (l_s.item).to_integer_32 /= 32 then
							if (l_s.item).to_integer_32 /= 9 then
								l_break := True
							end
						end
					else
						l_break := True
					end
					if not (l_break) then
						if (l_s.item).to_integer_32 = 9 then
							l_tab_pad := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32 - l_ind_done \\ ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
							if l_todo < l_tab_pad then
								l_break := True
							end
							if not (l_break) then
								l_todo := l_todo - l_tab_pad
								l_ind_done := l_ind_done + l_tab_pad
							end
						else
							l_todo := l_todo - 1
							l_ind_done := l_ind_done + 1
						end
					end
					if not (l_break) then
						l_ind_len := l_ind_len + 1
						if not l_p___0.is_void then
							l_tmp := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp.item := l_s.item
						end
						l_s := l_s + 1
					end
				end
				l_break := False
				l_tab_pad := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32 - l_ind_done \\ ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
				if l_todo >= l_tab_pad then
					l_todo := l_todo - l_tab_pad
					l_ind_len := l_ind_len + 1
					if not l_p___0.is_void then
						l_tmp___0 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___0.item := (('%T').code).to_natural_8
					end
				end
				from
				until
					not (l_todo >= ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32)
				loop
					l_todo := l_todo - ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
					l_ind_len := l_ind_len + 1
					if not l_p___0.is_void then
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___1.item := (('%T').code).to_natural_8
					end
				end
				from
				until
					not (l_todo > 0)
				loop
					l_todo := l_todo - 1
					l_ind_len := l_ind_len + 1
					if not l_p___0.is_void then
						l_tmp___2 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___2.item := ((' ').code).to_natural_8
					end
				end
				if l_p___0.is_void then
					l_line_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get_curline)))).to_integer_32 + 1
					l_line := (create {P_MISC2_STATIC}).alloc ((l_ind_len + l_line_len).to_natural_32)
					if l_line.is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_p___0 := l_line
					end
				end
				if not l_return then
					l_round := l_round + 1
				end
			end
			if not l_return then
				memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get_curline)), l_line_len.to_natural_32).do_nothing;
				(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_line, 0).do_nothing;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_ind_len
				Result := 1
			end
		end

	get_number_indent (a_lnum: INTEGER_32): INTEGER_32
		local
			l_col: CE_ARRAY [INTEGER_32]
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_regmatch___0: CE_ARRAY [PD_REGMMATCH_T]
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_pos___3.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_REGMMATCH_T]} l_regmatch___0.make (<<1>>)

			if a_lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_pos___3.item.lnum := (0).to_integer_32
				l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_flp, 1)
				if not (l_regmatch___0.item.regprog).is_void then
					l_regmatch___0.item.rmm_ic := 0
					l_regmatch___0.item.rmm_maxcol := 0
					if (l_regmatch___0.item.vim_regexec_multi ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curbuf.item, a_lnum, 0, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))).to_boolean then
						l_pos___3.item.lnum := l_regmatch___0.item.endpos[0].lnum + a_lnum
						l_pos___3.item.col := l_regmatch___0.item.endpos[0].col
						l_pos___3.item.coladd := 0
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog))
				end
				if l_pos___3.item.lnum = 0 then
					Result := (-1)
					l_return := True
				elseif ((l_pos___3.item.ml_get_pos).item).to_integer_32 = 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_pos___3, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				Result := (l_col.item)
			end
		end

	cin_is_cinword (a_line: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_cinw: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_cinw_buf: CE_POINTER [NATURAL_8]
			l_cinw_len: INTEGER_32
			l_retval: INTEGER_32
			l_len: INTEGER_32
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_cinw.make (<<1>>)

			l_line := a_line
			l_retval := 0
			l_cinw_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cinw))).to_integer_32 + 1
			l_cinw_buf := (create {P_MISC2_STATIC}).alloc (l_cinw_len.to_natural_32)
			if not l_cinw_buf.is_void then
				l_line := (create {P_CHARSET_STATIC}).skipwhite (l_line)
				l_cinw.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cinw
				from
				until
					not (not (l_break) and then ((l_cinw.item.item).to_boolean))
				loop
					l_break := False
					l_len := (create {P_MISC2_STATIC}).copy_option_part (l_cinw, l_cinw_buf, l_cinw_len, ce_string (","))
					if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_line), create {CE_INTEGER_8_POINTER}.make_cast (l_cinw_buf), l_len.to_natural_32)) = 0 then
						if ((create {P_CHARSET_STATIC}).vim_iswordc ((l_line[l_len]).to_integer_32)).to_boolean then
							if not ((create {P_CHARSET_STATIC}).vim_iswordc ((l_line[(l_len - 1)]).to_integer_32)).to_boolean then
								l_retval := 1
								l_break := True
							end
						else
							l_retval := 1
							l_break := True
						end
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cinw_buf))
			end
			Result := l_retval
		end

	open_line (a_dir___0, a_flags___0, a_old_indent___0: INTEGER_32): INTEGER_32
		local
			l_saved_line: CE_POINTER [NATURAL_8]
			l_next_line: CE_POINTER [NATURAL_8]
			l_p_extra: CE_POINTER [NATURAL_8]
			l_less_cols: INTEGER_32
			l_less_cols_off: INTEGER_32
			l_old_cursor: PD_POS_T
			l_newcol: INTEGER_32
			l_newindent: INTEGER_32
			l_n: INTEGER_32
			l_trunc_line: INTEGER_32
			l_retval: INTEGER_32
			l_extra_len: INTEGER_32
			l_lead_len: INTEGER_32
			l_lead_flags: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_leader: CE_POINTER [NATURAL_8]
			l_allocated: CE_POINTER [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_saved_char: INTEGER_32
			l_pos___3: CE_POINTER [PD_POS_T]
			l_do_si: INTEGER_32
			l_tmp: INTEGER_32
			l_no_si: INTEGER_32
			l_first_char: INTEGER_32
			l_vreplace_mode: INTEGER_32
			l_did_append: INTEGER_32
			l_saved_pi: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_ptr: CE_POINTER [NATURAL_8]
			l_last_char: NATURAL_8
			l_was_backslashed: INTEGER_32
			l_lead_repl: CE_POINTER [NATURAL_8]
			l_lead_repl_len: INTEGER_32
			l_lead_middle: CE_ARRAY [NATURAL_8]
			l_lead_end: CE_ARRAY [NATURAL_8]
			l_comment_end: CE_POINTER [NATURAL_8]
			l_extra_space: INTEGER_32
			l_current_flag: INTEGER_32
			l_require_blank: INTEGER_32
			l_p2: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_off___0: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: INTEGER_32
			l_repl_size: INTEGER_32
			l_old_size: INTEGER_32
			l_endp: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___14: INTEGER_32
			l_l___0: INTEGER_32
			l_repl_size___0: INTEGER_32
			l_i___0: INTEGER_32
			l_l___1: INTEGER_32
			l_l___2: INTEGER_32
			l_tmp___21: CE_POINTER [NATURAL_8]
			l_tmp___25: INTEGER_32
			l_tmp___29: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_lead_flags.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_lead_middle.make (<<50>>)
			create {CE_NATURAL_8_ARRAY} l_lead_end.make (<<50>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_next_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_p_extra := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_less_cols := 0
					l_less_cols_off := 0
					l_newcol := 0
					l_newindent := 0
					l_trunc_line := 0
					l_retval := 0
					l_extra_len := 0
					l_leader := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_allocated := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_saved_char := ('%/0/').code
					if not ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_si).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cin).to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
					else
						l_tmp := 0
					end
					l_do_si := l_tmp
					l_no_si := 0
					l_first_char := ('%/0/').code
					l_saved_pi := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_pi
					l_saved_line := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get_curline))
					if l_saved_line.is_void then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 158 -- skip if block
					end
				when 1 then -- if:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < ((create {P_GLOBALS_STATIC}).orig_line_count.item).to_integer_32 then
							l_next_line := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1)))
						else
							l_next_line := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
						end
						if l_next_line.is_void then
							l_pos := -1 + 157 -- goto theend
						end
				when 3 then;
						(create {P_EDIT_STATIC}).replace_push (('%/0/').code);
						(create {P_EDIT_STATIC}).replace_push (('%/0/').code)
						l_p___0.item := l_saved_line + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						from
						until
							(l_p___0.item.item).to_integer_32 = 0
						loop
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_p___0.item := l_p___0.item + ((create {P_EDIT_STATIC}).replace_push_mb (l_p___0.item))
							else
								l_tmp___3 := l_p___0.item
								l_p___0.item := l_p___0.item + 1;
								(create {P_EDIT_STATIC}).replace_push ((l_tmp___3.item).to_integer_32)
							end
						end
						l_saved_line[(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col] := (('%/0/').code).to_natural_8
				when 4 then -- if done
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
								l_p_extra := l_saved_line + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
								if l_do_si.to_boolean then
									l_p___0.item := (create {P_CHARSET_STATIC}).skipwhite (l_p_extra)
									l_first_char := (l_p___0.item.item).to_integer_32
								end
								l_extra_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p_extra))).to_integer_32
								l_saved_char := (l_p_extra.item).to_integer_32
								l_p_extra.item := (('%/0/').code).to_natural_8
							end
						end
						(create {P_UNDO_STATIC}).u_clearline;
						(create {P_GLOBALS_STATIC}).did_si.item := 0;
						(create {P_GLOBALS_STATIC}).ai_col.item := 0
						if a_dir___0 = 1 then
							if ((create {P_GLOBALS_STATIC}).did_ai.item).to_boolean then
								l_trunc_line := 1
							end
						end
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___2
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 7 then -- else:
						if not (l_do_si.to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 8 then -- if: | _L___2:
						l_newindent := get_indent_str (l_saved_line, ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32)
						if l_newindent = 0 then
							l_newindent := a_old_indent___0
						end
						if l_trunc_line.to_boolean then
							l_pos := -1 + 41 -- skip if block
						end
				when 9 then -- if:
						if not (l_do_si.to_boolean) then
							l_pos := -1 + 41 -- skip if block
						end
				when 10 then -- if:
						if (l_saved_line.item).to_integer_32 = 0 then
							l_pos := -1 + 41 -- skip if block
						end
				when 11 then -- if:
						if not (l_p_extra.is_void) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L___1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 14 then -- else:
						if l_first_char = 123 then
							l_pos := -1 + 41 -- skip if block
						end
				when 15 then -- if: | _L___1:
						l_old_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						l_ptr := l_saved_line
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_lead_len := get_leader_len (l_ptr, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
						else
							l_lead_len := 0
						end
						if a_dir___0 /= 1 then
							l_pos := -1 + 26 -- skip if block
						end
				when 16 then -- if:
						if l_lead_len = 0 then
							if (l_ptr[0]).to_integer_32 = 35 then
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_ptr[0]).to_integer_32 = 35 then
										if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1) then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
										l_ptr := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
									end
								end
								l_break := False
								l_newindent := get_indent
							end
						end
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_lead_len := get_leader_len (l_ptr, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
						else
							l_lead_len := 0
						end
						if not (l_lead_len > 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_p___0.item := (create {P_CHARSET_STATIC}).skipwhite (l_ptr)
						if (l_p___0.item[0]).to_integer_32 = 47 then
							if (l_p___0.item[1]).to_integer_32 = 42 then
								l_p___0.item := l_p___0.item + 1
							end
						end
						if (l_p___0.item[0]).to_integer_32 = 42 then
							l_p___0.item := l_p___0.item + 1
							from
							until
								not ((l_p___0.item.item).to_boolean)
							loop
								if (l_p___0.item[0]).to_integer_32 = 47 then
									if (l_p___0.item[-1]).to_integer_32 = 42 then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (l_p___0.item).distance (l_ptr)
										l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('%/0/').code)
										if not l_pos___3.is_void then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_pos___3.item.lnum
											l_newindent := get_indent
										end
									end
								end
								l_p___0.item := l_p___0.item + 1
							end
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 19 then -- else:
						l_p___0.item := (l_ptr + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))).to_integer_32) - 1
						from
						until
							(l_break)
						loop
							l_break := False
							if ((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0.item.item).to_integer_32 /= 32 then
									if (l_p___0.item.item).to_integer_32 /= 9 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0.item := l_p___0.item - 1
							end
						end
						l_break := False
						l_last_char := l_p___0.item.item
						if l_last_char.to_integer_32 /= 123 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 22 then -- else:
						if l_last_char.to_integer_32 /= 59 then
							l_pos := -1 + 24 -- skip if block
						end
				when 23 then -- if: | _L:
						if ((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
							l_p___0.item := l_p___0.item - 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if ((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > (l_ptr.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0.item.item).to_integer_32 /= 32 then
									if (l_p___0.item.item).to_integer_32 /= 9 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_p___0.item := l_p___0.item - 1
							end
						end
						l_break := False
				when 24 then -- if done
						if (l_p___0.item.item).to_integer_32 = 41 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (l_p___0.item).distance (l_ptr)
							l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('(').code)
							if not l_pos___3.is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_pos___3.item.lnum
								l_newindent := get_indent
								l_ptr := (create {P_MEMLINE_STATIC}).ml_get_curline
							end
						end
						if l_last_char.to_integer_32 = 123 then
							(create {P_GLOBALS_STATIC}).did_si.item := 1
							l_no_si := 1
						elseif l_last_char.to_integer_32 /= 59 then
							if l_last_char.to_integer_32 /= 125 then
								if (cin_is_cinword (l_ptr)).to_boolean then
									(create {P_GLOBALS_STATIC}).did_si.item := 1
								end
							end
						end
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 40
				when 26 then -- else:
						if l_lead_len /= 0 then
							l_pos := -1 + 39 -- skip if block
						end
				when 27 then -- if:
						if (l_ptr[0]).to_integer_32 /= 35 then
							l_pos := -1 + 39 -- skip if block
						end
				when 28 then -- if:
						l_was_backslashed := 0
				when 29 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 38 -- skip loop
						end
				when 30 then -- loop body:
						l_break := False
						if (l_ptr[0]).to_integer_32 /= 35 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						l_pos := -1 + 34 -- goto _L___0
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 33 then -- else:
						if not (l_was_backslashed.to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if: | _L___0:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
							l_break := True
						end
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 37
				when 36 then -- else:
						l_break := True
				when 37 then -- if done
						if not (l_break) then
							if (l_ptr.item).to_boolean then
								if (l_ptr[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
									l_was_backslashed := 1
								else
									l_was_backslashed := 0
								end
							else
								l_was_backslashed := 0
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1
							l_ptr := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
						end
						l_pos := -1 + 29 -- back to loop condition
				when 38 then -- loop done
						l_break := False
						if l_was_backslashed.to_boolean then
							l_newindent := 0
						else
							l_newindent := get_indent
						end
				when 39 then -- if done | if done
						l_p___0.item := (create {P_CHARSET_STATIC}).skipwhite (l_ptr)
						if (l_p___0.item.item).to_integer_32 = 125 then
							(create {P_GLOBALS_STATIC}).did_si.item := 1
						else
							(create {P_GLOBALS_STATIC}).can_si_back.item := 1
						end
				when 40 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_cursor.twin
				when 41 then -- if done | if done | if done | if done
						if l_do_si.to_boolean then
							(create {P_GLOBALS_STATIC}).can_si.item := 1
						end
						(create {P_GLOBALS_STATIC}).did_ai.item := 1
				when 42 then -- if done;
						(create {P_GLOBALS_STATIC}).end_comment_pending.item := ('%/0/').code
						if ((a_flags___0).bit_and (2)).to_boolean then
							l_lead_len := get_leader_len (l_saved_line, l_lead_flags, (a_dir___0 = -1).to_integer)
						else
							l_lead_len := 0
						end
						if not (l_lead_len > 0) then
							l_pos := -1 + 111 -- skip if block
						end
				when 43 then -- if:
						l_lead_repl := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_lead_repl_len := 0
						l_comment_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_extra_space := 0
						l_require_blank := 0
						l_p___0.item := l_lead_flags.item
				when 44 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 63 -- skip loop
						end
				when 45 then -- loop body:
						l_break := False
						l_continue := False
						if (l_p___0.item.item).to_boolean then
							if (l_p___0.item.item).to_integer_32 = 58 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then ((l_p___0.item.item).to_integer_32 = 98) then
							l_require_blank := 1
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 62 -- skip if block
						end
				when 46 then -- if:
						if (l_p___0.item.item).to_integer_32 /= 115 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						l_pos := -1 + 50 -- goto _L___5
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 49 then -- else:
						if (l_p___0.item.item).to_integer_32 /= 109 then
							l_pos := -1 + 62 -- skip if block
						end
				when 50 then -- if: | _L___5:
						l_current_flag := (l_p___0.item.item).to_integer_32
						if (l_p___0.item.item).to_integer_32 = 115 then
							if a_dir___0 = -1 then
								l_lead_len := 0
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_lead_middle, 50, ce_string (",")).do_nothing
								l_require_blank := 0
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 62 -- skip if block
						end
				when 51 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item.item).to_boolean then
								if (l_p___0.item[-1]).to_integer_32 = 58 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (l_p___0.item.item).to_integer_32 = 98 then
									l_require_blank := 1
								end
								l_p___0.item := l_p___0.item + 1
							end
						end
						l_break := False;
						(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_lead_middle, 50, ce_string (",")).do_nothing
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item.item).to_boolean then
								if (l_p___0.item[-1]).to_integer_32 = 58 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (l_p___0.item.item).to_integer_32 = 120 then
									(create {P_GLOBALS_STATIC}).end_comment_pending.item := -1
								end
								l_p___0.item := l_p___0.item + 1
							end
						end
						l_break := False
						l_n := (create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_lead_end, 50, ce_string (","))
						if (create {P_GLOBALS_STATIC}).end_comment_pending.item = -1 then
							(create {P_GLOBALS_STATIC}).end_comment_pending.item := (l_lead_end[l_n - 1]).to_integer_32
						end
						if a_dir___0 = 1 then
							l_p___0.item := l_saved_line + l_lead_len
							from
							until
								not (not (l_break) and then ((l_p___0.item.item).to_boolean))
							loop
								l_break := False
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_end), l_n.to_natural_32)) = 0 then
									l_comment_end := l_p___0.item
									l_lead_len := 0
									l_break := True
								end
								if not (l_break) then
									l_p___0.item := l_p___0.item + 1
								end
							end
							l_break := False
						end
						if not (l_lead_len > 0) then
							l_pos := -1 + 61 -- skip if block
						end
				when 52 then -- if:
						if l_current_flag = 115 then
							l_lead_repl := l_lead_middle
							l_lead_repl_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lead_middle))).to_integer_32
						end
						if ((l_saved_line[(l_lead_len - 1)]).to_integer_32 = 32) then
							l_pos := -1 + 61 -- skip if block
						end
				when 53 then -- if:
						if ((l_saved_line[(l_lead_len - 1)]).to_integer_32 = 9) then
							l_pos := -1 + 61 -- skip if block
						end
				when 54 then -- if:
						if l_p_extra.is_void then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = l_lead_len then
							l_extra_space := 1
						else
							l_pos := -1 + 57 -- goto _L___4
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 57 then -- else: | _L___4:
						if not (l_p_extra.is_void) then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						if (l_saved_line[l_lead_len]).to_integer_32 = 0 then
							l_extra_space := 1
						else
							l_pos := -1 + 60 -- goto _L___3
						end
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else: | _L___3:
						if l_require_blank.to_boolean then
							l_extra_space := 1
						end
				when 61 then -- if done | if done | if done | if done
						l_break := True
				when 62 then -- if done | if done | if done
						if not (l_return or l_break or l_continue) and then ((l_p___0.item.item).to_integer_32 = 101) then
							if a_dir___0 = 1 then
								l_comment_end := (create {P_CHARSET_STATIC}).skipwhite (l_saved_line)
								l_lead_len := 0
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								from
								until
									(l_break)
								loop
									l_break := False
									if ((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_com).c_pointer.to_integer_32).to_natural_32 then
										if (l_p___0.item.item).to_integer_32 = 44 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_p___0.item := l_p___0.item - 1
									end
								end
								l_break := False
								l_lead_repl := l_p___0.item
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_lead_repl.c_pointer.to_integer_32).to_natural_32 > (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_com).c_pointer.to_integer_32).to_natural_32 then
										if (l_lead_repl[-1]).to_integer_32 = 58 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										l_lead_repl := l_lead_repl - 1
									end
								end
								l_break := False
								l_lead_repl_len := (l_p___0.item).distance (l_lead_repl)
								l_extra_space := 1
								l_p2 := l_p___0.item
								from
								until
									(l_break)
								loop
									l_break := False
									if (l_p2.item).to_boolean then
										if (l_p2.item).to_integer_32 = 58 then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_break) then
										if (l_p2.item).to_integer_32 = 120 then
											(create {P_GLOBALS_STATIC}).end_comment_pending.item := -1
										end
										l_p2 := l_p2 + 1
									end
								end
								l_break := False
								if (create {P_GLOBALS_STATIC}).end_comment_pending.item = -1 then
									from
									until
										(l_break)
									loop
										l_break := False
										if (l_p2.item).to_boolean then
											if (l_p2.item).to_integer_32 = 44 then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_break) then
											l_p2 := l_p2 + 1
										end
									end
									l_break := False;
									(create {P_GLOBALS_STATIC}).end_comment_pending.item := (l_p2[-1]).to_integer_32
								end
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) and then ((l_p___0.item.item).to_integer_32 = 102) then
							if a_dir___0 = -1 then
								l_lead_len := 0
							else
								l_lead_repl := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
								l_lead_repl_len := 0
							end
							l_break := True
						end
						if (not l_return and not l_break) then
							l_p___0.item := l_p___0.item + 1
						end
						l_pos := -1 + 44 -- back to loop condition
				when 63 then -- loop done
						l_break := False
						l_continue := False
						if not (l_lead_len.to_boolean) then
							l_pos := -1 + 103 -- skip if block
						end
				when 64 then -- if:
						l_leader := (create {P_MISC2_STATIC}).alloc (((((l_lead_len + l_lead_repl_len) + l_extra_space) + l_extra_len) + 1).to_natural_32)
						l_allocated := l_leader
						if not (l_leader.is_void) then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_lead_len := 0
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 67 then -- else:;
						(create {P_MISC2_STATIC}).vim_strncpy (l_leader, l_saved_line, l_lead_len.to_natural_32)
						if l_lead_repl.is_void then
							l_pos := -1 + 96 -- skip if block
						end
				when 68 then -- if:
						l_c := 0
						l_off___0 := 0
						l_p___0.item := l_lead_flags.item
				when 69 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 82 -- skip loop
						end
				when 70 then -- loop body:
						l_break := False
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_p___0.item.item).to_integer_32 = 58 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 81 -- skip if block
						end
				when 71 then -- if:
						if (l_p___0.item.item).to_integer_32 /= 114 then
							l_pos := -1 + 74 -- skip if block
						end
				when 72 then -- if:
						l_tmp___10 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_c := (l_tmp___10.item).to_integer_32
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 74 then -- else:
						if (l_p___0.item.item).to_integer_32 /= 108 then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						l_tmp___10 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_c := (l_tmp___10.item).to_integer_32
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 77 then -- else:
						if not ((l_p___0.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if (l_p___0.item.item).to_integer_32 <= 57 then
							l_tmp___11 := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
							l_off___0 := l_tmp___11.to_integer_32
						else
							l_pos := -1 + 80 -- goto _L___6
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 81
				when 80 then -- else: | _L___6:
						if (l_p___0.item.item).to_integer_32 = 45 then
							l_tmp___11 := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
							l_off___0 := l_tmp___11.to_integer_32
						else
							l_p___0.item := l_p___0.item + 1
						end
				when 81 then -- if done | if done | if done
						l_pos := -1 + 69 -- back to loop condition
				when 82 then -- loop done
						l_break := False
						if l_c /= 114 then
							l_pos := -1 + 85 -- skip if block
						end
				when 83 then -- if:
						l_p___0.item := (l_leader + l_lead_len) - 1
						from
						until
							(l_break)
						loop
							l_break := False
							if ((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > (l_leader.c_pointer.to_integer_32).to_natural_32 then
								if (l_p___0.item.item).to_integer_32 /= 32 then
									if (l_p___0.item.item).to_integer_32 /= 9 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_p___0.item := l_p___0.item - 1
							end
						end
						l_break := False
						l_p___0.item := l_p___0.item + 1
						l_repl_size := ((create {P_CHARSET_STATIC}).vim_strnsize (l_lead_repl, l_lead_repl_len))
						l_old_size := 0
						l_endp := l_p___0.item
						from
						until
							(l_break)
						loop
							l_break := False
							if l_old_size < l_repl_size then
								if not (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > (l_leader.c_pointer.to_integer_32).to_natural_32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___14 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_leader, l_p___0.item - 1])) + 1
								else
									l_tmp___14 := 1
								end
								l_p___0.item := l_p___0.item - l_tmp___14
								l_old_size := l_old_size + ((create {P_CHARSET_STATIC}).ptr2cells (l_p___0.item))
							end
						end
						l_break := False
						l_l := l_lead_repl_len - (l_endp.distance ((l_p___0.item)))
						if l_l /= 0 then
							memmove (create {CE_VOID_POINTER}.make_cast ((l_endp + l_l)), create {CE_VOID_POINTER}.make_cast (l_endp), ((l_leader + l_lead_len).distance (l_endp)).to_natural_32).do_nothing
						end
						l_lead_len := l_lead_len + l_l
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0.item), create {CE_VOID_POINTER}.make_cast (l_lead_repl), l_lead_repl_len.to_natural_32).do_nothing
						if ((l_p___0.item + l_lead_repl_len).c_pointer.to_integer_32).to_natural_32 > ((l_leader + l_lead_len).c_pointer.to_integer_32).to_natural_32 then
							l_p___0.item[l_lead_repl_len] := (('%/0/').code).to_natural_8
						end
						from
						until
							(l_break)
						loop
							l_break := False
							l_p___0.item := l_p___0.item - 1
							if not (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 >= (l_leader.c_pointer.to_integer_32).to_natural_32) then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_l___0 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_leader, l_p___0.item]))
								if l_l___0 > 1 then
									l_p___0.item := l_p___0.item - l_l___0
									if ((create {P_CHARSET_STATIC}).ptr2cells (l_p___0.item)) > 1 then
										l_p___0.item[1] := ((' ').code).to_natural_8
										l_l___0 := l_l___0 - 1
									end
									memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0.item + 1)), create {CE_VOID_POINTER}.make_cast (((l_p___0.item + l_l___0) + 1)), ((l_leader + l_lead_len).distance (((l_p___0.item + l_l___0) + 1))).to_natural_32).do_nothing
									l_lead_len := l_lead_len - l_l___0
									l_p___0.item.item := ((' ').code).to_natural_8
								elseif (l_p___0.item.item).to_integer_32 /= 32 then
									if (l_p___0.item.item).to_integer_32 /= 9 then
										l_p___0.item.item := ((' ').code).to_natural_8
									end
								end
							end
						end
						l_break := False
				when 84 then -- if block done, skip else block:
						l_pos := -1 + 95
				when 85 then -- else:
						l_p___0.item := (create {P_CHARSET_STATIC}).skipwhite (l_leader)
						l_repl_size___0 := ((create {P_CHARSET_STATIC}).vim_strnsize (l_lead_repl, l_lead_repl_len))
						l_i___0 := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item[l_i___0]).to_integer_32 /= 0 then
								if not (l_i___0 < l_lead_len) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_l___1 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item + l_i___0])
								if ((create {P_CHARSET_STATIC}).vim_strnsize (l_p___0.item, l_i___0 + l_l___1)) > l_repl_size___0 then
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_i___0 := l_i___0 + l_l___1
							end
						end
						l_break := False
						if l_i___0 /= l_lead_repl_len then
							memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0.item + l_lead_repl_len)), create {CE_VOID_POINTER}.make_cast ((l_p___0.item + l_i___0)), ((l_lead_len - l_i___0) - ((l_p___0.item).distance (l_leader))).to_natural_32).do_nothing
							l_lead_len := l_lead_len + (l_lead_repl_len - l_i___0)
						end
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0.item), create {CE_VOID_POINTER}.make_cast (l_lead_repl), l_lead_repl_len.to_natural_32).do_nothing
						l_p___0.item := l_p___0.item + l_lead_repl_len
				when 86 then -- loop condition:
						if not (((l_p___0.item).c_pointer.to_integer_32).to_natural_32 < ((l_leader + l_lead_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 94 -- skip loop
						end
				when 87 then -- loop body:
						if ((l_p___0.item.item).to_integer_32 = 32) then
							l_pos := -1 + 93 -- skip if block
						end
				when 88 then -- if:
						if ((l_p___0.item.item).to_integer_32 = 9) then
							l_pos := -1 + 93 -- skip if block
						end
				when 89 then -- if:
						if not (((l_p___0.item + 1).c_pointer.to_integer_32).to_natural_32 < ((l_leader + l_lead_len).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						if (l_p___0.item[1]).to_integer_32 = 9 then
							l_lead_len := l_lead_len - 1
							memmove (create {CE_VOID_POINTER}.make_cast (l_p___0.item), create {CE_VOID_POINTER}.make_cast ((l_p___0.item + 1)), ((l_leader + l_lead_len).distance ((l_p___0.item))).to_natural_32).do_nothing
						else
							l_pos := -1 + 92 -- goto _L___7
						end
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 93
				when 92 then -- else: | _L___7:
						l_l___2 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
						if l_l___2 > 1 then
							if ((create {P_CHARSET_STATIC}).ptr2cells (l_p___0.item)) > 1 then
								l_l___2 := l_l___2 - 1
								l_tmp___21 := l_p___0.item
								l_p___0.item := l_p___0.item + 1
								l_tmp___21.item := ((' ').code).to_natural_8
							end
							memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0.item + 1)), create {CE_VOID_POINTER}.make_cast ((l_p___0.item + l_l___2)), ((l_leader + l_lead_len).distance ((l_p___0.item))).to_natural_32).do_nothing
							l_lead_len := l_lead_len - (l_l___2 - 1)
						end
						l_p___0.item.item := ((' ').code).to_natural_8
				when 93 then -- if done | if done
						l_p___0.item := l_p___0.item + 1
						l_pos := -1 + 86 -- back to loop condition
				when 94 then -- loop done
						l_p___0.item.item := (('%/0/').code).to_natural_8
				when 95 then -- if done
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean then
							l_newindent := get_indent_str (l_leader, ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32)
						elseif l_do_si.to_boolean then
							l_newindent := get_indent_str (l_leader, ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32)
						end
						if l_newindent + l_off___0 < 0 then
							l_off___0 := -l_newindent
							l_newindent := 0
						else
							l_newindent := l_newindent + l_off___0
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if l_off___0 > 0 then
								if l_lead_len > 0 then
									if (l_leader[(l_lead_len - 1)]).to_integer_32 /= 32 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								if not ((create {P_MISC2_STATIC}).vim_strchr (((create {P_CHARSET_STATIC}).skipwhite (l_leader)), ('%T').code)).is_void then
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_lead_len := l_lead_len - 1
								l_off___0 := l_off___0 - 1
							end
						end
						l_break := False
						if l_lead_len > 0 then
							if (l_leader[(l_lead_len - 1)]).to_integer_32 = 32 then
								l_extra_space := 0
							elseif (l_leader[(l_lead_len - 1)]).to_integer_32 = 9 then
								l_extra_space := 0
							end
						end
						l_leader[l_lead_len] := (('%/0/').code).to_natural_8
				when 96 then -- if done
						if l_extra_space.to_boolean then
							l_tmp___25 := l_lead_len
							l_lead_len := l_lead_len + 1
							l_leader[l_tmp___25] := ((' ').code).to_natural_8
							l_leader[l_lead_len] := (('%/0/').code).to_natural_8
						end
						l_newcol := l_lead_len
						if not (l_newindent.to_boolean) then
							l_pos := -1 + 99 -- skip if block
						end
				when 97 then -- if:
						l_pos := -1 + 100 -- goto _L___8
				when 98 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 99 then -- else:
						if not (((create {P_GLOBALS_STATIC}).did_si.item).to_boolean) then
							l_pos := -1 + 101 -- skip if block
						end
				when 100 then -- if: | _L___8:
						from
						until
							(l_break)
						loop
							l_break := False
							if l_lead_len.to_boolean then
								if (l_leader.item).to_integer_32 /= 32 then
									if (l_leader.item).to_integer_32 /= 9 then
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_lead_len := l_lead_len - 1
								l_newcol := l_newcol - 1
								l_leader := l_leader + 1
							end
						end
						l_break := False
				when 101 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).can_si.item := 0;
						(create {P_GLOBALS_STATIC}).did_si.item := (create {P_GLOBALS_STATIC}).can_si.item
				when 102 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 103 then -- else:
						if l_comment_end.is_void then
							l_pos := -1 + 111 -- skip if block
						end
				when 104 then -- if:
						if (l_comment_end[0]).to_integer_32 /= 42 then
							l_pos := -1 + 111 -- skip if block
						end
				when 105 then -- if:
						if (l_comment_end[1]).to_integer_32 /= 47 then
							l_pos := -1 + 111 -- skip if block
						end
				when 106 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean) then
							l_pos := -1 + 109 -- skip if block
						end
				when 107 then -- if:
						l_pos := -1 + 110 -- goto _L___9
				when 108 then -- if block done, skip else block:
						l_pos := -1 + 111
				when 109 then -- else:
						if not (l_do_si.to_boolean) then
							l_pos := -1 + 111 -- skip if block
						end
				when 110 then -- if: | _L___9:
						l_old_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_comment_end.distance (l_saved_line)
						l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('%/0/').code)
						if not l_pos___3.is_void then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_pos___3.item.lnum
							l_newindent := get_indent
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_cursor.twin
				when 111 then -- if done | if done | if done | if done | if done | if done
						if l_p_extra.is_void then
							l_pos := -1 + 127 -- skip if block
						end
				when 112 then -- if:
						l_p_extra.item := l_saved_char.to_natural_8
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
							if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
								(create {P_EDIT_STATIC}).replace_push (('%/0/').code)
							end
						end
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean) then
							l_pos := -1 + 115 -- skip if block
						end
				when 113 then -- if:
						l_pos := -1 + 116 -- goto _L___11
				when 114 then -- if block done, skip else block:
						l_pos := -1 + 126
				when 115 then -- else:
						if not (((a_flags___0).bit_and (1)).to_boolean) then
							l_pos := -1 + 126 -- skip if block
						end
				when 116 then -- if: | _L___11:
						if (l_break) then
							l_pos := -1 + 125 -- skip loop
						end
				when 117 then -- loop body:
						l_break := False
						if (l_p_extra.item).to_integer_32 /= 32 then
							l_pos := -1 + 120 -- skip if block
						end
				when 118 then -- if:
						l_pos := -1 + 121 -- goto _L___10
				when 119 then -- if block done, skip else block:
						l_pos := -1 + 124
				when 120 then -- else:
						if (l_p_extra.item).to_integer_32 /= 9 then
							l_pos := -1 + 123 -- skip if block
						end
				when 121 then -- if: | _L___10:
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (l_p_extra + 1)))).to_boolean then
								l_break := True
							end
						end
				when 122 then -- if block done, skip else block:
						l_pos := -1 + 124
				when 123 then -- else:
						l_break := True
				when 124 then -- if done
						if not (l_return or l_break or l_continue) then
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
								if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
									(create {P_EDIT_STATIC}).replace_push ((l_p_extra.item).to_integer_32)
								end
							end
							l_p_extra := l_p_extra + 1
							l_less_cols_off := l_less_cols_off + 1
						end
						l_pos := -1 + 116 -- back to loop condition
				when 125 then -- loop done
						l_break := False
				when 126 then -- if done
						if (l_p_extra.item).to_integer_32 /= 0 then
							(create {P_GLOBALS_STATIC}).did_ai.item := 0
						end
						l_less_cols := l_p_extra.distance (l_saved_line)
				when 127 then -- if done
						if l_p_extra.is_void then
							l_p_extra := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						end
						if l_lead_len.to_boolean then
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_leader), create {CE_INTEGER_8_POINTER}.make_cast (l_p_extra)).do_nothing
							l_p_extra := l_leader;
							(create {P_GLOBALS_STATIC}).did_ai.item := 1
							l_less_cols := l_less_cols - l_lead_len
						else
							(create {P_GLOBALS_STATIC}).end_comment_pending.item := ('%/0/').code
						end
						l_old_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						if a_dir___0 = -1 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
						end
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							l_pos := -1 + 130 -- skip if block
						end
				when 128 then -- if:
						l_pos := -1 + 131 -- goto _L___12
				when 129 then -- if block done, skip else block:
						l_pos := -1 + 135
				when 130 then -- else:
						if not (l_old_cursor.lnum >= ((create {P_GLOBALS_STATIC}).orig_line_count.item).to_integer_32) then
							l_pos := -1 + 134 -- skip if block
						end
				when 131 then -- if: | _L___12:
						if ((create {P_MEMLINE_STATIC}).ml_append ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_p_extra, 0, 0)) = 0 then
							l_pos := -1 + 157 -- goto theend
						end
				when 132 then;
						(create {P_MARK_STATIC}).mark_adjust ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1, 2_147_483_647, 1, 0)
						l_did_append := 1
				when 133 then -- if block done, skip else block:
						l_pos := -1 + 135
				when 134 then -- else:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum >= (create {P_GLOBALS_STATIC}).Insstart.item.item.lnum + ((create {P_GLOBALS_STATIC}).vr_lines_changed.item).to_integer_32 then
							(create {P_UNDO_STATIC}).u_save_cursor.do_nothing;
							(create {P_GLOBALS_STATIC}).vr_lines_changed.item := (create {P_GLOBALS_STATIC}).vr_lines_changed.item + 1
						end
						(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_p_extra, 1).do_nothing
						changed_bytes ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
						l_did_append := 0
				when 135 then -- if done
						if not (l_newindent.to_boolean) then
							l_pos := -1 + 138 -- skip if block
						end
				when 136 then -- if:
						l_pos := -1 + 139 -- goto _L___13
				when 137 then -- if block done, skip else block:
						l_pos := -1 + 140
				when 138 then -- else:
						if not (((create {P_GLOBALS_STATIC}).did_si.item).to_boolean) then
							l_pos := -1 + 140 -- skip if block
						end
				when 139 then -- if: | _L___13:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1
						if ((create {P_GLOBALS_STATIC}).did_si.item).to_boolean then
							if ((create {P_OPTION_STATIC}).p_sr.item.item).to_boolean then
								l_newindent := l_newindent - (l_newindent \\ ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32)
							end
							l_newindent := l_newindent + ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
						end
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ci).to_boolean then
							copy_indent (l_newindent, l_saved_line).do_nothing;
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_pi := 1
						else
							set_indent (l_newindent, 2).do_nothing
						end
						l_less_cols := l_less_cols - ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col);
						(create {P_GLOBALS_STATIC}).ai_col.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
							if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
								l_n := 0
								from
								until
									not (l_n < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
								loop
									(create {P_EDIT_STATIC}).replace_push (('%/0/').code)
									l_n := l_n + 1
								end
							end
						end
						l_newcol := l_newcol + ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
						if l_no_si.to_boolean then
							(create {P_GLOBALS_STATIC}).did_si.item := 0
						end
				when 140 then -- if done
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
							if not (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp___29 := l_lead_len
									l_lead_len := l_lead_len - 1
									if not (l_tmp___29 > 0) then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										(create {P_EDIT_STATIC}).replace_push (('%/0/').code)
									end
								end
								l_break := False
							end
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_cursor.twin
						if a_dir___0 /= 1 then
							l_pos := -1 + 147 -- skip if block
						end
				when 141 then -- if:
						if not (l_trunc_line.to_boolean) then
							l_pos := -1 + 144 -- skip if block
						end
				when 142 then -- if:
						l_pos := -1 + 145 -- goto _L___14
				when 143 then -- if block done, skip else block:
						l_pos := -1 + 146
				when 144 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean) then
							l_pos := -1 + 146 -- skip if block
						end
				when 145 then -- if: | _L___14:
						l_saved_line[(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col] := (('%/0/').code).to_natural_8
						if l_trunc_line.to_boolean then
							if not ((a_flags___0).bit_and (4)).to_boolean then
								(create {P_EDIT_STATIC}).truncate_spaces (l_saved_line)
							end
						end
						(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_saved_line, 0).do_nothing
						l_saved_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if l_did_append.to_boolean then
							changed_lines ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum + 1, 1)
							l_did_append := 0
							if ((a_flags___0).bit_and (8)).to_boolean then
								(create {P_MARK_STATIC}).mark_col_adjust ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + l_less_cols_off, 1, (-l_less_cols).to_integer_32)
							end
						else
							changed_bytes ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
						end
				when 146 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_old_cursor.lnum + 1
				when 147 then -- if done
						if l_did_append.to_boolean then
							changed_lines ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 0, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 1)
						end
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_newcol;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
							l_vreplace_mode := (create {P_GLOBALS_STATIC}).State.item;
							(create {P_GLOBALS_STATIC}).State.item := 16
						else
							l_vreplace_mode := 0
						end
						if not ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
							if l_leader.is_void then
								if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_lisp).to_boolean then
									if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ai).to_boolean then
										(create {P_EDIT_STATIC}).fixthisline (get_lisp_indent_address)
										l_p___0.item := (create {P_MEMLINE_STATIC}).ml_get_curline;
										(create {P_GLOBALS_STATIC}).ai_col.item := ((create {P_CHARSET_STATIC}).skipwhite (l_p___0.item)).distance ((l_p___0.item))
									end
								end
							end
						end
						if ((create {P_OPTION_STATIC}).p_paste.item.item).to_boolean then
							l_pos := -1 + 153 -- skip if block
						end
				when 148 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cin).to_boolean) then
							l_pos := -1 + 151 -- skip if block
						end
				when 149 then -- if:
						l_pos := -1 + 152 -- goto _L___15
				when 150 then -- if block done, skip else block:
						l_pos := -1 + 153
				when 151 then -- else:
						if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_inde).item).to_integer_32 = 0 then
							l_pos := -1 + 153 -- skip if block
						end
				when 152 then -- if: | _L___15:
						l_tmp___32 := (create {P_SEARCH_STATIC}).linewhite ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
						if a_dir___0 = 1 then
							l_tmp___33 := 257
						else
							l_tmp___33 := 258
						end
						if ((create {P_EDIT_STATIC}).in_cinkeys (l_tmp___33, (' ').code, l_tmp___32)).to_boolean then
							do_c_expr_indent
							l_p___0.item := (create {P_MEMLINE_STATIC}).ml_get_curline;
							(create {P_GLOBALS_STATIC}).ai_col.item := ((create {P_CHARSET_STATIC}).skipwhite (l_p___0.item)).distance ((l_p___0.item))
						end
				when 153 then -- if done | if done
						if l_vreplace_mode /= 0 then
							(create {P_GLOBALS_STATIC}).State.item := l_vreplace_mode
						end
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean) then
							l_pos := -1 + 156 -- skip if block
						end
				when 154 then -- if:
						l_p_extra := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get_curline))
						if l_p_extra.is_void then
							l_pos := -1 + 157 -- goto theend
						end
				when 155 then;
						(create {P_MEMLINE_STATIC}).ml_replace ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_next_line, 0).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
						ins_bytes (l_p_extra);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p_extra))
						l_next_line := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 156 then -- if done
						l_retval := 1
				when 157 then -- theend:;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_pi := l_saved_pi;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_saved_line));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_next_line));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_allocated))
						Result := l_retval
				when 158 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_leader_len (a_line: CE_POINTER [NATURAL_8]; a_flags___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_backward: INTEGER_32): INTEGER_32
		require
			not a_line.is_void
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_got_com: INTEGER_32
			l_found_one: INTEGER_32
			l_part_buf: CE_ARRAY [NATURAL_8]
			l_string___0: CE_POINTER [NATURAL_8]
			l_list: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_part_buf.make (<<50>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_list.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_got_com := 0
					l_i___0 := 0
					from
					until
						(l_break)
					loop
						l_break := False
						if (a_line[l_i___0]).to_integer_32 /= 32 then
							if (a_line[l_i___0]).to_integer_32 /= 9 then
								l_break := True
							end
						end
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
					end
					l_break := False
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then ((a_line[l_i___0]).to_boolean)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_found_one := 0
						l_list.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_com
				when 3 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_list.item.item).to_boolean)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						l_continue := False
						if not l_got_com.to_boolean then
							if not a_flags___0.is_void then
								a_flags___0.item := l_list.item
							end
						end
						(create {P_MISC2_STATIC}).copy_option_part (l_list, l_part_buf, 50, ce_string (",")).do_nothing
						l_string___0 := (create {P_MISC2_STATIC}).vim_strchr (l_part_buf, (':').code)
						if l_string___0.is_void then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_tmp := l_string___0
							l_string___0 := l_string___0 + 1
							l_tmp.item := (('%/0/').code).to_natural_8
							if l_got_com.to_boolean then
								if ((create {P_MISC2_STATIC}).vim_strchr (l_part_buf, ('n').code)).is_void then
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) and then (a_backward.to_boolean) then
							if not ((create {P_MISC2_STATIC}).vim_strchr (l_part_buf, ('O').code)).is_void then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if (l_string___0[0]).to_integer_32 /= 32 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if (l_string___0[0]).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_i___0 = 0 then
							l_continue := True
						elseif (a_line[(l_i___0 - 1)]).to_integer_32 /= 32 then
							if (a_line[(l_i___0 - 1)]).to_integer_32 /= 9 then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_string___0[0]).to_integer_32 /= 32 then
									if (l_string___0[0]).to_integer_32 /= 9 then
										l_break := True
									end
								end
								if not (l_break) then
									l_string___0 := l_string___0 + 1
								end
							end
							l_break := False
						end
				when 10 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							l_j := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_string___0[l_j]).to_integer_32 /= 0 then
									if (l_string___0[l_j]).to_integer_32 /= (a_line[(l_i___0 + l_j)]).to_integer_32 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_j := l_j + 1
								end
							end
							l_break := False
							if (l_string___0[l_j]).to_integer_32 /= 0 then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if not ((create {P_MISC2_STATIC}).vim_strchr (l_part_buf, ('b').code)).is_void then
								if (a_line[(l_i___0 + l_j)]).to_integer_32 /= 32 then
									if (a_line[(l_i___0 + l_j)]).to_integer_32 /= 9 then
										if (a_line[(l_i___0 + l_j)]).to_integer_32 /= 0 then
											l_continue := True
										end
									end
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := l_i___0 + l_j
							l_got_com := 1
							l_found_one := 1
							l_break := True
						end
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 3 -- back to loop condition
				when 11 then -- loop done
						l_break := False
						l_continue := False
						if not l_found_one.to_boolean then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							from
							until
								(l_break)
							loop
								l_break := False
								if (a_line[l_i___0]).to_integer_32 /= 32 then
									if (a_line[l_i___0]).to_integer_32 /= 9 then
										l_break := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_i___0 := l_i___0 + 1
								end
							end
							l_break := False
							if ((create {P_MISC2_STATIC}).vim_strchr (l_part_buf, ('n').code)).is_void then
								l_break := True
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					l_break := False
					if l_got_com.to_boolean then
						l_tmp___4 := l_i___0
					else
						l_tmp___4 := 0
					end
					Result := l_tmp___4
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	plines (a_lnum: INTEGER_32): INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curwin.item).item.plines_win (a_lnum, 1))
		end

	plines_nofill (a_lnum: INTEGER_32): INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curwin.item).item.plines_win_nofill (a_lnum, 1))
		end

	ins_bytes (a_p___0: CE_POINTER [NATURAL_8])
		do
			ins_bytes_len (a_p___0, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_p___0))).to_integer_32)
		end

	ins_bytes_len (a_p___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_n: INTEGER_32
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_len)
				loop
					if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
						l_n := (create {P_MBYTE_STATIC}).utfc_ptr2len_len (a_p___0 + l_i___0, a_len - l_i___0)
					else
						l_n := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_p___0 + l_i___0])
					end
					ins_char_bytes (a_p___0 + l_i___0, l_n)
					l_i___0 := l_i___0 + l_n
				end
			else
				l_i___0 := 0
				from
				until
					not (l_i___0 < a_len)
				loop
					ins_char ((a_p___0[l_i___0]).to_integer_32)
					l_i___0 := l_i___0 + 1
				end
			end
		end

	ins_char (a_c: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_n: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<21>>)

			l_n := (create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([a_c, l_buf___6])
			if (l_buf___6[0]).to_integer_32 = 0 then
				l_buf___6[0] := (('%N').code).to_natural_8
			end
			ins_char_bytes (l_buf___6, l_n)
		end

	ins_char_bytes (a_buf___6: CE_POINTER [NATURAL_8]; a_charlen: INTEGER_32)
		require
			not a_buf___6.is_void
		local
			l_c: INTEGER_32
			l_newlen: INTEGER_32
			l_oldlen: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldp: CE_POINTER [NATURAL_8]
			l_linelen___0: INTEGER_32
			l_col: INTEGER_32
			l_lnum: INTEGER_32
			l_i___0: INTEGER_32
			l_new_vcol: INTEGER_32
			l_vcol: CE_ARRAY [INTEGER_32]
			l_old_list: INTEGER_32
			l_tmp___7: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_vcol.make (<<1>>)

			l_c := (a_buf___6[0]).to_integer_32
			l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0 then
					(create {P_MISC2_STATIC}).coladvance_force (((create {P_MISC2_STATIC}).getviscol)).do_nothing
				end
			end
			l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			l_oldp := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
			l_linelen___0 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))).to_integer_32 + 1
			l_oldlen := 0
			l_newlen := a_charlen
			if (((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean then
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (128)).to_boolean then
					l_new_vcol := 0
					l_old_list := (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list
					if l_old_list.to_boolean then
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('L').code)).is_void then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := 0
						end
					end
					((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_vcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
					l_new_vcol := l_vcol.item + ((create {P_CHARSET_STATIC}).chartabsize (a_buf___6, l_vcol.item))
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_oldp[(l_col + l_oldlen)]).to_integer_32 /= 0 then
							if not (l_vcol.item < l_new_vcol) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_vcol.item := l_vcol.item + ((create {P_CHARSET_STATIC}).chartabsize ((l_oldp + l_col) + l_oldlen, l_vcol.item))
							if l_vcol.item > l_new_vcol then
								if (l_oldp[(l_col + l_oldlen)]).to_integer_32 = 9 then
									l_break := True
								end
							end
						end
						if not (l_break) then
							l_oldlen := l_oldlen + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([(l_oldp + l_col) + l_oldlen]))
							if l_vcol.item > l_new_vcol then
								l_newlen := l_newlen + (l_vcol.item - l_new_vcol)
							end
						end
					end
					l_break := False;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := l_old_list
				elseif (l_oldp[l_col]).to_integer_32 /= 0 then
					l_oldlen := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_oldp + l_col])
				end
				(create {P_EDIT_STATIC}).replace_push (('%/0/').code)
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_oldlen)
				loop
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_i___0 := l_i___0 + (((create {P_EDIT_STATIC}).replace_push_mb ((l_oldp + l_col) + l_i___0)) - 1)
					else
						(create {P_EDIT_STATIC}).replace_push ((l_oldp[(l_col + l_i___0)]).to_integer_32)
					end
					l_i___0 := l_i___0 + 1
				end
			end
			l_newp := (create {P_MISC2_STATIC}).alloc_check (((l_linelen___0 + l_newlen) - l_oldlen).to_natural_32)
			if l_newp.is_void then
				l_return := True
			end
			if not l_return then
				if l_col > 0 then
					memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), l_col.to_natural_32).do_nothing
				end
				l_p___0 := l_newp + l_col
				memmove (create {CE_VOID_POINTER}.make_cast ((l_p___0 + l_newlen)), create {CE_VOID_POINTER}.make_cast (((l_oldp + l_col) + l_oldlen)), ((l_linelen___0 - l_col) - l_oldlen).to_natural_32).do_nothing
				memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast (a_buf___6), a_charlen.to_natural_32).do_nothing
				l_i___0 := a_charlen
				from
				until
					not (l_i___0 < l_newlen)
				loop
					l_tmp___7 := l_i___0
					l_i___0 := l_i___0 + 1
					l_p___0[l_tmp___7] := ((' ').code).to_natural_8
				end
				(create {P_MEMLINE_STATIC}).ml_replace (l_lnum, l_newp, 0).do_nothing
				changed_bytes (l_lnum, l_col)
				if ((create {P_OPTION_STATIC}).p_sm.item.item).to_boolean then
					if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
						if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
							if a_charlen = 1 then
								if not ((create {P_EDIT_STATIC}).ins_compl_active).to_boolean then
									(create {P_SEARCH_STATIC}).showmatch (l_c)
								end
							end
						end
					end
				end
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + a_charlen
			end
		end

	ins_str (a_s: CE_POINTER [NATURAL_8])
		local
			l_oldp: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_newlen: INTEGER_32
			l_oldlen: INTEGER_32
			l_col: INTEGER_32
			l_lnum: INTEGER_32
			l_return: BOOLEAN
		do
			l_newlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_s))).to_integer_32
			l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
				if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd > 0 then
					(create {P_MISC2_STATIC}).coladvance_force (((create {P_MISC2_STATIC}).getviscol)).do_nothing
				end
			end
			l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			l_oldp := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
			l_oldlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))).to_integer_32
			l_newp := (create {P_MISC2_STATIC}).alloc_check (((l_oldlen + l_newlen) + 1).to_natural_32)
			if l_newp.is_void then
				l_return := True
			end
			if not l_return then
				if l_col > 0 then
					memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), l_col.to_natural_32).do_nothing
				end
				memmove (create {CE_VOID_POINTER}.make_cast ((l_newp + l_col)), create {CE_VOID_POINTER}.make_cast (a_s), l_newlen.to_natural_32).do_nothing
				memmove (create {CE_VOID_POINTER}.make_cast (((l_newp + l_col) + l_newlen)), create {CE_VOID_POINTER}.make_cast ((l_oldp + l_col)), ((l_oldlen - l_col) + 1).to_natural_32).do_nothing;
				(create {P_MEMLINE_STATIC}).ml_replace (l_lnum, l_newp, 0).do_nothing
				changed_bytes (l_lnum, l_col);
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + l_newlen
			end
		end

	del_char (a_fixpos: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				(create {P_MBYTE_STATIC}).mb_adjust_cursor
				if (((create {P_MEMLINE_STATIC}).ml_get_cursor).item).to_integer_32 = 0 then
					Result := 0
					l_return := True
				end
				if not l_return then
					Result := (del_chars (1, a_fixpos))
					l_return := True
				end
			end
			if not l_return then
				Result := (del_bytes (1, a_fixpos, 1))
			end
		end

	del_chars (a_count___2: INTEGER_32; a_fixpos: INTEGER_32): INTEGER_32
		local
			l_bytes___0: INTEGER_32
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_break: BOOLEAN
		do
			l_bytes___0 := 0
			l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_cursor
			l_i___0 := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i___0 < a_count___2 then
					if (l_p___0.item).to_integer_32 = 0 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
					l_bytes___0 := l_bytes___0 + l_l.to_integer_32
					l_p___0 := l_p___0 + l_l
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
			Result := (del_bytes (l_bytes___0, a_fixpos, 1))
		end

	del_bytes (a_count___2: INTEGER_32; a_fixpos_arg, a_use_delcombine: INTEGER_32): INTEGER_32
		local
			l_count___2: INTEGER_32
			l_oldp: CE_POINTER [NATURAL_8]
			l_newp: CE_POINTER [NATURAL_8]
			l_oldlen: INTEGER_32
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			l_was_alloced: INTEGER_32
			l_movelen: INTEGER_32
			l_fixpos: INTEGER_32
			l_cc___0: CE_ARRAY [INTEGER_32]
			l_n: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_cc___0.make (<<6>>)

			l_count___2 := a_count___2
			l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			l_fixpos := a_fixpos_arg
			l_oldp := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
			l_oldlen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_oldp))).to_integer_32
			if l_col >= l_oldlen then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((create {P_OPTION_STATIC}).p_deco.item.item).to_boolean then
					if a_use_delcombine.to_boolean then
						if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
							if ((create {P_MBYTE_STATIC}).utfc_ptr2len (l_oldp + l_col)).to_integer_32 >= l_count___2 then
								(create {P_MBYTE_STATIC}).utfc_ptr2char (l_oldp + l_col, l_cc___0).do_nothing
								if l_cc___0[0] /= 0 then
									l_n := l_col
									from
									until
										(l_break)
									loop
										l_break := False
										l_col := l_n
										l_count___2 := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_oldp + l_n)).to_integer_32
										l_n := (l_n.to_integer_32 + l_count___2).to_integer_32
										if not ((create {P_MBYTE_STATIC}).utf_iscomposing (((create {P_MBYTE_STATIC}).utf_ptr2char (l_oldp + l_n)))).to_boolean then
											l_break := True
										end
									end
									l_break := False
									l_fixpos := 0
								end
							end
						end
					end
				end
				l_movelen := ((l_oldlen.to_integer_32 - l_col.to_integer_32) - l_count___2) + 1
				if l_movelen <= 1 then
					if l_col > 0 then
						if l_fixpos.to_boolean then
							if (create {P_GLOBALS_STATIC}).restart_edit.item = 0 then
								if (((create {P_OPTION_STATIC}).ve_flags.item.item).bit_and ({NATURAL_32} 8)) = {NATURAL_32} 0 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 1;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
									if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_oldp, l_oldp + (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col]))
									end
								end
							end
						end
					end
					l_count___2 := (l_oldlen - l_col).to_integer_32
					l_movelen := 1
				end
				if ((create {P_NETBEANS_STATIC}).netbeans_active).to_boolean then
					l_was_alloced := 0
				else
					l_was_alloced := (create {P_MEMLINE_STATIC}).ml_line_alloced
				end
				if l_was_alloced.to_boolean then
					l_newp := l_oldp
				else
					l_newp := (create {P_MISC2_STATIC}).alloc (((l_oldlen + 1).to_integer_32 - l_count___2).to_natural_32)
					if l_newp.is_void then
						Result := 0
						l_return := True
					end
					if not l_return then
						memmove (create {CE_VOID_POINTER}.make_cast (l_newp), create {CE_VOID_POINTER}.make_cast (l_oldp), l_col.to_natural_32).do_nothing
					end
				end
			end
			if not l_return then
				memmove (create {CE_VOID_POINTER}.make_cast ((l_newp + l_col)), create {CE_VOID_POINTER}.make_cast (((l_oldp + l_col) + l_count___2)), l_movelen.to_natural_32).do_nothing
				if not l_was_alloced.to_boolean then
					(create {P_MEMLINE_STATIC}).ml_replace (l_lnum, l_newp, 0).do_nothing
				end
				changed_bytes (l_lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
				Result := 1
			end
		end

	truncate_line (a_fixpos: INTEGER_32): INTEGER_32
		local
			l_newp: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_col: INTEGER_32
			l_return: BOOLEAN
		do
			l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			l_col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col
			if l_col = 0 then
				l_newp := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
			else
				l_newp := (create {P_MISC2_STATIC}).vim_strnsave (((create {P_MEMLINE_STATIC}).ml_get (l_lnum)), l_col)
			end
			if l_newp.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_MEMLINE_STATIC}).ml_replace (l_lnum, l_newp, 0).do_nothing
				changed_bytes (l_lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col)
				if a_fixpos.to_boolean then
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col > 0 then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) - 1
					end
				end
				Result := 1
			end
		end

	del_lines (a_nlines: INTEGER_32; a_undo: INTEGER_32)
		local
			l_n: INTEGER_32
			l_first___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_first___0 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			if a_nlines <= 0 then
				l_return := True
			end
			if not l_return and then (a_undo.to_boolean) then
				if ((create {P_UNDO_STATIC}).u_savedel (l_first___0, a_nlines)) = 0 then
					l_return := True
				end
			end
			if not l_return then
				l_n := 0
				from
				until
					not (not (l_break) and then (l_n < a_nlines))
				loop
					l_break := False
					if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_flags).bit_and (1)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						(create {P_MEMLINE_STATIC}).ml_delete (l_first___0, 1).do_nothing
						l_n := l_n + 1
						if l_first___0 > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_break := True
						end
					end
				end
				l_break := False;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
				(create {P_MISC2_STATIC}).check_cursor_lnum
				deleted_lines_mark (l_first___0, l_n)
			end
		end

	gchar_cursor: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				Result := ((create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([((create {P_MEMLINE_STATIC}).ml_get_cursor)]))
				l_return := True
			end
			if not l_return then
				Result := (((create {P_MEMLINE_STATIC}).ml_get_cursor).item).to_integer_32
			end
		end

	pchar_cursor (a_c: INTEGER_32)
		do
			(((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_get_buf ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 1))[(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col] := a_c.to_natural_8
		end

	inindent (a_extra: INTEGER_32): INTEGER_32
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_col: INTEGER_32
			l_break: BOOLEAN
		do
			l_col := 0
			l_ptr := (create {P_MEMLINE_STATIC}).ml_get_curline
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_ptr.item).to_integer_32 /= 32 then
					if (l_ptr.item).to_integer_32 /= 9 then
						l_break := True
					end
				end
				if not (l_break) then
					l_ptr := l_ptr + 1
					l_col := l_col + 1
				end
			end
			l_break := False
			if l_col >= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + a_extra then
				Result := 1
			else
				Result := 0
			end
		end

	skip_to_option_part (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			l_p___0 := a_p___0
			if (l_p___0.item).to_integer_32 = 44 then
				l_p___0 := l_p___0 + 1
			end
			from
			until
				(l_p___0.item).to_integer_32 /= 32
			loop
				l_p___0 := l_p___0 + 1
			end
			Result := l_p___0
		end

	changed
		local
			l_save_msg_scroll: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_MBYTE_STATIC}).im_is_preediting).to_boolean then
				if not ((create {P_GLOBALS_STATIC}).xim_changed_while_preediting.item).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				(create {P_GLOBALS_STATIC}).xim_changed_while_preediting.item := 0
				if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed).to_boolean then
					l_save_msg_scroll := (create {P_GLOBALS_STATIC}).msg_scroll.item
					change_warning (0)
					if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_may_swap).to_boolean then
						if not (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_dontwrite).to_boolean then
							((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_open_file
							if ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).emsg_silent.item = 0 then
									(create {P_TERM_STATIC}).out_flush;
									(create {P_UI_STATIC}).ui_delay (2_000, 1);
									(create {P_MESSAGE_STATIC}).wait_return (1);
									(create {P_GLOBALS_STATIC}).msg_scroll.item := l_save_msg_scroll
								end
							end
						end
					end
					changed_int
				end
				(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changedtick := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changedtick) + 1
			end
		end

	changed_int
		do
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changed := 1;
			((create {P_GLOBALS_STATIC}).curbuf.item).item.ml_setflags
			check_status ((create {P_GLOBALS_STATIC}).curbuf.item);
			(create {P_GLOBALS_STATIC}).redraw_tabline.item := 1;
			(create {P_GLOBALS_STATIC}).need_maketitle.item := 1
		end

	changed_bytes (a_lnum: INTEGER_32; a_col: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_wlnum: INTEGER_32
		do
			((create {P_GLOBALS_STATIC}).curbuf.item).item.changedOneline (a_lnum)
			changed_common (a_lnum, a_col, a_lnum + 1, 0)
			if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff).to_boolean then
				l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				from
				until
					l_wp___0.is_void
				loop
					if (l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
						if not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
							l_wp___0.item.redraw_win_later (10)
							l_wlnum := (create {P_DIFF_STATIC}).diff_lnum_win (a_lnum, l_wp___0)
							if l_wlnum > 0 then
								(l_wp___0.item.w_buffer).item.changedOneline (l_wlnum)
							end
						end
					end
					l_wp___0 := l_wp___0.item.w_next
				end
			end
		end

	appended_lines_mark (a_lnum, a_count___2: INTEGER_32)
		do
			(create {P_MARK_STATIC}).mark_adjust (a_lnum + 1, 2_147_483_647, a_count___2, 0)
			changed_lines (a_lnum + 1, 0, a_lnum + 1, a_count___2)
		end

	deleted_lines_mark (a_lnum, a_count___2: INTEGER_32)
		do
			(create {P_MARK_STATIC}).mark_adjust (a_lnum, (a_lnum + a_count___2) - 1, 2_147_483_647, -a_count___2)
			changed_lines (a_lnum, 0, a_lnum + a_count___2, -a_count___2)
		end

	changed_lines (a_lnum: INTEGER_32; a_col: INTEGER_32; a_lnume, a_xtra: INTEGER_32)
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_wlnum: INTEGER_32
		do
			((create {P_GLOBALS_STATIC}).curbuf.item).item.changed_lines_buf (a_lnum, a_lnume, a_xtra)
			if a_xtra = 0 then
				if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff).to_boolean then
					l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
					from
					until
						l_wp___0.is_void
					loop
						if (l_wp___0.item.w_onebuf_opt.wo_diff).to_boolean then
							if not l_wp___0.is_equal ((create {P_GLOBALS_STATIC}).curwin.item) then
								l_wp___0.item.redraw_win_later (10)
								l_wlnum := (create {P_DIFF_STATIC}).diff_lnum_win (a_lnum, l_wp___0)
								if l_wlnum > 0 then
									(l_wp___0.item.w_buffer).item.changed_lines_buf (l_wlnum, (a_lnume - a_lnum) + l_wlnum, 0)
								end
							end
						end
						l_wp___0 := l_wp___0.item.w_next
					end
				end
			end
			changed_common (a_lnum, a_col, a_lnume, a_xtra)
		end

	changed_common (a_lnum: INTEGER_32; a_col: INTEGER_32; a_lnume, a_xtra: INTEGER_32)
		local
			l_lnume: CE_ARRAY [INTEGER_32]
			l_lnum: CE_ARRAY [INTEGER_32]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_i___0: INTEGER_32
			l_cols: INTEGER_32
			l_p___0: CE_POINTER [PD_POS_T]
			l_add: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_lnume.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnume.item := a_lnume
					l_lnum.item := a_lnum
					changed
					if ((create {P_GLOBALS_STATIC}).cmdmod.item.item.keepjumps).to_boolean then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_last_change.lnum := l_lnum.item;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_last_change.col := a_col
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_new_change).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen = 0 then
							l_add := 1
						else
							l_p___0 := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curbuf.item.c_pointer + (create {PD_FILE_BUFFER}.make).offset_of ("b_changelist") + (create {PD_POS_T}.make).structure_size * ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen - 1))
							if l_p___0.item.lnum /= l_lnum.item then
								l_add := 1
							else
								l_cols := (create {P_EDIT_STATIC}).comp_textwidth (0)
								if l_cols = 0 then
									l_cols := 79
								end
								if l_p___0.item.col + l_cols < a_col then
									l_tmp := 1
								elseif a_col + l_cols < l_p___0.item.col then
									l_tmp := 1
								else
									l_tmp := 0
								end
								l_add := l_tmp
							end
						end
						if l_add.to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_new_change := 0
							if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen = 100 then
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen := 99
								memmove (create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist)), create {CE_VOID_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist + 1)), (create {PD_POS_T}.make).structure_size.to_natural_32 * {NATURAL_32} 99).do_nothing
								l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
								from
								until
									not (not (l_return) and then (not l_tp.is_void))
								loop
									if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
										l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
									else
										l_wp___0 := l_tp.item.tp_firstwin
									end
									from
									until
										l_wp___0.is_void
									loop
										if (l_wp___0.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
											if l_wp___0.item.w_changelistidx > 0 then
												l_wp___0.item.w_changelistidx := (l_wp___0.item.w_changelistidx) - 1
											end
										end
										l_wp___0 := l_wp___0.item.w_next
									end
									l_tp := l_tp.item.tp_next
								end
							end
							l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
							from
							until
								not (not (l_return) and then (not l_tp.is_void))
							loop
								if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
									l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
								else
									l_wp___0 := l_tp.item.tp_firstwin
								end
								from
								until
									l_wp___0.is_void
								loop
									if (l_wp___0.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
										if l_wp___0.item.w_changelistidx = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen then
											l_wp___0.item.w_changelistidx := (l_wp___0.item.w_changelistidx) + 1
										end
									end
									l_wp___0 := l_wp___0.item.w_next
								end
								l_tp := l_tp.item.tp_next
							end
							(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen) + 1
						end
				when 6 then -- if done;
						(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelist[(create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen - 1] := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_last_change).twin;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_changelistidx := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_changelistlen
				when 7 then -- if done
					l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
					from
					until
						not (not (l_return) and then (not l_tp.is_void))
					loop
						if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
							l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						else
							l_wp___0 := l_tp.item.tp_firstwin
						end
						from
						until
							not (not (l_return) and then (not l_wp___0.is_void))
						loop
							if (l_wp___0.item.w_buffer).is_equal ((create {P_GLOBALS_STATIC}).curbuf.item) then
								if l_wp___0.item.w_redr_type < 10 then
									l_wp___0.item.w_redr_type := 10
								end
								l_wp___0.item.foldUpdate (l_lnum.item, (l_lnume.item + a_xtra) - 1)
								l_i___0 := l_wp___0.item.hasFoldingWin (l_lnum.item, l_lnum, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 0, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
								if l_wp___0.item.w_cursor.lnum = l_lnum.item then
									l_wp___0.item.w_cline_folded := l_i___0
								end
								l_i___0 := l_wp___0.item.hasFoldingWin (l_lnume.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_lnume, 0, create {CE_CLASS_POINTER [PD_FOLDINFO]}.make_shared (default_pointer))
								if l_wp___0.item.w_cursor.lnum = l_lnume.item then
									l_wp___0.item.w_cline_folded := l_i___0
								end
								if l_wp___0.item.w_cursor.lnum <= l_lnum.item then
									l_i___0 := l_wp___0.item.find_wl_entry (l_lnum.item)
									if l_i___0 >= 0 then
										if l_wp___0.item.w_cursor.lnum > (l_wp___0.item.w_lines + l_i___0).item.wl_lnum then
											l_wp___0.item.changed_line_abv_curs_win
										end
									end
								end
								if l_wp___0.item.w_cursor.lnum > l_lnum.item then
									l_wp___0.item.changed_line_abv_curs_win
								elseif l_wp___0.item.w_cursor.lnum = l_lnum.item then
									if l_wp___0.item.w_cursor.col >= a_col then
										l_wp___0.item.changed_cline_bef_curs_win
									end
								end
								if l_wp___0.item.w_botline >= l_lnum.item then
									l_wp___0.item.approximate_botline_win
								end
								l_i___0 := 0
								from
								until
									not (l_i___0 < l_wp___0.item.w_lines_valid)
								loop
									if ((l_wp___0.item.w_lines + l_i___0).item.wl_valid).to_boolean then
										if (l_wp___0.item.w_lines + l_i___0).item.wl_lnum >= l_lnum.item then
											if (l_wp___0.item.w_lines + l_i___0).item.wl_lnum < l_lnume.item then
												(l_wp___0.item.w_lines + l_i___0).item.wl_valid := (0).to_integer_8
											elseif a_xtra /= 0 then
												(l_wp___0.item.w_lines + l_i___0).item.wl_lnum := (l_wp___0.item.w_lines + l_i___0).item.wl_lnum + a_xtra;
												(l_wp___0.item.w_lines + l_i___0).item.wl_lastlnum := (l_wp___0.item.w_lines + l_i___0).item.wl_lastlnum + a_xtra
											end
										elseif (l_wp___0.item.w_lines + l_i___0).item.wl_lastlnum >= l_lnum.item then
											(l_wp___0.item.w_lines + l_i___0).item.wl_valid := (0).to_integer_8
										end
									end
									l_i___0 := l_i___0 + 1
								end
								if (l_wp___0.item.hasAnyFolding).to_boolean then
									l_wp___0.item.set_topline (l_wp___0.item.w_topline)
								end
							end
							l_wp___0 := l_wp___0.item.w_next
						end
						l_tp := l_tp.item.tp_next
					end
					if (create {P_GLOBALS_STATIC}).must_redraw.item < 10 then
						(create {P_GLOBALS_STATIC}).must_redraw.item := 10
					end
					if l_lnum.item <= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
						if a_xtra < 0 then
							l_tmp___1 := -a_xtra
						else
							l_tmp___1 := a_xtra
						end
						if l_lnume.item + l_tmp___1 > (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							(create {P_GLOBALS_STATIC}).last_cursormoved.item.lnum := (0).to_integer_32
						end
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_status (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
		do
			l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
			from
			until
				l_wp___0.is_void
			loop
				if (l_wp___0.item.w_buffer).is_equal (a_buf___6) then
					if (l_wp___0.item.w_status_height).to_boolean then
						l_wp___0.item.w_redr_status := 1
						if (create {P_GLOBALS_STATIC}).must_redraw.item < 10 then
							(create {P_GLOBALS_STATIC}).must_redraw.item := 10
						end
					end
				end
				l_wp___0 := l_wp___0.item.w_next
			end
		end

	change_warning (a_col: INTEGER_32)
		local
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).curbuf.item.item.b_did_warn = 0 then
				if ((create {P_UNDO_STATIC}).curbufIsChanged) = 0 then
					if not ((create {P_GLOBALS_STATIC}).autocmd_busy.item).to_boolean then
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro).to_boolean then
							(create {P_GLOBALS_STATIC}).curbuf_lock.item := (create {P_GLOBALS_STATIC}).curbuf_lock.item + 1;
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_FILECHANGEDRO, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing;
							(create {P_GLOBALS_STATIC}).curbuf_lock.item := (create {P_GLOBALS_STATIC}).curbuf_lock.item - 1
							if not ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ro).to_boolean then
								l_return := True
							end
							if not l_return then
								(create {P_MESSAGE_STATIC}).msg_start
								if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 = (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
									(create {P_GLOBALS_STATIC}).msg_col.item := a_col
								end
								(create {P_MESSAGE_STATIC}).msg_source ((create {P_GLOBALS_STATIC}).highlight_attr.item[17]);
								(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (w_readonly.item))), ((create {P_GLOBALS_STATIC}).highlight_attr.item[17]).bit_or (4_096));
								(create {P_EVAL_STATIC}).set_vim_var_string (4, create {CE_NATURAL_8_POINTER}.make_cast ((gettext (w_readonly.item))), -1);
								(create {P_MESSAGE_STATIC}).msg_clr_eos;
								(create {P_MESSAGE_STATIC}).msg_end.do_nothing
								if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
									if not ((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean then
										(create {P_TERM_STATIC}).out_flush;
										(create {P_UI_STATIC}).ui_delay (1_000, 1)
									end
								end
								(create {P_GLOBALS_STATIC}).curbuf.item.item.b_did_warn := 1;
								(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 0
								if ((create {P_GLOBALS_STATIC}).msg_row.item).to_integer_32 < (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
									(create {P_SCREEN_STATIC}).showmode.do_nothing
								end
							end
						end
					end
				end
			end
			if not l_return then
			end
		end

	ask_yesno (a_str___1: CE_POINTER [NATURAL_8]; a_direct: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_save_State: INTEGER_32
			l_break: BOOLEAN
		do
			l_r := (' ').code
			l_save_State := (create {P_GLOBALS_STATIC}).State.item
			if ((create {P_GLOBALS_STATIC}).exiting.item).to_boolean then
				(create {P_TERM_STATIC}).settmode (2)
			end
			(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item + 1;
			(create {P_GLOBALS_STATIC}).dont_scroll.item := 1;
			(create {P_GLOBALS_STATIC}).State.item := 2_048;
			(create {P_TERM_STATIC}).setmouse;
			(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1;
			(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
			from
			until
				(l_break)
			loop
				l_break := False
				if l_r /= 121 then
					if l_r = 110 then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					(create {P_MESSAGE_STATIC}).smsg_attr ([(create {P_GLOBALS_STATIC}).highlight_attr.item[10], create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%%s (y/n)?")), a_str___1]).do_nothing
					if a_direct.to_boolean then
						l_r := get_keystroke
					else
						l_r := (create {P_GETCHAR_STATIC}).plain_vgetc
					end
					if l_r = 3 then
						l_r := ('n').code
					elseif l_r = 27 then
						l_r := ('n').code
					end
					(create {P_MESSAGE_STATIC}).msg_putchar (l_r);
					(create {P_TERM_STATIC}).out_flush
				end
			end
			l_break := False;
			(create {P_GLOBALS_STATIC}).no_wait_return.item := (create {P_GLOBALS_STATIC}).no_wait_return.item - 1;
			(create {P_GLOBALS_STATIC}).State.item := l_save_State;
			(create {P_TERM_STATIC}).setmouse;
			(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
			(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
			Result := l_r
		end

	get_keystroke: INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_n: INTEGER_32
			l_save_mapped_ctrl_c: INTEGER_32
			l_waited: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<151>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 0
					l_save_mapped_ctrl_c := (create {P_GLOBALS_STATIC}).mapped_ctrl_c.item
					l_waited := 0;
					(create {P_GLOBALS_STATIC}).mapped_ctrl_c.item := 0
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 77 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False;
						(create {P_TERM_STATIC}).cursor_on;
						(create {P_TERM_STATIC}).out_flush
						if l_len = 0 then
							l_tmp := -1
						else
							l_tmp := 100
						end
						l_n := (create {P_UI_STATIC}).ui_inchar (l_buf___6 + l_len, (145 - l_len) // 3, l_tmp, 0)
						if l_n > 0 then
							l_n := (create {P_GETCHAR_STATIC}).fix_input_buffer (l_buf___6 + l_len, l_n, 0)
							l_len := l_len + l_n
							l_waited := 0
						elseif l_len > 0 then
							l_waited := l_waited + 1
						end
						l_n := (create {P_TERM_STATIC}).check_termcode (1, l_buf___6, l_len)
						if l_n < 0 then
							if not ((create {P_OPTION_STATIC}).p_ttimeout.item.item).to_boolean then
								l_continue := True
							else
								if (create {P_OPTION_STATIC}).p_ttm.item.item < 0 then
									l_tmp___0 := (create {P_OPTION_STATIC}).p_tm.item.item
								else
									l_tmp___0 := (create {P_OPTION_STATIC}).p_ttm.item.item
								end
								if l_waited.to_integer_32 * 100 < l_tmp___0 then
									l_continue := True
								end
							end
						end
						if not (l_break or l_continue) then
							if l_n > 0 then
								l_len := l_n
							end
							if l_len = 0 then
								l_continue := True
							end
						end
						if (l_break or l_continue) then
							l_pos := -1 + 76 -- skip if block
						end
				when 3 then -- if:
						l_n := (l_buf___6[0]).to_integer_32
						if l_n /= 128 then
							l_pos := -1 + 76 -- skip if block
						end
				when 4 then -- if:
						if (l_buf___6[1]).to_integer_32 = 254 then
							l_n := 128
						else
							if (l_buf___6[1]).to_integer_32 = 255 then
								l_tmp___1 := -(255 + ((88).bit_shift_left (8)))
							else
								l_tmp___1 := -((l_buf___6[1]).to_integer_32 + (((l_buf___6[2]).to_integer_32).bit_shift_left (8)))
							end
							l_n := l_tmp___1
						end
						if (l_buf___6[1]).to_integer_32 /= 252 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 7 then -- else:
						if l_n /= -(253 + ((53).bit_shift_left (8))) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 10 then -- else:
						if l_n /= -(253 + ((69).bit_shift_left (8))) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 13 then -- else:
						if l_n /= -(253 + ((45).bit_shift_left (8))) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 16 then -- else:
						if l_n /= -(253 + ((46).bit_shift_left (8))) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 19 then -- else:
						if l_n /= -(253 + ((70).bit_shift_left (8))) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 22 then -- else:
						if l_n /= -(253 + ((47).bit_shift_left (8))) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 25 then -- else:
						if l_n /= -(253 + ((48).bit_shift_left (8))) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 28 then -- else:
						if l_n /= -(253 + ((49).bit_shift_left (8))) then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 31 then -- else:
						if l_n /= -(253 + ((50).bit_shift_left (8))) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 34 then -- else:
						if l_n /= -(253 + ((51).bit_shift_left (8))) then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 37 then -- else:
						if l_n /= -(253 + ((52).bit_shift_left (8))) then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 40 then -- else:
						if l_n /= -(253 + ((75).bit_shift_left (8))) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 43 then -- else:
						if l_n /= -(253 + ((76).bit_shift_left (8))) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 46 then -- else:
						if l_n /= -(253 + ((77).bit_shift_left (8))) then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 49 then -- else:
						if l_n /= -(253 + ((78).bit_shift_left (8))) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 52 then -- else:
						if l_n /= -(253 + ((89).bit_shift_left (8))) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 55 then -- else:
						if l_n /= -(253 + ((90).bit_shift_left (8))) then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 58 then -- else:
						if l_n /= -(253 + ((91).bit_shift_left (8))) then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 61 then -- else:
						if l_n /= -(253 + ((92).bit_shift_left (8))) then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 64 then -- else:
						if l_n /= -(253 + ((93).bit_shift_left (8))) then
							l_pos := -1 + 67 -- skip if block
						end
				when 65 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 66 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 67 then -- else:
						if l_n /= -(253 + ((94).bit_shift_left (8))) then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 70 then -- else:
						if l_n /= -(249 + ((88).bit_shift_left (8))) then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 74 -- goto _L
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 73 then -- else:
						if l_n /= -(248 + ((88).bit_shift_left (8))) then
							l_pos := -1 + 75 -- skip if block
						end
				when 74 then -- if: | _L:
						if (l_buf___6[1]).to_integer_32 = 252 then
							(create {P_GLOBALS_STATIC}).mod_mask.item.item := (l_buf___6[2]).to_integer_32
						end
						l_len := l_len - (3)
						if l_len > 0 then
							memmove (create {CE_VOID_POINTER}.make_cast (l_buf___6), create {CE_VOID_POINTER}.make_cast ((l_buf___6 + 3)), l_len.to_natural_32).do_nothing
						end
						l_continue := True
				when 75 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not (l_break or l_continue) then
							l_break := True
						end
				when 76 then -- if done | if done
						if not (l_break or l_continue) and then (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_n]).to_integer_32 > l_len then
								l_continue := True
							end
							if not (l_break or l_continue) then
								if l_len >= 151 then
									l_tmp___2 := 150
								else
									l_tmp___2 := l_len
								end
								l_buf___6[l_tmp___2] := (('%/0/').code).to_natural_8
								l_n := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_buf___6])
							end
						end
						if not (l_break or l_continue) then
							if l_n = (create {P_GLOBALS_STATIC}).intr_char.item then
								l_n := ('%/27/').code
							end
							l_break := True
						end
						if (not l_break) then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 77 then -- loop done
					l_break := False
					l_continue := False;
					(create {P_GLOBALS_STATIC}).mapped_ctrl_c.item := l_save_mapped_ctrl_c
					Result := l_n
				when 78 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_number (a_colon: INTEGER_32; a_mouse_used: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_typed: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := 0
					l_typed := 0
					if not a_mouse_used.is_void then
						a_mouse_used.item := 0
					end
					if (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 1 then -- if:;
						(create {P_GLOBALS_STATIC}).dont_scroll.item := 1;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item + 1;
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item + 1
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 26 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False;
						(create {P_SCREEN_STATIC}).windgoto ((create {P_GLOBALS_STATIC}).msg_row.item, (create {P_GLOBALS_STATIC}).msg_col.item)
						l_c := (create {P_GETCHAR_STATIC}).safe_vgetc
						if not (l_c >= 48) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_c <= 57 then
							l_n := (l_n * 10 + l_c) - 48;
							(create {P_MESSAGE_STATIC}).msg_putchar (l_c)
							l_typed := l_typed + 1
						else
							l_pos := -1 + 6 -- goto _L___3
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 6 then -- else: | _L___3:
						if l_c /= -(107 + ((68).bit_shift_left (8))) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 16 -- goto _L___2
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 9 then -- else:
						if l_c /= -(253 + ((80).bit_shift_left (8))) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 16 -- goto _L___2
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 12 then -- else:
						if l_c /= -(107 + ((98).bit_shift_left (8))) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L___2
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else:
						if l_c /= 8 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if: | _L___2:
						if l_typed > 0 then
							(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%B %B")))
							l_typed := l_typed - 1
						end
						l_n := l_n // (10)
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else:
						if a_mouse_used.is_void then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if l_c = -(253 + ((44).bit_shift_left (8))) then
							a_mouse_used.item := 1
							l_n := (create {P_GLOBALS_STATIC}).mouse_row.item + 1
							l_break := True
						else
							l_pos := -1 + 21 -- goto _L___1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 21 then -- else: | _L___1:
						if l_n /= 0 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if l_c = 58 then
							if a_colon.to_boolean then
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff ((':').code)
								if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
									(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
								end
								(create {P_GLOBALS_STATIC}).skip_redraw.item := 1;
								(create {P_GLOBALS_STATIC}).do_redraw.item := 0
								l_break := True
							else
								l_pos := -1 + 24 -- goto _L___0
							end
						else
							l_pos := -1 + 24 -- goto _L___0
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else: | _L___0:
						if l_c = 13 then
							l_break := True
						elseif l_c = 10 then
							l_break := True
						elseif l_c = 3 then
							l_break := True
						elseif l_c = 27 then
							l_break := True
						end
				when 25 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 26 then -- loop done
						l_break := False;
						(create {P_GLOBALS_STATIC}).no_mapping.item := (create {P_GLOBALS_STATIC}).no_mapping.item - 1;
						(create {P_GLOBALS_STATIC}).allow_keys.item := (create {P_GLOBALS_STATIC}).allow_keys.item - 1
						Result := l_n
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prompt_for_number (a_mouse_used: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_save_cmdline_row: INTEGER_32
			l_save_State: INTEGER_32
		do
			if not a_mouse_used.is_void then
				(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Type number and <Enter> or click with mouse (empty cancels): ")))))
			else
				(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Type number and <Enter> (empty cancels): ")))))
			end
			l_save_cmdline_row := (create {P_GLOBALS_STATIC}).cmdline_row.item;
			(create {P_GLOBALS_STATIC}).cmdline_row.item := 0
			l_save_State := (create {P_GLOBALS_STATIC}).State.item;
			(create {P_GLOBALS_STATIC}).State.item := 8
			l_i___0 := get_number (1, a_mouse_used)
			if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
				(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item - 1;
				(create {P_GLOBALS_STATIC}).need_wait_return.item := 0;
				(create {P_GLOBALS_STATIC}).msg_didany.item := 0;
				(create {P_GLOBALS_STATIC}).msg_didout.item := 0
			else
				(create {P_GLOBALS_STATIC}).cmdline_row.item := l_save_cmdline_row
			end
			(create {P_GLOBALS_STATIC}).State.item := l_save_State
			Result := l_i___0
		end

	msgmore (a_n: INTEGER_32)
		local
			l_pn: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
				l_return := True
			elseif not ((create {P_SCREEN_STATIC}).messaging).to_boolean then
				l_return := True
			end
			if not l_return and then (not ((create {P_GLOBALS_STATIC}).keep_msg.item).is_void) then
				if not ((create {P_GLOBALS_STATIC}).keep_msg_more.item).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if a_n > 0 then
					l_pn := a_n
				else
					l_pn := -a_n
				end
				if l_pn > (create {P_OPTION_STATIC}).p_report.item.item then
					if l_pn = 1 then
						if a_n > 0 then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), (gettext (ce_string ("1 more line")))).do_nothing
						else
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), (gettext (ce_string ("1 line less")))).do_nothing
						end
					elseif a_n > 0 then
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), (gettext (ce_string ("%%ld more lines"))), l_pn]).do_nothing
					else
						sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), (gettext (ce_string ("%%ld fewer lines"))), l_pn]).do_nothing
					end
					if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).msg_buf.item)), (gettext (ce_string (" (Interrupted)")))).do_nothing
					end
					if ((create {P_MESSAGE_STATIC}).msg ((create {P_GLOBALS_STATIC}).msg_buf.item)).to_boolean then
						(create {P_MESSAGE_STATIC}).set_keep_msg ((create {P_GLOBALS_STATIC}).msg_buf.item, 0);
						(create {P_GLOBALS_STATIC}).keep_msg_more.item := 1
					end
				end
			end
		end

	beep_flush
		do
			if (create {P_GLOBALS_STATIC}).emsg_silent.item = 0 then
				(create {P_GETCHAR_STATIC}).flush_buffers (0)
				vim_beep
			end
		end

	vim_beep
		do
			if (create {P_GLOBALS_STATIC}).emsg_silent.item = 0 then
				if ((create {P_OPTION_STATIC}).p_vb.item.item).to_boolean then
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						if ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
							(create {P_TERM_STATIC}).out_char ((('%/7/').code).to_natural_32)
						else
							(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[30])
						end
					else
						(create {P_TERM_STATIC}).out_str ((create {P_TERM_STATIC}).term_strings.item[30])
					end
				else
					(create {P_TERM_STATIC}).out_char ((('%/7/').code).to_natural_32)
				end
				if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_debug.item.item, ('e').code)).is_void then
					(create {P_MESSAGE_STATIC}).msg_source ((create {P_GLOBALS_STATIC}).highlight_attr.item[17]);
					(create {P_MESSAGE_STATIC}).msg_attr (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Beep!")))), (create {P_GLOBALS_STATIC}).highlight_attr.item[17]).do_nothing
				end
			end
		end

	init_homedir
		local
			l_var: CE_POINTER [NATURAL_8]
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (homedir.item))
			homedir.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_var := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("HOME"))))
			if not l_var.is_void then
				if (l_var.item).to_integer_32 = 0 then
					l_var := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				end
			end
			if not l_var.is_void then
				if ((create {P_OS_UNIX_STATIC}).mch_dirname ((create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096)) = 1 then
					if ((create {P_OS_UNIX_STATIC}).mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item))) = 0 then
						if not ((create {P_OS_UNIX_STATIC}).mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast (l_var))).to_boolean then
							if ((create {P_OS_UNIX_STATIC}).mch_dirname ((create {P_GLOBALS_STATIC}).IObuff.item, 1_025)) = 1 then
								l_var := (create {P_GLOBALS_STATIC}).IObuff.item
							end
						end
						if ((create {P_OS_UNIX_STATIC}).mch_chdir (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item))) /= 0 then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_prev_dir.item)))))).do_nothing
						end
					end
				end
				homedir.item := (create {P_MISC2_STATIC}).vim_strsave (l_var)
			end
		end

	expand_env_save (a_src: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		do
			Result := (expand_env_save_opt (a_src, 0))
		end

	expand_env_save_opt (a_src: CE_POINTER [NATURAL_8]; a_one: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			l_p___0 := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
			if not l_p___0.is_void then
				expand_env_esc (a_src, l_p___0, 4_096, 0, a_one, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
			Result := l_p___0
		end

	expand_env (a_src, a_dst: CE_POINTER [NATURAL_8]; a_dstlen: INTEGER_32)
		do
			expand_env_esc (a_src, a_dst, a_dstlen, 0, 0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
		end

	expand_env_esc (a_srcp, a_dst: CE_POINTER [NATURAL_8]; a_dstlen, a_esc, a_one: INTEGER_32; a_startstr: CE_POINTER [NATURAL_8])
		require
			not a_srcp.is_void
			not a_dst.is_void
		local
			l_dst: CE_POINTER [NATURAL_8]
			l_dstlen: INTEGER_32
			l_src: CE_POINTER [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_var: CE_POINTER [NATURAL_8]
			l_copy_char___0: INTEGER_32
			l_mustfree: CE_ARRAY [INTEGER_32]
			l_at_start___0: INTEGER_32
			l_startstr_len: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___10: INTEGER_32
			l_pw: CE_POINTER [SD_PASSWD]
			l_xpc: CE_ARRAY [PD_EXPAND]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___21: NATURAL_32
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___24: CE_POINTER [NATURAL_8]
			l_tmp___25: CE_POINTER [NATURAL_8]
			l_tmp___26: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_mustfree.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_EXPAND]} l_xpc.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dst := a_dst
					l_dstlen := a_dstlen
					l_at_start___0 := 1
					l_startstr_len := 0
					if not a_startstr.is_void then
						l_startstr_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_startstr))).to_integer_32
					end
					l_src := (create {P_CHARSET_STATIC}).skipwhite (a_srcp)
					l_dstlen := l_dstlen - 1
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 31 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (l_src.item).to_boolean then
							if not (l_dstlen > 0) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 30 -- skip if block
						end
				when 3 then -- if:
						l_copy_char___0 := 1
						if (l_src.item).to_integer_32 /= 36 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 8 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 6 then -- else:
						if (l_src.item).to_integer_32 /= 126 then
							l_pos := -1 + 20 -- skip if block
						end
				when 7 then -- if:
						if not (l_at_start___0.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 8 then -- if: | _L___1:
						l_mustfree.item := 0
						if (l_src.item).to_integer_32 = 126 then
							l_pos := -1 + 18 -- skip if block
						end
				when 9 then -- if:
						l_tail := l_src + 1
						l_var := l_dst
						l_c := l_dstlen - 1
						if (l_tail.item).to_integer_32 /= 123 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if ((create {P_CHARSET_STATIC}).vim_isIDc (('{').code)).to_boolean then
							l_pos := -1 + 12 -- goto _L
						else
							l_tail := l_tail + 1
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___2 := l_c
								l_c := l_c - 1
								if l_tmp___2 > 0 then
									if (l_tail.item).to_boolean then
										if (l_tail.item).to_integer_32 = 125 then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_tmp___0 := l_var
									l_var := l_var + 1
									l_tmp___1 := l_tail
									l_tail := l_tail + 1
									l_tmp___0.item := l_tmp___1.item
								end
							end
							l_break := False
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___5 := l_c
							l_c := l_c - 1
							if l_tmp___5 > 0 then
								if (l_tail.item).to_integer_32 /= 0 then
									if not ((create {P_CHARSET_STATIC}).vim_isIDc ((l_tail.item).to_integer_32)).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_tmp___3 := l_var
								l_var := l_var + 1
								l_tmp___4 := l_tail
								l_tail := l_tail + 1
								l_tmp___3.item := l_tmp___4.item
							end
						end
						l_break := False
				when 13 then
						if (l_src[1]).to_integer_32 /= 123 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if (l_tail.item).to_integer_32 /= 125 then
							l_var := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							l_pos := -1 + 16 -- goto _L___0
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						if (l_src[1]).to_integer_32 = 123 then
							l_tail := l_tail + 1
						end
						l_var.item := (('%/0/').code).to_natural_8
						l_var := vim_getenv (l_dst, l_mustfree)
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						if (l_src[1]).to_integer_32 = 0 then
							l_var := homedir.item
							l_tail := l_src + 1
						elseif (vim_ispathsep ((l_src[1]).to_integer_32)).to_boolean then
							l_var := homedir.item
							l_tail := l_src + 1
						elseif not ((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" ,%T%N")), (l_src[1]).to_integer_32)).is_void then
							l_var := homedir.item
							l_tail := l_src + 1
						else
							l_tail := l_src
							l_var := l_dst
							l_c := l_dstlen - 1
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___10 := l_c
								l_c := l_c - 1
								if l_tmp___10 > 0 then
									if (l_tail.item).to_boolean then
										if ((create {P_CHARSET_STATIC}).vim_isfilec ((l_tail.item).to_integer_32)).to_boolean then
											if (vim_ispathsep ((l_tail.item).to_integer_32)).to_boolean then
												l_break := True
											end
										else
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_tmp___8 := l_var
									l_var := l_var + 1
									l_tmp___9 := l_tail
									l_tail := l_tail + 1
									l_tmp___8.item := l_tmp___9.item
								end
							end
							l_break := False
							l_var.item := (('%/0/').code).to_natural_8
							l_pw := getpwnam ((create {CE_INTEGER_8_POINTER}.make_cast (l_dst) + 1))
							if not l_pw.is_void then
								l_var := create {CE_NATURAL_8_POINTER}.make_cast (l_pw.item.pw_dir)
							else
								l_var := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
							if l_var.is_void then
								l_xpc.item.ExpandInit
								l_xpc.item.xp_context := 2
								l_var := l_xpc.item.ExpandOne (l_dst, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 80, 2)
								l_mustfree.item := 1
							end
						end
				when 19 then
						if a_esc.to_boolean then
							if not l_var.is_void then
								if not (strpbrk (create {CE_INTEGER_8_POINTER}.make_cast (l_var), ce_string (" %T"))).is_void then
									l_p___0 := ((create {P_MISC2_STATIC}).vim_strsave_escaped (l_var, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" %T"))))
									if not l_p___0.is_void then
										if (l_mustfree.item).to_boolean then
											(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_var))
										end
										l_var := l_p___0
										l_mustfree.item := 1
									end
								end
							end
						end
						if not l_var.is_void then
							if (l_var.item).to_integer_32 /= 0 then
								l_tmp___21 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_var))
								if (l_tmp___21 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tail)))) + {NATURAL_32} 1 < l_dstlen.to_natural_32 then
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_dst), create {CE_INTEGER_8_POINTER}.make_cast (l_var)).do_nothing
									l_dstlen := l_dstlen - (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_var))).to_integer_32
									l_c := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_var))).to_integer_32
									if (l_var.item).to_integer_32 /= 0 then
										if ((create {P_MISC2_STATIC}).after_pathsep (l_dst, l_dst + l_c)).to_boolean then
											if (vim_ispathsep ((l_tail.item).to_integer_32)).to_boolean then
												l_tail := l_tail + 1
											end
										end
									end
									l_dst := l_dst + l_c
									l_src := l_tail
									l_copy_char___0 := 0
								end
							end
						end
						if (l_mustfree.item).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_var))
						end
				when 20 then -- if done | if done
						if not (l_copy_char___0.to_boolean) then
							l_pos := -1 + 30 -- skip if block
						end
				when 21 then -- if:
						l_at_start___0 := 0
						if (l_src[0]).to_integer_32 /= 92 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if (l_src[1]).to_integer_32 /= 0 then
							l_tmp___23 := l_dst
							l_dst := l_dst + 1
							l_tmp___24 := l_src
							l_src := l_src + 1
							l_tmp___23.item := l_tmp___24.item
							l_dstlen := l_dstlen - 1
						else
							l_pos := -1 + 24 -- goto _L___3
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 24 then -- else: | _L___3:
						if (l_src[0]).to_integer_32 /= 32 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___2
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 27 then -- else:
						if (l_src[0]).to_integer_32 /= 44 then
							l_pos := -1 + 29 -- skip if block
						end
				when 28 then -- if: | _L___2:
						if not a_one.to_boolean then
							l_at_start___0 := 1
						end
				when 29 then -- if done | if done
						l_tmp___25 := l_dst
						l_dst := l_dst + 1
						l_tmp___26 := l_src
						l_src := l_src + 1
						l_tmp___25.item := l_tmp___26.item
						l_dstlen := l_dstlen - 1
						if not a_startstr.is_void then
							if ((l_src - l_startstr_len).c_pointer.to_integer_32).to_natural_32 >= (a_srcp.c_pointer.to_integer_32).to_natural_32 then
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_src - l_startstr_len)), create {CE_INTEGER_8_POINTER}.make_cast (a_startstr), l_startstr_len.to_natural_32)) = 0 then
									l_at_start___0 := 1
								end
							end
						end
				when 30 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 31 then -- loop done
					l_break := False
					l_dst.item := (('%/0/').code).to_natural_8
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_getenv (a_name___1: CE_POINTER [NATURAL_8]; a_mustfree: CE_POINTER [INTEGER_32]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pend: CE_POINTER [NATURAL_8]
			l_vimruntime: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))))
					if not l_p___0.is_void then
						if (l_p___0.item).to_integer_32 = 0 then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
					end
					if not l_p___0.is_void then
						Result := l_p___0
						l_return := True
					end
					if not l_return then
						l_vimruntime := ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("VIMRUNTIME"))) = 0).to_integer
						if not l_vimruntime.to_boolean then
							if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("VIM"))) /= 0 then
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						if l_vimruntime.to_boolean then
							if ((create {P_AUTO_PATHDEF_STATIC}).default_vimruntime_dir.item.item).to_integer_32 = 0 then
								l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("VIM"))))
								if not l_p___0.is_void then
									if (l_p___0.item).to_integer_32 = 0 then
										l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									end
								end
								if not l_p___0.is_void then
									l_p___0 := vim_version_dir (l_p___0)
									if not l_p___0.is_void then
										a_mustfree.item := 1
									else
										l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("VIM"))))
									end
								end
							end
						end
						if l_p___0.is_void then
							if not ((create {P_OPTION_STATIC}).p_hf.item.item).is_void then
								if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_hf.item.item, ('$').code)).is_void then
									l_p___0 := (create {P_OPTION_STATIC}).p_hf.item.item
								end
							end
							if not l_p___0.is_void then
								l_pend := gettail (l_p___0)
								if l_p___0.is_equal ((create {P_OPTION_STATIC}).p_hf.item.item) then
									l_pend := remove_tail (l_p___0, l_pend, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("doc")))
								end
								if not l_vimruntime.to_boolean then
									l_pend := remove_tail (l_p___0, l_pend, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("runtime")))
									l_pend := remove_tail (l_p___0, l_pend, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vim73")))
								end
								if (l_pend.c_pointer.to_integer_32).to_natural_32 > (l_p___0.c_pointer.to_integer_32).to_natural_32 then
									if ((create {P_MISC2_STATIC}).after_pathsep (l_p___0, l_pend)).to_boolean then
										l_pend := l_pend - 1
									end
								end
								l_p___0 := (create {P_MISC2_STATIC}).vim_strnsave (l_p___0, l_pend.distance (l_p___0))
								if not l_p___0.is_void then
									if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_p___0)).to_boolean then
										a_mustfree.item := 1
									else
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
										l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									end
								else
									a_mustfree.item := 1
								end
							end
						end
						if not (l_p___0.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if not (l_vimruntime.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if ((create {P_AUTO_PATHDEF_STATIC}).default_vimruntime_dir.item.item).to_integer_32 /= 0 then
							l_p___0 := (create {P_AUTO_PATHDEF_STATIC}).default_vimruntime_dir.item
							a_mustfree.item := 0
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if ((create {P_AUTO_PATHDEF_STATIC}).default_vim_dir.item.item).to_integer_32 /= 0 then
							if l_vimruntime.to_boolean then
								l_p___0 := vim_version_dir ((create {P_AUTO_PATHDEF_STATIC}).default_vim_dir.item)
								if not l_p___0.is_void then
									a_mustfree.item := 1
								else
									l_p___0 := (create {P_AUTO_PATHDEF_STATIC}).default_vim_dir.item
									a_mustfree.item := 0
								end
							else
								l_p___0 := (create {P_AUTO_PATHDEF_STATIC}).default_vim_dir.item
								a_mustfree.item := 0
							end
						end
				when 6 then -- if done
						if not l_p___0.is_void then
							if l_vimruntime.to_boolean then
								vim_setenv (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("VIMRUNTIME")), l_p___0);
								(create {P_GLOBALS_STATIC}).didset_vimruntime.item := 1
								l_buf___6 := (concat_str (l_p___0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/lang"))))
								if not l_buf___6.is_void then
									bindtextdomain (ce_string ("vim"), create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6)).do_nothing;
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
								end
							else
								vim_setenv (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("VIM")), l_p___0);
								(create {P_GLOBALS_STATIC}).didset_vim.item := 1
							end
						end
						Result := l_p___0
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_version_dir (a_vimdir: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if a_vimdir.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			elseif (a_vimdir.item).to_integer_32 = 0 then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_p___0 := concat_fnames (a_vimdir, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("vim73")), 1)
				if not l_p___0.is_void then
					if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_p___0)).to_boolean then
						Result := l_p___0
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				l_p___0 := concat_fnames (a_vimdir, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("runtime")), 1)
				if not l_p___0.is_void then
					if ((create {P_OS_UNIX_STATIC}).mch_isdir (l_p___0)).to_boolean then
						Result := l_p___0
						l_return := True
					end
				end
			end
			if not l_return then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
			end
		end

	remove_tail (a_p___0, a_pend, a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_len: INTEGER_32
			l_newend: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))).to_integer_32 + 1
			l_newend := a_pend - l_len
			if (l_newend.c_pointer.to_integer_32).to_natural_32 >= (a_p___0.c_pointer.to_integer_32).to_natural_32 then
				if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_newend), create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), (l_len - 1).to_natural_32)) = 0 then
					if l_newend.is_equal (a_p___0) then
						Result := l_newend
						l_return := True
					elseif ((create {P_MISC2_STATIC}).after_pathsep (a_p___0, l_newend)).to_boolean then
						Result := l_newend
						l_return := True
					end
				end
			end
			if not l_return then
				Result := a_pend
			end
		end

	vim_setenv (a_name___1, a_val___0: CE_POINTER [NATURAL_8])
		do
			setenv (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), create {CE_INTEGER_8_POINTER}.make_cast (a_val___0), 1).do_nothing
		end

	get_env_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (environ[a_idx])
			if l_str___1.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_n := 0
				from
				until
					not (not (l_break) and then (l_n < 99))
				loop
					l_break := False
					if (l_str___1[l_n]).to_integer_32 = 61 then
						l_break := True
					elseif (l_str___1[l_n]).to_integer_32 = 0 then
						l_break := True
					end
					if not (l_break) then
						name.item[l_n] := l_str___1[l_n]
						l_n := l_n + 1
					end
				end
				l_break := False
				name.item[l_n] := (('%/0/').code).to_natural_8
				Result := name.item
			end
		end

	home_replace (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_src, a_dst: CE_POINTER [NATURAL_8]; a_dstlen, a_one: INTEGER_32)
		local
			l_src: CE_POINTER [NATURAL_8]
			l_dst: CE_POINTER [NATURAL_8]
			l_dstlen: INTEGER_32
			l_dirlen: NATURAL_32
			l_envlen: NATURAL_32
			l_len: NATURAL_32
			l_homedir_env: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src := a_src
					l_dst := a_dst
					l_dstlen := a_dstlen
					l_dirlen := (0).to_natural_32
					l_envlen := (0).to_natural_32
					if l_src.is_void then
						l_dst.item := (('%/0/').code).to_natural_8
						l_return := True
					end
					if not l_return and then (not a_buf___6.is_void) then
						if (a_buf___6.item.b_help).to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_dst), create {CE_INTEGER_8_POINTER}.make_cast ((gettail (l_src)))).do_nothing
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 46 -- skip if block
					end
				when 1 then -- if:
						if not homedir.item.is_void then
							l_dirlen := strlen (create {CE_INTEGER_8_POINTER}.make_cast (homedir.item))
						end
						l_homedir_env := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (ce_string ("HOME"))))
						if not l_homedir_env.is_void then
							if (l_homedir_env.item).to_integer_32 = 0 then
								l_homedir_env := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
						if not l_homedir_env.is_void then
							l_envlen := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_homedir_env))
						end
						if not a_one.to_boolean then
							l_src := (create {P_CHARSET_STATIC}).skipwhite (l_src)
						end
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 45 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if (l_src.item).to_boolean then
							if not (l_dstlen > 0) then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 44 -- skip if block
						end
				when 4 then -- if:
						l_p___0 := homedir.item
						l_len := l_dirlen
				when 5 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 17 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if not (l_len.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 7 then -- if:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_src), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_len)) /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						if not ((vim_ispathsep ((l_src[l_len.to_integer_32]).to_integer_32)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 11 then -- else:
						if a_one.to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_src[l_len.to_integer_32]).to_integer_32 = 44 then
							l_pos := -1 + 15 -- goto _L
						elseif (l_src[l_len.to_integer_32]).to_integer_32 = 32 then
							l_pos := -1 + 15 -- goto _L
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else: | _L___0:
						if (l_src[l_len.to_integer_32]).to_integer_32 /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L:
						l_src := l_src + l_len.to_integer_32
						l_dstlen := l_dstlen - 1
						if l_dstlen > 0 then
							l_tmp___1 := l_dst
							l_dst := l_dst + 1
							l_tmp___1.item := (('~').code).to_natural_8
						end
						if not (vim_ispathsep ((l_src[0]).to_integer_32)).to_boolean then
							l_dstlen := l_dstlen - 1
							if l_dstlen > 0 then
								l_tmp___2 := l_dst
								l_dst := l_dst + 1
								l_tmp___2.item := (('/').code).to_natural_8
							end
						end
						l_break := True
				when 16 then -- if done | if done | if done | if done
						if not (l_break) and then (l_p___0.is_equal (l_homedir_env)) then
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_homedir_env
							l_len := l_envlen
						end
						l_pos := -1 + 5 -- back to loop condition
				when 17 then -- loop done
						l_break := False
				when 18 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 33 -- skip loop
						end
				when 19 then -- loop body:
						l_break := False
						if not ((l_src.item).to_boolean) then
							l_pos := -1 + 31 -- skip if block
						end
				when 20 then -- if:
						if not (a_one.to_boolean) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 25 -- goto _L___1
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 23 then -- else:
						if (l_src.item).to_integer_32 = 44 then
							l_pos := -1 + 29 -- skip if block
						end
				when 24 then -- if:
						if (l_src.item).to_integer_32 = 32 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if: | _L___1:
						l_dstlen := l_dstlen - 1
						if not (l_dstlen > 0) then
							l_break := True
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_break := True
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_break := True
				when 30 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						l_break := True
				when 32 then
						if not (l_break) then
							l_tmp___6 := l_dst
							l_dst := l_dst + 1
							l_tmp___7 := l_src
							l_src := l_src + 1
							l_tmp___6.item := l_tmp___7.item
						end
						l_pos := -1 + 18 -- back to loop condition
				when 33 then -- loop done
						l_break := False
				when 34 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 43 -- skip loop
						end
				when 35 then -- loop body:
						l_break := False
						if (l_src.item).to_integer_32 /= 32 then
							l_pos := -1 + 38 -- skip if block
						end
				when 36 then -- if:
						l_pos := -1 + 39 -- goto _L___2
				when 37 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 38 then -- else:
						if (l_src.item).to_integer_32 /= 44 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if: | _L___2:
						l_dstlen := l_dstlen - 1
						if not (l_dstlen > 0) then
							l_break := True
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_break := True
				when 42 then -- if done
						if not (l_break) then
							l_tmp___8 := l_dst
							l_dst := l_dst + 1
							l_tmp___9 := l_src
							l_src := l_src + 1
							l_tmp___8.item := l_tmp___9.item
						end
						l_pos := -1 + 34 -- back to loop condition
				when 43 then -- loop done
						l_break := False
				when 44 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 45 then -- loop done
						l_break := False
						l_dst.item := (('%/0/').code).to_natural_8
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	home_replace_save (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_src: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_dst: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
		do
			l_len := {NATURAL_32} 3
			if not a_src.is_void then
				l_len := l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_src)))
			end
			l_dst := (create {P_MISC2_STATIC}).alloc (l_len)
			if not l_dst.is_void then
				home_replace (a_buf___6, a_src, l_dst, l_len.to_integer_32, 1)
			end
			Result := l_dst
		end

	fullpathcmp (a_s1, a_s2: CE_POINTER [NATURAL_8]; a_checkname: INTEGER_32): INTEGER_32
		local
			l_exp1: CE_ARRAY [NATURAL_8]
			l_full1: CE_ARRAY [NATURAL_8]
			l_full2: CE_ARRAY [NATURAL_8]
			l_st1: CE_ARRAY [SD_STAT]
			l_st2: CE_ARRAY [SD_STAT]
			l_r1: INTEGER_32
			l_r2: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_exp1.make (<<4_096>>)
			create {CE_NATURAL_8_ARRAY} l_full1.make (<<4_096>>)
			create {CE_NATURAL_8_ARRAY} l_full2.make (<<4_096>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st1.make (<<1>>)
			create {CE_CLASS_ARRAY [SD_STAT]} l_st2.make (<<1>>)

			expand_env (a_s1, l_exp1, 4_096)
			l_r1 := stat (create {CE_INTEGER_8_POINTER}.make_cast (l_exp1), l_st1)
			l_r2 := stat (create {CE_INTEGER_8_POINTER}.make_cast (a_s2), l_st2)
			if l_r1 /= 0 then
				if l_r2 /= 0 then
					if a_checkname.to_boolean then
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_exp1), create {CE_INTEGER_8_POINTER}.make_cast (a_s2))) = 0 then
							Result := 7
							l_return := True
						end
						if not l_return then
							l_r1 := (create {P_WINDOW_STATIC}).vim_FullName (l_exp1, l_full1, 4_096, 0)
							l_r2 := (create {P_WINDOW_STATIC}).vim_FullName (a_s2, l_full2, 4_096, 0)
							if l_r1 = 1 then
								if l_r2 = 1 then
									if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_full1), create {CE_INTEGER_8_POINTER}.make_cast (l_full2))) = 0 then
										Result := 7
										l_return := True
									end
								end
							end
						end
					end
					if not l_return then
						Result := 4
						l_return := True
					end
				end
			end
			if not l_return then
				if l_r1 /= 0 then
					Result := 6
					l_return := True
				elseif l_r2 /= 0 then
					Result := 6
					l_return := True
				end
			end
			if not l_return and then (l_st1.item.st_dev = l_st2.item.st_dev) then
				if l_st1.item.st_ino = l_st2.item.st_ino then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 2
			end
		end

	gettail (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p1: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if a_fname.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
				l_return := True
			end
			if not l_return then
				l_p2 := a_fname
				l_p1 := l_p2
				from
				until
					not ((l_p2.item).to_boolean)
				loop
					if (vim_ispathsep ((l_p2.item).to_integer_32)).to_boolean then
						l_p1 := l_p2 + 1
					end
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___1 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p2]))
					else
						l_tmp___1 := 1
					end
					l_p2 := l_p2 + l_tmp___1
				end
				Result := l_p1
			end
		end

	gettail_sep (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_t: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_p___0 := get_past_head (a_fname)
			l_t := gettail (a_fname)
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_t.c_pointer.to_integer_32).to_natural_32 > (l_p___0.c_pointer.to_integer_32).to_natural_32 then
					if not ((create {P_MISC2_STATIC}).after_pathsep (a_fname, l_t)).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_t := l_t - 1
				end
			end
			l_break := False
			Result := l_t
		end

	getnextcomp (a_fname: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_fname.is_void
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_fname := a_fname
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_fname.item).to_boolean then
					if (vim_ispathsep ((l_fname.item).to_integer_32)).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_fname]))
					else
						l_tmp___0 := 1
					end
					l_fname := l_fname + l_tmp___0
				end
			end
			l_break := False
			if (l_fname.item).to_boolean then
				l_fname := l_fname + 1
			end
			Result := l_fname
		end

	get_past_head (a_path: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_path.is_void
		local
			l_retval: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_retval := a_path
			from
			until
				(l_break)
			loop
				l_break := False
				if not (vim_ispathsep ((l_retval.item).to_integer_32)).to_boolean then
					l_break := True
				end
				if not (l_break) then
					l_retval := l_retval + 1
				end
			end
			l_break := False
			Result := l_retval
		end

	vim_ispathsep (a_c: INTEGER_32): INTEGER_32
		do
			Result := (a_c = 47).to_integer
		end

	vim_ispathlistsep (a_c: INTEGER_32): INTEGER_32
		do
			Result := (a_c = 58).to_integer
		end

	shorten_dir (a_str___1: CE_POINTER [NATURAL_8])
		require
			not a_str___1.is_void
		local
			l_tail: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_skip___0: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_skip___0 := 0
			l_tail := gettail (a_str___1)
			l_d := a_str___1
			l_s := a_str___1
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if (l_s.c_pointer.to_integer_32).to_natural_32 >= (l_tail.c_pointer.to_integer_32).to_natural_32 then
					l_tmp := l_d
					l_d := l_d + 1
					l_tmp.item := l_s.item
					if (l_s.item).to_integer_32 = 0 then
						l_break := True
					end
				elseif (vim_ispathsep ((l_s.item).to_integer_32)).to_boolean then
					l_tmp___0 := l_d
					l_d := l_d + 1
					l_tmp___0.item := l_s.item
					l_skip___0 := 0
				elseif not l_skip___0.to_boolean then
					l_tmp___1 := l_d
					l_d := l_d + 1
					l_tmp___1.item := l_s.item
					if (l_s.item).to_integer_32 /= 126 then
						if (l_s.item).to_integer_32 /= 46 then
							l_skip___0 := 1
						end
					end
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_l := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s]))
						from
						until
							(l_break)
						loop
							l_break := False
							l_l := l_l - 1
							if not (l_l > 0) then
								l_break := True
							end
							if not (l_break) then
								l_tmp___3 := l_d
								l_d := l_d + 1
								l_s := l_s + 1
								l_tmp___3.item := l_s.item
							end
						end
						l_break := False
					end
				end
				if not (l_return or l_break) then
					l_s := l_s + 1
				end
			end
			l_break := False
		end

	dir_of_file_exists (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_retval: INTEGER_32
			l_return: BOOLEAN
		do
			l_p___0 := gettail_sep (a_fname)
			if l_p___0.is_equal (a_fname) then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_c := (l_p___0.item).to_integer_32
				l_p___0.item := (('%/0/').code).to_natural_8
				l_retval := (create {P_OS_UNIX_STATIC}).mch_isdir (a_fname)
				l_p___0.item := l_c.to_natural_8
				Result := l_retval
			end
		end

	concat_fnames (a_fname1, a_fname2: CE_POINTER [NATURAL_8]; a_sep: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_dest: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
		do
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname1))
			l_dest := (create {P_MISC2_STATIC}).alloc ((l_tmp + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname2)))) + {NATURAL_32} 3)
			if not l_dest.is_void then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_dest), create {CE_INTEGER_8_POINTER}.make_cast (a_fname1)).do_nothing
				if a_sep.to_boolean then
					add_pathsep (l_dest)
				end
				strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_dest), create {CE_INTEGER_8_POINTER}.make_cast (a_fname2)).do_nothing
			end
			Result := l_dest
		end

	concat_str (a_str1, a_str2: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_dest: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
		do
			l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str1)))
			l_dest := (create {P_MISC2_STATIC}).alloc (((l_l + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str2)))).to_natural_32 + {NATURAL_32} 1).to_natural_32)
			if not l_dest.is_void then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_dest), create {CE_INTEGER_8_POINTER}.make_cast (a_str1)).do_nothing
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_dest + l_l.to_integer_32)), create {CE_INTEGER_8_POINTER}.make_cast (a_str2)).do_nothing
			end
			Result := l_dest
		end

	add_pathsep (a_p___0: CE_POINTER [NATURAL_8])
		require
			not a_p___0.is_void
		do
			if (a_p___0.item).to_integer_32 /= 0 then
				if not ((create {P_MISC2_STATIC}).after_pathsep (a_p___0, a_p___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_p___0))).to_integer_32)).to_boolean then
					strcat (create {CE_INTEGER_8_POINTER}.make_cast (a_p___0), ce_string ("/")).do_nothing
				end
			end
		end

	FullName_save (a_fname: CE_POINTER [NATURAL_8]; a_force: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_new_fname: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_new_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if a_fname.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_buf___6 := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
				if not l_buf___6.is_void then
					if ((create {P_WINDOW_STATIC}).vim_FullName (a_fname, l_buf___6, 4_096, a_force)) /= 0 then
						l_new_fname := (create {P_MISC2_STATIC}).vim_strsave (l_buf___6)
					else
						l_new_fname := (create {P_MISC2_STATIC}).vim_strsave (a_fname)
					end
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
				end
				Result := l_new_fname
			end
		end

	find_start_comment (a_ind_maxcomment: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_pos___3: CE_POINTER [PD_POS_T]
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_cur_maxcomment: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_cur_maxcomment := a_ind_maxcomment
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_pos___3 := (create {P_SEARCH_STATIC}).findmatchlimit (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('*').code, 1, l_cur_maxcomment)
				if l_pos___3.is_void then
					l_break := True
				end
				if not (l_return or l_break) then
					l_line := (create {P_MEMLINE_STATIC}).ml_get (l_pos___3.item.lnum)
					l_p___0 := l_line
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item).to_boolean then
							if not (l_p___0.distance (l_line) < l_pos___3.item.col) then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_p___0 := skip_string (l_p___0)
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
					if l_p___0.distance (l_line) <= l_pos___3.item.col then
						l_break := True
					end
				end
				if not (l_return or l_break) then
					l_cur_maxcomment := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - l_pos___3.item.lnum) - 1).to_integer_32
					if l_cur_maxcomment <= 0 then
						l_pos___3 := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
						l_break := True
					end
				end
			end
			l_break := False
			Result := l_pos___3
		end

	skip_string (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False
						if (l_p___0[0]).to_integer_32 /= 39 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not (l_p___0[1]).to_boolean then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_i___0 := 2
							if (l_p___0[1]).to_integer_32 = 92 then
								l_i___0 := l_i___0 + 1
								from
								until
									(l_break)
								loop
									l_break := False
									if not ((create {P_CHARSET_STATIC}).vim_isdigit ((l_p___0[(l_i___0 - 1)]).to_integer_32)).to_boolean then
										l_break := True
									end
									if not (l_break) then
										l_i___0 := l_i___0 + 1
									end
								end
								l_break := False
							end
							if (l_p___0[l_i___0]).to_integer_32 = 39 then
								l_p___0 := l_p___0 + l_i___0
								l_continue := True
							end
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 5 then -- else:
						if (l_p___0[0]).to_integer_32 /= 34 then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						l_p___0 := l_p___0 + 1
				when 7 then -- loop condition:
						if not (not (l_break) and then ((l_p___0[0]).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						if (l_p___0[0]).to_integer_32 /= 92 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (l_p___0[0]).to_integer_32 = 34 then
							l_break := True
						end
				when 12 then
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 7 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						if (l_p___0[0]).to_integer_32 = 34 then
							l_continue := True
						end
				when 14 then -- if done | if done
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
						if (not l_return and not l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					l_break := False
					l_continue := False
					if not (l_p___0.item).to_boolean then
						l_p___0 := l_p___0 - 1
					end
					Result := l_p___0
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	do_c_expr_indent
		do
			if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_inde).item).to_integer_32 /= 0 then
				(create {P_EDIT_STATIC}).fixthisline (get_expr_indent_address)
			else
				(create {P_EDIT_STATIC}).fixthisline (get_c_indent_address)
			end
		end

	cin_skipcomment (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_prev_s: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_s := a_s
			from
			until
				not (not (l_return or l_break) and then ((l_s.item).to_boolean))
			loop
				l_break := False
				l_prev_s := l_s
				l_s := (create {P_CHARSET_STATIC}).skipwhite (l_s)
				if ind_hash_comment.item /= 0 then
					if not l_s.is_equal (l_prev_s) then
						if (l_s.item).to_integer_32 = 35 then
							l_s := l_s + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
							l_break := True
						end
					end
				end
				if not (l_return or l_break) and then ((l_s.item).to_integer_32 /= 47) then
					l_break := True
				end
				if not (l_return or l_break) then
					l_s := l_s + 1
					if (l_s.item).to_integer_32 = 47 then
						l_s := l_s + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
						l_break := True
					end
				end
				if not (l_return or l_break) and then ((l_s.item).to_integer_32 /= 42) then
					l_break := True
				end
				if not (l_return or l_break) then
					l_s := l_s + 1
					from
					until
						not (not (l_break) and then ((l_s.item).to_boolean))
					loop
						l_break := False
						if (l_s[0]).to_integer_32 = 42 then
							if (l_s[1]).to_integer_32 = 47 then
								l_s := l_s + (2)
								l_break := True
							end
						end
						if not (l_break) then
							l_s := l_s + 1
						end
					end
					l_break := False
				end
			end
			l_break := False
			Result := l_s
		end

	cin_nocode (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_s.is_void
		do
			Result := (((cin_skipcomment (a_s)).item).to_integer_32 = 0).to_integer
		end

	find_line_comment: CE_POINTER [PD_POS_T]
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			pos___0.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				pos___0.item.item.lnum := (pos___0.item.item.lnum) - 1
				if not (pos___0.item.item.lnum > 0) then
					l_break := True
				end
				if not (l_return or l_break) then
					l_line := (create {P_MEMLINE_STATIC}).ml_get (pos___0.item.item.lnum)
					l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_line)
					if (cin_islinecomment (l_p___0)).to_boolean then
						pos___0.item.item.col := l_p___0.distance (l_line)
						Result := pos___0.item
						l_return := True
					end
					if not l_return and then ((l_p___0.item).to_integer_32 /= 0) then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
			end
		end

	cin_islabel_skip (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_s.is_void
		local
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if not ((create {P_CHARSET_STATIC}).vim_isIDc (((a_s.item).item).to_integer_32)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					if not ((create {P_CHARSET_STATIC}).vim_isIDc (((a_s.item).item).to_integer_32)).to_boolean then
						l_break := True
					end
					if not (l_break) then
						a_s.item := (a_s.item) + 1
					end
				end
				l_break := False
				a_s.item := cin_skipcomment (a_s.item)
				if ((a_s.item).item).to_integer_32 = 58 then
					a_s.item := (a_s.item) + 1
					if ((a_s.item).item).to_integer_32 /= 58 then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	cin_islabel (a_ind_maxcomment: INTEGER_32): INTEGER_32
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_cursor_save: PD_POS_T
			l_trypos: CE_POINTER [PD_POS_T]
			l_line: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return, l_continue: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_line.make (<<1>>)

			l_s.item := cin_skipcomment (((create {P_MEMLINE_STATIC}).ml_get_curline))
			if (cin_isdefault (l_s.item)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (cin_isscopedecl (l_s.item)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if (cin_islabel_skip (l_s)).to_boolean then
					l_cursor_save := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					from
					until
						not (not (l_return) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1))
					loop
						l_continue := False;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
						l_trypos := find_start_comment (a_ind_maxcomment)
						if not l_trypos.is_void then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_trypos.item).twin
						end
						l_line.item := (create {P_MEMLINE_STATIC}).ml_get_curline
						if (cin_ispreproc (l_line.item)).to_boolean then
							l_continue := True
						end
						if not (l_return or l_continue) then
							l_line.item := cin_skipcomment (l_line.item)
							if (l_line.item.item).to_integer_32 = 0 then
								l_continue := True
							end
						end
						if not (l_return or l_continue) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_cursor_save.twin
							if (cin_isterminated (l_line.item, 1, 0)).to_boolean then
								Result := 1
								l_return := True
							elseif (cin_isscopedecl (l_line.item)).to_boolean then
								Result := 1
								l_return := True
							elseif (cin_iscase (l_line.item, 1)).to_boolean then
								Result := 1
								l_return := True
							elseif (cin_islabel_skip (l_line)).to_boolean then
								if (cin_nocode (l_line.item)).to_boolean then
									Result := 1
									l_return := True
								end
							end
							if not l_return then
								Result := 0
								l_return := True
							end
						end
					end
					if not l_return then
						l_continue := False;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_cursor_save.twin
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	cin_isinit: INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_s := cin_skipcomment (((create {P_MEMLINE_STATIC}).ml_get_curline))
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("typedef"), (7).to_natural_32)) = 0 then
				if not ((create {P_CHARSET_STATIC}).vim_isIDc ((l_s[7]).to_integer_32)).to_boolean then
					l_s := cin_skipcomment (l_s + 7)
				end
			end
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("enum"), (4).to_natural_32)) = 0 then
				if not ((create {P_CHARSET_STATIC}).vim_isIDc ((l_s[4]).to_integer_32)).to_boolean then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				if (cin_ends_in (l_s, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("=")), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("{")))).to_boolean then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	cin_iscase (a_s: CE_POINTER [NATURAL_8]; a_strict: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_s := cin_skipcomment (l_s)
					if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("case"), (4).to_natural_32)) /= 0 then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if ((create {P_CHARSET_STATIC}).vim_isIDc ((l_s[4]).to_integer_32)).to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 2 then -- if:
						l_s := l_s + (4)
				when 3 then -- loop condition:
						if not (not (l_return) and then ((l_s.item).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 4 then -- loop body:
						l_s := cin_skipcomment (l_s)
						if (l_s.item).to_integer_32 = 58 then
							if (l_s[1]).to_integer_32 = 58 then
								l_s := l_s + 1
							else
								Result := 1
								l_return := True
							end
						end
						if l_return then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						if (l_s.item).to_integer_32 /= 39 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_s[1]).to_boolean then
							if (l_s[2]).to_integer_32 = 39 then
								l_s := l_s + (2)
							else
								l_pos := -1 + 8 -- goto _L___1
							end
						else
							l_pos := -1 + 8 -- goto _L___1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else: | _L___1:
						if (l_s.item).to_integer_32 /= 47 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (l_s[1]).to_integer_32 = 42 then
							Result := 0
							l_return := True
						elseif (l_s[1]).to_integer_32 = 47 then
							Result := 0
							l_return := True
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (l_s.item).to_integer_32 = 34 then
							if a_strict.to_boolean then
								Result := 0
								l_return := True
							else
								Result := 1
								l_return := True
							end
						end
				when 12 then -- if done | if done
						if not l_return then
							l_s := l_s + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 13 then -- loop done
						if not l_return then
							Result := 0
							l_return := True
						end
				when 14 then -- if done | if done
					if not l_return then
						if (cin_isdefault (l_s)).to_boolean then
							Result := 1
							l_return := True
						end
					end
					if not l_return then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cin_isdefault (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
		do
			l_s := a_s
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("default"), (7).to_natural_32)) = 0 then
				l_s := cin_skipcomment (l_s + 7)
				if (l_s.item).to_integer_32 = 58 then
					if (l_s[1]).to_integer_32 /= 58 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	cin_isscopedecl (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return: BOOLEAN
		do
			l_s := a_s
			l_s := cin_skipcomment (l_s)
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("public"), (6).to_natural_32)) = 0 then
				l_i___0 := 6
			elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("protected"), (9).to_natural_32)) = 0 then
				l_i___0 := 9
			elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("private"), (7).to_natural_32)) = 0 then
				l_i___0 := 7
			else
				Result := 0
				l_return := True
			end
			if not l_return then
				l_s := cin_skipcomment (l_s + l_i___0)
				if (l_s.item).to_integer_32 = 58 then
					if (l_s[1]).to_integer_32 /= 58 then
						l_tmp___2 := 1
					else
						l_tmp___2 := 0
					end
				else
					l_tmp___2 := 0
				end
				Result := l_tmp___2
			end
		end

	after_label (a_l: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_l.is_void
		local
			l_l: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_l := a_l
			from
			until
				not (not (l_break) and then ((l_l.item).to_boolean))
			loop
				l_break := False
				if (l_l.item).to_integer_32 = 58 then
					if (l_l[1]).to_integer_32 = 58 then
						l_l := l_l + 1
					elseif not (cin_iscase (l_l + 1, 0)).to_boolean then
						l_break := True
					end
				elseif (l_l.item).to_integer_32 = 39 then
					if (l_l[1]).to_boolean then
						if (l_l[2]).to_integer_32 = 39 then
							l_l := l_l + (2)
						end
					end
				end
				if not (l_break) then
					l_l := l_l + 1
				end
			end
			l_break := False
			if (l_l.item).to_integer_32 = 0 then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_l := cin_skipcomment (l_l + 1)
				if (l_l.item).to_integer_32 = 0 then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				Result := l_l
			end
		end

	get_indent_nolabel (a_lnum: INTEGER_32): INTEGER_32
		local
			l_l: CE_POINTER [NATURAL_8]
			l_fp: CE_ARRAY [PD_POS_T]
			l_col: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_fp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			l_l := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
			l_p___0 := after_label (l_l)
			if l_p___0.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_fp.item.col := l_p___0.distance (l_l)
				l_fp.item.lnum := a_lnum;
				((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_fp, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				Result := (l_col.item)
			end
		end

	skip_label (a_lnum: INTEGER_32; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_ind_maxcomment: INTEGER_32): INTEGER_32
		require
			not a_pp.is_void
		local
			l_l: CE_POINTER [NATURAL_8]
			l_amount: INTEGER_32
			l_cursor_save: PD_POS_T
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cursor_save := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := a_lnum
					l_l := (create {P_MEMLINE_STATIC}).ml_get_curline
					if not ((cin_iscase (l_l, 0)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not ((cin_isscopedecl (l_l)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not ((cin_islabel (a_ind_maxcomment)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						l_amount := get_indent_nolabel (a_lnum)
						l_l := after_label (((create {P_MEMLINE_STATIC}).ml_get_curline))
						if l_l.is_void then
							l_l := (create {P_MEMLINE_STATIC}).ml_get_curline
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_amount := get_indent
						l_l := (create {P_MEMLINE_STATIC}).ml_get_curline
				when 10 then -- if done | if done
					a_pp.item := l_l;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_cursor_save.twin
					Result := l_amount
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cin_first_id_amount: INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_fp: CE_ARRAY [PD_POS_T]
			l_col: CE_ARRAY [INTEGER_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_fp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
					l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_line)
					l_len := ((create {P_CHARSET_STATIC}).skiptowhite (l_p___0)).distance (l_p___0)
					if l_len = 6 then
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("static"), (6).to_natural_32)) = 0 then
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + 6)
							l_len := ((create {P_CHARSET_STATIC}).skiptowhite (l_p___0)).distance (l_p___0)
						end
					end
					if l_len /= 6 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("struct"), (6).to_natural_32)) = 0 then
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + 6)
						else
							l_pos := -1 + 3 -- goto _L___5
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 3 then -- else: | _L___5:
						if l_len /= 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("enum"), (4).to_natural_32)) = 0 then
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + 4)
						else
							l_pos := -1 + 6 -- goto _L___4
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 6 then -- else: | _L___4:
						if l_len /= 8 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("unsigned"), (8).to_natural_32)) = 0 then
							l_pos := -1 + 11 -- goto _L___2
						else
							l_pos := -1 + 9 -- goto _L___3
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 9 then -- else: | _L___3:
						if l_len /= 6 then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("signed"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 11 then -- if: | _L___2:
						l_s := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + l_len)
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("int"), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_s[3]).to_integer_32 = 32 then
							l_p___0 := l_s
						elseif (l_s[3]).to_integer_32 = 9 then
							l_p___0 := l_s
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 14 then -- else: | _L___1:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("long"), (4).to_natural_32)) /= 0 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_s[4]).to_integer_32 = 32 then
							l_p___0 := l_s
						elseif (l_s[4]).to_integer_32 = 9 then
							l_p___0 := l_s
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 17 then -- else: | _L___0:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("short"), (5).to_natural_32)) /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if (l_s[5]).to_integer_32 = 32 then
							l_p___0 := l_s
						elseif (l_s[5]).to_integer_32 = 9 then
							l_p___0 := l_s
						else
							l_pos := -1 + 20 -- goto _L
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else: | _L:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("char"), (4).to_natural_32)) = 0 then
							if (l_s[4]).to_integer_32 = 32 then
								l_p___0 := l_s
							elseif (l_s[4]).to_integer_32 = 9 then
								l_p___0 := l_s
							end
						end
				when 21 then -- if done | if done | if done | if done | if done | if done | if done
					l_len := 0
					from
					until
						(l_break)
					loop
						l_break := False
						if not ((create {P_CHARSET_STATIC}).vim_isIDc ((l_p___0[l_len]).to_integer_32)).to_boolean then
							l_break := True
						end
						if not (l_break) then
							l_len := l_len + 1
						end
					end
					l_break := False
					if l_len /= 0 then
						l_pos := -1 + 24 -- skip if block
					end
				when 22 then -- if:
						Result := 0
						l_return := True
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 24 then -- else:
						if (l_p___0[l_len]).to_integer_32 /= 32 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						l_pos := -1 + 28 -- goto _L___6
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 27 then -- else:
						if (l_p___0[l_len]).to_integer_32 /= 9 then
							l_pos := -1 + 30 -- skip if block
						end
				when 28 then -- if: | _L___6:
						if (cin_nocode (l_p___0)).to_boolean then
							Result := 0
							l_return := True
						end
				when 29 then -- if block done, skip else block:
						l_pos := -1 + 31
				when 30 then -- else:
						Result := 0
						l_return := True
				when 31 then -- if done | if done
					if not l_return then
						l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + l_len)
						l_fp.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
						l_fp.item.col := l_p___0.distance (l_line);
						((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_fp, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						Result := (l_col.item)
					end
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cin_get_equal_amount (a_lnum: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_col: CE_ARRAY [INTEGER_32]
			l_fp: CE_ARRAY [PD_POS_T]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_fp.make (<<1>>)

			if a_lnum > 1 then
				l_line := (create {P_MEMLINE_STATIC}).ml_get (a_lnum - 1)
				if (l_line.item).to_integer_32 /= 0 then
					if (l_line[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
						Result := (-1)
						l_return := True
					end
				end
			end
			if not l_return then
				l_s := (create {P_MEMLINE_STATIC}).ml_get (a_lnum)
				l_line := l_s
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_s.item).to_integer_32 /= 0 then
						if not (((create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("=;{}%"%'")), (l_s.item).to_integer_32)).is_void) then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if (cin_iscomment (l_s)).to_boolean then
							l_s := cin_skipcomment (l_s)
						else
							l_s := l_s + 1
						end
					end
				end
				l_break := False
				if (l_s.item).to_integer_32 /= 61 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_s := (create {P_CHARSET_STATIC}).skipwhite (l_s + 1)
				if (cin_nocode (l_s)).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				if (l_s.item).to_integer_32 = 34 then
					l_s := l_s + 1
				end
				l_fp.item.lnum := a_lnum
				l_fp.item.col := l_s.distance (l_line);
				((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_fp, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				Result := (l_col.item)
			end
		end

	cin_ispreproc (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_s := a_s
			l_s := (create {P_CHARSET_STATIC}).skipwhite (l_s)
			if (l_s.item).to_integer_32 = 35 then
				Result := 1
				l_return := True
			end
			if not l_return then
				Result := 0
			end
		end

	cin_ispreproc_cont (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_lnump: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_pp.is_void
			not a_lnump.is_void
		local
			l_line: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_retval: INTEGER_32
			l_break: BOOLEAN
		do
			l_line := a_pp.item
			l_lnum := a_lnump.item
			l_retval := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if (cin_ispreproc (l_line)).to_boolean then
					l_retval := 1
					a_lnump.item := l_lnum
					l_break := True
				end
				if not (l_break) and then (l_lnum = 1) then
					l_break := True
				end
				if not (l_break) then
					l_lnum := l_lnum - 1
					l_line := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
					if (l_line.item).to_integer_32 = 0 then
						l_break := True
					elseif (l_line[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_line))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
						l_break := True
					end
				end
			end
			l_break := False
			if l_lnum /= a_lnump.item then
				a_pp.item := (create {P_MEMLINE_STATIC}).ml_get (a_lnump.item)
			end
			Result := l_retval
		end

	cin_iscomment (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_tmp: INTEGER_32
		do
			if (a_p___0[0]).to_integer_32 = 47 then
				if (a_p___0[1]).to_integer_32 = 42 then
					l_tmp := 1
				elseif (a_p___0[1]).to_integer_32 = 47 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	cin_islinecomment (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_tmp: INTEGER_32
		do
			if (a_p___0[0]).to_integer_32 = 47 then
				if (a_p___0[1]).to_integer_32 = 47 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	cin_isterminated (a_s: CE_POINTER [NATURAL_8]; a_incl_open, a_incl_comma: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_found_start: NATURAL_8
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_found_start := (0).to_natural_8
					l_s := cin_skipcomment (l_s)
					if (l_s.item).to_integer_32 = 123 then
						l_found_start := l_s.item
					elseif (l_s.item).to_integer_32 = 125 then
						if not (cin_iselse (l_s)).to_boolean then
							l_found_start := l_s.item
						end
					end
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_s.item).to_boolean)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						l_s := skip_string ((cin_skipcomment (l_s)))
						if (l_s.item).to_integer_32 /= 59 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 5 then -- else:
						if not (a_incl_open.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_s.item).to_integer_32 = 123 then
							l_pos := -1 + 13 -- goto _L
						else
							l_pos := -1 + 8 -- goto _L___0
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 8 then -- else: | _L___0:
						if (l_s.item).to_integer_32 /= 125 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 11 then -- else:
						if not (a_incl_comma.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_s.item).to_integer_32 /= 44 then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						if (cin_nocode (l_s + 1)).to_boolean then
							Result := (l_s.item).to_integer_32
							l_return := True
						end
				when 14 then -- if done | if done | if done | if done
						if not l_return and then ((l_s.item).to_boolean) then
							l_s := l_s + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if not l_return then
						Result := l_found_start.to_integer_32
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cin_isfuncdecl (a_sp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_first_lnum: INTEGER_32): INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_retval: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := a_first_lnum
					l_retval := 0
					if a_sp.is_void then
						l_s := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
					else
						l_s := a_sp.item
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_s.item).to_boolean then
							if (l_s.item).to_integer_32 /= 40 then
								if (l_s.item).to_integer_32 /= 59 then
									if (l_s.item).to_integer_32 /= 39 then
										if (l_s.item).to_integer_32 = 34 then
											l_break := True
										end
									else
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if (cin_iscomment (l_s)).to_boolean then
								l_s := cin_skipcomment (l_s)
							else
								l_s := l_s + 1
							end
						end
					end
					l_break := False
					if (l_s.item).to_integer_32 /= 40 then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 9 -- skip loop
						end
				when 2 then -- loop body:
						l_break := False
						if (l_s.item).to_boolean then
							if (l_s.item).to_integer_32 /= 59 then
								if (l_s.item).to_integer_32 /= 39 then
									if (l_s.item).to_integer_32 = 34 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if (l_s.item).to_integer_32 = 41 then
							if (cin_nocode (l_s + 1)).to_boolean then
								l_lnum := a_first_lnum - 1
								l_s := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
								if (l_s.item).to_integer_32 = 0 then
									l_retval := 1
								elseif (l_s[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
									l_retval := 1
								end
								l_pos := -1 + 10 -- goto done
							end
						end
				when 4 then
						if (l_s.item).to_integer_32 /= 44 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (cin_nocode (l_s + 1)).to_boolean then
							if l_lnum >= (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
								l_break := True
							end
							if not (l_break) then
								l_lnum := l_lnum + 1
								l_s := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if (cin_iscomment (l_s)).to_boolean then
							l_s := cin_skipcomment (l_s)
						else
							l_s := l_s + 1
						end
				when 8 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
						l_break := False
				when 10 then -- done:
						if l_lnum /= a_first_lnum then
							if not a_sp.is_void then
								a_sp.item := (create {P_MEMLINE_STATIC}).ml_get (a_first_lnum)
							end
						end
						Result := l_retval
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cin_isif (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_p___0), ce_string ("if"), (2).to_natural_32)) = 0 then
				if ((create {P_CHARSET_STATIC}).vim_isIDc ((a_p___0[2]).to_integer_32)).to_boolean then
					l_tmp___1 := 0
				else
					l_tmp___1 := 1
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cin_iselse (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			l_p___0 := a_p___0
			if (l_p___0.item).to_integer_32 = 125 then
				l_p___0 := cin_skipcomment (l_p___0 + 1)
			end
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("else"), (4).to_natural_32)) = 0 then
				if ((create {P_CHARSET_STATIC}).vim_isIDc ((l_p___0[4]).to_integer_32)).to_boolean then
					l_tmp___1 := 0
				else
					l_tmp___1 := 1
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cin_isdo (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_p___0), ce_string ("do"), (2).to_natural_32)) = 0 then
				if ((create {P_CHARSET_STATIC}).vim_isIDc ((a_p___0[2]).to_integer_32)).to_boolean then
					l_tmp___1 := 0
				else
					l_tmp___1 := 1
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cin_iswhileofdo (a_p___0: CE_POINTER [NATURAL_8]; a_lnum: INTEGER_32; a_ind_maxparen: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_cursor_save: PD_POS_T
			l_trypos: CE_POINTER [PD_POS_T]
			l_retval: INTEGER_32
			l_break: BOOLEAN
		do
			l_p___0 := a_p___0
			l_retval := 0
			l_p___0 := cin_skipcomment (l_p___0)
			if (l_p___0.item).to_integer_32 = 125 then
				l_p___0 := cin_skipcomment (l_p___0 + 1)
			end
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("while"), (5).to_natural_32)) = 0 then
				if not ((create {P_CHARSET_STATIC}).vim_isIDc ((l_p___0[5]).to_integer_32)).to_boolean then
					l_cursor_save := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := a_lnum;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
					l_p___0 := (create {P_MEMLINE_STATIC}).ml_get_curline
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item).to_boolean then
							if (l_p___0.item).to_integer_32 = 119 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
						end
					end
					l_break := False
					l_trypos := (create {P_SEARCH_STATIC}).findmatchlimit (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), 0, 0, a_ind_maxparen)
					if not l_trypos.is_void then
						if ((cin_skipcomment ((l_trypos.item.ml_get_pos) + 1)).item).to_integer_32 = 59 then
							l_retval := 1
						end
					end
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_cursor_save.twin
				end
			end
			Result := l_retval
		end

	cin_iswhileofdo_end (a_terminated, a_ind_maxparen, a_ind_maxcomment: INTEGER_32): INTEGER_32
		local
			l_line: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_trypos: CE_POINTER [PD_POS_T]
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if a_terminated /= 59 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
				l_p___0 := l_line
				from
				until
					not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0))
				loop
					l_p___0 := cin_skipcomment (l_p___0)
					if (l_p___0.item).to_integer_32 = 41 then
						l_s := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + 1)
						if (l_s.item).to_integer_32 = 59 then
							if (cin_nocode (l_s + 1)).to_boolean then
								l_i___0 := l_p___0.distance (l_line);
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_i___0
								l_trypos := find_match_paren (a_ind_maxparen, a_ind_maxcomment)
								if not l_trypos.is_void then
									l_s := cin_skipcomment (((create {P_MEMLINE_STATIC}).ml_get (l_trypos.item.lnum)))
									if (l_s.item).to_integer_32 = 125 then
										l_s := cin_skipcomment (l_s + 1)
									end
									if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("while"), (5).to_natural_32)) = 0 then
										if not ((create {P_CHARSET_STATIC}).vim_isIDc ((l_s[5]).to_integer_32)).to_boolean then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_trypos.item.lnum
											Result := 1
											l_return := True
										end
									end
								end
								if not l_return then
									l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
									l_p___0 := l_line + l_i___0
								end
							end
						end
					end
					if not l_return and then ((l_p___0.item).to_integer_32 /= 0) then
						l_p___0 := l_p___0 + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	cin_isbreak (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_p___0), ce_string ("break"), (5).to_natural_32)) = 0 then
				if ((create {P_CHARSET_STATIC}).vim_isIDc ((a_p___0[5]).to_integer_32)).to_boolean then
					l_tmp___1 := 0
				else
					l_tmp___1 := 1
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cin_is_cpp_baseclass (a_col: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_col.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_class_or_struct: INTEGER_32
			l_lookfor_ctor_init: INTEGER_32
			l_cpp_base_class: INTEGER_32
			l_lnum: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
					l_line := ((create {P_MEMLINE_STATIC}).ml_get_curline)
					a_col.item := 0
					l_s := (create {P_CHARSET_STATIC}).skipwhite (l_line)
					if (l_s.item).to_integer_32 = 35 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_s := cin_skipcomment (l_s)
						if (l_s.item).to_integer_32 = 0 then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						l_class_or_struct := 0
						l_lookfor_ctor_init := l_class_or_struct
						l_cpp_base_class := l_lookfor_ctor_init
						from
						until
							not (not (l_return or l_break) and then (l_lnum > 1))
						loop
							l_break := False
							l_line := (create {P_MEMLINE_STATIC}).ml_get (l_lnum - 1)
							l_s := (create {P_CHARSET_STATIC}).skipwhite (l_line)
							if (l_s.item).to_integer_32 = 35 then
								l_break := True
							elseif (l_s.item).to_integer_32 = 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								from
								until
									not (not (l_break) and then ((l_s.item).to_integer_32 /= 0))
								loop
									l_break := False
									l_s := cin_skipcomment (l_s)
									if (l_s.item).to_integer_32 = 123 then
										l_break := True
									elseif (l_s.item).to_integer_32 = 125 then
										l_break := True
									elseif (l_s.item).to_integer_32 = 59 then
										if (cin_nocode (l_s + 1)).to_boolean then
											l_break := True
										end
									end
									if not (l_break) and then ((l_s.item).to_integer_32 /= 0) then
										l_s := l_s + 1
									end
								end
								l_break := False
								if (l_s.item).to_integer_32 /= 0 then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_lnum := l_lnum - 1
							end
						end
						l_break := False
						l_line := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
						l_s := cin_skipcomment (l_line)
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 18 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if (l_s.item).to_integer_32 = 0 then
							if l_lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_lnum := l_lnum + 1
								l_line := (create {P_MEMLINE_STATIC}).ml_get (l_lnum)
								l_s := cin_skipcomment (l_line)
								if (l_s.item).to_integer_32 = 0 then
									l_continue := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if (l_s[0]).to_integer_32 /= 58 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if (l_s[1]).to_integer_32 = 58 then
							l_lookfor_ctor_init := 0
							l_s := cin_skipcomment (l_s + 2)
						elseif l_lookfor_ctor_init.to_boolean then
							l_cpp_base_class := 1
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							a_col.item := 0
							l_s := cin_skipcomment (l_s + 1)
						elseif l_class_or_struct.to_boolean then
							l_cpp_base_class := 1
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							a_col.item := 0
							l_s := cin_skipcomment (l_s + 1)
						else
							l_s := cin_skipcomment (l_s + 1)
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 7 then -- else:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("class"), (5).to_natural_32)) /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if ((create {P_CHARSET_STATIC}).vim_isIDc ((l_s[5]).to_integer_32)).to_boolean then
							l_pos := -1 + 10 -- goto _L___1
						else
							l_pos := -1 + 14 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 10 then -- else: | _L___1:
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("struct"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 11 then -- if:
						if not (((create {P_CHARSET_STATIC}).vim_isIDc ((l_s[6]).to_integer_32)).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 16 -- goto _L___0
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else: | _L:
						l_class_or_struct := 1
						l_lookfor_ctor_init := 0
						if (l_s.item).to_integer_32 = 99 then
							l_s := cin_skipcomment (l_s + 5)
						else
							l_s := cin_skipcomment (l_s + 6)
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else: | _L___0:
						if (l_s[0]).to_integer_32 = 123 then
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							l_cpp_base_class := l_lookfor_ctor_init
						elseif (l_s[0]).to_integer_32 = 125 then
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							l_cpp_base_class := l_lookfor_ctor_init
						elseif (l_s[0]).to_integer_32 = 59 then
							l_class_or_struct := 0
							l_lookfor_ctor_init := l_class_or_struct
							l_cpp_base_class := l_lookfor_ctor_init
						elseif (l_s[0]).to_integer_32 = 41 then
							l_class_or_struct := 0
							l_lookfor_ctor_init := 1
						elseif (l_s[0]).to_integer_32 = 63 then
							Result := 0
							l_return := True
						elseif ((create {P_CHARSET_STATIC}).vim_isIDc ((l_s[0]).to_integer_32)).to_boolean then
							if a_col.item = 0 then
								l_lookfor_ctor_init := 0
								if l_cpp_base_class.to_boolean then
									a_col.item := l_s.distance (l_line)
								end
							end
						else
							l_class_or_struct := 0
							l_lookfor_ctor_init := 0
						end
						if not l_return then
							if l_lnum = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								if (l_s.item).to_integer_32 = 44 then
									if (cin_nocode (l_s + 1)).to_boolean then
										a_col.item := 0
									end
								end
							end
							l_s := cin_skipcomment (l_s + 1)
						end
				when 17 then -- if done | if done | if done
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 2 -- back to loop condition
				when 18 then -- loop done | if done
					if not l_return then
						l_break := False
						l_continue := False
						Result := l_cpp_base_class
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_baseclass_amount (a_col, a_ind_maxparen, a_ind_maxcomment, a_ind_cpp_baseclass: INTEGER_32): INTEGER_32
		local
			l_amount: INTEGER_32
			l_vcol: CE_ARRAY [INTEGER_32]
			l_trypos: CE_POINTER [PD_POS_T]
		do
			create {CE_INTEGER_32_ARRAY} l_vcol.make (<<1>>)

			if a_col = 0 then
				l_amount := get_indent
				if (find_last_paren (((create {P_MEMLINE_STATIC}).ml_get_curline), ('(').code, (')').code)).to_boolean then
					l_trypos := find_match_paren (a_ind_maxparen, a_ind_maxcomment)
					if not l_trypos.is_void then
						l_amount := get_indent_lnum (l_trypos.item.lnum)
					end
				end
				if not (cin_ends_in (((create {P_MEMLINE_STATIC}).ml_get_curline), create {CE_NATURAL_8_POINTER}.make_cast (ce_string (",")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))).to_boolean then
					l_amount := l_amount + a_ind_cpp_baseclass
				end
			else
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := a_col;
				((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), l_vcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				l_amount := l_vcol.item
			end
			if l_amount < a_ind_cpp_baseclass then
				l_amount := a_ind_cpp_baseclass
			end
			Result := l_amount
		end

	cin_ends_in (a_s, a_find, a_ignore___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_s.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_return: BOOLEAN
		do
			l_p___0 := a_s
			l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_find))).to_integer_32
			from
			until
				not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0))
			loop
				l_p___0 := cin_skipcomment (l_p___0)
				if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (a_find), l_len.to_natural_32)) = 0 then
					l_r := (create {P_CHARSET_STATIC}).skipwhite (l_p___0 + l_len)
					if not a_ignore___0.is_void then
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_r), create {CE_INTEGER_8_POINTER}.make_cast (a_ignore___0), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_ignore___0))))) = 0 then
							l_r := (create {P_CHARSET_STATIC}).skipwhite (l_r + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_ignore___0))).to_integer_32)
						end
					end
					if (cin_nocode (l_r)).to_boolean then
						Result := 1
						l_return := True
					end
				end
				if not l_return and then ((l_p___0.item).to_integer_32 /= 0) then
					l_p___0 := l_p___0 + 1
				end
			end
			if not l_return then
				Result := 0
			end
		end

	find_start_brace (a_ind_maxcomment: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_cursor_save: PD_POS_T
			l_trypos: CE_POINTER [PD_POS_T]
			l_pos___3: CE_POINTER [PD_POS_T]
			l_break: BOOLEAN
		do
			create {CE_CLASS_POINTER [PD_POS_T]} l_pos___3.make

			l_cursor_save := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			from
			until
				(l_break)
			loop
				l_break := False
				l_trypos := (create {P_SEARCH_STATIC}).findmatchlimit (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('{').code, 4, 0)
				if l_trypos.is_void then
					l_break := True
				end
				if not (l_break) then
					pos_copy___0.item.item := (l_trypos.item).twin
					l_trypos := pos_copy___0.item;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_trypos.item).twin
					l_pos___3 := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
					if (l_trypos.item.cin_skip2pos) = l_trypos.item.col then
						l_pos___3 := find_start_comment (a_ind_maxcomment)
						if l_pos___3.is_void then
							l_break := True
						end
					end
				end
				if not (l_break) and then (not l_pos___3.is_void) then
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_pos___3.item.lnum
				end
			end
			l_break := False;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_cursor_save.twin
			Result := l_trypos
		end

	find_match_paren (a_ind_maxparen, a_ind_maxcomment: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_cursor_save: PD_POS_T
			l_trypos: CE_POINTER [PD_POS_T]
		do
			l_cursor_save := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
			l_trypos := (create {P_SEARCH_STATIC}).findmatchlimit (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('(').code, 0, a_ind_maxparen)
			if not l_trypos.is_void then
				if (l_trypos.item.cin_skip2pos) > l_trypos.item.col then
					l_trypos := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
				else
					pos_copy___1.item.item := (l_trypos.item).twin
					l_trypos := pos_copy___1.item;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_trypos.item).twin
					if not (find_start_comment (a_ind_maxcomment)).is_void then
						l_trypos := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
					end
				end
			end
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_cursor_save.twin
			Result := l_trypos
		end

	find_last_paren (a_l: CE_POINTER [NATURAL_8]; a_start___1, a_end: INTEGER_32): INTEGER_32
		require
			not a_l.is_void
		local
			l_i___0: INTEGER_32
			l_retval: INTEGER_32
			l_open_count: INTEGER_32
		do
			l_retval := 0
			l_open_count := 0;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
			l_i___0 := 0
			from
			until
				not ((a_l[l_i___0]).to_boolean)
			loop
				l_i___0 := (cin_skipcomment (a_l + l_i___0)).distance (a_l)
				l_i___0 := (skip_string (a_l + l_i___0)).distance (a_l)
				if (a_l[l_i___0]).to_integer_32 = a_start___1 then
					l_open_count := l_open_count + 1
				elseif (a_l[l_i___0]).to_integer_32 = a_end then
					if l_open_count > 0 then
						l_open_count := l_open_count - 1
					else
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_i___0
						l_retval := 1
					end
				end
				l_i___0 := l_i___0 + 1
			end
			Result := l_retval
		end

	get_c_indent: INTEGER_32
		local
			l_ind_level: INTEGER_32
			l_ind_open_imag: INTEGER_32
			l_ind_no_brace: INTEGER_32
			l_ind_first_open: INTEGER_32
			l_ind_open_extra: INTEGER_32
			l_ind_close_extra: INTEGER_32
			l_ind_open_left_imag: INTEGER_32
			l_ind_jump_label: INTEGER_32
			l_ind_case: INTEGER_32
			l_ind_case_code: INTEGER_32
			l_ind_case_break: INTEGER_32
			l_ind_scopedecl: INTEGER_32
			l_ind_scopedecl_code: INTEGER_32
			l_ind_param: INTEGER_32
			l_ind_func_type: INTEGER_32
			l_ind_cpp_baseclass: INTEGER_32
			l_ind_continuation: INTEGER_32
			l_ind_unclosed: INTEGER_32
			l_ind_unclosed2: INTEGER_32
			l_ind_unclosed_noignore: INTEGER_32
			l_ind_unclosed_wrapped: INTEGER_32
			l_ind_unclosed_whiteok: INTEGER_32
			l_ind_matching_paren: INTEGER_32
			l_ind_paren_prev: INTEGER_32
			l_ind_comment: INTEGER_32
			l_ind_in_comment: INTEGER_32
			l_ind_in_comment2: INTEGER_32
			l_ind_maxparen: INTEGER_32
			l_ind_maxcomment: INTEGER_32
			l_ind_java: INTEGER_32
			l_ind_js: INTEGER_32
			l_ind_keep_case_label: INTEGER_32
			l_cur_curpos: CE_ARRAY [PD_POS_T]
			l_amount: INTEGER_32
			l_scope_amount: INTEGER_32
			l_cur_amount: INTEGER_32
			l_col: CE_ARRAY [INTEGER_32]
			l_theline: CE_POINTER [NATURAL_8]
			l_linecopy___0: CE_POINTER [NATURAL_8]
			l_trypos: CE_POINTER [PD_POS_T]
			l_tryposBrace: CE_POINTER [PD_POS_T]
			l_our_paren_pos: CE_ARRAY [PD_POS_T]
			l_start___1: CE_POINTER [NATURAL_8]
			l_start_brace: INTEGER_32
			l_ourscope: INTEGER_32
			l_l: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_look: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_terminated: NATURAL_8
			l_lookfor: INTEGER_32
			l_whilelevel: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_options___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_fraction: INTEGER_32
			l_divider: INTEGER_32
			l_n: INTEGER_32
			l_iscase: INTEGER_32
			l_lookfor_break: INTEGER_32
			l_cont_amount: INTEGER_32
			l_original_line_islabel: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_lead_start_len: INTEGER_32
			l_lead_middle_len: INTEGER_32
			l_lead_start: CE_ARRAY [NATURAL_8]
			l_lead_middle: CE_ARRAY [NATURAL_8]
			l_lead_end: CE_ARRAY [NATURAL_8]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_start_align: INTEGER_32
			l_start_off: INTEGER_32
			l_done___2: INTEGER_32
			l_align: INTEGER_32
			l_off___0: INTEGER_32
			l_what: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___26: INTEGER_32
			l_ignore_paren_col: INTEGER_32
			l_save_lnum: INTEGER_32
			l_line: CE_POINTER [NATURAL_8]
			l_look_col: INTEGER_32
			l_tmp___54: INTEGER_32
			l_tmp___55: INTEGER_32
			l_tmp___88: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_cur_curpos.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_col.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_our_paren_pos.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_l.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_look.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_lnum.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_options___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_lead_start.make (<<50>>)
			create {CE_NATURAL_8_ARRAY} l_lead_middle.make (<<50>>)
			create {CE_NATURAL_8_ARRAY} l_lead_end.make (<<50>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ind_level := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_open_imag := 0
					l_ind_no_brace := 0
					l_ind_first_open := 0
					l_ind_open_extra := 0
					l_ind_close_extra := 0
					l_ind_open_left_imag := 0
					l_ind_jump_label := -1
					l_ind_case := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_case_code := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_case_break := 0
					l_ind_scopedecl := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_scopedecl_code := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_param := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_func_type := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_cpp_baseclass := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_continuation := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_unclosed := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw * 2).to_integer_32
					l_ind_unclosed2 := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
					l_ind_unclosed_noignore := 0
					l_ind_unclosed_wrapped := 0
					l_ind_unclosed_whiteok := 0
					l_ind_matching_paren := 0
					l_ind_paren_prev := 0
					l_ind_comment := 0
					l_ind_in_comment := 3
					l_ind_in_comment2 := 0
					l_ind_maxparen := 20
					l_ind_maxcomment := 70
					l_ind_java := 0
					l_ind_js := 0
					l_ind_keep_case_label := 0
					l_cur_amount := 2_147_483_647
					l_tryposBrace := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
					l_fraction := 0
					l_cont_amount := 0
					l_options___0.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_cino
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_options___0.item.item).to_boolean)) then
						l_pos := -1 + 43 -- skip loop
					end
				when 2 then -- loop body:
						l_tmp := l_options___0.item
						l_options___0.item := l_options___0.item + 1
						l_l.item := l_tmp
						if (l_options___0.item.item).to_integer_32 = 45 then
							l_options___0.item := l_options___0.item + 1
						end
						l_n := ((create {P_CHARSET_STATIC}).getdigits (l_options___0)).to_integer_32
						l_divider := 0
						if (l_options___0.item.item).to_integer_32 = 46 then
							l_options___0.item := l_options___0.item + 1
							l_fraction := (atol (create {CE_INTEGER_8_POINTER}.make_cast (l_options___0.item))).to_integer_32
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_options___0.item.item).to_integer_32 >= 48 then
									if not ((l_options___0.item.item).to_integer_32 <= 57) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_options___0.item := l_options___0.item + 1
									if l_divider.to_boolean then
										l_divider := l_divider * (10)
									else
										l_divider := 10
									end
								end
							end
							l_break := False
						end
						if (l_options___0.item.item).to_integer_32 /= 115 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if l_n /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_fraction = 0 then
							l_n := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_n := (l_n.to_integer_32 * (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw).to_integer_32
						if l_divider.to_boolean then
							l_n := (l_n.to_integer_32 + ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_sw * l_fraction.to_integer_32 + (l_divider // 2).to_integer_32) // l_divider.to_integer_32).to_integer_32
						end
				when 7 then
						l_options___0.item := l_options___0.item + 1
				when 8 then -- if done
						if (l_l.item[1]).to_integer_32 = 45 then
							l_n := -l_n
						end
						inspect (l_l.item.item).to_integer_32 -- switch 1 head
						when 62 then l_pos := -1 + 9
						when 101 then l_pos := -1 + 10
						when 110 then l_pos := -1 + 11
						when 102 then l_pos := -1 + 12
						when 123 then l_pos := -1 + 13
						when 125 then l_pos := -1 + 14
						when 94 then l_pos := -1 + 15
						when 76 then l_pos := -1 + 16
						when 58 then l_pos := -1 + 17
						when 61 then l_pos := -1 + 18
						when 98 then l_pos := -1 + 19
						when 112 then l_pos := -1 + 20
						when 116 then l_pos := -1 + 21
						when 47 then l_pos := -1 + 22
						when 99 then l_pos := -1 + 23
						when 67 then l_pos := -1 + 24
						when 105 then l_pos := -1 + 25
						when 43 then l_pos := -1 + 26
						when 40 then l_pos := -1 + 27
						when 117 then l_pos := -1 + 28
						when 85 then l_pos := -1 + 29
						when 87 then l_pos := -1 + 30
						when 119 then l_pos := -1 + 31
						when 109 then l_pos := -1 + 32
						when 77 then l_pos := -1 + 33
						when 41 then l_pos := -1 + 34
						when 42 then l_pos := -1 + 35
						when 103 then l_pos := -1 + 36
						when 104 then l_pos := -1 + 37
						when 106 then l_pos := -1 + 38
						when 74 then l_pos := -1 + 39
						when 108 then l_pos := -1 + 40
						when 35 then l_pos := -1 + 41
						else l_pos := -1 + 42
						end
				when 9 then -- switch 1, case 62
						l_ind_level := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 10 then -- switch 1, case 101
						l_ind_open_imag := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 11 then -- switch 1, case 110
						l_ind_no_brace := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 12 then -- switch 1, case 102
						l_ind_first_open := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 13 then -- switch 1, case 123
						l_ind_open_extra := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 14 then -- switch 1, case 125
						l_ind_close_extra := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 15 then -- switch 1, case 94
						l_ind_open_left_imag := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 16 then -- switch 1, case 76
						l_ind_jump_label := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 17 then -- switch 1, case 58
						l_ind_case := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 18 then -- switch 1, case 61
						l_ind_case_code := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 19 then -- switch 1, case 98
						l_ind_case_break := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 20 then -- switch 1, case 112
						l_ind_param := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 21 then -- switch 1, case 116
						l_ind_func_type := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 22 then -- switch 1, case 47
						l_ind_comment := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 23 then -- switch 1, case 99
						l_ind_in_comment := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 24 then -- switch 1, case 67
						l_ind_in_comment2 := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 25 then -- switch 1, case 105
						l_ind_cpp_baseclass := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 26 then -- switch 1, case 43
						l_ind_continuation := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 27 then -- switch 1, case 40
						l_ind_unclosed := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 28 then -- switch 1, case 117
						l_ind_unclosed2 := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 29 then -- switch 1, case 85
						l_ind_unclosed_noignore := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 30 then -- switch 1, case 87
						l_ind_unclosed_wrapped := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 31 then -- switch 1, case 119
						l_ind_unclosed_whiteok := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 32 then -- switch 1, case 109
						l_ind_matching_paren := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 33 then -- switch 1, case 77
						l_ind_paren_prev := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 34 then -- switch 1, case 41
						l_ind_maxparen := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 35 then -- switch 1, case 42
						l_ind_maxcomment := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 36 then -- switch 1, case 103
						l_ind_scopedecl := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 37 then -- switch 1, case 104
						l_ind_scopedecl_code := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 38 then -- switch 1, case 106
						l_ind_java := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 39 then -- switch 1, case 74
						l_ind_js := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 40 then -- switch 1, case 108
						l_ind_keep_case_label := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 41 then -- switch 1, case 35
						ind_hash_comment.item := l_n
						l_pos := -1 + 42 -- switch 1; break
				when 42 then -- switch 1, done:
						if (l_options___0.item.item).to_integer_32 = 44 then
							l_options___0.item := l_options___0.item + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 43 then -- loop done
					l_cur_curpos.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					if l_cur_curpos.item.lnum = 1 then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_linecopy___0 := (create {P_MISC2_STATIC}).vim_strsave (((create {P_MEMLINE_STATIC}).ml_get (l_cur_curpos.item.lnum)))
						if l_linecopy___0.is_void then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 271 -- skip if block
					end
				when 44 then -- if:
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_linecopy___0))).to_integer_32 then
								if (l_linecopy___0[(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col]).to_integer_32 = 41 then
									l_linecopy___0[(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col] := (('%/0/').code).to_natural_8
								end
							end
						end
						l_theline := (create {P_CHARSET_STATIC}).skipwhite (l_linecopy___0);
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
						l_original_line_islabel := cin_islabel (l_ind_maxcomment)
						if (l_theline.item).to_integer_32 /= 35 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						if (l_linecopy___0.item).to_integer_32 = 35 then
							l_amount := 0
						elseif ((create {P_EDIT_STATIC}).in_cinkeys (('#').code, (' ').code, 1)).to_boolean then
							l_amount := 0
						else
							l_pos := -1 + 47 -- goto _L___37
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 270
				when 47 then -- else: | _L___37:
						if not (l_original_line_islabel.to_boolean) then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						if not l_ind_js.to_boolean then
							if l_ind_jump_label < 0 then
								l_amount := 0
							else
								l_pos := -1 + 50 -- goto _L___36
							end
						else
							l_pos := -1 + 50 -- goto _L___36
						end
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 270
				when 50 then -- else: | _L___36:
						if not ((cin_islinecomment (l_theline)).to_boolean) then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_trypos := find_line_comment
						if not l_trypos.is_void then
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_trypos, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							l_amount := l_col.item
						else
							l_pos := -1 + 53 -- goto _L___34
						end
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 270
				when 53 then -- else: | _L___34:
						if not ((cin_iscomment (l_theline)).to_boolean) then
							l_pos := -1 + 240 -- skip if block
						end
				when 54 then -- if: | _L___33:
						l_trypos := find_match_paren (l_ind_maxparen, l_ind_maxcomment)
						if l_trypos.is_void then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if l_ind_java = 0 then
							l_pos := -1 + 61 -- goto _L___31
						else
							l_pos := -1 + 57 -- goto _L___32
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 57 then -- else: | _L___32:
						l_tryposBrace := find_start_brace (l_ind_maxcomment)
						if l_tryposBrace.is_void then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						l_pos := -1 + 61 -- goto _L___31
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 60 then -- else:
						if l_trypos.is_void then
							l_pos := -1 + 222 -- skip if block
						end
				when 61 then -- if: | _L___31:
						if not l_trypos.is_void then
							if not l_tryposBrace.is_void then
								if l_trypos.item.lnum /= l_tryposBrace.item.lnum then
									l_tmp___26 := (l_trypos.item.lnum < l_tryposBrace.item.lnum).to_integer
								else
									l_tmp___26 := (l_trypos.item.col < l_tryposBrace.item.col).to_integer
								end
								if l_tmp___26.to_boolean then
									l_trypos := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
								else
									l_tryposBrace := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
								end
							end
						end
						if l_trypos.is_void then
							l_pos := -1 + 115 -- skip if block
						end
				when 62 then -- if:
						if (l_theline[0]).to_integer_32 /= 41 then
							l_pos := -1 + 65 -- skip if block
						end
				when 63 then -- if:
						if l_ind_paren_prev.to_boolean then
							l_amount := get_indent_lnum ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)
						else
							l_pos := -1 + 65 -- goto _L___1
						end
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 66
				when 65 then -- else: | _L___1:
						l_amount := -1
						l_our_paren_pos.item := (l_trypos.item).twin
						l_lnum.item := l_cur_curpos.item.lnum - 1
						from
						until
							not (not (l_break) and then (l_lnum.item > l_our_paren_pos.item.lnum))
						loop
							l_break := False
							l_continue := False
							l_l.item := (create {P_CHARSET_STATIC}).skipwhite (((create {P_MEMLINE_STATIC}).ml_get (l_lnum.item)))
							if (cin_nocode (l_l.item)).to_boolean then
								l_continue := True
							end
							if not (l_return or l_break or l_continue) then
								if (cin_ispreproc_cont (l_l, l_lnum)).to_boolean then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_lnum.item
								l_trypos := find_start_comment (l_ind_maxcomment)
								if not l_trypos.is_void then
									l_lnum.item := l_trypos.item.lnum + 1
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_trypos := find_match_paren ((l_cur_curpos.item.corr_ind_maxparen (l_ind_maxparen)), l_ind_maxcomment)
								if not l_trypos.is_void then
									if l_trypos.item.lnum = l_our_paren_pos.item.lnum then
										if l_trypos.item.col = l_our_paren_pos.item.col then
											l_amount := get_indent_lnum (l_lnum.item)
											if (l_theline[0]).to_integer_32 = 41 then
												if l_our_paren_pos.item.lnum /= l_lnum.item then
													if l_cur_amount > l_amount then
														l_cur_amount := l_amount
													end
												end
												l_amount := -1
											end
											l_break := True
										end
									end
								end
							end
							if (not l_break) then
								l_lnum.item := l_lnum.item - 1
							end
						end
						l_break := False
						l_continue := False
				when 66 then
						if l_amount /= -1 then
							l_pos := -1 + 113 -- skip if block
						end
				when 67 then -- if:
						l_ignore_paren_col := 0
						l_amount := skip_label (l_our_paren_pos.item.lnum, l_look, l_ind_maxcomment)
						l_look.item := (create {P_CHARSET_STATIC}).skipwhite (l_look.item)
						if (l_look.item.item).to_integer_32 = 40 then
							l_save_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_our_paren_pos.item.lnum
							l_line := (create {P_MEMLINE_STATIC}).ml_get_curline
							l_look_col := (l_look.item).distance (l_line);
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_look_col + 1
							l_trypos := (create {P_SEARCH_STATIC}).findmatchlimit (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), (')').code, 0, l_ind_maxparen)
							if not l_trypos.is_void then
								if l_trypos.item.lnum = l_our_paren_pos.item.lnum then
									if l_trypos.item.col < l_our_paren_pos.item.col then
										l_ignore_paren_col := l_trypos.item.col + 1
									end
								end
							end
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_save_lnum
							l_look.item := ((create {P_MEMLINE_STATIC}).ml_get (l_our_paren_pos.item.lnum)) + l_look_col
						end
						if (l_theline[0]).to_integer_32 /= 41 then
							l_pos := -1 + 70 -- skip if block
						end
				when 68 then -- if:
						l_pos := -1 + 76 -- goto _L___3
				when 69 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 70 then -- else:
						if l_ind_unclosed /= 0 then
							l_pos := -1 + 73 -- skip if block
						end
				when 71 then -- if:
						l_pos := -1 + 76 -- goto _L___3
				when 72 then -- if block done, skip else block:
						l_pos := -1 + 91
				when 73 then -- else:
						if l_ind_unclosed_noignore.to_boolean then
							l_pos := -1 + 91 -- skip if block
						end
				when 74 then -- if:
						if (l_look.item.item).to_integer_32 /= 40 then
							l_pos := -1 + 91 -- skip if block
						end
				when 75 then -- if:
						if l_ignore_paren_col /= 0 then
							l_pos := -1 + 91 -- skip if block
						end
				when 76 then -- if: | _L___3:
						if (l_theline[0]).to_integer_32 = 41 then
							l_pos := -1 + 90 -- skip if block
						end
				when 77 then -- if:
						l_cur_amount := 2_147_483_647
						l_l.item := (create {P_MEMLINE_STATIC}).ml_get (l_our_paren_pos.item.lnum)
						if not (l_ind_unclosed_wrapped.to_boolean) then
							l_pos := -1 + 89 -- skip if block
						end
				when 78 then -- if:
						if not ((cin_ends_in (l_l.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("(")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))).to_boolean) then
							l_pos := -1 + 87 -- skip if block
						end
				when 79 then -- if:
						l_n := 1
						l_col.item := 0
				when 80 then -- loop condition:
						if not (l_col.item < l_our_paren_pos.item.col) then
							l_pos := -1 + 85 -- skip loop
						end
				when 81 then -- loop body:
						inspect (l_l.item[l_col.item]).to_integer_32 -- switch 2 head
						when 40 then l_pos := -1 + 82
						when 123 then l_pos := -1 + 82
						when 41 then l_pos := -1 + 83
						when 125 then l_pos := -1 + 83
						else l_pos := -1 + 84
						end
				when 82 then -- switch 2, case 40 | switch 2, case 123
						l_n := l_n + 1
						l_pos := -1 + 84 -- switch 2; break
				when 83 then -- switch 2, case 41 | switch 2, case 125
						if l_n > 1 then
							l_n := l_n - 1
						end
						l_pos := -1 + 84 -- switch 2; break
				when 84 then -- switch 2, done:
						l_col.item := l_col.item + 1
						l_pos := -1 + 80 -- back to loop condition
				when 85 then -- loop done
						l_our_paren_pos.item.col := 0
						l_amount := l_amount + (l_n * l_ind_unclosed_wrapped)
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 87 then -- else:
						l_pos := -1 + 89 -- goto _L___2
				when 88 then -- if done | if block done, skip else block:
						l_pos := -1 + 90
				when 89 then -- else: | _L___2:
						if l_ind_unclosed_whiteok.to_boolean then
							l_our_paren_pos.item.col := (l_our_paren_pos.item.col) + 1
						else
							l_col.item := l_our_paren_pos.item.col + 1
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_l.item[l_col.item]).to_integer_32 /= 32 then
									if (l_l.item[l_col.item]).to_integer_32 /= 9 then
										l_break := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_col.item := l_col.item + 1
								end
							end
							l_break := False
							if (l_l.item[l_col.item]).to_integer_32 /= 0 then
								l_our_paren_pos.item.col := l_col.item
							else
								l_our_paren_pos.item.col := (l_our_paren_pos.item.col) + 1
							end
						end
				when 90 then -- if done
						if l_our_paren_pos.item.col > 0 then
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_our_paren_pos, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							if l_cur_amount > l_col.item then
								l_cur_amount := l_col.item
							end
						end
				when 91 then -- if done | if done | if done | if done
						if (l_theline[0]).to_integer_32 /= 41 then
							l_pos := -1 + 94 -- skip if block
						end
				when 92 then -- if:
						if not l_ind_matching_paren.to_boolean then
							l_pos := -1 + 94 -- goto _L___7
						end
				when 93 then -- if block done, skip else block:
						l_pos := -1 + 113
				when 94 then -- else: | _L___7:
						if l_ind_unclosed /= 0 then
							l_pos := -1 + 97 -- skip if block
						end
				when 95 then -- if:
						l_pos := -1 + 100 -- goto _L___4
				when 96 then -- if block done, skip else block:
						l_pos := -1 + 113
				when 97 then -- else:
						if l_ind_unclosed_noignore.to_boolean then
							l_pos := -1 + 106 -- skip if block
						end
				when 98 then -- if:
						if (l_look.item.item).to_integer_32 /= 40 then
							l_pos := -1 + 104 -- skip if block
						end
				when 99 then -- if:
						if l_ignore_paren_col /= 0 then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if: | _L___4:
						if l_cur_amount.to_integer_32 /= 2_147_483_647 then
							l_amount := l_cur_amount
						end
				when 101 then -- if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else:
						l_pos := -1 + 106 -- goto _L___6
				when 103 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 104 then -- else:
						l_pos := -1 + 106 -- goto _L___6
				when 105 then -- if done | if block done, skip else block:
						l_pos := -1 + 113
				when 106 then -- else: | _L___6:
						l_col.item := l_our_paren_pos.item.col
				when 107 then -- loop condition:
						if not (l_our_paren_pos.item.col > l_ignore_paren_col) then
							l_pos := -1 + 112 -- skip loop
						end
				when 108 then -- loop body:
						l_our_paren_pos.item.col := (l_our_paren_pos.item.col) - 1
						inspect ((l_our_paren_pos.item.ml_get_pos).item).to_integer_32 -- switch 3 head
						when 40 then l_pos := -1 + 109
						when 41 then l_pos := -1 + 110
						else l_pos := -1 + 111
						end
				when 109 then -- switch 3, case 40
						l_amount := l_amount + l_ind_unclosed2
						l_col.item := l_our_paren_pos.item.col
						l_pos := -1 + 111 -- switch 3; break
				when 110 then -- switch 3, case 41
						l_amount := l_amount - l_ind_unclosed2
						l_col.item := (2_147_483_647).to_integer_32
						l_pos := -1 + 111 -- switch 3; break
				when 111 then -- switch 3, done:
						l_pos := -1 + 107 -- back to loop condition
				when 112 then -- loop done
						if (l_col.item).to_integer_32 = 2_147_483_647 then
							l_amount := l_amount + l_ind_unclosed
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_our_paren_pos.item.lnum;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_col.item
							l_trypos := find_match_paren (l_ind_maxparen, l_ind_maxcomment)
							if not l_trypos.is_void then
								l_amount := l_amount + l_ind_unclosed2
							else
								l_amount := l_amount + l_ind_unclosed
							end
						end
						if l_cur_amount < l_amount then
							l_amount := l_cur_amount
						end
				when 113 then -- if done | if done | if done
						if (cin_iscomment (l_theline)).to_boolean then
							l_amount := l_amount + l_ind_comment
						end
				when 114 then -- if block done, skip else block:
						l_pos := -1 + 220
				when 115 then -- else:
						l_trypos := l_tryposBrace
						l_ourscope := l_trypos.item.lnum
						l_start___1 := (create {P_MEMLINE_STATIC}).ml_get (l_ourscope)
						l_look.item := (create {P_CHARSET_STATIC}).skipwhite (l_start___1)
						if (l_look.item.item).to_integer_32 = 123 then
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_trypos, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							l_amount := l_col.item
							if (l_start___1.item).to_integer_32 = 123 then
								l_start_brace := 1
							else
								l_start_brace := 2
							end
						else
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_ourscope
							l_lnum.item := l_ourscope
							if (find_last_paren (l_start___1, ('(').code, (')').code)).to_boolean then
								l_trypos := find_match_paren (l_ind_maxparen, l_ind_maxcomment)
								if not l_trypos.is_void then
									l_lnum.item := l_trypos.item.lnum
								end
							end
							if l_ind_keep_case_label.to_boolean then
								if (cin_iscase (((create {P_CHARSET_STATIC}).skipwhite (((create {P_MEMLINE_STATIC}).ml_get_curline))), 0)).to_boolean then
									l_amount := get_indent
								else
									l_amount := skip_label (l_lnum.item, l_l, l_ind_maxcomment)
								end
							else
								l_amount := skip_label (l_lnum.item, l_l, l_ind_maxcomment)
							end
							l_start_brace := 3
						end
						if (l_theline[0]).to_integer_32 /= 125 then
							l_pos := -1 + 118 -- skip if block
						end
				when 116 then -- if:
						l_amount := l_amount + l_ind_close_extra
				when 117 then -- if block done, skip else block:
						l_pos := -1 + 220
				when 118 then -- else:
						l_lookfor := 0
						if (cin_iselse (l_theline)).to_boolean then
							l_lookfor := 1
						elseif (cin_iswhileofdo (l_theline, l_cur_curpos.item.lnum, l_ind_maxparen)).to_boolean then
							l_lookfor := 2
						end
						if l_lookfor /= 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_cur_curpos.item.lnum
							if (find_match (l_lookfor, l_ourscope, l_ind_maxparen, l_ind_maxcomment)) = 1 then
								l_amount := get_indent
								l_pos := -1 + 270 -- goto theend
							end
						end
				when 119 then
						if l_start_brace = 1 then
							l_amount := l_ind_open_left_imag
						elseif l_start_brace = 3 then
							l_amount := l_amount + l_ind_open_imag
						else
							l_amount := l_amount - l_ind_open_extra
							if l_amount < 0 then
								l_amount := 0
							end
						end
						l_lookfor_break := 0
						if (cin_iscase (l_theline, 0)).to_boolean then
							l_lookfor := 3
							l_amount := l_amount + l_ind_case
						elseif (cin_isscopedecl (l_theline)).to_boolean then
							l_lookfor := 7
							l_amount := l_amount + l_ind_scopedecl
						else
							if l_ind_case_break.to_boolean then
								if (cin_isbreak (l_theline)).to_boolean then
									l_lookfor_break := 1
								end
							end
							l_lookfor := 0
							l_amount := l_amount + l_ind_level
						end
						l_scope_amount := l_amount
						l_whilelevel := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_cur_curpos.item).twin
				when 120 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 219 -- skip loop
						end
				when 121 then -- loop body:
						l_break := False
						l_continue := False;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum <= l_ourscope) then
							l_pos := -1 + 138 -- skip if block
						end
				when 122 then -- if:
						if l_lookfor /= 10 then
							l_pos := -1 + 136 -- skip if block
						end
				when 123 then -- if:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= 0 then
							l_pos := -1 + 126 -- skip if block
						end
				when 124 then -- if:
						l_pos := -1 + 127 -- goto _L___8
				when 125 then -- if block done, skip else block:
						l_pos := -1 + 128
				when 126 then -- else:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < l_ourscope - l_ind_maxparen.to_integer_32) then
							l_pos := -1 + 128 -- skip if block
						end
				when 127 then -- if: | _L___8:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						elseif not l_ind_js.to_boolean then
							l_amount := l_amount + l_ind_continuation
						end
						l_break := True
				when 128 then -- if done
						if not (l_return or l_break or l_continue) then
							l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
							l_trypos := find_start_comment (l_ind_maxcomment)
							if not l_trypos.is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_trypos.item.lnum + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_ispreproc_cont (l_l, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor") + (create {PD_POS_T}.make).offset_of ("lnum")))).to_boolean then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_nocode (l_l.item)).to_boolean then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 134 -- skip if block
						end
				when 129 then -- if:
						l_terminated := (cin_isterminated (l_l.item, 0, 1)).to_natural_8
						if l_start_brace = 1 then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if:
						l_pos := -1 + 133 -- goto _L___9
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 134
				when 132 then -- else:
						if (cin_isfuncdecl (l_l, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).to_boolean then
							l_pos := -1 + 134 -- skip if block
						end
				when 133 then -- if: | _L___9:
						if l_terminated.to_integer_32 = 44 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then (l_terminated.to_integer_32 /= 59) then
							if (cin_isinit).to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if l_terminated.to_integer_32 = 0 then
								l_continue := True
							elseif l_terminated.to_integer_32 = 123 then
								l_continue := True
							end
						end
				when 134 then -- if done | if done
						if not (l_return or l_break or l_continue) and then (l_terminated.to_integer_32 /= 59) then
							l_trypos := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
							if (find_last_paren (l_l.item, ('(').code, (')').code)).to_boolean then
								l_trypos := find_match_paren (l_ind_maxparen, l_ind_maxcomment)
							end
							if l_trypos.is_void then
								if (find_last_paren (l_l.item, ('{').code, ('}').code)).to_boolean then
									l_trypos := find_start_brace (l_ind_maxcomment)
								end
							end
							if not l_trypos.is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_trypos.item.lnum + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if l_cont_amount > 0 then
								l_amount := l_cont_amount
							else
								l_amount := l_amount + l_ind_continuation
							end
						end
				when 135 then -- if block done, skip else block:
						l_pos := -1 + 137
				when 136 then -- else:
						if l_lookfor = 6 then
							if l_cont_amount > 0 then
								l_amount := l_cont_amount
							else
								l_amount := l_amount + l_ind_continuation
							end
						elseif l_lookfor /= 5 then
							if l_lookfor /= 9 then
								l_amount := l_scope_amount
								if (l_theline[0]).to_integer_32 = 123 then
									l_amount := l_amount + l_ind_open_extra
								end
							end
						end
				when 137 then -- if done
						if not (l_return or l_break or l_continue) then
							l_break := True
						end
				when 138 then -- if done
						if not (l_return or l_break or l_continue) then
							l_trypos := find_start_comment (l_ind_maxcomment)
							if not l_trypos.is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_trypos.item.lnum + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 160 -- skip if block
						end
				when 139 then -- if:
						l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
						l_iscase := cin_iscase (l_l.item, 0)
						if not (l_iscase.to_boolean) then
							l_pos := -1 + 142 -- skip if block
						end
				when 140 then -- if:
						l_pos := -1 + 143 -- goto _L___14
				when 141 then -- if block done, skip else block:
						l_pos := -1 + 160
				when 142 then -- else:
						if not ((cin_isscopedecl (l_l.item)).to_boolean) then
							l_pos := -1 + 160 -- skip if block
						end
				when 143 then -- if: | _L___14:
						if l_lookfor = 9 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then (l_whilelevel > 0) then
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 149 -- skip if block
						end
				when 144 then -- if:
						if l_lookfor /= 6 then
							l_pos := -1 + 147 -- skip if block
						end
				when 145 then -- if:
						l_pos := -1 + 148 -- goto _L___10
				when 146 then -- if block done, skip else block:
						l_pos := -1 + 149
				when 147 then -- else:
						if l_lookfor /= 10 then
							l_pos := -1 + 149 -- skip if block
						end
				when 148 then -- if: | _L___10:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						else
							l_amount := l_amount + l_ind_continuation
						end
						l_break := True
				when 149 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 159 -- skip if block
						end
				when 150 then -- if:
						if not (l_iscase.to_boolean) then
							l_pos := -1 + 153 -- skip if block
						end
				when 151 then -- if:
						if l_lookfor = 3 then
							l_pos := -1 + 158 -- goto _L___11
						else
							l_pos := -1 + 153 -- goto _L___13
						end
				when 152 then -- if block done, skip else block:
						l_pos := -1 + 159
				when 153 then -- else: | _L___13:
						if not (l_iscase.to_boolean) then
							l_pos := -1 + 156 -- skip if block
						end
				when 154 then -- if:
						if l_lookfor_break.to_boolean then
							l_pos := -1 + 158 -- goto _L___11
						else
							l_pos := -1 + 156 -- goto _L___12
						end
				when 155 then -- if block done, skip else block:
						l_pos := -1 + 159
				when 156 then -- else: | _L___12:
						if l_iscase.to_boolean then
							l_pos := -1 + 159 -- skip if block
						end
				when 157 then -- if:
						if l_lookfor /= 7 then
							l_pos := -1 + 159 -- skip if block
						end
				when 158 then -- if: | _L___11:
						l_trypos := find_start_brace (l_ind_maxcomment)
						if l_trypos.is_void then
							l_amount := get_indent
							l_break := True
						elseif l_trypos.item.lnum = l_ourscope then
							l_amount := get_indent
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_continue := True
						end
				when 159 then -- if done | if done | if done | if done
						if not (l_return or l_break or l_continue) then
							l_n := get_indent_nolabel ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
							if l_lookfor = 5 then
								if l_n.to_boolean then
									l_amount := l_n
								end
								if not l_lookfor_break.to_boolean then
									l_break := True
								end
							end
						end
						if not (l_return or l_break or l_continue) and then (l_n.to_boolean) then
							l_amount := l_n
							l_l.item := after_label (((create {P_MEMLINE_STATIC}).ml_get_curline))
							if not (l_l.item).is_void then
								if (cin_is_cinword (l_l.item)).to_boolean then
									if (l_theline[0]).to_integer_32 = 123 then
										l_amount := l_amount + l_ind_open_extra
									else
										l_amount := l_amount + (l_ind_level + l_ind_no_brace)
									end
								end
							end
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_tmp___54 := get_indent
							if l_iscase.to_boolean then
								l_tmp___55 := l_ind_case_code
							else
								l_tmp___55 := l_ind_scopedecl_code
							end
							l_scope_amount := l_tmp___54 + l_tmp___55
							if l_ind_case_break.to_boolean then
								l_lookfor := 8
							else
								l_lookfor := 4
							end
							l_continue := True
						end
				when 160 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 166 -- skip if block
						end
				when 161 then -- if:
						if l_lookfor /= 3 then
							l_pos := -1 + 164 -- skip if block
						end
				when 162 then -- if:
						l_pos := -1 + 165 -- goto _L___15
				when 163 then -- if block done, skip else block:
						l_pos := -1 + 166
				when 164 then -- else:
						if l_lookfor /= 7 then
							l_pos := -1 + 166 -- skip if block
						end
				when 165 then -- if: | _L___15:
						if (find_last_paren (l_l.item, ('{').code, ('}').code)).to_boolean then
							l_trypos := find_start_brace (l_ind_maxcomment)
							if not l_trypos.is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_trypos.item.lnum + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							end
						end
						l_continue := True
				when 166 then -- if done | if done
						if not (l_return or l_break or l_continue) and then (not l_ind_js.to_boolean) then
							if (cin_islabel (l_ind_maxcomment)).to_boolean then
								l_l.item := after_label (((create {P_MEMLINE_STATIC}).ml_get_curline))
								if (l_l.item).is_void then
									l_continue := True
								elseif (cin_nocode (l_l.item)).to_boolean then
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
							if (cin_ispreproc_cont (l_l, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor") + (create {PD_POS_T}.make).offset_of ("lnum")))).to_boolean then
								l_continue := True
							elseif (cin_nocode (l_l.item)).to_boolean then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_n := 0
							if l_lookfor /= 5 then
								if l_ind_cpp_baseclass > 0 then
									l_n := cin_is_cpp_baseclass (l_col)
									l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
								end
							end
							if l_n.to_boolean then
								if l_lookfor = 6 then
									if l_cont_amount > 0 then
										l_amount := l_cont_amount
									else
										l_amount := l_amount + l_ind_continuation
									end
								elseif (l_theline[0]).to_integer_32 = 123 then
									l_lookfor := 6
									l_ind_continuation := 0
									l_continue := True
								else
									l_amount := get_baseclass_amount (l_col.item, l_ind_maxparen, l_ind_maxcomment, l_ind_cpp_baseclass)
								end
								if not (l_return or l_break or l_continue) then
									l_break := True
								end
							elseif l_lookfor = 9 then
								if (cin_isterminated (l_l.item, 1, 0)).to_boolean then
									l_break := True
								else
									l_continue := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 218 -- skip if block
						end
				when 167 then -- if:
						l_terminated := (cin_isterminated (l_l.item, 0, 1)).to_natural_8
						if l_terminated.to_integer_32 /= 0 then
							l_pos := -1 + 170 -- skip if block
						end
				when 168 then -- if:
						l_pos := -1 + 172 -- goto _L___21
				when 169 then -- if block done, skip else block:
						l_pos := -1 + 218
				when 170 then -- else:
						if l_lookfor = 6 then
							l_pos := -1 + 195 -- skip if block
						end
				when 171 then -- if:
						if l_terminated.to_integer_32 /= 44 then
							l_pos := -1 + 193 -- skip if block
						end
				when 172 then -- if: | _L___21:
						find_last_paren (l_l.item, ('(').code, (')').code).do_nothing
						l_trypos := find_match_paren ((l_cur_curpos.item.corr_ind_maxparen (l_ind_maxparen)), l_ind_maxcomment)
						if l_trypos.is_void then
							if l_terminated.to_integer_32 = 44 then
								if (find_last_paren (l_l.item, ('{').code, ('}').code)).to_boolean then
									l_trypos := find_start_brace (l_ind_maxcomment)
								end
							end
						end
						if not l_trypos.is_void then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_trypos.item).twin
							l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
							if (cin_iscase (l_l.item, 0)).to_boolean then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
								l_continue := True
							elseif (cin_isscopedecl (l_l.item)).to_boolean then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if l_terminated.to_integer_32 = 44 then
								from
								until
									not (not (l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1))
								loop
									l_break := False
									l_l.item := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)
									if (l_l.item.item).to_integer_32 = 0 then
										l_break := True
									elseif (l_l.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_l.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
										l_break := True
									end
									if not (l_return or l_break or l_continue) then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
									end
								end
								l_break := False
							end
							if not l_ind_js.to_boolean then
								l_cur_amount := skip_label ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_l, l_ind_maxcomment)
							else
								l_cur_amount := get_indent
							end
							if l_terminated.to_integer_32 /= 44 then
								if l_lookfor /= 5 then
									if (l_theline[0]).to_integer_32 = 123 then
										l_amount := l_cur_amount
										if (((create {P_CHARSET_STATIC}).skipwhite (l_l.item)).item).to_integer_32 /= 123 then
											l_amount := l_amount + l_ind_open_extra
										end
										if l_ind_cpp_baseclass.to_boolean then
											l_lookfor := 9
											l_continue := True
										end
										if not (l_return or l_break or l_continue) then
											l_break := True
										end
									end
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 192 -- skip if block
						end
				when 173 then -- if:
						if not ((cin_is_cinword (l_l.item)).to_boolean) then
							l_pos := -1 + 176 -- skip if block
						end
				when 174 then -- if:
						l_pos := -1 + 177 -- goto _L___18
				when 175 then -- if block done, skip else block:
						l_pos := -1 + 192
				when 176 then -- else:
						if not ((cin_iselse (((create {P_CHARSET_STATIC}).skipwhite (l_l.item)))).to_boolean) then
							l_pos := -1 + 184 -- skip if block
						end
				when 177 then -- if: | _L___18:
						if l_lookfor /= 6 then
							l_pos := -1 + 180 -- skip if block
						end
				when 178 then -- if:
						l_pos := -1 + 181 -- goto _L___16
				when 179 then -- if block done, skip else block:
						l_pos := -1 + 182
				when 180 then -- else:
						if l_lookfor /= 10 then
							l_pos := -1 + 182 -- skip if block
						end
				when 181 then -- if: | _L___16:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						else
							l_amount := l_amount + l_ind_continuation
						end
						l_break := True
				when 182 then -- if done
						if not (l_return or l_break or l_continue) then
							l_amount := l_cur_amount
							if (l_theline[0]).to_integer_32 = 123 then
								l_amount := l_amount + l_ind_open_extra
							end
							if l_lookfor /= 5 then
								l_amount := l_amount + (l_ind_level + l_ind_no_brace)
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_l.item := (create {P_CHARSET_STATIC}).skipwhite (((create {P_MEMLINE_STATIC}).ml_get_curline))
							if (cin_isdo (l_l.item)).to_boolean then
								if l_whilelevel = 0 then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									l_whilelevel := l_whilelevel - 1
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_iselse (l_l.item)).to_boolean then
								if l_whilelevel = 0 then
									l_trypos := find_start_brace (l_ind_maxcomment)
									if l_trypos.is_void then
										l_break := True
									elseif (find_match (1, l_trypos.item.lnum, l_ind_maxparen, l_ind_maxcomment)) = 0 then
										l_break := True
									end
								end
							end
						end
				when 183 then -- if block done, skip else block:
						l_pos := -1 + 192
				when 184 then -- else:
						if l_lookfor = 6 then
							if l_terminated.to_integer_32 = 44 then
								l_amount := l_amount + l_ind_continuation
							end
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 192 -- skip if block
						end
				when 185 then -- if:
						if l_lookfor /= 10 then
							l_pos := -1 + 188 -- skip if block
						end
				when 186 then -- if:
						if l_terminated.to_integer_32 = 44 then
							if l_ind_cpp_baseclass = 0 then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_lookfor := 9
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) and then (l_amount > l_cur_amount) then
							l_amount := l_cur_amount
						end
				when 187 then -- if block done, skip else block:
						l_pos := -1 + 192
				when 188 then -- else:
						l_amount := l_cur_amount
						if l_lookfor /= 0 then
							l_pos := -1 + 191 -- skip if block
						end
				when 189 then -- if:
						if l_terminated.to_integer_32 = 44 then
							l_lookfor := 10
							l_cont_amount := cin_first_id_amount
						else
							l_pos := -1 + 191 -- goto _L___17
						end
				when 190 then -- if block done, skip else block:
						l_pos := -1 + 192
				when 191 then -- else: | _L___17:
						if l_lookfor = 0 then
							if (l_l.item.item).to_integer_32 /= 0 then
								if (l_l.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_l.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
									l_cont_amount := cin_get_equal_amount ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
								end
							end
						end
						if l_lookfor /= 5 then
							l_lookfor := 6
						end
				when 192 then -- if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 194
				when 193 then -- else:
						l_pos := -1 + 195 -- goto _L___22
				when 194 then -- if done | if block done, skip else block:
						l_pos := -1 + 218
				when 195 then -- else: | _L___22:
						if not ((cin_iswhileofdo_end (l_terminated.to_integer_32, l_ind_maxparen, l_ind_maxcomment)).to_boolean) then
							l_pos := -1 + 203 -- skip if block
						end
				when 196 then -- if:
						if l_lookfor /= 6 then
							l_pos := -1 + 199 -- skip if block
						end
				when 197 then -- if:
						l_pos := -1 + 200 -- goto _L___19
				when 198 then -- if block done, skip else block:
						l_pos := -1 + 201
				when 199 then -- else:
						if l_lookfor /= 10 then
							l_pos := -1 + 201 -- skip if block
						end
				when 200 then -- if: | _L___19:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						else
							l_amount := l_amount + l_ind_continuation
						end
						l_break := True
				when 201 then -- if done
						if not (l_return or l_break or l_continue) then
							if l_whilelevel = 0 then
								l_lookfor := 5
								l_amount := get_indent
								if (l_theline[0]).to_integer_32 = 123 then
									l_amount := l_amount + l_ind_open_extra
								end
							end
							l_whilelevel := l_whilelevel + 1
						end
				when 202 then -- if block done, skip else block:
						l_pos := -1 + 218
				when 203 then -- else:
						if l_lookfor = 8 then
							if (cin_isbreak (((create {P_CHARSET_STATIC}).skipwhite (((create {P_MEMLINE_STATIC}).ml_get_curline))))).to_boolean then
								l_lookfor := 4
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) and then (l_whilelevel > 0) then
							l_l.item := cin_skipcomment (((create {P_MEMLINE_STATIC}).ml_get_curline))
							if (cin_isdo (l_l.item)).to_boolean then
								l_amount := get_indent
								l_whilelevel := l_whilelevel - 1
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 209 -- skip if block
						end
				when 204 then -- if:
						if l_lookfor /= 6 then
							l_pos := -1 + 207 -- skip if block
						end
				when 205 then -- if:
						l_pos := -1 + 208 -- goto _L___20
				when 206 then -- if block done, skip else block:
						l_pos := -1 + 209
				when 207 then -- else:
						if l_lookfor /= 10 then
							l_pos := -1 + 209 -- skip if block
						end
				when 208 then -- if: | _L___20:
						if l_cont_amount > 0 then
							l_amount := l_cont_amount
						else
							l_amount := l_amount + l_ind_continuation
						end
						l_break := True
				when 209 then -- if done | if done
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 218 -- skip if block
						end
				when 210 then -- if:
						if l_lookfor /= 5 then
							l_pos := -1 + 213 -- skip if block
						end
				when 211 then -- if:
						if not l_lookfor_break.to_boolean then
							if l_whilelevel = 0 then
								l_break := True
							end
						end
				when 212 then -- if block done, skip else block:
						l_pos := -1 + 218
				when 213 then -- else: | term_again:
						l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
						if (find_last_paren (l_l.item, ('(').code, (')').code)).to_boolean then
							l_trypos := find_match_paren (l_ind_maxparen, l_ind_maxcomment)
							if not l_trypos.is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_trypos.item).twin
								l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
								if (cin_iscase (l_l.item, 0)).to_boolean then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
									l_continue := True
								elseif (cin_isscopedecl (l_l.item)).to_boolean then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
									l_continue := True
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							if l_ind_keep_case_label.to_boolean then
								if (cin_iscase (l_l.item, 0)).to_boolean then
									l_tmp___88 := 1
								else
									l_tmp___88 := 0
								end
							else
								l_tmp___88 := 0
							end
							l_iscase := l_tmp___88
							l_amount := skip_label ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_l, l_ind_maxcomment)
							if (l_theline[0]).to_integer_32 = 123 then
								l_amount := l_amount + l_ind_open_extra
							end
							l_l.item := (create {P_CHARSET_STATIC}).skipwhite (l_l.item)
							if (l_l.item.item).to_integer_32 = 123 then
								l_amount := l_amount - l_ind_open_extra
							end
							if l_iscase.to_boolean then
								l_lookfor := 4
							else
								l_lookfor := 5
							end
							if l_lookfor = 5 then
								if (l_l.item.item).to_integer_32 /= 125 then
									if (cin_iselse (l_l.item)).to_boolean then
										if l_whilelevel = 0 then
											l_trypos := find_start_brace (l_ind_maxcomment)
											if l_trypos.is_void then
												l_break := True
											elseif (find_match (1, l_trypos.item.lnum, l_ind_maxparen, l_ind_maxcomment)) = 0 then
												l_break := True
											end
											if not (l_return or l_break or l_continue) then
												l_continue := True
											end
										end
									end
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 218 -- skip if block
						end
				when 214 then -- if:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
						if ((cin_skipcomment (l_l.item)).item).to_integer_32 /= 125 then
							l_pos := -1 + 218 -- skip if block
						end
				when 215 then -- if:
						l_trypos := find_start_brace (l_ind_maxcomment)
						if l_trypos.is_void then
							l_pos := -1 + 218 -- skip if block
						end
				when 216 then -- if:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_trypos.item).twin
						l_l.item := cin_skipcomment (((create {P_MEMLINE_STATIC}).ml_get_curline))
						if (l_l.item.item).to_integer_32 = 125 then
							l_pos := -1 + 213 -- goto term_again
						elseif not (cin_iselse (l_l.item)).to_boolean then
							l_pos := -1 + 213 -- goto term_again
						end
				when 217 then;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
				when 218 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if (not l_return and not l_break) then
							
						end
						l_pos := -1 + 120 -- back to loop condition
				when 219 then -- loop done
						l_break := False
						l_continue := False
				when 220 then -- if done | if done
						if (cin_iscomment (l_theline)).to_boolean then
							l_amount := l_amount + l_ind_comment
						end
						if l_ind_jump_label > 0 then
							if l_original_line_islabel.to_boolean then
								l_amount := l_amount - l_ind_jump_label
							end
						end
				when 221 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 222 then -- else:
						if (l_theline[0]).to_integer_32 /= 123 then
							l_pos := -1 + 225 -- skip if block
						end
				when 223 then -- if:
						l_amount := l_ind_first_open
				when 224 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 225 then -- else:
						if not (l_cur_curpos.item.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count) then
							l_pos := -1 + 228 -- skip if block
						end
				when 226 then -- if:
						if (cin_nocode (l_theline)).to_boolean then
							l_pos := -1 + 228 -- goto _L___30
						elseif ((create {P_MISC2_STATIC}).vim_strchr (l_theline, ('{').code)).is_void then
							if ((create {P_MISC2_STATIC}).vim_strchr (l_theline, ('}').code)).is_void then
								if (cin_ends_in (l_theline, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))).to_boolean then
									l_pos := -1 + 228 -- goto _L___30
								elseif (cin_ends_in (l_theline, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (",")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))).to_boolean then
									l_pos := -1 + 228 -- goto _L___30
								elseif (cin_isfuncdecl (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), l_cur_curpos.item.lnum + 1)).to_boolean then
									if (cin_isterminated (l_theline, 0, 1)).to_boolean then
										l_pos := -1 + 228 -- goto _L___30
									else
										l_amount := l_ind_func_type
									end
								else
									l_pos := -1 + 228 -- goto _L___30
								end
							else
								l_pos := -1 + 228 -- goto _L___30
							end
						else
							l_pos := -1 + 228 -- goto _L___30
						end
				when 227 then -- if block done, skip else block:
						l_pos := -1 + 239
				when 228 then -- else: | _L___30:
						l_amount := 0;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_cur_curpos.item).twin
				when 229 then -- loop condition:
						if not (not (l_return or l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1)) then
							l_pos := -1 + 238 -- skip loop
						end
				when 230 then -- loop body:
						l_break := False
						l_continue := False;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
						l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
						l_trypos := find_start_comment (l_ind_maxcomment)
						if not l_trypos.is_void then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_trypos.item.lnum + 1;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_n := 0
							if l_ind_cpp_baseclass /= 0 then
								if (l_theline[0]).to_integer_32 /= 123 then
									l_n := cin_is_cpp_baseclass (l_col)
									l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
								end
							end
							if l_n.to_boolean then
								l_amount := get_baseclass_amount (l_col.item, l_ind_maxparen, l_ind_maxcomment, l_ind_cpp_baseclass)
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_ispreproc_cont (l_l, create {CE_INTEGER_32_POINTER}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor") + (create {PD_POS_T}.make).offset_of ("lnum")))).to_boolean then
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_nocode (l_l.item)).to_boolean then
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 237 -- skip if block
						end
				when 231 then -- if:
						l_n := 0
						if not ((cin_ends_in (l_l.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (",")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))).to_boolean) then
							l_pos := -1 + 234 -- skip if block
						end
				when 232 then -- if:
						l_pos := -1 + 236 -- goto _L___23
				when 233 then -- if block done, skip else block:
						l_pos := -1 + 237
				when 234 then -- else:
						if (l_l.item.item).to_integer_32 = 0 then
							l_pos := -1 + 237 -- skip if block
						end
				when 235 then -- if:
						l_n := (l_l.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_l.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32
						if l_n /= 92 then
							l_pos := -1 + 237 -- skip if block
						end
				when 236 then -- if: | _L___23:
						if (find_last_paren (l_l.item, ('(').code, (')').code)).to_boolean then
							l_trypos := find_match_paren (l_ind_maxparen, l_ind_maxcomment)
							if not l_trypos.is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_trypos.item).twin
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if l_n = 0 then
								if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_l.item := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)
								if (l_l.item.item).to_integer_32 = 0 then
									l_break := True
								elseif (l_l.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_l.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							end
						end
						l_break := False
						l_amount := get_indent
						if l_amount = 0 then
							l_amount := cin_first_id_amount
						end
						if l_amount = 0 then
							l_amount := l_ind_continuation
						end
						l_break := True
				when 237 then -- if done | if done | if done
						if not (l_return or l_break or l_continue) then
							if (cin_isfuncdecl (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), l_cur_curpos.item.lnum)).to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
							if (((create {P_CHARSET_STATIC}).skipwhite (l_l.item)).item).to_integer_32 = 125 then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_ends_in (l_l.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("};")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))).to_boolean then
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_isfuncdecl (l_l, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).to_boolean then
								l_amount := l_ind_param
								l_break := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_ends_in (l_l.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (";")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))).to_boolean then
								l_l.item := (create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)
								if (cin_ends_in (l_l.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (",")), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))).to_boolean then
									l_break := True
								elseif (l_l.item.item).to_integer_32 /= 0 then
									if (l_l.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_l.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
										l_break := True
									end
								end
								if not (l_return or l_break or l_continue) then
									l_l.item := (create {P_MEMLINE_STATIC}).ml_get_curline
								end
							end
						end
						if not (l_return or l_break or l_continue) then
							find_last_paren (l_l.item, ('(').code, (')').code).do_nothing
							l_trypos := find_match_paren (l_ind_maxparen, l_ind_maxcomment)
							if not l_trypos.is_void then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_trypos.item).twin
							end
							l_amount := get_indent
							l_break := True
						end
						l_pos := -1 + 229 -- back to loop condition
				when 238 then -- loop done
						l_break := False
						l_continue := False
						if (cin_iscomment (l_theline)).to_boolean then
							l_amount := l_amount + l_ind_comment
						end
						if l_cur_curpos.item.lnum > 1 then
							l_l.item := (create {P_MEMLINE_STATIC}).ml_get (l_cur_curpos.item.lnum - 1)
							if (l_l.item.item).to_integer_32 /= 0 then
								if (l_l.item[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_l.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
									l_cur_amount := cin_get_equal_amount (l_cur_curpos.item.lnum - 1)
									if l_cur_amount > 0 then
										l_amount := l_cur_amount
									elseif l_cur_amount = 0 then
										l_amount := l_amount + l_ind_continuation
									end
								end
							end
						end
				when 239 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 270
				when 240 then -- else:
						l_trypos := find_start_comment (l_ind_maxcomment)
						if l_trypos.is_void then
							l_pos := -1 + 269 -- skip if block
						end
				when 241 then -- if:
						l_lead_start_len := 2
						l_lead_middle_len := 1
						l_start_align := 0
						l_start_off := 0
						l_done___2 := 0;
						((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_trypos, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
						l_amount := l_col.item
						l_p___0.item := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_com
				when 242 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_p___0.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 267 -- skip loop
						end
				when 243 then -- loop body:
						l_break := False
						l_continue := False
						l_align := 0
						l_off___0 := 0
						l_what := 0
				when 244 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 266 -- skip loop
						end
				when 245 then -- loop body:
						l_break := False
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_p___0.item.item).to_integer_32 = 58 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 265 -- skip if block
						end
				when 246 then -- if:
						if (l_p___0.item.item).to_integer_32 /= 115 then
							l_pos := -1 + 249 -- skip if block
						end
				when 247 then -- if:
						l_tmp___4 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_what := (l_tmp___4.item).to_integer_32
				when 248 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 249 then -- else:
						if (l_p___0.item.item).to_integer_32 /= 101 then
							l_pos := -1 + 252 -- skip if block
						end
				when 250 then -- if:
						l_tmp___4 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_what := (l_tmp___4.item).to_integer_32
				when 251 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 252 then -- else:
						if (l_p___0.item.item).to_integer_32 /= 109 then
							l_pos := -1 + 255 -- skip if block
						end
				when 253 then -- if:
						l_tmp___4 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_what := (l_tmp___4.item).to_integer_32
				when 254 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 255 then -- else:
						if (l_p___0.item.item).to_integer_32 /= 108 then
							l_pos := -1 + 258 -- skip if block
						end
				when 256 then -- if:
						l_tmp___5 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_align := (l_tmp___5.item).to_integer_32
				when 257 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 258 then -- else:
						if (l_p___0.item.item).to_integer_32 /= 114 then
							l_pos := -1 + 261 -- skip if block
						end
				when 259 then -- if:
						l_tmp___5 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_align := (l_tmp___5.item).to_integer_32
				when 260 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 261 then -- else:
						if not ((l_p___0.item.item).to_integer_32 >= 48) then
							l_pos := -1 + 264 -- skip if block
						end
				when 262 then -- if:
						if (l_p___0.item.item).to_integer_32 <= 57 then
							l_tmp___6 := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
							l_off___0 := l_tmp___6.to_integer_32
						else
							l_pos := -1 + 264 -- goto _L___0
						end
				when 263 then -- if block done, skip else block:
						l_pos := -1 + 265
				when 264 then -- else: | _L___0:
						if (l_p___0.item.item).to_integer_32 = 45 then
							l_tmp___6 := (create {P_CHARSET_STATIC}).getdigits (l_p___0)
							l_off___0 := l_tmp___6.to_integer_32
						else
							l_p___0.item := l_p___0.item + 1
						end
				when 265 then -- if done | if done | if done | if done | if done | if done
						l_pos := -1 + 244 -- back to loop condition
				when 266 then -- loop done
						l_break := False
						if (l_p___0.item.item).to_integer_32 = 58 then
							l_p___0.item := l_p___0.item + 1
						end
						(create {P_MISC2_STATIC}).copy_option_part (l_p___0, l_lead_end, 50, ce_string (",")).do_nothing
						if l_what = 115 then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_lead_start), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_end)).do_nothing
							l_lead_start_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lead_start))).to_integer_32
							l_start_off := l_off___0
							l_start_align := l_align
						elseif l_what = 109 then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_lead_middle), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_end)).do_nothing
							l_lead_middle_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lead_middle))).to_integer_32
						elseif l_what = 101 then
							if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_theline), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_middle), l_lead_middle_len.to_natural_32)) = 0 then
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_theline), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_end), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lead_end))))) /= 0 then
									l_done___2 := 1
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1 then
										l_look.item := (create {P_CHARSET_STATIC}).skipwhite (((create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)))
										if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_look.item), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_start), l_lead_start_len.to_natural_32)) = 0 then
											l_amount := get_indent_lnum ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)
										elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_look.item), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_middle), l_lead_middle_len.to_natural_32)) = 0 then
											l_amount := get_indent_lnum ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)
											l_break := True
										elseif (strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((((create {P_MEMLINE_STATIC}).ml_get (l_trypos.item.lnum)) + l_trypos.item.col)), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_start), l_lead_start_len.to_natural_32)) /= 0 then
											l_continue := True
										end
									end
									if not (l_return or l_break or l_continue) then
										if l_start_off /= 0 then
											l_amount := l_amount + l_start_off
										elseif l_start_align = 114 then
											l_tmp___14 := (create {P_CHARSET_STATIC}).vim_strsize (l_lead_start)
											l_amount := l_amount + (l_tmp___14 - ((create {P_CHARSET_STATIC}).vim_strsize (l_lead_middle)))
										end
										l_break := True
									end
								end
							end
							if not (l_return or l_break or l_continue) then
								if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_theline), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_middle), l_lead_middle_len.to_natural_32)) /= 0 then
									if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_theline), create {CE_INTEGER_8_POINTER}.make_cast (l_lead_end), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_lead_end))))) = 0 then
										l_amount := get_indent_lnum ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - 1)
										if l_off___0 /= 0 then
											l_amount := l_amount + l_off___0
										elseif l_align = 114 then
											l_tmp___19 := (create {P_CHARSET_STATIC}).vim_strsize (l_lead_start)
											l_amount := l_amount + (l_tmp___19 - ((create {P_CHARSET_STATIC}).vim_strsize (l_lead_middle)))
										end
										l_done___2 := 1
										l_break := True
									end
								end
							end
						end
						l_pos := -1 + 242 -- back to loop condition
				when 267 then -- loop done
						l_break := False
						l_continue := False
						if not l_done___2.to_boolean then
							if (l_theline[0]).to_integer_32 = 42 then
								l_amount := l_amount + 1
							else
								l_amount := -1
								l_lnum.item := l_cur_curpos.item.lnum - 1
								from
								until
									not (not (l_break) and then (l_lnum.item > l_trypos.item.lnum))
								loop
									l_break := False
									l_continue := False
									if ((create {P_SEARCH_STATIC}).linewhite (l_lnum.item)).to_boolean then
										l_continue := True
									end
									if not (l_return or l_break or l_continue) then
										l_amount := get_indent_lnum (l_lnum.item)
										l_break := True
									end
									if (not l_break) then
										l_lnum.item := l_lnum.item - 1
									end
								end
								l_break := False
								l_continue := False
								if l_amount = -1 then
									if not l_ind_in_comment2.to_boolean then
										l_start___1 := (create {P_MEMLINE_STATIC}).ml_get (l_trypos.item.lnum)
										l_look.item := (l_start___1 + l_trypos.item.col) + 2
										if (l_look.item.item).to_integer_32 /= 0 then
											l_trypos.item.col := ((create {P_CHARSET_STATIC}).skipwhite (l_look.item)).distance (l_start___1)
										end
									end
									((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_trypos, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
									l_amount := l_col.item
									if l_ind_in_comment2.to_boolean then
										l_amount := l_amount + l_ind_in_comment
									elseif (l_look.item.item).to_integer_32 = 0 then
										l_amount := l_amount + l_ind_in_comment
									end
								end
							end
						end
				when 268 then -- if block done, skip else block:
						l_pos := -1 + 270
				when 269 then -- else:
						l_pos := -1 + 54 -- goto _L___33
				when 270 then -- if done | if done | if done | if done | theend:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_cur_curpos.item).twin;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_linecopy___0))
						if l_amount < 0 then
							Result := 0
							l_return := True
						end
				when 271 then -- if done
					if not l_return then
						Result := l_amount
					end
				when 272 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_match (a_lookfor: INTEGER_32; a_ourscope: INTEGER_32; a_ind_maxparen, a_ind_maxcomment: INTEGER_32): INTEGER_32
		local
			l_look: CE_POINTER [NATURAL_8]
			l_theirscope: CE_POINTER [PD_POS_T]
			l_mightbeif: CE_POINTER [NATURAL_8]
			l_elselevel: INTEGER_32
			l_whilelevel: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_lookfor = 1 then
						l_elselevel := 1
						l_whilelevel := 0
					else
						l_elselevel := 0
						l_whilelevel := 1
					end
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > a_ourscope + 1)) then
						l_pos := -1 + 14 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						l_continue := False;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
						l_look := cin_skipcomment (((create {P_MEMLINE_STATIC}).ml_get_curline))
						if not ((cin_iselse (l_look)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 5 then -- else:
						if not ((cin_isif (l_look)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 8 then -- else:
						if not ((cin_isdo (l_look)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if not ((cin_iswhileofdo (l_look, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, a_ind_maxparen)).to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						l_theirscope := find_start_brace (a_ind_maxcomment)
						if l_theirscope.is_void then
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then (l_theirscope.item.lnum < a_ourscope) then
							l_break := True
						end
						if not (l_return or l_break or l_continue) and then (l_theirscope.item.lnum > a_ourscope) then
							l_continue := True
						end
						if not (l_return or l_break or l_continue) then
							l_look := cin_skipcomment (((create {P_MEMLINE_STATIC}).ml_get_curline))
							if (cin_iselse (l_look)).to_boolean then
								l_mightbeif := cin_skipcomment (l_look + 4)
								if not (cin_isif (l_mightbeif)).to_boolean then
									l_elselevel := l_elselevel + 1
								end
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							if (cin_iswhileofdo (l_look, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, a_ind_maxparen)).to_boolean then
								l_whilelevel := l_whilelevel + 1
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_look := cin_skipcomment (((create {P_MEMLINE_STATIC}).ml_get_curline))
							if (cin_isif (l_look)).to_boolean then
								l_elselevel := l_elselevel - 1
								if l_elselevel = 0 then
									if a_lookfor = 1 then
										l_whilelevel := 0
									end
								end
							end
							if (cin_isdo (l_look)).to_boolean then
								l_whilelevel := l_whilelevel - 1
							end
							if l_elselevel <= 0 then
								if l_whilelevel <= 0 then
									Result := 1
									l_return := True
								end
							end
						end
				when 13 then -- if done | if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 14 then -- loop done
					if not l_return then
						l_break := False
						l_continue := False
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_expr_indent: INTEGER_32
		local
			l_indent: INTEGER_32
			l_pos___3: PD_POS_T
			l_save_State: INTEGER_32
			l_use_sandbox: INTEGER_32
		do
			l_use_sandbox := ((create {P_OPTION_STATIC}).was_set_insecurely (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("indentexpr")), 4))
			l_pos___3 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
			(create {P_EVAL_STATIC}).set_vim_var_nr (9, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)
			if l_use_sandbox.to_boolean then
				(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item + 1
			end
			(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item + 1
			l_indent := (create {P_EVAL_STATIC}).eval_to_number ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_inde)
			if l_use_sandbox.to_boolean then
				(create {P_GLOBALS_STATIC}).sandbox.item := (create {P_GLOBALS_STATIC}).sandbox.item - 1
			end
			(create {P_GLOBALS_STATIC}).textlock.item := (create {P_GLOBALS_STATIC}).textlock.item - 1
			l_save_State := (create {P_GLOBALS_STATIC}).State.item;
			(create {P_GLOBALS_STATIC}).State.item := 16;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_pos___3.twin;
			(create {P_MISC2_STATIC}).check_cursor;
			(create {P_GLOBALS_STATIC}).State.item := l_save_State
			if l_indent < 0 then
				l_indent := get_indent
			end
			Result := l_indent
		end

	lisp_match (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_len: INTEGER_32
			l_word: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<512>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_word.make (<<1>>)

			l_word.item := (create {P_OPTION_STATIC}).p_lispwords.item.item
			from
			until
				not (not (l_return) and then ((l_word.item.item).to_integer_32 /= 0))
			loop
				(create {P_MISC2_STATIC}).copy_option_part (l_word, l_buf___6, 512, ce_string (",")).do_nothing
				l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32
				if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (a_p___0), l_len.to_natural_32)) = 0 then
					if (a_p___0[l_len]).to_integer_32 = 32 then
						Result := 1
						l_return := True
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

	get_lisp_indent: INTEGER_32
		local
			l_pos___3: CE_POINTER [PD_POS_T]
			l_realpos: PD_POS_T
			l_paren: CE_ARRAY [PD_POS_T]
			l_amount: INTEGER_32
			l_that: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_col: INTEGER_32
			l_firsttry: INTEGER_32
			l_parencount: INTEGER_32
			l_quotecount: INTEGER_32
			l_vi_lisp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_paren.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_that.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_vi_lisp := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('p').code)).is_void).to_integer
					l_realpos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
					l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('(').code)
					if l_pos___3.is_void then
						l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('[').code)
					else
						l_paren.item := (l_pos___3.item).twin
						l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('[').code)
						if l_pos___3.is_void then
							l_pos___3 := l_paren
						else
							if l_pos___3.item.lnum /= l_paren.item.lnum then
								l_tmp___1 := (l_pos___3.item.lnum < l_paren.item.lnum).to_integer
							else
								if l_pos___3.item.col /= l_paren.item.col then
									l_tmp___0 := (l_pos___3.item.col < l_paren.item.col).to_integer
								else
									l_tmp___0 := (l_pos___3.item.coladd < l_paren.item.coladd).to_integer
								end
								l_tmp___1 := l_tmp___0
							end
							if l_tmp___1.to_boolean then
								l_pos___3 := l_paren
							end
						end
					end
					if l_pos___3.is_void then
						l_pos := -1 + 63 -- skip if block
					end
				when 1 then -- if:
						l_amount := -1
						l_parencount := 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_continue := False;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
							if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum >= l_pos___3.item.lnum) then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								if ((create {P_SEARCH_STATIC}).linewhite ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).to_boolean then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_that.item := (create {P_MEMLINE_STATIC}).ml_get_curline
								from
								until
									not (not (l_return) and then ((l_that.item.item).to_integer_32 /= 0))
								loop
									l_continue := False
									if (l_that.item.item).to_integer_32 = 59 then
										from
										until
											(l_that.item[1]).to_integer_32 = 0
										loop
											l_that.item := l_that.item + 1
										end
										l_continue := True
									end
									if not (l_return or l_break or l_continue) and then ((l_that.item.item).to_integer_32 = 92) then
										if (l_that.item[1]).to_integer_32 /= 0 then
											l_that.item := l_that.item + 1
										end
										l_continue := True
									end
									if not (l_return or l_break or l_continue) then
										if (l_that.item.item).to_integer_32 = 34 then
											if (l_that.item[1]).to_integer_32 /= 0 then
												from
												until
													(l_break)
												loop
													l_break := False
													l_that.item := l_that.item + 1
													if (l_that.item.item).to_boolean then
														if (l_that.item.item).to_integer_32 = 34 then
															l_break := True
														end
													else
														l_break := True
													end
													if not (l_break) and then ((l_that.item.item).to_integer_32 = 92) then
														l_that.item := l_that.item + 1
														if (l_that.item.item).to_integer_32 = 0 then
															l_break := True
														end
														if not (l_break) and then ((l_that.item[1]).to_integer_32 = 0) then
															l_that.item := l_that.item + 1
															l_break := True
														end
													end
												end
												l_break := False
											end
										end
										if (l_that.item.item).to_integer_32 = 40 then
											l_parencount := l_parencount + 1
										elseif (l_that.item.item).to_integer_32 = 91 then
											l_parencount := l_parencount + 1
										elseif (l_that.item.item).to_integer_32 = 41 then
											l_parencount := l_parencount - 1
										elseif (l_that.item.item).to_integer_32 = 93 then
											l_parencount := l_parencount - 1
										end
									end
									if (not l_return) then
										l_that.item := l_that.item + 1
									end
								end
								l_continue := False
								if l_parencount = 0 then
									l_amount := get_indent
									l_break := True
								end
							end
						end
						l_break := False
						l_continue := False
						if l_amount /= -1 then
							l_pos := -1 + 62 -- skip if block
						end
				when 2 then -- if:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := l_pos___3.item.lnum;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := l_pos___3.item.col
						l_col := l_pos___3.item.col
						l_that.item := (create {P_MEMLINE_STATIC}).ml_get_curline
						if not (l_vi_lisp.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (get_indent) = 0 then
							l_amount := 2
						else
							l_pos := -1 + 5 -- goto _L___9
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 5 then -- else: | _L___9:
						l_amount := 0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_that.item.item).to_boolean then
								if not l_col.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_amount := l_amount + ((create {P_CHARSET_STATIC}).lbr_chartabsize_adv (l_that, l_amount))
								l_col := l_col - 1
							end
						end
						l_break := False
						if l_vi_lisp.to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						if (l_that.item.item).to_integer_32 /= 40 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L___8
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if (l_that.item.item).to_integer_32 /= 91 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L___8:
						if (lisp_match (l_that.item + 1)).to_boolean then
							l_amount := l_amount + (2)
						else
							l_pos := -1 + 14 -- goto _L___7
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_pos := -1 + 14 -- goto _L___7
				when 13 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 62
				when 14 then -- else: | _L___7:
						l_that.item := l_that.item + 1
						l_amount := l_amount + 1
						l_firsttry := l_amount
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_that.item.item).to_integer_32 /= 32 then
								if (l_that.item.item).to_integer_32 /= 9 then
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_amount := l_amount + ((create {P_CHARSET_STATIC}).lbr_chartabsize (l_that.item, l_amount))
								l_that.item := l_that.item + 1
							end
						end
						l_break := False
						if not ((l_that.item.item).to_boolean) then
							l_pos := -1 + 62 -- skip if block
						end
				when 15 then -- if:
						if (l_that.item.item).to_integer_32 = 59 then
							l_pos := -1 + 62 -- skip if block
						end
				when 16 then -- if:
						if not l_vi_lisp.to_boolean then
							if (l_that.item.item).to_integer_32 /= 40 then
								if (l_that.item.item).to_integer_32 /= 91 then
									l_firsttry := l_firsttry + 1
								end
							end
						end
						l_parencount := 0
						l_quotecount := 0
						if not (l_vi_lisp.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 26 -- goto _L___5
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 19 then -- else:
						if (l_that.item.item).to_integer_32 = 34 then
							l_pos := -1 + 61 -- skip if block
						end
				when 20 then -- if:
						if (l_that.item.item).to_integer_32 = 39 then
							l_pos := -1 + 61 -- skip if block
						end
				when 21 then -- if:
						if (l_that.item.item).to_integer_32 = 35 then
							l_pos := -1 + 61 -- skip if block
						end
				when 22 then -- if:
						if not ((l_that.item.item).to_integer_32 < 48) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___5
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 25 then -- else:
						if not ((l_that.item.item).to_integer_32 > 57) then
							l_pos := -1 + 61 -- skip if block
						end
				when 26 then -- if: | _L___5:
						if (l_break) then
							l_pos := -1 + 60 -- skip loop
						end
				when 27 then -- loop body:
						l_break := False
						if not ((l_that.item.item).to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 28 then -- if:
						if (l_that.item.item).to_integer_32 /= 32 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 32 -- goto _L___3
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 31 then -- else:
						if (l_that.item.item).to_integer_32 /= 9 then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if: | _L___3:
						if not (l_quotecount.to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if:
						l_pos := -1 + 36 -- goto _L___2
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 35 then -- else:
						if not (l_parencount.to_boolean) then
							l_pos := -1 + 42 -- skip if block
						end
				when 36 then -- if: | _L___2:
						if (l_that.item.item).to_integer_32 /= 40 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 40 -- goto _L___1
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 39 then -- else:
						if (l_that.item.item).to_integer_32 /= 91 then
							l_pos := -1 + 41 -- skip if block
						end
				when 40 then -- if: | _L___1:
						if not l_quotecount.to_boolean then
							if not l_parencount.to_boolean then
								if l_vi_lisp.to_boolean then
									l_break := True
								end
							end
						end
				when 41 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						l_break := True
				when 43 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:
						l_pos := -1 + 36 -- goto _L___2
				when 45 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:
						l_break := True
				when 47 then
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 59 -- skip if block
						end
				when 48 then -- if:
						if (l_that.item.item).to_integer_32 = 34 then
							l_quotecount := (not l_quotecount.to_boolean).to_integer
						end
						if (l_that.item.item).to_integer_32 /= 40 then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 53
				when 51 then -- else:
						if (l_that.item.item).to_integer_32 /= 91 then
							l_pos := -1 + 53 -- skip if block
						end
				when 52 then -- if: | _L:
						if not l_quotecount.to_boolean then
							l_parencount := l_parencount + 1
						end
				when 53 then -- if done
						if (l_that.item.item).to_integer_32 /= 41 then
							l_pos := -1 + 56 -- skip if block
						end
				when 54 then -- if:
						l_pos := -1 + 57 -- goto _L___0
				when 55 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 56 then -- else:
						if (l_that.item.item).to_integer_32 /= 93 then
							l_pos := -1 + 58 -- skip if block
						end
				when 57 then -- if: | _L___0:
						if not l_quotecount.to_boolean then
							l_parencount := l_parencount - 1
						end
				when 58 then -- if done
						if (l_that.item.item).to_integer_32 = 92 then
							if (l_that.item[1]).to_integer_32 /= 0 then
								l_amount := l_amount + ((create {P_CHARSET_STATIC}).lbr_chartabsize_adv (l_that, l_amount))
							end
						end
						l_amount := l_amount + ((create {P_CHARSET_STATIC}).lbr_chartabsize_adv (l_that, l_amount))
				when 59 then -- if done
						l_pos := -1 + 26 -- back to loop condition
				when 60 then -- loop done
						l_break := False
				when 61 then -- if done | if done | if done | if done | if done
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_that.item.item).to_integer_32 /= 32 then
								if (l_that.item.item).to_integer_32 /= 9 then
									l_break := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_amount := l_amount + ((create {P_CHARSET_STATIC}).lbr_chartabsize (l_that.item, l_amount))
								l_that.item := l_that.item + 1
							end
						end
						l_break := False
						if not (l_that.item.item).to_boolean then
							l_amount := l_firsttry
						elseif (l_that.item.item).to_integer_32 = 59 then
							l_amount := l_firsttry
						end
				when 62 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else:
						l_amount := 0
				when 64 then;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_realpos.twin
					Result := l_amount
				when 65 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	prepare_to_exit
		do
			signal (1, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui.item.item.dying := 1;
				(create {P_TERM_STATIC}).out_trash
			else
				(create {P_SCREEN_STATIC}).windgoto (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, 0);
				(create {P_TERM_STATIC}).settmode (0);
				(create {P_TERM_STATIC}).stoptermcap;
				(create {P_TERM_STATIC}).out_flush
			end
		end

	preserve_exit
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_break: BOOLEAN
		do
			prepare_to_exit;
			(create {P_GLOBALS_STATIC}).really_exiting.item := 1;
			(create {P_TERM_STATIC}).out_str ((create {P_GLOBALS_STATIC}).IObuff.item);
			(create {P_SCREEN_STATIC}).screen_start;
			(create {P_TERM_STATIC}).out_flush;
			(create {P_MEMLINE_STATIC}).ml_close_notmod
			l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
			from
			until
				not (not (l_break) and then (not l_buf___6.is_void))
			loop
				l_break := False
				if not (l_buf___6.item.b_ml.ml_mfp).is_void then
					if not ((l_buf___6.item.b_ml.ml_mfp).item.mf_fname).is_void then
						(create {P_TERM_STATIC}).out_str (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Vim: preserving files...%N")))));
						(create {P_SCREEN_STATIC}).screen_start;
						(create {P_TERM_STATIC}).out_flush;
						(create {P_MEMLINE_STATIC}).ml_sync_all (0, 0)
						l_break := True
					end
				end
				if not (l_break) then
					l_buf___6 := l_buf___6.item.b_next
				end
			end
			l_break := False;
			(create {P_MEMLINE_STATIC}).ml_close_all (0);
			(create {P_TERM_STATIC}).out_str (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Vim: Finished.%N")))));
			(create {P_MAIN_STATIC}).getout (1)
		end

	vim_fexists (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_st: CE_ARRAY [SD_STAT]
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [SD_STAT]} l_st.make (<<1>>)

			if (stat (create {CE_INTEGER_8_POINTER}.make_cast (a_fname), l_st)).to_boolean then
				Result := 0
				l_return := True
			end
			if not l_return then
				Result := 1
			end
		end

	line_breakcheck
		do
			breakcheck_count.item := breakcheck_count.item + 1
			if breakcheck_count.item >= 200 then
				breakcheck_count.item := 0;
				(create {P_UI_STATIC}).ui_breakcheck
			end
		end

	fast_breakcheck
		do
			breakcheck_count.item := breakcheck_count.item + 1
			if breakcheck_count.item >= 2_000 then
				breakcheck_count.item := 0;
				(create {P_UI_STATIC}).ui_breakcheck
			end
		end

	expand_wildcards (a_num_pat: INTEGER_32; a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_retval: INTEGER_32
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_non_suf_match: INTEGER_32
			l_ffname: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_retval := gen_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
			if ((a_flags___0).bit_and (16)).to_boolean then
				Result := l_retval
				l_return := True
			elseif l_retval = 0 then
				Result := l_retval
				l_return := True
			end
			if not l_return then
				if ((create {P_OPTION_STATIC}).p_wig.item.item.item).to_boolean then
					l_i___0 := 0
					from
					until
						not (not (l_return or l_break) and then (l_i___0 < a_num_file.item))
					loop
						l_break := False
						l_ffname := FullName_save (a_file.item[l_i___0], 0)
						if l_ffname.is_void then
							l_break := True
						end
						if not (l_return or l_break) then
							if ((create {P_FILEIO_STATIC}).match_file_list ((create {P_OPTION_STATIC}).p_wig.item.item, a_file.item[l_i___0], l_ffname)).to_boolean then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_file.item[l_i___0]))
								l_j := l_i___0
								from
								until
									not (l_j + 1 < a_num_file.item)
								loop
									a_file.item[l_j] := a_file.item[(l_j + 1)]
									l_j := l_j + 1
								end
								a_num_file.item := (a_num_file.item) - 1
								l_i___0 := l_i___0 - 1
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ffname))
							l_i___0 := l_i___0 + 1
						end
					end
					l_break := False
				end
				if a_num_file.item > 1 then
					l_non_suf_match := 0
					l_i___0 := 0
					from
					until
						not (not (l_return) and then (l_i___0 < a_num_file.item))
					loop
						if not (match_suffix (a_file.item[l_i___0])).to_boolean then
							l_p___0 := a_file.item[l_i___0]
							l_j := l_i___0
							from
							until
								not (l_j > l_non_suf_match)
							loop
								a_file.item[l_j] := a_file.item[(l_j - 1)]
								l_j := l_j - 1
							end
							l_tmp___0 := l_non_suf_match
							l_non_suf_match := l_non_suf_match + 1
							a_file.item[l_tmp___0] := l_p___0
						end
						l_i___0 := l_i___0 + 1
					end
				end
				Result := l_retval
			end
		end

	match_suffix (a_fname: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fnamelen: INTEGER_32
			l_setsuflen: INTEGER_32
			l_setsuf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_suf_buf: CE_ARRAY [NATURAL_8]
			l_tail: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_setsuf.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_suf_buf.make (<<30>>)

			l_fnamelen := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_fname))).to_integer_32
			l_setsuflen := 0
			l_setsuf.item := (create {P_OPTION_STATIC}).p_su.item.item
			from
			until
				not (not (l_break) and then ((l_setsuf.item.item).to_boolean))
			loop
				l_break := False
				l_setsuflen := (create {P_MISC2_STATIC}).copy_option_part (l_setsuf, l_suf_buf, 30, ce_string (".,"))
				if l_setsuflen = 0 then
					l_tail := (gettail (a_fname))
					if ((create {P_MISC2_STATIC}).vim_strchr (l_tail, ('.').code)).is_void then
						l_setsuflen := 1
						l_break := True
					end
				else
					if l_fnamelen >= l_setsuflen then
						if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_suf_buf), create {CE_INTEGER_8_POINTER}.make_cast (((a_fname + l_fnamelen) - l_setsuflen)), l_setsuflen.to_natural_32)) = 0 then
							l_break := True
						end
					end
					if not (l_break) then
						l_setsuflen := 0
					end
				end
			end
			l_break := False
			Result := (l_setsuflen /= 0).to_integer
		end

	pstrcmp (a_a, a_b: CE_POINTER [ANY]): INTEGER_32
		do
			Result := ((create {P_MISC2_STATIC}).pathcmp ((create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_a)).item, (create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_b)).item, -1))
		end

	expand_path_option (a_curdir: CE_POINTER [NATURAL_8]; a_gap: CE_POINTER [PD_GROWARRAY])
		local
			l_path_option: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_path_option.make (<<1>>)
			create {CE_NATURAL_8_POINTER} l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_path).item).to_integer_32 = 0 then
						l_tmp := (create {P_OPTION_STATIC}).p_path.item.item
					else
						l_tmp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_path
					end
					l_path_option.item := l_tmp
					l_buf___6 := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
					if l_buf___6.is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not (l_break) and then ((l_path_option.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 2 then -- loop body:
						l_break := False
						l_continue := False;
						(create {P_MISC2_STATIC}).copy_option_part (l_path_option, l_buf___6, 4_096, ce_string (" ,")).do_nothing
						if (l_buf___6[0]).to_integer_32 /= 46 then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (l_buf___6[1]).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not ((vim_ispathsep ((l_buf___6[1]).to_integer_32)).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___0:
						if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname).is_void then
							l_continue := True
						end
						if not (l_break or l_continue) then
							l_p___0 := gettail ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)
							l_len := l_p___0.distance (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname))
							if l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32 >= 4_096 then
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							if (l_buf___6[1]).to_integer_32 = 0 then
								l_buf___6[l_len] := (('%/0/').code).to_natural_8
							else
								memmove (create {CE_VOID_POINTER}.make_cast ((l_buf___6 + l_len)), create {CE_VOID_POINTER}.make_cast ((l_buf___6 + 2)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + 2)))) + {NATURAL_32} 1).do_nothing
							end
							memmove (create {CE_VOID_POINTER}.make_cast (l_buf___6), create {CE_VOID_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname), l_len.to_natural_32).do_nothing;
							(create {P_TAG_STATIC}).simplify_filename (l_buf___6)
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 11 -- goto _L
				when 10 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if (l_buf___6[0]).to_integer_32 = 0 then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (a_curdir)).do_nothing
						elseif ((create {P_WINDOW_STATIC}).path_with_url (l_buf___6)).to_boolean then
							l_continue := True
						elseif not ((create {P_OS_UNIX_STATIC}).mch_isFullName (l_buf___6)).to_boolean then
							l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_curdir))).to_integer_32
							if (l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32) + 3 > 4_096 then
								l_continue := True
							end
							if not (l_break or l_continue) then
								memmove (create {CE_VOID_POINTER}.make_cast (((l_buf___6 + l_len) + 1)), create {CE_VOID_POINTER}.make_cast (l_buf___6), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))) + {NATURAL_32} 1).do_nothing
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (a_curdir)).do_nothing
								l_buf___6[l_len] := (('/').code).to_natural_8;
								(create {P_TAG_STATIC}).simplify_filename (l_buf___6)
							end
						end
				when 12 then
						if not (l_break or l_continue) then
							if (a_gap.item.ga_grow (1)) = 0 then
								l_break := True
							end
						end
						if not (l_break or l_continue) then
							l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (l_buf___6)
							if l_p___0.is_void then
								l_break := True
							end
						end
						if not (l_break or l_continue) then
							l_tmp___9 := a_gap.item.ga_len
							a_gap.item.ga_len := (a_gap.item.ga_len) + 1
							create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (a_gap.item.ga_data)[l_tmp___9] := l_p___0
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
						l_break := False
						l_continue := False;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	expand_in_path (a_gap: CE_POINTER [PD_GROWARRAY]; a_pattern: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_curdir: CE_POINTER [NATURAL_8]
			l_path_ga: CE_ARRAY [PD_GROWARRAY]
			l_files: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_paths: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_path_ga.make (<<1>>)

			l_files := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_paths := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_curdir := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
			if l_curdir.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				(create {P_OS_UNIX_STATIC}).mch_dirname (l_curdir, 4_096).do_nothing
				l_path_ga.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 1)
				expand_path_option (l_curdir, l_path_ga);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_curdir))
				if l_path_ga.item.ga_len = 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_paths := l_path_ga.item.ga_concat_strings
				l_path_ga.item.ga_clear_strings
				if l_paths.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_files := (create {P_EX_GETLN_STATIC}).globpath (l_paths, a_pattern, 0);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_paths))
				if l_files.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_e := l_files
				l_s := l_e
				from
				until
					not (not (l_return or l_break) and then ((l_s.item).to_integer_32 /= 0))
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_e.item).to_integer_32 /= 10 then
							if (l_e.item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_e := l_e + 1
						end
					end
					l_break := False
					if (l_e.item).to_integer_32 = 0 then
						addfile (a_gap, l_s, a_flags___0)
						l_break := True
					else
						l_e.item := (('%/0/').code).to_natural_8
						addfile (a_gap, l_s, a_flags___0)
						l_e := l_e + 1
						l_s := l_e
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_files))
				Result := (a_gap.item.ga_len)
			end
		end

	gen_expand_wildcards (a_num_pat: INTEGER_32; a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_p___0: CE_POINTER [NATURAL_8]
			l_add_pat: INTEGER_32
			l_did_expand_in_path: INTEGER_32
			l_tmp___0: INTEGER_32
			l_t: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_did_expand_in_path := 0
					if recursive___2.item.to_boolean then
						Result := ((create {P_OS_UNIX_STATIC}).mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0))
						l_return := True
					end
					if not l_return then
						l_i___0 := 0
						from
						until
							not (not (l_return) and then (l_i___0 < a_num_pat))
						loop
							if not (strpbrk (create {CE_INTEGER_8_POINTER}.make_cast (a_pat[l_i___0]), ce_string ("`%'{"))).is_void then
								if (vim_backtick (a_pat[l_i___0])).to_boolean then
									if ((a_pat[l_i___0])[1]).to_integer_32 /= 61 then
										l_tmp___0 := (create {P_OS_UNIX_STATIC}).mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
										Result := l_tmp___0
										l_return := True
									end
								else
									l_tmp___0 := (create {P_OS_UNIX_STATIC}).mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
									Result := l_tmp___0
									l_return := True
								end
							end
							if not l_return then
								l_i___0 := l_i___0 + 1
							end
						end
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						recursive___2.item := 1
						l_ga.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 30)
						l_i___0 := 0
				when 2 then -- loop condition:
						if not (not (l_return) and then (l_i___0 < a_num_pat)) then
							l_pos := -1 + 21 -- skip loop
						end
				when 3 then -- loop body:
						l_add_pat := -1
						l_p___0 := a_pat[l_i___0]
						if not ((vim_backtick (l_p___0)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_add_pat := expand_backtick (l_ga, l_p___0, a_flags___0)
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 6 then -- else:
						if ((create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('$').code)).is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if (l_p___0.item).to_integer_32 /= 126 then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						l_p___0 := expand_env_save_opt (l_p___0, 1)
						if l_p___0.is_void then
							l_p___0 := a_pat[l_i___0]
						elseif not ((create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('$').code)).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
							l_ga.item.ga_clear_strings
							l_i___0 := (create {P_OS_UNIX_STATIC}).mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
							recursive___2.item := 0
							Result := l_i___0
							l_return := True
						elseif (l_p___0.item).to_integer_32 = 126 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
							l_ga.item.ga_clear_strings
							l_i___0 := (create {P_OS_UNIX_STATIC}).mch_expand_wildcards (a_num_pat, a_pat, a_num_file, a_file, a_flags___0)
							recursive___2.item := 0
							Result := l_i___0
							l_return := True
						end
				when 11 then -- if done
						if not l_return then
							if ((create {P_OS_UNIX_STATIC}).mch_has_exp_wildcard (l_p___0)).to_boolean then
								if ((a_flags___0).bit_and (128)).to_boolean then
									if ((create {P_OS_UNIX_STATIC}).mch_isFullName (l_p___0)).to_boolean then
										l_add_pat := l_ga.item.mch_expandpath (l_p___0, a_flags___0)
									elseif (l_p___0[0]).to_integer_32 = 46 then
										if (vim_ispathsep ((l_p___0[1]).to_integer_32)).to_boolean then
											l_add_pat := l_ga.item.mch_expandpath (l_p___0, a_flags___0)
										elseif (l_p___0[1]).to_integer_32 = 46 then
											if (vim_ispathsep ((l_p___0[2]).to_integer_32)).to_boolean then
												l_add_pat := l_ga.item.mch_expandpath (l_p___0, a_flags___0)
											else
												recursive___2.item := 0
												l_add_pat := expand_in_path (l_ga, l_p___0, a_flags___0)
												recursive___2.item := 1
												l_did_expand_in_path := 1
											end
										else
											recursive___2.item := 0
											l_add_pat := expand_in_path (l_ga, l_p___0, a_flags___0)
											recursive___2.item := 1
											l_did_expand_in_path := 1
										end
									else
										recursive___2.item := 0
										l_add_pat := expand_in_path (l_ga, l_p___0, a_flags___0)
										recursive___2.item := 1
										l_did_expand_in_path := 1
									end
								else
									l_add_pat := l_ga.item.mch_expandpath (l_p___0, a_flags___0)
								end
							end
						end
				when 12 then -- if done
						if l_return then
							l_pos := -1 + 20 -- skip if block
						end
				when 13 then -- if:
						if l_add_pat /= -1 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 18 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 16 then -- else:
						if l_add_pat /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if not (((a_flags___0).bit_and (4)).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 18 then -- if: | _L___0:
						l_t := ((create {P_CHARSET_STATIC}).backslash_halve_save (l_p___0))
						if ((a_flags___0).bit_and (4)).to_boolean then
							addfile (l_ga, l_t, (((a_flags___0).bit_or (1))).bit_or (2))
						elseif ((create {P_OS_UNIX_STATIC}).mch_getperm (l_t)) >= 0 then
							addfile (l_ga, l_t, a_flags___0)
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_t))
				when 19 then -- if done | if done
						if l_did_expand_in_path.to_boolean then
							if l_ga.item.ga_len > 0 then
								if ((a_flags___0).bit_and (128)).to_boolean then
									l_ga.item.uniquefy_paths (l_p___0)
								end
							end
						end
						if not l_p___0.is_equal (a_pat[l_i___0]) then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
						l_i___0 := l_i___0 + 1
				when 20 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 21 then -- loop done | if done
					if not l_return then
						a_num_file.item := l_ga.item.ga_len
						if not (l_ga.item.ga_data).is_void then
							a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)
						else
							a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						end
						recursive___2.item := 0
						if not (l_ga.item.ga_data).is_void then
							l_tmp___12 := 1
						else
							l_tmp___12 := 0
						end
						Result := l_tmp___12
					end
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_backtick (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_tmp___0: INTEGER_32
		do
			if (a_p___0.item).to_integer_32 = 96 then
				if (a_p___0[1]).to_integer_32 /= 0 then
					if ((a_p___0 + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_p___0))).to_integer_32)[-1]).to_integer_32 = 96 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	expand_backtick (a_gap: CE_POINTER [PD_GROWARRAY]; a_pat: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_cmd: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_cnt: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)

			l_cnt := 0
			l_cmd := (create {P_MISC2_STATIC}).vim_strnsave (a_pat + 1, (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat))).to_integer_32 - 2)
			if l_cmd.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				if (l_cmd.item).to_integer_32 = 61 then
					l_buffer := (create {P_EVAL_STATIC}).eval_to_string (l_cmd + 1, l_p___0, 1)
				else
					if ((a_flags___0).bit_and (32)).to_boolean then
						l_tmp___0 := 16
					else
						l_tmp___0 := 0
					end
					l_buffer := get_cmd_output (l_cmd, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_tmp___0)
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_cmd))
				if l_buffer.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_cmd := l_buffer
				from
				until
					not (not (l_return) and then ((l_cmd.item).to_integer_32 /= 0))
				loop
					l_cmd := (create {P_CHARSET_STATIC}).skipwhite (l_cmd)
					l_p___0.item := l_cmd
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_p___0.item.item).to_integer_32 /= 13 then
								if (l_p___0.item.item).to_integer_32 = 10 then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_p___0.item := l_p___0.item + 1
						end
					end
					l_break := False
					if ((l_p___0.item).c_pointer.to_integer_32).to_natural_32 > (l_cmd.c_pointer.to_integer_32).to_natural_32 then
						l_i___0 := (l_p___0.item.item).to_integer_32
						l_p___0.item.item := (('%/0/').code).to_natural_8
						addfile (a_gap, l_cmd, a_flags___0)
						l_p___0.item.item := l_i___0.to_natural_8
						l_cnt := l_cnt + 1
					end
					l_cmd := l_p___0.item
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_cmd.item).to_integer_32 /= 0 then
							if (l_cmd.item).to_integer_32 /= 13 then
								if (l_cmd.item).to_integer_32 /= 10 then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_cmd := l_cmd + 1
						end
					end
					l_break := False
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
				Result := l_cnt
			end
		end

	addfile (a_gap: CE_POINTER [PD_GROWARRAY]; a_f: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32)
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_isdir: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_flags___0).bit_and (4)).to_boolean then
						if ((create {P_OS_UNIX_STATIC}).mch_getperm (a_f)) < 0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_isdir := (create {P_OS_UNIX_STATIC}).mch_isdir (a_f)
						if not (l_isdir.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not ((a_flags___0).bit_and (1)).to_boolean then
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not l_isdir.to_boolean then
							if not ((a_flags___0).bit_and (2)).to_boolean then
								l_return := True
							end
						end
				when 5 then -- if done
					if not l_return and then (not l_isdir.to_boolean) then
						if ((a_flags___0).bit_and (64)).to_boolean then
							if not ((create {P_OS_UNIX_STATIC}).mch_can_exe (a_f)).to_boolean then
								l_return := True
							end
						end
					end
					if not l_return then
						if (a_gap.item.ga_grow (1)) = 0 then
							l_return := True
						end
					end
					if not l_return then
						l_p___0 := (create {P_MISC2_STATIC}).alloc (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_f))) + {NATURAL_32} 1) + l_isdir.to_natural_32)
						if l_p___0.is_void then
							l_return := True
						end
					end
					if not l_return then
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), create {CE_INTEGER_8_POINTER}.make_cast (a_f)).do_nothing
						if l_isdir.to_boolean then
							if ((a_flags___0).bit_and (8)).to_boolean then
								add_pathsep (l_p___0)
							end
						end
						l_tmp___3 := a_gap.item.ga_len
						a_gap.item.ga_len := (a_gap.item.ga_len) + 1
						create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (a_gap.item.ga_data)[l_tmp___3] := l_p___0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_cmd_output (a_cmd, a_infile: CE_POINTER [NATURAL_8]; a_flags___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tempname: CE_POINTER [NATURAL_8]
			l_command: CE_POINTER [NATURAL_8]
			l_buffer: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_i___0: INTEGER_32
			l_fd: CE_POINTER [SD_IO_FILE]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buffer := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_i___0 := 0
					if ((create {P_EX_CMDS_STATIC}).check_restricted).to_boolean then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					elseif ((create {P_EX_CMDS_STATIC}).check_secure).to_boolean then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_tempname := (create {P_FILEIO_STATIC}).vim_tempname (('o').code)
						if l_tempname.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notmp.item)))))).do_nothing
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_command := (create {P_EX_CMDS_STATIC}).make_filter_cmd (a_cmd, a_infile, l_tempname)
						if l_command.is_void then
							l_pos := -1 + 5 -- goto done
						end
				when 2 then;
						(create {P_GLOBALS_STATIC}).no_check_timestamps.item := (create {P_GLOBALS_STATIC}).no_check_timestamps.item + 1;
						(create {P_MISC2_STATIC}).call_shell (l_command, (10).bit_or (a_flags___0)).do_nothing;
						(create {P_GLOBALS_STATIC}).no_check_timestamps.item := (create {P_GLOBALS_STATIC}).no_check_timestamps.item - 1;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_command))
						l_fd := fopen (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname), ce_string ("r"))
						if l_fd.is_void then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notopen.item))))), l_tempname).do_nothing
							l_pos := -1 + 5 -- goto done
						end
				when 3 then
						fseek (l_fd, 0, 2).do_nothing
						l_len := (ftell (l_fd)).to_integer_32
						fseek (l_fd, 0, 0).do_nothing
						l_buffer := (create {P_MISC2_STATIC}).alloc ((l_len + 1).to_natural_32)
						if not l_buffer.is_void then
							l_i___0 := (fread (create {CE_VOID_POINTER}.make_cast (l_buffer), (1).to_natural_32, l_len.to_natural_32, l_fd)).to_integer_32
						end
						fclose (l_fd).do_nothing
						unlink (create {CE_INTEGER_8_POINTER}.make_cast (l_tempname)).do_nothing
						if l_buffer.is_void then
							l_pos := -1 + 5 -- goto done
						end
				when 4 then
						if l_i___0 /= l_len then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_notread.item))))), l_tempname).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buffer))
							l_buffer := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						else
							l_buffer[l_len] := (('%/0/').code).to_natural_8
						end
				when 5 then -- done:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tempname))
						Result := l_buffer
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	FreeWild (a_count___2: INTEGER_32; a_files: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_count___2: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_count___2 := a_count___2
			if l_count___2 <= 0 then
				l_return := True
			elseif a_files.is_void then
				l_return := True
			end
			if not l_return then
				from
				until
					(l_break)
				loop
					l_break := False
					l_tmp := l_count___2
					l_count___2 := l_count___2 - 1
					if not l_tmp.to_boolean then
						l_break := True
					end
					if not (l_break) then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_files[l_count___2]))
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_files))
			end
		end

	goto_im: INTEGER_32
		local
			l_tmp___1: INTEGER_32
		do
			if ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
				if ((create {P_GETCHAR_STATIC}).stuff_empty).to_boolean then
					if ((create {P_GETCHAR_STATIC}).typebuf_typed).to_boolean then
						l_tmp___1 := 1
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

feature {ANY} -- routine addresses

	get_env_name_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_env_name)
		end

	get_c_indent_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_c_indent)
		end

	get_expr_indent_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_expr_indent)
		end

	get_lisp_indent_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_lisp_indent)
		end

	pstrcmp_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent pstrcmp)
		end

end
