class
	PD_EXPAND

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} xp_pattern.make
			create {CE_NATURAL_8_POINTER} xp_arg.make
			create {CE_POINTER_POINTER [NATURAL_8]} xp_files.make
			Precursor
		end

feature {ANY} -- fields

	xp_context: INTEGER_32 assign set_xp_context

	xp_pattern: CE_POINTER [NATURAL_8] assign set_xp_pattern

	xp_pattern_len: INTEGER_32 assign set_xp_pattern_len

	xp_arg: CE_POINTER [NATURAL_8] assign set_xp_arg

	xp_scriptID: INTEGER_32 assign set_xp_scriptID

	xp_backslash: INTEGER_32 assign set_xp_backslash

	xp_shell: INTEGER_32 assign set_xp_shell

	xp_numfiles: INTEGER_32 assign set_xp_numfiles

	xp_files: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_xp_files

feature {ANY} -- field setters

	set_xp_context (a_xp_context: INTEGER_32)
		do
			xp_context := a_xp_context
			update_memory_field ("xp_context")
		end

	set_xp_pattern (a_xp_pattern: CE_POINTER [NATURAL_8])
		do
			xp_pattern := a_xp_pattern
			update_memory_field ("xp_pattern")
		end

	set_xp_pattern_len (a_xp_pattern_len: INTEGER_32)
		do
			xp_pattern_len := a_xp_pattern_len
			update_memory_field ("xp_pattern_len")
		end

	set_xp_arg (a_xp_arg: CE_POINTER [NATURAL_8])
		do
			xp_arg := a_xp_arg
			update_memory_field ("xp_arg")
		end

	set_xp_scriptID (a_xp_scriptID: INTEGER_32)
		do
			xp_scriptID := a_xp_scriptID
			update_memory_field ("xp_scriptID")
		end

	set_xp_backslash (a_xp_backslash: INTEGER_32)
		do
			xp_backslash := a_xp_backslash
			update_memory_field ("xp_backslash")
		end

	set_xp_shell (a_xp_shell: INTEGER_32)
		do
			xp_shell := a_xp_shell
			update_memory_field ("xp_shell")
		end

	set_xp_numfiles (a_xp_numfiles: INTEGER_32)
		do
			xp_numfiles := a_xp_numfiles
			update_memory_field ("xp_numfiles")
		end

	set_xp_files (a_xp_files: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			xp_files := a_xp_files
			update_memory_field ("xp_files")
		end

feature {PD_EXPAND} -- private attributes

	cmd_showtail: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	findex: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	orig_save: CE_STATIC [CE_POINTER [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
		end

	tab: CE_STATIC [CE_ARRAY [PD_EXPGEN]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_EXPGEN]}.make_initialized (<<
					create {PD_EXPGEN}.make_initialized ([1, (create {P_EX_DOCMD_STATIC}).get_command_name_address, 0]),
					create {PD_EXPGEN}.make_initialized ([36, (create {P_EX_DOCMD_STATIC}).get_behave_arg_address, 1]),
					create {PD_EXPGEN}.make_initialized ([22, (create {P_EX_DOCMD_STATIC}).get_user_commands_address, 0]),
					create {PD_EXPGEN}.make_initialized ([23, (create {P_EX_DOCMD_STATIC}).get_user_cmd_flags_address, 0]),
					create {PD_EXPGEN}.make_initialized ([24, (create {P_EX_DOCMD_STATIC}).get_user_cmd_nargs_address, 0]),
					create {PD_EXPGEN}.make_initialized ([25, (create {P_EX_DOCMD_STATIC}).get_user_cmd_complete_address, 0]),
					create {PD_EXPGEN}.make_initialized ([15, (create {P_EVAL_STATIC}).get_user_var_name_address, 0]),
					create {PD_EXPGEN}.make_initialized ([18, (create {P_EVAL_STATIC}).get_function_name_address, 0]),
					create {PD_EXPGEN}.make_initialized ([19, (create {P_EVAL_STATIC}).get_user_func_name_address, 0]),
					create {PD_EXPGEN}.make_initialized ([20, (create {P_EVAL_STATIC}).get_expr_name_address, 0]),
					create {PD_EXPGEN}.make_initialized ([11, (create {P_MENU_STATIC}).get_menu_name_address, 0]),
					create {PD_EXPGEN}.make_initialized ([21, (create {P_MENU_STATIC}).get_menu_names_address, 0]),
					create {PD_EXPGEN}.make_initialized ([12, (create {P_SYNTAX_STATIC}).get_syntax_name_address, 1]),
					create {PD_EXPGEN}.make_initialized ([13, (create {P_SYNTAX_STATIC}).get_highlight_name_address, 1]),
					create {PD_EXPGEN}.make_initialized ([10, (create {P_FILEIO_STATIC}).get_event_name_address, 1]),
					create {PD_EXPGEN}.make_initialized ([14, (create {P_FILEIO_STATIC}).get_augroup_name_address, 1]),
					create {PD_EXPGEN}.make_initialized ([34, (create {P_EX_CMDS_STATIC}).get_sign_name_address, 1]),
					create {PD_EXPGEN}.make_initialized ([27, (create {P_EX_CMDS2_STATIC}).get_lang_arg_address, 1]),
					create {PD_EXPGEN}.make_initialized ([26, (create {P_MISC1_STATIC}).get_env_name_address, 1])
				>>)
		end

	expand_mapmodes: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	expand_isabbrev: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	expand_buffer: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	e_toomany: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('E').code).to_natural_8, (('7').code).to_natural_8, (('7').code).to_natural_8, ((':').code).to_natural_8,
					((' ').code).to_natural_8, (('T').code).to_natural_8, (('o').code).to_natural_8, (('o').code).to_natural_8,
					((' ').code).to_natural_8, (('m').code).to_natural_8, (('a').code).to_natural_8, (('n').code).to_natural_8,
					(('y').code).to_natural_8, ((' ').code).to_natural_8, (('f').code).to_natural_8, (('i').code).to_natural_8,
					(('l').code).to_natural_8, (('e').code).to_natural_8, ((' ').code).to_natural_8, (('n').code).to_natural_8,
					(('a').code).to_natural_8, (('m').code).to_natural_8, (('e').code).to_natural_8, (('s').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	names___0: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					ce_string ("all"),
					ce_string ("termcap")
				>>)
		end

	expand_option_idx: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	expand_option_name: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('t').code).to_natural_8, (('_').code).to_natural_8, (('%/0/').code).to_natural_8, (('%/0/').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	expand_option_flags: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	first_match: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	set_context_for_expression (a_arg: CE_POINTER [NATURAL_8]; a_cmdidx: INTEGER_32)
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_got_eq: INTEGER_32
			l_c: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg := a_arg
					l_got_eq := 0
					if a_cmdidx = 209 then
						Current.xp_context := 15
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := strpbrk (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("%"%'+-*/%%.=!?~|&$([<>,#"))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2.is_void then
							l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_arg))
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := l_arg + l_tmp.to_integer_32
							from
							until
								not (not (l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 >= (l_arg.c_pointer.to_integer_32).to_natural_32))
							loop
								l_break := False
								Current.xp_pattern := l_p___0
								update_class_fields -- Current might have been changed; synchronize
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___0 := (create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_arg, l_p___0 - 1])
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___1 := l_tmp___0 + 1
								else
									l_tmp___1 := 1
								end
								l_p___0 := l_p___0 - l_tmp___1
								if (l_p___0.item).to_integer_32 = 32 then
									l_break := True
								elseif (l_p___0.item).to_integer_32 = 9 then
									l_break := True
								end
							end
							l_break := False
							l_return := True
						end
					elseif a_cmdidx = 50 then
						Current.xp_context := 18
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.xp_context := 20
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 31 -- skip loop
						end
				when 2 then -- loop body:
						l_break := False
						l_tmp___5 := strpbrk (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("%"%'+-*/%%.=!?~|&$([<>,#"))
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5)
						Current.xp_pattern := l_tmp___4
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___4.is_void then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 30 -- skip if block
						end
				when 3 then -- if:
						l_c := (xp_pattern.item).to_integer_32
						if l_c /= 38 then
							l_pos := -1 + 14 -- skip if block
						end
				when 4 then -- if:
						l_c := (xp_pattern[1]).to_integer_32
						if l_c /= 38 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						Current.xp_pattern := xp_pattern + 1
						update_class_fields -- Current might have been changed; synchronize
						if a_cmdidx /= 209 then
							Current.xp_context := 20
							update_class_fields -- Current might have been changed; synchronize
						elseif l_got_eq.to_boolean then
							Current.xp_context := 20
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.xp_context := 0
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 7 then -- else:
						if l_c = 32 then
							l_pos := -1 + 13 -- skip if block
						end
				when 8 then -- if:
						Current.xp_context := 4
						update_class_fields -- Current might have been changed; synchronize
						if l_c /= 108 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 12 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 11 then -- else:
						if l_c /= 103 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L:
						if (xp_pattern[2]).to_integer_32 = 58 then
							Current.xp_pattern := xp_pattern + (2)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 13 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 30
				when 14 then -- else:
						if l_c /= 36 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						Current.xp_context := 26
						update_class_fields -- Current might have been changed; synchronize
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 17 then -- else:
						if l_c /= 61 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_got_eq := 1
						Current.xp_context := 20
						update_class_fields -- Current might have been changed; synchronize
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 20 then -- else:
						if l_c /= 60 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						if xp_context = 18 then
							l_tmp___3 := (create {P_MISC2_STATIC}).vim_strchr (xp_pattern, ('(').code)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___3.is_void then
								l_break := True
							else
								l_pos := -1 + 23 -- goto _L___2
							end
						else
							l_pos := -1 + 23 -- goto _L___2
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 23 then -- else: | _L___2:
						if a_cmdidx = 209 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 27 -- goto _L___0
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 26 then -- else:
						if not (l_got_eq.to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if: | _L___0:
						if l_c = 34 then
							from
							until
								(l_break)
							loop
								l_break := False
								Current.xp_pattern := xp_pattern + 1
								update_class_fields -- Current might have been changed; synchronize
								l_c := (xp_pattern.item).to_integer_32
								if l_c /= 0 then
									if l_c = 34 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) and then (l_c = 92) then
									if (xp_pattern[1]).to_integer_32 /= 0 then
										Current.xp_pattern := xp_pattern + 1
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
							l_break := False
							Current.xp_context := 0
							update_class_fields -- Current might have been changed; synchronize
						elseif l_c = 39 then
							from
							until
								(l_break)
							loop
								l_break := False
								Current.xp_pattern := xp_pattern + 1
								update_class_fields -- Current might have been changed; synchronize
								l_c := (xp_pattern.item).to_integer_32
								if l_c /= 0 then
									if l_c = 39 then
										l_break := True
									end
								else
									l_break := True
								end
							end
							l_break := False
							Current.xp_context := 0
							update_class_fields -- Current might have been changed; synchronize
						elseif l_c = 124 then
							if (xp_pattern[1]).to_integer_32 = 124 then
								Current.xp_pattern := xp_pattern + 1
								update_class_fields -- Current might have been changed; synchronize
								Current.xp_context := 20
								update_class_fields -- Current might have been changed; synchronize
							else
								Current.xp_context := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							Current.xp_context := 20
							update_class_fields -- Current might have been changed; synchronize
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						Current.xp_context := 20
						update_class_fields -- Current might have been changed; synchronize
				when 30 then -- if done | if done | if done | if done | if done | if done
						if not (l_return or l_break) then
							l_arg := xp_pattern
							if (l_arg.item).to_integer_32 /= 0 then
								from
								until
									(l_break)
								loop
									l_break := False
									l_arg := l_arg + 1
									l_c := (l_arg.item).to_integer_32
									if l_c /= 0 then
										if l_c /= 32 then
											if l_c /= 9 then
												l_break := True
											end
										end
									else
										l_break := True
									end
								end
								l_break := False
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 31 then -- loop done
						l_break := False
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
				when 32 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_context_in_sign_cmd (a_arg: CE_POINTER [NATURAL_8])
		require
			not a_arg.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_end_subcmd: CE_POINTER [NATURAL_8]
			l_last: CE_POINTER [NATURAL_8]
			l_cmd_idx: INTEGER_32
			l_begin_subcmd_args: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					Current.xp_context := 34
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EX_CMDS_STATIC}).expand_what.item := {PC_EXPAND_WHAT}.EXP_SUBCMD
					update_class_fields -- Current might have been changed; synchronize
					Current.xp_pattern := a_arg
					update_class_fields -- Current might have been changed; synchronize
					l_end_subcmd := (create {P_CHARSET_STATIC}).skiptowhite (a_arg)
					update_class_fields -- Current might have been changed; synchronize
					if (l_end_subcmd.item).to_integer_32 = 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_cmd_idx := (create {P_EX_CMDS_STATIC}).sign_cmd_idx (a_arg, l_end_subcmd)
						update_class_fields -- Current might have been changed; synchronize
						l_begin_subcmd_args := (create {P_CHARSET_STATIC}).skipwhite (l_end_subcmd)
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (l_begin_subcmd_args)
						update_class_fields -- Current might have been changed; synchronize
						if (l_p___0.item).to_integer_32 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						Current.xp_pattern := l_begin_subcmd_args
						update_class_fields -- Current might have been changed; synchronize
						inspect l_cmd_idx -- switch 1 head
						when 2 then l_pos := -1 + 3
						when 1 then l_pos := -1 + 3
						else l_pos := -1 + 4
						end
				when 3 then -- switch 1, case 2 | switch 1, case 1;
						(create {P_EX_CMDS_STATIC}).expand_what.item := {PC_EXPAND_WHAT}.EXP_SIGN_NAMES
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
				when 5 then -- switch 1, done:
						l_return := True
				when 6 then -- if done | if done
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 7 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							l_p___0 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
							update_class_fields -- Current might have been changed; synchronize
							l_last := l_p___0
							l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (l_p___0)
							update_class_fields -- Current might have been changed; synchronize
							if (l_p___0.item).to_integer_32 = 0 then
								l_break := True
							end
						end
						l_break := False
						l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_last, ('=').code)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_p___0.is_void) then
							l_pos := -1 + 14 -- skip if block
						end
				when 8 then -- if:
						Current.xp_pattern := l_last
						update_class_fields -- Current might have been changed; synchronize
						inspect l_cmd_idx -- switch 2 head
						when 0 then l_pos := -1 + 9
						when 3 then l_pos := -1 + 10
						when 5 then l_pos := -1 + 11
						when 4 then l_pos := -1 + 11
						else l_pos := -1 + 12
						end
				when 9 then -- switch 2, case 0;
						(create {P_EX_CMDS_STATIC}).expand_what.item := {PC_EXPAND_WHAT}.EXP_DEFINE
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 3;
						(create {P_EX_CMDS_STATIC}).expand_what.item := {PC_EXPAND_WHAT}.EXP_PLACE
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 13 -- switch 2; break
				when 11 then -- switch 2, case 5 | switch 2, case 4;
						(create {P_EX_CMDS_STATIC}).expand_what.item := {PC_EXPAND_WHAT}.EXP_UNPLACE
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, default:
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
				when 13 then -- switch 2, done: | if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						Current.xp_pattern := l_p___0 + 1
						update_class_fields -- Current might have been changed; synchronize
						inspect l_cmd_idx -- switch 3 head
						when 0 then l_pos := -1 + 15
						when 3 then l_pos := -1 + 16
						else l_pos := -1 + 17
						end
				when 15 then -- switch 3, case 0
						l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_last), ce_string ("texthl"), (l_p___0.distance (l_last)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 = 0 then
							Current.xp_context := 13
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp___1 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_last), ce_string ("linehl"), (l_p___0.distance (l_last)).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1 = 0 then
								Current.xp_context := 13
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_last), ce_string ("icon"), (l_p___0.distance (l_last)).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp = 0 then
									Current.xp_context := 2
									update_class_fields -- Current might have been changed; synchronize
								else
									Current.xp_context := 0
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						l_pos := -1 + 18 -- switch 3; break
				when 16 then -- switch 3, case 3
						l_tmp___2 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_last), ce_string ("name"), (l_p___0.distance (l_last)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 = 0 then
							(create {P_EX_CMDS_STATIC}).expand_what.item := {PC_EXPAND_WHAT}.EXP_SIGN_NAMES
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.xp_context := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 18 -- switch 3; break
				when 17 then -- switch 3, default:
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
				when 18 then -- switch 3, done: | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_one_cmd_context (a_buff: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_buff.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_cmd: CE_POINTER [NATURAL_8]
			l_arg: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_ea: CE_ARRAY [PD_EXARG]
			l_compl: CE_ARRAY [INTEGER_32]
			l_delim: INTEGER_32
			l_forceit: INTEGER_32
			l_usefilter: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___4: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: NATURAL_32
			l_c: INTEGER_32
			l_in_quote: INTEGER_32
			l_bow: CE_POINTER [NATURAL_8]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: INTEGER_32
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: INTEGER_32
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___22: CE_POINTER [NATURAL_8]
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___24: CE_POINTER [NATURAL_8]
			l_tmp___25: CE_POINTER [NATURAL_8]
			l_tmp___26: CE_POINTER [NATURAL_8]
			l_tmp___27: CE_POINTER [NATURAL_8]
			l_tmp___28: CE_POINTER [NATURAL_8]
			l_tmp___29: CE_POINTER [NATURAL_8]
			l_tmp___30: CE_POINTER [NATURAL_8]
			l_tmp___31: CE_POINTER [NATURAL_8]
			l_tmp___32: CE_POINTER [NATURAL_8]
			l_tmp___33: CE_POINTER [NATURAL_8]
			l_tmp___34: CE_POINTER [NATURAL_8]
			l_tmp___35: CE_POINTER [NATURAL_8]
			l_tmp___36: CE_POINTER [NATURAL_8]
			l_tmp___37: CE_POINTER [NATURAL_8]
			l_tmp___38: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_p___0.make
			create {CE_NATURAL_8_POINTER} l_arg.make
			create {CE_CLASS_ARRAY [PD_EXARG]} l_ea.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_compl.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 0
					l_compl.item := 0
					update_class_fields -- Current might have been changed; synchronize
					l_forceit := 0
					l_usefilter := 0;
					((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandInit
					update_class_fields -- Current might have been changed; synchronize
					Current.xp_pattern := a_buff
					update_class_fields -- Current might have been changed; synchronize
					Current.xp_context := 1
					update_class_fields -- Current might have been changed; synchronize
					l_ea.item.argt := 0
					update_class_fields -- Current might have been changed; synchronize
					l_cmd := a_buff
					from
					until
						(l_break)
					loop
						l_break := False
						l_tmp := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" %T:|")), (l_cmd.item).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp.is_void then
							l_break := True
						end
						if not (l_break) then
							l_cmd := l_cmd + 1
						end
					end
					l_break := False
					Current.xp_pattern := l_cmd
					update_class_fields -- Current might have been changed; synchronize
					if (l_cmd.item).to_integer_32 = 0 then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return and then ((l_cmd.item).to_integer_32 = 34) then
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						l_cmd := (create {P_EX_DOCMD_STATIC}).skip_range (l_cmd, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_EXPAND}.make).offset_of ("xp_context")))
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_cmd
						update_class_fields -- Current might have been changed; synchronize
						if (l_cmd.item).to_integer_32 = 0 then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return and then ((l_cmd.item).to_integer_32 = 34) then
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						if (l_cmd.item).to_integer_32 = 124 then
							Result := (l_cmd + 1)
							l_return := True
						elseif (l_cmd.item).to_integer_32 = 10 then
							Result := (l_cmd + 1)
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if:
						if (l_cmd.item).to_integer_32 /= 107 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_cmd[1]).to_integer_32 /= 101 then
							l_ea.item.cmdidx := {PC_CMD_INDEX}.CMD_k
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := l_cmd + 1
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 4 then -- else: | _L___1:
						l_p___0 := l_cmd
				when 5 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 11 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_tmp___0 := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if not (((l_tmp___0.item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if (l_p___0.item).to_integer_32 /= 42 then
							l_break := True
						end
				when 10 then
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 5 -- back to loop condition
				when 11 then -- loop done
						l_break := False
						if l_p___0.is_equal (l_cmd) then
							l_tmp___1 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("@*!=><&~#")), (l_p___0.item).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if not l_tmp___1.is_void then
								l_p___0 := l_p___0 + 1
							end
						end
						l_len := l_p___0.distance (l_cmd)
						if l_len = 0 then
							Current.xp_context := -2
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if l_return then
							l_pos := -1 + 21 -- skip if block
						end
				when 12 then -- if:
						l_ea.item.cmdidx := {PC_CMD_INDEX}.CMD_append
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							not (not (l_break) and then (l_ea.item.cmdidx < 517))
						loop
							l_break := False
							l_tmp___2 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EX_CMDS_STATIC}).cmdnames.item[l_ea.item.cmdidx].cmd_name), create {CE_INTEGER_8_POINTER}.make_cast (l_cmd), l_len.to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2 = 0 then
								l_break := True
							end
							if not (l_break) then
								l_ea.item.cmdidx := (l_ea.item.cmdidx + 1)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if not ((l_cmd[0]).to_integer_32 >= 65) then
							l_pos := -1 + 21 -- skip if block
						end
				when 13 then -- if:
						if not ((l_cmd[0]).to_integer_32 <= 90) then
							l_pos := -1 + 21 -- skip if block
						end
				when 14 then -- if: | loop condition:
						if (l_break) then
							l_pos := -1 + 20 -- skip loop
						end
				when 15 then -- loop body:
						l_break := False
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_tmp___3 := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if not (((l_tmp___3.item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							l_pos := -1 + 18 -- goto _L___0
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 /= 42 then
							l_break := True
						end
				when 19 then
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 14 -- back to loop condition
				when 20 then -- loop done
						l_break := False
				when 21 then -- if done | if done | if done | if done
					if not l_return and then ((l_p___0.item).to_integer_32 = 0) then
						if (l_p___0[-1]).to_integer_32 < 127 then
							l_tmp___4 := ctype_b_loc
							update_class_fields -- Current might have been changed; synchronize
							if (((l_tmp___4.item[(l_p___0[-1]).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 28 -- skip if block
					end
				when 22 then -- if:
						if l_ea.item.cmdidx /= 517 then
							l_pos := -1 + 27 -- skip if block
						end
				when 23 then -- if:
						if (l_cmd.item).to_integer_32 /= 115 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_tmp___5 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cgriI")), (l_cmd[1]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp___5.is_void then
							l_ea.item.cmdidx := {PC_CMD_INDEX}.CMD_substitute
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := l_cmd + 1
						else
							l_pos := -1 + 26 -- goto _L___2
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else: | _L___2:
						if (l_cmd[0]).to_integer_32 >= 65 then
							if (l_cmd[0]).to_integer_32 <= 90 then
								l_ea.item.cmd := l_cmd
								update_class_fields -- Current might have been changed; synchronize
								l_p___0 := l_ea.item.find_ucmd (l_p___0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), (create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), l_compl)
								update_class_fields -- Current might have been changed; synchronize
								if l_p___0.is_void then
									l_ea.item.cmdidx := {PC_CMD_INDEX}.CMD_SIZE
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
				when 27 then -- if done
						if l_ea.item.cmdidx = 517 then
							Current.xp_context := -2
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 28 then -- if done
					if l_return then
						l_pos := -1 + 40 -- skip if block
					end
				when 29 then -- if:
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
						if (l_p___0.item).to_integer_32 = 33 then
							l_forceit := 1
							l_p___0 := l_p___0 + 1
						end
						if not (l_ea.item.cmdidx < 0) then
							l_ea.item.argt := ((create {P_EX_CMDS_STATIC}).cmdnames.item[l_ea.item.cmdidx].cmd_argt).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
						l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_ea.item.cmdidx /= 479 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 33 -- goto _L___3
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 32 then -- else:
						if l_ea.item.cmdidx /= 460 then
							l_pos := -1 + 34 -- skip if block
						end
				when 33 then -- if: | _L___3:
						if (l_arg.item).to_integer_32 = 62 then
							l_arg := l_arg + 1
							if (l_arg.item).to_integer_32 = 62 then
								l_arg := l_arg + 1
							end
							l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg)
							update_class_fields -- Current might have been changed; synchronize
						elseif (l_arg.item).to_integer_32 = 33 then
							if l_ea.item.cmdidx = 479 then
								l_arg := l_arg + 1
								l_usefilter := 1
							end
						end
				when 34 then -- if done
						if l_ea.item.cmdidx = 330 then
							l_usefilter := l_forceit
							if (l_arg.item).to_integer_32 = 33 then
								l_arg := l_arg + 1
								l_usefilter := 1
							end
						end
						if l_ea.item.cmdidx /= 509 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						l_pos := -1 + 38 -- goto _L___4
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 39
				when 37 then -- else:
						if l_ea.item.cmdidx /= 511 then
							l_pos := -1 + 39 -- skip if block
						end
				when 38 then -- if: | _L___4:
						from
						until
							(l_arg.item).to_integer_32 /= (l_cmd.item).to_integer_32
						loop
							l_arg := l_arg + 1
						end
						l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg)
						update_class_fields -- Current might have been changed; synchronize
				when 39 then -- if done
						if ((l_ea.item.argt).bit_and (32_768)).to_boolean then
							if not l_usefilter.to_boolean then
								if (l_arg.item).to_integer_32 = 43 then
									l_p___0 := l_arg + 1
									l_arg := (create {P_EX_DOCMD_STATIC}).skip_cmd_arg (l_arg, 0)
									update_class_fields -- Current might have been changed; synchronize
									if (l_arg.item).to_integer_32 = 0 then
										Result := l_p___0
										l_return := True
									end
									if not l_return then
										l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg)
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
				when 40 then -- if done
					if not (not l_return and then (((l_ea.item.argt).bit_and (256)).to_boolean)) then
						l_pos := -1 + 56 -- skip if block
					end
				when 41 then -- if:
						if l_usefilter.to_boolean then
							l_pos := -1 + 56 -- skip if block
						end
				when 42 then -- if:
						l_p___0 := l_arg
						if l_ea.item.cmdidx = 333 then
							if (l_p___0[0]).to_integer_32 = 64 then
								if (l_p___0[1]).to_integer_32 = 34 then
									l_p___0 := l_p___0 + (2)
								end
							end
						end
				when 43 then -- loop condition:
						if not (not (l_return) and then ((l_p___0.item).to_boolean)) then
							l_pos := -1 + 56 -- skip loop
						end
				when 44 then -- loop body:
						if (l_p___0.item).to_integer_32 /= 22 then
							l_pos := -1 + 47 -- skip if block
						end
				when 45 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 47 then -- else:
						if (l_p___0.item).to_integer_32 /= 34 then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						if not ((l_ea.item.argt).bit_and (2_048)).to_boolean then
							l_pos := -1 + 54 -- goto _L___5
						else
							l_pos := -1 + 50 -- goto _L___6
						end
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 50 then -- else: | _L___6:
						if (l_p___0.item).to_integer_32 /= 124 then
							l_pos := -1 + 53 -- skip if block
						end
				when 51 then -- if:
						l_pos := -1 + 54 -- goto _L___5
				when 52 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 53 then -- else:
						if (l_p___0.item).to_integer_32 /= 10 then
							l_pos := -1 + 55 -- skip if block
						end
				when 54 then -- if: | _L___5:
						if (l_p___0[-1]).to_integer_32 /= 92 then
							if (l_p___0.item).to_integer_32 = 124 then
								Result := (l_p___0 + 1)
								l_return := True
							elseif (l_p___0.item).to_integer_32 = 10 then
								Result := (l_p___0 + 1)
								l_return := True
							end
							if not l_return then
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
						end
				when 55 then -- if done | if done | if done
						if not l_return then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___6 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___7 := l_tmp___6
							else
								l_tmp___7 := 1
							end
							l_p___0 := l_p___0 + l_tmp___7
						end
						l_pos := -1 + 43 -- back to loop condition
				when 56 then -- loop done | if done | if done
					if not l_return and then (not ((l_ea.item.argt).bit_and (4)).to_boolean) then
						if (l_arg.item).to_integer_32 /= 0 then
							l_tmp___8 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("|%"")), (l_arg.item).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___8.is_void then
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 135 -- skip if block
					end
				when 57 then -- if:
						l_tmp___9 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_buff))
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := a_buff + l_tmp___9.to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_p___0.is_equal (l_arg) then
								if (l_p___0.item).to_integer_32 /= 32 then
									if (l_p___0.item).to_integer_32 = 9 then
										l_break := True
									end
								else
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0 := l_p___0 - 1
							end
						end
						l_break := False
						if (l_p___0.item).to_integer_32 = 32 then
							l_p___0 := l_p___0 + 1
						elseif (l_p___0.item).to_integer_32 = 9 then
							l_p___0 := l_p___0 + 1
						end
						Current.xp_pattern := l_p___0
						update_class_fields -- Current might have been changed; synchronize
						if not (((l_ea.item.argt).bit_and (8)).to_boolean) then
							l_pos := -1 + 87 -- skip if block
						end
				when 58 then -- if:
						l_in_quote := 0
						l_bow := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						Current.xp_pattern := (create {P_CHARSET_STATIC}).skipwhite (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := xp_pattern
				when 59 then -- loop condition:
						if not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 81 -- skip loop
						end
				when 60 then -- loop body:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
							update_class_fields -- Current might have been changed; synchronize
						else
							l_c := (l_p___0.item).to_integer_32
						end
						if l_c /= 92 then
							l_pos := -1 + 63 -- skip if block
						end
				when 61 then -- if:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						else
							l_pos := -1 + 63 -- goto _L___9
						end
				when 62 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 63 then -- else: | _L___9:
						if l_c /= 96 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if not l_in_quote.to_boolean then
							Current.xp_pattern := l_p___0
							update_class_fields -- Current might have been changed; synchronize
							l_bow := l_p___0 + 1
						end
						l_in_quote := (not l_in_quote.to_boolean).to_integer
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 66 then -- else:
						if l_c /= 124 then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						l_pos := -1 + 79 -- goto _L___8
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 69 then -- else:
						if l_c /= 10 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if:
						l_pos := -1 + 79 -- goto _L___8
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 72 then -- else:
						if l_c /= 34 then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						l_pos := -1 + 79 -- goto _L___8
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 75 then -- else:
						if l_c /= 32 then
							l_pos := -1 + 78 -- skip if block
						end
				when 76 then -- if:
						l_pos := -1 + 79 -- goto _L___8
				when 77 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 78 then -- else:
						if l_c /= 9 then
							l_pos := -1 + 80 -- skip if block
						end
				when 79 then -- if: | _L___8:
						l_len := 0
						from
						until
							not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0))
						loop
							l_break := False
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
								update_class_fields -- Current might have been changed; synchronize
							else
								l_c := (l_p___0.item).to_integer_32
							end
							if l_c = 96 then
								l_break := True
							else
								l_tmp___10 := vim_isfilec_or_wc (l_c)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___10.to_boolean then
									l_break := True
								end
							end
							if not (l_return or l_break) then
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
									update_class_fields -- Current might have been changed; synchronize
								else
									l_len := 1
								end
								if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
									l_tmp___11 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___12 := l_tmp___11
								else
									l_tmp___12 := 1
								end
								l_p___0 := l_p___0 + l_tmp___12
							end
						end
						l_break := False
						if l_in_quote.to_boolean then
							l_bow := l_p___0
						else
							Current.xp_pattern := l_p___0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_p___0 := l_p___0 - l_len
				when 80 then -- if done | if done | if done | if done | if done | if done
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_tmp___13 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___14 := l_tmp___13
						else
							l_tmp___14 := 1
						end
						l_p___0 := l_p___0 + l_tmp___14
						l_pos := -1 + 59 -- back to loop condition
				when 81 then -- loop done
						if not l_bow.is_void then
							if l_in_quote.to_boolean then
								Current.xp_pattern := l_bow
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Current.xp_context := 2
						update_class_fields -- Current might have been changed; synchronize
						if not (l_usefilter.to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						l_pos := -1 + 85 -- goto _L___10
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 86
				when 84 then -- else:
						if l_ea.item.cmdidx /= 505 then
							l_pos := -1 + 86 -- skip if block
						end
				when 85 then -- if: | _L___10:
						Current.xp_shell := 1
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___15 := (create {P_CHARSET_STATIC}).skipwhite (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						if xp_pattern.is_equal (l_tmp___15) then
							Current.xp_context := 32
							update_class_fields -- Current might have been changed; synchronize
						end
				when 86 then -- if done
						if (xp_pattern.item).to_integer_32 = 36 then
							l_p___0 := xp_pattern + 1
							from
							until
								not (not (l_break) and then ((l_p___0.item).to_integer_32 /= 0))
							loop
								l_break := False
								l_tmp___16 := (create {P_CHARSET_STATIC}).vim_isIDc ((l_p___0.item).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if not l_tmp___16.to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_p___0 := l_p___0 + 1
								end
							end
							l_break := False
							if (l_p___0.item).to_integer_32 = 0 then
								Current.xp_context := 26
								update_class_fields -- Current might have been changed; synchronize
								Current.xp_pattern := xp_pattern + 1
								update_class_fields -- Current might have been changed; synchronize
								if l_compl.item /= 30 then
									if l_compl.item /= 31 then
										l_compl.item := 26
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
				when 87 then -- if done
						inspect l_ea.item.cmdidx -- switch 1 head
						when 143 then l_pos := -1 + 88
						when 371 then l_pos := -1 + 88
						when 423 then l_pos := -1 + 88
						when 55 then l_pos := -1 + 89
						when 63 then l_pos := -1 + 89
						when 203 then l_pos := -1 + 89
						when 204 then l_pos := -1 + 89
						when 161 then l_pos := -1 + 90
						when 3 then l_pos := -1 + 91
						when 10 then l_pos := -1 + 91
						when 25 then l_pos := -1 + 91
						when 30 then l_pos := -1 + 91
						when 37 then l_pos := -1 + 91
						when 39 then l_pos := -1 + 91
						when 86 then l_pos := -1 + 91
						when 100 then l_pos := -1 + 91
						when 151 then l_pos := -1 + 91
						when 150 then l_pos := -1 + 91
						when 167 then l_pos := -1 + 91
						when 192 then l_pos := -1 + 91
						when 191 then l_pos := -1 + 91
						when 190 then l_pos := -1 + 91
						when 208 then l_pos := -1 + 91
						when 231 then l_pos := -1 + 91
						when 342 then l_pos := -1 + 91
						when 353 then l_pos := -1 + 91
						when 376 then l_pos := -1 + 91
						when 419 then l_pos := -1 + 91
						when 444 then l_pos := -1 + 91
						when 463 then l_pos := -1 + 91
						when 464 then l_pos := -1 + 91
						when 485 then l_pos := -1 + 91
						when 253 then l_pos := -1 + 92
						when 82 then l_pos := -1 + 99
						when 102 then l_pos := -1 + 102
						when 155 then l_pos := -1 + 103
						when 461 then l_pos := -1 + 103
						when 507 then l_pos := -1 + 104
						when 349 then l_pos := -1 + 104
						when 182 then l_pos := -1 + 105
						when 118 then l_pos := -1 + 105
						when 174 then l_pos := -1 + 105
						when 114 then l_pos := -1 + 105
						when 173 then l_pos := -1 + 105
						when 310 then l_pos := -1 + 105
						when 113 then l_pos := -1 + 105
						when 183 then l_pos := -1 + 105
						when 119 then l_pos := -1 + 105
						when 16 then l_pos := -1 + 106
						when 115 then l_pos := -1 + 107
						when 116 then l_pos := -1 + 107
						when 367 then l_pos := -1 + 108
						when 369 then l_pos := -1 + 109
						when 370 then l_pos := -1 + 110
						when 417 then l_pos := -1 + 111
						when 400 then l_pos := -1 + 111
						when 311 then l_pos := -1 + 111
						when 238 then l_pos := -1 + 111
						when 448 then l_pos := -1 + 111
						when 406 then l_pos := -1 + 111
						when 319 then l_pos := -1 + 111
						when 440 then l_pos := -1 + 111
						when 405 then l_pos := -1 + 111
						when 314 then l_pos := -1 + 111
						when 17 then l_pos := -1 + 112
						when 413 then l_pos := -1 + 113
						when 209 then l_pos := -1 + 114
						when 172 then l_pos := -1 + 114
						when 128 then l_pos := -1 + 114
						when 482 then l_pos := -1 + 114
						when 153 then l_pos := -1 + 114
						when 122 then l_pos := -1 + 114
						when 126 then l_pos := -1 + 114
						when 137 then l_pos := -1 + 114
						when 125 then l_pos := -1 + 114
						when 123 then l_pos := -1 + 114
						when 50 then l_pos := -1 + 114
						when 339 then l_pos := -1 + 114
						when 455 then l_pos := -1 + 115
						when 154 then l_pos := -1 + 116
						when 103 then l_pos := -1 + 116
						when 124 then l_pos := -1 + 117
						when 166 then l_pos := -1 + 118
						when 375 then l_pos := -1 + 119
						when 23 then l_pos := -1 + 120
						when 41 then l_pos := -1 + 120
						when 40 then l_pos := -1 + 120
						when 19 then l_pos := -1 + 121
						when 355 then l_pos := -1 + 121
						when 66 then l_pos := -1 + 121
						when -1 then l_pos := -1 + 122 -- -1
						when -2 then l_pos := -1 + 122 -- -2
						when 250 then l_pos := -1 + 123
						when 275 then l_pos := -1 + 123
						when 270 then l_pos := -1 + 123
						when 273 then l_pos := -1 + 123
						when 470 then l_pos := -1 + 123
						when 473 then l_pos := -1 + 123
						when 286 then l_pos := -1 + 123
						when 290 then l_pos := -1 + 123
						when 175 then l_pos := -1 + 123
						when 178 then l_pos := -1 + 123
						when 70 then l_pos := -1 + 123
						when 76 then l_pos := -1 + 123
						when 222 then l_pos := -1 + 123
						when 225 then l_pos := -1 + 123
						when 457 then l_pos := -1 + 124
						when 282 then l_pos := -1 + 124
						when 477 then l_pos := -1 + 124
						when 293 then l_pos := -1 + 124
						when 184 then l_pos := -1 + 124
						when 94 then l_pos := -1 + 124
						when 242 then l_pos := -1 + 124
						when 1 then l_pos := -1 + 125
						when 278 then l_pos := -1 + 125
						when 45 then l_pos := -1 + 125
						when 77 then l_pos := -1 + 125
						when 170 then l_pos := -1 + 125
						when 179 then l_pos := -1 + 125
						when 453 then l_pos := -1 + 126
						when 95 then l_pos := -1 + 126
						when 185 then l_pos := -1 + 126
						when 254 then l_pos := -1 + 127
						when 279 then l_pos := -1 + 127
						when 458 then l_pos := -1 + 127
						when 5 then l_pos := -1 + 127
						when 6 then l_pos := -1 + 127
						when 18 then l_pos := -1 + 127
						when 272 then l_pos := -1 + 127
						when 274 then l_pos := -1 + 127
						when 283 then l_pos := -1 + 127
						when 472 then l_pos := -1 + 127
						when 475 then l_pos := -1 + 127
						when 478 then l_pos := -1 + 127
						when 288 then l_pos := -1 + 127
						when 291 then l_pos := -1 + 127
						when 294 then l_pos := -1 + 127
						when 177 then l_pos := -1 + 127
						when 180 then l_pos := -1 + 127
						when 186 then l_pos := -1 + 127
						when 72 then l_pos := -1 + 127
						when 78 then l_pos := -1 + 127
						when 96 then l_pos := -1 + 127
						when 442 then l_pos := -1 + 127
						when 449 then l_pos := -1 + 127
						when 302 then l_pos := -1 + 127
						when 437 then l_pos := -1 + 127
						when 129 then l_pos := -1 + 127
						when 81 then l_pos := -1 + 128
						when 84 then l_pos := -1 + 129
						when 295 then l_pos := -1 + 130
						when 368 then l_pos := -1 + 131
						when 197 then l_pos := -1 + 132
						when 24 then l_pos := -1 + 133
						else l_pos := -1 + 134
						end
				when 88 then -- switch 1, case 143 | switch 1, case 371 | switch 1, case 423
						Current.xp_context := 38
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 89 then -- switch 1, case 55 | switch 1, case 63 | switch 1, case 203 | switch 1, case 204
						if xp_context = 2 then
							Current.xp_context := 3
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 135 -- switch 1; break
				when 90 then -- switch 1, case 161
						Current.xp_context := 8
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 91 then -- switch 1, case 3 | switch 1, case 10 | switch 1, case 25 | switch 1, case 30 | switch 1, case 37 | switch 1, case 39 | switch 1, case 86 | switch 1, case 100 | switch 1, case 151 | switch 1, case 150 | switch 1, case 167 | switch 1, case 192 | switch 1, case 191 | switch 1, case 190 | switch 1, case 208 | switch 1, case 231 | switch 1, case 342 | switch 1, case 353 | switch 1, case 376 | switch 1, case 419 | switch 1, case 444 | switch 1, case 463 | switch 1, case 464 | switch 1, case 485
						Result := l_arg
						l_return := True
				when 92 then -- switch 1, case 253
						if l_return then
							l_pos := -1 + 99 -- skip if block
						end
				when 93 then -- if:
						if (l_arg.item).to_integer_32 /= 0 then
							l_pos := -1 + 96 -- skip if block
						end
				when 94 then -- if:
						l_pos := -1 + 97 -- goto _L___11
				when 95 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 96 then -- else:
						l_tmp___18 := (create {P_EX_DOCMD_STATIC}).ends_excmd ((l_arg.item).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___18.to_boolean then
							l_pos := -1 + 98 -- skip if block
						end
				when 97 then -- if: | _L___11:;
						((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_echohl_cmd (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___17 := (create {P_CHARSET_STATIC}).skiptowhite (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_tmp___17)
						update_class_fields -- Current might have been changed; synchronize
						if (l_arg.item).to_integer_32 /= 0 then
							Current.xp_context := 0
							update_class_fields -- Current might have been changed; synchronize
							l_arg := (create {P_REGEXP_STATIC}).skip_regexp (l_arg + 1, (l_arg.item).to_integer_32, (create {P_OPTION_STATIC}).p_magic.item.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
				when 98 then -- if done
						l_tmp___19 := (create {P_EX_DOCMD_STATIC}).find_nextcmd (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___19
						l_return := True
				when 99 then -- switch 1, case 82
						if not l_return then
							from
							until
								not (not (l_return) and then ((l_arg.item).to_integer_32 = 45))
							loop
								l_arg := l_arg + 1
								l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (l_arg)
								update_class_fields -- Current might have been changed; synchronize
								if (l_p___0.item).to_integer_32 = 0 then
									l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_arg, ('=').code)
									update_class_fields -- Current might have been changed; synchronize
									if l_p___0.is_void then
										Current.xp_context := 23
										update_class_fields -- Current might have been changed; synchronize
										Current.xp_pattern := l_arg
										update_class_fields -- Current might have been changed; synchronize
										Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
										l_return := True
									end
									if not l_return then
										l_tmp___21 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("complete"), (l_p___0.distance (l_arg)).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___21 = 0 then
											Current.xp_context := 25
											update_class_fields -- Current might have been changed; synchronize
											Current.xp_pattern := l_p___0 + 1
											update_class_fields -- Current might have been changed; synchronize
											Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
											l_return := True
										else
											l_tmp___20 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("nargs"), (l_p___0.distance (l_arg)).to_natural_32)
											update_class_fields -- Current might have been changed; synchronize
											if l_tmp___20 = 0 then
												Current.xp_context := 24
												update_class_fields -- Current might have been changed; synchronize
												Current.xp_pattern := l_p___0 + 1
												update_class_fields -- Current might have been changed; synchronize
												Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
												l_return := True
											end
										end
									end
									if not l_return then
										Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
										l_return := True
									end
								end
								if not l_return then
									l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						if l_return then
							l_pos := -1 + 102 -- skip if block
						end
				when 100 then -- if:
						l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						if (l_p___0.item).to_integer_32 = 0 then
							Current.xp_context := 22
							update_class_fields -- Current might have been changed; synchronize
							Current.xp_pattern := l_arg
							update_class_fields -- Current might have been changed; synchronize
							l_pos := -1 + 135 -- switch 1; break
						end
				when 101 then
						l_tmp___22 := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___22
						l_return := True
				when 102 then -- switch 1, case 102
						if not l_return then
							Current.xp_context := 22
							update_class_fields -- Current might have been changed; synchronize
							Current.xp_pattern := l_arg
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 135 -- switch 1; break
				when 103 then -- switch 1, case 155 | switch 1, case 461
						l_delim := (l_arg.item).to_integer_32
						if l_delim.to_boolean then
							l_arg := l_arg + 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_arg[0]).to_integer_32 /= 0 then
								if (l_arg[0]).to_integer_32 = l_delim then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if (l_arg[0]).to_integer_32 = 92 then
									if (l_arg[1]).to_integer_32 /= 0 then
										l_arg := l_arg + 1
									end
								end
								l_arg := l_arg + 1
							end
						end
						l_break := False
						if (l_arg[0]).to_integer_32 /= 0 then
							Result := (l_arg + 1)
							l_return := True
						end
						l_pos := -1 + 135 -- switch 1; break
				when 104 then -- switch 1, case 507 | switch 1, case 349
						l_delim := (l_arg.item).to_integer_32
						if l_delim.to_boolean then
							l_arg := l_arg + 1
							l_arg := (create {P_REGEXP_STATIC}).skip_regexp (l_arg, l_delim, (create {P_OPTION_STATIC}).p_magic.item.item, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_arg[0]).to_integer_32 /= 0 then
								if (l_arg[0]).to_integer_32 = l_delim then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if (l_arg[0]).to_integer_32 = 92 then
									if (l_arg[1]).to_integer_32 /= 0 then
										l_arg := l_arg + 1
									end
								end
								l_arg := l_arg + 1
							end
						end
						l_break := False
						if (l_arg[0]).to_integer_32 /= 0 then
							l_arg := l_arg + 1
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_arg[0]).to_boolean then
								l_tmp___23 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("|%"#")), (l_arg[0]).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								if not (l_tmp___23.is_void) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_arg := l_arg + 1
							end
						end
						l_break := False
						if (l_arg[0]).to_integer_32 /= 0 then
							Result := l_arg
							l_return := True
						end
						l_pos := -1 + 135 -- switch 1; break
				when 105 then -- switch 1, case 182 | switch 1, case 118 | switch 1, case 174 | switch 1, case 114 | switch 1, case 173 | switch 1, case 310 | switch 1, case 113 | switch 1, case 183 | switch 1, case 119
						l_tmp___24 := (create {P_CHARSET_STATIC}).skipdigits (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_tmp___24)
						update_class_fields -- Current might have been changed; synchronize
						if (l_arg.item).to_integer_32 = 47 then
							l_arg := l_arg + 1
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_arg.item).to_boolean then
									if (l_arg.item).to_integer_32 = 47 then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									if (l_arg.item).to_integer_32 = 92 then
										if (l_arg[1]).to_integer_32 /= 0 then
											l_arg := l_arg + 1
										end
									end
									l_arg := l_arg + 1
								end
							end
							l_break := False
							if (l_arg.item).to_boolean then
								l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg + 1)
								update_class_fields -- Current might have been changed; synchronize
								if (l_arg.item).to_boolean then
									l_tmp___25 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("|%"%N")), (l_arg.item).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___25.is_void then
										Current.xp_context := 0
										update_class_fields -- Current might have been changed; synchronize
									else
										Result := l_arg
										l_return := True
									end
								else
									Result := l_arg
									l_return := True
								end
							end
						end
						l_pos := -1 + 135 -- switch 1; break
				when 106 then -- switch 1, case 16
						l_tmp___26 := set_context_in_autocmd ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), l_arg, 0)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___26
						l_return := True
				when 107 then -- switch 1, case 115 | switch 1, case 116
						if not l_return then
							l_tmp___27 := set_context_in_autocmd ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), l_arg, 1)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___27
							l_return := True
						end
				when 108 then -- switch 1, case 367
						if not l_return then
							((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_set_cmd (l_arg, 0)
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 135 -- switch 1; break
				when 109 then -- switch 1, case 369;
						((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_set_cmd (l_arg, 2)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 110 then -- switch 1, case 370;
						((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_set_cmd (l_arg, 4)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 111 then -- switch 1, case 417 | switch 1, case 400 | switch 1, case 311 | switch 1, case 238 | switch 1, case 448 | switch 1, case 406 | switch 1, case 319 | switch 1, case 440 | switch 1, case 405 | switch 1, case 314
						if ((create {P_OPTION_STATIC}).p_wop.item.item.item).to_integer_32 /= 0 then
							Current.xp_context := 17
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.xp_context := 6
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 112 then -- switch 1, case 17
						Current.xp_context := 14
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 113 then -- switch 1, case 413;
						((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_syntax_cmd (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 114 then -- switch 1, case 209 | switch 1, case 172 | switch 1, case 128 | switch 1, case 482 | switch 1, case 153 | switch 1, case 122 | switch 1, case 126 | switch 1, case 137 | switch 1, case 125 | switch 1, case 123 | switch 1, case 50 | switch 1, case 339;
						((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_for_expression (l_arg, l_ea.item.cmdidx)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 115 then -- switch 1, case 455
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___28 := (create {P_MISC2_STATIC}).vim_strchr (l_arg, (' ').code)
							update_class_fields -- Current might have been changed; synchronize
							Current.xp_pattern := l_tmp___28
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___28.is_void then
								l_break := True
							end
							if not (l_return or l_break) then
								l_arg := xp_pattern + 1
							end
						end
						l_break := False
						Current.xp_context := 15
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 116 then -- switch 1, case 154 | switch 1, case 103
						Current.xp_context := 19
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 117 then -- switch 1, case 124;
						((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_echohl_cmd (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 118 then -- switch 1, case 166;
						((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_highlight_cmd (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 119 then -- switch 1, case 375;
						((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_sign_cmd (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 120 then -- switch 1, case 23 | switch 1, case 41 | switch 1, case 40
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp___29 := (create {P_MISC2_STATIC}).vim_strchr (l_arg, (' ').code)
							update_class_fields -- Current might have been changed; synchronize
							Current.xp_pattern := l_tmp___29
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___29.is_void then
								l_break := True
							end
							if not (l_return or l_break) then
								l_arg := xp_pattern + 1
							end
						end
						l_break := False
				when 121 then -- switch 1, case 19 | switch 1, case 355 | switch 1, case 66
						Current.xp_context := 9
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 122 then -- switch 1, case -1 | switch 1, case -2
						if l_compl.item /= 0 then
							if not ((l_ea.item.argt).bit_and (8)).to_boolean then
								if l_compl.item = 11 then
									l_tmp___30 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_menu_cmd (l_cmd, l_arg, l_forceit)
									update_class_fields -- Current might have been changed; synchronize
									Result := l_tmp___30
									l_return := True
								end
								if not l_return and then (l_compl.item = 1) then
									Result := l_arg
									l_return := True
								end
								if not l_return and then (l_compl.item = 16) then
									l_tmp___31 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_map_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("map")), l_arg, l_forceit, 0, 0, {PC_CMD_INDEX}.CMD_map)
									update_class_fields -- Current might have been changed; synchronize
									Result := l_tmp___31
									l_return := True
								end
								if not l_return then
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp___32 := (create {P_MISC2_STATIC}).vim_strchr (l_arg, (' ').code)
										update_class_fields -- Current might have been changed; synchronize
										Current.xp_pattern := l_tmp___32
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___32.is_void then
											l_break := True
										end
										if not (l_return or l_break) then
											l_arg := xp_pattern + 1
										end
									end
									l_break := False
									Current.xp_pattern := l_arg
									update_class_fields -- Current might have been changed; synchronize
								end
							end
							if not l_return then
								Current.xp_context := l_compl.item
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 135 -- switch 1; break
				when 123 then -- switch 1, case 250 | switch 1, case 275 | switch 1, case 270 | switch 1, case 273 | switch 1, case 470 | switch 1, case 473 | switch 1, case 286 | switch 1, case 290 | switch 1, case 175 | switch 1, case 178 | switch 1, case 70 | switch 1, case 76 | switch 1, case 222 | switch 1, case 225
						l_tmp___33 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_map_cmd (l_cmd, l_arg, l_forceit, 0, 0, l_ea.item.cmdidx)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___33
						l_return := True
				when 124 then -- switch 1, case 457 | switch 1, case 282 | switch 1, case 477 | switch 1, case 293 | switch 1, case 184 | switch 1, case 94 | switch 1, case 242
						if not l_return then
							l_tmp___34 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_map_cmd (l_cmd, l_arg, l_forceit, 0, 1, l_ea.item.cmdidx)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___34
							l_return := True
						end
				when 125 then -- switch 1, case 1 | switch 1, case 278 | switch 1, case 45 | switch 1, case 77 | switch 1, case 170 | switch 1, case 179
						if not l_return then
							l_tmp___35 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_map_cmd (l_cmd, l_arg, l_forceit, 1, 0, l_ea.item.cmdidx)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___35
							l_return := True
						end
				when 126 then -- switch 1, case 453 | switch 1, case 95 | switch 1, case 185
						if not l_return then
							l_tmp___36 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_map_cmd (l_cmd, l_arg, l_forceit, 1, 1, l_ea.item.cmdidx)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___36
							l_return := True
						end
				when 127 then -- switch 1, case 254 | switch 1, case 279 | switch 1, case 458 | switch 1, case 5 | switch 1, case 6 | switch 1, case 18 | switch 1, case 272 | switch 1, case 274 | switch 1, case 283 | switch 1, case 472 | switch 1, case 475 | switch 1, case 478 | switch 1, case 288 | switch 1, case 291 | switch 1, case 294 | switch 1, case 177 | switch 1, case 180 | switch 1, case 186 | switch 1, case 72 | switch 1, case 78 | switch 1, case 96 | switch 1, case 442 | switch 1, case 449 | switch 1, case 302 | switch 1, case 437 | switch 1, case 129
						if not l_return then
							l_tmp___37 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.set_context_in_menu_cmd (l_cmd, l_arg, l_forceit)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___37
							l_return := True
						end
				when 128 then -- switch 1, case 81
						if not l_return then
							Current.xp_context := 28
							update_class_fields -- Current might have been changed; synchronize
							Current.xp_pattern := l_arg
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 135 -- switch 1; break
				when 129 then -- switch 1, case 84
						Current.xp_context := 29
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 130 then -- switch 1, case 295
						Current.xp_context := 39
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 131 then -- switch 1, case 368
						Current.xp_context := 37
						update_class_fields -- Current might have been changed; synchronize
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 132 then -- switch 1, case 197
						l_tmp___38 := (create {P_CHARSET_STATIC}).skiptowhite (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						if (l_tmp___38.item).to_integer_32 = 0 then
							Current.xp_context := 27
							update_class_fields -- Current might have been changed; synchronize
							Current.xp_pattern := l_arg
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.xp_context := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						l_pos := -1 + 135 -- switch 1; break
				when 133 then -- switch 1, case 24
						Current.xp_context := 36
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 135 -- switch 1; break
				when 134 then -- switch 1, default:
						l_pos := -1 + 135 -- switch 1; break
				when 135 then -- switch 1, done: | if done
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 136 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nextwild (a_type, a_options___0: INTEGER_32): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_p1: CE_POINTER [NATURAL_8]
			l_p2: CE_POINTER [NATURAL_8]
			l_difflen: INTEGER_32
			l_v: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if xp_numfiles = -1 then
						set_expand_context ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
						cmd_showtail.item := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.expand_showtail
						update_class_fields -- Current might have been changed; synchronize
					end
					if xp_context = -2 then
						(create {P_MISC1_STATIC}).beep_flush
						update_class_fields -- Current might have been changed; synchronize
						Result := 1
						l_return := True
					end
					if not l_return and then (xp_context = 0) then
						Result := 0
						l_return := True
					end
					if not l_return then
						(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("...")))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_TERM_STATIC}).out_flush
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := xp_pattern.distance (((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff))
						Current.xp_pattern_len := (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos - l_i___0
						update_class_fields -- Current might have been changed; synchronize
						if a_type = 4 then
							l_p2 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandOne (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, a_type)
							update_class_fields -- Current might have been changed; synchronize
						elseif a_type = 5 then
							l_p2 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandOne (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, a_type)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_p1 := (create {P_EX_GETLN_STATIC}).addstar (xp_pattern, xp_pattern_len, xp_context)
							update_class_fields -- Current might have been changed; synchronize
							if l_p1.is_void then
								l_p2 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							else
								l_tmp := (create {P_MISC2_STATIC}).vim_strnsave ((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff + l_i___0, xp_pattern_len)
								update_class_fields -- Current might have been changed; synchronize
								l_p2 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandOne (l_p1, l_tmp, (210).bit_or (a_options___0), a_type)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p1))
								update_class_fields -- Current might have been changed; synchronize
								if not l_p2.is_void then
									if a_type = 7 then
										l_j := 0
										from
										until
											not (not (l_break) and then (l_j < xp_pattern_len))
										loop
											l_break := False
											if ((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff[(l_i___0 + l_j)]).to_integer_32 = 42 then
												l_break := True
											elseif ((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff[(l_i___0 + l_j)]).to_integer_32 = 63 then
												l_break := True
											end
											if not (l_break) then
												l_j := l_j + 1
											end
										end
										l_break := False
										l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p2))
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___0.to_integer_32 < l_j then
											(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p2))
											update_class_fields -- Current might have been changed; synchronize
											l_p2 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
										end
									end
								end
							end
						end
						if not l_p2.is_void then
							if not ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
								l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p2))
								update_class_fields -- Current might have been changed; synchronize
								l_difflen := l_tmp___1.to_integer_32 - xp_pattern_len
								if ((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen + l_difflen) + 4 > (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbufflen then
									l_v := (create {P_EX_GETLN_STATIC}).realloc_cmdbuff (((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen + l_difflen) + 4)
									update_class_fields -- Current might have been changed; synchronize
									Current.xp_pattern := (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff + l_i___0
									update_class_fields -- Current might have been changed; synchronize
								else
									l_v := 1
								end
								if l_v = 1 then
									memmove (create {CE_VOID_POINTER}.make_cast (((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff + ((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos + l_difflen))), create {CE_VOID_POINTER}.make_cast (((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff + (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos)), (((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen - (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos) + 1).to_natural_32).do_nothing
									update_class_fields -- Current might have been changed; synchronize
									l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p2))
									update_class_fields -- Current might have been changed; synchronize
									memmove (create {CE_VOID_POINTER}.make_cast (((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff + l_i___0)), create {CE_VOID_POINTER}.make_cast (l_p2), l_tmp___2).do_nothing
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen := (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen + l_difflen
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos := (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos + l_difflen
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p2))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EX_GETLN_STATIC}).redrawcmd
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EX_GETLN_STATIC}).cursorcmd
						update_class_fields -- Current might have been changed; synchronize
						if xp_context = 16 then
							if l_p2.is_void then
								Result := 0
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not (xp_numfiles <= 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_p2.is_void then
							(create {P_MISC1_STATIC}).beep_flush
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if xp_numfiles = 1 then
							((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandOne (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then
						Result := 1
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ExpandOne (a_str___1, a_orig: CE_POINTER [NATURAL_8]; a_options___0, a_mode: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_ss: CE_POINTER [NATURAL_8]
			l_orig_saved: INTEGER_32
			l_i___0: INTEGER_32
			l_len: NATURAL_32
			l_non_suf_match: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: INTEGER_32
			l_tmp___5: NATURAL_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ss := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_orig_saved := 0
					if a_mode /= 4 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if a_mode /= 5 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if xp_numfiles > 0 then
							if a_mode = 5 then
								if findex.item = -1 then
									findex.item := xp_numfiles
								end
								findex.item := findex.item - 1
							else
								findex.item := findex.item + 1
							end
							if findex.item < 0 then
								if orig_save.item.is_void then
									findex.item := xp_numfiles - 1
								else
									findex.item := -1
								end
							end
							if findex.item >= xp_numfiles then
								if orig_save.item.is_void then
									findex.item := 0
								else
									findex.item := -1
								end
							end
							if ((create {P_OPTION_STATIC}).p_wmnu.item.item).to_boolean then
								win_redr_status_matches ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), xp_numfiles, xp_files, findex.item, cmd_showtail.item)
								update_class_fields -- Current might have been changed; synchronize
							end
							if findex.item = -1 then
								l_tmp := (create {P_MISC2_STATIC}).vim_strsave (orig_save.item)
								update_class_fields -- Current might have been changed; synchronize
								Result := l_tmp
								l_return := True
							end
							if not l_return then
								l_tmp___0 := (create {P_MISC2_STATIC}).vim_strsave (xp_files[findex.item])
								update_class_fields -- Current might have been changed; synchronize
								Result := l_tmp___0
								l_return := True
							end
						else
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						if xp_numfiles /= -1 then
							if a_mode /= 6 then
								if a_mode /= 7 then
									(create {P_MISC1_STATIC}).FreeWild (xp_numfiles, xp_files)
									update_class_fields -- Current might have been changed; synchronize
									Current.xp_numfiles := -1
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (orig_save.item))
									update_class_fields -- Current might have been changed; synchronize
									orig_save.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
							end
						end
						findex.item := 0
						if a_mode = 1 then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 6 then -- if:
						if xp_numfiles /= -1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 7 then -- if:;
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (orig_save.item))
						update_class_fields -- Current might have been changed; synchronize
						orig_save.item := a_orig
						l_orig_saved := 1
						l_tmp___4 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandFromContext (a_str___1, create {CE_INTEGER_32_POINTER}.make_shared (c_pointer + (create {PD_EXPAND}.make).offset_of ("xp_numfiles")), create {CE_POINTER_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (c_pointer + (create {PD_EXPAND}.make).offset_of ("xp_files")), a_options___0)
						update_class_fields -- Current might have been changed; synchronize
						if (l_tmp___4 = 0) then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						if xp_numfiles /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not ((a_options___0).bit_and (64)).to_boolean then
							l_tmp___1 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_nomatch2.item)))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1), a_str___1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 11 then -- else:;
						(create {P_EX_GETLN_STATIC}).ExpandEscape ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), a_str___1, xp_numfiles, xp_files, a_options___0)
						update_class_fields -- Current might have been changed; synchronize
						if a_mode = 6 then
							l_pos := -1 + 19 -- skip if block
						end
				when 12 then -- if:
						if a_mode = 7 then
							l_pos := -1 + 19 -- skip if block
						end
				when 13 then -- if:
						if xp_numfiles.to_boolean then
							l_non_suf_match := xp_numfiles
						else
							l_non_suf_match := 1
						end
						if xp_context /= 2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 16 then -- else:
						if xp_context /= 3 then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | _L___0:
						if xp_numfiles > 1 then
							l_non_suf_match := 0
							l_i___0 := 0
							from
							until
								not (l_i___0 < 2)
							loop
								l_tmp___2 := (create {P_MISC1_STATIC}).match_suffix (xp_files[l_i___0])
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___2.to_boolean then
									l_non_suf_match := l_non_suf_match + 1
								end
								l_i___0 := l_i___0 + 1
							end
						end
				when 18 then -- if done
						if l_non_suf_match /= 1 then
							if not ((a_options___0).bit_and (64)).to_boolean then
								l_tmp___3 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (e_toomany.item))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							elseif not ((a_options___0).bit_and (8)).to_boolean then
								(create {P_MISC1_STATIC}).beep_flush
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_non_suf_match /= 1 then
							if a_mode /= 2 then
								l_ss := (create {P_MISC2_STATIC}).vim_strsave (xp_files[0])
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_ss := (create {P_MISC2_STATIC}).vim_strsave (xp_files[0])
							update_class_fields -- Current might have been changed; synchronize
						end
				when 19 then -- if done | if done | if done | if done | if done
						if a_mode = 7 then
							if xp_numfiles > 0 then
								l_len := (0).to_natural_32
								from
								until
									not (not (l_return or l_break) and then (((xp_files[0])[l_len.to_integer_32]).to_boolean))
								loop
									l_break := False
									l_i___0 := 0
									from
									until
										not (not (l_break) and then (l_i___0 < xp_numfiles))
									loop
										l_break := False
										if ((xp_files[l_i___0])[l_len.to_integer_32]).to_integer_32 /= ((xp_files[0])[l_len.to_integer_32]).to_integer_32 then
											l_break := True
										end
										if not (l_break) then
											l_i___0 := l_i___0 + 1
										end
									end
									l_break := False
									if l_i___0 < xp_numfiles then
										if not ((a_options___0).bit_and (8)).to_boolean then
											(create {P_MISC1_STATIC}).vim_beep
											update_class_fields -- Current might have been changed; synchronize
										end
										l_break := True
									end
									if not (l_return or l_break) then
										l_len := l_len + 1
									end
								end
								l_break := False
								l_ss := (create {P_MISC2_STATIC}).alloc (l_len.to_natural_32 + {NATURAL_32} 1)
								update_class_fields -- Current might have been changed; synchronize
								if (not l_ss.is_void) then
									(create {P_MISC2_STATIC}).vim_strncpy (l_ss, xp_files[0], l_len.to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
								end
								findex.item := -1
							end
						end
						if a_mode = 6 then
							if xp_numfiles > 0 then
								l_len := (0).to_natural_32
								l_i___0 := 0
								from
								until
									not (l_i___0 < xp_numfiles)
								loop
									l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (xp_files[l_i___0]))
									update_class_fields -- Current might have been changed; synchronize
									l_len := l_len + (l_tmp___5.to_natural_32 + {NATURAL_32} 1)
									l_i___0 := l_i___0 + 1
								end
								l_ss := (create {P_MISC2_STATIC}).lalloc (l_len, 1)
								update_class_fields -- Current might have been changed; synchronize
								if not l_ss.is_void then
									l_ss.item := (('%/0/').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
									l_i___0 := 0
									from
									until
										not (l_i___0 < xp_numfiles)
									loop
										strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_ss), create {CE_INTEGER_8_POINTER}.make_cast (xp_files[l_i___0])).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										if l_i___0 /= xp_numfiles - 1 then
											if ((a_options___0).bit_and (4)).to_boolean then
												l_tmp___6 := ce_string ("%N")
											else
												l_tmp___6 := ce_string (" ")
											end
											strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_ss), l_tmp___6).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										end
										l_i___0 := l_i___0 + 1
									end
								end
							end
						end
						if a_mode = 2 then
							((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandCleanup
							update_class_fields -- Current might have been changed; synchronize
						elseif a_mode = 6 then
							((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandCleanup
							update_class_fields -- Current might have been changed; synchronize
						end
						if not l_orig_saved.to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_orig))
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := l_ss
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ExpandInit
		do
			Current.xp_pattern := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.xp_pattern_len := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.xp_backslash := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.xp_shell := 0
			update_class_fields -- Current might have been changed; synchronize
			Current.xp_numfiles := -1
			update_class_fields -- Current might have been changed; synchronize
			Current.xp_files := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			Current.xp_arg := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
		end

	ExpandCleanup
		do
			if xp_numfiles >= 0 then
				(create {P_MISC1_STATIC}).FreeWild (xp_numfiles, xp_files)
				update_class_fields -- Current might have been changed; synchronize
				Current.xp_numfiles := -1
				update_class_fields -- Current might have been changed; synchronize
			end
		end

	showmatches (a_wildmenu: INTEGER_32): INTEGER_32
		local
			l_num_files: CE_ARRAY [INTEGER_32]
			l_files_found: CE_ARRAY [CE_POINTER [CE_POINTER [NATURAL_8]]]
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_maxlen: INTEGER_32
			l_lines___0: INTEGER_32
			l_columns: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_lastlen: INTEGER_32
			l_attr: INTEGER_32
			l_showtail: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: NATURAL_32
			l_halved_slash: CE_POINTER [NATURAL_8]
			l_exp_path: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_num_files.make (<<1>>)
			create {CE_POINTER_ARRAY [CE_POINTER [NATURAL_8]]} l_files_found.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if xp_numfiles = -1 then
						set_expand_context ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
						l_i___0 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.expand_cmdline ((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff, (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos, l_num_files, l_files_found)
						update_class_fields -- Current might have been changed; synchronize
						l_showtail := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.expand_showtail
						update_class_fields -- Current might have been changed; synchronize
						if l_i___0 /= -1 then
							Result := l_i___0
							l_return := True
						end
					else
						l_num_files.item := xp_numfiles
						update_class_fields -- Current might have been changed; synchronize
						l_files_found.item := xp_files
						update_class_fields -- Current might have been changed; synchronize
						l_showtail := cmd_showtail.item
					end
					if l_return then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						if not a_wildmenu.to_boolean then
							(create {P_GLOBALS_STATIC}).msg_didany.item := 0
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_start
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_TERM_STATIC}).out_flush
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_GLOBALS_STATIC}).msg_didany.item := 0
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_start
							update_class_fields -- Current might have been changed; synchronize
						end
						if not (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:;
						(create {P_GLOBALS_STATIC}).got_int.item := 0
						update_class_fields -- Current might have been changed; synchronize
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 4 then -- else:
						if not (a_wildmenu.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						win_redr_status_matches ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), l_num_files.item, l_files_found.item, 0, l_showtail)
						update_class_fields -- Current might have been changed; synchronize
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 7 then -- else:
						l_maxlen := 0
						l_i___0 := 0
				when 8 then -- loop condition:
						if not (l_i___0 < l_num_files.item) then
							l_pos := -1 + 14 -- skip loop
						end
				when 9 then -- loop body:
						if l_showtail.to_boolean then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if xp_context = 2 then
							(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_files_found.item[l_i___0], (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1)
							update_class_fields -- Current might have been changed; synchronize
							l_j := (create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
							update_class_fields -- Current might have been changed; synchronize
						elseif xp_context = 32 then
							(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_files_found.item[l_i___0], (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1)
							update_class_fields -- Current might have been changed; synchronize
							l_j := (create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
							update_class_fields -- Current might have been changed; synchronize
						elseif xp_context = 9 then
							(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_files_found.item[l_i___0], (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1)
							update_class_fields -- Current might have been changed; synchronize
							l_j := (create {P_CHARSET_STATIC}).vim_strsize ((create {P_GLOBALS_STATIC}).NameBuff.item.item)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if l_showtail.to_boolean then
							l_tmp := sm_gettail (l_files_found.item[l_i___0])
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := l_tmp
						else
							l_tmp___0 := l_files_found.item[l_i___0]
						end
						l_j := (create {P_CHARSET_STATIC}).vim_strsize (l_tmp___0)
						update_class_fields -- Current might have been changed; synchronize
				when 13 then
						if l_j > l_maxlen then
							l_maxlen := l_j
						end
						l_i___0 := l_i___0 + 1
						l_pos := -1 + 8 -- back to loop condition
				when 14 then -- loop done
						if xp_context = 17 then
							l_lines___0 := l_num_files.item
						else
							l_maxlen := l_maxlen + (2)
							l_columns := (((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32 + 2) // l_maxlen
							if l_columns < 1 then
								l_columns := 1
							end
							l_lines___0 := ((l_num_files.item + l_columns) - 1) // l_columns
						end
						l_attr := (create {P_GLOBALS_STATIC}).highlight_attr.item[2]
						if xp_context = 17 then
							l_tmp___1 := gettext (ce_string ("tagname"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1), (create {P_GLOBALS_STATIC}).highlight_attr.item[14])
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_clr_eos
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_advance (l_maxlen - 3)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := gettext (ce_string (" kind file%N"))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2), (create {P_GLOBALS_STATIC}).highlight_attr.item[14])
							update_class_fields -- Current might have been changed; synchronize
						end
						l_i___0 := 0
				when 15 then -- loop condition:
						if not (not (l_return or l_break) and then (l_i___0 < l_lines___0)) then
							l_pos := -1 + 32 -- skip loop
						end
				when 16 then -- loop body:
						l_break := False
						l_lastlen := 999
						l_k := l_i___0
				when 17 then -- loop condition:
						if not (not (l_return or l_break) and then (l_k < l_num_files.item)) then
							l_pos := -1 + 31 -- skip loop
						end
				when 18 then -- loop body:
						l_break := False
						if xp_context = 17 then
							(create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_files_found.item[l_k], (create {P_GLOBALS_STATIC}).highlight_attr.item[2]).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_files_found.item[l_k]))
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := (l_files_found.item[l_k] + l_tmp___3.to_integer_32) + 1;
							(create {P_MESSAGE_STATIC}).msg_advance (l_maxlen + 1)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_puts (l_p___0)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_advance (l_maxlen + 3)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_puts_long_attr (l_p___0 + 2, (create {P_GLOBALS_STATIC}).highlight_attr.item[2])
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 30 -- skip if block
						end
				when 19 then -- if:
						l_j := l_maxlen - l_lastlen
						from
						until
							(l_break)
						loop
							l_break := False
							l_j := l_j - 1
							if not (l_j >= 0) then
								l_break := True
							end
							if not (l_break) then
								(create {P_MESSAGE_STATIC}).msg_putchar ((' ').code)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_break := False
						if xp_context /= 2 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else:
						if xp_context /= 32 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 25 then -- else:
						if xp_context /= 9 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if: | _L___0:
						if xp_numfiles /= -1 then
							l_exp_path := (create {P_MISC1_STATIC}).expand_env_save_opt (l_files_found.item[l_k], 1)
							update_class_fields -- Current might have been changed; synchronize
							if not l_exp_path.is_void then
								l_tmp___4 := l_exp_path
							else
								l_tmp___4 := l_files_found.item[l_k]
							end
							l_halved_slash := (create {P_CHARSET_STATIC}).backslash_halve_save (l_tmp___4)
							update_class_fields -- Current might have been changed; synchronize
							if not l_halved_slash.is_void then
								l_tmp___5 := l_halved_slash
							else
								l_tmp___5 := l_files_found.item[l_k]
							end
							l_j := (create {P_OS_UNIX_STATIC}).mch_isdir (l_tmp___5)
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_exp_path))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_halved_slash))
							update_class_fields -- Current might have been changed; synchronize
						else
							l_j := (create {P_OS_UNIX_STATIC}).mch_isdir (l_files_found.item[l_k])
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_showtail.to_boolean then
							if l_showtail.to_boolean then
								l_tmp___6 := sm_gettail (l_files_found.item[l_k])
								update_class_fields -- Current might have been changed; synchronize
								l_p___0 := l_tmp___6
							else
								l_p___0 := l_files_found.item[l_k]
							end
						else
							(create {P_MISC1_STATIC}).home_replace (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer), l_files_found.item[l_k], (create {P_GLOBALS_STATIC}).NameBuff.item.item, 4_096, 1)
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := (create {P_GLOBALS_STATIC}).NameBuff.item.item
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_j := 0
						if l_showtail.to_boolean then
							l_tmp___7 := sm_gettail (l_files_found.item[l_k])
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := l_tmp___7
						else
							l_p___0 := l_files_found.item[l_k]
						end
				when 29 then -- if done | if done
						if l_j.to_boolean then
							l_tmp___8 := l_attr
						else
							l_tmp___8 := 0
						end
						l_lastlen := (create {P_MESSAGE_STATIC}).msg_outtrans_attr (l_p___0, l_tmp___8)
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + l_lines___0
				when 30 then -- if done
						l_pos := -1 + 17 -- back to loop condition
				when 31 then -- loop done
						l_break := False
						if (create {P_GLOBALS_STATIC}).msg_col.item > 0 then
							(create {P_MESSAGE_STATIC}).msg_clr_eos
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).msg_putchar (('%N').code)
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_TERM_STATIC}).out_flush
						update_class_fields -- Current might have been changed; synchronize
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							(create {P_GLOBALS_STATIC}).got_int.item := 0
							update_class_fields -- Current might have been changed; synchronize
							l_break := True
						end
						if not (l_return or l_break) then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 15 -- back to loop condition
				when 32 then -- loop done
						l_break := False;
						(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).msg_row.item
						update_class_fields -- Current might have been changed; synchronize
				when 33 then -- if done | if done
						if xp_numfiles = -1 then
							(create {P_MISC1_STATIC}).FreeWild (l_num_files.item, l_files_found.item)
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := (-1)
				when 34 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	expand_showtail: INTEGER_32
		local
			l_s: CE_POINTER [NATURAL_8]
			l_end: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if xp_context /= 2 then
				if xp_context /= 32 then
					if xp_context /= 3 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return then
				l_end := (create {P_MISC1_STATIC}).gettail (xp_pattern)
				update_class_fields -- Current might have been changed; synchronize
				if l_end.is_equal (xp_pattern) then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_s := xp_pattern
				from
				until
					not (not (l_return) and then ((l_s.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32))
				loop
					l_tmp___0 := (create {P_CHARSET_STATIC}).rem_backslash (l_s)
					update_class_fields -- Current might have been changed; synchronize
					if l_tmp___0.to_boolean then
						l_s := l_s + 1
					else
						l_tmp := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("*?[")), (l_s.item).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.is_void then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_s := l_s + 1
					end
				end
			end
			if not l_return then
				Result := 1
			end
		end

	expand_cmdline (a_str___1: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_matchcount: CE_POINTER [INTEGER_32]; a_matches___0: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_file_str: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			l_file_str := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if xp_context = -2 then
				(create {P_MISC1_STATIC}).beep_flush
				update_class_fields -- Current might have been changed; synchronize
				Result := (-2)
				l_return := True
			end
			if not l_return and then (xp_context = 0) then
				Result := 0
				l_return := True
			end
			if not l_return then
				Current.xp_pattern_len := (a_str___1 + a_col).distance (xp_pattern)
				update_class_fields -- Current might have been changed; synchronize
				l_file_str := (create {P_EX_GETLN_STATIC}).addstar (xp_pattern, xp_pattern_len, xp_context)
				update_class_fields -- Current might have been changed; synchronize
				if l_file_str.is_void then
					Result := (-2)
					l_return := True
				end
			end
			if not l_return then
				l_tmp := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandFromContext (l_file_str, a_matchcount, a_matches___0, 80)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					a_matchcount.item := 0
					update_class_fields -- Current might have been changed; synchronize
					a_matches___0.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_file_str))
				update_class_fields -- Current might have been changed; synchronize
				Result := (-1)
			end
		end

	ExpandFromContext (a_pat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_options___0: INTEGER_32): INTEGER_32
		local
			l_pat: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_regmatch___0: CE_ARRAY [PD_REGMATCH_T]
			l_ret: INTEGER_32
			l_flags___0: INTEGER_32
			l_free_pat: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_i___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_pat.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_REGMATCH_T]} l_regmatch___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_pat.item := a_pat
					update_class_fields -- Current might have been changed; synchronize
					l_flags___0 := 1
					if ((a_options___0).bit_and (1)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((4))
					end
					if ((a_options___0).bit_and (16)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((8))
					end
					if ((a_options___0).bit_and (32)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((16))
					end
					if ((a_options___0).bit_and (64)).to_boolean then
						l_flags___0 := (l_flags___0).bit_or ((32))
					end
					if xp_context /= 2 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if xp_context /= 3 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if xp_context /= 38 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						l_free_pat := 0
						if xp_backslash /= 0 then
							l_free_pat := 1
							l_pat.item := (create {P_MISC2_STATIC}).vim_strsave (l_pat.item)
							update_class_fields -- Current might have been changed; synchronize
							l_i___0 := 0
							from
							until
								not ((l_pat.item[l_i___0]).to_boolean)
							loop
								if (l_pat.item[l_i___0]).to_integer_32 = 92 then
									if xp_backslash = 2 then
										if (l_pat.item[(l_i___0 + 1)]).to_integer_32 = 92 then
											if (l_pat.item[(l_i___0 + 2)]).to_integer_32 = 92 then
												if (l_pat.item[(l_i___0 + 3)]).to_integer_32 = 32 then
													l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_pat.item + l_i___0) + 3)))
													update_class_fields -- Current might have been changed; synchronize
													memmove (create {CE_VOID_POINTER}.make_cast ((l_pat.item + l_i___0)), create {CE_VOID_POINTER}.make_cast (((l_pat.item + l_i___0) + 3)), l_tmp + {NATURAL_32} 1).do_nothing
													update_class_fields -- Current might have been changed; synchronize
												end
											end
										end
									end
									if xp_backslash = 1 then
										if (l_pat.item[(l_i___0 + 1)]).to_integer_32 = 32 then
											l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_pat.item + l_i___0) + 1)))
											update_class_fields -- Current might have been changed; synchronize
											memmove (create {CE_VOID_POINTER}.make_cast ((l_pat.item + l_i___0)), create {CE_VOID_POINTER}.make_cast (((l_pat.item + l_i___0) + 1)), l_tmp___0 + {NATURAL_32} 1).do_nothing
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
								l_i___0 := l_i___0 + 1
							end
						end
						if xp_context = 2 then
							l_flags___0 := (l_flags___0).bit_or ((2))
						elseif xp_context = 38 then
							l_flags___0 := (l_flags___0).bit_or ((130))
						else
							l_flags___0 := (((l_flags___0).bit_or (1))).bit_and (-3)
						end
						l_ret := expand_wildcards_eval (l_pat, a_num_file, a_file, l_flags___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_free_pat.to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat.item))
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := l_ret
						l_return := True
				when 8 then -- if done | if done
					if not l_return then
						a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						update_class_fields -- Current might have been changed; synchronize
						a_num_file.item := 0
						update_class_fields -- Current might have been changed; synchronize
						if xp_context = 8 then
							if (l_pat.item.item).to_integer_32 = 0 then
								l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("help"))
							else
								l_tmp___1 := l_pat.item
							end
							l_tmp___2 := (create {P_EX_CMDS_STATIC}).find_help_tags (l_tmp___1, a_num_file, a_file, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___2 = 1 then
								cleanup_help_tags (a_num_file.item, a_file.item)
								update_class_fields -- Current might have been changed; synchronize
								Result := 1
								l_return := True
							end
							if not l_return then
								Result := 0
								l_return := True
							end
						end
					end
					if not l_return and then (xp_context = 32) then
						l_tmp___3 := expand_shellcmd (l_pat.item, a_num_file, a_file, l_flags___0)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___3
						l_return := True
					end
					if not l_return and then (xp_context = 7) then
						l_tmp___4 := ExpandOldSetting (a_num_file, a_file)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___4
						l_return := True
					end
					if not l_return and then (xp_context = 9) then
						l_tmp___5 := ExpandBufnames (l_pat.item, a_num_file, a_file, a_options___0)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___5
						l_return := True
					end
					if not l_return then
						if xp_context = 6 then
							l_tmp___6 := expand_tags ((xp_context = 6).to_integer, l_pat.item, a_num_file, a_file)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___6
							l_return := True
						elseif xp_context = 17 then
							l_tmp___6 := expand_tags ((xp_context = 6).to_integer, l_pat.item, a_num_file, a_file)
							update_class_fields -- Current might have been changed; synchronize
							Result := l_tmp___6
							l_return := True
						end
					end
					if not l_return and then (xp_context = 28) then
						l_tmp___7 := ExpandRTDir (l_pat.item, a_num_file, a_file, ce_string ("colors"))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___7
						l_return := True
					end
					if not l_return and then (xp_context = 29) then
						l_tmp___8 := ExpandRTDir (l_pat.item, a_num_file, a_file, ce_string ("compiler"))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___8
						l_return := True
					end
					if not l_return and then (xp_context = 39) then
						l_tmp___9 := ExpandRTDir (l_pat.item, a_num_file, a_file, ce_string ("syntax"))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___9
						l_return := True
					end
					if not l_return and then (xp_context = 37) then
						l_tmp___10 := ExpandRTDir (l_pat.item, a_num_file, a_file, ce_string ("{syntax,indent,ftplugin}"))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___10
						l_return := True
					end
					if not l_return and then (xp_context = 31) then
						l_tmp___11 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandUserList (a_num_file, a_file)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___11
						l_return := True
					end
					if not l_return then
						if ((create {P_OPTION_STATIC}).p_magic.item.item).to_boolean then
							l_tmp___12 := 1
						else
							l_tmp___12 := 0
						end
						l_regmatch___0.item.regprog := (create {P_REGEXP_STATIC}).vim_regcomp (l_pat.item, l_tmp___12)
						update_class_fields -- Current might have been changed; synchronize
						if (l_regmatch___0.item.regprog).is_void then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_regmatch___0.item.rm_ic := (create {P_SEARCH_STATIC}).ignorecase (l_pat.item)
						update_class_fields -- Current might have been changed; synchronize
						if xp_context = 4 then
							l_ret := ExpandSettings ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), l_regmatch___0, a_num_file, a_file)
							update_class_fields -- Current might have been changed; synchronize
						elseif xp_context = 5 then
							l_ret := ExpandSettings ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), l_regmatch___0, a_num_file, a_file)
							update_class_fields -- Current might have been changed; synchronize
						elseif xp_context = 16 then
							l_ret := ExpandMappings (l_regmatch___0, a_num_file, a_file)
							update_class_fields -- Current might have been changed; synchronize
						elseif xp_context = 30 then
							l_ret := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.ExpandUserDefined (l_regmatch___0, a_num_file, a_file)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_ret := 0
							l_i___1 := 0
							from
							until
								not (not (l_break) and then (l_i___1 < (((create {PD_EXPGEN}.make).structure_size.to_natural_32 * (19).to_natural_32) // (create {PD_EXPGEN}.make).structure_size.to_natural_32).to_integer_32))
							loop
								l_break := False
								if xp_context = tab.item[l_i___1].context then
									if (tab.item[l_i___1].ic).to_boolean then
										l_regmatch___0.item.rm_ic := 1
										update_class_fields -- Current might have been changed; synchronize
									end
									l_ret := ExpandGeneric ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer)), l_regmatch___0, a_num_file, a_file, tab.item[l_i___1].func)
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
								if not (l_break) then
									l_i___1 := l_i___1 + 1
								end
							end
							l_break := False
						end
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_regmatch___0.item.regprog))
						update_class_fields -- Current might have been changed; synchronize
						Result := l_ret
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	call_user_expand_func (a_user_expand_func: CE_ROUTINE; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): CE_POINTER [ANY]
		local
			l_keep: NATURAL_8
			l_num: CE_ARRAY [NATURAL_8]
			l_args: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_save_current_SID: INTEGER_32
			l_ret: CE_POINTER [ANY]
			l_save_ccline: PD_CMDLINE_INFO
			l_tmp: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_num.make (<<50>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_args.make (<<3>>)

			l_save_current_SID := (create {P_GLOBALS_STATIC}).current_SID.item
			if xp_arg.is_void then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
				l_return := True
			elseif (xp_arg[0]).to_integer_32 = 0 then
				Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				a_num_file.item := 0
				update_class_fields -- Current might have been changed; synchronize
				a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				if ((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff).is_void then
					l_keep := (0).to_natural_8
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (xp_pattern))
					update_class_fields -- Current might have been changed; synchronize
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_num), ce_string ("%%d"), l_tmp.to_integer_32]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_args[1] := xp_pattern
					update_class_fields -- Current might have been changed; synchronize
				else
					l_keep := (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff[(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen];
					(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff[(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen] := (0).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_num), ce_string ("%%d"), (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_args[1] := (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff
					update_class_fields -- Current might have been changed; synchronize
				end
				l_args[0] := (create {P_MISC2_STATIC}).vim_strnsave (xp_pattern, xp_pattern_len)
				update_class_fields -- Current might have been changed; synchronize
				l_args[2] := l_num
				update_class_fields -- Current might have been changed; synchronize
				l_save_ccline := ((create {P_EX_GETLN_STATIC}).ccline.item.item).twin;
				(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdprompt := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).current_SID.item := xp_scriptID
				update_class_fields -- Current might have been changed; synchronize
				l_ret := create {CE_VOID_POINTER}.make_cast (a_user_expand_func.pointer_item ([xp_arg, 3, l_args, 0]))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_EX_GETLN_STATIC}).ccline.item.item := l_save_ccline.twin
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_GLOBALS_STATIC}).current_SID.item := l_save_current_SID
				update_class_fields -- Current might have been changed; synchronize
				if not ((create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff).is_void then
					(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff[(create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen] := l_keep
					update_class_fields -- Current might have been changed; synchronize
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_args[0]))
				update_class_fields -- Current might have been changed; synchronize
				Result := l_ret
			end
		end

	ExpandUserDefined (a_regmatch___0: CE_POINTER [PD_REGMATCH_T]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_retstr: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_keep: NATURAL_8
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			l_tmp := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.call_user_expand_func ((create {P_EVAL_STATIC}).call_func_retstr_address, a_num_file, a_file)
			update_class_fields -- Current might have been changed; synchronize
			l_retstr := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)
			if l_retstr.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_ga.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 3)
				update_class_fields -- Current might have been changed; synchronize
				l_s := l_retstr
				from
				until
					not (not (l_break) and then ((l_s.item).to_integer_32 /= 0))
				loop
					l_break := False
					l_continue := False
					l_e := (create {P_MISC2_STATIC}).vim_strchr (l_s, ('%N').code)
					update_class_fields -- Current might have been changed; synchronize
					if l_e.is_void then
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))
						update_class_fields -- Current might have been changed; synchronize
						l_e := l_s + l_tmp___0.to_integer_32
					end
					l_keep := l_e.item
					l_e.item := (0).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
					if (xp_pattern[0]).to_boolean then
						l_tmp___1 := a_regmatch___0.item.vim_regexec (l_s, 0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 = 0 then
							l_e.item := l_keep
							update_class_fields -- Current might have been changed; synchronize
							if (l_e.item).to_integer_32 /= 0 then
								l_e := l_e + 1
							end
							l_continue := True
						end
					end
					if not (l_break or l_continue) then
						l_tmp___2 := l_ga.item.ga_grow (1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 = 0 then
							l_break := True
						end
					end
					if not (l_break or l_continue) then
						create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)[l_ga.item.ga_len] := (create {P_MISC2_STATIC}).vim_strnsave (l_s, l_e.distance (l_s))
						update_class_fields -- Current might have been changed; synchronize
						l_ga.item.ga_len := (l_ga.item.ga_len) + 1
						update_class_fields -- Current might have been changed; synchronize
						l_e.item := l_keep
						update_class_fields -- Current might have been changed; synchronize
						if (l_e.item).to_integer_32 /= 0 then
							l_e := l_e + 1
						end
					end
					if (not l_break) then
						l_s := l_e
					end
				end
				l_break := False
				l_continue := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_retstr))
				update_class_fields -- Current might have been changed; synchronize
				a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)
				update_class_fields -- Current might have been changed; synchronize
				a_num_file.item := l_ga.item.ga_len
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	ExpandUserList (a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		local
			l_retlist: CE_POINTER [PD_LISTVAR_S]
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_tmp: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			l_tmp := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.call_user_expand_func ((create {P_EVAL_STATIC}).call_func_retlist_address, a_num_file, a_file)
			update_class_fields -- Current might have been changed; synchronize
			l_retlist := create {CE_CLASS_POINTER [PD_LISTVAR_S]}.make_cast (l_tmp)
			if l_retlist.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_ga.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 3)
				update_class_fields -- Current might have been changed; synchronize
				l_li := l_retlist.item.lv_first
				from
				until
					not (not (l_break) and then (not l_li.is_void))
				loop
					l_break := False
					l_continue := False
					if (l_li.item.li_tv.v_type).to_integer_32 /= 2 then
						l_continue := True
					elseif (l_li.item.li_tv.vval.v_string).is_void then
						l_continue := True
					end
					if not (l_break or l_continue) then
						l_tmp___0 := l_ga.item.ga_grow (1)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 = 0 then
							l_break := True
						end
					end
					if not (l_break or l_continue) then
						create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)[l_ga.item.ga_len] := (create {P_MISC2_STATIC}).vim_strsave (l_li.item.li_tv.vval.v_string)
						update_class_fields -- Current might have been changed; synchronize
						l_ga.item.ga_len := (l_ga.item.ga_len) + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					if (not l_break) then
						l_li := l_li.item.li_next
					end
				end
				l_break := False
				l_continue := False;
				(create {P_EVAL_STATIC}).list_unref (l_retlist)
				update_class_fields -- Current might have been changed; synchronize
				a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)
				update_class_fields -- Current might have been changed; synchronize
				a_num_file.item := l_ga.item.ga_len
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	set_context_in_map_cmd (a_cmd, a_arg: CE_POINTER [NATURAL_8]; a_forceit, a_isabbrev, a_isunmap, a_cmdidx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_cmd: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_arg: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_cmd.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmd.item := a_cmd
					update_class_fields -- Current might have been changed; synchronize
					l_arg := a_arg
					if not (a_forceit.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_cmdidx /= 250 then
							if a_cmdidx /= 457 then
								Current.xp_context := 0
								update_class_fields -- Current might have been changed; synchronize
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						if a_isunmap.to_boolean then
							if a_forceit.to_boolean then
								l_tmp := 1
							elseif a_isabbrev.to_boolean then
								l_tmp := 1
							else
								l_tmp := 0
							end
							expand_mapmodes.item := (create {P_GETCHAR_STATIC}).get_map_mode (l_cmd, l_tmp)
							update_class_fields -- Current might have been changed; synchronize
						else
							expand_mapmodes.item := 24
							if not a_isabbrev.to_boolean then
								expand_mapmodes.item := expand_mapmodes.item + (4_103)
							end
						end
						expand_isabbrev.item := a_isabbrev
						Current.xp_context := 16
						update_class_fields -- Current might have been changed; synchronize
						expand_buffer.item := 0
						from
						until
							(l_break)
						loop
							l_break := False
							l_continue := False
							l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("<buffer>"), (8).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0 = 0 then
								expand_buffer.item := 1
								l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg + 8)
								update_class_fields -- Current might have been changed; synchronize
								l_continue := True
							end
							if not (l_break or l_continue) then
								l_tmp___1 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("<unique>"), (8).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___1 = 0 then
									l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg + 8)
									update_class_fields -- Current might have been changed; synchronize
									l_continue := True
								end
							end
							if not (l_break or l_continue) then
								l_tmp___2 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("<silent>"), (8).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___2 = 0 then
									l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg + 8)
									update_class_fields -- Current might have been changed; synchronize
									l_continue := True
								end
							end
							if not (l_break or l_continue) then
								l_tmp___3 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("<script>"), (8).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___3 = 0 then
									l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg + 8)
									update_class_fields -- Current might have been changed; synchronize
									l_continue := True
								end
							end
							if not (l_break or l_continue) then
								l_tmp___4 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("<expr>"), (6).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___4 = 0 then
									l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_arg + 6)
									update_class_fields -- Current might have been changed; synchronize
									l_continue := True
								end
							end
							if not (l_break or l_continue) then
								l_break := True
							end
							if (not l_break) then
								
							end
						end
						l_break := False
						l_continue := False
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
				when 4 then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_context_in_menu_cmd (a_cmd, a_arg: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32): CE_POINTER [NATURAL_8]
		require
			not a_cmd.is_void
			not a_arg.is_void
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_after_dot: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_path_name: CE_POINTER [NATURAL_8]
			l_name___1: CE_POINTER [NATURAL_8]
			l_unmenu: CE_ARRAY [INTEGER_32]
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_expand_menus: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_unmenu.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg := a_arg
					l_path_name := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					Current.xp_context := -2
					update_class_fields -- Current might have been changed; synchronize
					l_p___0 := l_arg
				when 1 then -- loop condition:
					if not (not (l_break) and then ((l_p___0.item).to_boolean)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not ((l_p___0.item).to_integer_32 >= 48) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not ((l_p___0.item).to_integer_32 <= 57) then
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (l_p___0.item).to_integer_32 /= 46 then
							l_break := True
						end
				when 6 then
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_break := False
					if ((l_p___0.item).to_integer_32 = 32) then
						l_pos := -1 + 13 -- skip if block
					end
				when 8 then -- if:
						if ((l_p___0.item).to_integer_32 = 9) then
							l_pos := -1 + 13 -- skip if block
						end
				when 9 then -- if:
						l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("enable"), (6).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_arg[6]).to_integer_32 = 0 then
							l_p___0 := l_arg + 6
						elseif (l_arg[6]).to_integer_32 = 32 then
							l_p___0 := l_arg + 6
						elseif (l_arg[6]).to_integer_32 = 9 then
							l_p___0 := l_arg + 6
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_tmp := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_arg), ce_string ("disable"), (7).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							if (l_arg[7]).to_integer_32 = 0 then
								l_p___0 := l_arg + 7
							elseif (l_arg[7]).to_integer_32 = 32 then
								l_p___0 := l_arg + 7
							elseif (l_arg[7]).to_integer_32 = 9 then
								l_p___0 := l_arg + 7
							else
								l_p___0 := l_arg
							end
						else
							l_p___0 := l_arg
						end
				when 13 then -- if done | if done
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item).to_integer_32 /= 0 then
							if (l_p___0.item).to_integer_32 /= 32 then
								if (l_p___0.item).to_integer_32 /= 9 then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
					end
					l_break := False
					l_after_dot := l_p___0
					l_arg := l_after_dot
				when 14 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 25 -- skip loop
					end
				when 15 then -- loop body:
						l_break := False
						if (l_p___0.item).to_boolean then
							if (l_p___0.item).to_integer_32 = 32 then
								l_break := True
							elseif (l_p___0.item).to_integer_32 = 9 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___2
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else:
						if (l_p___0.item).to_integer_32 /= 22 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L___2:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						else
							l_pos := -1 + 22 -- goto _L___1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else: | _L___1:
						if (l_p___0.item).to_integer_32 = 46 then
							l_after_dot := l_p___0 + 1
						end
				when 23 then -- if done
						l_p___0 := l_p___0 + 1
				when 24 then -- if done
						l_pos := -1 + 14 -- back to loop condition
				when 25 then -- loop done
					l_break := False
					if (a_cmd.item).to_integer_32 /= 116 then
						l_pos := -1 + 28 -- skip if block
					end
				when 26 then -- if:
						if (a_cmd[1]).to_integer_32 = 101 then
							l_tmp___1 := 0
						else
							l_pos := -1 + 28 -- goto _L___3
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else: | _L___3:
						if (a_cmd.item).to_integer_32 = 112 then
							l_tmp___1 := 0
						else
							l_tmp___1 := 1
						end
				when 29 then
					l_expand_menus := l_tmp___1;
					(create {P_MENU_STATIC}).expand_emenu.item := ((a_cmd.item).to_integer_32 = 101).to_integer
					update_class_fields -- Current might have been changed; synchronize
					if l_expand_menus.to_boolean then
						if (l_p___0.item).to_integer_32 = 32 then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						elseif (l_p___0.item).to_integer_32 = 9 then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 49 -- skip if block
					end
				when 30 then -- if:
						if (l_p___0.item).to_integer_32 /= 0 then
							l_pos := -1 + 48 -- skip if block
						end
				when 31 then -- if:;
						(create {P_MENU_STATIC}).expand_modes.item := (create {P_MENU_STATIC}).get_menu_cmd_modes (a_cmd, a_forceit, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_unmenu)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_unmenu.item).to_boolean then
							(create {P_MENU_STATIC}).expand_modes.item := ((1).bit_shift_left (6)) - 1
							update_class_fields -- Current might have been changed; synchronize
						end
						l_menu___1 := (create {P_GLOBALS_STATIC}).root_menu.item.item
						if not l_after_dot.is_equal (l_arg) then
							l_path_name := (create {P_MISC2_STATIC}).alloc ((l_after_dot.distance (l_arg)).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_path_name.is_void then
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
							if not l_return then
								(create {P_MISC2_STATIC}).vim_strncpy (l_path_name, l_arg, ((l_after_dot.distance (l_arg)) - 1).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if l_return then
							l_pos := -1 + 46 -- skip if block
						end
				when 32 then -- if:
						l_name___1 := l_path_name
				when 33 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 46 -- skip loop
						end
				when 34 then -- loop body:
						l_break := False
						if not l_name___1.is_void then
							if not (l_name___1.item).to_boolean then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 45 -- skip if block
						end
				when 35 then -- if:
						l_p___0 := (create {P_MENU_STATIC}).menu_name_skip (l_name___1)
						update_class_fields -- Current might have been changed; synchronize
				when 36 then -- loop condition:
						if not (not (l_return or l_break) and then (not l_menu___1.is_void)) then
							l_pos := -1 + 44 -- skip loop
						end
				when 37 then -- loop body:
						l_break := False
						l_tmp___2 := l_menu___1.item.menu_name_equal (l_name___1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___2.to_boolean) then
							l_pos := -1 + 43 -- skip if block
						end
				when 38 then -- if:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if (l_menu___1.item.children).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_path_name))
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						else
							l_pos := -1 + 41 -- goto _L___4
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else: | _L___4:
						if ((l_menu___1.item.modes).bit_and ((create {P_MENU_STATIC}).expand_modes.item)) = 0 then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_path_name))
							update_class_fields -- Current might have been changed; synchronize
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 42 then
						if not l_return then
							l_break := True
						end
				when 43 then -- if done
						if not (l_return or l_break) then
							l_menu___1 := l_menu___1.item.next
						end
						l_pos := -1 + 36 -- back to loop condition
				when 44 then -- loop done
						if not l_return then
							l_break := False
							if l_menu___1.is_void then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_path_name))
								update_class_fields -- Current might have been changed; synchronize
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
						end
						if not l_return then
							l_name___1 := l_p___0
							l_menu___1 := l_menu___1.item.children
						end
				when 45 then -- if done
						l_pos := -1 + 33 -- back to loop condition
				when 46 then -- loop done | if done
						if not l_return then
							l_break := False;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_path_name))
							update_class_fields -- Current might have been changed; synchronize
							if l_expand_menus.to_boolean then
								Current.xp_context := 21
								update_class_fields -- Current might have been changed; synchronize
							else
								Current.xp_context := 11
								update_class_fields -- Current might have been changed; synchronize
							end
							Current.xp_pattern := l_after_dot
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MENU_STATIC}).expand_menu.item := l_menu___1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
				when 49 then -- if done | if done
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 50 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_context_in_set_cmd (a_arg: CE_POINTER [NATURAL_8]; a_opt_flags: INTEGER_32)
		require
			not a_arg.is_void
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_nextchar: INTEGER_32
			l_flags___0: NATURAL_32
			l_opt_idx: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_is_term_option: INTEGER_32
			l_key: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___5: NATURAL_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg := a_arg
					l_flags___0 := (0).to_natural_32
					l_opt_idx := 0
					l_is_term_option := 0
					expand_option_flags.item := a_opt_flags
					Current.xp_context := 4
					update_class_fields -- Current might have been changed; synchronize
					if (l_arg.item).to_integer_32 = 0 then
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						l_return := True
					end
					if not l_return then
						l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_arg))
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := (l_arg + l_tmp.to_integer_32) - 1
						if (l_p___0.item).to_integer_32 = 32 then
							if (l_p___0[-1]).to_integer_32 /= 92 then
								Current.xp_pattern := l_p___0 + 1
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 21 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not (not (l_return or l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_arg.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 8 -- skip loop
						end
				when 2 then -- loop body:
						l_break := False
						l_s := l_p___0
						if (l_p___0.item).to_integer_32 /= 32 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if (l_p___0.item).to_integer_32 /= 44 then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.c_pointer.to_integer_32).to_natural_32 > (l_arg.c_pointer.to_integer_32).to_natural_32 then
								if (l_s[-1]).to_integer_32 /= 92 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_s := l_s - 1
							end
						end
						l_break := False
				when 7 then -- if done
						if (l_p___0.item).to_integer_32 = 32 then
							if (((l_p___0.distance (l_s))).bit_and (1)) = 0 then
								l_p___0 := l_p___0 + 1
								l_break := True
							end
						end
						if not (l_return or l_break) then
							l_p___0 := l_p___0 - 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
						l_break := False
						l_tmp___0 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("no"), (2).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 = 0 then
							l_tmp___1 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("novice"), (6).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___1 /= 0 then
								Current.xp_context := 5
								update_class_fields -- Current might have been changed; synchronize
								l_p___0 := l_p___0 + (2)
							end
						end
						l_tmp___2 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("inv"), (3).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 = 0 then
							Current.xp_context := 5
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := l_p___0 + (3)
						end
						l_arg := l_p___0
						Current.xp_pattern := l_arg
						update_class_fields -- Current might have been changed; synchronize
						if (l_arg.item).to_integer_32 /= 60 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						from
						until
							not (not (l_return) and then ((l_p___0.item).to_integer_32 /= 62))
						loop
							l_tmp___3 := l_p___0
							l_p___0 := l_p___0 + 1
							if (l_tmp___3.item).to_integer_32 = 0 then
								l_return := True
							end
						end
						if not l_return then
							l_key := (create {P_MISC2_STATIC}).get_special_key_code (l_arg + 1)
							update_class_fields -- Current might have been changed; synchronize
							if l_key = 0 then
								Current.xp_context := 0
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
						if not l_return then
							l_p___0 := l_p___0 + 1
							l_nextchar := (l_p___0.item).to_integer_32
							l_is_term_option := 1
							expand_option_name.item[2] := ((-l_key).bit_and (255)).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							expand_option_name.item[3] := (((((-l_key).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 11 then -- else:
						if (l_p___0[0]).to_integer_32 /= 116 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (l_p___0[1]).to_integer_32 = 95 then
							l_p___0 := l_p___0 + (2)
							if (l_p___0.item).to_integer_32 /= 0 then
								l_p___0 := l_p___0 + 1
							end
							if (l_p___0.item).to_integer_32 = 0 then
								l_return := True
							end
							if not l_return then
								l_p___0 := l_p___0 + 1
								l_nextchar := (l_p___0.item).to_integer_32
								l_is_term_option := 1
								expand_option_name.item[2] := l_p___0[-2]
								update_class_fields -- Current might have been changed; synchronize
								expand_option_name.item[3] := l_p___0[-1]
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 14 -- goto _L___1
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 14 then -- else: | _L___1:
						if (l_break) then
							l_pos := -1 + 20 -- skip loop
						end
				when 15 then -- loop body:
						l_break := False
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_tmp___4 := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if not (((l_tmp___4.item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (8)).to_boolean then
							l_pos := -1 + 18 -- goto _L___0
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 /= 95 then
							if (l_p___0.item).to_integer_32 /= 42 then
								l_break := True
							end
						end
				when 19 then
						if not (l_return or l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 14 -- back to loop condition
				when 20 then -- loop done
						l_break := False
						if (l_p___0.item).to_integer_32 = 0 then
							l_return := True
						end
						if not l_return then
							l_nextchar := (l_p___0.item).to_integer_32
							l_p___0.item := (('%/0/').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							l_opt_idx := (create {P_OPTION_STATIC}).findoption (l_arg)
							update_class_fields -- Current might have been changed; synchronize
							l_p___0.item := l_nextchar.to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							if l_opt_idx = -1 then
								Current.xp_context := 0
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							elseif ((create {P_OPTION_STATIC}).options.item[l_opt_idx].var).is_void then
								Current.xp_context := 0
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
						if not l_return then
							l_flags___0 := (create {P_OPTION_STATIC}).options.item[l_opt_idx].flags
							if ((l_flags___0).bit_and ({NATURAL_32} 1)).to_boolean then
								Current.xp_context := 0
								update_class_fields -- Current might have been changed; synchronize
								l_return := True
							end
						end
				when 21 then -- if done | if done
					if l_return then
						l_pos := -1 + 34 -- skip if block
					end
				when 22 then -- if:
						if l_nextchar /= 45 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 29 -- goto _L___2
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 25 then -- else:
						if l_nextchar /= 43 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L___2
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 30
				when 28 then -- else:
						if l_nextchar /= 94 then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | _L___2:
						if (l_p___0[1]).to_integer_32 = 61 then
							l_p___0 := l_p___0 + 1
							l_nextchar := ('=').code
						end
				when 30 then -- if done | if done
						if l_nextchar = 61 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if l_nextchar /= 58 then
							Current.xp_context := -2
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						else
							l_pos := -1 + 33 -- goto _L___3
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else: | _L___3:
						if xp_context = 5 then
							Current.xp_context := -2
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
				when 34 then -- if done
					if not l_return and then (xp_context /= 5) then
						if (l_p___0[1]).to_integer_32 = 0 then
							Current.xp_context := 7
							update_class_fields -- Current might have been changed; synchronize
							if l_is_term_option.to_boolean then
								expand_option_idx.item := -1
							else
								expand_option_idx.item := l_opt_idx
							end
							Current.xp_pattern := l_p___0 + 1
							update_class_fields -- Current might have been changed; synchronize
							l_return := True
						end
					end
					if not l_return then
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
						if l_is_term_option.to_boolean then
							l_return := True
						elseif ((l_flags___0).bit_and ({NATURAL_32} 2)).to_boolean then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 67 -- skip if block
					end
				when 35 then -- if:
						Current.xp_pattern := l_p___0 + 1
						update_class_fields -- Current might have been changed; synchronize
						if not (((l_flags___0).bit_and ({NATURAL_32} 16)).to_boolean) then
							l_pos := -1 + 55 -- skip if block
						end
				when 36 then -- if:
						l_p___0 := (create {P_OPTION_STATIC}).options.item[l_opt_idx].var
						if not (l_p___0.is_equal ((create {P_OPTION_STATIC}).p_bdir.item)) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						l_pos := -1 + 52 -- goto _L___4
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 39 then -- else:
						if not (l_p___0.is_equal ((create {P_OPTION_STATIC}).p_dir.item)) then
							l_pos := -1 + 42 -- skip if block
						end
				when 40 then -- if:
						l_pos := -1 + 52 -- goto _L___4
				when 41 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 42 then -- else:
						if not (l_p___0.is_equal ((create {P_OPTION_STATIC}).p_path.item)) then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						l_pos := -1 + 52 -- goto _L___4
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 45 then -- else:
						if not (l_p___0.is_equal ((create {P_OPTION_STATIC}).p_rtp.item)) then
							l_pos := -1 + 48 -- skip if block
						end
				when 46 then -- if:
						l_pos := -1 + 52 -- goto _L___4
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 48 then -- else:
						if not (l_p___0.is_equal ((create {P_OPTION_STATIC}).p_cdpath.item)) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						l_pos := -1 + 52 -- goto _L___4
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 51 then -- else:
						if not (l_p___0.is_equal ((create {P_OPTION_STATIC}).p_vdir.item)) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if: | _L___4:
						Current.xp_context := 3
						update_class_fields -- Current might have been changed; synchronize
						if l_p___0.is_equal ((create {P_OPTION_STATIC}).p_path.item) then
							Current.xp_backslash := 2
							update_class_fields -- Current might have been changed; synchronize
						elseif l_p___0.is_equal ((create {P_OPTION_STATIC}).p_cdpath.item) then
							Current.xp_backslash := 2
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.xp_backslash := 1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 55
				when 54 then -- else:
						Current.xp_context := 2
						update_class_fields -- Current might have been changed; synchronize
						if l_p___0.is_equal ((create {P_OPTION_STATIC}).p_tags.item) then
							Current.xp_backslash := 2
							update_class_fields -- Current might have been changed; synchronize
						else
							Current.xp_backslash := 1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 55 then -- if done | if done | if done | if done | if done | if done
						l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_arg))
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := (l_arg + l_tmp___5.to_integer_32) - 1
				when 56 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 > (xp_pattern.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 66 -- skip loop
						end
				when 57 then -- loop body:
						l_break := False
						if (l_p___0.item).to_integer_32 /= 32 then
							l_pos := -1 + 60 -- skip if block
						end
				when 58 then -- if:
						l_pos := -1 + 61 -- goto _L___6
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 60 then -- else:
						if (l_p___0.item).to_integer_32 /= 44 then
							l_pos := -1 + 65 -- skip if block
						end
				when 61 then -- if: | _L___6:
						l_s := l_p___0
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_s.c_pointer.to_integer_32).to_natural_32 > (xp_pattern.c_pointer.to_integer_32).to_natural_32 then
								if (l_s[-1]).to_integer_32 /= 92 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_s := l_s - 1
							end
						end
						l_break := False
						if (l_p___0.item).to_integer_32 /= 32 then
							l_pos := -1 + 64 -- skip if block
						end
				when 62 then -- if:
						if xp_backslash = 2 then
							if l_p___0.distance (l_s) < 3 then
								Current.xp_pattern := l_p___0 + 1
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							else
								l_pos := -1 + 64 -- goto _L___5
							end
						else
							l_pos := -1 + 64 -- goto _L___5
						end
				when 63 then -- if block done, skip else block:
						l_pos := -1 + 65
				when 64 then -- else: | _L___5:
						if (l_p___0.item).to_integer_32 = 44 then
							if ((l_flags___0).bit_and ({NATURAL_32} 32_768)).to_boolean then
								if (((l_p___0.distance (l_s))).bit_and (1)) = 0 then
									Current.xp_pattern := l_p___0 + 1
									update_class_fields -- Current might have been changed; synchronize
									l_break := True
								end
							end
						end
				when 65 then -- if done | if done
						if not (l_return or l_break) and then (((create {P_OPTION_STATIC}).options.item[l_opt_idx].var).is_equal ((create {P_OPTION_STATIC}).p_sps.item)) then
							l_tmp___6 := strncmp (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), ce_string ("file:"), (5).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___6 = 0 then
								Current.xp_pattern := l_p___0 + 5
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
						end
						if not (l_return or l_break) then
							l_p___0 := l_p___0 - 1
						end
						l_pos := -1 + 56 -- back to loop condition
				when 66 then -- loop done
						l_break := False
				when 67 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	status_match_len (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_emenu: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return: BOOLEAN
		do
			l_s := a_s
			l_len := 0
			if xp_context = 11 then
				l_tmp := 1
			elseif xp_context = 21 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			l_emenu := l_tmp
			if l_emenu.to_boolean then
				l_tmp___0 := (create {P_MENU_STATIC}).menu_is_separator (l_s)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp___0.to_boolean then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_s.item).to_integer_32 = 0
				loop
					l_tmp___1 := ((create {CE_CLASS_POINTER [PD_EXPAND]}.make_shared (c_pointer))).item.skip_status_match_char (l_s)
					update_class_fields -- Current might have been changed; synchronize
					l_s := l_s + l_tmp___1
					l_tmp___2 := (create {P_CHARSET_STATIC}).ptr2cells (l_s)
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_len + l_tmp___2
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___3 := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___4 := l_tmp___3
					else
						l_tmp___4 := 1
					end
					l_s := l_s + l_tmp___4
				end
				Result := l_len
			end
		end

	skip_status_match_char (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_s.is_void
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp___0 := (create {P_CHARSET_STATIC}).rem_backslash (a_s)
					update_class_fields -- Current might have been changed; synchronize
					if not (l_tmp___0.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if xp_context /= 8 then
							l_pos := -1 + 12 -- goto _L___0
						else
							l_pos := -1 + 3 -- goto _L___2
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else: | _L___2:
						if xp_context /= 11 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___1
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if xp_context /= 21 then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if: | _L___1:
						if (a_s[0]).to_integer_32 /= 9 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 12 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 10 then -- else:
						if (a_s[0]).to_integer_32 /= 92 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if (a_s[1]).to_integer_32 = 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 12 then -- if: | _L___0:
						if xp_shell.to_boolean then
							l_tmp := (create {P_MISC2_STATIC}).csh_like_shell
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp.to_boolean then
								if (a_s[1]).to_integer_32 = 92 then
									if (a_s[2]).to_integer_32 = 33 then
										Result := 2
										l_return := True
									end
								end
							end
						end
						if not l_return then
							Result := 1
							l_return := True
						end
				when 13 then -- if done | if done | if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_context_in_echohl_cmd (a_arg: CE_POINTER [NATURAL_8])
		do
			Current.xp_context := 13
			update_class_fields -- Current might have been changed; synchronize
			Current.xp_pattern := a_arg
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SYNTAX_STATIC}).include_none.item := 1
			update_class_fields -- Current might have been changed; synchronize
		end

	set_context_in_syntax_cmd (a_arg: CE_POINTER [NATURAL_8])
		require
			not a_arg.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
		do
			Current.xp_context := 12
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SYNTAX_STATIC}).expand_what___0.item := {PC_EXPAND_WHAT_544__}.EXP_SUBCMD___0
			update_class_fields -- Current might have been changed; synchronize
			Current.xp_pattern := a_arg
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SYNTAX_STATIC}).include_link.item := 0
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_SYNTAX_STATIC}).include_default.item := 0
			update_class_fields -- Current might have been changed; synchronize
			if (a_arg.item).to_integer_32 /= 0 then
				l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (a_arg)
				update_class_fields -- Current might have been changed; synchronize
				if (l_p___0.item).to_integer_32 /= 0 then
					Current.xp_pattern := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___4 := (create {P_CHARSET_STATIC}).skiptowhite (xp_pattern)
					update_class_fields -- Current might have been changed; synchronize
					if (l_tmp___4.item).to_integer_32 /= 0 then
						Current.xp_context := 0
						update_class_fields -- Current might have been changed; synchronize
					else
						l_tmp___3 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_arg), ce_string ("case"), (l_p___0.distance (a_arg)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___3 = 0 then
							(create {P_SYNTAX_STATIC}).expand_what___0.item := {PC_EXPAND_WHAT_544__}.EXP_CASE
							update_class_fields -- Current might have been changed; synchronize
						else
							l_tmp := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_arg), ce_string ("keyword"), (l_p___0.distance (a_arg)).to_natural_32)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp = 0 then
								Current.xp_context := 13
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp___0 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_arg), ce_string ("region"), (l_p___0.distance (a_arg)).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___0 = 0 then
									Current.xp_context := 13
									update_class_fields -- Current might have been changed; synchronize
								else
									l_tmp___1 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_arg), ce_string ("match"), (l_p___0.distance (a_arg)).to_natural_32)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___1 = 0 then
										Current.xp_context := 13
										update_class_fields -- Current might have been changed; synchronize
									else
										l_tmp___2 := strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast (a_arg), ce_string ("list"), (l_p___0.distance (a_arg)).to_natural_32)
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___2 = 0 then
											Current.xp_context := 13
											update_class_fields -- Current might have been changed; synchronize
										else
											Current.xp_context := 0
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
						end
					end
				end
			end
		end

	set_context_in_highlight_cmd (a_arg: CE_POINTER [NATURAL_8])
		require
			not a_arg.is_void
		local
			l_arg: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg := a_arg
					Current.xp_context := 13
					update_class_fields -- Current might have been changed; synchronize
					Current.xp_pattern := l_arg
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SYNTAX_STATIC}).include_link.item := 2
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_SYNTAX_STATIC}).include_default.item := 1
					update_class_fields -- Current might have been changed; synchronize
					if (l_arg.item).to_integer_32 = 0 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (l_arg)
						update_class_fields -- Current might have been changed; synchronize
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if:;
						(create {P_SYNTAX_STATIC}).include_default.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := strncmp (ce_string ("default"), create {CE_INTEGER_8_POINTER}.make_cast (l_arg), (l_p___0.distance (l_arg)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp = 0 then
							l_arg := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
							update_class_fields -- Current might have been changed; synchronize
							Current.xp_pattern := l_arg
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (l_arg)
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:;
						(create {P_SYNTAX_STATIC}).include_link.item := 0
						update_class_fields -- Current might have been changed; synchronize
						if (l_arg[1]).to_integer_32 = 105 then
							if (l_arg[0]).to_integer_32 = 78 then
								highlight_list
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_tmp___0 := strncmp (ce_string ("link"), create {CE_INTEGER_8_POINTER}.make_cast (l_arg), (l_p___0.distance (l_arg)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0 /= 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						l_tmp___1 := strncmp (ce_string ("clear"), create {CE_INTEGER_8_POINTER}.make_cast (l_arg), (l_p___0.distance (l_arg)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						Current.xp_pattern := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
						update_class_fields -- Current might have been changed; synchronize
						l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (xp_pattern)
						update_class_fields -- Current might have been changed; synchronize
						if (l_p___0.item).to_integer_32 /= 0 then
							Current.xp_pattern := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
							update_class_fields -- Current might have been changed; synchronize
							l_p___0 := (create {P_CHARSET_STATIC}).skiptowhite (xp_pattern)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 8 then -- if done
						if (l_p___0.item).to_integer_32 /= 0 then
							Current.xp_context := 0
							update_class_fields -- Current might have been changed; synchronize
						end
				when 9 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_EXPAND} -- private routines

	set_expand_context (a_xp: CE_POINTER [PD_EXPAND])
		local
			l_return: BOOLEAN
		do
			if (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdfirstc /= 58 then
				if (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdfirstc /= 62 then
					if (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdfirstc /= 61 then
						if not ((create {P_EX_GETLN_STATIC}).ccline.item.item.input_fn).to_boolean then
							a_xp.item.xp_context := 0
							l_return := True
						end
					end
				end
			end
			if not l_return then
				(create {P_EX_GETLN_STATIC}).set_cmd_context (a_xp, (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdbuff, (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdlen, (create {P_EX_GETLN_STATIC}).ccline.item.item.cmdpos)
			end
		end

	win_redr_status_matches (a_xp: CE_POINTER [PD_EXPAND]; a_num_matches___0: INTEGER_32; a_matches___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_match, a_showtail: INTEGER_32)
		local
			l_match: INTEGER_32
			l_row: INTEGER_32
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_clen: INTEGER_32
			l_fillchar: INTEGER_32
			l_attr: CE_ARRAY [INTEGER_32]
			l_i___0: INTEGER_32
			l_highlight: INTEGER_32
			l_selstart: CE_POINTER [NATURAL_8]
			l_selstart_col: INTEGER_32
			l_selend: CE_POINTER [NATURAL_8]
			l_add_left: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_emenu: INTEGER_32
			l_l: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___12: INTEGER_32
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: NATURAL_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___23: CE_POINTER [NATURAL_8]
			l_tmp___25: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_attr.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_match := a_match
					l_highlight := 1
					l_selstart := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_selstart_col := 0
					l_selend := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_add_left := 0
					if a_matches___0.is_void then
						l_return := True
					end
					if not l_return then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							l_buf___6 := (create {P_MISC2_STATIC}).alloc (((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 * {NATURAL_32} 21 + {NATURAL_32} 1)
						else
							l_buf___6 := (create {P_MISC2_STATIC}).alloc (((create {P_GLOBALS_STATIC}).Columns.item.item).to_natural_32 + {NATURAL_32} 1)
						end
						if l_buf___6.is_void then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if l_match = -1 then
							l_match := 0
							l_highlight := 0
						end
						if a_showtail.to_boolean then
							l_tmp___0 := (sm_gettail (a_matches___0[l_match]))
						else
							l_tmp___0 := a_matches___0[l_match]
						end
						l_clen := (a_xp.item.status_match_len (l_tmp___0)) + 3
						if l_match = 0 then
							first_match.item := 0
						elseif l_match < first_match.item then
							first_match.item := l_match
							l_add_left := 1
						else
							l_i___0 := first_match.item
							from
							until
								not (l_i___0 < l_match)
							loop
								if a_showtail.to_boolean then
									l_tmp___3 := (sm_gettail (a_matches___0[l_i___0]))
								else
									l_tmp___3 := a_matches___0[l_i___0]
								end
								l_clen := l_clen + ((a_xp.item.status_match_len (l_tmp___3)) + 2)
								l_i___0 := l_i___0 + 1
							end
							if first_match.item > 0 then
								l_clen := l_clen + (2)
							end
							if l_clen.to_integer_32 > (create {P_GLOBALS_STATIC}).Columns.item.item then
								first_match.item := l_match
								l_clen := 2
								l_i___0 := l_match
								from
								until
									not (not (l_break) and then (l_i___0 < a_num_matches___0))
								loop
									l_break := False
									if a_showtail.to_boolean then
										l_tmp___6 := (sm_gettail (a_matches___0[l_i___0]))
									else
										l_tmp___6 := a_matches___0[l_i___0]
									end
									l_clen := l_clen + ((a_xp.item.status_match_len (l_tmp___6)) + 2)
									if l_clen.to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
										l_break := True
									end
									if not (l_break) then
										l_i___0 := l_i___0 + 1
									end
								end
								l_break := False
								if l_i___0 = a_num_matches___0 then
									l_add_left := 1
								end
							end
						end
						if l_add_left.to_boolean then
							from
							until
								not (not (l_break) and then (first_match.item > 0))
							loop
								l_break := False
								if a_showtail.to_boolean then
									l_tmp___9 := (sm_gettail (a_matches___0[(first_match.item - 1)]))
								else
									l_tmp___9 := a_matches___0[(first_match.item - 1)]
								end
								l_clen := l_clen + ((a_xp.item.status_match_len (l_tmp___9)) + 2)
								if l_clen.to_integer_32 >= (create {P_GLOBALS_STATIC}).Columns.item.item then
									l_break := True
								end
								if not (l_break) then
									first_match.item := first_match.item - 1
								end
							end
							l_break := False
						end
						l_fillchar := (create {P_SCREEN_STATIC}).fillchar_status (l_attr, 1)
						if first_match.item = 0 then
							l_buf___6.item := (('%/0/').code).to_natural_8
							l_len := 0
						else
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6), ce_string ("< ")).do_nothing
							l_len := 2
						end
						l_clen := l_len
						l_i___0 := first_match.item
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if a_showtail.to_boolean then
							l_tmp___23 := (sm_gettail (a_matches___0[l_i___0]))
						else
							l_tmp___23 := a_matches___0[l_i___0]
						end
						if not (((l_clen + (a_xp.item.status_match_len (l_tmp___23))) + 2).to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item) then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if l_i___0 = l_match then
							l_selstart := l_buf___6 + l_len
							l_selstart_col := l_clen
						end
						if a_showtail.to_boolean then
							l_s := (sm_gettail (a_matches___0[l_i___0]))
						else
							l_s := a_matches___0[l_i___0]
						end
						if a_xp.item.xp_context = 11 then
							l_tmp___12 := 1
						elseif a_xp.item.xp_context = 21 then
							l_tmp___12 := 1
						else
							l_tmp___12 := 0
						end
						l_emenu := l_tmp___12
						if not (l_emenu.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if ((create {P_MENU_STATIC}).menu_is_separator (l_s)).to_boolean then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)), create {CE_INTEGER_8_POINTER}.make_cast (((create {P_CHARSET_STATIC}).transchar (('|').code)))).do_nothing
							l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)))).to_integer_32
							l_len := l_len + l_l
							l_clen := l_clen + l_l
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							(l_s.item).to_integer_32 = 0
						loop
							l_s := l_s + (a_xp.item.skip_status_match_char (l_s))
							l_clen := l_clen + ((create {P_CHARSET_STATIC}).ptr2cells (l_s))
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
								if l_l > 1 then
									strncpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)), create {CE_INTEGER_8_POINTER}.make_cast (l_s), l_l.to_natural_32).do_nothing
									l_s := l_s + (l_l - 1)
									l_len := l_len + l_l
								else
									l_tmp___17 := (create {P_CHARSET_STATIC}).transchar_byte ((l_s.item).to_integer_32)
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___17)).do_nothing
									l_tmp___18 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)))
									l_len := l_len + l_tmp___18.to_integer_32
								end
							else
								l_tmp___17 := (create {P_CHARSET_STATIC}).transchar_byte ((l_s.item).to_integer_32)
								strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___17)).do_nothing
								l_tmp___18 := strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_buf___6 + l_len)))
								l_len := l_len + l_tmp___18.to_integer_32
							end
							l_s := l_s + 1
						end
				when 8 then
						if l_i___0 = l_match then
							l_selend := l_buf___6 + l_len
						end
						l_tmp___20 := l_len
						l_len := l_len + 1
						l_buf___6[l_tmp___20] := ((' ').code).to_natural_8
						l_tmp___21 := l_len
						l_len := l_len + 1
						l_buf___6[l_tmp___21] := ((' ').code).to_natural_8
						l_clen := l_clen + (2)
						l_i___0 := l_i___0 + 1
						if l_i___0 = a_num_matches___0 then
							l_break := True
						end
				when 9 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						if l_i___0 /= a_num_matches___0 then
							l_tmp___25 := l_len
							l_len := l_len + 1
							l_buf___6[l_tmp___25] := (('>').code).to_natural_8
							l_clen := l_clen + 1
						end
						l_buf___6[l_len] := (('%/0/').code).to_natural_8
						l_row := (create {P_GLOBALS_STATIC}).cmdline_row.item - 1
						if l_row >= 0 then
							if (create {P_GLOBALS_STATIC}).wild_menu_showing.item = 0 then
								if (create {P_GLOBALS_STATIC}).msg_scrolled.item > 0 then
									if ((create {P_GLOBALS_STATIC}).cmdline_row.item).to_integer_32 = (create {P_GLOBALS_STATIC}).Rows.item.item - 1 then
										(create {P_SCREEN_STATIC}).screen_del_lines (0, 0, 1, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32, 1, create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)).do_nothing;
										(create {P_GLOBALS_STATIC}).msg_scrolled.item := (create {P_GLOBALS_STATIC}).msg_scrolled.item + 1
									else
										(create {P_GLOBALS_STATIC}).cmdline_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item + 1
										l_row := l_row + 1
									end
									(create {P_GLOBALS_STATIC}).wild_menu_showing.item := 2
								else
									if (create {P_GLOBALS_STATIC}).lastwin.item.item.w_status_height = 0 then
										(create {P_GLOBALS_STATIC}).save_p_ls.item := ((create {P_OPTION_STATIC}).p_ls.item.item).to_integer_32;
										(create {P_GLOBALS_STATIC}).save_p_wmh.item := ((create {P_OPTION_STATIC}).p_wmh.item.item).to_integer_32;
										(create {P_OPTION_STATIC}).p_ls.item.item := 2;
										(create {P_OPTION_STATIC}).p_wmh.item.item := 0;
										(create {P_WINDOW_STATIC}).last_status (0)
									end
									(create {P_GLOBALS_STATIC}).wild_menu_showing.item := 1
								end
							end
							(create {P_SCREEN_STATIC}).screen_puts (l_buf___6, l_row, 0, l_attr.item)
							if not l_selstart.is_void then
								if l_highlight.to_boolean then
									l_selend.item := (('%/0/').code).to_natural_8;
									(create {P_SCREEN_STATIC}).screen_puts (l_selstart, l_row, l_selstart_col, (create {P_GLOBALS_STATIC}).highlight_attr.item[18])
								end
							end
							(create {P_SCREEN_STATIC}).screen_fill (l_row, l_row + 1, l_clen, ((create {P_GLOBALS_STATIC}).Columns.item.item).to_integer_32, l_fillchar, l_fillchar, l_attr.item)
						end
						(create {P_SCREEN_STATIC}).win_redraw_last_status ((create {P_GLOBALS_STATIC}).topframe.item);
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6))
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	sm_gettail (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_s.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_t: CE_POINTER [NATURAL_8]
			l_had_sep: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			l_t := a_s
			l_had_sep := 0
			l_p___0 := a_s
			from
			until
				(l_p___0.item).to_integer_32 = 0
			loop
				if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_p___0.item).to_integer_32)).to_boolean then
					l_had_sep := 1
				elseif l_had_sep.to_boolean then
					l_t := l_p___0
					l_had_sep := 0
				end
				if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
					l_tmp___1 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
				else
					l_tmp___1 := 1
				end
				l_p___0 := l_p___0 + l_tmp___1
			end
			Result := l_t
		end

	ExpandBufnames (a_pat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_options___0: INTEGER_32): INTEGER_32
		require
			not a_pat.is_void
			not a_num_file.is_void
			not a_file.is_void
		local
			l_count___2: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_round: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_attempt: INTEGER_32
			l_prog: CE_POINTER [PD_REGPROG_T]
			l_patc: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			l_count___2 := 0
			a_num_file.item := 0
			a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if (a_pat.item).to_integer_32 = 94 then
				l_patc := (create {P_MISC2_STATIC}).alloc ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat))) + {NATURAL_32} 11)
				if l_patc.is_void then
					Result := 0
					l_return := True
				end
				if not l_return then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_patc), ce_string ("\(^\|[\/]\)")).do_nothing
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_patc + 11)), create {CE_INTEGER_8_POINTER}.make_cast ((a_pat + 1))).do_nothing
				end
			else
				l_patc := a_pat
			end
			if not l_return then
				l_attempt := 0
				from
				until
					not (not (l_return or l_break) and then (l_attempt <= 1))
				loop
					l_break := False
					if l_attempt > 0 then
						if l_patc.is_equal (a_pat) then
							l_break := True
						end
					end
					if not (l_return or l_break or l_continue) then
						l_prog := (create {P_REGEXP_STATIC}).vim_regcomp (l_patc + l_attempt * 11, 1)
						if l_prog.is_void then
							if not l_patc.is_equal (a_pat) then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_patc))
							end
							Result := 0
							l_return := True
						end
						if not l_return then
							l_round := 1
							from
							until
								not (not (l_return or l_break) and then (l_round <= 2))
							loop
								l_break := False
								l_count___2 := 0
								l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
								from
								until
									l_buf___6.is_void
								loop
									l_continue := False
									if not (l_buf___6.item.b_p_bl).to_boolean then
										l_continue := True
									end
									if not (l_continue) then
										l_p___0 := (create {P_BUFFER_STATIC}).buflist_match (l_prog, l_buf___6)
										if not l_p___0.is_void then
											if l_round = 1 then
												l_count___2 := l_count___2 + 1
											else
												if ((a_options___0).bit_and (2)).to_boolean then
													l_p___0 := (create {P_MISC1_STATIC}).home_replace_save (l_buf___6, l_p___0)
												else
													l_p___0 := (create {P_MISC2_STATIC}).vim_strsave (l_p___0)
												end
												l_tmp___0 := l_count___2
												l_count___2 := l_count___2 + 1
												a_file.item[l_tmp___0] := l_p___0
											end
										end
									end
									l_buf___6 := l_buf___6.item.b_next
								end
								l_continue := False
								if l_count___2 = 0 then
									l_break := True
								end
								if not (l_return or l_break or l_continue) then
									if l_round = 1 then
										a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc (l_count___2.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
										if (a_file.item).is_void then
											(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_prog))
											if not l_patc.is_equal (a_pat) then
												(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_patc))
											end
											Result := 0
											l_return := True
										end
									end
									if not l_return then
										l_round := l_round + 1
									end
								end
							end
						end
						if not l_return then
							l_break := False;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_prog))
							if l_count___2.to_boolean then
								l_break := True
							end
							if not (l_return or l_break or l_continue) then
								l_attempt := l_attempt + 1
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				if not l_patc.is_equal (a_pat) then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_patc))
				end
				a_num_file.item := l_count___2
				if l_count___2 = 0 then
					l_tmp___2 := 0
				else
					l_tmp___2 := 1
				end
				Result := l_tmp___2
			end
		end

	vim_isfilec_or_wc (a_c: INTEGER_32): INTEGER_32
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_tmp___1: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<2>>)

			l_buf___6[0] := a_c.to_natural_8
			l_buf___6[1] := (('%/0/').code).to_natural_8
			if ((create {P_CHARSET_STATIC}).vim_isfilec (a_c)).to_boolean then
				l_tmp___1 := 1
			elseif a_c = 93 then
				l_tmp___1 := 1
			elseif ((create {P_OS_UNIX_STATIC}).mch_has_wildcard (l_buf___6)).to_boolean then
				l_tmp___1 := 1
			else
				l_tmp___1 := 0
			end
			Result := l_tmp___1
		end

	cleanup_help_tags (a_num_file: INTEGER_32; a_file: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_len: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (not (l_return) and then (l_i___0 < a_num_file))
			loop
				l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_file[l_i___0]))).to_integer_32 - 3
				if l_len > 0 then
					if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((a_file[l_i___0] + l_len)), ce_string ("@en"))) = 0 then
						l_j := 0
						from
						until
							not (not (l_break) and then (l_j < a_num_file))
						loop
							l_break := False
							if l_j /= l_i___0 then
								if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_file[l_j]))).to_integer_32 = l_len + 3 then
									if (strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_file[l_i___0]), create {CE_INTEGER_8_POINTER}.make_cast (a_file[l_j]), (l_len + 1).to_natural_32)) = 0 then
										l_break := True
									end
								end
							end
							if not (l_break) then
								l_j := l_j + 1
							end
						end
						l_break := False
						if l_j = a_num_file then
							(a_file[l_i___0])[l_len] := (('%/0/').code).to_natural_8
						end
					end
				end
				l_i___0 := l_i___0 + 1
			end
		end

	ExpandGeneric (a_xp: CE_POINTER [PD_EXPAND]; a_regmatch___0: CE_POINTER [PD_REGMATCH_T]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_func: CE_ROUTINE): INTEGER_32
		local
			l_i___0: INTEGER_32
			l_count___2: INTEGER_32
			l_round: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
		do
			l_count___2 := 0
			l_round := 0
			from
			until
				not (not (l_return) and then (l_round <= 1))
			loop
				l_i___0 := 0
				from
				until
					(l_break)
				loop
					l_break := False
					l_continue := False
					l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (a_func.pointer_item ([a_xp, l_i___0]))
					if l_str___1.is_void then
						l_break := True
					end
					if not (l_break or l_continue) and then ((l_str___1.item).to_integer_32 = 0) then
						l_continue := True
					end
					if not (l_break or l_continue) then
						if (a_regmatch___0.item.vim_regexec (l_str___1, 0)).to_boolean then
							if l_round.to_boolean then
								l_str___1 := (create {P_MISC2_STATIC}).vim_strsave_escaped (l_str___1, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" %T\.")))
								a_file.item[l_count___2] := l_str___1
								if a_func.is_equal ((create {P_MENU_STATIC}).get_menu_names_address) then
									if not l_str___1.is_void then
										l_str___1 := l_str___1 + ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_str___1))) - {NATURAL_32} 1).to_integer_32
										if (l_str___1.item).to_integer_32 = 1 then
											l_str___1.item := (('.').code).to_natural_8
										end
									end
								end
							end
							l_count___2 := l_count___2 + 1
						end
					end
					if (not l_break) then
						l_i___0 := l_i___0 + 1
					end
				end
				l_break := False
				l_continue := False
				if l_round = 0 then
					if l_count___2 = 0 then
						Result := 1
						l_return := True
					end
					if not l_return then
						a_num_file.item := l_count___2
						a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc (l_count___2.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
						if (a_file.item).is_void then
							a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ce_string (""))
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_count___2 := 0
					end
				end
				if not l_return then
					l_round := l_round + 1
				end
			end
			if not l_return then
				if a_xp.item.xp_context /= 21 then
					if a_xp.item.xp_context /= 11 then
						(create {P_MISC2_STATIC}).sort_strings (a_file.item, a_num_file.item)
					end
				end
				reset_expand_highlight
				Result := 1
			end
		end

	expand_shellcmd (a_filepat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flagsarg: INTEGER_32): INTEGER_32
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_path: CE_POINTER [NATURAL_8]
			l_mustfree: CE_ARRAY [INTEGER_32]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_buf___6: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: NATURAL_32
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_flags___0: INTEGER_32
			l_ret: INTEGER_32
			l_tmp___6: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_mustfree.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_buf___6.make (<<1>>)

			l_mustfree.item := 0
			l_buf___6.item := ((create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096))
			l_flags___0 := a_flagsarg
			if (l_buf___6.item).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_pat := (create {P_MISC2_STATIC}).vim_strsave (a_filepat)
				l_i___0 := 0
				from
				until
					not ((l_pat[l_i___0]).to_boolean)
				loop
					if (l_pat[l_i___0]).to_integer_32 = 92 then
						if (l_pat[(l_i___0 + 1)]).to_integer_32 = 32 then
							memmove (create {CE_VOID_POINTER}.make_cast ((l_pat + l_i___0)), create {CE_VOID_POINTER}.make_cast (((l_pat + l_i___0) + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((l_pat + l_i___0) + 1)))) + {NATURAL_32} 1).do_nothing
						end
					end
					l_i___0 := l_i___0 + 1
				end
				l_flags___0 := (l_flags___0).bit_or ((66))
				if ((create {P_OS_UNIX_STATIC}).mch_isFullName (l_pat)).to_boolean then
					l_path := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" "))
				elseif (l_pat[0]).to_integer_32 = 46 then
					if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_pat[1]).to_integer_32)).to_boolean then
						l_path := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("."))
					elseif (l_pat[1]).to_integer_32 = 46 then
						if ((create {P_MISC1_STATIC}).vim_ispathsep ((l_pat[2]).to_integer_32)).to_boolean then
							l_path := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("."))
						else
							l_path := (create {P_MISC1_STATIC}).vim_getenv (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("PATH")), l_mustfree)
						end
					else
						l_path := (create {P_MISC1_STATIC}).vim_getenv (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("PATH")), l_mustfree)
					end
				else
					l_path := (create {P_MISC1_STATIC}).vim_getenv (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("PATH")), l_mustfree)
				end
				l_ga.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 10)
				l_s := l_path
				from
				until
					not (not (l_return or l_break) and then ((l_s.item).to_integer_32 /= 0))
				loop
					l_break := False
					if (l_s.item).to_integer_32 = 32 then
						l_s := l_s + 1
					end
					l_e := (create {P_MISC2_STATIC}).vim_strchr (l_s, (':').code)
					if l_e.is_void then
						l_e := l_s + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
					end
					l_l := (l_e.distance (l_s)).to_natural_32
					if l_l > {NATURAL_32} 4_091 then
						l_break := True
					end
					if not (l_return or l_break) then
						(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6.item, l_s, l_l);
						(create {P_MISC1_STATIC}).add_pathsep (l_buf___6.item)
						l_l := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6.item));
						(create {P_MISC2_STATIC}).vim_strncpy (l_buf___6.item + l_l.to_integer_32, l_pat, {NATURAL_32} 4_095 - l_l)
						l_ret := (create {P_MISC1_STATIC}).expand_wildcards (1, l_buf___6, a_num_file, a_file, l_flags___0)
						if l_ret = 1 then
							if (l_ga.item.ga_grow (a_num_file.item)) = 0 then
								(create {P_MISC1_STATIC}).FreeWild (a_num_file.item, a_file.item)
							else
								l_i___0 := 0
								from
								until
									not (l_i___0 < a_num_file.item)
								loop
									l_s := a_file.item[l_i___0]
									if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))) > l_l then
										memmove (create {CE_VOID_POINTER}.make_cast (l_s), create {CE_VOID_POINTER}.make_cast ((l_s + l_l.to_integer_32)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_s + l_l.to_integer_32)))) + {NATURAL_32} 1).do_nothing
										l_tmp___6 := l_ga.item.ga_len
										l_ga.item.ga_len := (l_ga.item.ga_len) + 1
										create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)[l_tmp___6] := l_s
									else
										(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_s))
									end
									l_i___0 := l_i___0 + 1
								end
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_file.item))
							end
						end
						if (l_e.item).to_integer_32 /= 0 then
							l_e := l_e + 1
						end
						l_s := l_e
					end
				end
				l_break := False
				a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)
				a_num_file.item := l_ga.item.ga_len;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_buf___6.item));
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat))
				if (l_mustfree.item).to_boolean then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_path))
				end
				Result := 1
			end
		end

	ExpandRTDir (a_pat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_dirnames: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_num_file.is_void
			not a_file.is_void
			not a_dirnames.is_void
		local
			l_all: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_tmp: NATURAL_32
			l_tmp___4: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			a_num_file.item := 0
			a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pat))
			l_s := (create {P_MISC2_STATIC}).alloc ((l_tmp + (strlen (a_dirnames))) + {NATURAL_32} 7)
			if l_s.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_s), ce_string ("%%s/%%s*.vim"), a_dirnames, a_pat]).do_nothing
				l_all := (create {P_EX_GETLN_STATIC}).globpath ((create {P_OPTION_STATIC}).p_rtp.item.item, l_s, 0);
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_s))
				if l_all.is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_ga.item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 3)
				l_s := l_all
				from
				until
					not (not (l_return or l_break) and then ((l_s.item).to_integer_32 /= 0))
				loop
					l_break := False
					l_e := (create {P_MISC2_STATIC}).vim_strchr (l_s, ('%N').code)
					if l_e.is_void then
						l_e := l_s + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
					end
					if (l_ga.item.ga_grow (1)) = 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						if ((l_e - 4).c_pointer.to_integer_32).to_natural_32 > (l_s.c_pointer.to_integer_32).to_natural_32 then
							if (strncasecmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_e - 4)), ce_string (".vim"), (4).to_natural_32)) = 0 then
								l_s := l_e - 4
								from
								until
									not (not (l_break) and then ((l_s.c_pointer.to_integer_32).to_natural_32 > (l_all.c_pointer.to_integer_32).to_natural_32))
								loop
									l_break := False
									if (l_s.item).to_integer_32 = 10 then
										l_break := True
									elseif ((create {P_MISC1_STATIC}).vim_ispathsep ((l_s.item).to_integer_32)).to_boolean then
										l_break := True
									end
									if not (l_break) then
										if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
											l_tmp___4 := ((create {P_GLOBALS_STATIC}).mb_head_off.item.integer_32_item ([l_all, l_s - 1])) + 1
										else
											l_tmp___4 := 1
										end
										l_s := l_s - l_tmp___4
									end
								end
								l_break := False
								l_s := l_s + 1
								create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)[l_ga.item.ga_len] := (create {P_MISC2_STATIC}).vim_strnsave (l_s, (l_e.distance (l_s)) - 4)
								l_ga.item.ga_len := (l_ga.item.ga_len) + 1
							end
						end
						if (l_e.item).to_integer_32 /= 0 then
							l_e := l_e + 1
						end
						l_s := l_e
					end
				end
				l_break := False;
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_all))
				l_ga.item.remove_duplicates
				a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data)
				a_num_file.item := l_ga.item.ga_len
				Result := 1
			end
		end

	set_context_in_autocmd (a_xp: CE_POINTER [PD_EXPAND]; a_arg: CE_POINTER [NATURAL_8]; a_doautocmd: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_arg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_group: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_arg.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_arg.item := a_arg;
					(create {P_FILEIO_STATIC}).include_groups.item := 0
					l_p___0 := l_arg.item
					l_group := (create {P_FILEIO_STATIC}).au_get_grouparg (l_arg)
					if l_group = -2 then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						if (l_arg.item.item).to_integer_32 = 0 then
							if l_group /= -3 then
								if (l_arg.item[-1]).to_integer_32 /= 32 then
									if (l_arg.item[-1]).to_integer_32 /= 9 then
										l_arg.item := l_p___0
										l_group := -3
									end
								end
							end
						end
						l_p___0 := l_arg.item
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_p___0.item).to_integer_32 /= 0 then
								if (l_p___0.item).to_integer_32 = 32 then
									l_break := True
								elseif (l_p___0.item).to_integer_32 = 9 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (l_p___0.item).to_integer_32 = 44 then
									l_arg.item := l_p___0 + 1
								end
								l_p___0 := l_p___0 + 1
							end
						end
						l_break := False
						if (l_p___0.item).to_integer_32 = 0 then
							if l_group = -3 then
								(create {P_FILEIO_STATIC}).include_groups.item := 1
							end
							a_xp.item.xp_context := 10
							a_xp.item.xp_pattern := l_arg.item
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_arg.item := (create {P_CHARSET_STATIC}).skipwhite (l_p___0)
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if not ((l_arg.item.item).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						if (l_arg.item.item).to_integer_32 /= 32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (l_arg.item.item).to_integer_32 /= 9 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if (l_arg.item[-1]).to_integer_32 /= 92 then
							l_break := True
						end
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_break := True
				when 11 then
						if not (l_break) then
							l_arg.item := l_arg.item + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						l_break := False
						if (l_arg.item.item).to_boolean then
							Result := (l_arg.item)
							l_return := True
						end
				when 13 then -- if done
					if not l_return then
						if a_doautocmd.to_boolean then
							a_xp.item.xp_context := 2
						else
							a_xp.item.xp_context := 0
						end
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ExpandMappings (a_regmatch___0: CE_POINTER [PD_REGMATCH_T]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		require
			not a_num_file.is_void
			not a_file.is_void
		local
			l_mp: CE_POINTER [PD_MAPBLOCK]
			l_hash: INTEGER_32
			l_count___2: INTEGER_32
			l_round: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_ptr1: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_ptr2: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_ptr3: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___4: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___5: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp___7: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
		do
			create {CE_CLASS_POINTER [PD_MAPBLOCK]} l_mp.make
			create {CE_NATURAL_8_POINTER} l_p___0.make;

			(create {P_GETCHAR_STATIC}).validate_maphash
			a_num_file.item := 0
			a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_round := 1
			from
			until
				not (not (l_return or l_break) and then (l_round <= 2))
			loop
				l_break := False
				l_count___2 := 0
				l_i___0 := 0
				from
				until
					not (l_i___0 < 5)
				loop
					l_continue := False
					if l_i___0 = 0 then
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<silent>"))
					elseif l_i___0 = 1 then
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<unique>"))
					elseif l_i___0 = 2 then
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<script>"))
					elseif l_i___0 = 3 then
						l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<expr>"))
					elseif l_i___0 = 4 then
						if not expand_buffer.item.to_boolean then
							l_p___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("<buffer>"))
						else
							l_continue := True
						end
					else
						l_continue := True
					end
					if not (l_continue) then
						if (a_regmatch___0.item.vim_regexec (l_p___0, 0)).to_boolean then
							if l_round = 1 then
								l_count___2 := l_count___2 + 1
							else
								l_tmp := l_count___2
								l_count___2 := l_count___2 + 1
								a_file.item[l_tmp] := (create {P_MISC2_STATIC}).vim_strsave (l_p___0)
							end
						end
					end
					l_i___0 := l_i___0 + 1
				end
				l_continue := False
				l_hash := 0
				from
				until
					not (not (l_return or l_break) and then (l_hash < 256))
				loop
					l_break := False
					if expand_isabbrev.item.to_boolean then
						if l_hash > 0 then
							l_break := True
						end
						if not (l_return or l_break or l_continue) then
							l_mp := (create {P_GETCHAR_STATIC}).first_abbr.item.item
						end
					elseif expand_buffer.item.to_boolean then
						l_mp := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_maphash[l_hash]
					else
						l_mp := (create {P_GETCHAR_STATIC}).maphash.item[l_hash]
					end
					if not (l_return or l_break or l_continue) then
						from
						until
							l_mp.is_void
						loop
							if ((l_mp.item.m_mode).bit_and (expand_mapmodes.item)).to_boolean then
								l_p___0 := translate_mapping (l_mp.item.m_keys, 1)
								if not l_p___0.is_void then
									if (a_regmatch___0.item.vim_regexec (l_p___0, 0)).to_boolean then
										if l_round = 1 then
											l_count___2 := l_count___2 + 1
										else
											l_tmp___1 := l_count___2
											l_count___2 := l_count___2 + 1
											a_file.item[l_tmp___1] := l_p___0
											l_p___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
										end
									end
								end
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
							end
							l_mp := l_mp.item.m_next
						end
						l_hash := l_hash + 1
					end
				end
				l_break := False
				if l_count___2 = 0 then
					l_break := True
				end
				if not (l_return or l_break or l_continue) then
					if l_round = 1 then
						a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc (l_count___2.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
						if (a_file.item).is_void then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_round := l_round + 1
					end
				end
			end
			if not l_return then
				l_break := False
				if l_count___2 > 1 then
					(create {P_MISC2_STATIC}).sort_strings (a_file.item, l_count___2)
					l_ptr1 := a_file.item
					l_ptr2 := l_ptr1 + 1
					l_ptr3 := l_ptr1 + l_count___2
					from
					until
						not ((l_ptr2.c_pointer.to_integer_32).to_natural_32 < (l_ptr3.c_pointer.to_integer_32).to_natural_32)
					loop
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_ptr1.item), create {CE_INTEGER_8_POINTER}.make_cast (l_ptr2.item))).to_boolean then
							l_ptr1 := l_ptr1 + 1
							l_tmp___4 := l_ptr2
							l_ptr2 := l_ptr2 + 1
							l_ptr1.item := l_tmp___4.item
						else
							l_tmp___5 := l_ptr2
							l_ptr2 := l_ptr2 + 1;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tmp___5.item))
							l_count___2 := l_count___2 - 1
						end
					end
				end
				a_num_file.item := l_count___2
				if l_count___2 = 0 then
					l_tmp___7 := 0
				else
					l_tmp___7 := 1
				end
				Result := l_tmp___7
			end
		end

	expand_wildcards_eval (a_pat: CE_POINTER [CE_POINTER [NATURAL_8]]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]; a_flags___0: INTEGER_32): INTEGER_32
		require
			not a_pat.is_void
		local
			l_ret: INTEGER_32
			l_eval_pat: CE_POINTER [NATURAL_8]
			l_exp_pat: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_ignored_msg: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_usedlen: CE_ARRAY [INTEGER_32]
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_exp_pat.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ignored_msg.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_usedlen.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ret := 0
					l_eval_pat := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_exp_pat.item := a_pat.item
					if (l_exp_pat.item.item).to_integer_32 /= 37 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if (l_exp_pat.item.item).to_integer_32 /= 35 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_exp_pat.item.item).to_integer_32 /= 60 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:;
						(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item + 1
						l_eval_pat := (create {P_EX_DOCMD_STATIC}).eval_vars (l_exp_pat.item, l_exp_pat.item, l_usedlen, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_ignored_msg, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
						(create {P_GLOBALS_STATIC}).emsg_off.item := (create {P_GLOBALS_STATIC}).emsg_off.item - 1
						if not l_eval_pat.is_void then
							l_exp_pat.item := (create {P_MISC1_STATIC}).concat_str (l_eval_pat, l_exp_pat.item + l_usedlen.item)
						end
				when 8 then -- if done | if done
					if not (l_exp_pat.item).is_void then
						l_ret := (create {P_MISC1_STATIC}).expand_wildcards (1, l_exp_pat, a_num_file, a_file, a_flags___0)
					end
					if not l_eval_pat.is_void then
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_exp_pat.item));
						(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_eval_pat))
					end
					Result := l_ret
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ExpandSettings (a_xp: CE_POINTER [PD_EXPAND]; a_regmatch___0: CE_POINTER [PD_REGMATCH_T]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		require
			not a_regmatch___0.is_void
		local
			l_num_normal: INTEGER_32
			l_num_term: INTEGER_32
			l_opt_idx: INTEGER_32
			l_match: INTEGER_32
			l_count___2: INTEGER_32
			l_str___1: CE_POINTER [NATURAL_8]
			l_loop: INTEGER_32
			l_is_term_opt: INTEGER_32
			l_name_buf: CE_ARRAY [NATURAL_8]
			l_ic: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_name_buf.make (<<25>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_num_normal := 0
					l_num_term := 0
					l_count___2 := 0
					l_ic := a_regmatch___0.item.rm_ic
					l_loop := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then (l_loop <= 1)) then
						l_pos := -1 + 15 -- skip loop
					end
				when 2 then -- loop body:
						a_regmatch___0.item.rm_ic := l_ic
						if a_xp.item.xp_context /= 5 then
							l_match := 0
							from
							until
								not (l_match < (({PLATFORM}.Pointer_bytes.to_natural_32 * (2).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32)
							loop
								if (a_regmatch___0.item.vim_regexec (create {CE_NATURAL_8_POINTER}.make_cast (names___0.item[l_match]), 0)).to_boolean then
									if l_loop = 0 then
										l_num_normal := l_num_normal + 1
									else
										l_tmp := l_count___2
										l_count___2 := l_count___2 + 1
										a_file.item[l_tmp] := (create {P_MISC2_STATIC}).vim_strsave (create {CE_NATURAL_8_POINTER}.make_cast (names___0.item[l_match]))
									end
								end
								l_match := l_match + 1
							end
						end
						l_opt_idx := 0
				when 3 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 14 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						l_continue := False
						l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).options.item[l_opt_idx].fullname)
						if l_str___1.is_void then
							l_break := True
						end
						if not (l_break or l_continue) and then (((create {P_OPTION_STATIC}).options.item[l_opt_idx].var).is_void) then
							l_continue := True
						end
						if not (l_break or l_continue) and then (a_xp.item.xp_context = 5) then
							if not (((create {P_OPTION_STATIC}).options.item[l_opt_idx].flags).bit_and ({NATURAL_32} 1)).to_boolean then
								l_continue := True
							end
						end
						if not (l_break or l_continue) then
							l_is_term_opt := ((create {P_OPTION_STATIC}).options.item + l_opt_idx).item.istermoption
							if l_is_term_opt.to_boolean then
								if l_num_normal > 0 then
									l_continue := True
								end
							end
						end
						if (l_break or l_continue) then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						l_match := 0
						if not ((a_regmatch___0.item.vim_regexec (l_str___1, 0)).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_match := 1
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if ((create {P_OPTION_STATIC}).options.item[l_opt_idx].shortname).is_void then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (a_regmatch___0.item.vim_regexec (create {CE_NATURAL_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).options.item[l_opt_idx].shortname), 0)).to_boolean then
							l_match := 1
						else
							l_pos := -1 + 11 -- goto _L
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L:
						if l_is_term_opt.to_boolean then
							l_name_buf[0] := (('<').code).to_natural_8
							l_name_buf[1] := (('t').code).to_natural_8
							l_name_buf[2] := (('_').code).to_natural_8
							l_name_buf[3] := l_str___1[2]
							l_name_buf[4] := l_str___1[3]
							l_name_buf[5] := (('>').code).to_natural_8
							l_name_buf[6] := (('%/0/').code).to_natural_8
							if (a_regmatch___0.item.vim_regexec (l_name_buf, 0)).to_boolean then
								l_match := 1
								l_str___1 := l_name_buf
							end
						end
				when 12 then -- if done
						if l_match.to_boolean then
							if l_loop = 0 then
								if l_is_term_opt.to_boolean then
									l_num_term := l_num_term + 1
								else
									l_num_normal := l_num_normal + 1
								end
							else
								l_tmp___4 := l_count___2
								l_count___2 := l_count___2 + 1
								a_file.item[l_tmp___4] := (create {P_MISC2_STATIC}).vim_strsave (l_str___1)
							end
						end
				when 13 then -- if done
						if (not l_break) then
							l_opt_idx := l_opt_idx + 1
						end
						l_pos := -1 + 3 -- back to loop condition
				when 14 then -- loop done
						l_break := False
						l_continue := False
						if a_xp.item.xp_context /= 5 then
							if l_num_normal = 0 then
								l_opt_idx := 0
								from
								until
									(l_break)
								loop
									l_break := False
									l_continue := False
									l_str___1 := get_termcode (l_opt_idx)
									if l_str___1.is_void then
										l_break := True
									end
									if not (l_break or l_continue) then
										if ((((ctype_b_loc).item[(l_str___1[0]).to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
											if not ((((ctype_b_loc).item[(l_str___1[1]).to_integer_32]).to_integer_32).bit_and (16_384)).to_boolean then
												l_continue := True
											end
										else
											l_continue := True
										end
									end
									if not (l_break or l_continue) then
										l_name_buf[0] := (('t').code).to_natural_8
										l_name_buf[1] := (('_').code).to_natural_8
										l_name_buf[2] := l_str___1[0]
										l_name_buf[3] := l_str___1[1]
										l_name_buf[4] := (('%/0/').code).to_natural_8
										l_match := 0
										if (a_regmatch___0.item.vim_regexec (l_name_buf, 0)).to_boolean then
											l_match := 1
										else
											l_name_buf[0] := (('<').code).to_natural_8
											l_name_buf[1] := (('t').code).to_natural_8
											l_name_buf[2] := (('_').code).to_natural_8
											l_name_buf[3] := l_str___1[0]
											l_name_buf[4] := l_str___1[1]
											l_name_buf[5] := (('>').code).to_natural_8
											l_name_buf[6] := (('%/0/').code).to_natural_8
											if (a_regmatch___0.item.vim_regexec (l_name_buf, 0)).to_boolean then
												l_match := 1
											end
										end
										if l_match.to_boolean then
											if l_loop = 0 then
												l_num_term := l_num_term + 1
											else
												l_tmp___9 := l_count___2
												l_count___2 := l_count___2 + 1
												a_file.item[l_tmp___9] := (create {P_MISC2_STATIC}).vim_strsave (l_name_buf)
											end
										end
									end
									if (not l_break) then
										l_opt_idx := l_opt_idx + 1
									end
								end
								l_break := False
								l_continue := False
								a_regmatch___0.item.rm_ic := 1
								l_opt_idx := 0
								from
								until
									(l_break)
								loop
									l_break := False
									l_str___1 := get_key_name (l_opt_idx)
									if l_str___1.is_void then
										l_break := True
									end
									if not (l_break or l_continue) then
										l_name_buf[0] := (('<').code).to_natural_8
										strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_name_buf + 1)), create {CE_INTEGER_8_POINTER}.make_cast (l_str___1)).do_nothing
										strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_name_buf), ce_string (">")).do_nothing
										if (a_regmatch___0.item.vim_regexec (l_name_buf, 0)).to_boolean then
											if l_loop = 0 then
												l_num_term := l_num_term + 1
											else
												l_tmp___10 := l_count___2
												l_count___2 := l_count___2 + 1
												a_file.item[l_tmp___10] := (create {P_MISC2_STATIC}).vim_strsave (l_name_buf)
											end
										end
										l_opt_idx := l_opt_idx + 1
									end
								end
								l_break := False
							end
						end
						if l_loop = 0 then
							if l_num_normal > 0 then
								a_num_file.item := l_num_normal
							elseif l_num_term > 0 then
								a_num_file.item := l_num_term
							else
								Result := 1
								l_return := True
							end
							if not l_return then
								a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc ((a_num_file.item).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
								if (a_file.item).is_void then
									a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (ce_string (""))
									Result := 0
									l_return := True
								end
							end
						end
						if not l_return then
							l_loop := l_loop + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 15 then -- loop done
					if not l_return then
						Result := 1
					end
				when 16 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_key_name (a_i___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_i___0 >= (((create {PD_KEY_NAME_ENTRY}.make).structure_size.to_natural_32 * (136).to_natural_32) // (create {PD_KEY_NAME_ENTRY}.make).structure_size.to_natural_32).to_integer_32 then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := ((create {P_MISC2_STATIC}).key_names_table.item[a_i___0].name)
			end
		end

	ExpandOldSetting (a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		require
			not a_num_file.is_void
			not a_file.is_void
		local
			l_var: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_var := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			a_num_file.item := 0
			a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (((create {P_MISC2_STATIC}).alloc ({PLATFORM}.Pointer_bytes.to_natural_32)))
			if (a_file.item).is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				if expand_option_idx.item < 0 then
					l_var := (create {P_TERM_STATIC}).find_termcode (expand_option_name.item + 2)
					if l_var.is_void then
						expand_option_idx.item := (create {P_OPTION_STATIC}).findoption (expand_option_name.item)
					end
				end
				if expand_option_idx.item >= 0 then
					((create {P_OPTION_STATIC}).options.item + expand_option_idx.item).item.option_value2string (expand_option_flags.item)
					l_var := (create {P_GLOBALS_STATIC}).NameBuff.item.item
				elseif l_var.is_void then
					l_var := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				end
				l_buf___6 := (create {P_MISC2_STATIC}).vim_strsave_escaped (l_var, (create {P_GLOBALS_STATIC}).escape_chars.item)
				if l_buf___6.is_void then
					(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (a_file.item))
					a_file.item := create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				(a_file[0]).item := l_buf___6
				a_num_file.item := 1
				Result := 1
			end
		end

	reset_expand_highlight
		do
			(create {P_SYNTAX_STATIC}).include_none.item := 0;
			(create {P_SYNTAX_STATIC}).include_default.item := (create {P_SYNTAX_STATIC}).include_none.item;
			(create {P_SYNTAX_STATIC}).include_link.item := (create {P_SYNTAX_STATIC}).include_default.item
		end

	highlight_list
		local
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_i___0 := 10
			from
			until
				(l_break)
			loop
				l_break := False
				l_i___0 := l_i___0 - 1
				if not (l_i___0 >= 0) then
					l_break := True
				end
				if not (l_break) then
					highlight_list_two (l_i___0, (create {P_GLOBALS_STATIC}).highlight_attr.item[2])
				end
			end
			l_break := False
			l_i___0 := 40
			from
			until
				(l_break)
			loop
				l_break := False
				l_i___0 := l_i___0 - 1
				if not (l_i___0 >= 0) then
					l_break := True
				end
				if not (l_break) then
					highlight_list_two (99, 0)
				end
			end
			l_break := False
		end

	highlight_list_two (a_cnt, a_attr: INTEGER_32)
		local
			l_tmp: INTEGER_32
		do
			(create {P_MESSAGE_STATIC}).msg_puts_attr (create {CE_NATURAL_8_POINTER}.make_cast ((ce_string ("N %BI %B!  %B") + a_cnt // 11)), a_attr);
			(create {P_MESSAGE_STATIC}).msg_clr_eos;
			(create {P_TERM_STATIC}).out_flush
			if a_cnt = 99 then
				l_tmp := 40
			else
				l_tmp := a_cnt.to_integer_32 * 50
			end
			(create {P_UI_STATIC}).ui_delay (l_tmp, 0)
		end

	expand_tags (a_tagnames: INTEGER_32; a_pat: CE_POINTER [NATURAL_8]; a_num_file: CE_POINTER [INTEGER_32]; a_file: CE_POINTER [CE_POINTER [CE_POINTER [NATURAL_8]]]): INTEGER_32
		require
			not a_pat.is_void
			not a_num_file.is_void
			not a_file.is_void
		local
			l_i___0: INTEGER_32
			l_c: INTEGER_32
			l_tagnmflag: INTEGER_32
			l_tagnm: CE_ARRAY [NATURAL_8]
			l_t_p: CE_ARRAY [PD_TAG_POINTERS]
			l_ret: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_tagnm.make (<<100>>)
			create {CE_CLASS_ARRAY [PD_TAG_POINTERS]} l_t_p.make (<<1>>)

			if a_tagnames.to_boolean then
				l_tagnmflag := 2
			else
				l_tagnmflag := 0
			end
			if (a_pat[0]).to_integer_32 = 47 then
				l_ret := (create {P_TAG_STATIC}).find_tags (a_pat + 1, a_num_file, a_file, (((4).bit_or (l_tagnmflag))).bit_or (32), 300, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)
			else
				l_ret := (create {P_TAG_STATIC}).find_tags (a_pat, a_num_file, a_file, (((((4).bit_or (l_tagnmflag))).bit_or (32))).bit_or (8), 300, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)
			end
			if l_ret = 1 then
				if not a_tagnames.to_boolean then
					l_i___0 := 0
					from
					until
						not (l_i___0 < a_num_file.item)
					loop
						l_t_p.item.parse_match (a_file.item[l_i___0]).do_nothing
						l_c := (l_t_p.item.tagname_end).distance ((l_t_p.item.tagname))
						memmove (create {CE_VOID_POINTER}.make_cast (l_tagnm), create {CE_VOID_POINTER}.make_cast (l_t_p.item.tagname), l_c.to_natural_32).do_nothing
						l_tmp := l_c
						l_c := l_c + 1
						l_tagnm[l_tmp] := (0).to_natural_8
						l_tmp___0 := l_c
						l_c := l_c + 1
						if not (l_t_p.item.tagkind).is_void then
							if ((l_t_p.item.tagkind).item).to_boolean then
								l_tagnm[l_tmp___0] := (l_t_p.item.tagkind).item
							else
								l_tagnm[l_tmp___0] := (('f').code).to_natural_8
							end
						else
							l_tagnm[l_tmp___0] := (('f').code).to_natural_8
						end
						l_tmp___1 := l_c
						l_c := l_c + 1
						l_tagnm[l_tmp___1] := (0).to_natural_8
						memmove (create {CE_VOID_POINTER}.make_cast ((a_file.item[l_i___0] + l_c)), create {CE_VOID_POINTER}.make_cast (l_t_p.item.fname), ((l_t_p.item.fname_end).distance ((l_t_p.item.fname))).to_natural_32).do_nothing;
						(a_file.item[l_i___0])[(l_c + ((l_t_p.item.fname_end).distance ((l_t_p.item.fname))))] := (0).to_natural_8
						memmove (create {CE_VOID_POINTER}.make_cast (a_file.item[l_i___0]), create {CE_VOID_POINTER}.make_cast (l_tagnm), l_c.to_natural_32).do_nothing
						l_i___0 := l_i___0 + 1
					end
				end
			end
			Result := l_ret
		end

	get_termcode (a_i___0: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if a_i___0 >= (create {P_TERM_STATIC}).tc_len.item then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (((create {P_TERM_STATIC}).termcodes.item + a_i___0).c_pointer + (create {PD_TERMCODE}.make).offset_of ("name") + {PLATFORM}.Natural_8_bytes * (0)))
			end
		end

	translate_mapping (a_str___1: CE_POINTER [NATURAL_8]; a_expmap: INTEGER_32): CE_POINTER [NATURAL_8]
		require
			not a_str___1.is_void
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_c: INTEGER_32
			l_modifiers: INTEGER_32
			l_cpo_bslash: INTEGER_32
			l_cpo_special: INTEGER_32
			l_cpo_keycode: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str___1 := a_str___1
					l_ga.item.ga_init
					l_ga.item.ga_itemsize := 1
					l_ga.item.ga_growsize := 40
					l_cpo_bslash := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('B').code)).is_void).to_integer
					l_cpo_special := (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('<').code)).is_void).to_integer
					l_cpo_keycode := (((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_cpo.item.item, ('k').code)).is_void).to_integer
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_str___1.item).to_boolean)) then
						l_pos := -1 + 35 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						l_c := (l_str___1.item).to_integer_32
						if l_c /= 128 then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if (l_str___1[1]).to_integer_32 = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if (l_str___1[2]).to_integer_32 = 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 5 then -- if:
						l_modifiers := 0
						if (l_str___1[1]).to_integer_32 = 252 then
							l_str___1 := l_str___1 + 1
							l_str___1 := l_str___1 + 1
							l_modifiers := (l_str___1.item).to_integer_32
							l_str___1 := l_str___1 + 1
							l_c := (l_str___1.item).to_integer_32
						end
						if l_cpo_special.to_boolean then
							if l_cpo_keycode.to_boolean then
								if l_c = 128 then
									if not l_modifiers.to_boolean then
										l_i___0 := 0
										from
										until
											not (not (l_break) and then (l_i___0 < (create {P_TERM_STATIC}).tc_len.item))
										loop
											l_break := False
											if (((create {P_TERM_STATIC}).termcodes.item + l_i___0).item.name[0]).to_integer_32 = (l_str___1[1]).to_integer_32 then
												if (((create {P_TERM_STATIC}).termcodes.item + l_i___0).item.name[1]).to_integer_32 = (l_str___1[2]).to_integer_32 then
													l_break := True
												end
											end
											if not (l_break) then
												l_i___0 := l_i___0 + 1
											end
										end
										l_break := False
										if l_i___0 < (create {P_TERM_STATIC}).tc_len.item then
											l_ga.item.ga_concat (((create {P_TERM_STATIC}).termcodes.item + l_i___0).item.code)
											l_str___1 := l_str___1 + (2)
											l_continue := True
										end
									end
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if l_c = 128 then
							if (l_str___1[1]).to_integer_32 /= 0 then
								if (l_str___1[2]).to_integer_32 /= 0 then
									if a_expmap.to_boolean then
										if l_cpo_special.to_boolean then
											l_ga.item.ga_clear
											Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
											l_return := True
										end
									end
									if not l_return then
										if (l_str___1[1]).to_integer_32 = 254 then
											l_c := 128
										else
											if (l_str___1[1]).to_integer_32 = 255 then
												l_tmp___2 := -(255 + ((88).bit_shift_left (8)))
											else
												l_tmp___2 := -((l_str___1[1]).to_integer_32 + (((l_str___1[2]).to_integer_32).bit_shift_left (8)))
											end
											l_c := l_tmp___2
										end
										if l_c = -(255 + ((88).bit_shift_left (8))) then
											l_c := ('%/0/').code
										end
										l_str___1 := l_str___1 + (2)
									end
								end
							end
						end
						if l_return then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						if not (l_c < 0) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if not (l_modifiers.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if a_expmap.to_boolean then
							if l_cpo_special.to_boolean then
								l_ga.item.ga_clear
								Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
								l_return := True
							end
						end
						if not l_return then
							l_ga.item.ga_concat (((create {P_MISC2_STATIC}).get_special_key_name (l_c, l_modifiers)))
							l_continue := True
						end
				when 12 then -- if done | if done | if done | if done | if done | if done
						if l_return then
							l_pos := -1 + 34 -- skip if block
						end
				when 13 then -- if:
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 33 -- skip if block
						end
				when 14 then -- if:
						if l_c /= 32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						l_pos := -1 + 31 -- goto _L___0
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 17 then -- else:
						if l_c /= 9 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 31 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 20 then -- else:
						if l_c /= 10 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 31 -- goto _L___0
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 23 then -- else:
						if l_c /= 22 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 31 -- goto _L___0
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 26 then -- else:
						if l_c /= 60 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						if not l_cpo_special.to_boolean then
							l_pos := -1 + 31 -- goto _L___0
						else
							l_pos := -1 + 29 -- goto _L___1
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 29 then -- else: | _L___1:
						if l_c /= 92 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if l_cpo_bslash.to_boolean then
							l_pos := -1 + 32 -- skip if block
						end
				when 31 then -- if: | _L___0:
						if l_cpo_bslash.to_boolean then
							l_tmp___4 := 22
						else
							l_tmp___4 := ('\').code
						end
						l_ga.item.ga_append (l_tmp___4)
				when 32 then -- if done | if done | if done | if done | if done | if done
						if l_c.to_boolean then
							l_ga.item.ga_append (l_c)
						end
				when 33 then -- if done
						if (not l_return) then
							l_str___1 := l_str___1 + 1
						end
				when 34 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 35 then -- loop done
					if not l_return then
						l_continue := False
						l_ga.item.ga_append (('%/0/').code)
						Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data))
					end
				when 36 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			xp_context := a_other.xp_context
			xp_pattern := a_other.xp_pattern
			xp_pattern_len := a_other.xp_pattern_len
			xp_arg := a_other.xp_arg
			xp_scriptID := a_other.xp_scriptID
			xp_backslash := a_other.xp_backslash
			xp_shell := a_other.xp_shell
			xp_numfiles := a_other.xp_numfiles
			xp_files := a_other.xp_files
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				xp_context = a_other.xp_context and
				xp_pattern.is_equal (a_other.xp_pattern) and
				xp_pattern_len = a_other.xp_pattern_len and
				xp_arg.is_equal (a_other.xp_arg) and
				xp_scriptID = a_other.xp_scriptID and
				xp_backslash = a_other.xp_backslash and
				xp_shell = a_other.xp_shell and
				xp_numfiles = a_other.xp_numfiles and
				xp_files.is_equal (a_other.xp_files)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("xp_context"),
					create {CE_STRUCTURE_FIELD}.make ("xp_pattern"),
					create {CE_STRUCTURE_FIELD}.make ("xp_pattern_len"),
					create {CE_STRUCTURE_FIELD}.make ("xp_arg"),
					create {CE_STRUCTURE_FIELD}.make ("xp_scriptID"),
					create {CE_STRUCTURE_FIELD}.make ("xp_backslash"),
					create {CE_STRUCTURE_FIELD}.make ("xp_shell"),
					create {CE_STRUCTURE_FIELD}.make ("xp_numfiles"),
					create {CE_STRUCTURE_FIELD}.make ("xp_files")
				>>)
			init_structure_info
		end

end
