class
	P_VIEW_SOURCE_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_matrix_complex_long_double_view_array (a_array: CE_POINTER [REAL_96]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_long_double_view_array_with_tda (a_base: CE_POINTER [REAL_96]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_view_array (a_array: CE_POINTER [REAL_64]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_view_array_with_tda (a_base: CE_POINTER [REAL_64]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_view_array (a_array: CE_POINTER [REAL_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_view_array_with_tda (a_base: CE_POINTER [REAL_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_long_double_view_array (a_array: CE_POINTER [REAL_96]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_long_double_view_array_with_tda (a_base: CE_POINTER [REAL_96]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_view_array (a_array: CE_POINTER [REAL_64]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_VIEW
		local
			l_view: PD_GSL_MATRIX_VIEW
			l_m___4: PD_GSL_MATRIX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_view_array_with_tda (a_base: CE_POINTER [REAL_64]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_VIEW
		local
			l_view: PD_GSL_MATRIX_VIEW
			l_m___4: PD_GSL_MATRIX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_float_view_array (a_array: CE_POINTER [REAL_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_float_view_array_with_tda (a_base: CE_POINTER [REAL_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_ulong_view_array (a_array: CE_POINTER [NATURAL_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_ULONG_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_ulong_view_array_with_tda (a_base: CE_POINTER [NATURAL_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_ULONG_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_long_view_array (a_array: CE_POINTER [INTEGER_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_long_view_array_with_tda (a_base: CE_POINTER [INTEGER_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_uint_view_array (a_array: CE_POINTER [NATURAL_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_UINT_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_uint_view_array_with_tda (a_base: CE_POINTER [NATURAL_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_UINT_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_int_view_array (a_array: CE_POINTER [INTEGER_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_INT_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_int_view_array_with_tda (a_base: CE_POINTER [INTEGER_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_INT_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_view_array (a_array: CE_POINTER [NATURAL_16]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_view_array_with_tda (a_base: CE_POINTER [NATURAL_16]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_USHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_short_view_array (a_array: CE_POINTER [INTEGER_16]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_SHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_short_view_array_with_tda (a_base: CE_POINTER [INTEGER_16]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_SHORT_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_uchar_view_array (a_array: CE_POINTER [NATURAL_8]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_UCHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_uchar_view_array_with_tda (a_base: CE_POINTER [NATURAL_8]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_UCHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_char_view_array (a_array: CE_POINTER [INTEGER_8]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_CHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_char_view_array_with_tda (a_base: CE_POINTER [INTEGER_8]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_CHAR_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_long_double_const_view_array (a_array: CE_POINTER [REAL_96]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_long_double_const_view_array_with_tda (a_base: CE_POINTER [REAL_96]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_const_view_array (a_array: CE_POINTER [REAL_64]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_const_view_array_with_tda (a_base: CE_POINTER [REAL_64]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_view_array (a_array: CE_POINTER [REAL_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_view_array_with_tda (a_base: CE_POINTER [REAL_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_long_double_const_view_array (a_array: CE_POINTER [REAL_96]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_long_double_const_view_array_with_tda (a_base: CE_POINTER [REAL_96]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_DOUBLE_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_const_view_array (a_array: CE_POINTER [REAL_64]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_const_view_array_with_tda (a_base: CE_POINTER [REAL_64]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CONST_VIEW
			l_m___4: PD_GSL_MATRIX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_float_const_view_array (a_array: CE_POINTER [REAL_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_float_const_view_array_with_tda (a_base: CE_POINTER [REAL_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_FLOAT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_ulong_const_view_array (a_array: CE_POINTER [NATURAL_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_ulong_const_view_array_with_tda (a_base: CE_POINTER [NATURAL_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_ULONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_ULONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_long_const_view_array (a_array: CE_POINTER [INTEGER_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_LONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_long_const_view_array_with_tda (a_base: CE_POINTER [INTEGER_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_LONG_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_LONG_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_LONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_uint_const_view_array (a_array: CE_POINTER [NATURAL_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_UINT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_uint_const_view_array_with_tda (a_base: CE_POINTER [NATURAL_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_UINT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UINT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UINT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_int_const_view_array (a_array: CE_POINTER [INTEGER_32]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_INT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_int_const_view_array_with_tda (a_base: CE_POINTER [INTEGER_32]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_INT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_INT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_INT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_view_array (a_array: CE_POINTER [NATURAL_16]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_ushort_const_view_array_with_tda (a_base: CE_POINTER [NATURAL_16]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_USHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_short_const_view_array (a_array: CE_POINTER [INTEGER_16]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_short_const_view_array_with_tda (a_base: CE_POINTER [INTEGER_16]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_SHORT_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_SHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_uchar_const_view_array (a_array: CE_POINTER [NATURAL_8]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_uchar_const_view_array_with_tda (a_base: CE_POINTER [NATURAL_8]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_UCHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_UCHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_char_const_view_array (a_array: CE_POINTER [INTEGER_8]; a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 29, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 34, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_array
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_n2
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_matrix_char_const_view_array_with_tda (a_base: CE_POINTER [INTEGER_8]; a_n1, a_n2, a_tda: NATURAL_32): PD_GSL_MATRIX_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_CHAR_CONST_VIEW
			l_m___4: PD_GSL_MATRIX_CHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_m___4.make

			l_view.matrix.size1 := (0).to_natural_32
			l_view.matrix.size2 := (0).to_natural_32
			l_view.matrix.tda := (0).to_natural_32
			l_view.matrix.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.matrix.owner := 0
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("view_source.c"), 63, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("view_source.c"), 68, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 > a_tda then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must not exceed tda"), ce_string ("view_source.c"), 73, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_m___4.size1 := (0).to_natural_32
				l_m___4.size2 := (0).to_natural_32
				l_m___4.tda := (0).to_natural_32
				l_m___4.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_m___4.data := a_base
				l_m___4.size1 := a_n1
				l_m___4.size2 := a_n2
				l_m___4.tda := a_tda
				l_m___4.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_m___4.owner := 0
				l_view.matrix := l_m___4.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_long_double_view_array (a_base: CE_POINTER [REAL_96]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_long_double_view_array_with_stride (a_base: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_view_array (a_base: CE_POINTER [REAL_64]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_view_array_with_stride (a_base: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_float_view_array (a_base: CE_POINTER [REAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_float_view_array_with_stride (a_base: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_long_double_view_array (a_base: CE_POINTER [REAL_96]; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_VIEW
			l_v: PD_GSL_VECTOR_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_long_double_view_array_with_stride (a_base: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_VIEW
			l_v: PD_GSL_VECTOR_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_view_array (a_base: CE_POINTER [REAL_64]; a_n: NATURAL_32): PD_GSL_VECTOR_VIEW
		local
			l_view: PD_GSL_VECTOR_VIEW
			l_v: PD_GSL_VECTOR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_float_view_array (a_base: CE_POINTER [REAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_float_view_array_with_stride (a_base: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_ulong_view_array (a_base: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_VIEW
			l_v: PD_GSL_VECTOR_ULONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_ulong_view_array_with_stride (a_base: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_VIEW
			l_v: PD_GSL_VECTOR_ULONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_long_view_array (a_base: CE_POINTER [INTEGER_32]; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_VIEW
			l_v: PD_GSL_VECTOR_LONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_long_view_array_with_stride (a_base: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_LONG_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_VIEW
			l_v: PD_GSL_VECTOR_LONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_uint_view_array (a_base: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_VIEW
			l_v: PD_GSL_VECTOR_UINT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_uint_view_array_with_stride (a_base: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_UINT_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_VIEW
			l_v: PD_GSL_VECTOR_UINT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_int_view_array (a_base: CE_POINTER [INTEGER_32]; a_n: NATURAL_32): PD_GSL_VECTOR_INT_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_VIEW
			l_v: PD_GSL_VECTOR_INT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_int_view_array_with_stride (a_base: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_INT_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_VIEW
			l_v: PD_GSL_VECTOR_INT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_ushort_view_array (a_base: CE_POINTER [NATURAL_16]; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_ushort_view_array_with_stride (a_base: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_short_view_array (a_base: CE_POINTER [INTEGER_16]; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_VIEW
			l_v: PD_GSL_VECTOR_SHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_short_view_array_with_stride (a_base: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_VIEW
			l_v: PD_GSL_VECTOR_SHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_uchar_view_array (a_base: CE_POINTER [NATURAL_8]; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_VIEW
			l_v: PD_GSL_VECTOR_UCHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_uchar_view_array_with_stride (a_base: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_VIEW
			l_v: PD_GSL_VECTOR_UCHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_char_view_array (a_base: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_VIEW
			l_v: PD_GSL_VECTOR_CHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_char_view_array_with_stride (a_base: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_VIEW
			l_v: PD_GSL_VECTOR_CHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_long_double_const_view_array (a_base: CE_POINTER [REAL_96]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_long_double_const_view_array_with_stride (a_base: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_const_view_array (a_base: CE_POINTER [REAL_64]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_const_view_array_with_stride (a_base: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_float_const_view_array (a_base: CE_POINTER [REAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_complex_float_const_view_array_with_stride (a_base: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_long_double_const_view_array (a_base: CE_POINTER [REAL_96]; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
			l_v: PD_GSL_VECTOR_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_long_double_const_view_array_with_stride (a_base: CE_POINTER [REAL_96]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_DOUBLE_CONST_VIEW
			l_v: PD_GSL_VECTOR_LONG_DOUBLE
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_96_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_DOUBLE_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_const_view_array_with_stride (a_base: CE_POINTER [REAL_64]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CONST_VIEW
			l_v: PD_GSL_VECTOR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_64_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_float_const_view_array (a_base: CE_POINTER [REAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_float_const_view_array_with_stride (a_base: CE_POINTER [REAL_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_FLOAT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_ulong_const_view_array (a_base: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_CONST_VIEW
			l_v: PD_GSL_VECTOR_ULONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_ulong_const_view_array_with_stride (a_base: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_ULONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_ULONG_CONST_VIEW
			l_v: PD_GSL_VECTOR_ULONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_ULONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_long_const_view_array (a_base: CE_POINTER [INTEGER_32]; a_n: NATURAL_32): PD_GSL_VECTOR_LONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_CONST_VIEW
			l_v: PD_GSL_VECTOR_LONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_long_const_view_array_with_stride (a_base: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_LONG_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_LONG_CONST_VIEW
			l_v: PD_GSL_VECTOR_LONG
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_LONG_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_uint_const_view_array (a_base: CE_POINTER [NATURAL_32]; a_n: NATURAL_32): PD_GSL_VECTOR_UINT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_CONST_VIEW
			l_v: PD_GSL_VECTOR_UINT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_uint_const_view_array_with_stride (a_base: CE_POINTER [NATURAL_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_UINT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UINT_CONST_VIEW
			l_v: PD_GSL_VECTOR_UINT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UINT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_int_const_view_array (a_base: CE_POINTER [INTEGER_32]; a_n: NATURAL_32): PD_GSL_VECTOR_INT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_CONST_VIEW
			l_v: PD_GSL_VECTOR_INT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_int_const_view_array_with_stride (a_base: CE_POINTER [INTEGER_32]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_INT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_INT_CONST_VIEW
			l_v: PD_GSL_VECTOR_INT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_INT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_ushort_const_view_array (a_base: CE_POINTER [NATURAL_16]; a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_ushort_const_view_array_with_stride (a_base: CE_POINTER [NATURAL_16]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_USHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_USHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_USHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_16_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_USHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_short_const_view_array (a_base: CE_POINTER [INTEGER_16]; a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_SHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_short_const_view_array_with_stride (a_base: CE_POINTER [INTEGER_16]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_SHORT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_SHORT_CONST_VIEW
			l_v: PD_GSL_VECTOR_SHORT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_16_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_SHORT_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_uchar_const_view_array (a_base: CE_POINTER [NATURAL_8]; a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_CONST_VIEW
			l_v: PD_GSL_VECTOR_UCHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_uchar_const_view_array_with_stride (a_base: CE_POINTER [NATURAL_8]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_UCHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_UCHAR_CONST_VIEW
			l_v: PD_GSL_VECTOR_UCHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_UCHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_char_const_view_array (a_base: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_CONST_VIEW
			l_v: PD_GSL_VECTOR_CHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 28, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := (1).to_natural_32
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

	gsl_vector_char_const_view_array_with_stride (a_base: CE_POINTER [INTEGER_8]; a_stride, a_n: NATURAL_32): PD_GSL_VECTOR_CHAR_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_CHAR_CONST_VIEW
			l_v: PD_GSL_VECTOR_CHAR
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			l_view.vector.stride := (0).to_natural_32
			l_view.vector.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
			l_view.vector.owner := 0
			if a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("view_source.c"), 55, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_stride = {NATURAL_32} 0) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("stride must be positive integer"), ce_string ("view_source.c"), 61, 4)
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				l_v.stride := (0).to_natural_32
				l_v.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_v.data := a_base
				l_v.size := a_n
				l_v.stride := a_stride
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_CHAR_STRUCT]}.make_shared (default_pointer)
				l_v.owner := 0
				l_view.vector := l_v.twin
				Result := l_view.twin
			end
		end

end
