class
	PD_GSL_MATRIX_COMPLEX_FLOAT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_MATH_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_REAL_32_POINTER} data.make
			create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]} block.make
			Precursor
		end

feature {ANY} -- fields

	size1: NATURAL_32 assign set_size1

	size2: NATURAL_32 assign set_size2

	tda: NATURAL_32 assign set_tda

	data: CE_POINTER [REAL_32] assign set_data

	block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT] assign set_block

	owner: INTEGER_32 assign set_owner

feature {ANY} -- field setters

	set_size1 (a_size1: NATURAL_32)
		do
			size1 := a_size1
			update_memory_field ("size1")
		end

	set_size2 (a_size2: NATURAL_32)
		do
			size2 := a_size2
			update_memory_field ("size2")
		end

	set_tda (a_tda: NATURAL_32)
		do
			tda := a_tda
			update_memory_field ("tda")
		end

	set_data (a_data: CE_POINTER [REAL_32])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_block (a_block: CE_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT])
		do
			block := a_block
			update_memory_field ("block")
		end

	set_owner (a_owner: INTEGER_32)
		do
			owner := a_owner
			update_memory_field ("owner")
		end

feature {ANY} -- public routines

	gsl_matrix_complex_float_get (a_i, a_j: NATURAL_32): PD_GSL_COMPLEX_FLOAT
		do
			Result := ((create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((data + ({NATURAL_32} 2 * (a_i * tda + a_j)).to_integer_32))).item).twin
		end

	gsl_matrix_complex_float_set (a_i, a_j: NATURAL_32; a_x: PD_GSL_COMPLEX_FLOAT)
		do
			(create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((data + ({NATURAL_32} 2 * (a_i * tda + a_j)).to_integer_32))).item := a_x.twin
			update_class_fields -- Current might have been changed; synchronize
		end

	gsl_matrix_complex_float_ptr (a_i, a_j: NATURAL_32): CE_POINTER [PD_GSL_COMPLEX_FLOAT]
		do
			Result := (create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((data + ({NATURAL_32} 2 * (a_i * tda + a_j)).to_integer_32)))
		end

	gsl_matrix_complex_float_const_ptr (a_i, a_j: NATURAL_32): CE_POINTER [PD_GSL_COMPLEX_FLOAT]
		do
			Result := (create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((data + ({NATURAL_32} 2 * (a_i * tda + a_j)).to_integer_32)))
		end

	gsl_blas_cgemv (a_TransA: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_TransA /= {NATURAL_32} 111 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = a_X.item.size then
							if l_M = a_Y.item.size then
								cblas_cgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							else
								l_pos := -1 + 3 -- goto _L___4
							end
						else
							l_pos := -1 + 3 -- goto _L___4
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else: | _L___4:
						if a_TransA /= {NATURAL_32} 112 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_M = a_X.item.size then
							if l_N = a_Y.item.size then
								cblas_cgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							else
								l_pos := -1 + 6 -- goto _L___2
							end
						else
							l_pos := -1 + 6 -- goto _L___2
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else: | _L___2:
						if a_TransA /= {NATURAL_32} 113 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_M = a_X.item.size then
							if l_N = a_Y.item.size then
								cblas_cgemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							else
								l_pos := -1 + 9 -- goto _L___0
							end
						else
							l_pos := -1 + 9 -- goto _L___0
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 662, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 10 then -- if done | if done
					if not l_return then
						Result := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_chemv (a_Uplo: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_Y: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 706, 20)
							update_class_fields -- Current might have been changed; synchronize
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						if l_N = a_X.item.size then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if l_N = a_Y.item.size then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 710, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if done | if done
					if not l_return then
						cblas_chemv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_Y.item.data), (a_Y.item.stride).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_ctrmv (a_Uplo, a_TransA, a_Diag: NATURAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := size1
			l_N := size2
			if l_M /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 845, 20)
					update_class_fields -- Current might have been changed; synchronize
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif l_N /= a_X.item.size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 849, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				cblas_ctrmv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	gsl_blas_ctrsv (a_Uplo, a_TransA, a_Diag: NATURAL_32; a_X: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := size1
			l_N := size2
			if l_M /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square"), ce_string ("blas.c"), 938, 20)
					update_class_fields -- Current might have been changed; synchronize
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif l_N /= a_X.item.size then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 942, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				cblas_ctrsv ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_TransA, a_Diag, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_X.item.data), (a_X.item.stride).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	gsl_blas_cgemm (a_TransA, a_TransB: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_B.is_void
			not a_C.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_TransA = {NATURAL_32} 111 then
						l_tmp := size1
					else
						l_tmp := size2
					end
					l_MA := l_tmp
					if a_TransA = {NATURAL_32} 111 then
						l_tmp___0 := size2
					else
						l_tmp___0 := size1
					end
					l_NA := l_tmp___0
					if a_TransB = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_TransB = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M /= l_MA then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_N = l_NB then
							if l_NA = l_MB then
								cblas_cgemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_TransA, a_TransB, l_M.to_integer_32, l_N.to_integer_32, l_NA.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
								update_class_fields -- Current might have been changed; synchronize
								Result := 0
								l_return := True
							else
								l_pos := -1 + 3 -- goto _L___0
							end
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L___0:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_383, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 4 then
					if not l_return then
						Result := 0
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_csymm (a_Side, a_Uplo: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_B.is_void
			not a_C.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_MB: NATURAL_32
			l_NB: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					l_MA := size1
					l_NA := size2
					l_MB := a_B.item.size1
					l_NB := a_B.item.size2
					if l_MA /= l_NA then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1_499, 20)
							update_class_fields -- Current might have been changed; synchronize
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							if l_N = l_NB then
								if l_NA = l_MB then
									cblas_csymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									Result := 0
									l_return := True
								else
									l_pos := -1 + 4 -- goto _L___0
								end
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_M = l_MB then
							if l_N = l_NA then
								if l_NB = l_MA then
									cblas_csymm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									Result := 0
									l_return := True
								else
									l_pos := -1 + 7 -- goto _L
								end
							else
								l_pos := -1 + 7 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_513, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if done | if done
					if not l_return then
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_chemm (a_Side, a_Uplo: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_B.is_void
			not a_C.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_MB: NATURAL_32
			l_NB: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					l_MA := size1
					l_NA := size2
					l_MB := a_B.item.size1
					l_NB := a_B.item.size2
					if l_MA /= l_NA then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 1_569, 20)
							update_class_fields -- Current might have been changed; synchronize
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							if l_N = l_NB then
								if l_NA = l_MB then
									cblas_chemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									Result := 0
									l_return := True
								else
									l_pos := -1 + 4 -- goto _L___0
								end
							else
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_M = l_MB then
							if l_N = l_NA then
								if l_NB = l_MA then
									cblas_chemm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
									update_class_fields -- Current might have been changed; synchronize
									Result := 0
									l_return := True
								else
									l_pos := -1 + 7 -- goto _L
								end
							else
								l_pos := -1 + 7 -- goto _L
							end
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_583, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if done | if done
					if not l_return then
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_csyrk (a_Uplo, a_Trans: NATURAL_32; a_alpha, a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_C.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_J: NATURAL_32
			l_tmp: NATURAL_32
			l_K: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_C.item.size1
			l_N := a_C.item.size2
			if a_Trans = {NATURAL_32} 111 then
				l_tmp := size1
			else
				l_tmp := size2
			end
			l_J := l_tmp
			if a_Trans = {NATURAL_32} 111 then
				l_tmp___0 := size2
			else
				l_tmp___0 := size1
			end
			l_K := l_tmp___0
			if l_M /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1_686, 20)
					update_class_fields -- Current might have been changed; synchronize
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif l_N /= l_J then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_690, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				cblas_csyrk ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_K.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	gsl_blas_cherk (a_Uplo, a_Trans: NATURAL_32; a_alpha, a_beta: REAL_32; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_C.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_J: NATURAL_32
			l_tmp: NATURAL_32
			l_K: NATURAL_32
			l_tmp___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := a_C.item.size1
			l_N := a_C.item.size2
			if a_Trans = {NATURAL_32} 111 then
				l_tmp := size1
			else
				l_tmp := size2
			end
			l_J := l_tmp
			if a_Trans = {NATURAL_32} 111 then
				l_tmp___0 := size2
			else
				l_tmp___0 := size1
			end
			l_K := l_tmp___0
			if l_M /= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1_739, 20)
					update_class_fields -- Current might have been changed; synchronize
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif l_N /= l_J then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_743, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				cblas_cherk ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_K.to_integer_32, a_alpha, create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, a_beta, create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				Result := 0
			end
		end

	gsl_blas_csyr2k (a_Uplo, a_Trans: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: PD_GSL_COMPLEX_FLOAT; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_B.is_void
			not a_C.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_Trans = {NATURAL_32} 111 then
						l_tmp := size1
					else
						l_tmp := size2
					end
					l_MA := l_tmp
					if a_Trans = {NATURAL_32} 111 then
						l_tmp___0 := size2
					else
						l_tmp___0 := size1
					end
					l_NA := l_tmp___0
					if a_Trans = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_Trans = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1_850, 20)
							update_class_fields -- Current might have been changed; synchronize
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if l_N = l_MA then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if l_N = l_MB then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_NA = l_NB then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_854, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 11 then -- if done | if done | if done
					if not l_return then
						cblas_csyr2k ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_NA.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_beta.dat)), create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_cher2k (a_Uplo, a_Trans: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_beta: REAL_32; a_C: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_B.is_void
			not a_C.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_tmp: NATURAL_32
			l_NA: NATURAL_32
			l_tmp___0: NATURAL_32
			l_MB: NATURAL_32
			l_tmp___1: NATURAL_32
			l_NB: NATURAL_32
			l_tmp___2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_C.item.size1
					l_N := a_C.item.size2
					if a_Trans = {NATURAL_32} 111 then
						l_tmp := size1
					else
						l_tmp := size2
					end
					l_MA := l_tmp
					if a_Trans = {NATURAL_32} 111 then
						l_tmp___0 := size2
					else
						l_tmp___0 := size1
					end
					l_NA := l_tmp___0
					if a_Trans = {NATURAL_32} 111 then
						l_tmp___1 := a_B.item.size1
					else
						l_tmp___1 := a_B.item.size2
					end
					l_MB := l_tmp___1
					if a_Trans = {NATURAL_32} 111 then
						l_tmp___2 := a_B.item.size2
					else
						l_tmp___2 := a_B.item.size1
					end
					l_NB := l_tmp___2
					if l_M = l_N then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix C must be square"), ce_string ("blas.c"), 1_911, 20)
							update_class_fields -- Current might have been changed; synchronize
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 3 then -- else:
						if l_N = l_MA then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 6 then -- else:
						if l_N = l_MB then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if l_NA = l_NB then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 1_915, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 11 then -- if done | if done | if done
					if not l_return then
						cblas_cher2k ({PC_CBLAS_ORDER}.CblasRowMajor, a_Uplo, a_Trans, l_N.to_integer_32, l_NA.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32, a_beta, create {CE_VOID_POINTER}.make_cast (a_C.item.data), (a_C.item.tda).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						Result := 0
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_ctrmm (a_Side, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_B.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := size1
					l_NA := size2
					if l_MA /= l_NA then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 2_027, 20)
							update_class_fields -- Current might have been changed; synchronize
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							cblas_ctrmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							cblas_ctrmm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2_039, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if done | if done
					if not l_return then
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_blas_ctrsm (a_Side, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_alpha: PD_GSL_COMPLEX_FLOAT; a_B: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_B.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_MA: NATURAL_32
			l_NA: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := a_B.item.size1
					l_N := a_B.item.size2
					l_MA := size1
					l_NA := size2
					if l_MA /= l_NA then
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix A must be square"), ce_string ("blas.c"), 2_146, 20)
							update_class_fields -- Current might have been changed; synchronize
							Result := 20
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if a_Side /= {NATURAL_32} 141 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_M = l_MA then
							cblas_ctrsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if a_Side /= {NATURAL_32} 142 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_N = l_MA then
							cblas_ctrsm ({PC_CBLAS_ORDER}.CblasRowMajor, a_Side, a_Uplo, a_TransA, a_Diag, l_M.to_integer_32, l_N.to_integer_32, create {CE_VOID_POINTER}.make_cast ((a_alpha.dat)), create {CE_VOID_POINTER}.make_cast (data), tda.to_integer_32, create {CE_VOID_POINTER}.make_cast (a_B.item.data), (a_B.item.tda).to_integer_32)
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("invalid length"), ce_string ("blas.c"), 2_158, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if done | if done
					if not l_return then
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_complex_float_isnull: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_k < {NATURAL_32} 2))
					loop
						if (data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32]).to_double /= 0.0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_k := l_k + 1
						end
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_matrix_complex_float_ispos: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_k < {NATURAL_32} 2))
					loop
						if (data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32]).to_double <= 0.0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_k := l_k + 1
						end
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_matrix_complex_float_isneg: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_k < {NATURAL_32} 2))
					loop
						if (data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32]).to_double >= 0.0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_k := l_k + 1
						end
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_matrix_complex_float_isnonneg: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_k < {NATURAL_32} 2))
					loop
						if (data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32]).to_double < 0.0 then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_k := l_k + 1
						end
					end
					if not l_return then
						l_j := l_j + 1
					end
				end
				if not l_return then
					l_i := l_i + 1
				end
			end
			if not l_return then
				Result := 1
			end
		end

	gsl_matrix_complex_float_row (a_i: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("rowcol_source.c"), 27, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + ((a_i * {NATURAL_32} 2) * tda).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := size2
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_column (a_j: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 51, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + (a_j * {NATURAL_32} 2).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := size1
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_diagonal: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_v.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_v.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_v.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_v.data := data
			update_class_fields -- Current might have been changed; synchronize
			if size1 < size2 then
				l_v.size := size1
				update_class_fields -- Current might have been changed; synchronize
			else
				l_v.size := size2
				update_class_fields -- Current might have been changed; synchronize
			end
			l_v.stride := tda + {NATURAL_32} 1
			update_class_fields -- Current might have been changed; synchronize
			l_v.block := block
			update_class_fields -- Current might have been changed; synchronize
			l_v.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector := l_v.twin
			update_class_fields -- Current might have been changed; synchronize
			Result := l_view.twin
		end

	gsl_matrix_complex_float_subdiagonal (a_k: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_k >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("subdiagonal index is out of range"), ce_string ("rowcol_source.c"), 92, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + ((a_k * {NATURAL_32} 2) * tda).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if size1 - a_k < size2 then
					l_v.size := size1 - a_k
					update_class_fields -- Current might have been changed; synchronize
				else
					l_v.size := size2
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v.stride := tda + {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_superdiagonal (a_k: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_k >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 118, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + (a_k * {NATURAL_32} 2).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if size1 < size2 - a_k then
					l_v.size := size1
					update_class_fields -- Current might have been changed; synchronize
				else
					l_v.size := size2 - a_k
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v.stride := tda + {NATURAL_32} 1
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_subrow (a_i, a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("rowcol_source.c"), 142, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("rowcol_source.c"), 147, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_offset + a_n > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimension n overflows matrix"), ce_string ("rowcol_source.c"), 151, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + ({NATURAL_32} 2 * (a_i * tda + a_offset)).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_subcolumn (a_j, a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 175, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("rowcol_source.c"), 180, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_offset + a_n > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimension n overflows matrix"), ce_string ("rowcol_source.c"), 184, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := data + ({NATURAL_32} 2 * (a_offset * tda + a_j)).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_row (a_i: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("rowcol_source.c"), 27, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + ((a_i * {NATURAL_32} 2) * tda).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := size2
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_column (a_j: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 51, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + (a_j * {NATURAL_32} 2).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := size1
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_diagonal: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_v.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_v.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_v.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_v.data := data
			update_class_fields -- Current might have been changed; synchronize
			if size1 < size2 then
				l_v.size := size1
				update_class_fields -- Current might have been changed; synchronize
			else
				l_v.size := size2
				update_class_fields -- Current might have been changed; synchronize
			end
			l_v.stride := (tda + {NATURAL_32} 1)
			update_class_fields -- Current might have been changed; synchronize
			l_v.block := block
			update_class_fields -- Current might have been changed; synchronize
			l_v.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector := l_v.twin
			update_class_fields -- Current might have been changed; synchronize
			Result := l_view.twin
		end

	gsl_matrix_complex_float_const_subdiagonal (a_k: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_k >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("subdiagonal index is out of range"), ce_string ("rowcol_source.c"), 92, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + ((a_k * {NATURAL_32} 2) * tda).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if size1 - a_k < size2 then
					l_v.size := (size1 - a_k)
					update_class_fields -- Current might have been changed; synchronize
				else
					l_v.size := size2
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v.stride := (tda + {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_superdiagonal (a_k: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_k >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 118, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + (a_k * {NATURAL_32} 2).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				if size1 < size2 - a_k then
					l_v.size := size1
					update_class_fields -- Current might have been changed; synchronize
				else
					l_v.size := (size2 - a_k)
					update_class_fields -- Current might have been changed; synchronize
				end
				l_v.stride := (tda + {NATURAL_32} 1)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_subrow (a_i, a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("rowcol_source.c"), 142, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("rowcol_source.c"), 147, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_offset + a_n > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimension n overflows matrix"), ce_string ("rowcol_source.c"), 151, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + ({NATURAL_32} 2 * (a_i * tda + a_offset)).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_subcolumn (a_j, a_offset, a_n: NATURAL_32): PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_VECTOR_COMPLEX_FLOAT_CONST_VIEW
			l_v: PD_GSL_VECTOR_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_v.make

			l_view.vector.size := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.stride := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.vector.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("rowcol_source.c"), 175, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("vector length n must be positive integer"), ce_string ("rowcol_source.c"), 180, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_offset + a_n > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimension n overflows matrix"), ce_string ("rowcol_source.c"), 184, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v.size := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_v.data := (data + ({NATURAL_32} 2 * (a_offset * tda + a_j)).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v.size := a_n
				update_class_fields -- Current might have been changed; synchronize
				l_v.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_v.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.vector := l_v.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_swap_rows (a_i, a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row1: CE_POINTER [REAL_32]
			l_row2: CE_POINTER [REAL_32]
			l_k: NATURAL_32
			l_tmp: REAL_32
			l_return, l_break: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			if a_i >= l_size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first row index is out of range"), ce_string ("swap_source.c"), 29, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_j >= l_size1) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second row index is out of range"), ce_string ("swap_source.c"), 34, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				if a_i /= a_j then
					l_row1 := data + (({NATURAL_32} 2 * a_i) * tda).to_integer_32
					l_row2 := data + (({NATURAL_32} 2 * a_j) * tda).to_integer_32
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2 * l_size2)
					loop
						l_tmp := l_row1[l_k.to_integer_32]
						l_row1[l_k.to_integer_32] := l_row2[l_k.to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_row2[l_k.to_integer_32] := l_tmp
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_swap_columns (a_i, a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_col1: CE_POINTER [REAL_32]
			l_col2: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_n: NATURAL_32
			l_tmp: REAL_32
			l_return, l_break: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			if a_i >= l_size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first column index is out of range"), ce_string ("swap_source.c"), 64, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_j >= l_size2) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second column index is out of range"), ce_string ("swap_source.c"), 69, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				if a_i /= a_j then
					l_col1 := data + ({NATURAL_32} 2 * a_i).to_integer_32
					l_col2 := data + ({NATURAL_32} 2 * a_j).to_integer_32
					l_p := (0).to_natural_32
					from
					until
						not (not (l_return) and then (l_p < l_size1))
					loop
						l_n := (l_p * {NATURAL_32} 2) * tda
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 2)
						loop
							l_tmp := l_col1[(l_n + l_k).to_integer_32]
							l_col1[(l_n + l_k).to_integer_32] := l_col2[(l_n + l_k).to_integer_32]
							update_class_fields -- Current might have been changed; synchronize
							l_col2[(l_n + l_k).to_integer_32] := l_tmp
							update_class_fields -- Current might have been changed; synchronize
							l_k := l_k + 1
						end
						l_p := l_p + 1
					end
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_swap_rowcol (a_i, a_j: NATURAL_32): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_row: CE_POINTER [REAL_32]
			l_col: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_k: NATURAL_32
			l_r___3: NATURAL_32
			l_c___1: NATURAL_32
			l_tmp: REAL_32
			l_return, l_break: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			if l_size1 /= l_size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square to swap row and column"), ce_string ("swap_source.c"), 106, 20)
					update_class_fields -- Current might have been changed; synchronize
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_i >= l_size1) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("swap_source.c"), 111, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_j >= l_size2) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("swap_source.c"), 116, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_row := data + (({NATURAL_32} 2 * a_i) * tda).to_integer_32
				l_col := data + ({NATURAL_32} 2 * a_j).to_integer_32
				l_p := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_p < l_size1))
				loop
					l_r___3 := l_p * {NATURAL_32} 2
					l_c___1 := (l_p * {NATURAL_32} 2) * tda
					l_k := (0).to_natural_32
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_tmp := l_col[(l_c___1 + l_k).to_integer_32]
						l_col[(l_c___1 + l_k).to_integer_32] := l_row[(l_r___3 + l_k).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_row[(l_r___3 + l_k).to_integer_32] := l_tmp
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
					l_p := l_p + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_transpose: INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_tmp: REAL_32
			l_return, l_break: BOOLEAN
		do
			l_size1 := size1
			l_size2 := size2
			if l_size1 /= l_size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix must be square to take transpose"), ce_string ("swap_source.c"), 154, 20)
					update_class_fields -- Current might have been changed; synchronize
					Result := 20
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_size1))
				loop
					l_j := l_i + {NATURAL_32} 1
					from
					until
						not (not (l_return) and then (l_j < l_size2))
					loop
						l_k := (0).to_natural_32
						from
						until
							not (l_k < {NATURAL_32} 2)
						loop
							l_e1 := (l_i * tda + l_j) * {NATURAL_32} 2 + l_k
							l_e2 := (l_j * tda + l_i) * {NATURAL_32} 2 + l_k
							l_tmp := data[l_e1.to_integer_32]
							data[l_e1.to_integer_32] := data[l_e2.to_integer_32]
							update_class_fields -- Current might have been changed; synchronize
							data[l_e2.to_integer_32] := l_tmp
							update_class_fields -- Current might have been changed; synchronize
							l_k := l_k + 1
						end
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_transpose_memcpy (a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_src.is_void
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_e1: NATURAL_32
			l_e2: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := size1
					l_dest_size2 := size2
					if l_dest_size2 = l_src_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_dest_size1 = l_src_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("dimensions of dest matrix must be transpose of src matrix"), ce_string ("swap_source.c"), 192, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return then
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_dest_size1))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (not (l_return) and then (l_j < l_dest_size2))
							loop
								l_k := (0).to_natural_32
								from
								until
									not (l_k < {NATURAL_32} 2)
								loop
									l_e1 := (l_i * tda + l_j) * {NATURAL_32} 2 + l_k
									l_e2 := (l_j * a_src.item.tda + l_i) * {NATURAL_32} 2 + l_k
									data[l_e1.to_integer_32] := a_src.item.data[l_e2.to_integer_32]
									update_class_fields -- Current might have been changed; synchronize
									l_k := l_k + 1
								end
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_complex_float_memcpy (a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_src.is_void
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := size1
					l_dest_size2 := size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 31, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return then
						l_src_tda := a_src.item.tda
						l_dest_tda := tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_src_size1))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < {NATURAL_32} 2 * l_src_size2)
							loop
								data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32] := a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32]
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_complex_float_swap (a_src: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_src.is_void
		local
			l_src_size1: NATURAL_32
			l_src_size2: NATURAL_32
			l_dest_size1: NATURAL_32
			l_dest_size2: NATURAL_32
			l_src_tda: NATURAL_32
			l_dest_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tmp: REAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_src_size1 := a_src.item.size1
					l_src_size2 := a_src.item.size2
					l_dest_size1 := size1
					l_dest_size2 := size2
					if l_src_size1 = l_dest_size1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if l_src_size2 = l_dest_size2 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix sizes are different"), ce_string ("copy_source.c"), 63, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if done
					if not l_return then
						l_src_tda := a_src.item.tda
						l_dest_tda := tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_src_size1))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < {NATURAL_32} 2 * l_src_size2)
							loop
								l_tmp := a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32]
								a_src.item.data[(({NATURAL_32} 2 * l_src_tda) * l_i + l_j).to_integer_32] := data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32]
								update_class_fields -- Current might have been changed; synchronize
								data[(({NATURAL_32} 2 * l_dest_tda) * l_i + l_j).to_integer_32] := l_tmp
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_complex_float_add (a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 29, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								data[l_aij.to_integer_32] := data[l_aij.to_integer_32] + (a_b___0.item.data[l_bij.to_integer_32])
								update_class_fields -- Current might have been changed; synchronize
								data[(l_aij + {NATURAL_32} 1).to_integer_32] := data[(l_aij + {NATURAL_32} 1).to_integer_32] + (a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32])
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						l_return := True
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_complex_float_sub (a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 63, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								data[l_aij.to_integer_32] := data[l_aij.to_integer_32] - (a_b___0.item.data[l_bij.to_integer_32])
								update_class_fields -- Current might have been changed; synchronize
								data[(l_aij + {NATURAL_32} 1).to_integer_32] := data[(l_aij + {NATURAL_32} 1).to_integer_32] - (a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32])
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						l_return := True
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_complex_float_mul_elements (a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_ar: REAL_32
			l_ai: REAL_32
			l_br: REAL_32
			l_bi: REAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 97, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								l_ar := data[l_aij.to_integer_32]
								l_ai := data[(l_aij + {NATURAL_32} 1).to_integer_32]
								l_br := a_b___0.item.data[l_bij.to_integer_32]
								l_bi := a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32]
								data[l_aij.to_integer_32] := l_ar * l_br - l_ai * l_bi
								update_class_fields -- Current might have been changed; synchronize
								data[(l_aij + {NATURAL_32} 1).to_integer_32] := l_ar * l_bi + l_ai * l_br
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						l_return := True
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_complex_float_div_elements (a_b___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		require
			not a_b___0.is_void
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda_a: NATURAL_32
			l_tda_b: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_aij: NATURAL_32
			l_bij: NATURAL_32
			l_ar: REAL_32
			l_ai: REAL_32
			l_br: REAL_32
			l_bi: REAL_32
			l_s: REAL_32
			l_tmp: REAL_64
			l_sbr: REAL_32
			l_sbi: REAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_M := size1
					l_N := size2
					if a_b___0.item.size1 = l_M then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if a_b___0.item.size2 = l_N then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrices must have same dimensions"), ce_string ("oper_complex_source.c"), 137, 19)
							update_class_fields -- Current might have been changed; synchronize
							Result := 19
							l_return := True
							if not l_return then
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						l_tda_a := tda
						l_tda_b := a_b___0.item.tda
						l_i := (0).to_natural_32
						from
						until
							not (not (l_return) and then (l_i < l_M))
						loop
							l_j := (0).to_natural_32
							from
							until
								not (l_j < l_N)
							loop
								l_aij := {NATURAL_32} 2 * (l_i * l_tda_a + l_j)
								l_bij := {NATURAL_32} 2 * (l_i * l_tda_b + l_j)
								l_ar := data[l_aij.to_integer_32]
								l_ai := data[(l_aij + {NATURAL_32} 1).to_integer_32]
								l_br := a_b___0.item.data[l_bij.to_integer_32]
								l_bi := a_b___0.item.data[(l_bij + {NATURAL_32} 1).to_integer_32]
								l_tmp := hypot (l_br.to_double, l_bi.to_double)
								update_class_fields -- Current might have been changed; synchronize
								l_s := (1.0 / l_tmp).truncated_to_real
								l_sbr := l_s * l_br
								l_sbi := l_s * l_bi
								data[l_aij.to_integer_32] := (l_ar * l_sbr + l_ai * l_sbi) * l_s
								update_class_fields -- Current might have been changed; synchronize
								data[(l_aij + {NATURAL_32} 1).to_integer_32] := (l_ai * l_sbr - l_ar * l_sbi) * l_s
								update_class_fields -- Current might have been changed; synchronize
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
						Result := 0
						l_return := True
				when 7 then -- if done
					if not l_return then
						Result := 0
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_matrix_complex_float_scale (a_x: PD_GSL_COMPLEX_FLOAT): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_xr: REAL_32
			l_xi: REAL_32
			l_aij: NATURAL_32
			l_ar: REAL_32
			l_ai: REAL_32
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_xr := a_x.dat[0]
			l_xi := a_x.dat[1]
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					l_aij := {NATURAL_32} 2 * (l_i * l_tda + l_j)
					l_ar := data[l_aij.to_integer_32]
					l_ai := data[(l_aij + {NATURAL_32} 1).to_integer_32]
					data[l_aij.to_integer_32] := l_ar * l_xr - l_ai * l_xi
					update_class_fields -- Current might have been changed; synchronize
					data[(l_aij + {NATURAL_32} 1).to_integer_32] := l_ar * l_xi + l_ai * l_xr
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_float_add_constant (a_x: PD_GSL_COMPLEX_FLOAT): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_return: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_M))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_N)
				loop
					data[({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32] := data[({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32] + (a_x.dat[0])
					update_class_fields -- Current might have been changed; synchronize
					data[({NATURAL_32} 2 * (l_i * l_tda + l_j) + {NATURAL_32} 1).to_integer_32] := data[({NATURAL_32} 2 * (l_i * l_tda + l_j) + {NATURAL_32} 1).to_integer_32] + (a_x.dat[1])
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_float_add_diagonal (a_x: PD_GSL_COMPLEX_FLOAT): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_loop_lim: NATURAL_32
			l_tmp: NATURAL_32
			l_i: NATURAL_32
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			if l_M < l_N then
				l_tmp := l_M
			else
				l_tmp := l_N
			end
			l_loop_lim := l_tmp
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_loop_lim)
			loop
				data[({NATURAL_32} 2 * (l_i * l_tda + l_i)).to_integer_32] := data[({NATURAL_32} 2 * (l_i * l_tda + l_i)).to_integer_32] + (a_x.dat[0])
				update_class_fields -- Current might have been changed; synchronize
				data[({NATURAL_32} 2 * (l_i * l_tda + l_i) + {NATURAL_32} 1).to_integer_32] := data[({NATURAL_32} 2 * (l_i * l_tda + l_i) + {NATURAL_32} 1).to_integer_32] + (a_x.dat[1])
				update_class_fields -- Current might have been changed; synchronize
				l_i := l_i + 1
			end
			Result := 0
		end

	gsl_matrix_complex_float_set_row (a_i: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_row_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 99, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_N) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix row size and vector length are not equal"), ce_string ("getset_source.c"), 105, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_row_data := data + (({NATURAL_32} 2 * a_i) * l_tda).to_integer_32
				l_stride := a_v.item.stride
				l_j := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_j < l_N))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_row_data[({NATURAL_32} 2 * l_j + l_k).to_integer_32] := l_v_data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
					l_j := l_j + 1
				end
				Result := 0
			end
		end

	gsl_matrix_complex_float_set_col (a_j: NATURAL_32; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_M: NATURAL_32
			l_N: NATURAL_32
			l_tda: NATURAL_32
			l_v_data: CE_POINTER [REAL_32]
			l_column_data: CE_POINTER [REAL_32]
			l_stride: NATURAL_32
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_M := size1
			l_N := size2
			l_tda := tda
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 140, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := 4
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return and then (a_v.item.size /= l_M) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix column size and vector length are not equal"), ce_string ("getset_source.c"), 146, 19)
					update_class_fields -- Current might have been changed; synchronize
					Result := 19
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_v_data := a_v.item.data
				l_column_data := data + ({NATURAL_32} 2 * a_j).to_integer_32
				l_stride := a_v.item.stride
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < l_M))
				loop
					l_k := {NATURAL_32} 0
					from
					until
						not (l_k < {NATURAL_32} 2)
					loop
						l_column_data[(({NATURAL_32} 2 * l_i) * l_tda + l_k).to_integer_32] := l_v_data[(({NATURAL_32} 2 * l_stride) * l_i + l_k).to_integer_32]
						update_class_fields -- Current might have been changed; synchronize
						l_k := l_k + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

	gsl_vector_complex_float_alloc_row_from_matrix (a_i: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
			l_M: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_M := size1
			if a_i >= l_M then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("getset_source.c"), 181, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_VECTOR_COMPLEX_FLOAT}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_cast (l_tmp)
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 189, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := data + (({NATURAL_32} 2 * a_i) * tda).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.size := size2
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.stride := (1).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_v
			end
		end

	gsl_vector_complex_float_alloc_col_from_matrix (a_j: NATURAL_32): CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
		local
			l_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]
			l_N: NATURAL_32
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			l_N := size2
			if a_j >= l_N then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("getset_source.c"), 210, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_VECTOR_COMPLEX_FLOAT}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_v := create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_cast (l_tmp)
				if l_v.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for vector struct"), ce_string ("getset_source.c"), 218, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_v.item.data := data + ({NATURAL_32} 2 * a_j).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.size := size1
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.stride := tda
				update_class_fields -- Current might have been changed; synchronize
				l_v.item.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_v
			end
		end

	gsl_matrix_complex_float_fread (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_status := 0
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			if l_tda = l_size2 then
				l_status := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_complex_float_raw_fread (a_stream, data, l_size1 * l_size2, (1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < l_size1))
				loop
					l_break := False
					l_status := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_complex_float_raw_fread (a_stream, data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_status.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			Result := l_status
		end

	gsl_matrix_complex_float_fwrite (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_status := 0
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			if l_tda = l_size2 then
				l_status := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_complex_float_raw_fwrite (a_stream, data, l_size1 * l_size2, (1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < l_size1))
				loop
					l_break := False
					l_status := (create {P_FWRITE_SOURCE_STATIC}).gsl_block_complex_float_raw_fwrite (a_stream, (data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_status.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			Result := l_status
		end

	gsl_matrix_complex_float_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_status := 0
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			if l_tda = l_size2 then
				l_status := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_complex_float_raw_fprintf (a_stream, data, l_size1 * l_size2, (1).to_natural_32, a_format)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < l_size1))
				loop
					l_break := False
					l_status := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_complex_float_raw_fprintf (a_stream, (data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					update_class_fields -- Current might have been changed; synchronize
					if l_status.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			Result := l_status
		end

	gsl_matrix_complex_float_fscanf (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_break: BOOLEAN
		do
			l_status := 0
			l_size1 := size1
			l_size2 := size2
			l_tda := tda
			if l_tda = l_size2 then
				l_status := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_complex_float_raw_fscanf (a_stream, data, l_size1 * l_size2, (1).to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
			else
				l_i := (0).to_natural_32
				from
				until
					not (not (l_break) and then (l_i < l_size1))
				loop
					l_break := False
					l_status := (create {P_FPRINTF_SOURCE_STATIC}).gsl_block_complex_float_raw_fscanf (a_stream, data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_status.to_boolean then
						l_break := True
					end
					if not (l_break) then
						l_i := l_i + 1
					end
				end
				l_break := False
			end
			Result := l_status
		end

	gsl_matrix_complex_float_submatrix (a_i, a_j, a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_VIEW
			l_s: PD_GSL_MATRIX_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.size2 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.tda := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_i + a_n1 > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_j + a_n2 > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.size1 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.size2 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.tda := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := data + ({NATURAL_32} 2 * (a_i * tda + a_j)).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_s.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_s.tda := tda
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.matrix := l_s.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_const_submatrix (a_i, a_j, a_n1, a_n2: NATURAL_32): PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
		local
			l_view: PD_GSL_MATRIX_COMPLEX_FLOAT_CONST_VIEW
			l_s: PD_GSL_MATRIX_COMPLEX_FLOAT
			l_return, l_break: BOOLEAN
		do
			create l_view.make
			create l_s.make

			l_view.matrix.size1 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.size2 := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.tda := (0).to_natural_32
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
			update_class_fields -- Current might have been changed; synchronize
			l_view.matrix.owner := 0
			update_class_fields -- Current might have been changed; synchronize
			if a_i >= size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("row index is out of range"), ce_string ("submatrix_source.c"), 29, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_j >= size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("column index is out of range"), ce_string ("submatrix_source.c"), 33, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first dimension must be non-zero"), ce_string ("submatrix_source.c"), 37, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second dimension must be non-zero"), ce_string ("submatrix_source.c"), 41, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_i + a_n1 > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("first dimension overflows matrix"), ce_string ("submatrix_source.c"), 45, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_j + a_n2 > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("second dimension overflows matrix"), ce_string ("submatrix_source.c"), 49, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := l_view.twin
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_s.size1 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.size2 := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.tda := (0).to_natural_32
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := create {CE_REAL_32_POINTER}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := create {CE_CLASS_POINTER [PD_GSL_BLOCK_COMPLEX_FLOAT_STRUCT]}.make_shared (default_pointer)
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_s.data := (data + ({NATURAL_32} 2 * (a_i * tda + a_j)).to_integer_32)
				update_class_fields -- Current might have been changed; synchronize
				l_s.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_s.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_s.tda := tda
				update_class_fields -- Current might have been changed; synchronize
				l_s.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_s.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				l_view.matrix := l_s.twin
				update_class_fields -- Current might have been changed; synchronize
				Result := l_view.twin
			end
		end

	gsl_matrix_complex_float_alloc_from_matrix (a_k1, a_k2, a_n1, a_n2: NATURAL_32): CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]
		local
			l_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]
			l_tmp: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
		do
			if a_n1 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n1 must be positive integer"), ce_string ("init_source.c"), 146, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_n2 = {NATURAL_32} 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("matrix dimension n2 must be positive integer"), ce_string ("init_source.c"), 151, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_k1 + a_n1 > size1 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("submatrix dimension 1 exceeds size of original"), ce_string ("init_source.c"), 156, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			elseif a_k2 + a_n2 > size2 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("submatrix dimension 2 exceeds size of original"), ce_string ("init_source.c"), 161, 4)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				l_tmp := malloc ((create {PD_GSL_MATRIX_COMPLEX_FLOAT}.make).structure_size.to_natural_32)
				update_class_fields -- Current might have been changed; synchronize
				l_m___4 := create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_cast (l_tmp)
				if l_m___4.is_void then
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).gsl_error (ce_string ("failed to allocate space for matrix struct"), ce_string ("init_source.c"), 169, 8)
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_CLASS_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]}.make_shared (default_pointer))
						l_return := True
						if not l_return then
							l_break := True
						end
					end
					if not l_return then
						l_break := False
					end
				end
			end
			if not l_return then
				l_m___4.item.data := (data + (a_k1 * tda).to_integer_32) + a_k2.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.size1 := a_n1
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.size2 := a_n2
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.tda := tda
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.block := block
				update_class_fields -- Current might have been changed; synchronize
				l_m___4.item.owner := 0
				update_class_fields -- Current might have been changed; synchronize
				Result := l_m___4
			end
		end

	gsl_matrix_complex_float_set_identity
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_q___3: NATURAL_32
			l_tda: NATURAL_32
			l_zero: PD_GSL_COMPLEX_FLOAT
			l_one: PD_GSL_COMPLEX_FLOAT
			l_return: BOOLEAN
		do
			create l_zero.make
			create l_one.make

			l_data := data
			l_p := size1
			l_q___3 := size2
			l_tda := tda
			l_zero.dat[0] := {REAL_32} 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_zero.dat[1] := {REAL_32} 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_one.dat[0] := {REAL_32} 1.0
			update_class_fields -- Current might have been changed; synchronize
			l_one.dat[1] := {REAL_32} 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_p))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_q___3)
				loop
					if l_i = l_j then
						(create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((l_data + ({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32))).item := l_one.twin
						update_class_fields -- Current might have been changed; synchronize
					else
						(create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((l_data + ({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32))).item := l_zero.twin
						update_class_fields -- Current might have been changed; synchronize
					end
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
		end

	gsl_matrix_complex_float_set_zero
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_q___3: NATURAL_32
			l_tda: NATURAL_32
			l_zero: PD_GSL_COMPLEX_FLOAT
			l_return: BOOLEAN
		do
			create l_zero.make

			l_data := data
			l_p := size1
			l_q___3 := size2
			l_tda := tda
			l_zero.dat[0] := {REAL_32} 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_zero.dat[1] := {REAL_32} 0.0
			update_class_fields -- Current might have been changed; synchronize
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_p))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_q___3)
				loop
					(create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((l_data + ({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32))).item := l_zero.twin
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
		end

	gsl_matrix_complex_float_set_all (a_x: PD_GSL_COMPLEX_FLOAT)
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_data: CE_POINTER [REAL_32]
			l_p: NATURAL_32
			l_q___3: NATURAL_32
			l_tda: NATURAL_32
			l_return: BOOLEAN
		do
			l_data := data
			l_p := size1
			l_q___3 := size2
			l_tda := tda
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < l_p))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (l_j < l_q___3)
				loop
					(create {CE_CLASS_POINTER [PD_GSL_COMPLEX_FLOAT]}.make_cast ((l_data + ({NATURAL_32} 2 * (l_i * l_tda + l_j)).to_integer_32))).item := a_x.twin
					update_class_fields -- Current might have been changed; synchronize
					l_j := l_j + 1
				end
				l_i := l_i + 1
			end
		end

feature {PD_GSL_MATRIX_COMPLEX_FLOAT} -- private routines

	cblas_cgemm (a_Order, a_TransA, a_TransB: NATURAL_32; a_M, a_N, a_K: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32; a_beta, a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_ldf: INTEGER_32
			l_ldg: INTEGER_32
			l_conjF: INTEGER_32
			l_conjG: INTEGER_32
			l_TransF: INTEGER_32
			l_TransG: INTEGER_32
			l_F___0: CE_POINTER [REAL_32]
			l_G: CE_POINTER [REAL_32]
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_Cij_real: REAL_32
			l_Cij_imag: REAL_32
			l_Fik_real: REAL_32
			l_Fik_imag: REAL_32
			l_temp_real: REAL_32
			l_temp_imag: REAL_32
			l_Gkj_real: REAL_32
			l_Gkj_imag: REAL_32
			l_temp_real___0: REAL_32
			l_temp_imag___0: REAL_32
			l_Fik_real___0: REAL_32
			l_Fik_imag___0: REAL_32
			l_Gjk_real: REAL_32
			l_Gjk_imag: REAL_32
			l_Fki_real: REAL_32
			l_Fki_imag: REAL_32
			l_temp_real___1: REAL_32
			l_temp_imag___1: REAL_32
			l_Gkj_real___0: REAL_32
			l_Gkj_imag___0: REAL_32
			l_temp_real___2: REAL_32
			l_temp_imag___2: REAL_32
			l_Fki_real___0: REAL_32
			l_Fki_imag___0: REAL_32
			l_Gjk_real___0: REAL_32
			l_Gjk_imag___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_REAL_32_POINTER} l_F___0.make
			create {CE_REAL_32_POINTER} l_G.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_REAL_32_POINTER}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_REAL_32_POINTER}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Order = {NATURAL_32} 101 then
							l_n1 := a_M
							l_n2 := a_N
							l_F___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)
							l_ldf := a_lda
							if a_TransA = {NATURAL_32} 113 then
								l_conjF := -1
							else
								l_conjF := 1
							end
							if a_TransA = {NATURAL_32} 111 then
								l_TransF := 111
							else
								l_TransF := 112
							end
							l_G := create {CE_REAL_32_POINTER}.make_cast (a_B)
							l_ldg := a_ldb
							if a_TransB = {NATURAL_32} 113 then
								l_conjG := -1
							else
								l_conjG := 1
							end
							if a_TransB = {NATURAL_32} 111 then
								l_TransG := 111
							else
								l_TransG := 112
							end
						else
							l_n1 := a_N
							l_n2 := a_M
							l_F___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)
							l_ldf := a_ldb
							if a_TransB = {NATURAL_32} 113 then
								l_conjF := -1
							else
								l_conjF := 1
							end
							if a_TransB = {NATURAL_32} 111 then
								l_TransF := 111
							else
								l_TransF := 112
							end
							l_G := create {CE_REAL_32_POINTER}.make_cast (a_A___0)
							l_ldg := a_lda
							if a_TransA = {NATURAL_32} 113 then
								l_conjG := -1
							else
								l_conjG := 1
							end
							if a_TransA = {NATURAL_32} 111 then
								l_TransG := 111
							else
								l_TransG := 112
							end
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Cij_real := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
								l_Cij_imag := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real - l_beta_imag * l_Cij_imag
								create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag + l_beta_imag * l_Cij_real
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								l_return := True
							end
						end
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 44 -- skip if block
					end
				when 10 then -- if:
						if l_TransF /= 111 then
							l_pos := -1 + 25 -- skip if block
						end
				when 11 then -- if:
						if l_TransG /= 111 then
							l_pos := -1 + 23 -- skip if block
						end
				when 12 then -- if:
						l_k := 0
				when 13 then -- loop condition:
						if not (not (l_return) and then (l_k < a_K)) then
							l_pos := -1 + 22 -- skip loop
						end
				when 14 then -- loop body:
						l_i := 0
				when 15 then -- loop condition:
						if not (not (l_return) and then (l_i < l_n1)) then
							l_pos := -1 + 21 -- skip loop
						end
				when 16 then -- loop body:
						l_Fik_real := l_F___0[2 * (l_ldf * l_i + l_k)]
						l_Fik_imag := (l_conjF.to_real * l_F___0[(2 * (l_ldf * l_i + l_k) + 1)])
						l_temp_real := l_alpha_real * l_Fik_real - l_alpha_imag * l_Fik_imag
						l_temp_imag := l_alpha_real * l_Fik_imag + l_alpha_imag * l_Fik_real
						if l_temp_real.to_double /= 0.0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_temp_imag.to_double /= 0.0 then
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						l_j := 0
						from
						until
							not (l_j < l_n2)
						loop
							l_Gkj_real := l_G[2 * (l_ldg * l_k + l_j)]
							l_Gkj_imag := (l_conjG.to_real * l_G[(2 * (l_ldg * l_k + l_j) + 1)])
							create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] + (l_temp_real * l_Gkj_real - l_temp_imag * l_Gkj_imag)
							create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] + (l_temp_real * l_Gkj_imag + l_temp_imag * l_Gkj_real)
							l_j := l_j + 1
						end
				when 20 then
						l_i := l_i + 1
						l_pos := -1 + 15 -- back to loop condition
				when 21 then -- loop done
						l_k := l_k + 1
						l_pos := -1 + 13 -- back to loop condition
				when 22 then -- loop done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___5
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 25 then -- else: | _L___5:
						if l_TransF /= 111 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_TransG = 112 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < l_n2))
								loop
									l_temp_real___0 := (0.0).truncated_to_real
									l_temp_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Fik_real___0 := l_F___0[2 * (l_ldf * l_i + l_k)]
										l_Fik_imag___0 := (l_conjF.to_real * l_F___0[(2 * (l_ldf * l_i + l_k) + 1)])
										l_Gjk_real := l_G[2 * (l_ldg * l_j + l_k)]
										l_Gjk_imag := (l_conjG.to_real * l_G[(2 * (l_ldg * l_j + l_k) + 1)])
										l_temp_real___0 := l_temp_real___0 + (l_Fik_real___0 * l_Gjk_real - l_Fik_imag___0 * l_Gjk_imag)
										l_temp_imag___0 := l_temp_imag___0 + (l_Fik_real___0 * l_Gjk_imag + l_Fik_imag___0 * l_Gjk_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] + (l_alpha_real * l_temp_real___0 - l_alpha_imag * l_temp_imag___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] + (l_alpha_real * l_temp_imag___0 + l_alpha_imag * l_temp_real___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 28 -- goto _L___4
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 28 then -- else: | _L___4:
						if l_TransF /= 112 then
							l_pos := -1 + 43 -- skip if block
						end
				when 29 then -- if:
						if l_TransG /= 111 then
							l_pos := -1 + 41 -- skip if block
						end
				when 30 then -- if:
						l_k := 0
				when 31 then -- loop condition:
						if not (not (l_return) and then (l_k < a_K)) then
							l_pos := -1 + 40 -- skip loop
						end
				when 32 then -- loop body:
						l_i := 0
				when 33 then -- loop condition:
						if not (not (l_return) and then (l_i < l_n1)) then
							l_pos := -1 + 39 -- skip loop
						end
				when 34 then -- loop body:
						l_Fki_real := l_F___0[2 * (l_ldf * l_k + l_i)]
						l_Fki_imag := (l_conjF.to_real * l_F___0[(2 * (l_ldf * l_k + l_i) + 1)])
						l_temp_real___1 := l_alpha_real * l_Fki_real - l_alpha_imag * l_Fki_imag
						l_temp_imag___1 := l_alpha_real * l_Fki_imag + l_alpha_imag * l_Fki_real
						if l_temp_real___1.to_double /= 0.0 then
							l_pos := -1 + 37 -- skip if block
						end
				when 35 then -- if:
						if l_temp_imag___1.to_double /= 0.0 then
							l_pos := -1 + 37 -- goto _L___2
						end
				when 36 then -- if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else: | _L___2:
						l_j := 0
						from
						until
							not (l_j < l_n2)
						loop
							l_Gkj_real___0 := l_G[2 * (l_ldg * l_k + l_j)]
							l_Gkj_imag___0 := (l_conjG.to_real * l_G[(2 * (l_ldg * l_k + l_j) + 1)])
							create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] + (l_temp_real___1 * l_Gkj_real___0 - l_temp_imag___1 * l_Gkj_imag___0)
							create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] + (l_temp_real___1 * l_Gkj_imag___0 + l_temp_imag___1 * l_Gkj_real___0)
							l_j := l_j + 1
						end
				when 38 then
						l_i := l_i + 1
						l_pos := -1 + 33 -- back to loop condition
				when 39 then -- loop done
						l_k := l_k + 1
						l_pos := -1 + 31 -- back to loop condition
				when 40 then -- loop done | if block done, skip else block:
						l_pos := -1 + 42
				when 41 then -- else:
						l_pos := -1 + 43 -- goto _L___3
				when 42 then -- if done | if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else: | _L___3:
						if l_TransF = 112 then
							if l_TransG = 112 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j < l_n2))
									loop
										l_temp_real___2 := (0.0).truncated_to_real
										l_temp_imag___2 := (0.0).truncated_to_real
										l_k := 0
										from
										until
											not (l_k < a_K)
										loop
											l_Fki_real___0 := l_F___0[2 * (l_ldf * l_k + l_i)]
											l_Fki_imag___0 := (l_conjF.to_real * l_F___0[(2 * (l_ldf * l_k + l_i) + 1)])
											l_Gjk_real___0 := l_G[2 * (l_ldg * l_j + l_k)]
											l_Gjk_imag___0 := (l_conjG.to_real * l_G[(2 * (l_ldg * l_j + l_k) + 1)])
											l_temp_real___2 := l_temp_real___2 + (l_Fki_real___0 * l_Gjk_real___0 - l_Fki_imag___0 * l_Gjk_imag___0)
											l_temp_imag___2 := l_temp_imag___2 + (l_Fki_real___0 * l_Gjk_imag___0 + l_Fki_imag___0 * l_Gjk_real___0)
											l_k := l_k + 1
										end
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] + (l_alpha_real * l_temp_real___2 - l_alpha_imag * l_temp_imag___2)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] + (l_alpha_real * l_temp_imag___2 + l_alpha_imag * l_temp_real___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_gemm_c.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_gemm_c.h"), ce_string ("unrecognized operation")])
						end
				when 44 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_cgemv (a_order, a_TransA: NATURAL_32; a_M, a_N: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_beta, a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_lenX: INTEGER_32
			l_lenY: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_iy: INTEGER_32
			l_tmp: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___0: INTEGER_32
			l_y_real: REAL_32
			l_y_imag: REAL_32
			l_tmpR: REAL_32
			l_tmpI: REAL_32
			l_iy___1: INTEGER_32
			l_tmp___1: INTEGER_32
			l_dotR: REAL_32
			l_dotI: REAL_32
			l_ix: INTEGER_32
			l_tmp___2: INTEGER_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_A_real: REAL_32
			l_A_imag: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_tmpR___0: REAL_32
			l_tmpI___0: REAL_32
			l_iy___2: INTEGER_32
			l_tmp___4: INTEGER_32
			l_A_real___0: REAL_32
			l_A_imag___0: REAL_32
			l_ix___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_x_real___1: REAL_32
			l_x_imag___1: REAL_32
			l_tmpR___1: REAL_32
			l_tmpI___1: REAL_32
			l_iy___3: INTEGER_32
			l_tmp___6: INTEGER_32
			l_A_real___1: REAL_32
			l_A_imag___1: REAL_32
			l_iy___4: INTEGER_32
			l_tmp___7: INTEGER_32
			l_dotR___0: REAL_32
			l_dotI___0: REAL_32
			l_ix___2: INTEGER_32
			l_tmp___8: INTEGER_32
			l_x_real___2: REAL_32
			l_x_imag___2: REAL_32
			l_A_real___2: REAL_32
			l_A_imag___2: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_REAL_32_POINTER}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_REAL_32_POINTER}.make_cast (a_beta)[1]
					if a_M = 0 then
						l_return := True
					elseif a_N = 0 then
						l_return := True
					end
					if not l_return and then (l_alpha_real.to_double = 0.0) then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_TransA = {NATURAL_32} 111 then
							l_lenX := a_N
							l_lenY := a_M
						else
							l_lenX := a_M
							l_lenY := a_N
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							if a_incY > 0 then
								l_tmp := 0
							else
								l_tmp := (l_lenY - 1) * -a_incY
							end
							l_iy := l_tmp
							l_i := 0
							from
							until
								not (l_i < l_lenY)
							loop
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy] := (0.0).truncated_to_real
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)] := (0.0).truncated_to_real
								l_iy := l_iy + a_incY
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_incY > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (l_lenY - 1) * -a_incY
						end
						l_iy___0 := l_tmp___0
						l_i := 0
						from
						until
							not (l_i < l_lenY)
						loop
							l_y_real := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___0]
							l_y_imag := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___0 + 1)]
							l_tmpR := l_y_real * l_beta_real - l_y_imag * l_beta_imag
							l_tmpI := l_y_real * l_beta_imag + l_y_imag * l_beta_real
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___0] := l_tmpR
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___0 + 1)] := l_tmpI
							l_iy___0 := l_iy___0 + a_incY
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								l_return := True
							end
						end
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 10 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_TransA = {NATURAL_32} 111 then
							l_pos := -1 + 15 -- goto _L___5
						else
							l_pos := -1 + 13 -- goto _L___7
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 13 then -- else: | _L___7:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_TransA /= {NATURAL_32} 112 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___5:
						if a_incY > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (l_lenY - 1) * -a_incY
						end
						l_iy___1 := l_tmp___1
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_lenY))
						loop
							l_dotR := (0.0).truncated_to_real
							l_dotI := (0.0).truncated_to_real
							if a_incX > 0 then
								l_tmp___2 := 0
							else
								l_tmp___2 := (l_lenX - 1) * -a_incX
							end
							l_ix := l_tmp___2
							l_j := 0
							from
							until
								not (l_j < l_lenX)
							loop
								l_x_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
								l_x_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
								l_A_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
								l_A_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)]
								l_dotR := l_dotR + (l_A_real * l_x_real - l_A_imag * l_x_imag)
								l_dotI := l_dotI + (l_A_real * l_x_imag + l_A_imag * l_x_real)
								l_ix := l_ix + a_incX
								l_j := l_j + 1
							end
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___1] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___1] + (l_alpha_real * l_dotR - l_alpha_imag * l_dotI)
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___1 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___1 + 1)] + (l_alpha_real * l_dotI + l_alpha_imag * l_dotR)
							l_iy___1 := l_iy___1 + a_incY
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___6
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 19 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if a_TransA = {NATURAL_32} 112 then
							l_pos := -1 + 24 -- goto _L___2
						else
							l_pos := -1 + 22 -- goto _L___4
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 22 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						if a_TransA /= {NATURAL_32} 111 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___3 := 0
						else
							l_tmp___3 := (l_lenX - 1) * -a_incX
						end
						l_ix___0 := l_tmp___3
						l_j := 0
						from
						until
							not (not (l_return) and then (l_j < l_lenX))
						loop
							l_x_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0]
							l_x_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
							l_tmpR___0 := l_alpha_real * l_x_real___0 - l_alpha_imag * l_x_imag___0
							l_tmpI___0 := l_alpha_real * l_x_imag___0 + l_alpha_imag * l_x_real___0
							if a_incY > 0 then
								l_tmp___4 := 0
							else
								l_tmp___4 := (l_lenY - 1) * -a_incY
							end
							l_iy___2 := l_tmp___4
							l_i := 0
							from
							until
								not (l_i < l_lenY)
							loop
								l_A_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_i)]
								l_A_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_i) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___2] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___2] + (l_A_real___0 * l_tmpR___0 - l_A_imag___0 * l_tmpI___0)
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___2 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___2 + 1)] + (l_A_real___0 * l_tmpI___0 + l_A_imag___0 * l_tmpR___0)
								l_iy___2 := l_iy___2 + a_incY
								l_i := l_i + 1
							end
							l_ix___0 := l_ix___0 + a_incX
							l_j := l_j + 1
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_pos := -1 + 28 -- goto _L___3
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 28 then -- else: | _L___3:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if a_TransA = {NATURAL_32} 113 then
							if a_incX > 0 then
								l_tmp___5 := 0
							else
								l_tmp___5 := (l_lenX - 1) * -a_incX
							end
							l_ix___1 := l_tmp___5
							l_j := 0
							from
							until
								not (not (l_return) and then (l_j < l_lenX))
							loop
								l_x_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1]
								l_x_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)]
								l_tmpR___1 := l_alpha_real * l_x_real___1 - l_alpha_imag * l_x_imag___1
								l_tmpI___1 := l_alpha_real * l_x_imag___1 + l_alpha_imag * l_x_real___1
								if a_incY > 0 then
									l_tmp___6 := 0
								else
									l_tmp___6 := (l_lenY - 1) * -a_incY
								end
								l_iy___3 := l_tmp___6
								l_i := 0
								from
								until
									not (l_i < l_lenY)
								loop
									l_A_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_i)]
									l_A_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_i) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___3] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___3] + (l_A_real___1 * l_tmpR___1 - -l_A_imag___1 * l_tmpI___1)
									create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___3 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___3 + 1)] + (l_A_real___1 * l_tmpI___1 + -l_A_imag___1 * l_tmpR___1)
									l_iy___3 := l_iy___3 + a_incY
									l_i := l_i + 1
								end
								l_ix___1 := l_ix___1 + a_incX
								l_j := l_j + 1
							end
						else
							l_pos := -1 + 31 -- goto _L___1
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___1:
						if a_order = {NATURAL_32} 102 then
							if a_TransA = {NATURAL_32} 113 then
								if a_incY > 0 then
									l_tmp___7 := 0
								else
									l_tmp___7 := (l_lenY - 1) * -a_incY
								end
								l_iy___4 := l_tmp___7
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_lenY))
								loop
									l_dotR___0 := (0.0).truncated_to_real
									l_dotI___0 := (0.0).truncated_to_real
									if a_incX > 0 then
										l_tmp___8 := 0
									else
										l_tmp___8 := (l_lenX - 1) * -a_incX
									end
									l_ix___2 := l_tmp___8
									l_j := 0
									from
									until
										not (l_j < l_lenX)
									loop
										l_x_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2]
										l_x_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)]
										l_A_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
										l_A_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)]
										l_dotR___0 := l_dotR___0 + (l_A_real___2 * l_x_real___2 - -l_A_imag___2 * l_x_imag___2)
										l_dotI___0 := l_dotI___0 + (l_A_real___2 * l_x_imag___2 + -l_A_imag___2 * l_x_real___2)
										l_ix___2 := l_ix___2 + a_incX
										l_j := l_j + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___4] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___4] + (l_alpha_real * l_dotR___0 - l_alpha_imag * l_dotI___0)
									create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___4 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___4 + 1)] + (l_alpha_real * l_dotI___0 + l_alpha_imag * l_dotR___0)
									l_iy___4 := l_iy___4 + a_incY
									l_i := l_i + 1
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_gemv_c.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_gemv_c.h"), ce_string ("unrecognized operation")])
						end
				when 32 then -- if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_chemm (a_Order, a_Side, a_Uplo: NATURAL_32; a_M, a_N: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32; a_beta, a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_uplo: INTEGER_32
			l_side: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_Cij_real: REAL_32
			l_Cij_imag: REAL_32
			l_Bij_real: REAL_32
			l_Bij_imag: REAL_32
			l_temp1_real: REAL_32
			l_temp1_imag: REAL_32
			l_temp2_real: REAL_32
			l_temp2_imag: REAL_32
			l_Aii_real: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Bkj_real: REAL_32
			l_Bkj_imag: REAL_32
			l_Bij_real___0: REAL_32
			l_Bij_imag___0: REAL_32
			l_temp1_real___0: REAL_32
			l_temp1_imag___0: REAL_32
			l_temp2_real___0: REAL_32
			l_temp2_imag___0: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Bkj_real___0: REAL_32
			l_Bkj_imag___0: REAL_32
			l_Aii_real___0: REAL_32
			l_Bij_real___1: REAL_32
			l_Bij_imag___1: REAL_32
			l_temp1_real___1: REAL_32
			l_temp1_imag___1: REAL_32
			l_temp2_real___1: REAL_32
			l_temp2_imag___1: REAL_32
			l_Ajj_real: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_Bik_real: REAL_32
			l_Bik_imag: REAL_32
			l_Bij_real___2: REAL_32
			l_Bij_imag___2: REAL_32
			l_temp1_real___2: REAL_32
			l_temp1_imag___2: REAL_32
			l_temp2_real___2: REAL_32
			l_temp2_imag___2: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_Bik_real___0: REAL_32
			l_Bik_imag___0: REAL_32
			l_Ajj_real___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_REAL_32_POINTER}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_REAL_32_POINTER}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Order = {NATURAL_32} 101 then
							l_n1 := a_M
							l_n2 := a_N
							l_uplo := a_Uplo.to_integer_32
							l_side := a_Side.to_integer_32
						else
							l_n1 := a_N
							l_n2 := a_M
							if a_Uplo = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Side = {NATURAL_32} 141 then
								l_side := 142
							else
								l_side := 141
							end
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Cij_real := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
								l_Cij_imag := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real - l_beta_imag * l_Cij_imag
								create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag + l_beta_imag * l_Cij_real
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								l_return := True
							end
						end
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 10 then -- if:
						if l_side /= 141 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < l_n2))
								loop
									l_Bij_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real := l_alpha_real * l_Bij_real - l_alpha_imag * l_Bij_imag
									l_temp1_imag := l_alpha_real * l_Bij_imag + l_alpha_imag * l_Bij_real
									l_temp2_real := (0.0).truncated_to_real
									l_temp2_imag := (0.0).truncated_to_real
									l_Aii_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real * l_Aii_real)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_imag * l_Aii_real)
									l_k := l_i + 1
									from
									until
										not (l_k < l_n1)
									loop
										l_Aik_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Bkj_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)]
										l_Bkj_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] + (l_Aik_real * l_temp1_real - -l_Aik_imag * l_temp1_imag)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] + (l_Aik_real * l_temp1_imag + -l_Aik_imag * l_temp1_real)
										l_temp2_real := l_temp2_real + (l_Aik_real * l_Bkj_real - l_Aik_imag * l_Bkj_imag)
										l_temp2_imag := l_temp2_imag + (l_Aik_real * l_Bkj_imag + l_Aik_imag * l_Bkj_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real - l_alpha_imag * l_temp2_imag)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag + l_alpha_imag * l_temp2_real)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___3:
						if l_side /= 141 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_uplo = 122 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < l_n2))
								loop
									l_Bij_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real___0 := l_alpha_real * l_Bij_real___0 - l_alpha_imag * l_Bij_imag___0
									l_temp1_imag___0 := l_alpha_real * l_Bij_imag___0 + l_alpha_imag * l_Bij_real___0
									l_temp2_real___0 := (0.0).truncated_to_real
									l_temp2_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < l_i)
									loop
										l_Aik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Bkj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)]
										l_Bkj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] + (l_Aik_real___0 * l_temp1_real___0 - -l_Aik_imag___0 * l_temp1_imag___0)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] + (l_Aik_real___0 * l_temp1_imag___0 + -l_Aik_imag___0 * l_temp1_real___0)
										l_temp2_real___0 := l_temp2_real___0 + (l_Aik_real___0 * l_Bkj_real___0 - l_Aik_imag___0 * l_Bkj_imag___0)
										l_temp2_imag___0 := l_temp2_imag___0 + (l_Aik_real___0 * l_Bkj_imag___0 + l_Aik_imag___0 * l_Bkj_real___0)
										l_k := l_k + 1
									end
									l_Aii_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___0 * l_Aii_real___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_imag___0 * l_Aii_real___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___0 - l_alpha_imag * l_temp2_imag___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___0 + l_alpha_imag * l_temp2_real___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 16 -- goto _L___2
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else: | _L___2:
						if l_side /= 142 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < l_n2))
								loop
									l_Bij_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real___1 := l_alpha_real * l_Bij_real___1 - l_alpha_imag * l_Bij_imag___1
									l_temp1_imag___1 := l_alpha_real * l_Bij_imag___1 + l_alpha_imag * l_Bij_real___1
									l_temp2_real___1 := (0.0).truncated_to_real
									l_temp2_imag___1 := (0.0).truncated_to_real
									l_Ajj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___1 * l_Ajj_real)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_imag___1 * l_Ajj_real)
									l_k := l_j + 1
									from
									until
										not (l_k < l_n2)
									loop
										l_Ajk_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_Bik_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)]
										l_Bik_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] + (l_temp1_real___1 * l_Ajk_real - l_temp1_imag___1 * l_Ajk_imag)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] + (l_temp1_real___1 * l_Ajk_imag + l_temp1_imag___1 * l_Ajk_real)
										l_temp2_real___1 := l_temp2_real___1 + (l_Bik_real * l_Ajk_real - l_Bik_imag * -l_Ajk_imag)
										l_temp2_imag___1 := l_temp2_imag___1 + (l_Bik_real * -l_Ajk_imag + l_Bik_imag * l_Ajk_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___1 - l_alpha_imag * l_temp2_imag___1)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___1 + l_alpha_imag * l_temp2_real___1)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if l_side = 142 then
							if l_uplo = 122 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j < l_n2))
									loop
										l_Bij_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										l_temp1_real___2 := l_alpha_real * l_Bij_real___2 - l_alpha_imag * l_Bij_imag___2
										l_temp1_imag___2 := l_alpha_real * l_Bij_imag___2 + l_alpha_imag * l_Bij_real___2
										l_temp2_real___2 := (0.0).truncated_to_real
										l_temp2_imag___2 := (0.0).truncated_to_real
										l_k := 0
										from
										until
											not (l_k < l_j)
										loop
											l_Ajk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
											l_Ajk_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
											l_Bik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)]
											l_Bik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)]
											create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] + (l_temp1_real___2 * l_Ajk_real___0 - l_temp1_imag___2 * l_Ajk_imag___0)
											create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] + (l_temp1_real___2 * l_Ajk_imag___0 + l_temp1_imag___2 * l_Ajk_real___0)
											l_temp2_real___2 := l_temp2_real___2 + (l_Bik_real___0 * l_Ajk_real___0 - l_Bik_imag___0 * -l_Ajk_imag___0)
											l_temp2_imag___2 := l_temp2_imag___2 + (l_Bik_real___0 * -l_Ajk_imag___0 + l_Bik_imag___0 * l_Ajk_real___0)
											l_k := l_k + 1
										end
										l_Ajj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___2 * l_Ajj_real___0)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_imag___2 * l_Ajj_real___0)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___2 - l_alpha_imag * l_temp2_imag___2)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___2 + l_alpha_imag * l_temp2_real___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_hemm.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_hemm.h"), ce_string ("unrecognized operation")])
						end
				when 20 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_chemv (a_order, a_Uplo: NATURAL_32; a_N: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32; a_beta, a_Y: CE_POINTER [ANY]; a_incY: INTEGER_32)
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
			l_iy___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_y_real: REAL_32
			l_y_imag: REAL_32
			l_tmpR: REAL_32
			l_tmpI: REAL_32
			l_ix: INTEGER_32
			l_tmp___2: INTEGER_32
			l_iy___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_temp1_real: REAL_32
			l_temp1_imag: REAL_32
			l_temp2_real: REAL_32
			l_temp2_imag: REAL_32
			l_j_min: INTEGER_32
			l_j_max: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___4: INTEGER_32
			l_jy: INTEGER_32
			l_tmp___5: INTEGER_32
			l_Aii_real: REAL_32
			l_Aij_real: REAL_32
			l_Aij_imag: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___6: INTEGER_32
			l_iy___2: INTEGER_32
			l_tmp___7: INTEGER_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_temp1_real___0: REAL_32
			l_temp1_imag___0: REAL_32
			l_temp2_real___0: REAL_32
			l_temp2_imag___0: REAL_32
			l_j_min___0: INTEGER_32
			l_j_max___0: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___8: INTEGER_32
			l_jy___0: INTEGER_32
			l_tmp___9: INTEGER_32
			l_Aii_real___0: REAL_32
			l_Aij_real___0: REAL_32
			l_Aij_imag___0: REAL_32
			l_tmp___10: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_order = {NATURAL_32} 102 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_REAL_32_POINTER}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_REAL_32_POINTER}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							if a_incY > 0 then
								l_tmp___0 := 0
							else
								l_tmp___0 := (a_N - 1) * -a_incY
							end
							l_iy := l_tmp___0
							l_i := 0
							from
							until
								not (l_i < a_N)
							loop
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy] := (0.0).truncated_to_real
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy + 1)] := (0.0).truncated_to_real
								l_iy := l_iy + a_incY
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if a_incY > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incY
						end
						l_iy___0 := l_tmp___1
						l_i := 0
						from
						until
							not (l_i < a_N)
						loop
							l_y_real := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___0]
							l_y_imag := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___0 + 1)]
							l_tmpR := l_y_real * l_beta_real - l_y_imag * l_beta_imag
							l_tmpI := l_y_real * l_beta_imag + l_y_imag * l_beta_real
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___0] := l_tmpR
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___0 + 1)] := l_tmpI
							l_iy___0 := l_iy___0 + a_incY
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								l_return := True
							end
						end
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 29 -- skip if block
					end
				when 10 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_Uplo = {NATURAL_32} 121 then
							l_pos := -1 + 15 -- goto _L___3
						else
							l_pos := -1 + 13 -- goto _L___5
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 13 then -- else: | _L___5:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L___3:
						if a_incX > 0 then
							l_tmp___2 := 0
						else
							l_tmp___2 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___2
						if a_incY > 0 then
							l_tmp___3 := 0
						else
							l_tmp___3 := (a_N - 1) * -a_incY
						end
						l_iy___1 := l_tmp___3
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_x_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
							l_x_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							l_temp1_real := l_alpha_real * l_x_real - l_alpha_imag * l_x_imag
							l_temp1_imag := l_alpha_real * l_x_imag + l_alpha_imag * l_x_real
							l_temp2_real := (0.0).truncated_to_real
							l_temp2_imag := (0.0).truncated_to_real
							l_j_min := l_i + 1
							l_j_max := a_N
							if a_incX > 0 then
								l_tmp___4 := 0
							else
								l_tmp___4 := (a_N - 1) * -a_incX
							end
							l_jx := l_tmp___4 + l_j_min * a_incX
							if a_incY > 0 then
								l_tmp___5 := 0
							else
								l_tmp___5 := (a_N - 1) * -a_incY
							end
							l_jy := l_tmp___5 + l_j_min * a_incY
							l_Aii_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___1] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___1] + (l_temp1_real * l_Aii_real)
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___1 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___1 + 1)] + (l_temp1_imag * l_Aii_real)
							l_j := l_j_min
							from
							until
								not (l_j < l_j_max)
							loop
								l_Aij_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
								l_Aij_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)])
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_jy] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_jy] + (l_temp1_real * l_Aij_real - l_temp1_imag * -l_Aij_imag)
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_jy + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_jy + 1)] + (l_temp1_real * -l_Aij_imag + l_temp1_imag * l_Aij_real)
								l_x_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx]
								l_x_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
								l_temp2_real := l_temp2_real + (l_x_real * l_Aij_real - l_x_imag * l_Aij_imag)
								l_temp2_imag := l_temp2_imag + (l_x_real * l_Aij_imag + l_x_imag * l_Aij_real)
								l_jx := l_jx + a_incX
								l_jy := l_jy + a_incY
								l_j := l_j + 1
							end
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___1] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___1] + (l_alpha_real * l_temp2_real - l_alpha_imag * l_temp2_imag)
							create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___1 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___1 + 1)] + (l_alpha_real * l_temp2_imag + l_alpha_imag * l_temp2_real)
							l_ix := l_ix + a_incX
							l_iy___1 := l_iy___1 + a_incY
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___4
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 19 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if a_Uplo = {NATURAL_32} 122 then
							l_pos := -1 + 24 -- goto _L___1
						else
							l_pos := -1 + 22 -- goto _L___2
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 29
				when 22 then -- else: | _L___2:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 28 -- skip if block
						end
				when 23 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if: | _L___1:
						if a_incX > 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___6 + (a_N - 1) * a_incX
						if a_incY > 0 then
							l_tmp___7 := 0
						else
							l_tmp___7 := (a_N - 1) * -a_incY
						end
						l_iy___2 := l_tmp___7 + (a_N - 1) * a_incY
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___10 := l_i
								l_i := l_i - 1
								if not l_tmp___10.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_x_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0]
								l_x_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
								l_temp1_real___0 := l_alpha_real * l_x_real___0 - l_alpha_imag * l_x_imag___0
								l_temp1_imag___0 := l_alpha_real * l_x_imag___0 + l_alpha_imag * l_x_real___0
								l_temp2_real___0 := (0.0).truncated_to_real
								l_temp2_imag___0 := (0.0).truncated_to_real
								l_j_min___0 := 0
								l_j_max___0 := l_i
								if a_incX > 0 then
									l_tmp___8 := 0
								else
									l_tmp___8 := (a_N - 1) * -a_incX
								end
								l_jx___0 := l_tmp___8 + l_j_min___0 * a_incX
								if a_incY > 0 then
									l_tmp___9 := 0
								else
									l_tmp___9 := (a_N - 1) * -a_incY
								end
								l_jy___0 := l_tmp___9 + l_j_min___0 * a_incY
								l_Aii_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___2] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___2] + (l_temp1_real___0 * l_Aii_real___0)
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___2 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___2 + 1)] + (l_temp1_imag___0 * l_Aii_real___0)
								l_j := l_j_min___0
								from
								until
									not (l_j < l_j_max___0)
								loop
									l_Aij_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
									l_Aij_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)])
									create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_jy___0] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_jy___0] + (l_temp1_real___0 * l_Aij_real___0 - l_temp1_imag___0 * -l_Aij_imag___0)
									create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_jy___0 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_jy___0 + 1)] + (l_temp1_real___0 * -l_Aij_imag___0 + l_temp1_imag___0 * l_Aij_real___0)
									l_x_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx___0]
									l_x_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx___0 + 1)]
									l_temp2_real___0 := l_temp2_real___0 + (l_x_real___0 * l_Aij_real___0 - l_x_imag___0 * l_Aij_imag___0)
									l_temp2_imag___0 := l_temp2_imag___0 + (l_x_real___0 * l_Aij_imag___0 + l_x_imag___0 * l_Aij_real___0)
									l_jx___0 := l_jx___0 + a_incX
									l_jy___0 := l_jy___0 + a_incY
									l_j := l_j + 1
								end
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___2] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[2 * l_iy___2] + (l_alpha_real * l_temp2_real___0 - l_alpha_imag * l_temp2_imag___0)
								create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___2 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_Y)[(2 * l_iy___2 + 1)] + (l_alpha_real * l_temp2_imag___0 + l_alpha_imag * l_temp2_real___0)
								l_ix___0 := l_ix___0 - a_incX
								l_iy___2 := l_iy___2 - a_incY
							end
						end
						l_break := False
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_hemv.h"), ce_string ("unrecognized operation")])
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_hemv.h"), ce_string ("unrecognized operation")])
				when 29 then -- if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_cher2k (a_Order, a_Uplo, a_Trans: NATURAL_32; a_N, a_K: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32; a_beta: REAL_32; a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_temp_real: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_temp1_real: REAL_32
			l_temp1_imag: REAL_32
			l_Bik_real: REAL_32
			l_Bik_imag: REAL_32
			l_temp_real___0: REAL_32
			l_temp_imag: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_temp1_real___0: REAL_32
			l_temp1_imag___0: REAL_32
			l_Bik_real___0: REAL_32
			l_Bik_imag___0: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_temp2_real: REAL_32
			l_temp2_imag: REAL_32
			l_Bjk_real: REAL_32
			l_Bjk_imag: REAL_32
			l_Aki_real: REAL_32
			l_Aki_imag: REAL_32
			l_Bki_real: REAL_32
			l_Bki_imag: REAL_32
			l_temp1_real___1: REAL_32
			l_temp1_imag___1: REAL_32
			l_temp2_real___0: REAL_32
			l_temp2_imag___0: REAL_32
			l_Akj_real: REAL_32
			l_Akj_imag: REAL_32
			l_Bkj_real: REAL_32
			l_Bkj_imag: REAL_32
			l_temp_real___1: REAL_32
			l_temp_imag___0: REAL_32
			l_Aik_real___1: REAL_32
			l_Aik_imag___1: REAL_32
			l_temp1_real___2: REAL_32
			l_temp1_imag___2: REAL_32
			l_Bik_real___1: REAL_32
			l_Bik_imag___1: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_temp2_real___1: REAL_32
			l_temp2_imag___1: REAL_32
			l_Bjk_real___0: REAL_32
			l_Bjk_imag___0: REAL_32
			l_temp_real___2: REAL_32
			l_Aik_real___2: REAL_32
			l_Aik_imag___2: REAL_32
			l_temp1_real___3: REAL_32
			l_temp1_imag___3: REAL_32
			l_Bik_real___2: REAL_32
			l_Bik_imag___2: REAL_32
			l_Aki_real___0: REAL_32
			l_Aki_imag___0: REAL_32
			l_Bki_real___0: REAL_32
			l_Bki_imag___0: REAL_32
			l_temp1_real___4: REAL_32
			l_temp1_imag___4: REAL_32
			l_temp2_real___2: REAL_32
			l_temp2_imag___2: REAL_32
			l_Akj_real___0: REAL_32
			l_Akj_imag___0: REAL_32
			l_Bkj_real___0: REAL_32
			l_Bkj_imag___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					if a_beta.to_double /= 1.0 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if l_alpha_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_alpha_imag.to_double = 0.0 then
							l_return := True
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if a_K = 0 then
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						if a_Order = {NATURAL_32} 101 then
							l_uplo := a_Uplo.to_integer_32
							l_trans := a_Trans.to_integer_32
						else
							if a_Uplo = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Trans = {NATURAL_32} 111 then
								l_trans := 113
							else
								l_trans := 111
							end
							l_alpha_imag := l_alpha_imag * (-1).to_real
						end
						if a_beta.to_double = 0.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j <= l_i)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							end
						elseif a_beta.to_double /= 1.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_i)] * a_beta
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_i) + 1)] := (0.0).truncated_to_real
									l_j := l_i + 1
									from
									until
										not (l_j < a_N)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] * a_beta
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] * a_beta
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j < l_i)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] * a_beta
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] * a_beta
										l_j := l_j + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_i)] * a_beta
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_i) + 1)] := (0.0).truncated_to_real
									l_i := l_i + 1
								end
							end
						else
							l_i := 0
							from
							until
								not (l_i < a_N)
							loop
								create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_i) + 1)] := (0.0).truncated_to_real
								l_i := l_i + 1
							end
						end
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								l_return := True
							end
						end
					end
					if l_return then
						l_pos := -1 + 16 -- skip if block
					end
				when 6 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_temp_real := (0.0).truncated_to_real
								l_k := 0
								from
								until
									not (l_k < a_K)
								loop
									l_Aik_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
									l_Aik_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
									l_temp1_real := l_alpha_real * l_Aik_real - l_alpha_imag * l_Aik_imag
									l_temp1_imag := l_alpha_real * l_Aik_imag + l_alpha_imag * l_Aik_real
									l_Bik_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
									l_Bik_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
									l_temp_real := l_temp_real + (l_temp1_real * l_Bik_real + l_temp1_imag * l_Bik_imag)
									l_k := l_k + 1
								end
								create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_i)] + ((2).to_real * l_temp_real)
								create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_i) + 1)] := (0.0).truncated_to_real
								l_j := l_i + 1
								from
								until
									not (not (l_return) and then (l_j < a_N))
								loop
									l_temp_real___0 := (0.0).truncated_to_real
									l_temp_imag := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_temp1_real___0 := l_alpha_real * l_Aik_real___0 - l_alpha_imag * l_Aik_imag___0
										l_temp1_imag___0 := l_alpha_real * l_Aik_imag___0 + l_alpha_imag * l_Aik_real___0
										l_Bik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
										l_Bik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
										l_Ajk_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_temp2_real := l_alpha_real * l_Ajk_real - l_alpha_imag * l_Ajk_imag
										l_temp2_imag := l_alpha_real * l_Ajk_imag + l_alpha_imag * l_Ajk_real
										l_Bjk_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_j * a_ldb + l_k)]
										l_Bjk_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_j * a_ldb + l_k) + 1)]
										l_temp_real___0 := l_temp_real___0 + ((l_temp1_real___0 * l_Bjk_real + l_temp1_imag___0 * l_Bjk_imag) + (l_Bik_real___0 * l_temp2_real + l_Bik_imag___0 * l_temp2_imag))
										l_temp_imag := l_temp_imag + ((l_temp1_real___0 * -l_Bjk_imag + l_temp1_imag___0 * l_Bjk_real) + (l_Bik_real___0 * -l_temp2_imag + l_Bik_imag___0 * l_temp2_real))
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + l_temp_real___0
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + l_temp_imag
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 9 -- goto _L___2
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else: | _L___2:
						if l_uplo /= 121 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_trans = 113 then
							l_k := 0
							from
							until
								not (not (l_return) and then (l_k < a_K))
							loop
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_Aki_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
									l_Aki_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)]
									l_Bki_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_i)]
									l_Bki_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_i) + 1)]
									l_temp1_real___1 := l_alpha_real * l_Aki_real - l_alpha_imag * -l_Aki_imag
									l_temp1_imag___1 := l_alpha_real * -l_Aki_imag + l_alpha_imag * l_Aki_real
									l_temp2_real___0 := l_alpha_real * l_Bki_real - l_alpha_imag * l_Bki_imag
									l_temp2_imag___0 := -(l_alpha_real * l_Bki_imag + l_alpha_imag * l_Bki_real)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_i)] + ((2).to_real * (l_temp1_real___1 * l_Bki_real - l_temp1_imag___1 * l_Bki_imag))
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_i) + 1)] := (0.0).truncated_to_real
									l_j := l_i + 1
									from
									until
										not (l_j < a_N)
									loop
										l_Akj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
										l_Akj_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
										l_Bkj_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
										l_Bkj_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_j)] + ((l_temp1_real___1 * l_Bkj_real - l_temp1_imag___1 * l_Bkj_imag) + (l_temp2_real___0 * l_Akj_real - l_temp2_imag___0 * l_Akj_imag))
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_j) + 1)] + ((l_temp1_real___1 * l_Bkj_imag + l_temp1_imag___1 * l_Bkj_real) + (l_temp2_real___0 * l_Akj_imag + l_temp2_imag___0 * l_Akj_real))
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
								l_k := l_k + 1
							end
						else
							l_pos := -1 + 12 -- goto _L___1
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else: | _L___1:
						if l_uplo /= 122 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < l_i))
								loop
									l_temp_real___1 := (0.0).truncated_to_real
									l_temp_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_temp1_real___2 := l_alpha_real * l_Aik_real___1 - l_alpha_imag * l_Aik_imag___1
										l_temp1_imag___2 := l_alpha_real * l_Aik_imag___1 + l_alpha_imag * l_Aik_real___1
										l_Bik_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
										l_Bik_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
										l_Ajk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_temp2_real___1 := l_alpha_real * l_Ajk_real___0 - l_alpha_imag * l_Ajk_imag___0
										l_temp2_imag___1 := l_alpha_real * l_Ajk_imag___0 + l_alpha_imag * l_Ajk_real___0
										l_Bjk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_j * a_ldb + l_k)]
										l_Bjk_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_j * a_ldb + l_k) + 1)]
										l_temp_real___1 := l_temp_real___1 + ((l_temp1_real___2 * l_Bjk_real___0 + l_temp1_imag___2 * l_Bjk_imag___0) + (l_Bik_real___1 * l_temp2_real___1 + l_Bik_imag___1 * l_temp2_imag___1))
										l_temp_imag___0 := l_temp_imag___0 + ((l_temp1_real___2 * -l_Bjk_imag___0 + l_temp1_imag___2 * l_Bjk_real___0) + (l_Bik_real___1 * -l_temp2_imag___1 + l_Bik_imag___1 * l_temp2_real___1))
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + l_temp_real___1
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + l_temp_imag___0
									l_j := l_j + 1
								end
								l_temp_real___2 := (0.0).truncated_to_real
								l_k := 0
								from
								until
									not (l_k < a_K)
								loop
									l_Aik_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
									l_Aik_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
									l_temp1_real___3 := l_alpha_real * l_Aik_real___2 - l_alpha_imag * l_Aik_imag___2
									l_temp1_imag___3 := l_alpha_real * l_Aik_imag___2 + l_alpha_imag * l_Aik_real___2
									l_Bik_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
									l_Bik_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
									l_temp_real___2 := l_temp_real___2 + (l_temp1_real___3 * l_Bik_real___2 + l_temp1_imag___3 * l_Bik_imag___2)
									l_k := l_k + 1
								end
								create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_i)] + ((2).to_real * l_temp_real___2)
								create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_i) + 1)] := (0.0).truncated_to_real
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___0:
						if l_uplo = 122 then
							if l_trans = 113 then
								l_k := 0
								from
								until
									not (not (l_return) and then (l_k < a_K))
								loop
									l_i := 0
									from
									until
										not (not (l_return) and then (l_i < a_N))
									loop
										l_Aki_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
										l_Aki_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)]
										l_Bki_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_i)]
										l_Bki_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_i) + 1)]
										l_temp1_real___4 := l_alpha_real * l_Aki_real___0 - l_alpha_imag * -l_Aki_imag___0
										l_temp1_imag___4 := l_alpha_real * -l_Aki_imag___0 + l_alpha_imag * l_Aki_real___0
										l_temp2_real___2 := l_alpha_real * l_Bki_real___0 - l_alpha_imag * l_Bki_imag___0
										l_temp2_imag___2 := -(l_alpha_real * l_Bki_imag___0 + l_alpha_imag * l_Bki_real___0)
										l_j := 0
										from
										until
											not (l_j < l_i)
										loop
											l_Akj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
											l_Akj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
											l_Bkj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
											l_Bkj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
											create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_j)] + ((l_temp1_real___4 * l_Bkj_real___0 - l_temp1_imag___4 * l_Bkj_imag___0) + (l_temp2_real___2 * l_Akj_real___0 - l_temp2_imag___2 * l_Akj_imag___0))
											create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_j) + 1)] + ((l_temp1_real___4 * l_Bkj_imag___0 + l_temp1_imag___4 * l_Bkj_real___0) + (l_temp2_real___2 * l_Akj_imag___0 + l_temp2_imag___2 * l_Akj_real___0))
											l_j := l_j + 1
										end
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_i)] + ((2).to_real * (l_temp1_real___4 * l_Bki_real___0 - l_temp1_imag___4 * l_Bki_imag___0))
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_i) + 1)] := (0.0).truncated_to_real
										l_i := l_i + 1
									end
									l_k := l_k + 1
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_her2k.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_her2k.h"), ce_string ("unrecognized operation")])
						end
				when 16 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_cherk (a_Order, a_Uplo, a_Trans: NATURAL_32; a_N, a_K: INTEGER_32; a_alpha: REAL_32; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_beta: REAL_32; a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_temp_real: REAL_32
			l_temp_imag: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_temp_real___0: REAL_32
			l_temp_imag___0: REAL_32
			l_Aki_real: REAL_32
			l_Aki_imag: REAL_32
			l_Akj_real: REAL_32
			l_Akj_imag: REAL_32
			l_temp_real___1: REAL_32
			l_temp_imag___1: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_temp_real___2: REAL_32
			l_temp_imag___2: REAL_32
			l_Aki_real___0: REAL_32
			l_Aki_imag___0: REAL_32
			l_Akj_real___0: REAL_32
			l_Akj_imag___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_beta.to_double = 1.0 then
						if a_alpha.to_double = 0.0 then
							l_return := True
						elseif a_K = 0 then
							l_return := True
						end
					end
					if not l_return then
						if a_Order = {NATURAL_32} 101 then
							l_uplo := a_Uplo.to_integer_32
							l_trans := a_Trans.to_integer_32
						else
							if a_Uplo = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Trans = {NATURAL_32} 111 then
								l_trans := 113
							else
								l_trans := 111
							end
						end
						if a_beta.to_double = 0.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j <= l_i)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							end
						elseif a_beta.to_double /= 1.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_i)] * a_beta
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_i) + 1)] := (0).to_real
									l_j := l_i + 1
									from
									until
										not (l_j < a_N)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] * a_beta
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] * a_beta
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j < l_i)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] * a_beta
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] * a_beta
										l_j := l_j + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_i)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_i)] * a_beta
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_i) + 1)] := (0).to_real
									l_i := l_i + 1
								end
							end
						else
							l_i := 0
							from
							until
								not (l_i < a_N)
							loop
								create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_i) + 1)] := (0.0).truncated_to_real
								l_i := l_i + 1
							end
						end
						if a_alpha.to_double = 0.0 then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (not (l_return) and then (l_j < a_N))
								loop
									l_temp_real := (0.0).truncated_to_real
									l_temp_imag := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Ajk_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag := (-create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
										l_temp_real := l_temp_real + (l_Aik_real * l_Ajk_real - l_Aik_imag * l_Ajk_imag)
										l_temp_imag := l_temp_imag + (l_Aik_real * l_Ajk_imag + l_Aik_imag * l_Ajk_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (a_alpha * l_temp_real)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (a_alpha * l_temp_imag)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else: | _L___1:
						if l_uplo /= 121 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_trans = 113 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (not (l_return) and then (l_j < a_N))
								loop
									l_temp_real___0 := (0.0).truncated_to_real
									l_temp_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aki_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
										l_Aki_imag := (-create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
										l_Akj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
										l_Akj_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
										l_temp_real___0 := l_temp_real___0 + (l_Aki_real * l_Akj_real - l_Aki_imag * l_Akj_imag)
										l_temp_imag___0 := l_temp_imag___0 + (l_Aki_real * l_Akj_imag + l_Aki_imag * l_Akj_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (a_alpha * l_temp_real___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (a_alpha * l_temp_imag___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 7 -- goto _L___0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else: | _L___0:
						if l_uplo /= 122 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j <= l_i))
								loop
									l_temp_real___1 := (0.0).truncated_to_real
									l_temp_imag___1 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Ajk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag___0 := (-create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
										l_temp_real___1 := l_temp_real___1 + (l_Aik_real___0 * l_Ajk_real___0 - l_Aik_imag___0 * l_Ajk_imag___0)
										l_temp_imag___1 := l_temp_imag___1 + (l_Aik_real___0 * l_Ajk_imag___0 + l_Aik_imag___0 * l_Ajk_real___0)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (a_alpha * l_temp_real___1)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (a_alpha * l_temp_imag___1)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 10 -- goto _L
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L:
						if l_uplo = 122 then
							if l_trans = 113 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j <= l_i))
									loop
										l_temp_real___2 := (0.0).truncated_to_real
										l_temp_imag___2 := (0.0).truncated_to_real
										l_k := 0
										from
										until
											not (l_k < a_K)
										loop
											l_Aki_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
											l_Aki_imag___0 := (-create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
											l_Akj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
											l_Akj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
											l_temp_real___2 := l_temp_real___2 + (l_Aki_real___0 * l_Akj_real___0 - l_Aki_imag___0 * l_Akj_imag___0)
											l_temp_imag___2 := l_temp_imag___2 + (l_Aki_real___0 * l_Akj_imag___0 + l_Aki_imag___0 * l_Akj_real___0)
											l_k := l_k + 1
										end
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (a_alpha * l_temp_real___2)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (a_alpha * l_temp_imag___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_herk.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_herk.h"), ce_string ("unrecognized operation")])
						end
				when 11 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_csymm (a_Order, a_Side, a_Uplo: NATURAL_32; a_M, a_N: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32; a_beta, a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_uplo: INTEGER_32
			l_side: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_Cij_real: REAL_32
			l_Cij_imag: REAL_32
			l_Bij_real: REAL_32
			l_Bij_imag: REAL_32
			l_temp1_real: REAL_32
			l_temp1_imag: REAL_32
			l_temp2_real: REAL_32
			l_temp2_imag: REAL_32
			l_Aii_real: REAL_32
			l_Aii_imag: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Bkj_real: REAL_32
			l_Bkj_imag: REAL_32
			l_Bij_real___0: REAL_32
			l_Bij_imag___0: REAL_32
			l_temp1_real___0: REAL_32
			l_temp1_imag___0: REAL_32
			l_temp2_real___0: REAL_32
			l_temp2_imag___0: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Bkj_real___0: REAL_32
			l_Bkj_imag___0: REAL_32
			l_Aii_real___0: REAL_32
			l_Aii_imag___0: REAL_32
			l_Bij_real___1: REAL_32
			l_Bij_imag___1: REAL_32
			l_temp1_real___1: REAL_32
			l_temp1_imag___1: REAL_32
			l_temp2_real___1: REAL_32
			l_temp2_imag___1: REAL_32
			l_Ajj_real: REAL_32
			l_Ajj_imag: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_Bik_real: REAL_32
			l_Bik_imag: REAL_32
			l_Bij_real___2: REAL_32
			l_Bij_imag___2: REAL_32
			l_temp1_real___2: REAL_32
			l_temp1_imag___2: REAL_32
			l_temp2_real___2: REAL_32
			l_temp2_imag___2: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_Bik_real___0: REAL_32
			l_Bik_imag___0: REAL_32
			l_Ajj_real___0: REAL_32
			l_Ajj_imag___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_REAL_32_POINTER}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_REAL_32_POINTER}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Order = {NATURAL_32} 101 then
							l_n1 := a_M
							l_n2 := a_N
							l_uplo := a_Uplo.to_integer_32
							l_side := a_Side.to_integer_32
						else
							l_n1 := a_N
							l_n2 := a_M
							if a_Uplo = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Side = {NATURAL_32} 141 then
								l_side := 142
							else
								l_side := 141
							end
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Cij_real := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
								l_Cij_imag := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real - l_beta_imag * l_Cij_imag
								create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag + l_beta_imag * l_Cij_real
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								l_return := True
							end
						end
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 10 then -- if:
						if l_side /= 141 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < l_n2))
								loop
									l_Bij_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real := l_alpha_real * l_Bij_real - l_alpha_imag * l_Bij_imag
									l_temp1_imag := l_alpha_real * l_Bij_imag + l_alpha_imag * l_Bij_real
									l_temp2_real := (0.0).truncated_to_real
									l_temp2_imag := (0.0).truncated_to_real
									l_Aii_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
									l_Aii_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real * l_Aii_real - l_temp1_imag * l_Aii_imag)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_real * l_Aii_imag + l_temp1_imag * l_Aii_real)
									l_k := l_i + 1
									from
									until
										not (l_k < l_n1)
									loop
										l_Aik_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Bkj_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)]
										l_Bkj_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] + (l_Aik_real * l_temp1_real - l_Aik_imag * l_temp1_imag)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] + (l_Aik_real * l_temp1_imag + l_Aik_imag * l_temp1_real)
										l_temp2_real := l_temp2_real + (l_Aik_real * l_Bkj_real - l_Aik_imag * l_Bkj_imag)
										l_temp2_imag := l_temp2_imag + (l_Aik_real * l_Bkj_imag + l_Aik_imag * l_Bkj_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real - l_alpha_imag * l_temp2_imag)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag + l_alpha_imag * l_temp2_real)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___3:
						if l_side /= 141 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_uplo = 122 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < l_n2))
								loop
									l_Bij_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real___0 := l_alpha_real * l_Bij_real___0 - l_alpha_imag * l_Bij_imag___0
									l_temp1_imag___0 := l_alpha_real * l_Bij_imag___0 + l_alpha_imag * l_Bij_real___0
									l_temp2_real___0 := (0.0).truncated_to_real
									l_temp2_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < l_i)
									loop
										l_Aik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Bkj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)]
										l_Bkj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_k * a_ldc + l_j)] + (l_Aik_real___0 * l_temp1_real___0 - l_Aik_imag___0 * l_temp1_imag___0)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_k * a_ldc + l_j) + 1)] + (l_Aik_real___0 * l_temp1_imag___0 + l_Aik_imag___0 * l_temp1_real___0)
										l_temp2_real___0 := l_temp2_real___0 + (l_Aik_real___0 * l_Bkj_real___0 - l_Aik_imag___0 * l_Bkj_imag___0)
										l_temp2_imag___0 := l_temp2_imag___0 + (l_Aik_real___0 * l_Bkj_imag___0 + l_Aik_imag___0 * l_Bkj_real___0)
										l_k := l_k + 1
									end
									l_Aii_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
									l_Aii_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___0 * l_Aii_real___0 - l_temp1_imag___0 * l_Aii_imag___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_real___0 * l_Aii_imag___0 + l_temp1_imag___0 * l_Aii_real___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___0 - l_alpha_imag * l_temp2_imag___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___0 + l_alpha_imag * l_temp2_real___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 16 -- goto _L___2
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else: | _L___2:
						if l_side /= 142 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < l_n1))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j < l_n2))
								loop
									l_Bij_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_temp1_real___1 := l_alpha_real * l_Bij_real___1 - l_alpha_imag * l_Bij_imag___1
									l_temp1_imag___1 := l_alpha_real * l_Bij_imag___1 + l_alpha_imag * l_Bij_real___1
									l_temp2_real___1 := (0.0).truncated_to_real
									l_temp2_imag___1 := (0.0).truncated_to_real
									l_Ajj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
									l_Ajj_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___1 * l_Ajj_real - l_temp1_imag___1 * l_Ajj_imag)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_real___1 * l_Ajj_imag + l_temp1_imag___1 * l_Ajj_real)
									l_k := l_j + 1
									from
									until
										not (l_k < l_n2)
									loop
										l_Ajk_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_Bik_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)]
										l_Bik_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] + (l_temp1_real___1 * l_Ajk_real - l_temp1_imag___1 * l_Ajk_imag)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] + (l_temp1_real___1 * l_Ajk_imag + l_temp1_imag___1 * l_Ajk_real)
										l_temp2_real___1 := l_temp2_real___1 + (l_Bik_real * l_Ajk_real - l_Bik_imag * l_Ajk_imag)
										l_temp2_imag___1 := l_temp2_imag___1 + (l_Bik_real * l_Ajk_imag + l_Bik_imag * l_Ajk_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___1 - l_alpha_imag * l_temp2_imag___1)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___1 + l_alpha_imag * l_temp2_real___1)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if l_side = 142 then
							if l_uplo = 122 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j < l_n2))
									loop
										l_Bij_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										l_temp1_real___2 := l_alpha_real * l_Bij_real___2 - l_alpha_imag * l_Bij_imag___2
										l_temp1_imag___2 := l_alpha_real * l_Bij_imag___2 + l_alpha_imag * l_Bij_real___2
										l_temp2_real___2 := (0.0).truncated_to_real
										l_temp2_imag___2 := (0.0).truncated_to_real
										l_k := 0
										from
										until
											not (l_k < l_j)
										loop
											l_Ajk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
											l_Ajk_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
											l_Bik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)]
											l_Bik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)]
											create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_k)] + (l_temp1_real___2 * l_Ajk_real___0 - l_temp1_imag___2 * l_Ajk_imag___0)
											create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_k) + 1)] + (l_temp1_real___2 * l_Ajk_imag___0 + l_temp1_imag___2 * l_Ajk_real___0)
											l_temp2_real___2 := l_temp2_real___2 + (l_Bik_real___0 * l_Ajk_real___0 - l_Bik_imag___0 * l_Ajk_imag___0)
											l_temp2_imag___2 := l_temp2_imag___2 + (l_Bik_real___0 * l_Ajk_imag___0 + l_Bik_imag___0 * l_Ajk_real___0)
											l_k := l_k + 1
										end
										l_Ajj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
										l_Ajj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_temp1_real___2 * l_Ajj_real___0 - l_temp1_imag___2 * l_Ajj_imag___0)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_temp1_real___2 * l_Ajj_imag___0 + l_temp1_imag___2 * l_Ajj_real___0)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp2_real___2 - l_alpha_imag * l_temp2_imag___2)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp2_imag___2 + l_alpha_imag * l_temp2_real___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_symm_c.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_symm_c.h"), ce_string ("unrecognized operation")])
						end
				when 20 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_csyr2k (a_Order, a_Uplo, a_Trans: NATURAL_32; a_N, a_K: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32; a_beta, a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_Cij_real: REAL_32
			l_Cij_imag: REAL_32
			l_Cij_real___0: REAL_32
			l_Cij_imag___0: REAL_32
			l_temp_real: REAL_32
			l_temp_imag: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Bik_real: REAL_32
			l_Bik_imag: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_Bjk_real: REAL_32
			l_Bjk_imag: REAL_32
			l_Aki_real: REAL_32
			l_Aki_imag: REAL_32
			l_Bki_real: REAL_32
			l_Bki_imag: REAL_32
			l_temp1_real: REAL_32
			l_temp1_imag: REAL_32
			l_temp2_real: REAL_32
			l_temp2_imag: REAL_32
			l_Akj_real: REAL_32
			l_Akj_imag: REAL_32
			l_Bkj_real: REAL_32
			l_Bkj_imag: REAL_32
			l_temp_real___0: REAL_32
			l_temp_imag___0: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Bik_real___0: REAL_32
			l_Bik_imag___0: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_Bjk_real___0: REAL_32
			l_Bjk_imag___0: REAL_32
			l_Aki_real___0: REAL_32
			l_Aki_imag___0: REAL_32
			l_Bki_real___0: REAL_32
			l_Bki_imag___0: REAL_32
			l_temp1_real___0: REAL_32
			l_temp1_imag___0: REAL_32
			l_temp2_real___0: REAL_32
			l_temp2_imag___0: REAL_32
			l_Akj_real___0: REAL_32
			l_Akj_imag___0: REAL_32
			l_Bkj_real___0: REAL_32
			l_Bkj_imag___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_REAL_32_POINTER}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_REAL_32_POINTER}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Order = {NATURAL_32} 101 then
							l_uplo := a_Uplo.to_integer_32
							l_trans := a_Trans.to_integer_32
						else
							if a_Uplo = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Trans = {NATURAL_32} 111 then
								l_trans := 112
							else
								l_trans := 111
							end
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j <= l_i)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (l_j < a_N)
								loop
									l_Cij_real := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
									l_Cij_imag := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real - l_beta_imag * l_Cij_imag
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag + l_beta_imag * l_Cij_real
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (l_j <= l_i)
								loop
									l_Cij_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
									l_Cij_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real___0 - l_beta_imag * l_Cij_imag___0
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag___0 + l_beta_imag * l_Cij_real___0
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								l_return := True
							end
						end
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 10 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (not (l_return) and then (l_j < a_N))
								loop
									l_temp_real := (0.0).truncated_to_real
									l_temp_imag := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Bik_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
										l_Bik_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
										l_Ajk_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_Bjk_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_j * a_ldb + l_k)]
										l_Bjk_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_j * a_ldb + l_k) + 1)]
										l_temp_real := l_temp_real + ((l_Aik_real * l_Bjk_real - l_Aik_imag * l_Bjk_imag) + (l_Bik_real * l_Ajk_real - l_Bik_imag * l_Ajk_imag))
										l_temp_imag := l_temp_imag + ((l_Aik_real * l_Bjk_imag + l_Aik_imag * l_Bjk_real) + (l_Bik_real * l_Ajk_imag + l_Bik_imag * l_Ajk_real))
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real - l_alpha_imag * l_temp_imag)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag + l_alpha_imag * l_temp_real)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___3:
						if l_uplo /= 121 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_trans = 112 then
							l_k := 0
							from
							until
								not (not (l_return) and then (l_k < a_K))
							loop
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_Aki_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
									l_Aki_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)]
									l_Bki_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_i)]
									l_Bki_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_i) + 1)]
									l_temp1_real := l_alpha_real * l_Aki_real - l_alpha_imag * l_Aki_imag
									l_temp1_imag := l_alpha_real * l_Aki_imag + l_alpha_imag * l_Aki_real
									l_temp2_real := l_alpha_real * l_Bki_real - l_alpha_imag * l_Bki_imag
									l_temp2_imag := l_alpha_real * l_Bki_imag + l_alpha_imag * l_Bki_real
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										l_Akj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
										l_Akj_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
										l_Bkj_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
										l_Bkj_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_j)] + ((l_temp1_real * l_Bkj_real - l_temp1_imag * l_Bkj_imag) + (l_temp2_real * l_Akj_real - l_temp2_imag * l_Akj_imag))
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_j) + 1)] + ((l_temp1_real * l_Bkj_imag + l_temp1_imag * l_Bkj_real) + (l_temp2_real * l_Akj_imag + l_temp2_imag * l_Akj_real))
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
								l_k := l_k + 1
							end
						else
							l_pos := -1 + 16 -- goto _L___2
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else: | _L___2:
						if l_uplo /= 122 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j <= l_i))
								loop
									l_temp_real___0 := (0.0).truncated_to_real
									l_temp_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Bik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
										l_Bik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
										l_Ajk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_Bjk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_j * a_ldb + l_k)]
										l_Bjk_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_j * a_ldb + l_k) + 1)]
										l_temp_real___0 := l_temp_real___0 + ((l_Aik_real___0 * l_Bjk_real___0 - l_Aik_imag___0 * l_Bjk_imag___0) + (l_Bik_real___0 * l_Ajk_real___0 - l_Bik_imag___0 * l_Ajk_imag___0))
										l_temp_imag___0 := l_temp_imag___0 + ((l_Aik_real___0 * l_Bjk_imag___0 + l_Aik_imag___0 * l_Bjk_real___0) + (l_Bik_real___0 * l_Ajk_imag___0 + l_Bik_imag___0 * l_Ajk_real___0))
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real___0 - l_alpha_imag * l_temp_imag___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag___0 + l_alpha_imag * l_temp_real___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if l_uplo = 122 then
							if l_trans = 112 then
								l_k := 0
								from
								until
									not (not (l_return) and then (l_k < a_K))
								loop
									l_i := 0
									from
									until
										not (not (l_return) and then (l_i < a_N))
									loop
										l_Aki_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
										l_Aki_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)]
										l_Bki_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_i)]
										l_Bki_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_i) + 1)]
										l_temp1_real___0 := l_alpha_real * l_Aki_real___0 - l_alpha_imag * l_Aki_imag___0
										l_temp1_imag___0 := l_alpha_real * l_Aki_imag___0 + l_alpha_imag * l_Aki_real___0
										l_temp2_real___0 := l_alpha_real * l_Bki_real___0 - l_alpha_imag * l_Bki_imag___0
										l_temp2_imag___0 := l_alpha_real * l_Bki_imag___0 + l_alpha_imag * l_Bki_real___0
										l_j := 0
										from
										until
											not (l_j <= l_i)
										loop
											l_Akj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
											l_Akj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
											l_Bkj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
											l_Bkj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
											create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_lda + l_j)] + ((l_temp1_real___0 * l_Bkj_real___0 - l_temp1_imag___0 * l_Bkj_imag___0) + (l_temp2_real___0 * l_Akj_real___0 - l_temp2_imag___0 * l_Akj_imag___0))
											create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_lda + l_j) + 1)] + ((l_temp1_real___0 * l_Bkj_imag___0 + l_temp1_imag___0 * l_Bkj_real___0) + (l_temp2_real___0 * l_Akj_imag___0 + l_temp2_imag___0 * l_Akj_real___0))
											l_j := l_j + 1
										end
										l_i := l_i + 1
									end
									l_k := l_k + 1
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_syr2k_c.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_syr2k_c.h"), ce_string ("unrecognized operation")])
						end
				when 20 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_csyrk (a_Order, a_Uplo, a_Trans: NATURAL_32; a_N, a_K: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_beta, a_C: CE_POINTER [ANY]; a_ldc: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_beta_real: REAL_32
			l_beta_imag: REAL_32
			l_Cij_real: REAL_32
			l_Cij_imag: REAL_32
			l_Cij_real___0: REAL_32
			l_Cij_imag___0: REAL_32
			l_temp_real: REAL_32
			l_temp_imag: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_temp_real___0: REAL_32
			l_temp_imag___0: REAL_32
			l_Aki_real: REAL_32
			l_Aki_imag: REAL_32
			l_Akj_real: REAL_32
			l_Akj_imag: REAL_32
			l_temp_real___1: REAL_32
			l_temp_imag___1: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_temp_real___2: REAL_32
			l_temp_imag___2: REAL_32
			l_Aki_real___0: REAL_32
			l_Aki_imag___0: REAL_32
			l_Akj_real___0: REAL_32
			l_Akj_imag___0: REAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					l_beta_real := create {CE_REAL_32_POINTER}.make_cast (a_beta)[0]
					l_beta_imag := create {CE_REAL_32_POINTER}.make_cast (a_beta)[1]
					if l_alpha_real.to_double = 0.0 then
						if l_alpha_imag.to_double = 0.0 then
							if l_beta_real.to_double = 1.0 then
								if l_beta_imag.to_double = 0.0 then
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if a_Order = {NATURAL_32} 101 then
							l_uplo := a_Uplo.to_integer_32
							if a_Trans = {NATURAL_32} 111 then
								l_trans := 111
							else
								l_trans := 112
							end
						else
							if a_Uplo = {NATURAL_32} 121 then
								l_uplo := 122
							else
								l_uplo := 121
							end
							if a_Trans = {NATURAL_32} 111 then
								l_trans := 112
							else
								l_trans := 111
							end
						end
						if l_beta_real.to_double /= 0.0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_beta_imag.to_double = 0.0 then
							if l_uplo = 121 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := l_i
									from
									until
										not (l_j < a_N)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (l_j <= l_i)
									loop
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := (0.0).truncated_to_real
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := (0.0).truncated_to_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else: | _L___0:
						if l_beta_real.to_double /= 1.0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if l_beta_imag.to_double /= 0.0 then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if l_uplo = 121 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (l_j < a_N)
								loop
									l_Cij_real := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
									l_Cij_imag := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real - l_beta_imag * l_Cij_imag
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag + l_beta_imag * l_Cij_real
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (l_j <= l_i)
								loop
									l_Cij_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)]
									l_Cij_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (a_ldc * l_i + l_j)] := l_beta_real * l_Cij_real___0 - l_beta_imag * l_Cij_imag___0
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (a_ldc * l_i + l_j) + 1)] := l_beta_real * l_Cij_imag___0 + l_beta_imag * l_Cij_real___0
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						end
				when 8 then -- if done
						if l_alpha_real.to_double = 0.0 then
							if l_alpha_imag.to_double = 0.0 then
								l_return := True
							end
						end
				when 9 then -- if done
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 10 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (not (l_return) and then (l_j < a_N))
								loop
									l_temp_real := (0.0).truncated_to_real
									l_temp_imag := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Ajk_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_temp_real := l_temp_real + (l_Aik_real * l_Ajk_real - l_Aik_imag * l_Ajk_imag)
										l_temp_imag := l_temp_imag + (l_Aik_real * l_Ajk_imag + l_Aik_imag * l_Ajk_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real - l_alpha_imag * l_temp_imag)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag + l_alpha_imag * l_temp_real)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___3:
						if l_uplo /= 121 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_trans = 112 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := l_i
								from
								until
									not (not (l_return) and then (l_j < a_N))
								loop
									l_temp_real___0 := (0.0).truncated_to_real
									l_temp_imag___0 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aki_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
										l_Aki_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)]
										l_Akj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
										l_Akj_imag := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
										l_temp_real___0 := l_temp_real___0 + (l_Aki_real * l_Akj_real - l_Aki_imag * l_Akj_imag)
										l_temp_imag___0 := l_temp_imag___0 + (l_Aki_real * l_Akj_imag + l_Aki_imag * l_Akj_real)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real___0 - l_alpha_imag * l_temp_imag___0)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag___0 + l_alpha_imag * l_temp_real___0)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 16 -- goto _L___2
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else: | _L___2:
						if l_uplo /= 122 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_trans = 111 then
							l_i := 0
							from
							until
								not (not (l_return) and then (l_i < a_N))
							loop
								l_j := 0
								from
								until
									not (not (l_return) and then (l_j <= l_i))
								loop
									l_temp_real___1 := (0.0).truncated_to_real
									l_temp_imag___1 := (0.0).truncated_to_real
									l_k := 0
									from
									until
										not (l_k < a_K)
									loop
										l_Aik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
										l_Aik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)]
										l_Ajk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)]
										l_temp_real___1 := l_temp_real___1 + (l_Aik_real___0 * l_Ajk_real___0 - l_Aik_imag___0 * l_Ajk_imag___0)
										l_temp_imag___1 := l_temp_imag___1 + (l_Aik_real___0 * l_Ajk_imag___0 + l_Aik_imag___0 * l_Ajk_real___0)
										l_k := l_k + 1
									end
									create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real___1 - l_alpha_imag * l_temp_imag___1)
									create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag___1 + l_alpha_imag * l_temp_real___1)
									l_j := l_j + 1
								end
								l_i := l_i + 1
							end
						else
							l_pos := -1 + 19 -- goto _L___1
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if l_uplo = 122 then
							if l_trans = 112 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < a_N))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j <= l_i))
									loop
										l_temp_real___2 := (0.0).truncated_to_real
										l_temp_imag___2 := (0.0).truncated_to_real
										l_k := 0
										from
										until
											not (l_k < a_K)
										loop
											l_Aki_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
											l_Aki_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)]
											l_Akj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
											l_Akj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)]
											l_temp_real___2 := l_temp_real___2 + (l_Aki_real___0 * l_Akj_real___0 - l_Aki_imag___0 * l_Akj_imag___0)
											l_temp_imag___2 := l_temp_imag___2 + (l_Aki_real___0 * l_Akj_imag___0 + l_Aki_imag___0 * l_Akj_real___0)
											l_k := l_k + 1
										end
										create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[2 * (l_i * a_ldc + l_j)] + (l_alpha_real * l_temp_real___2 - l_alpha_imag * l_temp_imag___2)
										create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_C)[(2 * (l_i * a_ldc + l_j) + 1)] + (l_alpha_real * l_temp_imag___2 + l_alpha_imag * l_temp_real___2)
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_syrk_c.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_syrk_c.h"), ce_string ("unrecognized operation")])
						end
				when 20 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_ctrmm (a_Order, a_Side, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_M, a_N: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_nonunit: INTEGER_32
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_side: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_temp_real: REAL_32
			l_temp_imag: REAL_32
			l_Aii_real: REAL_32
			l_Aii_imag: REAL_32
			l_Bij_real: REAL_32
			l_Bij_imag: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Bkj_real: REAL_32
			l_Bkj_imag: REAL_32
			l_temp_real___0: REAL_32
			l_temp_imag___0: REAL_32
			l_Aki_real: REAL_32
			l_Aki_imag: REAL_32
			l_Bkj_real___0: REAL_32
			l_Bkj_imag___0: REAL_32
			l_Aii_real___0: REAL_32
			l_Aii_imag___0: REAL_32
			l_Bij_real___0: REAL_32
			l_Bij_imag___0: REAL_32
			l_tmp___0: INTEGER_32
			l_temp_real___1: REAL_32
			l_temp_imag___1: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Bkj_real___1: REAL_32
			l_Bkj_imag___1: REAL_32
			l_Aii_real___1: REAL_32
			l_Aii_imag___1: REAL_32
			l_Bij_real___1: REAL_32
			l_Bij_imag___1: REAL_32
			l_tmp___1: INTEGER_32
			l_temp_real___2: REAL_32
			l_temp_imag___2: REAL_32
			l_Aii_real___2: REAL_32
			l_Aii_imag___2: REAL_32
			l_Bij_real___2: REAL_32
			l_Bij_imag___2: REAL_32
			l_Aki_real___0: REAL_32
			l_Aki_imag___0: REAL_32
			l_Bkj_real___2: REAL_32
			l_Bkj_imag___2: REAL_32
			l_temp_real___3: REAL_32
			l_temp_imag___3: REAL_32
			l_Akj_real: REAL_32
			l_Akj_imag: REAL_32
			l_Bik_real: REAL_32
			l_Bik_imag: REAL_32
			l_Ajj_real: REAL_32
			l_Ajj_imag: REAL_32
			l_Bij_real___3: REAL_32
			l_Bij_imag___3: REAL_32
			l_tmp___2: INTEGER_32
			l_temp_real___4: REAL_32
			l_temp_imag___4: REAL_32
			l_Ajj_real___0: REAL_32
			l_Ajj_imag___0: REAL_32
			l_Bij_real___4: REAL_32
			l_Bij_imag___4: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_Bik_real___0: REAL_32
			l_Bik_imag___0: REAL_32
			l_temp_real___5: REAL_32
			l_temp_imag___5: REAL_32
			l_Ajj_real___1: REAL_32
			l_Ajj_imag___1: REAL_32
			l_Bij_real___5: REAL_32
			l_Bij_imag___5: REAL_32
			l_Akj_real___0: REAL_32
			l_Akj_imag___0: REAL_32
			l_Bik_real___1: REAL_32
			l_Bik_imag___1: REAL_32
			l_temp_real___6: REAL_32
			l_temp_imag___6: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_Bik_real___2: REAL_32
			l_Bik_imag___2: REAL_32
			l_Ajj_real___2: REAL_32
			l_Ajj_imag___2: REAL_32
			l_Bij_real___6: REAL_32
			l_Bij_imag___6: REAL_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					if a_Order = {NATURAL_32} 101 then
						l_n1 := a_M
						l_n2 := a_N
						l_side := a_Side.to_integer_32
						l_uplo := a_Uplo.to_integer_32
						if a_TransA = {NATURAL_32} 111 then
							l_trans := 111
						else
							l_trans := 112
						end
					else
						l_n1 := a_N
						l_n2 := a_M
						if a_Side = {NATURAL_32} 141 then
							l_side := 142
						else
							l_side := 141
						end
						if a_Uplo = {NATURAL_32} 121 then
							l_uplo := 122
						else
							l_uplo := 121
						end
						if a_TransA = {NATURAL_32} 111 then
							l_trans := 111
						else
							l_trans := 112
						end
					end
					if l_side /= 141 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_uplo = 121 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j < l_n2))
									loop
										l_temp_real := (0.0).truncated_to_real
										l_temp_imag := (0.0).truncated_to_real
										if l_nonunit.to_boolean then
											l_Aii_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
											l_Aii_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)])
											l_Bij_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_Bij_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
											l_temp_real := l_Aii_real * l_Bij_real - l_Aii_imag * l_Bij_imag
											l_temp_imag := l_Aii_real * l_Bij_imag + l_Aii_imag * l_Bij_real
										else
											l_temp_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_temp_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
										end
										l_k := l_i + 1
										from
										until
											not (l_k < l_n1)
										loop
											l_Aik_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
											l_Aik_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)])
											l_Bkj_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
											l_Bkj_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
											l_temp_real := l_temp_real + (l_Aik_real * l_Bkj_real - l_Aik_imag * l_Bkj_imag)
											l_temp_imag := l_temp_imag + (l_Aik_real * l_Bkj_imag + l_Aik_imag * l_Bkj_real)
											l_k := l_k + 1
										end
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real - l_alpha_imag * l_temp_imag
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag + l_alpha_imag * l_temp_real
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 3 -- goto _L___12
							end
						else
							l_pos := -1 + 3 -- goto _L___12
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 3 then -- else: | _L___12:
						if l_side /= 141 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_uplo = 121 then
							if l_trans = 112 then
								l_i := l_n1
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if l_i > 0 then
										l_tmp___0 := l_i
										l_i := l_i - 1
										if not l_tmp___0.to_boolean then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break) then
										l_j := 0
										from
										until
											not (not (l_return) and then (l_j < l_n2))
										loop
											l_temp_real___0 := (0.0).truncated_to_real
											l_temp_imag___0 := (0.0).truncated_to_real
											l_k := 0
											from
											until
												not (l_k < l_i)
											loop
												l_Aki_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
												l_Aki_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
												l_Bkj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
												l_Bkj_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
												l_temp_real___0 := l_temp_real___0 + (l_Aki_real * l_Bkj_real___0 - l_Aki_imag * l_Bkj_imag___0)
												l_temp_imag___0 := l_temp_imag___0 + (l_Aki_real * l_Bkj_imag___0 + l_Aki_imag * l_Bkj_real___0)
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_Aii_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
												l_Aii_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)])
												l_Bij_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
												l_Bij_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
												l_temp_real___0 := l_temp_real___0 + (l_Aii_real___0 * l_Bij_real___0 - l_Aii_imag___0 * l_Bij_imag___0)
												l_temp_imag___0 := l_temp_imag___0 + (l_Aii_real___0 * l_Bij_imag___0 + l_Aii_imag___0 * l_Bij_real___0)
											else
												l_temp_real___0 := l_temp_real___0 + (create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)])
												l_temp_imag___0 := l_temp_imag___0 + (create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)])
											end
											create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___0 - l_alpha_imag * l_temp_imag___0
											create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___0 + l_alpha_imag * l_temp_real___0
											l_j := l_j + 1
										end
									end
								end
								l_break := False
							else
								l_pos := -1 + 6 -- goto _L___10
							end
						else
							l_pos := -1 + 6 -- goto _L___10
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else: | _L___10:
						if l_side /= 141 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_uplo = 122 then
							if l_trans = 111 then
								l_i := l_n1
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if l_i > 0 then
										l_tmp___1 := l_i
										l_i := l_i - 1
										if not l_tmp___1.to_boolean then
											l_break := True
										end
									else
										l_break := True
									end
									if not (l_return or l_break) then
										l_j := 0
										from
										until
											not (not (l_return) and then (l_j < l_n2))
										loop
											l_temp_real___1 := (0.0).truncated_to_real
											l_temp_imag___1 := (0.0).truncated_to_real
											l_k := 0
											from
											until
												not (l_k < l_i)
											loop
												l_Aik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
												l_Aik_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)])
												l_Bkj_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
												l_Bkj_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
												l_temp_real___1 := l_temp_real___1 + (l_Aik_real___0 * l_Bkj_real___1 - l_Aik_imag___0 * l_Bkj_imag___1)
												l_temp_imag___1 := l_temp_imag___1 + (l_Aik_real___0 * l_Bkj_imag___1 + l_Aik_imag___0 * l_Bkj_real___1)
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_Aii_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
												l_Aii_imag___1 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)])
												l_Bij_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
												l_Bij_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
												l_temp_real___1 := l_temp_real___1 + (l_Aii_real___1 * l_Bij_real___1 - l_Aii_imag___1 * l_Bij_imag___1)
												l_temp_imag___1 := l_temp_imag___1 + (l_Aii_real___1 * l_Bij_imag___1 + l_Aii_imag___1 * l_Bij_real___1)
											else
												l_temp_real___1 := l_temp_real___1 + (create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)])
												l_temp_imag___1 := l_temp_imag___1 + (create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)])
											end
											create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___1 - l_alpha_imag * l_temp_imag___1
											create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___1 + l_alpha_imag * l_temp_real___1
											l_j := l_j + 1
										end
									end
								end
								l_break := False
							else
								l_pos := -1 + 9 -- goto _L___8
							end
						else
							l_pos := -1 + 9 -- goto _L___8
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 9 then -- else: | _L___8:
						if l_side /= 141 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if l_uplo = 122 then
							if l_trans = 112 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j < l_n2))
									loop
										l_temp_real___2 := (0.0).truncated_to_real
										l_temp_imag___2 := (0.0).truncated_to_real
										if l_nonunit.to_boolean then
											l_Aii_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_i)]
											l_Aii_imag___2 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_i) + 1)])
											l_Bij_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_Bij_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
											l_temp_real___2 := l_Aii_real___2 * l_Bij_real___2 - l_Aii_imag___2 * l_Bij_imag___2
											l_temp_imag___2 := l_Aii_real___2 * l_Bij_imag___2 + l_Aii_imag___2 * l_Bij_real___2
										else
											l_temp_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_temp_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
										end
										l_k := l_i + 1
										from
										until
											not (l_k < l_n1)
										loop
											l_Aki_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
											l_Aki_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
											l_Bkj_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_k * a_ldb + l_j)]
											l_Bkj_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_k * a_ldb + l_j) + 1)]
											l_temp_real___2 := l_temp_real___2 + (l_Aki_real___0 * l_Bkj_real___2 - l_Aki_imag___0 * l_Bkj_imag___2)
											l_temp_imag___2 := l_temp_imag___2 + (l_Aki_real___0 * l_Bkj_imag___2 + l_Aki_imag___0 * l_Bkj_real___2)
											l_k := l_k + 1
										end
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___2 - l_alpha_imag * l_temp_imag___2
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___2 + l_alpha_imag * l_temp_real___2
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 12 -- goto _L___6
							end
						else
							l_pos := -1 + 12 -- goto _L___6
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 12 then -- else: | _L___6:
						if l_side /= 142 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_uplo = 121 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_n1))
								loop
									l_j := l_n2
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										if l_j > 0 then
											l_tmp___2 := l_j
											l_j := l_j - 1
											if not l_tmp___2.to_boolean then
												l_break := True
											end
										else
											l_break := True
										end
										if not (l_return or l_break) then
											l_temp_real___3 := (0.0).truncated_to_real
											l_temp_imag___3 := (0.0).truncated_to_real
											l_k := 0
											from
											until
												not (l_k < l_j)
											loop
												l_Akj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
												l_Akj_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)])
												l_Bik_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
												l_Bik_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
												l_temp_real___3 := l_temp_real___3 + (l_Akj_real * l_Bik_real - l_Akj_imag * l_Bik_imag)
												l_temp_imag___3 := l_temp_imag___3 + (l_Akj_real * l_Bik_imag + l_Akj_imag * l_Bik_real)
												l_k := l_k + 1
											end
											if l_nonunit.to_boolean then
												l_Ajj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
												l_Ajj_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)])
												l_Bij_real___3 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
												l_Bij_imag___3 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
												l_temp_real___3 := l_temp_real___3 + (l_Ajj_real * l_Bij_real___3 - l_Ajj_imag * l_Bij_imag___3)
												l_temp_imag___3 := l_temp_imag___3 + (l_Ajj_real * l_Bij_imag___3 + l_Ajj_imag * l_Bij_real___3)
											else
												l_temp_real___3 := l_temp_real___3 + (create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)])
												l_temp_imag___3 := l_temp_imag___3 + (create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)])
											end
											create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___3 - l_alpha_imag * l_temp_imag___3
											create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___3 + l_alpha_imag * l_temp_real___3
										end
									end
									l_break := False
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 15 -- goto _L___4
							end
						else
							l_pos := -1 + 15 -- goto _L___4
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 15 then -- else: | _L___4:
						if l_side /= 142 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if l_uplo = 121 then
							if l_trans = 112 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j < l_n2))
									loop
										l_temp_real___4 := (0.0).truncated_to_real
										l_temp_imag___4 := (0.0).truncated_to_real
										if l_nonunit.to_boolean then
											l_Ajj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
											l_Ajj_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)])
											l_Bij_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_Bij_imag___4 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
											l_temp_real___4 := l_Ajj_real___0 * l_Bij_real___4 - l_Ajj_imag___0 * l_Bij_imag___4
											l_temp_imag___4 := l_Ajj_real___0 * l_Bij_imag___4 + l_Ajj_imag___0 * l_Bij_real___4
										else
											l_temp_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_temp_imag___4 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
										end
										l_k := l_j + 1
										from
										until
											not (l_k < l_n2)
										loop
											l_Ajk_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
											l_Ajk_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
											l_Bik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
											l_Bik_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
											l_temp_real___4 := l_temp_real___4 + (l_Ajk_real * l_Bik_real___0 - l_Ajk_imag * l_Bik_imag___0)
											l_temp_imag___4 := l_temp_imag___4 + (l_Ajk_real * l_Bik_imag___0 + l_Ajk_imag * l_Bik_real___0)
											l_k := l_k + 1
										end
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___4 - l_alpha_imag * l_temp_imag___4
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___4 + l_alpha_imag * l_temp_real___4
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 18 -- goto _L___2
							end
						else
							l_pos := -1 + 18 -- goto _L___2
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 18 then -- else: | _L___2:
						if l_side /= 142 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if l_uplo = 122 then
							if l_trans = 111 then
								l_i := 0
								from
								until
									not (not (l_return) and then (l_i < l_n1))
								loop
									l_j := 0
									from
									until
										not (not (l_return) and then (l_j < l_n2))
									loop
										l_temp_real___5 := (0.0).truncated_to_real
										l_temp_imag___5 := (0.0).truncated_to_real
										if l_nonunit.to_boolean then
											l_Ajj_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
											l_Ajj_imag___1 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)])
											l_Bij_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_Bij_imag___5 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
											l_temp_real___5 := l_Ajj_real___1 * l_Bij_real___5 - l_Ajj_imag___1 * l_Bij_imag___5
											l_temp_imag___5 := l_Ajj_real___1 * l_Bij_imag___5 + l_Ajj_imag___1 * l_Bij_real___5
										else
											l_temp_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
											l_temp_imag___5 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
										end
										l_k := l_j + 1
										from
										until
											not (l_k < l_n2)
										loop
											l_Akj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
											l_Akj_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)])
											l_Bik_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
											l_Bik_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
											l_temp_real___5 := l_temp_real___5 + (l_Akj_real___0 * l_Bik_real___1 - l_Akj_imag___0 * l_Bik_imag___1)
											l_temp_imag___5 := l_temp_imag___5 + (l_Akj_real___0 * l_Bik_imag___1 + l_Akj_imag___0 * l_Bik_real___1)
											l_k := l_k + 1
										end
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___5 - l_alpha_imag * l_temp_imag___5
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___5 + l_alpha_imag * l_temp_real___5
										l_j := l_j + 1
									end
									l_i := l_i + 1
								end
							else
								l_pos := -1 + 21 -- goto _L___0
							end
						else
							l_pos := -1 + 21 -- goto _L___0
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___0:
						if l_side = 142 then
							if l_uplo = 122 then
								if l_trans = 112 then
									l_i := 0
									from
									until
										not (not (l_return) and then (l_i < l_n1))
									loop
										l_j := l_n2
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if l_j > 0 then
												l_tmp___3 := l_j
												l_j := l_j - 1
												if not l_tmp___3.to_boolean then
													l_break := True
												end
											else
												l_break := True
											end
											if not (l_return or l_break) then
												l_temp_real___6 := (0.0).truncated_to_real
												l_temp_imag___6 := (0.0).truncated_to_real
												l_k := 0
												from
												until
													not (l_k < l_j)
												loop
													l_Ajk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
													l_Ajk_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
													l_Bik_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_k)]
													l_Bik_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_k) + 1)]
													l_temp_real___6 := l_temp_real___6 + (l_Ajk_real___0 * l_Bik_real___2 - l_Ajk_imag___0 * l_Bik_imag___2)
													l_temp_imag___6 := l_temp_imag___6 + (l_Ajk_real___0 * l_Bik_imag___2 + l_Ajk_imag___0 * l_Bik_real___2)
													l_k := l_k + 1
												end
												if l_nonunit.to_boolean then
													l_Ajj_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_j)]
													l_Ajj_imag___2 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_j) + 1)])
													l_Bij_real___6 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)]
													l_Bij_imag___6 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)]
													l_temp_real___6 := l_temp_real___6 + (l_Ajj_real___2 * l_Bij_real___6 - l_Ajj_imag___2 * l_Bij_imag___6)
													l_temp_imag___6 := l_temp_imag___6 + (l_Ajj_real___2 * l_Bij_imag___6 + l_Ajj_imag___2 * l_Bij_real___6)
												else
													l_temp_real___6 := l_temp_real___6 + (create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (l_i * a_ldb + l_j)])
													l_temp_imag___6 := l_temp_imag___6 + (create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (l_i * a_ldb + l_j) + 1)])
												end
												create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_temp_real___6 - l_alpha_imag * l_temp_imag___6
												create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_temp_imag___6 + l_alpha_imag * l_temp_real___6
											end
										end
										l_break := False
										l_i := l_i + 1
									end
								else
									(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trmm_c.h"), ce_string ("unrecognized operation")])
								end
							else
								(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trmm_c.h"), ce_string ("unrecognized operation")])
							end
						else
							(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trmm_c.h"), ce_string ("unrecognized operation")])
						end
				when 22 then -- if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_ctrmv (a_order, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_N: INTEGER_32; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp___0: NATURAL_32
			l_nonunit: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_tmp___1: INTEGER_32
			l_temp_r: REAL_32
			l_temp_i: REAL_32
			l_j_min: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___2: INTEGER_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_A_real: REAL_32
			l_A_imag: REAL_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_A_real___0: REAL_32
			l_A_imag___0: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_temp_r___0: REAL_32
			l_temp_i___0: REAL_32
			l_j_max: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_x_real___1: REAL_32
			l_x_imag___1: REAL_32
			l_A_real___1: REAL_32
			l_A_imag___1: REAL_32
			l_x_real___2: REAL_32
			l_x_imag___2: REAL_32
			l_A_real___2: REAL_32
			l_A_imag___2: REAL_32
			l_tmp___5: INTEGER_32
			l_ix___1: INTEGER_32
			l_tmp___6: INTEGER_32
			l_temp_r___1: REAL_32
			l_temp_i___1: REAL_32
			l_j_max___0: INTEGER_32
			l_jx___1: INTEGER_32
			l_tmp___7: INTEGER_32
			l_x_real___3: REAL_32
			l_x_imag___3: REAL_32
			l_A_real___3: REAL_32
			l_A_imag___3: REAL_32
			l_x_real___4: REAL_32
			l_x_imag___4: REAL_32
			l_A_real___4: REAL_32
			l_A_imag___4: REAL_32
			l_tmp___8: INTEGER_32
			l_ix___2: INTEGER_32
			l_tmp___9: INTEGER_32
			l_temp_r___2: REAL_32
			l_temp_i___2: REAL_32
			l_j_min___0: INTEGER_32
			l_jx___2: INTEGER_32
			l_tmp___10: INTEGER_32
			l_x_real___5: REAL_32
			l_x_imag___5: REAL_32
			l_A_real___5: REAL_32
			l_A_imag___5: REAL_32
			l_x_real___6: REAL_32
			l_x_imag___6: REAL_32
			l_A_real___6: REAL_32
			l_A_imag___6: REAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					if a_TransA /= {NATURAL_32} 113 then
						l_tmp___0 := a_TransA
					else
						l_tmp___0 := {NATURAL_32} 112
					end
					l_Trans := l_tmp___0.to_integer_32
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_order /= {NATURAL_32} 101 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 6 -- goto _L___12
							else
								l_pos := -1 + 3 -- goto _L___16
							end
						else
							l_pos := -1 + 3 -- goto _L___16
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 3 then -- else: | _L___16:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___1
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_temp_r := (0.0).truncated_to_real
							l_temp_i := (0.0).truncated_to_real
							l_j_min := l_i + 1
							if a_incX > 0 then
								l_tmp___2 := 0
							else
								l_tmp___2 := (a_N - 1) * -a_incX
							end
							l_jx := l_tmp___2 + a_incX * l_j_min
							l_j := l_j_min
							from
							until
								not (l_j < a_N)
							loop
								l_x_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx]
								l_x_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
								l_A_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
								l_A_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)])
								l_temp_r := l_temp_r + (l_A_real * l_x_real - l_A_imag * l_x_imag)
								l_temp_i := l_temp_i + (l_A_real * l_x_imag + l_A_imag * l_x_real)
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_x_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
								l_x_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
								l_A_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								l_A_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := l_temp_r + (l_A_real___0 * l_x_real___0 - l_A_imag___0 * l_x_imag___0)
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_temp_i + (l_A_real___0 * l_x_imag___0 + l_A_imag___0 * l_x_real___0)
							else
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] + l_temp_r
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] + l_temp_i
							end
							l_ix := l_ix + a_incX
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 12 -- goto _L___14
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___14
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 12 then -- else: | _L___14:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 18 -- goto _L___7
							else
								l_pos := -1 + 15 -- goto _L___11
							end
						else
							l_pos := -1 + 15 -- goto _L___11
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 15 then -- else: | _L___11:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L___7:
						if a_incX > 0 then
							l_tmp___3 := 0
						else
							l_tmp___3 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___3 + (a_N - 1) * a_incX
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___5 := l_i
								l_i := l_i - 1
								if not l_tmp___5.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_temp_r___0 := (0.0).truncated_to_real
								l_temp_i___0 := (0.0).truncated_to_real
								l_j_max := l_i
								if a_incX > 0 then
									l_tmp___4 := 0
								else
									l_tmp___4 := (a_N - 1) * -a_incX
								end
								l_jx___0 := l_tmp___4
								l_j := 0
								from
								until
									not (l_j < l_j_max)
								loop
									l_x_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx___0]
									l_x_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx___0 + 1)]
									l_A_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
									l_A_imag___1 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)])
									l_temp_r___0 := l_temp_r___0 + (l_A_real___1 * l_x_real___1 - l_A_imag___1 * l_x_imag___1)
									l_temp_i___0 := l_temp_i___0 + (l_A_real___1 * l_x_imag___1 + l_A_imag___1 * l_x_real___1)
									l_jx___0 := l_jx___0 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_x_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0]
									l_x_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
									l_A_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
									l_A_imag___2 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0] := l_temp_r___0 + (l_A_real___2 * l_x_real___2 - l_A_imag___2 * l_x_imag___2)
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] := l_temp_i___0 + (l_A_real___2 * l_x_imag___2 + l_A_imag___2 * l_x_real___2)
								else
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0] := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0] + l_temp_r___0
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] + l_temp_i___0
								end
								l_ix___0 := l_ix___0 - a_incX
							end
						end
						l_break := False
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 24 -- goto _L___9
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___9
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 24 then -- else: | _L___9:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 30 -- goto _L___2
							else
								l_pos := -1 + 27 -- goto _L___6
							end
						else
							l_pos := -1 + 27 -- goto _L___6
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 27 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 36 -- skip if block
						end
				when 28 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 34 -- skip if block
						end
				when 29 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := (a_N - 1) * -a_incX
						end
						l_ix___1 := l_tmp___6 + (a_N - 1) * a_incX
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___8 := l_i
								l_i := l_i - 1
								if not l_tmp___8.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_temp_r___1 := (0.0).truncated_to_real
								l_temp_i___1 := (0.0).truncated_to_real
								l_j_max___0 := l_i
								if a_incX > 0 then
									l_tmp___7 := 0
								else
									l_tmp___7 := (a_N - 1) * -a_incX
								end
								l_jx___1 := l_tmp___7
								l_j := 0
								from
								until
									not (l_j < l_j_max___0)
								loop
									l_x_real___3 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx___1]
									l_x_imag___3 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx___1 + 1)]
									l_A_real___3 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_i)]
									l_A_imag___3 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_i) + 1)])
									l_temp_r___1 := l_temp_r___1 + (l_A_real___3 * l_x_real___3 - l_A_imag___3 * l_x_imag___3)
									l_temp_i___1 := l_temp_i___1 + (l_A_real___3 * l_x_imag___3 + l_A_imag___3 * l_x_real___3)
									l_jx___1 := l_jx___1 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_x_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1]
									l_x_imag___4 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)]
									l_A_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
									l_A_imag___4 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1] := l_temp_r___1 + (l_A_real___4 * l_x_real___4 - l_A_imag___4 * l_x_imag___4)
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] := l_temp_i___1 + (l_A_real___4 * l_x_imag___4 + l_A_imag___4 * l_x_real___4)
								else
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1] := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1] + l_temp_r___1
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] + l_temp_i___1
								end
								l_ix___1 := l_ix___1 - a_incX
							end
						end
						l_break := False
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 36 -- goto _L___4
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 36 -- goto _L___4
				when 35 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 36 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 42 -- goto _L
							else
								l_pos := -1 + 39 -- goto _L___1
							end
						else
							l_pos := -1 + 39 -- goto _L___1
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 39 then -- else: | _L___1:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 48 -- skip if block
						end
				when 40 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___9 := 0
						else
							l_tmp___9 := (a_N - 1) * -a_incX
						end
						l_ix___2 := l_tmp___9
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_temp_r___2 := (0.0).truncated_to_real
							l_temp_i___2 := (0.0).truncated_to_real
							l_j_min___0 := l_i + 1
							if a_incX > 0 then
								l_tmp___10 := 0
							else
								l_tmp___10 := (a_N - 1) * -a_incX
							end
							l_jx___2 := l_tmp___10 + l_j_min___0 * a_incX
							l_j := l_j_min___0
							from
							until
								not (l_j < a_N)
							loop
								l_x_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx___2]
								l_x_imag___5 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx___2 + 1)]
								l_A_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_i)]
								l_A_imag___5 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_i) + 1)])
								l_temp_r___2 := l_temp_r___2 + (l_A_real___5 * l_x_real___5 - l_A_imag___5 * l_x_imag___5)
								l_temp_i___2 := l_temp_i___2 + (l_A_real___5 * l_x_imag___5 + l_A_imag___5 * l_x_real___5)
								l_jx___2 := l_jx___2 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_x_real___6 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2]
								l_x_imag___6 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)]
								l_A_real___6 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								l_A_imag___6 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2] := l_temp_r___2 + (l_A_real___6 * l_x_real___6 - l_A_imag___6 * l_x_imag___6)
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] := l_temp_i___2 + (l_A_real___6 * l_x_imag___6 + l_A_imag___6 * l_x_real___6)
							else
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2] := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2] + l_temp_r___2
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] + l_temp_i___2
							end
							l_ix___2 := l_ix___2 + a_incX
							l_i := l_i + 1
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trmv_c.h"), ce_string ("unrecognized operation")])
				when 45 then -- if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trmv_c.h"), ce_string ("unrecognized operation")])
				when 47 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trmv_c.h"), ce_string ("unrecognized operation")])
				when 49 then -- if done | if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cblas_ctrsm (a_Order, a_Side, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_M, a_N: INTEGER_32; a_alpha, a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_B: CE_POINTER [ANY]; a_ldb: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_nonunit: INTEGER_32
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_side: INTEGER_32
			l_uplo: INTEGER_32
			l_trans: INTEGER_32
			l_alpha_real: REAL_32
			l_alpha_imag: REAL_32
			l_Bij_real: REAL_32
			l_Bij_imag: REAL_32
			l_Aii_real: REAL_32
			l_Aii_imag: REAL_32
			l_s: REAL_32
			l_a_real: REAL_32
			l_a_imag: REAL_32
			l_Bij_real___0: REAL_32
			l_Bij_imag___0: REAL_32
			l_Aki_real: REAL_32
			l_Aki_imag: REAL_32
			l_Bij_real___1: REAL_32
			l_Bij_imag___1: REAL_32
			l_tmp___1: INTEGER_32
			l_Bij_real___2: REAL_32
			l_Bij_imag___2: REAL_32
			l_Aii_real___0: REAL_32
			l_Aii_imag___0: REAL_32
			l_s___0: REAL_32
			l_a_real___0: REAL_32
			l_a_imag___0: REAL_32
			l_Bij_real___3: REAL_32
			l_Bij_imag___3: REAL_32
			l_Aik_real: REAL_32
			l_Aik_imag: REAL_32
			l_Bij_real___4: REAL_32
			l_Bij_imag___4: REAL_32
			l_Bij_real___5: REAL_32
			l_Bij_imag___5: REAL_32
			l_Aii_real___1: REAL_32
			l_Aii_imag___1: REAL_32
			l_s___1: REAL_32
			l_a_real___1: REAL_32
			l_a_imag___1: REAL_32
			l_Bij_real___6: REAL_32
			l_Bij_imag___6: REAL_32
			l_Aki_real___0: REAL_32
			l_Aki_imag___0: REAL_32
			l_Bij_real___7: REAL_32
			l_Bij_imag___7: REAL_32
			l_Bij_real___8: REAL_32
			l_Bij_imag___8: REAL_32
			l_Aii_real___2: REAL_32
			l_Aii_imag___2: REAL_32
			l_s___2: REAL_32
			l_a_real___2: REAL_32
			l_a_imag___2: REAL_32
			l_Bij_real___9: REAL_32
			l_Bij_imag___9: REAL_32
			l_Aik_real___0: REAL_32
			l_Aik_imag___0: REAL_32
			l_Bij_real___10: REAL_32
			l_Bij_imag___10: REAL_32
			l_tmp___5: INTEGER_32
			l_Bij_real___11: REAL_32
			l_Bij_imag___11: REAL_32
			l_Ajj_real: REAL_32
			l_Ajj_imag: REAL_32
			l_s___3: REAL_32
			l_a_real___3: REAL_32
			l_a_imag___3: REAL_32
			l_Bij_real___12: REAL_32
			l_Bij_imag___12: REAL_32
			l_Bij_real___13: REAL_32
			l_Bij_imag___13: REAL_32
			l_Ajk_real: REAL_32
			l_Ajk_imag: REAL_32
			l_Bij_real___14: REAL_32
			l_Bij_imag___14: REAL_32
			l_Ajj_real___0: REAL_32
			l_Ajj_imag___0: REAL_32
			l_s___4: REAL_32
			l_a_real___4: REAL_32
			l_a_imag___4: REAL_32
			l_Bij_real___15: REAL_32
			l_Bij_imag___15: REAL_32
			l_Bij_real___16: REAL_32
			l_Bij_imag___16: REAL_32
			l_Akj_real: REAL_32
			l_Akj_imag: REAL_32
			l_tmp___8: INTEGER_32
			l_Bij_real___17: REAL_32
			l_Bij_imag___17: REAL_32
			l_Ajj_real___1: REAL_32
			l_Ajj_imag___1: REAL_32
			l_s___5: REAL_32
			l_a_real___5: REAL_32
			l_a_imag___5: REAL_32
			l_Bij_real___18: REAL_32
			l_Bij_imag___18: REAL_32
			l_Bij_real___19: REAL_32
			l_Bij_imag___19: REAL_32
			l_Ajk_real___0: REAL_32
			l_Ajk_imag___0: REAL_32
			l_tmp___10: INTEGER_32
			l_Bij_real___20: REAL_32
			l_Bij_imag___20: REAL_32
			l_Ajj_real___2: REAL_32
			l_Ajj_imag___2: REAL_32
			l_s___6: REAL_32
			l_a_real___6: REAL_32
			l_a_imag___6: REAL_32
			l_Bij_real___21: REAL_32
			l_Bij_imag___21: REAL_32
			l_Bij_real___22: REAL_32
			l_Bij_imag___22: REAL_32
			l_Akj_real___0: REAL_32
			l_Akj_imag___0: REAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					l_alpha_real := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[0]
					l_alpha_imag := create {CE_REAL_32_POINTER}.make_cast (a_alpha)[1]
					if a_Order = {NATURAL_32} 101 then
						l_n1 := a_M
						l_n2 := a_N
						l_side := a_Side.to_integer_32
						l_uplo := a_Uplo.to_integer_32
						l_trans := a_TransA.to_integer_32
						if a_TransA = {NATURAL_32} 111 then
							l_trans := 111
						else
							l_trans := 112
						end
					else
						l_n1 := a_N
						l_n2 := a_M
						if a_Side = {NATURAL_32} 141 then
							l_side := 142
						else
							l_side := 141
						end
						if a_Uplo = {NATURAL_32} 121 then
							l_uplo := 122
						else
							l_uplo := 121
						end
						if a_TransA = {NATURAL_32} 111 then
							l_trans := 111
						else
							l_trans := 112
						end
					end
					if l_side /= 141 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if:
						if l_trans /= 111 then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real - l_alpha_imag * l_Bij_imag
								create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag + l_alpha_imag * l_Bij_real
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 7 then
						l_i := l_n1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___1 := l_i
								l_i := l_i - 1
								if not l_tmp___1.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if l_nonunit.to_boolean then
									l_Aii_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
									l_Aii_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
									l_s := (xhypot___1 (l_Aii_real.to_double, l_Aii_imag.to_double)).truncated_to_real
									l_a_real := l_Aii_real / l_s
									l_a_imag := l_Aii_imag / l_s
									l_j := 0
									from
									until
										not (l_j < l_n2)
									loop
										l_Bij_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___0 * l_a_real + l_Bij_imag___0 * l_a_imag) / l_s
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___0 * l_a_real - l_Bij_real___0 * l_a_imag) / l_s
										l_j := l_j + 1
									end
								end
								l_k := 0
								from
								until
									not (not (l_return) and then (l_k < l_i))
								loop
									l_Aki_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
									l_Aki_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
									l_j := 0
									from
									until
										not (l_j < l_n2)
									loop
										l_Bij_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] - (l_Aki_real * l_Bij_real___1 - l_Aki_imag * l_Bij_imag___1)
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] - (l_Aki_real * l_Bij_imag___1 + l_Aki_imag * l_Bij_real___1)
										l_j := l_j + 1
									end
									l_k := l_k + 1
								end
							end
						end
						l_break := False
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___20
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___20
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 13 then -- else: | _L___20:
						if l_side /= 141 then
							l_pos := -1 + 26 -- skip if block
						end
				when 14 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 24 -- skip if block
						end
				when 15 then -- if:
						if l_trans /= 112 then
							l_pos := -1 + 22 -- skip if block
						end
				when 16 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 19 -- goto _L___0
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___0:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___2 - l_alpha_imag * l_Bij_imag___2
								create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___2 + l_alpha_imag * l_Bij_real___2
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 20 then
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							if l_nonunit.to_boolean then
								l_Aii_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								l_Aii_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
								l_s___0 := (xhypot___1 (l_Aii_real___0.to_double, l_Aii_imag___0.to_double)).truncated_to_real
								l_a_real___0 := l_Aii_real___0 / l_s___0
								l_a_imag___0 := l_Aii_imag___0 / l_s___0
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									l_Bij_real___3 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___3 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___3 * l_a_real___0 + l_Bij_imag___3 * l_a_imag___0) / l_s___0
									create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___3 * l_a_real___0 - l_Bij_real___3 * l_a_imag___0) / l_s___0
									l_j := l_j + 1
								end
							end
							l_k := l_i + 1
							from
							until
								not (not (l_return) and then (l_k < l_n1))
							loop
								l_Aik_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
								l_Aik_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)])
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									l_Bij_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___4 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] - (l_Aik_real * l_Bij_real___4 - l_Aik_imag * l_Bij_imag___4)
									create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] - (l_Aik_real * l_Bij_imag___4 + l_Aik_imag * l_Bij_real___4)
									l_j := l_j + 1
								end
								l_k := l_k + 1
							end
							l_i := l_i + 1
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 26 -- goto _L___18
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_pos := -1 + 26 -- goto _L___18
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 26 then -- else: | _L___18:
						if l_side /= 141 then
							l_pos := -1 + 39 -- skip if block
						end
				when 27 then -- if:
						if l_uplo /= 122 then
							l_pos := -1 + 37 -- skip if block
						end
				when 28 then -- if:
						if l_trans /= 111 then
							l_pos := -1 + 35 -- skip if block
						end
				when 29 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 32 -- goto _L___1
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else: | _L___1:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___5 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___5 - l_alpha_imag * l_Bij_imag___5
								create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___5 + l_alpha_imag * l_Bij_real___5
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 33 then
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							if l_nonunit.to_boolean then
								l_Aii_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								l_Aii_imag___1 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
								l_s___1 := (xhypot___1 (l_Aii_real___1.to_double, l_Aii_imag___1.to_double)).truncated_to_real
								l_a_real___1 := l_Aii_real___1 / l_s___1
								l_a_imag___1 := l_Aii_imag___1 / l_s___1
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									l_Bij_real___6 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___6 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___6 * l_a_real___1 + l_Bij_imag___6 * l_a_imag___1) / l_s___1
									create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___6 * l_a_real___1 - l_Bij_real___6 * l_a_imag___1) / l_s___1
									l_j := l_j + 1
								end
							end
							l_k := l_i + 1
							from
							until
								not (not (l_return) and then (l_k < l_n1))
							loop
								l_Aki_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_i)]
								l_Aki_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_i) + 1)])
								l_j := 0
								from
								until
									not (l_j < l_n2)
								loop
									l_Bij_real___7 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___7 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] - (l_Aki_real___0 * l_Bij_real___7 - l_Aki_imag___0 * l_Bij_imag___7)
									create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] - (l_Aki_real___0 * l_Bij_imag___7 + l_Aki_imag___0 * l_Bij_real___7)
									l_j := l_j + 1
								end
								l_k := l_k + 1
							end
							l_i := l_i + 1
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 39 -- goto _L___16
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 38
				when 37 then -- else:
						l_pos := -1 + 39 -- goto _L___16
				when 38 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 39 then -- else: | _L___16:
						if l_side /= 141 then
							l_pos := -1 + 52 -- skip if block
						end
				when 40 then -- if:
						if l_uplo /= 122 then
							l_pos := -1 + 50 -- skip if block
						end
				when 41 then -- if:
						if l_trans /= 112 then
							l_pos := -1 + 48 -- skip if block
						end
				when 42 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 45 -- goto _L___2
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else: | _L___2:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___8 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___8 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___8 - l_alpha_imag * l_Bij_imag___8
								create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___8 + l_alpha_imag * l_Bij_real___8
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 46 then
						l_i := l_n1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___5 := l_i
								l_i := l_i - 1
								if not l_tmp___5.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								if l_nonunit.to_boolean then
									l_Aii_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
									l_Aii_imag___2 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
									l_s___2 := (xhypot___1 (l_Aii_real___2.to_double, l_Aii_imag___2.to_double)).truncated_to_real
									l_a_real___2 := l_Aii_real___2 / l_s___2
									l_a_imag___2 := l_Aii_imag___2 / l_s___2
									l_j := 0
									from
									until
										not (l_j < l_n2)
									loop
										l_Bij_real___9 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___9 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___9 * l_a_real___2 + l_Bij_imag___9 * l_a_imag___2) / l_s___2
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___9 * l_a_real___2 - l_Bij_real___9 * l_a_imag___2) / l_s___2
										l_j := l_j + 1
									end
								end
								l_k := 0
								from
								until
									not (not (l_return) and then (l_k < l_i))
								loop
									l_Aik_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_i * a_lda + l_k)]
									l_Aik_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_i * a_lda + l_k) + 1)])
									l_j := 0
									from
									until
										not (l_j < l_n2)
									loop
										l_Bij_real___10 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___10 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_k + l_j)] - (l_Aik_real___0 * l_Bij_real___10 - l_Aik_imag___0 * l_Bij_imag___10)
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_k + l_j) + 1)] - (l_Aik_real___0 * l_Bij_imag___10 + l_Aik_imag___0 * l_Bij_real___10)
										l_j := l_j + 1
									end
									l_k := l_k + 1
								end
							end
						end
						l_break := False
				when 47 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:
						l_pos := -1 + 52 -- goto _L___14
				when 49 then -- if done | if block done, skip else block:
						l_pos := -1 + 51
				when 50 then -- else:
						l_pos := -1 + 52 -- goto _L___14
				when 51 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 52 then -- else: | _L___14:
						if l_side /= 142 then
							l_pos := -1 + 65 -- skip if block
						end
				when 53 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 63 -- skip if block
						end
				when 54 then -- if:
						if l_trans /= 111 then
							l_pos := -1 + 61 -- skip if block
						end
				when 55 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 58 -- goto _L___3
						end
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 59
				when 58 then -- else: | _L___3:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___11 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___11 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___11 - l_alpha_imag * l_Bij_imag___11
								create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___11 + l_alpha_imag * l_Bij_real___11
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 59 then
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (not (l_return) and then (l_j < l_n2))
							loop
								if l_nonunit.to_boolean then
									l_Ajj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_j)]
									l_Ajj_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_j) + 1)])
									l_s___3 := (xhypot___1 (l_Ajj_real.to_double, l_Ajj_imag.to_double)).truncated_to_real
									l_a_real___3 := l_Ajj_real / l_s___3
									l_a_imag___3 := l_Ajj_imag / l_s___3
									l_Bij_real___12 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___12 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___12 * l_a_real___3 + l_Bij_imag___12 * l_a_imag___3) / l_s___3
									create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___12 * l_a_real___3 - l_Bij_real___12 * l_a_imag___3) / l_s___3
								end
								l_Bij_real___13 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___13 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								l_k := l_j + 1
								from
								until
									not (l_k < l_n2)
								loop
									l_Ajk_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
									l_Ajk_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
									create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] - (l_Ajk_real * l_Bij_real___13 - l_Ajk_imag * l_Bij_imag___13)
									create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] - (l_Ajk_real * l_Bij_imag___13 + l_Ajk_imag * l_Bij_real___13)
									l_k := l_k + 1
								end
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 62
				when 61 then -- else:
						l_pos := -1 + 65 -- goto _L___12
				when 62 then -- if done | if block done, skip else block:
						l_pos := -1 + 64
				when 63 then -- else:
						l_pos := -1 + 65 -- goto _L___12
				when 64 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 65 then -- else: | _L___12:
						if l_side /= 142 then
							l_pos := -1 + 78 -- skip if block
						end
				when 66 then -- if:
						if l_uplo /= 121 then
							l_pos := -1 + 76 -- skip if block
						end
				when 67 then -- if:
						if l_trans /= 112 then
							l_pos := -1 + 74 -- skip if block
						end
				when 68 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 71 -- skip if block
						end
				when 69 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 71 -- goto _L___4
						end
				when 70 then -- if block done, skip else block:
						l_pos := -1 + 72
				when 71 then -- else: | _L___4:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___14 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___14 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___14 - l_alpha_imag * l_Bij_imag___14
								create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___14 + l_alpha_imag * l_Bij_real___14
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 72 then
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := l_n2
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_j > 0 then
									l_tmp___8 := l_j
									l_j := l_j - 1
									if not l_tmp___8.to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									if l_nonunit.to_boolean then
										l_Ajj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_j)]
										l_Ajj_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_j) + 1)])
										l_s___4 := (xhypot___1 (l_Ajj_real___0.to_double, l_Ajj_imag___0.to_double)).truncated_to_real
										l_a_real___4 := l_Ajj_real___0 / l_s___4
										l_a_imag___4 := l_Ajj_imag___0 / l_s___4
										l_Bij_real___15 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___15 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___15 * l_a_real___4 + l_Bij_imag___15 * l_a_imag___4) / l_s___4
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___15 * l_a_real___4 - l_Bij_real___15 * l_a_imag___4) / l_s___4
									end
									l_Bij_real___16 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___16 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_k := 0
									from
									until
										not (l_k < l_j)
									loop
										l_Akj_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
										l_Akj_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)])
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] - (l_Akj_real * l_Bij_real___16 - l_Akj_imag * l_Bij_imag___16)
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] - (l_Akj_real * l_Bij_imag___16 + l_Akj_imag * l_Bij_real___16)
										l_k := l_k + 1
									end
								end
							end
							l_break := False
							l_i := l_i + 1
						end
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 75
				when 74 then -- else:
						l_pos := -1 + 78 -- goto _L___10
				when 75 then -- if done | if block done, skip else block:
						l_pos := -1 + 77
				when 76 then -- else:
						l_pos := -1 + 78 -- goto _L___10
				when 77 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 78 then -- else: | _L___10:
						if l_side /= 142 then
							l_pos := -1 + 91 -- skip if block
						end
				when 79 then -- if:
						if l_uplo /= 122 then
							l_pos := -1 + 89 -- skip if block
						end
				when 80 then -- if:
						if l_trans /= 111 then
							l_pos := -1 + 87 -- skip if block
						end
				when 81 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 84 -- goto _L___5
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 85
				when 84 then -- else: | _L___5:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___17 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___17 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___17 - l_alpha_imag * l_Bij_imag___17
								create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___17 + l_alpha_imag * l_Bij_real___17
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 85 then
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := l_n2
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_j > 0 then
									l_tmp___10 := l_j
									l_j := l_j - 1
									if not l_tmp___10.to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_return or l_break) then
									if l_nonunit.to_boolean then
										l_Ajj_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_j)]
										l_Ajj_imag___1 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_j) + 1)])
										l_s___5 := (xhypot___1 (l_Ajj_real___1.to_double, l_Ajj_imag___1.to_double)).truncated_to_real
										l_a_real___5 := l_Ajj_real___1 / l_s___5
										l_a_imag___5 := l_Ajj_imag___1 / l_s___5
										l_Bij_real___18 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
										l_Bij_imag___18 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___18 * l_a_real___5 + l_Bij_imag___18 * l_a_imag___5) / l_s___5
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___18 * l_a_real___5 - l_Bij_real___18 * l_a_imag___5) / l_s___5
									end
									l_Bij_real___19 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___19 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									l_k := 0
									from
									until
										not (l_k < l_j)
									loop
										l_Ajk_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_j * a_lda + l_k)]
										l_Ajk_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_j * a_lda + l_k) + 1)])
										create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] - (l_Ajk_real___0 * l_Bij_real___19 - l_Ajk_imag___0 * l_Bij_imag___19)
										create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] - (l_Ajk_real___0 * l_Bij_imag___19 + l_Ajk_imag___0 * l_Bij_real___19)
										l_k := l_k + 1
									end
								end
							end
							l_break := False
							l_i := l_i + 1
						end
				when 86 then -- if block done, skip else block:
						l_pos := -1 + 88
				when 87 then -- else:
						l_pos := -1 + 91 -- goto _L___8
				when 88 then -- if done | if block done, skip else block:
						l_pos := -1 + 90
				when 89 then -- else:
						l_pos := -1 + 91 -- goto _L___8
				when 90 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 91 then -- else: | _L___8:
						if l_side /= 142 then
							l_pos := -1 + 104 -- skip if block
						end
				when 92 then -- if:
						if l_uplo /= 122 then
							l_pos := -1 + 102 -- skip if block
						end
				when 93 then -- if:
						if l_trans /= 112 then
							l_pos := -1 + 100 -- skip if block
						end
				when 94 then -- if:
						if l_alpha_real.to_double /= 1.0 then
							l_pos := -1 + 97 -- skip if block
						end
				when 95 then -- if:
						if l_alpha_imag.to_double /= 0.0 then
							l_pos := -1 + 97 -- goto _L___6
						end
				when 96 then -- if block done, skip else block:
						l_pos := -1 + 98
				when 97 then -- else: | _L___6:
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (l_j < l_n2)
							loop
								l_Bij_real___20 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___20 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := l_alpha_real * l_Bij_real___20 - l_alpha_imag * l_Bij_imag___20
								create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := l_alpha_real * l_Bij_imag___20 + l_alpha_imag * l_Bij_real___20
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 98 then
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < l_n1))
						loop
							l_j := 0
							from
							until
								not (not (l_return) and then (l_j < l_n2))
							loop
								if l_nonunit.to_boolean then
									l_Ajj_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_j)]
									l_Ajj_imag___2 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_j) + 1)])
									l_s___6 := (xhypot___1 (l_Ajj_real___2.to_double, l_Ajj_imag___2.to_double)).truncated_to_real
									l_a_real___6 := l_Ajj_real___2 / l_s___6
									l_a_imag___6 := l_Ajj_imag___2 / l_s___6
									l_Bij_real___21 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
									l_Bij_imag___21 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
									create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)] := (l_Bij_real___21 * l_a_real___6 + l_Bij_imag___21 * l_a_imag___6) / l_s___6
									create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)] := (l_Bij_imag___21 * l_a_real___6 - l_Bij_real___21 * l_a_imag___6) / l_s___6
								end
								l_Bij_real___22 := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_j)]
								l_Bij_imag___22 := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_j) + 1)]
								l_k := l_j + 1
								from
								until
									not (l_k < l_n2)
								loop
									l_Akj_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (l_k * a_lda + l_j)]
									l_Akj_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (l_k * a_lda + l_j) + 1)])
									create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[2 * (a_ldb * l_i + l_k)] - (l_Akj_real___0 * l_Bij_real___22 - l_Akj_imag___0 * l_Bij_imag___22)
									create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_B)[(2 * (a_ldb * l_i + l_k) + 1)] - (l_Akj_real___0 * l_Bij_imag___22 + l_Akj_imag___0 * l_Bij_real___22)
									l_k := l_k + 1
								end
								l_j := l_j + 1
							end
							l_i := l_i + 1
						end
				when 99 then -- if block done, skip else block:
						l_pos := -1 + 101
				when 100 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trsm_c.h"), ce_string ("unrecognized operation")])
				when 101 then -- if done | if block done, skip else block:
						l_pos := -1 + 103
				when 102 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trsm_c.h"), ce_string ("unrecognized operation")])
				when 103 then -- if done | if block done, skip else block:
						l_pos := -1 + 105
				when 104 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trsm_c.h"), ce_string ("unrecognized operation")])
				when 105 then -- if done | if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	xhypot___1 (a_x, a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				l_return := True
			end
			if not l_return then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

	cblas_ctrsv (a_order, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_N: INTEGER_32; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp___0: NATURAL_32
			l_nonunit: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___1: INTEGER_32
			l_a_real: REAL_32
			l_a_imag: REAL_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_s: REAL_32
			l_b_real: REAL_32
			l_b_imag: REAL_32
			l_tmp_real: REAL_32
			l_tmp_imag: REAL_32
			l_Aij_real: REAL_32
			l_Aij_imag: REAL_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_a_real___0: REAL_32
			l_a_imag___0: REAL_32
			l_s___0: REAL_32
			l_b_real___0: REAL_32
			l_b_imag___0: REAL_32
			l_tmp___4: INTEGER_32
			l_a_real___1: REAL_32
			l_a_imag___1: REAL_32
			l_x_real___1: REAL_32
			l_x_imag___1: REAL_32
			l_s___1: REAL_32
			l_b_real___1: REAL_32
			l_b_imag___1: REAL_32
			l_tmp_real___0: REAL_32
			l_tmp_imag___0: REAL_32
			l_Aij_real___0: REAL_32
			l_Aij_imag___0: REAL_32
			l_x_real___2: REAL_32
			l_x_imag___2: REAL_32
			l_a_real___2: REAL_32
			l_a_imag___2: REAL_32
			l_s___2: REAL_32
			l_b_real___2: REAL_32
			l_b_imag___2: REAL_32
			l_a_real___3: REAL_32
			l_a_imag___3: REAL_32
			l_x_real___3: REAL_32
			l_x_imag___3: REAL_32
			l_s___3: REAL_32
			l_b_real___3: REAL_32
			l_b_imag___3: REAL_32
			l_tmp_real___1: REAL_32
			l_tmp_imag___1: REAL_32
			l_Aij_real___1: REAL_32
			l_Aij_imag___1: REAL_32
			l_x_real___4: REAL_32
			l_x_imag___4: REAL_32
			l_a_real___4: REAL_32
			l_a_imag___4: REAL_32
			l_s___4: REAL_32
			l_b_real___4: REAL_32
			l_b_imag___4: REAL_32
			l_tmp___9: INTEGER_32
			l_a_real___5: REAL_32
			l_a_imag___5: REAL_32
			l_x_real___5: REAL_32
			l_x_imag___5: REAL_32
			l_s___5: REAL_32
			l_b_real___5: REAL_32
			l_b_imag___5: REAL_32
			l_tmp_real___2: REAL_32
			l_tmp_imag___2: REAL_32
			l_Aij_real___2: REAL_32
			l_Aij_imag___2: REAL_32
			l_x_real___6: REAL_32
			l_x_imag___6: REAL_32
			l_a_real___6: REAL_32
			l_a_imag___6: REAL_32
			l_s___6: REAL_32
			l_b_real___6: REAL_32
			l_b_imag___6: REAL_32
			l_tmp___12: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					if a_TransA /= {NATURAL_32} 113 then
						l_tmp___0 := a_TransA
					else
						l_tmp___0 := {NATURAL_32} 112
					end
					l_Trans := l_tmp___0.to_integer_32
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_N = 0 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 50 -- skip if block
					end
				when 1 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 7 -- goto _L___12
							else
								l_pos := -1 + 4 -- goto _L___16
							end
						else
							l_pos := -1 + 4 -- goto _L___16
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 4 then -- else: | _L___16:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___1 + a_incX * (a_N - 1)
						if l_nonunit.to_boolean then
							l_a_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * (a_N - 1) + (a_N - 1))]
							l_a_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * (a_N - 1) + (a_N - 1)) + 1)])
							l_x_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
							l_x_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							l_s := (xhypot___2 (l_a_real.to_double, l_a_imag.to_double)).truncated_to_real
							l_b_real := l_a_real / l_s
							l_b_imag := l_a_imag / l_s
							create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := (l_x_real * l_b_real + l_x_imag * l_b_imag) / l_s
							create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_x_imag * l_b_real - l_b_imag * l_x_real) / l_s
						end
						l_ix := l_ix - a_incX
						l_i := a_N - 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___4 := l_i
								l_i := l_i - 1
								if not l_tmp___4.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmp_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
								l_tmp_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
								l_jx := l_ix + a_incX
								l_j := l_i + 1
								from
								until
									not (l_j < a_N)
								loop
									l_Aij_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
									l_Aij_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)])
									l_x_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx]
									l_x_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
									l_tmp_real := l_tmp_real - (l_Aij_real * l_x_real___0 - l_Aij_imag * l_x_imag___0)
									l_tmp_imag := l_tmp_imag - (l_Aij_real * l_x_imag___0 + l_Aij_imag * l_x_real___0)
									l_jx := l_jx + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_a_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
									l_a_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
									l_s___0 := (xhypot___2 (l_a_real___0.to_double, l_a_imag___0.to_double)).truncated_to_real
									l_b_real___0 := l_a_real___0 / l_s___0
									l_b_imag___0 := l_a_imag___0 / l_s___0
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := (l_tmp_real * l_b_real___0 + l_tmp_imag * l_b_imag___0) / l_s___0
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_tmp_imag * l_b_real___0 - l_tmp_real * l_b_imag___0) / l_s___0
								else
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := l_tmp_real
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_tmp_imag
								end
								l_ix := l_ix - a_incX
							end
						end
						l_break := False
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 13 then -- else: | _L___14:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 19 -- goto _L___7
							else
								l_pos := -1 + 16 -- goto _L___11
							end
						else
							l_pos := -1 + 16 -- goto _L___11
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 16 then -- else: | _L___11:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___7:
						if a_incX > 0 then
							l_ix := 0
						else
							l_ix := (a_N - 1) * -a_incX
						end
						if l_nonunit.to_boolean then
							l_a_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[0]
							l_a_imag___1 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[1])
							l_x_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
							l_x_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							l_s___1 := (xhypot___2 (l_a_real___1.to_double, l_a_imag___1.to_double)).truncated_to_real
							l_b_real___1 := l_a_real___1 / l_s___1
							l_b_imag___1 := l_a_imag___1 / l_s___1
							create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := (l_x_real___1 * l_b_real___1 + l_x_imag___1 * l_b_imag___1) / l_s___1
							create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_x_imag___1 * l_b_real___1 - l_b_imag___1 * l_x_real___1) / l_s___1
						end
						l_ix := l_ix + a_incX
						l_i := 1
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
							l_tmp_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							if a_incX > 0 then
								l_jx := 0
							else
								l_jx := (a_N - 1) * -a_incX
							end
							l_j := 0
							from
							until
								not (l_j < l_i)
							loop
								l_Aij_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_j)]
								l_Aij_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_j) + 1)])
								l_x_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx]
								l_x_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
								l_tmp_real___0 := l_tmp_real___0 - (l_Aij_real___0 * l_x_real___2 - l_Aij_imag___0 * l_x_imag___2)
								l_tmp_imag___0 := l_tmp_imag___0 - (l_Aij_real___0 * l_x_imag___2 + l_Aij_imag___0 * l_x_real___2)
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_a_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								l_a_imag___2 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
								l_s___2 := (xhypot___2 (l_a_real___2.to_double, l_a_imag___2.to_double)).truncated_to_real
								l_b_real___2 := l_a_real___2 / l_s___2
								l_b_imag___2 := l_a_imag___2 / l_s___2
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := (l_tmp_real___0 * l_b_real___2 + l_tmp_imag___0 * l_b_imag___2) / l_s___2
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_tmp_imag___0 * l_b_real___2 - l_tmp_real___0 * l_b_imag___2) / l_s___2
							else
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := l_tmp_real___0
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_tmp_imag___0
							end
							l_ix := l_ix + a_incX
							l_i := l_i + 1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 25 then -- else: | _L___9:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 31 -- goto _L___2
							else
								l_pos := -1 + 28 -- goto _L___6
							end
						else
							l_pos := -1 + 28 -- goto _L___6
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 28 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 37 -- skip if block
						end
				when 29 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 35 -- skip if block
						end
				when 30 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if: | _L___2:
						if a_incX > 0 then
							l_ix := 0
						else
							l_ix := (a_N - 1) * -a_incX
						end
						if l_nonunit.to_boolean then
							l_a_real___3 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[0]
							l_a_imag___3 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[1])
							l_x_real___3 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
							l_x_imag___3 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							l_s___3 := (xhypot___2 (l_a_real___3.to_double, l_a_imag___3.to_double)).truncated_to_real
							l_b_real___3 := l_a_real___3 / l_s___3
							l_b_imag___3 := l_a_imag___3 / l_s___3
							create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := (l_x_real___3 * l_b_real___3 + l_x_imag___3 * l_b_imag___3) / l_s___3
							create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_x_imag___3 * l_b_real___3 - l_b_imag___3 * l_x_real___3) / l_s___3
						end
						l_ix := l_ix + a_incX
						l_i := 1
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
							l_tmp_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							if a_incX > 0 then
								l_jx := 0
							else
								l_jx := (a_N - 1) * -a_incX
							end
							l_j := 0
							from
							until
								not (l_j < l_i)
							loop
								l_Aij_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_i)]
								l_Aij_imag___1 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_i) + 1)])
								l_x_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx]
								l_x_imag___4 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
								l_tmp_real___1 := l_tmp_real___1 - (l_Aij_real___1 * l_x_real___4 - l_Aij_imag___1 * l_x_imag___4)
								l_tmp_imag___1 := l_tmp_imag___1 - (l_Aij_real___1 * l_x_imag___4 + l_Aij_imag___1 * l_x_real___4)
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_a_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
								l_a_imag___4 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
								l_s___4 := (xhypot___2 (l_a_real___4.to_double, l_a_imag___4.to_double)).truncated_to_real
								l_b_real___4 := l_a_real___4 / l_s___4
								l_b_imag___4 := l_a_imag___4 / l_s___4
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := (l_tmp_real___1 * l_b_real___4 + l_tmp_imag___1 * l_b_imag___4) / l_s___4
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_tmp_imag___1 * l_b_real___4 - l_tmp_real___1 * l_b_imag___4) / l_s___4
							else
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := l_tmp_real___1
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_tmp_imag___1
							end
							l_ix := l_ix + a_incX
							l_i := l_i + 1
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 37 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 43 -- goto _L
							else
								l_pos := -1 + 40 -- goto _L___1
							end
						else
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 40 then -- else: | _L___1:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 49 -- skip if block
						end
				when 41 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___9 := 0
						else
							l_tmp___9 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___9 + a_incX * (a_N - 1)
						if l_nonunit.to_boolean then
							l_a_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * (a_N - 1) + (a_N - 1))]
							l_a_imag___5 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * (a_N - 1) + (a_N - 1)) + 1)])
							l_x_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
							l_x_imag___5 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
							l_s___5 := (xhypot___2 (l_a_real___5.to_double, l_a_imag___5.to_double)).truncated_to_real
							l_b_real___5 := l_a_real___5 / l_s___5
							l_b_imag___5 := l_a_imag___5 / l_s___5
							create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := (l_x_real___5 * l_b_real___5 + l_x_imag___5 * l_b_imag___5) / l_s___5
							create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_x_imag___5 * l_b_real___5 - l_b_imag___5 * l_x_real___5) / l_s___5
						end
						l_ix := l_ix - a_incX
						l_i := a_N - 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___12 := l_i
								l_i := l_i - 1
								if not l_tmp___12.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_tmp_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
								l_tmp_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
								l_jx := l_ix + a_incX
								l_j := l_i + 1
								from
								until
									not (l_j < a_N)
								loop
									l_Aij_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + l_i)]
									l_Aij_imag___2 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + l_i) + 1)])
									l_x_real___6 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx]
									l_x_imag___6 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
									l_tmp_real___2 := l_tmp_real___2 - (l_Aij_real___2 * l_x_real___6 - l_Aij_imag___2 * l_x_imag___6)
									l_tmp_imag___2 := l_tmp_imag___2 - (l_Aij_real___2 * l_x_imag___6 + l_Aij_imag___2 * l_x_real___6)
									l_jx := l_jx + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_a_real___6 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + l_i)]
									l_a_imag___6 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + l_i) + 1)])
									l_s___6 := (xhypot___2 (l_a_real___6.to_double, l_a_imag___6.to_double)).truncated_to_real
									l_b_real___6 := l_a_real___6 / l_s___6
									l_b_imag___6 := l_a_imag___6 / l_s___6
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := (l_tmp_real___2 * l_b_real___6 + l_tmp_imag___2 * l_b_imag___6) / l_s___6
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := (l_tmp_imag___2 * l_b_real___6 - l_tmp_real___2 * l_b_imag___6) / l_s___6
								else
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := l_tmp_real___2
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_tmp_imag___2
								end
								l_ix := l_ix - a_incX
							end
						end
						l_break := False
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trsv_c.h"), ce_string ("unrecognized operation")])
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trsv_c.h"), ce_string ("unrecognized operation")])
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_trsv_c.h"), ce_string ("unrecognized operation")])
				when 50 then -- if done | if done | if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	xhypot___2 (a_x, a_y: REAL_64): REAL_64
		local
			l_xabs: REAL_64
			l_yabs: REAL_64
			l_min: REAL_64
			l_max: REAL_64
			l_u: REAL_64
			l_return: BOOLEAN
		do
			l_xabs := (fabs (a_x))
			l_yabs := (fabs (a_y))
			if l_xabs < l_yabs then
				l_min := l_xabs
				l_max := l_yabs
			else
				l_min := l_yabs
				l_max := l_xabs
			end
			if l_min = (0).to_double then
				Result := l_max
				l_return := True
			end
			if not l_return then
				l_u := l_min / l_max
				Result := (l_max * (sqrt ((1).to_double + l_u * l_u)))
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			size1 := a_other.size1
			size2 := a_other.size2
			tda := a_other.tda
			data := a_other.data
			block := a_other.block
			owner := a_other.owner
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				size1 = a_other.size1 and
				size2 = a_other.size2 and
				tda = a_other.tda and
				data.is_equal (a_other.data) and
				block.is_equal (a_other.block) and
				owner = a_other.owner
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("size1"),
					create {CE_STRUCTURE_FIELD}.make ("size2"),
					create {CE_STRUCTURE_FIELD}.make ("tda"),
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("block"),
					create {CE_STRUCTURE_FIELD}.make ("owner")
				>>)
			init_structure_info
		end

end
